#include <bits/stdc++.h>

#define int long long
#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define rz resize
#define inf 1e18

using namespace std;

mt19937 rnd(time(0));

struct T{
    int v, u, w;

    T (int _v, int _u, int _w)
    {
        v = _v;
        u = _u;
        w = _w;
    }
    T ()
    {

    }
};

void solve()
{
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vec<int> a (n);
    for(auto &i : a)
        cin >> i;
    vec<vec<pii>> g (n);
    vec<vec<int>> best (n, vec<int> (n, inf));
    vec<T> b (m);
    vec<int> next (n);
    for(auto &[v, u, w] : b)
    {
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].pb({u, w});
        best[v][u] = min(best[v][u], w);
        next[v] = w;
    }

    if(group == 1)
    {
        vec<int> d (n, inf);
        d[0] = 0;
        set<pii> q;
        q.insert({0, 0});

        while(sz(q))
        {
            int v = q.begin()->s;
            q.erase(q.begin());

            for(auto &[u, w] : g[v])
            {
                if(d[u] > d[v] + w)
                {
                    if(q.find({d[u], u}) != q.end())
                        q.erase({d[u], u});
                    d[u] = d[v] + w;
                    q.insert({d[u], u});
                }
            }
        }

        if(d.back() == inf)
            cout << -1 << endl;
        else if(d.back() <= p)
            cout << 0 << endl;
        else
            cout << d.back() - p << endl;
    }
    else if(group == 2)
    {
        int ans = 0;
        int curmx = a[0];
        for(int i = 0; i < n - 1; i++)
        {
            curmx = max(curmx, a[i]);
            if(p >= next[i])
            {
                p -= next[i];
                continue;
            }
            int d = next[i] - p;
            int cnt = (d + curmx - 1) / curmx;
            ans += cnt;
            p += cnt * curmx;
            p -= next[i];
        }

        cout << ans << endl;
    }
    else if(group == 3 || group == 0)
    {
        int ans = inf;
        function<void(int, int, int, int, vec<int> used)> go = [&](int v, int curmx, int curans, int p, vec<int> used)
        {
            if(v == n - 1)
            {
                ans = min(ans, curans);
                return;
            }
            curmx = max(curmx, a[v]);
            used[v] = 1;

            FOR(u, n)
            {
                if(!used[u] && best[v][u] != inf)
                {
                    int w = best[v][u];
                    if(p >= w)
                    {
                        go(u, curmx, curans, p - w, used);
                    }
                    else
                    {
                        int d = w - p;
                        int cnt = (d + curmx - 1) / curmx;
                        go(u, curmx, curans + cnt, p - w + cnt * curmx, used);
                    }
                }
            }
        };

        go(0, 0, 0, p, vec<int> (n));

        if(ans == inf)
            cout << -1 << endl;
        else
            cout << ans << endl;
    }
    else
        assert(0);
}

/**


3 2 5 2
3 2 5
1 2 4
2 3 5

*/

signed main() {
    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}


