#include <bits/stdc++.h>

#define int long long
#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define rz resize
#define inf 1e18

using namespace std;

mt19937 rnd(time(0));

struct T{
    int v, u, w;

    T (int _v, int _u, int _w)
    {
        v = _v;
        u = _u;
        w = _w;
    }
    T ()
    {

    }
};

const int MAGIC = 8e6;

void solve()
{
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vec<int> a (n);
    for(auto &i : a)
        cin >> i;
    vec<vec<pii>> g (n);
    vec<vec<int>> best (n, vec<int> (n, inf));
    vec<T> b (m);
    vec<int> next (n);
    for(auto &[v, u, w] : b)
    {
        cin >> v >> u >> w;
        v--;
        u--;
        g[v].pb({u, w});
        best[v][u] = min(best[v][u], w);
        next[v] = w;
    }

    vec<int> d (n, inf);
    d[0] = 0;
    set<pii> q;
    q.insert({0, 0});

    while(sz(q))
    {
        int v = q.begin()->s;
        q.erase(q.begin());

        for(auto &[u, w] : g[v])
        {
            if(d[u] > d[v] + w)
            {
                if(q.find({d[u], u}) != q.end())
                    q.erase({d[u], u});
                d[u] = d[v] + w;
                q.insert({d[u], u});
            }
        }
    }

    if(d.back() == inf)
    {
        cout << -1 << endl;
        return;
    }

    if(group == 1)
    {
        if(d.back() == inf)
            cout << -1 << endl;
        else if(d.back() <= p)
            cout << 0 << endl;
        else
            cout << d.back() - p << endl;
    }
    else if(group == 2)
    {
        int ans = 0;
        int curmx = a[0];
        for(int i = 0; i < n - 1; i++)
        {
            curmx = max(curmx, a[i]);
            if(p >= next[i])
            {
                p -= next[i];
                continue;
            }
            int d = next[i] - p;
            int cnt = (d + curmx - 1) / curmx;
            ans += cnt;
            p += cnt * curmx;
            p -= next[i];
        }

        cout << ans << endl;
    }
    else
    {
        g.clear();
        g.resize(n);
        FOR(i, n)
        {
            FOR(j, n)
            {
                if(i == j) continue;
                if(best[i][j] != inf)
                    g[i].pb({j, best[i][j]});
            }
            shuffle(all(g[i]), rnd);
        }

        int allvers = 0;
        int ans = inf;
        function<void(int, int, int, int, int)> go = [&](int v, int curmx, int curans, int p, int cnt)
        {
            allvers++;
            if(v == n - 1)
            {
                ans = min(ans, curans);
                if(allvers > MAGIC)
                {
                    cout << ans << endl;
                    exit(0);
                }
                return;
            }
            curmx = max(curmx, a[v]);
            if(allvers > MAGIC)
            {
                cout << ans << endl;
                exit(0);
            }
            if(curans >= ans || cnt > n * 2)
                return;

            for(auto &[u, w] : g[v])
            {
                if(p >= w)
                {
                    go(u, curmx, curans, p - w, cnt + 1);
                }
                else
                {
                    int d = w - p;
                    int curcnt = (d + curmx - 1) / curmx;
                    go(u, curmx, curans + curcnt, p - w + curcnt * curmx, cnt + 1);
                }
            }
        };

        go(0, 0, 0, p, 0);
        cout << ans << endl;
    }
}

/**


3 2 5 2
3 2 5
1 2 4
2 3 5

*/

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}
