#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ll long long
#define int ll
#define pb push_back
#define ull unsigned long long
#define pii pair<int, int>
#define F first
#define S second

using namespace std;
const int MOD = 1e9 + 7;
const int N = 1e3 + 10;
int inf = 1e18;
vector <pii> g[N];

int32_t main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int n, m, p, G;
    cin >> n >> m >> p >> G;
    vector <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    vector <int> c1(m);
    for (int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        if (x == y) continue;
        c1[i] = c;
        x--; y--;
        g[x].pb({y, c});
        g[y].pb({x, c});
    }
    if (G == 2) {
        int ans = 0;
        int v = 0;
        int mx = w[0];
        while (v != n - 1) {
            int to = v + 1, cost = c1[v];
            if (p < cost) {
                int need = cost - p;
                int k = need / mx;
                if (need % mx) k++;
                ans += k;
                p += k * mx;
            }
            p -= cost;
            v = to;
            mx = max(mx, w[v]);
        }
        cout << ans;
        return 0;
    }
    if (G == 1) {
        vector <int> d(n, inf);
        d[0] = 0;
        priority_queue <pii> q;
        q.push({0, 0});
        while (!q.empty()) {
            int v = q.top().S, dist = -q.top().F;
            q.pop();
            if (d[v] < dist) continue;
            for (auto to: g[v]) {
                if (d[to.F] > d[v] + to.S) {
                    d[to.F] = d[v] + to.S;
                    q.push({-d[to.F], to.F});
                }
            }
        }
        if (d[n - 1] == inf) cout << -1;
        else {
            if (d[n - 1] <= p) cout << 0;
            else cout << d[n - 1] - p;
        }
        return 0;
    }
    return 0;
}
