#include <iostream>
#include <vector>
#include <deque>
#include <set>
#include <string>
#include <map>
#include <queue>
#include <algorithm>
#include <cmath>
#include <fstream>
#include <bitset>

#define f first
#define s second
#define int long long

using namespace std;

const int N = 5*1e5, mod = 1e9+7;
int t1 = 1;

void start();
void update();




signed main() {
    start();
    while(t1--){
        update();
    }
    return 0;
}
int n, k, m;
void start(){
    //cin >> t1;

}
const int inf = 1e15;
vector<int> used(800);
void DFS(int v, vector<vector<int>> &g, vector<int> &ans){
    used[v] = 1;
    for(int i = 0; i<n; i++){
        if(g[v][i] != -1 and used[i] == 0){
            used[i] = 1;
            if(i == n-1){
                ans[v] = min(ans[v], g[v][i]);
            }
            else{
                DFS(i, g, ans);
                ans[v] = min(ans[v], ans[i]+g[v][i]);
            }
        }
        else if(g[v][i] != -1){
            ans[v] = min(ans[v], ans[i]+g[v][i]);
        }
    }
}


void update(){

    int p, g1;
    cin >> n >> m >> p >> g1;
    vector<int> w(n);
    for(int i = 0; i<n; i++){
        cin >> w[i];
    }
    vector<int> a(m), b(m), s(m);
    vector<vector<int>> g(n, vector<int>(n, -1));
    for(int i = 0; i<m ; i++){
        cin >> a[i] >> b[i] >> s[i];
        g[a[i]-1][b[i]-1] = s[i];
    }
    vector<int> ans(n, inf);
    DFS(0, g, ans);
    if(ans[0] == inf) {
        cout << -1 << endl;
    }
    else{
        cout << ans[0]-2 << endl;
    }

}