from math import inf
from queue import PriorityQueue

n, m, p, g = map(int, input().split())
profit = list(map(int, input().split()))
graph = [[] for _ in range(n)]
for _ in range(m):
    a, b, w = map(int, input().split())
    graph[a - 1].append((b - 1, w))
dist = [inf] * n
q = PriorityQueue()
q.put((0, 0))
while not q.empty():
    d, v = q.get()
    if d > dist[v]:
        continue
    dist[v] = d
    for u, x in graph[v]:
        if dist[u] > d + x:
            dist[u] = d + x
            q.put((x + d, u))
if dist[-1] is inf:
    print(-1)
else:
    print(dist[-1])
