#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <deque>

using namespace std;
typedef long long ll;

int main() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (auto &x : w) cin >> x;
    vector<int> sww;
    vector<int> wi(n);
    {
        set<int> ws;
        for (auto &x : w) ws.insert(x);
        map<int, int> wtoi;
        int owi = 0;
        for (auto x : ws) {
            sww.push_back(x);
            wtoi[x] = owi++;
        }
        for (int i = 0; i < n; ++i) {
            wi[i] = wtoi[w[i]];
        }
    }
    if (g == 1) {
        vector<vector<int>> a(n);
        while (m--) {
            int u, v, s;
            cin >> u >> v >> s;
            --u, --v;
            a[u].push_back(v);
        }
        deque<pair<int, int>> bfs;
        vector<int> d(n);
        bfs.emplace_back(0, 1);
        while (!bfs.empty()) {
            auto [v, dst] = bfs.front();
            bfs.pop_front();
            if (d[v]) continue;
            d[v] = dst;
            for (int u : a[v]) {
                bfs.emplace_back(u, dst + 1);
            }
        }
        if (d[n-1] == 0) {
            cout << -1 << endl;
        } else {
            cout << d[n-1] - 1 << endl;
        }
    }
}