#include <bits/stdc++.h>

using namespace std;
#define int long long
const int INF = 1e15;
const int N = 800;
int f[N][N];

inline void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i != j) f[i][j] = INF;
        }
    }
    vector <int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int x, y, s;
        cin >> x >> y >> s;
        f[x - 1][y - 1] = min(f[x - 1][y - 1], s);
    }
    for (int k = 0; k < n; ++k) {
        for (int a = 0; a < n; ++a) {
            for (int b = 0; b < n; ++b) {
                f[a][b] = min(f[a][b], f[a][k] + f[k][b]);
            }
        }
    }
    if (f[0][n - 1] == INF) {
        cout << "-1\n";
        return;
    }
    vector <pair <int, int>> dp(n, make_pair(INF, 0));
    vector <pair <int, int>> all;
    for (int i = 0; i < n; ++i) {
        all.emplace_back(w[i], i);
    }
    sort(all.begin(), all.end());
    dp[0] = make_pair(0, p);
    for (auto i : all) {
        int v = i.second;
        int cur_cnt = dp[v].first;
        int cur_p = dp[v].second;
        if (cur_cnt == INF) continue;
        int ncnt, np;
        for (int j = 0; j < n; ++j) {
            if ((w[j] > w[v] || j == n - 1) && f[v][j] != INF) {
                int need = f[v][j] - cur_p;
                if (need <= 0) {
                    ncnt = cur_cnt;
                    np = cur_p - f[v][j];
                } else {
                    int pl = (need + w[v] - 1) / w[v];
                    ncnt = cur_cnt + pl;
                    np = cur_p + w[v] * pl - f[v][j];
                }
                if (dp[j].first > ncnt || (dp[j].first == ncnt && dp[j].second < np)) dp[j] = {ncnt, np};
            }
        }
    }
    cout << dp[n - 1].first << "\n";
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
    return 0;
}

/*
4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

 4 4 10 0
 1 2 10 1
 1 2 20
 2 4 30
 1 3 25
 3 4 89
 */