//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7, INF = 1e18 + 1;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve() {
    ll n, m, p, t;
    cin >> n >> m >> p >> t;
    vector < ll > w(n);
    forall(i, w) cin >> i;
    vector < set < pair < ll, ll >>> g(n);
    for (ll i = 0; i < m; i++) {
        ll x, y ,c;
        cin >> x >> y >> c;
        x--; y--;
        g[x].insert({y, c});
    }

    if (t == 1) {
        vector<ll> dist(n, INF);
        dist[0] = 0;
        set < pair < ll, ll >> q;
        q.insert({0, 0});
        while (!q.empty()) {
            ll v = q.begin()->second;
            q.erase(q.begin());
            forall(i, g[v]) {
                if (dist[i.first] > dist[v] + i.second) {
                    q.erase({dist[i.first], i.first});
                    dist[i.first] = dist[v] + i.second;
                    q.insert({dist[i.first], i.first});
                }
            }
        }
        if (dist[n - 1] == INF) cout << -1;
        else cout << max(dist[n - 1] - p, 0ll);
        return;
    }
    if (t == 2) {
        ll cnt = 0, mx = w[0];
        for (ll i = 0; i < n - 1; i++) {
            mx = max(mx, w[i]);
            p -= g[i].begin()->second;
            if (p < 0) {
                cnt += (-p + mx - 1) / mx;
                p += (-p + mx - 1) / mx * mx;
            }
        }
        cout << cnt;
        return;
    }
    vector < ll > per(n - 1);
    for (ll i = 0; i < n - 1; i++) per[i] = i + 1;
    ll ans = INF;
    vector < vector < ll >> graph(n, vector < ll > (n, INF));
    for (ll i = 0; i < n; i++) forall(j, g[i]) graph[i][j.first] = min(graph[i][j.first], j.second);
    do {
        ll cnt = 0, s = p, now = 0, mx = w[0];
        bool fl = true;
        for (ll i =0 ; i < n - 1; i++) {
            if (now == n - 1) break;
            if (graph[now][per[i]] == INF) fl = false;
            now = per[i];
        }
        if (fl) {
            now = 0;
            for (ll i = 0; i < n - 1; i++) {
                if (now == n - 1) break;
                mx = max(mx, w[now]);
                s -= graph[now][per[i]];
                if (s < 0) {
                    cnt += (-s + mx - 1) / mx;
                    s += (-s + mx - 1) / mx * mx;
                }
                now = per[i];
            }
            ans = min(ans, cnt);
        }
    } while (next_permutation(all(per)));
    if (ans == INF) ans = -1;
    cout << ans;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}