#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<random>
#include<stack>
#include<deque>
#include<iomanip>
#include <cstring>

using namespace std;

//#pragma optimize("O3")
//#pragma optimize("avx2")
//#pragma optimize("unrool-loops")

#define int long long

random_device rd;
mt19937 gen(rd());

int w[10005];
vector<pair<int,int>> gr[10005];
int dist[1005];

void Dijkstra(int n) {
	for (int i = 0; i < n; i++){
		dist[i] = 1e15;
	}
	dist[0] = 0;
	set<pair<int, int>>s;
	s.insert({ 0, 0 });
	while (!s.empty()) {
		auto v = *s.begin();
		s.erase(s.begin());
		for (auto u : gr[v.second]) {
			if (dist[u.first] > v.first + u.second) {
				s.erase({ dist[u.first], u.first });
				dist[u.first] = v.first + u.second;
				s.insert({ dist[u.first], u.first });
			}
		}
	}
	return;
}
void solve() {
	int n, m, p, g;
	cin >> n >> m >> p >> g;

	for (int i = 0; i < n; i++) {
		cin >> w[i];
	}
	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		gr[u].push_back({ v, w });
	}
	if (g == 1) {
		Dijkstra(n);
		if (dist[n - 1] > 1e14) {
			cout << "-1" << "\n";
			return;
		}
		cout << max(0ll, dist[n - 1] - p) << "\n";
		return;
	}
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//freopen("Text.txt", "r", stdin);
	//freopen("", "w", stdout)

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}