#include <iostream>
#include <vector>
#include <algorithm>


using namespace std;
long long s[1000][1000];
long long w[1000];


vector<long long> b;
long long n;
long long checkroute(vector<long long> route, long long p) {
	long long ans = 0;
	long long opt = w[route[0]];
	for (long long i = 1; i < route.size(); i++) {
		
		long long cost = s[route[i - 1]][route[i]];
		if (cost > 1e9)
			return -1;
		long long need = cost - p;
		if (need > 0) {
			long long req = (need-1) / opt+1;
			ans += req;
			p += req * opt;
		}
		p -= cost;
		
		opt = max(opt, w[route[i]]);
	}
	return ans;
}
long long fd(long long v,long long p) {
	if (v == n - 1) {
		return 1;
	}
	for (long long i = 0; i < n; i++) {
		if (s[v][i] <= 1e9) {
			if (i != p) {
				b.push_back(i);
				if (fd(i, v)) {
					return 1;
				}
				b.pop_back();
			}
		}
	}
	return 0;
}
long long bans = 1e16 + 5;
long long m, p, g;
long long had[1000];
void floc(long long v) {
	had[v] = 1;
	if (v == n - 1) {
		auto h = checkroute(b,p);
		if (h != -1) {
			bans = min(bans, h);
		}
		had[v] = 0;
		return;
	}

	for (long long i = 1; i < n; i++) {
		if (!had[i]&&s[v][i]<=1e9) {
			b.push_back(i);
			floc(i);
			b.pop_back();
		}
	}
	had[v] = 0;
}

signed main() {
	cin >> n;
	for (long long i = 0; i < n; i++) {
		for (long long j = 0; j < n; j++) {
			s[i][j] = 1e9+5;
		}
	}
	cin >> m >> p >> g;
	for (long long i = 0; i < n; i++) {
		cin >> w[i];
	}
	for (long long j = 0; j < m; j++) {
		long long t1, t2, c;		
		cin >> t1 >> t2 >> c;

		t1--;
		t2--;
		s[t1][t2] = min(s[t1][t2], c);
	}


	if (g == 3||g==0) {
		b.push_back(0);
		floc(0);
		if (bans < 1e14) {
			cout << bans;
			return 0;
		}
		cout << -1;
		return 0;
	}
	if (g == 2) {
		b.push_back(0);
		fd(0, -1);
		long long ans = checkroute(b, p);
		cout << ans;
	}


	
}