#include <bits/stdc++.h>
//#include <ext/pd_ds/assoc_container.hpp>
//#include <ext/pd_ds/tree_policy.hpp>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define mp make_pair
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef int64_t ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
ostream& operator << (ostream& out, pair<T, T1> &pr) {
    out << pr.first << " " << pr.second;
    return out;
}

template<typename T, typename T1>
istream& operator >> (istream& in, pair<T, T1> &pr) {
    in >> pr.first >> pr.second;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &arr) {
    for (auto &i : arr) {out << i << " ";}
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &arr) {
    for (auto &i : arr) {in >> i;}
    return in;
}

//typedef tree<int, null_type, less<int>,
// rb_tree_tag, tree_order_statistics_node> ordered_set;

vector<vector<pii>> g;
vector<int> s;

void solve() {
    int n, m, p, gr; cin >> n >> m >> p >> gr;
    s.rs(n); cin >> s;

    g.rs(n);
    for (int i = 0; i < m; i++) {
        int a, b, c; cin >> a >> b >> c;
        a--; b--;

        g[a].pb({b, c});
        g[b].pb({a, c});
    }

    if (gr == 1) {
        vector<int> dist(n, 1e18);
        dist[0] = 0;

        multiset<pii> s1;
        for (int i = 0; i < n; i++) s1.insert({dist[i], i});
        while (!(s1.empty())) {
            pii a = *s1.begin();
            s1.erase(s1.begin());

            if (a.ff == 1e18) break;

            for (auto i : g[a.ss]) {
                if (dist[i.ff] > dist[a.ss] + i.ss) {
                    auto cur = s1.lower_bound({s[i.ff], i.ff});
                    if (cur == s1.end()) continue;

                    s1.erase(cur);


                    dist[i.ff] = dist[a.ss] + i.ss;

                    s1.insert({dist[i.ff], i.ff});

                }
            }
        }

        cout << max(0LL, dist[n - 1] - p);
    }

}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double start_time = clock();
#endif
    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------\n";
#endif
    }
#ifdef LOCAL
    cout << "execution time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}