#include <bits/stdc++.h>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

typedef int64_t ll;
typedef uint64_t ull;

#define int ll

const int INF = 1e9 + 117;

int n, m, p, tst;
vector<int> w;
vector<vector<pair<int, int>>> g;

int stup() {
    vector<int> distancce(n, INF);
    distancce[0] = 0;
    vector<bool> used(n, false);
    for (int i = 0; i < n; ++i) {
        int ver = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (ver == -1 || distancce[ver] > distancce[j])) ver = j;
        }
        if (ver == -1) break;
        used[ver] = true;
        if (distancce[ver] == INF) break;
        for (auto& [e, x] : g[ver]) {
            distancce[e] = min<ll>(distancce[e], distancce[ver] + x);
        }
    }
    if (distancce[n - 1] == INF) {
        cout << "-1\n";
    } else {
        cout << max<ll>(0, distancce[n - 1] - p) << '\n';
    }
}

signed main() {
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fast();
    cin >> n >> m >> p >> tst;
    w.resize(n);
    g.resize(n);
    for (auto& e : w) cin >> e;
    for (int i = 0; i < m; ++i) {
        int a, b, x;
        cin >> a >> b >> x;
        a--; b--;
        g[a].push_back({b, x});
    }
    if (tst == 1) {
        // cout << "1\n";
        stup();
        return 0;
    }
    cout << "4\n";
    return 0;
}
