#include<iostream>
#include<vector>
#include<algorithm>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
typedef long long ll;
using namespace std;
const ll inf = 1e15;
vec<vec<pair<int, int>>> a;

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int n, m, p, g;
	cin >> n >> m >> p >> g;
	vec<ll> w(n);
	for (int i = 0; i < n; i++)
		cin >> w[i];
	a.resize(n);
	vec<vec<ll>> d(n, vec<ll>(n, inf));
	for (int i = 0; i < n; i++)
		d[i][i] = 0;
	for (int i = 0; i < m; i++) {
		int u, v, s;
		cin >> u >> v >> s;
		u--, v--;
		a[u].push_back({ v, s });
		d[u][v] = s;
	}
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (d[i][k] != inf && d[k][j] != inf) {
					d[i][j] = min(d[i][k] + d[k][j], d[i][j]);
				}
			}
		}
	}
	cout << max(0LL, d[0][n - 1] - p);

}