#include <iostream>
#include <vector>
#include <algorithm>
#include <math.h>
#include <unordered_map>
#include <set>
#include <map>

#define int long long
using namespace std;
int INF = 1e14;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, p, t;
    cin >> n >> m >> p >> t;
    vector<vector<pair<int, int>>> g(n);
    int st = 0;
    int end = n - 1;
    vector<int> w(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    if (true) {
        for (int i = 0; i < m; i++) {
            int a, b, s;
            cin >> a >> b >> s;
            a--;
            b--;
            g[a].push_back({b, s});
            g[b].push_back({a, s});
        }
        vector<int> d(n, INF);
        vector<int> used(n);
        d[st] = 0;
        for (int i = 0; i < n; i++) {
            int v = -1;
            for (int j = 0; j < n; j++) {
                if (!used[j]) {
                    if (v == -1) {
                        v = j;
                    } else {
                        if (d[v] > d[j]) {
                            v = j;
                        }
                    }
                }
            }
            used[v] = 1;
            for (auto elem: g[v]) {
                int cost = elem.second;
                int to = elem.first;
                if (d[to] > d[v] + cost) {
                    d[to] = d[v] + cost;
                }
            }

        }
        if (d[end] == INF) {
            cout << -1;
            return 0;
        }
        cout << max((int) 0, d[end] - p);
    }
    return 0;
}

