#include<bits/stdc++.h>

#define x first
#define y second
#define endl "\n"
#define int long long

using namespace std;

void fast()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
}

bool operator < (pair<int, int> a, pair<int, int> b)
{
    if(a.x == b.x)
        return a.y > b.y;
    return a.x < b.x;
}

pair<int, int> operator + (pair<int, int> a, pair<int, int> b)
{
    return {a.x + b.x, b.y};
}

int32_t main()
{
    fast();
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    int w[n];
    for(int i = 0; i < n; i++)
        cin >> w[i];
    if(g == 2)
    {
        vector<int> s;
        for(int i = 0, t, u, v; i < n - 1; i++)
        {
            cin >> u >> v >> t;
            s.push_back(t);
        }
        vector<int> mx(n);
        mx[0] = w[0];
        for(int i = 1; i < n; i++)
            mx[i] = max(mx[i - 1], w[i]);
        int ans = 0;
        for(int i = 0; i < n - 1; i++)
        {
            int d = (max(0LL, s[i] - p) + mx[i] - 1) / mx[i];
            p += d * mx[i];
            p -= s[i];
            ans += d;
        }
        cout << ans << endl;
        return 0;
    }
    vector<pair<int, int>> graph[n];
    if(g == 1)
    {
        for(int i = 0, u, v, t; i < m; i++)
        {
            cin >> u >> v >> t;
            graph[u - 1].push_back({v - 1, t});
        }
        vector<int> dist(n, 1e18);
        dist[0] = 0;
        priority_queue<pair<int, int>> pq;
        pq.push({0, 0});
        while(!pq.empty())
        {
            int dst = -(pq.top()).x, v = (pq.top()).y;
            pq.pop();
            if(dist[v] < dst)
                continue;
            for(auto i : graph[v])
                if(i.y + dst < dist[i.x])
                {
                    dist[i.x] = i.y + dst;
                    pq.push({-dist[i.x], i.x});
                }
        }
        if(dist[n - 1] >= 1e18)
            cout << -1;
        else cout << max(0LL, dist[n - 1] - p);
        return 0;
    }
    for(int i = 0, u, v, t; i < m; i++)
    {
        cin >> u >> v >> t;
        graph[u - 1].push_back({v - 1, t});
    }
    pair<int, int> dp[n][n];
    for(int i = 0; i < n; i++)
        for(int j = 0; j < n; j++)
            dp[i][j] = {1e18, 0};
    dp[0][0] = {0, p};
    int ans = 1e18;
    while(true)
    {
        for(int i = 0; i < n; i++)
            for(int j = 0; j < n; j++)
            {
                for(auto x : graph[i])
                {
                    int d = (max(0LL, -dp[i][j].y + x.y) + w[j] - 1) / w[j];
                    int tp = dp[i][j].y + d * w[j] - x.y;
                    if(w[j] == w[x.x])
                        dp[x.x][x.x] = min(dp[x.x][x.x], (dp[i][j] + make_pair(d, tp))),
                        dp[x.x][j] = min(dp[x.x][j], (dp[i][j] + make_pair(d, tp)));
                    else dp[x.x][(w[j] < w[x.x] ? x.x : j)] = min(dp[x.x][(w[j] < w[x.x] ? x.x : j)], dp[i][j] + make_pair(d, tp));
                    if(x.x == n - 1)
                        ans = min({ans, dp[x.x][x.x].x, dp[x.x][j].x});
                    if(clock() / (double)CLOCKS_PER_SEC >= 0.995)
                    {
                        cout << (ans >= 1e18 ? -1LL : ans);
                        return 0;
                    }
                }
            }
    }
    return 0;
}
