#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define int int64_t
#define pb push_back
#define pii pair <int, int>
#define endl '\n'
#define pw(x) (int64_t(1) << x)

using namespace std;
using namespace __gnu_pbds;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> oset;
const int N = 810, INF = 1e18;
vector <pii> g[N];
int dp[N][N * 3];
bool u[N];

void dfs (int v) {
    u[v] = 1;
    for(auto to : g[v]) {
        if(!u[to.fi]) {
            dfs(to.fi);
        }
    }
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    int w[n];
    for(int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    bool ok = (m == n - 1);
    map <pii, int> e;
    for(int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        if(!e.count({x, y})) {
            e[{x, y}] = c;
        } else {
            e[{x, y}] = min(e[{x, y}], c);
        }
        if(x != i || y != i + 1) {
            ok = 0;
        }
        g[x].pb({y, c});
    }
    dfs(0);
    if(!u[n - 1]) {
        cout << -1;
        return 0;
    }
    if(n <= 10) {
        int ans = INF;
        for(int msk = 0; msk < pw(n); ++msk) {
            vector <int> all;
            for(int i = 0; i < n; ++i) {
                if((msk >> i) & 1) {
                    if(i >= 1 && i < n - 1) all.pb(i);
                }
            }
            do {
                all.insert(all.begin(), 0);
                all.pb(n - 1);
                bool ok = 1;
                for(int i = 0; i + 1 < all.size(); ++i) {
                    bool f = 0;
                    for(auto to : g[all[i]]) {
                        if(to.fi == all[i + 1]) {
                            f = 1;
                            break;
                        }
                    }
                    if(!f) {
                        ok = 0;
                    }
                }
                if(!ok) {
                    all.erase(all.begin());
                    all.pop_back();
                    continue;
                }
                vector <int> dp(all.size()), cost(all.size());
                dp[0] = 0;
                cost[0] = p;
                int mx = 0;
                for(int i = 0; i + 1 < all.size(); ++i) {
                    mx = max(mx, w[all[i]]);
                    int need = e[{all[i], all[i + 1]}];
                    if(cost[i] >= need) {
                        dp[i + 1] = dp[i];
                        cost[i + 1] = cost[i] - need;
                        continue;
                    }
                    int kol = (need - cost[i]) / mx + ((need - cost[i]) % mx > 0);
                    dp[i + 1] = dp[i] + kol;
                    cost[i + 1] = cost[i] - need + mx * kol;
                }
                ans = min(ans, dp[all.size() - 1]);
                all.erase(all.begin());
                all.pop_back();
            } while (next_permutation(all.begin(), all.end()));
        }
        if(ans == INF) ans = -1;
        cout << ans;
        return 0;
    }
    if(*max_element(w, w + n) == 1) {
        vector <int> r(n, INF);
        r[0] = 0;
        priority_queue <pii> q;
        q.push({-r[0], 0});
        while (!q.empty()) {
            int dst = -q.top().fi, v = q.top().se;
            q.pop();
            for(auto to : g[v]) {
                if(r[to.fi] > r[v] + to.se) {
                    r[to.fi] = r[v] + to.se;
                    q.push({-r[to.fi], to.fi});
                }
            }
        }
        cout << max(int64_t(0), r[n - 1] - p);
        return 0;
    }
    if(ok) {
        vector <int> dp(n), cost(n);
        dp[0] = 0;
        cost[0] = p;
        int mx = 0;
        for(int i = 0; i + 1 < n; ++i) {
            mx = max(mx, w[i]);
            int need = e[ {i, i + 1}];
//            cerr << i << ' ' << need << ' ' << cost[i] << endl;
            if(cost[i] >= need) {
                dp[i + 1] = dp[i];
                cost[i + 1] = cost[i] - need;
                continue;
            }
            int kol = (need - cost[i]) / mx + ((need - cost[i]) % mx > 0);
//            cerr << i << ' ' << kol << ' ' << mx << endl;
            dp[i + 1] = dp[i] + kol;
            cost[i + 1] = cost[i] - need + mx * kol;
        }
        cout << dp[n - 1];
        return 0;
    }
    cout << -1;
    return 0;
}
//3 2
//2 2 3
//1 2 3
//2 3 3
//2 1
