#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb emplace_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

const int MAXN = 810;

vector<pt> gr[MAXN];
ll mt[MAXN][MAXN];
ll c[MAXN];

ll solve1(int n, ll p){
    for (int k = 0; k < n; k++){
        for (int i = 0; i < n; i++){
            for (int j = 0; j < n; j++){
                mt[i][j] = min(mt[i][j], mt[i][k] + mt[k][j]);
            }
        }
    }
    if (mt[0][n - 1] >= 1e18)
        return -1;
    return max(mt[0][n - 1] - p, 0ll);
}

ll solve2(int n, ll p){
    ll mx = 0;
    ll ans = 0;
    for (int i = 0; i < n - 1; i++){
        mx = max(mx, c[i]);
        ll need = mt[i][i + 1];
        if (need > p){
            ll cnt = (need - p + mx - 1) / mx;
            p += cnt * mx;
            ans += cnt;
        }
        p -= need;
    }
    return ans;
}

int used[1000];

ll gl = 1e18;

void dfs(int v, int to, ll r, ll mx, ll curr_ans){
    if (v == to){
        gl = min(gl, curr_ans);
        return;
    }
    used[v] = true;
    mx = max(mx, c[v]);
    for (auto [u, w]: gr[v]){
        if (used[u])
            continue;
        ll r1 = r, curr_ans1 = curr_ans;
        if (r1 < w){
            ll cnt = (w - r1 + mx - 1) / mx;
            curr_ans1 += cnt;
            r1 += cnt * mx;
        }
        r1 -= w;
        dfs(u, to, r1, mx, curr_ans1);
    }
    used[v] = false;
}

ll solve3(int n, ll p){
    dfs(0, n - 1, p, 0, 0);
    if (gl >= 1e18){
        return -1;
    } else {
        return gl;
    }
}

void run(){
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; i++)
        cin >> c[i];
    for (int i = 0; i < n; i++){
        fill(mt[i], mt[i] + n, 1e18);
    }
    for (int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        gr[u].pb(v, w);
        mt[u][v] = min((ll)w, mt[u][v]);
    }
    if (g == 1){
        cout << solve1(n, p) << '\n';
    } else if (g == 2){
        cout << solve2(n, p) << '\n';
    } else if (g == 3){
        cout << solve3(n, p) << '\n';
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
