#include <bits/stdc++.h>

using namespace std;

typedef long double ld;

#define fout cerr
#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vl vector<ll>
#define vii vector<vi>
#define vll vector<vl>
#define all(arr) arr.begin(), arr.end()
#define rev(arr) arr.rbegin(), arr.rend()
#define lb(arr, val) int(lower_bound(all(arr), val) - arr.begin())
#define ub(arr, val) int(upper_bound(all(arr), val) - arr.begin())
#define _unique(arr) arr.erase(unique(all(arr)), arr.end())
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vpi vector<pii>
#define vpl vector<pll>
#define size(arr) int(arr.size())

ostream &operator<<(ostream &out, vi a) {
    for (auto u: a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream &in, vi &a) {
    for (auto &u: a) {
        in >> u;
    }
    return in;
}

ostream &operator<<(ostream &out, vl a) {
    for (auto u: a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream &in, vl &a) {
    for (auto &u: a) {
        in >> u;
    }
    return in;
}

istream &operator>>(istream &in, pii &a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream &out, pii a) {
    out << a.first << " " << a.second;
    return out;
}

istream &operator>>(istream &in, pll &a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream &out, pll a) {
    out << a.first << " " << a.second;
    return out;
}

const int MAX_N = 2e5 + 5;
const int LOG_N = 25;
const ll INF = 1e10 + 7;

ll mod = 1e9 + 7;

int n, m, p, Q;

void solve_1() {
    vi ttt(n);
    cin >> ttt;
    vector<vector<pll>> g(n);
    for (int i = 0; i < m; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({v, w});
    }
    vl d(n, INF);
    d[0] = 0;
    set<pii> s;
    s.insert({0, 0});
    for (int t = 0; t < n; ++t) {
//        cout << t << "\n";
        auto [td, v] = *s.begin();
        s.erase({td, v});
        for (auto u : g[v]) {
            if (d[u.first] > td + u.second) {
                s.erase({d[u.first], u.first});
                d[u.first] = td + u.second;
                s.insert({d[u.first], u.first});
            }
        }
//        for (auto u : s) cout << u.first << "\n";
    }
//    cout << d << "\n";
    if (d.back() == INF) {
        cout << -1;
    } else {
        cout << max(d.back() - p, 0ll);
    }
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
    #define fout if (0) cout
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
#endif
    cout << setprecision(13) << fixed;

    cin >> n >> m >> p >> Q;
    if (Q == 1) {
        solve_1();
    }

}