#include <bits/stdc++.h>

#include <list>
#include <numeric>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
#define pb push_back
#define int long long
//typedef ordered_set<int> = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<pair<int, int>>> gr(800);
vector<int> w(800);
int n, m, p, g, a, b, s;

vector<pair<int, int>> e;// price, w

bool dfs(int v) {
    if (v == n-1) {
            return 1;
    }
    for (auto [i, s] : gr[v]) {
        e.pb({s, w[v]});
        if (dfs(i)) {
            return 1;
        }
        e.pop_back();

    }
    return 0;
}
int ans = 1e18;

void dfs1(vector<bool> used, int v, int res, int ma, int pr) {
    if (v == n-1) {
        ans = min(ans, res);
    }
    used[v] = 1;
    ma = max(ma, w[v]);
    for (auto [i, s1] : gr[v]) {

        if (!used[i]) {
            int res1, pr1;
            if (pr < s1) {
                int k = (s1-pr + ma-1) / ma;
                res1 = res + k;
                pr1 =pr + k * ma;
                pr1 -= s1;
            } else {
                pr1 =pr- s1;
            }
            dfs1(used, i, res1, ma,pr1);
        }
    }
}

void solve() {
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> s;
        a--;
        b--;
        gr[a].pb({b, s});
    }
    if (g == 1) {

        vector<int> dist(n, 1e18);
        vector<bool> used(n);
        dist[0] = 0;
        for (int j = 0; j < n-1; j++) {
            int y=-1, d=1e18;
            for  (int i = 0; i < n; i++) {
                if (!used[i] && dist[i] < d) {
                    d = dist[i];
                    y = i;
                }
            }
            if(y == -1) {
                break;
            }
            used[y] = 1;
            for (auto [i, s] : gr[y]) {
                if (dist[i] > dist[y] + s) {
                    dist[i] = dist[y] + s;
                }
            }
        }
        if (dist[n-1] == 1e18) {
            cout << -1;
            return;
        }
        cout << max(0ll, dist[n-1] - p);
    }
    if ( g == 2) {
        int ans = 0;
        if (!dfs(0)) {
            cout << -1;
        } else{
            int ma = 0;
            for (auto [s, w1] : e) {
                ma = max(ma, w1);
                if (p < s) {
                    int k = (s-p + ma-1) / ma;
                    ans += k;
                    p += k * ma;
                    p -= s;
                } else {
                    p -= s;
                }
            }
            cout << ans;
        }
    }
    if (g >= 3) {
        vector<bool> used(n);
        dfs1(used, 0, 0, 0, p);
        cout << (ans == 1e18 ? -1 : ans);
    }
}

signed main() {
#ifdef LOCAL
    auto f = freopen("C:\\clion\\input.txt", "r", stdin);
    auto f1 = freopen("C:\\clion\\output.txt", "w", stdout);
#endif
    int t;
    t= 1;//cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}