#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
#else
#define debug(x...) 7
#endif
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}
void solve_case() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<int> w(n);
    vector<vector<ll>> dist(n, vector<ll>(n, infll));
    for (int i = 0; i < n; i++) {
        dist[i][i] = 0;
    }
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        chmin(dist[a][b], s);
    }
    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                chmin(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }
    if (dist[0][n - 1] == infll) {
        cout << -1 << "\n";
        return;
    }
    if (G == 1) {
        cout << max(0ll, dist[0][n - 1] - p) << "\n";
        return;
    } else if (G == 2) {
        int mx = 0;
        ll bal = p;
        ll ans = 0;
        for (int i = 0; i + 1 < n; i++) {
            chmax(mx, w[i]);
            if (bal < dist[i][i + 1]) {
                ll add = (dist[i][i + 1] - bal + mx - 1) / mx;
                ans += add;
                bal += mx * add;
            }
            bal -= dist[i][i + 1];
        }
        cout << ans << "\n";
        return;
    } else {
        vector<pair<ll, ll>> dp(n, {infll, 0});
        function<void(int, int)> relax = [&](int i, int j) {
            ll bal = dp[i].se;
            ll add = 0;
            pair<ll, ll> nw = dp[i];
            if (bal < dist[i][j]) {
                add = (dist[i][j] - bal + w[i] - 1) / w[i];
                nw.fi += add;
                nw.se += add * w[i];
            }
            nw.se -= dist[i][j];
            chmin(dp[j], nw);
        };
        dp[0] = {0, p};
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int left, int right){
            return w[left] < w[right];
        });
        for (int i : ord) {
            for (int j = 0; j < n; j++) {
                relax(i, j);
            }
        }
        cout << dp[n - 1].fi << "\n";
        return;
    }
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
    return 0;
}