#pragma GCC optimize("Ofast")

#include<bits/stdc++.h>
#include<ext/pb_ds/tree_policy.hpp>
#include<ext/pb_ds/assoc_container.hpp>

#define F first
#define S second
#define pii pair<int, int>
#define pb push_back
#define ins insert
#define int long long
#define ll long long
#define orok order_of_key
#define fob find_by_order
#define endl "\n"


using namespace std;
using namespace __gnu_pbds;

mt19937 gen(time(0));


typedef tree <int, null_type, less < int > , rb_tree_tag, tree_order_statistics_node_update> oset;


const int inf = 1e18;
const int N = 1e5 + 10;
const int M = 1e4;
const int mod = 1e9 + 9;

vector < pii > g[N];
int dist[N];
int w[N];
int n, m, p, test;
int u[N];
int pref[N];
int cost[N];

void solve1()
{
    fill(dist, dist + n, inf);

    dist[0] = 0;
    priority_queue < pii > q;
    q.push({0, 0});

    while(!q.empty())
    {
        int v = q.top().S;
        q.pop();

        if(u[v])
            continue;

        u[v] = 1;
        for(auto to : g[v])
            if(dist[to.F] > dist[v] + to.S)
        {
            dist[to.F] = dist[v] + to.S;
            q.push({-dist[to.F], to.F});
        }
    }

    if(dist[n - 1] == inf)
        cout << -1;
    else
        cout << max(0ll, dist[n - 1] - p);

}


void solve2()
{
     int mx = 0;
     int now = p;
     int ans = 0;

     for(int i = 0; i < n - 1; i++)
     {
         mx = max(mx, w[i]);
         if(now >= cost[i])
         now -= cost[i];
         else
         {
             int need = cost[i] - now;
             int cnt = need / mx + bool(need % mx);

             now += cnt * mx;
             ans += cnt;
             now -= cost[i];
         }


     }

     cout << ans;
}
int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #else

    #endif // LOCAL



    cin >> n >> m >> p >> test;

    for(int i = 0; i < n; i++)
        cin >> w[i];

    for(int i = 0; i < m; i++)
    {
        int x, y, c;
        cin >> x >> y >> c;

        x --;
        y --;

        g[x].pb({y, c});
        pref[i + 1] = pref[i] + c;
        cost[i] = c;
//        g[y].pb({x, c});


    }

    if(test == 1)
    {
        solve1();
        return 0;
    }

    if(test == 2)
    {
        solve2();
        return 0;
    }










    return 0;
}


