#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>
#define int long long
#define sz(a) (int)a.size()

using namespace std;

const int N = 805, INF = 1e16;

struct edge{
    int to, mx, c;
    edge(int a, int b, int d) {
        to = a;
        mx = b;
        c = d;
    }
};

vector<pair<int, int>> g[N];
int w[N], used[N][N];
vector<edge> gr[N][N];
pair<int, int> dp[N][N];

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        --u;
        --v;
        g[u].push_back({v, c});
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (auto l : g[i]) {
                int k = j;
                if (w[l.first] > w[k]) {
                    k = l.first;
                }
                gr[i][j].push_back(edge(l.first, k, l.second));
            }
        }
    }
    for (int i = 0; i < N; ++i) {
        for (int j = 0; j < N; ++j) {
            dp[i][j] = {INF, -INF};
        }
    }
    dp[0][0] = {0, p};
    set<tuple<int, int, int, int>> s;
    s.insert({0, -p, 0, 0});
    while (!s.empty()) {
        auto cur = *s.begin();
        s.erase(cur);
        int v = get<2>(cur);
        int x = get<3>(cur);
        int sh = get<0>(cur);
        int mon = -get<1>(cur);
        used[v][x] = 1;
        for (auto i : gr[v][x]) {
            int to = i.to;
            int tox = i.mx;
            int cost = i.c;
            if (used[to][tox]) continue;
            int need = cost - mon;
            if (need <= 0) {
                if (sh < dp[to][tox].first || (sh == dp[to][tox].first && mon - cost > dp[to][tox].second)) {
                    tuple<int, int, int, int> cur = {dp[to][tox].first, -dp[to][tox].second, to, tox};
                    s.erase(cur);
                    dp[to][tox].first = sh;
                    dp[to][tox].second = mon - cost;
                    cur = {dp[to][tox].first, -dp[to][tox].second, to, tox};
                    s.insert(cur);
                }
            }
            else {
                int mosh = (need + w[x] - 1) / w[x];
                mon += mosh * w[x];
                sh += mosh;
                if (sh < dp[to][tox].first || (sh == dp[to][tox].first && mon - cost > dp[to][tox].second)) {
                    tuple<int, int, int, int> cur = {dp[to][tox].first, -dp[to][tox].second, to, tox};
                    s.erase(cur);
                    dp[to][tox].first = sh;
                    dp[to][tox].second = mon - cost;
                    cur = {dp[to][tox].first, -dp[to][tox].second, to, tox};
                    s.insert(cur);
                }
            }
        }
    }
    int ans = INF;
    for (int i = 0; i < n; ++i) {
        ans = min(ans, dp[n - 1][i].first);
    }
    if (ans == INF) {
        ans = -1;
    }
    cout << ans << '\n';
}
