#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define int long long

using namespace std;
typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

mt19937 rnd(0);

int n, m, p;
vector<int> w;
vector<vector<pair<int, int>>> g;

void solve_1() {
    vector<pair<int, int>> pr(n, {-1, -1});
    vector<int> d(n, 1000000000000000);
    vector<bool> used(n, false);
    d[0] = 0;
    set<pair<int, int>> q;
    for (int i = 0; i < n; ++i) q.emplace(d[i], i);
    while (!q.empty()) {
        auto [dist, v] = *q.begin();
        q.erase(q.begin());
        used[v] = true;
        for (auto [u, cost]: g[v]) {
            if (used[u]) continue;
            q.erase({d[u], u});
            if (d[u] > dist + cost) {
                d[u] = dist + cost;
                pr[u] = {v, cost};
            }
            q.insert({d[u], u});
        }
    }
    int sm = 0, ind = n - 1;
    while (ind != 0) {
        sm += pr[ind].second;
        ind = pr[ind].first;
    }
    cout << sm - p;
}

signed main() {
    cin >> n >> m >> p;
    int gr; cin >> gr;
    w.resize(n); cin >> w;
    for (int i = 0; i < m; ++i) {
        int ai, bi, si;
        cin >> ai >> bi >> si;
        --ai, --bi;
        g[ai].emplace_back(bi, si);
    }
    if (gr == 1) solve_1();
    /*else if (gr == 2) solve_2();
    else solve_3();*/
}