#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR101
#include "debug.h"
#define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"
#else
#define dbg(x)
#endif

typedef long long ll;
typedef long double ld;

#define int ll
#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

void solve1(int n, int m, int p, vector<int> w, vector<tuple<int, int, int>> e,
    vector<vector<pair<int, int>>> g) {
    
    vector<ll> d(n, LLONG_MAX);
    d[0] = 0;
    set<pair<ll, int>> st;
    st.insert({ 0, 0 });

    while (!st.empty()) {
        int u = st.begin()->second;
        st.erase(st.begin());
        for (auto [v, c] : g[u]) {
            if (d[v] > d[u] + c) {
                st.erase({ d[v], v });
                d[v] = d[u] + c;
                st.insert({ d[v], v });
            }
        }
    }

    if (d[n - 1] == LLONG_MAX) {
        cout << -1 << '\n';
    } else {
        cout << max(0ll, d[n - 1] - p) << '\n';
    }
}

void solve2(int n, int m, int p, vector<int> w, vector<tuple<int, int, int>> e,
    vector<vector<pair<int, int>>> g) {
    vector<int> rm(n, n);
    {
        vector<int> st;
        for (int i = 0; i < n; ++i) {
            while (!st.empty() && w[i] < w[st.back()]) {
                rm[st.back()] = i;
                st.pop_back();
            }
            st.push_back(i);
        }
    }

    vector<ll> ps(n);
    for (int i = 0; i < n - 1; ++i) {
        ps[i + 1] = ps[i] + get<2>(e[i]);
    }

    int i = 0;
    ll ans = 0;
    while (i < n) {
        if (rm[i] == n) {

        }
    }
}

int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    while (T--) {
        int n, m, p, group;
        cin >> n >> m >> p >> group;

        vector<int> w(n);
        for (int& x : w) cin >> x;

        vector<tuple<int, int, int>> e(m);
        vector g(n, vector<pair<int, int>>());
        for (auto& [u, v, c] : e) {
            cin >> u >> v >> c;
            --u, --v;
            g[u].emplace_back(v, c);
        }

        if (group == 1) {
            solve1(n, m, p, w, e, g);
        }
    }
}