#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 800;

ll rast[MAXN][MAXN];

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, p, q;
    cin >> n >> m >> p >> q;
    vector <ll> w(n);
    vector <pair <ll, ll>> g[n];
    vector <pair <ll, ll>> rg[n];
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    ll a, b, c;

    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].push_back({b, c});
        rg[b].push_back({a, c});
    }
    int v;
    vector <int> usedd(n, -1);
    for (int i = 0; i < n; i++) {
        set <pair <ll, int>> go;
        go.insert({0, i});
        usedd[i] = i;
        while (!go.empty()) {
            auto it = go.begin();
            v = (*it).second;
            usedd[v] = i;
            go.erase(it);
            for (auto [u, cc] : rg[v]) {
                if (usedd[u] != i) {
                    if (rast[i][u] == 0) {
                        rast[i][u] = rast[i][v] + cc;
                        go.insert({rast[i][u], u});
                    } else if (rast[i][u] > rast[i][v] + cc){
                        go.erase({rast[i][u], u});
                        rast[i][u] = rast[i][v] + cc;
                        go.insert({rast[i][u], u});
                    }
                }
            }
        }
    }
    v = 0;
    vector <pair <ll, ll>> dp(n, {-1, -1});
    vector <bool> used(n, false);
    dp[0] = {0, p};
    while (v != n - 1 && !used[v]) {
        used[v] = true;
        for (int i = 0; i < n; i++) {
            if (rast[i][v]) {
                if (dp[i] == pair <ll, ll>{-1, -1}) {
                    ll cnt1 = dp[v].first;
                    ll cnt2 = dp[v].second;
                    cnt2 -= rast[i][v];
                    if (cnt2 < 0) {
                        cnt1 += ((abs(cnt2) + w[v] - 1) / w[v]);
                        cnt2 = ((cnt2 % w[v]) + w[v]) % w[v];
                    }
                    dp[i] = {cnt1, cnt2};
                } else {
                    ll cnt1 = dp[v].first;
                    ll cnt2 = dp[v].second;
                    cnt2 -= rast[i][v];
                    if (cnt2 < 0) {
                        cnt1 += ((abs(cnt2) + w[v] - 1) / w[v]);
                        cnt2 = ((cnt2 % w[v]) + w[v]) % w[v];
                    }
                    if (dp[i].first == cnt1) {
                        dp[i].second = max(cnt2, dp[i].second);
                    } else {
                        dp[i] = min(dp[i], {cnt1, cnt2});
                    }
                }
            }
        }
        for (int i = 0; i < n; i++) {
            if (!used[i] && pair <ll, ll>{-1, -1} != dp[i]) {
                if (used[v]) {
                    v = i;
                } else if (dp[v].first == dp[i].first) {
                    if (dp[v].second < dp[i].second) {
                        v = i;
                    }
                } else if (dp[v] > dp[i]) {
                    v = i;
                }
            }
        }
    }
    cout << dp[n - 1].first;
}