#include<bits/stdc++.h>
#define pb push_back
#define fr first
#define sc second
#define ll long long
#define de(x) cout << #x << " = " << x << endl;
#define all(A) A.begin(), A.end()
using namespace std;

template<class T> using matrix = vector<vector<T>>;

ll N, M, P, group;
matrix<pair<int, int>> G;
vector<ll> W;

int main(){
	cin >> N >> M >> P >> group;
	if(group == 1){
		for(int i = 1; i <= N; i ++){
			int a; cin >> a;
		}
		G.resize(N + 1);
		for(int i = 0; i < M; i ++){
			int u, v, w; cin >> u >> v >> w;
			G[u].pb({v, w});
		}
		priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> pq;
		vector<ll> used1(N + 1), dist1(N + 1, 1e15);
		dist1[1] = 0;
		pq.push({0, 1});
		while(!pq.empty()){
			int u = pq.top().sc;
			pq.pop();
			if(used1[u]) continue;
			used1[u] = true;
			for(auto [v, w] : G[u]){
				if(!used1[v] && dist1[u] + w < dist1[v]){
					dist1[v] = dist1[u] + w;
					pq.push({dist1[v], v});
				}
			}
		}
		if(dist1[N] != 1e15) cout << max(0LL, dist1[N] - P) << endl;
		else cout << "-1\n";
	}
	if(group == 2){
		W.resize(N + 1);
		for(int i = 1; i <= N; i ++){
			cin >> W[i];
		}
		vector<ll> costs(N + 1);
		for(int i = 0; i < M; i ++){
			int a, b; cin >> a >> b >> costs[i + 1];
		}
		ll ans = 0;
		for(int i = 1; i < N; i ++){
			ll e = i, cost = 0;
			while(e < N && W[e] <= W[i]){
				cost += costs[e];
				++ e;
			}
			-- e;
			if(P < cost){
				ll t = (cost - P + W[i] - 1) / W[i];
				ans += t;
				P += t * W[i];
			}
			P -= cost;
			i = e;
		}
		cout << ans << endl;
	}
	if(group == 3){
		W.resize(N + 1);
		for(int i = 1; i <= N; i ++){
			cin >> W[i];
		}
		map<pair<int, int>, ll> costs;
		for(int i = 0; i < M; i ++){
			int a, b, cost; cin >> a >> b >> cost;
			costs[{a, b}] = cost;
		}
		vector<int> path;
		for(int i = 1; i <= N; i ++){
			path.pb(i);
		}
		ll ans = 1e15;
		do{
			ll curr = 0;
			bool flag = true;
			for(int i = 0; i < N; i ++){
				if(path[i] == N) break;
				if(!costs.count({path[i], path[i + 1]})){
					flag = false;
				}
			}
			if(!flag) continue;
			for(int i = 0; i < N; i ++){
				ll e = i, cost;
				while(e < N && path[i] != N && W[path[e]] <= W[path[i]]){
					cost += W[path[e]];
					++ e;
				}
				-- e;
				if(P < cost){
					ll t = (cost - P + W[i] - 1) / W[i];
					curr += t;
					P += t * W[i];
				}
				P -= cost;
				i = e;
			}
			ans = min(ans, curr);
		}while(next_permutation(all(path)));
		if(ans == 1e15) cout << "-1\n";
		else cout << ans << endl;
	}
}