#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}
struct edge{
        int to, w;
    };
vector<vector<edge>> gr;

vector<vector<ll>> dists;
void get(int i){
    dists[i][i] = 0;
    set<pair<ll, ll>> had;
    had.insert({0, i});
    while (!had.empty()){
        int v = had.begin()->second;
        had.erase(had.begin());
        for (auto el : gr[v]){
            if (dists[i][el.to] > dists[i][v] + el.w){
                had.erase({dists[i][el.to], el.to});
                dists[i][el.to] = dists[i][v] + el.w;
                had.insert({dists[i][el.to], el.to});
            }
        }
    }
}

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    gr.resize(n);
    dists.resize(n, vector<ll> (n, 1e16));
    for (int i = 0; i < m; i++){
        int u, v, s;
        cin >> u >> v >> s;
        u--;
        v--;
        gr[u].push_back({v, s});
        gr[v].push_back({u, s});
    }
    for (int i = 0; i < n; i++){
        get(i);
    }
    cout << dists[0][n - 1] << "\n";


}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    ll t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
