#include <iostream>
#include <algorithm>
#include <map>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <queue>
using namespace std;
int main() {
    long long n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<long long> w1(n);
    vector<vector<pair<long long, long long>>> v1(n);
    for (long long i = 0; i < n; i++)
        cin >> w1[i];
    for (long long i = 0; i < m; i++) {
        long long a, b, s;
        cin >> a >> b >> s;
        v1[a - 1].push_back({b - 1, s});
    }
    if (g == 1) {
        vector<long long> met(n, 1e18);
        met[0] = 0;
        queue<long long> q;
        q.push(0);
        while (!q.empty()) {
            long long x = q.front();
            q.pop();
            for (long long i = 0; i < v1[x].size(); i++) {
                if (met[x] + v1[x][i].second < met[v1[x][i].first]) {
                    met[v1[x][i].first] = met[x] + v1[x][i].second;
                    q.push(v1[x][i].first);
                }
            }
        }
        if (met[n - 1] == 1e18)
            cout << -1;
        else
            cout << max(met[n - 1] - p, 0ll);
        return 0;
    }
    return 0;
}
