#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) (a.size())

#define line cout<<'\n'

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 815;

vector <vector<int>> g(nmax, vector <int> (nmax, -1));
vector <bool> used(nmax);

void dfs(int v) {
    used[v] = true;
    for (int i = 1; i < nmax; i++) {
        if (!used[i] && g[v][i] != -1)
            dfs(i);
    }
}

vector <int> d(nmax), w(nmax);
vector <int> par(nmax);

void bfs(int v) {
    d[v] = 0;
    par[v] = v;
    queue<int> q;
    q.push(v);
    while(!q.empty()) {
        v = q.front();
        q.pop();
        for (int i = 1; i < nmax; i++) {
            if (!used[i] && g[i][v] != -1) {
                d[i] = d[v] + g[i][v];
                q.push(i);
                par[i] = v;
                used[i] = true;
            }
        }
    }
}

void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 1; i <= n; i++)
        cin >> w[i];
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u][v] = c;
    }

    dfs(1);
    if (!used[n]) {
        cout << -1;
        return;
    }
    fill(all(used), false);

    if (G == 0) {
        

        return;
    }
    if (G == 1) {
        bfs(n);
        int ans = inf, k = 0;
        int v = 1;
        while (v != n) {
            int to = par[v];
            ans = min(ans, k + (max(0LL, (d[v] - p + w[v] - 1) / w[v])));
            int buf = max(0LL, (g[v][to] - p + w[v] - 1) / w[v]);
            p += buf * w[v];
            p -= g[v][to];
            k += buf;
            v = to;
        }
        cout << ans;

        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}