#include <iostream>
#include <vector>
#include <random>
#include <set>

#define int long long
typedef long  long ll;
using namespace std;

//
// mt19937 rnd(time(0));
vector<int> dp, farm; // dp - cколько раз надо шоу давать, farm - сколько мак денег за шоу можем нафармить за 1 шоу до этого города и в нем.
vector<vector<pair<int, int>>> g;

void dfs(int v, int money, int max_farm) {
    //cout << v << endl;
    max_farm = max(max_farm, farm[v]);

    for (auto [u, w] : g[v]) {

        //if (farm[u] <= max_farm && dp[u] != (int) 1e9) continue;
        if (dp[u] > dp[v] + (max((ll) 0, (w - money)) + max_farm - 1) / max_farm) {
//            cout << v << " " << u << " " << money << " " << (max((ll) 0, (w - money)) + max_farm - 1) / max_farm << endl;
            dp[u] = dp[v] + (max((ll) 0, (w - money)) + max_farm - 1) / max_farm;
            int new_money = money - w;
            if (new_money < 0) {
                new_money = ((abs(new_money) + max_farm - 1) / max_farm) * max_farm - abs(new_money);
            }
            dfs(u, new_money, max_farm);
        }

    }
}

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    g.resize(n);
    dp.assign(n, 1e9);
    farm.resize(n);

    for (int i = 0; i < n; i++) {
        cin >> farm[i];
    }
    
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].emplace_back(b, c);
    }
    dp[0] = 0;
    dfs(0, p, 0);
//    for (int i : dp) {
//        cout << i << " ";
//    }
//    cout << endl;
    if (dp[n - 1] == (int) 1e9) {
        cout << -1;
    } else {
        cout << dp[n - 1];
    }


}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
//
//vect a.x * b.y - b.x * a.y
//scal a.x * b.x + a.y * b.y
