#include <bits/stdc++.h>

//#define _GLIBCXX_DEBUG

//#define GCC optimize("O3")
//#define GCC optimize("Ofast")
//#define GCC optimize("unroll-loops")
//#define GCC target("avx2")

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using namespace std;

int n, m, p, group;
vector<int> w;
vector<vector<pair<int, int>>> g;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> n >> m >> p >> group;
    w.resize(n);
    g.resize(n);
    for (int &i: w) cin >> i;
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        g[v - 1].emplace_back(u - 1, s);
    }
    if (group == 1) {
        vector<int> dist(n, INT64_MAX);
        vector<bool> used(n, true);
        dist[0] = 0;
        for (int i = 0; i < n; ++i) {
            int index = -1;
            for (int j = 0; j < n; ++j) {
                if (used[j] && (index == -1 || dist[index] > dist[j])) {
                    index = j;
                }
            }
            if (dist[index] == INT64_MAX) break;
            used[index] = false;
            for (auto &[u, s]: g[index]) {
                if (dist[index] + s < dist[u]) {
                    dist[u] = dist[index] + s;
                }
            }
        }
        if (dist[n - 1] == INT64_MAX) {
            cout << -1;
        } else {
            cout << max(0ll, dist[n - 1] - p);
        }
    } else if (group == 2) {
        int cost = 0;
        for (int v = 0; v < n; ++v) {
            for (auto &[u, s]: g[v]) {
                cost += s;
            }
        }
        int t = *max_element(all(w));
        cout << max(0ll, (cost - p + t - 1) / t);
    } else {

    }
    return 0;
}