#include "bits/stdc++.h"
using namespace std;
#define nt int
#define int long long
const int maxn = 805;
vector <pair<int, nt>> g[maxn];
int w[maxn];
signed main() {
    int n, m, p, te;
    cin >> n >> m >> p >> te;
    for (int i = 1; i <= n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].push_back({v, w});
    }
    if (te == 2) {
        int ans = 0;
        int mp = w[1];
        for (int city = 1; city < n; city++) {
            mp = max(mp, w[city]);
            int need = g[city][0].second - p;
            if (need > 0) {
                p += ((need + mp - 1) / mp) * mp;
                ans += (need + mp - 1) / mp;
            }
            p -= g[city][0].second;
        }
        cout << ans << '\n';
        return 0;
    }
    if (te == 1) {
        vector <int> dist(n + 1, 1e18);
        dist[1] = 0;
        set<pair<int, int>> der;
        for (int i = 1; i <= n; i++) der.insert({dist[i], i});
        while (!der.empty()) {
            int v = der.begin() -> second;
            if (dist[v] >= 1e18) break;
            der.erase(der.begin());
            for (auto [to, cost]: g[v]) {
                if (dist[to] > dist[v] + cost) {
                    der.erase({dist[to], to});
                    dist[to] = dist[v] + cost;
                    der.insert({dist[to], to});
                }
            }
        }
        if (dist[n] >= 1e18) {
            cout << -1;
        } else cout << max(0ll, dist[n] - p);
        return 0;
    }
    vector <vector <int>> to(n + 1, vector <int> (n + 1, 1e12));
    for (int i = 1; i <= n; i++) {
        to[i][i] = 0;
        for (auto [u, w]: g[i]) to[i][u] = min(to[i][u], w);
    }
    for (int k = 1; k <= n; k++) {
        for (int i = 1; i <= n; i++) {
            for (int j = 1; j <= n; j++) {
                if (to[i][j] > to[i][k] + to[k][j]) {
                    to[i][j] = to[i][k] + to[k][j];
                }
            }
        }
    }
    if (to[1][n] >= 1e18) {
        cout << -1;
        return 0;
    }
    vector <pair<int, int>> get_to(n + 1, {1e13, 0});
    vector <pair<int, int>> s;
    for (int i = 1; i <= n; i++) {
        s.push_back({w[i], i});
    }
    std::sort(s.begin(), s.end());
    get_to[1] = {0, p};
    for (int i = 1; i <= n; i++) {
        for (auto [cnt, v]: s) {
            for (int prev = 1; prev <= n; prev++) {
                if (prev == v) continue;
                int cst = to[prev][v];
                int money;
                int vyst;
                if (cst > get_to[prev].second) {
                    int left = cst - get_to[prev].second;
                    vyst = (left + w[prev] - 1) / w[prev];
                    money = vyst * w[prev] - left;
                    vyst += get_to[prev].first;
                } else {
                    vyst = get_to[prev].first;
                    money = get_to[prev].second - cst;
                }
                if (vyst < get_to[v].first) {
                    int can_earn = (get_to[v].first - vyst) * w[v] + money;
                    if (can_earn > get_to[v].second) {
                        get_to[v] = {vyst, money};
                    }
                } else {
                    int can_earn = get_to[v].second + w[v] * (vyst - get_to[v].first);
                    if (can_earn < money) {
                        get_to[v] = {vyst, money};
                    }
                }
            }
        }
    }
    cout << get_to[n].first;


    return 0;
}