#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>

#pragma warning(disable: 4996)

typedef long long ll;
typedef long double ld;

using namespace std;

#define vec vector
#define pii pair<int, int>
#define pll pair<ll, ll>
#define int ll

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

map<int, vec<pii>> gr;

void solve() {
    int n, m, p, g; cin >> n >> m >> p >> g;

    vec<int> qwe(n);
    for (int i = 0; i < n; i++) {
        cin >> qwe[i];
    }

    gr.clear();
    for (int i = 0; i < m; i++) {
        int a, b, s; cin >> a >> b >> s;
        gr[a - 1].push_back({b - 1, s});
    }

    if (g == 1) {
        vec<ll> dist(n, LINF);
        dist[0] = 0;
        set<pii> q;
        q.insert({0, 0});
        while (!q.empty()) {
            int v = q.begin()->second;
            for (auto [to, w] : gr[v]) {
                if (dist[v] + w < dist[to]) {
                    q.erase({dist[to], to});
                    dist[to] = dist[v] + w;
                    q.insert({dist[to], to});
                }
            }
        }
        cout << max(0LL, dist[n - 1] - p) << "\n";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

//#ifdef _DEBUG
//    freopen("input.txt", "r", stdin);
//#endif // _DEBUG

    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}