#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 5e6 + 300, mod = 1e9 + 7;
ll inf = 1e14;
void solve(){
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<ll> cost(n + 1);
    for(int i = 1; i <= n; i++)
        cin >> cost[i];
    vector<vector<pair<ll, ll>>> graph(n + 1);
    for(int i = 0; i < m; i++){
        ll a, b, w;
        cin >> a >> b >> w;
        graph[a].push_back(make_pair(b, w));
    }
    if(g != -1){
        vector<ll> dst(n + 1, inf);
        dst[1] = 0;
        priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
        q.push(make_pair(0, 1));
        while(!q.empty()){
            pair<ll, ll> cur = q.top();
            q.pop();
            if(dst[cur.second] < cur.first)
                continue;
            for(pair<ll, ll> nxt : graph[cur.second]){
                ll nv = nxt.first, ndst = cur.first + nxt.second;
                if(dst[nv] > ndst){
                    dst[nv] = ndst;
                    q.push(make_pair(ndst, nv));
                }
            }
        }
        if(dst[n] == inf){
            cout << -1 << "\n";
            return;
        }
        cout << max((ll)0, dst[n] - p);
    }
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}