#include <bits/stdc++.h>

using namespace std;
typedef long long int ll;
const int maxn = 200005;
const ll INF = 2000000000000000000;
const int mod = 1000000007;
ll w[maxn];
vector<pair<ll, ll>> g[maxn];
ll dikstra(ll n) {
    set<pair<ll, ll>> st;
    st.insert({0, 1});
    for (int i = 2; i <= n; ++i) {
        st.insert({INF, i});
    }
    vector<ll> len(n + 1, INF);
    vector<bool> used(n + 1, false);
    len[1] = 0;
    while (!st.empty()) {
        auto v = *st.begin();
        used[v.second] = true;
        for (auto u : g[v.second]) {
            if (used[u.first]) {
                continue;
            }
            st.erase({len[u.first], u.first});
            len[u.first] = min(len[u.first], v.first + u.second);
            st.insert({len[u.first], u.first});
        }
        st.erase(st.begin());
    }
    /*for (int i = 1; i <= n; ++i) {
        cout << len[i] << " ";
    }
    cout << "\n";*/
    return len[n];
}
int main() {
    cin.tie(0);
    cout.tie(0);
    cin.sync_with_stdio(0);
    cout.sync_with_stdio(0);
    ll n, m, p, gr;
    cin >> n >> m >> p >> gr;
    for (int i = 1; i <= n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        ll a, b, s;
        cin >> a >> b >> s;
        g[a].push_back({b, s});
    }
    if (gr == 1) {
        ll pq = dikstra(n);
        if (pq == INF) {
            cout << -1 << "\n";
            return 0;
        }
        cout << max(pq - p, 0ll) << "\n";
        return 0;
    }
    if (gr == 2) {
        ll v = 1, maxx = w[1], ans = 0;
        while (v != n) {
            if (p >= g[v][0].second) {
                p -= g[v][0].second;
            } else {
                ans += (g[v][0].second - p) / maxx;
                if ((g[v][0].second - p) % maxx != 0) {
                    ++ans;
                    p = maxx - (g[v][0].second - p) % maxx;
                } else {
                    p = 0;
                }
            }
            ++v;
            maxx = max(maxx, w[v]);
        }
        cout << ans << "\n";
    }
    return 0;
}
/*
6 7 3 1
1 1 1 1 1 1
1 2 3
1 3 4
2 4 1
3 4 1
4 5 1
2 5 3
5 6 7
 */