#include <iostream>
#include <string>
#include <vector>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>
#include <cmath>
#include <random>
#include <ctime>
#include <cassert>
#include <algorithm>
#define int long long
using namespace std;

vector<vector<pair<int, int>>> g;
vector<int> costs;

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m, p, gr;
	cin >> n >> m >> p >> gr;
	costs.resize(n);
	g.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> costs[i];
	}
	int a, b, s;
	for (int i = 0; i < m; ++i) {
		cin >> a >> b >> s;
		if (a == b) {
			continue;
		}
		a--; b--;
		g[a].push_back({ b, s });
	}
	if (gr == 1) {
		int now = 0;
		vector<int> rast(n, 1e18);
		rast[0] = 0;
		set<pair<int, int>> vars;
		while (true) {
			for (auto i : g[now]) {
				if (rast[i.first] > rast[now] + i.second) {
					rast[i.first] = rast[now] + i.second;
					vars.insert({ rast[now] + i.second, i.first });
				}
			}
			if (vars.empty()) {
				break;
			}
			pair<int, int> el = *vars.begin();
			while (rast[el.second] != el.first) {
				vars.erase(vars.begin());
				if (vars.empty()) {
					break;
				}
				el = *vars.begin();
			}
			if (vars.empty()) {
				break;
			}
			now = el.second;
			vars.erase(vars.begin());
			if (now == n - 1) {
				break;
			}
		}
		if (rast[n - 1] == 1e18) {
			cout << -1 << '\n';
		}
		else {
			cout << max(1ll * 0, rast[n - 1] - p);
		}
	}
	else if (gr == 2) {
		vector<int> st;
		vector<int> where(n, n);
		for (int i = n - 1; i > -1; --i) {
			while (!st.empty() && costs[st.back()] <= costs[i]) {
				st.pop_back();
			}
			if (!st.empty()) {
				where[i] = st.back();
			}
			st.push_back(i);
		}
		vector<int> prefs = { 0 };
		for (int i = 0; i < n - 1; ++i) {
			prefs.push_back(prefs.back() + g[i][0].second);
		}
		int now = 0;
		int ans = 0;
		while (now != n - 1) {
			if (where[now] == n) {
				//!!!
				ans += ((prefs[n - 1] - prefs[now]) - p + costs[now] - 1) / costs[now];
				now = n - 1;
			}
			else if (prefs[where[now]] - prefs[now] > p) {
				ans += ((prefs[where[now]] - prefs[now]) - p + costs[now] - 1) / costs[now];
				p += (((prefs[where[now]] - prefs[now]) - p + costs[now] - 1) / costs[now]) * (costs[now]);
				p -= prefs[where[now]] - prefs[now];
				now = where[now];
			}
			else {
				p -= prefs[where[now]] - prefs[now];
				now = where[now];
			}
		}
		cout << ans << '\n';
	}
}

/*
4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50
*/