#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int ll

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

struct Edge {
    int from, to;
    ll s;

    Edge() = default;
    Edge(int from, int to, ll s) : from(from), to(to), s(s) {}
};

int n, m, p, group;
vector<vector<int>> g;
vector<Edge> e;
vector<ll> w, compr_w;
ll ans = INFLL;
pll used[801][801];

//void go(int v, ll cur, ll mx, ll money) {
//    if (v == n - 1) {
//        ans = min(ans, cur);
//        return;
//    }
//    int id = lower_bound(all(compr_w), mx) - compr_w.begin();
//    if (used[v][id] < cur) {
//        return;
//    }
//    used[v][id] = cur;
//    mx = max(mx, w[v]);
//    for (auto i : g[v]) {
//        int u = e[i].to;
//        ll s = e[i].s;
//        if (s > money) {
//            ll need = ((s - money) + mx - 1) / mx;
//            go(u, cur + need, mx, money + need * mx - s);
//        } else {
//            go(u, cur, mx, money - s);
//        }
//    }
//}

void solve() {
    cin >> n >> m >> p >> group;
    g.resize(n);
    e.resize(m);
    w.resize(n);
    vector<vector<int>> gg(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            used[i][j] = {INFLL, 0};
        }
    }
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        --v; --u;
        gg[v].emplace_back(i);
        e[i] = {v, u, s};
    }
    for (int v = 0; v < n; ++v) {
        if (gg[v].empty()) {
            continue;
        }
        sort(all(gg[v]), [&](int a, int b) {
            return (e[a].to < e[b].to) || (e[a].to == e[b].to && e[a].s < e[b].s) || (e[a].to == e[b].to && e[a].s == e[b].s && w[e[a].to] < w[e[b].to]);
        });
        g[v].emplace_back(gg[v][0]);
        for (int i = 1; i < sz(gg[v]); ++i) {
            if (e[g[v].back()].to != e[gg[v][i]].to) {
                g[v].emplace_back(gg[v][i]);
            }
        }
    }
    compr_w = w;
    sort(all(compr_w));
    compr_w.resize(unique(all(compr_w)) - compr_w.begin());

    auto get_id = [&](ll x) {
        return (int)(lower_bound(all(compr_w), x) - compr_w.begin());
    };

    if (group == 1) {
        vector<ll> d(n, INFLL);
        d[0] = 0;
        set<pii> q;
        q.emplace(0, 0);
        while (!q.empty()) {
            int v = q.begin()->second;
            q.erase(q.begin());
            for (auto i : g[v]) {
                int u = e[i].to;
                ll s = e[i].s;
                if (d[u] > d[v] + s) {
                    q.erase({d[u], u});
                    d[u] = d[v] + s;
                    q.emplace(d[u], u);
                }
            }
        }
        if (d[n - 1] == INFLL) {
            cout << -1 << en;
            return;
        }
        cout << max(0LL, d[n - 1] - p);
        return;
    }
    if (group == 2) {
        ll mx = w[0];
        ans = 0;
        ll now = p;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(mx, w[i]);
            int id = g[i][0];
            ll s = e[id].s;
            if (s > now) {
                ll need = ((s - now) + mx - 1) / mx;
                ans += need;
                now += need * mx;
            }
            now -= s;
        }
        cout << ans << en;
        return;
    }
    if (group >= 3 || group == 0) {
        ans = INFLL;
        int id = get_id(w[0]);
        used[0][id] = {0, p};
        set<pair<ll, pii>> q;
        q.insert({0, {0, id}});
        while (!q.empty()) {
            auto p = *q.begin();
            q.erase(q.begin());
            int v = p.second.first;
            id = p.second.second;
            if (v == n - 1) {
                ans = min(ans, used[v][id].first);
                continue;
            }
            ll money_now = used[v][id].second;
            ll mx = max(w[v], compr_w[id]);
            int new_id = get_id(mx);
            for (auto i : g[v]) {
                int u = e[i].to;
                ll s = e[i].s;
                ll money = money_now;
                ll need = 0;
                if (s > money) {
                    need = ((s - money) + mx - 1) / mx;
                }
                money = money + need * mx - s;
                ll cur = used[v][id].first + need;
                if (used[u][new_id].first > cur) {
                    q.erase({used[u][new_id].first, {u, new_id}});
                    used[u][new_id] = {cur, money};
                    q.insert({used[u][new_id].first, {u, new_id}});
                }
            }
        }
        if (ans == INFLL) {
            cout << -1 << en;
            return;
        }
        cout << ans << en;
        return;
    }
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}