#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);

int n, m, p;
const int INF = 1e18;

vector<int> w;
vector<vector<pair<int, int>>> g;

void solve1() {
    set<pair<int, int>> q;
    vector<int> d(n, INF);
    d[0] = 0;
    q.insert({d[0], 0});
    while (!q.empty()) {
        auto [dist, v] = *q.begin();
        q.erase(q.begin());
        for (auto [u, ww] : g[v]) {
            if (d[u] > dist + ww) {
                q.erase({d[u], u});
                d[u] = dist + ww;
                q.insert({d[u], u});
            }
        }
    }
    cout << (d[n - 1] == INF ? -1 : d[n - 1]) << '\n';
}

void solve() {
    int type;
    cin >> n >> m >> p >> type;
    g.resize(n);
    w.resize(n);
    for (auto &i : w) cin >> i;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        g[a].emplace_back(b, c);
        g[b].emplace_back(a, c);
    }
    if (type == 1) {
        solve1();
    }
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}