#include <bits/stdc++.h>

#define int long long

using namespace std;

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<int> wi(n);
    for (auto &el: wi)
        cin >> el;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, si;
        cin >> u >> v >> si;
        --u, --v;
        g[u].push_back({v, si});
    }
    if (G == 1) {
        vector<int> dist(n);
        dist[0] = 0;
        set<pair<int, int>> s;
        s.insert({0, 0});
        while (!s.empty()) {
            int v = s.begin()->second;
            s.erase(s.begin());
            if (v == n - 1) {
                cout << max(0ll, dist[v] - p);
                return 0;
            }
            for (auto [to, w]: g[v]) {
                if (dist[to] == 0 || dist[v] + w < dist[to]) {
                    s.erase({dist[to], to});
                    dist[to] = dist[v] + w;
                    s.insert({dist[to], to});
                }
            }
        }
        cout << -1;
        return 0;
    } else if (G == 2) {
        vector<int> a(n);
        for (int i = 0; i < n - 1; ++i)
            a[i] = g[i][0].second;
        vector<int> suffsum(n);
        suffsum[n - 1] = 0;
        for (int i = n - 2; i >= 0; --i)
            suffsum[i] = suffsum[i + 1] + a[i];
        vector<map<int, int>> dp(n);
        dp[0][0] = p;
        for (int i = 0; i < n - 1; ++i) {
            for (auto [j, val]: dp[i]) {
                for (int k = 0;; ++k) {
                    int vl = val + k * wi[i] - a[i];
                    if (vl >= 0) {
                        dp[i + 1][j + k] = max(dp[i + 1][j + k], vl);
                        if (dp[i + 1][j + k] >= suffsum[i + 1])
                            break;
                    }
                }
            }
        }
        cout << dp.back().begin()->first;
        return 0;
    }
}