#pragma 'GCC-optimize'
#pragma 'unroll-loops'
#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(),x.end()
#define f first
#define s second

using namespace std;

void solve() {
    int n, m, p, T, inf = 2e14;
    cin >> n >> m >> p >> T;
    vector <int> w(n);
    vector <vector <pair <int, int> > > g(n);
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int u, v, W; cin >> u >> v >> W;
        u--; v--;
        g[u].emplace_back(v, W);
    }
    vector <pair <int, int> > d(n, {inf, inf});
    d[0] = {p, 0};
    set <pair <int, int> > q;
    q.insert({p, 0});
    while (!q.empty()) {
        int u = q.begin()->second;
        q.erase(q.begin());
        for (auto &[v, W]: g[u]) {
            if (d[u].f >= W) {
                if (d[v].s > d[u].s) {
                    q.erase({d[v].f, v});
                    d[v].f = d[v].f - W;
                    d[v].s = d[u].s;
                    q.insert({d[v].f, v});
                }
            }
            else {
                if (d[v].s > d[u].s + (int)ceil((double)(W - d[u].f) / (double)w[u])) {
                    q.erase({d[v].f, v});
                    d[v].f = 0;
                    d[v].s = d[u].s + (int)ceil((double)(W - d[u].f) / (double)w[u]);
                    q.insert({d[v].f, v});
                }
            }
        }
    }
    if (d.back().s == inf) cout << -1;
    else cout << d.back().s;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        solve();
    }
    return 0;
}