#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <tuple>
using namespace std;
typedef long long ll;
typedef long double ld;
struct st {
	ll kol, ost;
};
bool operator<(st a, st b) {
	return tie(a.kol, b.ost) < tie(b.kol, a.ost);
}
ll inf = 1e18;
ll len[800][800], kol[800];
st lenans[800][800];
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	ll n, m, p, tn; cin >> n >> m >> p >> tn;
	for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) len[i][j] = inf, lenans[i][j] = { inf, -1 };
	for (int i = 0; i < n; i++) cin >> kol[i], len[i][i] = 0, lenans[i][i] = { 0, p };
	for (int i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c; a--, b--;
		len[a][b] = min(len[a][b], c);
		if (c <= p) lenans[a][b] = min(lenans[a][b], { 0, p - c });
		else {
			ll cnt = (c - p + kol[a] - 1) / kol[a];
			lenans[a][b] = min(lenans[a][b], { cnt, p + kol[a] * cnt - c });
		}
	}
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				len[i][j] = min(len[i][j], len[i][k] + len[k][j]);
			}
		}
	}
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (lenans[i][k].kol == inf || len[k][j] == inf) continue;
				ll cnt = (max(0ll, (len[k][j] - lenans[i][k].ost)) + kol[k] - 1) / kol[k];
				if (lenans[i][j].kol > lenans[i][k].kol + cnt) lenans[i][j] = { lenans[i][k].kol + cnt, cnt * kol[k] + lenans[i][k].ost - len[k][j] };
				else if (lenans[i][j].kol == lenans[i][k].kol + cnt) lenans[i][j].ost = max(lenans[i][j].ost, cnt * kol[k] + lenans[i][k].ost - len[k][j]);
			}
		}
	}
	if (n <= 10) {
		ll ans = 1e18;
		for (int i = 0; i < (1 << n); i++) {
			vector <int> x;
			for (int j = 0; j < n; j++) {
				if ((i & (1 << j))) x.push_back(j);
			}
			if (x.size() == 0 || x[0] != 0 || x.back() != n - 1) continue;
			ll cnt = 0, t = p;
			for (int j = 0; j < x.size() - 1; j++) {
				if (len[x[j]][x[j + 1]] <= t) {
					t -= len[x[j]][x[j + 1]];
				}
				else {
					ll cnt1 = (len[x[j]][x[j + 1]] - t + kol[x[j]] - 1) / kol[x[j]];
					cnt += cnt1;
					t = t + cnt1 * kol[x[j]] - len[x[j]][x[j + 1]];
				}
			}
			ans = min(ans, cnt);
		}
		if (ans == 1e18) ans = -1;
		cout << ans;
		return 0;
	}
	else {
		if (lenans[0][n - 1].kol == inf) cout << -1;
		else cout << lenans[0][n - 1].kol;
	}
	return 0;
}