#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define PB push_back

using namespace std;
ll t, n, a, m, p, g9, b, c, f;
vector<vector<pair<ll, ll>>> g;
vector<vector<ll>> d;
vector<pair<ll, ll>> w;

void solve() {
    cin >> n >> m >> p >> g9;
    g.resize(n);
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i].F;
        w[i].S = i;
    }
    sort(w.begin(), w.end());
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c;
        a--;
        b--;
        g[a].PB({b, c});
    }
    d.resize(n, vector<ll>(n, LLONG_MAX));
    for (int i = 0; i < n; i++) {
        d[i][i] = 0;
        set<pair<ll, ll>> st;
        st.insert({0, i});
        vector<ll> used(n);
        while (!st.empty()) {
            auto el = *st.begin();
            st.erase(el);
            if (!used[el.S]) {
                used[el.S]++;
                for (auto to: g[el.S]) {
                    if (!used[to.F]) {
                        st.erase({d[i][to.F], to.F});
                        d[i][to.F] = min(d[i][to.F], el.F + to.S);
                        st.insert({d[i][to.F], to.F});
                    }
                }
            }
        }
    }
    f = 0;
    vector<ll> dp1(n, LLONG_MAX), dp2(n);
    dp1[0] = 0;
    dp2[0] = p;
    for (int i = 0; i < n; i++) {
        if (w[i].S == 0) {
            f++;
        }
        if (f && dp1[w[i].S] != LLONG_MAX) {
            for (int j = 0; j < n; j++) {
                if (d[w[i].S][j] != LLONG_MAX) {
                    ll temp = d[w[i].S][j];
                    ll k = 0;
                    if (temp > dp2[w[i].S]) {
                        k = (temp - dp2[w[i].S] + w[i].F - 1) / w[i].F;
                    }
                    if (dp1[j] > dp1[w[i].S] + k) {
                        dp1[j] = dp1[w[i].S] + k;
                        dp2[j] = dp2[w[i].S] + k * w[i].F - temp;
                    } else if (dp1[j] == dp1[w[i].S] + k) {
                        dp2[j] = max(dp2[j], dp2[w[i].S] + k * w[i].F - temp);
                    }
                }
            }
        }
    }
    if (dp1[n - 1] != LLONG_MAX) {
        cout << dp1[n - 1] << "\n";
    } else {
        cout << -1 << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
