#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 810, P = 1e4 + 10;

vector <pair <int, int> > g[N];
ll w[N], d[N];
int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    for (int i = 1; i <= n; i++)
        cin >> w[i], d[i] = 1e18;
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c;
        g[a].push_back({ b, c });
    }
    set <pair <int, int>> s;
    s.insert({ 0, 1 });
    d[1] = 0;
    while (s.size()) {
        int v = s.begin()->second;
        s.erase(s.begin());
        for (auto& u : g[v]) {
            if (d[u.first] > d[v] + u.second) {
                s.erase({ d[u.first], u.first });
                d[u.first] = d[v] + u.second;
                s.insert({ d[u.first], u.first });
            }
        }
    }
    if (d[n] == 1e18)
        cout << -1;
    else
        cout << max(0ll, d[n] - p);
} 