#include <bits/stdc++.h>

using namespace std;
#define int long long

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    int w[n];
    for(int i = 0; i < n; i++)
        cin >> w[i];
    vector<pair<int, int>> g[n];
    for(int i = 0; i < m; i++){
        int u, v, c;
        cin >> u >> v >> c;
        g[u - 1].emplace_back(v - 1, c);
    }
    if(G == 1) {
        int dist[n];
        fill(dist, dist + n, (int) 1e18);
        dist[0] = 0;
        set<pair<int, int>> st;
        st.insert({dist[0], 0});
        while (!st.empty()) {
            int v = st.begin()->second;
            st.erase(st.begin());
            for (auto[u, cost]: g[v]) {
                if (dist[u] > dist[v] + cost) {
                    dist[u] = dist[v] + cost;
                    st.insert({dist[u], u});
                }
            }
        }
        if (dist[n - 1] == (int) 1e18)
            cout << -1;
        else
            cout << max(0ll, dist[n - 1] - p);
    }else{
        int ans = 0;
        for(int i = 0; i < n - 1; i++){
            int cost = g[i][0].second;
            if(p >= cost){
                p -= cost;
            }else{
                int t = (cost - p) / w[i] + ((cost - p) % w[i] != 0);
                ans += t;
                p += w[i] * t;
                p -= cost;
            }
        }
        cout << ans;
    }
    return 0;
}
