#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
#define int long long
#define dl long double

const int inf = 2e18;

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    int w[n];
    for (auto &i: w) cin >> i;
    if (g == 1) {
        int d[n][n];
        for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) d[i][j] = inf;
        for (int i = 0; i < n; i++) d[i][i] = 0;
        int u, v, c;
        for (int i = 0; i < m; i++) {
            cin >> u >> v >> c;
            u--, v--;
            d[u][v] = min(d[u][v], c);
        }
        vector<int> dist(n, inf);
        vector<bool> used(n, false);
        dist[0] = 0;
        while (true) {
            u = -1;
            for (int j = 0; j < n; j++)
                if (!used[j] && dist[j] != inf && (u == -1 || dist[j] < dist[u])) u = j;
            if (u == -1) break;
            used[u] = true;
            for (int to = 0; to < n; to++) dist[to] = min(dist[to], dist[u] + d[u][to]);
        }
        if (dist[n - 1] >= 1e18) cout << "-1\n";
        else cout << max(dist[n - 1] - p, 0ll) << '\n';
    } else if (g == 2) {
        int u, v;
        int d[n];
        for (int i = 0; i < m; i++) {
            cin >> u >> v >> d[i];
        }
        vector<bool> check(n), used(n);
        for (int j = 0; j < n; j++) {
            int cm = -inf, best = -1;
            for (int i = 0; i < n - 1; i++)
                if (!used[i] && w[i] > cm) cm = w[i], best = i;
            used[best] = true;
            check[best] = true;
            if (best == 0) break;
            for (int i = 0; i < best; i++)
                if (check[i]) {
                    check[best] = false;
                    break;
                }
        }
        check.back() = true;
        int ans = 0, now;
        for (int i = 0; i < n - 1;) {
            int j = i + 1;
            now = d[i];
            while (!check[j]) j++, now += d[j - 1];
            if (p < now) {
                int k = (now - p) / w[i];
                if ((now - p) % w[i]) k++;
                ans += k;
                p += k * w[i];
            }
            p -= now;
            i = j;
        }
        cout << ans;
    }
}

signed main() {
#ifndef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}