#define _CRT_SECURE_NO_WARNINGS
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <iostream>
#include <random>
#include <vector>
#include <cmath>
#include <deque>
#include <set>
#include <map>
using namespace std;

using ll = long long;

const ll INF = 1e9;
const ll LLINF = 1e18;

ll n, m, p, g;
vector<ll> w;
vector<vector<pair<ll, ll>>> graph;

vector<bool> vis;
int dfs1(int u, int t) {
	if (u == t) {
		return 0;
	}
	vis[u] = true;
	for (auto [v, s] : graph[u]) {
		int r = dfs1(v, t);
		if (r != -1) {
			return r + s;
		}
	}
	return -1;
}

void solve1() {
	cout << max(0ll, dfs1(0, n - 1) - p) << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);
	cin >> n >> m >> p >> g;
	w.resize(n);
	for (int i = 0; i < n; ++i) {
		cin >> w[i];
	}
	graph.assign(n, vector<pair<ll, ll>>());
	for (int i = 0; i < m; ++i) {
		ll u, v, s;
		cin >> u >> v >> s;
		u--, v--;
		graph[u].push_back({ v, s });
	}
	solve1();
	//int t;
	//cin >> t;
	//while (t--) {
	//	solve();
	//}
}