#include <bits/stdc++.h>
#define int long long
#define sz size()
#define vint vector<int>
#define vool vector<bool>

using namespace std;

vector<pair<int, int> > graph[810];

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    int w[n + 1];
    for(int i = 1; i <= n; i ++)
        cin >> w[i];
    for(int i = 1; i <= m; i ++)
    {
        int a, b, x;
        cin >> a >> b >> x;
        graph[a].push_back({b, x});
    }
    if(g == 1)
    {
        priority_queue<pair<int, int>, vector<pair<int, int> >, greater<pair<int, int> > > q;
        q.push({0, 1});
        vint ans(n + 1, LLONG_MAX);
        ans[1] = 0;
        while(!q.empty())
        {
            pair<int, int> qq = q.top();
            q.pop();
            int dst = qq.first;
            int cur_v = qq.second;
            if(ans[cur_v] < dst)
                continue;
            for(auto x : graph[cur_v])
            {
                int c = x.second;
                int nxt_v = x.first;
                if(ans[nxt_v] > c + dst)
                {
                    ans[nxt_v] = c + dst;
                    q.push({c + dst, nxt_v});
                }
            }
        }
        if(ans[n] == LLONG_MAX)
        {
            cout << -1 << endl;
        }
        else
        {
            cout << max((long long)0, ans[n] - p);
        }
        return 0;
    }
}
