#include <bits/stdc++.h>
#define int long long
#define sz size()
#define vint vector<int>
#define vool vector<bool>
#define f first
#define s second

using namespace std;

vector<pair<int, int> > graph[810];
int n, m, p, g;
int w[810];

bool check()
{
    vint used(n + 1);
    queue<int> q;
    q.push(1);
    while(!q.empty())
    {
        int v = q.front();
        q.pop();
        if(used[v])
            continue;
        used[v] = 1;
        for(auto x : graph[v])
        {
            if(!used[x.first])
                q.push(x.first);
        }
    }
    if(used[n] == 0)
        return 1;
    return 0;
}

int ans = LLONG_MAX;
const int mx = 1024;

void dfs(int v, vector<pair<int, int> > cost, int timee)
{
    if(v == n)
    {
        int money = p;
        int mx_go = w[1];
        int pr = 0;
        for(auto x : cost)
        {
         //   cout << x.first << " " << x.second << " " << money << " " << mx_go << "! " << endl;;
            int vert = x.first;
            int c = x.second;
            if(c <= money)
            {
                money -= c;
            }
            else
            {
                int need = c - money;
                int t = need / mx_go;
                if(need % mx_go != 0)
                    t ++;
                pr += t;
                money = t * mx_go - need;
                //cout << "need = " << need << " t = " << t << " money = " << money << endl;
            }
            mx_go = max(mx_go, w[vert]);
        }
        //cout << endl;
        //cout << "ans = " << pr << endl;
        ans = min(ans, pr);
    }
    else
    {
        if(timee > mx)
            return;
        for(auto x : graph[v])
        {
            int nxt = x.first;
            int c = x.second;
            cost.push_back({nxt, c});
            dfs(nxt, cost, timee + 1);
            cost.pop_back();
        }
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m >> p >> g;
    for(int i = 1; i <= n; i ++)
        cin >> w[i];
    for(int i = 1; i <= m; i ++)
    {
        int a, b, x;
        cin >> a >> b >> x;
        graph[a].push_back({b, x});
    }
    if(g == 1)
    {
        priority_queue<pair<int, int>, vector<pair<int, int> >, greater<pair<int, int> > > q;
        q.push({0, 1});
        vint ans(n + 1, LLONG_MAX);
        ans[1] = 0;
        while(!q.empty())
        {
            pair<int, int> qq = q.top();
            q.pop();
            int dst = qq.first;
            int cur_v = qq.second;
            if(ans[cur_v] < dst)
                continue;
            for(auto x : graph[cur_v])
            {
                int c = x.second;
                int nxt_v = x.first;
                if(ans[nxt_v] > c + dst)
                {
                    ans[nxt_v] = c + dst;
                    q.push({c + dst, nxt_v});
                }
            }
        }
        if(ans[n] == LLONG_MAX)
        {
            cout << -1 << endl;
        }
        else
        {
            cout << max((long long)0, ans[n] - p);
        }
        return 0;
    }
    bool f = check();
    if(f == 1)
    {
        cout << -1;
        return 0;
    }

    vector<pair<int, int> > cost;
    dfs(1, cost, 0);
    cout << ans;
}

/*

4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

*/
