#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <unordered_set>

using namespace std;
typedef unsigned long long  ull;
typedef pair < long long, long long > pll;
typedef long long ll;

vector < long long > w;
vector < long long > tout;
vector <  int > used;
vector < vector < pll > > gr;
long long tim;
long long n;

void dfs(ll v) {
    used[v] = 1;
    for (auto pa : gr[v]) {
        ll to = pa.first;
        if (!used[to]) {
            dfs(to);
        }
    }
    tim++;
    tout[v] = tim;
}

long long answer = 1e9;

void all_path(ll v, vector < ll > maxes, vector < pll > dolg, ll sum, ll kol) {
    if (v == n - 1) {
        if (kol < answer) {
            answer = kol;
        }
        return;
    }

    long long ne = w[v];
    if (maxes.size() != 0) {
        ne = max(ne, maxes.back());
    }
    maxes.push_back(ne);

    for (auto pa : gr[v]) {
        ll to = pa.first, s = pa.second;
        if (tout[to] < tout[v]) {
            if (sum < s) {
                ll raz = s - sum;
                ll k = (raz + maxes.back() - 1) / maxes.back();
                

                //dolg.push_back({ maxes.size(), s - sum });
                all_path(to, maxes, dolg, maxes.back() * k - raz, kol + k);
                //dolg.pop_back();
            }
            else {
                all_path(to, maxes, dolg, sum - s, kol);
            }
        }
    }
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long m, p, g;
    cin >> n >> m >> p >> g;

    w.resize(n);
    for (long long i = 0; i < n; i++) {
        cin >> w[i];
    }

    gr.resize(n);
    for (long long i = 0; i < m; i++) {
        long long u, v, s;
        cin >> u >> v >> s;
        u--; v--;
        gr[u].push_back({ v, s });
    }

    used.assign(n, 0);
    tout.resize(n);
    tim = 0;
    dfs(0);

    all_path(0, {}, {}, p, 0);
    if (answer != 1e9) {
        cout << answer;
    }
    else {
        cout << -1;
    }
}
