#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef __int128 lll;
typedef long double ld;
ll inf = 1e15, mod = 1e9 + 21;
ld eps = 1e-9;
#define all(a) a.begin(), a.end()

ll binpow(ll n, ll k) {
    if (!k)
        return 1;
    if (k % 2)
        return (binpow(n, k - 1) * n) % mod;
    ll a = binpow(n, k / 2);
    return (a * a) % mod;
}

vector<ll> w;
vector<vector<vector<ll>>> g;
vector<ll> us;

ll dfs(ll v, ll mx, ll p) {
    if (v == w.size() - 1)
        return 0;
    mx = max(mx, w[v]);
    ll ans = inf;
    us[v] = 1;
    for (auto i: g[v])
        if (!us[i[0]]) {
            ll kl = 0;
            if (p < i[1])
                kl = (i[1] - p + mx - 1) / mx;
            ans = min(ans, kl + dfs(i[0], mx, p + kl * mx - i[1]));
        }
    us[v] = 0;
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n, m, p, gg;
    cin >> n >> m >> p >> gg;
    if (gg == 1) {
        for (ll i = 0; i < n; i++)
            cin >> gg;
        vector<vector<vector<ll>>> g(n);
        for (ll i = 0; i < m; i++) {
            ll u, v, w;
            cin >> u >> v >> w;
            u--;
            v--;
            g[u].push_back({v, w});
        }
        vector<ll> d(n, inf);
        d[0] = 0;
        set<vector<ll>> st;
        st.insert({0, 0});
        while (!st.empty()) {
            auto v = (*st.begin())[1];
            st.erase(st.begin());
            for (auto i: g[v])
                if (d[i[0]] > d[v] + i[1]) {
                    if (st.find({d[i[0]], i[0]}) != st.end())
                        st.erase({d[i[0]], i[0]});
                    d[i[0]] = d[v] + i[1];
                    st.insert({d[i[0]], i[0]});
                }
        }
        if (d[n - 1] == inf)
            cout << -1;
        else
            cout << max(0ll, d[n - 1] - p);
        return 0;
    }
    if (gg == 2) {
        ll ans = 0;
        vector<ll> w(n);
        for (ll i = 0; i < n; i++)
            cin >> w[i];
        vector<ll> s(m);
        for (ll i = 0; i < m; i++)
            cin >> s[i] >> s[i] >> s[i];
        ll mx = 0;
        for (ll i = 0; i < n - 1; i++) {
            mx = max(mx, w[i]);
            if (p < s[i]) {
                ll k = (s[i] - p + mx - 1) / mx;
                ans += k;
                p += mx * k;
            }
            p -= s[i];
        }
        cout << ans;
        return 0;
    }
    w.resize(n);
    g.resize(n);
    us.resize(n);
    for (ll i = 0; i < n; i++)
        cin >> w[i];
    for (ll i = 0; i < m; i++) {
        ll u, v, ww;
        cin >> u >> v >> ww;
        u--;
        v--;
        g[u].push_back({v, ww});
    }
    ll an = dfs(0, 0, p);
    if (an > 1e13)
        an = -1;
    cout << an;
}