#include <bits/stdc++.h>
using namespace std;
#define int long long
int INF = 1e15;
void djkstra(vector<int>& used, int start, vector<vector<pair<int, int>>>& gr, vector<int>& dist) {
    priority_queue<pair<int, int>> q;
    q.push({0, start});
    while (!q.empty()) {
        int from = q.top().second;
        q.pop();
        if (used[from] == 1) {
            continue;
        }
        used[from] = 1;
        for (auto to: gr[from]) {
            if (used[to.first] == 0) {
                if (dist[to.first] > dist[from] + to.second) {
                    dist[to.first] = dist[from] + to.second;
                    q.push({-dist[to.first], to.first});
                }
            }
        }
    }
}

signed main() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    int wm = -1;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        wm = max(w[i], wm);
    }
    vector<vector<pair<int, int>>> gr(n);
    vector<int> C(m);
    int ch = 0, sc = 0;
    vector<int> pref(m+1);
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        if (b != a+1) {
            ch = 1;
        }
        gr[a-1].push_back({b-1, c});
        sc += c;
        if (i == 0) {
            pref[i+1] = c;
        }else {
            pref[i+1] = pref[i] + c;
        }
        C[i] = c;
    }
    vector<pair<int, int>> vc;
    vc.push_back({INF, INF});
    vector<int> rh(n, -1);
    if (ch == 0 && m == (n-1)) {
        for (int i = 0; i < n; i++) {
            while (w[i] >= vc.back().first) {
                rh[vc.back().second] = i;
                vc.pop_back();
            }
            vc.push_back({w[i], i});
        }
        int bal = p;
        int pr = 0;
        for (int i = 0; i < m; i++) {
            if (i != 0) {
                if (rh[i] == -1) {
                    if (pref[n-1] - pref[i] <= bal) {
                        bal -= C[i];
                    } else {
                        if ((pref[n - 1] - pref[i ] - bal) % w[i] == 0) {
                            pr += (pref[n - 1] - pref[i] - bal) / w[i];
                            bal = bal + pr*w[i];
                            bal -= C[i];
                        } else {
                            pr += ((pref[n - 1] - pref[i] - bal) / w[i] + 1);
                            bal = bal + pr*w[i];
                            bal -= C[i];
                        }
                    }
                    continue;
                }
                if (pref[rh[i]] - pref[i] <= bal) {
                    bal -= C[i];
                } else {
                    if (rh[i] == -1) {
                        if ((pref[n-1] - pref[i] - bal)%w[i] == 0){
                            pr += (pref[n-1] - pref[i] - bal)/w[i];
                            bal = bal + pr*w[i];
                            bal -= C[i];
                        } else {
                            pr += ((pref[n-1] - pref[i] - bal)/w[i] + 1);
                            bal = bal + pr*w[i];
                            bal -= C[i];
                        }
                        continue;
                    }
                    if ((pref[rh[i]] - pref[i] - bal)%w[i] == 0){
                        pr += (pref[rh[i]] - pref[i-1] - bal)/w[i];
                        bal = bal + pr*w[i];
                        bal -= C[i];
                    } else {
                        pr += ((pref[rh[i]] - pref[i] - bal)/w[i] + 1);
                        bal = bal + pr*w[i];
                        bal -= C[i];
                    }
                }
            } else {
                if (rh[i] == -1) {
                    if (pref[n-1] <= bal) {
                        bal -= C[i];
                    } else {
                        if ((pref[n - 1]  - bal) % w[i] == 0) {
                            pr += (pref[n - 1] - bal) / w[i];
                            bal = bal + pr*w[i];
                            bal -= C[i];
                        } else {
                            pr += ((pref[n - 1] - bal) / w[i] + 1);
                            bal = bal + pr*w[i];
                            bal -= C[i];
                        }
                    }
                    continue;
                }
                if (pref[rh[i]] <= bal) {
                    bal -= C[i];
                } else {
                    if ((pref[rh[i]]  - bal)%w[i] == 0){
                        pr += (pref[rh[i]]  - bal)/w[i];
                        bal = bal + pr*w[i];
                        bal -= C[i];
                    } else {
                        pr += ((pref[rh[i]]  - bal)/w[i] + 1);
                        bal = bal + pr*w[i];
                        bal -= C[i];
                    }
                }
            }
        }
        cout << pr;
        return 0;
    }
    vector<int> dist(n, INF);
    dist[0] = 0;
    vector<int> used(n, 0);
    djkstra(used, 0, gr, dist);
    if (dist[n-1] == INF) {
        cout << -1;
    } else {
        if (p >= dist[n-1]) {
            cout << 0;
        } else {
            cout << dist[n-1]-p;
        }
    }
}
