#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
//using namespace __gnu_pbds;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
const ll inf = 1e9 + 7;
const ll linf = 1e17;
const ll mod = 1e9 + 7;
const ll base = 239;
void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
mt19937 rnd(239);
void solve(){
    ll n, m, p, tst;
    cin >>n >> m >> p >> tst;
    vector<ll> w(n);
    for(ll i = 0; i < n; i++){
        cin >> w[i];
    }
    if(tst == 1){
        //if(p == 0) exit(139);
        vector<ll> dist(n, linf);
        dist[0] = 0;
        set<pair<ll, ll>> s;
        vector<vector<pair<ll, ll>>> g(n);
        for(ll x, y, wt, i = 0; i < m; i++){
            cin >> x >> y >> wt;
            x--; y--;
            g[x].push_back({y, wt});
        }
        s.insert({0, 0});
        while(!s.empty()){
            ll v = s.begin()->second;
            s.erase(s.begin());
            for(auto [to, wt] :g[v]){
                if(dist[to] > dist[v] + wt){
                    s.erase({dist[to], to});
                    dist[to] = dist[v] + wt;
                    s.insert({dist[to], to});
                }
            }
        }
        cout << (dist[n - 1] == linf ? -1 : max(0ll, dist[n - 1] - p));
    }
    if(tst == 2){
        vector<ll> cost(n, 0);
        for(ll a, b, s, i = 0; i < m; i++){
            cin >> a >> b >> s;
            cost[b - 1] = s;
        }
        for(ll i = 1; i < n; i++){
            cost[i] += cost[i - 1];
        }
        vector<ll> nxt(n, n - 1);
        vector<ll> st;
        for(ll i = n - 1; i >=0; i--){
            while(!st.empty() && w[st.back()] <= w[i]) st.pop_back();
            if(!st.empty()) nxt[i] = st.back();
            st.push_back(i);
        }
        ll ans = 0;
        ll cur = 0;
        ll hv = p;
        while(cur != n - 1){
            ll k = max(0ll, cost[nxt[cur]] - cost[cur] + w[cur] - 1 - hv) / w[cur];
            hv = k * w[cur] + hv - (cost[nxt[cur]] - cost[cur]);
            ans += k;
            cur = nxt[cur];
        }
        cout << ans << '\n';
    }
    if(tst == 3 || tst == 0){
        ll cans = linf;
        vector<ll> prm(n);
        iota(all(prm), 0);
        vector<vector<pair<ll, ll>>> g(n);
        for(ll x, y, wt, i = 0; i < m; i++){
            cin >> x >> y >> wt;
            x--; y--;
            g[x].push_back({y, wt});
        }
        ll nc = n;
        do {
            for(ll q = 2; q<=nc; q++) {
                n = q;
                if (prm[0] != 0 || prm[n - 1] != nc - 1) continue;
                bool go = true;
                vector<ll> cost(n, 0);
                for (ll i = 0; i < n - 1; i++) {
                    bool f1 = false;
                    for (auto [to, wt]: g[prm[i]]) {
                        if (to == prm[i + 1]) {
                            cost[i + 1] = wt;
                            f1 = true;
                            break;
                        }
                    }
                    if (!f1) {
                        go = 0;
                        continue;
                    }
                }
                if (!go) break;
                for (ll i = 1; i < n; i++) {
                    cost[i] += cost[i - 1];
                }
                vector<ll> wc(n);
                for (ll i = 0; i < n; i++) {
                    wc[i] = w[prm[i]];
                }
                vector<ll> nxt(n, n - 1);
                vector<ll> st;
                for (ll i = n - 1; i >= 0; i--) {
                    while (!st.empty() && wc[st.back()] <= wc[i]) st.pop_back();
                    if (!st.empty()) nxt[i] = st.back();
                    st.push_back(i);
                }
                ll ans = 0;
                ll cur = 0;
                ll hv = p;
                while (cur != n - 1) {
                    ll k = max(0ll, cost[nxt[cur]] - cost[cur] + wc[cur] - 1 - hv) / wc[cur];
                    hv = k * wc[cur] + hv - (cost[nxt[cur]] - cost[cur]);
                    ans += k;
                    cur = nxt[cur];
                }
                cans = min(cans, ans);
                break;
            }
        } while(next_permutation(all(prm)));
        if(tst == 0 && cans == linf) {
            cout << -1;
            return;
        }
        cout << cans << '\n';
        return;
    }
}
signed main() {
#ifdef Local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}
