#include <bits/stdc++.h>

#define int long long
using namespace std;
vector<vector<pair<int, int>>> g;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, p, _;
    cin >> n >> m >> p >> _;
    g.resize(n);
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int u, v, z;
        cin >> u >> v >> z;
        g[u].push_back({v, z});
    }
    vector<int> dist(n, LLONG_MAX);
    dist[0] = 0;
    set<pair<int, int>> s;
    s.insert({0, 0});
    while (!s.empty()) {
        auto v = *s.begin();
        s.erase(v);
        for (auto to: g[v.second]) {
            if (dist[to.first] > dist[v.second] + to.second) {
                s.erase({dist[to.first], to.first});
                dist[to.first] = dist[v.second] + to.second;
                s.insert({dist[to.first], to.first});
            }
        }
    }
    if (dist[n - 1] == LLONG_MAX)cout << -1;
    else {
        cout << max(0LL, dist[n - 1] - p);
    }
}
