#include <iostream>
#include <bits/stdc++.h>
#define int long long

using namespace std;

const int inf = 1e18;

signed main() {
    int n, m, p, test;
    cin >> n >> m >> p >> test;

    if (test == 1){
        vector<int> w(n);
        for (int i = 0; i < n; i ++) cin >> w[i];
        vector<vector<pair<int, int>>> g(n);
        int a, b, c;
        for (int i = 0; i < m; i ++){
            cin >> a >> b >> c;
            a --, b --;
            g[a].push_back({b, c});
        }

        vector<int> dist(n, inf);
        vector<int> used(n, 0);

        dist[0] = 0;

        for (int i = 0; i < n; i ++){
            int v = -1;
            for (int j = 0; j < n; j ++){
                if (!used[j] && (v == -1 || dist[j] < dist[v])){
                    v = j;
                }
            }
            if (v == -1){
                break;
            }
            used[v] = 1;
            for (auto p : g[v]){
                dist[p.first] = min(dist[p.first], dist[v] + p.second);
            }
        }

        if (dist[n - 1] == inf){
            cout << -1;
        } else {
            cout << dist[n - 1];
        }
        return 0;
    }
}
