#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,fma,bmi,bmi2,mmx,tune=native")
#include "bits/extc++.h"
#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define frl(i, x) for(auto& i : x)
#define rep(i, j, k) for(int i = j; i < k; i++)
#define rrep(i, j, k) for(int i = k - 1; i >= j; i--)
#define S second
#define F first

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = double;
using ull = unsigned long long;
using treap = tree<int, null_type>;

void solve(){
    ll n, m, p, t;
    cin >> n >> m >> p >> t;
    if(t == 1 || t == 2){
        vector<int> w(n);
        frl(i, w) cin >> i;
        vector<int> pr(n);
        pr[0] = w[0];
        rep(i, 1, n) pr[i] = max(pr[i-1], w[i]);
        const ll inf = 1e18;
        vector<ll> d(n, inf);
        vector<vector<pair<int, int>>> g(n);
        rep(i, 0, m){
            int a, b, c;
            cin >> a >> b >> c;
            a--, b--;
            g[a].emplace_back(b, c);
        }
        set<pair<ll, int>> s;
        d[0] = 0;
        s.emplace(0, 0);
        while(!s.empty()){
            auto [dd, v] = *s.begin();
            s.erase(s.begin());
            frl(i, g[v]){
                if(d[i.F] > dd + i.S){
                    s.erase({d[i.F], i.F});
                    d[i.F] = dd + i.S;
                    s.emplace(d[i.F], i.F);
                }
            }
        }
        if(d[n-1] == inf) cout << -1;
        else if(t == 1) cout << max(0ll, d[n-1] - p);
        else if(t == 2) {
            ll cnt = 0;
            rep(i, 0, n-1){
                ll cost = g[i][0].S;
                if(cost <= p){
                    p -= cost;
                }
                else{
                    cnt += (cost - p + pr[i] - 1) / pr[i];
                    p += (cost - p + pr[i] - 1) / pr[i] * pr[i];
                    p -= cost;
                }
            }
            cout << cnt;
        }
    }
}

signed main(){
    cin.tie(0)->ios::sync_with_stdio(0);
    cout << setprecision(15) << fixed;
    int TT=1;
    //cin>>TT;
    while(TT--) solve();
}