#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

const int MAXN = 807;

vector <pair <int, int>> g[MAXN];
int w[MAXN];

void solve() {
	int n, m, p, gr;
	cin >> n >> m >> p >> gr;
	int v, u, s;
	for (int i = 0; i < n; i++)
		cin >> w[i];
	for (int i = 0; i < m; i++) {
		cin >> v >> u >> s;
		v--; u--;
		g[v].push_back({ u, s });
	}
	set < pair <long long, pair <pair <int, int>, int>>> se;
	se.insert({ 0, {{w[0], p}, 0}});
	vector <long long> dist(n, 1e9);
	vector <int> sm(n, -1e9);
	vector <int> sw(n, -1e9);
	sm[0] = p;
	sw[0] = w[0];
	dist[0] = 0;
	while (se.size()) {
		int v = se.begin()->second.second;
		int cw = se.begin()->second.first.first;
		int cm = se.begin()->second.first.second;
		int distv = se.begin()->first;
		se.erase(se.begin());
		if (v == n - 1) {
			cout << distv << "\n";
			return;
		}
		for (auto to : g[v]) {
			int need = max(0, to.second - cm);
			int take = need / cw;
			if (need % cw)
				take++;
			int ndist = distv + take;
			int nm = 1ll * take * cw + cm - to.second;
			int nw = max(cw, w[to.first]);
			if ((ndist < dist[to.first]) ||
				((ndist == dist[to.first] && nw > sw[to.first]) ||
					(ndist == dist[to.first] && nw == sw[to.first] && nm > sm[to.first]))) {
				se.erase({ dist[to.first], {{sw[to.first], sm[to.first]}, to.first} });
				dist[to.first] = ndist;
				sm[to.first] = nm;
				sw[to.first] = nw;
				se.insert({ dist[to.first], {{sw[to.first], sm[to.first]}, to.first} });
			}
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}