#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

const int INF = 1e18 + 7, N = 800;
const ld EPS = 1e-6;

int w[N];
vector<pair<int, int>> g[N];
bitset<N> used[N];

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, m, p, asdlfj;
    cin >> n >> m >> p >> asdlfj;
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[--a].emplace_back(--b, s);
    }
    priority_queue<array<int, 3>, vector<array<int, 3>>, greater<>> st;
    st.push({0, -p, 0});
    while (!st.empty()) {
        auto [ans, mon, sost] = st.top();
        auto now = sost / n, mx = sost % n;
        st.pop();
        if (used[now][mx]) continue;
        used[now][mx] = true;
        if (now == n - 1) {
            cout << ans;
            return 0;
        }
        for (auto j : g[now]) {
            int k = max((j.second + mon - 1) / w[mx] + 1, 0ll);
            if (w[j.first] > w[mx])
                st.push({ans + k, mon - k * w[mx] + j.second, j.first * n + j.first});
            else st.push({ans + k, mon - k * w[mx] + j.second, j.first * n + mx});
        }
    }
    cout << -1;
}
