#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <queue>
#define ll long long
#define ld long double
using namespace std;
const string space=" ", slashn="\n";


int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll n, m, p, g; cin >> n >> m >> p >> g;

    if (g==1) {
        vector<ll> w(n);
        for (ll i=0; i<n; ++i) {
            cin >> w[i];
        }

        vector<vector<pair<ll, ll>>> list(n, vector<pair<ll, ll>>());
        // { to, cost }
        for (ll i=0; i<m; ++i) {
            ll a, b, s; cin >> a >> b >> s;
            list[a-1].push_back({b-1, s});
        }

        vector<ll> min_cost(n, INT64_MAX);
        // минимальная стоимость оказаться в конктретном городе
        min_cost[0] = 0;

        queue<pair<ll, ll>> q;
        q.push({0, 0});
        while (!q.empty()) {
            auto v = q.front();
            q.pop();
            //cout << v.first << slashn;

            if (v.second != min_cost[v.first]) {
                continue;
            }

            for (auto nei : list[v.first]) {
                if (min_cost[nei.first] > min_cost[v.first] + nei.second) {
                    min_cost[nei.first] = min_cost[v.first] + nei.second;
                    q.push({nei.first, min_cost[nei.first]});
                }
            }
        }

        if (min_cost[n-1] == INT64_MAX) {
            cout << -1 << slashn;
        } else {
            if (min_cost[n-1]-p>0) {
                cout << min_cost[n-1]-p << slashn;
            } else {
                cout << 0 << slashn;
            }
        }
    }


    return 0;
}