#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define pb push_back
#define int long long

const int INF = 2e18 + 333, N = 5e5 + 10;

vec<int> p(N, 1);

struct Hash{
    vec<int> h;
    int n;
    void init(string& s) {
        n = (int)s.size();
        h.assign(n + 1, 0);
        for (int i = 1; i <= n; ++i) {
            h[i] = (h[i - 1] + (s[i - 1] - 'a' + 1) * p[i - 1]) % INF;
        }
    }
    int get(int l, int r) {
        return (((h[r + 1] - h[l] + INF) % INF) * p[N - l - 1]) % INF;
    }
};

vec<int> w(1e3);

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vec<vec<int>> f(n, vec<int>(n, INF));
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        a--; b--;
        f[a][b] = min(f[a][b], s);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int q = 0; q < n; ++q)
                f[j][q] = min(f[j][q], f[j][i] + f[i][q]);
        }
    }
    if (g == 1) {
        if (f[0][n - 1] == INF) cout << -1 << endl;
        else cout << max(0ll, f[0][n - 1]  - p) << endl;
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (int i = 1; i < N; ++i) p[i] = (p[i - 1] * 37) % INF;
    for (; t > 0; --t) {
        solve();
    }
    return 0;
}