#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define pb push_back
//#define int long long

const ll INF = 2e18 + 333;
const int INFik = 1e9 + 1, N = 5e5 + 10;

vec<int> w(1e3);
vec<vec<ll>> f(1e3, vec<ll>(1e3, INF));
ll ans2 = INF;
int n, m, p, g, timer = 0;
vec<int> c(1e3);

void pr(int pred, int v, vec<int>& used, int y = 0, int s = p, int maxv = 0, ll ans = 0) {
    if (timer >= 1e7 || ans2 <= ans) return;
    if (pred != -1) {
        maxv = max(w[pred], maxv);
        int c = f[pred][v];
        if (c > s) {
            c -= s;
            s = 0;
        }
        else {
            s -= c;
            c = 0;
        }
        int ln = (c + maxv - 1) / maxv;
        s += maxv * ln - c;
        ans += ln;
    }
    timer++;
    if (v == n - 1) {
        ans2 = min(ans, ans2);
        return;
    }
    for (int i : c) {
        if (used[i] == 0 && f[v][i] < INFik) {
            used[i]++;
            int yy = y;
            if (yy == 1) yy = 2;
            pr(v, i, used, yy, s, maxv, ans);
            used[i]--;
        }
        else if (used[i] == 1 && f[v][i] < INFik && (y == 1 || y == 0)) {
            used[i]++;
            pr(v, i, used, 1, s, maxv, ans);
            used[i]--;
        }
    }
}

void solve() {
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; ++i) cin >> w[i];
    vec<bool> us(n);
    int cc = 0;
    if (n <= 10) {
        for (; cc < n;) {
            int j = rnd() % n;
            if (!us[j]) {
                us[j] = 1;
                c[cc++] = j;
            }
        }
    }
    //for (int i = 0; i < 10; ++i) cout << c[i] << " ";
    for (int i = 0; i < m; ++i) {
        int a, b;
        ll s;
        cin >> a >> b >> s;
        a--; b--;
        f[a][b] = min(f[a][b], s);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int q = 0; q < n; ++q)
                f[j][q] = min(f[j][q], f[j][i] + f[i][q]);
        }
    }
    if (f[0][n - 1] == INF) {
        cout << -1 << endl;
        return;
    }
    if (g == 1) {
        cout << max(0ll, f[0][n - 1]  - p) << endl;
        return;
    }
    if (g == 2) {
        ll ans = 0, s = p;
        ll maxv = 0;
        for (int i = 0; i < n - 1; ++i) {
            maxv = max(ll(w[i]), maxv);
            if (f[i][i + 1] > s) {
                f[i][i + 1] -= s;
                s = 0;
            }
            else {
                s -= f[i][i + 1];
                f[i][i + 1] = 0;
            }
            int ln = (f[i][i + 1] + maxv - 1) / maxv;
            s += maxv * ln - f[i][i + 1];
            ans += ln;
        }
        cout << ans;
        return;
    }
    if (g == 3 || g == 0) {
        vec<int> used(n);
        used[0] = 1;
        pr(-1, 0, used);
        cout << ans2;
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
    return 0;
}