#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=805;
const int INF=1e9+5;

struct Edge
{
    int v,w;
    Edge() {}
    Edge(int _v,int _w)
    {
        v=_v;
        w=_w;
    }
};
bool operator< (Edge a,Edge b)
{
    return a.w>b.w;
}

int n,m,p,g;
int a[MAXN];
vector<Edge> adj[MAXN];
int d[MAXN];
priority_queue<Edge> pq;
bool used[MAXN];

void dijkstra(int v)
{
    for(int i=1;i<=n;i++) d[i]=INF;
    d[v]=0;
    pq.push(Edge(v,0));
    while(!pq.empty())
    {
        v=pq.top().v;
        pq.pop();
        if(used[v]) continue;
        used[v]=1;
        for(int i=0;i<adj[v].size();i++)
        {
            if(!used[adj[v][i].v] && d[v]+adj[v][i].w<d[adj[v][i].v])
            {
                d[adj[v][i].v]=d[v]+adj[v][i].w;
                pq.push(Edge(adj[v][i].v, d[adj[v][i].v]));
            }
        }
    }
}

int main()
{
ios::sync_with_stdio(0);
cin.tie(0);
cout.tie(0);

cin>>n>>m>>p>>g;
for(int i=1;i<=n;i++)
{
    cin>>a[i];
}
for(int i=0;i<m;i++)
{
    int u,v,w;
    cin>>u>>v>>w;
    adj[u].push_back(Edge(v,w));
}

if(g==1)
{
    dijkstra(1);
    cout<<d[n]-p<<endl;
    return 0;
}

return 0;
}
