#include<bits/stdc++.h>
#define endl '\n'

using namespace std;


struct edge
{
    int v;
    long long dist;
    edge() {}
    edge(int a, long long b)
    {
        v=a;
        dist=b;
    }
};
bool operator<(edge p, edge q)
{
    return p.dist>q.dist;
}
priority_queue<edge> pq;

vector<edge> gr[1024];
long long n, m, p, g;
long long dist[1024];
bool used[1024];

void dijkstra()
{
    pq.push(edge(1, 0));
    while(!pq.empty())
    {
        int tv=pq.top().v;
        long long d=pq.top().dist;
        pq.pop();
        if(used[tv]) continue;
        used[tv]=1;
        int brs=gr[tv].size();
        for(int i=0; i<brs; i++)
        {
            int nv=gr[tv][i].v;
            long long ndst=d+gr[tv][i].dist;
            if(dist[nv]>ndst)
            {
                dist[nv]=ndst;
                pq.push(edge(nv, dist[nv]));
            }
        }
    }
}

void solve1()
{
    for(int i=1; i<=n; i++)
    {
        cin>>g;
        dist[i]=1e18;
    }
    for(int i=0; i<m; i++)
    {
        int a, b, c;
        cin>>a>>b>>c;
        gr[a].push_back(edge(b, c));
    }
    dist[1]=0;
    dijkstra();
    if(dist[n]>=1e18) cout<<-1<<endl;
    else if(p>=dist[n]) cout<<0<<endl;
    else cout<<dist[n]-p<<endl;
}

long long c[1024];
long long strv[1024];
void solve2()
{
    for(int i=1; i<=n; i++) cin>>c[i];
    for(int i=1; i<=m; i++)
    {
        int a, b, t;
        cin>>a>>b>>t;
        strv[a]=t;
    }
    long long tm=0, ans=0;
    for(long long i=1; i<=n-1; i++)
    {
        tm=max(tm, c[i]);
        if(p<strv[i])
        {
            long long t=strv[i]-p;
            ans+=(t+tm-1)/tm;
            p+=((t+tm-1)/tm)*tm;
        }
        p-=strv[i];
    }
    cout<<ans<<endl;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>m>>p>>g;
    if(g==1) solve1();
    else solve2();
    return 0;
}
/**
4 4 7 1
5 1 6 2
1 2 5
2 3 10
3 4 50
3 4 70

*/
