#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using pi = pair<int, int>;

const int maxN = 2e5;

struct Item {
    int a, b, c;
    Item(int a = 0, int b = 0, int c = 0) : a(a), b(b), c(c) {}
    bool operator<(const Item& other) const {
        return a < other.a;
    }
} b[maxN];

int test = 1, n, k, a[maxN], ans, cnt[maxN], dp[maxN], it;

void solve() {
    it = 0;
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> k;
        int last = -1;
        cnt[i] = 0;
        while (k--) {
            cin >> a[i];
            if (last < a[i]) {
                last = a[i];
                b[it++] = Item(a[i], i, cnt[i]);
                cnt[i]++;
            }
        }
        dp[i] = cnt[i];
        a[i] = last;
    }
    sort(b, b + it);
    ans = 0;
    for (int l = 0, r = 0; l < it; l = r) {
        while (r < it && b[l].a == b[r].a)
            r++;
        int temp = ans;
        for (int i = l; i < r; i++) {
            dp[b[i].b] = max(dp[b[i].b], temp + cnt[b[i].b] - b[i].c);
            if (b[i].a == a[b[i].b])
                ans = max(ans, dp[b[i].b]);
        }
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
