#include <bits/stdc++.h>

#define int long long
#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

using namespace std;

void solve()
{
    int n;
    cin >> n;
    vec<vec<int>> a (n);
    int maxa = 0;
    FOR(i, n)
    {
        int k;
        cin >> k;
        a[i].resize(k);
        for(auto &x : a[i])
            cin >> x;
        maxa = max(maxa, *max_element(all(a[i])));
    }

    vec<vec<pii>> g (n + 1);
    FOR(i, n)
    {
        int cnt = 0;
        int mx = 0;
        for(auto j : a[i])
        {
            if(mx < j)
            {
                mx = j;
                cnt++;
            }
        }
        g[0].pb({i + 1, cnt});
    }

    FOR(i, n)
    {
        for(int j = i + 1; j < n; j++)
        {
            int mx1 = *max_element(all(a[i]));
            int mx2 = *max_element(all(a[j]));

            if(mx1 < mx2)
            {
                int mx = mx1;
                int cnt = 0;
                for(auto x : a[j])
                {
                    if(mx < x)
                    {
                        mx = x;
                        cnt++;
                    }
                }
                g[i + 1].pb({j + 1, cnt});
            }
            else
            {
                int mx = mx2;
                int cnt = 0;
                for(auto x : a[i])
                {
                    if(mx < x)
                    {
                        mx = x;
                        cnt++;
                    }
                }
                g[j + 1].pb({i + 1, cnt});
            }
        }
    }

    vec<int> topsort;
    function<void(int)> calc = [&](int v)
    {
        for(auto &[u, w] : g[v])
            calc(u);
        topsort.pb(v);
    };

    calc(0);
    reverse(all(topsort));
    vec<int> dp (n + 1);

    for(auto v : topsort)
    {
        for(auto &[u, w] : g[v])
        {
            dp[u] = max(dp[u], dp[v] + w);
        }
    }

    cout << *max_element(all(dp));
}

signed main() {
    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}

