#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); i++)
#define sz(x) int(size(x))
using vi = vector<int>;
using pii = pair<int, int>;
using ll = long long;

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;

    vector<vi> albs(n);
    rep(i, 0, n) {
        int k;
        cin >> k;

        albs[i].resize(k);
        for (auto &el: albs[i]) cin >> el;
        vi cur;
        for (auto el: std::move(albs[i])) {
            if (cur.empty() || el > cur.back()) cur.push_back(el);
        }
        albs[i] = cur;
    }

    vi p(n);
    iota(p.begin(), p.end(), 0);

    ll ans = 0;
    do {
        ll cur_ans = sz(albs[p[0]]);
        rep(i, 1, n) {
            cur_ans += count_if(albs[p[i]].begin(), albs[p[i]].end(), [&](int x) {
                return x > albs[p[i - 1]].back();
            });
        }
        ans = max(ans, cur_ans);
    } while (next_permutation(p.begin(), p.end()));
    cout << ans << '\n';
}