#include <bits/stdc++.h>
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> p(n), mx(n);
    int total = 0;
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        int k;
        cin >> k;
        a[i].resize(k);
        mx[i] = -1;
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
            mx[i] = max(mx[i], a[i][j]);
        }
        total += k;
    }
    sort(p.begin(), p.end(), [&](const int& A, const int& B) {
         return mx[A] < mx[B];
    });
    vector<int> b(total);
    int __last = 0;
    for (const int& i : p) {
        for (const int& x : a[i]) {
            b[__last++] = x;
        }
    }
    vector<int> lis(total + 1, 1000000000);
    lis[0] = -1;
    int ans = 0;
    for (int i = 0; i < total; ++i) {
        int j = lower_bound(lis.begin(), lis.end(), b[i]) - lis.begin();
        lis[j] = b[i];
        ans = max(ans, j);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
