#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define endl '\n'
#define len(a) (int)a.size()
#define f first
#define s second

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const int MAXI = 1e9 + 1e7;

int main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n;
        cin >> n;
        vector<vector<int> > album(n);
        vector<pair<int, int> > sorted;
        for (int i = 0; i < n; i++) {
            int k;
            cin >> k;
            album[i].resize(k);
            int max_song = -1;
            for (int j = 0; j < k; j++) {
                cin >> album[i][j];
                max_song = max(max_song, album[i][j]);
            }
            sorted.emplace_back(max_song, i);
        }
        sort(all(sorted));
        vector<int> dp;
        for (auto [max_song, idx] : sorted) {
            int res = 0;
            vector<int> stk;
            for (int j = 0; j < len(album[idx]); j++) {
                if (stk.empty() || stk.back() < album[idx][j])
                    stk.push_back(album[idx][j]);
            }
            for (int j = len(stk) - 1; j >= 0; j--) {
                if (sorted[0].f >= stk[j])
                    res = max(res, len(stk) - j);
                else {
                    int pos = distance(sorted.begin(), --lower_bound(all(sorted), make_pair(stk[j], -1)));
                    res = max(res, dp[pos] + len(stk) - j);
                }
            }
            if (dp.empty())
                dp.push_back(res);
            else
                dp.push_back(max(dp.back(), res));
        }
        cout << dp.back() << endl;
    }
}
