#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<algorithm>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    int mxnum = 0;
    set<int> st;
    vector<vector<int>> v(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        int mxcurnum = 0;
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;

            if (!j || mxcurnum < a) {
                v[i].push_back(a);
                mxcurnum = a;
                st.insert(a);
                mxnum = max(mxnum, a);
            }
        }
    }

    if (n <= 7) {
        vector<int> p(n);
        for (int i = 0; i < n; i++)
            p[i] = i;

        int mxlen = -1;
        do {
            int mx = 0, curlen = 0;
            for (auto e : p) {
                for (auto l : v[e]) {
                    if (l > mx) {
                        mx = l;
                        curlen++;
                    }
                }
            }
            mxlen = max(mxlen, curlen);
        } while (next_permutation(p.begin(), p.end()));

        cout << mxlen << '\n';
        return 0;
    }

    if (mxnum < 3) {
        cout << st.size() << '\n';
        return 0;
    }
    
    int ans = 0, res = -1;
    sort(v.begin(), v.end());
    for (auto& e : v) {
        for (auto i : e) {
            if (i > res) {
                res = i;
                ans++;
            }
        }
    }
    
    cout << ans << '\n';

    return 0;
}