#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

template<typename T, typename G>
istream& operator >> (istream &in, pair<T, G> &a) {
    in >> a.X >> a.Y;
    return in;
}

template<typename T, typename G>
ostream& operator << (ostream &in, pair<T, G> &a) {
    in << a.X << ' ' << a.Y;
    return in;
}

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> my(n);
    vector<int> max_el(n);

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        my[i].resize(k);
        cin >> my[i];

        max_el[i] = *max_element(all(my[i]));
    }

    vector<int> val(n, 0);
    iota(all(val), 0);

    sort(all(val), [&] (int i, int j) {
        return max_el[i] < max_el[j];
    });

    int prev_max = 0;
    int sum = 0;

    for (int &it : val) {
        for (int &x : my[it]) {
            if (rmax(prev_max, x)) {
                sum += 1;
            }
        }
    }

    cout << sum << endl;
}

signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;

#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}

