#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100, MOD = 1e9 + (1000 - 7), MAXN = 2e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    vector<vector<ll>> newa(n);
    for (ll i = 0; i < n; ++i) {
        ll k;
        cin >> k;
        a[i].resize(k);
        for (ll j = 0; j < k; ++j) {
            cin >> a[i][j];
        }
        ll mx = 0;
        for (ll j = 0; j < k; ++j) {
            if (a[i][j] > mx) newa[i].push_back(a[i][j]);
            mx = max(mx, a[i][j]);
        }
    }
    ll mxa = 3;
    vector<ll> dp(mxa);
    for (ll st = 0; st < n; ++st) {
        for (ll i = 0; i < n; ++i) {
            for (ll j = 0; j < mxa; ++j) {
                ll mx = max(j, newa[i].back());
                dp[mx] = max(dp[mx], dp[j] + (ll)(newa[i].end() - upper_bound(newa[i].begin(), newa[i].end(), j)));
            }
        }
    }
    cout << *max_element(dp.begin(), dp.end());
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}