#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;
typedef long double ld;

using namespace std;

const ll MOD = 1e9 + 7;
const ll MAXN = 2e5 + 5;
const ll logn = 17;
const ll INF = 2e9;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int prev = 0;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (x > prev) {
                a[i].push_back(x);
                prev = x;
            }
        }
    }

    if (n <= 7) {
        int ans = 0;
        vector<int> prek(n);
        iota(prek.begin(), prek.end(), 0);
        do {
            vector<int> tmp;
            for (int i = 0; i < n; ++i) {
                int k = (int)a[prek[i]].size();
                for (int j = 0; j < k; ++j) {
                    tmp.push_back(a[prek[i]][j]);
                    //cout << a[prek[i]][j];
                }
                // cout << ' ';
            }
            //cout << '\n';

            int mx = 0, cnt = 0;
            for (auto x : tmp) {
                if (x > mx) {
                    ++cnt;
                    mx = x;
                }
            }

            ans = max(ans, cnt);
        } while(next_permutation(prek.begin(), prek.end()));

        cout << ans << '\n';
        return;
    }

    int flag1 = 0, flag2 = 0;
    for (int i = 0; i < n; ++i) {
        vector<int> kek = {1, 2};
        if (a[i] == kek) {
            cout << 2 << '\n';
            return;
        }
        if (a[i][0] == 1) {
            flag1 = 1;
        } else {
            flag2 = 1;
        }
    }
    
    if (flag1 && flag2) {
        cout << 2 << '\n';
    } else {
        cout << 1 << '\n';
    }
}

int main() {
    ll t = 1;
    //cin >> t;
    while (t --> 0) {
        solve();
    }

    return 0;
}
