#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
typedef long double ld;
using namespace std;

int get(const vector<int> &A) {
    int cnt = 0;
    int mx = 0;
    for (const int &i : A) {
        if (i > mx) {
            cnt++;
            mx = i;
        }
    }
    return cnt;
}

vector<int> operator+(const vector<int> &A, const vector<int> &B) {
    vector<int> C;
    C.reserve(A.size() + B.size());
    for (const auto &i : A) {
        C.push_back(i);
    }
    for (const auto &i : B) {
        C.push_back(i);
    }
    return C;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    static clock_t START = clock();
    int n;
    cin >> n;
    vector<vector<int>> A(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        A[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> A[i][j];
        }
    }
    random_device rd;
    mt19937 rnd(rd());
    vector<int> B(n);
    iota(B.begin(), B.end(), 0);
    int ans = 0;
    do {
        shuffle(B.begin(), B.end(), rnd);
        vector<int> res;
        for (int i: B) {
            for (const auto &item: A[i]) {
                res.push_back(item);
            }
        }
        ans = max(ans, get(res));
    } while (1. * (clock() - START) / CLOCKS_PER_SEC < 0.9);
    cout << ans << "\n";
    return 0;
}
