#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN

void dbg(ll a) { cout << a << "\n"; }

void dbg(int a) { cout << a << "\n"; }

void dbg(string &a) { cout << a << "\n"; }

void dbg(ll a, ll b) { cout << a << " " << b << "\n"; }

void dbg(int a, int b) { cout << a << " " << b << "\n"; }

void dbg(ll a, ll b, ll c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(int a, int b, int c) { cout << a << " " << b << " " << c << "\n"; }

void dbg(vector<ll> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

void dbg(vector<int> &a) {
    for (auto i: a) cout << i << " ";
    cout << "\n";
}

#else
#define dbg(...)
#endif

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    map<int, vector<int>> b;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            a[i][j] = rnd() % 10 + 1;
            cin >> a[i][j];
        }
        b[*max_element(all(a[i]))].push_back(i);
    }
    int ans = 0;
    vector<int> dp(2e5 + 1);
    for (auto [mx, ids]: b) {
        for (auto i: ids) {
            int ccur = 0, val = 0;
            vector<int> used(a[i].size());
            for (int j = 0; j < a[i].size(); j++) {
                if (a[i][j] > ccur) {
                    ccur = a[i][j];
                    val++;
                    used[j] = 1;
                }
            }
            for (int j = 0; j < a[i].size(); j++) {
                if (used[j]) {
                    int prev = *max_element(dp.begin(), dp.begin() + a[i][j]);
                    dp[mx] = max(dp[mx], val + prev);
                    val--;
                }
            }
        }
    }
    ans = *max_element(all(dp));
    cout << ans << "\n";
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
