#include<iostream>
#include<vector>
#include<algorithm>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
typedef long long ll;
using namespace std;
const int inf = 1e9;

int main() {
    int n;
    cin >> n;
    vec<vec<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            if (a[i].empty() || x > a[i].back())
                a[i].push_back(x);
        }
    }
    sort(all(a), [](vec<int>& b, vec<int>& c) {
        return b.back() < c.back();
        });
    vec<vec<int>> dp(n + 1, vec<int>(n + 1, -inf));
    dp[0][0] = 0;
    int res = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < i; j++) {
            dp[i + 1][j + 1] = dp[i][j + 1];
            int pos = a[i].end() - upper_bound(a[i].begin(), a[i].end(), a[j].back());
            dp[i + 1][i + 1] = max(dp[i + 1][i + 1], dp[i + 1][j + 1] + pos);
        }
        dp[i + 1][0] = 0;
        dp[i + 1][i + 1] = max(dp[i + 1][i + 1], sz(a[i]));
        res = max(dp[i + 1][i + 1], res);
    }
    /*
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++)
            cout << dp[i][j] << " ";
        cout << "\n";
    }*/
    cout << res;
}