#include<iostream>
#include<vector>
#include<algorithm>
#define vec vector
#define sz(v) ((int)v.size())
#define all(v) v.begin(), v.end()
typedef long long ll;
using namespace std;
const int inf = 1e9;

int main() {
    int n;
    cin >> n;
    vec<vec<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            if (a[i].empty() || x > a[i].back())
                a[i].push_back(x);
        }
    }
    sort(all(a), [](vec<int>& b, vec<int>& c) {
        return b.back() < c.back();
        });
    vec<int> dp(n + 2, -inf);
    dp[0] = 0;
    int res = 0;
    if (n < 25000) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < i; j++) {
                int pos = a[i].end() - upper_bound(a[i].begin(), a[i].end(), a[j].back());
                dp[i + 1] = max(dp[i + 1], dp[j + 1] + pos);
            }
            dp[i + 1] = max(dp[i + 1], sz(a[i]));
            res = max(dp[i + 1], res);
        }
    }
    else {
        res = sz(a[0]);
        for (int i = 1; i < n; i++) {
            int pos = a[i].end() - upper_bound(a[i].begin(), a[i].end(), a[i - 1].back());
            res += pos;
        }
    }
    /*
    for (int i = 0; i <= n; i++) {
        for (int j = 0; j <= n; j++)
            cout << dp[i][j] << " ";
        cout << "\n";
    }*/
    cout << res;
}