#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 2e5 + 5;

vector<int> a[MAXN];
int k[MAXN];

int calc(int i1, int i2) {
    int mx = -inf, ans = 0;
    for (int i = 0; i < k[i1]; i++) {
        if (a[i1][i] > mx) {
            ans++;
            mx = a[i1][i];
        }
    }
    for (int i = 0; i < k[i2]; i++) {
        if (a[i2][i] > mx) {
            ans++;
            mx = a[i2][i];
        }
    }
    return ans;
}

void solve() {
    int n;
    cin >> n;

    for (int i = 0; i < n; i++) {
        cin >> k[i];
        a[i].rs(k[i]);
        cin >> a[i];
    }

    vector<int> srt(n, 0);
    iota(all(srt), 0);
    sort(all(srt), [&](int i1, int i2) {
        int calc1 = calc(i1, i2);
        int calc2 = calc(i2, i1);
        if (calc1 == calc2)return *max_element(all(a[i1])) < *max_element(all(a[i2]));
        return calc1 > calc2;
    });

    int ans = 0;
    int mx = -inf;
    // cout << srt << '\n';
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k[srt[i]]; j++) {
            if (a[srt[i]][j] > mx) {
                ans++;
                mx = a[srt[i]][j];
            }
        }
    }
    cout << ans << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}
