#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb emplace_back

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

const int MAXN = 2e5 + 10;

vector<pt> rec[MAXN];
int tree[MAXN * 4];

void upd(int v, int l, int r, int pos, int val){
    if (r - l == 1){
        tree[v] = max(tree[v], val);
        return;
    }
    int mid = (l + r) >> 1;
    if (pos < mid)
        upd(v << 1, l, mid, pos, val);
    else
        upd(v << 1 | 1, mid, r, pos, val);
    tree[v] = max(tree[v << 1], tree[v << 1 | 1]);
}

int getmax(int v, int l, int r, int ql, int qr){
    if (r <= ql || qr <= l)
        return 0;
    if (ql <= l && r <= qr)
        return tree[v];
    int mid = (l + r) >> 1;
    return max(getmax(v << 1, l, mid, ql, qr), getmax(v << 1 | 1, mid, r, ql, qr));
}

void run(){
    int n;
    cin >> n;
    for (int i = 0; i < n; i++){
        int k;
        cin >> k;
        vector<int> st;
        for (int j = 0; j < k; j++){
            int x;
            cin >> x;
            x++;
            if (st.empty() || x > st.back())
                st.push_back(x);
        }
        for (int j = 0; j < sz(st); j++){
            rec[st[j]].pb(sz(st) - j, st.back());
        }
    }
    for (int pos = 1; pos < MAXN; pos++){
        int lst = getmax(1, 1, MAXN + 1, 1, pos);
        for (auto [add, to]: rec[pos]){
            upd(1, 1, MAXN + 1, to, lst + add);
        }
    }
    cout << getmax(1, 1, MAXN + 1, 1, MAXN + 1) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
