﻿#include <iostream>
#include <random>
#include <vector>
#include<string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>
#include <math.h>
#include <iomanip>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
mt19937 rnd(time(0));
vector<vector<int>> a;

bool cmp(vector<int> a1, vector<int> a2) {
	int s1 = a1.size() - 1, s2 = a2.size() - 1;
	while (s1 >= 0 && s2 >= 0) {
		if (a1[s1] != a2[s2]) return a1[s1] < a2[s2];
		s1--;
		s2--;
	}
	if (s1 == -1) return 1;
	return 0;
}

signed main()
{
	int n; cin >> n;
	a.resize(n);
	vector<int> b(n);
	int MAX = 0;
	for (int i = 0; i < n; ++i) {
		int k; cin >> k;
		int maxi = 0;
		for (int j = 0; j < k; ++j) {
			int x; cin >> x;
			if (x > maxi) {
				maxi = x;
				a[i].push_back(x);
			}
		}
		b[i] = maxi;
		MAX = max(MAX, maxi);
	}

	sort(all(a), cmp);

	/*
	cout << endl;
	for (auto& v : a) {
		for (auto& i : v) cout << i << " ";
		cout << endl;
	}
	cout << endl;
	*/

	vector<int> dp(n, 0);
	dp[0] = a[0].size();
	for (int i = 1; i < n; ++i) {
		dp[i] = a[i].size();
		for (int j = 0; j < i; ++j) {
			int maxi = a[j][a[j].size() - 1];
			int k = (a[i].end() - upper_bound(all(a[i]), maxi));
			dp[i] = max(dp[i], dp[j] + k);
		}
	}

	cout << dp[n - 1];
	return 0;

	/*
	if (MAX <= 2) {
		int ans = 0;
		for (int i = 0; i < n; ++i)
			if (a[i].size() && a[i][0] == 1) ans = 1;
		if (MAX == 2) ans++;
		cout << ans;
		return 0;
	}

	vector<int> v(n);
	int ans = 0;
	for (int i = 0; i < n; ++i) v[i] = i;
	int maxi = 0;
	int cnt = 0;
	for (int i = 0; i < n; ++i) {
		cnt += (a[v[i]].end() - upper_bound(all(a[v[i]]), maxi));
		maxi = max(maxi, b[v[i]]);
	}
	ans = max(ans, cnt);
	while (next_permutation(all(v))) {
		maxi = 0;
		cnt = 0;
		for (int i = 0; i < n; ++i) {
			cnt += (a[v[i]].end() - upper_bound(all(a[v[i]]), maxi));
			maxi = max(maxi, b[v[i]]);
		}
		ans = max(ans, cnt);
	}

	cout << ans;
	*/
}