// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt,tune=native")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag,
// tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

struct album {
    vector<int> tracks;
    int mx = 0, score = 0, id;
    album(vector<int> &a, int id_) {
        id = id_;
        for (auto x : a) {
            tracks.pb(x);
            if (x > mx)
                score++;
            mx = max(mx, x);
        }
    }
    bool operator<(album &a) {
        return mx < a.mx || mx == a.mx && score > a.score ||
               mx == a.mx && score == a.score && id < a.id;
    }
};

void solve() {
    int n;
    cin >> n;
    vector<album> a;
    for (int i = 0; i < n; i++) {
        vector<int> cur;
        int k;
        cin >> k;
        while (k--) {
            int x;
            cin >> x;
            cur.pb(x);
        }
        a.pb(album(cur, i));
    }
    sort(all(a));
    int mx = 0, ans = 0;
    for (auto &row : a) {
        for (auto x : row.tracks) {
            if (x > mx) {
                mx = x;
                ans++;
            }
        }
    }
    cout << ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    return 0;
}