#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> a(n);
    vector<vector<int>> b(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (auto& x : a[i]) {
            cin >> x;
        }
        int curr_max = 0;
        for (auto x : a[i]) {
            if (x > curr_max) {
                b[i].push_back(x);
                curr_max = x;
            }
        }
    }

    sort(b.begin(), b.end(), [&](const auto& lhs, const auto& rhs) {
        return make_pair(lhs.back(), lhs[0]) < make_pair(rhs.back(), rhs[0]);
    });

    b.insert(b.begin(), {0});
    int ans = 0;
    vector<int> dp(n + 1);
    for (int i = 1; i <= n; ++i) {
        for (int j = 0; j < i; ++j) {
            int cost = upper_bound(b[i].begin(), b[i].end(), b[j].back()) - b[i].begin();
            cost = b[i].size() - cost;
            dp[i] = max(dp[i], dp[j] + cost);
        }
        ans = max(ans, dp[i]);
    }
    cout << ans << '\n';

    return 0;
}