
#ifdef WIN64
    #define _GLIBCXX_DEBUG
#endif // WIN64
#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple
#define isz(x) (int) x.size()
#define xx first
#define yy second

#ifdef WIN64
    #define check(x) cerr << (#x) << " = " << x << "\n"
    template<class T> void print(T* ar, int sz) {
        for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
        cerr << "\n";
    }
#else
    #define check(x) 17
    template<class T> void print(T* ar, int sz) {}
#endif // WIN64

const int N = (int) 1000 + 1;
const int INF = (int) 1e9 + 117;
const int MOD = (int) 1e9 + 7;
const long long INFll = (long long) 2e18 + 117;
const double EPS = 1e-8;

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

#define int long long

using Pt = pair<int, int>;
using ll = long long;

int solve1() {
    return 0;
}

int n;
vector<int> tid[N], compress, t[N];
vector<pair <int, pair<int, int>> > a;

inline int f(int i, int x) {
    int j = (int) (upper_bound(all(tid[i]), x) - tid[i].begin());
    return isz(tid[i]) - j;
}

inline int get_compress(int x) {
    return (int) (lower_bound(all(compress), x) - compress.begin());
}

vector<int> dp;

int solve() {
    assert(cin >> n);
    dp.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        int k;
        assert(cin >> k);
        int mx = 0;
        while (k--) {
            int x;
            assert(cin >> x);
            if (x > mx) {
                tid[i].push_back(x);
                mx = x;
            }
        }
        a.push_back(mkp(mx, mkp(isz(tid[i]), i)));
        check(mx);
        check(isz(tid[i]));
        compress.push_back(mx);
    }

    if (n > 1000) {
        sort(all(compress));
        compress.erase(unique(all(compress)), compress.end());

        for (int i = 0; i < n; ++i) {
            t[get_compress(a[i].xx)].push_back(i);
        }

        check(isz(compress));

        for (int x = 0; x < isz(compress); ++x) check(compress[x]);

        int ans = 0;

        for (int i = 0; i < isz(compress); ++i) {
            sort(all(t[i]), [&](int u, int v) {
                return a[u].yy.xx > a[v].yy.xx;
            });

            for (int x = i + 1; x < isz(compress); ++x) {
                sort(all(t[x]), [&](int u, int v) {
                    return f(u, compress[x - 1]) > f(v, compress[x - 1]);
                });
            }
            int res = a[t[i][0]].yy.xx;
            for (int x = i + 1; x < isz(compress); ++x) {
                res += f(t[x][0], compress[x - 1]);
            }
            if (res > ans) ans = res;
        }
        cout << ans << "\n";
        return 0;
    }

    sort(all(a));

    for (int i = 0; i < n; ++i) {
        int res = a[i].yy.xx;
        check(i);
        for (int j = 0; j < i; ++j) {
            check(a[j].yy.yy);
            int nres = dp[j] + f(a[i].yy.yy, a[j].xx);
            check(j);
            check(dp[j]);
            check(f(a[i].yy.yy, a[j].xx));
            check(nres);
            if (nres > res) {
                res = nres;
            }
        }
        dp[i] = res;
    }

    check(dp);

    cout << *max_element(all(dp)) << "\n";

    return 0;
}

signed main() {
#ifdef WIN64
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WIN64
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
