#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef std::pair<int, int> pii;

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::milliseconds>(f - s).count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define pb push_back
#define ff first
#define sc second
#define str string
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

template<typename T, typename T1> istream& operator>>(istream& in, pair<T, T1> &a) { in >> a.ff >> a.sc; return in; }
template<typename T, typename T1> ostream& operator<<(ostream& out, pair<T, T1> a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream& in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T> a) { for (auto el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937 gen(mt_seed); int randint(int l, int r) { uniform_int_distribution<> random(l, r); return random(gen); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const {return x ^ RANDOM; }};

struct trip {
    int ff, sc, th;
};

bool cmp(trip a, trip b) {
    if (a.sc == b.sc) {
        if (a.th == b.th)
            return a.ff < b.ff;
        return a.th > b.th;
    }
    return a.sc < b.sc;
}

int main() {
    fast
//    file_in

    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<trip> b(n);
    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        int last = 0;
        for (int j = 0; j < m; ++j) {
            int cur;
            cin >> cur;
            if (cur > last) {
                last = cur;
                a[i].pb(cur);
            }
        }
        if (sz(a) > 1) {
            b[i] = {a[i][0], a[i][1], sz(a)};
        } else {
            b[i] = {a[i][0], a[i][0], sz(a)};
        }
    }

    bool check3 = 1;
    for (auto &now : a)
        for (auto el : now)
            if (el >= 2)
                check3 = 0;

    if (n <= 7) {
        sort(all(a));
        int ans = 0;
        do {
            int mx = 0;
            int res = 0;
            for (int i = 0; i < n; ++i) {
                for (auto el : a[i]) {
                    if (el > mx) {
                        mx = el;
                        ++res;
                    }
                }
            }
            ans = max(ans, res);
        } while(next_permutation(all(a)));
        cout << ans;
    } else if (check3) {
        bool check1 = 1, check2 = 1;
        for (int i = 0; i < n; ++i) {
            if (sz(a[i]) == 2) {cout << 2; return 0;}
            if (a[i][0] == 2) {
                check1 = 0;
            } else {
                check2 = 0;
            }
        }
        if (check1 == 0 && check2 == 0) {
            cout << 2;
        } else {
            cout << 1;
        }
    } else {
        int ans = 0, max = 0;
        for (int i = 0; i < n; ++i) {
            if (b[i].ff > max) {
                max = b[i].ff;
                ++ans;
            }
            if (b[i].sc > max) {
                max = b[i].sc;
                ++ans;
            }
        }
        cout << ans;
    }
    return 0;
}
