#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

void solve() {
  int n;
  cin >> n;
  vector<vector<int>> a(n);
  for (int i = 0; i < n; ++i) {
    int k;
    cin >> k;
    a[i].resize(k);
    for (int j = 0; j < k; ++j) {
      cin >> a[i][j];
    }
  }
  vector<int> mx(n);
  for (int i = 0; i < n; ++i) {
    mx[i] = *max_element(all(a[i]));
  }
  vector<int> order(n);
  iota(all(order), 0);
  sort(all(order), [&](int i, int j) {
    return mx[i] < mx[j];
  });
  int ans = 0, last = 0;
  for (int i : order) {
    for (int x : a[i]) {
      if (x > last) {
        last = x;
        ++ans;
      }
    }
  }
  cout << ans;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt = 1;
  //cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}
