#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream &is, pair <T1, T2> &a) {is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream &os, pair <T1, T2> a) {os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream &is, vector <T> &a) {for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream &os, vector <T> a) {for (auto x : a) os << x << " "; os << endl; return os;}

const int N = 200010;
int f[N];

void upd(int i, int x){
    for (; i < N; i |= i + 1) f[i] = max(f[i], x);
}

int get(int i){
    int ans = 0;
    for (; i >= 0; i = (i & (i + 1)) - 1) ans = max(ans, f[i]);
    return ans;
}

bool cmp(const vector <int> &a, const vector <int> &b) {return a.back() < b.back();}

void solve(){
    int n;
    cin >> n;
    vector <vector <int>> a(n);
    for (int i = 0; i < n; i++){
        int k;
        cin >> k;
        int mx = -inf;
        while (k--){
            int x;
            cin >> x;
            if (x > mx) a[i].push_back(x), mx = x;
        }
    }
    sort(a.begin(), a.end(), cmp);
    for (auto x : a){
        for (int i = 0; i < x.size(); i++) {
            upd(x.back(), get(x[i] - 1) + x.size() - i);
        }
    }
    cout << get(N - 1) << endl;
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}