#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;
constexpr int INF = 2e9;

bool STRS = false;

//struct st {
//    constexpr int sz = (1 << 18);
//
//};

struct Solution {
    mt19937 rnd;

    Solution() {
        rnd = mt19937(time(nullptr));
    }

    struct seg {
        int s = -1, e = -1, w = 0;

        seg() {}
        seg(int s, int e, int w) : s(s), e(e), w(w) {}
    };

    signed operator()(int TEST = -1) {
        int n; cin >> n;
        auto genSeg = [](vector<seg>& ans) -> void {
            int k; cin >> k;
            vector<int> ar(k);
            for (auto& it : ar) {
                cin >> it;
                it = -it;
            }
            reverse(ar.begin(), ar.end());
            int mn = INF;
            vector<int> ps(k + 1, INF);
            ps[0] = -INF;
            vector<int> dp(k + 1, 0);
            unordered_map<int, seg> tps;
            for (int i = 0; i < k; ++i) {
                mn = min(mn, ar[i]);
                auto it = (lower_bound(ps.begin(), ps.end(), ar[i]) - ps.begin());
                dp[it] = dp[it - 1] + 1;
                ps[it] = ar[i];
                if (!tps.count(dp[it]) || tps[dp[it]].e < -ar[i]) {
                    tps[dp[it]] = seg(-ar[i], -mn, dp[it]);
                }
            }
            for (auto& it : tps) {
                ans.push_back(it.second);
            }
        };
        vector<seg> se;
        while (n--) {
            genSeg(se);
        }
        sort(se.begin(), se.end(), [](seg l, seg r)-> bool {
            if (l.e != r.e)
                return l.e < r.e;
            return l.s < r.s;
        });
#ifdef ILKRAS
        constexpr int sz = 10 + 1;
#else
        constexpr int sz = 2e5 + 1;
#endif
        vector<int> dp(sz);
        for (auto& it : se) {
            auto rs = *max_element(dp.begin(), dp.begin() + it.s);
            dp[it.e] = max(dp[it.e], rs + it.w);
        }
        cout << *max_element(dp.begin(), dp.end());
        return 0;
    }
};
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    int t = 1;
//    cin >> t;
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}