#include <bits/stdc++.h>

using namespace std;

typedef int64_t ll;
constexpr int INF = 2e9;

bool STRS = false;

struct st {
#ifndef ILKRAS
    static constexpr int sz = (1 << 18);
#else
    static constexpr int sz = (1 << 10);
#endif
    vector<int> dt;

    st() {
        dt.resize(sz * 2);
    }

    void set(int id, int val) {
        id += sz;
        if (dt[id] < val) {
            dt[id] = val;
            for (id /= 2; id > 0; id /= 2)
                dt[id] = max(dt[id * 2], dt[id * 2 + 1]);
        }
    }

    int get(int l, int r, int ld = 0, int rd = sz, int id = 1) {
        if (l >= rd || r <= ld) return 0;
        if (l <= ld && rd <= r) return dt[id];
        return max(get(l, r, ld, (ld + rd) / 2, id * 2), get(l, r, (ld + rd) / 2, rd, id * 2 + 1));
    }
};

struct Solution {
    mt19937 rnd;

    Solution() {
        rnd = mt19937(time(nullptr));
    }

    struct seg {
        int s = -1, e = -1, w = 0;

        seg() {}
        seg(int s, int e, int w) : s(s), e(e), w(w) {}
    };

    signed operator()(int TEST = -1) {
        int n; cin >> n;
        auto genSeg = [](vector<seg>& ans) -> void {
            int k; cin >> k;
            vector<int> ar(k);
            for (auto& it : ar) {
                cin >> it;
            }
            vector<int> st;
            vector<int> nr(k, k);
            vector<int> dp(k + 1);
            vector<int> mx(k + 1);
            for (int i = 0; i < k; ++i) {
                while (!st.empty() && ar[st.back()] < ar[i]) {
                    nr[st.back()] = i;
                    st.pop_back();
                }
                st.push_back(i);
            }
            for (int i = k - 1; i >= 0; --i) {
                dp[i] = dp[nr[i]] + 1;
                if (nr[i] == k)
                    mx[i] = ar[i];
                else
                    mx[i] = mx[nr[i]];
            }
            int mxv = -1;
            for (int i = 0; i < k; ++i) {
                if (ar[i] > mxv) {
                    ans.emplace_back(ar[i], mx[i], dp[i]);
                    mxv = ar[i];
                }
            }
        };
        vector<seg> se;
        while (n--) {
            genSeg(se);
        }
        sort(se.begin(), se.end(), [](seg l, seg r)-> bool {
            if (l.e != r.e)
                return l.e < r.e;
            return l.s < r.s;
        });
       st dp;
        for (auto& it : se) {
            dp.set(it.e, dp.get(0, it.s) + it.w);
        }
        cout << dp.dt[1] << "\n";
        return 0;
    }
};
signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    int t = 1;
//    cin >> t;
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}

//2
//1
//1
//7
//1 2 228 1 2 3 228