#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace __gnu_pbds;
using namespace std;

template<typename Ty, class Compare = less<Ty>>
        using ordered_set = tree<Ty, null_type, Compare, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ull = unsigned long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vll = vector<ll>;
using vvll = vector<vll>;
using pii = pair<int, int>;

#define mk make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,popcnt")

/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1
*/

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int n; cin >> n;
    vvi a(n);
    for (int i = 0; i < n; ++i)
    {
        int k; cin >> k;
        for (int j = 0; j < k; ++j)
        {
            int x; cin >> x;
            if (!a[i].empty())
            {
                if (a[i].back() < x)
                    a[i].push_back(x);
            }
            else
            {
                a[i].push_back(x);
            }
        }
    }
    sort(all(a),
         [&](auto& ai, auto& aj)->bool {return lexicographical_compare(rall(ai), rall(aj));});
    /*
    for (int i = 0; i < n; ++i)
    {
        for (auto e: a[i])
            cerr << e << " ";
        cerr << endl;
    }
     */
    int ans = 0;
    int m = -1;
    for (int i = 0; i < n; ++i)
    {
        for (int e: a[i])
        {
            if (e > m)
            {
                m = e;
                ++ans;
            }
        }
    }
    cout << ans << "\n";
    return 0;
}
