#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<stack>
#include<queue>

using namespace std;

typedef long long ll;

int main() {
	int n;
	cin >> n;
	vector<vector<int>> v(n);
	vector<pair<ll, int>> mait(n);
	for (int i = 0; i < n; ++i) {
		int s;
		cin >> s;
		int x;
		cin >> x;
		v[i].push_back(x);
		for (int j = 1; j < s; ++j) {
			cin >> x;
			if (x > *v[i].rbegin()) v[i].push_back(x);
		}
		mait[i] = { *v[i].rbegin(), i };
	}
	sort(mait.begin(), mait.end());
	vector <ll> ans(n, 0);
	ans[0] = v[mait[0].second].size();
	for (int i = 1; i < n; ++i) {
		ll kan = 0;
		for (int j = 0; j < v[mait[i].second].size(); ++j) {
			int l = 0, r = i;
			while (l + 1 < r) {
				int mid = (l + r) / 2;
				if (mait[mid].first < v[mait[i].second][j]) l = mid;
				else r = mid;
			}
			if (mait[l].first < v[mait[i].second][j]) {
				if (kan < ans[l] + (ll)v[mait[i].second].size() - j) {
					kan = ans[l] + (ll)v[mait[i].second].size() - j;
				}
			}
			else {
				if (kan < (ll)v[mait[i].second].size() - j) {
					kan = (ll)v[mait[i].second].size() - j;
				}
			}
		}
		ans[i] = kan;
	}
	cout << ans[n - 1];
}