//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n;
	cin >> n;
	vector<pair<ll, vector<ll>>> arr;
	for (ll i = 0; i < n; i++) {
		ll k;
		cin >> k;
		arr.emplace_back(0, vector<ll>(k, 0));
		for (ll j = 0; j < k; j++) {
			cin >> arr.back().second[j];
			assign_max(arr.back().first, arr.back().second[j]);
		}
		ll lst = -1;
		vector<ll> now = arr.back().second;
		arr.back().second.clear();
		for (auto i : now) {
			if (assign_max(lst, i)) {
				arr.back().second.push_back(i);
			}
		}
	}
	sort(arr.begin(), arr.end());
	vector<ll> dp(n + 1, 0);
	for (ll i = 0; i < n; i++) {
		for (ll j = 0; j < arr[i].second.size(); j++) {
			ll l = -1, r = i;
			while (r - l > 1) {
				ll mid = (l + r) / 2;
				if (arr[mid].first < arr[i].second[j]) {
					l = mid;
				} else {
					r = mid;
				}
			}
			assign_max(dp[i + 1], (ll)(arr[i].second.size()) - j + dp[l + 1]);
		}
	}
	cout << dp.back() << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		solve();
	} else {
		solve();
	}
}
