#include<bits/stdc++.h>
#define pb push_back
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

template<class T> using matrix = vector<vector<T>>;

const int MAXN = 2e5 + 5;

matrix<pair<int, int>> G;
vector<int> used, dp;

int main(){
	int N; cin >> N;
	G = matrix<pair<int, int>>(MAXN);
	dp = used = vector<int>(MAXN);
	for(int i = 0; i < N; i ++){
		int k; cin >> k;
		vector<int> curr;
		for(int i = 0; i < k; i ++){
			int x; cin >> x;
			if(curr.empty() || curr.back() < x){
				curr.pb(x);
			}
		}
		for(int i = 0; i < curr.size(); i ++){
			int u = curr[i] - 1;
			G[u].pb({curr.back(), curr.size() - i});
		}
	}
	for(int x = 0; x < MAXN - 1; x ++){
		G[x].pb({x + 1, 0});
	}
	for(int u = MAXN - 1; u >= 0; u --){
		for(auto [v, w] : G[u]){
			dp[u] = max(dp[v] + w, dp[u]);
		}
	}
	cout << dp[0] << endl;
}
/**
4
5 4 9 4 6 8
1 7
2 8 6
1 1

4
2 3 4
2 1 8
2 2 8
2 7 9

4
3 3 5 6 
2 2 3 
1 1 
1 4

*/