#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, vector<ll>>> had(n);

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        had[i].second.resize(k);
        cin >> had[i].second;
        ll maxim = 0;
        for (auto el : had[i].second){
            maxim = max(maxim , el);
        }
        had[i].first = maxim;
    }
    std::sort(had.begin(), had.end());
    vector<ll> stek_maximov= {0};
    vector<vector<ll>> real_stek= {{}};
    for (auto el : had){
        while (stek_maximov.size() > 1){
            ll maxis = stek_maximov[stek_maximov.size() - 2];
            ll cnt = 0;
            for (auto el2 : real_stek.back()){
                if (maxis < el2){
                    maxis = el2;
                    cnt++;
                }
            }
            for (auto el2 : el.second){
                if (maxis < el2){
                    maxis = el2;
                    cnt++;
                }
            }
            ll cnt2 = 0;
            maxis = stek_maximov[stek_maximov.size() - 2];
            for (auto el2 : el.second){
                if (maxis < el2){
                    maxis = el2;
                    cnt2++;
                }
            }
            if (cnt2 >= cnt){
                stek_maximov.pop_back();
                real_stek.pop_back();
            }
            else{
                break;
            }
        }
        stek_maximov.push_back(el.first);
        real_stek.push_back(el.second);
    }
    ll maxim  = 0;
    ll cnt = 0;
    for (auto el : real_stek){
        for (auto el2 : el){
            if (el2 > maxim){
                maxim = el2;
                cnt++;
            }
        }
    }
    cout << cnt << "\n";

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

