#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, vector<ll>>> had(n);

    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        had[i].second.resize(k);
        cin >> had[i].second;
        ll maxim = 0;
        for (auto el: had[i].second) {
            maxim = max(maxim, el);
        }
        vector<ll> stek;
        std::reverse(had[i].second.begin(), had[i].second.end());
        for (auto el : had[i].second){
            while (!stek.empty() && stek.back() < el){
                stek.pop_back();
            }
            stek.push_back(el);
        }
        std::reverse(stek.begin(), stek.end());
        had[i].second = stek;
        had[i].first = maxim;
    }
    had.push_back({0, {}});
    std::sort(had.begin(), had.end());
    vector<ll> dp(200001, 0);
    dp[0] = 0;
    for (int i = 0; i <= n; i++){
        for (int k = 0; k < had[i].second.size(); k++){
            ll maxim = 0;
            for (int  j = 0 ; j < had[i].second[k]; j++){
                maxim = max(maxim, dp[j]);
            }
            dp[had[i].first] = max(dp[had[i].first], ll(had[i].second.size() - k + maxim));
        }
    }
    ll maxim = 0;
    for (auto el : dp){
        maxim = max(maxim, el);
    }
    cout << maxim << "\n";

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}

