#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;
typedef double ld;
vector<vector<ll>> p;
void f(ll n, ll m, vector<ll> a, vector<ll> u) {
	if (m == 0) p.push_back(a);
	else {
		for (ll i = 0; i < n; ++i) {
			if (u[i]) continue;
			a.push_back(i);
			u[i] = 1;
			f(n, m - 1, a, u);
			u[i] = 0;
			a.pop_back();
		}
	}
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n;
	cin >> n;
	vector<ll> k(n);
	vector<vector<ll>> a(n);
	for (ll i = 0; i < n; ++i) {
		cin >> k[i];
		a[i].resize(k[i]);
		for (ll j = 0; j < k[i]; ++j) cin >> a[i][j];
	}
	vector<ll> A, u(n, 0);
	f(n, n, A, u);
	ll ans = 0;
	for (ll i = 0; i < (ll)p.size(); ++i) {
		vector<ll> b;
		for (ll j = 0; j < n; ++j) {
			for (auto z : a[p[i][j]]) b.push_back(z);
		}
		vector<ll> dp((ll)b.size() + 1, 1e18);
		dp[0] = 0;
		for (ll j = 0; j < (ll)b.size(); ++j) {
			ll l = 0, r = (ll)b.size();
			while (r - l > 1) {
				ll m = (l + r) / 2;
				if (dp[m] < b[j]) l = m;
				else r = m;
			}
			ans = max(ans, r);
			dp[r] = b[j];
		}
	}
	cout << ans;
	return 0;
}