import sys


def cmp(a, b):
    l, r = -1, len(a)
    while r - l > 1:
        m = (r + l) // 2
        if a[m] > b[-1]:
            r = m
        else:
            l = m
    ans = len(a) - r + len(b)
    l, r = -1, len(b)
    while r - l > 1:
        m = (r + l) // 2
        if b[m] > a[-1]:
            r = m
        else:
            l = m
    ass = len(b) - r + len(a)
    if ans == ass:
        return a[-1] < b[-1]
    return ans < ass


def merge(a):
    if len(a) == 1:
        return a
    m = len(a) // 2
    x = a[:m]
    y = a[m:]
    x = merge(x)
    y = merge(y)
    i, j = 0, 0
    while i < len(x) and j < len(y):
        if cmp(x[i], y[j]):
            a[i + j] = x[i]
            i += 1
        else:
            a[i + j] = y[j]
            j += 1
    while i < len(x):
        a[i + j] = x[i]
        i += 1
    while j < len(y):
        a[i + j] = y[j]
        j += 1
    return a


def solve():
    n = int(input())
    a = []
    for i in range(n):
        m = int(input())
        x = 0
        a.append([])
        for j in list(map(int, input().split())):
            if j > x:
                a[-1].append(j)
                x = j
    merge(a)
    x = 0
    ans = 0
    for i in range(n):
        for j in a[i]:
            if j > x:
                ans += 1
                x = j
    print(ans)


solve()
