//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> v(n);
    bool small = true;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        v[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> v[i][j];
            if (v[i][j] > 2) {
                small = false;
            }
        }
    }

    int ans = 0;
    vector<int> dp((int)2e5 + 1, (int) 1e9);
    for (int i = 0; i < n; i++) {
        for (int el : v[i]) {
            auto it = lower_bound(dp.begin(), dp.end(), el);
            dp[(int) (it - dp.begin())] = el;
            ans = max(ans, (int) (it - dp.begin()) + 1);
        }
    }
    cout << ans << endl;
}
