#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;

#define all(a) (a).begin(), (a).end()W


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n, ma = 0;
    cin >> n;

    vector<vector<pii>> a(200001);

    for (int i = 0; i < n; ++i) {
        int m;
        cin >> m;
        vector<int> mi;
        for (int j = 0; j < m; ++j) {
            int now;
            cin >> now;
            if (mi.size() == 0 || mi.back() < now) {
                mi.push_back(now);
                ma = max(now, ma);
            }
        }

        for (int j = 0; j < mi.size(); ++j) {
            a[mi[j] - 1].push_back({ mi.back(), mi.size() - j } );
        }
    }

    vector<ll> dp(ma + 3, 0);

    for (int i = 0; i < ma + 1; ++i) {
        dp[i + 1] = max(dp[i + 1], dp[i]);
        for (auto [last, lust] : a[i]) {
            dp[last] = max(dp[last], dp[i] + lust);
        }
    }


    cout << dp[ma];

    return 0;
}
