#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ll long long
#define pii pair<int, int>
#define dl long double
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
vector<int> dp;
map<int, vector<vector<int>>> a;
vector<int> MAX = {0};
int LEN, N;
vector<int> t;

void build() {
    N = 1;
    while (N <= LEN)N *= 2;
    t.resize(2 * N);
}

void upd(int i, int x) {
    i += N;
    t[i] = x;
    while (i) {
        i /= 2;
        t[i] = max(t[i * 2], t[i * 2 + 1]);
    }
}

int get(int lq, int rq, int v = 1, int l = 0, int r = N) {
    if (rq <= l || r <= lq)return 0;
    if (lq <= l && r <= rq)return t[v];
    int m = (l + r) / 2;
    return max(get(lq, rq, v * 2, l, m), get(lq, rq, v * 2 + 1, m, r));
}

void op(int i) {
    int best = 0;
    int mx = MAX[i];
    for (auto &v: a[mx]) {
        int m = sz(v);
        for (int j = 0; j < m; ++j) {
            int R = lower_bound(all(MAX), v[j]) - MAX.begin();
            best = max(best, get(0, R) + m - j);
        }
    }
    dp[i] = best;
    upd(i, best);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> b(k);
        int mx = 0;
        for (int &x: b)cin >> x, mx = max(mx, x);
        a[mx].push_back(b);
    }
    LEN = sz(a) + 1;
    int ans = 0;
    for (auto &[mx, mas]: a) {
        for (auto &v: mas) {
            int nowmx = 0;
            vector<int> b;
            for (int &el: v) {
                if (el > nowmx) {
                    nowmx = el;
                    b.push_back(el);
                }
            }
            v = b;
        }
        MAX.push_back(mx);
    }
    build();
    dp.resize(LEN);
    for (int i = 1; i < LEN; ++i) {
        op(i);
    }
    for (int res: dp)ans = max(ans, res);
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}
/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1

 */