#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>

#include <vector>
#include <string>
#include <bitset>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

typedef long long ll;
typedef long double ld;

#define vec vector 
#define pii pair<ll, ll>
#define pll pair<ll, ll>

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

using namespace std;

#pragma warning(disable: 4996)

int n;

void solve() {
    bool sub2 = 1;
    cin >> n;
    vec<vec<int>> albs;
    for (int i = 0; i < n; i++) {
        int k; cin >> k;
        vec<int> alb; 
        ll prev = -LINF;
        for (int j = 0; j < k; j++) {
            ll x; cin >> x;
            if (x > 2)
                sub2 = 0;
            if (x > prev) {
                alb.push_back(x);
                prev = x;
            }
        }
        if (alb.size())
            albs.push_back(alb);
    }

    if (sub2) {
        vec<pii> rem(albs.size(), {-1, -1});
        for (int i = 0; i < albs.size(); i++) {
            auto alb = albs[i];
            for (auto elem : alb) {
                if (elem == 1 && rem[i].first == -1) {
                    rem[i].first = i;
                }
                if (elem == 2 && rem[i].second == -1) {
                    rem[i].second = i;
                }
            }
        }
        int j = -1;
        for (int i = 0; i < albs.size(); i++) {
            if (rem[i].first < rem[i].second) {
                cout << 2 << "\n";
                return;
            }
            if (rem[i].first != -1 && rem[i].second == -1) {
                j = i;
            }
        }
        if (j != -1) {
            for (int i = 0; i < albs.size(); i++) {
                if (rem[i].second != -1 && i != j) {
                    cout << 2 << "\n";
                    return;
                }
            }
        }
        cout << 1 << '\n';
        return;
    }

    vec<int> now;
    for (int i = 0; i < albs.size(); i++) {
        now.push_back(i);
    }
    ll ans = 0;
    while (next_permutation(now.begin(), now.end())) {
        ll prev = -INF;
        ll res = 0;
        for (auto i : now) {
            for (auto elem : albs[i]) {
                if (elem > prev) {
                    res++;
                    prev = elem;
                }
            }
        }
        ans = max(ans, res);
    }
    ll prev = -INF;
    ll res = 0;
    for (int i = 0; i < albs.size(); i++) {
        for (auto elem : albs[i]) {
            if (elem > prev) {
                res++;
                prev = elem;
            }
        }
    }
    ans = max(ans, res);
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    //cin >> tests;

    while (tests--) {
        solve();
    }
}