#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 1e6 + 300, mod = 1e9 + 7;
double rnd(){
    return (long double)(rand() / RAND_MAX);
}
void solve(){
    ll n;
    cin >> n;
    vector<vector<ll>> nums(n);
    for(int i = 0; i < n; i++){
        ll k;
        cin >> k;
        for(int j = 0; j < k; j++){
            ll x;
            cin >> x;
            nums[i].push_back(x);
        }
    }
    auto get_LIS = [&](vector<ll> &order){
        vector<ll> temp;
        for(ll num : order)
            for(ll v : nums[num])
                temp.push_back(v);
        ll res = 0, last = 0;
        for(ll num : temp)
            if(num > last){
                last = num;
                res++;
            }
        return res;
    };
    vector<ll> order;
    for(int i = 0; i < n; i++)
        order.push_back(i);
    for(int i = 0; i < 1000; i++)
        swap(order[rand() % order.size()], order[rand() % order.size()]);
    ll ans = get_LIS(order);
    long double t = 1;
    double start = ::clock();
    while((::clock() - start) / CLOCKS_PER_SEC < 0.9){
        t *= 0.99;
        vector<ll> temp_order = order;
        int ind = rand() % order.size();
        swap(temp_order[ind], temp_order[(ind + 1) % n]);
        ll temp_ans = get_LIS(temp_order);
        if(temp_ans > ans || rnd() < exp((temp_ans - ans) / t)){
            order = temp_order;
            ans = temp_ans;
        }
    }
    cout << ans;
}
int main(){
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}
