#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 1e6 + 300, mod = 1e9 + 7;
double rnd(){
    return (long double)(rand() / RAND_MAX);
}
void solve(){
    ll n;
    cin >> n;
    vector<vector<ll>> nums(n);
    vector<ll> max_val(n + 1);
    for(int i = 0; i < n; i++){
        ll k;
        cin >> k;
        for(int j = 0; j < k; j++){
            ll x;
            cin >> x;
            nums[i].push_back(x);
            max_val[i] = max(max_val[i], x);
        }
    }
    vector<ll> order;
    for(int i = 0; i < n; i++)
        order.push_back(i);
    sort(order.begin(), order.end(), [&](ll a, ll b){
        return max_val[a] < max_val[b];
    });
    ll last = 0, ans = 0;
    for(int i = 0; i < n; i++){
        ll best = 0, c = 0;
        for(int j = i; j < n && max_val[order[i]] == max_val[order[j]]; j++){
            ll add = 0, temp = last;
            c++;
            for(ll num : nums[order[j]]){
                add += temp < num;
                temp = max(temp, num);
            }
            best = max(best, add);
        }
        ans += best;
        last = max_val[order[i]];
        i += c - 1;
    }
    cout << ans;
}
int main(){
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}
