
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
using namespace std;
#define double long double
#define int long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) <<": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;    
    }
    return a + b;
}

const int MAXA = 200020;
void solve() {
    int n;
    cin >> n;
    vector<int> all_k(n), get_mx(n);
    vector<pair<int, int> > for_sort;
    vector<vector<int> > all_bad(n), add(n), all(n);
    for (int i = 0; i < n; i++) {
        int k, mx = 0;
        cin >> k;
        all_k[i] = k;
        for (int j = 0; j < k; j++) {
            int a; cin >> a;
            all_bad[i].pb(a);
            mx = max(mx, a);
        }
        for_sort.pb({ mx,i });
        get_mx[i] = mx;
    }
    sort(for_sort.begin(), for_sort.end());
    for (int i = 0; i < n; i++) {
        for (auto c : all_bad[for_sort[i].second]) {
            all[i].pb(c);
            add[i].pb(0);
        }
        get_mx[i] = for_sort[i].first;
    }
    for (int i = 0; i < n; i++) {
        vector<int> next(add[i].size(),-1), cnt = next;
        vector<int> a = all[i];
        vector<int> st;
        for (int j = 0; j < add[i].size(); j++) {
            while (st.size() > 0 && a[st[st.size() - 1]] < a[j]) {
                next[st[st.size() - 1]] = j;
                st.pop_back();
            }
            st.pb(j);
        }
        for (int j = add[i].size() - 1; j >= 0; j--) {
            if (next[j] == -1) {
                cnt[j] = 0;
                continue;
            }
            cnt[j] = cnt[next[j]] + 1;
        }
        add[i] = cnt;
    }
    /*
    debug(3);
    for (auto c : add) {
        for (auto x : c) {
            cout << x << " ";
        }
        cout << endl;
    }
    */
    vector<int> dp(MAXA);
    for (int i = 0; i < n; i++) {
        for (auto c : dp) cout << c << " ";
        int mx = 0, may_st = 0;
        for (int j = 0; j < all[i].size(); j++) {
            for (int u = 0; u < all[i][j]; u++) {
                mx = max(mx, dp[u] + add[i][j] + 1);
            }
        }
        dp[get_mx[i]] = max(dp[get_mx[i]], mx);
    }
    int ans = 0;
    for (int i = 0; i < MAXA; i++) {
        ans = max(dp[i], ans);
    }
    cout << ans;
}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    srand(time(NULL));
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
