﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = int;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e9);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<vector<pair<ll, ll>>> b;
vector<vector<ll>> a;
vector<ll> mx;
ll n;


ll mmx = 0;

ll fn(const ll i, const ll x) {
	auto buf = upper_bound(b[i].begin(), b[i].end(), make_pair(x + 1, -1));
	return b[i].end() - buf;
}


void solve(istream& cin, ostream& cout) {
	// n = 5;
	cin >> n;
	a.resize(n);
	b.resize(n);
	mx.resize(n);


	for (auto& t : a) {
		ll k;
		cin >> k;
		t.resize(k);
		for (auto& u : t) {
			// u = rnd() % 10 + 1;
			cin >> u;
			mmx = max(mmx, u);
		}
	}


	if (mmx == 1) {
		cout << "1\n";
		return;
	}

	for (ll i = 0; i < n; ++i) {
		b[i].emplace_back(a[i][0], 0);
		for (ll j = 1; j < a[i].size(); ++j) {
			if (a[i][j] > b[i].back().first)
				b[i].emplace_back(a[i][j], j);
		}
		mx[i] = b[i].back().first;
	}


	if (mmx == 2) {
		bool is_one = false;
		bool is_two = false;
		for (auto& t : b) {
			for (ll i = 0; i < t.size(); ++i) {
				if (t[i].first == 1)
					is_one = true;
				if (t[i].first == 2)
					is_two = true;
			}
		}
		if (is_one && is_two)
			cout << "2\n";
		else
			cout << "1\n";
		return;
	}


	vector<ll> pr(n);
	for (ll i = 0; i < n; ++i)
		pr[i] = i;
	sort(pr.begin(), pr.end(), [&](ll x, ll y) {return mx[x] < mx[y]; });


	ll res = 0;
	map<ll, ll> mp;
	mp[0] = 0;
	for (auto& i : pr) {
		ll cnt = 0;
		for (auto t = mp.begin(); t != mp.end() && (n <= 1000 || cnt < 30); ++t, ++cnt) {
			auto& [x, sum] = *t;
			if (x >= mx[i])
				break;
			ll buf = fn(i, x);
			mp[max(x, mx[i])] = max(mp[max(x, mx[i])], sum + buf);
			res = max(res, sum + buf);
		}
		if (n > 1000) {
			cnt = 0;
			for (auto t = --mp.lower_bound(mx[i]); t != mp.begin() && cnt < 25; --t, ++cnt) {
				auto& [x, sum] = *t;
				if (x >= mx[i])
					break;
				ll buf = fn(i, x);
				mp[max(x, mx[i])] = max(mp[max(x, mx[i])], sum + buf);
				res = max(res, sum + buf);
			}
		}
	}


	cout << res << '\n';
}