﻿#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>

#include <algorithm>
#include <cmath>

#include <chrono>
#include <random>

#include <unordered_map>
#include <unordered_set>
#include <functional>
#include <vector>
#include <string>
#include <deque>
#include <queue>
#include <stack>
#include <array>
#include <list>
#include <set>
#include <map>

using namespace std;
using namespace chrono;


using ll = int;
using ull = unsigned long long;
using ld = long double;

constexpr ll INF = static_cast<ll>(1e9);
constexpr ld EPS = 1e-9L;


#ifndef MSC_VER
ull __lg(ull x) {
	ull res = 0;
	for (; x > 1; x /= 2)
		++res;
	return res;
}
#endif


mt19937 rnd(0);


void solve(istream& cin, ostream& cout);


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);


	ll _ = 1;
	// cin >> _;
	while (_--)
		solve(cin, cout);
}


vector<vector<ll>> b;
vector<vector<ll>> a;
ll n;


ll fn(const ll i, const ll x) {
	auto buf = upper_bound(b[i].begin(), b[i].end(), x);
	return b[i].end() - buf;
}


void solve(istream& cin, ostream& cout) {
	// n = 5;
	cin >> n;
	a.resize(n);
	b.resize(n);


	for (auto& t : a) {
		ll k;
		cin >> k;
		t.resize(k);
		for (auto& u : t) {
			cin >> u;
		}
	}

	for (ll i = 0; i < n; ++i) {
		b[i].push_back(a[i][0]);
		for (ll j = 1; j < a[i].size(); ++j) {
			if (a[i][j] > b[i].back())
				b[i].push_back(a[i][j]);
		}
	}


	vector<ll> pr(n);
	for (ll i = 0; i < n; ++i)
		pr[i] = i;
	sort(pr.begin(), pr.end(), [&](ll x, ll y) {return b[x].back() < b[y].back(); });


	ll res = 0;
	map<ll, ll> mp;
	mp[0] = 0;
	for (auto& i : pr) {
		ll cnt = 0;
		auto& xx = mp[b[i].back()];

		auto iter = b[i].begin();
		for (auto t = mp.begin(); t != mp.end() && (n <= 1000 || cnt < 30); ++t, ++cnt) {
			auto& [x, sum] = *t;
			if (x >= b[i].back())
				break;
			while (x >= *iter)
				++iter;
			ll buf = b[i].end() - iter;
			xx = max(xx, sum + buf);
			res = max(res, sum + buf);
		}
		if (n > 1000) {
			cnt = 0;
			iter = --b[i].end();
			for (auto t = --mp.lower_bound(b[i].back()); t != mp.begin() && cnt < 25; --t, ++cnt) {
				auto& [x, sum] = *t;
				if (x >= b[i].back())
					break;
				while (iter != b[i].begin() && *iter > x)
					--iter;
				if (*iter <= x)
					++iter;
				ll buf = b[i].end() - iter;
				xx = max(xx, sum + buf);
				res = max(res, sum + buf);
			}
		}
	}


	cout << res << '\n';
}