#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vld = vector<ld>;

void brute(vii& ord, vbb& used, vvi& a, int n, int& ans) {
	if (ord.size() == n) {
		vii res;
		for (auto& num : ord) {
			for (auto& elem : a[num]) {
				res.push_back(elem);
			}
		}
		int mx = 0;
		int tmp = 0;
		for (auto& elem : res) {
			tmp += elem > mx;
			mx = max(elem, mx);
		}
		ans = max(ans, tmp);
		return;
	}
	for (int i = 0; i < n; i++) {
		if (used[i]) {
			continue;
		}
		used[i] = 1;
		ord.push_back(i);
		brute(ord, used, a, n, ans);
		ord.pop_back();
		used[i] = 0;
	}
}

bool comp(pii a, pii b) {
	if (max(a.first, a.second) != max(b.first, b.second)) {
		return max(a.first, a.second) < max(b.first, b.second);
	}
	return min(a.first, a.second) < min(b.first, b.second);
}

void add(int v, int l, int r, int ind, int val, vii& tr) {
	if (r <= ind || ind < l) {
		return;
	}
	if (l + 1 == r) {
		tr[v] = val;
		return;
	}
	int mid = (l + r) / 2;
	add(2 * v + 1, l, mid, ind, val, tr);
	add(2 * v + 2, mid, r, ind, val, tr);
	tr[v] = max(tr[2 * v + 1], tr[2 * v + 2]);
}

int get_max(int v, int l, int r, int ql, int qr, vii& tr) {
	if (r <= ql || qr <= l) {
		return 0;
	}
	if (ql <= l && r <= qr) {
		return tr[v];
	}
	int mid = (l + r) / 2;
	return max(get_max(2 * v + 1, l, mid, ql, qr, tr), get_max(2 * v + 2, mid, r, ql, qr, tr));
}

void solve(){
	int n;
	cin >> n;
	vvi a(n);
	bool flag = 1, flag2 = 1, flag3 = 1;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		flag3 &= k <= 2;
		a[i].resize(k);
		for (auto& elem : a[i]) {
			cin >> elem;
			flag &= elem <= 2;
			flag2 &= elem <= 10;
		}
	}
	int ans = 0;
	for (auto& arr : a) {
		for (int i = 1; i < arr.size(); i++) {
			arr[i] = max(arr[i - 1], arr[i]);
		}
		arr.resize(unique(arr.begin(), arr.end()) - arr.begin());
	}
	vpii ord;
	for (int i = 0; i < n; i++) {
		ord.push_back({ a[i].back(), i });
	}
	sort(ord.begin(), ord.end());
	int N = 2e5 + 5;
	vii tr(6 * N);
	vii bld(N);
	for (auto& num : ord) {
		int i = num.second;
		int res = 0;
		for (int j = 0; j < a[i].size(); j++) {
			int tmp = get_max(0, 0, N, 0, a[i][j], tr);
			tmp += ((int)a[i].size() - j);
			res = max(res, tmp);
		}
		bld[a[i].back()] = max(bld[a[i].back()], res);
		add(0, 0, N, a[i].back(), bld[a[i].back()], tr);
	}
	cout << tr[0];
	return;
	if (n <= 7) {
		vbb used(n);
		vii ord;
		brute(ord, used, a, n, ans);
		cout << ans << '\n';
		return;
	} 
	if (flag) {
		for (auto& elem : a) {
			if (elem[0] == 1) {
				ans++;
				break;
			}
		}
		for (auto& arr : a) {
			bool f = 0;
			for (auto& elem : arr) {
				f |= (elem == 2);
			}
			if (f) {
				ans++;
				break;
			}
		}
		cout << ans;
		return;
	}
	if (flag2) {
		vii mx(n);
		for (int i = 0; i < n; i++) {
			int mx1 = 0;
			for (auto& elem : a[i]) {
				mx1 = max(mx1, elem);
			}
			mx[i] = mx1;
		}	
		vvi res(n, vii(11));
		for (int i = 0; i < n; i++) {
			for (int j = 0; j <= 10; j++) {
				int mx1 = j;
				for (auto& elem : a[i]) {
					res[i][j] += elem > mx1;
					mx1 = max(elem, mx1);
				}
			}
		}
		vii dp(11);
		for (int j = 0; j <= 10; j++) {
			for (int i = 0; i < n; i++) {
				dp[mx[i]] = max(dp[mx[i]], dp[j] + res[i][j]);
			}
		}
		for (auto& elem : dp) {
			ans = max(ans, elem);
		}
		cout << ans << '\n';
		return;
	}
	if (flag3) {
		vpii p;
		for (auto& arr : a) {
			if (arr.size() == 1) {
				p.push_back({ arr[0], arr[0] });
			}
			else {
				if (arr[0] > arr[1]) {
					arr[1] = arr[0];
				}
				p.push_back({ arr[0], arr[1] });
			}
		}
		sort(p.begin(), p.end(), comp);
		int N = 2e5 + 5;
		vii tr(6 * N);
		vii bld(N);
		for (auto& elem : p) {
			int res = bld[elem.second];
			if (elem.first < elem.second) {
				int tmp = get_max(0, 0, N, 0, elem.first, tr);
				res = max(res, tmp + 2);
			}
			res = max(res, get_max(0, 0, N, 0, elem.second, tr) + 1);
			bld[elem.second] = max(res, bld[elem.second]);
			add(0, 0, N, elem.second, bld[elem.second], tr);
		}
		cout << tr[0];
		return;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}