#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>

using namespace std;

bool cmp(const vector<long long>& a, const vector<long long>& b) {
	return a[a.size() - 1] < b[b.size() - 1];
}

void solve() {
	long long n, k, inp, mx = 0;;
	vector<vector<long long>> vect;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> k;
		vect.push_back({});
		for (int j = 0; j < k; ++j) {
			cin >> inp;
			mx = max(mx, inp);
			if (vect[i].size() == 0 || vect[i][vect[i].size() - 1] < inp) {
				vect[i].push_back(inp);
			}
		}
	}
	vector<long long> dp(mx + 1);
	sort(vect.begin(), vect.end(), cmp);

	// for (int i = 0; i < n; ++i) {
	// 	cout << i << ": ";
	// 	for (int j : vect[i]) {
	// 		cout << j << ' ';
	// 	}
	// 	cout << endl;
	// }

	inp = 0;
	for (int i = 1; i <= mx; ++i) {
		k = 0;
		while (inp < vect.size() && i == vect[inp][vect[inp].size() - 1]) {
			for (int j = 0; j < vect[inp].size(); ++j) {
				k = max(k, dp[vect[inp][j] - 1] + (long long) vect[inp].size() - j);
				// cout << inp << ' ' << k << ' ' << vect[inp][j] << endl;
			}
			++inp;
		}
		dp[i] = max(dp[i - 1], k);
	}

	// for (int i = 0; i < dp.size(); ++i) {
	// 	cout << i << ": " << dp[i] << endl;
	// }

	cout << dp[mx] << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();

	return 0;
}