#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <string>
#include <vector>

#define sz(a) int((int)a.size())

using namespace std;

struct VEC {
    vector<int> a;
    int a_mx;
};

bool comp(VEC& a, VEC& b) {
    return a.a_mx < b.a_mx;
}

void solve() {
    int n;
    cin >> n;
    vector<VEC> vv(n);
    for (int i = 0; i < n; ++i) {
        int l;
        cin >> l;
        vv[i].a.resize(l);
        int mx = 0;
        for (int &el: vv[i].a) {
            cin >> el;
            mx = max(mx, el);
        }
        vv[i].a_mx = mx;
    }
    sort(vv.begin(), vv.end(), comp);
    int mx = 0, cnt = 0;
    for (int i = 0; i < n; ++i) {
        for (int el: vv[i].a) {
//            cout << el << ' ';
            if (el > mx) {
                mx = el;
                cnt++;
            }
        }
    }
//    cout << '\n';
    cout << cnt;
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}
