#include <bits/stdc++.h>

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<std::vector<int>> input(n);
    for (auto& vec : input) {
        int k;
        std::cin >> k;
        vec.resize(k);

        for (int& i : vec) {
            std::cin >> i;
        }

        for (int i = 1; i < k; i++) {
            vec[i] = std::max(vec[i], vec[i - 1]);
        }
        vec.erase(std::unique(vec.begin(), vec.end()), vec.end());
    }

    std::sort(input.begin(), input.end(), [&](const auto& a, const auto& b) { return a.back() < b.back(); });

    struct BIT {
        std::vector<int> data;
        int n;

        BIT(int n) : n(n) {
            data.assign(n, 0);
        }

        void upd(int i, int val) {
            for (; i < n; i |= i + 1) {
                data[i] = std::max(data[i], val);
            }
        }

        int get(int i) {
            int res = 0;
            for (; i >= 0; i = (i & (i + 1)) - 1) {
                res = std::max(res, data[i]);
            }
            return res;
        }
    };

    BIT bit(2e5 + 5);
    for (auto& vec : input) {
        int max = 0;
        for (int i = 0; i < vec.size(); i++) {
            max = std::max(max, ((int)vec.size() - i) + bit.get(vec[i] - 1));
        }
        bit.upd(vec.back(), max);
    }

    int ans = bit.get(bit.n - 1);
    std::cout << ans << "\n";

    return 0;
}
