#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 2e5 + 5;

int n;
ve<int> a[N];
ve<int> b[N];
ve<int> order;

int mxVal;
int dp[N];

int t[4 * N];

void upd(int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        umx(t[v], x);
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos <= tm) {
        upd(v << 1, tl, tm, pos, x);
    } else {
        upd(v << 1 | 1, tm + 1, tr, pos, x);
    }
    t[v] = max(t[v << 1], t[v << 1 | 1]);
}

void upd(int pos, int x) {
    upd(1, 0, N - 1, pos, x);
}

int get(int v, int tl, int tr, int l, int r) {
    if (l > r) {
        return -1e9;
    }
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) >> 1;
    return max(get(v << 1, tl, tm, l, min(r, tm)),
               get(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r));
}

int get(int l, int r) {
    return get(1, 0, N - 1, l, r);
}

void build(int v = 1, int tl = 0, int tr = N - 1) {
    t[v] = -1e9;
    if (tl == tr) {
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;
    fr (i, 1, n) {
        int k;
        cin >> k;
        fr (j, 1, k) {
            int x;
            cin >> x;
            a[i].pb(x);
            umx(mxVal, x);
        }
    }

    fr (i, 1, n) {
        int mx = -1e9;
        fr (j, 0, sz(a[i]) - 1) {
            if (mx < a[i][j]) {
                b[i].pb(a[i][j]);
            }
            umx(mx, a[i][j]);
        }
    }
    fr (i, 1, n) order.pb(i);

    sort(all(order), [](int i, int j) {
        return b[i].back() < b[j].back();
    });


    build();
//    fill(dp, dp + 1 + mxVal, -1e9);
//    dp[0] = 0;
    upd(0, 0);


    fe (cur, order) {


        int mx = 0;
        int last = 0;
        fr (i, 0, sz(b[cur]) - 1) {
            umx(mx, get(last, b[cur][i] - 1) + sz(b[cur]) - i);
//            fr (j, last, b[cur][i] - 1) {
//                umx(mx, dp[j] + (sz(b[cur]) - i));
//            }
            last = b[cur][i];
        }
        upd(b[cur].back(), mx);
//        umx(dp[b[cur].back()], mx);
    }
//    int best = -1e9;
//    fr (i, 0, mxVal) {
//        umx(best, dp[i]);
//    }

    cout << t[1] << "\n";

    return 0;
}
