#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k, x;
        cin >> k >> x;
        a[i].emplace_back(x);
        for (int j = 1; j < k; ++j) {
            cin >> x;
            if (x > a[i].back()) {
                a[i].emplace_back(x);
            }
        }
    }
    vector<int> order(n);
    iota(all(order), 0);
    sort(all(order), [&](int lhs, int rhs) {
        return a[lhs].back() < a[rhs].back();
    });
    vector<int> dp(n);
    for (int i = 0; i < n; ++i) {
        int cur = order[i];
        dp[i] = sz(a[cur]);
        for (int j = 0; j < i; ++j) {
            int here = order[j];
            int more = sz(a[cur]) - (int)(upper_bound(all(a[cur]), a[here].back()) - a[cur].begin());
            dp[i] = max(dp[i], dp[j] + more);
        }
    }
    cout << *max_element(all(dp)) << en;
}

void stupid() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k, x;
        cin >> k >> x;
        a[i].emplace_back(x);
        for (int j = 1; j < k; ++j) {
            cin >> x;
            if (x > a[i].back()) {
                a[i].emplace_back(x);
            }
        }
    }
    vector<int> order(n);
    iota(all(order), 0);
    int ans = 0;
    do {
        int here = 0;
        int last = -1;
        for (auto i: order) {
            for (auto j: a[i]) {
                if (j > last) {
                    last = j;
                    ++here;
                }
            }
        }
        ans = max(ans, here);
    } while (next_permutation(all(order)));
    cout << ans << en;
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 2;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
//        solve();
        stupid();
    }
    return 0;
}
