#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);
const int N = 2e5 + 3;
const int INF = 1e9;

vector<int> formx[N];

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> mxses;
    int ind = 0;
    for (auto &v : a) {
        int k;
        cin >> k;
        v.resize(k);
        int mx = 0;
        for (auto &e : v) {
            cin >> e;
            mx = max(mx, e);
        }
        formx[mx].emplace_back(ind++);
        mxses.emplace_back(mx);
    }

    auto nvp = [&](int st, vector<int>& a) {
        int n = a.size();
        int ans = 0;
        for (auto x : a) {
            if (x > st) {
                ans++;
                st = x;
            }
        }
        return ans;
    };

    sort(all(mxses));
    
    int prev = -INF;
    vector<int> cur;
    for (auto cur_mx : mxses) {
        int best = -1, cnt = -1;
        for (auto i : formx[cur_mx]) {
            int c = nvp(prev, a[i]);
            if (c > cnt) {
                best = i;
                cnt = c;
            }
        }
        for (auto x : a[best])
            cur.emplace_back(x);
        prev = cur_mx;
    }
    cout << nvp(-INF, cur);
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}