﻿// D.cpp : This file contains the 'main' function. Program execution begins and ends there.
//

#include <bits/stdc++.h>

using namespace std;
using ll = long long;

using music = bitset<10>;

music album()
{
    ll n;
    cin >> n;
    ll mx = 0;
    music m;
    for (size_t i = 0; i < n; i++)
    {
        int note;
        cin >> note;
        if (note > mx)
        {
            mx = note;
            m[note - 1] = 1;
        }
    }
    return m;
}

bool comp(music submask, music mask)
{
    submask &= mask;
    bool st = 0;
    int cnt = 0, mcnt = submask.count();
    mask ^= submask;
    for (size_t i = 0; i < mask.size(); i++)
    {
        if (st && mask[i] && cnt < mcnt)
            return false;
        if (mask[i])
            st = true, cnt++;
    }
    return true;
}

int main()
{
    ll n;
    cin >> n;
    //if (n <= 7)
    //{
    //    // return -1;
    //}
    ll sumk = 0, maxk = 0, maxa = 0; // statisticks
    vector<vector<ll>> sound(n);
    for (size_t i = 0; i < n; i++)
    {
        ll k;
        cin >> k;
        ll mx = 0;
        for (size_t j = 0; j < k; j++)
        {
            ll note;
            cin >> note;
            if (note > mx)
            {
                mx = note;
                sound[i].push_back(note);
                maxa = max(maxa, note);
            }
        }
        sumk += sound[i].size();
        maxk = max<ll>(maxk, sound[i].size());
    }
    if (maxa <= 3)
    {
        vector <music> group;
        for (size_t i = 0; i < n; i++)
        {
            music m;
            for (auto& t : sound[i])
            {
                m[t - 1] = 1;
            }
            group.emplace_back(m);
        }
        size_t best = 0;
        for (size_t tmask = 0; tmask < (1ll << 3); tmask++)
        {
            music mask = tmask, ans = 0;
            for (auto& i : group)
            {
                if (comp(i, mask))
                    ans |= i;
            }
            ans &= mask;
            best = max(best, ans.count());
        }
        cout << best << '\n';
        return 0;
    }
    //if (maxk <= 2)
    //{
    //    sort(sound.begin(), sound.end());
    //    // resort
    //    for (int i = n - 1; i >= 0; i--)
    //    {
    //        if (sound[i].size() == 1)
    //            continue;
    //        for (size_t j = i + 1; j < n; j++)
    //        {
    //            if (sound[j - 1].back() > sound[j].back())
    //                swap(sound[j - 1], sound[j]);
    //            else
    //                break;
    //        }
    //    }
    //    ll mx = 0;
    //    ll ans = 0;
    //    for (auto& i : sound)
    //    {
    //        for (auto& j : i)
    //        {
    //            if (j > mx)
    //            {
    //                mx = j;
    //                ans++;
    //            }
    //        }
    //    }
    //    cout << ans << '\n';
    //    return 0;
    //}
    sort(sound.begin(), sound.end());
    if (n <= 10)
    {
        ll best = 0;
        do
        {
            ll mx = 0;
            ll ans = 0;
            for (auto& i : sound)
            {
                for (auto& j : i)
                {
                    if (j > mx)
                    {
                        mx = j;
                        ans++;
                    }
                }
            }
            best = max(ans, best);
        } while (next_permutation(sound.begin(), sound.end()));
        cout << best << '\n';
        return 0;
    }
    if (maxk <= 2)
    {
        sort(sound.begin(), sound.end());
        // resort
        for (int i = n - 1; i >= 0; i--)
        {
            if (sound[i].size() == 1)
                continue;
            for (size_t j = i + 1; j < n; j++)
            {
                if (sound[j - 1].back() > sound[j][0])
                    swap(sound[j - 1], sound[j]);
                else
                    break;
            }
        }
        ll mx = 0;
        ll ans = 0;
        for (auto& i : sound)
        {
            for (auto& j : i)
            {
                if (j > mx)
                {
                    mx = j;
                    ans++;
                }
            }
        }
        cout << ans << '\n';
        return 0;
    }
}

// Run program: Ctrl + F5 or Debug > Start Without Debugging menu
// Debug program: F5 or Debug > Start Debugging menu

// Tips for Getting Started: 
//   1. Use the Solution Explorer window to add/manage files
//   2. Use the Team Explorer window to connect to source control
//   3. Use the Output window to see build output and other messages
//   4. Use the Error List window to view errors
//   5. Go to Project > Add New Item to create new code files, or Project > Add Existing Item to add existing code files to the project
//   6. In the future, to open this project again, go to File > Open > Project and select the .sln file
