#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <queue>
#include <string>
#include <climits>
#include <math.h>

using namespace std;

#define ll long long
#define pii pair<int, int>
#define pll pair<ll, ll>
#define mod 1000000007



int main()
{
	int siz;
	cin >> siz;
	vector<vector<ll>> arr(siz);
	vector<pll> mam(siz, {0, 0});
	for (ll i = 0; i < siz; i++)
	{
		ll len; cin >> len;
		for (int j = 0; j < len; j++)
		{
			ll tmp; cin >> tmp;
			arr[i].push_back(tmp);
			mam[i].first = max(mam[i].first, tmp);
		}
		mam[i].second = i;
	}
	sort(mam.begin(), mam.end());

	ll out = 0, step = 0;
	ll now_out = 0;
	for (ll i = 0; i < siz; i++)
	{
		ll now = mam[i].second;
		ll tmp_step = step;
		ll tmp_out = 0;
		if (i < siz && mam[i].first == mam[max(i - 1, (ll)0)].first) {
			for (ll j = 0; j < arr[now].size(); j++)
			{
				if (arr[now][j] > tmp_step) {
					tmp_step = arr[now][j];
					tmp_out++;
				}
			}
			now_out = max(tmp_out, now_out);
		}
		else {
			out += now_out;
			now_out = 0;
			step = mam[i - 1].first;
			tmp_step = step;
			for (ll j = 0; j < arr[now].size(); j++)
			{
				if (arr[now][j] > tmp_step) {
					tmp_step = arr[now][j];
					tmp_out++;
				}
			}
			now_out = max(tmp_out, now_out);
		}
	}
	cout << out + now_out << endl;
	
}







