#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 1e5 + 1, mod = 1e9 + 7, INF = 1e18;

ll getnvp(ll n, vector<ll>& a) {
    vector<ll> dp(n + 1, INF);
    dp[0] = -INF;
    for(ll i = 1; i <= n; i++){
        ll l = 0, r = i;
        while(r - l > 1){
            ll mid = (l + r) / 2;
            if(dp[mid] < a[i - 1]){
                l = mid;
            } else {
                r = mid;
            }
        }
        if(dp[l] < a[i - 1] && dp[l + 1] > a[i - 1]){
            dp[l + 1] = a[i - 1];
        }
    }
    for(ll i = n; i >= 1; i--){
        if(dp[i] != INF){
            return i;
        }
    }
}

struct str {
    ll mx, nv, id;
};

bool cmp(const str& a, const str& b){
    if(a.mx == b.mx){
        return a.nv > b.nv;
    }
    return a.mx < b.mx;
}

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    vector<str> b(n);
    for(ll i = 0; i < n; i++){
        ll cnt, mx = 0;
        cin >> cnt;
        for(ll j = 0; j < cnt; j++){
            ll k;
            cin >> k;
            mx = max(mx, k);
            a[i].push_back(k);
        }
        b[i].mx = mx, b[i].nv = getnvp(cnt, a[i]), b[i].id = i;
    }
    sort(b.begin(), b.end(), cmp);
    vector<ll> c;
    for(ll i = 0; i < n; i++){
        ll ind = b[i].id;
        for(ll j = 0; j < (ll)a[ind].size(); j++){
            c.push_back(a[ind][j]);
        }
    }
    ll ans = getnvp((ll)c.size(), c);
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
