#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5 + 1, mod = 1e9 + 7, INF = 1e18;

bool cmp(const pair<ll, vector<ll>>& a, const pair<ll, vector<ll>>& b){
    return a.first < b.first;
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, vector<ll>>> a(n);
    for(ll i = 0; i < n; i++){
        ll cnt, mx = 0;
        cin >> cnt;
        for(ll j = 0; j < cnt; j++){
            ll k;
            cin >> k;
            mx = max(mx, k);
            a[i].second.push_back(k);
        }
        a[i].first = mx;
    }
    sort(a.begin(), a.end(), cmp);
    vector<vector<ll>> pos(n);
    for(ll i = 0; i < n; i++){
        ll mx = 0;
        for(ll j = 0; j < (ll)a[i].second.size(); j++){
            if(mx < a[i].second[j]){
                mx = a[i].second[j];
                pos[i].push_back(j);
            }
        }
    }
    vector<ll> dp(N);
    for(ll i = 0; i < n; i++){
        for(ll j = 0; j < pos[i].size(); j++){
            ll ps = pos[i][j], mx = 0;
            for(ll g = 0; g < a[i].second[ps]; g++){
                mx = max(mx, dp[g]);
            }
            dp[a[i].first] = max(dp[a[i].first], mx + (ll)pos[i].size() - j);
        }
    }
    ll ans = 0;
    for(ll i = 0; i < N; i++){
        ans = max(ans, dp[i]);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    while(t--){
        solve();
    }
}
