#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(),x.end()
#define vi vector <int>
#define fi(n) for (int i = 0; i < n; ++i)
#define f first
#define s second

using namespace std;

// geom
/*struct point {double x, y;};
point operator+ (point a, point b) {return {a.x + b.x, a.y + b.y};}
point operator- (point a, point b) {return {a.x - b.x, a.y - b.y};}
point operator* (point a, double k) {return {a.x * k, a.y * k};}
point operator/ (point a, double k) {return a * (1 / k);}
double dot (point a, point b) {return a.x * b.x + a.y * b.y;}
double cross (point a, point b) {return a.x * b.y - a.y * b.x;}
double angle (point a, point b) {return atan2(cross(a, b), dot(a, b));}
double area(vector <point> p) {
    int n = (int)p.size();
    double ans = 0;
    for (int i = 1; i < n; ++i) {
        ans += cross(p[1] - p[0], p[i] - p[0]);
    }
    return fabs(ans) / 2;
}*/

// segtree
/*const int maxn = 2e5;
vector <int> a(maxn), t(4 * maxn);
int func(int r1, int r2) {
    return r1 + r2;
}
void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v] = a[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t[v] = func(t[2 * v + 1], t[2 * v + 2]);
}
void update(int v, int l, int r, int i, int d) {
    if (i >= r || i < l) {
        return;
    }
    int m = (l + r) / 2;
    update(2 * v + 1, l, m, i, d);
    update(2 * v + 2, m, r, i, d);
    t[v] = func(t[2 * v + 1], t[2 * v + 2]);
}
int get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return func(t[2 * v + 1], t[2 * v + 2]);
}*/

// dfs
/*const int maxn = 2e5;
const int logn = __lg(maxn);
vector <int> path;
vector <int> used(maxn, 0);
vector <vector <int> > g(maxn);
void dfs(int u, int p = -1) {
    used[u] = 1;
    path.push_back(u);
    for (int v: g[u]) {
        if (!used[v]) {
            dfs(v, u);
        }
    }
    path.push_back(u);
}*/

//sparse table
/*const int maxn = 2e5;
const int logn = 18;
vector <int> a(maxn);
vector <vector <int> > up(logn, vector <int>(n, 0));

void build() {
    int n; cin >> n;
    for (int i = 0; i < n; ++i) {
        up[0][i] = a[i];
    }
    for (int pw = 1; pw < logn; pw++) {
        for (int i = 0; i < n; ++i) {
            up[pw][i] = min(up[pw - 1][i], up[pw - 1][i + (1<<(pw - 1))]);
        }
    }
}*/

bool cmp(pair <pair <int, int>, vector <int> > &a, pair <pair <int, int>, vector <int> > &b) {
    if (a.f.s == b.f.s) {
        if (a.f.f == b.f.f) return a.s.size() < b.s.size();
        return a.f.f < b.f.f;
    }
    return a.f.s < b.f.s;
}

void solve() {
    int n; cin >> n;
    vector <pair <pair <int, int>, vector <int> > > m;
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        vector <int> a(k);
        int mn = 1e9, mx = -1;
        for (int j = 0; j < k; ++j) {
            cin >> a[j];
            mn = min(mn, a[j]);
            mx = max(mx, a[j]);
        }
        m.push_back({{mn, mx}, a});
    }
    sort(m.begin(), m.end(), cmp);
    int mxx = -1, cnt = 0;
    for (auto x: m) {
        for (auto y: x.s) {
            if (y > mxx) {
                mxx = y;
                cnt++;
            }
        }
    }
    cout << cnt;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    // cin >> tests;
    tests = 1;
    while (tests--) {
        solve();
    }
    return 0;
}
