#include <bits/stdc++.h>

#define all(x) x.begin(),x.end()
#define vi vector <int>
#define fi(n) for (int i = 0; i < n; ++i)
#define f first
#define s second

using namespace std;

bool cmp(pair <pair <int, int>, vector <int> > &a, pair <pair <int, int>, vector <int> > &b) {
    return a.f < b.f;
}

int nvp(vector <int> a) {
    int ans = 1, mx = a[0];
    for (int i = 1; i < (int)a.size(); ++i) {
        if (a[i] > mx) {
            mx = a[i];
            ans++;
        }
    }
    return ans;
}

void ssolve(int n) {
    vector <vi> c(n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        vector <int> a(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[j];
        }
        c[i] = a;
    }
    vector <int> p;
    for (int i = 0; i < n; ++i) p.push_back(i);
    int ans = 0;
    do {
        vector <int> b;
        int mx = 0;
        for (auto x: p) {
            for (auto y: c[x]) {
                b.push_back(y);
                mx = max(mx, y);
            }
        }
        int pre = nvp(b);
        if (pre > ans) {
            ans = pre;
            // for (auto x: b) cout << x << " "; cout << '\n';
        }
    } while(next_permutation(p.begin(), p.end()));
    cout << ans << '\n';
}

bool comp(vector <int> &a, vector <int> &b) {
    vector <int> c1, c2;
    for (auto x: a) c1.push_back(x);
    for (auto x: b) c1.push_back(x);
    for (auto x: b) c2.push_back(x);
    for (auto x: a) c2.push_back(x);
    return nvp(c1) > nvp(c2);
}

void solve() {
    int n; cin >> n;
    if (n <= 10) {
        ssolve(n);
        return;
    }
    vector <vector <int> > m(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        vector<int> a(k);
        int mn = 1e9, mx = -1;
        for (int j = 0; j < k; ++j) {
            cin >> a[j];
            mn = min(mn, a[j]);
            mx = max(mx, a[j]);
        }
        m[i] = a;
    }
    sort(m.begin(), m.end(), comp);
    int mxx = 0, cnt = 0;
    for (const auto& x: m) {
        for (auto y: x) {
            if (y > mxx) {
                mxx = y;
                cnt++;
            }
        }
    }
    cout << cnt;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    // cin >> tests;
    tests = 1;
    while (tests--) {
        solve();
    }
    return 0;
}