#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<int> t(8e5 + 4);

void update(int v, int l, int r, int ql, int qr, int val) {
    if (l >= qr || r <= ql) {
        return;
    }
    if (l >= ql && r <= qr) {
        t[v] = max(t[v], val);
        return;
    }
    int m = (l  + r) / 2;
    update(2 * v + 1, l, m, ql, qr, val);
    update(2 * v + 2, m, r, ql, qr, val);
    t[v] = max(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return -1;
    }
    if (l >= ql && r <= qr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return max(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

int main() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> tmp;
    for (int i = 0, k; i < n; ++i) {
        cin >> k;
        tmp.resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> tmp[j];
        }
        int mx = tmp[0];
        a[i].push_back(tmp[0]);
        for (int j = 1; j < k; ++j) {
            if (tmp[j] > mx) {
                mx = tmp[j];
                a[i].push_back(mx);
            }
        }
    }
    sort(a.begin(), a.end());
    a.resize(unique(a.begin(), a.end()) - a.begin());
    sort(a.begin(), a.end(), [](vector<int> &a, vector<int> &b) { return a.back() < b.back(); });
    vector<int> dp(2e5 + 1);
    n = a.size();
    for (int i = a[0].back(), j = 0; i <= a.back().back(); ++i) {
        for (; j <  n && a[j].back() == i; ++j) {
            update(0, 0, 2e5 + 1, i, i + 1, int(a[j].size()));
            for (int k = 0; k < a[j].size(); ++k) {
                update(0, 0, 2e5 + 1, i, i + 1, get(0, 0, 2e5 + 1, 0, a[j][k]) + int(a[j].size()) - k);
            }
        }
    }
    cout << get(0, 0, 2e5 + 1, 0, 2e5 + 1);
    return 0;
}
