#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <set>

using namespace std;

struct Album {
	vector<int> a, good_els;
	int MaxEl;
	int get(int x) {
		int ind = upper_bound(good_els.begin(), good_els.end(), x) - good_els.begin();
		return good_els.size() - ind;
	}
};

bool cmp(Album a, Album b) {
	return a.MaxEl < b.MaxEl;
}

int n, k;

vector<Album> vc, answ;

set<pair<int, int> > s;

int main()
{
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	std::ios::sync_with_stdio(false);
	cin.tie(0);
#endif
	cin >> n;
	for (int I = 0; I < n; I++) {
		Album a;
		int k;
		cin >> k;
		int MX = 0;
		for (int i = 0; i < k; i++) {
			int v;
			cin >> v;
			a.a.push_back(v);
			if (v > MX) {
				MX = v;
				a.good_els.push_back(v);
			}
		}
		a.MaxEl = MX;
		vc.push_back(a);
	}
	sort(vc.begin(), vc.end(), cmp);
	s.insert({ 0,0 });
	for (auto u : vc) {
		int ANSW = 0;
		for (int i = 0; i < u.good_els.size(); i++) {
			auto it = s.upper_bound({ u.good_els[i] - 1, 0 });
			it--;
			ANSW = max(ANSW, int(u.good_els.size() - i + it->second));
		}
		while (true) {
			auto it = s.lower_bound({ u.MaxEl, 0 });
			if (it == s.end() || it->second >= ANSW) {
				break;
			}
			s.erase(it);
		}
		s.insert({ u.MaxEl, ANSW });
	}
	auto it = s.end();
	it--;
	cout << it->second;
}
