#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;

#define int long long
#define sz(a) (int)a.size()
#define all(a)a.begin(),a.end()
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
const int inf = 1e18;
const int mod = 1e9 + 7;
const int R = 1 << 18;

vector<int> sg(2 * R);

int get(int x, int xl, int xr, int ql, int qr) {
    if (xr <= ql || qr <= xl)
        return 0;
    if (ql <= xl && xr <= qr)
        return sg[x];
    int mid = (xl + xr) >> 1;
    return max(get(x * 2, xl, mid, ql, qr), get(x * 2 + 1, mid, xr, ql, qr));
}

void upd(int x, int d) {
    x += R;
    sg[x] = d;
    x >>= 1;
    while (x > 0) {
        sg[x] = max(sg[x * 2], sg[x * 2 + 1]);
        x >>= 1;
    }
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int last = 0;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (x > last) {
                a[i].push_back(x);
                last = x;
            }
        }
    }
    vector<int> p(n);
    iota(all(p), 0);
    sort(all(p), [&](int i, int j) {
        return a[i].back() < a[j].back();
    });

    for (int i = 0; i < n; ++i) {
        int v = p[i];
        int dp = sz(a[v]);
        for (int j = 0; j < sz(a[v]); ++j)
            dp = max(dp, sz(a[v]) - j + get(1, 0, R, 0, a[v][j]));
        upd(a[v].back(), dp);
    }
    cout << sg[1] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}
