#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>

using namespace std;
using ll = long long;
using ld = long double;

const int maxa = 1001;

int g[maxa][maxa];
vector<int> mx;

int inf = 1e9;

void dfs(int v){
    mx[v] = 0;
    for (int i = 0; i < maxa; ++i){
        if (g[i][v] != -inf) {
            if (mx[i] == -inf) {
                dfs(i);
            }
            mx[v] = max(mx[v], mx[i] + g[i][v]);
        }
    }
}

//struct DO{
//    int n;
//    vector<int> mod;
//
//    DO(int n_){
//        n = n_;
//        mod.assign(4 * n, -inf);
//    }
//
//    void push(int v, int l, int r){
//        if (r - l > 1 && mod[v] != -inf){
//            mod[2 * v + 1] = mod[v];
//            mod[2 * v + 2] = mod[v];
//        }
//        mod[v] = -inf;
//    }
//
//    void update(int v, int l, int r, int ql, int qr, int x){
//        push(v, l, r);
//        if (ql <= l && r <= qr){
//            mod[v] = max(mod[v], x);
//            return;
//        }
//        if (ql >= r || l >= qr){
//            return;
//        }
//        int m = (l + r) / 2;
//        update(2 * v + 1, l, m, ql, qr, x);
//        update(2 * v + 2, m, r, ql, qr, x);
//    }
//
//    vector<int> ans;
//
//    void build(int v, int l, int r, int x = -inf){
//        x = max(x, mod[v]);
//        if (r - l == 1){
//            ans[l] = x;
//            return;
//        }
//        int m = (l + r) / 2;
//        build(2 * v + 1, l, m, x);
//        build(2 * v + 2, m, r, x);
//    }
//};
//
//
//void Update(int i, int l, int r, int x){
//
//}

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        v[i].reserve(k);
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (v[i].empty() || v[i].back() < x){
                v[i].push_back(x);
            }
        }
    }
    if (n <= 7){
        vector<int> order(n);
        iota(order.begin(), order.end(), 0);
        int mx = 0;
        do{
//            for (auto el : order){
//                cout << el << ' ';
//            }
//            cout << endl;
            int nmx = -1;
            int sum = 0;
            for (int i : order) {
                sum += v[i].size() - (upper_bound(v[i].begin(), v[i].end(), nmx) - v[i].begin());
                nmx = max(nmx, v[i].back());
            }
//            cout << sum << endl;
            mx = max(mx, sum);
        } while(next_permutation(order.begin(), order.end()));
        cout << mx << endl;
        return 0;
    }
    vector<pair<int, pair<int, int>>> vv;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < v[i].size(); ++j) {
            vv.push_back({v[i][j], {i, j}});
        }
    }
    sort(vv.begin(), vv.end());
    int maxa = 2e5 + 1;
    vector<int> dp(maxa, 0);
    int i = 0;
    for (int j = 0; j < vv.size(); ++j){
        while (i < vv[j].first){
            if (i > 0){
                dp[i] = max(dp[i], dp[i - 1]);
            }
            ++i;
        }
        int x = vv[j].second.first;
        int y = vv[j].second.second;
        dp[v[x].back()] = max(dp[v[x].back()], dp[i - 1] + (int)v[x].size() - y);
    }
    cout << dp[i - 1] << endl;
//    for (int i = 0; i < maxa; ++i) {
//        fill(g[i], g[i] + maxa, -inf);
//    }
//    g.assign(maxa, vector<int>(maxa, -inf));
//    mx.assign(maxa, -inf);
//
//    for (int i = 0; i < n; ++i) {
//        int sz = v[i].size();
//        for (int j = 0; j < sz; ++j) {
//            Update(v[i].back(), (j > 0 ? v[i][j - 1] : 0), v[i][j], sz - j);
//            for (int k = (j > 0 ? v[i][j - 1] : 0); k < v[i][j]; ++k) {
//                g[v[i].back()][k] = max(g[v[i].back()][k], sz - j);
//            }
//        }
//    }

//    for (int i = 0; i < maxa; ++i) {
//        for (int j = 0; j < maxa; ++j) {
//            cout << g[i][j] << ' ';
//        }
//        cout << endl;
//    }

//    dfs(0);
//    cout << mx[0] << endl;

#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}