#define _CRT_SECURE_NO_WARNINGS
#include <algorithm>
#include <iostream>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <random>
#include <numeric>
#include <unordered_set>
using namespace std;

mt19937 rnd(1000 - 7);

using ll = long long;
using ld = long double;

const ll INF = 1e9;
const ll LLINF = 1e18;
const ld PI = 2 * atan2(1, 0);
const ld EPS = 1e-8;

//struct Point {
//	ll x, y;
//	
//	Point() : x(0), y(0) {}
//	Point(ll _x, ll _y) : x(_x), y(_y) {}
//
//	Point operator+(const Point& other) const {
//		return Point(x + other.x, y + other.y);
//	}
//
//	Point operator-(const Point& other) const {
//		return Point(x - other.x, y - other.y);
//	}
//
//	Point operator^(const Point& other) const {
//		return other - *this;
//	}
//
//	ll operator*(const Point& other) const {
//		return x * other.x + y * other.y;
//	}
//
//	ll operator%(const Point& other) const {
//		return x * other.y - y * other.x;
//	}
//};

struct Album {
	int a, b, c;
};

bool cmp(const Album& a, const Album& b) {
	return a.b < b.b;
}

void solve() {
	int n;
	cin >> n;
	vector<Album> a;
	for (int i = 0; i < n; ++i) {
		int k;
		cin >> k;
		vector<int> cur(k);
		for (int j = 0; j < k; ++j)
			cin >> cur[j];
		vector<int> maximums;
		maximums.push_back(cur[0]);
		for (int j = 1; j < k; ++j) {
			if (cur[j] > maximums.back()) {
				maximums.push_back(cur[j]);
			}
		}
		for (int j = 0; j < maximums.size(); ++j) {
			a.push_back({ maximums[j], maximums.back(), (int)maximums.size() - j });
		}
	}

	sort(a.begin(), a.end(), cmp);
	vector<int> dp(2e5 + 1, 0);
	int i = 0;
	for (int t = 0; t < dp.size(); ++t) {
		if (t > 0)
			dp[t] = max(dp[t], dp[t - 1]);
		while (i < a.size() && a[i].b == t) {
			dp[t] = max(dp[t], dp[a[i].a - 1] + a[i].c);
			i++;
		}
	}
	cout << dp.back() << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);

	// freopen("input.txt", "r", stdin);
	// freopen("output.txt", "w", stdout);

	solve();
}
