#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()

typedef long long ll;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<vector<pair<int, int>>> pref(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) cin >> a[i][j];

        pref[i].resize(k);
        pref[i][0] = {a[i][0], 0};
        for (int j = 1; j < k; j++) {
            pref[i][j] = pref[i][j - 1];
            if (a[i][j] > pref[i][j].first) {
                pref[i][j] = {a[i][j], j};
            }
        }
        vector<int> nw;
        int cur = k - 1;
        while (cur != -1) {
            nw.push_back(pref[i][cur].first);
            cur = pref[i][cur].second - 1;
        }
        reverse(all(nw));
        a[i] = nw;
    }

    const int MAXN = 2e5;
    vector<vector<int>> ind(MAXN + 1);
    for (int i = 0; i < n; i++) ind[a[i].back()].push_back(i);
    vector<int> dp(MAXN + 1, 0);
    for (int i = 1; i <= MAXN; i++) {
        dp[i] = dp[i - 1];
        for (auto id : ind[i]) {
            int sz = a[id].size();
            for (int k = 0; k < sz; k++) {
                dp[i] = max(dp[i], dp[a[id][k] - 1] + sz - k);
            }
        }
    }

    cout << dp[MAXN];

    return 0;
}