#include <iostream>
#include<iomanip>
#include <numeric>
#include<cmath>
#include<vector>
#include<map>
#include <queue>
#include<initializer_list>
typedef long long ll;
using namespace std;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;

const ll MAXN = 200010;
int t[4*MAXN];
//3-4; v = 5; 5-7 v = 6 
//0 2 = 4; 3 4 = 5;

int dp[MAXN];

void update(int v, int tl, int tr, int l, int r) {
	if (l > r)return;
	if (tl == l && tr == r) {
		t[v]++; return;
	}
	int mid = (tl + tr) / 2;
	update(2 * v, tl, mid, l, min(mid, r));
	update(2 * v+1, mid + 1, tr, max(mid + 1, l), r);
}

int get(int v, int tl, int tr, int pos) {
	if (tl == pos && tr == pos)return t[v];
	int mid = (tl + tr) / 2;
	int ret=t[v];
	if (pos <= mid)ret += get(2 * v, tl, mid, pos);
	else ret += get(2 * v+1, mid + 1, tr, pos);
	return ret;
}



void solve2() {
	int t; cin >> t;
	vector<vector<int>> gipermass;
	while (t--) {
		int n; cin >> n;
		vector<int> mass(n); 
		for (auto& x : mass)cin >> x;
		//for (int i = 0; i < n; i++)mass[i] = rand() % 20;
		//for (int i = 0; i < n; i++)cout << mass[i] << " ";
		//cout << "\n";
		int mm = 0;
		for (int i = 0; i < mass.size(); i++) {
			mm = max(mass[i], mm);
		}
		mass.push_back(mm);
		gipermass.push_back(mass);
	}
	int iter_gip = 0;
	sort(gipermass.begin(), gipermass.end(), [](vector<int>& a, vector<int>& b) {return a[a.size() - 1] < b[b.size() - 1]; });
	for (int i = 0; i < MAXN; i++) {
		if (iter_gip == gipermass.size())break;
		if (gipermass[iter_gip][gipermass[iter_gip].size() - 1] == i) {
			int was_max = 0;
			for (int j = 0; j < gipermass[iter_gip].size() - 1; j++) {
				if (gipermass[iter_gip][j] <= was_max)continue;
				int max_prev = 0;
				int start_point = 0;
				if (iter_gip > 0)start_point = gipermass[iter_gip-1][gipermass[iter_gip - 1].size()-1];
				for (int i = start_point; i < gipermass[iter_gip][j]; i++)max_prev = max(max_prev, dp[i]);
				dp[gipermass[iter_gip][j]] = max(dp[gipermass[iter_gip][j]], max_prev + 1);
				if(j>0)dp[gipermass[iter_gip][j]] = max(dp[gipermass[iter_gip][j]], dp[gipermass[iter_gip][j-1]]+1);
				was_max = max(was_max, gipermass[iter_gip][j]);
			}
			i--;
			iter_gip++;
		}
	}int ans = 0;
	for (int i = 0; i < MAXN; i++)ans = max(ans, dp[i]);
	cout << ans;
	//==================================================
	/*
	fill(dp, dp + MAXN, 0);
	 iter_gip = 0;
	sort(gipermass.begin(), gipermass.end(), [](vector<int>& a, vector<int>& b) {return a[a.size() - 1] < b[b.size() - 1]; });
	for (int i = 0; i < MAXN; i++) {
		if (iter_gip == gipermass.size())break;
		if (gipermass[iter_gip][gipermass[iter_gip].size() - 1] == i) {
			int was_max = 0;
			for (int j = 0; j < gipermass[iter_gip].size() - 1; j++) {
				if (gipermass[iter_gip][j] <= was_max)continue;
				int max_prev = 0;
				for (int i = 0; i < gipermass[iter_gip][j]; i++)max_prev = max(max_prev, dp[i]);
				dp[gipermass[iter_gip][j]] = max(dp[gipermass[iter_gip][j]], max_prev + 1);
				was_max = max(was_max, gipermass[iter_gip][j]);
			}
			i--;
			iter_gip++;
		}
	} ans = 0;
	for (int i = 0; i < MAXN; i++)ans = max(ans, dp[i]);
	cout << ans;

	*/
}


int main(){
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); solve2();
}
