#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef __int128 lll;
typedef long double ld;
ll inf = 1e15, mod = 1e9 + 7;
ld eps = 1e-9;
#define all(a) a.begin(), a.end()

ll binpow(ll n, ll k) {
    if (!k)
        return 1;
    if (k % 2)
        return (binpow(n, k - 1) * n) % mod;
    ll a = binpow(n, k / 2);
    return (a * a) % mod;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    vector<pair<vector<ll>, ll>> b(n);
    for (ll i = 0; i < n; i++) {
        ll k;
        cin >> k;
        a[i].resize(k);
        for (ll j = 0; j < k; j++)
            cin >> a[i][j];
        b[i].second = i;
        b[i].first = a[i];
        sort(all(b[i].first), greater<>());
    }
    if (n <= 7) {
        vector<ll> p(n);
        for (ll i = 0; i < n; i++)
            p[i] = i;
        ll an = 0;
        do {
            ll kl = 0, mx = 0;
            for (auto it: p)
                for (auto i: a[it])
                    if (i > mx) {
                        kl++;
                        mx = i;
                    }
            an = max(an, kl);
        } while (next_permutation(all(p)));
        cout << an;
        return 0;
    }
    sort(all(b));
    ll ans = 0, mx = 0;
    for (auto it: b)
        for (auto i: a[it.second])
            if (i > mx) {
                ans++;
                mx = i;
            }
    cout << ans;
}