#include<bits/stdc++.h>
#define dbg(x) cout << #x << "=" << x << "\n";
using namespace std;

#define int long long

struct tree{
    vector<int> t;
    int sz=1;

    tree(int n){
        while(sz < n){
            sz *= 2;
        }

        t.resize(2*sz, 0);
    }

    int get(int v, int vl, int vr, int l, int r){
        if(vr <= l || r <= vl){
            return 0;
        }else if(l <= vl && vr <= r){
            return t[v];
        }else{
            int m=(vl+vr)/2;

            return max(get(2*v, vl, m, l, r), get(2*v+1, m, vr, l, r));
        }
    }

    void u(int v, int vl, int vr, int l, int val){
        if(vl + 1 == vr){
            t[v] = max(t[v], val);

            return;
        }

        int m=(vl+vr)/2;

        if(l < m){
            u(2*v, vl, m, l, val);
        }else{
            u(2*v+1, m, vr, l, val);
        }

        t[v] = max(t[2*v], t[2*v+1]);
    }
};

void solve(){
        int n; cin >> n;

    vector<vector<int>> a(n,vector<int> ());

    for(int i=0; i < n; i++){
        int k; cin >> k;

        a[i].resize(k);

        vector<int> b;

        int maxi=0;


        for(int j=0; j < k; j++){
            cin >> a[i][j];

            if(a[i][j] > maxi){
                maxi = a[i][j];
                b.push_back(maxi);
            }
        }

        reverse(b.begin(), b.end());

        a[i] = b;
    }

    sort(a.begin(), a.end());

    for(auto &el: a){
        sort(el.begin(), el.end());
    }



    tree dp = tree(2e5 + 1);

    for(int i=0; i < n; i++){
        int best = 0;

        for(int j=0; j <a[i].size(); j++){
            if(j > 0 && a[i][j-1] == a[i][j]){
                continue;
            }

            int f = dp.get(1, 0, dp.sz, 0, a[i][j]);



            best = max(best, f + (int)a[i].size() - j);
        }

        //dbg(dp.get(1, 0, dp.sz, 0, 9));

        dp.u(1, 0, dp.sz, a[i].back(), best);
    }

    cout << dp.t[1];
}

int32_t main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);


    int t=1; //cin >> t;

    for(int i=0; i < t; i++){
        solve();

        cout << "\n";
    }
}
