#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cmath>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#define ll long long
#define ld long double

// login: open-2023-382
// passw: fx5mmuap

using namespace std;

const ll inf = 1e18;
const ll siz = (1ll << 18);

vector<ll> t(2 * siz - 1, 0);

ll getAns(ll x, ll tl, ll tr, ll l, ll r) {
	if (l <= tl && tr <= r) {
		return t[x];
	}
	if (r <= tl || tr <= l) {
		return 0;
	}
	ll mid = (tl + tr) / 2;
	return max(getAns(x * 2 + 1, tl, mid, l, r), getAns(x * 2 + 2, mid, tr, l, r));
}

void upd(ll x, ll tl, ll tr, ll ind, ll c) {
	if (tr - tl == 1) {
		t[x] = c;
		return;
	}
	ll mid = (tl + tr) / 2;
	if (ind < mid) {
		upd(x * 2 + 1, tl, mid, ind, c);
	} else {
		upd(x * 2 + 2, mid, tr, ind, c);
	}
	t[x] = max(t[x * 2 + 1], t[x * 2 + 2]);
}

class Point {
public:
	Point() = default;
	ld x, y;
	Point(ld x, ld y) {
		this->x = x;
		this->y = y;
	}
};

class Vector {
public:
	Vector() = default;
	ld x, y;
	Vector(ld x, ld y) {
		this->x = x;
		this->y = y;
	}
	Vector(Point a, Point b) {
		this->x = b.x - a.x;
		this->y = b.y - a.y;
	}
};

class Line {
public:
	Line() = default;
	ld a, b, c;
	Line(ld a, ld b, ld c) {
		this->a = a;
		this->b = b;
		this->c = c;
	}
	Line(Vector n, Point a) {
		this->a = n.x;
		this->b = n.y;
		this->c = -this->a * a.x - this->b * a.y;
	}
	
};

ll n;
vector<vector<ll>> s;

void read() {
	cin >> n;
	s = vector<vector<ll>>(n);
	for (ll i = 0; i < n; i++) {
		ll k;
		cin >> k;
		ll last = 0;
		for (ll j = 0; j < k; j++) {
			ll x;
			cin >> x;
			if (x > last) {
				s[i].push_back(x);
				last = x;
			}
		}
	}
}

bool comp(vector<ll> a, vector<ll> b) {
	return a.back() < b.back();
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	
	read();
	sort(s.begin(), s.end(), comp);
	for (auto& v : s) {
		ll k = v.size();
		ll cur = 0;
		for (ll i = 0; i < k; i++) {
			ll ind = v[i];
			cur = max(cur, getAns(0, 0, siz, 0, ind) + k - i);
		}
		upd(0, 0, siz, v.back(), cur);
	}
	cout << t[0];

	return 0;
} 