#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long

typedef unsigned long long ull;
typedef long double ld;

#define ff first
#define ss second

void solve() {
    int n;
    cin >> n;
    vector< vector<int> > v(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        v[i].resize(k);
        for (auto &j : v[i])
            cin >> j;
    }
    vector<int> u(n);
    iota(u.begin(), u.end(), 0);
    int ans = 0;
    do {
        int mx = 0;
        int cnt = 0;
        for (auto &i : u) {
            for (auto &j : v[i]) {
                if (j > mx)
                    cnt++;
                mx = max(mx, j);
            }
        }
        ans = max(ans, cnt);
    } while(next_permutation(u.begin(), u.end()));
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    // cin >> _;
    for (; _; --_) {
        solve();
    }
    return 0;
}