#include <bits/stdc++.h>


#define newline cout << '\n'


using namespace std;
typedef long long ll;
typedef long double ld;
const ll inf = 1e18;
mt19937 rnd(time(0));
	
vector<string> p;

void perms(string cur, vector<bool> used, int n) {
	if ((int)cur.length() == n) {
		p.push_back(cur);
		return;
	}
	for (int i = 1; i <= n; ++i) {
		if (!used[i]) {
			cur += to_string(i);
			used[i] = true;
			perms(cur, used, n);
			used[i] = false;
			cur.pop_back();
		}
	}
}

int calc(vector<int> &f) {
	int prev_max = -1, res = 0;
	for (int i : f) {
		if (i > prev_max) {
			prev_max = i;
			++res;
		}
	}
	return res;
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif


	int n, k, x, u, ans = -1;
	cin >> n >> k;

	vector<vector<int>> a(n);

	for (int i = 0; i < n; ++i) {
		cin >> x;
		while (x--) {
			cin >> u;
			a[i].push_back(u);
		}
	}
	string cur;
	vector<bool> used(n + 1, false);
	perms(cur, used, n);
	for (auto i : p) {
		vector<int> f;
		for (char c : i) {
			int v = c - '0';
			--v;
			for (int el : a[v]) {
				f.push_back(el);
			}
		}
		ans = max(ans, calc(f));
	}

	cout << ans << '\n';
	

	return 0;
}