#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#include <deque>
#include <algorithm>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n;
	cin >> n;
	vector<vector<int>> v(n);
	vector<int> msk(n);
	for (int i = 0; i < n; ++i) {
		msk[i] = i;
		int k;
		cin >> k;
		for (int j = 0; j < k; ++j) {
			int c;
			cin >> c;
			v[i].push_back(c);
		}
	}
	bool fl = 1;
	int res = 0;
	while (fl) {
		int cur = 0;
		int mx = 0;
		for (int i = 0; i < n; ++i) {
			for (auto j : v[msk[i]]) {
				if (mx < j) {
					++cur;
					mx = j;
				}
			}
		}
		res = max(res, cur);
		fl = next_permutation(msk.begin(), msk.end());
	}
	cout << res;
	return 0;
}