#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;



void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> tracks(n + 1);
    for (ll i = 1; i <= n; ++i) {
        ll q;
        cin >> q;
        while (q--) {
            ll x;
            cin >> x;
            tracks[i].push_back(x);
        }
    }

    if (n <= 7) {
        vector<ll> p;
        ll ans = 0;
        for (ll i = 1; i <= n; ++i) {
            p.push_back(i);
        }

        do {
            ll now = 0;
            ll mx = 0;
            for (auto x : p) {
                for (auto y : tracks[x]) {
                    if (y > mx) {
                        mx = y;
                        ++now;
                    }
                }
            }

            ans = max(ans, now);
        } while (next_permutation(p.begin(), p.end()));

        cout << ans << "\n";
        exit(0);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
