#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

mt19937 rng(228);

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
//    while (1) {
    int n = 6;
    cin >> n;
    vector<vector<int>> v(n);
    vector<int> coords;
    for (int i = 0; i < n; ++i) {
        int k = 20;
        cin >> k;
        v[i].resize(k);
        for (auto &j : v[i]) {
            j = rng() % 100 + 1;
        }
        cin >> v[i];
        vector<int> ggg;
        for (int j = 0; j < k; ++j) {
            while (!ggg.empty() && v[i][j] <= ggg.back()) {
                ggg.pop_back();
            }
            ggg.push_back(v[i][j]);
        }
        v[i] = ggg;
        for (auto j : v[i]) {
            coords.push_back(j);
        }
    }
    coords.push_back(0);
    sort(coords.begin(), coords.end());
    coords.resize(unique(coords.begin(), coords.end()) - coords.begin());
    for (int i = 0; i < n; ++i) {
        for (auto &j : v[i]) {
            j = lower_bound(coords.begin(), coords.end(), j) - coords.begin();
        }
    }
    auto gg = v;
    auto check = [&](vector<vector<int>> a) {
        int ans = 0;
        int mx = 0;
        for (int i = 0; i < (int) a.size(); ++i) {
            for (int j : a[i]) {
//                cout << j << " ";
                if (j > mx) {
                    ++ans;
                }
                mx = max(mx, j);
            }
//            cout << " ";
        }
        return ans;
    };
    int rans = 0;
    sort(v.begin(), v.end());
    do {
        rans = max(rans, check(v));
    } while (next_permutation(v.begin(), v.end()));
    cout << rans << "\n";
    return 0;
    int sz = coords.size();
    vector<int> dp(sz);
    sort(v.begin(), v.end(), [&](const vector<int> &a, const vector<int> &b) {
        return a.back() < b.back();
    });
    for (int i = 0; i < n; ++i) {
        for (int j = sz - 1; j >= 0; --j) {
            if (j >= v[i].back()) {
                continue;
            }
            int cost = (int) v[i].size() - (upper_bound(v[i].begin(), v[i].end(), j) - v[i].begin());
            dp[v[i].back()] = max(dp[v[i].back()], dp[j] + cost);
        }
    }
    int ans = *max_element(dp.begin(), dp.end());
//    cout << ans << "\n";
//    int ans = check(v);
    if (ans != rans) {
        cout << ans << " " << rans << "\n";
        cout << n << "\n";
        for (int i = 0; i < n; ++i) {
            cout << gg[i].size() << "\n";
            for (int j = 0; j < (int) gg[i].size(); ++j) {
                cout << coords[gg[i][j]] << " ";
            }
            cout << "\n";
        }
        return 0;
    }
    cout << "OK\n";
//    }
}
