#include <bits/stdc++.h>

#define int long long
#define double long double

using namespace std;

bool operator-(vector<int> a, vector<int> b) {
    sort(a.begin(), a.end()), sort(b.begin(), b.end());
    while (!a.empty() && !b.empty()) {
        if (a.back() < b.back()) {
            return true;
        } else if (a.back() > b.back()) {
            return false;
        } else {
            a.pop_back(), b.pop_back();
        }
    }
    if (a.empty()) {
        return true;
    }
    return false;
}

bool cmp(vector<int> &a, vector<int> &b) {
    int cnt_a = a.size(), cnt_b = b.size();
    int lba = upper_bound(b.begin(), b.end(), a.back()) - b.begin() - 1;
    int lbb = upper_bound(a.begin(), a.end(), b.back()) - a.begin() - 1;
    return cnt_a + lba < cnt_b + lbb;
}

signed main() {
    //ifstream cin("text.in");
    //ofstream cout("text.out");
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    mt19937_64 gen(time(nullptr));
    int n, i, k, j, ma = 0, cnt = 0, in;
    cin >> n;
    vector<vector<int>> arr(n);
    for (i = 0; i < n; i++) {
        cin >> k;
        ma = 0;
        for (j = 0; j < k; j++) {
            cin >> in;
            if (in > ma) {
                ma = in, arr[i].push_back(in);
            }
        }
    }
    sort(arr.begin(), arr.end(), cmp);
    ma = 0;
    for (i = 0; i < n; i++) {
        for (int u : arr[i]) {
            if (u > ma) {
                ma = u, cnt++;
            }
        }
    }
    cout << cnt;
    return 0;
}
