#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	int n; cin >> n;
	vector<vector<int>> v(n);
	fori(n) {
		int k; cin >> k;
		v[i].resize(k);
		cin >> v[i];
	}

	vector<int> tv(n);
	fori(n)
		tv[i] = i;

	ll ans = 0;
	do {

		vector<int> ms;
		fori(n) {
			forj(v[tv[i]].size())
				ms.push_back(v[tv[i]][j]);
		}

		ll cnt = 0;
		int mx = 0;
		fori(ms.size()) {
			if (ms[i] > mx) {
				cnt++;
				mx = ms[i];
			}
		}

		ans = max(ans, cnt);

	} while (next_permutation(all(tv)));

	cout << ans;
}