/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;
int n, k[maxn], ridx[maxn];
vector < int > album[maxn];

void compress_album(int i)
{
    ///sort(album[i].begin(), album[i].end());
    vector < int > new_album;
    int last = 0;
    for (int j = 0; j < k[i]; j ++)
    {
        if (album[i][j] > last)
        {
            new_album.push_back(album[i][j]);
            last = album[i][j];
        }
    }
    album[i] = new_album;
}

bool cmp(int a, int b)
{
    return album[a].back() < album[b].back();
}

int dp[maxn];
vector < int > song[maxn];
void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        int x;
        cin >> k[i];
        album[i].resize(k[i]);
        for (int j = 0; j < k[i]; j ++)
        {
            cin >> album[i][j];
        }
    }

    for (int i = 1; i <= n; i ++)
        compress_album(i), ridx[i] = i;

    sort(ridx + 1, ridx + n + 1, cmp);


    for (int i = 1; i <= n; i ++)
    {
        int idx = ridx[i];
        dp[i] = album[idx].size();
        int pt = 0;
        for (int j = 1; j < i; j ++)
        {
            while(pt < album[idx].size() && album[ridx[j]].back() >= album[idx][pt])
                pt ++;
            dp[i] = max(dp[i], (int)(dp[j] + album[idx].size() - pt));
        }
    }

    cout << dp[n] << endl;
}

int main()
{
    solve();
    return 0;
}
/**
3
3
4 8 5
3
2 6 9
2
1 10
 */
