#include <algorithm>
#include <iostream>
#include <utility>
#include <vector>
#include <random>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

vector<int> alb[MAXN + 5];

mt19937 gen(13490);

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    for (int i = 1; i <= n; ++ i)
    {
        int k;
        cin >> k;

        int prv = 0;
        vector<int> v;
        for (int j = 1; j <= k; ++ j)
        {
            int num;
            cin >> num;
            if (num > prv)
            {
                v.push_back(num);
                prv = num;
            }
        }
        alb[i] = v;
    }

    vector< vector<int> > opt;
    opt.push_back(alb[1]);
    for (int i = 2; i <= n; ++ i)
    {
        int l = -1, r = opt.size(), mid;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (opt[mid].back() < alb[i].back()) l = mid;
            else r = mid;
        }
        int p = lower_bound(alb[i].begin(), alb[i].end(), (l >= 0 ? opt[l].back() + 1 : 0)) - alb[i].begin();
        alb[i].erase(alb[i].begin(), alb[i].begin() + p);
        if (r == opt.size())
        {
            opt.push_back(alb[i]);
            continue;
        }
        int q = lower_bound(opt[r].begin(), opt[r].end(), alb[i].back() + 1) - opt[r].begin();
        if (q > alb[i].size()) continue;
        if (q < alb[i].size() or gen() % 5)
        {
            opt[r].erase(opt[r].begin(), opt[r].begin() + q);
            if (opt[r].size() == 0) opt.erase(opt.begin() + r);
            opt.insert(opt.begin() + r, alb[i]);
        }
    }

    int ans = 0;
    for (auto v : opt)
    {
        ans += v.size();
    }
    cout << ans << endl;

    return 0;
}
