#include <bits/stdc++.h>

using namespace std;
using ll = long long;

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<array<int, 2>> a(n);

    for (auto &[x, y] : a) {
        cin >> x >> y;
    }

    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);

    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return a[i % n][i / n] < a[j % n][j / n];
    });

    set<pair<int, int>> gr, sm;

    for (int i = 0; i < n; ++i) {
        gr.emplace(a[i][1], i);
    }

    int ans = 1e9;

    for (int i : ord) {
        gr.erase({a[i][1], i});

        int mx = 0;

        if (!gr.empty()) {
            mx = gr.rbegin()->first;
        }

        if (!sm.empty()) {
            auto it = sm.lower_bound({a[i][0], -1});

            int b1 = -1, b2 = -1;

            if (it != sm.end()) {
                b1 = it->first;
            }

            if (it != sm.begin()) {
                b2 = prev(it)->first;
            }

            if (b1 == -1 || b2 == -1) {
                mx = max({mx, b1, b2});
            } else if (abs(a[i][0] - b1) <= abs(a[i][0] - b2)) {
                mx = max(mx, b1);
            } else {
                mx = max(mx, b2);
            }
        }

        ans = min(ans, int(abs(a[i][0] - mx)));

        sm.emplace(a[i][1], i);
    }

    cout << ans << '\n';

    return 0;
}
