#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

#define LC(V) (2*(V)+1)
#define RC(V) (2*(V)+2)

using namespace std;
using namespace __gnu_pbds;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int INF = 2e9;

int solve(int n, const vector<pair<int, int>> &a) {
    int ans = INF;
    multiset<int> dab;
    for (auto [x, y]: a) dab.insert(min(x, y));
    multiset<int> db;
    for (auto [x, y]: a) db.insert(y);
    for (int i = 0; i < n; i++) {
        dab.erase(dab.find(min(a[i].first, a[i].second)));
        db.erase(db.find(a[i].second));
        int ma = a[i].first;
        if (dab.upper_bound(ma) == dab.end()) {
            int mb = -INF;
            {
                auto it = db.lower_bound(ma);
                if (it == db.end() || *it != ma) {
                    if (it != db.begin()) it--;
                }
                if (it != db.end()) mb = *it;
            }
            ans = min(ans, ma - mb);
        }
        dab.insert(min(a[i].first, a[i].second));
        db.insert(a[i].second);
    }
    return ans;
}

int main() {
#ifndef AVEVAD
    cin.tie(0);
    ios_base::sync_with_stdio(0);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto &[x, y]: a) cin >> x >> y;
    int ans = INF;
    ans = min(ans, solve(n, a));
    for (auto &[x, y]: a) swap(x, y);
    ans = min(ans, solve(n, a));
    cout << ans << '\n';
}