#include <bits/stdc++.h>
using namespace std;
#define rep(i, a, b) for (int (i) = (a); (i) < (b); i++)
#define sz(x) int(size(x))
using vi = vector<int>;
using pii = pair<int, int>;
using ll = long long;

int main() {
    cin.tie(nullptr)->exceptions(ios::failbit);
    ios::sync_with_stdio(false);

    int n;
    cin >> n;
    vector<pii> a(n);
    rep(i, 0, n) cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());

    vi suf(n + 1);
    for (int i = n - 1; i >= 0; i--) {
        suf[i] = max(suf[i + 1], a[i].second);
    }

    int ans = INT_MAX;
    rep(i, 0, n - 1) {
        ans = min(ans, abs(a[n - 1].first - a[i].second));
    }

    rep(i, 0, n) {
        ans = min(ans, abs(a[i].first - suf[i + 1]));
    }
    cout << ans << '\n';
}