#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n;
    cin >> n;
    vector <ll> a(n), b(n);
    bool flag = true;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        if (a[i] != b[i])
            flag = false;
    }
    if (flag) {
        sort(a.begin(), a.end());
        cout << a[n - 1] - a[n - 2];
        return;
    }
    ll ans = 1e9;
    for (ll i = 0; i < n; ++i) {
        ll mx1 = a[i];
        ll mx2 = -1e9;
        for (ll j = 0; j < n; ++j) {
            if (i != j) {
                if (a[i] < a[j]) {
                    mx2 = max(mx2, b[j]);
                }
                else {
                    if (b[j] > mx2) {
                        if (abs(mx2 - mx1) > abs(mx2 - b[j]))
                            mx2 = b[j];
                    }
                }
            }
        }
        ans = min(abs(mx1 - mx2), ans);
    }
    cout << ans;
}
int main()
{
    FAST();
    int tt = 1; //cin >> tt;
    while (tt--) {
        solve();
    }
}