#include <bits/stdc++.h>

#include <utility>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

typedef long long ll;
typedef long double ld;
using namespace std;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a;
    for (int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        a.emplace_back(x, y);
    }

    sort(all(a));
    multiset<int> st;
    for (int i = 0; i < n; ++i) {
        st.insert(a[i].second);
    }

    int answer = 2e9 + 1;
    set<int> was;
    for (int i = 0; i <= n - 1; ++i) {
        int mx_a = a[i].first;
        st.erase(st.find(a[i].second));
        if (!st.empty()) {
            int mx_b = *st.rbegin();
            answer = min(answer, abs(mx_a - mx_b));
            if (!was.empty()) {
                auto it = was.lower_bound(mx_a);
                if (it != was.end()) {
                    answer = min(answer, abs(mx_a - max(*it, mx_b)));
                }

                it = was.upper_bound(mx_a);
                if (it != was.begin()) {
                    --it;
                    answer = min(answer, abs(mx_a - max(*it, mx_b)));
                }
            }
        } else {
            if (!was.empty()) {
                auto it = was.lower_bound(mx_a);
                if (it != was.end()) {
                    answer = min(answer, abs(mx_a - *it));
                }

                it = was.upper_bound(mx_a);
                if (it != was.begin()) {
                    --it;
                    answer = min(answer, abs(mx_a - *it));
                }
            }
        }

        was.insert(a[i].second);
    }

    cout << answer;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
#ifdef MT
    cin >> T;
#endif
    while (T--) {
        solve();
    }
    return 0;
}