#include <bits/stdc++.h>


typedef long long ll;
typedef unsigned long long ull;
using namespace std;
const ll INF = 1e18;



int main() {
    ios::sync_with_stdio(true);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    multiset<ll> bs;
    vector<vector<ll>> apos(n);
    unordered_map<ll, ll> key;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        bs.insert(b[i]);
        if (key.find(a[i]) == key.end()) {
            key[a[i]] = key.size();
        }
        apos[key[a[i]]].push_back(i);
    }
    vector<ll> asort = a;
    std::sort(asort.rbegin(), asort.rend());
    ll mxb = 0;
    ll best = INF;
    for (ll i = 0; i < n && !bs.empty();) {
        auto ela = asort[i];
        for (auto pos : apos[key[ela]]) {
            ll elb = b[pos];
            bs.erase(bs.find(elb));
            ll x = INF;
            auto it = bs.lower_bound(ela);
            if (it != bs.end()) {
                x = abs(max(*it, mxb) - ela);
            }
            if (it != bs.begin()) {
                ll y = abs(max(*(--it), mxb) - ela);
                x = min(x, y);
            }
            best = min(x, best);
//            cerr << mxb << " " << ela << " " << elb << " " << x << "\n";
            bs.insert(elb);
        }
        for (auto pos : apos[key[ela]]) {
            mxb = max(mxb, b[pos]);
            ++i;
        }
    }
    cout << best << "\n";


    return 0;
}