#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    {
        vector <pair<int, int>> tmp(n);
        for (int i = 0; i < n; ++i) {
            tmp[i] = {a[i], b[i]};
        }
        sort(tmp.begin(), tmp.end());
        for (int i = 0; i < n; ++i) {
            tie(a[i], b[i]) = tmp[i];
        }
    }
    int ans = INT_MAX;
    vector<int> suff_max(n + 1);
    suff_max[n] = INT_MIN;
    for (int i = n - 1; i >= 0; --i) {
        suff_max[i] = max(suff_max[i + 1], b[i]);
    }
    for (int i = 0; i < n; ++i) {
        int max_a = a[i];
        int max_b = suff_max[i + 1];
        /*for (int j = 0; j < n; ++j) {
            if (a[j] > max_a) {
                max_b = max(max_b, b[j]);
            }
        }*/
        //if (max_b == INT_MIN) {
        int best_max_b = max_b;
        for (int j = 0; j < i; ++j) {
            if (abs(max_a - b[j]) < abs(max_a - best_max_b) && b[j] >= max_b) {
                best_max_b = b[j];
            }
        }
        //}
        ans = min(ans, abs(max_a - best_max_b));
    }
    cout << ans;
}


signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}