#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ft first
#define sd second
#define pb push_back

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<int,int> pii;

const int N=5e5+228;
const int inf=1e9+1;
const ll Inf=1e18+1;
const int mod=1e9+7;

pll a[N];

bool comp(pll a,pll b){
    return a.ft<b.ft || (a.ft==b.ft && a.sd>b.sd);
}

void solve(){
    int n;
    cin >> n;
    for(int i=0;i<n;i++) cin >> a[i].ft >> a[i].sd;
    sort(a,a+n,comp);
    ll mn=1e18;
    multiset<ll> st;
    for(int i=0;i<n;i++)
        st.insert(a[i].sd);
    ll mx=0;
    for(int i=n-1;i>=0;i--){
        st.erase(st.find(a[i].sd));
        auto it=st.lower_bound(a[i].ft);
        if(it!=st.begin()) it--;
        for(int j=0;j<3 && it!=st.end();j++){
//            cout << abs(a[i].ft-(*it)) << " " << a[i].ft << " " << (*it) << endl;
            if(n==i+1){
                ll mxi=0;
                mxi=(*it);
                mn=min(mn,abs(mxi-a[i].ft));
            }
            else{
                ll mxi=0;
                mxi=mx;
                mn=min(mn,abs(mxi-a[i].ft));
                mxi=max(*it,mxi);
                mn=min(mn,abs(mxi-a[i].ft));
            }
        }
        mx=max(mx,a[i].sd);
    }
    cout << mn << endl;
}
int main()
{
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t=1;
    while(t--){
        solve();
    }
    return 0;
}
