#include<iostream>
#include<vector>
#include<string>
#include<set>
#include<map>
#include<stack>
#include<queue>
#include<deque>
#include<cmath>
#include<iomanip>
#include<algorithm>
#include<unordered_map>
#include<unordered_set>
using namespace std;

struct edge {
    int a, b;
};

bool operator<(const edge& first, const edge& second) {
    return first.a < second.a;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<edge> cost(n);
    for (int i = 0; i < n; i++)
        cin >> cost[i].a >> cost[i].b;
    sort(cost.rbegin(), cost.rend());

    multiset<int, greater<int>> st1, st2;
    st1.insert(-1000000000);
    st2.insert(-1000000000);
    for (int i = 0; i < n; i++)
        st1.insert(cost[i].a);

    int ans = 2000000000;
    for (int i = 0; i < n; i++) {
        int first = *(st1.begin());
        int second = *(st2.begin());

        //st1.erase(st1.find(first));
        //st2.erase(st2.find(second));

        int total = abs(first - second);

        st1.erase(st1.find(cost[i].a));
        st2.insert(cost[i].b);

        int cur = abs((*st1.begin()) - (*st2.begin()));

        if (cur > total) {
            st2.erase(st2.find(cost[i].b));
            st1.insert(cost[i].a);
        }

        ans = min({ans, cur, total});
    }

    for (int i = 0; i < n; i++)
        swap(cost[i].a, cost[i].b);
    sort(cost.rbegin(), cost.rend());

    st1.clear();
    st2.clear();

    st1.insert(-1000000000);
    st2.insert(-1000000000);
    for (int i = 0; i < n; i++)
        st1.insert(cost[i].a);

    int ans2 = 2000000000;
    for (int i = 0; i < n; i++) {
        int first = *(st1.begin());
        int second = *(st2.begin());

        //st1.erase(st1.find(first));
        //st2.erase(st2.find(second));

        int total = abs(first - second);

        st1.erase(st1.find(cost[i].a));
        st2.insert(cost[i].b);

        int cur = abs((*st1.begin()) - (*st2.begin()));

        if (cur > total) {
            st2.erase(st2.find(cost[i].b));
            st1.insert(cost[i].a);
        }

        ans2 = min({ans2, cur, total});
    }

    cout << min(ans, ans2) << '\n';

    return 0;
}
