#include <iostream>
#include <set>
#include <vector>
#include <algorithm>
#include <map>

using namespace std;

int main() {
	int n; cin >> n;
	vector<pair<int, int>> a(n);
	for (auto i = 0; i < n; ++i) {
		int x, y; cin >> x >> y;
		a[i] = { x, y};
	}
	sort(a.begin(), a.end());
	vector<int> mx(n);
	mx[n - 1] = a[n - 1].second;
	for (auto i = n - 2; i >= 0; --i) {
		mx[i] = max(mx[i + 1], a[i].second);
	}
	int ans = 1000000001;
	set<int> yy;
	for (auto i = 1; i < n - 1; ++i) {
		yy.insert(a[i - 1].second);
		if (mx[i + 1] >= a[i].first) {
			ans = min(ans, mx[i + 1] - a[i].first);
		}
		else {
			int k = mx[i + 1];
			ans = min(ans, a[i].first - k);
			auto iub= yy.lower_bound(a[i].first);
			if (iub==yy.end()){
				ans = min(ans, a[i].first - *prev(yy.end()));
			}
			else if (iub == yy.begin()) {
				ans = min(ans, *yy.begin() - a[i].first);
			}
			else {
				int ub = *yy.lower_bound(a[i].first);
				int lb = *prev(yy.upper_bound(a[i].first));
				ans = min(ans, ub - a[i].first);
				ans = min(ans, a[i].first - lb);
			}
		}
	}
	yy.insert(a[n - 2].second);
	auto iub = yy.lower_bound(a[n-1].first);
	if (iub == yy.end()) {
		ans = min(ans, a[n-1].first - *prev(yy.end()));
	}
	else if (iub == yy.begin()) {
		ans = min(ans, *yy.begin() - a[n-1].first);
	}
	else {
		int ub = *yy.lower_bound(a[n-1].first);
		int lb = *prev(yy.upper_bound(a[n-1].first));
		ans = min(ans, ub - a[n-1].first);
		ans = min(ans, a[n-1].first - lb);
	}
	cout << ans;
	return 0;
}