#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>
#pragma GCC optimize("Ofast")
#pragma GCC optimize("O3")
#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

const int N = 5e5 + 1;

bool cmp1 (pair<ii, int> a1, pair<ii, int> b1) {
    auto a = a1.ft;
    auto b = b1.ft;
    if (a.ft == b.ft) {
        return a.sd < b.sd;
    }
    return a.ft < b.ft;
}

bool cmp2 (pair<ii, int> a1, pair<ii, int> b1) {
    auto a = a1.ft;
    auto b = b1.ft;

    if (a.sd == b.sd) {
        return a.ft < b.ft;
    }
    return a.sd < b.sd;
}

bool cmp23 (pair<ii, int> a, pair<ii, int> b) {
    return max(a.ft.ft, a.ft.sd) < max(b.ft.ft, b.ft.sd);
}
int n;

int solve_smart (vector<int> a, vector<int> b) {
    vector<pair<ii, int>> v(n);
    for (int i = 0; i < n; i++) {
        v[i] = mp(mp(a[i], b[i]), i);
    }
    vector<pair<ii, int>> w = v;
    sort(w.begin(), w.end(), cmp23);
    sort(v.begin(), v.end(), cmp1);
    for (int i = 0; i < n; i++) {
        // cout << w[i].ft.ft << " " << w[i].ft.sd << " " << w[i].sd << endl;
    }
    int in = 0;
    int best_b[n + 1], best_a[n + 1];
    int ind_best_a[n + 1], ind_best_b[n + 1];
    int best_b2[n + 1], best_a2[n + 1];
    best_b[0] = best_a[0] = -1e9;
    best_b2[0] = best_a2[0] = -1e9;
    ind_best_a[0] = ind_best_b[0] = -1;
    for (int i = 0; i < n; i++) {
        best_a[i + 1] = best_a[i];
        ind_best_a[i + 1] = ind_best_a[i];
        best_a2[i + 1] = best_a2[i];
        best_b[i + 1] = best_b[i];
        ind_best_b[i + 1] = ind_best_b[i];
        best_b2[i + 1] = best_b2[i];
        if (w[i].ft.sd >= best_b[i]) {
            best_b[i + 1] = w[i].ft.sd;
            ind_best_b[i + 1] = w[i].sd;
            best_b2[i + 1] = best_b[i];
        } else if (w[i].ft.sd > best_b2[i]) {
            best_b2[i + 1] = w[i].ft.sd;
        }
        if (w[i].ft.ft >= best_a[i]) {
            best_a[i + 1] = w[i].ft.ft;
            ind_best_a[i + 1] = w[i].sd;
            best_a2[i + 1] = best_a[i];
        } else if (w[i].ft.ft > best_a2[i]) {
            best_a2[i + 1] = w[i].ft.ft;
        }
    }
    for (int i = 0; i <= n; i++) {
        //cout << best_a[i] << " a " << ind_best_a[i] << " " << best_a2[i] << endl;
        //cout << best_b[i] << " b " << ind_best_b[i] << " " << best_b2[i] << endl;
    }
    int ans = 2e9;
    int max1[n + 1];
    max1[n - 1] = v[n - 1].ft.sd;
    for (int i = n - 2; i >= 0; i--) {
        max1[i] = max(max1[i + 1], v[i].ft.sd);
    }
    max1[n] = -1e9;
    in = -1;
    int min_now = 1e9 + 1;
    for (int i = 0; i < n; i++) {
        while ((in + 1 < n) && (max(w[in + 1].ft.ft, w[in + 1].ft.sd) <= v[i].ft.ft)) {
            in++;
        }
        int b_now = max1[i + 1];
        if (b_now > v[i].ft.ft)
            continue;
        int good = best_b[in + 1];
        if (ind_best_b[in + 1] == v[i].sd) {
            good = best_b2[in + 1];
        }
        b_now = max(b_now, good);
        ans = min(ans, abs(v[i].ft.ft - b_now));
    }
    sort(v.begin(), v.end(), cmp2);

    max1[n - 1] = v[n - 1].ft.ft;
    for (int i = n - 2; i >= 0; i--) {
        max1[i] = max(max1[i + 1], v[i].ft.ft);
    }
    min_now = 1e9 + 1;
    in = -1;
    for (int i = 0; i < n; i++) {
        while ((in + 1 < n) && (max(w[in + 1].ft.ft, w[in + 1].ft.sd) <= v[i].ft.sd)) {
            in++;
        }
        int a_now = max1[i + 1];
        if (a_now > v[i].ft.sd) {
            continue;
        }
        int good = best_a[in + 1];
        if (ind_best_a[in + 1] == v[i].sd) {
            good = best_a2[in + 1];
        }
        a_now = max(a_now, good);
        ans = min(ans, abs(v[i].ft.sd - a_now));
    }
    return ans;
}

int solve_stupid (vector<int> a, vector<int> b) {
    int ans = 1e9 + 1;
    for (int i = 0; i < n; i++) {
        int max1 = -1e9;
        for (int j = 0; j < n; j++) {
            if (j == i)
                continue;
            if ((a[j] <= a[i]) && (b[j] <= a[i])) {
                max1 = max(max1, b[j]);
            } else if (a[j] > a[i]) {
                max1 = max(max1, b[j]);
            }
        }
        ans = min(ans, abs(a[i] - max1));
    }
    for (int i = 0; i < n; i++) {
        int max1 = -1e9;
        for (int j = 0; j < n; j++) {
            if (j == i)
                continue;
            if ((b[j] <= b[i]) && (a[j] <= b[i])) {
                max1 = max(max1, a[j]);
            } else if (b[j] > b[i]) {
                max1 = max(max1, a[j]);
            }
        }
        ans = min(ans, abs(b[i] - max1));
    }
    return ans;
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];
    cout << solve_smart(a, b);/*
    //solve_stupid();
    //return 0;
    mt19937 rnd;
    rnd.seed(time(NULL));
    for (int i = 0; i < 1000; i++) {
        n = (rnd() % 10) + 2;
        vector<int> a(n), b(n);
        for (int i1 = 0; i1 < n; i1++) {
            a[i1] = rnd() % 10;
            b[i1] = rnd() % 10;
        }
        cout << n << endl;
        //for (int i1 = 0; i1 < )
        int ans1 = solve_smart(a, b);
        int ans2 = solve_stupid(a, b);
        if (ans1 != ans2) {
            cout << "!!!!!!!!!!\n";
            cout << n << endl;
            for (int i1 = 0; i1 < n; i1++) {
                cout << a[i1] << " "<< b[i1] << endl;
            }
            cout << ans1 << " " << ans2 << endl;
        }
    }*/
}