#include <bits/stdc++.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e18 + 7;
const int MOD = 998244353;
const int maxn = 1e6 + 1;

vector<int> a, b;
bool cmp(int x, int y) {
    return a[x] < a[y];
}

void solve() {
    itn n;
    cin >> n;
    a.resize(n);
    b.resize(n);
    for(int i = 0; i < n; ++i) cin >> a[i] >> b[i];
    vector<int> ind(n);
    iota(all(ind), 0);
    sort(all(ind), cmp);
    vector<int> new_b;
    for(auto i : ind) new_b.pb(b[i]);
    b = new_b;
    vector<itn> sufmax(n + 1);
    sufmax[n] = -INF;
    for(int i = n - 1; i >= 0; --i) {
        sufmax[i] = max(sufmax[i + 1], b[i]);
    }
    set<int> was;
    int ans = INF;
    for(int i = 0; i < n; ++i) {
        int c = sufmax[i + 1];
        int mxa = a[i];
        int cur = abs(mxa - c);
        if((int)was.size() > 0) {
            auto it = was.upper_bound(mxa);
            if(it == was.begin()) {
                cur = min(cur, abs(*it - mxa));
            } else if(it == was.end()) {
                cur = min(cur, abs(*(--it) -mxa));
            } else {
                cur = min(cur, abs(*it - mxa));
                cur = min(cur, abs(*(--it) -mxa));
            }
        }
        was.insert(b[i]);
        ans = min(ans, cur);
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}