//#pragma GCC optimize("O3", "inline", "unroll-loops", "no-stack-protector")
//#pragma GCC comment("/linker:64000000")
//#pragma GCC targer("fma")
#include <bits/stdc++.h>

#include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
using namespace __gnu_cxx;

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

template<typename T>
using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

inline void solve() {
    int n;
    cin >> n;

    vector<pii> a(n);

    for (pii &it : a) {
        cin >> it.X >> it.Y;
        it.Y *= -1;
    }

    sort(all(a));
    for (auto &it : a) {
        it.Y *= -1;
    }

    vector<int> suff_max(n + 1, -2e18);

    for (int i = n - 1; i >= 0; i--) {
        suff_max[i] = max(suff_max[i + 1], a[i].Y);
    }
    int ans = 2e18;

    set<int> all_b;
    map<int, int> cnt;
    for (int i = 0; i < a.size(); i++) {
        vector<int> my;
        auto it = a[i];
        int j = i;
        vector<int> b;

        while (j < n && a[j].X == a[i].X) {
            b.push_back(a[j].Y);
            j++;
        }
        i = j - 1;

        int val = suff_max[j];

//        map<int, int> cnt;
        for (int &it : b) {
            cnt[it]++;
            all_b.insert(it);
        }
//        for ()
        rmin(ans, abs(val - it.X));

        for (int &h : b) {
            if (cnt[h] == 1) {
                all_b.erase(h);
            }

            if (val <= it.X) {
                auto i = all_b.lower_bound(it.X);
                if (i != all_b.begin()) {
                    --i;
                    rmax(val, *i);
                    rmin(ans, abs(val - it.X));
                    i++;
                }

                if (i != all_b.end()) {
                    val = *i;
                    rmin(ans, abs(val - it.X));
                }
            }

            all_b.insert(h);
        }
    }

    cout << ans << endl;
}


signed main() {
    fast;
//    cout.precision(10);
//    cout << fixed;


#ifdef LOCAL_CLION
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#else
    freopen("./input.txt", "r", stdin);
    freopen("./output.txt", "w", stdout);
#endif

    int t = 1;
//    cin >> t;

    while (t--) {
        solve();
    }
}
