//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7, INF = 1e9 + 1;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve() {
    ll n;
    cin >> n;
    vector < pair < ll, ll >> a(n);
    multiset < ll > after;
    set < ll > was, was_r;
    was.insert(INF);
    was_r.insert(-INF);
    after.insert(-INF);
    ll ans = INF;
    forall(i, a) cin >> i.first >> i.second;
    sort(all(a));

    ll mx = -INF;
    for (ll i = n - 1; i >= 0; i--) {
        ans = min(ans, abs(a[i].first - mx));
        mx = max(mx, a[i].second);
    }
    forall(i, a) swap(i.first, i.second);

    sort(all(a));
    mx = -INF;
    for (ll i = n - 1; i >= 0; i--) {
        ans = min(ans, abs(a[i].first - mx));
        mx = max(mx, a[i].second);
    }
    cout << ans;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}