#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

const int INF = 1e9 + 42;

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto& [i, j] : a)
        cin >> i >> j;

    set<pair<int, int>> sb;
    for (int i = 0; i < n; ++i)
        sb.insert({a[i].second, i});
    sb.insert({-INF, -INF});
    sb.insert({2 * INF, INF});

    vector<pair<int, int>> va(n);
    for (int i = 0; i < n; ++i)
        va[i] = {a[i].first, i};
    sort(all(va));

    int ans = INF;
    int bm = -INF;
    for (int i = n - 1; i > 0; --i) {//cout << "! " << i << endl;
        sb.erase({a[va[i].second].second, va[i].second});
        /*
        for (auto [x, y] : sb)
            cout << x << " " << y << endl;
        */
        int tmp = -INF, curcnt = INF;
        auto it = sb.lower_bound(va[i]);
        auto l = it, r = it;
        --l, ++r, ++r;
        for (auto j = l; j != sb.end() && j != r; ++j) {
            int cnt = abs(va[i].first - j->first);//cout << "!! " << j->first << endl;
            if (curcnt > cnt) {
                curcnt = cnt;
                tmp = j->first;
            }
        }

        tmp = max(tmp, bm);
        if (abs(va[i].first - tmp) > abs(va[i].first - bm))
            tmp = bm;
        ans = min(ans, abs(va[i].first - tmp));
        bm = max(bm, a[va[i].second].second);
        /*
        cout << tmp << endl;
        cout << ans << endl;
        */
    }
    ans = min(ans, abs(va[0].first - bm));

    cout << ans << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}

/*
2
2 4
3 4
 */