#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;


#define int ll
#define ff first
#define ss second
#define pb push_back
#define sz(x) long(x.size())
#define rs resize
#define all(x) x.begin(), x.end()
#define qmn(a, b) a = min(a, b)
#define qmx(a, b) a = max(a, b)
#define fastio() cin.tie(0)->sync_with_stdio(0)
typedef long long ll;
typedef pair<int, int> pii;
typedef long double ld;
typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
const int INF32 = 2e9 + 5;
const ll INF64 = 2e18 + 5;
const int MX = 5e5 + 7;
const int ABOBA = 333;


int n, a[MX], b[MX];
pii c[MX];
vector<int> t[1 << 21];


void build(int v, int tl, int tr) {
    if (tl == tr) {
        t[v].pb(c[tl].ss);
        return;
    }
    int tm = (tl + tr) / 2;
    build(2 * v + 1, tl, tm);
    build(2 * v + 2, tm + 1, tr);
    for (int i = tl; i <= tr; i++) {
        t[v].pb(c[i].ss);
    }
    sort(all(t[v]));
}


int getMX(int v, int tl, int tr, int l, int r, int x) {
    if (l > r) return -INF32;
    if (l > tr || tl > r) return -INF32;
    if (l <= tl && tr <= r) {
        int ind = upper_bound(all(t[v]), x) - t[v].begin();
        if (!ind) return -INF32;
        ind--;
        return t[v][ind];
    }
    int tm = (tl + tr) / 2;
    return max(getMX(2 * v + 1, tl, tm, l, r, x), getMX(2 * v + 2, tm + 1, tr, l, r, x));
}


int getNext(int v, int tl, int tr, int l, int r, int x) {
    if (l > r) return -INF32;
    if (l > tr || tl > r) return -INF32;
    if (l <= tl && tr <= r) {
        int ind = upper_bound(all(t[v]), x) - t[v].begin();
        if (ind == sz(t[v])) return -INF32;
        return t[v][ind];
    }
    int tm = (tl + tr) >> 1;
    return min(getNext(2 * v + 1, tl, tm, l, r, x), getNext(2 * v + 2, tm + 1, tr, l, r, x));
}


void tryy(int &x, int y, int z) {
    qmn(x, abs(y - z));
}


void solve() {
    //solve here
    cin >> n;
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        c[i] = {a[i], b[i]};
    }
    set<int> take;
    vector<int> suff(n + 1, -1);
    for (int i = 1; i <= n; i++) {
        suff[i] = max(suff[i - 1], c[n - i].ss);
    }
    sort(c, c + n);
    build(0, 0, n - 1);
    int ans = INF32;
    for (int i = 0; i < n; i++) {
        int f = c[i].ff;
        int j;
        int l = 0;
        int r = n - i;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            if (c[i + mid].ff > c[i].ff) r = mid;
            else l = mid;
        }
        j = i + r;
        //[j, n - 1] len = n - 1 - j + 1 = n - j
        int s = suff[n - j];
        pii ft = {getMX(0, 0, n - 1, 0, i - 1, f), getNext(0, 0, n - 1, 0, i - 1, f)};
        pii sc = {getMX(0, 0, n - 1, i + 1, j - 1, f), getNext(0, 0, n - 1, i + 1, j - 1, f)};
        tryy(ans, f, s);
        tryy(ans, f, max(s, ft.ff));
        tryy(ans, f, max(s, ft.ss));
        tryy(ans, f, max(s, sc.ss));
        tryy(ans, f, max(s, sc.ff));
        tryy(ans, f, max(s, max(ft.ff, sc.ff)));
        tryy(ans, f, max(s, max(ft.ff, sc.ss)));
        tryy(ans, f, max(s, max(ft.ss, sc.ff)));
        tryy(ans, f, max(s, max(ft.ss, sc.ss)));
    }
    cout << ans;
}


int32_t main() {
    fastio();
    int tests = 1;
    //cin >> tests;
    while (tests--) solve();
    return 0;
}