#include <bits/stdc++.h>

#define int long long
const int INF = 1e10 + 7;

using namespace std;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, min_res = INF;
    cin >> n;
    vector<pair<int, int>> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> b[i].first;
        b[i].second = a[i].second = i;
    }
    sort(a.begin(), a.end(), greater<>());
    sort(b.begin(), b.end(), greater<>());
    vector<bool> used(n);
    int ind1 = 0, ind2 = 0;
    while (ind1 < n && ind2 < n) {
        if (a[ind1].second != b[ind2].second) {
            min_res = min(min_res, abs(a[ind1].first - b[ind2].first));
        }
        if (a[ind1].first > b[ind2].first) {
            if (used[a[ind1].second])
                break;
            used[a[ind1].second] = true;
            ind1++;
        } else if (a[ind1].first < b[ind2].first) {
            if (used[b[ind2].second])
                break;
            used[b[ind2].second] = true;
            ind2++;
        } else {
            if (ind1 == n - 1 || used[a[ind1].second]) {
                ind2++;
                continue;
            } else if (ind2 == n - 1 || used[b[ind2].second]) {
                ind1++;
                continue;
            }
            if (a[ind1 + 1].first >= b[ind2 + 1].first) {
                ind1++;
            } else {
                ind2++;
            }
        }
    }
    cout << min_res << "\n";
}