#include <iostream>
#include <set>
#include <algorithm>
using namespace std;
const int MAXN=5e5+10;
const int INF=1e9+10;
multiset <int> ms;
pair <int,int> p[MAXN];
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    for (int i=0;i<n;i++) {
        cin >> p[i].first >> p[i].second;
        ms.insert(p[i].second);
    }
    sort(p,p+n);
    int ans=INF;
    for (int i=0;i<n-1;i++) {
        ms.erase(ms.find(p[i].second));
        ans=min(ans,abs(p[i].first-(*ms.rbegin())));
        ans=min(ans,abs(p[n-1].first-p[i].second));
    }
    ms.clear();
    for (int i=0;i<n;i++) {
        swap(p[i].first,p[i].second);
        ms.insert(p[i].second);
    }
    sort(p,p+n);
    for (int i=0;i<n-1;i++) {
        ms.erase(ms.find(p[i].second));
        ans=min(ans,abs(p[i].first-(*ms.rbegin())));
        ans=min(ans,abs(p[n-1].first-p[i].second));
    }
    cout << ans << endl;
    return 0;
}