#include <iostream>
#include<vector>
#include<algorithm>
#include<math.h>
#include<set>
#include<iomanip>
using namespace std;
long long md1 = 200720071,p1 = 37;
int n;
vector<long long>tr;
vector<long long>st;
void build(int p, int l, int r) {
    if (l == r - 1) {
        tr[p] = (long long)l * st[l]%md1;
        return;
    }
    build(2 * p + 1, l, (l + r) / 2);
    build(2 * p + 2,(l + r) / 2,r);
    tr[p] = tr[2 * p + 1] + tr[2 * p + 2];
    tr[p] %= md1;
}
void ch(int p, int l, int r, int i, long long k) {
    if (l > i or r <= i) {
        return;
    }
    if (l == r - 1) {
        tr[p] = (long long)k* st[l] % md1;
        return;
    }
    ch(2 * p + 1, l, (l + r) / 2,i,k);
    ch(2 * p + 2, (l + r) / 2, r,i,k);
    tr[p] = tr[2 * p + 1] + tr[2 * p + 2];
    tr[p] %= md1;
}
long long get(int p, int l, int r, int a, int b) {
    if (l >= b or r <= a) {
        return 0;
    }
    if (l >= a and r <= b) {
        return tr[p];
    }
    return (get(2 * p + 1, l, (l + r) / 2, a, b)+ get(2 * p + 2,(l + r) / 2,r, a, b))%md1;
}
bool cmp(int l1, int r1, int l2, int r2) {
    if (l1 > l2) {
        swap(l1, l2);
        swap(r1, r2);
    }
    long long k = get(0, 0, n, l1, r1) * st[l2 - l1] % md1;
    return (k == get(0, 0, n, l2, r2));
}
long long md = 1e9 + 7;
vector<vector<int>>r;
vector<bool>used;
vector<int>tin, tout;
vector<int>p;
vector<int>par;
int tm1 = 0;
long long ans = 1;
long long bnup(long long h, long long a) {
    if (h == 0) {
        return 0;
    }
    if (a == 0) {
        return 1;
    }
    if (a == 1) {
        return h;
    }
    if (a % 2 == 0) {
        return bnup((h * h) % md, a/2);
    }
    else {
        return h * bnup(h, a - 1)%md;
    }
}
void dfs(int i) {
    used[i] = true;
    tin[i] = tm1; tm1++;
    for (auto j : r[i]) {
        if (!used[j]) {
            dfs(j);
        }
    }
    tout[i] = tm1; tm1++;
}
vector<int> go(int a, int b) {
    vector<int>ans;
    ans.push_back(a);
    while (tin[a] > tin[b] or tout[a] < tout[b]) {
        ans.push_back(p[a]);
        a = p[a];
    }
    vector<int>ans1;
    ans1.push_back(b);
    while (b!=a) {
        ans1.push_back(p[b]);
        b = p[b];
    }
    for (int j = ans1.size() - 2; j >= 0; j--) {
        ans.push_back(ans1[j]);
    }
    return ans;
}
int get_par(int i) {
    if (par[i] == i) {
        return i;
    }
    par[i] = get_par(par[i]);
    return par[i];
}
vector<long long>lm, rm;
vector<vector<int>>adept;
void pr(int a, int b) {
    if (adept[get_par(b)].size() > adept[get_par(a)].size()) {
        swap(a, b);
    }
    if (get_par(a) != get_par(b)) {
        a = get_par(a); b = get_par(b);
        long long l1 = max(lm[a], lm[b]);
        long long r1 = min(rm[a], rm[b]);
        r1 = max(r1, l1 - 1);
        ans *= bnup(rm[a] - lm[a] + 1, md - 2);
        ans %= md;
        ans *= bnup(rm[b] - lm[b] + 1, md - 2);
        ans %= md;
        ans *= (r1 - l1 + 1);
        ans %= md;
        lm[a] = l1, rm[a] = r1;
        for (auto i : adept[b]) {
            adept[a].push_back(i);
            ch(0, 0, n, i, a);
        }
        par[b] = a;
        
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<pair<long long, long long>>a(n);
    multiset<long long>q;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first>>a[i].second;
        q.insert(a[i].second);
        a[i].second *= -1;
    }
    
    sort(a.begin(), a.end());
    long long mx = -1;
    long long mn = 1e15;
    int i = n - 1;
    for (int j = n - 1; j >= 1; j--) {
        while (i>=0 and a[i].first > a[j - 1].first) {
            mx = max(mx, -a[i].second);
            q.erase(q.find(-a[i].second));
            i--;
        }
        if (j <= i){
            q.erase(q.find(-a[j].second));
        }
        mn = min(abs(mx - a[j - 1].first), mn);
        auto t = q.lower_bound(a[j - 1].first);
        if (t != q.end()) {
           mn = min(abs(max(mx,*t) - a[j - 1].first), mn);
        }
        if (q.size() and t != q.begin()) {
            t--;
           mn = min(abs(max(mx, *t) - a[j - 1].first), mn);
        }
        if (j <= i) {
            q.insert(-a[j].second);
        }
    }
    for (int j = 0; j < n - 1; j++) {
        mn = min(mn, abs(-a[j].second - a[n - 1].first));
    }
    cout << mn;
}