#include <iostream>
#include <vector>
#include <queue>
#include <cmath>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <random>
#include <algorithm>
#include <numeric>

using namespace std;

//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC target("avx,avx2,popcnt")

//#define DEBUG

#define all(x) x.begin(), x.end()
#define nl '\n'

#ifdef DEBUG

#define deb(x) cout << #x << '=' << x << ' '
#define debnl(x) cout << #x << '=' << x << endl
#define name(x) cout << #x << endl;
#define print(a) { cout << #a << endl; for (auto x: a) cout << x << ' '; cout << endl; }
#define print2d(a) { cout << #a << endl; for (auto x: a) {for (auto y: x) cout << y << ' '; cout << endl;} cout << endl; }
#define printpair(a) { cout << #a << endl; for (auto x: a) cout << '(' << x.first << ' ' << x.second << ") "; cout << endl; }

#else

#define deb(x)
#define debnl(x)
#define name(x)
#define print(a)
#define print2d(a)
#define printpair(a)

#endif

typedef pair<int, int> ii;
typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef vector<ii> vii;
typedef vector<vii> vvii;
typedef vector<vvii> vvvii;
typedef vector<ll> vll;
typedef vector<vll> vvll;
typedef vector<vvll> vvvll;
typedef vector<char> vc;
typedef vector<vc> vvc;
typedef vector<vvc> vvvc;

//mt19937_64 rnd;

void fastIO() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
}

const int INF = 1e9 + 1;

void solve();

signed main() {
	int T = 1;
	//cin >> T;
	while (T--) {
		solve();
	}
}


void solve() {
	int n;
	cin >> n;
	vii a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].first >> a[i].second;
	}

	sort(all(a));

	vi suf(n + 1);
	suf[n] = 0;

	for (int i = n - 1; i >= 0; i--) {
		suf[i] = max(a[i].second, suf[i + 1]);
	}

	int ans = INF;
	set<int> s;
	for (int i = 0; i < n; i++) {
		if (i > 0) s.insert(a[i - 1].second);
		int x = a[i].first;
		if (i < n - 1) ans = min(ans, abs(suf[i + 1] - x));

		auto it = s.lower_bound(x);
		if (it != s.begin()) {
			auto it2 = --it;
			ans = min(ans, abs(x - max(suf[i + 1], *it2)));
		}
		if (it != s.end()) {
			ans = min(ans, abs(x - max(suf[i + 1], *it)));
		}
		deb(i); debnl(ans);
	}
	cout << ans << nl;


}
