
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>
#include <random>
#include <cmath>
#include <bitset>
#include <deque>

#define pll pair<long long, long long>
#define ll long long
#define ft first
#define sd second
#define sll set<long long>
#define msll multiset<long long> 
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define vll vector<ll>
#define ve vector
#define mp make_pair
#define INF (ll)1e18

using namespace std;

ll n;
ve<pll> a;

void solve() {
	cin >> n;

	a.resize(n);
	
	for (int i = 0; i < n; i++) {
		cin >> a[i].ft >> a[i].sd;
	}

	sort(all(a));

	ll prev = -1;
	ll cnt = 1;
	sll kk2, kk1;
	ll ans = INF;
	vll pref(n, -INF);

	pref[n - 1] = a[n - 1].sd;

	for (int i = n - 2; i >= 0; i--) {
		pref[i] = max(pref[i + 1], a[i].sd);
	}

	for (int i = 0; i < n; i++) {
		if (a[i].ft != prev) {
			cnt = 1;
		}
		else {
			cnt++;
		}

		if (cnt > 1) {
			kk1.insert(a[i].sd);
			kk2.insert(-a[i].sd);
		}

		ll t1 = -INF, t2 = -INF;

		if (kk1.lower_bound(a[i].ft) != kk1.end()) {
			t1 = *kk1.lower_bound(a[i].ft);
		}

		if (kk2.lower_bound(-a[i].ft) != kk2.end()) {
			t2 = -*kk2.lower_bound(-a[i].ft);
		}
		
		ll t3 = -INF;
		if (i + 1 < n) {
			t3 = pref[i + 1];
		}

		t1 = max(t1, t3);
		t2 = max(t2, t3);

		ans = min({ ans, abs(a[i].ft - t1), abs(a[i].ft - t2) });

		if (cnt == 1) {
			kk1.insert(a[i].sd);
			kk2.insert(-a[i].sd);
		}
	}

	cout << ans << "\n";

}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif 

	solve();

	return 0;
}
