#include <bits/stdc++.h>

using namespace std;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    solve();
    cout << endl;
    return 0;
}

#define int long long
#define endl '\n'
const int N = 1e5 + 100, INF = 1e15;
struct kibet {
    int a, b;
};

bool cmp(kibet a, kibet b) {
    if (a.a != b.a) {
        return a.a < b.a;
    }
    return a.b < b.b;
}

void solve() {
    int n;
    cin >> n;
    vector<kibet> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].a >> a[i].b;
    }
    sort(a.rbegin(), a.rend(), cmp);
    int ans = INF, mx = -1;
    for (int i = 0; i < n; i++) {
        int bliz = INF, pos = -1;
        for (int j = i+1; j < n; j++) {
            if (a[j].b > mx) {
                bliz = min(bliz, abs(a[j].b - a[i].a));
            }
        }
        if (bliz == INF) {
            if (mx != -1) {
                ans = min(ans, abs(a[i].a - mx));
            }
        } else {
            ans = min(ans, bliz);
            if (mx != -1) {
                ans = min(ans, abs(a[i].a - mx));
            }
        }
        mx = max(mx, a[i].b);
    }
    cout << ans << endl;
}