#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

const int N = 1e6;
const int A = 26;
string s[N];
string t;

int tr[A][N], go[A][N], suf[N], par[N], term[N], let[N];
int SZ = 1;

void add(int i) {
    int u = 1;
    for (auto c : s[i]) {
        if (tr[c - 'a'][u] == 0) tr[c - 'a'][u] = ++SZ;
        u = tr[c - 'a'][u];
        let[u] = c - 'a';
    }
    term[u]++;
}

void build() {
    queue<int> q;
    q.push(1);
    suf[1] = par[1] = 1;
    while (q.size()) {
        int u = q.front();
        q.pop();
        suf[u] = suf[par[u]];
        if (u != 1 && tr[let[u]][suf[u]] != 0 && tr[let[u]][suf[u]] != u) {
            suf[u] = tr[let[u]][suf[u]];
        }
        term[u] += term[suf[u]];
        if (u != 1) {
            for (int c = 0; c < A; ++c) {
                if (tr[c][u]) go[c][u] = tr[c][u];
                else go[c][u] = go[c][suf[u]];
            }
        } else {
            for (int c = 0; c < A; ++c) {
                if (tr[c][u]) go[c][u] = tr[c][u];
                else go[c][u] = 1;
            }
        }
        for (int c = 0; c < A; ++c) {
            if (tr[c][u]) {
                par[tr[c][u]] = u;
                q.push(tr[c][u]);
            }
        }
    }
}

int d[5 * N], dd[5 * N];
int all = 0;

void process() {
    int u = 1;
    for (int i = 0; i < t.size(); ++i) {
        u = go[t[i] - 'a'][u];
        d[i] = term[u];
        all += term[u];
    }
}

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, m;
    cin >> n >> m;
    cin >> t;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    {
        for (int i = 0; i < n; ++i) {
            add(i);
        }
        build();
        process();
        for (int i = t.size() - 1; i; --i) d[i - 1] += d[i];
        for (int i = 0; i < t.size(); ++i) swap(d[i], dd[i]);
        for (int i = 0; i <= SZ; ++i) {
            suf[i] = par[i] = let[i] = term[i] = 0;
            for (int c = 0; c < A; ++c) {
                go[c][i] = tr[c][i] = 0;
            }
        }
        SZ = 1;
        all = 0;
    }
    reverse(all(t));
    for (int i = 0; i < n; ++i) reverse(all(s[i]));
    {
        for (int i = 0; i < n; ++i) {
            add(i);
        }
        build();
        process();
        for (int i = t.size() - 1; i; --i) d[i - 1] += d[i];
        for (int i = 0; i < t.size(); ++i) swap(d[i], dd[i]);
        for (int i = 0; i <= SZ; ++i) {
            suf[i] = par[i] = let[i] = term[i] = 0;
            for (int c = 0; c < A; ++c) {
                go[c][i] = tr[c][i] = 0;
            }
        }
        SZ = 1;
    }
    reverse(dd, dd + t.size());
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        cout << all - (l > 0 ? dd[l - 1] : 0) - d[r + 1] << '\n';
    }

}

void solve() {
}