#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    if (n <= 5000) {
        int ans = 1e9;
        for (int i = 0; i < n; ++i) {
            int max_b = 0;
            for (int k = 0; k < n; ++k) {
                if (a[k] > a[i])
                    max_b = max(max_b, b[k]);
            }
            ans = min(ans, abs(a[i] - max_b));
            for (int k = 0; k < n; ++k) {
                if (k == i) continue;
                ans = min(ans, abs(a[i] - max(max_b, b[k])));
            }
        }
        cout << ans;
    }
    else {
        int max1 = 0, max2 = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] > max1) {
                max2 = max1;
                max1 = a[i];
            }
            else if (a[i] > max2) {
                max2 = a[i];
            }
        }
        cout << max1 - max2;
    }

    return 0;
}