﻿#include <iostream>
#include <random>
#include <vector>
#include<string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <math.h>
#include <queue>
#include <deque>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

int INF = 1e9 + 7;

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
mt19937 rnd(time(0));

signed main()
{
	fast;
	int n; cin >> n;
	vector<pii> v(n);
	for (int i = 0; i < n; ++i) {
		int x, y;
		cin >> x >> y;
		v[i] = { x, y };
	}

	sort(all(v));

	vector<int> a(n), b(n);
	for (int i = 0; i < n; ++i) {
		a[i] = v[i].first;
		b[i] = v[i].second;
	}

	vector<int> suf(n, 0);

	suf[n - 1] = b[n - 1];
	for (int i = n - 2; i >= 0; --i)
		suf[i] = max(suf[i + 1], b[i]);

	set<int> s;
	int ans = abs(a[0] - suf[1]);

	for (int i = 1; i < n - 1; ++i) {
		int a0 = a[i];
		s.insert(b[i - 1]);

		auto it = upper_bound(s.begin(), s.end(), a0);

		int r = suf[i + 1];

		int b_max = INF;
		if (it != s.end()) b_max = (*it);
		int b_min = -INF;
		if (it != s.begin()) b_min = *(--it);

		if (r >= a0) {
			ans = min(ans, abs(r - a0));
		}
		else {
			int mini = max(r, b_min);
			ans = min(ans, min(abs(a0 - mini), abs(b_max - a0)));
		}
	}

	for (int i = 0; i < n - 1; ++i)
		ans = min(ans, abs(a[n - 1] - b[i]));

	cout << ans;
}