// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <ranges>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
using namespace __gnu_pbds;
typedef tree<int, null_type, less<>, rb_tree_tag,
tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int ll

bool comp(pll &a, pll &b) {
    return a.F < b.F || a.F == b.F && abs(a.F - a.S) > abs(b.F - b.S);
}

void solve() {
    const int inf = INT_MAX - 10;
    int n;
    cin >> n;
    vector<pll> a(n);
    int mx_r = 0, mx_l = 0, cnt_l = 0, cnt_r = 0;
    for (auto &i : a) {
        cin >> i.F >> i.S;
        if (i.F > mx_l) {
            mx_l = i.F;
            cnt_l = 1;
        } else if (i.F == mx_l) {
            cnt_l++;
        }
        if (i.S > mx_r) {
            mx_r = i.S;
            cnt_r = 1;
        } else if (i.S == mx_r) {
            cnt_r++;
        }
    }
    sort(all(a), comp);
    vector<int> mx(n, -inf);
    for (int i = n - 1; i >= 1; i--)
        mx[i - 1] = max(mx[i], a[i].S);
    int res = inf;
    for (int i = 0; i < n; i++) {
        if (cnt_l > 1 || a[i].F != mx_l) {
            res = min(res, abs(a[i].S - mx_l));
        }
        if (cnt_r > 1 || a[i].S != mx_r) {
            res = min(res, abs(a[i].F - mx_r));
        }
    }
    ordered_set seen;
    for (int i = 0; i < n; i++) {
        int cur = mx[i];
        vector<int> add;
        int pos = seen.order_of_key(a[i].F);
        if (!seen.empty())
            add.pb(*(seen.find_by_order(pos)));
        if (pos > 0) add.pb(*(seen.find_by_order(pos - 1)));
        if (pos < seen.size()) add.pb(*(seen.find_by_order(pos + 1)));
        res = min(res, abs(a[i].F - cur));
        for (auto x : add)
            if (x > cur)
                res = min(res, abs(a[i].F - x));
        seen.insert(a[i].S);
    }
    cout << res << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    //    cin >> t;
    while (t--)
        solve();
    return 0;
}