#include <iostream>
#include <iomanip>

#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>

#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cmath>

using namespace std;

int main()
{
	int n;
	cin >> n;
	
	vector<int> a(n);
	vector<pair<int, int>> b(n);
	for (int i = 0; i < n; ++i)
	{
		cin >> a[i] >> b[i].first;
		b[i].second = i;
	}

	priority_queue<pair<int, int>> pq;
	for (int i = 0; i < n; ++i)
		pq.push({ a[i], i });

	sort(b.begin(), b.end());
	vector<int> c(n);
	for (int i = 0; i < n; ++i)
		c[i] = b[i].first;
		

	int mast = 0;
	int min_ans = INT_MAX;
	while (!pq.empty())
	{
		pair<int, int> v = pq.top();
		pq.pop();

		int ind = lower_bound(c.begin(), c.end(), v.first) - c.begin();
		if (b[ind].second != v.second)
		{
			min_ans = min(min_ans, min(abs(max(mast, b[max(0, ind - 1)].first) - v.first), 
									   abs(max(mast, b[max(0, ind    )].first) - v.first)));
		}
		else
		{
			min_ans = min(min_ans, min(abs(max(mast, b[max(0    , ind - 1)].first) - v.first),
									   abs(max(mast, b[min(n - 1, ind + 1)].first) - v.first)));
		}

		mast = max(mast, b[v.second].first);
	}

	cout << min_ans;
}
