#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
#else
#define debug(x...) 7
#endif
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}


void solve_case() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; i++) cin >> a[i] >> b[i];
    int ans = inf;
    for (int rep = 0; rep < 2; rep++) {
        vector<int> ord(n);
        iota(ord.begin(), ord.end(), 0);
        sort(ord.begin(), ord.end(), [&](int left, int right){
            return b[left] < b[right] || (b[left] == b[right] && a[left] < a[right]);
        });
        multiset<int> st(a.begin(), a.end());
        for (int i : ord) {
            st.erase(st.find(a[i]));
            if (!st.empty()) {
                chmin(ans, abs(*st.rbegin() - b[i]));
            }
        }
        swap(a, b);
    }
    cout << ans << "\n";
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    int T = 1;
    while (T--) {
        solve_case();
    }
    return 0;
}