#ifdef WIN64
    #define _GLIBCXX_DEBUG
#endif // WIN64
#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple
#define isz(x) (int) x.size()
#define xx first
#define yy second

#ifdef WIN64
    #define check(x) cerr << (#x) << " = " << x << "\n"
    template<class T> void print(T* ar, int sz) {
        for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
        cerr << "\n";
    }
#else
    #define check(x) 17
    template<class T> void print(T* ar, int sz) {}
#endif // WIN64

const int N = (int) 5e5 + 1;
const int INF = (int) 1e9 + 117;
const int MOD = (int) 1e9 + 7;
const long long INFll = (long long) 2e18 + 117;
const double EPS = 1e-8;

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> inmin(T& x, T y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
}

template<class T> inmax(T& x, T y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
}

#define int long long

using Pt = pair<int, int>;
using ll = long long;

int n, a[N], b[N];

int solve1() {
    bool ok = 1;
    for (int i = 0; i < n; ++i) if (a[i] != b[i]) ok = 0;

    if (ok) {
        sort(a, a + n);
        int ans = INF;
        for (int i = 1; i < n; ++i) inmin(ans, a[i] - a[i - 1]);
        cout << ans << "\n";
        return 0;
    }

    if (ok) {
        cout << "0\n";
        return 0;
    }

    int ans = INF;

    check(ans);

    for (unsigned mask = 1; mask < (1 << n); ++mask) {
        int mxa = 0, mxb = 0;

        for (int i = 0; i < n; ++i) {
            if ((mask >> i) & 1) {
                inmax(mxa, a[i]);
                inmax(mxb, b[i]);
            }
        }

        inmin(ans, abs(mxa - mxb));
        check(ans);
    }

    cout << ans << "\n";
    return 0;
}

int solve() {
    return 0;
}

signed main() {
#ifdef WIN64
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WIN64
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        assert(cin >> n);
        for (int i = 0; i < n; ++i) assert(cin >> a[i] >> b[i]);
        solve1();
    }
    return 0;
}
