#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
typedef std::pair<int, int> pii;

#define mt_seed chrono::high_resolution_clock::now().time_since_epoch().count()
#define time_now chrono::high_resolution_clock::now()
#define time_res(s, f) chrono::duration_cast<chrono::milliseconds>(f - s).count()
#define fast ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
#define pb push_back
#define ff first
#define sc second
#define str string
#define file_in freopen("input.txt", "r", stdin);
#define file_out freopen("output.txt", "w", stdout);
#define all(a) a.begin(), a.end()
#define sz(a) (int)a.size()

using namespace std;
using namespace __gnu_pbds;

template<typename T, typename T1> istream& operator>>(istream& in, pair<T, T1> &a) { in >> a.ff >> a.sc; return in; }
template<typename T, typename T1> ostream& operator<<(ostream& out, pair<T, T1> a) { out << a.ff << " " << a.sc; return out; }
template<typename T> istream& operator>>(istream& in, vector<T> &a) { for (auto &el : a) in >> el; return in; }
template<typename T> ostream& operator<<(ostream& out, vector<T> a) { for (auto el : a) out << el << " "; return out; }
template<typename T> T min(T a, T b, T c) { return min(min(a, b), c); }
template<typename T> T max(T a, T b, T c) { return max(max(a, b), c); }
template<typename T> T min(T a, T b, T c, T d) { return min(min(a, b), min(c, d)); }
template<typename T> T max(T a, T b, T c, T d) { return max(max(a, b), max(c, d)); }
mt19937 gen(mt_seed); int randint(int l, int r) { uniform_int_distribution<> random(l, r); return random(gen); }
const int RANDOM = mt_seed; struct chash { int operator()(int x) const {return x ^ RANDOM; }};

struct cmp {
    bool operator()(int a, int b) const {
        return a > b;
    }
};

int main() {
    fast
//    file_in

    int n;
    cin >> n;
    vector<pii> a(n);
    cin >> a;
    sort(all(a));

    set<int> q1;
    set<int, cmp> q2;

    vector<int> suf_max(n);
    suf_max[n - 1] = a[n - 1].sc;
    for (int i = n - 2; i >= 0; --i)
        suf_max[i] = max(suf_max[i + 1], a[i].sc);

    vector<int> ans(n);
    ans[0] = abs(a[0].ff - suf_max[1]);
    for (int i = 1; i < n; ++i) {
        q1.insert(a[i - 1].sc);
        q2.insert(a[i - 1].sc);
        if (i == n - 1) {
            int lower = -1e9;
            if (q2.lower_bound(a[i].ff) != q2.end())
                lower = *q2.lower_bound(a[i].ff);
            int bigger = -1e9;
            if (q1.lower_bound(a[i].ff) != q1.end())
                bigger = *q1.lower_bound(a[i].ff);
            ans[i] = min(abs(a[i].ff - bigger), abs(a[i].ff - lower));
        } else {
            int mx = suf_max[i + 1];
            ans[i] = abs(a[i].ff - mx);
            if (a[i].ff <= mx) continue;
            int lower = mx;
            if (q2.lower_bound(a[i].ff) != q2.end())
                lower = max(mx, *q2.lower_bound(a[i].ff));
            int bigger = mx;
            if (q1.lower_bound(a[i].ff) != q1.end())
                bigger = max(mx, *q1.lower_bound(a[i].ff));
            ans[i] = min(ans[i], abs(a[i].ff - bigger), abs(a[i].ff - lower));
        }
    }

    int res = 1e9;
    for (int i = 0; i < n; ++i)
        res = min(res, ans[i]);
    cout << res;
    return 0;
}