#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<string>
#include<math.h>
#include<bitset>
#include<random>

using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'
using ll = long long;
using ld = long double;

const int N = 1e6 + 9, X = 1 << 20, M = 1e9 + 7;
const long long INF = 1e18 + 9;

int a[N], b[N];
int n;
int suf[N];
int calc(vector<pair<int, int>> v) {
	sort(all(v));
	for (int i = n - 1; i >= 0; i--) {
		suf[i] = max(suf[i + 1], v[i].second);
	}
	set<int> s;
	int res = INF;
	for (int i = 0; i < n; i++) {
		
		if(suf[i + 1] >= v[i].first) {
			res = min(res, suf[i + 1] - v[i].first);
		}
		else {
			auto next = s.lower_bound(v[i].first);
			if (next != s.end()) {
				res = min(res, *next - v[i].first);
			}
			if (s.size() && next != s.begin()) {
				res = min(res, v[i].first - *prev(next));
			}
		}
		s.insert(v[i].second);
	}
	return res;
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	
	
	cin >> n;
	vector < pair<int, int>> v(n);
	for (int i = 0; i < n; i++) {
		cin >> v[i].first >> v[i].second;
	}
	cout << calc(v);

}