#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

#define int long long
#define double long double

using namespace std;

const int MAXN = 201'000;
const long long inf = 1e18;

signed main() {
    ios_base::sync_with_stdio((0)); cin.tie(0); cout.tie(0);
    cout << setprecision(11) << fixed;
    int n; cin >> n;
    vector <int> a(n), b(n);
    vector <pair<int, int> > c, d;
    for (int i = 0; i < n; i ++){
        cin >> a[i] >> b[i];
        c.push_back({a[i], i});
        d.push_back({b[i], i});
    }
    sort(c.begin(), c.end());
    sort(d.begin(), d.end());
    int ans = inf;
    set <pair<int, int>> r;
    set <pair<int, int>> t; for (auto i : d) t.insert(i);
    for (int i = n - 1; i >= 0; i --){
        t.erase({b[c[i].second], c[i].second});
        int mx = -inf;
        if (r.size() && (*(--r.end())).first >= c[i].first){
            ans = min(ans, (*(--r.end())).first - c[i].first);
        }
        else{
            if (t.size()){
                auto j = t.upper_bound({c[i].first, inf});
                if (j != t.begin()) mx = max(mx, (*(--j)).first);
            }
            if (r.size()) mx = max(mx, (*(--r.end())).first);
            if (mx != -inf) ans = min(ans, c[i].first - mx);
            if (t.size() && (*(--t.end())).first >= c[i].first) ans = min(ans, (*(t.upper_bound({c[i].first, -1}))).first - c[i].first);
        }
        r.insert({b[c[i].second], c[i].second});
    }
    cout << ans;
    return 0;
}