#include <iostream>
#include <vector>
#include <set>
#include <algorithm>

using namespace std;

void chmin(int &a, int b) {
	if (a > b) a = b;
}

void chmax(int &a, int b) {
	if (a < b) a = b;
}

int main() {
	int n;
	cin >> n;
	vector<pair<int, int>> vec(n);
	for (auto &[a, b]: vec) cin >> a >> b;
	sort(vec.begin(), vec.end());
	// for (auto [a, b]: vec) cout << a << ' ' << b << endl;
	set<int> s;
	vector<int> sufmax(n);
	sufmax[n - 1] = vec[n - 1].second;
	for (int i = n - 2; i >= 0; --i) {
		sufmax[i] = max(sufmax[i + 1], vec[i].second);
	}
	vector<int> next_not_equal(n);
	next_not_equal[n - 1] = n;
	for (int i = n - 2; i >= 0; --i) {
		if (vec[i].first == vec[i + 1].first) next_not_equal[i] = next_not_equal[i + 1];
		else next_not_equal[i] = i + 1;
	}
	int ans = 1e9;
	for (int i = 0; i < n; ++i) {
		int first = vec[i].first;
		int second = 0;
		//int next_not_equal = i;
		//while (next_not_equal != n && vec[next_not_equal].first == vec[i].first) ++next_not_equal;
		if (next_not_equal[i] != n) {
			second = sufmax[next_not_equal[i]];
			chmin(ans, abs(second - first));
			// cout << "suff " << second - first << endl;
		}
		auto it = s.lower_bound(first); // first not less
		if (it != s.end() && (*it) > second) {
			chmin(ans, abs((*it) - first));
			// cout << "first not less " << (*it) - first << endl;
		}
		it = (s.upper_bound(first)); // last less
		if (it != s.begin() && (*(--it)) > second) {
			// cout << "last less " << (*it) - first << endl;
			chmin(ans, abs((*it) - first));
		}
		s.insert(vec[i].second);
		// for (int x: s) cout << x << ' ';
		// cout << endl;
	}
	cout << ans << endl;
}