#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int n;
  cin >> n;
  vector<int> a(n), b(n);
  for (int i = 0; i < n; ++i) {
    cin >> a[i] >> b[i];
  }
  vector<int> prefMx(n + 1), suffMx(n + 1);
  for (int i = 0; i < n; ++i) {
    prefMx[i + 1] = max(prefMx[i], min(a[i], b[i]));
  }
  for (int i = n - 1; i >= 0; --i) {
    suffMx[i] = max(suffMx[i + 1], min(a[i], b[i]));
  }
  int ans = INT_MAX;
  multiset<int> as, bs;
  for (int i = 0; i < n; ++i) {
    as.insert(a[i]);
    bs.insert(b[i]);
  }
  for (int i = 0; i < n; ++i) {
    if (max(prefMx[i], suffMx[i + 1]) <= a[i]) {
      int maxB = 0;
      bs.erase(bs.find(b[i]));
      auto it = bs.upper_bound(a[i]);
      if (it != bs.begin()) maxB = *prev(it);
      bs.insert(b[i]);
      ans = min(ans, a[i] - maxB);
    }
    if (max(prefMx[i], suffMx[i + 1]) <= b[i]) {
      int maxA = 0;
      as.erase(as.find(a[i]));
      auto it = as.upper_bound(b[i]);
      if (it != as.begin()) maxA = *prev(it);
      as.insert(a[i]);
      ans = min(ans, b[i] - maxA);
    }
  }
  cout << ans;
  return 0;
}
