#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define ld long double
#define all(a) a.begin(), a.end()

const long long INF = 1e18;
const long long MAXN = 1e5;
const long double EPS = 1e-10;


//----------СНМ-----------
/*
int pr[MAXN];

void add(int v) {
    pr[v] = v;
}

int get(int v) {
    if (v == pr[v]) return v;
    return get(pr[v]);
}

void union_sets(int v, int u) {
    v = get(v);
    u = get(u);
    if (v == u) return;
    pr[u] = v;
    union_sets(v, pr[u]);
}
*/

void solve() {
    int n;
    cin >> n;
    vector <pair <int, int>> a;
    vector <int> prefmax1(n, -1), prefmax2(n, -1);
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a.pb(mp(x, y));
    }
    sort(all(a));
    for (int i = 0; i < n; i++) {
        int x = a[i].first, y = a[i].second;
        if (i == 0) prefmax1[i] = x, prefmax2[i] = y;
        else prefmax1[i] = max(prefmax1[i - 1], x), prefmax2[i] = max(prefmax2[i - 1], x);
    }
    vector <int> suffmax1(n, -1), suffmax2(n, -1);
    suffmax1[n - 1] = a[n - 1].first, suffmax2[n - 1] = a[n - 1].second;
    for (int i = n - 2; i >= 0; i--) {
        suffmax1[i] = max(suffmax1[i + 1], a[i].first);
        suffmax2[i] = max(suffmax2[i + 1], a[i].second);
    }

    multiset <int> cur;
    for (int i = 0; i < n; i++) cur.insert(a[i].second);

    int ans = INF;
    for (int i = n - 1; i >= 0; i--) {
        int mx = -1;
        if (i + 1 < n) mx = suffmax2[i + 1];
        int tmp = INF;
        if (mx >= a[i].first) tmp = mx - a[i].first;
        else {
            cur.erase(cur.lower_bound(a[i].second));

            int first = *cur.upper_bound(a[i].first);
            int second = INF;
            if ((--cur.upper_bound(a[i].first)) != cur.begin()) second = *(--cur.upper_bound(a[i].first));
            int third = INF;
            if ((++cur.upper_bound(a[i].first)) != cur.end()) third = *(++cur.upper_bound(a[i].first));
            if (first < mx) first = INF;
            if (second < mx) second = INF;
            if (third < mx) third = INF;

            //for (auto at: cur) cout << at << " ";
            //cout << endl;
            //cout << first << " " << second << " " << third << endl;
            tmp = min(min(abs(a[i].first - first), abs(a[i].first - second)), abs(a[i].first - third));
            cur.insert(a[i].second);
        }
        //cout << tmp << endl;
        ans = min(ans, tmp);
    }
    cout << ans << endl;
}


signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    solve();
}