#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define endl "\n"
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif


const int INF = 2e9 + 10;


int n;
vec<int> a, b, sorted;


bool check(int d) {
    int ma = sorted.back();
    int cnt = count(all(a), ma);
    int le = ma - d, ri = ma;
    for (int i = 0; i < n; ++i) {
        if (le <= b[i] && b[i] <= ri) {
            if (cnt >= 2) return true;
            if (a[i] != ma) return true;
        }
    }

    ma = sorted[n - 2];
    le = ma - d, ri = ma;
    for (int i = 0; i < n; ++i) {
        if (a[i] <= ma) continue;
        if (le <= b[i] && b[i] <= ri)
            return true;
    }

    return false;

}


signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    cin >> n;
    a.resize(n); b.resize(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i] >> b[i];
    sorted = a;
    sort(all(sorted));

    int l = -1, r = INF;
    while (r > l + 1) {
        int mid = (l + r) / 2;
        if (check(mid)) r = mid;
        else l = mid;
    }
    int ans = r;

    swap(a, b);
    sorted = b; sort(all(b));
    l = -1, r = INF;
    while (r > l + 1) {
        int mid = (l + r) / 2;
        if (check(mid)) r = mid;
        else l = mid;
    }
    ans = min(ans, r);

    cout << ans;
}