#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()

using namespace std;
typedef long long ll;

template<typename T>
istream& operator>>(istream& in, vector<T>& v) {
    for (auto& u: v) in >> u;
    return in;
}

pair<int, int> get_near(int val, set<int>& x) {
    auto itmo = x.lower_bound(val);
    pair<int, int> res = {-1, -1};
    if (itmo != x.end()) res.second = *itmo;
    if (itmo != x.begin()) res.first = *(--itmo);
    return res;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n; cin >> n;
    vector<pair<int, int>> q(n), opt(n);
    set<int> x;
    for (int i = 0; i < n; ++i) {
        cin >> q[i].first >> q[i].second;
    }
    sort(all(q));
    for (int i = 0; i < n; ++i) {
        opt[i] = {-2, -2};
        if (i == n - 1 || q[i].first != q[i + 1].first) {
            if (i > 0 && q[i].first == q[i - 1].first)
                for (int j = i; q[j].first == q[i].first && j >= 0; --j) x.insert(q[j].second);
            opt[i] = get_near(q[i].first, x);
            if (i == 0 || q[i].first != q[i - 1].first) x.insert(q[i].second);
        }
    }
    vector<int> suf(n + 1);
    suf[n] = -1;
    for (int i = n - 1; i >= 0; --i) {
        suf[i] = max(suf[i + 1], q[i].second);
    }
    int ans = INT32_MAX;
    for (int i = 0; i < n; ++i) {
        if (opt[i].first == -2) continue;
        int val = suf[i + 1];
        if (opt[i].first != -1 and (val == -1 || abs(q[i].first - val) > abs(q[i].first - max(val, opt[i].first))))
            val = opt[i].first;
        if (opt[i].second != -1 and (val == -1 || abs(q[i].first - val) > abs(q[i].first - max(val, opt[i].second))))
            val = opt[i].second;
        assert(val != -1);
        ans = min(ans, abs(q[i].first - val));
    }
    cout << ans;
}