#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define ld long double
#define pi pair<int, int>
#define int long long
mt19937 MT(179);
const int INF = 1e9 + 7;
vector<int> a;
vector<int> b;
bool cmp1(int i, int j) {
    return a[i] > a[j];
}
void solve() {
    int N = 0; cin >> N;
    a.assign(N, 0);
    b.assign(N, 0);
    for(int i = 0; i < N; ++i) {
        cin >> a[i] >> b[i];
    }
    vector<int> ind; ind.assign(N, 0);
    iota(ind.begin(), ind.end(), 0ll);
    sort(ind.begin(), ind.end(), cmp1);
    multiset<int> already_bought;
    multiset<int> lft;
    for(int i = 0; i < N; ++i) {
        lft.insert(b[i]);
    }
    int cur_ans = INF;
    for(int j = 0; j < N; ++j) {
        int cur_ind = ind[j];
        lft.erase(lft.find(b[cur_ind]));
        int ans = INF;
        auto it1 = lft.lower_bound(a[cur_ind]);
        if(it1 != lft.end()) ans = min(ans, *it1 - a[cur_ind]);
        if(it1 != lft.begin()) {
            it1--; ans = min(ans, a[cur_ind] - *it1);
        }
        if(!already_bought.empty()) {
            int tmp1 = -1;
            tmp1 = max(tmp1, abs(*already_bought.begin() - a[cur_ind]));
            tmp1 = max(tmp1, abs(*already_bought.rbegin() - a[cur_ind]));
            ans = min(ans, tmp1);
        }
        cur_ans = min(cur_ans, ans);
        if(j == N - 1) break;
        if(a[ind[j + 1]] == a[cur_ind]) {
            lft.insert(b[cur_ind]);
        } else {
            already_bought.insert(b[cur_ind]);
            int val = a[cur_ind];
            int it = j - 1;
            while(it >= 0 && a[ind[it]] == val) {
                already_bought.insert(b[ind[it]]);
                lft.erase(lft.find(b[ind[it]]));
                it--;
            }
        }
    }
    cout << cur_ans << "\n";
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    while(T--) {
        solve();
    }
    return 0;
}
/*
 3
6 1
5 2
4 3
 */
