#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <algorithm>
#include <cmath>
#include <iomanip>

#define int long long

using namespace std;

void solve()
{
    int n;
    cin>>n;
    vector <pair<int, int> > prices(n);
    multiset <int> kek, kek2;
    for (int i=0; i<n; i++)
    {
        cin>>prices[i].first>>prices[i].second;
        kek.insert(prices[i].second);
    }
    sort(prices.begin(),prices.end());
    int minans=1e9;
    for (int i=0; i<n; i++)
    {
        kek.erase(kek.find(prices[i].second));
        int need=-1;
        if (kek.size())  need=*(kek.rbegin());
        minans=min(minans,abs(prices[i].first-need));
        if (kek2.size())
        {
            auto it=kek2.upper_bound(prices[i].first);
            if (it!=kek2.end() and *it>need)
            {
                minans=min(minans,abs(prices[i].first-*it));
            }
            if (it!=kek2.begin() and *(--it)>need)
            {
                minans=min(minans,abs(prices[i].first-*it));
            }
        }
        kek2.insert(prices[i].second);
    }
    cout<<minans<<"\n";
}

signed main() {
    int t=1;
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    //cin>>t;
    while (t--)
    {
        solve();
    }
}