#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>

using namespace std;

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int inf = 1e18;

int n;
vector<pair<int, int> > a;
bool test_case_4 = true;

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i ++){
        cin >> a[i].first >> a[i].second;
        if (a[i].first != a[i].second)
            test_case_4 = false;
    }

    if (test_case_4){
        sort(rall(a));
        cout << a[0].first - a[1].second;
        return 0;
    }

    int ans = inf;
    for(int i = 0; i < n; i ++){
        int ma = -inf;
        int mi = -inf;
        for(int j = 0; j < n; j ++){
            if (i == j)
                continue;
            if (a[j].first > a[i].first){
                mi = max(a[j].second, mi);
            }
            if (abs(a[i].first - ma) > abs(a[i].first - a[j].second))
                ma = a[j].second;
        }
        if (ma < mi)
            ma = mi;
        ans = min(ans, abs(a[i].first - ma));
    }

    cout << ans;
}
