#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) (a.size())

#define line cout<<'\n'

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 2e5 + 100;

//vector <int> tree[]

void solve() {
    int n;
    cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; i++)
        cin >> a[i] >> b[i];

    vector <pair<int, int>> p(n + 1), v(n + 1);
    for (int i = 0; i < n; i++) {
        p[i + 1] = {a[i], b[i]};
        v[i + 1] = {b[i], a[i]};
    }

    vector <int> mxp(n + 2), mxv(n + 2), sufp(n + 2), sufv(n + 2);
    sort(all(p));
    sort(all(v));
    vector <int> P(n + 1), V(n + 1);
    for (int i = 1; i <= n; i++)
        P[i] = p[i].first, V[i] = v[i].first;

    for (int i = 1; i <= n; i++) {
        mxp[i] = max(mxp[i - 1], p[i - 1].second);
        mxv[i] = max(mxv[i - 1], v[i - 1].second);
    }

    for (int i = n; i >= 1; i--) {
        sufp[i] = max(sufp[i + 1], p[i].second);
        sufv[i] = max(sufv[i + 1], v[i].second);
    }
    sufp[n + 1] = -inf;

    map<int, int> mp;
    for (auto x : a)
        mp[x]++;

    int ans = inf;
    for (int i = 1; i <= n; i++) {
        ans = min(ans, abs(P[i] - sufp[i + 1]));
        for (int j = 1; j <= i; j++) {
            if (j == i && mp[P[i]] == 1) continue;
            if (p[j].second >= sufp[i + 1])
                ans = min(ans, abs(p[j].second - P[i]));
        }
    }

//    int u = 0;
//    if (P[n - 2] != P[n - 1]) u++;
//    for (int i = 0; i < n; i++) {
//        if (u == 1 && a[i] == P[n - 1]) continue;
//        ans = min(ans, abs(P[n - 1] - b[i]));
//    }

    cout << ans;


}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}