#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

int ask(int n) {
	cout << "? " << n << endl;
	int ans; cin >> ans;
	if (ans == -1) exit(0);
	return ans;
}

void solve() {
	int n; cin >> n;
	vector <pair <int, int>> v(n);
	for (auto& [a, b] : v) cin >> a >> b;
	sort(all(v));

	vector <pair <int, int>> p;
	for (int i = 0; i < n; ++i) {
		p.push_back({ v[i].second, i });
	}
	sort(all(p));

	int ans = 1e15;
	int mx = -1e15;
	int j = n;
	for (int i = n - 1; i >= 0; --i) {
		while (j > 0 && v[j - 1].first > v[i].first) {
			--j;
			mx = max(mx, v[j].second);
		}

		int cl = 1e15;
		for (int j = 0; j < n; ++j) {
			if (j != i && v[j].second >= mx && abs(v[i].first - v[j].second) < abs(v[i].first - cl)) {
				cl = v[j].second;
			}
		}
		ans = min(ans, abs(v[i].first - cl));

		/*int l = lower_bound(all(p), pair <int, int>(v[i].first, -100)) - p.begin() - 1;
		int r = lower_bound(all(p), pair <int, int>(v[i].first, -100)) - p.begin();
		if (l >= 0 && p[l].second == i) --l;
		if (r < p.size() && p[r].second == i) ++r;

		if (l >= 0 && p[l].first >= mx) {
			ans = min(ans, abs(v[i].first - p[l].first));
		}
		if (r < p.size() && p[r].first >= mx) {
			ans = min(ans, abs(v[i].first - p[r].second));
		}
		ans = min(ans, abs(v[i].first - mx));*/
	}

	cout << ans;
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}