#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <iomanip>
#include <cassert>
#include <algorithm>
#include <set>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(a) (a).begin(), (a).end()


const int INF = 1e9 + 179;

bool cmp(pii a, pii b) {
    if (a.second < b.second)
        return true;
    return false;
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    set<int> pend;
    vector<int> f;
    vector<pii> s;

    for (int i = 0; i < n; ++i) {
        int a, b;
        cin >> a >> b;
        f.push_back(a);
        s.push_back({ b, a });
    }

    sort(all(s), cmp);
    sort(all(f));

    vector<int> ms = { -INF };

    for (int i = n - 1; 0 <= i; --i) {
        ms.push_back(max(ms.back(), s[i].first));
    }

    for (auto elem : ms) {
        cout << elem << ' ';
    }
    cout << '\n';

    reverse(all(ms));

    int less = -INF, answ = INF;
    for (int i = 0; i < n; ++i) {
        answ = min(answ, abs(ms[i + 1] - f[i]));
        set<int> help = pend;
        for (auto elem : pend) {
            if (elem <= f[i]) {
                help.erase(elem);
                less = min(less, elem);
            } else {
                answ = min(answ, abs(elem - f[i]));
                break;
            }
        }
        answ = min(answ, abs(less - f[i]));
        pend = help;
        pend.insert(s[i].first);
    }

    cout << answ;

    return 0;
}
