#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }

const int N = 5e5 + 100;

int s;
int t[2 * N];

inline void build() { fill(t, t + 2 * s, -iinf); }
inline void upd(int i, int x) {
    chmax(t[i += s], x);
    while (i > 1) {
        t[i >> 1] = max(t[i], t[i ^ 1]);
        i >>= 1;
    }
}
inline int get(int l, int r) {
    int res = -iinf;
    l += s, r += s + 1;
    while (l < r) {
        if (r & 1) chmax(res, t[--r]);
        if (l & 1) chmax(res, t[l++]);
        l >>= 1, r >>= 1;
    } return res;
}

inline int get(const int &n, ve<pii> a, ve<pii> b) {
    sort(all(a)), sort(all(b));
    ve<int> last(n);

    s = n; build();
    for (int i = 0, ptr = 0; i < n; ++i) {
        while (ptr < n && b[ptr].fi <= a[i].fi) {
            upd(b[ptr].se, ptr);
            ++ptr;
        }

        const auto &[x, ii] = a[i];
        int ps = max(get(0, ii - 1), get(ii + 1, s - 1));

        last[i] = (ps == -iinf ? -1 : ps);
    }

    ve<int> used(n);
    int sum = 0, cur = -1;

    int answer = iinf;

    for (int i = 0; i < n; ++i) {
        sum += (!used[a[i].se]);
        ++used[a[i].se];

        while (cur < last[i]) {
            sum += (!used[b[cur + 1].se]);
            ++used[b[cur + 1].se];
            ++cur;
        }
        while (cur > last[i]) {
            sum -= (used[b[cur].se] == 1);
            --used[b[cur].se];
            --cur;
        }

        if (sum == n && cur >= 0) {
            chmin(answer, a[i].fi - b[last[i]].fi);
        }
    }
    return answer;
}

inline void solve() {
    int n;
    cin >> n;
    ve<pii> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].fi >> b[i].fi;
        a[i].se = b[i].se = i;
    }

    int answer = iinf;

    chmin(answer, get(n, a, b));
    for (int i = 0; i < n; ++i) swap(a[i].fi, b[i].fi);
    chmin(answer, get(n, a, b));

    cout << answer;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
