#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

const int INF = 0x3f3f3f3f;

void solve() {
    int n, ans = INF;
    cin >> n;

    vector<pair<int, int>> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> b[i].first;
        a[i].second = b[i].second = i;
    }

    int l = -INF;
    for (int i = 0; i < n; ++i) {
        l = max(l, min(a[i].first, b[i].first));
    }

    sort(a.begin(), a.end());
    sort(b.begin(), b.end());

    int j = 0;
    for (int i = 0; i < n; ++i) {
        if (a[i].first < l) continue;
        while (j + 1 < n && b[j + 1].first <= a[i].first) {
            j++;
        }
        if (a[i].second == b[j].second) {
            j--;
        }
        if (j >= 0) {
            ans = min(ans, a[i].first - b[j].first);
        }
    }

    j = 0;
    for (int i = 0; i < n; ++i) {
        if (b[i].first < l) continue;
        while (j + 1 < n && a[j + 1].first <= b[i].first) {
            j++;
        }
        if (b[i].second == a[j].second) {
            j--;
        }
        if (j >= 0) {
            ans = min(ans, b[i].first - a[j].first);
        }
    }

    cout << ans << "\n";
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}