#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

const ll mod = 998244353;

const ll INF = 1e18;

vector<ll> used, a, b;
ll ans = INF;

void gen(ll i, ll n, ll mx1, ll mx2) {
    if (i == n) {
        if (mx1 == -1 || mx2 == -1) {
            return;
        }
        ans = min(ans, abs(mx2 - mx1));
        return;
    }
    for (ll d = 0; d < n; d++) {
        if (!used[d]) {
            used[d] = 1;
            gen(i + 1, n, max(mx1, a[d]), mx2);
            gen(i + 1, n, mx1, max(mx2, b[d]));
            used[d] = 0;
        }
    }
}

void solve() {
    ll n;
    cin >> n;
    a.resize(n);
    b.resize(n);
    used.resize(n);
    bool f = true;
    for (ll i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] != b[i]) {
            f = false;
        }
    }
    if (f) {
        vector<ll> p = a;
        sort(p.begin(), p.end());
        cout << p[n - 1] - p[n - 2];
        return;
    }
    gen(0, n, -1, -1);
    cout << ans;
    a.clear();
    b.clear();
    used.clear();
    ans = INF;
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}