#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

const ll mod = 998244353;

const ll INF = 1e18;

void solve() {
    ll n;
    cin >> n;
    vector<ll> a(n), b(n);
    bool f = true;
    for (ll i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        if (a[i] != b[i]) {
            f = false;
        }
    }
    if (f) {
        vector<ll> p = a;
        sort(p.begin(), p.end());
        cout << p[n - 1] - p[n - 2];
        return;
    }
    ll ans = INF;
    for (ll i = 0; i < n; i++) {
        ll mx1 = a[i];
        ll mx2 = -1;
        for (ll j = 0; j < n; j++) {
            if (a[j] > mx1) {
                mx2 = max(mx2, b[j]);
            }
        }
        if (mx2 == -1) {
            ll d = INF;
            for (ll j = 0; j < n; j++) {
                if (i == j) {
                    continue;
                }
                if (abs(b[j] - mx1) < d) {
                    d = abs(b[j] - mx1);
                    mx2 = b[j];
                }
            }
        }
        ans = min(ans, abs(mx2 - mx1));
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}