#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
#define double long double
const int N = 1e6, C = 1000, K = 28, INF = 0x3f3f3f3f;
const double EPS = 1e-5;

/*
random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);
*/

struct hash_str {
    int P, M, n;
    vector<int> p, power;

    void init(string &s, int Pr, int Mod) {
        P = Pr;
        M = Mod;
        n = (int) s.size();
        p.resize(n + 1);
        power.resize(n + 1);
        power[0] = 1;
        for (int i = 1; i <= n; i++) {
            power[i] = (power[i - 1] * P) % M;
        }
        for (int i = 1; i <= n; i++) {
            p[i] = (p[i - 1] + (int) (s[i - 1] - 'a') * power[i]) % P;
        }
    }

    int subhash(int l, int r) {
        int val = (p[r] - p[l] + M) % M;
        val = (val * power[n - r]) % M;
        return val;
    }

    bool comp(int l1, int r1, int l2, int r2) {
        if (r2 - l2 != r1 - l1)
            return false;
        return subhash(l1, r1) == subhash(l2, r2);
    }
};



void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n), b(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i].fi >> b[i].fi;
        a[i].se = i;
        b[i].se = i;
    }
    multiset<int> ms;
    ms.insert(-INF);
    ms.insert(INF);
    for (int i = 0; i < n; i++) {
        ms.insert(b[i].fi);
    }
    sort(all(a));
    reverse(all(a));
    int maxb = 0, ans = INF;
    for (int i = 0; i < n; i++) {
        int m1 = a[i].fi, val = b[a[i].se].fi;
        ms.erase(ms.find(val));
        auto q1 = ms.lwb(m1),
        q2 = q1;
        q2--;
        int x = *q1, y = *q2;
        x = max(x, maxb);
        y = max(y, maxb);
        ans = min(ans, abs(m1 - x));
        ans = min(ans, abs(m1 - y));
        maxb = max(maxb, val);
    }
    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //cout << fixed << setprecision(15);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}