#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <string>
#include <vector>
#include <climits>

#define sz(a) int((int)a.size())

//#define int long long

using namespace std;

vector<int> a, b;

bool can(int mx_a_at, int mx_b_at) {
   int mx_a = a[mx_a_at], mx_b = b[mx_b_at];
   for (int i = 0; i < a.size(); ++i) {
       if (a[i] > mx_a && b[i] > mx_b && i != mx_a_at && i != mx_b_at) {
           return false;
       }
   }
   return true;
}

void solve() {
    int n;
    cin >> n;
    a.resize(n);
    b.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    int ans = 2e9;
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            if (i == j) {
                continue;
            }
            if (can(i, j)) {
                ans = min(ans, abs(a[i] - b[j]));
                //cout << i << ' ' << i << ' ' << ans << '\n';
                if (ans == 0) {
                    cout << 0;
                    return;
                }
            }
        }
    }
    cout << ans;
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}