#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
using namespace std;
#define int long long
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }
    sort(v.begin(), v.end());
    vector<int> suf(n);
    suf[0] = 0;
    for (int i = 1; i < n; i++) {
        suf[i] = max(suf[i - 1], v[n - i].second);
    }
    set<int> have;
    int mn = 1e12;
    for (int i = 0; i < n; i++) {
        if (suf[n - i - 1] > v[i].first) {
            mn = min(mn, abs(suf[n - i - 1] - v[i].first));
        } else {
            auto it = lower_bound(have.begin(), have.end(), v[i].first);
            if (it != have.end()) {
                mn = min(mn, abs(*it - v[i].first));
            }
            if (it != have.begin()) {
                it--;
                mn = min(mn, abs(*it - v[i].first));
            }
        }
        have.insert(v[i].second);
    }
    cout << mn;
}

/*
/home/olymp/PreDay/cmake-build-debug/PreDay
5
1 1 2 2
2 4
1 3
1 3
2 4
4 4
4
1 1 2 2
1 2 2 1
 3 4 4 3
 3 4 3 5
 */