#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

signed main(){
    Fast();
    int n;
    cin >> n;
    vector <pair <int, int>> p(n);
    int ma = -1, ind = -1;
    for (int i = 0; i < n; i++){
        int a, b;
        cin >> a >> b;
        p[i] = {a, b};
    }
    sort(p.begin(), p.end());
    vector <int> suf(n);
    for (int i = n - 1; i > -1; i--){
        if (i == n - 1){
            suf[i] = p[i].second;
        }else{
            suf[i] = max(p[i].second, suf[i + 1]);
        }
    }
    int ans = INF;
    for (int i = 0; i < n - 1; i++){
        ans = min(ans, abs(p[i].first - suf[i + 1]));
    }
    int m = -1;
    for (int i = 0; i < n - 1; i++){
        ans = min(ans, abs(p.back().first - p[i].second));
    }
    ans = min(ans, abs(p.back().first - m));
    cout << ans;
    return 0;
}