#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);

const int INF = 1e9 + 7;


void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (auto &[a, b] : v) {
        cin >> a >> b;
    }
    int mn = INF;
    for (int mask = 0; mask < (1 << n); mask++) {
        int mxa = 0, mxb = 0;
        for (int i = 0; i < n; i++) {
            if (mask >> i & 1) mxa = max(mxa, v[i].F);
            else mxb = max(mxb, v[i].S);
        }
        mn = min(mn, abs(mxb - mxa));
    }
    cout << mn << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}