#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int naive(vector<int> a, vector<int> b){
	int n = a.size();
	int res = 1e9;
	for (int mask = 0; mask < (1 << n); mask++){
		vector<int> mx(2);
		for (int i = 0; i < n; i++){
			if (bool(mask & (1 << i))){
				mx[1] = max(mx[1], b[i]);
			} else {
				mx[0] = max(mx[0], a[i]);
			}
		}
		res = min(res, abs(mx[0] - mx[1]));
	}
	return res;
}

int smart(vector<int> a, vector<int> b){
	int n = a.size();
	int res = 1e9;
	res = min(res, *max_element(all(a)));
	res = min(res, *max_element(all(b)));
	vector<pair<int, int>> t(n);
	for (int i = 0; i < n; i++){
		t[i] = {a[i], b[i]};
	}
	sort(all(t));
	vector<int> suff(n + 1);
	for (int i = n - 1; i >= 0; i--){
		suff[i] = max(suff[i + 1], t[i].second);
	}
	set<int> s = {0};
	for (int i = 0; i < n; i++){
		int x = t[i].first;
		int y = suff[i + 1];
		res = min(res, abs(x - y));
		if (s.upper_bound(suff[i + 1]) != s.end()){
			y = max(suff[i + 1], *s.upper_bound(suff[i + 1]));
			res = min(res, abs(x - y));
		}
		if (s.upper_bound(x) != s.end()){
			y = max(suff[i + 1], *s.upper_bound(x));
			res = min(res, abs(x - y));
		}
		auto it = s.upper_bound(x);
		if (it != s.begin()){
			it--;
			y = max(suff[i + 1], *it);
			res = min(res, abs(x - y));
		}
		s.insert(t[i].second);
	}

	return res;
}

int main(){
	srand(time(0));
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	if (0){
		int T = 1e5;
	//	cin >> T;
		while (T--){
			int n = 3;
	//		cin >> n;
			vector<int> a(n);
			vector<int> b(n);
			for (int i = 0; i < n; i++){
				a[i] = rand() % 10 + 1;
				b[i] = rand() % 10 + 1;
			}
			if (naive(a, b) != smart(a, b)){
				cout << n << "\n";
				for (int i = 0; i < n; i++){
					cout << a[i] << " " << b[i] << "\n";
				}
				break;
			}
		}
	} else {
		int T = 1;
	//	cin >> T;
		while (T--){
			int n;
			cin >> n;
			vector<int> a(n);
			vector<int> b(n);
			for (int i = 0; i < n; i++){
				cin >> a[i] >> b[i];
			}
			cout << smart(a, b) << "\n";
			#ifdef ON_PC
				cout << naive(a, b) << "\n";
			#endif // ON_PC
		}
	}
	return 0;
}
