//#pragma 'GCC-optimize'
#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(),x.end()
#define vi vector <int>
#define vvi vector <vector <int> >
#define fi(n) for (int i = 0; i < n; ++i)
#define f first
#define s second

using namespace std;

int wrong(int n, vector <pair <int, int> > a) {
    sort(a.begin(), a.end());
    int ans = 1e9;
    for (int i = 0; i < n; ++i) {
        if (a.back().f > a[i].f) {
            int mx = -1;
            for (int j = i + 1; j < n; ++j) {
                if (a[j].f > a[i].f) {
                    mx = max(mx, a[j].s);
                }
            }
            ans = min(ans, abs(a[i].f - mx));
            for (int j = 0; j < i; ++j) {
                if (a[j].s > mx) {
                    ans = min(ans, abs(a[i].f - a[j].s));
                }
            }
        }
        else {
            for (int j = 0; j < n; ++j) {
                if (i != j) {
                    ans = min(ans, abs(a[i].f - a[j].s));
                }
            }
        }
    }
    return ans;
}

int right(int n, vector <pair <int, int> > &a) {
    int ans = 1e9;
    for (int mask = 1; mask < (1<<n) - 1; mask++) {
        int ma = -1, mb = -1;
        for (int i = 0; i < n; ++i) {
            if (mask & (1<<i)) ma = max(ma, a[i].f);
            else mb = max(mb, a[i].s);
        }
        ans = min(ans, abs(ma - mb));
    }
    return ans;
}

void stress() {
    mt19937 rnd(time(nullptr));
    int n = 5;
    vector <pair <int, int> > a(n, {0, 0});
    for (int i = 0; i < n; ++i) {
        a[i].f = rnd() % 20 + 1;
        a[i].s = rnd() % 20 + 1;
    }
    int r1 = right(n, a), r2 = wrong(n, a);
    cout << "Ans: " << r1 << "  Got: " << r2 << '\n';
    if (r1 != r2) {
        cout << "a: "; for (auto x: a) cout << "{ " << x.f << " " << x.s << " } "; cout << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        // stress();
        int n; cin >> n;
        vector <pair <int, int> > a(n);
        for (int i = 0; i < n; ++i) cin >> a[i].f >> a[i].s;
        cout << wrong(n, a);
    }
    return 0;
}