//#pragma 'GCC-optimize'
#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(),x.end()
#define vi vector <int>
#define vvi vector <vector <int> >
#define fi(n) for (int i = 0; i < n; ++i)
#define f first
#define s second

using namespace std;

const int maxn = 5e5;
vector <int> t(4 * maxn), bb;

int func(int r1, int r2) {
    return max(r1, r2);
}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        t[v] = bb[l];
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    t[v] = func(t[2 * v + 1], t[2 * v + 2]);
}

int get(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return 0;
    }
    if (ql <= l && r <= qr) {
        return t[v];
    }
    int m = (l + r) / 2;
    return func(get(2 * v + 1, l, m, ql, qr), get(2 * v + 2, m, r, ql, qr));
}

vector <int> mbs(int n, vector <int> &a) {
    vector <int> b(n, n);
    stack <int> st;
    for (int i = 0; i < n; ++i) {
        while (!st.empty() && a[st.top()] < a[i]) {
            b[st.top()] = i;
            st.pop();
        }
        st.push(i);
    }
    return b;
}

int wrong(int n, vector <pair <int, int> > a) {
    sort(a.begin(), a.end());
    vector <int> A, B;
    map <int, int> M;
    for (auto x: a) {
        A.push_back(x.f);
        B.push_back(x.s);
        M[x.f]++;
        bb.push_back(x.s);
    }
    sort(all(B));
    build(0, 0, n);
    // for (int i = 0; i < 10; ++i) cout << t[i] << " "; cout << '\n';
    vector <int> _a = mbs(n, A);
    set <int> Q;
    int ans = 1e9;
    for (int i = 0; i < n; ++i) {
        if (a.back().f > a[i].f) {
            int mx = get(0, 0, n, _a[i], n);
            ans = min(ans, abs(a[i].f - mx));

            auto it = Q.upper_bound(mx);
            for (int j = 0; j < 2; ++j) {
                if (it != Q.end()) ans = min(ans, abs(a[i].f - *it));
                else break;
                it++;
            }
        }
        else {
            int l = 0, r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
                if (B[m] >= a[i].f) r = m;
                else l = m;
            }
            for (int j = l - 1; j <= r + 1; ++j) {
                if (B[j] != a[i].f || (B[j] == a[i].f && M[B[j]] > 1)) {
                    ans = min(ans, abs(a[i].f - B[j]));
                }
            }
        }
        Q.insert(a[i].s);
    }
    return ans;
}

int fake(int n, vector <pair <int, int> > &a) {
    sort(a.begin(), a.end());
    return a[n - 1].f - a[n - 2].f;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    //cin >> tests;
    tests = 1;
    while (tests--) {
        // stress();
        int n; cin >> n;
        vector <pair <int, int> > a(n);
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            cin >> a[i].f >> a[i].s;
            if (a[i].f == a[i].s) {
                cnt++;
            }
        }
        if (cnt == n) cout << fake(n, a);
        else cout << wrong(n, a);
    }
    return 0;
}