#include<bits/stdc++.h>

using namespace std;

struct Point
{
    int x,y;
    Point(){};
    Point(int xi, int yi)
    {
        x = xi;
        y = yi;
    }
};

const int maxn = 5*1e5+5;
int n;
long long a[maxn],b[maxn];
//long long dp[maxn][maxn];
//long long max1[maxn][maxn],max2[maxn][maxn];
vector<Point>v;

void read()
{
    cin >> n;
    for(int i=1;i<=n;i++)
    {
        cin >> a[i] >> b[i];
        v.push_back({a[i],b[i]});
    }
}

void solve1()
{
    long long ans = 1e9;
    long long max1,max2;
    for(int mask=1;mask<(1<<n)-1;mask++)
    {
        max1 = max2 = 0;
        for(int j=0;j<n;j++)
        {
            if(mask&(1<<j)) max1 = max(max1,a[j+1]);
            else max2 = max(max2,b[j+1]);
        }
        ans = min(ans,abs(max1-max2));
    }
    cout << ans << endl;
    exit(0);
}

bool cmp(Point p1, Point p2)
{
    if(p1.x<p2.x) return true;
    if(p1.x>p2.x) return false;
    return p1.y<p2.y;
}

void solve()
{
    sort(v.begin(),v.end(),cmp);
    int sz = v.size();
    long long maxb = -1;
    long long ans = 1e9;
    long long pom;
    for(int i=sz-1;i>=0;i--)
    {
        if(maxb== -1) pom = 1e9;
        else pom = abs(v[i].x-maxb);
        for(int j=0;j<i;j++)
        {
            if(v[j].y>maxb)
            {
                pom = min(pom,(long long)abs(v[i].x-v[j].y));
            }
        }
        ans = min(ans,pom);
        maxb = max(maxb,(long long)v[i].y);
    }
    cout << ans << endl;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
	return 0;
}

