#include <bits/stdc++.h>

#define x first
#define y second
#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    for (auto & e : arr)
        cin >> e.x >> e.y;

    sort(all(arr));
    set<int> ms;
    set<int> ms2;
    
    map<int, int> cnt;
    
    for (auto & e : arr) {
        ms.insert(e.y);
        ms2.insert(-e.y);
        ++cnt[e.y];
    }

    int u = -INF;

    int ans = INF;

    for (int i = n - 1; i >= 0; --i) {
        if (--cnt[arr[i].y] == 0) {
            ms.erase(arr[i].y);
            ms2.erase(-arr[i].y);
        }

        if (i != n - 1) {
            u = max(u, arr[i + 1].y);
        }

        auto e = ms.lower_bound(arr[i].x);
        if (e != ms.end()) {
            int val = max(*e, u);
            ans = min(ans, abs(val - arr[i].x));
        }

        auto e2 = ms2.lower_bound(-arr[i].x);
        if (e2 != ms2.end()) {
            int val = max(-(*e2), u);
            ans = min(ans, abs(val - arr[i].x));
        }
    }

    cout << ans << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}
