#include <bits/stdc++.h>

using namespace std;

using ll = long long;

vector<vector<int>> t(2e6);

void build (int v, int l, int r, vector<int>& b) {
    if (r - l == 1) {
        t[v] = {b[l]};
        return;
    }
    int m = (l + r) / 2;
    build(2 * v + 1, l, m, b);
    build(2 * v + 2, m, r, b);
    int i = 0, j = 0;
    for (; i < t[2 * v + 1].size() && j < t[2 * v + 2].size();) {
        if (t[2 * v + 1][i] < t[2 * v + 2][j]) {
            t[v].push_back(t[2 * v + 1][i]);
            ++i;
        } else {
            t[v].push_back(t[2 * v + 2][j]);
            ++j;
        }
    }
    while (i < t[2 * v + 1].size()) {
        t[v].push_back(t[2 * v + 1][i]);
        ++i;
    }
    while (j < t[2 * v + 2][j]) {
        t[v].push_back(t[2 * v + 2][j]);
        ++j;
    }
}

int getmax(int v, int l, int r, int ql, int qr) {
    if (l >= qr || r <= ql) {
        return -1;
    }
    if (l >= ql && r <= qr) {
        return t[v].back();
    }
    int m = (l + r) / 2;
    return max(getmax(2 * v + 1, l, m, ql, qr), getmax(2 * v + 2, m, r, ql, qr));
}

int main() {
    int n;
    cin >> n;
    vector<pair<int, int>> tmp(n);
    for (int i = 0; i < n; ++i) {
        cin >> tmp[i].first >> tmp[i].second;
    }
    sort(tmp.begin(), tmp.end());
    vector<int> a(n), b(n);
    for (int i  = 0; i < n; ++i) {
        a[i] = tmp[i].first;
        b[i] = tmp[i].second;
    }
    build(0, 0, n, b);
    int ans = 2e9;
    for (int i = 0; i < n; ++i) {
        if (a[i] == a.back()) {
            int good_bigger_i = lower_bound(t[0].begin(), t[0].end(), a[i]) - t[0].begin();
            if (good_bigger_i < n) {
                if (good_bigger_i == n - 1) {
                    if (b[i] != t[0][good_bigger_i]) {
                        ans = min(ans, abs(a[i] - t[0][good_bigger_i]));
                    }
                } else {
                    if (b[i] == t[0][good_bigger_i]) {
                        ans = min(ans, abs(t[0][good_bigger_i + 1] - a[i]));
                    } else {
                        ans = min(ans, abs(t[0][good_bigger_i] - a[i]));
                    }
                }
            }
            int good_less_i = good_bigger_i - 1;
            if (good_less_i >= 0) {
                if (t[0][good_less_i] != b[0]) {
                    ans = min(ans, abs(a[i] - t[0][good_less_i]));
                } else {
                    if (good_less_i != 0) {
                        ans = min(ans, abs(a[i] - t[0][good_less_i - 1]));
                    }
                }
            }
        }
        int ub_i = upper_bound(a.begin(), a.end(), a[i]) - a.begin();
        int least_good = getmax(0, 0, n, ub_i, n);
        if (least_good >= a[i]) {
            ans = min(ans, abs(least_good - a[i]));
        } else {
            int good_i = upper_bound(t[0].begin(), t[0].end(), a[i]) - t[0].begin() - 1;
            if (b[i] == t[0][good_i]) {
                ans = min(ans, abs(a[i] - t[0][good_i - 1]));
            } else {
                ans = min(ans, abs(a[i] - t[0][good_i]));
            }
        }
    }
    cout << ans;
}