#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,bmi,bmi2,fma,lzcnt,popcnt")
#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const int inf = 1e9 + 7;


//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, less<int>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


int f(const vi &a, const vi &b) {
    int n = a.size();

    vi pref(n);
    pref[0] = a[0];

    for (int i = 1; i < n; i++) {
        pref[i] = max(pref[i-1], a[i]);
    }

    int sufmaxA = 0;
    int sufmaxB = 0;
    int ans = inf;

    for (int i = n-1; i >= 1; i--) {
        ans = min(ans, abs(max(pref[i-1], sufmaxA) - max(b[i], sufmaxB)));

        if (a[i] < b[i]) {
            sufmaxA = max(sufmaxA, a[i]);
        } else {
            sufmaxB = max(sufmaxB, b[i]);
        }
    }

    return ans;

}


void solve() {
    int n;
    cin >> n;

    vi a(n);
    vi b(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    int ans = min(f(a, b), f(b, a));
    cout << ans << '\n';
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}


