#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;


int get(int mx, int a){
    if (mx == -1){
        return 0;
    }
    return abs(mx - a);
}

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> b[i];
        a[i].second = i;
    }
    int l = -1;
    int r = 1e9;
    sort(a.rbegin(), a.rend());
    int j = a[0].second;

    while (r - l > 1){
        int m = (l + r) / 2;
        set<pair<int, int>> bb;
        int mx = -1;
        for (int i = 0; i < n; ++i) {
            bb.insert({b[i], i});
        }
        bool fff = false;
        for (auto [aa, i] : a){
            bb.erase({b[i], i});
            if (mx != -1 && get(mx, aa) <= m){
                fff = true;
                break;
            }
            auto it = bb.lower_bound({aa - m, 0});
            if (it != bb.end() && get(max(mx, it->first), aa) <= m){
                fff = true;
                break;
            }
            mx = max(mx, aa);
        }
        if (fff){
            r = m;
        } else{
            l = m;
        }
    }
    cout << r << endl;


#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}