#include <iostream>
#include<iomanip>
#include <numeric>
#include<cmath>
#include<vector>
#include<map>
#include <queue>
#include<initializer_list>
typedef long long ll;
using namespace std;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;

#define INF 1999999999

void solve2() {
	int n; cin >> n;
	vector<pair<int, int>> workmass;
	vector<vector<int>> mass;
	for (int i = 0; i < n; i++) {
		int a, b; cin >> a >> b;
		workmass.push_back(make_pair(a, b));
		mass.push_back({b, 1, i});
		mass.push_back({a, 0, i});
	}
	sort(mass.begin(), mass.end());
	int lower_delta = 0; bool zero_find=0, one_find=0;
	int counter_zn = 0, count_idx = -1;
	for (int i = 0; i < n; i++) {
		if (lower_delta == min(workmass[i].first, workmass[i].second)) {
			counter_zn++;
			if (workmass[i].first == min(workmass[i].first, workmass[i].second)) zero_find = 1;
			if (workmass[i].second == min(workmass[i].first, workmass[i].second)) one_find = 1;
		}
		else if(lower_delta < min(workmass[i].first, workmass[i].second)){
			counter_zn = 1; count_idx = i;
			zero_find = 0, one_find = 0;
			lower_delta = max(lower_delta, min(workmass[i].first, workmass[i].second));
			if (workmass[i].first == min(workmass[i].first, workmass[i].second)) zero_find = 1;
			if (workmass[i].second == min(workmass[i].first, workmass[i].second)) one_find = 1;
		}

	}
	int ans = INF, tempoans;
	int from_a = INF, from_b = INF;
	int prev_from_a = INF,  prev_from_b = INF;
	int idx_a = 987654321, idx_b = 123456789;
	for (int i = 2*n - 1; i >= 0; i--) {
		if (mass[i][0] < lower_delta) {
			int znach_a = -1, znach_b = -1;
			for (int j = i; j >= 0; j--) {
				if (mass[j][1] == 1 && (counter_zn > 1|| mass[j][2] != count_idx))znach_b = max(znach_b, mass[j][0]);
				else if(counter_zn > 1 || mass[j][2] != count_idx) znach_a = max(znach_a, mass[j][0]);
			}
			if (zero_find && znach_b!=-1) 
				ans = min(ans, lower_delta - znach_b);
			if (one_find && znach_a != -1)
				ans = min(ans, lower_delta - znach_a);
			
			break;
		}
		if (mass[i][1] == 1) {
			prev_from_b = from_b;
			from_b = mass[i][0];
			idx_b = mass[i][2];
		}

		if (mass[i][1] == 0) {
			prev_from_a = from_a;
			from_a = mass[i][0];
			idx_a = mass[i][2];
		}
		if (idx_b != idx_a)
			ans = min(ans, abs(from_a - from_b));
		else
			ans = min(ans, min(abs(prev_from_a - from_b), abs(prev_from_b - from_a)));
	}
	cout << ans;
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); solve2();
}