#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int n;
	cin >> n;
	map<int, vector<ll>>arr;
	for (int i = 0; i < n; i++) {
		int a, b;
		cin >> a >> b;
		arr[a].push_back(b);
	}
	vector<int>a(arr.size());
	vector<vector<ll>>vars(arr.size());
	vector<ll>suf(arr.size());
	int i = 0;
	for (auto& x : arr) {
		a[i] = x.first;
		vars[i] = x.second;
		sort(vars[i].begin(), vars[i].end());
		++i;
	}
	for (int i = int(arr.size()) - 2; i >= 0; i--) {
		for (ll x : vars[i + 1])
			suf[i] = max(suf[i], x);
	}
	ll ans = 1e18;
	set<int>have;
	for (int i = 0; i < arr.size(); i++) {
		if (suf[i] >= a[i]) {
			ans = min(ans, abs(a[i] - suf[i]));
		}
		else {
			ll v1 = 1e18, v2 = 1e18, me1 = 1e18, me2 = 1e18;
			auto it = have.upper_bound(a[i]);
			if (it != have.end())
				v1 = *it;
			if (it != have.begin()) {
				--it;
				v2 = *it;
			}
			auto it_me = upper_bound(vars[i].begin(), vars[i].end(), a[i]);
			if (it_me != vars[i].end()) {
				me1 = *it_me;
			}
			if (it_me != vars[i].begin()) {
				it_me--;
				me2 = *it_me;
			}
			ll best = v1;
			if (abs(a[i] - v2) < abs(a[i] - best))
				best = v2;
			if (abs(a[i] - me1) < abs(a[i] - best))
				best = me1;
			if (abs(a[i] - me2) < abs(a[i] - best))
				best = me2;
			best = max(best, suf[i]);
			ans = min(ans, abs(a[i] - best));
		}
		for (auto x : vars[i])
			have.insert(x);
	}
	cout << ans;
	return 0;
}