#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
//#include <iomanip>
//#include <map>
//#include <random>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/rope>

using namespace std;
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
//mt19937 rnd(459);

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define __GLIBCXX_DEBUG
#define debug(x) cout << #x << ":\t" << x << endl
#define debugb(b, x) cout << b << x << endl
#else
#define debug(x) ;
#define debugb(b, x) ;
#endif

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll))
        end_char = ' ';
    if (typeid(T) == typeid(ld))
        end_char = '\t';
    for (const T& e :vec) {
        out << e << end_char;
    }
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool mini(T& a, const T& b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */



signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef DUDE
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<pair<int, int>> p(n);
    for (int i = 0; i < n; ++i) {
        cin >> p[i].first >> p[i].second;
    }
    sort(all(p));
    int res = 1e9 + 1;
    set<int> pref;
    vector<int> bigger(n);
    int v = 0;
    for (int i = n - 1; i >= 0; --i) {
        bigger[i] = v;
        maxi(v, p[i].second);
    }
    for (int i = 0; i < n && res > 0; ++i) {
        int a = p[i].first;
        int b = bigger[i];
        mini(res, abs(b - a));
        if (b < a) {
            auto it = pref.lower_bound(a);
            if (it != pref.end()) {
                mini(res, abs(a - *it));
            }
            if (it != pref.begin()) {
                mini(res, abs(a - *prev(it)));
            }
        }
        pref.insert(p[i].second);
    }
    cout << res;
    return 0;
}
