#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    vector<ll> mn, mx;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        if (a[i].first > a[i].second) swap(a[i].first, a[i].second);
        mn.push_back(a[i].first);
        mx.push_back(a[i].second);
    }
    sort(mn.begin(), mn.end());
    sort(mx.begin(), mx.end());
    ll ans = 1e18;
    for (int i = 0; i < n; ++i) {
        ll cnt = upper_bound(mn.begin(), mn.end(), a[i].first) - mn.begin();
        --cnt;
        if (cnt >= n - 1) {
            ans = min(ans, mn[cnt] - mn[cnt - 1]);
            ll v = upper_bound(mx.begin(), mx.end(), a[i].first) - mx.begin();
            if (v) {
                --v;
                if (a[i].first == a[i].second) --v;
                if (v >= 0)ans = min(ans, mn[cnt] - mx[v]);
            }
        }
        cnt = upper_bound(mn.begin(), mn.end(), a[i].second) - mn.begin();
        --cnt;
        if (cnt >= n) {
            if (a[i].second == a[i].first) ans = min(ans, a[i].second - mn[cnt - 2]);
            else ans = min(ans, a[i].second - mn[cnt - 1]);
            ll v = upper_bound(mx.begin(), mx.end(), a[i].second) - mx.begin();
            if (v >= 2) {
                v -= 1;
                ans = min(ans, mx[v] - mx[v - 1]);
            }
        }
    }
    cout << ans;
}