#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n;
    cin >> n;
    vector<pair<ll, ll>> a(n);
    vector<ll> b, c;
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
        b.push_back(a[i].first);
        c.push_back(a[i].second);
    }
    sort(b.begin(), b.end());
    sort(c.begin(), c.end());
    ll ans = 1e18;
    vector<ll> pref(n), suf(n);
    for (int i = 0; i < n; ++i) {
        pref[i] = min(a[i].first, a[i].second);
        if (i) pref[i] = max(pref[i], pref[i - 1]);
    }
    for (int i = 0; i < n; ++i) {
        if (a[i].first >= pref[n - 1]) {
            ll v = upper_bound(c.begin(), c.end(), a[i].first) - c.begin();
            --v;
            if (v >= 0) ans = min(ans, a[i].first - c[v]);
        }
        if (a[i].second >= pref[n - 1]){
            ll v = upper_bound(b.begin(), b.end(), a[i].second) - b.begin();
            --v;
            if (v >= 0) ans = min(ans, a[i].second - b[v]);
        }
    }
    cout << ans;
}