#include <bits/stdc++.h>
#define newline cout << '\n'
#define f first
#define s second
#define all(x) x.begin(), x.end()


using namespace std;
typedef long long ll;
typedef long double ld;


const int inf = 2e9;
const int logn = 22;
const int nmax = 1e5 + 5;
const ll linf = 2e18;
mt19937 rnd(time(0));


bool cmp(pair<int, int> a, pair<int, int> b) {
	return (a.s < b.s || (a.s == b.s && a.f >= b.f));
}


void display(multiset<ll> &l) {
	for (auto it = l.begin(); it != l.end(); ++it) {
		cout << *it << ' ';
	}
	newline;
}


void solve() {
	int n;
	cin >> n;

	ll ans = linf, tmp = linf;
	vector<pair<ll, ll>> a(n);
	unordered_map<ll, ll> cnt;

	for (int i = 0; i < n; ++i) {
		cin >> a[i].f >> a[i].s;
		cnt[a[i].s]++;
	}

	sort(all(a), cmp);

	vector<ll> max_suf(n + 1, 0);
	for (int i = n - 1; i > -1; --i) {
		max_suf[i] = max(max_suf[i + 1], a[i].f);
	}

	for (int i = 0; i < n - 1; ++i) {
		tmp = abs(a[i].s - max_suf[i + 1]);
		ans = min(ans, tmp);
	}

	ll max_val = a[n - 1].s;
	for (int i = 0; i < n; ++i) {
		if (a[i].s == max_val) {
			if (cnt[max_val] > 1) {
				ans = min(ans, abs(a[i].f - max_val));
			}
		} else {
			ans = min(ans, abs(a[i].f - max_val));
		}
	}

	cout << ans << '\n';
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
	}

	

	return 0;
}