#ifdef LOCAL
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")
#endif

#include <algorithm>
#include <bitset>
#include <complex>
#include <deque>
#include <exception>
#include <fstream>
#include <functional>
#include <iomanip>
#include <ios>
#include <iosfwd>
#include <iostream>
#include <istream>
#include <iterator>
#include <limits>
#include <list>
#include <locale>
#include <map>
#include <memory>
#include <new>
#include <numeric>
#include <ostream>
#include <queue>
#include <set>
#include <sstream>
#include <stack>
#include <stdexcept>
#include <streambuf>
#include <string>
#include <typeinfo>
#include <utility>
#include <valarray>
#include <vector>
#include <array>
#include <atomic>
#include <chrono>
#include <codecvt>
#include <condition_variable>
#include <forward_list>
#include <future>
#include <initializer_list>
#include <mutex>
#include <random>
#include <ratio>
#include <regex>
#include <scoped_allocator>
#include <system_error>
#include <thread>
#include <tuple>
#include <typeindex>
#include <type_traits>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
using namespace std;

template<typename T>
ostream& operator<<(ostream& out, const vector<T>& v) {
    for (T x : v) out << x << " ";
    return out;
}

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()
#define ll long long
#define ld long double

void solve() {

    int n;
    cin >> n;

    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++) cin >> v[i].first >> v[i].second;

    multiset<int> s;
    for (int i = 0; i < n; i++) s.insert(v[i].second);

    int mn = 2e9, mx = -1;
    for (int i = n - 1; i >= 0; i--) {
        s.erase(s.find(v[i].second));
        int l = -1, ge = -1;
        if (s.lower_bound(v[i].first) != s.end()) ge = *s.lower_bound(v[i].first);
        if (s.lower_bound(v[i].first) != s.begin()) l = *prev(s.lower_bound(v[i].first));

        if (mx == -1) {
            if (l != -1) mn = min(mn, v[i].first - l);
            if (ge != -1) mn = min(mn, ge - v[i].first);
        } else {
            mn = min(mn, abs(v[i].first - mx));
            if (l != -1 && l >= mx) mn = min(mn, v[i].first - l);
            if (ge != -1 && ge >= mx) mn = min(mn, ge - v[i].first);
        }

        mx = max(mx, v[i].second);
    }

    cout << mn;

}

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif

    cout << setprecision(10) << fixed;
    solve();

}