#include <iostream>
#include <string>
#include<vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <complex>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<vector<int> > vvi;
typedef vector<vector<ll>> vvl;
typedef vector<bool> vb;


#define all(v) v.begin(), v.end()
#define pb push_back()
/*
ll p[500005];

int pred(int a) {
    if(a != p[a])
        return p[a] = pred(p[a]);
    else return a;

}
void merge(int a, int b) {
    if(abs(rand()) % 2) {
        a = pred(a);
        p[a] = b;
    } else {
        b = pred(b);
        p[b] = a;
    }
}

bool check(int a, int b) {
    return (pred(a) == pred(b));
}
 */
/*
void build(vl & t, int v, int l, int r, vi & a) {
    if(l == r) t[v] = a[l];
    else {
        int m = (l + r) / 2;
        build(t, 2 * v, l, m, a);
        build(t, 2 * v + 1, m + 1, r, a);
        t[v] = (t[2 * v] + t[2 * v + 1]);
    }
}
int sum(vl & t, int v, int tl, int tr, int l, int r) {
    if(l == tl && r == tr) return t[v];
    // look out
    if(l > r) return 0;
    // look out
    int tm = (tl + tr) / 2;
    return sum(t, 2 * v, tl, tm, l, min(tm, r)) +
            sum(t, 2 * v + 1, tm + 1, tr, max(tm + 1, l), r);

}
void update(vl & t, int v, int tl, int tr, int pos, int x) {
    if(tl == tr) t[v] = x;
    else {
        int tm = (tl + tr) / 2;
        if(pos <= tm) update(t, 2 * v, tl, tm, pos, x);
        else update(t, 2 * v + 1, tm + 1, tr, pos, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}
*/

/*void dfs(ll v,vector<vector<pair<ll, ll>>> & g, vl & used) {
    used[v] = 1;
    for(auto u : g[v]) {
        if(used[u.first]) continue;
        dfs(u.first, g, used);
    }
}*/

const ll M = 1e9 + 7;
ll fastPow(ll a, ll n) {
    if(n == 0) return 1;
    ll bf = fastPow(a, n / 2);
    bf *= bf;
    bf %= M;
    if(n % 2) bf *= a;
    return bf % M;
}
void solve() {
    ll n;
    cin >> n;
    //vl a(n); for(int i = 0; i < n; ++i) cin >> a[i];
    vector<pair<ll, ll>> v(n); for(int i = 0; i < n; ++i) cin >> v[i].first >> v[i].second;
    set<pair<ll, ll>> a, b;
    for(int i =  0; i < n; ++i) {
        a.insert({v[i].first, i});
        b.insert({v[i].second, i});
    }
    ll ans = M;
    ll mx = 0;
    for(int j = 0 ;j < n; ++j) {
        auto it = a.end();
        it--;
        auto p = *it;
        a.erase(it);
        b.erase(make_pair(v[p.second].second, p.second));

        it = b.lower_bound({p.first, 0});
        ll res = M;
        if(it != b.end()) {
            res = abs(p.first - max(mx, (*it).first));
        }
        if(it != b.begin()) {
            it--;
            res = min(res, abs(p.first - max(mx, (*it).first)));
        }

        ans = min(ans, res);
        mx = max(mx, v[p.second].second);
    }
    cout << ans ;

    //ll ans = 0;

    // ll k; cin >> k;
    // ll a, b, c; cin >> a >> b >> c;
    //ll d; cin >> d;
    // string s; cin >> s; n = s.length();

    // cout << (ans ? "YES" : "NO");
    // cout << ans.size() << '\n';
    // for(auto x : ans) cout << x << '\n';
    // for(auto p : ans) cout << p.first << ' ' << p.second << "\n";
    cout << "\n";

}
signed main() {
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) {
        solve();
    }

    return 0;
}
