#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

int n;

int get(vector<pair<int, int>> c) {
    sort(all(c), [](const auto &x, const auto &y) {
        if (x.X == y.X) return x.Y > y.Y;
        return x.X > y.X;
    });
    multiset<int> st;
    int mn = 2e9;
    for (auto &[x, y] : c) {
        if (!st.empty()) {
            mn = min(mn, abs(x - *st.rbegin()));
        }
        st.insert(y);
    }
    return mn;
}

void solve() {
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    vector<pair<int, int>> c;
    for (int i = 0; i < n; ++i) {
        c.emplace_back(a[i], b[i]);
    }
    int ans = get(c);
    for (auto &[x, y] : c) swap(x, y);
    cout << min(ans, get(c));
}