#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;
const ll MOD = 1e9 + 7;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> v(n);
    for (auto &i: v)
        cin >> i.first >> i.second;
    std::sort(v.begin(), v.end());
    vector<int> suf(n);
    suf[n - 1] = v[n - 1].second;
    for (int i = n - 2; i >= 0; i--) {
        suf[i] = max(suf[i + 1], v[i].second);
    }
    int ans = 1e9 + 1;
    multiset<int> s;
    for (auto[a, b]: v)
        s.insert(b);
    for (auto i: v) {
        auto ndx = lower_bound(v.begin(), v.end(), pair<int, int>{i.first, 1e9 + 1}) - v.begin();
        if (ndx == n) {
            s.erase(s.find(i.second));
            if (s.lower_bound(i.first) != s.end()) ans = min(ans, abs(i.first - *s.lower_bound(i.first)));
            if (s.lower_bound(i.first) != s.begin()) ans = min(ans, abs(i.first - *(--s.lower_bound(i.first))));
            s.insert(i.second);
        } else
            ans = min(ans, abs(i.first - suf[ndx]));
    }
    cout << ans;
}