#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using ll = long long;
using vi = vector<int>;

int test = 1, n, k;
ll a;
unordered_map<int, ll> dict;
vi ans;

bool calc(int l, int r, ll ps, ll ss) {
    if (l > r)
        return true;
    if (1LL * r * (r + 1) / 2 - 1LL * l * (l - 1) / 2 == ss - ps)
        return true;
    if (l == r) {
        ans.push_back(l);
        return true;
    }
    int m = (l + r) / 2;
    ll a;
    auto it = dict.find(m);
    if (it == dict.end()) {
        cout << "? " << m << endl;
        cin >> a;
        if (a == -1)
            return false;
        dict[m] = a;
    } else {
        a = it->second;
    }
    if (!calc(l, m, ps, a))
        return false;
    if (!calc(m + 1, r, a, ss))
        return false;
    return true;
}

bool solve() {
    dict.clear();
    ans.clear();
    cin >> n >> k;
    cout << "? " << n << endl;
    cin >> a;
    if (a == -1)
        return false;
    dict[n] = a;
    if (!calc(1, n, 0, a))
        return false;
    cout << "!";
    for (int i = 0; i < k; i++)
        cout << " " << ans[i];
    cout << endl;
    cin >> a;
    return a == 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> test;
    while (test--) {
        if (!solve())
            return 0;
    }
    return 0;
}
