#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void print(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
mt19937 rnd(time(NULL));
const int inf = 1e18, MAXN = 2e5+10, mod = 998244353, mod1 = (int)1e9+7, mod2 = 1e9+1011;
const long double eps = 1e-9;

void solve() {
    int n, k; cin >> n >> k;
    vector<int> res(k);
    map<int, int> mp;
    if (k == 3) {
        cout << "? " << n << endl;
        int all_sum; cin >> all_sum;
        int l = 1, r = n+1;
        while (l+1 < r) {
            int m = (l+r)/2;
            int real_sum = n*(n+1)/2 - (m-1)*m/2;
            cout << "? " << m-1 << endl;
            int sum; cin >> sum;
            sum = all_sum-sum;
            if (sum < real_sum) l = m;
            else r = m;
        }
        res[0] = l;
        int sum2 = n*(n+1)/2 - all_sum - l;
        int val = sum2;
        sum2 /= 2;
        cout << "? " << sum2 << endl;
        int sum3; cin >> sum3;
        sum3 = (sum2+1)*sum2/2 - sum3;
        res[1] = sum3;
        res[2] = val-sum3;
        cout << "! ";
        for (auto elem : res) cout << elem << " ";
        cout << endl;
        int a; cin >> a;
        if (a == -1) exit(0);
        return;
    }
    if (k == 4) {
        vector<int> res1(k), res2(k);
        cout << "? " << n << endl;
        int all_sum; cin >> all_sum; mp[n] = all_sum;
        int l = 1, r = n+1;
        while (l+1 < r) {
            int m = (l+r)/2;
            int real_sum = n*(n+1)/2 - (m-1)*m/2;
            cout << "? " << m-1 << endl;
            int sum; cin >> sum; mp[m-1] = sum;
            sum = all_sum-sum;
            if (sum < real_sum) l = m;
            else r = m;
        }
        res1[0] = res2[0] = l;
        int sum2 = n*(n+1)/2 - all_sum - l;
        int sum3;
        if (!mp.count(sum2/3)) {
            cout << "? " << sum2/3 << endl;
            cin >> sum3;
            mp[sum2/3] = sum3;
        }
        sum3 = mp[sum2/3];
        sum3 = (sum2/3+1)*(sum2/3)/2 - sum3;
        if (sum3 <= sum2/3) {
            res1[1] = sum3;
            int sum4 = sum2-sum3;
            int sum5;
            if (!mp.count(sum4/2)) {
                cout << "? " << sum4/2 << endl;
                cin >> sum5;
                mp[sum4/2] = sum5;
            }
            sum5 = mp[sum4/2];
            sum5 = (sum4/2+1)*(sum4/2)/2 - sum5;
            if (res1[1] <= sum4/2) sum5 -= res1[1];
            res1[2] = sum5;
            res1[3] = sum4-sum5;
            if (res1[2] > sum2/3 && res1[3] > sum2/3) {
                cout << "! ";
                for (auto elem : res1) cout << elem << " ";
                cout << endl;
                int a; cin >> a;
                if (a == -1) exit(0);
                return;
            }
        }
        if (sum2-sum3 > sum2/3) {
            res2[1] = sum2-sum3;
            int sum4;
            if (!mp.count(sum3/2)) {
                cout << "? " << sum3/2 << endl;
                cin >> sum4;
                mp[sum3/2] = sum4;
            }
            sum4 = mp[sum3/2];
            sum4 = (sum3/2+1)*(sum3/2)/2 - sum4;
            if (res2[1] <= sum3/2) sum4 -= res2[1];
            res2[2] = sum4;
            res2[3] = sum3-sum4;
            if (res2[2] <= sum2/3 && res2[3] <= sum2/3) {
                cout << "! ";
                for (auto elem : res2) cout << elem << " ";
                cout << endl;
                int a; cin >> a;
                if (a == -1) exit(0);
                return;
            }
        }
        assert(0);
    }
    for (int i = 0; i<k; ++i) {
        int l = 0, r = n;
        while (l+1 < r) {
            int m = (l+r)/2;
            if (!mp.count(m)) {
                cout << "? " << m << endl;
                int sum; cin >> sum;
                mp[m] = sum;
            }
            int real_sum = (m+1)*m/2;
            for (int j = 0; j<i; ++j) {
                if (res[j] <= m) real_sum -= res[j];
            }
            if (mp[m] < real_sum) r = m;
            else l = m;
        }
        res[i] = r;
    }
    cout << "! ";
    for (auto elem : res) cout << elem << " ";
    cout << endl;
    int a; cin >> a;
    if (a == -1) exit(0);
    res.clear();
    mp.clear();
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
