#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

ll INF = 2e18;
const ll mod = 1e9 + 7;

ll ask(int p){
    cout << "? " << p << '\n';
    cout.flush();
    ll sum = 0;
    cin >> sum;
    if(sum == -1) exit(0);
    return sum;
}

gp_hash_table<int, bool> was;
gp_hash_table<int, ll> val;

void solve(){
    ll n, k;
    cin >> n >> k;
    if(n <= 1000){
        ll lst = 0;
        vector<int> res;
        for(int i = 1; i + 1 <= n; i+= 2){
            ll cc = ask(i + 1);
            if(cc - lst == 0){
                res.push_back(i);
                res.push_back(i + 1);
            } else if(cc - lst == i) res.push_back(i + 1);
            else if(cc - lst == i + 1) res.push_back(i);
            lst = cc;
        }
        if(n % 2 == 1){
            ll cc = ask(n);
            if(cc == lst) res.push_back(n);
        }
        cout << "! ";
        cout.flush();
        for(int u : res){
            cout << u << ' ';
            cout.flush();
        }
        cout << '\n';
        cout.flush();
        ll aa;
        cin >> aa;
        if(aa == -1) exit(0);
        return;
    }
    was.clear();
    ll lstpos = 0, cc = 0;
    vector<ll> ans;
    for(int i = 0; i < k; i++){
        ll l = lstpos + 1, r = n, res = -1, sm = -1;
        while(l <= r){
            ll mid = (l + r) / 2ll;
            ll u = (lstpos + 1ll + mid) * (mid - lstpos) / 2ll;
            ll pp = (was[mid] ? val[mid] : ask(mid));
            was[mid] = 1;
            val[mid] = pp;
            if(pp - cc != u){
                res = mid;
                sm = pp;
                r = mid - 1ll;
            } else l = mid + 1ll;
        }
        assert(res != -1);
        ans.push_back(res);
        lstpos = res;
        cc = sm;
    }
    cout << "! ";
    cout.flush();
    for(ll u : ans){
        cout << u << ' ';
        cout.flush();
    }
    cout << '\n';
    cout.flush();
    ll aa;
    cin >> aa;
    if(aa == -1) exit(0);
}

int main(){
    ios_base::sync_with_stdio(0);
    //cin.tie(0);
    int tt;
    cin >> tt;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "_____________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
    return 0;
}


