#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

#define int long long

int get_res() {
    int res;
    cin >> res;
    return res;
}

int ask(int p) {
    cout << "? " << p << endl;
    cout.flush();
    return get_res();
}

bool end(int res) {
    return res == -1;
}

int pref_sum(int x) {
    return x * (x + 1) / 2;
}

int answer(vector<int> &ans) {
    cout << "! ";
    for (auto i : ans) {
        cout << i << " ";
    }
    cout << endl;
    cout.flush();
    return get_res();
}

bool ended = false;

void solve() {
    int n, k;
    cin >> n >> k;
    int found_w = 0;
    int cur = 1;
    vector<int> ans;
    for (int _ = 0; _ < k; ++_) {
        int l = cur - 1;
        int r = n;
        while (r - l > 1) {
            int m = (l + r + 1) / 2;
            int res = ask(m);
            if (end(res)) {
                ended = true;
                return;
            }
            int real = pref_sum(m) - found_w;
            if (res == real) {
                l = m;
            } else {
                r = m;
            }
        }
        ans.push_back(r);
        found_w += r;
        cur = r + 1;
    }
    int res = answer(ans);
    if (end(res)) {
        ended = true;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    //freopen("input.txt", "r", stdin);
    //freopen("output.txt", "w", stdout);
    int t;
    cin >> t;
    while (t--) {
        solve();
        if (ended) return 0;
    }
}