#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 2e9 + 7;
const ld eps = 1e-9;

void solve() {
	int n, k; cin >> n >> k;
	if (k == 3) {
		cout << "? " << n << endl;
		ll sum; cin >> sum;
		sum = n * (n + 1) / 2 - sum;
		k = n / 2;
		ll sum1;
		while (true) {
			cout << "? " << k << endl;
			cin >> sum1;
			sum1 = k * (k + 1) / 2 - sum1;
			if (sum1 != sum) {
				break;
			}
			n /= 2;
			k /= 2;
		}
		int l, r;
		bool down = false;
		if (sum1 > k) {
			l = 1;
			r = k;
		}
		if (sum1 == 1) {
			l = k;
			r = n;
		}
		else {
			ll sum2; cout << "? " << sum1 - 1 << endl;
			cin >> sum2;
			if (sum2 == (sum1) * (sum1 - 1) / 2) {
				l = k;
				r = n;
			}
			else {
				l = 1;
				r = k;
				down = true;
			}
		}
		if (down) {
			while (r - l > 1) {
				int m = (r + l) / 2;
				ll t;
				cout << "? " << m << endl;
				cin >> t;
				t = m * (m + 1) / 2 - t;
				if (t == sum1) {
					r = m;
				}
				else {
					l = m;
				}
			}
			cout << "! " << sum1 - r << " " << r << " " << sum - sum1;
			cout << endl;

		}
		else {
			while (r - l > 1) {
				int m = (r + l) / 2;
				ll t;
				cout << "? " << m << endl;
				cin >> t;
				t = m * (m + 1) / 2 - t;
				if (t == sum - sum1) {
					l = m;
				}
				else {
					r = m;
				}
			}
			cout << "! " << sum1 << " " << l << " " << sum - sum1 - l << endl;
		}
		int a; cin >> a;
		if (a == -1) exit(0);
		return;
	}
	int last = 0;
	vector<int> ans;
	for (int x = 2; x <= n; x += 2) {
		cout << '?' << " " << x << endl;
		int cur; cin >> cur;
		if (cur - last == 0) {
			ans.push_back(x);
			ans.push_back(x - 1);
		}
		if (cur - last == x) {
			ans.push_back(x  - 1);
		}
		if (cur - last == x - 1) {
			ans.push_back(x);
		}
		last = cur;
	}
	if (n % 2) {
		cout << "? " << n << endl;
		int a; cin >> a;
		if (a == last) ans.push_back(n);
	}
	cout << "! ";
	for (auto& it : ans) cout << it << " ";
	cout << endl;
	int a; cin >> a;
	if (a == -1) exit(0);
	return;
}

signed main() {
	int t; cin >> t;
	for (int x = 0; x < t; x++) {
		solve();
	}
}