#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double

int getsum(int x, int y) {
    return y * (y + 1) / 2 - x * (x - 1) / 2;
}

int findans(int tl, int tr, int data) {
    int l = tl - 1, r = tr;
    while(l + 1 < r){
        int mid = (l + r) >> 1;
        cout << "? " << mid << endl;
        int x;
        cin >> x;
        x -= data;
        if (getsum(tl, mid) != x)
            r = mid;
        else
            l = mid;
    }
    return r;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    int cur_sum = 0, l = 1;
    for(int i = 0;i<k;++i){
        int pos = findans(l, n + 1, cur_sum);
        ans.push_back(pos);
        cur_sum += getsum(l, pos - 1);
        l = pos + 1;
    }
    cout << "! ";
    for(auto u: ans)
        cout << u << " ";
    cout << endl;
    int x;
    cin >> x;
    if(x != 1)
        exit(0);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
