#include <iostream>
#include <vector>
#include <map>

using namespace std;

long long n, k;
map<long long, long long> mp;

long long sm(long double x) {
    return (x * (x + 1.0) / 2.0);
}

vector<long long> ans;

void rec(long long l, long long r) {


    if (mp.find(l) == mp.end()) {
        cout <<"? " << l << endl;
        long long x;
        cin >> x;
        if (x == -1) {
            long long c = 0;
            cout << x / c;
        }
        mp[l] = x;
    }
    if (mp.find(r) == mp.end()) {
        cout <<"? " << r << endl;
        long long x;
        cin >> x;
        if (x == -1) {
            long long c = 0;
            cout << x / c;
        }
        mp[r] = x;
    }
    //cout << l << " " << r << " " << sm(r) - sm(l) << " " <<mp[r] << " " << mp[l] << endl;
    long long t = (sm(r) - sm(l)) - (mp[r] - mp[l]);
    if (t == 0) {
        return;
    }
    if (r - l == 1) {
        ans.push_back(r);
        return;
    }


    if (t <= r) {
        ans.push_back(t);
        return;
    }
    long long mid = (l + r) / 2;
    rec(l, mid);
    rec(mid, r);
}

int main()
{
    long long t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        cin >> n >> k;
        mp.clear();
        ans.clear();
        mp[0] = 0;


        long long t = 0, mx = 2;
        while (ans.size() != k) {
            rec(t, min(t + mx, n));
            t += mx;
            mx *= 2;
        }

        cout <<"! ";
        for (auto j : ans) {
            cout << j << " ";
        } cout << endl;
        long long x;
        cin >> x;
        if (x == -1) {
            long long c = 0;
            cout << x / c;
        }
    }
    return 0;
}
