#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <time.h>
using namespace std;
unordered_map<long long, long long> qs;
long long query(long long r) {
	if (qs.find(r) != qs.end()) {
		return qs[r];
	}


	cout << "? " << r << endl;
	long long t;
	cin >> t;
	if (t == -1) {
		while (true) {

		}
	}
	return qs[r] = t;
}
long long arpr(long long l) {
	return l * (l + 1) / 2;
}
vector<long long> found;
long long proc(long long l, long long r, long long total) {
	if (found.size() == total) {
		return 0;
	}
	long long m = (l + r) / 2;
	long long realsum = query(r) - query(l - 1);
	long long target = arpr(r) - arpr(l - 1);
	if (target == realsum) {
		return 0;
	}

	if (realsum == 0) {
		for (long long i = l; i <= r; i++) {
			found.push_back(i);
		}
		return 0;
	}


	if (l == r) {
		found.push_back(l);
		return 1;
	}
	long long diff = target - realsum;
	if (2 * (long long)l > diff) {
		found.push_back(diff);
		return 1;
	}
	if (rand() % 2 == 0) {
		proc(l, m, total);
		proc(m + 1, r, total);
	}
	else {
		proc(m + 1, r, total);
		proc(l, m, total);

	}
	return 0;
}

long long gdiff(long long l, long long r) {
	long long realsum = query(r) - query(l - 1);
	long long target = arpr(r) - arpr(l - 1);
	return target - realsum;
}
long long proc2(long long l, long long r,long long lean) {
	if (l == r)
		return l;

	long long m = (l + r) / 2;
	long long dr = gdiff(m + 1, r);
	long long dl = gdiff(l, m);

	if (lean == 0) {
		if (dl == 0)
			return proc2(m + 1, r, 0);
		if (dr == 0)
			return proc2(l, m, 0);
		if (dr > r) {
			return proc2(m + 1, r, -1);
		}
		else {
			return proc2(l, m, 1);
		}
	}
	if (lean == 1) {
		if (dr != 0) {
			return proc2(m + 1, r, 1);
		}
		return proc2(l,m, 1);
	}
	if (lean == -1) {
		if (dl != 0) {
			return proc2(l,m, -1);
		}
		return proc2(m + 1, r, -1);
	}

	
	
	

}




long long proc3(long long l, long long r,long long sz, long long cut) {
	if (l == r) {
		return l;
	}
	long long m = (l + r) / 2;
	long long dl = gdiff(l, m);
	long long dr = gdiff(m+1, r);
	long long L = 0;
	long long R = r - m+1;
	while (R - L > 1) {
		long long med = (L + R) / 2;
		long long ops = arpr(m + med) - arpr(m);
		if (ops <= dr) {
			L = med;
		}
		else {
			R = med;
		}
	}

	long long szr = L;
	long long szl = sz-szr;
	if (szl >= cut) {
		return proc3(l, m, szl, cut);
	}
	return proc3(m + 1, r, szr, cut - szl);

	
	
}

signed  main() {
	srand(time(0));
	long long tt;
	cin >> tt;
	for (long long t = 0; t < tt; t++) {
		qs.clear();
		long long n, k;
		cin >> n >> k;
		qs[0] = 0;
		vector<long long> ans(k);
		
		for (long long i = 1; i < k; i+=2) {
			ans[i] = proc3(1, n, k, i+1);
		}
		for (long long j = 0; j < k; j+=2) {
			long long ll = 1;
			if (j != 0) {
				ll = ans[j - 1]+1;
			}
			long long rr = n;
			if (j != n-1) {
				rr = ans[j + 1] - 1;
			}
			ans[j] = gdiff(ll, rr);
		}
		cout << "! ";
		for (auto h : ans) {
			cout << h << ' ';
		}
		cout << endl;
		long long aa;
		cin >> aa;
		if (aa == -1)
			return 0;
	}
	return 0;

}