#include <bits/stdc++.h>

using namespace std;

map<int, long long> used;

long long ask_query(int pos) {
    if (used.count(pos)) {
        return used[pos];
    }
    cout << "? " << pos << endl;
    cin >> used[pos];
    return used[pos];
}

long long get_segm(int l, int r) {
    return ask_query(r) - ask_query(l - 1);
}

long long get_ans_segm(int l, int r) {
    if (r < l) {
        return 0;
    }
    return (l + r) * 1LL * (r - l + 1) / 2;
}

vector<int> ans;

int n, k;

int check_vals(int l, int r) {
    long long sum = get_segm(l, r);
    long long sum_ans = (l + r) * 1LL * (r - l + 1) / 2;
    if (sum == sum_ans) {
        return 0;
    }
    if (sum == 0) {
        return r - l + 1;
    }
    for (int i = 1; i <= k && i <= r - l; ++i) {
        if (sum + get_ans_segm(r - i + 2, r) < sum_ans && sum + get_ans_segm(l, l + i) > sum_ans) {
            return i;
        }
    }
    return -1;
}

long long solve_vals(int l, int r, int k) {
    if (k == -1) {
        return 0;
    }
    if (k == 0) {
        return 0;
    }
    long long sum = get_segm(l, r);
    long long sum_ans = get_ans_segm(l, r);
    long long sumk = sum_ans - sum;
    if (k == 1) {
        ans.push_back(sumk);
        return sumk;
    }
    int centr = sumk / k;
    return solve_vals(l, centr, check_vals(l, centr)) + solve_vals(centr + 1, r, check_vals(centr + 1, r));
}

long long solve(int l, int r) {
    long long sum = get_segm(l, r);
    long long sum_ans = (l + r) * 1LL * (r - l + 1) / 2;
    if (sum == 0) {
        long long ret = 0;
        for (int i = l; i <= r; ++i) {
            ans.push_back(i);
            ret += i;
        }
        return ret;
    }
    if (check_vals(l, r) != -1) {
        return solve_vals(l, r, check_vals(l, r));
    }
    int m = (l + r) / 2;
    long long add = 0;
    add += solve(l, m);
    if (sum + add + m + 1 <= sum_ans) {
        add += solve(m + 1, r);
    }
    return add;
    // solve(l, m);
    // solve(m + 1, r);
}

void solve() {
    used.clear();
    used[0] = 0;
    ans.clear();
    cin >> n >> k;
    solve(1, n);
    cout << "! ";
    for (int i = 0; i < (int)ans.size(); ++i) {
        cout << ans[i] << ' ';
    }
    cout << endl;
    int ans_nw;
    cin >> ans_nw;
    if (ans_nw == -1) {
        exit(0);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
