#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define inf (ll)1e9
#define db double

ll ask(ll pos) {
    cout << "? " << pos << endl;
    cin >> pos;
    return pos;
}

void solve() {
    ll n, k; cin >> n >> k;
    vector<ll> bad;
    ll bound = 0, sum = 0;
    for (ll i = 0; i < k; i++) {
        ll l = bound, r = n + 1;
        while (r - l > 1) {
            ll mid = (r + l) >> 1;
            if (ask(mid) == mid * (mid + 1) / 2 - sum) {
                l = mid;
            } else {
                r = mid;
            }
        }
        bad.push_back(r);
        sum += r;
        bound = r;
    }
    cout << "! ";
    for (auto& x : bad) cout << x << " ";
    cout << endl;
    cin >> n;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll t = 1;
    cin >> t;
    while (t--) solve();
    return 0;
}