#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;

using namespace std;

vector<ll> ans;

ll ask(ll p) {
    cout << "? " << p << '\n';
    cout.flush();
    ll ns; cin >> ns;
    return ns;
}

void slv(ll l, ll r, ll minus, ll alsum) {
    if ((alsum * 2LL) == (r * (r - 1) - l * (l - 1))) {
        return;
    }
    if (l + 1 == r) {
        ans.push_back(l);
        return;
    }
    ll mid = (l + r) / 2;
    ll nw = ask(mid - 1) - minus;
    slv(l, mid, minus, nw);
    slv(mid, r, minus + nw, alsum - nw);
}

void solve() {
    ll n, k; cin >> n >> k;
    ll al = ask(n);
    ans.clear();
    slv(1, n + 1, 0, al);
    cout << "!";
    for (ll j : ans) {
        cout << ' ' << j;
    }
    cout << '\n';
    cout.flush();
    int a; cin >> a;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}