#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>


using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)

//#pragma GCC optimization("Ofast")
//#pragma GCC optimization("sse4")
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ld EPS = 1e-9;

ll sum(ll l, ll r) { // (l, r]
    if (l >= r) return 0;
    return r * (r + 1) / 2 - l * (l + 1) / 2;
}

map<ll, ll> que;

ll get(ll x) { // [1, x]
    if (que.find(x) == que.end()) {
        cout << "? " << x << endl;
        cin >> que[x];
        if (que[x] == -1) exit(0);
    }
    return que[x];
}

ll get(ll l, ll r) { // (l, r]
    if (l >= r) {
        return 0;
        cout << "aboba" << endl;
        exit(0);
    }
    return get(r) - get(l);
}

vector<ll> ans;

ll find(ll l, ll r, ll k) {
    k = min(k, r-l);
    if (k == 0) return 0;
    if (sum(l, r) == get(l, r)) return 0;
    if (k == 1) {
        ans.push_back(sum(l, r) - get(l, r));
        return 1;
    }
    ll sm = sum(l, r) - get(l, r);
    ll lx = 1, rx = k + 1;
    while(lx+1<rx){
        ll mid = (lx+rx)/2;
        if (sum(l, l +mid) > sm) rx = mid;
        else if (sum(r-mid, r) < sm) lx = mid;
        else if (sm / mid <= r){
            if (sum(l, sm / mid) == get(l, sm / mid)){
                rx = mid;
            }else{
                lx = mid;
            }
        } else{
            lx = mid;
        }
    }
    if (lx == 0) return 0;
    if (lx == 1){
        ans.push_back(sm);
        return 1;
    }
    if (sm / lx == l || sm / lx == r)
        exit(-1);
    ll left = find(l, sm / lx, lx - 1);
    ll right = find(sm / lx, r, lx - left);
    return left + right;
}

int main() {
    fastio();
    ll t;
    cin >> t;
    while (t--) {
        ll n, k;
        cin >> n >> k;
        que.clear();
        que[0] = 0;
        ans.clear();
//        if (k == 3) {
//            ll r = 0;
//            ll sm = sum(r, n) - get(r, n);
//            ll f = sm / 3;
//            ll sm1 = sum(r, f) - get(r, f);
//            ll sm2 = sm - sm1;
//
//            if (get(r, sm1 / 2) == sum(r, sm1 / 2)) {
//                ans.push_back(sm1);
//                ans.push_back(sum(f, sm2 / 2) - get(f, sm2 / 2));
//                ans.push_back(sm2 - ans.back());
//            } else {
//                ans.push_back(sum(r, sm1 / 2) - get(r, sm1 / 2));
//                ans.push_back(sm1 - ans.back());
//                ans.push_back(sm2);
//            }
//            cout << "! ";
//            for (ll x : ans) cout << x << " ";
//            cout << endl;
//            ll res;
//            cin >> res;
//            if (res == -1) exit(0);
//        } else if (k == 4) {
//            ll l = 0, r = n;
//            while (l + 1 < r) {
//                ll mid = (l + r) / 2;
//                if (get(0, mid) == sum(0, mid)) {
//                    l = mid;
//                } else {
//                    r = mid;
//                }
//            }
//            ans.push_back(r);
//            ll sm = sum(r, n) - get(r, n);
//            ll f = sm / 3;
//            ll sm1 = sum(r, f) - get(r, f);
//            ll sm2 = sm - sm1;
//
//            if (get(r, sm1 / 2) == sum(r, sm1 / 2)) {
//                ans.push_back(sm1);
//                ans.push_back(sum(f, sm2 / 2) - get(f, sm2 / 2));
//                ans.push_back(sm2 - ans.back());
//            } else {
//                ans.push_back(sum(r, sm1 / 2) - get(r, sm1 / 2));
//                ans.push_back(sm1 - ans.back());
//                ans.push_back(sm2);
//            }
//            cout << "! ";
//            for (ll x : ans) cout << x << " ";
//            cout << endl;
//            ll res;
//            cin >> res;
//            if (res == -1) exit(0);
//        } else {
            find(0, n, k);
            cout << "! ";
            for (ll x : ans) cout << x << " ";
            cout << endl;
            ll res;
            cin >> res;
            if (res == -1) exit(0);
//        }
    }
    return 0;
}