
#define _CRT_SECURE_NO_WARNINGS

#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <cmath>
#include <random>
#include <cmath>
#include <bitset>
#include <deque>

#define pll pair<long long, long long>
#define ll long long
#define ft first
#define sd second
#define sll set<long long>
#define msll multiset<long long> 
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define vll vector<ll>
#define ve vector
#define mp make_pair
#define INF (ll)1e18

using namespace std;

map<ll, ll> mem;

ll ask(ll p) {
	if (mem.find(p) == mem.end()) {
		cout << "?" << p << endl;
		ll t;
		cin >> t;
		mem[p] = t;
		return t;
	}
	else {
		return mem[p];
	}
}

ll bin_next(ll pls, ll l, ll r) {	

	while (r - l > 1) {
		ll cur = (l + r) / 2;
		
		if (ask(cur) + pls < (cur) * (cur + 1) / 2) {
			r = cur;
		}
		else {
			l = cur;
		}
	}

	return r;
}

void solve() {
	mem.clear();
	ll n, k;
	cin >> n >> k;

	ll l = 0, r = n, pls = 0;
	vll ans;

	for (int i = 0; i < k; i++) {
		ll pos = bin_next(pls, l, r);
		l = pos;
		pls += pos;

		ans.push_back(pos);
	}

	cout << "! ";
	for (auto& i : ans) {
		cout << i << ' ';
	}
	cout << endl;

}

int main() {
#ifdef _DEBUG
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);
#endif 

	ll t;
	cin >> t;

	while (t--) {
		solve();
	}

	return 0;
}
