#include <iostream>
#include <iomanip>

#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>

#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cmath>

using namespace std;

bool f(int l, int r, int pref_sum, vector<int>& inds, map<int, int>& mp)
{
	if (l > r)
		return true;

	int m = l + (r - l) / 2;
	int ans;
	if (mp.find(m) == mp.end())
	{
		cout << "? " << m << endl;
		cin >> ans;
		if (ans == -1)
			return false;
		mp[m] = ans;
	}
	else
		ans = mp[m];

	int cm = m;
	while ((pref_sum + (l + cm) * (cm - l + 1) / 2) - ans == cm)
	{
		inds.push_back(cm);
		--cm;
	}

	int cl = l;
	while ((pref_sum + (cl + cm) * (cm - cl + 1) / 2) - ans == cl)
	{
		inds.push_back(cl);
		cl++;
	}

	if ((pref_sum + (cl + cm) * (cm - cl + 1) / 2) > ans)
		f(cl, cm, pref_sum, inds, mp);

	f(m + 1, r, ans, inds, mp);
	return true;
}

void solve()
{
	int n, k;
	cin >> n >> k;

	vector<int> inds;
	map<int, int> mp;
	if (!f(1, n, 0, inds, mp))
		return;

	cout << "! ";
	for (int i : inds)
		cout << i << " ";
	cout << endl;
	int ans;
	cin >> ans;
	if (ans == -1)
		exit(0);
}

int main()
{
	int t;
	cin >> t;
	while (t--)
		solve();
}