// #define _GLIBCXX_DEBUG_PEDANTIC
// думай о правильности перед написанием
// проверяй идеи
// проверяй правильность кода
// пробуй разные подходы
// не задерживайся слишком долго на одной задаче
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define int long long

#define dbg(x) cerr << #x << ": " << x << endl;


int ask(int p) {
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return x;
}

mt19937 rng(1337);

void solve() {
    int n, k;
    cin >> n >> k;

    vector<int> tokens;
    ll prev_sum = 0;
    int prev_border = 1;

    set<int> good;
    map<int, int> mem;
    {
        while (k--) {
            int l = prev_border - 1;
            int r = n;
            while (l != r - 1) {
                int m = (l + r) / 2;

                auto it = good.lower_bound(m);
                if (it != good.end()) {
                    l = m;
                    continue;
                }

                int curr = m * (m + 1) / 2 - prev_sum;
                int x;
                if (mem.find(m) != mem.end()) {
                    x = mem[m];
                } else {
                    x = ask(m);
                    mem[m] = x;
                }

                if (x == m * (m + 1) / 2) {
                    good.insert(m);
                }

                if (x != curr) {
                    r = m;
                } else {
                    l = m;
                }
            }
            tokens.push_back(r);
            prev_sum += r;
            prev_border = r + 1;
        }
    }
    cout << "! ";
    for (auto x : tokens) {
        cout << x << ' ';
    }
    cout << endl;

    int f;
    cin >> f;
    if (f == -1) exit(0);
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);


    int t;
    cin >> t;;
    while (t--) {
        solve();
    }

    return 0;
}