#include "bits/stdc++.h"
//#pragma GCC optimize("Ofast,unroll-loops")

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
//#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const int base = 177013;
const int mod = 1e9 + 7;

ll get_must_sum(int x){
    return (ll)x * (ll)(x + 1) / 2;
}

ll get_sum_segment(int l, int r){
    l += 1;
    r += 1;
    return get_must_sum(r) - get_must_sum(l - 1);
}

map<int, ll> was;

ll ask(int x){
    if(was[x]){
        return was[x] - 1;
    }
    if(x == 0)
        return 0;
    cout << "? " << x << endl;
    ll a;
    cin >> a;
    if(a == -1)
        exit(0);
    was[x] = a + 1;
    return a;
}

vector<int> pozs;

void fnd(int l, int r, ll weight){
    if(weight == get_sum_segment(l, r))
        return;

    ll c = get_sum_segment(l, r) - weight;
    if(c >= l + 1 and c <= r + 1) {
        pozs.emplace_back(c);
        return;
    }

    int vmid = (l + r) / 2;
    fnd(l, vmid, ask(vmid + 1) - ask(l));
    fnd(vmid + 1, r, ask(vmid + 1) - ask(r + 1));
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    // Это красиво.
    int t;
    cin >> t;
    while(t--) {
        was.clear();
        int n, k;
        cin >> n >> k;
        pozs.clear();

        fnd(0, n - 1, ask(n));

        cout << "! ";
        for (auto u: pozs)
            cout << u << ' ';
        cout << endl;
        int ans;
        cin >> ans;
        if(ans == -1)
            exit(0);
    }
}