#include <bits/stdc++.h>
#include <stdexcept>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, k;

    long long false_sum(long long r) {
        cout << "? " << r << "\n";
        long long res;
        cin >> res;
        if (res == -1) {
            throw runtime_error("Exceeded query count");
        }
        return r * (r + 1) / 2 - res;
    }

    vector<long long> res;

    solve() {
        long long prev_sum = 0;
        for (int i = 2; i <= n + 1; i += 2) {
            long long cur_sum = false_sum(min(i, (int)n));
            if (cur_sum == prev_sum) {
                continue;
            }
            if (cur_sum - prev_sum <= i) {
                res.push_back(cur_sum - prev_sum);
            } else {
                assert(cur_sum - prev_sum == i + (i - 1));
                res.push_back(i - 1);
                res.push_back(i);
            }
            prev_sum = cur_sum;
        }
        output();
    }

    void output() {
        cout << "! ";
        for (long long x : res) {
            cout << x << " ";
        }
        cout << "\n";
        int res;
        cin >> res;
        if (res == -1) {
            throw std::runtime_error("Oopsie, guessed wrong...");
        }
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t;
    while (t--) {
        solve();
    }
}
