#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>

#define int long long
#define double long double

using namespace std;

const int MAXN = 1'00'000;
const long long inf = 1e18;
const int p = 179;

unordered_map <int, int> is;
unordered_map <int, bool> is2;
int pp[MAXN + 1];
int pr[MAXN];
int has[MAXN];
int fen[MAXN];
int t[4 * MAXN];
vector <int> w[MAXN];
inline int get(int l, int r){
    if (l == 0) return has[r] * pp[MAXN];
    return (has[r] - has[l - 1]) * pp[MAXN - l];
}

inline void upd(int i, int l, int r, int ind, int val){
    while (l + 1 != r){
        if (ind < (l + r) / 2){
            i = 2 * i + 1;
            r = (l + r) / 2;
        }
        else{
            i = 2 * i + 2;
            l = (l + r) / 2;
        }
    }
    t[i] += val;
    while (i){
        i = (i - 1) / 2;
        t[i] += val;
    }
}
inline int ans(int i, int l, int r, int ql, int qr){
    if (qr <= l || ql >= r) return 0;
    if (ql <= l && r <= qr) return t[i];
    return ans(2 * i + 1, l, (l + r)/ 2, ql, qr) + ans(2 * i + 2, (l + r) / 2, r, ql, qr)
            ;}

signed main() {
    pp[0] = 1;
    for (int i = 1; i <= MAXN; i ++) pp[i] = pp[i - 1] * p;
    ios_base::sync_with_stdio((0)); cin.tie(0); cout.tie(0);
    cout << setprecision(11) << fixed;
    int n, m; cin >> n >> m;
    is.reserve(MAXN * 18); is.max_load_factor(0.25);
    is2.reserve(1 * (2 * MAXN)); is2.max_load_factor(0.25);
    string s; cin >> s;
    vector <string> d;
    for (int i = 0; i < n; i ++){
        string t; cin >> t;
        d.push_back(t);
    }
    auto cmp = [](string& a, string & b){
        return a.size() < b.size();
    };
    sort(d.begin(), d.end(), cmp);
    for (int i = 0; i < d.size(); i ++){
        int id = -1;
        int h = 0;
        for (int j = 0; j < d[i].size(); j ++) {
            h += pp[j] * d[i][j];
            if (is[h * pp[MAXN]] != 0) id = is[h * pp[MAXN]] - 1;
            else is[h * pp[MAXN]] = i + 1;
        }
        is2[h * pp[MAXN]] = 1;
        pr[i] = id;
    }
    for (int i = 0; i < s.size(); i ++){
        has[i] = pp[i] * s[i];
        if (i > 0) has[i] += has[i - 1];
    }
    //multiset <int> rr;
    for (int i = 0; i < s.size(); i ++){
        if (!is[s[i] * pp[MAXN]]) continue;
        int l = i, r = s.size();
        while(l + 1 < r){
            int m = (l + r) / 2;
            if (is[get(i, m)]) l = m;
            else r = m;
        }
        int v = is[get(i, l)] - 1;
        while (v != -1 && !is2[get(i, i + d[v].size() - 1)]){
            v = pr[v];
        }
        if (v != -1)
            do{
                //add(0, 0, s.size(), i, i + d[v].size() - 1);
                //rr.insert(i + d[v].size() - 1);
                w[i].push_back(i + d[v].size() - 1);
                upd(0,0,s.size(), i + d[v].size() - 1, 1);
                v = pr[v];
            } while (v != -1);
    }
    vector <pair<pair<int, int>, int>> q(m);
    for (int i = 0; i < m; i ++){
        cin >> q[i].first.first >> q[i].first.second; q[i].first.first --;
        q[i].second = i;
    }
    sort(q.begin(), q.end());
    int j = 0;
    vector <int> rans(m);
    for (int i = 0; i < s.size(); i ++){
        while (q[j].first.first == i){
            rans[q[j].second] = ans(0, 0, s.size(), 0, q[j].first.second);
            j++;
        }
        for (int prg : w[i]) upd(0, 0, s.size(), prg, -1);
    }
    for (int i : rans) cout << i << ' ';
    return 0;
}
