#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

unordered_map<int, ll> mp;

ll ask(int i) {
  if (mp.find(i) != mp.end()) return mp[i];
  cout << "? " << i << endl;
  ll ans;
  cin >> ans;
  if (ans == -1) exit(0);
  mp[i] = ans;
  return ans;
}

ll prog(int l, int r) {
  return 1ll * (r - l + 1) * (l + r) / 2;
}

void solve() {
  mp.clear();
  int n, k;
  cin >> n >> k;
  ll sumBad = 0;
  int cur = 0;
  vector<int> res;
  while (size(res) < k) {
    for (int lg = 30; lg >= 0; --lg) {
      if (cur + (1 << lg) <= n && ask(cur + (1 << lg)) == prog(1, cur + (1 << lg)) - sumBad) {
        cur += 1 << lg;
      }
    }
    res.push_back(cur + 1);
    cur += 2;
  }
  cout << "! ";
  for (int x : res) cout << x << ' ';
  cout << endl;
  int ans;
  cin >> ans;
  if (ans == -1) exit(0);
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int tt;
  cin >> tt;
  while (tt--) {
    solve();
  }
  return 0;
}