#include <bits/stdc++.h>

#include <ranges>
#include <utility>

using namespace std;

typedef int64_t ll;
typedef long double ld;
constexpr int INF = 2e9;

bool STRS = false;

static constexpr ll mod = 1e9 + 7;

struct Solution {
    mt19937 rnd;

    struct Interactor {
        unordered_map<int, ll> rs;
        int n{}, k{};

#ifdef ILKRAS
        vector<int> ar;
        int counter = 0;
#endif

        Interactor() {
#ifdef ILKRAS
            cout << "INIT" << endl;
#endif
            cin >> n >> k;
#ifdef ILKRAS
            ar.resize(n);
            iota(ar.begin(), ar.end(), 1);
            for (int i = 0; i < k; ++i) {
                int id;
                cin >> id;
                ar[id - 1] = 0;
            }
#endif
        };

        ll ask(int p) {
//            assert(1 <= p && p <= n);
            if (rs.count(p))
                return rs[p];
#ifdef ILKRAS
            cout << "ASK " << ++counter << endl;
#endif
            cout << "? " << p << endl;
#ifndef ILKRAS
            cin >> rs[p];
#else
            ll res = 0;
            for (int i = 0; i < p; ++i) {
                res += ar[i];
            }
            rs[p] = res;
            cout << "RES: " << res << endl;
#endif
            return rs[p];
        }

        void ans(vector<int> ar) {
            cout << "! ";
            for (auto& it : ar) {
                cout << it << " ";
            }
            cout << endl;
#ifdef ILKRAS
            cout << "FINISHED IN " << counter << endl;
#else
            int res;
            cin >> res;
            if (res != 1) {
                exit(0);
            }
#endif
        }
    };

    Interactor io;

    Solution() {
        rnd = mt19937(time(nullptr));
    }

    vector<int> ans;

    ll mst(int l, int r) {
        return (ll)(l + 1) * (ll)(r - l) + (ll)(r - l) * (ll)(r - l - 1) / 2ll;
    }

    void slvrc(int l, // 0
               int r, // n
               ll lsum, // 0
               ll rsum, // ask(n)
               int& k
               ) {
        ll cur = rsum - lsum;
        if (cur == mst(l, r)) {
            return;
        }
        if (l + 1 == r || k == 1) {
            ans.push_back((int)(mst(l, r) - cur));
            k--;
            return;
        }
        int m = (l + r) / 2;
        ll df = io.ask(m);
        slvrc(l, m, lsum, df, k);
        if (k == 0)
            return;
        slvrc(m, r, df, rsum, k);
    }

    signed operator()(int TEST = -1) {
        int n = io.n;
        int k = io.k;
        slvrc(0, n, 0, io.ask(n), k);
        io.ans(ans);
#ifdef ILKRAS
#endif
        return 0;
    }
};

signed main() {;
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    int t = 1;
    cin >> t;
#ifdef ILKRAS
#endif
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}
//
//3
//3 2
//1 3
//10 4
//2 6 8 10
//100000 3
//400 5700 89000
//
