#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2")
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <string>
#include <cmath>
#include <iomanip>
#include <deque>


using namespace std;

typedef long long ll;

int addm(int a, int b, int m) {
	return (a + b) % m;
}

int subm(int a, int b, int m) {
	return ((a - b) % m + m) % m;
}

int mulm(int a, int b, int m) {
	return (ll)a * b % m;
}

int bin_pow(int a, int n, int m) {
	if (n == 0) {
		return 1;
	}
	if (n % 2 == 0) {
		int b = bin_pow(a, n / 2, m);
		return mulm(b, b, m);
	}
	else {
		return mulm(a, bin_pow(a, n - 1, m), m);
	}
}

ll gcd(ll a, ll b) {
	if (b == 0) {
		return a;
	}
	return gcd(b, a % b);
}

vector<ll> gcdex(ll a, ll b) {
	if (b == 0) {
		return { a, 0, a };
	}
	else {
		vector<ll> aaa = gcdex(b, a % b);
		return { aaa[1], aaa[0] - (a / b) * aaa[1], aaa[2] };
	}
}

signed main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	int  t;
	cin >> t;
	while (t--) {
		int n, k;
		cin >> n >> k;
		int idx = 0;
		vector<int> ans;
		map<int, ll > eee;
		ll summ = 0;
		ll LAST = 0;
		for (int i = 1; i <= n; i += k) {
			int L = i, R = min(i + k - 1, n);
			cout << '?' << ' ' << R << endl;
			ll aaa;
			cin >> aaa;
			if (aaa - LAST == (ll)R * (R + 1) / 2 - (ll)L * (L - 1) / 2) {
				LAST = aaa;
				continue;
			}
			else {
				ll idx = L - 1;
				while (1) {
					ll l = idx, r = R + 1;
					while (l + 1 < r) {
						ll mid = (l + r) / 2;
						cout << '?' << ' ' << mid << endl;
						ll aaa;
						cin >> aaa;
						if (mid * (mid + 1) / 2 - summ == aaa) {
							l = mid;
						}
						else {
							r = mid;
						}
					}
					if (l == R) {
						break;
					}
					idx = r;
					ans.push_back(r);
					summ += r;
				}
			}
		}
		cout << '!' << ' ';
		for (auto el : ans) {
			cout << el << ' ';
		}
		cout << endl;
		int aaa;
		cin >> aaa;
		/*for (int i = 0; i < k; i++) {
			if (i == k - 1) {
				cout << '?' << ' ' << n << endl;
				ll aaa;
				cin >> aaa;
				ans.push_back((ll)n * (n + 1) / 2 - aaa - summ);
			}
			else {
				int L = idx, R = n;
				while (L + 1 < R) {
					int mid = (L + R) / 2;
					cout << '?' << ' ' << mid << endl;
					ll aaa;
					if (eee.find(mid) != eee.end()) {
						aaa = eee[mid];
					}
					cin >> aaa;
					eee[mid] = aaa;
					if ((ll)mid * (mid + 1) / 2 - summ == aaa) {
						L = mid;
					}
					else {
						R = mid;
					}
				}
				summ += R;
				ans.push_back(R);
				idx = R;
			}
		}
		cout << '!' << ' ';
		for (auto el : ans) {
			cout << el << ' ';
		}
		cout << endl;
		int aaa;
		cin >> aaa;
		if (aaa == -1) {
			return 0;
		}*/
	}
	exit(0);
}