#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef unsigned long long ull;
#define all(x) x.begin(), x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define sz(x) int(x.size())
#define int ll

map <int, int> memo;
int ask(int p) {
	if (p == 0) return 0;
	if (!memo.count(p)) {
		cout << "? " << p << endl;
		int ans;
		cin >> ans;
		assert(ans >= 0);
		memo[p] = ans;
	}
	return memo[p];
}

void solve() {
	memo.clear();
	
	int n, k;
	cin >> n >> k;
	
	vector <int> ans;
	
	int L = 1;
	for (int q = 0; q < k; q++) {
		int l = L - 1, r = n;
		while (l + 1 < r) {
			int M = (l + r) / 2; bool any = 0;
			for (int m = max(l + 1, M - 500); m <= min(r - 1, M + 500); m++) {
				if (memo.count(m)) {
					if (ask(m) - ask(L - 1) == (L + m) * (m - L + 1) / 2) l = m;
					else r = m;
					any = 1;
					break;
				}
			}
			
			if (any) continue;
			
			int m = M;
			if (ask(m) - ask(L - 1) == (L + m) * (m - L + 1) / 2) l = m;
			else r = m;
		}
		ans.push_back(r);
		L = r + 1;
	}
	
	cout << "! ";
	for (int i: ans) cout << i << ' ';
	cout << endl;
	
	int res;
	cin >> res;
	assert(res == 1);
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	int TC;
	cin >> TC;
	while (TC--) solve();
	
	return 0;
}
