#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#define int long long
using namespace std;


struct checker {
    vector<int> bad;
    vector<int> pref;
    checker() {}
    void add(int x) {
        bad.push_back(x);
        sort(bad.begin(), bad.end());
        pref = bad;
        for (int i = 1; i < (int)pref.size(); ++i)
            pref[i] += pref[i - 1];
    }
    
    int get(int i) {
        int ind = (int)(lower_bound(bad.begin(), bad.end(), i) - bad.begin());
        return i * (i + 1) / 2 - pref[ind];
    }
};


bool check(int i, checker &c) {
    cout << i << endl;
    int res; cin >> res;
    if (res != c.get(i))
        return false;
    return true;
}

void print(checker &c) {
    cout << "! ";
    for (auto &x : c.bad) {
        cout << x << ' ';
    }
    cout << endl;
    int a; cin >> a;
    if (a == 1)
        return;
    exit(0);
}

void solve() {
    int n, k;
    cin >> n >> k;
    checker c;
    for (int i = 1; i <= n; ++i) {
        if (check(i, c))
            continue;
        else
            c.add(i);
        if (c.bad.size() == k) {
            print(c);
        }
    }
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}