#include <bits/stdc++.h>
using namespace std;
#define int int64_t
#define ss second
#define ff first
// #define LOCAL
int n, k;

struct SegTree {
	vector<int> tree;
	int n;

	SegTree (const vector<int> &a) {
		n = a.size();
		tree.resize(n * 2);
	}

	int get(int l, int r) {
		l += n, r += n;
		int ans = 0;
		while(l < r) {
			if(l & 1) {
				ans += tree[l++];
			}
			if(!(r & 1)) {
				ans += tree[r--];
			}
			l /= 2;
			r /= 2;
		}
		if(l == r) {
			ans += tree[l];
		}
		return ans;
	}

	void change(int i, int x) {
		i += n;
		tree[i] = x;
		while(i) {
			i /= 2;
			tree[i] = tree[i * 2] + tree[i * 2 + 1];
		}
	}
};

void solve1000st() {
	vector<int> poses, res;
	while(k--) {
		int l = 1, r = n + 1;
		while(r - l > 1) {
			int m = (l + r) / 2;
			cout << "? " << m << endl;
			int x;
			cin >> x;
			assert(x != -1);
			int delta = 0;
			for(auto i : poses) {
				if(i <= m) {
					delta += i;
				}
			}
			cout << x << " " << m * (m + 1) / 2 << " " << m << " " << delta << endl;
			if(x == m * (m + 1) / 2 - delta) {
				l = m;
			} else if(m * (m + 1) / 2 - delta == x + m) {
				l = r = m;
			} else {
				r = m;
			}
		}
		res.push_back(l);
		poses.push_back(l);
	}
	cout << "! ";
	for(auto i : res) {
		cout << i << " ";
	}
	cout << endl;
	int a;
	cin >> a;
	assert(a != -1);
}

void solve() {
	cin >> n >> k;
	solve1000st();
}

int32_t main() {
#ifdef LOCAL
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#endif
	int st = 1;
	cin >> st;
	while(st--) {
		solve();
	}
}