#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <cstring>
#include <queue>
#include <map>
#include <unordered_map>

using namespace std;

#define int long long
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int inf = 1e18;

int n, k;

main(){
//    ios_base::sync_with_stdio(0);
//    cin.tie(0);

    int t;
    cin >> t;
    while (t --){
        cin >> n >> k;

        vector<int> ans;
        int x, sum = 0;

        if (n <= 0 * 1000){
            for(int i = 1; i <= n; i ++){
                cout << "? " << i << endl;
                int x;
                cin >> x;
                if (x + sum != i * (i + 1) / 2){
                    ans.push_back(i);
                    sum += i;
                }
            }
        } else {
            int safe_l = 0;
            while(sz(ans) < k){
                int l = safe_l + 1, r = n;
                while(l < r - 1){
                    int m = (l + r) / 2;
                    cout << "? " << m << endl;
                    cin >> x;
                    if (x + sum == m * (m + 1) / 2){
                        safe_l = m;
                        l = m + 1;
                    } else
                        r = m;
                }

                cout << "? " << l << endl;
                cin >> x;
                if (x + sum == l * (l + 1) / 2){
                    ans.push_back(r);
                    sum += r;
                } else {
                    ans.push_back(l);
                    sum += l;
                }
            }
        }

        cout << "! ";
        for(auto i : ans)
            cout << i << ' ';
        cout << endl;

        cin >> x;
        if (x == -1)
            break;
    }
}

/*

*/
