#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iomanip>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 500500;
const ll mod = 1e9 + 7;

bool fl = 0;
ll n, k;

void solve() {
	cin >> n >> k;
	ll last = 0;
	ll p = 0;
	vector <int> ans;
	ll sum;
	map <ll, ll> mp;
	set <ll> s;
	cout << "? " << n << endl;
	cin >> mp[n];
	s.insert(n);
	while (k > 1) {
		--k;
		ll l = last, r = n;
		for (auto t = s.upper_bound(l); t != s.end(); ++t) {
			ll u = *t;
			if (u * (u + 1) / 2 - p - mp[u] == 0) {
				l = u;
			}
			else {
				r = u;
				break;
			}
		}
		while (r - l > 1) {
			ll m = (r + l) / 2;
			if (s.find(m) != s.end()) {
				sum = mp[m];
			}
			else {
				cout << "? " << m << endl;
				cin >> sum;
				s.insert(m);
				mp[m] = sum;
			}
			if (sum == -1) {
				fl = 1;
				return;
			}
			if (sum + p == m * (m + 1) / 2) {
				l = m;
			}
			else {
				r = m;
			}
		}
		ans.push_back(r);
		last = r;
		p += r;
	}
	ans.push_back(n * (n + 1) / 2 - mp[n] - p);
	cout << "! ";
	for (int i : ans) cout << i << ' ';
	cout << endl;
	cin >> sum;
	if (sum == -1) {
		fl = 1;
	}
}

int main() {
	int t;
	cin >> t;
	while (t-- && !fl) {
		solve();
	}
}