#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <queue>
#include <set>

typedef long long llong;
// const int MAXN = 1000000 + 10;
const llong INF = 1e18;

// bool bad[MAXN];
// llong prefix[MAXN];
// int cntQuestions;
inline llong getSum(int l, int r)
{
    return 1LL * (l + r) * (r - l + 1) / 2;
}

int n;
inline llong makeQuestion(int k)
{
    // assert(k <= n);
    // cntQuestions++;
    // return prefix[k];
    llong res;
    std::cout << "? " << k << std::endl;
    std::cin >> res;
    return res;
}

int searchL, searchR;
std::vector <int> listFake;
llong sumOfFake;
llong currFound;
llong currSum;
int k;

void reset()
{
    listFake.clear();
    sumOfFake = currFound = currSum = 0;
    searchL = searchR = 0;
}

int search()
{
    int l = searchL - 1, r = searchR, mid;
    while (l < r - 1)
    {
        llong currTry;
        mid = (l + r) / 2;
        currTry = makeQuestion(mid);
        currTry -= getSum(1, l - 1) - sumOfFake;
        currTry += currFound;
        // if (mid + 1 <= r && currSum - currTry == getSum(mid + 1, r))
        // {
        //     searchR = mid;
        // }

        if (currTry == getSum(l, mid)) l = mid;
        else r = mid;
    }

    searchL = r + 1;
    return r;
}

void solve()
{
    // std::cout << "here\n";
    int bucketSize = n / k;
    int l = 0, r = 0;
    while (listFake.size() < k)
    {
        l = r + 1;
        r += bucketSize;
        r = std::min(r, n);
        if (l > n)
        {
            break;
        }

        currSum = makeQuestion(r);
        currSum -= getSum(1, l - 1) - sumOfFake;
        currFound = 0; searchL = l; searchR = r;
        if (currSum == 0)
        {
            for (int i = l ; i <= r ; ++i)
            {
                sumOfFake += i;
                listFake.push_back(i);
            }

            continue;
        }

        if (currSum < l + l + 1)
        {
            for (int i = l ; i <= r ; ++i)
            {
                if (i == currSum) continue;
                listFake.push_back(i);
                sumOfFake += i;
            }

            continue;
        }

        while (currSum + l + (l + 1) <= getSum(l, r))
        {
            int curr = search();
            listFake.push_back(curr);
            currFound += curr;
            currSum += curr;
        }

        if (currSum != getSum(l, r))
        {
            listFake.push_back(getSum(l, r) - currSum);
            currFound += listFake.back();
        }
    
        sumOfFake += currFound;
    }

    std::cout << "!";
    for (const int &i : listFake)
    {
        std::cout << ' ' << i;
    }

    std::cout << std::endl;
}

void input()
{
    std::cin >> n >> k;
    // std::fill(bad, bad + 1 + n, false);
    // for (int i = 1 ; i <= k ; ++i)
    // {
    //     int idx;
    //     do idx = rand()%n + 1;
    //     while (bad[idx]);
    //     // std::cin >> idx;
    //     bad[idx] = true;
    //     std::cout << "idx: " << idx << '\n';
    // }

    // for (int i = 1 ; i <= n ; ++i)
    // {
    //     prefix[i] = prefix[i - 1];
    //     if (!bad[i]) prefix[i] += i;
    // }
}

int tests;
int main()
{
    // srand(1);
    std::cin >> tests;

    while (tests--)
    {
        reset();
        input();
        solve();
        return 0;
    }

    return 0;
}