#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
using namespace __gnu_pbds;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }
mt19937_64 rng(chrono::steady_clock::now().time_since_epoch().count());

const bool debug = 1;

ve<int> bad;
inline ll sum(const int &x) {
    return x * 1ll * (x + 1) / 2ll;
}

ve<int> ans;
map<int,ll> cash;

int Q = 0;

inline ll ask(int pos) {
    if (!pos) {
        return 0;
    }
    if (cash.count(pos)) {
        ll res = cash[pos];
        for (const auto &x : ans) {
            if (x <= pos) {
                res += x;
            }
        }
        return res;
    }

    if (!debug) {
        cout << "? " << pos << endl;
        fflush(stdout);
    }

    ll res; ++Q;

    if (!debug) {
        cin >> res;
        if (res == -1) {
            exit(0);
        }
    }
    else {
        res = sum(pos);
        for (const auto &x : bad) {
            if (x <= pos) {
                res -= x;
            }
        }
    }

    cash[pos] = res;

    for (const auto &x : ans) {
        if (x <= pos) {
            res += x;
        }
    }
    return res;
}

inline void slv1(int n, int k) {
    ans.clear();
    cash.clear();

    int last_found = 0;

    Q = 0;

    while (k--) {
        int l = 0, r = n, m, F;
        while (l <= r) {
            m = l + r >> 1;
            if (m <= last_found || ask(m) == sum(m)) {
                F = m, l = m + 1;
            }
            else {
                r = m - 1;
            }
        }
        ans.pb(F + 1);
        last_found = F + 1;
    }
}

inline void slv3(int n, int k) {
    ans.clear();
    cash.clear();

    int l = 0, r = n, m, F = 0;
    while (l <= r) {
        m = l + r >> 1;
        ll f = sum(m) - ask(m);
        if (!f) {
            F = m;
            l = m + 1;
        }
        else {
            r = m - 1;
        }
    }
    int x = F + 1;

    ans.pb(x);

    ll S = sum(n) - ask(n);
    ll y = sum(S / 2) - ask(S / 2);
    ans.pb(y);
    ans.pb(S - y);
}

inline void slv4(int n, int k) {
    ans.clear(); Q = 0;
    cash.clear();

    ll S = sum(n) - ask(n);

    int l = 0, r = n, m, F;
    while (l <= r) {
        m = l + r >> 1;
        ll s = sum(m) - ask(m);
        if (!s) F = m, l = m + 1;
        else r = m - 1;
    }

    int x = F + 1;

    ans.pb(x);

    S -= x;

    {
        ll y = sum(S / 3) - ask(S / 3);

        bool ok = 0;
        {
            S -= y;
            if (sum(S / 2) - ask(S / 2) - y > 0) {
                ans.pb(y);
                int z = sum(S / 2) - ask(S / 2);
                ans.pb(z);
                ans.pb(S - z);
                ok = 1;

                return;
            }
            S += y;
        }
        if (!ok) {
            y = S - y;
            ans.pb(y);
            S -= y;

            ll z = sum(S / 2) - ask(S / 2);
            ans.pb(z);
            ans.pb(S - z);
        }
    }
}

inline void solve() {
    int n, k;
    if (!debug) cin >> n >> k;
    else {
        n = 1e9;
        k = 4;
    }

    if (debug) {
        bad.clear();
        bad.resize(k);

        map<int,int> us;
        for (int i = 0; i < k; ++i) {
            int x = 1 + rng() % n;
            while (us.count(x)) {
                x = 1 + rng() % n;
            }

            bad[i] = x;
            us[x] = 1;
        }
    }

    if (k == 3) slv3(n, k);
    else if (k == 4) slv4(n, k);
    else slv1(n, k);

    cerr << Q << endl;

    if (!debug) {
        cout << "! ";
        for (auto &x : ans) cout << x << " ";
        cout << endl;
        fflush(stdout);

        int res;
        cin >> res;
        if (res == -1) exit(0);
    }
    else {
        sort(all(bad));
        sort(all(ans));
        if (ans != bad) {
            for (auto &x : bad) cout << x << " ";
            cout << '\n';
            for (auto &x : ans) cout << x << " ";
            exit(0);
        }
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; cin >> q;
    while (q--) solve();
} // what is happening
