//#pragma GCC optimize("O3")
//#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) << ": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
ll bin_pow_make(ll a, ll n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        ll t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    ll x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b, int m) {
    return ((ll)a * b) % m;
}

int add(int a, int b, int m) {
    if (a + b >= m) return a + b - m;
    return a + b;
}
map<int, int> we_find;
map<int, int> good_find;
set<int> ans;
int k;
int ask(int pos) {
    cout << "? " << " " << pos << endl;
    int sum;
    cin >> sum;
    we_find[pos] = sum;
    return sum;
}
void out_ans(set<int> a) {
    cout << "! ";
    for (auto c : a) cout << c << " ";
    cout << endl;
    int fl;
    cin >> fl;
    if (fl == -1) exit(0);
}
int get_sum(int n) {
    return (n * (n + 1)) / 2;
}
bool is_good(int x) {
    int ind = x, sum = we_find[x], add = 0, must = get_sum(ind);
    for (auto c : ans) {
        if (c <= ind) add += c;
    }
    if (sum + add == must) {
        good_find[x] = 1;
        return 1;
    }
    return 0;
}
void check() {
    int we_can = 0, mx = -1, fl = 0;
    for (auto c : we_find) {
        int must = get_sum(c.first), p = c.second, add = 0, ind = c.first;
        for (auto x : ans) {
            if (x <= ind) add += x;
        }
        if (must == c.second + add) {
            mx = max(mx, c.first);
        }
    }
    for (auto c : we_find) {
        int sum_cur = c.second, ind = c.first, must = get_sum(ind), add = 0;
        if (ind <= mx) continue;
        for (auto x : ans) {
            if (x <= ind) add += x;
        }
        int can = must - sum_cur - add;
        /*
        debug(can);
        debug(ind);
        debug(sum_cur);
        debug(must);
        debug(add);
        */
        if (can < mx + mx + 1 && can != 0) {
            ans.insert(can);
            fl = 1;
            break;
        }

    }
}
void upd() {
    vector<pair<int, int> > cur;
    for (auto c : we_find) {
        cur.pb({ c.first,c.second });
    }
    for (int i = 0; i < cur.size() - 1; i++) {
        int f = cur[i].first, sum_f = cur[i].second, s = cur[i + 1].first, sum_s = cur[i + 1].second;
        int must = get_sum(s) - get_sum(f);
        int sum = sum_s - sum_f;
        if (must != sum) {
            int can = must - sum;
            if (f + f + 3 > can && can != 0) {
                ans.insert(can);
                return;
            }
            else {
                if (k == 3) ask((s + f) / 2);
            }
        }
    }
}
void solve() {
    we_find.clear();
    good_find.clear();
    ans.clear();
    int n, add = 0;
    cin >> n >> k;
    int op = ask(n);
    we_find[n] = op;
    for (int it = 0; it < k; it++) {
        if (ans.size() == k) break;
        int l = 0, r = n;
        int fl = 0;
        while (r - l > 1) {
            int m = (r + l) / 2, cur = 0;
            if (we_find.count(m)) {
                cur = we_find[m];
            }
            else {
                cur = ask(m);
            }
            int must = get_sum(m), add = 0;
            for (auto c : ans) {
                if (c <= m) add += c;
            }
            if (cur + add == must) {
                l = m;
            }
            else {
                r = m;
            }
            if (k == 3) {
                int pred = ans.size();
                check();
                if (ans.size() != pred) {
                    fl = 1;
                    break;
                }
                upd();
                if (ans.size() == pred) continue;
                fl = 1;
                break;
            }
        }
        for (auto c : we_find) {
            if (is_good(c.first)) continue;
        }
        if (!fl) ans.insert(r);
        while (true) {
            int pred = ans.size();
            if (ans.size() == k) break;
            check();
            if (ans.size() != pred) continue;
            upd();
            if (ans.size() == pred) break;
        }
    }
    out_ans(ans);
}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}