#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 2e6;
const db eps = 1e-9;

int ask(int ind) {
    cout << "? " << ind + 1 << endl;
    int ans; cin >> ans;
    if (ans == -1) exit(0);
    return ans;
}

void answer(vector<int> inds) {
    sort(all(inds));
    cout << "! ";
    for (auto ind : inds) cout << ind + 1 << ' ';
    cout << endl;
    int ans; cin >> ans;
    if (ans == -1) exit(0);
}

void solve() {
    int n, k; cin >> n >> k;
    int add = 0;
    int L = -1;
    vector<int> ans;
    map<int, int> was;
    for (int i = 0; i < k; ++i) {
        int l = L, r = n;
        while (r - l > 1) {
            int mid = (l + r) / 2;
            int sum = 0;
            if (was.find(mid) != was.end()) {
                sum = was[mid];
            } else {
                sum = ask(mid);
                was[mid] = sum;
            }
            sum += add;
            int need = ((mid + 1) * (mid + 2)) / 2;
            if (sum == need) {
                l = mid;
            } else {
                r = mid;
            }
        }
        ans.push_back(r);
        add += r + 1;
        L = r;
    }
    answer(ans);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
//#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
//#endif
    int t; cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
    return 0;
}