#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast,unroll-loops,fast-math")
//#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
//#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution<ll> uid;
    return abs(uid(rng)) % n;
}

ll B = 1;
map <ll, ll> q;

ll f(ll x) {
    if (q.find(x) != q.end())
        return q[x];
    cout << "? " << x << endl;
    ll res;
    cin >> res;
    q[x] = res;
    if (res == -1)
        exit(0);
    return res;
}

ll sum(ll x) {
    return x * (x + 1) / 2 - f(x);
}

ll cnt = 0;
bool check(ll x) {
    ll t = (x + 1) * x / 2 - cnt;
    return t == f(x);
}

void solve() {
    q.clear();
    ll n, k;
    cin >> n >> k;
    if (k == 3 && n > 1000) {
        ll l = 0, r = n;
        while (l + 1 < r) {
            ll m = (l + r) / 2;
            if (check(m))
                l = m;
            else
                r = m;
        }
        ll x1 = r;
        ll sx1 = sum(x1);
        ll ost = sum(n) - sx1;
        ll x2 = sum(ost / 2) - sx1;
        ll x3 = ost - x2;
        cout << "! " << x1 << ' ' << x2 << ' ' << x3 << endl;
        int c;
        cin >> c;
        if (c == -1)
            exit(0);
        return;
    }
    B = n;
    while (B >= 4 && int(log2(B) + 1) * k + (n - 1) / B > int(log2(B >> 1) + 1) * k + (n - 1) / (B >> 1))
        B /= 2;
    cnt = 0;
    vector <ll> v = {0};
    for (ll i = 1; (i - 1) * B <= n; i++)
        v.push_back(sum(min(n, B * i)));
    vector <ll> ans;
    for (ll i = 1; (i - 1) * B <= n; i++) {
        cnt = v[i - 1];
        ll last = B * (i - 1);
        while (cnt < v[i]) {
            ll l = last, r = min(B * i, n);
            while (l + 1 < r) {
                ll m = (l + r) / 2;
                if (check(m))
                    l = m;
                else
                    r = m;
            }
            ans.push_back(r);
            last = r;
            cnt += r;
            if (ans.size() == k)
                break;
        }
        if (ans.size() == k)
            break;
    }
    cout << "! ";
    for (auto& i : ans)
        cout << i << ' ';
    cout << endl;
    int c;
    cin >> c;
    if (c == -1)
        exit(0);
}

int main() {
    //cin.tie(nullptr);
    //cout.tie(nullptr);
    //ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
