#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

const int N = 5e5 + 1;
const int mod = 1e9 + 7;
const int inf = 1e12;

int ask (int l, int r) {
    cout << "? " << l + 1 << ' ' << r + 1 << endl;
    int x;
    cin >> x;
    return x;
}

int g (int l, int r) {
    return (l + r) * (r - l + 1) / 2;
}

void solve () {
    int n, k;
    cin >> n >> k;
    vc <int> ans;
    while (sz(ans) != k) {
        int start = (ans.empty() ? 0 : ans.back() + 1);
        int l = start, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (ask(start, m) != g(start, m)) {
                r = m;
            } else {
                l = m;
            }
        }
        ans.pb(r);
    }
    cout << "! ";
    for (int i : ans)
        cout << i + 1 << ' ';
    cout << '\n';
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
