#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

const int N = 5e5 + 1;
const int mod = 1e9 + 7;
const int inf = 1e12;

map <int, int> mp;

int ask (int p) {
    if (p <= 0)
        return 0;
    if (mp.find(p) != mp.end())
        return mp[p];
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return mp[p] = x;
}

int g (int l, int r) {
    return (l + r) * (r - l + 1) / 2;
}

void solve () {
    mp.clear();
    int n, k;
    cin >> n >> k;
    vc <int> ans;
    while (sz(ans) != k) {
        int start = (ans.empty() ? 1 : ans.back() + 1);
        int l = start - 1, r = n + 1;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int need = g(start, m);
            int got = ask(m) - ask(start - 1);
            if (need != got) {
                int diff = need - got;
                if (diff < m)
                    r = diff;
                else {
                    r = m;
                }
            } else {
                l = m;
            }
        }
        if (r == n + 1) {
            break;
        }
        ans.pb(r);
    }
    cout << "! ";
    for (int i : ans)
        cout << i << ' ';
    cout << endl;
    int a;
    cin >> a;
    if (a != 1)
        exit(1);
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
