#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>
#include <random>
#include <chrono>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

const int N = 5e5 + 1;
const int mod = 1e9 + 7;
const int inf = 1e12;

map <int, int> mp;

int ask (int p) {
    if (p <= 0)
        return 0;
    if (mp.find(p) != mp.end())
        return mp[p];
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return mp[p] = x;
}

int g (int l, int r) {
    return (l + r) * (r - l + 1) / 2;
}
vc <int> ans;
int n, k;

mt19937 rnd(chrono::high_resolution_clock().now().time_since_epoch().count());

void dfs (int l, int r, int mx) {
    if (l == r) {
        ans.pb(l);
        return;
    }
    int sum = ask(r) - ask(l - 1);
    int diff = g(l, r) - sum;
    if (r - l <= 2) {
        vc <int> a;
        for (int j = l; j <= r; ++j)
            a.pb(j);
        int msk = -1;
        int cnt = 0;
        for (int mask = 0; mask < 1 << sz(a); ++mask) {
            int s = 0;
            for (int j = 0; j < sz(a); ++j) {
                if (mask >> j & 1)
                    s += a[j];
            }
            if (s == diff) {

                msk = mask;
                ++cnt;
            }
        }
        if (cnt == 1) {
            for (int j = 0; j < sz(a); ++j) {
                if (msk >> j & 1)
                    ans.pb(a[j]);
            }
            return;
        }
    }
    if (l <= diff && diff <= r && (mx == 1 || diff < 2 * l + 1 || ask(diff - 1) - ask(l - 1) == g(l, diff - 1))) {
        ans.pb(diff);
        return;
    }
    int m = (l + r) / 2;
    for (int i = 1; i <= mx; ++i) {
        if (l * i + i * (i - 1) / 2 <= diff && diff <= r * i - i * (i - 1) / 2 && l <= diff / i && diff / i <= r) {
            m = diff / i;
            break;
        }
    }
    int both = 0;
    if (ask(m) - ask(l - 1) != g(l, m) && ask(r) - ask(m) != g(m + 1, r))
        both = 1;
    if (ask(m) - ask(l - 1) != g(l, m))
        dfs(l, m, mx - both);
    if (ask(r) - ask(m) != g(m + 1, r))
        dfs(m + 1, r, mx - both);
}

void solve () {
    mp.clear();
    cin >> n >> k;
    dfs(1, n, k);
    cout << "! ";
    for (int i : ans)
        cout << i << ' ';
    cout << endl;
    ans.clear();
    int a;
    cin >> a;
    if (a != 1)
        exit(1);
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}