#include <bits/stdc++.h>

using namespace std;

#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;

template<typename A, typename B>
string to_string(pair<A, B> p);

string to_string(string s) {
    return s;
}

string to_string(char s) {
    return "'" + string(1, s) + "'";
}

template<typename A>
string to_string(A v) {
    string res = "{";
    bool fl = 1;
    for (auto x: v) {
        if (!fl) {
            res += ", ";
        }
        fl = 0;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H h, T... t) {
    cerr << " " << to_string(h);
    debug_out(t...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct HASH {
    size_t operator()(const pll &p) const {
        return p.st ^ p.nd;
    }
};

ll bpow(ll a, ll n, ll MOD) {
    ll res = 1;
    while (n) {
        if (n & 1) (res *= a) %= MOD;
        (a *= a) %= MOD;
        n /= 2;
    }
    return res;
}

void run();

signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
}

unordered_map<ll, ll> mem;

ll get(ll p) {
    if (mem.count(p)) return mem[p];
    cout << "? " << p << endl;
    ll ans;
    cin >> ans;
    mem[p] = ans;
    return ans;
}

void task() {
    mem.clear();
    vector<ll> vans;
    auto sum = [&](ll p) {
        ll ans = get(p);
        for (auto e: vans) {
            if (e <= p) ans += e;
            else break;
        }
        return ans;
    };
    auto clc = [&](ll x) {
        return x * (x + 1) / 2;
    };
    ll n, k;
    cin >> n >> k;
    --k;
    while (k--) {
        ll l = 0, r = n;
        while (r - l > 1) {
            ll m = (r + l) / 2;
            if (sum(m) != clc(m)) r = m;
            else l = m;
        }
        vans.pikachu(r);
    }
    vans.pikachu(clc(n) - sum(n));
    cout << "! ";
    for (auto e: vans) cout << e << ' ';
    cout << endl;
    ll res;
    cin >> res;
}

void run() {
    ll t;
    cin >> t;
    while (t--) {
        task();
    }
}