#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
const int N = 1e6, C = 1000, K = 28, INF = 0x3f3f3f3f;
const double EPS = 1e-5;

/*
random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);
*/

struct hash_str {
    int P, M, n;
    vector<int> p, power;

    void init(string &s, int Pr, int Mod) {
        P = Pr;
        M = Mod;
        n = (int) s.size();
        p.resize(n + 1);
        power.resize(n + 1);
        power[0] = 1;
        for (int i = 1; i <= n; i++) {
            power[i] = (power[i - 1] * P) % M;
        }
        for (int i = 1; i <= n; i++) {
            p[i] = (p[i - 1] + (int) (s[i - 1] - 'a') * power[i]) % P;
        }
    }

    int subhash(int l, int r) {
        int val = (p[r] - p[l] + M) % M;
        val = (val * power[n - r]) % M;
        return val;
    }

    bool comp(int l1, int r1, int l2, int r2) {
        if (r2 - l2 != r1 - l1)
            return false;
        return subhash(l1, r1) == subhash(l2, r2);
    }
};

vector<int> z_func(string &s) {
    int n = (int) s.size();
    vector<int> z(n);
    for (int i = 1, l = 0, r = 0; i < n; i++) {
        if (i < r)
            z[i] = min(z[i - l], r - i);
        while (i + z[i] < n && s[i] == s[i + z[i]])
            z[i]++;
        if (i + z[i] >= r) {
            r = i + z[i];
            l = i;
        }
    }
    return z;
}

int req(int val) {
    cout << "? " << val << endl;
    int inp;
    cin >> inp;
    cout.flush();
    return inp;
}

bool check(int i, int inp, int sum) {
    __int128 val1 = i * (i + 1) / 2,
            val2 = inp + sum;
    return val1 == val2;
}

bool solve() {
    cout.flush();
    int n, k;
    cin >> n >> k;
    vector<int> ans(k);
    map<int, int> used;
    int last = 0, sum = 0;
    for (int i = 0; i < k - 1; i++) {
        int l = last, r = n;
        while (r - l > 1) {
            int m = (r + l) / 2;
            int val;
            if (used.find(m) == used.end()) {
                val = req(m);
                used[m] = val;
            }
            else
                val = used[m];
            if (check(m, val, sum))
                l = m;
            else
                r = m;
        }

        ans[i] = r;
        sum += r;
        last = r;
    }
    int q = req(n);
    __int128 all = n * (n + 1) / 2;
    ans[k - 1] = all - (q + sum);
    cout << "! ";
    for (int i = 0; i < k; i++) {
        cout << ans[i] << " ";
    }
    cout << endl;
    int val;
    cin >> val;
    return val == 1;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //cout << fixed << setprecision(15);
    int T = 1;
    cin >> T;
    while (T--) {
        if (!solve())
            return 0;
    }
    return 0;
}