#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()
#define pw(x) (1ll << (x))

typedef unsigned long long ull;
typedef long long ll;

//template <typename T>
//using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int maxn = 5e5;
const int inf = 1e9 + 1;

ll ask(ll pos) {
   cout << "? " << pos << '\n';
   cout.flush();
   cin >> pos;
   assert(pos != -1);
   return pos;   
}

ll calc(ll x, vector<int> &evils) {
   ll ans = ask(x);
   for (int i : evils) {
      if (i <= x) {
         ans = ans + i;
      }
   }
   return ans;
}

void run_test(int test_case) {
   int n, k;
   cin >> n >> k;
   
   vector<int> evils;
   
   for (int i = 0; i < k; i++) {
      int l = 1, r = n;
      while (l < r) {
         ll mid = (l + r) >> 1;
         if (calc(mid, evils) != mid * (mid + 1) / 2) {
            r = mid;
         } else {
            l = mid + 1;
         }
      }
      evils.push_back(l);
   }
   cout << "!";
   for (int i : evils) {
      cout << ' ' << i;
   }
   cout << '\n';
   cout.flush();
}

int main() {
   ios_base::sync_with_stdio(0);
   cin.tie(0);
   
   int test_cases = 1;
   cin >> test_cases;
   for (int test_case = 1; test_case <= test_cases; test_case++) {
      run_test(test_case);
   }
   
}