#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

ll ask(ll x) {
    cout << "? " << x << endl;
    ll res;
    cin >> res;
    assert(res >= 0);
    return res;
}

void answer(vector<int> &a) {
    cout << "! ";
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << endl;
    int res;
    cin >> res;
    assert(res == 1);
}

ll get_sum(ll l, ll r) {
    return (l + r) * (r - l + 1) / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    ll sum = ask(n);
    vector<int> ans;
    int last = 0;
    ll musor = 0;
    while (sz(ans) < k) {
        int l = last, r = n;
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            if (musor + ask(m) == get_sum(1, m)) {
                l = m;
            } else {
                r = m;
            }
        }
        ans.emplace_back(r);
        musor += r;
        last = r;
    }
    answer(ans);
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
