#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int ll

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

map<int, ll> all_q;

#ifdef LOCAL

const int N = 1000;
ll sums[N + 1];
vector<int> ban = {3, 5, 6, 16, 19, 21, 22, 24, 25, 27, 28, 29, 30, 31, 37, 38, 43, 45, 48, 50, 55, 57, 59, 63, 65, 67, 69, 70, 72, 74, 76, 77, 78, 79, 80, 82, 84, 86, 87, 89, 91, 92, 94, 95, 98, 102, 106, 108, 109, 110, 111, 113, 114, 115, 117, 119, 120, 123, 126, 131, 134, 135, 137, 138, 139, 144, 145, 148, 150, 153, 154, 156, 158, 162, 163, 164, 165, 168, 170, 173, 174, 178, 180, 181, 183, 184, 185, 187, 188, 192, 194, 195, 196, 197, 198, 200, 201, 202, 204, 205
};
int cnt_q;

void init_game() {
    cnt_q = 0;
    for (int i = 1; i <= N; ++i) {
        sums[i] = i;
    }
    for (auto x : ban) {
        sums[x] = 0;
    }
    for (int i = 2; i <= N; ++i) {
        sums[i] += sums[i - 1];
    }
}

ll ask(ll x) {
    if (all_q.find(x) != all_q.end()) {
        return all_q[x];
    }
    ++cnt_q;
//    cout << "? " << x << endl;
    ll res = sums[x];
//    cin >> res;
    assert(res >= 0);
    all_q[x] = res;
    return res;
}

void answer(vector<int> &a) {
//    cout << "! ";
//    for (auto x : a) {
//        cout << x << ' ';
//    }
//    cout << endl;
    sort(all(a));
    if (a != ban) {
        cout << "WA!" << en;
        for (auto i : ban) {
            cout << i << ' ';
        }
        cout << en;
        for (auto i : a) {
            cout << i << ' ';
        }
        cout << en;
        return;
    } else {
        cout << "OK " << cnt_q << en;
        return;
    }
}
#else
ll ask(ll x) {
    if (all_q.find(x) != all_q.end()) {
        return all_q[x];
    }
    cout << "? " << x << endl;
    ll res;
    cin >> res;
    assert(res >= 0);
    all_q[x] = res;
    return res;
}

void answer(vector<int> &a) {
    cout << "! ";
    for (auto x : a) {
        cout << x << ' ';
    }
    cout << endl;
    int res;
    cin >> res;
    assert(res == 1);
}
#endif

ll get_sum(ll l, ll r) {
    return (l + r) * (r - l + 1) / 2;
}

int n, k;
ll sum;
vector<int> ans;

void rec(int l, int r, ll pref) {
    if (sz(ans) == k) {
        return;
    }
    if (r - l + 1 == 3) {
        ll cur = ask(r) - pref;
        if (cur == 0) {
            ans.emplace_back(l);
            ans.emplace_back(l + 1);
            ans.emplace_back(l + 2);
        }
        if (cur == l) {
            ans.emplace_back(l + 1);
            ans.emplace_back(l + 2);
        }
        if (cur == l + 1) {
            ans.emplace_back(l);
            ans.emplace_back(l + 2);
        }
        if (cur == l + 2) {
            ans.emplace_back(l);
            ans.emplace_back(l + 1);
        }
        if (cur == l + l + 1) {
            ans.emplace_back(l + 2);
        }
        if (cur == l + l + 2) {
            ans.emplace_back(l + 1);
        }
        if (cur == l + 1 + l + 2) {
            ans.emplace_back(l);
        }
        return;
    }
    if (r - l + 1 == 2) {
        ll cur = ask(r) - pref;
        if (cur == 0) {
            ans.emplace_back(l);
            ans.emplace_back(l + 1);
        }
        if (cur == l) {
            ans.emplace_back(l + 1);
        }
        if (cur == l + 1) {
            ans.emplace_back(l);
        }
        return;
    }
}

void kek() {
//    cin >> n >> k;
    ans.clear();
    all_q.clear();
    sum = ask(n);
//    rec(1, n, 0);
    ll pref = ask(1);
    if (pref == 0) {
        ans.emplace_back(1);
    }
    for (int i = 2; i <= n; i += 3) {
        int l = i, r = min(n, i + 2);
        ll q = ask(r);
        ll cur = q - pref;
        if (r - l + 1 == 1) {
            if (cur == 0) {
                ans.emplace_back(l);
            }
        }
        if (r - l + 1 == 3) {
            if (cur == 0) {
                ans.emplace_back(l);
                ans.emplace_back(l + 1);
                ans.emplace_back(l + 2);
            }
            if (cur == l) {
                ans.emplace_back(l + 1);
                ans.emplace_back(l + 2);
            }
            if (cur == l + 1) {
                ans.emplace_back(l);
                ans.emplace_back(l + 2);
            }
            if (cur == l + 2) {
                ans.emplace_back(l);
                ans.emplace_back(l + 1);
            }
            if (cur == l + l + 1) {
                ans.emplace_back(l + 2);
            }
            if (cur == l + l + 2) {
                ans.emplace_back(l + 1);
            }
            if (cur == l + 1 + l + 2) {
                ans.emplace_back(l);
            }
        }
        if (r - l + 1 == 2) {
            if (cur == 0) {
                ans.emplace_back(l);
                ans.emplace_back(l + 1);
            }
            if (cur == l) {
                ans.emplace_back(l + 1);
            }
            if (cur == l + 1) {
                ans.emplace_back(l);
            }
        }
        pref = q;
    }
//    assert(sz(ans) == k);
    answer(ans);
}

void solve() {
//    cin >> n >> k;
    sum = ask(n);
    ll nohave = get_sum(1, n) - sum;
    ans.clear();
    all_q.clear();
    int last = 0;
    ll musor = 0;
    while (sz(ans) < k - 1) {
        int l = last, r = n;
        while (r - l > 1) {
            int m = l + (r - l) / 2;
            if (musor + ask(m) == get_sum(1, m)) {
                l = m;
            } else {
                r = m;
            }
        }
        ans.emplace_back(r);
        musor += r;
        last = r;
    }
    ans.emplace_back(nohave - musor);
    answer(ans);
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
    init_game();
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
    cin >> tests;
#endif
    for (int test = 1; test <= tests; ++test) {
        cin >> n >> k;
        if (n <= 1000) {
            kek();
        } else {
            solve();
        }
//        solve();
//        kek();
    }
    return 0;
}
