#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(3423423342);

const int INF = 1e9 + 7;

map<int, int> pref;

int k;

bool stress = false;
set<int> best;

int cnt = 0, mx = 0;

set<int> used;

int stress_ask(int n) {
    cnt++;
    int sm = n * (n + 1) / 2;
    for (auto a : best)
        if (a <= n) sm -= a;
    pref[n] = sm;
    return sm;
}

int ask(int n) {
    if (used.count(n)) return pref[n];
    if (stress) return stress_ask(n);
    cout << "? " << n << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
    pref[n] = ans;
    used.insert(n);
    return ans;
}

vector<int> ans;


pair<int, int> interruct() {
    int n = rnd() % (int)(1e9) + 1, cnt = min((ll)rnd() % 100ll, n);
    for (int i = 0; i < cnt; i++)
        best.insert(rnd() % n + 1);
    return {n, best.size()};
}

void rec(int l, int r) {
    int c;
    c = r * (r + 1) / 2 - l * (l - 1) / 2 - (ask(r) - ask(l - 1));
    //dbg(l << ' ' << r);
    if (c == 0) {
        return;
    } else if (k == 1) {
        assert(l <= c && c <= r);
        ans.emplace_back(c);
        k--;
    } else if (c == r * (r + 1) / 2 - l * (l - 1) / 2) {
        for (int i = l; i <= r; i++) {
            ans.emplace_back(i);
            k--;
        }
    } else if (c >= l && c <= r && 2 * l >= c) {
        ans.emplace_back(c);
        k--;
    } else {
        int m = (l + r) / 2;
        rec(l, m);
        rec(m + 1, r);
    }
}

void solve() {
    cnt = 0;
    pref.clear();
    ans.clear();
    best.clear();
    used.clear();
    used.insert(0);
    pref[0] = 0;
    int n;
    if (stress) {
        auto bebr = interruct();
        n = bebr.F, k = bebr.S;
    } else {
        cin >> n >> k;
    }
    rec(1, n);
    if (k != 0) {
        for (auto a : best) {
            cout << a << ' ';
            cout << endl;
            exit(0);
        }
    }
    if (stress) {
        if (ans.size() == best.size()) {
            bool fl = true;
            for (auto a: ans)
                fl &= (best.count(a) > 0);
            if (fl) {
                cout << "Ok\n";
            } else {
                for (auto a: best) cout << a << ' ';
                cout << endl;
                exit(0);
            }
        } else {
            for (auto a: best) cout << a << ' ';
            cout << endl;
            exit(0);
        }
    } else {
        cout << "! ";
        sort(all(ans));
        for (auto a: ans)
            cout << a << ' ';
        cout << endl;
        int b;
        cin >> b;
        if (b == -1) {
            exit(0);
        }
    }
    mx = max(cnt, mx);
}

signed main() {
    int t = 10000000;
    if (!stress)
        cin >> t;
    while (t--) {
        solve();
    }
    if (stress)
        cout << mx;
}