#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n, k;
#ifdef LOCAL
vector<ll> fake;
#endif

ll get(int p) {
#ifdef LOCAL
	ll ret = 0;
	for (ll x : fake) {
		if (x <= p) {
			ret += x;
		}
	}
	return ret;
#else
	cout << "? " << p << endl;
	ll a;
	cin >> a;
	if (a == -1) exit(0);
	return p * 1ll * (p + 1) / 2 - a;
#endif
}

ll f(ll x) {
	if (x == 1) {
		return 0;
	}
	return get(x - 1);
}

vector<ll> vals;

void solve(int l, int r, ll fl, ll fr) {
	vals.push_back(fl);
	vals.push_back(fr);
	if (r - l <= 1) return;
	ll m = (l + r) / 2;
	ll fm = f(m);
	vals.push_back(fm);
	if (fm != fl) {
		solve(l, m, fl, fm);
	}
	if (fm != fr) {
		solve(m, r, fm, fr);
	}
}

void solve() {
	cin >> n >> k;
#ifdef LOCAL
	fake.resize(k);
	for (int i = 0; i < k; ++i) {
		cin >> fake[i];
	}
#endif
	vals.clear();
	solve(1, n + 1, 0, f(n + 1));
	sort(vals.begin(), vals.end());
	vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
	assert((int)vals.size() == k + 1);
	cout << "! ";
	for (int i = 1; i <= k; ++i) {
		cout << vals[i] - vals[i - 1] << " ";
	}
	cout << endl;
	int a;
	cin >> a;
	if (a == -1) exit(0);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}