#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

int n, k;
#ifdef LOCAL
vector<ll> fake;
#endif

int queries;

ll get(int p) {
	++queries;
	assert(queries <= 3500);
#ifdef LOCAL
	ll ret = 0;
	for (ll x : fake) {
		if (x <= p) {
			ret += x;
		}
	}
	return ret;
#else
	cout << "? " << p << endl;
	ll a;
	cin >> a;
	if (a == -1) exit(0);
	return p * 1ll * (p + 1) / 2 - a;
#endif
}

ll f(ll x) {
	if (x == 1) {
		return 0;
	}
	return get(x - 1);
}

vector<ll> vals;

ll getsum(int l, int r) {
	return (l + r) * 1ll * (r - l + 1) / 2;
}

bool can(int l, int r, ll s, int i) {
	if (s >= getsum(l, l + i - 1) && s <= getsum(r - i, r - 1)) {
		return true;
	}
	return false;
}

void solve(int l, int r, ll fl, ll fr) {
	vals.push_back(fl);
	vals.push_back(fr);
	if (r - l <= 1) {
		return;
	}
	ll s = fr - fl;
	vector<pair<int, int>> segs;
	for (int i = 1; i <= min(k, r - l + 1); ++i) {
		if (!can(l, r, s, i)) {
			continue;
		}
		int l1 = l, r1 = r;
		while (r1 - l1 > 1) {
			int m1 = (l1 + r1) / 2;
			if (can(l, m1, s, i)) {
				r1 = m1;
			} else {
				l1 = m1;
			}
		}
		int x = r1;
		l1 = l, r1 = r;
		while (r1 - l1 > 1) {
			int m1 = (l1 + r1) / 2;
			if (can(m1, r, s, i)) {
				l1 = m1;
			} else {
				r1 = m1;
			}
		}
		int y = l1;
		assert(y < x);
		segs.push_back({y, x});
	}
	int mn = 1e9 + 1;
	for (auto [y, x] : segs) {
		// cout << y << " " << x << endl;
		mn = min(mn, x);
	}
	bool ok = true;
	for (auto [y, x] : segs) {
		ok &= mn - 1 >= y;
	}
	// cout << endl;
	int m = min(max(l + 1, mn - 1), r - 1);
	if (!ok) {
		m = (l + r) / 2;
	}
	ll fm = f(m);
	vals.push_back(fm);
	if (fm != fl) {
		solve(l, m, fl, fm);
	}
	if (fm != fr) {
		solve(m, r, fm, fr);
	}
}

void solve() {
	cin >> n >> k;
#ifdef LOCAL
	fake.resize(k);
	for (int i = 0; i < k; ++i) {
		cin >> fake[i];
	}
#endif
	vals.clear();
	queries = 0;
	// ll lstf = f(n + 1);
	// while (n > 0) {
	// 	int kek = (n + 1) / 2;
	// 	ll newf = f(kek);
	// 	solve(kek, n + 1, newf, lstf);
	// 	lstf = newf;
	// 	n = kek - 1;
	// }
	solve(1, n + 1, 0, f(n + 1));
	sort(vals.begin(), vals.end());
	vals.resize(unique(vals.begin(), vals.end()) - vals.begin());
	assert((int)vals.size() == k + 1);
	cout << "! ";
	for (int i = 1; i <= k; ++i) {
		cout << vals[i] - vals[i - 1] << " ";
	}
	cout << endl;
#ifdef LOCAL
	cout << queries << " " << k + 30 << endl;
#endif
	int a;
	cin >> a;
	if (a == -1) exit(0);
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}