#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <numeric>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef vector<vvi> vvvi;
typedef pair<int, int> pi;
typedef vector<pi> vpi;
typedef vector<vpi> vvpi;
typedef vector<vpi> vvpi;
typedef set<int> si;
typedef multiset<int> msi;
typedef set<pi> spi;
typedef multiset<pi> mspi;
typedef vector<si> vsi;
typedef vector<spi> vspi;
typedef vector<bool> vb;

template<typename T> bool minravno(T& a, const T& b) {
	if (b < a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> bool maxravno(T& a, const T& b) {
	if (b > a) {
		a = b;
		return true;
	}
	return false;
}
template<typename T> void input(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cin >> a[k];
}
template<typename T> void print(const T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	for (int k = i; k <= j; ++k)
		cout << a[k] << ' ';
}
template<typename T> void sort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void rsort(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	sort(a.begin() + i, a.begin() + (j + 1));
	reverse(a.begin() + i, a.begin() + (j + 1));
}
template<typename T> void reverse(T& a, int i = 0, int j = -1) {
	if (j == -1)
		j = (int)a.size() - 1;
	reverse(a.begin() + i, a.begin() + (j + 1));
}

int n, k;

int prog(int x) {
	return x * (x + 1) / 2;
}

int prog(int l, int r) {
	return prog(r) - prog(l - 1);
}

int ask(int i) {
	cout << "? " << i << endl;
	int res;
	cin >> res;
	return prog(i) - res;
}

int find_first(int l, int r, int x) {
	l--;
	while (r - l > 1) {
		int m = (r + l) / 2;
		int val = ask(m) - x;
		if (val)
			r = m;
		else
			l = m;
	}
	return r;
}

vi solve(int l, int r, int x) {
	vi res;
	for (int i = 0; i < k; ++i) {
		int j = find_first(l, r, x);
		res.push_back(j);
		l = j + 1;
		x += j;
	}
	return res;
}

vi solve3(int l, int r, int x) {
	return {};
}

vi solve4(int l, int r, int x) {
	return {};
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	
	int t;
	cin >> t;
	while (t--) {
		cin >> n >> k;
		vi ans;
		if (k >= -5)
			ans = solve(1, n, 0);
		else if (k == 4)
			ans = solve4(1, n, 0);
		else
			ans = solve3(1, n, 0);
		cout << "! ";
		print(ans);
		cout << endl;
	}

	return 0;
}