#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;

void solve();

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--){
        solve();
    }
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}

vector<int> found;


map<int, ll> asked;

int cnt = 0;

ll ask(int k){
//    cerr << "ask " << k << endl;
    ll x;
    if (asked.find(k) == asked.end()){
        cout << "? " << k << endl;
        cnt++;
        cin >> x;
        asked[k] = x;
    }
    x = asked[k];
    for (auto el : found){
        if (el <= k){
            x += el;
        }
    }
//    cerr << "res is " << x << endl;
    return x;
}

ll get(ll x){
    return (x + 1) * x / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    if (k == 3){
        int l = 0;
        int r = n;
        while (r - l > 1){
            int m = (l + r) / 2;
//            cout << l << ' ' << r << ' ' << m << ' ' << get(m) << endl;
            int x = get(m);
            int y = ask(m);
            if (x == y){
                l = m;
            } else{
                r = m;
            }
        }
        found.push_back(r);
        ll all = get(n) - ask(n);
        ll x = all / 2;
        ll next = get(x) - ask(x);
        found.push_back(next);
        found.push_back(all - next);
    } else {
        for (int i = 0; i < k; ++i) {
            int l = 0;
            int r = n;
            while (r - l > 1) {
                int m = (l + r) / 2;
//            cout << l << ' ' << r << ' ' << m << ' ' << get(m) << endl;
                int x = get(m);
                int y = ask(m);
                if (x == y) {
                    l = m;
                } else {
                    r = m;
                }
            }
            found.push_back(r);
        }
    }
//    cerr << cnt << endl;
    cnt = 0;
    cout << "! ";
    for (int i = 0; i < k; ++i) {
        cout << found[i] << ' ';
    }
    cout << endl;
    int a;
    cin >> a;
    asked.clear();
    found.resize(0);
    assert(a == 1);
}