#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937 rnd(24234);
const ll inf = 1e18;


ll n, k;


ll ask(ll p){
    cout << "? " << p << endl;
    ll sm = 0;
    cin >> sm;
    return (p * (p + 1)) / 2 - sm;
}


ll answer(vector<ll> &a){
    cout << "!";
    for(auto i: a){
        cout << " " << i;
    }
    cout << endl;
}


void solve(ll l, ll r, ll dx, ll msm, vector<ll> &rs){
    if(msm == 0){
        return;
    }
    if(l > ((r - 1) / 2) && msm < l + l + 1){
        rs.push_back(msm);
        return;
    }
    for(int cnt = 2; ; cnt += 1){
        ll p = msm / cnt;
        if(p >= r){
            continue;
        }
        ll sm = ask(p) - dx;
        if(sm != 0){
            solve(l, p, dx, sm, rs);
            solve(p + 1, r, dx + sm, msm - sm, rs);
            return;
        }
    }
}


vector<ll> solve(){
    vector<ll> rs;
    ll l = 1;
    ll prvs_sm = 0;
    while(l <= n){
        ll r = min(l + l, n);
        ll msm = ask(r) - prvs_sm;
        solve(l, r, 0, msm, rs);
        prvs_sm += msm;
        l = r + 1;
    }
    sort(all(rs));
    return rs;
}


int32_t main(){
    if(1){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    cin >> t;
    while(t--){
        cin >> n >> k;
        auto ans = solve();
        answer(ans);
    }
    return 0;
}

/*
1
10 3
38
3
3
7


*/