#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace     std;
using namespace     __gnu_pbds;
#define int         long long
#define popcnt      __builtin_popcount
#define clz         __builtin_clz
#define ctz         __builtin_ctz
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
map<int, int> queries;
int ask(int x) {
    if (x == 0) return 0;
    if (queries.count(x)) return queries[x];
    cout << "? " << x << endl;
    int f;
    cin >> f;
    if (f == -1) {
        exit(0);
    }
    return queries[x] = f;
}
int sum(int l, int r) {
    return (r + 1) * r / 2 - (l - 1) * l / 2;
} 
void solve() {
    queries = map<int, int>();
    int n, k;
    cin >> n >> k;
    if (n <= 1000) {
        int last = 0;
        vector<int> bad;
        for (int i = 2; i <= n; i += 2) {
            int z = ask(i);
            if (z == -1) {
                exit(0);
            }
            int q = z - (last + i * 2 - 1);
            if (q == -i) {
                bad.push_back(i);
            } else if (q == -i + 1) {
                bad.push_back(i - 1);
            } else if (q != 0) {    
                bad.push_back(i);
                bad.push_back(i - 1);
            }
            last = z;
        }
        if (n & 1) {
            int f = ask(n);
            int g = ask(n - 1);
            if (f == g)
                bad.push_back(n);
        }
        cout << "! ";
        copy(bad.begin(), bad.end(), ostream_iterator<int>(cout, " "));
        cout << endl;
        int p;
        cin >> p;
        if (p == -1) {
            exit(0);
        }
        return;
    }
    vector<int> found;
    int pos = 0, offset = 0;
    while (k > 1) {
        int lo = pos, hi = n - k;
        while (hi > lo + 1) {
            int mi = (lo + hi) / 2;
            int f = ask(mi);
            int z = (sum(1, mi) - f) - offset;
            if (z)
                hi = mi;
            else
                lo = mi;
        }
        found.push_back(hi);
        pos = hi;
        offset = (sum(1, hi)) - ask(hi);
        k--;
    }
    int full = ask(n);
    cout << "! ";
    copy(found.begin(), found.end(), ostream_iterator<int>(cout, " "));
    cout << sum(1, n) - full - accumulate(found.begin(), found.end(), 0ll);
    cout << endl;
    int p;
    cin >> p;
    if (p == -1) {
        exit(0);
    }
}
signed main() {
    // cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    cin >> Tc;
    while (Tc--) {
        solve(), cout << '\n';
    }
}