/*
Lisa
Jennie
Jisoo
Rose
 */

#pragma GCC optimize("03")

#include <iostream>
#include <algorithm>
#include <vector>
#include <set>
#include <bitset>
#include <map>
#include <cstring>
#include <chrono>
#include <random>
#include <bits/extc++.h>


using namespace std;
using namespace __gnu_pbds;

using ll = long long;
#define int ll
using pii = pair<int, int>;
using ld = long double;
using pll = pair<ll, ll>;

const int mxn = 1e9 + 7;
const ll mod = 1000000007;
const ll inf = 1e18;
const ld eps = 1e-8;

#define all(a) a.begin(), a.end()
#define pb push_back
#define endl '\n'
#define vout(a) for (auto i : a) {cout << i << ' ';}; cout << endl;
#define debug(a) cerr << a << endl;
// #define int ll


ll sum (ll l, ll r) {
    return r * (r + 1) / 2 - l * (l - 1) / 2;
}


map <pll, ll> fake;
map <ll, ll> pref;


ll res, n, k;
void tl() {
    for (int i = 0; i < 1e9; ++i) {
        cout << i << endl;
    }
}

void ask (ll l, ll r) {
    cout << "? " << r << endl; cout.flush();
    cin >> res;
    if (res == -1) {
        tl();
    }
    fake[{l, r}] = sum(1, r) - res - pref[l - 1];
    pref[r] = fake[{l, r}] + pref[l - 1];
}


vector <ll> ans;

ll get (ll l, ll r) {
    vector <ll> mi(k + 1, 0), ma(k + 1, 0);
    for (ll i = 1; i <= k && i <= r - l + 1; ++i) {
        mi[i] = l * i + i * (i - 1) / 2;
        ma[i] = r * i - i * (i - 1) / 2;
    }
    ll x = 0;
    bool can = true;
    for (ll i = 1; i <= k && i <= r - l + 1; ++i) {
        if (mi[i] > ma[i - 1] && (i == k || i == r - l + 1 || ma[i] < mi[i + 1]) && can) {
            x = i;
        }
        else {
            can = false;
        }
    }
    return x;
}

void slv (ll l, ll r) {
    if (l > r || !fake[{l, r}]) {
        return;
    }
    if (fake[{l, r}] <= r) {
        ans.pb(fake[{l, r}]);
        return;
    }
    ll S = fake[{l, r}];
    vector <ll> mi(k + 1, 0), ma(k + 1, 0);
    for (ll i = 1; i <= k && i <= r - l + 1; ++i) {
        mi[i] = l * i + i * (i - 1) / 2;
        ma[i] = r * i - i * (i - 1) / 2;
    }
    ll x = 0;
    bool can = true;
    for (ll i = 1; i <= k && i <= r - l + 1; ++i) {
        if (S >= mi[i] && S <= ma[i] && mi[i] > ma[i - 1] && (i == k || i == r - l + 1 || ma[i] < mi[i + 1])) {
            // i = cnt
            ll m = S / i;
            ask(l, m);
            fake[{m + 1, r}] = pref[r] - pref[m];
            slv(l, m);
            slv(m + 1, r);
            return;
        }
        if (mi[i] > ma[i - 1] && (i == k || i == r - l + 1 || ma[i] < mi[i + 1]) && can) {
            x = i;
        }
        else {
            can = false;
        }
    }
    ll left = l, right = r;
    while (right - left > 1) {
        ll m = (left + right) / 2;
        if (get(l, m) == min(m - l + 1, x + 1)) {
            left = m;
        }
        else {
            right = m;
        }
    }
    ll m = left;
    ask(l, m);
    fake[{m + 1, r}] = pref[r] - pref[m];
    slv(l, m);
    slv(m + 1, r);
}


void solve() {
    fake.clear(); pref.clear(); ans.clear();
    cin >> n >> k;
    ll curr = 1;
    while (true) {
        ask(curr, min(n, curr * 2));
        slv(curr, min(n, curr * 2));
        curr = curr * 2 + 1;
        if (curr > n) {
            break;
        }
    }
    for (auto i : fake) {
        // cout << i.first.first << ' ' << i.first.second << ' ' << i.second << endl;
    }
    cout << "! "; vout(ans); cout.flush();
    cin >> res;
    if (res == -1) {
        // tl();
        exit(0);
    }
    else {
        // exit(0);
    }
}


signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1; cin >> t;
    while (t--) {
        solve();
    }
}