#pragma GCC target("avx2")
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

int calc(int a, int b)
{
    return (b - a + 1) * (a + b) / 2;
}

map<int, bool> was;
map<int, int> val;

int query(int p)
{
    if (p == 0) return 0;
    if (was[p]) return val[p];
    cout << "? " << p << endl;
    int res;
    cin >> res;
    was[p] = true;
    val[p] = res;
    return res;
}

vec<int> ans;

void solve(int l, int r)
{
    if (l > r) return;
    if (l == r)
    {
        ans.pb(l);
        return;
    }
    int m = l + r >> 1;
    int v1 = query(l - 1);
    int v2 = query(m);
    int v3 = query(r);
    if (v2 - v1 != calc(l, m)) solve(l, m);
    if (v3 - v2 != calc(m + 1, r)) solve(m + 1, r);
}

void solve()
{
    was.clear();
    val.clear();
    int n, k;
    cin >> n >> k;
    solve(1, n);
    cout << "! ";
    for (int &x : ans) cout << x << " ";
    cout << endl;
    int a;
    cin >> a;
}

int32_t main()
{
    int t;
    cin >> t;
    while (t--)
        solve();
    return 0;
}
