#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

long long ask(int p){

    cout<< "? " << p << endl;
    long long ans;
    cin >> ans;
    return ans;
}

void solve(){
    int n, k;
    cin>> n >> k;

    vector<int> ids;
    vector<long> pref(n + 1, 0);
    for(int i = 2; i <= n; i += 2){

        if(ids.size() == k){
            break;
        }

        pref[i] = ask(i);
        if(pref[i] == -1)
            return ;
        long long su = pref[i] - pref[i - 2];
        if(su == 2 * i - 1)
            continue;

        if(su == 0){
            ids.push_back(i -1);
            ids.push_back(i);
            continue;
        }

        if(su == i){
            ids.push_back(i - 1);
        }
        if(su == i - 1)
            ids.push_back(i);
    }

    if(n % 2 == 1){
        long long u = ask(n) - pref[n - 1];
        if(u == 0)
            ids.push_back(n);

    }

    cout<< "! ";
    for(auto j : ids)
        cout<< j << " ";
    cout<< endl;

}



int main(){
    //ios_base::sync_with_stdio(false);
    //cin.tie(0);

    int t;
    cin >> t;
    while(t --)
        solve();

    return 0;
}
