#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

map <int, long long> asked;

long long ask(int p) {
	if (asked.find(p) != asked.end())
		return asked[p];
	cout << "? " << p << endl;
	long long res;
	cin >> res;
	asked[p] = res;
	return res;
}

long long f(int l, int r) {
	int len = (r - l + 1);
	return 1ll * (l + r) * len / 2;
}


void solve() {
	asked.clear();
	int n, k;
	cin >> n >> k;
	int st = 1;
	long long sum = 0;
	vector <int> ans;
	while (st <= n && ask(n) + sum != f(1, n)) {
		int l = st, r = n;
		while (l < r) {
			int mid = (l + r) / 2;
			if (ask(mid) + sum != f(1, mid))
				r = mid;
			else
				l = mid + 1;
		}
		sum += l;
		ans.push_back(l);
		st = l + 1;
	}
	cout << "! ";
	for (auto e : ans)
		cout << e << " ";
	cout << endl;
	int one;
	cin >> one;
	if (one == -1)
		exit(0);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}