#include <iostream>
#include <string>
#include<vector>
#include <map>
#include <set>
#include <queue>
#include <cmath>
#include <algorithm>
#include <complex>

using namespace std;

typedef long long ll;
typedef vector<int> vi;
typedef vector<ll> vl;
typedef vector<vector<int> > vvi;
typedef vector<vector<ll>> vvl;
typedef vector<bool> vb;


#define all(v) v.begin(), v.end()
#define pb push_back()
/*
ll p[500005];

int pred(int a) {
    if(a != p[a])
        return p[a] = pred(p[a]);
    else return a;

}
void merge(int a, int b) {
    if(abs(rand()) % 2) {
        a = pred(a);
        p[a] = b;
    } else {
        b = pred(b);
        p[b] = a;
    }
}

bool check(int a, int b) {
    return (pred(a) == pred(b));
}
 */
/*
void build(vl & t, int v, int l, int r, vi & a) {
    if(l == r) t[v] = a[l];
    else {
        int m = (l + r) / 2;
        build(t, 2 * v, l, m, a);
        build(t, 2 * v + 1, m + 1, r, a);
        t[v] = (t[2 * v] + t[2 * v + 1]);
    }
}
int sum(vl & t, int v, int tl, int tr, int l, int r) {
    if(l == tl && r == tr) return t[v];
    // look out
    if(l > r) return 0;
    // look out
    int tm = (tl + tr) / 2;
    return sum(t, 2 * v, tl, tm, l, min(tm, r)) +
            sum(t, 2 * v + 1, tm + 1, tr, max(tm + 1, l), r);

}
void update(vl & t, int v, int tl, int tr, int pos, int x) {
    if(tl == tr) t[v] = x;
    else {
        int tm = (tl + tr) / 2;
        if(pos <= tm) update(t, 2 * v, tl, tm, pos, x);
        else update(t, 2 * v + 1, tm + 1, tr, pos, x);
        t[v] = t[2 * v] + t[2 * v + 1];
    }
}
*/

/*void dfs(ll v,vector<vector<pair<ll, ll>>> & g, vl & used) {
    used[v] = 1;
    for(auto u : g[v]) {
        if(used[u.first]) continue;
        dfs(u.first, g, used);
    }
}*/

const ll M = 1e9 + 7;
ll fastPow(ll a, ll n) {
    if(n == 0) return 1;
    ll bf = fastPow(a, n / 2);
    bf *= bf;
    bf %= M;
    if(n % 2) bf *= a;
    return bf % M;
}
map<ll, ll> q;
vl ans;
ll k = 0;
int allGood = 1;

void f(ll l, ll r, ll sum) {
    if(allGood == -1) return;
    if(ans.size() == k - 1) return;
    if(l == r) {
        ans.push_back(l);
        return;
    }
    if(sum < 2 * l + 1) {
        ans.push_back(sum);
        return;
    }
    //while(l < r) {
    ll m = (l + r) / 2;
    cout << "? " << m << endl;
    ll t; cin >> t;
    if(t == -1) {
        allGood = -1;
        return;
    }
    q[m] = t;
    ll left = m * (m + 1) / 2 - (l - 1) *(l) / 2 - (q[m] - q[l - 1]);
    ll right = r * (r + 1) / 2 - m * (m + 1) / 2 - (q[r] - q[m]);
    if(left != 0) {
        f(l, m, left);
    }
    if(right != 0) f(m + 1, r, right);
    //}


}
void g(ll l, ll r, ll bfk) {

    ll sum = r * (r + 1) / 2 - (l - 1) * l / 2 - (q[r] - q[l - 1]);
    ll m = (l + r) / 2;
    if(bfk == 1) {
        ans.push_back(sum);
        return;
    }
    if(bfk == 2) {
        m = sum / 2;
        cout << "? " << m << endl;
        ll t; cin >> t;

        if(t == -1) {
            allGood = -1;
            return;
        }
        q[m] = t;
        //cout << m * (m + 1) / 2 - (l - 1) *(l) / 2 << ' ' << q[m] << ' ' << q[l - 1]<< endl;
        ll left = m * (m + 1) / 2 - (l - 1) *(l) / 2 - (q[m] - q[l - 1]);
        ll right = r * (r + 1) / 2 - m * (m + 1) / 2 - (q[r] - q[m]);
        ans.push_back(left);
        ans.push_back(right);
        return;
    }
    cout << "? " << m << endl;
    ll t; cin >> t;

    if(t == -1) {allGood = -1;return;}
    q[m] = t;
    ll left = m * (m + 1) / 2 - (l - 1) *(l) / 2 - (q[m] - q[l - 1]);
    ll right = sum - left;
    if(left == 0) g(m + 1, r, k);
    if(right == 0) g(l, m, k);
    if(left != 0 && right != 0) {
        cout << "? " << left / 2 << endl;
        cin >> t;
        if(t == -1) {allGood = -1;return;}
        q[left / 2] = t;
        ll s = (left / 2) * (left / 2 + 1) / 2 - q[left / 2];
        if(s == 0) {
            ans.push_back(left);
            g(m + 1, r, bfk - 1);

        } else {
            ans.push_back(s);
            ans.push_back(left - s);
            ans.push_back(right);
        }
    }
}
void solve() {
    ll n;
    cin >> n;
    cin >> k;
    ans.clear();
    q.clear();
    allGood = 1;
    q[0] = 0;
    ll l = 1;
    ll r = n;
    cout << "? " <<  r << endl;
    ll t1; cin >> t1;
    q[r] = t1;
    if(k == 3) {
        g(l, r, k);
    } else
        f(l, r, r * (r + 1) / 2 - q[r]);
    if(ans.size() == k - 1) {
        ll sum = 0;
        for(auto x : ans) sum += x;
        ans.push_back(n * (n + 1) / 2-  q[n] - sum);
    }



    if(allGood == -1) return;
    cout << "! ";
    for(auto x : ans) {
        cout << x << ' ';
    }
    cout << endl;
    cin >> allGood;
    //vl a(n); for(int i = 0; i < n; ++i) cin >> a[i];


    //ll ans = 0;

    // ll k; cin >> k;
    // ll a, b, c; cin >> a >> b >> c;
    //ll d; cin >> d;
    // string s; cin >> s; n = s.length();

    // cout << (ans ? "YES" : "NO");
    // cout << ans.size() << '\n';
    // for(auto x : ans) cout << x << '\n';
    // for(auto p : ans) cout << p.first << ' ' << p.second << "\n";
    //cout << "\n";

}
signed main() {
    //ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while(t--) {
        if(allGood == -1) return 0;
        solve();
    }

    return 0;
}