#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <fstream>

using namespace std;

#define ll long long
#define eps 1e-10
#define inf 1e15
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

#ifdef LOCAL_BOBER
#define preproc ifstream fl("sample.io")
//#define cin fl
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr);
#else
#define preproc ;
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr); cin.tie(nullptr);
#endif

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

vector<ll> pref;
vector<ll> ans;

void rec(ll l, ll r) {
	if (r - l <= 2) {
		ll sum = pref[r] - pref[l];
		if (sum == 0) {
			for (int i = l + 1; i <= r; i++)
				ans.push_back(i);
		}
		else if (sum == l + 1 && r != l + 1) {
			ans.push_back(r);
		}
		else if (sum == r && l + 1 != r) {
			ans.push_back(l + 1);
		}

		re;
	}

	int t = (r + l) / 2;
	cout << "? " << t << "\n";
	cout.flush();
	cin >> pref[t];

	if (pref[t] - pref[l] != (t + l + 1) * (t - l) / 2) {
		if (pref[t] - pref[l] == 0) {
			for (int i = l + 1; i <= t; i++)
				ans.push_back(i);
		}
		else rec(l, t);
	}

	if (pref[r] - pref[t] != (r + t + 1) * (r - t) / 2) {
		if (pref[r] - pref[t] == 0) {
			for (int i = t + 1; i <= r; i++) {
				ans.push_back(i);
			}
		}
		else rec(t, r);
	}
}

int main() {
	//preproc; 
	//fast_io;

	int t; cin >> t;
	while (t--) {
		ll n, k; cin >> n >> k;
		pref.resize(n + 1);
		fill(all(pref), 0);
		ans.clear();

		cout << "? " << n << "\n";
		cout.flush();
		ll q; cin >> q;
		pref[n] = q;
		rec(0, n);

		cout << "! ";
		for (auto i : ans) cout << i << ' ';
		cout << "\n";
		cout.flush();

		cin >> q;
		if (q == -1)re 0;
	}
}