#include <iostream>
#include <algorithm>
#include <numeric>
#include <cmath>
#include <vector>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <iomanip>

using namespace std;
using ll = long long;

const ll MOD = 1e9 + 7, p = 179;

struct Str{
    vector <ll> hPrev;
    vector <ll> pMod;
};

ll hash_(Str str, int l, int r){
    return (abs(str.hPrev[r + 1] % MOD - str.hPrev[l] % MOD)) / str.pMod[l] % MOD;
}

int main() {
    ll n, m;
    cin >> n >> m;
    string str;
    cin >> str;
    vector <string> arr(n);
    for (int i = 0; i < n; i++){
        cin >> arr[i];
    }
    Str mainStr;
    mainStr.pMod.resize(str.size() + 1);
    mainStr.hPrev.resize(str.size() + 1);
    mainStr.pMod[0] = 1;
    mainStr.hPrev[0] = 0;
    for (int i = 1; i <= str.size(); i++){
        mainStr.pMod[i] = (mainStr.pMod[i - 1] * p) % MOD;
        mainStr.hPrev[i] = (mainStr.hPrev[i - 1] + str[i - 1] * mainStr.pMod[i]) % MOD;
    }
    cout << hash_(mainStr, 0, 2) << '\n' << hash_(mainStr, 3, 5) << '\n';
    for (int i = 0; i < m; i++){
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int ans = 0;
        for (auto elem : arr) {
            for (int j = l; j + elem.size() <= r + 1; j++) {
                if (str.substr(j, elem.size()) == elem){
                    ans++;
                }
            }
        }
        cout << ans << ' ';
    }
}
