#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int >
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree < T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = (int)1e9 + 7;
const int N = (int)5e5 + 5;
const int p = 41;

int pw[N], ans[N];

vector < pii > add[N], rem[N];
vector < int > query[N];

pii getHash(string s) {
    int sz = (int)s.size() - 1, res = 0;
    for (int i = 1; i <= sz; i++) {
        res = (res + pw[i - 1] * (s[i] - 'a' + 1)) % MOD;
    }
    return { res, sz };
}

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    pw[0] = 1;
    for (int i = 1; i < N; i++) {
        pw[i] = (pw[i - 1] * p) % MOD;
    }

    int n, q;
    string s;
    cin >> n >> q >> s;
    s.insert(0, "$");
    vector < string > a(n + 1);
    map < pii, int > mp;
    for (int i = 1; i <= n; i++) {
        cin >> a[i]; a[i].insert(0, "$");
        mp[getHash(a[i])] = 1;
    }
    vector < pii > all(q + 1);
    for (int i = 1; i <= q; i++) {
        cin >> all[i].first >> all[i].second;
        query[all[i].first].push_back(i);
    }

    int sz = (int)s.size() - 1;
    vector < pii > p;
    for (int i = 1; i <= sz; i++) {
        int cur = 0;
        for (int j = i; j <= sz; j++) {
            cur = (cur + pw[j - i] * (s[j] - 'a' + 1)) % MOD;
            if (!mp.count({ cur, j - i + 1 })) continue;
            add[i].push_back({ j, i }); rem[j + 1].push_back({ j, i });
            p.push_back({ i, j });
        }
    }

    for (int i = 1; i <= q; i++) {
        int answ = 0;
        for (auto x: p) {
            if (x.first >= all[i].first && x.second <= all[i].second) {
                answ++;
            }
        }
        cout << answ << ' ';
    }
    return 0;
}
