#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);



void solve() {
    ll n, m;
    cin >> n >> m;

    string s;
    cin >> s;

    vector<ll> step_p(1e6 + 1);
    step_p[0] = 1;

    for (ll i = 1; i < 1e6 + 1; ++i) {
        step_p[i] = step_p[i - 1] * 31;
        step_p[i] %= 228228337;
    }

    vector<ll> pref_hash(s.size() + 1);
    pref_hash[0] = 0;

    for (ll i = 1; i <= s.size(); ++i) {
        pref_hash[i] = pref_hash[i - 1] + (ll(s[i - 1] - 'a' + 1) * step_p[i - 1]) % 228228337;
        pref_hash[i] %= 228228337;
    }

    vector<ll> lenn(n);
    vector<vector<ll>> vhod(n);

    for (ll i = 0; i < n; ++i) {
        string h;
        cin >> h;

        lenn[i] = h.size();

        ll rt = 0;

        for (ll j = 0; j < h.size(); ++j) {
            rt += (step_p[j] * ll(h[j] - 'a' + 1)) % 228228337;
            rt %= 228228337;
        }

        for (ll j = 0; j <= (ll)s.size() - (ll)h.size(); ++j) {
            ll fg = pref_hash[j + h.size()] - pref_hash[j];
            if (fg < 0) fg += 228228337;

            if (fg == ((rt * step_p[j]) % 228228337)) {
                vhod[i].push_back(j);
            }
        }
    }

    if (n <= 100) {
        vector<vector<ll>> for_ind1(n, vector<ll> (s.size() + 1, 0));
        vector<vector<ll>> for_ind2(n, vector<ll> (s.size() + 1, 0));
        
        for (ll i = 0; i < n; ++i) {
            for (auto j : vhod[i]) for_ind1[i][j + 1]++;
            for (ll j = 1; j < s.size() + 1; ++j) for_ind1[i][j] += for_ind1[i][j - 1];

            // for (auto j : )
        }

        while (m--) {
            ll left, right;
            cin >> left >> right;

            --left;

            ll ans = 0;

            for (ll i = 0; i < n; ++i) {
                // ll ind1 = lower_bound(all(vhod[i]), left) - vhod[i].begin();
                ll ind1 = for_ind1[i][left];
                // ll ind2 = lower_bound(all(vhod[i]), right - lenn[i] + 1) - vhod[i].begin();
                // cout << "! " << i << ' ' << ind2 << ' ' << for_ind1[i][right - lenn[i] + 1] << '\n';
                ll ind2 = 0;
                if (right - lenn[i] + 1 >= 0) ind2 = for_ind1[i][right - lenn[i] + 1];

                ans += max(0LL, ind2 - ind1);
            }

            cout << ans << ' ';
        }

        return;
    }

    vector<vector<ll>> cnt(s.size(), vector<ll> (s.size(), 0));

    for (ll i = 0; i < n; ++i) {
        for (auto j : vhod[i]) {
            cnt[j][j + lenn[i] - 1]++;
        }
    }    

    for (ll i = 0; i < s.size(); ++i) {
        for (ll j = 1; j < s.size(); ++j) {
            cnt[i][j] += cnt[i][j - 1];
        }
    }

    // before all is good

    vector<vector<ll>> suff(s.size(), vector<ll> (s.size(), 0));

    suff[s.size() - 1] = cnt[s.size() - 1];

    for (ll i = s.size() - 2; i >= 0; --i) {
        for (ll j = 0; j < s.size(); ++j) {
            suff[i][j] = cnt[i][j] + suff[i + 1][j];
        }
    }

    // for (ll i = 0; i < s.size(); ++i) {
    //     for (ll j = 0; j < s.size(); ++j) {
    //         cout << suff[i][j] << ' ';
    //     }
    //     cout << endl;
    // }

    while (m--) {
        ll left, right;
        cin >> left >> right;

        cout << suff[left - 1][right - 1] << ' ';
    }


    // vector<ll> start(s.size(), 0);

    // for (auto i : vhod) {
    //     for (auto j : i) start[j]++;
    // }

    // for (ll i = 1; i < s.size(); ++i) start[i] += start[i - 1];

    // vector<ll> end(s.size() + 1, 0);

    // for (ll i = 0; i < n; ++i) {
    //     for (auto j : vhod[i]) {
    //         end[j + lenn[i]]++;
    //     }
    // }

    // for (ll i = 1; i <= s.size(); ++i) end[i] += end[i - 1];

    // vector<ll> delt(end.size() + 1);
    // for (ll i = 0; i < n; ++i) {
    //     for (auto j : vhod[i]) {
    //         // delt[j + 1]++;
    //         // delt[j + lenn[i]]--;
    //         for (ll k = 2; k < lenn[i] - 1; ++k) {
    //             end[j + k]++;
    //         }
    //     }
    // }

    // // ll shag = 0;

    // // for (ll i = 0; i < end.size(); ++i) {
    // //     shag += delt[i];
    // //     start[i] -= shag;
    // // }

    // for (auto i : start) cout << i << ' ';
    // cout << endl;
    // for (auto i : end) cout << i << ' ';
    // cout << endl;

    // while (m--) {
    //     ll left, right;
    //     cin >> left >> right;

    //     ll ans = end[right];

    //     if (left > 1) {
    //         ans -= start[left - 2];
    //     }

    //     cout << ans << ' ';
    // }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int tests = 1;

    while (tests--) {
        solve();
    }
}

/*

5 4 3 2
1 2 1 10 6
1 2 5

2 3 3
3 4 4
4 5 20

*/