#include <iostream>
#include <map>
#include <vector>
#include <string>
#include <algorithm>
#include <deque>

#pragma GCC optimize "Ofast"

using namespace std;
typedef long long ll;
typedef uint32_t uint;
typedef unsigned long long ull;
#define vc vector

struct Node {
    char go = 26;
    int pt[26]{};
    int ssl[26]{};
    int p = 0;
    int sup = 0;
    size_t d = 0;
    Node() {
        for (auto &x : pt) x = 0;
        for (auto &x :ssl) x = 0;
    }
};

//constexpr int MAXS = 1000000;
//Node ak[MAXS + 100];
//char go[MAXS + 100];
//int pt[MAXS + 100][26];
//int ssl[MAXS + 100][26];
//int p[MAXS + 100];
//int sup[MAXS + 100];
vector<char> go;
vector<vector<int>> pt;
vector<vector<int>> ssl;
vector<int> p;
vector<int> sup;

//size_t d[MAXS + 100];
vector<size_t> d;
vector<vector<uint32_t>> cbv;

void init(int x) {
    go[x] = 26;
    for (auto &y : pt[x]) y = 0;
    for (auto &y : ssl[x]) y = 0;
    p[x] = 0;
    sup[x] = 0;
    d[x] = 0;
}

int akp = 0;

int MAXS;

int main() {
    for (auto &x : cbv) for (auto &y : x) y = 0;
    cin.tie(nullptr); cout.tie(nullptr); ios_base::sync_with_stdio(false);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    if (t.size() > 50000) {
        cbv = vector<vector<uint>>(449, vector<uint>(250001));
        MAXS = 100000;

    } else {
        cbv = vector<vector<uint>>(1416, vector<uint>(50001));
        MAXS = 1000000;
    }

//    vector<char> go;
//    vector<vector<int>> pt;
//    vector<vector<int>> ssl;
//    vector<int> p;
//    vector<int> sup;
//
////size_t d[MAXS + 100];
//    vector<size_t> d;
//
    MAXS += 100;
    go = vc<char>(MAXS);
    pt = vc<vc<int>>(MAXS, vc<int>(26));
    ssl = vc<vc<int>>(MAXS, vc<int>(26));
    p = vc<int>(MAXS);
    sup = vc<int>(MAXS);
    d = vc<size_t>(MAXS);
    MAXS -= 100;
    for (auto &x : t) x -= 'a';
    vector<vector<string>> as;
    map<size_t, int> slmap;
    vector<string> rs(n);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        for (auto &x : s) x -= 'a';
        rs[i] = s;
    }
    sort(rs.begin(), rs.end(), [&](const string &x, const string &y){return x.size() < y.size();});
    for (const string& s : rs) {
        if (slmap.find(s.size()) == slmap.end()) {
            slmap[s.size()] = (int)as.size();
            as.emplace_back();
        }
        as[slmap[s.size()]].push_back(s);
    }
//    vector<vector<ull>> cbv(slmap.size(), vector<ull>(t.size() + 1));
    int cnp = -1;
    for (auto [xsz, xcnt] : slmap) {
        cnp++;
        akp = 0;
        init(akp++);
//        ak[akp++] = Node();
        for (const string &s : as[slmap[xsz]]) {
            int v = 0;
            for (char c : s) {
                if (pt[v][c]) {
                    v = pt[v][c];
                } else {
                    pt[v][c] = akp;
//                    ak[v].ssl[c] = akp;
                    init(akp);
                    go[akp] = c;
                    p[akp] = v;
                    d[akp] = d[v] + 1;
                    v = akp;
                    akp++;
                }
            }
        }
        deque<int> bfs;

        for (int i : pt[0]) {
            if (i != 0) bfs.push_front(i);
        }
        while (!bfs.empty()) {
            int v = bfs.front();
            bfs.pop_front();
//            Node &x = ak[v];
            sup[v] = ssl[p[v]][go[v]];
            for (char c = 0; c < 26; ++c) {
                if (ssl[v][c] == 0) {
                    ssl[v][c] = (pt[sup[v]][c] ? pt[sup[v]][c] : ssl[sup[v]][c]);
                }
            }
            for (int y : pt[v]) {
                if (y) {
                    bfs.push_back(y);
                }
            }
        }

//        for (size_t v = 0; v < akp; ++v) {
//            for (char c = 0; c < 26; ++c) {
//                pt[v][c] = (pt[v][c] ? pt[v][c] : ssl[v][c]);
//            }
//        }

        int v = 0;
        for (size_t i = 0; i + 1 < min(t.size() + 1, xsz); ++i) {
            v = (pt[v][t[i]] ? pt[v][t[i]] : ssl[v][t[i]]);
//            v = pt[v][t[i]];
        }
        for (size_t i = xsz - 1; i < t.size(); ++i) {
            v = (pt[v][t[i]] ? pt[v][t[i]] : ssl[v][t[i]]);
//            v = pt[v][t[i]];
            cbv[cnp][i - (xsz - 1) + 1] = (d[v] == xsz);
        }
        for (size_t i = 0; i < t.size(); ++i) {
            cbv[cnp][i+1] += cbv[cnp][i];
        }
    }
    vector<int> mszs;
    for (auto [xsz, xcnt]: slmap) {
        mszs.push_back((int)xsz);
    }
//    cout << endl;
//    for (auto &x : cbv) {
//        for (auto &y : x) {
//            cout << y << ' ';
//        }
//        cout << endl;
//    }
    vector<pair<int, int>> qs(m);
    for (auto &x : qs) {cin >> x.first >> x.second; --x.first;}
    vector<int> qmax(m);
    int cp = -1;
    for (auto [l, r] : qs) {
        cp++;
//        --l;
        //[l, r) 0-(sz-1) enumeration
//        ull ans = 0;
        {
            int L = -1;
            int R = (int)mszs.size();
            while (L + 1 < R) {
                int mm = (L + R) / 2;
                if (mszs[mm] > r - l) R = mm;
                else L = mm;
            }
            qmax[cp] = R;
//            for (int j = 0; j < R; ++j) {
//                ans += cbv[j][r - mszs[j] + 1] - cbv[j][l];
//            }
        }
//        cout << ans << '\n';
    }
    vector<ull> ans(m);
    for (int j = 0; j < (int)mszs.size(); ++j) {
        for (int i = 0; i < m; ++i) {
            if (qmax[i] > j) ans[i] += cbv[j][qs[i].second - mszs[j] + 1] - cbv[j][qs[i].first];
        }
    }
    for (auto &x : ans) cout << x << ' ';
    return 0;
}