#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <string>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n , m;
    cin >> n >> m;
    vector<string> a(n);
    string t;
    cin >> t;
    vector<pair<int , int>> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        string s = a[i] + '%' + t;
        int n1 = t.size() + a[i].size() + 1;
        vector<int> pi(n1);
        for (int k = 1; k < n1; k++) {
            int j = pi[k-1];
            while (j > 0 && s[j] != s[k]) {
                j = pi[j-1];
            }
            if (s[j] == s[k]) {
                j++;
            }
            pi[k] = j;
            if (j == a[i].size()) {
                p.push_back(make_pair(k - (2 * a[i].size()) + 1 , k - a[i].size()));
            }
        }
    }
    sort(p.begin() , p.end());
    vector<int> ans(m);
    vector<vector<int>> pa(m , vector<int> (3));
    for (int i = 0; i < m; i++) {
        int l , r;
        cin >> l >> r;
        pa[i][0] = l; pa[i][1] = r; pa[i][2] = i;
    }
    sort(pa.begin() , pa.end());
    int j = 0;
    for (int i = 0; i < pa.size(); i++) {
        while ((j < p.size()) && (p[j].first < pa[i][0])) {
            j++;
        }
        int k = j - 1;
        while ((j < p.size()) && (p[j].first >= pa[i][0]) && (p[j].second <= pa[i][1])) {
            ans[pa[i][2]]++;
            j++;
        }
        j = k;
    }
    for (int i = 0; i < m; i++) {
        cout << ans[i] << " ";
    }
    return 0;
}
