#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const int maxn = 1e6 + 1;
const int p = 239;
const int p1 = 1079;
const int MOD1 = 1e9 + 9;

int mult(int x, int y) {
    long long ans = x;
    ans *= y;
    if(ans >= MOD) ans %= MOD;
    return (int)ans;
}

int mult1(int x, int y) {
    long long ans = x;
    ans *= y;
    if(ans >= MOD1) ans %= MOD1;
    return (int)ans;
}

int sum(int x, int y) {
    int ans = x + y;
    if(ans >= MOD) ans -= MOD;
    return ans;
}

int sum1(int x, int y) {
    int ans = x + y;
    if(ans >= MOD1) ans -= MOD1;
    return ans;
}

int sub(int x, itn y) {
    int ans = x - y;
    if(ans < 0) ans += MOD;
    return ans;
}

int sub1(int x, int y) {
    int ans = x - y;
    if(ans < 0) ans += MOD1;
    return ans;
}

int get_hash(int l, int r, vector<int> &h, vector<int> &pows) {
    ++r;
    return sub(h[r], mult(h[l], pows[r - l]));
}

int get_hash1(int l, int r, vector<int> &h, vector<int> &pows) {
    ++r;
    return sub1(h[r], mult1(h[l], pows[r - l]));
}


void solve() {
    int k, m;
    cin >> k >> m;
    string s;
    cin >> s;
    itn n = (int)s.size();
    vector<itn> h(n + 1, 1);
    vector<int> pows(n + 1, 1);
    vector<itn> h2(n + 1, 1);
    vector<int> pows1(n + 1, 1);
    for(int i = 0; i < n; ++i) {
        h[i + 1] = sum(mult(h[i], p), s[i]);
        pows[i + 1] = mult(pows[i], p);

        h2[i + 1] = sum1(mult1(h2[i], p1), s[i]);
        pows1[i + 1] = mult1(pows1[i], p1);
    }
    vector<itn> lens;
    set<pii> hashs;
    for(int i = 0; i < k; ++i) {
        string t;
        cin >> t;
        if((int)t.size() > (int)s.size()) continue;
        lens.pb((int)t.size());
        int h1 = 1;
        for(int j = 0; j < (int)t.size(); ++j) h1 = sum(mult(h1, p), t[j]);

        int h3 = 1;
        for(int j = 0; j < (int)t.size(); ++j) h3 = sum1(mult1(h3, p1), t[j]);
        hashs.insert({sub(h1, pows[(int)t.size()]), sub1(h3, pows1[(int)t.size()])});
    }
    sort(all(lens));
    vector<itn> lens1;
    set<int> usd;
    for(int i = 0; i < (int)lens.size(); ++i) {
        if(usd.find(lens[i]) == usd.end()) {
            lens1.pb(lens[i]);
            usd.insert(lens[i]);
        }
    }
    lens = lens1;
    /*cout << lens;
    return;*/
    unordered_map<int, vector<int>> pref_cnt;
    for(auto to : lens) {
        pref_cnt[to].resize(n, 0);
        for(int i = to - 1; i < n; ++i) {
            if(i >= 1) pref_cnt[to][i] = pref_cnt[to][i - 1];
            int cur = get_hash(i - to + 1, i, h, pows);
            int cur1 = get_hash1(i - to + 1, i, h2, pows1);
            if(hashs.find({cur, cur1}) != hashs.end()) pref_cnt[to][i]++;
        }
    }
    /*cout << "****" << '\n';
    for(auto to : pref_cnt) cout << to.X << ": " << to.Y << '\n';
    cout << "****" << '\n';
    return;*/
    for(Int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l; --r;
        int ans = 0;
        for(auto to : lens) {
            if(pref_cnt[to][r] == 0) continue;
            if(r - l + 1 < to) continue;
            ans += pref_cnt[to][r] - ((l + to - 2 >= 0) ? pref_cnt[to][l + to - 2] : 0);
        }
        cout << ans << ' '; 
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int tmr = 1;
    //cin >> tmr;
    while(tmr--) {
        solve();
    }
}