///pandemonica, modeus, cerberus, malina, zdrada, azazel, justice, lucifer, judgement, beelzebub
#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
using namespace std;

#define ll __int128
//#define int __int128
#define int long long
#define f first
#define s second
#define endl '\n'
#define diuble long double

const int mod=1000000009;
const int p=31;

vector <int> st(1000001,1);

int step(int a, int n)
{
    if (n==0)return 1;
    if (n==1)return a;
    int b=step(a,n/2);
    return b*b%mod*step(a,n%2)%mod;
}

int invp;

vector <signed> tr;
void add(int v, int l, int r, int pos, int x)
{
    if (pos<l || r<pos)return;
    if (l==r){
        tr[v]+=x;
        return;
    }
    int m=(l+r)>>1;
    add(v*2,l,m,pos,x);
    add(v*2+1,m+1,r,pos,x);
    tr[v]=tr[v*2]+tr[v*2+1];
}
int get_sum(int v, int l, int r, int A, int B)
{
    if (B<l || r<A)return 0;
    if (A<=l && r<=B)return tr[v];
    int m=(l+r)>>1;
    return get_sum(v*2,l,m,A,B)+get_sum(v*2+1,m+1,r,A,B);
}

void solve()
{
    int n,q;
    cin >> n >> q;
    string t;
    cin >> t;
    vector <string> s(n);
    int maxlen=0;
    vector <bool> was_len(1000001,0);
    for (int i=0; i<n; i++){
        cin >> s[i];
        if (s[i].size()>t.size())continue;
        maxlen=max(maxlen,(int)s[i].size());
        was_len[s[i].size()]=1;
    }
    vector <unordered_map <signed,bool> > good_hash_len(maxlen+1);
    //vector <map <int,int> > len(maxlen+1);
    //vector <int> hesh(n,0);
    for (int i=0; i<n; i++){
        int k=s[i].size();
        if (k>t.size())continue;
        if (k>t.size())continue;
        int needh=0;
        for (int j=k-1; j>=0; j--){
            needh*=p; needh%=mod;
            needh+=(s[i][j]-'a');///+1 не нужен
            if (needh>=mod)needh-=mod;
        }
        //hesh[i]=needh;
        good_hash_len[k][needh]=1;
    }
    vector <pair <signed,signed> > good;
    for (int k=1; k<=maxlen; k++){
        if (!was_len[k])continue;

        int h=0;
        for (int j=k-1; j>=0; j--){
            h*=p; h%=mod;
            h+=(t[j]-'a');///+1 не нужен
            if (h>=mod)h-=mod;
        }

        for (int j=0; j+k-1<t.size(); j++){
            //len[k][h]++;
            if (good_hash_len[k][h]){
                good.push_back({j,j+k-1});
            }
            if (j+k==t.size())break;
            h-=(t[j]-'a'); if (h<0)h+=mod; h*=invp; h%=mod;
            h+=(t[j+k]-'a')*st[k-1]; h%=mod;
        }
    }
    ///+++
    vector <vector <signed> > pos_good(t.size());
    for (auto i:good){
        pos_good[i.f].push_back(i.s);
    }
    vector <pair <pair <signed,signed>,signed> > x(q);
    for (int i=0; i<q; i++){
        cin >> x[i].f.f >> x[i].f.s;
        x[i].f.f--;
        x[i].f.s--;
        x[i].s=i;
    }
    sort(x.begin(),x.end());
    int k=t.size();
    tr.resize(4*k+10,0);
    for (auto i:good){
        add(1,0,k-1,i.s,1);
    }
    vector <int> ans(q,0);
    int pos_now=0;
    for (int i=0; i<q; i++){
        int l=x[i].f.f;
        int r=x[i].f.s;
        int ind=x[i].s;
        while (pos_now<l){
            for (int j:pos_good[pos_now]){
                add(1,0,k-1,j,-1);
                //now.erase({j,pos_now});
            }
            pos_now++;
        }
        ans[ind]=get_sum(1,0,k-1,l,r);
    }
    for (int i:ans)cout << i << " ";
    cout << endl;
}

signed main()
{
#ifdef LOCAL
#else
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#endif // LOCAL

    invp=step(p,mod-2);
    for (int i=1; i<1000000; i++){
        st[i]=st[i-1]*p%mod;
    }

    int n=1;
    //cin >> n;
    while (n--){
        solve();
    }
    return 0;
}
/**
4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50

4 1 2 1
1 1 1 1
1 3 2
*/
