#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

const int MOD = 1e9 + 7, BASE = 101;
const int MAXN = 1e5;

vector<ll> bpow;

struct Hash {
    vector<ll> h;

    Hash(const string& s) {
        int n = s.size();

        h.assing(n + 1, 0);
        for (int i = 1; i <= n; ++i)
            h[i] = (h[i - 1] * BASE + s[i - 1] - 'a' + 1) % MOD;
    }

    ll get(int l, int r) {
        return (h[r] - (h[l] * bpow[r - l] % MOD) + MOD) % MOD;
    }
};

void precalc() {
    bpow.assing(MAXN + 1, 0);
    bpow[0] = 1;
    for (int i = 1; i <= MAXN; ++i)
        bpow[i] = bpow[i - 1] * BASE % MOD;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> a(n);
    for (auto& i : a)
        cin >> i;

    Hash ht(t);
    map<ll, int> ha;
    for (int i = 0; i < n; ++i) {
        ll tmp = Hash(a[i]).get(0, a[i].size());
        if (!ha.count(tmp))
            ha[tmp] = 0;
        ++ha[tmp];
    }

    vector<vector<int>> dp(t.size() + 1, vector<int>(t.size() + 1));
    for (int i = 0; i < t.size(); ++i)
        dp[i][i + 1] = ha[ht.get(i, i + 1)];
    for (int len = 2; len <= t.size(); ++len)
        for (int l = 0; l + len <= t.size(); ++l) {
            int r = l + len;
            dp[l][r] = dp[l + 1][r] + dp[l][r - 1] - dp[l + 1][r - 1] + ha[ht.get(l, r)];
        }
    /*
    for (auto i : dp) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }
     */
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l;
        cout << dp[l][r] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    precalc();

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
