#include "bits/stdc++.h"
using namespace std;

// cd /mnt/commons/
// g++ -DHOME -Wall -Wextra -DGLIBCXX_DEBUG 1.cpp && ./a.out 

// #define int long long
#define ll long long


#define all(a) a.begin(), a.end()
#define vc vector
#define ld long double
#define forn(i , n) for(int i = 0; i < (int)n; i++)
#define fri(st , en , step) for(int i = st; i < (int)en ; i+=step)
#define frj(st , en , step) for(int j = st; j < (int)en ; j+=step)
#define sz(a) ((int)a.size())
#define pb push_back
#define mp make_pair


template<typename T>
ostream& operator<<(ostream& a, vc<T> b){
	forn(i , sz(b) - 1) a << b[i] << " ";
	if(sz(b)) a << b.back(); 
	return a;
}






#ifdef HOME
	#define o(a) << "[" << #a << ": " << a << "] "
#else
	#define o(a) ;
#endif



class debug{
public:
	debug(){}
	~debug(){
		#ifdef HOME
			cerr << endl;
		#endif
	}
	template<typename T>
	debug& operator<<(T a){
		#ifdef HOME
			cerr << a;
		#endif
		return *this;
	}
};

mt19937 rnd(1211);

template<typename T>
inline bool cmin(T &a, T b){
	if(a > b){
		a = b;
		return 1;
	}
	return 0;
}

template<typename T>
inline bool cmax(T &a, T b){
	if(a < b){
		a = b;
		return 1;
	}
	return 0;
}


const ld e = 1e-9;
// const int inf = 1e18;
const int maxn = 1e5 + 10;

// const int MOD = 476015135761880453;
const int MOD = 1986191149;
const int P = 51;

#define int unsigned int

int pw[maxn] , H[maxn];

int A[maxn][1500] , A1[maxn][500];
// int *A
int n , m;

unordered_set<int> HH[(int) 1e6 + 10];

inline void run(){
	pw[0] = 1;
	fri(1 , maxn , 1){
		pw[i] = (ll)pw[i - 1] * P % MOD;
	}


	cin >> n >> m;
	string t;
	cin >> t;
	int szt = sz(t);
	vc<int> SZ(n);
	
	forn(i , n){
		string s;
		cin >> s;
		if(sz(s) > szt) continue;
		SZ[i] = sz(s);
		int h = 0;
		forn(j , sz(s)){
			h = (h + (ll) pw[j] * (s[j] - 'a')) % MOD;
		} 
		h = (ll) h * pw[szt - sz(s) ] % MOD;
		// debug() o(h);
		HH[sz(s)].insert(h);
	}
	// debug() o(SZ);
	sort(all(SZ));
	SZ.resize(unique(all(SZ)) - SZ.begin());
	

	// A = A1;

	fri(1 , szt + 1, 1){
		H[i] = (H[i - 1] + (ll) pw[i - 1] * (t[i - 1] - 'a')) % MOD;
		// debug() o(H[i]);
	}

	forn(i ,  sz(SZ)){
		int len = SZ[i];
		forn(j , szt - len + 1){
			int h = (ll)(H[j + len] + MOD - H[j]) * pw[szt - (j + len)] % MOD;
			// debug() o(h) o(len) o(H[j]) o(j) o(i) o(HH[len].count(h));
			if(sz(SZ) >= 500 ) A[j  + 1][i] = A[j][i] + HH[len].count(h);
			else A1[j  + 1][i] = A1[j][i] + HH[len].count(h);

		}
	}
	// debug() o(A[szt - 2][2]);
	while(m--){
		int l , r;
		cin >> l >> r;
		l--;
		int  ans = 0;
		forn(i , sz(SZ)){
			if((ll)r - SZ[i] + 1 >= l){
				if(sz(SZ) >= 500 )
					ans += A[r - SZ[i] + 1][i] - A[l][i];
				else ans += A1[r - SZ[i] + 1][i] - A1[l][i];
			}
		}
		cout << ans << " ";
	}	
	cout << "\n";


//
}


signed main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int tt = 1;
	// cin >> tt;
	while(tt--){
		run();
	}
	return 0;
}