#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int osn = 29;
const int mod = 1e9 + 7;

#define nit int
vector<int> step, hash1;

int h(int l, int r) {
    return (hash1[r] - hash1[l - 1] * step[r - l + 1] + mod * 1ll * mod) % mod;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    string s;
    vector<size_t> a(n);
    vector<int> hashes(n);
    cin >> s;
    step.resize(s.size());
    step[0] = 1;
    for (int i = 1; i < s.size(); ++i) {
        step[i] = (step[i - 1] * osn) % mod;
    }
    hash1.resize(s.size() + 1);
    hash1[0] = 0;
    for (int i = 0; i < s.size(); ++i) {
        hash1[i + 1] = (hash1[i] * osn + s[i] - 'a' + 1) % mod;
    }
    for (int i = 0; i < n; ++i) {
        string s1;
        cin >> s1;
        a[i] = s1.size();
        hashes[i] = 0;
        for (int j = 0; j < s1.size(); ++j) {
            hashes[i] = (hashes[i] * osn + s1[j] - 'a' + 1) % mod;
        }
    }
    while (m--) {
        int x, y;
        cin >> x >> y;
        nit ans = 0;
        x--, y--;
        for (int j = 0; j < n; ++j) {
            for (int i = x; i + a[j] <= y + 1; ++i) {
                if (h(i + 1, i + a[j]) == hashes[j]) {
                    ans++;
                }
            }
        }
        cout << ans << " ";
    }
}
