#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
const int osn = 29;
const int mod = 1e9 + 7;

#define nit int
#define lnog long

ll h(int l, int r, vector<ll> &step, vector<ll> &hash) {
    return (hash[r] - hash[l - 1] * step[r - l + 1] + mod * 1ll * mod) % mod;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0), cout.tie(0);
    int n, m;
    cin >> n >> m;
    string s;
    vector<size_t> a(n);
    cin >> s;
    vector<ll> step(s.size());
    step[0] = 1;
    for (int i = 1; i < s.size(); ++i) {
        step[i] = (step[i - 1] * osn) % mod;
    }
    vector<ll> hash(s.size() + 1);
    hash[0] = 0;
    for (int i = 0; i < s.size(); ++i) {
        hash[i + 1] = (hash[i] * osn + s[i] - 'a' + 1) % mod;
    }
    vector<vector<int>> vhod(n);
    set<int>st;
    for (int i = 0; i < n; ++i) {
        string s1;
        cin >> s1;
        if (s1.size()>s.size()){
            st.insert(i);
            continue;
        }
        a[i] = s1.size();
        ll hashes = 0;
        for (int j = 0; j < s1.size(); ++j) {
            hashes = (hashes * osn + s1[j] - 'a' + 1) % mod;
        }
        for (int j = 0; j <= s.size() - s1.size(); ++j) {
            if (h(j + 1, j + s1.size(), step, hash) == hashes) {
                vhod[i].push_back(j + 1);
            }
        }
    }
    while (m--) {
        int x, y;
        cin >> x >> y;
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            if (st.count(i)){
                continue;
            }
            int len_ = a[i];
            int l = 0, r = vhod[i].size();
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (vhod[i][mid] <= x) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            if (vhod[i][l] < x) {
                l++;
            }
            int be = l;
            l = 0, r = vhod[i].size();
            while (r - l > 1) {
                int mid = (l + r) / 2;
                if (vhod[i][mid] <= y - len_ + 1) {
                    l = mid;
                } else {
                    r = mid;
                }
            }
            if (vhod[i][l]+len_<=1+y && be<=l) {
                ans += l - be + 1;
            }
        }
        cout << ans << " ";
    }

}