#include <bits/stdc++.h>
///#include <ext/pb_ds/assoc_container.hpp>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define fi first
#define se second
#define all(v) (v).begin(), (v).end()

//#define int long long

using namespace std;
///using namespace __gnu_pbds;
using ll = long long;
using ld = double;
using pii = pair <int, int>;

mt19937 rnd(4);

int const N = 5e5 + 4;
ll const mod = 1e9 + 7, B = 37;
ll b[N];

void gg(){
    b[0] = 1;
    for(int i = 1; i < N; ++i){
        b[i] = (b[i - 1] * B)%mod;
    }
    return;
}

struct Hash{
    vector <ll> h;

    Hash(string& s){
        int n = s.size();
        h.resize(n);
        h[0] = (s[0] - 'a' + 1);
        for(int i = 1; i < n; ++i){
            h[i] = (h[i - 1] * B + (s[i] - 'a' + 1))%mod;
        }
    }

    int get(int l, int r){
        return (h[r] - (l == 0 ? 0 : (h[l - 1] * b[r - l + 1])%mod) + mod)%mod;
    }
};

int get_hash(string& s){
    ll h = (s[0] - 'a' + 1);
    for(int i = 1; i < (int)s.size(); ++i){
        h = (h * B + (s[i] - 'a' + 1))%mod;
    }
    return h;
}


int const _N = 5e4 + 23;
vector <int> t[4 * N];

void update(int tl, int tr, int v, int pos, int x){
    if(pos < tl or tr < pos){
        return;
    }
    t[v].push_back(x);
    if(pos == tl and pos == tr){
        //t[v].push_back(x);
        return;
    }
    int tm = (tl + tr) >> 1;
    update(tl, tm, (v << 1) + 1, pos, x);
    update(tm + 1, tr, (v << 1) + 2, pos, x);
    return;
}

void build(int tl, int tr, int v){
    //sort(all(t[v]));
    if(tl == tr){
        sort(all(t[v]));
        return;
    }
    merge(all(t[(v << 1) + 1]), all(t[(v << 1) + 2]), t[v].begin());
    int tm = (tl + tr) >> 1;
    build(tl, tm, (v << 1) + 1);
    build(tm + 1, tr, (v << 1) + 2);
    return;
}

int get(int l, int r, int tl, int tr, int v, int x){
    l = max(l, tl);
    r = min(r, tr);
    if(l > r or tl > tr){
        return 0;
    }
    if(l == tl and r == tr){
        if(t[v].empty()){ return 0;}
        return (upper_bound(all(t[v]), x) - t[v].begin());
    }
    int tm = (tl + tr) >> 1;
    return (get(l, r, tl, tm, (v << 1) + 1, x) + get(l, r, tm + 1, tr, (v << 1) + 2, x));
}

signed main(){
    ibase;
    gg();
    int n, m, k;
    cin >> n >> m;
    string ts;
    cin >> ts;
    k = ts.size();
    Hash ht(ts);
    vector <int> hs;
    vector <string> a;
    for(int i = 0; i < n; ++i){
        string s;
        cin >> s;
        a.push_back(s);
        hs.push_back(get_hash(s));
    }

    //vector <pii> pos;

    for(int i = 0; i < n; ++i){
        int len = (int)a[i].size();
        for(int l = 0; l + len - 1 < k; ++l){
            if(ht.get(l, l + len - 1) == hs[i]){
                //pos.push_back({l, l + len - 1});
                update(0, N - 1, 0, l, l + len - 1);
            }
        }
    }

    build(0, N - 1, 0);

    while(m --> 0){
        int l, r, ans = 0;
        cin >> l >> r;
        --l; --r;
//        for(auto [_l, _r] : pos){
//            ans += (l <= _l and _r <= r);
//        }
        cout << get(l, r, 0, N - 1, 0, r) << ' ';
    }
}
