#include <bits/stdc++.h>

#define int long long

#ifndef DDD
#define cerr if(0) cerr
#endif

using namespace std;

template<typename T>
istream& operator>>(istream& is, vector<T>& v) {
    for (auto &u : v) {
        is >> u;
    }
    return is;
}

template<typename T>
ostream& operator<<(ostream& os, vector<T>& v) {
    for (auto &u : v) {
        os << u << ' ';
    }
    return os;
}


void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    cin >> s;
    while (m--) {
        int l, r;
        cin >> l >> r;
        string curt = t.substr(l - 1, r - l + 1);
        int ans = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j + s[i].size() - 1 < curt.size(); ++j) {
                if (curt.substr(j, s[i].size()) == s[i]) {
                    ans += 1;
                }
            }
        }
        cout << ans << '\n';
    }
}

int32_t main() {
#ifdef DDD
    freopen("/mnt/commons/day2/input.txt", "r", stdin);
#else
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}