﻿#include <iostream>
#include <map>
#include <string>
#include <vector>

using namespace std;

#define fastio ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0)

const int maxn = 1e4;

int n, m;
string s;

vector<string> v;

vector<map<int, int>> c;

bool check(int idx, string t) {
	if (idx + t.length() > s.length())
		return false;
	for (int i = idx; i < idx + t.length(); ++i)
		if (s[i] != t[i - idx])
			return false;
	return true;
}

int pref[maxn][maxn];

signed main() {
	fastio;
	cin >> n >> m >> s;
	c.resize(s.length());
	for (int i = 0; i < n; ++i) {
		string t;
		cin >> t;
		v.push_back(t);
	}
	for (auto t : v) {
		for (int i = 0; i < s.length(); ++i) {
			if (check(i, t))
				++c[i][t.length()];
		}
	}
	while (m--) {
		int l, r;
		cin >> l >> r;
		--l, --r;
		int res = 0;
		for (int i = l; i <= r; ++i)
			for (auto j : c[i])
				if (i + j.first - 1 <= r)
					res += j.second;
		cout << res << " ";
	}
}