#include <iostream>
#include <algorithm>
#include <vector>
#include <iomanip>

#define int long long
#define print(a) std::cout << (a) << std::endl


signed main() {
	std::ios_base::sync_with_stdio();
	std::cin.tie();
	std::cout.tie();

	std::string s;
	int n, m;
	std::cin >> n >> m >> s;
	std::vector<std::string> mas(n);
	for (int i = 0; i < n; ++i) std::cin >> mas[i];

	std::vector<std::vector<bool>> maspos(n, std::vector<bool>(s.size(), 0));

	if (n < s.size()) {
		for (int i = 0; i < n; ++i) {
			int li = 0, si = mas[i].size();
			while (li + si <= s.size()) {
				if (s.substr(li, si) == mas[i]) {
					maspos[i][li] = 1;
				}
				li++;
			}
		}
	}
	else {
		for (int i = 0; i < s.size(); ++i) {
			for (int j = 0; j < n; ++j) {
				if (i + mas[j].size() > s.size()) continue;
				if (s.substr(i, mas[j].size()) == mas[j]) maspos[j][i] = 1;
			}
		}
	}

	for (int k = 0; k < m; ++k) {
		int l, r;
		std::cin >> l >> r;
		--l;
		--r;
		int sum = 0;
		for (int i = l; i <= r; ++i) {
			for (int j = 0; j < n; ++j) {
				if (i + mas[j].size() - 1 > r) continue;
				if (maspos[j][i]) ++sum;
			}
		}
		std::cout << sum << " ";
	}

	return 0;
}