#include <bits/stdc++.h>
using namespace std;

#define int long long 
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back
#define all(x) x.begin(),x.end()
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const int inf=1e18;
const int mod=1e9+7;

int n=5e5,m=5e5;
string s;
vector<string> a(n);
const int len=5e6;
int S=0;
int K;
int cnt[len];
int pref[len];

struct trie {
	trie* c[26];
	int end;
	trie() {
		forn(i,26) c[i]=NULL;
		end=0;
	}
	void add(string&s, int i=0) {
		if (i>=s.size()) {
			++end; return;
		}
		int b=s[i]-'a';
		if (!c[b]) c[b]=new trie();
		c[b]->add(s,i+1);
	}
	void query(string&s, int ind, int i=0) {
		if (end) {
			//cout<<s<<' '<<ind<<' '<<i<<'\n';
			pref[ind]++;
			cnt[ind+i-1]++;
		}
		if (i>=s.size()) {
			return;
		}
		int b=s[i]-'a';
		if (!c[b]) return;
		c[b]->query(s,ind,i+1);
	}
};

trie t;

vector<int> z(string&f) {
	string k=f+'#'+s;
	vector<int> z(k.size(),0);
	int r=1;
	int last=0;
	for (int i=1; i<k.size(); ++i) {
		r=max(r,i);
		z[i]=min(z[i-last],r-i);
		if (z[i]+i<r) continue;
		while (k[r]==k[r-i]) ++r;
		z[i]=r-i;
		last=i;
	}
	return z;
}

void solve() {

	cin>>n>>m>>s;
	forn(i,n) cin>>a[i];
	forn(i,n) S+=a[i].size();
	K=sqrt(S);

	forn(i,n) {
		if (a[i].size()>K) {
			auto v=z(a[i]);
			int sz=a[i].size();
			for (int j=sz+1; j<v.size(); ++j) {
				if (v[j]==sz) {
					cnt[j-2]++;
					pref[j-sz-1]++;
				}
			}
		} else {
			t.add(a[i]);
		}
	}
	forn(i,s.size()) {
		string tmp;
		int lim=min(i+K,(int)s.size());
		for(int j=i;j<lim;++j) tmp+=s[j];
		t.query(tmp,i);
	}

	for(int i=1;i<s.size();++i) {
		pref[i]+=pref[i-1];
		cnt[i]+=cnt[i-1];
	}

	while (m--) {
		int l,r; cin>>l>>r; --l, --r;
		int full = cnt[r]-(l?cnt[l-1]:0);
		int open = l?(pref[l-1]-cnt[l-1]):0;
		cout<<full-open<<' ';
	}

	//forn(i,s.size()) cout<<pref[i]<<' '; cout<<'\n';
	//forn(i,s.size()) cout<<cnt[i]<<' '; cout<<'\n';

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	//cin>>t;
	while (t--) solve();
	return 0;
}