//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

const long long INF=1e15;
const long long MOD=1e9+7;
const long long B=179;
vector<long long> pows;
void calc(string&s, vector<long long>&h) {
    h.push_back(0);
    for (auto c:s) {
        h.push_back((h.back()*B%MOD+(long long)(c-'a'+1))%MOD);
    }
}

long long get(long long l, long long r, vector<long long>&h) {
    return (h[r] - h[l] * pows[r-l]%MOD + MOD)%MOD;
}


signed main() {
    long long n,m;
    cin>> n >> m;
    pows.push_back(1);
    for (long long i = 0;i<1000000;i++) {
        pows.push_back(pows.back()*B%MOD);
    }
    string t;
    cin >> t;
    vector<long long> h;
    calc(t, h);
    vector<long long> hs(n);
    vector<long long> len(n);
    for (long long i =0;i<n;i++) {
        string s;
        cin >> s;
        hs[i] = 0;
        len[i] = s.size();
        for (auto c:s) {
            hs[i] *= B;
            hs[i] += (long long)(c-'a'+1);
            hs[i] %= MOD;
        }
    }
    if (n <=100 && m <=500) {
        while(m--) {
            long long l, r;
            cin >> l >> r;
            l--;
            r--;
            long long ans=0;
            for (long long i = l;i<=r;i++) {

                for (long long j = 0;j<n;j++) {
                    if (len[j] + i - 1 <= r && get(i, i + len[j], h) == hs[j]) {
                        ans++;
                    }
                }
            }
            cout << ans << "\n";
        }
    }
    else {
        vector<vector<long long>> pref(n);
        for (long long i = 0;i<n;i++) {
            pref[i].push_back(0);
            for (long long j = 0;j<t.size();j++) {
                if (len[i] + j -1 <= t.size()-1 && get(j, j+len[i], h) == hs[i]) {
                    pref[i].push_back(pref[i].back()+1);
                }
                else {
                    pref[i].push_back(pref[i].back());
                }
            }
        }
        while(m--) {
            long long l, r;
            cin >> l >> r;
            l--;
            r--;
            long long ans = 0;
            for (long long j =0;j<n;j++) {
                long long r1 = r - len[j]+1;
                if (r1 < l) {
                    continue;
                }
                ans += pref[j][r1+1] - pref[j][l];
            }
            cout << ans << "\n";
        }
    }



}