#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) x.begin(), x.end()
int p = 67;
int mod = 1e9 + 7;
int ppow[(int) 1e7];

vector<int> hsh(string& t) {
    vector<int> ans(t.size());
    ans[0] = t[0] - 'a';
    int pp = p;
    for (int i = 1; i < t.size(); i++) {
        ans[i] = (ans[i - 1] + (t[i] - 'a') * pp) % mod;
        pp *= p;
        pp %= mod;
    }
    return ans;
}
void init() {
    ppow[0] = 1;
    for (int i = 1; i < 1e7; i++) {
        ppow[i] = ppow[i - 1] * p % mod;    
    }
}
int substr(int l, int r, vector<int> & t) {
    int tmp = t[r] - (l > 0 ? t[l - 1] : 0);
    tmp = tmp * ppow[(int) 1e6 - l] % mod;
    return tmp;
}

int leq(int l1, int r1, int l2, int r2, vector<int>& s1, vector<int>& s2) {
    int l = 0, r = min(r1 - l1 + 1, r2 - l2 + 1);
    while (r - l > 1) {
        int m = (r + l) / 2;
        if (substr(l1, l1 + m, s1) == substr(l2, l2 + m, s2)) {
            l = m;
        } else {
            r = m;
        }
    }
    return l;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> a(n);
    vector<int> ht = hsh(t);
    for (auto& i : a) cin >> i;
    vector<vector<int>> ha(n);
    init();
    for (int i = 0; i < n; i++) {
        ha[i] = hsh(a[i]);
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int ans = 0;
        for (auto i : ha) {
            for (int j = l; j <= r - i.size() + 1; j++) {
                if (substr(0, i.size() - 1, i) == substr(j, j + i.size() - 1, ht)) {
                    ans++;
                }
            }
        }
        cout << ans << '\n';
    }
}   