#pragma GCC optimize("O3")
#include<bits/stdc++.h>
using namespace std;

#define int long long
typedef long long ll; typedef long double ld;
typedef vector<int> vi; typedef pair<int, int> pii;
const int MAXN = 5001;
const ll inf = 2e9;
const ll mod = 1000000009;
const ll p = 59;
struct hsh{
    int n;
    int nm, np;
    string s;
    vi pr, sp;
    void build_sp(){
        sp.resize(n);
        int cp = 1;
        for(int i = 0; i < n; i++){
            sp[i] = cp;
            cp *= np;
            cp %= nm;
        }
    }
    void build_pr(){
        pr.resize(n);
        int ch = 0;
        for(int i = 0; i < n; i++){
            ch*= np;
            ch %= mod;
            int cs = s[i] - 'a' + 23;
            ch += cs*cs;
            ch %= nm;
            pr[i] = ch;
        }
    }
    hsh(string& _s, int _nm, int _np){
        nm = _nm;
        np = _np;
        s = _s;
        n = s.size();
        build_sp();
        build_pr();
    }
    int get_h(int l, int r){
        int ch = pr[r];
        if(l > 0){
            int cl = r - l + 1;
            ch = (ch + nm - (pr[l-1] * sp[cl])% nm) % nm; 
        }
        return ch;
    }
};
int get_h(string& s){
    int ch = 0;int cp = 1;
    for(int i = (int)s.size()-1; i >= 0; i--){
        int cs = s[i] - 'a' + 23;
        ch += (cs* cs * cp)%mod;
        ch %= mod;
        cp *= p;
        cp %= mod;
    }
    return ch;
}
vector<unsigned int> where[101];
// vi who[MAXN];
void run_case(){
    int m, qq;cin >> m >> qq;
    string s;cin >> s;
    int n = s.size();

    vector<string> v(m);for(string& i : v)cin >> i;
    vi hashes;
    for(int i =0; i < m; i++){
        hashes.push_back(get_h(v[i]));
    }
    hsh h1(s, mod, p);
    if(m <= 100){
        for(int i = 0; i < m; i++)where[i].clear();
        for(int i = 0; i < m; i++){
            for(int j = 0; j < n - (int)v[i].size() + 1; j++){
                int ch = h1.get_h(j, j + (int)v[i].size() - 1);
                int nh = hashes[i];
                // cout << ch << ' ' << nh << '\n';
                if(ch == nh){
                    where[i].push_back(j);
                }
            }
        }
        for(int i = 0; i < qq; i++){
            int l, r;cin >> l >> r;l--;r--;
            int taa = 0;
            for(int j = 0; j < m; j++){
                // for(int z : where[j]){
                //     if(z >= l && z + (int)v[j].size() - 1 <= r)taa++;
                // }
                int cr = lower_bound(where[j].begin(), where[j].end(), r - (int)v[j].size() + 2) - where[j].begin();
                int cl = lower_bound(where[j].begin(), where[j].end(), l) - where[j].begin();
                taa += max(0LL, cr-cl);
                // assert(cr >= cl);
            }
            cout << taa << ' ';
        }
        cout << '\n';
        return;
    }
    vector<vi> ans(n, vi(n));
    vector<vi> who(n);
    for(int i = 0; i < n; i++)who[i] = vi({});
    for(int i = 0; i < m; i++){
        for(int j = 0; j < n - (int)v[i].size() + 1; j++){
            int ch = h1.get_h(j, j + (int)v[i].size() - 1);
            int nh = hashes[i];
            // cout << ch << ' ' << nh << '\n';
            if(ch == nh){
                who[j].push_back(i);
            }
        }
    }
    vi cn(n);
    for(int i = 0; i < n; i++){
        for(int j : who[i]){
            cn[i + (int)v[j].size() - 1]++;
        }
    }
    for(int l = 0; l < n; l++){
        int ca = 0;
        for(int r = l; r < n; r++){
            ca += cn[r];
            ans[l][r] = ca;
        }
        for(int j : who[l]){
            cn[l + (int)v[j].size() - 1]--;
        }
    }
    for(int i = 0; i < qq; i++){
        int l, r;cin >> l >> r;l--;r--;
        // qs[r].push_back({l, i});
        cout << ans[l][r]<< ' ';
    }
    cout << '\n';
}

signed main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int tt = 1;
    #ifdef PAFIMOV
        freopen("input.txt" , "r", stdin);
        cin >> tt;
    #endif
    // cin >> tt;
    while(tt--){
        run_case();
    }
}