#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++ i)
#define rf(i, a, b) for (int i = (a); i >= (b); -- i)
#define fe(x, a) for (auto& x : a)

#define fi first
#define se second

#define pb push_back
#define pw(x) (1LL << x)
#define sz(x) (int)(x).size()
#define all(x) (x).begin(), (x).end()

using namespace std;

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;

template <typename T>
using oset = tree <T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn (T& a, T b) {return a > b ? (a = b, 1) : 0;}
template <typename T>
bool umx (T& a, T b) {return a < b ? (a = b, 1) : 0;}

using ll = long long;
using ld = long double;
using pll = pair <ll, ll>;
using pii = pair <int, int>;

mt19937_64 rnd (time (0));

const int N = 6e4 + 5;
const int oo = 1e9;
const ll OO = 1e18;

const int mod = 1e9 + 7;
const int p = 31;

int add (int a, int b) {
    a += b;
    if (a >= mod) return a - mod;
    return a;
}

int mult (int a, int b) {
    return 1LL * a * b % mod;
}

int sub (int a, int b) {
    a -= b;
    if (a < 0) a += mod;
    return a;
}

ll n, Q;
string s, t[N];

ll b[N];
ll pref[N];

ll get (ll l, ll r) {
    ++ r;
//    cout << pref[l] << " " << pref[r] << " " << b[r - l] << "\n";
    return sub (pref[r], mult (pref[l], b[r - l]));
}

map <string, ll> mp;
vector <pair < string, ll > > v;

vector <ll> pos[N];

struct SegTree {
    vector <ll> t[4*N];

    void build (ll v = 1, ll tl = 0, ll tr = sz(s) - 1) {
        if (tl == tr) {
            fe (x, pos[tl]) t[v].pb (x);
            sort (all (t[v]));
            return;
        }

        ll tm = (tl + tr) >> 1;

        build (v << 1, tl, tm);
        build (v << 1 | 1, tm + 1, tr);

        fe (x, t[v << 1]) t[v].pb (x);
        fe (x, t[v << 1 | 1]) t[v].pb (x);
        sort (all (t[v]));
    }

    ll get (ll v, ll tl, ll tr, ll l, ll r, ll x) {
        if (l > r) return 0;
        if (tl == l && tr == r) {
            return upper_bound (all(t[v]), x) - t[v].begin();
        }

        ll tm = (tl + tr) >> 1;

        return get (v << 1, tl, tm, l, min (r, tm), x) +
            get (v << 1 | 1, tm + 1, tr, max (tm + 1, l), r, x);
    }

    ll get (ll l, ll r, ll x) {
        return get (1, 0, sz(s) - 1, l, r, x);
    }
} tr;

ll Hash[N];
int main() {
#ifdef localy
    freopen ("input.txt", "r", stdin);
    freopen ("output.txt", "w", stdout);
#endif // localy
    ios_base::sync_with_stdio (0); cin.tie(0);

    cin >> n >> Q;
    cin >> s;


    fr (i, 1, n) {
        cin >> t[i];
        fr (j, 1, sz(t[i])) {
            Hash[i] = add (mult(Hash[i], p), t[i][j - 1] - 'a' + 1);
        }

    }



    b[0] = 1;
    fr (i, 1, sz(s)) {
        pref[i] = add (mult (pref[i - 1], p), s[i - 1] - 'a' + 1);
        b[i] = mult (b[i - 1], p);
    }


    fr (i, 0, sz(s) - 1) {

        fr (j, 1, n) {
            if (i + sz(t[j]) - 1 < sz(s)) {
                if (get (i, i + sz(t[j]) - 1) == Hash[j]) pos[i].pb (i + sz(t[j]) - 1);
            }
        }
    }

    tr.build ();


    while (Q --) {
        ll res = 0;
        ll l, r;
        cin >> l >> r;

        -- l;
        -- r;

        cout << tr.get (l, r, r) << " ";
    }

    return 0;
}
