#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define int int64_t
#define pb push_back
#define pii pair <int, int>
#define endl '\n'

using namespace std;
using namespace __gnu_pbds;
typedef tree <int, null_type, less_equal <int>, rb_tree_tag, tree_order_statistics_node_update> oset;
const int mod = 1e9 + 7, N = 1e6 + 50, p = 43;
int st[N], of[N], f[N];

void upd (int i, int x) {
    while (i < N) {
        f[i] += x;
        i = (i | (i + 1));
    }
}

int get (int i) {
    int ans = 0;
    while (i >= 0) {
        ans += f[i];
        i = (i & (i + 1)) - 1;
    }
    return ans;
}

int getSum (int l, int r) {
    return get(r) - get(l - 1);
}

int bp (int a, int st) {
    int ans = 1;
    while (st > 0) {
        if(st & 1) {
            ans *= a;
            ans %= mod;
        }
        a *= a;
        a %= mod;
        st >>= 1;
    }
    return ans;
}

void PreCalc () {
    st[0] = 1;
    of[0] = 1;
    for(int i = 1; i < N; ++i) {
        st[i] = (st[i - 1] * p) % mod;
        of[i] = bp(st[i], mod - 2);
    }
}

struct node {
    int l, r, id;
};

bool comp (node a, node b) {
    return a.r < b.r;
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    PreCalc();
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int H[t.size()];
    H[0] = t[0] - 'a' + 1;
    for(int i = 1; i < t.size(); ++i) {
        H[i] = (H[i - 1] + (t[i] - 'a' + 1) * st[i]) % mod;
    }
    gp_hash_table <int, int> mp;
    set <pair <string, int>> all;
    for(int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int h = 0;
        for(int i = 0; i < s.size(); ++i) {
            h = (h + (s[i] - 'a' + 1) * st[i]) % mod;
        }
//        cerr << h << endl;
        mp[h]++;
        all.insert({s, h});
    }
    auto get = [&] (int l, int r) {
        int ans = H[r];
        if(l) {
            ans -= H[l - 1];
            ans += mod;
            ans %= mod;
        }
        return ans;
    };
    vector <pii> q[t.size()];
    for(int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        q[r].pb({l, i});
    }
    vector <int> ans(m);
    for(int r = 0; r < t.size(); ++r) {
        for(auto to : all) {
            if(r - to.fi.size() + 1 >= 0) {
                int h1 = get(r - to.fi.size() + 1, r);
                h1 *= of[r - to.fi.size() + 1];
                h1 %= mod;
                if(h1 == to.se) {
                    upd(r - to.fi.size() + 1, 1);
                }
            }
        }
        for(auto to : q[r]) {
            ans[to.se] = getSum(to.fi, r);
        }
    }
    for(auto to : ans) cout << to << ' ';
    return 0;
}
