#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

const int N = 1e6 + 1;
const int A = 26;
string s[N];
string t;

int tr[A][N], suf[N], par[N], term[N], let[N], len[N];
int SZ = 1;

void add(int i) {
    int u = 1;
    for (auto c : s[i]) {
        if (tr[c - 'a'][u] == 0) tr[c - 'a'][u] = ++SZ;
        u = tr[c - 'a'][u];
        let[u] = c - 'a';
    }
    term[u]++;
}

vector<int> g[N];

void build() {
    queue<int> q;
    q.push(1);
    suf[1] = par[1] = 1;
    while (q.size()) {
        int u = q.front();
        q.pop();
        suf[u] = suf[par[u]];
        if (u != 1 && tr[let[u]][suf[par[u]]] != 0 && par[u] != 1) {
            suf[u] = tr[let[u]][suf[par[u]]];
        }
        if (u != 1) term[u] += term[suf[u]];
        if (u != 1) g[suf[u]].push_back(u);
        for (int c = 0; c < A; ++c) {
            if (tr[c][u]) {
                par[tr[c][u]] = u;
                len[tr[c][u]] = len[u] + 1;
                q.push(tr[c][u]);
            }
        }
    }
}

const int LOG = 20;
int bp[LOG][N];

int go(int u, int c) {
    while (!tr[c][u] && u != 1) {
        u = suf[u];
    }
    if (tr[c][u]) u = tr[c][u];
    return u;
}

int vert[5 * N];

void process() {
    int u = 1;
    for (int i = 0; i < t.size(); ++i) {
        u = go(u, t[i] - 'a');
        vert[i] = u;
    }
}

//vector<int> ev[5 * N];

int32_t main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, m;
    cin >> n >> m;
    cin >> t;
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
    }
    for (int i = 0; i < n; ++i) {
        add(i);
    }
    build();
    process();
//        sizes(1);
//        dfs(1);
//        for (int i = 1; i <= SZ; ++i) ev[len[i]].push_back(i);
    for (int i = 1; i <= SZ; ++i) {
        bp[0][i] = suf[i];
        for (int k = 0; k + 1 < LOG; ++k) {
            bp[k + 1][i] = bp[k][bp[k][i]];
        }
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        ll res = 0;
        for (int i = l; i <= r; ++i) {
            int u = vert[i];
            for (int k = LOG - 1; k >= 0; --k) {
                if (len[bp[k][u]] > i - l + 1) {
                    u = bp[k][u];
                }
            }
            if (len[u] > i - l + 1) u = bp[0][u];
            assert(len[u] <= i - l + 1);
            res += term[u];
        }
        cout << res << '\n';
    }
}

void solve() {
}