﻿#include <iostream>
#include <random>
#include <vector>
#include<string>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <algorithm>
#include <stack>
#include <iomanip>
#include <math.h>
#include <queue>
#include <deque>

using namespace std;

#define int long long
#define all(arr) arr.begin(), arr.end()
#define vi vector<int>
#define vvi vector<vi>
#define pii pair<int, int>

int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const int BASE = 31;

#define fast ios_base::sync_with_stdio(0), cin.tie(0), cout.tie(0)
mt19937 rnd(time(0));

int MAXN = 1e6;
vector<int> hs;
vector<int> deg(MAXN);

int get(int l, int r) {
	return (hs[r - 1] - hs[l - 1] * deg[r - l] + MOD*MOD) % MOD;
}

signed main()
{
	deg[0] = 1;
	for (int i = 1; i < MAXN; ++i) deg[i] = (deg[i - 1] * BASE) % MOD;
	int n, m;
	cin >> n >> m;
	string t; cin >> t;
	vector<string> v(n);
	for (auto& i : v) cin >> i;

	int t0 = t.size();
	hs.resize(t0 + 1, 0);
	for (int i = 1; i <= t0; ++i)
		hs[i] = (hs[i - 1] * BASE + t[i - 1]) % MOD;

	vector<int> hash(n);
	for (int i = 0; i < n; ++i) {
		string s = v[i];
		int h = 0;
		for (int i = 1; i <= s.size(); ++i)
			h = (h * BASE + s[i - 1]) % MOD;
		hash[i] = h;
	}

	vector<vector<int>> a(t0);
	for (int i = 0; i < n; ++i) {
		int sz = v[i].size();
		int h = hash[i];
		for (int j = 0; j <= t0 - sz; ++j) {
			if (get(j + 1, j + sz + 1) == h)
				a[j].push_back(sz);
		}
	}

	for (auto& i : a) sort(all(i));

	vector<vector<int>> anss(t0, vector<int>(t0, -1));

	for (int ii = 0; ii < m; ++ii) {
		int l, r;
		cin >> l >> r;
		l--;
		r--;
		if (anss[l][r] != -1) {
			cout << anss[l][r] << "\n";
			continue;
		}
		int ans = 0;
		for (int i = l; i <= r; ++i) {
			int cnt = (upper_bound(all(a[i]), r - i + 1) - a[i].begin());
			ans += cnt;
		}
		cout << ans << "\n";
		anss[l][r] = ans;
	}
	return 0;
	for (auto& i : a) {
		for (auto& j : i) cout << j << " ";
		cout << endl;
	}
}