#include <bits/stdc++.h>

using namespace std;

typedef long double ld;

#define fout cerr
#define ll long long
#define ull unsigned long long
#define vi vector<int>
#define vl vector<ll>
#define vii vector<vi>
#define vll vector<vl>
#define all(arr) arr.begin(), arr.end()
#define rev(arr) arr.rbegin(), arr.rend()
#define lb(arr, val) int(lower_bound(all(arr), val) - arr.begin())
#define ub(arr, val) int(upper_bound(all(arr), val) - arr.begin())
#define _unique(arr) arr.erase(unique(all(arr)), arr.end())
#define pii pair<int, int>
#define pll pair<ll, ll>
#define vpi vector<pii>
#define vpl vector<pll>
#define size(arr) int(arr.size())

ostream &operator<<(ostream &out, vi a) {
    for (auto u: a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream &in, vi &a) {
    for (auto &u: a) {
        in >> u;
    }
    return in;
}

ostream &operator<<(ostream &out, vl a) {
    for (auto u: a) {
        out << u << " ";
    }
    return out;
}

istream &operator>>(istream &in, vl &a) {
    for (auto &u: a) {
        in >> u;
    }
    return in;
}

istream &operator>>(istream &in, pii &a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream &out, pii a) {
    out << a.first << " " << a.second;
    return out;
}

istream &operator>>(istream &in, pll &a) {
    in >> a.first >> a.second;
    return in;
}

ostream &operator<<(ostream &out, pll a) {
    out << a.first << " " << a.second;
    return out;
}

const int MAX_N = 2e5 + 5;
const int LOG_N = 25;
const int INF = 1e9 + 7;

ll mod = 1e9 + 7;


ll p = 31;
vl q;

vl h;
int get_hash(string s) {
//    cout << s << "\n";
    ll t = 1;
    ll ans = 0;
    for (auto u : s) {
//        cout << ans << "\n";
        ans = (ans + (1ll * (u - 'a' + 1) * t) % mod + mod) % mod;
        t = (t * p) % mod;

//        cout << ((u - 'a') * t) % mod << "\n";
//        cout << ans << "\n";
    }
    return ans;
}

void build(string s) {
    ll t = 1;
    h.resize(size(s));
    h[0] = (s[0] - 'a' + 1);
//    cout << h[0] << "\n";
    q.resize(size(s));
    q[0] = t;
    for (int i = 1; i < size(s); ++i) {
        t = (t * p) % mod;
        h[i] = (h[i - 1] + ((s[i] - 'a' + 1) * t) % mod) % mod;
        q[i] = t;
    }
}

ll get(int l, int r) {
    ll ans = h[r];
    if (l != 0) ans -= h[l - 1];
    return (ans + mod) % mod;
}

bool my_equal(ll hash, int l, int r) {
    if (hash * q[l] == get(l, r)) return true;
    return false;
}

int main() {
#ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#else
#define fout if (0) cout
    ios_base::sync_with_stdio(0);
    cout.tie(0);
    cin.tie(0);
#endif
    cout << setprecision(13) << fixed;

    int n, m;
    cin >> n >> m;
    vl a(n);
    string t;
    cin >> t;
    set<int> s;
    vector<string> st;
    for (int i = 0; i < n; ++i) {
        string tmp;
        cin >> tmp;
        st.push_back(tmp);
        a[i] = get_hash(tmp);
//        cout << a[i] << " ";
//        s.insert(a[i]);
    }
    build(t);
//    cout << h << "\n";
//    cout << q << "\n";
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int cnt = 0;
        for (int i = l; i <= r; ++i) {
            for (int j = i; j <= r; ++j) {
                for (auto u : st) {
//                    if (my_equal(u, i, j)) cnt++;
//                    for (int k = i; k <= j; ++k) cout << char(t[k]);
//                    cout << "\n";
//                    cout << get(i, j) << "\n";
//                    cout << u * q[i] << "\n";
                    bool fl = true;
                    if (j - i + 1 != size(u)) continue;
                    for (int k = i; k <= j; ++k) {
                        if (u[k - i] != t[k]) {
                            fl = false;
                            break;
                        }
                    }
                    if (fl) {
                        cnt++;
                        break;
                    }
                }
            }
        }
        cout << cnt << "\n";
    }

}