#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define _GLICXX_DEBUG
#define endl '\n'
#define ss second
#define ff first
#define all(a) (a).begin(), (a).end()
//#define int long long

const ll INF = 2e18 + 10, mod = 2e9 + 902137, td = 139;

vector<int> a[50000];
vector<int> tree[200000];
ll tp[50010], hp[50010];

ll hs(int l, int r) {
    return ((hp[r] - hp[l] * tp[r - l]) % mod + mod) % mod;
}

void build(int v, int l, int r) {
    if (l + 1 == r) {
        tree[v] = a[l];
        sort(all(tree[v]));
        return;
    }
    int m = (r + l) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    int i = 0, j = 0;
    while (i < tree[v * 2 + 1].size() && j < tree[v * 2 + 2].size()) {
        if (tree[v * 2 + 1][i] < tree[v * 2 + 2][j]) {
            tree[v].push_back(tree[v * 2 + 1][i]);
            i++;
        } else {
            tree[v].push_back(tree[v * 2 + 2][j]);
            j++;
        }
    }
    while (i < tree[v * 2 + 1].size()) {
        tree[v].push_back(tree[v * 2 + 1][i]);
        i++;
    }
    while (j < tree[v * 2 + 2].size()) {
        tree[v].push_back(tree[v * 2 + 2][j]);
        j++;
    }
}

int get(int v, int l, int r, int ql, int qr, int d) {
    if (r <= ql || l >= qr) {
        return 0;
    }
    if (l >= ql && r <= qr) {
        return upper_bound(all(tree[v]), d) - tree[v].begin();
    }
    int m = (r + l) / 2;
    return get(v * 2 + 1, l, m, ql, qr, d) + get(v * 2 + 2, m, r, ql, qr, d);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    tp[0] = 1;
    for (int i = 0; i < t.size(); ++i) {
        hp[i + 1] = (hp[i] * td % mod + t[i]) % mod;
        tp[i + 1] = tp[i] * td % mod;
    }

    string s;
    for (int i = 0; i < n; ++i) {
        cin >> s;
        ll h = 0;
        for (int j = 0; j < s.size(); ++j) {
            h *= td;
            h += s[j];
            h %= mod;
        }
        for (int j = 0; j < t.size(); ++j) {
            if (j + s.size() > t.size()) break;
            if (h == hs(j, j + (int) s.size())) {
                a[j].push_back(j + (int) s.size() - 1);
            }
        }
    }

    build(0, 0, t.size());

    while(m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        cout << get(0, 0, t.size(), l, r + 1, r) << " ";
    }
}
