#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 5e5 + 10;
int n, m, z[maxn], tree[4 * maxn], ans[maxn];
string t, s[maxn];
vector< pair<int, int> > v;

struct interval{
    int l, r, idx;
}e[maxn];

void z_func(string a, string b){
    string p = a + '#' + b;
    int l = 0, r = 0;
    for(int i = 0;i < p.size();i++)
        z[i] = 0;
    for(int i = 1;i < p.size();i++){
        if(i <= r) z[i] = min(z[i - l], r - i + 1);
        while(i + z[i] < p.size() && p[z[i]] == p[i + z[i]])
            z[i]++;
        if(i + z[i] - 1 > r)
            l = i, r = i + z[i] - 1;
    }
    for(int i = a.size();i < p.size();i++){
        if(z[i] == a.size())
            {v.push_back(make_pair(i - a.size(), i - 1));}
    }
}

bool cmp(interval i1, interval i2){
    if(i1.r != i2.r)
        return i1.r < i2.r;
    return i1.l < i2.l;
}

bool cmp_pair(pair<int, int> p1, pair<int, int> p2){
    if(p1.second != p2.second)
        return p1.second < p2.second;
    return p1.first < p2.first;
}

void read(){
    cin >> n >> m;
    cin >> t;
    for(int i = 1;i <= n;i++){
        cin >> s[i];
        z_func(s[i], t);
    }
    for(int i = 1;i <= m;i++){
        cin >> e[i].l >> e[i].r;
        e[i].idx = i;
    }
    sort(e + 1, e + m + 1, cmp);
    sort(v.begin(), v.end(), cmp_pair);
}


void update(int i, int l, int r, int x){
    if(l == r){
        tree[i]++;
    }
    else{
        int mid = (l + r) / 2;
        if(x <= mid)
            update(2 * i, l, mid, x);
        else
            update(2 * i + 1, mid + 1, r, x);
        tree[i] = tree[2 * i] + tree[2 * i + 1];
    }
}

int query(int i, int l, int r, int ql, int qr){
    if(ql > qr)
        return 0;
    if(l >= ql && r <= qr)
        return tree[i];
    else{
        int mid = (l + r) / 2;
        return query(2 * i, l, mid, ql, min(mid, qr)) + query(2 * i + 1, mid + 1, r, max(mid + 1, ql), qr);
    }
}

void solve(){
    int j = 0;
    for(int i = 1;i <= m;i++){
        while(j < v.size() && v[j].second <= e[i].r){
            update(1, 1, t.size(), v[j].first);
            j++;
        }
        ans[e[i].idx] = query(1, 1, t.size(), e[i].l, e[i].r);
    }
    for(int i = 1;i <= m;i++)
        cout << ans[i] << " ";
    cout << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
