#include "bits/stdc++.h"
//#pragma GCC optimize("Ofast,unroll-loops")

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
//#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const int base = 177013;
const int mod = 1e9 + 7;
vector<int> base_pow;
vector<int> hashs;

void precalc(string &h){
    hashs.assign(h.size() + 1, 0);
    base_pow.assign(h.size() + 1, 1);
    for (int i = 1; i < h.size() + 1; ++i) {
        base_pow[i] = (ll)base_pow[i - 1] * base % mod;
    }
    for (int i = 1; i < h.size() + 1; ++i) {
        hashs[i] = (ll)(hashs[i - 1] + h[i - 1] - 'a' + 1) * base % mod;
    }
}

bool cmp(int l, int r, int h){
    int g = (hashs[r + 1] - ((ll)hashs[l] * base_pow[r - l + 1] % mod) + mod) % mod;
    return g == h;
}


int hah(string &g){
    int ans = 0;
    for(auto u : g){
        ans = ((ll)(ans + u - 'a' + 1) * base) % mod;
    }
    return ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int n, t;
    cin >> n >> t;
    string h;
    cin >> h;
    precalc(h);
    vector<int> strs(n);
    vector<int> sz(n);
    for (int i = 0; i < n; ++i) {
        string j;
        cin >> j;
        sz[i] = j.size();
        strs[i] = hah(j);
    }

    vector<vector<int>> vs(n, vector<int>());
    for (int i = 0; i < n; ++i) {
        if(sz[i] > h.size())
            continue;
        for (int j = 0; j < h.size() - sz[i] + 1; ++j) {
            if(cmp(j, j + sz[i] - 1, strs[i]))
                vs[i].emplace_back(j);
        }
    }
    int debug = 0;

    for (int i = 0; i < t; ++i) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        ll ans = 0;
        for (int j = 0; j < n; ++j) {
            if(!vs[j].empty() and vs[j][0] + sz[j] - 1 <= r and vs[j][vs[j].size() - 1] >= l){
                auto st = lower_bound(all(vs[j]), l) - vs[j].begin();
                auto end = lower_bound(all(vs[j]), r - sz[j] + 2) - vs[j].begin() - 1;
                ans += end - st + 1;
            }
        }
        cout << ans << ' ';
    }
    cout << endl;
}