#include "bits/stdc++.h"
//#pragma GCC optimize("Ofast,unroll-loops")

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define int ll
//#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const ll base = 17;
const ll mod = 1e13 + 23;
vector<int> base_pow;
vector<int> hashs;

void precalc(string &h){
    hashs.assign(h.size() + 1, 0);
    base_pow.assign(h.size() + 1, 1);
    for (int i = 1; i < h.size() + 1; ++i) {
        base_pow[i] = ((ll)base_pow[i - 1] * base % mod);
    }
    for (int i = 1; i < h.size() + 1; ++i) {
        hashs[i] = ((ll)(hashs[i - 1] + h[i - 1] - 'a' + 1) * base % mod);
    }
}

bool cmp(int l, int r, int h){
    int g = ((hashs[r + 1] - ((ll)hashs[l] * base_pow[r - l + 1] % mod) + mod + mod) % mod);
    return g == h;
}


int hah(string &g){
    int ans = 0;
    for(auto u : g){
        ans = ((ll)(ans + u - 'a' + 1) * base) % mod;
    }
    return ans;
}

vector<vector<int>> rs;
vector<vector<int>> ls;

struct Q{
    int l, r;
    int id;
};

int l = 0;
int r = -1;
ll a = 0;

void add_l(){
    int g = upper_bound(all(ls[l]), r) - ls[l].begin();
    a += g;
}

void add_r(){
    int g = rs[r].end() - lower_bound(all(rs[r]), l);
    a += g;
}

void rem_l(){
    int g = upper_bound(all(ls[l]), r) - ls[l].begin();
    a -= g;
}

void rem_r(){
    int g = rs[r].end() - lower_bound(all(rs[r]), l);
    a -= g;
}

const int gr = 330;

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n, t;
    cin >> n >> t;
    string h;
    cin >> h;

    rs.assign(h.size(), {});
    ls.assign(h.size(), {});

    precalc(h);
    vector<int> strs(n);
    vector<int> sz(n);
    for (int i = 0; i < n; ++i) {
        string j;
        cin >> j;
        sz[i] = j.size();
        strs[i] = hah(j);
    }

    for (int i = 0; i < n; ++i) {
        if(sz[i] > h.size())
            continue;
        for (int j = 0; j < h.size() - sz[i] + 1; ++j) {
            if(cmp(j, j + sz[i] - 1, strs[i])) {
                ls[j].emplace_back(j + sz[i] - 1);
                rs[j + sz[i] - 1].emplace_back(j);
            }
        }
    }
    for (int i = 0; i < h.size(); ++i) {
        sort(all(rs[i]));
        sort(all(ls[i]));
    }

    vector<Q> qs;

    for (int i = 0; i < t; ++i) {
        int l1, r1;
        cin >> l1 >> r1;
        --l1, --r1;
        qs.push_back({l1, r1, i});
    }

    sort(all(qs), [](auto l, auto r){
        int l_gr = l.l / gr;
        int r_gr = r.l / gr;
        if(l_gr != r_gr)
            return l_gr < r_gr;
        if(l_gr % 2 == 0)
            return l.r < r.r;
        return l.r > r.r;
    });

    vector<ll> ans(t, -1);
    for(auto q : qs){
        int need_l = q.l;
        int need_r = q.r;
        while (r < need_r){
            ++r;
            add_r();
        }
        while(l > need_l){
            --l;
            add_l();
        }
        while (r > need_r){
            rem_r();
            --r;
        }
        while(l < need_l){
            rem_l();
            ++l;
        }
        ans[q.id] = a;
    }
    for(auto u : ans){
        cout << u << ' ';
    }
    cout << endl;
}