#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<string>
#include<math.h>
#include<bitset>
#include<random>
#include<unordered_map>

using namespace std;

//#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'
using ll = long long;
using ld = long double;

mt19937 rnd(777);

const int N = 1e6 + 9, X = 1 << 20, K = 20;
const long long INF = 1e18 + 9;

const int M = 1e9 + 7, M1 = 1e9 + 9;

struct mod {
	int x = 0, y = 0;
	mod(int a, int b) {
		x = a;
		y = b;
	}
	mod(int a) {
		x = a;
		y = a;
	}
	mod() {
		x = 0;
	}
};
bool operator == (mod a, mod b) {
	return a.x == b.x && a.y == b.y;
}
bool operator <(mod a, mod b) {
	if (a.x != b.x)
		return a.x < b.x;
	return a.y < b.y;
}
bool operator >(mod a, mod b) {
	return b < a;
}
mod operator +(mod a, mod b) {
	int x1 = a.x + b.x;
	int y1 = a.y + b.y;
	if (x1 >= M)
		x1 -= M;
	if (y1 >= M1)
		y1 -= M1;
	return { x1, y1 };
}
void operator += (mod a, mod b) {
	a = a + b;
}
mod operator -(mod a, mod b) {
	int x1 = a.x - b.x;
	int y1 = a.y - b.y;
	if (x1 < 0)
		x1 += M;
	if (y1 < 0)
		y1 += M1;
	return { x1, y1 };
}
void operator -= (mod a, mod b) {
	a = a - b;
}
mod operator *(mod a, mod b) {
	return { (ll(a.x) * b.x) % M, (ll(a.y) * b.y) % M1 };
}

mod b = { 257, 259 };
mod h[N];
mod p[N];

void precalc(string& s) {
	for (int i = 0; i < s.size(); i++) {
		h[i + 1] = h[i] * b + s[i];
	}
}
mod calc(string& s) {
	mod ans = 0;
	for (int i = 0; i < s.size(); i++) {
		ans = ans * b + s[i];
	}
	return ans;
}
mod get(int l, int r) {
	return h[r] - h[l] * p[r - l];
}


int good[N];
int pref[N];

string s[N];
int ans[N];
vector<mod> cnt[N];

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	p[0] = 1;
	for (int i = 1; i < N; i++)
		p[i] = p[i - 1] * b;

	int n, m;
	cin >> n >> m;

	string t;
	cin >> t;
	precalc(t);

	vector<int> len;
	for (int i = 0; i < n; i++) {
		string s;
		cin >> s;
		cnt[s.size()].push_back(calc(s));
		len.push_back(s.size());
	}
	sort(all(len));

	len.resize(unique(all(len)) - len.begin());

	for (auto l : len)
		sort(all(cnt[l]));

	vector<pair<int, int>> q(m);
	for (int i = 0; i < m; i++) {
		cin >> q[i].first >> q[i].second;
		q[i].first--;
	}
	for (auto l : len) {
		for (int i = 0; i < t.size(); i++) {
			good[i] = 0;
		}
		for (int i = 0; i + l <= t.size(); i++) {
			pref[i + 1] = pref[i];
			mod h = get(i, i + l);
			auto lb = lower_bound(all(cnt[l]), h) - cnt[l].begin();
			if (lb != cnt[l].size() && cnt[l][lb] == h)
				pref[i + 1]++;
		}
		for (int i = 0; i < m; i++) {
			int right = q[i].second - l + 1;
			if (right <= q[i].first)
				continue;
			int cnt = pref[right] - pref[q[i].first];
			ans[i] += cnt;
		}
	}
	for (int i = 0; i < m; i++)
		cout << ans[i] << " ";
}