#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
using namespace std;

/*#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
typedef tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;*/

const int mxs = 'z' - 'a' + 1;

struct node{
    node *c[mxs];
    char sym = '$';
    bool isTerm = false;
    node() {
        for (auto *&q: c) q = nullptr;
    }
    node(char sym, bool term = false) : sym(sym), isTerm(term) {
        for (auto *&q: c) q = nullptr;
    }
};

vector<int> evs;

void add_string(node *root, string &s, int i = 0) {
    if (i == (int)s.size()) {
        root->isTerm = true;
        return;
    }
    if (root->c[s[i] - 'a']) return add_string(root->c[s[i] - 'a'], s, i + 1);
    root->c[s[i] - 'a'] = new node(s[i]);
    add_string(root->c[s[i] - 'a'], s, i + 1);
}

void getCnt(node *cur, string &s, int i, int l) {
    if (cur->isTerm) {
        evs.push_back(i - 1);
    }
    if (i == (int)s.size()) {
        return;
    }
    if (cur->c[s[i] - 'a']) {
        return getCnt(cur->c[s[i] - 'a'], s, i + 1, l);
    }
}

struct segtree{
    vector<vector<int>> tree;
    int n;
    void build(vector<int> &a, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x].push_back(a[lx]);
            return;
        }
        int m = (lx + rx) / 2;
        build(a, 2 * x + 1, lx, m);
        build(a, 2 * x + 2, m, rx);
        merge(all(tree[2 * x + 1]), all(tree[2 * x + 2]), back_inserter(tree[x]));
    }
    segtree(vector<int> &a){
        n = (int)a.size();
        tree.resize(4 * n);
        build(a, 0, 0, n);
    }
    int calc(int l, int r, int v, int x, int lx, int rx) {
        if (lx >= l && rx <= r) {
            if (tree[x].empty()) return 0;
            int m = (int)(lower_bound(all(tree[x]), v) - tree[x].begin());
            return m;
        }
        if (lx >= r || rx <= l) return 0;
        int m = (lx + rx) / 2;
        int s1 = calc(l, r, v, 2 * x + 1, lx, m);
        int s2 = calc(l, r, v, 2 * x + 2, m, rx);
        return s1 + s2;
    }
};

signed main(){
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/kek/input.txt", "r", stdin);
    freopen("/home/olymp/CLionProjects/kek/output.txt", "w", stdout);
#endif
    ios_base::sync_with_stdio(false); cin.tie(nullptr);
    node *cur = new node();
    int n, m; cin >> n >> m;
    string s; cin >> s;
    for (int i = 0; i < n; ++i) {
        string t; cin >> t;
        add_string(cur, t);
    }
    vector<pair<int, int>> ids((int)s.size());
    for (int i = 0; i < (int)s.size(); ++i) {
        ids[i].first = (int)evs.size();
        getCnt(cur, s, i, i);
        ids[i].second = (int)evs.size() - 1;
    }
    segtree st(evs);
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        l--; r--;
        int ans = st.calc(ids[l].first, ids[r].second + 1, r + 1, 0, 0, (int)evs.size());
        cout << ans << " ";
    }
    cout << "\n";

}