#include <bits/stdc++.h>
#define size(a) int(a.size())
#define all(a) a.begin(), a.end()
using namespace std;
using ll = long long;
using ld = long double;

const ll md = ll(1e18) + 7;
const int p = 31;

inline ll add(ll a, ll b) {
  a += b;
  if (a >= md) a -= md;
  return a;
}

inline ll sub(ll a, ll b) {
  a -= b;
  if (a < 0) a += md;
  return a;
}

inline ll mul(ll a, ll b) {
  return __int128(a) * b % md;
}

int main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
  int n, m;
  cin >> n >> m;
  string t;
  cin >> t;
  vector<string> s(n);
  vector<ll> h(n);
  unordered_set<ll> st;
  for (int i = 0; i < n; ++i) {
    cin >> s[i];
    h[i] = 0;
    for (char c : s[i]) h[i] = add(mul(h[i], p), c - 'a' + 1);
    st.insert(h[i]);
  }
  int sz = size(t);
  vector<ll> pw(sz + 1);
  pw[0] = 1;
  for (int i = 1; i < size(pw); ++i) {
    pw[i] = mul(pw[i - 1], p);
  }
  vector<ll> ht(sz + 1);
  for (int i = 0; i < sz; ++i) {
    ht[i + 1] = add(mul(ht[i], p), t[i] - 'a' + 1);
  }
  vector<vector<int>> aux(sz, vector<int>(sz));
  for (int l = 0; l < sz; ++l) {
    ll cur = 0;
    for (int r = l; r < sz; ++r) {
      cur = add(mul(cur, p), t[r] - 'a' + 1);
      aux[l][r] = st.find(cur) != st.end();
      if (r > 0) aux[l][r] += aux[l][r - 1];
    }
  }
  while (m--) {
    int L, R;
    cin >> L >> R;
    --L, --R;
    ll ans = 0;
    for (int l = L; l <= R; ++l) {
      ans += aux[l][R];
    }
    cout << ans << ' ';
  }
  return 0;
}
