#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod1 = 1e9 + 7, mod2 = 1e9 + 9, p1 = 31, p2 = 47;

struct ha {
    vector<pair<int, int>> pr;
    int h1 = 0, h2 = 0;

    ha() {};

    ha(string s) {
        h1 = h2 = 0;
        pr.resize(s.size());
        for (int i = 0; i < s.size(); i++) {
            h1 *= p1;
            h2 *= p2;
            h1 += s[i] - 'a' + 1;
            h2 += s[i] - 'a' + 1;
            h1 %= mod1;
            h2 %= mod2;
            pr[i] = {h1, h2};
        }
    }
};

string t;
int n, m;
ha ht;
vector<pair<int,int>> st;
vector<string> w;
vector<ha> h;

pair<int,int> sub(int l, int r){
    auto[h1,h2]=ht.pr[r];
    if (l){
        auto[a,b] = ht.pr[l-1];
        a*=st[r-l+1].first;
        a%=mod1;
        b*=st[r-l+1].second;
        b%=mod2;
        h1=(h1+mod1-a)%mod1;
        h2=(h2+mod2-b)%mod2;
    }
    return {h1,h2};
}

bool check(int i,int j){
    if (t.size()-i<w[j].size()) return 0;
    int l=i,r=i+w[j].size()-1;
    auto[h1,h2] = sub(l,r);
    if (h1==h[j].h1 && h2==h[j].h2) return 1;
    return 0;
}

signed main() {
    st.push_back({1,1});
    for (int i=0;i<1e6;i++){
        st.push_back({st[i].first*p1%mod1,st[i].second*p2%mod2});
    }
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> t;
    ht = ha(t);
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        h.push_back(ha(w[i]));
    }
    vector<pair<int,int>> ot;
    for (int i = 0; i < t.size(); i++) {
        unordered_set<int> se;
        for (int j = 0; j < n; j++) {
            if (se.count(w[j].size())!=0) continue;
            if (check(i, j)) ot.push_back({i,i+w[j].size()-1}),se.insert(w[j].size());
        }
    }
    while (m--){
        int x,y,ans=0;
        cin>>x>>y;
        x--;y--;
        for (auto[a,b] : ot){
            if (a>=x && b<=y) ans++;
        }
        cout<<ans<<' ';
    }
}