#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace __gnu_pbds;
using namespace std;
using idexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod1 = 1e9 + 7, mod2 = 1e9 + 9, p1 = 31, p2 = 47;

struct ha {
    vector<pair<int, int>> pr;
    int h1 = 0, h2 = 0;

    ha() {};

    ha(string s) {
        h1 = h2 = 0;
        pr.resize(s.size());
        for (int i = 0; i < s.size(); i++) {
            h1 *= p1;
            h2 *= p2;
            h1 += s[i] - 'a' + 1;
            h2 += s[i] - 'a' + 1;
            h1 %= mod1;
            h2 %= mod2;
            pr[i] = {h1, h2};
        }
    }
};

string t;
int n, m;
ha ht;
vector<pair<int, int>> st;
vector<string> w;
vector<ha> h;

pair<int, int> sub(int l, int r) {
    auto [h1, h2] = ht.pr[r];
    if (l) {
        auto [a, b] = ht.pr[l - 1];
        a *= st[r - l + 1].first;
        a %= mod1;
        b *= st[r - l + 1].second;
        b %= mod2;
        h1 = (h1 + mod1 - a) % mod1;
        h2 = (h2 + mod2 - b) % mod2;
    }
    return {h1, h2};
}

bool check(int i, int j) {
    if (t.size() - i < w[j].size()) return 0;
    int l = i, r = i + w[j].size() - 1;
    auto [h1, h2] = sub(l, r);
    if (h1 == h[j].h1 && h2 == h[j].h2) return 1;
    return 0;
}

bool cmp(vector<int> &a, vector<int> &b){
    return a[1]<b[1];
}

bool comp(pair<int,int> &a,pair<int,int> &b){
    return a.second<b.second;
}

vector<int> tr;
int res=0;

void upd(int v, int l, int r, int in){
    if (l==r){
        tr[v]++;
        return ;
    }
    int m=(l+r)/2;
    if (in<=m) upd(v*2,l,m,in);
    else upd(v*2+1,m+1,r,in);
    tr[v]=tr[v*2]+tr[v*2+1];
}

void sum(int v, int l, int r, int x, int y){
    if (l==x && r==y){
        res+=tr[v];
        return ;
    }
    int m=(l+r)/2;
    if (x<=m) sum(v*2,l,m,x,min(m,y));
    if (y>m) sum(v*2+1,m+1,r,max(m+1,x),y);
}

signed main() {
    st.push_back({1, 1});
    for (int i = 0; i < 1e6; i++) {
        st.push_back({st[i].first * p1 % mod1, st[i].second * p2 % mod2});
    }
    ios::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> t;
    ht = ha(t);
    w.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        h.push_back(ha(w[i]));
    }
    vector<pair<int, int>> ot;
    for (int i = 0; i < t.size(); i++) {
        unordered_set<int> se;
        for (int j = 0; j < n; j++) {
            if (se.count(w[j].size()) != 0) continue;
            if (check(i, j)) ot.push_back({i, i + w[j].size() - 1}), se.insert(w[j].size());
        }
    }
    vector<vector<int>> req;
    int q=0;
    while (m--) {
        int x, y, ans = 0;
        cin >> x >> y;
        x--;
        y--;
        req.push_back({x, y,q});
        q++;
    }
    sort(req.begin(), req.end(), cmp);
    sort(ot.begin(),ot.end(),comp);
    int uo=0,ur=0;
    tr.resize(4*t.size()+1);
    vector<int> ans(req.size());
    for (int i=0;i<t.size();i++){
        while (uo<ot.size() && ot[uo].second==i){
            upd(1,1,t.size(),ot[uo].first+1);
            uo++;
        }
        while (ur<req.size() && req[ur][1]==i){
            res=0;
            sum(1,1,t.size(),req[ur][0]+1,req[ur][1]+1);
            ans[req[ur][2]]=res;
            ur++;
        }
    }
    for (int i : ans) cout<<i<<' ';
}