#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define ld long double
#define pi pair<int, int>
#define int long long
mt19937 MT(179);
const int INF = 1e18;
const int P = 31;
const int MOD = 1e9 + 7;
vector<int> p;
const int maxN = 1e6 + 5;
void precalc() {
    p.assign(maxN, 1);
    for(int i = 1; i < maxN; ++i) {
        p[i] = p[i - 1] * P;
        p[i] %= MOD;
    }
}
map<pair<int, int>, int> m;
void make_hsh(string&s1, vi& hs) {
    int N = s1.size();
    hs.assign(N + 1, 0);
    for(int i = 1; i <= N; ++i) {
        hs[i] = hs[i - 1] * P + (s1[i - 1] - 'a' + 1);
        hs[i] %= MOD;
    }
}
int gtt(string &s1) {
    int chash = 0;
    for(int i = 0; i < s1.size(); ++i) {
        chash = chash * P + (s1[i] -'a' + 1);
        chash %= MOD;
    }
    return chash;
}
int gthsh(int l, int r, vi& hsh) {
    int tmp = hsh[r + 1] - hsh[l] * p[r - l + 1];
    tmp %= MOD;
    if(tmp < 0) tmp += MOD;
    return tmp;
}
vector<int> orighsh;
vector<int> sechsh;
vector<int> szzs;
vector<vector<pi>> blgs;
vector<vector<int>> st;
vector<vector<int>> pref;
void build(int v, int l, int r) {
    if(l == r) {
        int cpref = 0; pref[v].push_back(cpref);
        for(auto x : blgs[l]) {
            cpref += x.second;
            st[v].push_back(x.first);
            pref[v].push_back(cpref);
        }
        return;
    }
    int mid = (l + r) / 2;
    build(2 * v, l, mid);
    build(2 * v + 1, mid + 1, r);
    int it1 = 0; int it2 = 0;
    int cur_pref = 0;
    pref[v].push_back(cur_pref);
    while(it1 < st[2 * v].size() && it2 < st[2 * v + 1].size()) {
        if(st[2 * v][it1] < st[2 * v + 1][it2]) {
            st[v].push_back(st[2 * v][it1]);
            cur_pref += (pref[2 * v][it1 + 1] - pref[2 * v][it1]);
            it1++;
            pref[v].push_back(cur_pref);
        } else {
            st[v].push_back(st[2 * v + 1][it2]);
            cur_pref += (pref[2 * v + 1][it2 + 1] - pref[2 * v + 1][it2]);
            it2++;
            pref[v].push_back(cur_pref);
        }
    }
    while(it1 < st[2 * v].size()) {
        st[v].push_back(st[2 * v][it1]);
        cur_pref += (pref[2 * v][it1 + 1] - pref[2 * v][it1]);
        it1++;
        pref[v].push_back(cur_pref);
    }
    while(it2 < st[2 * v + 1].size()) {
        st[v].push_back(st[2 * v + 1][it2]);
        cur_pref += (pref[2 * v + 1][it2 + 1] - pref[2 * v + 1][it2]);
        it2++;
        pref[v].push_back(cur_pref);
    }
}
int get(int v, int l, int r, int L, int R, int val) {
    if(l > R || L > r) return 0;
    if(l >= L && R >= r) {
        return pref[v][upper_bound(st[v].begin(), st[v].end(), val) - st[v].begin()];
    }
    int mid = (l + r) / 2;
    return get(2 * v, l, mid, L, R, val) + get(2 * v + 1, mid + 1, r, L, R, val);
}
void solve_small(int N, int M) {
    string t = ""; cin >> t;
    int S = t.size();
    make_hsh(t, orighsh);
    blgs.assign(S, vector<pi> ());
    szzs.assign(N, 0);
    for(int j = 0; j < N; ++j) {
        string k = ""; cin >> k;
        sechsh.push_back(gtt(k));
        szzs[j] = k.size();
        m[{sechsh[j], szzs[j]}]++;
    }
    for(int pos = 0; pos < S; ++pos) {
        for(int sec_pos = pos; sec_pos < S; ++sec_pos) {
            int tmp = gthsh(pos, sec_pos, orighsh);
            if(m.count({tmp, sec_pos - pos + 1})) blgs[pos].push_back({sec_pos, m[{tmp, sec_pos - pos + 1}]});
        }
        sort(blgs[pos].begin(), blgs[pos].end());
    }
    st.assign(4 * S, vector<int> ());
    pref.assign(4 * S, vector<int> ());
    build(1, 0, S - 1);
    for(int j = 0; j < M; ++j) {
        int l = 0, r = 0; cin >> l >> r;
        l--; r--;
        cout << get(1, 0, S - 1, l, r, r) << endl;
    }
}

void solve() {
    int N = 0, M = 0; cin >> N >> M;
    if(N <= 5000) {
        solve_small(N, M);
        return;
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    precalc();
    while(T--) {
        solve();
    }
    return 0;
}

