#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <deque>


#pragma GCC optimize("avx2")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("179")


using namespace std;


const long long inf = 2e6;


#define int long long


int mod = 1791791791;
int p = 31;
const int indl = 5001;
int pref[5001][5001];







signed main() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector <string> all(n);
    for (int i = 0; i < n; i++) {
        cin >> all[i];
    }
    vector <int> p_pow(inf);
    p_pow[0] = 1;
    for (int i = 1; i < inf; i++) {
        p_pow[i] = p_pow[i - 1] * p;
        p_pow[i] %= mod;
    }
    vector <int> ht(t.size() + 1);
    for (int i = 0; i < t.size(); i++) {
        ht[i + 1] = ht[i] + ((t[i] - 'a' + 1) * p_pow[i]) % mod;
        ht[i + 1] %= mod;
    }
    set <int> alh;
    set <int> ald;
    vector <int> hsh(n);
    int cn = 0;
    for (auto nw : all) {
        int su = 0;
        for (int i = 0; i < nw.size(); i++) {
            su += ((nw[i] - 'a' + 1) * p_pow[i]) % mod;
            su %= mod;
        }
        hsh[cn] = (su * p_pow[inf - 1]) % mod;
        ald.insert(nw.size());
        alh.insert(hsh[cn]);
        cn++;
    }
    vector <vector <int>> prc(t.size() + 1, vector <int> (t.size() + 1));
    for (int i = 0; i < t.size(); i++) {
        for (int dl = 1; dl <= t.size() - i; dl++) {
            int ch = 0;
            int nw = (ht[i + dl] - ht[i] + mod) % mod;
            nw = nw * p_pow[inf - 1 - i];
            nw %= mod;
            if (alh.find(nw) != alh.end()) {
                ch = 1;
            }
            prc[i + dl][dl] = ch;
            pref[i + 1][dl] = pref[i][dl] + ch;
        }
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int ans = 0;
        for (auto y : ald) {
            if (l + y - 1 > r) {
                ans = ans;
            }
            else {
                ans += pref[r + 1 - y + 1][y] - pref[l][y];
            }
        }
        cout << ans << "\n";
    }
}