#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define f(n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define pb push_back

typedef long long ll;
typedef vector<int> vei;
typedef string str;


struct Hashes {
    int p = 179, mod = 1e9+7;
    vector<int> ps;
    vector<int> hash;
    int n;
    Hashes(string s) {
        n = s.size();
        ps.resize(n+1);
        ps[0] = 1;
        hash.resize(n+1);
        for(int i = 0; i < n; ++i) {
            ps[i+1] = ps[i] * p % mod;
            hash[i+1] = (hash[i] * p + (s[i] - 'a' + 1)) % mod;
        }
    }

    int get_hash(int l, int sz) {
        return ((hash[l + sz] - hash[l] * ps[sz])%mod+mod)%mod;
    }
};



void solve() {
    int n, m;
    cin>>n>>m;
    str s;
    cin>>s;
    Hashes au(s);
    map<int, map<int, int>> gt;
    f(n) {
//        cout<<i<<endl;
        str t;
        cin>>t;
        Hashes tt(t);
        gt[t.size()][tt.get_hash(0, t.size())] = 1;
    }
    map<int, vector<int>> prs;
    for(auto e : gt) {
        prs[e.first].resize(s.size()+1);
        for(int i = 0; i + e.first <= s.size(); ++i) {
            prs[e.first][i+1] = prs[e.first][i] + e.second[au.get_hash(i, e.first)];
        }
    }
    f(m) {
//        cout<<i<<endl;
        int l, r;
        cin>>l>>r;
        int ans = 0;
        --l;
        for(auto e : prs) {
            ans += e.second[r-e.first+1] - e.second[l];
        }
        cout<<ans<<' ';
    }
}

signed main() {
    cout<<fixed<<setprecision(15);
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
//    cin>>tc;
    for(int i = 0; i < tc; ++i) {
        // cout << "Test case: " << i+1 << endl;
        solve();
    }
    return 0;
}
