#include "bits/stdc++.h"
//#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
//using namespace __gnu_pbds;
//using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
#define int long long
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define ll long long
const long long INF = 30000000000000000;
int mod = 1e9 + 7;
int p = 228;
mt19937 rnd(time(0));
vector<int> h, pw;

int get(int l, int r) {
    return (h[r] - (h[l] * pw[r - l] % mod) + mod) % mod;
}

void build(int n) {
    pw.resize(n + 1);
    h.resize(n + 1);
    pw[0] = 1;
    for (int i = 1; i <= n; ++i) {
        pw[i] = (pw[i - 1] * p) % mod;
    }

}

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    int q = sz(s);
    build(q);
    auto it = &h;
    for (int i = 0; i < q; ++i) {
        h[i + 1] = (h[i] * p + s[i]) % mod;
    }
    vector<pair<int, int>> hashes(n);
    for (int i = 0; i < n; ++i) {
        int hash = 0;
        string t;
        cin >> t;
        for (char j: t)
            hash = (hash * p + j) % mod;
        hashes[i] = {hash, sz(t)};
    }
    vector<vector<int>> pref(n, vector<int>(q + 1));
    for (int j = 0; j < n; ++j) {
        auto[hs, len] = hashes[j];
        for (int i = len; i <= q; ++i) {
            pref[j][i] = pref[j][i-1];
            int hash = get(i - len, i);
            if (hash == hs) {
                pref[j][i]++;
            }
        }
    }
    for (int i = 0; i < m; ++i) {
        int L, R;
        cin >> L >> R;
        int ans = 0;
        for (int j = 0; j < n; ++j) {
            auto[hs, len] = hashes[j];
            if(len > R-L + 1)continue;
             ans+=pref[j][R];
            ans-=pref[j][max(0ll, L +len - 2)];
        }
        cout << ans << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
//    cin >> test;
    while (test--)
        solve();
    return 0;
}