#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
using namespace __gnu_pbds;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }

constexpr ll md = 1e16 + 61;
constexpr ll p = 10039;

inline ll add(ll a, ll b) {
    if ((a += b) >= md) a -= md;
    return a;
}
inline ll sub(ll a, ll b) {
    if ((a -= b) < 0) a += md;
    return a;
}
inline ll mul(ll a, ll b) {
    ll q = (ld)a * (ld)b / (ld)md;
    ll r = (a * b - q * md) % md;
    if (r < 0) r += md;
    return r;
}

const int N = 1e6 + 100;

ll pw[N];
inline void calc() {
    pw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = mul(pw[i - 1], p);
    }
}

ll h[N];
inline ll get(int l, int r) {
    return sub(h[l], mul(pw[r - l + 1], h[r + 1]));
}

inline void solve() { calc();

    int n, m;
    cin >> n >> m;

    string s; cin >> s;
    int k = sz(s);

    for (int i = k - 1; ~i; --i) {
        h[i] = add(s[i] - 'a' + 1, mul(p, h[i + 1]));
    }

    ve<string> a(n);
    for (auto &x : a) cin >> x;

    gp_hash_table<ll,bool> mp;
    for (const auto &s : a) {
        ll h = 0;
        for (int i = 0; i < sz(s); ++i) {
            h = add(h, mul(pw[i], s[i] - 'a' + 1));
        } mp[h] = 1;
    }

    ve<int> al;
    for (const auto &x : a) al.pb(sz(x));

    sort(all(al));
    al.erase(unique(all(al)), al.end());

    ve<pii> c;
    for (int r = 0; r < k; ++r) {
        for (const int &len : al) {
            int l = r - len + 1;
            if (l < 0) break;

            if (mp.find(get(l, r)) != mp.end()) {
                c.pb({r, l});
            }
        }
    }

    while (m--) {
        int l, r;
        cin >> l >> r, --l, --r;

        int L = l;
        l = lower_bound(all(c), mpp(l, -iinf)) - c.begin();
        r = upper_bound(all(c), mpp(r, iinf)) - c.begin() - 1;

        int ans = 0;
        for (int i = l; i <= r; ++i) {
            if (c[i].se >= L) {
                ++ans;
            }
        }
        cout << ans << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
