#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,fma")

#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
using namespace __gnu_pbds;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }

constexpr int md = 1e9 + 9;
constexpr int p1 = 10039;
constexpr int p2 = 257;

inline int add(int a, int b) {
    if ((a += b) >= md) a -= md;
    return a;
}
inline int sub(int a, int b) {
    if ((a -= b) < 0) a += md;
    return a;
}
inline int mul(int a, int b) {
    return (ll)a * b % md;
}

const int N = 1e6 + 100;

int pw1[N], pw2[N];
inline void calc() {
    pw1[0] = pw2[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw1[i] = mul(pw1[i - 1], p1);
        pw2[i] = mul(pw2[i - 1], p2);
    }
}

pii h[N];
inline pii get(int l, int r) {
    return mpp(
               sub(h[l].fi, mul(pw1[r - l + 1], h[r + 1].fi)),
               sub(h[l].se, mul(pw2[r - l + 1], h[r + 1].se))
               );
}

constexpr int buben = 710;
int nn, mx_b;
int a[N], addd[N / buben + 10];

inline void addq(int pos, int x) {
    a[pos] += x;
    addd[pos / buben] += x;
}
inline int get_sum(int l) {
    int lb = l / buben; ll ans = 0;
    for (int i = lb + 1; i <= mx_b; ++i) ans += addd[i];
    for (int i = l; i < (lb + 1) * buben; ++i) ans += a[i];
    return ans;
}

struct HASH {
    const inline ll operator()(const pii &x) const {
        return x.fi ^ ((ll)x.se << 30ll);
    }
};

inline void solve() { calc();

    int n, m;
    cin >> n >> m;

    string s; cin >> s;
    int k = sz(s);

    nn = k;
    mx_b = (nn - 1) / buben;

    for (int i = k - 1; ~i; --i) {
        h[i].fi = add(s[i] - 'a' + 1, mul(p1, h[i + 1].fi));
        h[i].se = add(s[i] - 'a' + 1, mul(p2, h[i + 1].se));
    }

    ve<string> a(n);
    for (auto &x : a) cin >> x;

    gp_hash_table<pii,int,HASH> mp;
    for (const auto &s : a) {
        int h1 = 0, h2 = 0;
        for (int i = 0; i < sz(s); ++i) {
            h1 = add(h1, mul(pw1[i], s[i] - 'a' + 1));
            h2 = add(h2, mul(pw2[i], s[i] - 'a' + 1));
        } mp[mpp(h1, h2)] = 1;
    }

    ve<int> al;
    for (const auto &x : a) al.pb(sz(x));

    sort(all(al));
    al.erase(unique(all(al)), al.end());

    ve<ll> ans(m);
    ve<ve<pii>> que(k);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r, --l, --r;

        que[r].pb({l, i});
    }

    for (int r = 0; r < k; ++r) {
        for (const int &len : al) {
            int l = r - len + 1;
            if (l < 0) break;

            if (mp.find(get(l, r)) != mp.end()) {
                addq(l, +1);
            }
        }

        for (const auto &[l, id] : que[r]) {
            ans[id] = get_sum(l);
        }
    }

    for (auto &x : ans) cout << x << " ";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
