#include <bits/stdc++.h>
using namespace std;
#define nt int
#define int long long
const int mod = 1e9 + 7;
const int p = 31;
const int maxn = 1e5 + 5;
const int k = 1000;
unordered_set<int> cc[k];
int pows[maxn];
int h[maxn];
int cnt_hash(string& s) {
    int res = 0;
    for (char c: s) {
        res = res * p + c - 'a' + 1;
        res %= mod;
    }
    return res;
}
int cnt[maxn][k];
int get_h(nt l, int r) {
    int f = h[r] - (h[l - 1] * pows[r - l + 1]) % mod;
    if (f < 0) f += mod;
    return f;
}
signed main() {
    pows[0] = 1;
    for (int i = 1; i < maxn; i++) {
        pows[i] = pows[i - 1] * p;
        pows[i] %= mod;
    }
    int n, q;
    cin >> n >> q;
    string s; cin >> s;
    s = ' ' + s;
    for (int i = 1; i < s.size(); i++) {
        h[i] = (h[i - 1] * p + s[i] - 'a' + 1);
        h[i] %= mod;
    }
    vector <string> patt;
    vector <int> lens;
    for (int i = 0; i < n; i++) {
        string t; cin >> t;
        lens.push_back(t.size());
        patt.push_back(t);
    }
    std::sort(lens.begin(), lens.end());
    lens = vector <int> (lens.begin(), std::unique(lens.begin(), lens.end()));
    for (string t: patt) {
        int hh = cnt_hash(t);
        cc[std::lower_bound(lens.begin(), lens.end(), t.size()) - lens.begin()].insert(hh);
    }
    for (int l = 1; l < s.size(); l++) {
        for (int j = 0; j < lens.size() && lens[j] <= l; j++) {
            int lst_hash = get_h(l - lens[j] + 1, l);
            if (lens[j] <= l && cc[j].find(lst_hash) != cc[j].end()) cnt[l][j]++;
        }
    }
    while (q--) {
        int l, r;
        cin >> l >> r;
        int ans = 0;
        for (int end = l; end <= r; end++) {
            int sz = end - l + 1;
            for (int j = 0; j < lens.size() && lens[j] <= sz; j++) ans += cnt[end][j];
        }
        cout << ans << '\n';
    }

    return 0;
}