#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<pair<int, int>> all;

void find_pos(const string &t, const string &si) {
    if (si.size() > t.size()) return;
    const string x = si + "#" + t;
    int n = (int) si.size(), m = (int) t.size(), w = n + m + 1;

    vector<int> p(w);
    for (int i = 1; i < w; ++i) {
        int j = p[i - 1];
        while (j > 0 && x[i] != x[j]) {
            j = p[j - 1];
        }
        if (x[i] == x[j]) {
            p[i] = j + 1;
        }
        if (p[i] == n) {
            all.emplace_back(i - 2 * n, i - n);
        }
    }
}

void solve() {
    int n, m;
    string t;
    cin >> n >> m >> t;

    for (int i = 0; i < n; ++i) {
        string si;
        cin >> si;

        find_pos(t, si);
    }

    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        l--;

        ll ans = 0;
        for (auto x : all) {
            if (l <= x.first && x.second <= r) {
                ans++;
            }
        }
        cout << ans << "\n";
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
