#include <bits/stdc++.h>

#define ll long long
#define all(x) x.begin(), x.end()
#define fi first
#define se second


using namespace std;

struct node{
    ll val = 0;
    map<ll, ll> k;
};

vector<node> t;
vector<node> a;
ll sz;
void build(ll v = 1, ll tl = 0, ll tr = sz - 1){
    if(tl == tr){
        t[v] = a[tl];
        return;
    }
    ll tm = (tl + tr) / 2;
    build(v * 2, tl, tm);
    build(v * 2 + 1, tm + 1, tr);
    t[v].val = t[v * 2].val + t[v * 2 + 1].val;
    for(auto i : t[v * 2].k)
        t[v].k[i.first] += i.second;
    for(auto i : t[v * 2 + 1].k)
        if(i.first > tm - tl + 1)
            t[v].k[i.first - (tm - tl + 1)] += i.second;
        else
            t[v].val += i.second;
}

node get(ll l, ll r, ll v = 1, ll tl = 0, ll tr = sz - 1){
    if(tl >= l && tr <= r)
        return t[v];
    if(tl > r || tr < l)
        return {0, map<ll, ll>()};
    ll tm = (tl + tr) / 2;
    node g1 = get(l, r, v * 2, tl, tm);
    node g2 = get(l, r, v * 2 + 1, tm + 1, tr);
    node res;
    res.val = g1.val + g2.val;
    for(auto i : g1.k)
        res.k[i.first] += i.second;
    for(auto i : g2.k)
        if(i.first > tm - max(l, tl) + 1)
            res.k[i.first - (tm - max(l, tl) + 1)] += i.second;
        else
            res.val += i.second;
    return res;
}

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    ll n, m;
    cin >> n >> m;
    string temp;
    cin >> temp;
    sz = temp.size();
    if(sz <= 5000 && m <= 500){
        a.resize(temp.size());
        t.resize(10*temp.size());
        for(ll it = 0; it < n; it++){
            string st;
            cin >> st;
            string tt = st + "#" + temp;
            vector<ll> pi(tt.size(), 0);
            for(ll i = 1; i < tt.size(); i++){
                ll j = pi[i - 1];
                while(j != 0 && tt[i] != tt[j])
                    j = pi[j - 1];
                j += tt[i] == tt[j];
                pi[i] = j;
            }
            for(ll i = st.size() + 1; i < tt.size(); i++)
                if(pi[i] == st.size()){
                    if(st.size() == 1)
                        a[i - (st.size() + 1)].val++;
                    else
                        a[i - (st.size() + 1)].k[st.size() - 1]++;
                }
        }
        build();
        //cout << t[1].val << "\n";
    //    for(auto i : a)
    //        cout << i.val << " ";
    ////    cout << "\n";
        while(m--){
            ll l, r;
            cin >> l >> r;
            l--;
            r--;
            cout << get(l, r).val << " ";
        }
    }
    
    return 0;
}
