#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

const ll mod = 998244353;

ll add(ll x, ll y) {
    ll s = x + y;
    if (s > mod) {
        s -= mod;
    }
    return s;
}

ll sub(ll x, ll y) {
    ll s = x - y;
    if (s < 0) {
        s += mod;
    }
    return s;
}

ll mul(ll x, ll y) {
    return x * y % mod;
}

void solve() {
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> a(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
    }
    ll dl = (ll)t.size();
    vector<ll> pr(dl + 1);
    ll p = 239;
    pr[0] = 1;
    for (ll i = 1; i <= dl; i++) {
        pr[i] = mul(pr[i - 1], p);
    }
    vector<ll> h(dl + 1);
    h[1] = t[0];
    for (ll i = 2; i <= dl; i++) {
        h[i] = add(mul(h[i - 1], p), t[i - 1]);
    }
    vector<ll> ha(n);
    for (ll i = 0; i < n; i++) {
        string s = a[i];
        ll w = s[0];
        for (ll j = 1; j < (ll)s.size(); j++) {
            w = add(mul(w, p), s[j]);
        }
        ha[i] = w;
    }
    vector<pair<ll, ll>> g;
    for (ll i = 1; i <= dl; i++) {
        for (ll j = 0; j < n; j++) {
            ll d = (ll)a[j].size();
            if (i + d - 1 > dl) {
                continue;
            }
            ll h1 = sub(h[i + d - 1], mul(h[i - 1], pr[d]));
            ll h2 = ha[j];
            if (h1 == h2) {
                 g.emplace_back(i, i + d - 1);
            }
        }
    }
    sort(g.begin(), g.end());
    for (ll q = 0; q < m; q++) {
        ll l, r;
        cin >> l >> r;
        ll k = 0;
        for (auto x : g) {
            if (l <= x.first && x.second <= r) {
                k++;
            }
        }
        cout << k << ' ';
    }
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}