#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
const int maxn = 1 << 20;
const int inf = 2e9;
const int mod = 1e9 + 7;
const int mod1 = 1e9 + 9;

int bylen[maxn];

struct query {
    int l, r, len, i;
    query() {}
    query(int l, int r, int len, int i): l(l), r(r), len(len), i(i) {}
};

const int p = 59;
long long P[maxn];
long long P1[maxn];
int h[maxn];
int get(int l, int r) {
    return ((h[r] - h[l - 1] * P[r - l + 1]) % mod + mod) % mod;
}
int h1[maxn];
int get1(int l, int r) {
    return ((h1[r] - h1[l - 1] * P1[r - l + 1]) % mod1 + mod1) % mod1;
}
int pref[maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> a(n);
    for (string& x : a) cin >> x;
    vector<int> lens;
    for (int i = 0; i < n; ++i) {
        lens.push_back(a[i].size());
    }
    sort(lens.begin(), lens.end());
    lens.resize(unique(lens.begin(), lens.end()) - lens.begin());
    for (int i = 0; i < lens.size(); ++i) {
        bylen[lens[i]] = i;
    }
    vector<long long> ans(m, 0);
    vector<pair<int, int>> qq;
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        qq.push_back({ l, r });
    }
    for (int i = 1; i <= t.size(); ++i) {
        h[i] = (h[i - 1] * 1ll * p + t[i - 1] - 'a' + 1) % mod;
        h1[i] = (h1[i - 1] * 1ll * p + t[i - 1] - 'a' + 1) % mod1;
    }
    unordered_set<int> s;
    s.reserve(1 << 20);
    unordered_set<int> s1;
    s1.reserve(1 << 20);
    for (int i = 0; i < n; ++i) {
        int x = 0;
        int x1 = 0;
        for (char c : a[i]) {
            x = (x * 1ll * p + c - 'a' + 1) % mod;
            x1 = (x1 * 1ll * p + c - 'a' + 1) % mod1;
        }
        s.insert(x);
        s1.insert(x1);
    }
    int ptr = 0;
    for (int i = 0; i < lens.size(); ++i) {
        fill(pref, pref + maxn, 0);
        for (int j = lens[i] - 1; j < t.size(); ++j) {
            int L = j - lens[i] + 1;
            if (s.count(get(L + 1, j + 1)) && s1.count(get1(L + 1, j + 1))) {
                pref[j + 1] = 1;
            }
        }
        for (int j = 1; j <= t.size(); ++j) {
            pref[j] += pref[j - 1];
        }
        int len = lens[i];
        for (int i = 0; i < m; ++i) {
            auto [l, r] = qq[i];
            l = l + len - 1;
            if (l < r) {
                ans[i] += pref[r] - pref[l];
            }
        }
    }
    for (int i : ans) {
        cout << i << ' ';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    P[0] = P1[0] = 1;
    for (int i = 1; i < maxn; ++i) {
        P[i] = (P[i - 1] * 1ll * p) % mod;
        P1[i] = (P1[i - 1] * 1ll * p) % mod1;
    }
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
