#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
using namespace std;
#define int long long
const int mod = 1e9 + 7;
const int base = 57;

int pows[2500 * 101];
int pref[2000 * 101];


int sub(int i, int j) {
    return ((pref[j] - pref[i] * pows[j - i]) % mod + mod) % mod;
}

vector<int> cnt[1000 * 101];

signed main() {
    pows[0] = 1;
    for (int i = 1; i < 2500 * 101; i++) {
        pows[i] = pows[i - 1] * base % mod;
    }

    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<int> have;
    set<int> sz;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        sz.insert(s.size());
        int h = 0;
        for (int i = 0; i < s.size(); i++) {
            h = (h + s[i]) * base % mod;
        }
        have.push_back(h);
    }
    sort(have.begin(), have.end());
    have.push_back(mod + 1);
    for (int i = 0; i <= t.size(); i++) {
        cnt[i].resize(sz.size());
    }
    pref[0] = 0;
    for (int i = 1; i <= t.size(); i++) {
        pref[i] = (long long)((pref[i - 1] + t[i - 1])) * base % mod;
    }
    int j = 0;
    for (auto x : sz) {
        for (int i = 0; i <= (int)t.size() - x; i++) {
            int now = sub(i, i + x);
            if (*lower_bound(have.begin(), have.end(), now) == now) {
                cnt[i + 1][j] = 1;
            }
        }
        j++;
    }
    for (int i = 1; i <= t.size(); i++) {
        for (int j = 0; j < sz.size(); j++) {
            cnt[i][j] += cnt[i - 1][j];
        }
    }
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        int j = 0;
        int ans = 0;
        for (auto x : sz) {
            if (r - x + 1 < l) {
                continue;
            }
            ans += cnt[r - x + 1][j] - cnt[l - 1][j];
            j++;
        }
        cout << ans << ' ';
    }
}