#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;
using ull = unsigned long long;

const int N = 1e6 + 5;

int n, m;
string t;
ve<string> a;
ve<int> Q[N];
ve<pii> good;
int ans[N];
ve<array<int, 3>> query;

int inc[N];

int szTrie = 1;
int to[N][26];
int go[N][26];
int suf[N];
int ch[N];
bool term[N];

void add(const string& s) {
    int v = 1;
    fr (i, 0, sz(s) - 1) {
        if (!to[v][s[i] - 'a']) {
            to[v][s[i] - 'a'] = ++szTrie;
//            cout << to[v][s[i] - 'a'] << " " << s.substr(0, i + 1) << "\n";
        }
        v = to[v][s[i] - 'a'];
    }
    term[v] = 1;
}

int par[N];
int len[N];

ve<int> occ[N];

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif


    cin >> n >> m;

    cin >> t;

    fr (i, 1, n) {
        string s;
        cin >> s;

        a.pb(s);
        Q[sz(s)].pb(i - 1);
    }


    fe (cur, a) {
        add(cur);
    }

    {
        queue<int> q;
        q.push(1);
        while (sz(q)) {
            int v = q.front();
            q.pop();

            fr (i, 0, 25) {
                if (to[v][i]) {
                    len[to[v][i]] = len[v] + 1;
                    par[to[v][i]] = v;
                    ch[to[v][i]] = i;
                    q.push(to[v][i]);
                }
            }
            int from = suf[par[v]];
            if (len[v] > 1 && !from) from = 1;

            suf[v] = go[from][ch[v]];
            if (len[v] && !suf[v]) suf[v] = 1;

            fr (i, 0, 25) {
                if (to[v][i]) {
                    go[v][i] = to[v][i];
                } else {
                    go[v][i] = go[!suf[v] ? 1 : suf[v]][i];
                }
            }
        }
    }

//    fr (i, 1, 5) {
//        cout << i << " " << suf[i] << "\n";
//    }
//
//    return 0;

    fr (i, 1, m) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;

        query.pb({l, r, i});
    }

    {
        int v = 1;
        fr (i, 0, sz(t) - 1) {
            v = go[v][t[i] - 'a'];
            if (v == 0) v = 1;

            int u = v;
            while (u != 1) {
                if (term[u]) {
                    occ[len[u]].pb(i - len[u] + 1);
                }
                u = suf[u];
            }
//            cout << i + 1 << " " << v << " " << len[v] << "\n";
        }
    }

    fr (len, 1, N - 1) {
        if (sz(Q[len])) {
            fr (i, 0, sz(t) - len) {
                inc[i] = 0;
            }

            fe (cur, occ[len]) {
                inc[cur] = 1;
            }

            fr (i, 1, sz(t) - len) {
                inc[i] += inc[i - 1];
            }

            fe (cur, query) {
                int l = cur[0];
                int r = cur[1];
                int idx = cur[2];

                if (l <= r - len + 1) {
                    int res = inc[r - len + 1];
                    if (l - 1 >= 0) res -= inc[l - 1];
                    ans[idx] += res;
                }
            }
        }
    }

    fr (i, 1, m) {
        cout << ans[i] << "\n";
    }

    return 0;
}
