#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 9;
const int P = 179;

int mul(int a, int b) {
    return (1ll * a * b) % MOD;
}

int sub(int a, int b) {
    int res = (a - b) % MOD + MOD;
    return res % MOD;
}

int add(int a, int b) {
    return (a + b) % MOD;
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int ln = t.size();
    vector<int> power(ln);
    power[0] = 1;
    vector<int> pref_hash(ln);
    for (int i = 0; i < ln; ++i) {
        pref_hash[i] = mul((i ? pref_hash[i - 1] : 0), P);
        pref_hash[i] = add(pref_hash[i], t[i] - 'a' + 1);
        if (i)
            power[i] = mul(power[i - 1], P);
    }
    auto get_hash = [&](int l, int r) {
        if (l == 0)
            return pref_hash[r];
        return sub(pref_hash[r], mul(pref_hash[l - 1], power[r - l + 1]));
    };
    vector<vector<int>> occ(n);
    vector<int> szi(n);
    vector<int> sh(n);
    int tmcnt = 0;
    for (auto &el: occ) {
        string tmp;
        cin >> tmp;
        int curh = 0;
        for (int i = 0; i < tmp.size(); ++i) {
            curh = mul(curh, P);
            curh = add(curh, tmp[i] - 'a' + 1);
        }
        sh[curh] = curh;
        szi[tmcnt++] = tmp.size();
        for (int i = 0; i + tmp.size() - 1 < ln; ++i)
            if (get_hash(i, i + tmp.size() - 1) == curh)
                el.push_back(i);
    }
    for (int tn =0; tn < m; ++tn) {
        int li, ri;
        cin >> li >> ri;
        --li, --ri;
        int ans =0;
        for (int i =0 ; i < n; ++i) {
            for (int j = 0; j + szi[i] - 1 < ln; ++j)
                ans += (sh[i] == get_hash(j, j + szi[i] - 1));
        }
        cout << ans << ' ';
    }
}