#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define str to_string
#define pb push_back

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef long double ld;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template <typename T>
inline ll len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD1 = 1e9 + 7;
const ll MOD2 = 998244353;
const ll p1 = 41;
const ll p2 = 53;
const int maxN = 5e5 + 9;
const int maxS = 6e6 + 9;
string t;
string a[maxN];
ll h1[maxN], h2[maxN];
ll pw1[maxN], pw2[maxN];
void bh() {
    int n = len(t);
    pw1[0] = pw2[0] = 1;
    for(int i = 1; i <= n; ++i) {
        h1[i] = (h1[i - 1] * p1 + (t[i] - 'a' + 1)) % MOD1;
        pw1[i] = pw1[i - 1] * p1 % MOD1;
        h2[i] = (h2[i - 1] * p2 + (t[i] - 'a' + 1)) % MOD2;
        pw2[i] = pw2[i - 1] * p2 % MOD2;
    }
}
ll gh(string& s) {
    ll res1 = 0, res2 = 0;
    for(auto &i: s) {
        res1 = (res1 * p1 + (i - 'a' + 1)) % MOD1;
        res2 = (res2 * p2 + (i - 'a' + 1)) % MOD2;
    }
    return res1 * MOD2 + res2;
}
ll gh(int l, int r) {
    ll res1, res2;
    {
        res1 = h1[r];
        res1 -= h1[l - 1] * pw1[r - l + 1] % MOD1;
        if(res1 < 0) res1 += MOD1;
    }
    {
        res2 = h2[r];
        res2 -= h2[l - 1] * pw2[r - l + 1] % MOD2;
        if(res2 < 0) res2 += MOD2;
    }
    return res1 * MOD2 + res2;
}

vector<int> inds[maxN];
unordered_map<ll, int> who;
void get(int k) {
    int n = len(t) - 1;
    for(int l = 1; l + k - 1 <= n; ++l) {
        ll th = gh(l, l + k - 1);
        if(who.count(th)) {
            inds[who[th]].pb(l);
        }
    }
}


struct qry {
    int l, r, i;
    bool operator<(const qry& sec) const {
        return l < sec.l;
    }
};
qry qs[maxN];
ll ans[maxN];
vector<int> rs[maxN];
ll fw[maxN];
void add(int i, ll x) {
    while(i <= len(t) - 1) {
        fw[i] += x;
        i |= i + 1;
    }
}
ll getsum(int r) {
    ll res = 0;
    while(r >= 0) {
        res += fw[r];
        r = (r & (r + 1)) - 1;
    }
    return res;
}
int n, q;
void go() {
    for(int i = 1; i <= n; ++i) {
        int le = len(a[i]);
        for(auto &l: inds[i]) {
            rs[l].pb(l + le - 1);
        }
    }
    sort(qs + 1, qs + q + 1);
    reverse(qs + 1, qs + q + 1);
    int L = len(t);
    for(int cq = 1; cq <= q; ++cq) {
        while(qs[cq].l < L) {
            --L;
            for(auto &r: rs[L]) add(r, 1);
        }
        ans[qs[cq].i] = getsum(qs[cq].r);
    }
}

bool cmp(const string& a, const string& b) {
    return len(a) < len(b);
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    cin >> n >> q;
    cin >> t;
    t.insert(t.begin(), 0);

    bh();
    for(int i = 1; i <= n; ++i) cin >> a[i];
    sort(a + 1, a + n + 1, cmp);
    for(int i = 1; i <= n; ++i) {
        ll ch = gh(a[i]);
        who[ch] = i;
    }
    int ple = -1;
    for(int i = 1; i <= n; ++i) {
        if(len(a[i]) != ple) get(len(a[i]));
        ple = len(a[i]);
    }

    for(int i = 1; i <= q; ++i) {
        int l, r; cin >> l >> r;
        qs[i] = {l, r, i};
    }
    go();
    for(int i = 1; i <= q; ++i) cout << ans[i] << ' ';
    cout << '\n';
}
/*

3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5

4 4
abcdca
ab
ca
bcd
openolympiad
1 5
2 2
2 6
1 6

 */