#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);
#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}

const int maxn = 5e5;
string t[maxn];

const int maxlen = 5e6;
vector<pair<int, int>> req[maxlen + 1];

int ans[maxn];

void solve() {
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    int len = s.size();
    for (int i = 0; i < n; ++i) {
        cin >> t[i];
    }
    for (int i = 0; i < m; ++i) {
        int x, y;
        cin >> x >> y;
        req[y].push_back({x, i});
    }

    vector<int> cnt(len + 1);

    for (int i = 1; i <= len; ++i) {
        string u = "";
        for (int j = i; j >= 1; --j) {
            u = s[j - 1] + u;

            for (int x = 0; x < n; ++x)
                if (t[x] == u)
                    cnt[j] += 1;
        }

        for (auto [l, pos] : req[i]) {
            for (int j = l; j <= i; ++j)
                ans[pos] += cnt[j];
        }
    }

    for (int i = 0; i < m; ++i)
        cout << ans[i] << " ";
    cout << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}