#include "bits/stdc++.h"

using namespace std;
#define sz(a) (int)a.size()
#define all(a)a.begin(),a.end()
#define ll long long
vector<ll> mod = {998244354, 1000000007};
vector<ll> p = {313, 241};

vector<ll> f;

void upd(int x) {
    for (int i = x; i < sz(f); i = (i | (i + 1)))
        f[i] += 1;
}

ll get(int x) {
    ll s = 0;
    for (int i = x; i > 0; i = (i & (i + 1)) - 1)
        s += f[i];
    return s;

}

struct info {
    vector<int> g;
    int term = 0;

    info() {
        g.assign(26, -1);
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    f.assign(sz(t) + 1, 0);
    vector<ll> hash(2);
    vector<vector<ll>> h(2, vector<ll>(sz(t)));
    vector<vector<ll>> P(2, vector<ll>(sz(t) + 1, 1));
    for (int i = 0; i < 2; ++i)
        for (int j = 0; j < sz(t); ++j)
            h[i][j] = ((j > 0 ? h[i][j - 1] : 0) * p[i] + t[j]) % mod[i];
    for (int i = 0; i < 2; ++i)
        for (int j = 1; j < sz(P[i]); ++j)
            P[i][j] = (P[i][j - 1] * p[i]) % mod[i];

    int B = min(sz(t), 400);
//    vector<unordered_set<int>> light(B + 1);
    vector<pair<int, vector<ll>>> heavy;
    vector<info> W(1);
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        if (sz(s) <= B) {
            int cur = 0;
            for (auto c: s) {
                if (W[cur].g[c - 'a'] == -1) {
                    W.emplace_back();
                    W[cur].g[c - 'a'] = sz(W) - 1;
                }
                cur = W[cur].g[c - 'a'];
            }
            W[cur].term = 1;
        } else {
            hash = {0, 0};
            for (auto c: s)
                for (int j = 0; j < 2; ++j)
                    hash[j] = (hash[j] * p[j] + c) % mod[j];

            heavy.emplace_back(sz(s), hash);
        }
    }
    sort(all(heavy));

    vector<ll> ans(m);
    struct info {
        int l, r, ind;
    };
    vector<info> qs(m);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        qs[i] = {l, r, i};
    }
    sort(all(qs), [&](info a, info b) {
        return vector{a.l, a.r, a.ind} < vector{b.l, b.r, b.ind};
    });
    int pnt = m - 1;
    for (int i = sz(t) - 1; i >= 0; --i) {
        for (auto [len, hs]: heavy) {
            if (i + len - 1 >= sz(t))
                break;
            for (int j = 0; j < 2; ++j)
                hash[j] = ((h[j][i + len - 1] - (i > 0 ? h[j][i - 1] : 0ll) * P[j][len] % mod[j]) % mod[j] + mod[j]) %
                          mod[j];
            if (hash == hs)
                upd(i + len - 1 + 1);
        }
        int cur = 0;
        for (int j = i; j < min(sz(t), i + B); ++j) {
            if (W[cur].g[t[j] - 'a'] == -1)
                break;
            cur = W[cur].g[t[j] - 'a'];
            if (W[cur].term)
                upd(j + 1);
        }
        while (pnt >= 0 && i <= qs[pnt].l) {
            ans[qs[pnt].ind] = get(qs[pnt].r - 1 + 1);
            --pnt;
        }
    }
    for (int i = 0; i < m; ++i)
        cout << ans[i] << ' ';
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}