#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod = (int) 1e9 + 7;
const int pr = 31;
const int N = (int) 5e6 + 10;

unordered_map<int, vector<int>> mp;
unordered_map<int, vector<int>> pref;
int nn, m, h[N], p[N], inv[N], n;

int get_hash(const string &s) {
    int hash = 0;
    for (int i = 0; i < (int) s.size(); i++)
        hash = (hash + ((s[i] - 'a' + 1) * p[i]) % mod) % mod;
    return hash;
}

int Binary_Pow(int x, int y) {
    if (y == 0)return 1;
    if (y == 1)return x % mod;
    if (y % 2 == 1)
        return (Binary_Pow((x * x) % mod, y / 2) * x) % mod;
    return Binary_Pow((x * x) % mod, y / 2);
}

int get_sub(int l, int r) {
    if (l > 0)
        return (((h[r] - h[l - 1]) % mod + mod) % mod * inv[l]) % mod;
    return h[r];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cin >> nn >> m;
    string t;
    cin >> t;
    n = (int) t.size();
    p[0] = 1;
    for (int i = 1; i < N; i++)
        p[i] = (p[i - 1] * pr) % mod;
    inv[0] = 1;
    inv[1] = Binary_Pow(pr, mod - 2);
    for (int i = 2; i < N; i++) {
        inv[i] = (inv[i - 1] * inv[1]) % mod;
    }
    h[0] = (t[0] - 'a' + 1);
    for (int i = 1; i < n; i++)
        h[i] = (h[i - 1] + ((t[i] - 'a' + 1) * p[i]) % mod) % mod;
    string s[nn];
    for (int i = 0; i < nn; i++)
        cin >> s[i], mp[(int) s[i].size()] = {};
    set<int> st;
    for (int i = 0; i < nn; i++)
        st.insert(get_hash(s[i]));
    for (const auto &i: mp) {
        int sz = i.first;
        mp[sz].resize(n, 0ll);
        for (int j = 0; j <= n - sz; j++) {
            if (st.find(get_sub(j, j + sz - 1)) != st.end())
                mp[sz][j] = 1;
        }
        pref[sz].resize(n, 0ll);
        pref[sz][0] = mp[sz][0];
        for (int j = 1; j < n; j++)
            pref[sz][j] = pref[sz][j - 1] + mp[sz][j];
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (const auto &i: mp) {
            int sz = i.first;
            int left = l, right = r - sz + 1;
            if (right >= left)
                ans += pref[sz][right] - pref[sz][left] + mp[sz][left];
        }
        cout << ans << " ";
    }
    return 0;
}