#include <bits/stdc++.h>

using namespace std;
#define int long long

const int mod1 = (int) 1e9 + 9;
const int mod2 = (int) 1e9 + 7;
const int pr = 29;
const int N = (int) 5e6 + 1;

int nn, m, h1[N], p1[N], inv1[N], n, h2[N], p2[N], inv2[N];
int cnt[(int) 1e6 + 1];
vector<int> mp[(int) 1e6 + 1];
vector<int> pref[(int) 1e6 + 1];

pair<int, int> get_hash(const string &s) {
    int hash1 = 0, hash2 = 0;
    for (int i = 0; i < (int) s.size(); i++) {
        hash1 = (hash1 + ((s[i] - 'a' + 1) * p1[i]) % mod1) % mod1;
        hash2 = (hash2 + ((s[i] - 'a' + 1) * p2[i]) % mod2) % mod2;
    }
    return {hash1, hash2};
}

int Binary_Pow1(int x, int y) {
    if (y == 0)return 1;
    if (y == 1)return x % mod1;
    if (y % 2 == 1)
        return (Binary_Pow1((x * x) % mod1, y / 2) * x) % mod1;
    return Binary_Pow1((x * x) % mod1, y / 2);
}

int Binary_Pow2(int x, int y) {
    if (y == 0)return 1;
    if (y == 1)return x % mod2;
    if (y % 2 == 1)
        return (Binary_Pow2((x * x) % mod2, y / 2) * x) % mod2;
    return Binary_Pow2((x * x) % mod2, y / 2);
}

pair<int, int> get_sub(int l, int r) {
    if (l > 0)
        return {(((h1[r] - h1[l - 1]) % mod1 + mod1) % mod1 * inv1[l]) % mod1,
                (((h2[r] - h2[l - 1]) % mod2 + mod2) % mod2 * inv2[l]) % mod2};
    return {h1[r], h2[r]};
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr), cout.tie(nullptr);
    cin >> nn >> m;
    string t;
    cin >> t;
    n = (int) t.size();
    p1[0] = 1;
    for (int i = 1; i < N; i++)
        p1[i] = (p1[i - 1] * pr) % mod1;
    p2[0] = 1;
    for (int i = 1; i < N; i++)
        p2[i] = (p2[i - 1] * pr) % mod2;
    inv1[0] = 1;
    inv1[1] = Binary_Pow1(pr, mod1 - 2);
    for (int i = 2; i < N; i++) {
        inv1[i] = (inv1[i - 1] * inv1[1]) % mod1;
    }
    inv2[0] = 1;
    inv2[1] = Binary_Pow2(pr, mod2 - 2);
    for (int i = 2; i < N; i++) {
        inv2[i] = (inv2[i - 1] * inv2[1]) % mod1;
    }
    h1[0] = (t[0] - 'a' + 1);
    for (int i = 1; i < n; i++)
        h1[i] = (h1[i - 1] + ((t[i] - 'a' + 1) * p1[i]) % mod1) % mod1;
    h2[0] = (t[0] - 'a' + 1);
    for (int i = 1; i < n; i++)
        h2[i] = (h2[i - 1] + ((t[i] - 'a' + 1) * p2[i]) % mod2) % mod2;
    string s[nn];
    vector<int> sizes;
    for (int i = 0; i < nn; i++) {
        cin >> s[i];
        cnt[s[i].size()]++;
        if (cnt[s[i].size()] == 1) {
            mp[s[i].size()].resize(n, 0ll);
            pref[s[i].size()].resize(n, 0ll);
            sizes.emplace_back((int) s[i].size());
        }
    }
    set<int> st1, st2;
    for (int i = 0; i < nn; i++)
        st1.insert(get_hash(s[i]).first);
    for (int i = 0; i < nn; i++)
        st2.insert(get_hash(s[i]).second);
    for (auto sz: sizes) {
        for (int j = 0; j <= n - sz; j++) {
            if (st1.find(get_sub(j, j + sz - 1).first) != st1.end())
                mp[sz][j] = 1;
            else if (st2.find(get_sub(j, j + sz - 1).second) != st2.end())
                mp[sz][j] = 1;
        }
        pref[sz][0] = mp[sz][0];
        for (int j = 1; j < n; j++)
            pref[sz][j] = pref[sz][j - 1] + mp[sz][j];
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (auto sz: sizes) {
            int left = l, right = r - sz + 1;
            if (right >= left)
                ans += pref[sz][right] - pref[sz][left] + mp[sz][left];
        }
        cout << ans << " ";
    }
    return 0;
}