#include <bits/stdc++.h>
#define ll long long
#define int long long
#define ld long double
#define pii pair <int, int>
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;

const int sz = 5e5 + 5;

ll tree[4 * sz];

void upd(int l, int r, int h, int pos) {
    if (l == r) {
        tree[h]++;
        return;
    }
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    if (pos <= m) {
        upd(l, m, h1, pos);
    }
    else {
        upd(m + 1, r, h2, pos);
    }
    tree[h] = tree[h1] + tree[h2];
}

ll get(int l, int r, int h, int tl, int tr) {
    if (tl <= l && r <= tr) {
        return tree[h];
    }
    if (tr < l || r < tl) {
        return 0;
    }
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    return get(l, m, h1, tl, tr) + get(m + 1, r, h2, tl, tr);
}

struct trie {
    vector <trie*> v;
    vector <int> f;
    trie() {
        v.resize(26, nullptr);
        f.resize(26, 0);
    }

};

void add(trie * root, string & s, int pos) {
    if (root == nullptr) {
//        cout << s << " " << pos << endl;
        return;
    }
//    cout << s << " " << pos  << endl;
//    if (!(((root -> v)[s[pos] - 'a']) == nullptr)) {
//        cout << "aboba" << endl;
//    }
    if (!pos) {
//        cout << s << "  " << s[pos] - 'a' << endl;
        root -> f[s[pos] - 'a'] = 1;
        return;
    }
//    cout << "aboba" << endl;
    if (((root -> v)[s[pos] - 'a']) == nullptr) {
//        cout << s << " " << pos << endl;
        trie* xx = new trie();
        root -> v[s[pos] - 'a'] = xx;
    }
    root = root -> v[s[pos] - 'a'];
    pos--;
    add(root, s, pos);
}

string s;

void rec(trie * root, int pos) {
    int st = pos;
    ll ans = 0;
    while (pos >= 0) {
        ans += root -> f[s[pos] - 'a'];
//        cout << pos << " " << st << " " << root -> f[s[pos] - 'a'] << endl;
        if (root -> f[s[pos] - 'a']) {
            upd(0, sz(s) - 1, 0, pos);
        }
        if (root -> v[s[pos] - 'a'] == nullptr) {
            break;
        }
        root = root -> v[s[pos] - 'a'];
        pos--;
    }
}

struct point {
    int l, r, id;
    friend istream operator >> (istream & is, point & p) {
        is >> p.l >> p.r;
    }
};

bool cmp(point a, point b) {
    return a.r < b.r;
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(0);
//    cout.tie(0);
    trie* root = new trie();
    ll n, m;
    cin >> n >> m;
//    string s;
    cin >> s;
//    vector <point> v(m);
    vector <vector <pii> > v(sz(s));
    for (int i = 0; i < n; i++) {
        string ss;
        cin >> ss;
        add(root, ss, sz(ss) - 1);
    }
    vector <ll> ans(m);
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r; l--; r--;
        v[r].push_back({l, i});
//        cin >> v[i];
//        v[i].id = i;
    }
//    sort    (all(v), cmp);
    for (int i = 0; i < sz(s); i++) {
        rec(root, i);
        for (auto [l, id] : v[i]) {
            ans[id] = get(0, sz(s) - 1, 0, l, i);
        }
    }
    for (auto c : ans) {
        cout << c << " ";
    }
}



