#include <bits/stdc++.h>
#define ll long long
#define int long long
#define ld long double
#define pii pair <int, int>
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;

const int sz = 5e5 + 5;

ll tree[4 * sz];

void upd(int l, int r, int h, int pos, int x) {
    if (l == r) {
        tree[h] += x;
        return;
    }
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    if (pos <= m) {
        upd(l, m, h1, pos, x);
    }
    else {
        upd(m + 1, r, h2, pos, x);
    }
    tree[h] = tree[h1] + tree[h2];
}

ll get(int l, int r, int h, int tl, int tr) {
    if (tl <= l && r <= tr) {
        return tree[h];
    }
    if (tr < l || r < tl) {
        return 0;
    }
    int m = (r + l) / 2, h1 = 2 * h + 1, h2 = 2 * h + 2;
    return get(l, m, h1, tl, tr) + get(m + 1, r, h2, tl, tr);
}

struct trie {
    vector <trie*> v;
    vector <int> f;
    trie() {
        v.resize(26, nullptr);
        f.resize(26, 0);
    }

};

void add(trie * root, string & s, int pos) {
    if (root == nullptr) {
//        cout << s << " " << pos << endl;
        return;
    }
//    cout << s << " " << pos  << endl;
//    if (!(((root -> v)[s[pos] - 'a']) == nullptr)) {
//        cout << "aboba" << endl;
//    }
    if (!pos) {
//        cout << s << "  " << s[pos] - 'a' << endl;
        root -> f[s[pos] - 'a'] = 1;
        return;
    }
//    cout << "aboba" << endl;
    if (((root -> v)[s[pos] - 'a']) == nullptr) {
//        cout << s << " " << pos << endl;
        trie* xx = new trie();
        root -> v[s[pos] - 'a'] = xx;
    }
    root = root -> v[s[pos] - 'a'];
    pos--;
    add(root, s, pos);
}

string s;

void rec(trie * root, int pos) {
    int st = pos;
    ll ans = 0;
    while (pos >= 0) {
        ans += root -> f[s[pos] - 'a'];
//        cout << pos << " " << st << " " << root -> f[s[pos] - 'a'] << endl;
        if (root -> f[s[pos] - 'a']) {
            upd(0, sz(s) - 1, 0, pos, 1);
        }
        if (root -> v[s[pos] - 'a'] == nullptr) {
            break;
        }
        root = root -> v[s[pos] - 'a'];
        pos--;
    }
}

struct point {
    int l, r, id;
    friend istream operator >> (istream & is, point & p) {
        is >> p.l >> p.r;
    }
};

bool cmp(point a, point b) {
    return a.r < b.r;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    trie* root = new trie();
    ll n, m;
    cin >> n >> m;
    cin >> s;
    vector <vector <pii> > v(sz(s));
    if (n <= 100) {
        vector <vector <ll> > pref(sz(s));
        vector <ll> sizes(n);
//        cout << sz(s) << endl;
        for (int t = 0; t < n; t++) {
            string s1;
            cin >> s1;
            sizes[t] = sz(s1);
            string ss = s1;
//            cout << s1 << endl;
            vector <ll> p(sz(s) + sz(ss) + 1);
            for (int i = 1; i < sz(ss); i++) {
                int j = p[i - 1];
                while (j > 0 && ss[i] != ss[j]) {
                    j = p[j - 1];
                }
                if (ss[i] == ss[j]) {
                    j++;
                }
                p[i] = j;
            }
            ss += "#";
            for (int i = sz(ss); i < sz(p); i++) {
                ss += s[i - sz(s1) - 1];
                int j = p[i - 1];
                while (j > 0 && ss[i] != ss[j]) {
                    j = p[j - 1];
                }
                if (ss[i] == ss[j]) {
                    j++;
                }
                p[i] = j;
//                if (j == sz(s1)) {
//                    cout << i << " " <<  i - sz(s1) - j<< endl;
//                    cout << i - sz(s1) - j << endl;
//                    pref[i - sz(s1) - j]++;
//                }
            }
            for (int i = sz(s1) + 1; i < sz(p); i++) {
                pref[t].emplace_back(p[i]);
//                cout << p[i] << " ";
            }
//            cout << endl;
//            cout << s1 << " " << ss << endl;
//            for (int i = 0; i < sz(p); i++) {
//                cout << p[i] << " ";
//            }
//            cout << endl;
        }
        for (int i = 0; i < m; i++) {
            ll l, r;
            cin >> l >> r;
            l--; r--;
            v[r].push_back({l, i});
        }
        vector <ll> ans(m);
//        cout << sz(s) << endl;

        for (int i = 0; i < sz(s); i++) {
            for (int t = 0; t < n; t++) {
                if (sizes[t] == pref[t][i]) {
                    upd(0, sz(s) - 1, 0, i - sizes[t] + 1, 1);
                }
            }
//            upd(0, sz(s) - 1, 0, i, pref[i]);
            for (auto [l, id] : v[i]) {
                ans[id] = get(0, sz(s) - 1, 0, l, i);
            }
        }
        for (auto c : ans) {
            cout << c << " ";
        }
        return 0;
    }

    for (int i = 0; i < n; i++) {
        string ss;
        cin >> ss;
        add(root, ss, sz(ss) - 1);
    }
    vector <ll> ans(m);
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r; l--; r--;
        v[r].push_back({l, i});
//        cin >> v[i];
//        v[i].id = i;
    }
//    sort    (all(v), cmp);
    for (int i = 0; i < sz(s); i++) {
        rec(root, i);
        for (auto [l, id] : v[i]) {
            ans[id] = get(0, sz(s) - 1, 0, l, i);
        }
    }
    for (auto c : ans) {
        cout << c << " ";
    }
}



