#include <bits/stdc++.h>
using namespace std;

#define int long long
#define X first
#define Y second
#define all(x) (x).begin(), (x).end()

const int INF32 = 0x3f3f3f3f;
const int INF64 = 0x3f3f3f3f3f3f3f3f;
const int MOD = 1000000007;
const int k = 31;

const int maxn = 5000000;

int powk[maxn + 1];

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
    }
    powk[0] = 1;
    for (int i = 1; i <= maxn; i++) {
        powk[i] = (powk[i - 1] * k) % MOD;
    }
    vector<int> hashes(t.size() + 1);
    for (int i = 0; i < (int)t.size(); i++) {
        hashes[i + 1] = (hashes[i] + (t[i] - 'a' + 1) * powk[i]) % MOD;
    }
    vector<vector<int>> pos(n);
    for (int i = 0; i < n; i++) {
        int hash = 0;
        for (int j = 0; j < (int)s[i].size(); j++) {
            hash = (hash + (s[i][j] - 'a' + 1) * powk[j]) % MOD;
        }
        hash = (hash * powk[maxn]) % MOD;
        for (int j = 0; j < (int)t.size() - (int)s[i].size() + 1; j++) {
            if ((((hashes[j + (int)s[i].size()] - hashes[j] + MOD) % MOD) * powk[maxn - j]) % MOD == hash) {
                pos[i].push_back(j);
            }
        }
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            ans += upper_bound(all(pos[i]), r - (int)s[i].size() + 1) - lower_bound(all(pos[i]), l);
        }
        cout << ans << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
}