#include <bits/stdc++.h>
#define int long long
#define sz size()
#define vint vector<int>
#define vool vector<bool>
#define f first
#define s second

using namespace std;

int n, m;

vector<int> pref(string& s)
{
    vint p(s.sz);
    for(int i = 1; i < s.sz; i ++)
    {
        int cur = p[i - 1];
        while(cur != 0 && s[i] != s[cur])
            cur = p[cur - 1];
        if(s[i] == s[cur])
            p[i] = cur + 1;
    }
    return p;
}

string t;
const int c = 2236;

vector<int> tree[200010];
vector<int> all[50010];

void build(int v, int l, int r)
{
    if(l == r)
    {
        tree[v] = all[l];
        sort(tree[v].begin(), tree[v].end());
   /*     cout << v << " " << l << " " << l << endl;
        for(int i = 0; i < tree[v].sz; i ++)
            cout << tree[v][i] << " ";
        cout << endl;
      */  return;
    }
    int m = (l + r) / 2;
    build(v * 2, l, m);
    build(v * 2 + 1, m + 1, r);
    merge(tree[v * 2].begin(), tree[v * 2].end(), tree[v * 2 + 1].begin(), tree[v * 2 + 1].end(), back_inserter(tree[v]));
    sort(tree[v].begin(), tree[v].end());
   /* cout << v << " " << l << " " << r << endl;
    for(int i = 0; i < tree[v].sz; i ++)
        cout << tree[v][i] << " ";
    cout << endl;*/
}

int gett(int v, int ll, int rr, int l, int r)
{
    if(ll >= l && rr <= r)
    {
        if(tree[v].sz == 0)
            return 0;
        int k = upper_bound(tree[v].begin(), tree[v].end(), r) - tree[v].begin();
    //    cout << ll << " " << rr << " " << k << endl;
        return k;
    }
    if(ll > r || rr < l)
        return 0;
    if(tree[v].sz == 0)
        return 0;
    int m = (ll + rr) / 2;
    int aaa = gett(v * 2, ll, m, l, r);
    int bbb = gett(v * 2 + 1, m + 1, rr, l, r);
    //cout << ll << " " << rr << " " << aaa + bbb << endl;
    return (aaa + bbb);
}
int32_t main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    cin >> t;
    for(int i = 0; i < n; i ++)
    {
        string s;
        cin >> s;
        string nn = s + "@" + t;
        vint a = pref(nn);
        for(int i = s.sz + 1; i < a.sz; i ++)
        {
            if(a[i] == s.sz)
            {
       //         cout << "! " << i - s.sz - s.sz + 1 << " " << i - s.sz << endl;
                all[i - s.sz - s.sz + 1].push_back(i - s.sz);
            }
        }
    }

    build(1, 0, t.sz);
    while(m --)
    {
        int l, r;
        cin >> l >> r;
        cout << gett(1, 0, t.sz, l, r) << " ";
    }
}