#include <bits/stdc++.h>

#define int long long
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG A.cpp -o A
using namespace std;

vector<int> p; 

vector<int> zf(string a) {
    int n = (int)a.size();
    vector<int> z(n);
    int l = 0, r = 0;
    for (int i = 1; i < n; ++i) {
        if (i <= r && i >= l) z[i] = min(z[i - l], r - i + 1);
        while (i + z[i] < n && a[i + z[i]] == a[z[i]]) z[i]++;
        if (i + z[i] - 1 > r) l = i, r = i + z[i] - 1; 
    }
    return z;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int sz = (int)t.size();
    vector<string> a(n);
    for (auto &i : a) cin >> i;
    vector<vector<int>> idxs(n);

    for (int i = 0; i < n; ++i) {
        string s = a[i] + "#" + t;
        auto z = zf(s);
        for (int j = 0; j < sz; ++j) if (z[j + (int)a[i].size() + 1]== (int)a[i].size()) idxs[i].push_back(j);
        // for (int j = 0; j + (int)a[i].size() <= sz; ++j) {
        //     if (t.substr(j, (int)a[i].size()) == a[i]) 
        // }
    }
    // for (int i = 0; i < n; ++i) {
    //     cerr << a[i] << ": ";
    //     for (auto j : idxs[i]) cerr << j << ' ';
    //     cerr << '\n';
    // }
    // cerr << "SUS\n";
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
         int ans = 0;
        for (int j = 0; j < n; ++j) {
            //cerr << j << ' ';
            int lx = l, rx = r - (int)a[j].size();
            if (rx < lx) continue;
            auto lb = lower_bound(idxs[j].begin(), idxs[j].end(), l);
            auto rb = upper_bound(idxs[j].begin(), idxs[j].end(), r - (int)a[j].size());
            //cerr << (rb - lb) << '\n';
            ans += max(0LL, (int)(rb - lb));
        }
        //cerr << '\n';
        cout << ans << ' ';
    }
}

int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    solve();
    return 0;
}
