#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <deque>
#include <queue>
#include <memory.h>
#include <iomanip>
#include <random>
#include <ctime>
#define int long long
#define pii pair<int,int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define double long double
#define INF 10000000009
#define itn int
#define swpa swap
#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()
using namespace std;

const int N = 100005, R = 1 << 20;

mt19937 rnd(228);

struct Hash {
	int x, y;
	Hash(int a, int b) : x(a), y(b) {}
	Hash() : x(0), y(0) {}
};
Hash P = { 67,73 }, MOD = { (int)(1e9) + 7, (int)(1e9) + 9 };

Hash operator +(Hash a, Hash b) {
	return { (a.x + b.x) % MOD.x, (a.y + b.y) % MOD.y };
}
Hash operator -(Hash a, Hash b) {
	return { (a.x + MOD.x - b.x) % MOD.x, (a.y + MOD.y - b.y) % MOD.y };
}
Hash operator *(Hash a, Hash b) {
	return { (a.x * b.x) % MOD.x, (a.y * b.y) % MOD.y };
}
Hash operator *(Hash a, int b) {
	return { (a.x * b) % MOD.x, (a.y * b) % MOD.y };
}
bool operator == (Hash a, Hash b) {
	return (a.x == b.x && a.y == b.y);
}
bool operator != (Hash a, Hash b) {
	return a.x != b.x || a.y != b.y;
}

vector<Hash> pw(N);
void build_powers() {
	pw[0] = { 1,1 };
	for (int i = 1; i < N; i++)
		pw[i] = pw[i - 1] * P;
} 
vector<Hash> build_hash(string& s) {
	s = '&' + s;
	vector<Hash>hs(s.size());
	for (itn i = 1; i < (int)(s.size()); i++)
		hs[i] = hs[i - 1] + pw[i] * s[i];
	return hs;
}

Hash get_hash(vector<Hash>& hs, int l, int r) {
	return hs[r] - hs[l - 1];
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(17);
	srand(time(0));
	
	int n, m;
	cin >> n >> m;

	build_powers();

	string t;
	cin >> t;
	vector<Hash> main = build_hash(t);
	vector<string> vc(n);
	for (auto& i : vc)
		cin >> i;
	vector<Hash> hs(n);
	map<pii, int> mp;
	for (auto i = 0; i < n; i++) {
		vector<Hash> kok = build_hash(vc[i]);
		hs[i] = kok.back() * pw[(int)(main.size())];
		mp[{hs[i].x, hs[i].y}]++;
	}
	while (m--) {
		int l, r;
		cin >> l >> r;
		
		int ans = 0;
		for (itn i = l; i <= r; i++) {
			for (int j = i; j <= r; j++) {
				if (i == j && i == 5)
					int kmgrt = 0;
				Hash a = get_hash(main, i, j) * pw[(int)(main.size()) - i + 1];
				if (mp.find({ a.x,a.y }) != mp.end())
					ans++;
			}
		}
		cout << ans << " ";
	}
	return 0;
}
