#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/t_policy.hpp>

using namespace std;
//using namespace __gnu_pbds;

#define int long long

typedef long double ld;
typedef long long ll;
//#define oset tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>


const ll INF = 1e18 + 2, MOD = 1e9 + 123, N = 5001, K = 20, bs = 179;
mt19937 rnd(time(0));

struct hs {
    vector<int> pref, p;

    hs(string s) {
        int n = s.size();
        pref.assign(n + 1, 0);
        p.assign(n + 1, 1);
        for (int i = 1; i <= n; i++) {
            p[i] = (p[i - 1] * bs) % MOD;
            pref[i] = (pref[i - 1] * bs + s[i - 1]) % MOD;
        }
    }

    int geth(int l, int r) {
        int h = ((pref[r] - pref[l - 1] * p[r - l + 1]) % MOD + MOD) % MOD;
        return h;
    }
};

bool cmp(string& s1, string& s2) {
    return s1.size() < s2.size();
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    hs th = hs(t);
    vector<string> a(n);
    vector<hs> ah;
    vector<vector<int>> pref(n, vector<int>(t.size() + 1));
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    sort(a.begin(), a.end(), cmp);
    for (int i = 0; i < n; i++) {
        ah.push_back(hs(a[i]));
        int k = a[i].size();
        for (int j = 0; j + k <= t.size(); j++) {
            if (ah[i].geth(1, k) == th.geth(j + 1, j + k))
                pref[i][j + k]++;
        }
        for (int j = 1; j <= t.size(); j++) {
            if (i != 0)
                pref[i][j] += pref[i - 1][j];
        }
    }
    vector<int> mxi(t.size() + 1, -1);
    int cur = 0;
    for (int i = 1; i <= t.size(); i++) {
        while (cur < n && a[cur].size() <= i)
            cur++;
        mxi[i] = cur;
    }
    vector<vector<int>> dp(N, vector<int> (N));
    for (int k = 0; k < t.size(); k++) {
        for (int i = 1; i + k <= t.size(); i++) {
            dp[i][i + k] = dp[i][i + k - 1];
            if (mxi[k + 1] != 0)
                dp[i][i + k] += pref[mxi[k + 1] - 1][i + k];
        }
    }

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        cout << dp[l][r] << " ";
    }

}

signed main() {
//    set<int> s;
//    s.insert(1);
//    s.insert(2);
//    auto it = s.end();
//    it = prev(it, 1);
//    cout << *it << endl;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int _ = 1;
//    cin >> _;
    while (_--) {
        solve();
    }
    return 0;
}