#include <iostream>
#include <bits/stdc++.h>
#define int long long

using namespace std;

const int mod = 1e9 + 7, k = 179, mod2 = 1e9 + 9, k2 = 41;

vector<int> hashes, st, hashes2, st2;

void calc(string &t){
    int hash = 0, hash2 = 0;
    for (auto c : t){
        int sym = (c - 'a' + 1);
        hash = (hash * k + sym) % mod;
        hashes.push_back(hash);

        hash2 = (hash2 * k2 + sym) % mod2;
        hashes2.push_back(hash2);
    }
}

pair<int, int> get(int l, int r){
    if (l == 0) return {hashes[r], hashes2[r]};
    int w1 = ((hashes[r] - (hashes[l - 1] * st[r - l + 1]) % mod) % mod + mod) % mod;
    int w2 = ((hashes2[r] - (hashes2[l - 1] * st2[r - l + 1]) % mod2) % mod2 + mod2) % mod2;
    return {w1, w2};
}


signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    int main_size = (int) t.size();

    st.assign(main_size + 1, 0);
    st[0] = 1;
    for (int i = 1; i <= main_size; i ++){
        st[i] = (st[i - 1] * k) % mod;
    }

    st2.assign(main_size + 1, 0);
    st2[0] = 1;
    for (int i = 1; i <= main_size; i ++){
        st2[i] = (st2[i - 1] * k2) % mod2;
    }

    calc(t);

    if (true){
        set<int> lens;
        set<pair<int, int>> h;
        string s;

        for (int i = 0; i < n; i++) {
            int hash = 0, hash2 = 0;
            cin >> s;
            for (auto c: s) {
                int pos = (c - 'a' + 1);
                hash = (hash * k + pos) % mod;
                hash2 = (hash2 * k2 + pos) % mod2;
            }
            h.insert({hash, hash2});
            lens.insert((int) s.size());
        }
        vector<int> dif;
        for (auto l : lens) dif.push_back(l);
        const int SQRT = (int)dif.size();
        vector<vector<int>> find(SQRT, vector<int>(main_size, 0));

        for (int j = 0; j < SQRT; j ++){
            int l = dif[j];
            for (int i = 0; i <= main_size - l; i ++){
                if (h.find(get(i, i + l - 1)) != h.end()){
                    find[j][i] = 1;
                }
            }
        }
        for (int i = 0; i < SQRT; i++) {
            for (int j = 0; j < main_size; j++) {
                find[i][j] += (j == 0 ? 0 : find[i][j - 1]);
            }
        }

        for (int i = 0; i < m; i++) {
            int l, r;
            cin >> l >> r;
            l--, r--;
            int ans = 0;
            for (int j = 0; j < SQRT; j++) {
                int rik = r - dif[j] + 1;
                if (l > rik) continue;
                ans += find[j][rik] - (l == 0 ? 0 : find[j][l - 1]);
            }
            cout << ans << " ";
        }
        return 0;
    }

    /*
    vector<vector<int>> find(n, vector<int>(main_size, 0));
    vector<int> len(n);
    string s;

    for (int i = 0; i < n; i++) {
        int hash = 0;
        cin >> s;
        for (auto c: s) {
            int pos = (c - 'a' + 1);
            hash = (hash * k + pos) % mod;
        }
        len[i] = (int) s.size();


        for (int j = 0; j <= main_size - len[i]; j++) {
            if (get(j, j + len[i] - 1) == hash) {
                find[i][j] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < main_size; j++) {
            find[i][j] += (j == 0 ? 0 : find[i][j - 1]);
        }
    }

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int j = 0; j < n; j++) {
            int rik = r - len[j] + 1;
            if (l > rik) continue;
            ans += find[j][rik] - (l == 0 ? 0 : find[j][l - 1]);
        }
        cout << ans << " ";
    }*/
}

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5

 */