#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const ll MOD = 1e9 + 7;
const ll P = 31;

int count(vector<ll>& mc, int i) {
    auto bg = upper_bound(mc.begin(), mc.end(), i);
    auto fr = lower_bound(mc.begin(), mc.end(), i);
    if (fr != mc.end() && *fr == i) {
        return bg - fr;
    } else {
        return 0;
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;

    vector<ll> mc;
    while (n--) {
        string x;
        cin >> x;
        ll h = 0;
        for (auto y : x) {
            h *= P;
            h += (y - 'a' + 1);
            h %= MOD;
        }

        mc.push_back(h);
    }
    sort(mc.begin(), mc.end());


    n = t.size();
    vector<vector<ll>> ans(n, vector<ll>(n));
    for (int i = 0; i < n; ++i) {
        ll now = 0;
        for (int j = i; j < n; ++j) {
            now = (now * P + (t[j] - 'a' + 1));
            now %= MOD;
            ans[i][j] += count(mc, now);
        }
    }

    for (int i = n - 1; i >= 0; --i) {
        for (int k = 1; k < n; ++k) {
            ans[i][k] += ans[i][k - 1];
        }
    }

    vector<vector<ll>> pref(n, vector<ll>(n));
    for (int i = 0; i < n; ++i) {
        pref[0][i] = ans[0][i];
    }
    for (int i = 1; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            pref[i][j] = pref[i - 1][j] + ans[i][j];
        }
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        --l;
        --r;

        ll ans1 = pref[r][r];
        if (l - 1 >= 0) {
            ans1 -= pref[l - 1][r];
        }
        cout << ans1 << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}