#include <bits/stdc++.h>

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

const ll INF = 1791791797, p = 179;
const int N = 750001, M = 1e5 + 1, Q = 5e5;
const ld EPS = 1e-6;

ll pf[N], pw[N];
vector<ll> pod[M];
vector<int> flex[N];
vector<pair<int, int>> req[N];
int ans[Q], fen[N], k;

void add(int i) {
    for (; i <= k; i |= (i + 1)) fen[i]++;
}

int get(int i) {
    int res = 0;
    for (; i > -1; i = (i & (i + 1)) - 1) res += fen[i];
    return res;
}


ll get(int l, int r) {
    ll res = pf[r] - pf[l] * pw[r - l] % INF;
    if (res < 0) res += INF;
    return res;
}

int main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    string t;
    cin >> n >> m >> t;
    pw[0] = 1;
    k = t.size();
    for (int i = 1; i <= k; i++) pw[i] = pw[i - 1] * p % INF;
    pf[0] = 0;
    for (int i = 0; i < k; i++)
        pf[i + 1] = (pf[i] * p + t[i]) % INF;
    for (int i = 0; i < n; i++) {
        cin >> t;
        ll now = 0;
        for (auto j : t) now = (now * p + j) % INF;
        pod[t.size()].push_back(now);
    }
    unordered_set<ll> st;
    st.max_load_factor(0.2);
    for (int len = 1; len <= k; len++) {
        if (pod[len].empty()) continue;
        st.clear();
        st.reserve(pod[len].size());
        for (auto j : pod[len]) st.insert(j);
        for (int i = 0; i <= k - len; i++) {
            if (st.find(get(i, i + len)) != st.end()) flex[i].push_back(i + len);
        }
    }
    for (int i = 0; i < m; i++) {
        ans[i] = 0;
        int l, r;
        cin >> l >> r;
        req[l - 1].emplace_back(r, i);
        req[r].emplace_back(r, i);
    }
    for (int i = 0; i <= k; i++) fen[i] = 0;
    for (int i = 0; i <= k; i++) {
        for (auto j : req[i]) {
            if (j.first > i) ans[j.second] -= get(j.first);
            else ans[j.second] += get(j.first);
        }
        for (auto j : flex[i]) add(j);
    }
    for (int i = 0; i < m; i++) cout << ans[i] << ' ';
}