#include <bits/stdc++.h>
#include <bits/extc++.h>

#include <random>

//#define int long long
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 9e5 + 7;

int suff_arr[N];
int lcp[N];
int fenw[N];

void add(int i) {

    for (; i < N; i += i &-i) {
        fenw[i]++;
    }
}

int get(int i) {
    int ans = 0;
    for (; i > 0; i -= i &-i) {
        ans += fenw[i];
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    string s = t;
    unordered_map<string, int> inds;
    for (int i = 0; i < n; ++i) {
        string r;
        cin >> r;
        s.push_back('#');
        inds[r] = s.size();
        s += r;
    }
    s.push_back('#');
//    cout << s << endl;
    for (int i = 0; i < s.size(); ++i) {
        suff_arr[i] = i;
    }
    sort(suff_arr, suff_arr + s.size(), [&](int a, int b) {
        int ind = 0;
        while (true) {
            if (a + ind >= s.size()) return true;
            if (b + ind >= s.size()) return false;
            if (s[a + ind] < s[b + ind]) return true;
            if (s[a + ind] > s[b + ind]) return false;
            ind++;
        }
    });
//    for (int i = 0; i < s.size(); ++i) {
//        cout << suff_arr[i] << " ";
//    }
//    cout << endl;
    n = s.size();
    for (int i = 0; i < n - 1; ++i) {
        int now = 0;
        while (now + suff_arr[i] < n and now + suff_arr[i + 1] < n and
               s[now + suff_arr[i]] == s[now + suff_arr[i + 1]]) {
            now++;
        }
        lcp[i] = now;
    }
//    for (int i = 0; i < n; ++i) {
//        cout << lcp[i] << ' ';
//    }
//    cout << endl;
    vector<int> obr(n);
    for (int i = 0; i < n; ++i) {
        obr[suff_arr[i]] = i;
    }
    vector<vector<int>> quers(n + 1);
    for (auto& c: inds) {
        int ind = obr[c.second];
        int ind2 = ind;
//        cout << c.first << " " << ind << endl;
        while (ind2 < n - 1 and lcp[ind2] >= c.first.size()) {
            quers[suff_arr[ind2 + 1] + c.first.size()].push_back(suff_arr[ind2 + 1] + 1);
            ind2++;
        }
        int ind3 = ind - 1;
        while (ind3 >= 0 and lcp[ind3] >= c.first.size()) {
//            cout <<"lll " << suff_arr[ind3] << endl;
            quers[suff_arr[ind3] + c.first.size()].push_back(suff_arr[ind3] + 1);
            ind3--;
        }
    }
    vector<vector<pair<int, int>>> quer2(n + 1);
    for (int j = 0; j < m; ++j) {
        int l, r;
        cin >> l >> r;
        quer2[r].push_back({l, j});
    }
    vector<int> ans(m);
    int cnt = 0;
    for (int i = 1; i <= n; ++i) {
//        cout << i << endl;
        for (auto c : quers[i]) {
            cnt++;
//            cout << c << " " << i << endl;
//            if (c == 1)
            add(c);
        }
        for (auto c : quer2[i]) {
            ans[c.second] = cnt - get(c.first - 1);
        }
    }
    for (auto c : ans) {
        cout << c << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed;
    cout.precision(12);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}