#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <fstream>

using namespace std;

#define ll long long
#define eps 1e-10
#define inf 1e15
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

#ifdef LOCAL_BOBER
#define preproc ifstream fl("sample.io")
#define cin fl
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr);
#else
#define preproc ;
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr); cin.tie(nullptr);
#endif

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

struct node {
	map<char, node*> mp;
	ll add = 0;

	void add_f(string& s, int i) {
		if (i == s.size()) {
			this->add++;
			re;
		}

		if (mp[s[i]] == nullptr)
			mp[s[i]] = new node();

		mp[s[i]]->add_f(s, i + 1);
	}

	ll cnt(string& s, int i) {
		if (i == s.size())re add;

		if (mp[s[i]] == nullptr)re add;

		re add + mp[s[i]]->cnt(s, i + 1);
	}
};

node* bor = new node();

int main() {
	preproc; fast_io;

	int n, m; cin >> n >> m;
	string t; cin >> t;
	fori(n) {
		string a; cin >> a;
		bor->add_f(a, 0);
	}

	while (m--) {
		ll l, r; cin >> l >> r;
		string q = t.substr(l - 1, r - l + 1);

		ll ans = 0;
		fori(q.size()) {
			ans += bor->cnt(q, i);
		}
		cout << ans << " ";
	}
}