#include <bits/stdc++.h>

using namespace std;
using ll = long long;

constexpr int N = 2e5 + 1, M = 2e5 + 1;

int n, m, bit, a, b;

int Weight[M];

inline int w(int i) {
    return Weight[i] >> bit & 1;
}

vector<pair<int, int>> adj[N], rev[N];

vector<int> ord;

bool used[N];

void dfs_ord(int v) {
    used[v] = true;

    for (auto [to, i] : adj[v]) {
        if (!used[to]) {
            dfs_ord(to);
        }
    }

    ord.push_back(v);
}

bool yay = true;

int cnt_b[N], dp_b[N];

int stupid_dp() {
    for (int x : ord) {
        cnt_b[x] = dp_b[x] = 0;

        if (x == b) {
            cnt_b[x] = 1;
            continue;
        }

        for (auto [to, i] : adj[x]) {
            cnt_b[x] ^= cnt_b[to];
            dp_b[x] ^= dp_b[to];

            if (cnt_b[to]) {
                dp_b[x] ^= w(i);
            }
        }
    }

    return dp_b[a];
}

int cana[N][2], canb[N][2];

int solve_bit() {
    return stupid_dp();
}

void solve() {
    yay = true;
    cin >> n >> m;

    for (int i = 0; i < n; ++i) {
        adj[i].clear(), rev[i].clear();
    }

    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v >> Weight[i];
        u -= 1, v -= 1;

        adj[u].emplace_back(v, i);
        rev[v].emplace_back(u, i);
    }

    cin >> a >> b;
    a -= 1, b -= 1;

    memset(used, 0, sizeof(used[0]) * n);

    ord.clear();
    dfs_ord(a);
//    reverse(ord.begin(), ord.end());

    if (find(ord.begin(), ord.end(), b) == ord.end()) {
        cout << "0\n";
        return;
    }

    int A = __lg(*max_element(Weight, Weight + m));

    int ans = 0;

    for (bit = 0; bit <= A && yay; ++bit) {
        if (solve_bit()) {
            ans += 1 << bit;
        }
    }

    if (!yay) {
        cout << "-1\n";
        return;
    }

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int test = 1;
    cin >> test;

    while (test--) {
        solve();
    }

    return 0;
}
