#include <bits/stdc++.h>

using namespace std;

#define int long long

const int MAXN = 2e5;

vector <pair <int, int>> g[MAXN];

bool used[MAXN];

vector <int> order;

void dfs(int v) {
    used[v] = true;
    for (auto [to, w] : g[v]) {
        if (!used[to])
            dfs(to);
    }
    order.push_back(v);
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m, ans1 = 0, ans2 = 0;
        cin >> n >> m;
        bool flag = true;
        vector <int> u(m), v(m), w(m);
        for (int i = 0; i < n; ++i) {
            used[i] = false;
            g[i].clear();
        }
        order.clear();
        for (int i = 0; i < m; ++i) {
            cin >> u[i] >> v[i] >> w[i];
            --u[i];
            --v[i];
            g[u[i]].push_back({v[i], w[i]});
            g[v[i]].push_back({u[i], w[i]});
            if (u[i] >= v[i])
                flag = false;
        }
        int a, b;
        cin >> a >> b;
        --a;
        --b;
        if (!flag) {
            if (a > b)
                swap(a, b);
            if (a == b) {
                int ans = 0;
                for (int i = 0; i < n; ++i)
                    ans ^= w[i];
                if (ans == 0) {
                    cout << 0 << '\n';
                } else {
                    cout << -1 << '\n';
                }
            } else {
                for (int i = a; i < b; ++i)
                    ans1 ^= w[i];
                for (int i = b; i < n; ++i)
                    ans2 ^= w[i];
                for (int i = 0; i < a; ++i)
                    ans2 ^= w[i];
                if (ans1 == 0 && ans2 == 0) {
                    cout << 0 << '\n';
                } else {
                    cout << -1 << '\n';
                }
            }
            continue;
        }
        dfs(a);
        reverse(order.begin(), order.end());
        vector <int> cnt(n, 0), dp(n, 0);
        cnt[a] = 1;
        for (int v : order) {
            for (auto [to, w] : g[v]) {
                if (cnt[v] % 2)
                    dp[to] = (dp[to] ^ dp[v] ^ w);
                cnt[to] += cnt[v];
            }
        }
        cout << dp[b] << '\n';
    }
    return 0;
}
