#define _GLIBCXX_DEBUG

#include <iostream>
#include <cstdio>
#include <cstdlib>
#include <vector>
#include <cassert>
#include <functional>
#include <set>
#include <algorithm>
#include <map>
#include <random>
#include <chrono>

using namespace std;

int main(){
    int TTQ;
    cin >> TTQ;
    for (int qqqq = 0; qqqq < TTQ; qqqq++){
        int n, m;
        cin >> n >> m;
        vector<vector<pair<int, uint32_t>>> neib(n);
        for (int i = 0; i < m; i++){
            int u, v;
            uint32_t w;
            cin >> u >> v >> w;
            neib[u - 1].emplace_back(v - 1, w);
            neib[v - 1].emplace_back(u - 1, w);
        }
        int A, B;
        cin >> A >> B;
        A--;
        B--;

        function<pair<uint32_t, uint32_t>(int, int)> pp = [&](int F, int T) -> pair<uint32_t, uint32_t>{
            vector<bool> used(n, false);
            function<uint32_t(int, uint32_t, int)> biba = [&](int v, uint32_t pw, int dest) -> uint32_t{
                if (v == dest){
                    return pw;
                }
                used[v] = true;
                for (auto [u, w] : neib[v]){
                    if (!used[u]){
                        return biba(u, pw ^ w, dest);
                    }
                }
                return 0;
            };
            assert(F != T);
            uint64_t P1 = biba(F, 0, T);
            uint64_t P2 = biba(F, 0, T);
            return {P1, P2};
        };
        if (n == 1){
            ::printf("0\n");
        } else if (A == B){
            auto [d1, d2] = pp(0, 1);
            if ((d1 ^ d2) == 0){
                ::printf("0\n");
            } else {
                printf("-1\n");
            }
        } else {
            auto [d1, d2] = pp(A, B);
            if (d1 == 0 && d2 == 0){
                printf("0\n");
            } else {
                printf("-1\n");
            }
        }
    }
    return 0;
}
