#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n, m;
    cin >> n >> m;
    bool flag = false;
    vector <vector <pair<ll, pair<ll, ll>>> > g(n);
    for (ll i = 0; i < m; ++i) {
        ll s, f, l;
        cin >> s >> f >> l;
        s--; f--;
        g[s].push_back({ f, {l, 0} });
    }
    ll st, fn; cin >> st >> fn;
    st--;
    fn--;
    queue <pair<ll, ll>> q;
    q.push({ st , 0ll });
    vector <pair<ll, ll>> par(n, { -1, -1 });
    while (!q.empty()) {
        auto now = q.front();
        q.pop();
        for (auto i : g[now.first]) {
            if (i.first == fn) {
                ll ts = now.second ^ i.second.first;
                cout << ts << endl;
                return;
            }
            q.push({ i.first, now.second ^ i.second.first });
        }
    }
    cout << 0 << endl;
}
int main()
{
    FAST();
    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
    }
}
