#include <bits/stdc++.h>

#include <utility>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

template<typename T>
std::ostream &operator<<(std::ostream &out, std::vector<T> &a) {
    for (auto &el: a)
        out << el << ' ';
    return out;
}

template<typename T>
std::istream &operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &el: a)
        in >> el;
    return in;
}

template<typename T1, typename T2>
std::istream &operator>>(std::istream &in, std::pair<T1, T2> &a) {
    in >> a.first >> a.second;
    return in;
}

typedef long long ll;
typedef long double ld;
using namespace std;

const int maxn = 2e5 + 1;
vector<pair<int, int>> g[maxn];
int n, m;

void clear() {
    for (int i = 0; i < n; ++i)
        g[i].clear();
}
void solve() {
    cin >> n >> m;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w, --u, --v;
        g[u].emplace_back(v, w);
    }

    int a, b;
    cin >> a >> b, --a, --b;
    vector<map<int, int>> vals(n);
    vals[a][0]++;
    for (int i = 0; i < n; ++i) {
        for (auto [to, w] : g[i]) {
            for (auto &el : vals[a]) {
                vals[to][el.first^w]+=el.second;
            }
        }
    }

    int ans = 0;
    for (auto &el : vals[b]) {
        if (el.second % 2 == 1)
            ans ^= el.first;
    }
    cout << ans << '\n';
    clear();
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int T; cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}