#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define endl '\n'
#define len(a) (int)a.size()
#define f first
#define s second

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const int MAXI = 1e9 + 1e7;

const int MAXN = 2e5 + 100;

vector<pair<int, int> > out[MAXN], in[MAXN];
vector<int> top_sort;
bool used[MAXN];

void dfs(int u) {
    used[u] = true;
    for (auto [v, w] : out[u]) {
        if (!used[v])
            dfs(v);
    }
    top_sort.push_back(u);
}

void init(int n) {
    fill(in, in + n, vector<pair<int, int> >(0));
    fill(out, out + n, vector<pair<int, int> >(0));
    fill(used, used + n, false);
    top_sort.clear();
}

int main() {
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        init(n);
        vector<tuple<int, int, int> > edge;
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            edge.emplace_back(u - 1, v - 1, w);
            out[u - 1].emplace_back(v - 1, w);
            in[v - 1].emplace_back(u - 1, w);
        }
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        dfs(a);
        vector<int> from_a(n), to_b(n);
        from_a[a] = 1, to_b[b] = 1;
        for (int u : top_sort) {
            for (auto [v, w] : out[u])
                to_b[u] ^= to_b[v];
        }
        reverse(all(top_sort));
        for (int u : top_sort) {
            for (auto [v, w] : in[u])
                from_a[u] ^= from_a[v];
        }
        int ans = 0;
        for (auto [u, v, w] : edge)
            ans ^= w * ((from_a[u] * to_b[v]) % 2);
        cout << ans << endl;
    }
}
