#define pii pair < int, int >
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;

const int N = (int)2e5 + 5;
const int MOD = (int)1e9 + 7;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

vector < pii > g[N];

int dfs(int a, int b, int now) {
    if (a == b) {
        return now;
    }
    for (auto to: g[a]) {
        return dfs(to.first, b, (now ^ to.second));
    }
}

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output1.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int q;
    cin >> q;
    while (q--) {
        int n, m;
        cin >> n >> m;
        int xr = 0;
        for (int i = 1; i <= n; i++) {
            g[i].clear();
        }
        for (int i = 1; i <= m; i++) {
            int u, v, cost;
            cin >> u >> v >> cost;
            g[u].push_back({ v, cost });
            xr ^= cost;
        }
        int a, b;
        cin >> a >> b;
        int val = dfs(a, b, 0);
        if (val == 0 && xr == 0) {
            cout << 0 << '\n';
            continue;
        }
        cout << -1 << '\n';
    }
    return 0;
}
