#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);
const int MOD = (int)(1e9 + 7);



ll n, m;
const ll MAXN = 2e5 + 2;
vector<pair<ll, ll>> g[MAXN], rev_g[MAXN];
ll a, b;

ll get_less_rebr() {
    vector<ll> cnt1(n + 1, 0);
    vector<ll> cnt2(n + 1, 0);
    
    cnt1[a] = 1;

    for (ll i = a; i < b; ++i) {
        for (auto j : g[i]) {
            if (j.first > b) continue;

            cnt1[j.first] += cnt1[i];
        }
    }

    cnt2[b] = 1;

    for (ll i = b; i > a; --i) {
        for (auto j : rev_g[i]) {
            if (j.first < a) continue;

            cnt2[j.first] += cnt2[i];
        }
    }

    ll ans = 0;

    for (ll i = a; i < b; ++i) {
        for (auto j : g[i]) {
            if (cnt1[i] % 2 && cnt2[j.first] % 2) {
                ans ^= j.second;
                // cout << "! " << j.second << endl;
            }
        }
    }

    return ans;
}

void solve() {
    cin >> n >> m;

    bool flag = true;

    for (ll i = 0; i < m; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;

        if (u >= v) {
            flag = false;
        }

        g[u].push_back({v, w});
        rev_g[v].push_back({u, w});
    }
    cin >> a >> b;

    if (flag) {
        cout << get_less_rebr() << '\n';
    }



    for (ll i = 1; i <= n; ++i) {
        g[i].clear();
        rev_g[i].clear();
    }
}

signed main() {
    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}

// cd "d:\open_olympiad\" ; if ($?) { g++ main.cpp -o main } ; if ($?) { .\main } 
/*

1
6 6
1 3 1
3 4 2
4 6 4
1 2 8     
2 5 16
5 6 32
1 6

*/