#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define int long long
#define all(x) (x).begin(), (x).end()

struct SegmentTree {
    struct Node {

    };
    vector<Node> tree;
    int size;

    void init(int n) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.resize(2 * size - 1, {});
    }

    Node combine(Node a, Node b) {

    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = {};
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            set(i, v, 2 * x + 1, lx, m);
        } else {
            set(i, v, 2 * x + 2, m, rx);
        }
    }

    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }

    Node get(int l, int r, int x, int lx, int rx) {
        // l lx rx r
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        // l r lx rx
        // lx rx l r
        if (lx >= r || l >= rx) {
            return {};
        }
        int m = (lx + rx) / 2;
        auto left = get(l, r, 2 * x + 1, lx, m);
        auto right = get(l, r, 2 * x + 2, m, rx);
        return combine(left, right);
    }

    Node get(int l, int r) {
        return get(l, r, 0, 0, size);
    }
};

struct Vector {
    int x, y;

    Vector() = default;

    Vector(int x, int y) : x(x), y(y) {}

    Vector operator-(Vector ot) {

    }
};

long long cross_product(Vector a, Vector b) {
    return a.x * b.y - a.y * b.x;
}

long long dot_product(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

int32_t main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int tt;
    cin >> tt;
    while (tt--) {
        int n, m;
        cin >> n >> m;
        assert(n == m);
        vector<int> w(n);
        int all_xor = 0;
        for (int i = 0; i < m; i++) {
            int fr, to, ww;
            cin >> fr >> to >> ww;
            w[i] = ww;
            all_xor ^= ww;
        }
        int a, b;
        cin >> a >> b;
        a--;
        b--;
        int xor1 = 0;
        int v = a;
        while (v != b) {
            xor1 ^= w[v];
            v++;
            v %= n;
        }
        if (a == b) {
            xor1 = 0;
        }
        if ((all_xor ^ xor1) == 0) {
            cout << xor1 << '\n';
        } else {
            cout << -1 << '\n';
        }
    }
    return 0;
}