#include<iostream>
#include<vector>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_set>
#include<unordered_map>
#include<queue>
#include<deque>
#include<stack>
#include<string>
#include<cmath>
#include<climits>
#include<random>
#include<bitset>
#include<ctime>

#define ft first
#define sd second
#define mp make_pair
#define pb push_back

using namespace std;

using ll = long long;
using ii = pair<int, int>;
using ld = long double;

int a, b;

vector<vector<ii>> g(0);
vector<vector<ii>> t(0);

vector<set<int>> g1(0);


vector<int> tout(0);
vector<int> used(0);
vector<int> color(0);
vector<bool> good(0);
vector<int> way(0);

int timer = 0;

void dfs (int now) {
   // cout << now << '\n';
    if (used[now])
        return;
    used[now] = true;
    timer++;
    for (auto j : g[now]) {
        dfs(j.ft);
        timer++;
    }
    tout[now] = timer;
    timer++;

}

vector<int> way_to_a(0);

bool cmp (int i, int j) {
    return tout[i] > tout[j];
}

void dfs_color (int now, int c1) {
    if (used[now])
        return;
    color[now] = c1;
    used[now] = true;
    for (auto j : t[now]) {
        dfs_color(j.ft, c1);
    }
}

void dfs1 (int now, int in, int len) {
    if (len != 0)
        good[in] = false;
    if (used[now]) {
        return;
    }
    used[now] = true;
    for (auto j : g[now]) {
        if (color[j.ft] != in)
            continue;
        dfs1(j.ft, in, j.sd ^ len);
        if (!good[in])
            return;
    }
}
bool x;
void find_a (int now) {
    if (used[now])
        return;
    if (now == color[b]) {
        x = true;
        return;
    }
    for (auto j : g1[now]) {
        way_to_a.pb(j);
        find_a(j);
        if (x) {
            return;
        }
        way_to_a.pop_back();
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    t.assign(n, {});
    tout.assign(n, 0);
    vector<pair<ii, int>> all(0);

    int cor1 = 0;
    int w2[n];
    w2[0] = 0;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        all.pb(mp(mp(u - 1, v - 1), w));
        g[u - 1].pb(mp(v - 1, w));
        t[v - 1].pb(mp(u - 1, w));
        cor1 ^= w;
        w2[(i + 1) % m] = cor1;
    }
    used.assign(n, false);
    color.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i);
    }

    vector<int> order(n);
    for (int i = 0; i < n; i++) {
        order[i] = i;
    }
    sort(order.begin(), order.end(), cmp);
    used.assign(n, false);
    int cnt = 0;
    vector<int> main_in(0);
    for (auto j : order) {
        if (!used[j]) {
            color[j] = cnt;
            main_in.pb(j);
            cnt++;
            dfs_color(j, color[j]);
        }
    }
    //cout << cnt << endl;
    good.assign(n, true);
    way.assign(n, 0);
    used.assign(n, false);
    for (int i = 0; i < 1; i++) {
        dfs1(0, i, 0);
    }
    cin >> a >> b;
    a--; b--;
    //cout << color[a - 1] << " " << color[b - 1] << " " << good[0] << " " << good[1] << " " << main_in[0] << " " << main_in[1] << endl;
    //cout << a << " " << b << " " << good.size() << " " << way.size() << " " << good[0] << endl;
    cout.precision(20);
    g1.assign(cnt, {});
    map<ii, vector<int>> m1;
    for (int i = 0; i < all.size(); i++) {
        if (color[all[i].ft.ft] != color[all[i].ft.sd]) {
            g1[color[all[i].ft.ft]].insert(color[all[i].ft.sd]);
            m1[mp(color[all[i].ft.ft], color[all[i].ft.sd])].push_back(all[i].sd);
        }
    }
    way_to_a.assign(1, color[a]);
    used.assign(n, false);
    x = false;
    find_a(color[a]);
    if (!x) {
        cout << 0 << '\n';
        return;
    }
    int dp = 0;
    if (!good[color[a]]) {
        cout << -1 << '\n';
        return;
    }
    for (int i = 1; i < way_to_a.size(); i++) {
       // cout << way_to_a[i] << endl;
        if (!good[way_to_a[i]]) {
            cout << -1 << '\n';
            return;
        } else {
            int dp1 = 0;
            for (auto j : m1[mp(way_to_a[i - 1], way_to_a[i])]) {
                dp1 = dp1 ^ (dp ^ j);
            }
            dp = dp1;
        }
    }
    cout << dp <<  '\n';
    return;
    if ((cor1) || (w2[a - 1] != w2[b - 1])) {
        cout << -1 << '\n';
    } else {
        cout << 0 << '\n';
    }
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    int tt;
    cin >> tt;
    while (tt--)
        solve();
    return 0;
}