#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

using namespace std;

struct el{
    int b, e, w;
    el () {}
    el(int b, int e, int w) {
        this->b = b;
        this->e = e;
        this->w = w;
    }
};

void sol() {
    int n, m;
    cin >> n >> m;
    vector<el> v(m);
    vector<vector<vector<int>>> dist(2, vector<vector<int>>(n));
    for (int i = 0; i < m; i++) {
        int b, e, w;
        cin >> b >> e >> w;
        b--;
        e--;
        v[i] = el(b, e, w);
    }
    int a, f;
    cin >> a >> f;
    a--;
    f--;
    dist[0][a].push_back(0);
    int id = 0;
    int res = 0;
    for (int i = 0; i < n + 1; i++) {
        for (int j = 0; j < n; j++) {
            for (int k = 1; k < dist[id][j].size(); k++) {
                dist[id][j][0] = (dist[id][j][0] ^ dist[id][j][k]);
            }
            while (dist[id][j].size() > 1) {
                dist[id][j].pop_back();
            }
        }
        for (int j = 0; j < m; j++) {
            auto [b, e, w] = v[j];
            if (dist[id][b].size() != 0) {
                for (auto x : dist[id][b]) {
                    dist[(id + 1) % 2][e].push_back(x ^ w);
                }
            }

        }
        /*for (int i = 0; i < n; i++) {
            cout << i << " : ";
            for (auto x : dist[id][i]) {
                cout << x << " ";
            } cout << endl;
        } cout << endl;*/
        for (auto x : dist[id][f]) {
            res = (res ^ x);
        }
        for (int j = 0; j < n; j++) {
            dist[id][j].clear();
        }

        id = (id + 1) % 2;
    }
    cout << res << endl;
    return;
    /*int res1 = res;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            auto [b, e, w] = v[j];
            if (dist[id][b].size() != 0) {
                for (auto x : dist[id][b]) {
                    dist[(id + 1) % 2][e].push_back(x ^ w);
                }
            }

        }
        for (auto x : dist[id][f]) {
            res = (res ^ x);
            if (res != res1) {
                cout <<"-1" << endl;
                return;
            }
        }
        for (int j = 0; j < n; j++) {
            dist[id][j].clear();
        }

        id = (id + 1) % 2;
    }
    if (res != res1) {
        cout << "-1" << endl;
        return;
    } else {
        cout << res << endl;
    }*/

}

int main()
{
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        sol();
    }
    return 0;
}

/*
1
4 5
1 2 1
2 3 1
3 4 0
1 3 1
2 4 0
1 4

5
1 1
1 1 0
1 1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
2 3
4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4



*/


