//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

const ll N = 1e5 + 1;
vector < pair < ll, ll >> g[N], r_g[N];
bool is_bad[N], fl = false;
ll used[N], par[N];

void dfs(ll v) {
    used[v] = 1;
    for(auto [i, j]: g[v]) {
        if (j == 0) continue;
        if (used[i] == 0) {
            par[i] = v;
            dfs(i);
        }
        else if (used[i] == 1) {
            is_bad[i] = true;
            ll u = v;
            while (u != i) {
                is_bad[u] = true;
                u = par[u];
            }
            break;
        }
        if (is_bad[v]) break;
    }
    used[v] = 2;
}

void dfs1(ll v) {
    used[v] = 1;
    if (is_bad[v]) {
        fl = true;
        return;
    }
    for(auto [i, j]: r_g[v]) {
        if (used[i]) continue;
        dfs1(i);
        if (fl) return;
    }
}

void solve () {
    ll n, m;
    cin >> n >> m;
    vector < ll > a(n);
    forall(i, a) cin >> i >> i >> i;
    ll x, y;
    cin >> x >> y;
    x--; y--;
    ll xx = 0;
    forall(i, a) xx ^= i;
    if (xx) {
        cout << -1;
        return;
    }
    ll ans = 0;
    while (x != y) {
        ans ^= a[x];
        x = (x + 1) % n;
    }
    cout << ans;
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}
