#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
//#define int ll

int n, m;
vector<vector<pair<int, int>>> g;
int s, f;

void solve_cyc() {
    vector<int> d(n);
    for (int i = 0; i < n; ++i)
        d[i] = g[i][0].second;
    int x = 0;
    for (auto i : d)
        x ^= i;
    int tmp = 0;
    for (int i = s; i != f; i = (i + 1) % n)
        tmp ^= d[i];
    if ((tmp ^ x) != 0 || tmp != 0)
        cout << -1 << endl;
    else
        cout << 0 << endl;
}

void dfs(int v, const vector<vector<pair<int, int>>>& gg, vector<bool>& used) {
    used[v] = 1;
    for (auto& [u, w] : gg[v])
        if (!used[u])
            dfs(u, gg, used);
}

vector<int> calc(const vector<vector<pair<int, int>>>& gg, int s) {
    vector<int> dp(n);
    dp[s] = 1;

    vector<bool> used(n);
    dfs(0, g, used);
    /*
    for (auto i : used)
        cout << i << " ";
    cout << endl;
    */
    vector<int> p(n);
    for (int i = 0; i < n; ++i)
        if (used[i])
            for (auto& [j, w] : gg[i])
                ++p[j];

    deque<int> q;
    q.push_back(s);
    while (!q.empty()) {
        int v = q[0];
        q.pop_front();
        for (auto& [u, w] : gg[v]) {
            dp[u] ^= dp[v];
            if (--p[u] == 0)
                q.push_back(u);
        }
    }

    return dp;
}

void solve_no_cyc() {
    auto dp1 = calc(g, s);
    /*
    for (auto i : dp1)
        cout << i << " ";
    cout << endl << endl;
    */
    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < n; ++i)
        for (auto& [j, w] : g[i])
            gr[j].push_back({i, w});
    auto dp2 = calc(gr, f);
    /*
    for (auto i : dp2)
        cout << i << " ";
    cout << endl;
    */
    int ans = 0;
    for (int i = 0; i < n; ++i)
        for (auto& [j, w] : g[i])
            ans ^= w * dp1[i] * dp2[j];

    cout << ans << endl;
}

void solve() {
    cin >> n >> m;
    g.assing(n,{});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
    }
    cin >> s >> f;
    --s, --f;

    bool flag = 1;
    for (int i = 0; i < n; ++i)
        if (!(g[i].size() == 1 && g[i][0].first == (i + 1) % n))
            flag = 0;

    if (flag)
        solve_cyc();
    else
        solve_no_cyc();
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
}
/*
1
3 3
1 2 7
2 3 0
1 3 7
1 3
 */