#include <iostream>
#include <algorithm>
#include <string>
#include <vector>
#include <cmath>
#include <chrono>
#include <ctime>
#include <set>
#include <map>
#include <stack>
#include <queue>
#include <deque>
#include <limits>
#include <iomanip>
#include <unordered_set>
#include <unordered_map>
#include <fstream>
#include <functional>
#include <random>
#include <cassert>
using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second

ll ttt;
const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll N = 200007;
const ll K = 40007;
const ll LG = 21;
ll n, m, k;
ll a[N];
vector<pair<int, ll>>g[N];
int cnt[N];
ll dp[N][2];

void dfs(int v) {
	for (auto to : g[v]) {
		cnt[to.ff]--;
		dp[to.ff][to.ss] += dp[v][0];
		dp[to.ff][!to.ss] += dp[v][1];
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	cin >> ttt;
	while (ttt--) {
		cin >> n >> m;
		ll z = 0;
		int lu = -1, lv = -1;
		for (int i = 0; i < m; i++) {
			int x, y;
			ll w;
			cin >> x >> y >> w;
			a[i] = w;
			lu = x;
			lv = y;
			g[x].push_back({ y,w });
			cnt[y]++;
			z ^= a[i];
		}
		int v, u;
		cin >> v >> u;
		if (lu == n && lv == 1) {
			v--, u--;
			ll res = 0;
			for (int i = v; i != u; i++, i %= m) {
				res ^= a[i];
			}
			if (res == 0 && z == 0) {
				cout << 0 << endl;
			}
			else {
				cout << -1 << endl;
			}
		}
		else {
			dp[v][0] = 1;
			for (int v = 1; v <= n; v++) {
				if (cnt[v] == 0) {
					dfs(v);
				}
			}
			if (dp[u][1] % 2 == 1) {
				cout << 1 << endl;
			}
			else {
				cout << 0 << endl;
			}
			for (int v = 1; v <= n; v++) {
				g[v].clear();
				dp[v][0] = dp[v][1] = 0;
				cnt[v] = 0;
			}
		}
	}
}
