#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;

const int N = 2e5 + 5;
vc<std::pair<int, int>> g[N];
vc<std::pair<int, int>> rg[N];
bool da[N], used[N];
bool heaven[N], adek[N];
int cnt[N];

int a, b;

void ing(int v) {
    da[v] = true;
    for (auto [u, w]: rg[v]) if (!da[u]) ing(u);
}

std::pair<int, int> dp[N];
int x[N];

bool tru(int v) {
    if (v == b && x[v]) return false;
    used[v] = true;
    for (auto [u, w]: g[v]) {
        if (!da[u]) continue;
        if (used[u]) {
            if (x[u] != (x[v] ^ w)) return false;
        } else {
            x[u] = x[v] ^ w;
            if (!tru(u)) return false;
        }
    }
    return true;
}

void calc(int v) {
    if (used[v]) return;
    used[v] = true;
    if (v == b) return void(dp[v] = {0, 1});
    dp[v] = {0, 0};
    if (heaven[v]) return;
    for (auto [u, w]: g[v]) {
        if (!da[u]) continue;
        calc(u);
        dp[v].first ^= dp[u].first ^ (dp[u].second * w);
        dp[v].second ^= dp[u].second;
    }
}

bool s[N];

void ok(int v) {
    s[v] = true;
    for (auto [u, w] : g[v]) if (!s[u]) ok(u);
}

int main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    std::cin >> t;
    while (t--) {
        int n, m;
        std::cin >> n >> m;
        for (int v = 0; v <= n; ++v) g[v].clear(), rg[v].clear(), used[v] = da[v] = cnt[v] = adek[v] = s[v] = false, heaven[v] = true, x[v] = -1;
        int c = 0;
        for (int v, u, w; m-- && std::cin >> v >> u >> w;) c ^= w, g[v].emplace_back(u, w), rg[u].emplace_back(v, w);
        std::cin >> a >> b;
        ing(b);
        ok(a);
        for (int v = 1; v <= n; ++v) da[v] = da[v] && s[v];
        if (!da[a]) {
            std::cout << 0 << '\n';
            continue;
        }
        vc<int> st = {};
        for (int v = 1; v <= n; ++v) for (auto [u, w]: g[v]) if (da[v] && da[u]) cnt[u]++;
        if (!cnt[a]) st.push_back(a);
        x[a] = 0;
        while (!st.empty()) {
            int v = st.back();
            st.pop_back();
            heaven[v] = false;
            for (auto [u, w]: g[v]) {
                if (da[u]) {
                    adek[u] |= adek[v];
                    if (x[u] != -1) adek[u] = true;
                    x[u] = x[v] ^ w;
                    --cnt[u];
                }
                if (!cnt[u]) st.push_back(u);
            }
        }
        bool fl = true;
        for (int v = 1; v <= n; ++v) if (da[v] && heaven[v]) fl &= !adek[v];
        std::fill(used, used + n + 1, 0);
        for (int v = 1; v <= n; ++v) if (da[v] && heaven[v] && x[v] != -1) fl &= tru(v);
        if (!fl) {
            std::cout << -1 << '\n';
            continue;
        } else {
            std::fill(used, used + n + 1, 0);
            calc(a);
            std::cout << dp[a].first << '\n';
        }

    }
}
