#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

vector<vector<pll>> gr, gr1;
vector<bool> used;
vector<ll> d;
map<pii, int> cnt;

ll res = 0;

void dfs(int v){
    used[v] = true;
    for (auto i : gr1[v]){
        if (!used[i.ff]) dfs(i.ff);
        (d[v] += d[i.ff]) %= 2;
        if (d[i.ff]) res ^= i.ss;
    }
}

void dfs1(int v){
    used[v] = true;
    if (d[v] == 1) return;
    for (auto i : gr[v]){
        if (!used[i.ff]) dfs1(i.ff);
    }
}

void solve(){
    int n, m;
    cin >> n >> m;
    vector<int> g(n);
    int r = 0;
    for (int i = 0; i < n; i++){
        int u, v, x;
        cin >> u >> v >> x;
        r ^= x;
        g[i] = x;
    }
    int a, b;
    cin >> a >> b; a--, b--;
    if (r != 0){
        cout << -1 << endl;
        return;
    }
    r = 0;
    for (int i = a; i != b; i = (i + 1) % n){
        r ^= g[i];
    }
    cout << r << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    cin >> n;
    while(n--) solve();
}
