#include "bits/stdc++.h"
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while (t --> 0) {
        int n, m;
        cin >> n >> m;
        vector<int> w(m);
        int allxor = 0;
        for (int i = 0; i < m; ++i) {
            cin >> w[i] >> w[i] >> w[i];
            allxor ^= w[i];
        }
        int a, b;
        cin >> a >> b;
        --a, --b;
        bool sw = false;
        if (a > b) {
            sw = true;
            swap(a, b);
        }
        int pathxor = 0;
        for (int u = a; u != b; u = (u + 1) % n) {
            pathxor ^= w[u];
        }

        if (allxor != 0 || pathxor != 0) {
            cout << "-1\n";
            continue;
        }
        cout << (sw ? (pathxor ^ allxor) : pathxor) << '\n';
    }
    return 0;
}
