#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

int n, m;
int a, b;
vector<bool> used;
bool dug;
vector<vector<pair<int, int>>> g, gr;
vector<pair<pair<int, int>, int>> rebra;

void solveDug() {
    vector<int>kolbeg(n), kolend(n);
    kolbeg[a] = 1;
    kolend[b] = 1;
    for(int i = 0; i < n; i++) {
        for(auto &k : g[i]) {
            kolbeg[k.first] += kolbeg[i];
        }
    }
    for(int i = n-1; i>=0; i--) {
        for(auto &k : gr[i])
            kolend[k.first] += kolend[i];
    }
    int ans = 0;
    for(auto &i : rebra) {
        if((kolbeg[i.first.first] & 1) && (kolend[i.first.second] & 1))
            ans^=i.second;
    }
    cout << ans << "\n";
}

void solveCycle() {
    int an1 = 0;
    int an2 = 0;
    for(auto &i: rebra) {
        an1^=i.second;
    }
    if (an1 != 0) {
        cout<<-1<<"\n";
        return;
    }
    while(a!=b) {
        an2 ^= g[a][0].second;
        a = g[a][0].first;
    }
    if(an2 != 0) {
        cout << -1<< "\n";
        return;
    }
    cout << 0<<"\n";
}

void solve() {
    cin >> n >> m;
    g.clear();
    gr.clear();
    dug=1;
    bool noZer=0;
    used.clear();
    rebra.clear();
    rebra.resize(m);
    used.resize(n);
    gr.resize(n);
    g.resize(n);
    while(m--) {
        int q, w, e;
        cin >> q >> w >> e;
        q--; w--;
        rebra[m]={{q, w}, e};
        if (e != 0)
            noZer=1;
        g[q].emplace_back(make_pair(w, e));
        if(q>w)
            dug=0;
        gr[w].emplace_back(make_pair(q, e));
    }
    cin >> a >> b;
    if(n==1) {
        if(noZer)
            cout<<-1;
        else
            cout<<0;
        cout<<"\n";
        return;
    }
    a--; b--;
    if(dug) {
        solveDug();
        return;
    }
    solveCycle();
}

int main() {
    //cin.tie(0); cout.tie(0); ios_base::sync_with_stdio(0);
    int t = 1;
    cin >> t;
    while(t--)
        solve();
    return 0;
}
