#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) x.begin(), x.end()
vector<pair<int, int>> pr;
const int mod = 1e9 + 7;
struct dsu {
    vector<int> p, sz;
    vector<pair<int, int>> pr;
    void init(int n) {
        p.resize(n, -1);
        sz.resize(n, 1);
        pr.resize(n);
    }
    int parent(int cur) {
        if (p[cur] == -1) return cur;
        p[cur] = parent(p[cur]);
        return p[cur];
    }
    void merge(int a, int b) {
        a = parent(a);
        b = parent(b);
        if (a == b) return;
        if (sz[a] < sz[b]) swap(a, b);
        p[b] = a;
        sz[a] += sz[b];
        pr[a].first = max(pr[a].first, pr[b].first);
        pr[a].second = min(pr[a].second, pr[b].second);
    }
    int amo(int cur) {
        if (pr[cur].second < pr[cur].first) return 0;
        return pr[cur].second - pr[cur].first + 1;
    } 
}; 
void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> a(n);
    for (auto& i : a) {
        int u, v;
        cin >> u >> v;
        cin >> i;
    }
    vector<int> pr(n);
    pr[0] = a[0];
    for (int i = 1; i < n; i++) {
        pr[i] = pr[i - 1] ^ a[i];
    }
    int x, y;
    cin >> x >> y;
    x--;
    y--;
    if (x < y) {
        cout << ((x > 0 ? pr[x - 1] : 0) ^ (y > 0 ? pr[y - 1] : 0)) << '\n';
    } else {
        cout << (pr.back() ^ (x > 0 ? pr[x - 1] : 0) ^ (y > 0 ? pr[y - 1] : 0)) << '\n';
    }
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) solve();
} 
