#include <iostream>
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define ld long double
#define LL __int128
#define F first
#define S second
mt19937 rnd(100);

ll n, m, a, b;
vector<vector<pair<ll, ll>>> g, reg;
vector<ll> fromA, fromB, inRebs, reinRebs, used, xr;
vector<bool> alive, alive1;

bool hasCycle(ll u, ll x, vector<vector<pair<ll, ll>>> &g1) {
    if (!alive[u] || !alive1[u])
        return 0;
    if (used[u] == 2)
        return 0;
    else if (used[u] == 1)
        return x != xr[u] || x;
    used[u] = 1;
    xr[u] = x;

    for (auto p: g1[u])
        if (hasCycle(p.F, x ^ p.S, g1))
            return 1;
    //used[u] = 2;
    used[u] = 0;
    return 0;
}

void find(ll start, vector<ll> &ans, vector<ll> &in, vector<vector<pair<ll, ll>>> &g1) {
    ans[start] = 1;
    stack<ll> st;
    st.push(start);
    while (!st.empty()) {
        ll h = st.top();
        st.pop();

        for (auto &p: g1[h]) {
            ans[p.F] += ans[h];
            ans[p.F] %= 2;
            in[p.F]--;
            if (!in[p.F])
                st.push(p.F);
        }
    }
}

void f(ll u) {
    if (alive[u])
        return;
    alive[u] = 1;
    for (auto p: reg[u])
        f(p.F);
}

void ff(ll u) {
    if (alive1[u])
        return;
    alive1[u] = 1;
    for (auto p: g[u])
        ff(p.F);
}

ll ans1, timer = 0;
vector<ll> tin, up;
vector<bool> used1;

ll aaaa(ll u) {
    tin[u] = timer++;
    up[u] = tin[u];
    for (auto &v: g[u]) {
        ll hh;
        if (tin[v.F] == -1)
            hh = aaaa(v.F);
        else
            hh = tin[v.F];
        up[u] = min(up[u], hh);
        if (hh <= tin[u])
            v.S = 0;
    }

    return up[u];
}


void f1(ll u, ll xo) {
    if (u == b)
        ans1 ^= xo;
    if (used[u] == 1000)
        return;
    used[u]++;
    for (auto p: g[u])
        f1(p.F, xo ^ p.S);
}

ll solve1() {
    ans1 = 0;
    f(b);
    ff(a);
    used.assign(n, 0);
    xr.assign(n, 0);
    if (hasCycle(a, 0, g))
        return -1;
    used.assign(n, 0);
    xr.assign(n, 0);
    if (hasCycle(b, 0, reg))
        return -1;
    used.assign(n, 0);
    tin.assign(n, -1);
    up.assign(n, -1);
    aaaa(a);
    used.assign(n, 0);
    f1(a, 0);
    return ans1;
}

ll solve() {
    f(b);
    ff(a);
    used.assign(n, 0);
    xr.assign(n, 0);
    if (hasCycle(a, 0, g))
        return -1;
    used.assign(n, 0);
    xr.assign(n, 0);
    if (hasCycle(b, 0, reg))
        return -1;

    used.assign(n, 0);
    tin.assign(n, -1);
    up.assign(n, -1);
    aaaa(a);

    for (int i = 0; i < n; ++i) {
        for (auto p: g[i]) {
            ll u = i, v = p.F;
            if (alive[u] && alive1[u] && alive[v] && alive1[v]) {
                inRebs[v]++;
                reinRebs[u]++;
            }
        }
    }

    find(a, fromA, inRebs, g);
    find(b, fromB, reinRebs, reg);

    ll ans = 0;
    for (int i = 0; i < n; ++i)
        for (auto p: g[i]) {
            ans ^= ((fromA[i] * fromB[p.F]) % 2) * p.S;
        }
    return ans;
}

int main() {
    cin.tie(0), ios_base::sync_with_stdio(0);


    {
        ll _;
        cin >> _;
        while (_--) {
            cin >> n >> m;
            g.clear();
            g.resize(n);
            reg.clear();
            reg.resize(n);
            fromA.assign(n, 0);
            fromB.assign(n, 0);
            inRebs.assign(n, 0);
            reinRebs.assign(n, 0);
            alive.assign(n, 0);
            alive1.assign(n, 0);

            ll u, v, w;
            for (int i = 0; i < m; ++i) {
                cin >> u >> v >> w;
                g[u - 1].emplace_back(v - 1, w);
                reg[v - 1].emplace_back(u - 1, w);
            }
            cin >> a >> b;
            a--, b--;
            cout << solve() << endl;
        }
        return 0;
    }



    ll h = 1;
    while (cout << h++ << endl) {
        n = rnd() % 4 + 1;
        m = rnd() % 4 + 1;
        g.clear();
        g.resize(n);
        reg.clear();
        reg.resize(n);
        fromA.assign(n, 0);
        fromB.assign(n, 0);
        inRebs.assign(n, 0);
        reinRebs.assign(n, 0);
        used.assign(n, 0);
        xr.assign(n, 0);
        alive.assign(n, 0);
        alive1.assign(n, 0);

        vector<tuple<ll, ll, ll>> help(m);
        ll u, v, w;
        for (int i = 0; i < m; ++i) {
            u = rnd() % n + 1;
            v = rnd() % n + 1;
            w = rnd() % 16;
            help[i] = {u, v, w};

            g[u - 1].emplace_back(v - 1, w);
            reg[v - 1].emplace_back(u - 1, w);
        }

        a = rnd() % n, b = rnd() % n;

        ll x = solve();
        ll y = solve1();
        if (x != y) {
            cout << "1\n" << n << ' ' << m << '\n';
            for (auto t: help)
                cout << get<0>(t) << ' ' << get<1>(t) << ' ' << get<2>(t) << '\n';
            cout << a + 1 << ' ' << b + 1 << "\n\n";
            cout << "My: " << x << '\n' << "Correct: " << y << endl;
            solve1();
            return 0;
        }
    }

    return 0;
}
/*
5
1 1
1 1 0
1 1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
2 3
4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4


15 ^ 8

1111
1000
0111

Нужно научиться проверять есть ли циклы с не нулевым ксором или те при попадании в которые ксор может не равняться 0
Для каждого циклового ребра надо сделать w 0
 */
/*
5
1 1
1 1 0
1 1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
2 3
4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4

 */
/*
1. Чекаем есть ли цикл.
 Если есть то ответ -1
2. Для каждого ребра ищем количество путей лежащих через него
 Для этого ищем кол-во путей от а и б до каждой вершины

Для этого не запускаемся из вершины пока не обработали все входящие в нее ребра


 !!!!!!!!От б пути ищем по обратным ребрам
 */
/*
A:
 Нужно выбрать н чисел проезвидением хотябы к чтобы a1/b1 + a2/b2 + a3/b3 ... было максимально
B:

C:

D:
 Есть набор массивов. Нужно расположить эти массивы так чтобы жадно взятая возростающая последовательность была максимальна.
 */