#include <iostream>
#include <iomanip>
#include <set>
#include <map>
#include <vector>
#include <algorithm>
#include <queue>
#include <deque>
#include <string>
#include <cmath>


using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define all(a) a.begin(), a.end()
#define fout(a) cout << fixed << setprecision(a)
void fastio() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

const ll INF = 1e18;
const ll MOD = 1e9 + 7;

ll n, m, a, b;
vector<vector<pair<ll, ll>>> g;

void solve1(){
    ll ans = 0;
    ll v = a;
    while(v != b){
        ans ^= g[v][0].second;
        v = g[v][0].first;
    }
    ll ful = 0;
    for (ll i  =0;i<n;i++) ful^=g[i][0].second;
    if (ful == 0 && ans == 0)
        cout << 0 << "\n";
    else
        cout << -1 << "\n";
}

void solve2(){
    vector<ll> x(n, 0), k(n, 0);
    k[a] = 1;
    for (ll i = 0;i<n;i++){
        for (auto& p : g[i]){
            k[p.first]=(k[p.first]+k[i])%2;
            x[p.first]^=x[i]*k[i];
        }
    }
    cout << x[b] << "\n";
}

int main() {
    fastio();
    ll t;
    cin >> t;
    while(t--){
        cin >> n >> m;
        g.assign(n, {});
        bool ok1 = (n == m), ok2 = 1;
        for (ll i = 0;i<m;i++){
            ll u, v, w;
            cin >> u >> v >> w;
            u--;v--;
            g[u].push_back({v, w});
            ok1 &= (u == i && v == (i+1)%n);
            ok2&=(u<v);
        }
        cin >> a >> b;
        a--;b--;
        if (ok1) {
            solve1();
            continue;
        }
        if (ok2) {
            solve2();
            continue;
        }
    }
    return 0;
}