#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define pb push_back
#define ld long double
#define pii pair <int, int>
#define endl '\n'
#define int int64_t
#define pw(x) (int64_t(1) << x)

using namespace std;
mt19937 gen(time(0));
const int N = 2e5 + 50;
vector <pii> g[N];

void solve () {
    int n, m;
    cin >> n >> m;
    for(int i = 0; i < n; ++i) {
        g[i].clear();
    }
    bool fl = 1;
    for(int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        int nxt = (x + 1) % n;
        if(y != nxt) {
            fl = 0;
        }
        g[x].pb({y, c});
    }
    int a, b;
    cin >> a >> b;
    a--; b--;
    if(n == 1 && m == 1) {
        cout << 0 << endl;
        return;
    }
    if(n == m && fl) {
        cout << -1 << endl;
    } else {
        queue <int> q;
        q.push(a);
        vector <int> r(n, -1);
        r[a] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for(auto to : g[v]) {
                if(r[to.fi] == -1) {
                    r[to.fi] = r[v] ^ to.se;
                    q.push(to.fi);
                }
            }
        }
        cout << r[b] << endl;
    }
}
int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int q;
    cin >> q;
    while (q --) {
        solve();
    }
    return 0;
}
