#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--) solve();
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<set<int>> g(n), gr(n);
    map<pair<int, int>, set<int>> st;
    map<pair<int, int>, vector<int>> vec;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        st[{u, v}].insert(w);
        vec[{u, v}].push_back(w);
        g[u].insert(v);
        gr[v].insert(u);
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    vector<int> top;
    vector<int> used(n);
    auto dfs = [&](auto dfs, int u) -> void {
        used[u] = 1;
        for (auto to : g[u]) {
            if (!used[to]) dfs(dfs, to);
        }
        top.push_back(u);
    };
    dfs(dfs, a);
    reverse(all(top));
    used.assign(n, 0);
    vector<int> nonzero(n), dp(n), cnt(n), kk(n), pt(n);
    cnt[a] = 1;
    kk[a] = 1;
    for (auto u : top) {
        used[u] = 1;
        for (auto to : g[u]) {
            if (!used[to] || u == to) {
                pt[to] = pt[u] ^ *st[{u, to}].begin();
                for (auto w : vec[{u, to}]) {
                    dp[to] ^= dp[u] ^ (cnt[u] * w);
                    cnt[to] ^= cnt[u];
                    kk[to] = min(2, kk[u] + kk[to]);
                }
                if (u != to) {
                    if (st[{u, to}].size() > 1 || kk[u] > 1 || pt[to] != 0) nonzero[to] = 1;
                } else {
                    if (st[{u, to}].size() == 1 && *st[{u, to}].begin() == 0){}
                    else nonzero[u] = 1;
                }
                if (u == to) {
                    if (nonzero[u]) {
                        cout << "-1\n";
                        return;
                    }
                }
            } else {
                if (kk[u] == 1) {
                    if ((pt[u] ^ *st[{u, to}].begin()) == pt[to]){}
                    else {
                        cout << "-1\n";
                        return;
                    }
                } else {
                    if (nonzero[u] || nonzero[to] || st[{u, to}].size() > 1 || kk[u] > 1 ||
                        (pt[u] ^ *st[{u, to}].begin()) != 0) {
                        cout << "-1\n";
                        return;
                    }
                }
            }
        }
    }
    cout << dp[b] << '\n';
}