#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb emplace_back

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

const int MAXN = 2e5 + 10;

vector<pt> gr[MAXN];

int solve1(int n, int m){
    int a, b;
    cin >> a >> b;
    a--, b--;
    int res = 0;
    while (a != b){
        auto [to, w] = gr[a][0];
        res ^= w;
        a = to;
    }
    int res2 = 0;
    for (int i = 0; i < n; i++)
        res2 ^= gr[i][0].y;
    res2 ^= res;
    if (res2 == res && res == 0)
        return 0;
    return -1;
}

int solve(){
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++)
        gr[i].clear();
    bool f1 = (n == m);
    for (int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        gr[u].pb(v, w);
        f1 &= (u == i);
        if (i < m - 1)
            f1 &= (v == i + 1);
        else
            f1 &= (v == 0);
    }
    if (f1)
        return solve1(n, m);
}

void run(){
    int t;
    cin >> t;
    while (t--)
        cout << solve() << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
