#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define int long long


void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n + 1);
    for(int i=0;i<m;++i){
        int f1, f2, f3;
        cin >> f1>> f2 >> f3;
        g[f1].push_back({f2, f3});
        g[f2].push_back({f1, f3});
    }
    int s, f;
    cin >> s >> f;

    vector<bool> used(n + 1, false);
    vector<int> ts;

    function<void(int)> dfs = [&](int v){
        used[v] = true;
        for(auto [to,w]:g[v]){
            if(used[to]) continue;
            dfs(to);
        }
        ts.push_back(v);
    };

    for(int i=1;i<=n;++i){
        if(!used[i]) dfs(i);
    }
//    reverse(ts.begin(), ts.end());

    vector<pair<int, int>> dp(n + 1, {0, 0});
    dp[f] = {0, 1};
    for(auto i:ts){
        for(auto [to,w]:g[i]){
            int x = dp[to].first;
            if(dp[to].second){
                x ^= w;
            }
            dp[i].first ^= x;
            dp[i].second = (dp[i].second + dp[to].second) % 2;
        }
    }
    cout << dp[s].first;
}

int32_t main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int t;
    cin >> t;
    while(t--){
        solve();
        cout << "\n";
    }
}