#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, m;
    vector<vector<pair<int, int>>> reverse_graph;
    int a, b;
    vector<int> dp1, dp2; // f, count
    vector<int> vis;

    void DFS(int v) {
        vis[v] = 1;
        for (auto [prev, w] : reverse_graph[v]) {
            if (!vis[prev]) {
                DFS(prev);
            }
            if (vis[prev] == 2) {
                if (dp1[prev] == -1) {
                    dp1[v] = -1;
                } else {
                    dp1[v] ^= dp1[prev] ^ (dp2[prev] * w);
                    dp2[v] ^= dp2[prev];
                }
            } else {
                // we found a cycle
                // we need to figure out if it spoils us
                // can we do that?
                // maybe we should try updating through it several times

               // assert(false);
            }
        }
        vis[v] = 2;
    }

    solve() : reverse_graph(n), dp1(n), dp2(n), vis(n) {
        for (int i = 0; i < m; ++i) {
            in<int> v, u, w;
            reverse_graph[u - 1].emplace_back(v - 1, w);
        }

        cin >> a >> b;
        --a; --b;
        dp1[a] = 0;
        dp2[a] = 1;
        vis[a] = 2;
        DFS(b);
        cout << dp1[b] << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t;
    while (t--) {
        solve();
    }
}
