#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_set>
using namespace std;
using ll = long long;
using pll = pair<ll, ll>;

vector<vector<pll>> g;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        ll u, v, w;
        cin >> n >> m;
        g.assign(n, vector<pll>());
        for (int i = 0; i < m; ++i) {
            cin >> u >> v >> w;
            --u, --v;
            g[u].emplace_back(v, w);
        }
        ll res = 0;
        ll a, b;
        cin >> a >> b;
        --a, --b;
        while (a != b) {
            res ^= g[a][0].second;
            a = g[a][0].first;
        }
        cout << res << endl;
    }
    return 0;
}
