#include <bits/stdc++.h>
#define fr(i, a, b) for (int i = a; i <= b; i++)
#define rf(i, a, b) for (int i = a; i >= b; i--)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back

#define all(x) x.begin(), x.end()
#define pw(x) (1LL << (x))
#define sz(x) (int)x.size()

using namespace std;

template <typename T>
using ve = vector < T >;

template <typename T>
bool umx(T& a, T b) { return a < b ? a = b, 1 : 0; }

template <typename T>
bool umn(T& a, T b) { return a > b ? a = b, 1 : 0; }

using ll = long long;
using pll = pair <ll, ll>;
using pii = pair <int, int>;


const ll OO = 1e18;
const int oo = 1e9 + 10000;
const int N = 2e5 + 100;

ve <pii> G[N];
ve <pii> RG[N];

ve <int> A;
bool vis[N];
int n, m;

void go(int u) {
    vis[u] = 1;
    fe(to, G[u]) {
        if(!vis[to.fi]) go(to.fi);
    }
    A.pb(u);
}

int tot[N];

int xr[N];
bool bd[N];

void dfs(int u) {
    vis[u] = 1;
    fe(to, G[u]) {
        if(!vis[to.fi]) {
            xr[to.fi] = to.se ^ xr[u];
            dfs(to.fi);
        } else {
            if(xr[u] != (xr[to.fi]^to.se)) {
                bd[u] = 1;
                bd[to.fi] = 1;
            }
        }
    }
}

int col[N];

void clr(int u, int c) {
    vis[u] = 1;
    col[u] = c;
    fe(to, G[u]) if(!vis[to.fi]){
        clr(to.fi, c);
    }
}
bool badV[N];
ve <pii> NG[N];
ve <pii> RNG[N];
bool F[N];


void slv() {
    cin >> n >> m;
    fr(i, 0, m - 1) {
        int u, v, c; cin >> u >> v >> c; u--; v--;
        G[u].pb({v, c});
        RG[v].pb({v, c});
    }
    int s, t; cin >> s >> t; s--; t--;


    dfs(s);
    fill(vis, vis + n, 0);

    fr(i, 0, n - 1) {
        if(!vis[i]) go(i);
    }
    fill(vis, vis + n, 0);
    int cnt = 0;
    fr(i, 0, n - 1) if(!vis[i]) clr(i, cnt++);
    assert(cnt == 1);
    fr(i, 0, n - 1) {
        badV[col[i]] |= bd[i];
        fe(to, G[i]) {
            if(col[i] != col[to.fi]) {
                NG[col[i]].pb(make_pair(col[to.fi], to.se));
                RNG[col[to.fi]].pb({col[i], to.se});
            } else {
                F[col[i]] = 1;
            }
        }
    }

    if (col[s] == col[t]) {
        if(badV[col[s]]) {
            cout << "-1\n";
        } else {
            cout << "0\n";
        }
    }
    A.clear();
    fr(i ,0, n - 1) {
        NG[i].clear();
        RNG[i].clear();
        G[i].clear();
        vis[i] = 0;
        xr[i] = 0;
        F[i] = 0;
        badV[i] = 0;
        tot[i] = 0;
    }
}



int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t; cin >> t;
    while(t--) {
        slv();
    }

    return 0;
}
