#include <bits/stdc++.h>

#include <ranges>
#include <utility>

using namespace std;

typedef int64_t ll;
typedef long double ld;
constexpr int INF = 2e9;

bool STRS = false;

static constexpr ll mod = 1e9 + 7;

struct Solution {
    mt19937 rnd;

    Solution() {
        rnd = mt19937(time(nullptr));
    }

    void solve1(vector<vector<pair<int, int>>>& g, int n) {
        vector<int> ar(n);
        for (int i = 0; i < n; ++i) {
            ar[i] = g[i].back().second;
        }
        int x = 0;
        int a, b; cin >> a >> b;
        a--; b--;
        for (int i = a; i < 2 * n; ++i) {
            if (i % n != b) {
                x ^= ar[i % n];
            } else {
                break;
            }
        }
        int y = ar[b];
        for (int i = b + 1; i < 2 * n; ++i) {
            if (i % n != a) {
                y ^= ar[i % n];
            } else {
                break;
            }
        }
        if (y != 0 || x != 0) {
            cout << "-1\n";
        } else {
            cout << "0\n";
        }
    }
    
    signed operator()(int TEST = -1) {
        int n, m; cin >> n >> m;
        vector<vector<pair<int, int>>> g(n);
        bool SUBTASK_1 = m == n;
        for (int i = 0; i < m; ++i) {
            int a, b, w; cin >> a >> b >> w;
            g[a].emplace_back(b, w);
            if (!(a == i + 1 && b == (i + 1) % n + 1)) {
                SUBTASK_1 = false;
            }
        }
        if (SUBTASK_1) {
            solve1(g, n);
            return 0;
        }
#ifdef ILKRAS
        cout << endl;
#endif
        return 0;
    }
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    int t = 1;
    cin >> t;
#ifdef ILKRAS
#endif
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}

//4
//
//2 2
//1 2 1
//2 1 1
//1 1
//
//3 3
//1 2 1
//2 3 1
//3 1 0
//1 3
//
//3 3
//1 2 1
//2 3 1
//3 1 0
//1 2
//
//3 3
//1 2 1
//2 3 1
//3 1 1
//1 3