#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = long double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 2e5 + 5;
vector<pair<int, int>> g[N];
bool used[N];
int dp[N], dp2[N];

void dfs(int v, vector<int> &ts) {
    used[v] = true;
    for (auto i: g[v])
        if (!used[i.ff])
            dfs(i.ff, ts);
    ts.pb(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i <= n; i++) {
        g[i].clear();
        dp[i] = dp2[i] = 0;
        used[i] = false;
    }
    int alxr = 0;
    for (int i = 0; i < m; i++) {
        int a, b, w;
        cin >> a >> b >> w;
        a--, b--;
        alxr ^= w;
        g[a].pb({b, w});
    }
    int s, f;
    cin >> s >> f;
    s--, f--;
    if (n == m) {
        int ok = 1;
        for (int i = 0; i < n; i++) {
            ok &= (g[i].size() == 1);
            if (g[i].size() == 1) ok &= (g[i][0].first == ((i + 1) % n));
        }
        if (ok) {
            if (alxr == 0) {
                int res = 0;
                while (s != f) {
                    res ^= g[s][0].ss;
                    s = g[s][0].ff;
                }
                if(res != 0) res = -1;
                cout << res << '\n';
            } else {
                cout << -1 << '\n';
            }
            return;
        }
    }
    dp2[s] = 1;
    vector<int> ts;
    dfs(s, ts);
    reverse(all(ts));
    for (auto i: ts) {
        for (auto j: g[i]) {
            int xr = dp[i];
            if (dp2[i] % 2 == 1) xr ^= j.second;
            dp2[j.ff] += dp2[i];
            dp2[j.ff] %= 2;
            dp[j.ff] ^= xr;
        }
    }
    cout << dp[f] << '\n';

}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
}