#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <math.h>
#include <string>
using namespace std;
#define ll long long
ll gcd(ll a, ll b){
    if(b == 0)
        return a;
    return gcd(b, a % b);
}
ll b_pow(ll a, ll b){
    if(b == 0)
        return 1;
    if(b % 2 == 0){
        ll x = b_pow(a, b/2);
        return x * x;
    }
    return b_pow(a, b - 1) * a;
}
struct road{
    ll y, len;
};

void make(vector <vector<road>>& way, ll now, ll b, vector <ll>& nice, ll ans){
    if(now == b){
        nice.push_back(ans);
    }
    else{
        for(int i = 0; i < way[now].size(); i++){
            make(way, way[now][i].y, b, nice, ans^way[now][i].len);
        }
    }
}

bool cycle(vector <vector<road>>& way, ll now, vector <bool> was, ll& f, ll& f1, ll b){
    if(now == b && f1 < 0)
        f1 = 1;
    for(int i = 0; i < way[now].size(); i++){
        if(was[way[now][i].y] && way[now][i].len != 0) {
            f = 1;
            return f;
        }
        if(was[way[now][i].y] && way[now][i].len == 0) {
            f1 = 0;
            return f;
        }
        was[way[now][i].y] = 1;
        cycle(way, way[now][i].y, was, f, f1, b);
        was[way[now][i].y] = 0;
    }
    return f;
}

int main() {
    ll t;
    cin >> t;
    for(int l = 0; l < t; l++){
        ll n, m;
        cin >> n >> m;
        vector <vector<road>> way(m, vector <road> (0));
        ll v, u, w;
        for(int i = 0; i < m; i++){
            cin >> v >> u >> w;
            v--, u--;
            road p;
            p.y = u, p.len = w;
            way[v].push_back(p);
        }
        ll a, b;
        cin >> a >> b;
        vector <bool> was(n, 0);
        a--, b--;
        if(n == 1){
            if(way[0][0].len == 0)
                cout << 0 << endl;
            else
                cout << -1<<endl;
            continue;
        }
        vector <ll> nice(0);
        make(way, a, b, nice, 0);
        ll ans = 0;
        for(int i = 0; i < nice.size(); i++)
            ans = ans^nice[i];
        cout << ans<<endl;
        /*was[a] = 1;
        ll f = 0, f1 = -1;
        cycle(way, a, was, f, f1, b);
        if(f == 1){
            cout << -1<<endl;
            continue;
        }
        if(f1 != 1){
            cout << 0<<endl;
            continue;
        }

        */
    }
}