#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/detail/standard_policies.hpp>
using namespace __gnu_pbds;
using namespace std;

template<typename Ty, class Compare = less<Ty>>
        using ordered_set = tree<Ty, null_type, Compare, rb_tree_tag, tree_order_statistics_node_update>;

using ll = long long;
using ull = unsigned long long;
using vi = vector<int>;
using vvi = vector<vector<int>>;
using vll = vector<ll>;
using vvll = vector<vll>;
using pii = pair<int, int>;

#define mk make_pair
#define all(c) (c).begin(), (c).end()
#define rall(c) (c).rbegin(), (c).rend()

//#pragma GCC optimize("O3")
#pragma GCC target("avx2,bmi,bmi2,popcnt")

/*

*/

vvi g;
vvi w;
vi c;
vector<bool> used;

int timer = 0;

void dfs(int v)
{
    used[v] = true;
    for (int i = 0; i < g[v].size(); ++i)
    {
        if (!used[g[v][i]])
            dfs(g[v][i]);
    }
    c[v] = timer++;
}

int main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    int ttt;
    cin >> ttt;
    while (ttt--)
    {
        timer = 0;
        int n, m;
        cin >> n >> m;
        g.assign(n, vi());
        w.assign(n, vi());
        for (int i = 0; i < m; ++i)
        {
            int u, v, W;
            cin >> u >> v >> W;
            --u; --v;
            g[u].push_back(v);
            w[u].push_back(W);
        }
        int a, b;
        cin >> a >> b;
        --a; --b;
        used.assign(n, false);
        c.assign(n, -1);
        dfs(a);
        if (c[b] == -1)
        {
            cout << 0 << "\n";
            continue;
        }
        vi ind(n);
        iota(all(ind), 0);
        sort(all(ind), [&](int u, int v){return c[u] > c[v];});
        vi dp(n, 0);
        for (int i = 0; i < n; ++i)
        {
            int v = ind[i];
            if (c[v] == -1)
                continue;
            for (int j = 0; j < g[v].size(); ++j)
            {
                int to = g[v][j];
                if (c[to] > c[v])
                {
                    if (dp[to] != (dp[v] ^ w[v][j]))
                    {
                        cout << -1 << "\n";
                        goto fall;
                    }
                }
                else
                {
                    dp[to] ^= (dp[v] ^ w[v][j]);
                }
            }
        }
        cout << dp[b] << "\n";
        fall:;
    }
    return 0;
}
