#include <bits/stdc++.h>

using namespace std;

struct edge {
    int v, w;
    edge(int V = 0, int W = 0) {
        v = V; w = W;
    }
};

void solve1(int n, int m, vector<vector<edge>> &gr) {
    int a, b;
    cin >> a >> b;
    --a; --b;
    int xr = 0;
    int cr = a;
    while (cr != b) {
        xr ^= gr[cr][0].w;
        cr = gr[cr][0].v;
    }
    
    int allxr = 0;
    for (auto &x : gr) {
        allxr ^= x[0].w;
    }
    if (allxr != 0)
        cout << 0 << '\n';
    else
        cout << xr << '\n';
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<edge>> gr;
    bool c = 1;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u; --v;
        if ((u + 1) % n != v)
            c = 0;
        gr[u].emplace_back(v, w);
    }
    if (c)
        solve1(n, m, gr);
}

signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
}