#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define ld long double
#define pi pair<int, int>
mt19937 MT(179);
int NUMBIT = 30;
bool isKthBitSet(int num, int k) {
    return num & (1 << k);
}
int NOD(int a, int b) {
    if(b == 0) return a;
    return NOD(b, a % b);
}
vector<int> rev;
vector<vector<pi>> g;
vector<vector<int>> newg;
vector<vector<int>> revg;
vector<int> id;
vector<bool> used;
vector<int> sz;
vector<int> rch1;
vector<bool> used2;
void DFS1(int v) {
    used[v] = true;
    for(auto x : newg[v]) {
        if(!used[x]) DFS1(x);
    }
    rev.push_back(v);
}
void DFS2(int v, int clr) {
    id[v] = clr;
    for(auto x : revg[v]) {
        if(id[x] == -1) DFS2(x, clr);
    }
}
void DFS3(int v) {
    used[v] = true;
    for(auto x : newg[v]) {
        if(!used[x]) {
            DFS3(x);
        }
        if(id[x] == id[v]) continue;
        rch1[id[v]] = rch1[id[v]] ^ rch1[id[x]];
    }
}
void DFS4(int v) {
    used2[v] = true;
    for(auto x : newg[v]) {
        if(!used2[x]) DFS4(x);
    }
}
void DFS5(int v) {
    used[v] = true;
    for(auto x : revg[v]) {
        if(!used[x]) DFS5(x);
    }
}
void solve() {
    int N = 0, M = 0; cin >> N >> M;
    int mweight = 0;
    vector<int> inc; vector<int> outc;
    inc.assign(N, 0);
    outc.assign(N, 0);
    g.assign(N, vector<pi> ());
    for(int j = 0; j < M; ++j) {
        int u = 0, v = 0, w = 0; cin >> u >> v >> w;
        u--; v--;
        inc[u]++;
        outc[v]++;
        g[u].push_back({v, w});
        mweight = max(mweight, w);
    }
    int lllg = 0;
    while(mweight != 0) {
        lllg++; mweight /= 2;
    }
    int A = 0;
    int B = 0;
    cin >> A >> B;
    A--; B--;
    rev.reserve(2 * N);
    int ans = 0;
    for(int nbit = 0; nbit < lllg; ++nbit) {
        rev.clear();
        newg.assign(2 * N, vi());
        revg.assign(2 * N, vi());
        for(int i = 0; i < 2 * N; ++i) {
            if(inc[i / 2] != 0) newg[i].reserve(inc[i / 2]);
            if(outc[i / 2] != 0) revg[i].reserve(outc[i / 2]);
        }
        for(int ind  = 0; ind < N; ++ind) {
            for(int j = 0; j < g[ind].size(); ++j) {
                if(isKthBitSet(g[ind][j].second, nbit)) {
                    newg[2 * ind].push_back(g[ind][j].first * 2 + 1);
                    revg[g[ind][j].first * 2  + 1].push_back(2 * ind);
                    newg[2 * ind + 1].push_back(g[ind][j].first * 2);
                    revg[2 * g[ind][j].first].push_back(2 * ind + 1);
                } else {
                    newg[2 * ind].push_back(g[ind][j].first * 2);
                    newg[2 * ind + 1].push_back(g[ind][j].first * 2 + 1);
                    revg[2 * g[ind][j].first].push_back(2 * ind);
                    revg[2 * g[ind][j].first + 1].push_back(2 * ind + 1);
                }
            }
        }
        used.assign(2 * N, false);
        for(int i = 0; i < 2 * N; ++i) {
            if(used[i]) continue;
            DFS1(i);
        }
        id.assign(2 * N, -1);
        int curid = 0;
        for(int i = 2 * N - 1; i >= 0; --i) {
            int v = rev[i];
            if(id[v] != -1) continue;
            DFS2(v, curid++);
        }
        sz.assign(2 * N, 0);
        for(int i = 0; i < 2 * N; ++i) {
            for(auto x : newg[i]) {
                if(id[i] == id[x]) sz[id[i]]++;
            }
        }
        rch1.assign(2 * N, 0);
        rch1[id[2 * B + 1]] = 1;
        used2.assign(2 * N, false);
        DFS4(2 * A);
        used.assign(2 * N, false);
        DFS5(2 * B + 1);
        for(int i = 0; i < 2 * N; ++i) {
            if(sz[id[i]] >= 1 && used[i] && used2[i]) {
                cout << "-1" << "\n";
                return;
            }
        }
        used.assign(2 * N, false);
        for(int i = 0; i < 2 * N; ++i) {
            if(used[i]) continue;
            DFS3(i);
        }
        if(rch1[id[2 * A]]) ans += (1 << nbit);
    }
    cout << ans << "\n";
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    cin >> T;
    while(T--) {
        solve();
    }
    return 0;
}
/*
2 2
1 2 1
2 1 2
1 2
*/