#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int MAXN = 2e5;

vector <pair <int, ll>> g[MAXN];
vector <pair <int, ll>> revg[MAXN];
vector <int> deg(MAXN, 0);
vector <int> rdeg(MAXN, 0);
vector <ll> ans(MAXN, 0);
vector <int> cnts(MAXN, 0), cntf(MAXN, 0);

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        ans[i] = 0;
        g[i].clear();
        revg[i].clear();
        deg[i] = 0;
        rdeg[i] = 0;
    }
    int v, u;
    ll w;
    for (int i = 0; i < m; i++) {
        cin >> v >> u >> w;
        v--;
        u--;
        deg[u]++;
        rdeg[v]++;
        g[v].push_back({u, w});
        revg[u].push_back({v, w});
    }
    int s, f;
    cin >> s >> f;
    s--;
    f--;
    cnts[s]++;
    cntf[s]++;
    vector <int> go;
    go.push_back(s);
    while (!go.empty()) {
        v = go.back();
        go.pop_back();
        for (auto [vv, c] : g[v]) {
            cnts[vv] ^= cnts[v];
            deg[vv]--;
            if (deg[vv] == 0) {
                go.push_back(vv);
            }
        }
    }
    go.push_back(f);
    while (!go.empty()) {
        v = go.back();
        go.pop_back();
        for (auto [vv, c] : revg[v]) {
            cntf[vv] ^= cntf[v];
            rdeg[vv]--;
            if (rdeg[vv] == 0) {
                go.push_back(vv);
            }
        }
    }
    ll anss = 0;
    for (int i = 0; i < n; i++) {
        for (auto [vv, c] : g[i]) {
            if (cnts[i] & cntf[vv]) {
                anss ^= c;
            }
        }
    }
    cout << anss << "\n";
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}