#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 200100;
const ll mod = 1e9 + 7;

vector <pair <int, ll> > g[sz];
bool dp[sz];

ll solve_cycle(int n) {
	int a, b;
	cin >> a >> b;
	return 0;
}

ll solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 1; i <= n; ++i) {
		g[i].resize(0);
		dp[i] = 0;
	}
	bool fl = 0;
	for (int i = 0; i < m; ++i) {
		int u, v;
		ll w;
		cin >> u >> v >> w;
		g[u].push_back({ v, w });
		if (v < u) fl = 1;
	}
	if (fl) {
		return solve_cycle(n);
	}
	int a, b;
	cin >> a >> b;
	if (a > b) return 0;
	dp[a] = 1;
	ll ans = 0;
	for (int i = a; i < b; ++i) {
		for (auto p : g[i]) {
			dp[p.first] += dp[i];
		}
		if (dp[i]) {
			for (auto p : g[i]) {
				if (p.first <= b) ans ^= p.second;
			}
		}
	}
	return ans;
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		cout << solve() << '\n';
	}
} 