#include "iostream"
#include "vector"
#include "algorithm"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

struct edge {
    int a, b, w;
};

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int test; cin >> test;
    while (test--) {
        int n, m; cin >> n >> m;
        if (n != m) {
            vector<vector<pair<int, int>>> g(n), gr(n);
            vector<edge> edges(m);
            for (int i = 0; i < m; ++i) {
                int u, v, w; cin >> u >> v >> w;
                u--; v--;
                edges[i] = {u, v, w};
                g[u].emplace_back(v, w);
                gr[v].emplace_back(u, w);
            }
            int a, b; cin >> a >> b;
            a--; b--;
            if (a > b) {
                cout << 0 << '\n';
                continue;
            }
            vector<int> ways(n, 0);
            ways[a] = 1;
            for (int i = a; i < b; ++i) {
                for (auto el: g[i]) {
                    ways[el.first] += ways[i];
                    ways[el.first] %= 2;
                }
            }
            vector<int> waysr(n, 0);
            waysr[b] = 1;
            for (int i = b; i > a; --i) {
                for (auto el: gr[i]) {
                    waysr[el.first] += ways[i];
                    waysr[el.first] %= 2;
                }
            }
            int ans = 0;
            for (auto e: edges) {
                int num = ways[e.a] * waysr[e.b];
                if (num) {
                    ans ^= e.w;
                }
            }
            cout << ans << '\n';
            continue;
        }
        vector<int> ed(m);
        int tot = 0;
        for (int i = 0; i < m; ++i) {
            int u, v; cin >> u >> v >> ed[i];
            tot ^= ed[i];
            u--; v--;
        }
        int a, b; cin >> a >> b;
        a--; b--;
        int ans = 0;
        if (a <= b) {
            for (int i = a; i < b; ++i) {
                ans ^= ed[i];
            }
        } else {
            for (int i = a; i < n; ++i) {
                ans ^= ed[i];
            }
            for (int i = 0; i < b; ++i) {
                ans ^= ed[i];
            }
        }
        if (ans == 0 and tot == 0) {
            cout << ans << '\n';
        } else {
            cout << -1 << '\n';
        }
    }
}