#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define fast ios::sync_with_stdio(false);cin.tie(0);

vector<vector<pair<int, int>>> g, gf;
vector<bool> used;
vector<int> t_s, t_s1;
vector<int> col;
vector<int> sz;

void top_sort(int v) {
    used[v] = true;
    for (auto [u, w] : g[v]) {
        if (used[u])
            continue;
        top_sort(u);
    }
    t_s.push_back(v);
}

void top_sort1(int v) {
    used[v] = true;
    for (auto [u, w] : gf[v]) {
        if (used[u])
            continue;
        top_sort1(u);
    }
    t_s1.push_back(v);
}

void dfs1(int v, int c) {
    sz[c]++;
    col[v] = c;
    for (auto [u, w] : gf[v]) {
        if (used[u])
            continue;
        dfs1(u, c);
    }
}

vector<bool> from_a, from_b;

void dfs2(int v) {
    used[v] = true;
    from_a[v] = true;
    for (auto [u, w] : g[v]) {
        if (!used[u])
            dfs2(u);
    }
}


void dfs3(int v) {
    used[v] = true;
    from_b[v] = true;
    for (auto [u, w] : gf[v]) {
        if (!used[u])
            dfs3(u);
    }
}

void sol() {
    used.clear();
    t_s.clear();
    t_s1.clear();
    sz.clear();
    col.clear();
    from_a.clear();
    g.clear();
    gf.clear();
    from_b.clear();
    int n, m;
    cin >> n >> m;
    col.resize(n);
    used.resize(n);
    from_a.resize(n);
    from_b.resize(n);
    g.resize(n);
    sz.resize(n);
    used.resize(n);
    gf.resize(n);
    vector<array<int, 3>> ribs;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;v--;
        g[u].push_back({v, w});
        gf[v].push_back({u, w});
        ribs.push_back({u, v, w});
    }
    int a, b;
    cin >> a >> b;
    a--;b--;
    for (int i = 0; i < n; i++) {
        if (!used[i])
            top_sort(i);
    }
    reverse(t_s.begin(), t_s.end());
    fill(used.begin(), used.end(), false);
    dfs2(a);
    fill(used.begin(), used.end(), false);
    dfs3(b);
    fill(used.begin(), used.end(), false);
    vector<int> dp_a(n), dp_b(n);
    dp_a[a] = 1;
    dp_b[b] = 1;
    fill(used.begin(), used.end(), false);
    top_sort1(b);
    reverse(t_s1.begin(), t_s1.end());
    for (auto i : t_s) {
        for (auto [u, w] : g[i]) {
            dp_a[u] = (dp_a[u] + dp_a[i]) % 2;
        }
    }
    for (auto i : t_s1) {
        for (auto [u, w] : gf[i]) {
            dp_b[u] = (dp_b[u] + dp_b[i]) % 2;
        }
    }
    int ans = 0;
    for (auto [u, v, w] : ribs) {
            if ((dp_a[u] * dp_b[v]) == 1) {
                ans ^= w;
            }
    }
    cout << ans << '\n';
}

signed main() {
    fast;
    int t;
    cin >> t;
    while (t--)
        sol();
}