#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

const int N = 200200;
vector < vector < pii > > g(N);
int dp[N], cnt[N], used[N];

void dfs (int v) {
    used[v] = 1;
    for (auto i : g[v]) {
        int to = i.F, w = i.S;
        dp[to] ^= dp[v];
        if (cnt[v] % 2 == 1) {
            dp[to] ^= w;
        }
        cnt[to] += cnt[v];
//        cout << v << " " << to << " " << dp[v] << " " << dp[to] << " " << cnt[to] << "\n";
    }

    for (auto i : g[v]) {
        int to = i.F, w = i.S;
        if (used[to]) {
            continue;
        }
        dfs(to);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    for (int i = 1; i <= n; i++) {
        g[i].clear();
        used[i] = 0;
    }

    int sum = 0, ok = 1;
    for (int i = 1; i <= m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
        sum ^= w;
    }

    int a, b;
    cin >> a >> b;

    int xr = 0;
    if (a > b) {
        swap(a, b);
    }

    for (int i = a; i < b; i++) {
        xr ^= g[i][0].S;
    }

    if (n == m) {
        int ok = 1;
        for (int i = 1; i < n; i++) {
            if (g[i][0].F != i + 1) {
                ok = 0;
                break;
            }
        }
        if (ok) {
            if (xr == 0 && sum == 0) {
                cout << 0;
                return;
            }
            else {
                cout << -1;
                return;
            }
        }
    }

        cnt[a] = 1;
        dfs (a);
        cout << dp[b] << "\n";
        return;





}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}
