#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

const int N = 200200;
vector < vector < pii > > g(N);
int dp[N], cnt[N], used[N];
vi order;
int tin[N];

void calc (int x) {
    set <pii> q;
    q.insert({tin[x], x});
    while (!q.empty()) {
        int v = q.begin()->F;
        q.erase(q.begin());
        for (auto i : g[v]) {
            int to = i.F, w = i.S;
            dp[to] ^= dp[v];
            if (cnt[v] % 2 == 1) {
                dp[to] ^= w;
            }
            cnt[to] += cnt[v];
            cnt[to] %= 2;
            q.insert({tin[to], to});
        }
    }
}

//bfnghejnejf

void dfs (int v) {
    used[v] = 1;
    for (auto i : g[v]) {
        int to = i.F;
        if (used[to]) {
            continue;
        }
        dfs(to);
    }
    order.pb(v);
}

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        used[i] = 0;
    }

    int sum = 0, ok = 1;
    for (int i = 1; i <= m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        if (u > v) {
            ok = 0;
        }
        g[u].pb({v, w});
        sum ^= w;
    }

    int a, b;
    cin >> a >> b;

//    if (!ok) {
        int xr = 0;
        if (a > b) {
            swap(a, b);
        }
        for (int i = a; i < b; i++) {
            xr ^= g[i][0].S;
        }
        if (xr == 0 && sum == 0) {
            cout << 0;
        }
        else {
            cout << -1;
        }
        return;
//    }

    for (int i = 1; i <= n; i++) {
        if (!used[i]) {
            dfs (i);
        }
    }

    reverse(all(order));

    for (int i = 0; i < n; i++) {
        tin[order[i]] = i + 1;
    }

    cnt[a] = 1;
    calc(a);
    cout << dp[b];
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << "\n";
    }
}
