#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define ve vector
#define mpp make_pair
#define pb push_back
#define all(x)      (x).begin(),(x).end()
#define sz(x)       ((int)(x).size())
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;

template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

inline void solve() {
    int n, m;
    cin >> n >> m;
    ve<ve<pii>> gr(n), gt(n);

    int f = (n == m);
    int X = 0;

    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;

        gr[--v].pb({--u, w});
        gt[u].pb({v, w});

        X ^= w;

        if (i < n - 1) {
            f &= (v == i && u == i + 1);
        }
        else {
            f &= (v == n - 1 && u == 0);
        }
    }

    int v, u;
    cin >> v >> u, --v, --u;

    if (f) {
        int ans = 0;
        for (int i = v; i < u; i = (i + 1) % n) {
            for (const auto &[to, w] : gr[i]) {
                if (to == (i + 1) % n) {
                    ans ^= w;
                    break;
                }
            }
        }

        if (X > 0 && ans > 0) {
            return void(cout << -1 << '\n');
        }
        else {
            return void(cout << (ans ^ X) << '\n');
        }
    }

    if (v > u) {
        return void(cout << 0 << '\n');
    }

    ve<int> dp(n, -1);
    for (int i = n - 1; ~i; --i) {
        if (i == u) {
            dp[i] = 1;
        }
        else {
            int ok = 0, s = 0;
            for (const auto &[to, w] : gr[i]) {
                if (~dp[to]) {
                    s += dp[to];
                    s &= 1;

                    ok = 1;
                }
            }
            if (ok) {
                dp[i] = s;
            }
        }
    }
    ve<int> dp1(n, -1);
    for (int i = 0; i < n; ++i) {
        if (i == v) dp1[i] = 1;
        else {
            int ok = 0, s = 0;
            for (const auto &[to, w] : gt[i]) {
                if (~dp1[to]) {
                    s += dp1[to];
                    s &= 1;

                    ok = 1;
                }
            }
            if (ok) {
                dp1[i] = s;
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
//        cout << i + 1 << ": " << dp1[i] << " " << dp[i] << '\n';
        for (const auto &[to, w] : gr[i]) {
            if ((~dp1[i]) && (~dp[to])) {
                ans ^= (dp1[i] * dp[to]) * w;
            }
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; cin >> q;
    while (q--) solve();
}
