#include <bits/stdc++.h>
using namespace std;
#define nt int
const int maxn = 2e5 + 7;
vector <pair<int, int>> g[maxn], revg[maxn];
nt dp_to[maxn], dp_from[maxn];
int cnt_to[maxn], cnt_from[maxn];
bool used[maxn];
void clearr(int n) {
    for (int i = 1; i <= n; i++) {
        g[i].clear();
        dp_to[i] = 0;
        cnt_to[i] = 0;
        revg[i].clear();
        dp_from[i] = 0;
        cnt_from[i] = 0;
        used[i] = 0;
    }
}

void dfs1(int v) {
    used[v] = 1;
    cnt_to[v] = 0;
    dp_to[v] = 0;
    for (auto [u, w]: g[v]) {
        if (!used[u]) dfs1(u);
        if (cnt_to[u] % 2 == 1) dp_to[v] ^= w;
        dp_to[v] ^= dp_to[u];
        cnt_to[v] += cnt_to[u];
        cnt_to[v] %= 2;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    int all = 0;
    vector <int> a(n);
    bool ar = 1;
    if (n != m) {
        for (int i = 0; i < m; i++) {
            int u, v;
            cin >> u >> v;
            if (u > v) ar = 0;
            int w;
            cin >> w;
            g[u].push_back({v, w});
        }

        int s, t;
        cin >> s >> t;
        if (s == t) {
            cout << 0 << '\n';
            clearr(n);
            return;
        }
        dp_to[t] = 0;
        cnt_to[t] = 1;
        used[t] = 1;
        dfs1(s);
        cout << dp_to[s] << '\n';
        clearr(n);
        return;
    }
    for (int i = 0; i < m; i++) {
        int u, v;
        cin >> u >> v;
        if (u > v) ar = 0;
        int w;
        cin >> w;
        a[i] = w;
        all ^= w;
        g[u].push_back({v, w});
    }
    if (ar) {
        int s, t;
        cin >> s >> t;
        if (s == t) {
            cout << 0 << '\n';
            clearr(n);
            return;
        }
        dp_to[t] = 0;
        cnt_to[t] = 1;
        used[t] = 1;
        dfs1(s);
        cout << dp_to[s] << '\n';
        clearr(n);
        return;
    } else {
        int s, t;
        cin >> s >> t;
        s--, t--;
        int ans = 0;
        for (int i = s;i != t; i = (i + 1) % n) {
            ans ^= a[i];
        }
        if (ans != 0 || (all ^ ans) != 0) {
            cout << -1 << '\n';
        } else {
            cout << 0 << '\n';
        }
    }
}
signed main() {
    int t; cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}