#include <bits/stdc++.h>

using namespace std;

const int C = 200010;

vector<vector<pair<int, int>>> g, rg;
vector<int> used, dp, is_cycled, reach_b;
int finish, CYCLE_B;
//
//void find_cycle(int u) {
//    used[u] = 1;
//    for (auto[v, c] : g[u]) {
//        if (used[v] == 1) {
//            is_cycled[v] = 1;
//            continue;
//        }
//        find_cycle(v);
//        if (is_cycled[v]) is_cycled[u] = 1;
//    }
//    used[u] = 2;
//}
//
//void b_cycle(int u) {
//    if (is_cycled[u]) CYCLE_B = 1;
//    if (used[u]) return;
//    used[u] = 1;
//    for (auto[v, c] : rg[u]) {
//        b_cycle(v);
//    }
//}

void dfs(int u) {
    if (u == finish) {
        reach_b[u] = 1;
        return;
    }
    if (used[u]) return;
    used[u] = 1;
    for (auto[v, c] : g[u]) {
        dfs(v);
        if (reach_b[v]) dp[u] = dp[v] ^ dp[u] ^ (c * (g[v].size() % 2 == 1 || g[v].empty())), reach_b[u] = 1;
    }
}

void solve() {
    CYCLE_B = 0;
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    rg.assign(n, {});
    used.assign(n, 0);
    dp.assign(n, 0);
    reach_b.assign(n, 0);
    is_cycled.assign(n, 0);
    int W = 0, group1 = 1;
    vector<int> gr1(m);
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w, a--, b--;
        gr1[i] = w;
        if (i != a || (i + 1) % n != b) group1 = 0;
        W ^= w;
        g[a].emplace_back(b, w);
        rg[b].emplace_back(a, w);
    }
    //   cout << group1 << endl;
    int a, b;
    cin >> a >> b, a--, b--;
    int W0 = 0;
    if (a < b) b += n;
    for (int i = a; i < b; ++i) W0 ^= gr1[i % n];
    assert(group1);
    if (group1) {
        if ((W ^ W0) == 0) cout << W0 << endl;
        else cout << -1 << endl;
        return;
    }
    finish = b;
    //  find_cycle(a);
    used.assign(n, 0);
    // b_cycle(b);
    if (CYCLE_B) {
        cout << -1 << '\n';
        return;
    }
    used.assign(n, 0);
    dfs(a);
    if (reach_b[a] == 0) {
        cout << -1 << '\n';
        return;
    }
    cout << dp[a] << '\n';

}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}
