#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<pair<ll, ll>>> g;
ll st, fn;
ll ans = 0;

void dfs(ll u, ll xr) {
    if (u == fn) {
        ans = (ans ^ xr);
        return;
    }
    for (auto [v, w] : g[u]) {
        dfs(v, (xr ^ w));
    }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.resize(n);
    for (ll i = 0; i < m; i++) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].emplace_back(v, w);
    }
    cin >> st >> fn;
    st--;
    fn--;
    dfs(st, 0);
    cout << ans;
    g.clear();
    ans = 0;
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> tpk;
    while (tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}