#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<pair<int, int>>> g;
vector<int> used;
vector<int> ans;
int st, fn;

void dfs(int u) {
    used[u] = 1;
    if (u == fn) {
        ans[u] = 0;
        return;
    }
    for (auto [v, w] : g[u]) {
        if (!used[v]) {
            dfs(v);
        }
        if (ans[v] != -1) {
            ans[u] = (ans[u] ^ (ans[v] ^ w));
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.resize(n);
    used.resize(n);
    ans.resize(n, -1);
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].emplace_back(v, w);
    }

    cin >> st >> fn;
    st--;
    fn--;
    dfs(st);
    cout << ans[st];
    g.clear();
    used.clear();
    ans.clear();
}

int main() {
#ifdef LOCAL
    long long clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> tpk;
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}