#include <iostream>
#include <vector>

using namespace std;

vector<long long> color, xr, cnt;

char dfs (long long pos, long long dist, long long now, long long was, long long bg, const vector<vector<vector<long long>>>& ways) {
	color[pos] = 1;
	for (auto i : ways[pos]) {
		// cout << now << ' ' << (now ^ i[1]) << endl;
		if (color[i[0]] == 1 && !(i[0] == bg && (now ^ i[1]) == 0 && (was == 0 || pos == bg))) {

			// cout << pos << " -> " << i[0] << endl;
			return -1;
		}

		else if (color[i[0]] == 2) {
			if (xr[i[0]] != -1) {
				if (xr[pos] == -1) {
					xr[pos] = 0;
				}
				xr[pos] ^= ((cnt[i[0]] % 2) * i[1]) ^ xr[i[0]];
				cnt[pos] += cnt[i[0]];
			}
		}

		else if (color[i[0]] == 0) {
			char res = dfs(i[0], dist, now ^ i[1], (pos == dist ? now : was), bg, ways);
			if (res == (char) -1) {
				return (char) -1;
			}
			if (xr[i[0]] != -1) {
				if (xr[pos] == -1) {
					xr[pos] = 0;
				}
				xr[pos] ^= ((cnt[i[0]] % 2) * i[1]) ^ xr[i[0]];
				cnt[pos] += cnt[i[0]];
			}
		}

	}

	color[pos] = 2;
	if (pos == dist) {
		xr[pos] = 0;
		cnt[pos] = 1;
	}
	return 0;
}

void solve() {
	long long t, n, m, u, v, w, a, b;
	vector<vector<vector<long long>>> ways;

	cin >> t;
	while (t--) {
		cin >> n >> m;
		ways = vector<vector<vector<long long>>>(n);
		color = vector<long long>(n, 0);
		cnt = vector<long long>(n, 0);
		xr = vector<long long> (n, -1);

		for (int i = 0; i < m; ++i) {
			cin >> u >> v >> w;
			--u; --v;
			ways[u].push_back({v, w});
			// cout << i << endl;
		}
		cin >> a >> b;
		--a; --b;
		// cout << 0 << endl;
		// continue;
		xr[b] = 0;
		cnt[b] = 1;

		char res = dfs(a, b, 0, -1, a, ways);
		
		// for (int i : cnt) {
		// 	cout << i << ' ';
		// }
		// cout << endl;
		// cout << (long long) res << ' ';
		
		if (res == -1) {
			cout << -1 << endl;
		}
		else {
			cout << xr[a] << endl;
		}
	}
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();

	return 0;
}