    #include <iostream>
    #include <map>
    #include <vector>
    #include <iomanip>
    #include <algorithm>
    using namespace std;
    vector<pair<int, int>> g[2000 * 101];
    vector<pair<int, int>> gt[2000 * 101];
    int used[2000 * 101];
    vector<int> tps;
    int dp[2000 * 101][30][2];
    int dp2[2000 * 101][30][2];
    void dfs(int v) {
        used[v] = 1;
        for (auto [u, w] : g[v]) {
            if (!used[u]) {
                dfs(u);
            }
        }
        tps.push_back(v);
    }

    void dfst(int v) {
        used[v] = 1;
        for (auto [u, w] : gt[v]) {
            if (!used[u]) {
                dfst(u);
            }
        }
        tps.push_back(v);
    }

    int comp[2000 * 101];
    int clr = 0;
    void rdfs(int v) {
        comp[v] = clr;
        used[v] = 1;
        for (auto [u, w] : gt[v]) {
            if (!used[u]) {
                rdfs(u);
            }
        }
    }
    const int maxc = 30;
    void solve() {
        int n, m;
        cin >> n >> m;
        for (int i = 0; i <= n; i++) {
            for (int j = 0; j < 30; j++) {
                for (int k = 0; k < 2; k++) {
                    dp[i][j][k] = 0;
                    dp2[i][j][k] = 0;
                }
            }
        }
        clr = 0;
        fill(used, used + n + 1, 0);
        fill(g, g + n + 1, vector<pair<int, int>>());
        fill(comp, comp + n + 1, -1);
        fill(gt, gt + n + 1, vector<pair<int, int>>());
        int xr = 0;
        bool ok = true;
        for (int i = 0; i < m; i++) {
            int a, b, c;
            cin >> a >> b >> c;
            g[a].emplace_back(b, c);
            gt[b].emplace_back(a, c);
            xr ^= c;
        }
        int a, b;
        cin >> a >> b;

        tps.clear();
        for (int i = 1; i <= n; i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        reverse(tps.begin(), tps.end());
        fill(used, used + n + 1, 0);
        for (auto x : tps) {
            if (!used[x]) {
                rdfs(x);
                clr++;
            }
        }
        vector<int> good(clr);
        for (int i = 1; i <= n; i++) {
            for (auto j : g[i]) {
                if (comp[i] == comp[j.first]) {
                    good[comp[i]] = 1;
                }
            }
        }
        fill(used, used + n + 1, 0);
        tps.clear();
        dfs(a);
        reverse(tps.begin(), tps.end());
        for (int i = 0; i < maxc; i++) {
            dp[a][i][0] = 1;
        }
        for (auto x : tps) {
            for (auto [y, w] : gt[x]) {
                for (int i = 0; i < maxc; i++) {
                    for (int j = 0; j < 2; j++) {
                        int ib = (w>>i)&1;
                        if (dp[y][i][j]) {
                            dp[x][i][j^ib] = 1;
                        }
                    }
                }
            }
        }
        for (auto x : tps) {
            for (auto [y, w] : gt[x]) {
                for (int i = 0; i < maxc; i++) {
                    for (int j = 0; j < 2; j++) {
                        int ib = (w>>i)&1;
                        if (dp[y][i][j]) {
                            dp[x][i][j^ib] = 1;
                        }
                    }
                }
            }
        }
        fill(used, used + n + 1, 0);
        tps.clear();
        dfst(b);
        reverse(tps.begin(), tps.end());
        for (int i = 0; i < maxc; i++) {
            dp2[b][i][0] = 1;
        }
        for (auto x : tps) {
            for (auto [y, w] : g[x]) {
                for (int i = 0; i < maxc; i++) {
                    for (int j = 0; j < 2; j++) {
                        int ib = (w>>i)&1;
                        if (dp2[y][i][j]) {
                            dp2[x][i][j^ib] = 1;
                        }
                    }
                }
            }
        }
        for (auto x : tps) {
            for (auto [y, w] : g[x]) {
                for (int i = 0; i < maxc; i++) {
                    for (int j = 0; j < 2; j++) {
                        int ib = (w>>i)&1;
                        if (dp2[y][i][j]) {
                            dp2[x][i][j^ib] = 1;
                        }
                    }
                }
            }
        }
        for (int i = 1; i <= n; i++) {
            for (int nb = 0; nb < maxc; nb++) {
                for (int k1 = 0; k1 < 2; k1++) {
                    for (int k2 = 0; k2 < 2; k2++) {
                        if (k1^k2) {
                            if (dp[i][nb][k1] && dp2[i][nb][k2] && good[comp[i]]) {
                                cout << -1 << endl;
                                return;
                            }
                        }
                    }
                }
            }
        }
        fill(used, used + n + 1, 0);
        tps.clear();
        dfs(a);
        reverse(tps.begin(), tps.end());
        vector<int> ddp(n + 1, 0);
        vector<int> ddp2(n + 1, 0);

        ddp[a] = 0;
        ddp2[a] = 1;
        for (auto x : tps) {
            for (auto [u, w] : gt[x]) {
                if (ddp2[u] % 2 == 1) {
                    ddp[x] ^= ddp[u] ^ w;
                } else {
                    ddp[x] ^= ddp[u];
                }
                ddp2[x] += ddp2[u];
                ddp2[x] %= 2;
            }
        }
        cout << ddp[b] << '\n';

    }

    signed main() {
        ios::sync_with_stdio(false);
        cin.tie(NULL);
        cout.tie(NULL);
        int t;
        cin >> t;
        for (int i = 0; i < t; i++) {
            solve();
        }
    }

    /*
    1
    3 3
     2 2 1

    1 2 1
    2 3 1
    1 3
     */