#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 2e5 + 5;

int n, m;
int w[N];
ve<pii> g[N];
int s, t;
bool subtask1 = 1;
bool subtask2 = 1;

int dp1[N], dp2[N];
ve<int> G[N], GR[N];
bool vis[N];

ve<int> order;

void dfs1(int v) {
    vis[v] = 1;
    fe (to, G[v]) {
        if (!vis[to]) {
            dfs1(to);
        }
    }
    order.pb(v);
}


void dfs2(int v) {
    vis[v] = 1;
    fe (to, GR[v]) {
        if (!vis[to]) {
            dfs2(to);
        }
    }
    order.pb(v);
}

pii e[N];

void solve() {
    cin >> n >> m;

    subtask1 = 1;
    subtask2 = 1;
    fr (i, 1, n) {
        g[i].clear();
        G[i].clear();
        GR[i].clear();
    }

    subtask1 &= n == m;

    fr (i, 1, m) {
        int a, b;
        cin >> a >> b >> w[i];
        g[a].pb({b, i});
        g[b].pb({a, i});

        GR[b].pb(a);
        G[a].pb(b);

        subtask2 &= a < b;

        if (a < n) {
            subtask1 &= b == a + 1;
        }
        e[i] = {a, b};
    }

    cin >> s >> t;

    if (subtask2) {
        fr (i, 1, n) {
            dp1[i] = 0;
            dp2[i] = 0;
        }

        order.clear();
        fill(vis + 1, vis + 1 + n, 0);
        dfs1(s);
        reverse(all(order));

        bool found = 0;
        fe (cur, order) {
            found |= cur == t;
        }

        if (!found) {
            cout << "0\n";
            return;
        }

        dp1[s] = 1;

        fe (v, order) {
            fe (to, G[v]) {
                dp1[to] ^= dp1[v];
            }
        }

        order.clear();
        fill(vis + 1, vis + 1 + n, 0);
        dfs2(t);
        reverse(all(order));

        dp2[t] = 1;

        fe (v, order) {
            fe (to, GR[v]) {
                dp2[to] ^= dp2[v];
            }
        }

        int ans = 0;
        fr (i, 1, m) {
            if ((dp1[e[i].fi] * dp2[e[i].se]) % 2) {
                ans ^= w[i];
            }
        }
        cout << ans << "\n";
        return;
    }

    if (subtask1) {
//        if (s == t && n % 2 == 0) {
//            cout << "0\n";
//            return;
//        }

        int xo = 0;
        bool good = 1;
        fr (i, 1, m) {
            xo ^= w[i];
            good &= w[i] == 0;
        }
        if (!xo) {
            cout << "0\n";
        } else {
            cout << "-1\n";
        }

//        if (xo) {
//        cout << "-1\n";
//            return;
//        }
//
//        cout << "0\n";
        return;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int test;
    cin >> test;
    while (test--) {
        solve();
    }

    return 0;
}
