#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5 + 1, mod = 1e9 + 7, INF = 1e18;

struct str {
    ll v, u, c;
};

void solve() {
    ll n, m;
    cin >> n >> m;
    vector<str> vert(m);
    vector<vector<ll>> gr(n + 1), revgr(n + 1);
    vector<ll> s(n + 1), rs(n + 1);
    for(ll i = 0; i < m; i++){
        cin >> vert[i].v >> vert[i].u >> vert[i].c;
        s[vert[i].u]++, rs[vert[i].v]++;
        gr[vert[i].v].push_back(vert[i].u);
        revgr[vert[i].u].push_back(vert[i].v);
    }
    ll a, b;
    cin >> a >> b;
    vector<ll> dpa(n + 1), ca(n + 1), dpb(n + 1), cb(n + 1);
    dpa[a] = 1, ca[a] = true;
    queue<ll> q;
    q.push(a);
    while(!q.empty()){
        ll t = q.front();
        q.pop();
        for(auto u : gr[t]){
            ca[u] = true;
            s[u]--;
            dpa[u] = (dpa[u] + dpa[t]) % 2;
            if(s[u] == 0){
                q.push(u);
            }
        }
    }
    dpb[b] = 1, cb[b] = true;
    q.push(b);
    while(!q.empty()){
        ll t = q.front();
        q.pop();
        for(auto u : revgr[t]){
            cb[u] = true;
            rs[u]--;
            dpb[u] = (dpb[u] + dpb[t]) % 2;
            if(rs[u] == 0){
                q.push(u);
            }
        }
    }
    vector<ll> ans(30);
    for(ll i = 0; i < m; i++){
        if(ca[vert[i].v] && cb[vert[i].u]){
            ll p = ca[vert[i].v] * cb[vert[i].u];
            for(ll j = 0; j < 30; j++){
                if((vert[i].c >> j) & 1){
                    ans[j] = (ans[j] + p) % 2;
                }
            }
        }
    }
    ll ot = 0;
    for(ll i = 0; i < 30; i++){
        ot += ans[i] * (1 << i);
    }
    cout << ot << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    cin >> t;
    while(t--){
        solve();
    }
}
