#include <bits/stdc++.h>

#define int long long

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (a > b) {
        cout << -1 << '\n';
        return;
    }
    vector<int> dp(n);
    dp[a] = 0;
    for (int i = a; i < b; ++i)
        for (auto [to, w] : g[i])
            dp[to] ^= (dp[i] ^ w);
    cout << dp[b] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0), cin.tie(0);
    int tc;
    cin >> tc;
    while (tc--)
        solve();
}