#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(),x.end()
#define vi vector <int>
#define fi(n) for (int i = 0; i < n; ++i)
#define f first
#define s second

using namespace std;

const int maxn = 2e5;
vector <map <int, int> > g(maxn);
vector <int> used(maxn, 0);
int n, m;
vector <vector <int> > dp(maxn, vector <int>(2, 0));

void dfs(int u) {
    used[u] = 1;
    for (auto &[v, w]: g[u]) {
        if (dp[u][0]) dp[v][0 ^ w]++;
        if (dp[u][1]) dp[v][1 ^ w]++;
        dfs(v);
    }
}

void solve1() {
    int a, b; cin >> a >> b;
    a--; b--;
    dp[a][0] = 1;
    dfs(a);
    // for (int i = 0; i < n; ++i) cout << dp[i][0] << " " << dp[i][1] << '\n';
    int ans = 0;
    for (int i = 0; i < dp[b][1]; ++i) ans = ans ^ 1;
    cout << ans << '\n';
}

void solve() {
    cin >> n >> m;
    int sm = 0, xr = 0;
    int ok = 0;
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--; sm += w;
        if (u + 1 == v || u - n + 1 == v) ok++;
        g[u][v] = w;
    }
    if (!(n == m && ok == n)) {
        solve1();
        return;
    }
    int a, b; cin >> a >> b;
    a--; b--;
    int x = 0;
    if (a < b) {
        for (int i = a; i < b; ++i) {
            x = x ^ g[i][i + 1];
        }
        for (int i = b; i < a + n; ++i) {
            xr = xr ^ g[i % n][(i + 1) % n];
        }
    } else {
        for (int i = a; i < b + n; ++i) {
            x = x ^ g[i % n][(i + 1) % n];
        }
        for (int i = b; i < a; ++i) {
            xr = xr ^ g[i][i + 1];
        }
    }
    if (sm == 0 || (x == 0 && xr == 0)) cout << 0 << '\n';
    else cout << -1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    cin >> tests;
    //tests = 1;
    while (tests--) {
        solve();
    }
    return 0;
}