#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define str to_string
#define pb push_back

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef long double ld;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template <typename T>
inline ll len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 1e18 + 9;
const ll MOD = 1e9 + 7;
const int maxN = 2e5 + 9;
vector<pii> og[maxN], rg[maxN];
bool bada[maxN], badb[maxN];
int vis[maxN];
int ind[maxN];
vector<pii> st;
vector<int> ts;
vector<int> bads;
void dfscyc(vector<pii>* g, int v, pii fm) {
    ind[v] = len(st);
    if(st.empty()) st.pb({v, 0});
    else st.pb({v, st.back().second ^ fm.second});
    vis[v] = 1;
    for(auto &i: g[v]) {
        int to = i.first;
        int w = i.second;
        if(vis[to] == 2) continue;
        if(vis[to] == 1) {
            int j = ind[to];
            bads.pb(v);
//            bad[v] = 1;
//            if((st.back().second ^ st[j].second ^ w) != 0) {
//                bad[v] = 1;
//            }
        }
        else {
            dfscyc(g, to, i);
        }
    }
    vis[v] = 2;
    st.pop_back();
    ts.pb(v);
}

void dfsbad(vector<pii>* g, bool* bad, int v) {
    bad[v] = 1;
    for(auto &i: g[v]) {
        if(!bad[i.first]) {
            dfsbad(g, bad, i.first);
        }
    }
}

int dpa[maxN], dpb[maxN];
struct edge {
    int u, v, w;
};

void clear(int n, int m) {
    st.clear(); ts.clear(); bads.clear();
    for(int i = 0; i <= n; ++i) {
        dpa[i] = dpb[i] = -1;
        og[i].clear(); rg[i].clear();
        bada[i] = badb[i] = 0;
        vis[i] = 0;
        ind[i] = 0;
    }
}
void solve() {
    int n, m; cin >> n >> m;
    clear(n, m);
    vector<edge> es;
    for(int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        og[u].pb({v, w});
        rg[v].pb({u, w});
        es.pb({u, v, w});
    }
    int a, b; cin >> a >> b;

    bads.clear(); ts.clear();
    dfscyc(og, a, pii{-1, -1});
    auto tsa = ts;
    for(auto &v: bads) {
        if(!bada[v]) dfsbad(og, bada, v);
    }

    bads.clear(); ts.clear();
    dfscyc(rg, b, pii{-1, -1});
    auto tsb = ts;
    for(auto &v: bads) {
        if(!badb[v]) dfsbad(rg, badb, v);
    }


    reverse(all(tsa));
    dpa[a] = 1;
    for(auto &v: tsa) {
        if(dpa[v] == -1) continue;
        for(auto &i: og[v]) {
            if(dpa[i.first] == -1) dpa[i.first] = 0;
            dpa[i.first] ^= dpa[v];
        }
    }

    reverse(all(tsb));
    dpb[b] = 1;
    for(auto &v: tsb) {
        if(dpb[v] == -1) continue;
        for(auto &i: rg[v]) {
            if(dpb[i.first] == -1) dpb[i.first] = 0;
            dpb[i.first] ^= dpb[v];
        }
    }


    int ans = 0;
    for(auto &i: es) {
        if(i.w == 0) continue;
        if(dpa[i.u] == -1 || dpb[i.v] == -1) continue;
        if(bada[i.u] || badb[i.v]) {
            ans = -1;
            break;
        }
        int tot = dpa[i.u] * dpb[i.v];
        if(tot % 2) ans ^= i.w;
    }
    cout << ans << '\n';
}
int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
    int tc; cin >> tc;
    while(tc--) solve();
}
/*

5

1 1
1 1 0
1 1

3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3

2 2
1 2 1
2 1 2
1 2

3 3
1 2 7
2 3 0
3 1 7
2 3

4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4



 */