#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;

int n, m;
vector<pair<int, int>> g[N];
int s, t;
int dpsum[N], dpcnt[N];

void solve() {
	cin >> n >> m;
	for (int i = 0; i < n; ++i) {
		g[i].clear();
	}
	for (int i = 0; i < m; ++i) {
		int v, u, w;
		cin >> v >> u >> w;
		--v, --u;
		g[v].push_back({u, w});
	}
	cin >> s >> t;
	--s, --t;
	for (int i = 0; i < n; ++i) {
		dpsum[i] = 0;
		dpcnt[i] = 0;
	}
	dpsum[s] = 0;
	dpcnt[s] = 1;
	for (int v = 0; v < n; ++v) {
		for (auto [u, w] : g[v]) {
			dpsum[u] ^= dpsum[v];
			dpcnt[u] ^= dpcnt[v];
			if (dpcnt[v]) dpsum[u] ^= w;
		}
	}
	cout << dpsum[t] << endl;
}
int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
	return 0;
}