#pragma GCC optimize ("Ofast", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "popcnt")
#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <deque>
#include <queue>
#include <cstdio>
#include <iomanip>
#include <map>
#include <set>
#include <random>
#include <ctime>
#include <random>
#include <bitset>
#define endl '\n'

using namespace std;
using ll = long long;
using ld = long double;
const int N = 2e5 + 10;

struct node {
    int a, b, c;
};

vector <int> g[N], g2[N];
vector <int> o;
vector <node> G;
int us[N], ckl;
void dfs(int v) {
    us[v] = 1;
    for (auto& u : g[v]) {
        if (!us[u])
            dfs(u);
        else if (us[u] == 1) {
            ckl = 1;
        }
    }
    us[v] = 2;
    o.push_back(v);
}

int T = 1;
void dfs2(int v) {
    us[v] = T;
    for (auto& u : g2[v])
        if (!us[u])
            dfs2(u);
}
vector <pair <int, int> > g3[N];
int xrt[N];
int dfs3(int v, int xr, int b) {
    us[v] = 1;
    if (v == b)
        return xr;
    int res = -1;
    for (auto& u : g3[v]) {
        if (!us[u.first]) {
            res = dfs3(u.first, xr ^ u.second, b);
        }
        else if (xrt[u.first] != xr)
            return -1;
    }
    return res;
}

int kl[N], kl2[N];
void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        g[a].push_back(b);
        g2[b].push_back(a);
        g3[a].push_back({ b, c });
        G.push_back({ a, b, c });
    }
    int a, b;
    for (int i = 1; i <= n; i++)
        if (!us[i])
            dfs(i);
    cin >> a >> b;
    if (!ckl) {
        kl[a] = 1;
        kl2[b] = 1;
        for (int i = 0; i < n; i++) {
            int v = o[i];
            for (auto& u : g[v])
                kl2[v] ^= kl2[u];
        }
        reverse(o.begin(), o.end());
        for (int i = 0; i < n; i++) {
            int v = o[i];
            for (auto& u : g2[v])
                kl[v] ^= kl[u];
        }
        int ans = 0;
        for (auto& r : G) {
            if (kl[r.a] == 1 && kl2[r.b] == 1)
                ans ^= r.c;
        }
        cout << ans;
    }
    else {
        fill(us, us + n + 1, 0);
        reverse(o.begin(), o.end());
        for (auto& i : o)
            if (!us[i]) {
                dfs2(i);
                T++;
            }
        fill(us, us + n + 1, 0);
        int aa = dfs3(a, 0, b);
        fill(us, us + n + 1, 0);
        fill(xrt, xrt + n + 1, 0);
        int bb = dfs3(b, 0, a);

        if (us[a] != us[b] || aa != bb || aa == -1) {
            cout << -1;
        }
        else
            cout << 0;
    }
    for (int i = 0; i <= n; i++) {
        g[i].clear(), g2[i].clear();
        g3[i].clear();
        xrt[i] = 0;
        kl[i] = kl2[i] = us[i] = 0;
    }
    T = 1;
    ckl = 0;
    o.clear();
    G.clear();
}

int main() {
#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#else 
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << endl;
    }
}