#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e6+2;

ve<pll> gr[N],rev[N];
char used[N];

void dfs(ll s)
{
    if(used[s]) return;
    used[s]=1;

    for(pll i:rev[s])
        dfs(i.F);
}

ll cnt[N],xr[N];

void solve()
{
    ll n,m;
    cin>>n>>m;

    for(ll i=0;i<n;i++)
        gr[i].clear();

    for(ll i=0;i<m;i++)
    {
        ll a,b,w;
        cin>>a>>b>>w;
        gr[a-1].PB({b-1,w});
        rev[b-1].PB({a-1,w});
    }

    ll s,t;
    cin>>s>>t;
    s--, t--;
    fill(used,used+n,0);
    fill(xr,xr+n,0);
    fill(cnt,cnt+n,0);
    dfs(t);
    cnt[t]=1;

    for(ll i=t-1;i>=s;i--)
    {
        if(!used[i]) continue;

        for(pll j:gr[i])
        {
            if(!used[j.F]) continue;
            cnt[i]=(cnt[i]+cnt[j.F])%2;
            if(cnt[j.F]%2==1) xr[i]^=xr[j.F]^j.S;
        }
    }

    cout<<xr[s]<<endl;
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    ll q;
    cin>>q;

    while(q--)
        solve();

    return 0;
}

/*
2
3 2
1 2 2
2 3 4
1 3
3 3
1 2 2
2 3 4
2 3 4
1 3
*/
