#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;

const int MAXN = 2e5;
const int lg = 30;
vector<vector<pair<int, int>>> g;
int dp[MAXN];
int cnt[MAXN];
vector<int> used;

int s, t;
void dfs(int v) {
    used[v] = true;
    dp[v] = 0;
    cnt[v] = 0;
    if (v == t) {
        dp[v] = 0;
        cnt[v] = 1;
        return;
    }

    for (auto [u, w] : g[v]) {
        if (!used[u]) dfs(u);

        dp[v] ^= dp[u];
        if (cnt[u] % 2 == 1) dp[v] ^= w;
        cnt[v] += cnt[u];
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    bool acyclic = true;

    g.assign(n, vector<pair<int, int>>());

    int x = 0;
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
        g[v].emplace_back(u, w);
        x ^= w;
        if (u >= v) {
            acyclic = false;
        }
    }
    cin >> s >> t;
    s--; t--;

    if (!acyclic && x != 0) {
        cout << -1 << '\n';
        return;
    }

    used.assign(n, false);
    dfs(s);
    cout << dp[s] << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) solve();

    return 0;
}