#include <bits/stdc++.h>

#define int long long
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG C.cpp -o C
using namespace std;

vector<vector<pair<int, int>>> g;
vector<vector<int>> dp;
vector<int> used;

void dfs(int v, int p = -1) {
    used[v] = 1;
    for (auto [u, w] : g[v]) {
        if (u == p) continue;
        dp[u][0] = w == dp[v][1];
        dp[u][1] = w != dp[v][1];
        dfs(u, p);
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<int> s(n);
    g.resize(n);
    bool flag = 1;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        if (u >= v && (u != n || v != 1)) flag = 0;
        s[--u] = w;
        g[u].push_back({--v, w});
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (flag) {
        int f = 0;
        if (a > b) b += n;
        for (int i = a; i != b; ++i) f ^= s[i % n];
        cerr << f << '\n';
        if (f != 0) {
            cout << "-1\n";
            return;
        }
        f = 0;
        for (int i = 0; i < n; ++i) f ^= s[i];
        cerr << f << '\n';
        if (f != 0) cout << "-1\n";
        else cout << "0\n";
        return;
    }
    used.resize(n);
    dp.resize(n, vector<int>(2));
    dp[a][0] = 1;
    dfs(a);
    cout << dp[b][0] + dp[b][1] << '\n';
}
int32_t main() {
    #ifdef LOCAL
    freopen("in.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}
