#include <bits/stdc++.h>

using namespace std;

#define int long long
#define F first
#define S second
#define endl '\n'

void solve() {
    int n, m;
    cin >> n >> m;

    vector<vector<pair<int, int>>> g(n + 1);

    int hui = 0;

    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;

        g[v].push_back({u, w});

        hui = (hui ^ w);
    }

    vector<int> cnt(n + 1);
    vector<int> xr(n + 1);

    int a, b;
    cin >> a >> b;

    queue<int> q;
    q.push(a);

    cnt[a] = 1;

    for (int v = a; v <= n; v++) {
        if (cnt[v] == 0) {
            continue;
        }

        for (auto &[u, w] : g[v]) {
            int cn = cnt[v];

            int x = xr[v];

            if (cn % 2) {
                x ^= w;
            }

            cnt[u] += cn;
            xr[u] = (xr[u] ^ x);
        }
    }

    for (int v = 1; v < a; v++) {
        if (cnt[v] == 0) {
            continue;
        }

        for (auto &[u, w] : g[v]) {
            int cn = cnt[v];

            int x = xr[v];

            if (cn % 2) {
                x ^= w;
            }

            cnt[u] += cn;
            xr[u] = (xr[u] ^ x);
        }
    }

    if (hui != 0 and g[n].size() != 0) {
        cout << -1;
        return;
    }

    cout << xr[b];
}

signed main() {
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    srand(time(0));

    int t;
    cin >> t;

    while (t--) {
        solve();
        cout << endl;
    }

    return 0;
}

/*
4
5
4 9 4 6 8
1 7
2
8 6
1 1
 */

/*
 4
2
3 4
2
1 8
2
2 8
2
7 9
 */