#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

void solva(int & n, int & m, vector <vector <pair<int, int> > > & graph) {
    int st, fin;
    cin >> st >> fin;

    int a = 0, b = 0;
    st--;
    fin--;
    int cur = st;
    while(cur != fin) {
        a = a ^ graph[cur][0].second;
        cur = graph[cur][0].first;
    }
    b = graph[fin][0].second;
    cur = graph[fin][0].first;
    while(cur != st) {
        b = b ^ graph[cur][0].second;
        cur = graph[cur][0].first;
    }
    if (a == 0 && b == 0) {
        cout << 0 << endl;
    } else {
        cout << -1 << endl;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    bool bol = 0;
    vector <vector<pair<int, int> > > graph(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        graph[u].push_back({v, w});
        if (u >= v) {
            bol = 1;
        }
    }

    if (bol) {
        solva(n, m, graph);
        return;
    }

    int a, b;
    cin >> a >> b;
    a--;
    b--;

    if (a >= b)
    {
        cout << 0 << endl;
        return;
    }

    vector <pair<int, int> > hor(n, {0, 0});
    hor[a] = {0, 1};
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < graph[i].size(); ++j) {
            if (hor[i].second % 2 == 0) {
                hor[graph[i][j].first].first = hor[graph[i][j].first].first ^ hor[i].first;
            } else {
                hor[graph[i][j].first].first = hor[graph[i][j].first].first ^ hor[i].first ^ graph[i][j].second;
            }
            hor[graph[i][j].first].second += hor[i].second;
        }
    }
    cout << hor[b].first << endl;
}



const int mod = 1000000007;

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;
    while(t--) {
        solve();
    }
}
