#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

vector<ll> pref;
ll get(ll l, ll r) {
    if (l > r) {
        return 0;
    }
    return pref[r] ^ pref[l - 1];
}

vector<vector<pair<ll, ll>>> graph;

void solve() {
    ll t;
    cin >> t;
    while (t--) {
        ll n, m;
        cin >> n >> m;

        vector<ll> arr(n + 1);
        pref.resize(n + 1);
        graph.assign(n + 1, vector<pair<ll, ll>>());
        bool pg1 = true;
        for (ll j = 1; j <= m; ++j) {
            ll a, b, w;
            cin >> a >> b >> w;
            arr[a] = w;
            graph[a].push_back({b, w});
            if (j != n && a + 1 != b) {
                pg1 = false;
            }
            if (j == n && (a != n || b != 1)) {
                pg1 = false;
            }
        }

        ll from, to;
        cin >> from >> to;

        if (pg1) {
            for (ll i = 1; i <= n; ++i) {
                pref[i] = pref[i - 1] ^ arr[i];
            }

            if (from > to) {
                swap(from, to);
            }

            ll len1 = get(from, to - 1);
            ll len2 = get(1, from - 1) ^ get(to, n);
            if (len1 != 0 || len2 != 0) {
                cout << -1 << "\n";
            } else {
                cout << 0 << "\n";
            }
        } else {
            vector<bool> visited(n + 1);
            vector<ll> count(n + 1);
            count[from] = 1;
            visited[from] = true;
            vector<ll> values(n + 1);
            vector<ll> now = {from};

            while (!now.empty()) {
                vector<ll> neww;

                for (auto x : now) {
                    for (auto y: graph[x]) {
                        if (visited[y.first]) {
                            if (count[x] % 2 == 0) {
                                values[y.first] ^= values[x];
                            } else {
                                values[y.first] ^= (values[x] ^ y.second);
                            }
                            count[y.first] += count[x];
                        }
                    }
                }

                for (auto x : now) {
                    for (auto y: graph[x]) {
                        if (!visited[y.first]) {
                            if (count[x] % 2 == 0) {
                                values[y.first] ^= values[x];
                            } else {
                                values[y.first] ^= (values[x] ^ y.second);
                            }
                            count[y.first] += count[x];
                        }
                    }
                }

                for (auto x : now) {
                    for (auto y: graph[x]) {
                        if (!visited[y.first]) {
                            visited[y.first] = true;
                            neww.push_back(y.first);
                        }
                    }
                }

                now = neww;
            }

            cout << values[to] << "\n";
        }
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}