#include <bits/stdc++.h>
using namespace std;

int main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<pair<int, int>>> g(n);
        for (int i = 0; i < m; i++) {
            int u, v, w;
            cin >> u >> v >> w;
            u--, v--;
            g[u].emplace_back(v, w);
        }
        int a, b;
        cin >> a >> b;
        a--, b--;
        queue<int> q;
        q.push(a);
        vector<bool> visited(n);
        vector<int> paths(n);
        visited[a] = true;
        paths[a] = 1;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w] : g[u]) {
                paths[v] ^= paths[u];
                if (!visited[v]) {
                    visited[v] = true;
                    q.push(v);
                }
            }
        }
        visited.assign(n, false);
        visited[a] = true;
        q.push(a);
        vector<int> x(n);
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, w] : g[u]) {
                if (paths[u] == 1) {
                    x[v] ^= x[u] ^ w;
                }
                if (!visited[v]) {
                    visited[v] = true;
                    q.push(v);
                }
            }
        }
        cout << x[b] << "\n";
    }
}