#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector<vector<pair<int, int>>> g(n);
        int full = 0;
        for (int i = 0; i < m; ++i) {
            int u, v, w;
            cin >> u >> v >> w;
            full ^= w;
            --u;
            --v;
            assert(u == i && v == (i + 1) % n);
            g[u].push_back({v, w});
        }
        int a, b;
        cin >> a >> b;
        if (full != 0) {
            cout << "-1\n";
        } else {
            cout << "0\n";
        }
    }
}
