#include <bits/stdc++.h>

using namespace std;
using ll = long long;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

vector<vector<pair<int, int>>> g, gr;
vector<bool> usedb;

void dfs1(int v) {
    usedb[v] = 1;
    for (auto [u, _] : gr[v]) {
        if (!usedb[u]) {
            dfs1(u);
        }
    }
}

vector<bool> useda;
vector<int> dp1, dp2;

void dfs2(int v) {
    useda[v] = 1;
    for (auto [u, w] : g[v]) {
        if (!usedb[u]) {
            continue;
        }
        if (!useda[u]) {
            dfs2(u);
        }
        dp1[v] ^= dp1[u];
        if (dp2[u] == 1) {
            dp1[v] ^= w;
        }
        (dp2[v] += dp2[u]) %= 2;
    }
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        g.clear();
        g.resize(n);
        gr.clear();
        gr.resize(n);
        int full = 0;
        vector<int> ww;
        bool dag = 1;
        for (int i = 0; i < m; ++i) {
            int u, v, w;
            cin >> u >> v >> w;
            full ^= w;
            --u;
            --v;
            if (u >= v) {
                dag = 0;
            }
//            assert(u == i && v == (i + 1) % n);
            g[u].push_back({v, w});
            gr[v].push_back({u, w});
            ww.push_back(w);
        }
        int a, b;
        cin >> a >> b;
        --a; --b;
        if (!dag) {
            int x = 0;
            while (a != b) {
                x ^= ww[a];
                ++a;
                a %= n;
            }
            if (full != 0 || x != 0) {
                cout << "-1\n";
            } else {
                cout << "0\n";
            }
        } else {
            usedb.assign(n, 0);
            dfs1(b);
            useda.assign(n, 0);
            dp1.assign(n, 0);
            dp2.assign(n, 0);
            dp2[b] = 1;
            dfs2(a);
            cout << dp1[a] << "\n";
        }
    }
}
