#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=2e5+5;

struct Edge
{
    int v,w;
    Edge() {}
    Edge(int _v,int _w)
    {
        v=_v;
        w=_w;
    }
};

int n,m;
vector<Edge> adj[MAXN];
int a,b;

void init()
{
    for(int i=1;i<=n;i++) adj[i].clear();
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int t;
cin>>t;
while(t--)
{
    init();
    bool fl1=1;
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back(Edge(v,w));
        if((v-u+n)%n!=1) fl1=0;
    }
    cin>>a>>b;
    if(n==m && fl1)
    {
        adj[0].push_back(adj[n][0]);
        int cur=0;
        for(int i=a;i%n!=b;i++)
        {
            cur^=adj[i%n][0].w;
        }
        if(cur>0) {cout<<-1<<endl; continue;}
        cur=0;
        for(int i=1;i<=n;i++)
        {
            cur^=adj[i][0].w;
        }
        if(cur>0) {cout<<-1<<endl; continue;}
        cout<<0<<endl;
        continue;
    }
}

return 0;
}
