#include <iostream>
#include <utility>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

bool flag;
int n, m, a, b;
vector< pair<int, int> > G[MAXN + 5];

void solve()
{
    cin >> n >> m;

    for (int i = 1; i <= n; ++ i)
    {
        G[i].clear();
    }

    bool flag1 = true;
    if (n != m) flag1 = false;
    for (int i = 1; i <= m; ++ i)
    {
        int u, v, w;
        cin >> u >> v >> w;
        int t = (i + 1) % n;
        if (t == 0) t = n;
        if (u != i or v != t) flag1 = false;
        G[u].push_back({v, w});
    }

    cin >> a >> b;
    
    if (flag1)
    {
        int x = 0;
        while (a != b)
        {
            x ^= G[a][0].second;
            a = G[a][0].first;
        }
        
        int y = 0;
        do
        {
            y ^= G[a][0].second;
            a = G[a][0].first;
        } while (a != b);
        
        if (x == 0 and y == 0) cout << 0 << endl;
        else cout << -1 << endl;
        return;
    }
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
