#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    cin >> t;
    while (t--) {
        solve();
        cout << '\n';
    }
}

void dfs(int s, vector<int> &is, vector<vector<pair<int, int>>> &g, vector<int> &top) {
    is[s] = 1;
    for (auto[a, w]: g[s]) {
        if (is[a])
            continue;
        dfs(a, is, g, top);
    }
    top.push_back(s);
}

void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    bool is = n == m;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;
        if ((a + 1) % n != b)is = 0;
        g[a].push_back({b, c});
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    if (is) {
        vector<int> v(m);
        int x = 0;
        for (int i = 0; i < n; i++) {
            v[i] = g[i][0].second;
            x ^= v[i];
        }
        if (a < b) {
            int x1 = 0;
            for (int i = a; i < b; i++) {
                x1 ^= v[i];
            }
            if ((x1 ^ x) != 0 || x1 != 0) {
                cout << -1;
            } else
                cout << x1;
        } else {
            int x1 = x;
            for (int i = b; i < a; i++) {
                x1 ^= v[i];
            }
            if ((x1 ^ x) != 0 || x1 != 0) {
                cout << -1;
            } else
                cout << x1;
        }
        return;
    }
    vector<int> top;
    vector<int> u(n);
    vector<vector<pair<int,int>>> g1(n);
    for (int i = 0; i < n; i++) {
        for (auto[j, w]: g[i])
            g1[j].push_back({i, w});

    }
    for (int i = 0; i < n; i++) {
        if (!u[i])
            dfs(i, u, g1, top);
    }
    int ndx = 0;
    for (int i = 0; i < n; i++) {
        if (top[i] == a)
            ndx = i;
    }
    vector<int> dp(n), ans(n);
    dp[a] = 1;
    for (int i = ndx; i < n; i++) {
        for (auto[j, w]: g[i]) {
            dp[j] += dp[i];
            if (dp[i] % 2)
                ans[j] ^= ans[i] ^ w;
            else
                ans[j] ^= ans[i];
        }
    }
    cout << ans[b];


};