#include <bits/stdc++.h>

#include <utility>

#define forn(i, n) for (int i = 0; i < (int) (n); ++i)
#define rep(i, a, b) for (int i = (a); i <= (b); ++i)
#define repr(i, a, b) for (int i = (a); i >= (b); --i)
#define all(x) (x).begin(),(x).end()
#define len(x) (int)(x).size()

template<typename T>
std::ostream &operator<<(std::ostream &out, std::vector<T> &a) {
    for (auto &el: a)
        out << el << ' ';
    return out;
}

template<typename T>
std::istream &operator>>(std::istream &in, std::vector<T> &a) {
    for (auto &el: a)
        in >> el;
    return in;
}

template<typename T1, typename T2>
std::istream &operator>>(std::istream &in, std::pair<T1, T2> &a) {
    in >> a.first >> a.second;
    return in;
}

typedef long long ll;
typedef long double ld;
using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto &el : a) cin >> el;

    if (n == 2) {
        double ans = 0;
        for (int i = 1; i * i <= k && i <= a[0]; ++i) {
            int oth = (k - 1) / i + 1;
            if (oth > a[1])
                continue;
            ans = max(ans, (a[0] / i) * (a[1] / oth) * (1.0 / (a[0] * a[1])) * k);
        }

        swap(a[0], a[1]);

        for (int i = 1; i * i <= k && i <= a[0]; ++i) {
            int oth = (k - 1) / i + 1;
            if (oth > a[1])
                continue;
            ans = max(ans, (a[0] / i) * (a[1] / oth) * (1.0 / (a[0] * a[1])) * k);
        }

        cout << fixed << setprecision(20) << ans;
    } else if (n == 1) {
        double ans = 0;
        for (int i = k; i <= a[0]; ++i) {
            ans = max(ans, (a[0] / i) * (1.0 / a[0]) * k);
        }
        cout <<fixed << setprecision(20) << ans;
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    solve();
    return 0;
}