#include <bits/stdc++.h>

using namespace std;

#define int long long
#define itn int
#define pb push_back
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define ld long double
#define Int int
#define Itn int
#define pii pair<int, int>
#define X first
#define Y second

template<typename T>
istream &operator >> (istream &in, vector<T> &arr) {
    for(auto &to : arr) in >> to;
    return in;
}

template<typename T>
ostream &operator << (ostream &out, vector<T> &arr) {
    for(auto &to : arr) out << to << " ";
    return out;
}

#pragma GCC target("avx")

const int INF = 1e9 + 7;
const int MOD = 1e9 + 7;
const int maxn = 1e6 + 1;

vector<vector<int>> g;
vector<itn> tin, tout;
vector<itn> p;
vector<pii> tmr;
int timer = 0;

void dfs(int v) {
    tin[v] = timer++;
    for(auto to : g[v]) {
        if(tin[to] != -1) continue;
        dfs(to);
    }
    tout[v] = timer++;
}

bool isp(int v, int u) {//v - eto predok u?
    return (tin[v] <= tin[u] && tout[u] <= tout[v]);
}

vector<int> get_path(int v, int u) {
    vector<int> ans;
    if(isp(v, u)) {
        int cur = u;
        while(cur != v) {
            ans.pb(cur);
            cur = p[cur];
        }
        ans.pb(v);
        reverse(all(ans));
        return ans;
    }
    if(isp(u, v)) {
        int cur = v;
        while(cur != u) {
            ans.pb(cur);
            cur = p[cur];
        }
        ans.pb(u);
        return ans;
    }
    int cur = v;
    while(!isp(cur, u)) cur = p[cur];
    int lca = cur;
    vector<int> path1, path2;
    cur = v;
    while(cur != lca) {
        path1.pb(cur);
        cur = p[cur];
    }
    cur = u;
    while(cur != lca) {
        path2.pb(cur);
        cur = p[cur];
    }
    reverse(all(path2));
    for(auto to : path1) ans.pb(to);
    ans.pb(lca);
    for(auto to : path2) ans.pb(to);
    return ans;
}

pii per(pii a, pii b) {
    if(a.X > b.X) swap(a, b);
    if(b.X > a.Y) return {-1, -2};
    else {
        if(b.Y <= a.Y) return b;
        else return {b.X, a.Y};
    }
}

void dfs1(int v, vector<vector<int>> &ng, vector<bool> &nu, pii &cur_otr) {
    nu[v] = true;
    cur_otr = per(cur_otr, tmr[v]);
    for(auto to : ng[v]) {
        if(cur_otr.X == -INF) return;
        if(!nu[to]) dfs1(to, ng, nu, cur_otr);
    }
}

int bin_pow(int x, int y) {
    if(y == 0) return 1;
    if(y == 1) return x;
    int z = bin_pow(x, y / 2);
    if(y % 2 == 0) return (z * z) % MOD;
    else return ((z * z) % MOD) * x % MOD;
}

vector<int> root;
vector<itn> sz;
vector<pii> otr;
int ans = 1;
int find_root(itn v) {
    if(root[v] == v) return v;
    else {
        root[v] = find_root(root[v]);
        return root[v];
    }
}

void merg(int x, int y) {
    int p1 = find_root(x);
    int p2 = find_root(y);
    if(sz[p1] > sz[p2]) {
        root[p2] = p1;
        itn sz1 = otr[p1].Y - otr[p1].X + 1;
        int sz2 = otr[p2].Y - otr[p2].X + 1;
        ans = (ans * bin_pow(sz1, MOD - 2));
        if(ans >= MOD) ans %= MOD;
        ans = (ans * bin_pow(sz2, MOD - 2));
        if(ans >= MOD) ans %= MOD;
        otr[p1] = per(otr[p1], otr[p2]);
        ans *= (otr[p1].Y - otr[p1].X + 1);
        if(ans >= MOD) ans %= MOD;
    } else {
        root[p1] = p2;
        itn sz1 = otr[p1].Y - otr[p1].X + 1;
        int sz2 = otr[p2].Y - otr[p2].X + 1;
        ans = (ans * bin_pow(sz1, MOD - 2));
        if(ans >= MOD) ans %= MOD;
        ans = (ans * bin_pow(sz2, MOD - 2));
        if(ans >= MOD) ans %= MOD;
        otr[p2] = per(otr[p1], otr[p2]);
        ans *= (otr[p2].Y - otr[p2].X + 1);
        if(ans >= MOD) ans %= MOD;
    }
}

void solve() {
    int n;
    cin >> n;
    p.resize(n, 1);
    for(int i = 1; i < n; ++i) cin >> p[i];
    for(auto &to : p) --to;
    g.resize(n);
    for(int i = 1; i < n; ++i) {
        g[p[i]].pb(i);
        g[i].pb(p[i]);
    }
    tin.resize(n, -1);
    tout.resize(n);
    dfs(0);
    tmr.resize(n);
    for(int i = 0; i < n; ++i) {
        int x, y;
        cin >> x >> y;
        tmr[i] = {x, y};
    }
    root.resize(n);
    otr.resize(n);
    sz.resize(n, 1);
    for(int i = 0; i < n; ++i) {
        root[i] = i;
        otr[i] = tmr[i];
        ans *= (tmr[i].Y - tmr[i].X + 1);
        if(ans > MOD) ans %= MOD;
    }
    itn m;
    cin >> m;
    set<pii> edg;
    while(m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        vector<itn> cur1 = get_path(a, b);
        vector<itn> cur2 = get_path(c, d);
        vector<pii> ne;
        for(int i = 0; i < (int)cur1.size(); ++i) {
            if(cur1[i] == cur2[i]) continue;
            pii ccucc = {min(cur1[i], cur2[i]), max(cur1[i], cur2[i])};
            if(edg.find(ccucc) == edg.end()) {
                ne.pb(ccucc);
                edg.insert(ccucc);
            }
        }
        for(auto to : ne) {
            int x = to.X, y = to.Y;
            int p1 = find_root(x);
            int p2 = find_root(y);
            if(p1 == p2) continue;
            merg(p1, p2);
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inp.txt", "r", stdin);
    freopen("out.txt", "w", stdout);
#endif
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) {
        solve();
    }
}