#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#include <bits/stdc++.h>

// open-2023-122
// rma98vsm
// kpnbqsqu


using namespace std;
typedef long long ll;
typedef long double ld;

#define INF ll(1e18)
#define SIZE 200005
#define MOD ll(1e9+7)

#define f first
#define s second
#define pb push_back
#define ppb pop_back

#define loop(i, n) for(ll i = 0; i < n; i++)
#define loopone(i, n) for(ll i = 1; i <= n; i++)
#define loopb(i, n) for(ll i = n-1; i >= 0; i--)
#define loopbone(i, n) for(ll i = n; i > 0; i--)

#define rndm drst(rng)
#define vout(x) for(auto u : x) cout << u << ' ';
#define all(x) x.begin(), x.end()

mt19937_64 rng(time(0));
uniform_int_distribution<ll> drst;

ll sussy_baka;
ll n, m, i, j, k, x, y, z;
string str, trash;
char chr;

const ll maxlg = 18;

ll pr[SIZE];
ll lk[maxlg][SIZE];
ll timer = 0;
ll tin[SIZE], tout[SIZE];
vector<pair<ll, ll>> val = {{0, 0}};
vector<ll> g[SIZE];
ll ans = 1;

vector<ll> team[SIZE];
ll col[SIZE];


void hang(ll ind, ll p = 0) {

    pr[ind] = p;
    tin[ind] = timer++;
    lk[0][ind] = p;
    for (ll i = 0; i < maxlg-1; i++)
        lk[i+1][ind] = lk[i][lk[i][ind]];
    for (auto u : g[ind]) hang(u, ind);
    tout[ind] = timer++;
}

inline ll anc(ll a, ll b) {
    return tin[a] <= tin[b] and tin[b] < tout[a];
}

inline ll lca(ll a, ll b) {
    if (anc(a, b)) return a;
    if (anc(b, a)) return b;
    //cout << ")@ " << a << ' ' << b << endl;
    loopb(i, maxlg)
        if (!anc(lk[i][a], b)) a = lk[i][a];
    return lk[0][a];
}

ll pw(ll a, ll x, ll mod) {
    if (x == 0) return 1;
    ll ans = pw(a, x/2, mod);
    if (x % 2) return ans * ans % MOD * a % MOD;
    return ans * ans % MOD;
}

ll lkm[SIZE];
ll sz[SIZE];
pair<ll, ll> lm[SIZE];

inline void merger(ll a, ll b) {
    a = col[a];
    b = col[b];

    if (sz[a] < sz[b]) swap(a, b);
    sz[a] += sz[b];
    lkm[b] = a;

    for (auto u : team[b]) {
        team[a].pb(u);
        col[u] = a;
    }

    ll one = lm[a].s - lm[a].f + 1;
    ll two = lm[b].s - lm[b].f + 1;
    ans *= pw(one, MOD-2, MOD);
    ans %= MOD;
    ans *= pw(two, MOD-2, MOD);
    ans %= MOD;
    lm[a].f = max(lm[a].f, lm[b].f);
    lm[a].s = min(lm[a].s, lm[b].s);
    if (lm[a].s < lm[a].f) ans = 0;
    ans *= lm[a].s - lm[a].f + 1;
    ans %= MOD;
}



int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    #ifdef DEBUG
    freopen("test.txt", "r", stdin);
    #endif

    //

    tin[0] = -INF;
    tout[0] = INF;

    cin >> n;
    //cout << n;

    loopone (i, n-1) {
        cin >> x;
        g[x].pb(i+1);
    }

    hang(1);

    loopone (i, n) {
        col[i] = i;
        team[i].pb(i);
        cin >> x >> y;

        val.pb({x, y});
        ans = ans * (y-x+1) % MOD;
    }

    loopone (i, n) {
        lkm[i] = i;
        sz[i] = 1;
        lm[i] = val[i];
    }

    cin >> m;

    while (m --) {
        ll a, b;
        cin >> x >> y >> a >> b;

        vector<ll> L, R;
        ll lcl = lca(x, y);
        ll rcl = lca(a, b);

        while (x != lcl) {
            L.pb(x);
            x = pr[x];
        }
        L.pb(lcl);

        while (a != rcl) {
            R.pb(a);
            a = pr[a];
        }
        R.pb(rcl);


        vector<ll> Lr, Rr;

        while (y != lcl) {
            Lr.pb(y);
            y = pr[y];
        }

        while (b != rcl) {
            Rr.pb(b);
            b = pr[b];
        }
        reverse(all(Lr));
        reverse(all(Rr));

        for (auto u : Lr) L.pb(u);
        for (auto u : Rr) R.pb(u);

        loop (i, L.size()) {
            if (col[L[i]] != col[R[i]])
                merger(L[i], R[i]);
        }

        cout << ans << '\n';
    }

    return 0;
}
