#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ull unsigned long long
#define ll long long
#define ld long double
#define x first
#define y second

const ll INF = 1e17 + 2, MOD = 1e9 + 7, MOD1 = 228228227, N = 2e5 + 2;

random_device rd;
mt19937 rnd(rd());

vector<pair<int, int>> u;
vector<vector<int>> g(N), gr(N), up;
vector<int> tin, tout;
int t = 0;

void calc(int v, int p = -1) {
    tin[v] = t++;
    up[0][v] = p;
    for (int i = 1; i < 24 && up[i - 1][v] != -1; i++) {
        up[i][v] = up[i - 1][up[i - 1][v]];
    }
    for (auto e : g[v]) {
        calc(e, v);
    }
    tout[v] = t;
}

bool isAnc(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

int lca(int a, int b) {
    if (isAnc(a, b)) {
        return a;
    }
    if (isAnc(b, a)) {
        return b;
    }
    for (int i = 24; i >= 0; i--) {
        if (up[i][a] == -1) {
            continue;
        }
        if (!isAnc(up[i][a], b)) {
            a = up[i][a];
        }
    }
    return up[0][a];
}

void solve() {
    int n;
    cin >> n;
    up.assign(25, vector<int>(n + 1, -1));
    tin.resize(n), tout.resize(n);
    for (int i = 1; i < n; i++) {
        int p;
        cin >> p;
        p--;
        g[p].push_back(i);
        gr[i].push_back(i);
    }
    u.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> u[i].x >> u[i].y;
    }
    vector<pair<int, int>> k = u;
    calc(0);
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<int> f, s;
        int anc1 = lca(a, b), anc2 = lca(c, d);
        for (int i = a; i != anc1 && i != -1; i = up[0][i]) {
            f.push_back(i);
        }
        f.push_back(anc1);
        vector<int> f1;
        for (int i = b; i != anc1 && i != -1; i = up[0][i]) {
            f1.push_back(i);
        }
        reverse(f1.begin(), f1.end());
        for (auto &e : f1) {
            f.push_back(e);
        }
        for (int i = c; i != anc2 && i != -1; i = up[0][i]) {
            s.push_back(i);
        }
        s.push_back(anc2);
        vector<int> s1;
        for (int i = d; i != anc2 && i != -1; i = up[0][i]) {
            s1.push_back(i);
        }
        reverse(s1.begin(), s1.end());
        for (auto &e : s1) {
            s.push_back(e);
        }
        vector<pair<int, int>> res = k;
        bool fl = true;
        int ans = 1;
        vector<bool> used(n);
        vector<vector<int>> g1(n);
        for (int i = 0; i < f.size(); i++) {
            if (u[f[i]].x > u[s[i]].y || u[f[i]].y < u[s[i]].x) {
                cout << "0\n";
                fl = false;
                break;
            }
            if (res[f[i]].x <= res[s[i]].x) {
                if (res[f[i]].y <= res[s[i]].y) {
                    res[f[i]].x = res[s[i]].x;
                    res[s[i]] = res[f[i]];
                } else {
                    res[f[i]] = res[s[i]];
                }
            } else {
                 if (res[f[i]].y <= res[s[i]].y) {
                    res[s[i]] = res[f[i]];
                } else {
                    res[s[i]].x = res[f[i]].x;
                    res[f[i]] = res[s[i]];
                }
            }
            for (auto e : g1[f[i]]) {
                if (u[f[i]].x > u[s[e]].y || u[f[i]].y < u[s[e]].x) {
                    cout << "0\n";
                    fl = false;
                    break;
                }
                if (res[f[i]].x <= res[s[e]].x) {
                    if (res[f[i]].y <= res[s[e]].y) {
                        res[f[i]].x = res[s[e]].x;
                        res[s[e]] = res[f[i]];
                    } else {
                        res[f[i]] = res[s[e]];
                    }
                } else {
                    if (res[f[i]].y <= res[s[e]].y) {
                        res[s[e]] = res[f[i]];
                    } else {
                        res[s[e]].x = res[f[i]].x;
                        res[f[i]] = res[s[e]];
                    }
                }
            }
            for (auto e : g1[s[i]]) {
                if (u[s[i]].x > u[f[e]].y || u[s[i]].y < u[f[e]].x) {
                    cout << "0\n";
                    fl = false;
                    break;
                }
                if (res[f[e]].x <= res[s[i]].x) {
                    if (res[f[e]].y <= res[s[i]].y) {
                        res[f[e]].x = res[s[i]].x;
                        res[s[i]] = res[f[e]];
                    } else {
                        res[f[e]] = res[s[i]];
                    }
                } else {
                    if (res[f[e]].y <= res[s[i]].y) {
                        res[s[i]] = res[f[e]];
                    } else {
                        res[s[i]].x = res[f[e]].x;
                        res[f[e]] = res[s[i]];
                    }
                }
                res[f[e]] = res[s[i]];
            }
            g1[s[i]].push_back(i);
            g1[f[i]].push_back(i);
        }
        for (int i = 0; i < f.size(); i++) {
            if (!used[f[i]] && !used[s[i]]) {
                ans = (ans * (res[f[i]].y - res[f[i]].x + 1)) % MOD;
            }
            used[f[i]] = true;
            used[s[i]] = true;
            for (int &e : g1[f[i]]) {
                used[e] = true;
            }
            for (int &e : g1[s[i]]) {
                used[e] = true;
            }
        }
        if (fl) {
            vector<bool> need(n);
            for (int &e : f) {
                need[e] = true;
            }
            for (int &e : s) {
                need[e] = true;
            }
            for (int i = 0; i < n; i++) {
                if (!need[i]) {
                    ans = (ans * (res[i].y - res[i].x + 1)) % MOD;
                }
            }
            cout << ans << '\n';
        }
        k = res;
    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
}
