#include <bits/stdc++.h>

#include <list>
#include <numeric>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long double ld;
typedef long long ll;
#define pb push_back
//typedef ordered_set<int> = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<int>> to(200000);
vector<int> par(200000);
vector<int> pard(200000);
vector<int> sz(200000);
vector<int> l(200000);
vector<int> r(200000);
vector<int> h(200000);
vector<int> real_(200000);
int n, m, c,a,b,d;
ll ans = 1;
const ll mod = 1e9+7;

void dfs(int v, int p) {
    for (int u : to[v]) {
        if (u != p) {
            h[u] = h[v]+1;
            par[u] = v;
            dfs(u, v);
        }
    }
}

int find_(int v) {
    if (pard[v] == v) {
        return v;
    }
    return pard[v] = find_(pard[v]);
}
ll bin_pow(ll i, ll p) {
    if (p == 1) {
        return i;
    }
    ll k = bin_pow(i, p/2);
    if (p % 2 ) {
        return k*k%mod*i%mod;
    }
    return k * k % mod;
}
ll inv(int i) {
    return bin_pow(i, mod-2);
}

void unite(int v, int u) {
    u = find_(u);
    v = find_(v);
    if (u == v) {
        return;
    }
        ans *= inv(r[v] - l[v] + 1);
        ans = ans % mod;
        ans *= inv(r[u] - l[u] + 1);
        ans = ans % mod;
        ans *= max(0, min(r[u], r[v]) - max(l[u], l[v]) + 1);
        ans = ans % mod;
    l[u] = l[v] = max(l[u], l[v]);
    r[u] = r[v] = min(r[u], r[v]);
    if (r[v] < l[v]) {
        ans = 0;
    }
    if (sz[u] > sz[v]) {
        pard[v] = u;
    }
    else{
        pard[u] = v;
        if (sz[u] == sz[v]) {
            sz[u]++;
        }
    }
}

void set_(int a, int b, int c, int d) {
    vector<int> va;
    vector<int> var;
    while (h[a] > h[b]) {
        va.pb(a);
        a=par[a];
    }
    while (h[b] > h[a]) {
        var.pb(b);
        b=par[b];
    }
    while (a != b) {
        va.pb(a);
        a=par[a];
        var.pb(b);
        b=par[b];
    }
    va.push_back(a);
    reverse(var.begin(), var.end());
    for (auto i : var) {
        va.pb(i);
    }
    vector<int> vc;
    vector<int> vcr;
    while (h[c] > h[d]) {
        vc.pb(c);
        c=par[c];
    }
    while (h[d] > h[c]) {
        vcr.pb(d);
        d=par[d];
    }
    while (c != d) {
        vc.pb(c);
        c=par[c];
        vcr.pb(d);
        d=par[d];
    }
    vc.push_back(c);
    reverse(vcr.begin(), vcr.end());
    for (auto i : vcr) {
        vc.pb(i);
    }
    for (int i  = 0; i < va.size(); i++) {
        unite(va[i], vc[i]);
    }
}
void solve() {
    cin >> n;
    for (int i = 0; i <n-1; i++) {
        cin >> c;
        c--;
        par[i+1] = c;
        to[c].pb(i+1);
    }
    dfs(0, -1);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
    }
    iota(real_.begin(), real_.end(), 0);
    iota(pard.begin(), pard.end(), 0);
    for (int j = 0; j < n; j++) {
            ans = ans * max(0, r[j] - l[j] + 1) % mod;
    }
    cin >> m;
    for (int i = 0; i < m; i++) {
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        //a=real_[a];
        //b=real_[b];
        //c=real_[c];
        //d=real_[d];
        set_(a, b, c, d);
        cout << ans << '\n';
    }
}


signed main() {
#ifdef LOCAL
    auto f = freopen("C:\\clion\\input.txt", "r", stdin);
    auto f1 = freopen("C:\\clion\\output.txt", "w", stdout);
#endif
    solve();
    return 0;
}
