#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
#define fi first
#define se second
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define sz(a) (int)a.size()
#define vi vector<int>
#define vvi vector<vi>
#define vvvi vector<vvi>
#define vll vector<ll>
#define vvll vector<vll>
#define vvvll vector<vvll>
#define vpii vector<pii>
#define vpll vector<pll>
#define vvpii vector<vpii>
#define vvpll vector<vpll>
#define pb(a) push_back(a)
#define m_p(a, b) make_pair(a, b)

template<typename _>
bool chmin(_ &a, _ b) {
    if (b < a) {
        a = b;
        return true;
    }
    else return false;
}

template<typename _>
bool chmax(_ &a, _ b) {
    if (b > a) {
        a = b;
        return true;
    }
    else return false;
}

mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());

const ll INFLL = 2e18 + 20;
const int INF = 1e9 + 20;
const ll MOD = 1e9+7;
const int N = 202020;
ll ans = 1;
ll bp(ll a, ll b){
    if(b == 0) return 1ll;
    ll t = bp(a, b / 2);
    return t * t % MOD * (b & 1 ? a : 1) % MOD;
}
ll inv(ll a) {return bp(a, MOD - 2);}
pll cur[N];
vi g[N];
int tin[N], tout[N], par[N], parent[N];
int ti;
void dfs(int v, int p){
    tin[v] = ti++;
    par[v] = p;
    for(auto to : g[v]){
        if(to == p) continue;
        dfs(to, v);
    }
    tout[v] = ti++;
}
int get(int a){
    if(parent[a] == a) return a;
    return parent[a] = get(parent[a]);
}
void merge(int a, int b){
    a = get(a);
    b = get(b);
    if(a == b) return;
    ll l1 = cur[a].fi;
    ll r1 = cur[a].se;
    ll l2 = cur[b].fi;
    ll r2 = cur[b].se;
    ans = ans * inv(r1-l1+1) % MOD;
    ans = ans * inv(r2-l2+1) % MOD;
    chmax(cur[a].fi, cur[b].fi);
    chmin(cur[a].se, cur[b].se);
    chmin(cur[a].fi, cur[a].se + 1);
    ans = ans * (cur[a].se - cur[a].fi + 1) % MOD;
    parent[b] = a;
}
bool is(int a, int b){
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}
vi go(int a, int b){
    vi res;
    while(1){
        res.pb(a);
        if(is(a, b)) break;
        a = par[a];
    }
    return res;
}
signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCALE
    freopen("input.txt", "r", stdin);
#endif

    int n;
    cin >> n;
    for(int i = 0; i < n; i++) parent[i] = i;

    for(int i = 1; i < n; i++){
        int p;
        cin >> p;
        p--;
        g[p].pb(i);
        g[i].pb(p);
    }
    for(int i = 0; i < n; i++){
        ll l, r;
        cin >> l >> r;
        cur[i] = {l, r};
        ans = ans * (r - l + 1) % MOD;
    }
    dfs(0, 0);
    int q;
    cin >> q;
    for(int i = 0; i < q; i++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        vi path1 = go(a, b);
        vi path2 = go(b, a);
        path2.pop_back();
        reverse(all(path2));

        vi path3 = go(c, d);
        vi path4 = go(d, c);
        path4.pop_back();
        reverse(all(path4));
        for(auto &j : path4) path3.pb(j);
        for(auto &j : path2) path1.pb(j);

        for(int j = 0; j < sz(path1); j++) {
            merge(path1[j], path3[j]);
        }
        cout << ans << "\n";
    }
}