#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = long double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 2e5 + 5;
vector<int> g[N];
int tin[N], tout[N];
int up[20][N], l[N], r[N];
int T = 1;
ll suml[N], sumr[N];


bool f(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

void dfs(int v) {
    tin[v] = T++;
    suml[v] += l[v];
    sumr[v] += r[v];
    for (int i = 1; i < 20; i++)
        up[i][v] = up[i - 1][up[i - 1][v]];
    for (auto i: g[v]) {
        suml[i] += suml[v];
        sumr[i] += sumr[v];
        dfs(i);
    }
    tout[v] = T++;
}

int LCA(int a, int b) {
    if (f(a, b)) return a;
    if (f(b, a)) return b;
    for (int i = 19; i >= 0; i--)
        if (!f(up[i][a], b))
            a = up[i][a];
    return up[0][a];
}

int path[N][2], rpath[N][2];
int t = 0, t2 = 0;

void split(int a, int b, int id) {
    t = 0, t2 = 0;
    int lca = LCA(a, b);
    while (a != lca) {
        path[t++][id] = a;
        a = up[0][a];
    }
    path[t++][id] = lca;
    while (b != lca) {
        rpath[t2++][id] = b;
        b = up[0][b];
    }
    for (int j = t2 - 1; j >= 0; j--)
        path[t++][id] = rpath[j][id];
}

int mul(int a, int b) {
    return (1ll * a * b) % MOD;
}

int binpow(ll a, ll b) {
    ll res = 1;
    a %= MOD;
    while (b > 0) {
        if (b % 2 == 1) res = (res * a) % MOD;
        a = (a * a) % MOD;
        b /= 2;
    }
    return res;
}


int p[N], l2[N], r2[N];

int get(int v) {
    if (v == p[v]) return v;
    return p[v] = get(p[v]);
}

int res = 1;

void join(int x, int y) {
    x = get(x), y = get(y);
    if (x == y) return;
    p[x] = y;
    res = mul(res, binpow(r2[y] - l2[y] + 1, MOD - 2));
    res = mul(res, binpow(r2[x] - l2[x] + 1, MOD - 2));
    relaxma(l2[y], l2[x]);
    relaxmi(r2[y], r2[x]);
    if(l2[y] > r2[y]) res = 0;
    else res = mul(res, r2[y] - l2[y] + 1);
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> up[0][i];
        up[0][i]--;
        g[up[0][i]].pb(i);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        res = mul(res, r[i] - l[i] + 1);
    }
    int q;
    cin >> q;
    for (int i = 0; i < n; i++) {
        l2[i] = l[i], r2[i] = r[i];
        p[i] = i;
    }
    for (int test = 0; test < q; test++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        if (res > 0) {
            split(a, b, 0);
            split(c, d, 1);
            for (int i = 0; i < t && res > 0; i++) {
                int v1 = path[i][0], v2 = path[i][1];
                join(v1, v2);
            }
        }
        cout << res << '\n';
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}