#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl '\n'
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;
const int N = 2e5;

ll lb[N];
ll rb[N];
int p[N];
vector<int> g[N];

int h[N];
int tin[N];
int tout[N];
int cnt = 0;

void dfs(int v) {
    tin[v] = cnt++;
    for (auto to : g[v]) {
        h[to] = h[v] + 1;
        dfs(to);
    }
    tout[v] = cnt++;
}

vector<int> solve2(int a, int b) {
    int f = 0;
    if (h[a] < h[b]) {
        swap(a, b);
        f  = 1;
    }

    vector<int> fp;
    int w = b;
    while (!(  tin[w] <= tin[a] && tout[w] >= tout[a]  )   ) {
        fp.push_back(w);
        w = p[w];
    }
    vector<int> vs;
    while (a != w) {
        vs.push_back(a);
        a = p[a];
    }
    vs.push_back(a);
    reverse(all(vs));
    for (auto x : vs) {
        fp.push_back(x);
    }

    if (f) {
        reverse(all(fp));
    }
    return fp;
}

void solve() {
    int n, m;
    cin >> n;

    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }

    vector<int> k(n);
    vector<vector<int>> km(n);
    for (int i = 0; i < n; i++) {
        cin >> lb[i] >> rb[i];
        k[i] = i;
        km[i].push_back(i);
    }

    dfs(0);


    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;

        vector<int> fp = solve2(a, b);
        vector<int> sp = solve2(c, d);

        for (int i = 0; i < fp.size(); i++) {
            int x = fp[i], y = sp[i];
            if (k[x] == k[y]) {
                continue;
            }
            ll l = max(lb[x], lb[y]), r = min(rb[x], rb[y]);
            if (l > r) {
                cout << 0 << endl;
                while (m--) {
                    cout << 0 << endl;
                }
                return;
            }
            if (km[k[x]].size() < km[k[y]].size()) {
                swap(x, y);
            }
            for (auto z : km[y]) {
                k[z] = k[x];
                km[k[x]].push_back(z);
            }

            lb[x] = l;
            lb[y] = l;
            rb[x] = r;
            rb[y] = r;
        }
        ll ans = 1;
        for (int i = 0; i < n; i++) {
            if (k[i] != i) {
                continue;
            }
            if (rb[i] < lb[i]) {
                cout << 0 << endl;
                while (m--) {
                    cout << 0 << endl;
                }
                return;
            }
            ans = (ans * (rb[i] - lb[i] + 1)) % MOD;
        }
        cout << ans << endl;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
