#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }

typedef pair <int, int> pii;
typedef long double ld;

const int N = 3e5 + 10;
vector <int> g[N];
int l[N], r[N];
int dp[N][2], up[N][20], tin[N], tout[N], tim = 0, par[N];
int dep[N];
int dpa[N];

inline void dfs (int v, int p) {
    tin[v] = tim++;
    up[v][0] = p; par[v] = p;
    for (int i = 1; i < 20; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto u : g[v]) {
        if (u == p) continue;
        dep[u] = dep[v] + 1;
        dfs(u, v);
    }
    tout[v] = tim++;
}
inline bool is  (int a, int b) { return tin[a] <= tin[b] && tout[a] >= tout[b]; }
inline int lca (int a, int b) {
    if (is(a, b)) return a;
    if (is(b, a)) return b;
    for (int i = 19; ~i; --i) if (!is(up[a][i], b)) a = up[a][i];
    return up[a][0];
}

const int mod = 1e9 + 7;
inline int add (int a, int b) { a += b; if (a >= mod) a -= mod; return a; }
inline int mul (int a, int b) { return (a * 1ll * b) % mod; }

inline void solve () {
    int n; cin >> n;
    for (int i = 1; i < n; ++i) {
        int p; cin >> p; --p;
        g[i].pb(p); g[p].pb(i);
    }
    for (int i = 0; i < n; ++i) cin >> l[i] >> r[i];
    for (int i = 0; i < n; ++i) {
        int x = r[i] - l[i] + 1;
        int xx = x / 2;
        int xxx = x - xx;
        if (l[i] % 2 == 0) dp[i][0] = xxx, dp[i][1] = xx;
        else dp[i][1] = xxx, dp[i][0] = xx;
        dpa[i] = x;
    }

    dfs(0, 0);

    int q; cin >> q;
    for (int it = 0; it < q; ++it) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        int ab = lca(a, b), cd = lca(c, d);
        vector <int> pathab, pathcd;
        while (a != ab) {
            pathab.pb(a);
            a = par[a];
        }
        vector <int> half;
        while (b != ab) {
            half.pb(b);
            b = par[b];
        }
        reverse(all(half));
        pathab.pb(ab); for (auto i : half) pathab.pb(i); half.clear();

        while (c != cd) {
            pathcd.pb(c);
            c = par[c];
        }
        while (d != cd) {
            half.pb(d);
            d = par[d];
        }
        reverse(all(half));
        pathcd.pb(cd); for (auto i : half) pathcd.pb(i); half.clear();

        assert(sz(pathab) == sz(pathcd));

        for (int i = 0; i < sz(pathab); ++i) {
            int v1 = pathab[i], v2 = pathcd[i];
            int m = min(dp[v1][0], dp[v2][0]);
            int mm = min(dp[v1][1], dp[v2][1]);

            dp[v1][0] = dp[v2][0] = m;
            dp[v1][1] = dp[v2][1] = mm;
            dpa[v1] = dpa[v2] = max(m, mm);
        }

        int ans = 1;
        for (int i = 0; i < n; ++i) {
            ans = mul(ans, dpa[i]);
        }
        cout << ans << endl;
    }
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
