#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

const int mod = 1e9 + 7;
const int N = 200200, P = 200227;
int n, m;
vvi g(N);
int a[N], b[N], c[N], d[N], par[N], _sz[N], can[N], cur_p[N], p[N], st[N], st_inv[N];
pii diap[N];
set <int> cont[N];
int ans = 1;

int bp (int x, int st) {
    if (st == 0) {
        return 1ll;
    }

    int t = bp(x, st / 2);
    t *= t;
    t %= mod;
    if (st & 1) {
        t *= x;
    }
    return t % mod;
}


int inv (int x) {
    return bp(x, mod - 2);
}

pii inters (pii a, pii b) {
    if (a.F > b.S || b.F > a.S) {
        return {0, -1};
    }

    if (a.S < b.S) {
        swap(a, b);
    }

    if (a.S == -1 || b.S == -1) {
        return {0, -1};
    }

    int nr = min(a.S, b.S);
    int nl = max(a.F, b.F);
    return {nl, nr};
}

int get_p(int v) {
    if (par[v] == v) {
        return v;
    }
    return (par[v] = get_p(par[v]));
}

void _union (int u, int v) {
    u = get_p(u);
    v = get_p(v);
    if (u == v) {
        return;
    }

    if (_sz[u] > _sz[v]) {
        swap(u, v);
    }

    ans *= inv(can[u]); ans %= mod;
    ans *= inv(can[v]); ans %= mod;

    diap[v] = inters(diap[v], diap[u]);
    can[v] = diap[v].S - diap[v].F + 1;
    ans *= can[v]; ans %= mod;

    par[u] = v;
    _sz[v] += _sz[u];

    for (auto i : cont[u]) {
        cont[v].insert(i);
        par[i] = v;
//        upd (1, 1, n, i, par[i]);
    }
}

void dfs3000 (int v, int pr) {
    for (auto i : g[v]) {
        if (i == pr) {
            continue;
        }
        cur_p[i] = v;
        dfs3000 (i, v);
    }
}
void solve3000 () {
    for (int i = 1; i <= m; i++) {
        for (int j = 1; j <= n; j++) {
            cur_p[j] = j;
        }
        dfs3000 (a[i], a[i]);

        int v = b[i];
        vi vec1;
        vec1.pb(v);
        while (v != a[i]) {
            v = cur_p[v];
            vec1.pb(v);
        }
        reverse(all(vec1));

        for (int j = 1; j <= n; j++) {
            cur_p[j] = j;
        }
        dfs3000 (c[i], c[i]);

        v = d[i];
        vi vec2;
        vec2.pb(v);
        while (v != c[i]) {
            v = cur_p[v];
            vec2.pb(v);
        }
        reverse(all(vec2));

        for (int i = 0; i < vec1.sz; i++) {
            _union (vec1[i], vec2[i]);
        }

        cout << ans << "\n";
    }
}


/*
void upd (int v, int l, int r, int pos, int val) {
    if (l > pos || r < pos) {
        return;
    }

    if (l == r) {

    }
}

void _union (int u, int v) {
    u = get_p(u);
    v = get_p(v);
    if (u == v) {
        return;
    }

    if (_sz[u] > _sz[v]) {
        swap(u, v);
    }

    ans *= inv(can[u]); ans %= mod;
    ans *= inv(can[v]); ans %= mod;

    diap[v] = inters(diap[v], diap[u]);
    can[v] = diap[v].S - diap[v].F + 1;
    ans *= can[v]; ans %= mod;

    par[u] = v;
    _sz[v] += _sz[u];

    for (auto i : cont[u]) {
        cont[v].insert(i);
        par[i] = v;
        upd (1, 1, n, i, par[i]);
    }
}*/



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].pb(i);
        g[i].pb(p[i]);

    }


    st[0] = 1;
    st_inv[0] = 1;
    for (int i = 1; i <= n; i++) {
        st[i] = st[i - 1] * P; st[i] %= mod;
        st_inv[i] = inv(st[i]);
    }

    for (int i = 1; i <= n; i++) {
        _sz[i] = 1, par[i] = i;
        cont[i].insert(i);
//        upd (1, 1, n, i, par[i]);
//        upd (1, 1, n, i, par[i]);
    }


    for (int i = 1; i <= n; i++) {
        cin >> diap[i].F >> diap[i].S;
        can[i] = diap[i].S - diap[i].F + 1;
        ans *= can[i];
        ans %= mod;
    }

    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> a[i] >> b[i] >> c[i] >> d[i];
    }

    if (n <= 3000 && m <= 3000) {
        solve3000();
        return 0;
    }

//    for (   )
//    for ()


}
