#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution <ll> uid;
    return uid(rng) % n;
}

int l[200010], r[200010];
ll ans = 1;
const ll mod = 1e9 + 7;

ll binpow(ll x, int k) {
    if (k == 0)
        return 1;
    ll ret = binpow(x, k / 2);
    ret = ret * ret % mod;
    if (k & 1)
        ret = ret * x % mod;
    return ret;
}

int p[200010];
int get(int x) {
    if (x == p[x])
        return x;
    return p[x] = get(p[x]);
}
void merge(int x, int y) {
    x = get(x), y = get(y);
    if (x == y)
        return;
    ans = ans * binpow(ll(r[x] - l[x] + 1) * (r[y] - l[y] + 1) % mod, mod - 2) % mod;
    p[x] = y;
    l[y] = max(l[y], l[x]);
    r[y] = min(r[y], r[x]);
    if (l[y] > r[y])
        ans = 0;
    ans = ans * (r[y] - l[y] + 1) % mod;
}

int n;
int pr[200010], h[200010];
vector <int> g[200010];
int tmr = 0;
int tin[200010], tout[200010];

void dfs(int s) {
    tin[s] = tmr;
    tmr++;
    for (auto& e : g[s]) {
        h[e] = h[s] + 1;
        dfs(e);
    }
    tout[s] = tmr;
    tmr++;
}

vector <int> f(int a, int b) {
    vector <int> res, res2;
    while (!(tin[a] <= tin[b] && tout[a] >= tout[b])) {
        res.push_back(a);
        a = pr[a];
    }
    res.push_back(a);
    while (!(tin[b] <= tin[a] && tout[b] >= tout[a])) {
        res2.push_back(b);
        b = pr[b];
    }
    reverse(res2.begin(), res2.end());
    for (auto& el : res2)
        res.push_back(el);
    return res;
}

void solve() {
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> pr[i];
        pr[i]--;
        g[pr[i]].push_back(i);
    }
    dfs(0);
    for (int i = 0; i < n; i++) {
        cin >> l[i] >> r[i];
        ans = ans * (r[i] - l[i] + 1) % mod;
        p[i] = i;
    }
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector <int> v1 = f(a, b), v2 = f(c, d);
        for (int i = 0; i < v1.size(); i++)
            merge(v1[i], v2[i]);
        cout << ans << endl;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
