#include <bits/stdc++.h>
#define int long long
#define double long double
#define f first
#define s second

using namespace std;

int md = 1000000007;
const int maxn = (1 <<18);
vector <int> h(maxn, 0);

int get(int v)
{
    if(v == h[v])
        return v;
    h[v] = get(h[v]);
    return h[v];
}


int bp(int a, int st){
    if(st == 0)
        return 1;
    if(st == 1)
        return a;
    int b = bp(a, st/2);
    b = (b * b) % md;
    return  b * bp(a, st % 2) % md;
}

vector <int> hv(maxn, 0), g[maxn], p(maxn);

void counthv(int v = 0)
{
    for(auto u:g[v]){
        hv[u] = hv[v] + 1;
        counthv(u);
    }
}

vector <int> path(int a, int b)
{
    vector <int> alca, blca;
    while(hv[a] > hv[b]){
        alca.push_back(a);
        a = p[a];
    }
    while(hv[a] < hv[b]){
        blca.push_back(b);
        b = p[b];
    }
    while(a != b){
        alca.push_back(a);
        blca.push_back(b);
        a = p[a], b = p[b];
    }
    alca.push_back(a);
    reverse(blca.begin(), blca.end());
    vector <int> ans = alca;
    for(auto c:blca)
        ans.push_back(c);
    return ans;

}



signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie();
    cout.tie();
    int n, m;
    cin >> n;
    p[0] = 0;
    for(int i = 1; i < n; ++i) {
        cin >> p[i], h[i] = i, p[i]--;
        g[p[i]].push_back(i);
    }

    vector <int> l(n), r(n);
    int ans = 1;
    for(int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
        ans *= (r[i] - l[i] + 1);
        ans %= md;
    }
    cin >> m;
    counthv();
    //path(0, 1);
    while(m--){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector <int> ab = path(a, b);
        vector <int> cd = path(c, d);
        for(int i = 0; i < ab.size(); ++i){
            int ha = get(ab[i]), hc = get(cd[i]);
            if(ha == hc)
                continue;
            if(l[ha] < r[ha]) {
                ans *= bp(r[ha] - l[ha] + 1, md - 2);
                ans %= md;
            }
            if(l[hc] < r[hc]) {
                ans *= bp(r[hc] - l[hc] + 1, md - 2);
                ans %= md;
            }
            if(ha > hc){
                l[hc] = max(l[hc], l[ha]);
                r[hc] = min(r[hc], r[ha]);
                h[ha] = hc;
                if(l[hc] <= r[hc] )ans *= (r[hc] - l[hc] + 1);
                else
                    ans = 0;
                ans %= md;
            }
            else{
                l[ha] = max(l[hc], l[ha]);
                r[ha] = min(r[hc], r[ha]);
                h[hc] = ha;
                if(l[ha] <= r[ha]) ans *= (r[ha] - l[ha] + 1);
                else ans = 0;
                ans %= md;
            }
        }
        cout << ans << '\n';
    }
    return 0;
}
