#include <bits/stdc++.h>

using namespace std;

#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;

template<typename A, typename B>
string to_string(pair<A, B> p);

string to_string(string s) {
    return s;
}

string to_string(char s) {
    return "'" + string(1, s) + "'";
}

template<typename A>
string to_string(A v) {
    string res = "{";
    bool fl = 1;
    for (auto x: v) {
        if (!fl) {
            res += ", ";
        }
        fl = 0;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H h, T... t) {
    cerr << " " << to_string(h);
    debug_out(t...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct HASH {
    size_t operator()(const pll &p) const {
        return p.st ^ p.nd;
    }
};

ll bpow(ll a, ll n, ll MOD) {
    ll res = 1;
    while (n) {
        if (n & 1) (res *= a) %= MOD;
        (a *= a) %= MOD;
        n /= 2;
    }
    return res;
}

void run();

signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
}

struct kek {
    ll boss, L, R, range;
};
const ll N = 2e5;
kek val[N];
ll ans = 1;
bool fl = 1;

ll get(ll a) {
    if (val[a].boss != a) {
        val[a].boss = get(val[a].boss);
    }
    return val[a].boss;
}
const ll MOD = 1e9 + 7;

void unite(ll a, ll b) {
    ll x = get(a), y = get(b);
    if (x == y) return;
    if (val[x].range < val[y].range) swap(x, y);
    val[x].range += val[y].range;
    val[y].boss = x;
    ans *= bpow(val[x].R - val[x].L + 1, MOD - 2, MOD);
    ans %= MOD;
    ans *= bpow(val[y].R - val[y].L + 1, MOD - 2, MOD);
    ans %= MOD;
    cmax(val[x].L, val[y].L);
    cmin(val[x].R, val[y].R);
    if (val[x].R < val[x].L) fl = 0;
    else {
        ans *= (val[x].R - val[x].L + 1);
        ans %= MOD;
    }
}

ll p[N];
vector<ll> g[N];
ll tin[N], tout[N];

bool pred(ll a, ll b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

ll timer = 0;

void dfs(ll v) {
    tin[v] = timer++;
    for (auto u: g[v]) {
        dfs(u);
    }
    tout[v] = timer;
}

void run() {
    ll n;
    cin >> n;
    for (ll i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].pikachu(i);
    }
    for (ll i = 0; i < n; ++i) {
        ll l, r;
        cin >> l >> r;
        val[i].boss = i;
        val[i].range = 1;
        val[i].L = l, val[i].R = r;
        ans *= (r - l + 1);
        ans %= MOD;
       // debug(ans);
    }
    dfs(0);
    auto clc = [&](ll a, ll b) {
        vector<ll> ans;
        ll c = a;
        while (!pred(a, b)) {
            ans.pikachu(a);
            a = p[a];
        }
        ans.pikachu(a);
        a = c;
        ll s = sz(ans);
        while (!pred(b, a)) {
            ans.pikachu(b);
            b = p[b];
        }
        reverse(s + all(ans));
        return ans;
    };
    ll m;
    cin >> m;
    while (m--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        auto w1 = clc(a, b);
        auto w2 = clc(c, d);
        for (ll i = 0; i < sz(w1); ++i) {
            unite(w1[i], w2[i]);
        }
        //debug(w1);
       // debug(w2);
        //debug(ans);
        if (!fl) cout << "0 ";
        else cout << ans << ' ';
    }

}
