#include<bits/stdc++.h>

using namespace std;

#define ll long long

vector<vector<ll>> gr;
vector<pair<ll, ll>> a;
vector<ll> d1;

void dfs(ll v, ll p = -1, ll d = 0) {
    d1[v] = d;
    for (auto u : gr[v]) {
        if (u != p) {
            dfs(u, v, d + 1);
        }
    }
}

vector<ll> a1;
ll mod = 1e9 + 7;
set<ll> s1;
map<ll, pair<ll, ll>> m2;

ll f(ll u) {
    if (a1[u] == u) {
        return u;
    }
    return a1[u] = f(a1[u]);
}

void f1(ll u, ll v) {
    u = f(u);
    v = f(v);
    if (u != v) {
        a1[u] = v;
        s1.erase(u);
        m2[v].first = max(m2[v].first, m2[u].first);
        m2[v].second = min(m2[v].second, m2[u].second);
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    gr.resize(n);
    for (ll i = 1; i < n; i++) {
        ll x;
        cin >> x;
        x--;
        gr[i].push_back(x);
        gr[x].push_back(i);
    }
    a.resize(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    d1.resize(n);
    dfs(0);
    a1.resize(n);
    for (ll i = 0; i < n; i++) {
        a1[i] = i;
        m2[i] = a[i];
        s1.insert(i);
    }
    ll m;
    cin >> m;
    while (m--) {
        ll x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--;
        y1--;
        x2--;
        y2--;
        vector<ll> p1;
        vector<ll> dist1(n, 1e18);
        queue<ll> q1;
        vector<ll> prev1(n, -1);
        q1.push(x1);
        dist1[x1] = 0;
        while (!q1.empty()) {
            ll u = q1.front();
            q1.pop();
            for (auto v : gr[u]) {
                if (dist1[v] > dist1[u] + 1) {
                    dist1[v] = dist1[u] + 1;
                    q1.push(v);
                    prev1[v] = u;
                }
            }
        }
        ll u1 = y1;
        while (u1 != -1) {
            p1.push_back(u1);
            u1 = prev1[u1];
        }
        reverse(p1.begin(), p1.end());
        vector<ll> p2;
        vector<ll> dist2(n, 1e18);
        queue<ll> q2;
        vector<ll> prev2(n, -1);
        q2.push(x2);
        dist2[x2] = 0;
        while (!q2.empty()) {
            ll u = q2.front();
            q2.pop();
            for (auto v : gr[u]) {
                if (dist2[v] > dist2[u] + 1) {
                    dist2[v] = dist2[u] + 1;
                    q2.push(v);
                    prev2[v] = u;
                }
            }
        }
        ll u2 = y2;
        while (u2 != -1) {
            p2.push_back(u2);
            u2 = prev2[u2];
        }
        reverse(p2.begin(), p2.end());
        for (ll i = 0; i < min(p1.size(), p2.size()); i++) {
            f1(p1[i], p2[i]);
        }
        ll answer = 1;
        for (auto elem : s1) {
            if (m2[elem].first > m2[elem].second) {
                answer = 0;
                break;
            }
            answer *= (m2[elem].second - m2[elem].first + 1);
            answer = answer % mod;
        }
        cout << answer << endl;
    }
}
