#include <bits/stdc++.h>

#define ll long long
#define int long long
#define pii pair <int, int>
#define x first
#define y second
#define all(x) x.begin(), x.end()
#define sz(x) (int)(x.size())
using namespace std;




int t = 0, mod = 1e9 + 7, ans = 1;
vector <vector <ll> > v;
vector <ll> p, tin, tout, used, par, l, used1;
vector <pii> gr, new_gr;

ll get_par(int h) {
    if (par[h] == -1) {
        return h;
    }
    return par[h] = get_par(par[h]);
}

void merge(int h1, int h2) {
    if (l[h1] > l[h2]) {
        par[h2] = h1;
        l[h1] += l[h2];
        new_gr[h1].x = max(new_gr[h1].x, new_gr[h2].x);
        new_gr[h1].y = min(new_gr[h1].y, new_gr[h2].y);
    }
    else {
        par[h1] = h2;
        l[h2] += l[h1];
        new_gr[h2].x = max(new_gr[h1].x, new_gr[h2].x);
        new_gr[h2].y = min(new_gr[h1].y, new_gr[h2].y);
    }
}

ll bin_pow(int x, int pw) {
    if (!pw) return 1;
    ll tmp = bin_pow(x, pw / 2);
    tmp = (tmp * tmp) % mod;
    if (pw & 1) {
        tmp = (tmp * x) % mod;
    }
//    cout << tmp << " " << pw << endl;
    return tmp;
}

void dfs(int h) {
    tin[h] = t;
    for (auto c : v[h]) {
        t++;
        dfs(c);
    }
    tout[h] = t;
}

ll get_ans(int a, int b, int c, int d) {
    ll tmp = 1, other = 1;
    vector <ll> v1, v2, v3, v4;
    while (!(tin[a] <= tin[b] && tout[b] <= tout[a])) {
        v1.push_back(a);
        a = p[a];
    }
    v1.push_back(a);
//    cout << a << endl;
    while (b != a) {
        v2.push_back(b);
        b = p[b];
    }
    for (int i = sz(v2) - 1; i >= 0; i--) {
        v1.push_back(v2[i]);
    }
    v2.clear();
    while (!(tin[c] <= tin[d] && tout[d] <= tout[c])) {
        v3.push_back(c);
        c = p[c];
    }
    v3.push_back(c);
    while (d != c) {
        v4.push_back(d);
        d = p[d];
    }
    for (int i = sz(v4) - 1; i >= 0; i--) {
        v3.push_back(v4[i]);
    }
    v4.clear();

    for (int i = 0; i < sz(v1); i++) {
        int h1 = get_par(v1[i]), h2 = get_par(v3[i]);
        if (h1 != h2) {
            merge(h1, h2);
        }
//        cout << v1[i] << " " << v3[i] << "   " << h1 << " " << h2 << endl;
//        int l1 = gr[v1[i]].x, r1 = gr[v1[i]].y, l2 = gr[v3[i]].x, r2 = gr[v3[i]].y;
//        if (used[v1[i]] && used[v3[i]]) continue;
//        used[v1[i]] = 1;
//        used[v3[i]] = 1;
//        new_gr[v1[i]].x = max(new_gr[v1[i]].x, new_gr[v3[i]].x);
//        new_gr[v1[i]].y = min(new_gr[v1[i]].y, new_gr[v3[i]].y);
//        new_gr[v3[i]].x = max(new_gr[v3[i]].x, new_gr[v1[i]].x);
//        new_gr[v3[i]].y = min(new_gr[v3[i]].y, new_gr[v1[i]].y);
    }
    for (int i = 0; i < sz(v1); i++) {
        int h1 = get_par(v1[i]);
        if (!used[h1]) {
            tmp = (tmp * (new_gr[h1].y - new_gr[h1].x + 1)) % mod;
            used[h1] = 1;
        }
        if (!used1[v1[i]]) {
            other = (other * (gr[v1[i]].y - gr[v1[i]].x + 1)) % mod;
        }
        if (!used1[v3[i]]) {
            other = (other * (gr[v3[i]].y - gr[v3[i]].x + 1)) % mod;
        }
//        if (!used[v1[i]] && !used[v3[i]]) {
//            tmp = (tmp * max((new_gr[v1[i]].y - new_gr[v1[i]].x + 1), 0ll)) % mod;
//        }
        used1[v1[i]] = 1;
        used1[v3[i]] = 1;
    }
    for (int i = 0; i < sz(v1); i++) {
        used1[v1[i]] = 0;
        used1[v3[i]] = 0;
        int h1 = get_par(v1[i]);
        used[h1] = 0;
    }
//    for (int i = 0; i < sz(v1); i++) {
//        cout << v1[i] << " ";
//    }
//    cout << endl;
//    for (int i = 0; i < sz(v3); i++) {
//        cout << v3[i] << " ";
//    }
//    cout << endl;
//    cout << ans << " " << tmp << " " << other << endl;
//    cout << ((ans * bin_pow(other, mod - 2)) % mod * tmp) % mod << endl;
    return ((ans * bin_pow(other, mod - 2)) % mod * tmp) % mod;
}


signed main() {
    ll n;
    cin >> n;
    v.resize(n); p.resize(n); tin.resize(n);
    tout.resize(n); gr.resize(n); new_gr.resize(n); used.resize(n);
    used1.resize(n); l.resize(n, 1); par.resize(n, -1);
    for (int i = 1; i < n; i++) {
        cin >> p[i]; p[i]--;
        v[p[i]].push_back(i);
    }
    for (int i = 0; i < n; i++) {
        cin >> gr[i].x >> gr[i].y;
        new_gr[i] = gr[i];
        ans = (ans * (gr[i].y - gr[i].x + 1)) % mod;
    }
    dfs(0);
    ll m;
    cin >> m;
    while (m--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d; a--; b--; c--; d--;
        cout << get_ans(a, b, c, d) << endl;
    }
}
