#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<cmath>
#include<vector>
#include<set>
#include<map>
#include<iomanip>
#include<algorithm>
using namespace std;
struct point {
	int l;
	int r;
};
int mod = 1e9 + 7;
vector <int> pr;
vector <int> sz;
vector <point> f;
point peresech(point a, point b) {
	point c;
	c.l = max(a.l, b.l);
	c.r = min(a.r, b.r);
	return c;
}
int find_parent(int x) {
	if (x == pr[x]) {
		return x;
	}
	else {
		return pr[x] = find_parent(pr[x]);
	}
}
void join(int v, int u) {
	v = find_parent(v);
	u = find_parent(u);
	if (u == v) return;
	if (sz[u] > sz[v]) {
		swap(u, v);
	}
	sz[v] += sz[u];
	pr[u] = v;
	f[v] = peresech(f[u], f[v]);
	return;
}
int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	int n, m;
	cin >> n;
	vector <int> p(n);
	for (int i = 0; i < n - 1; i++) {
		cin >> p[i];
	}
	vector <point> a(n);
	for (int i = 0; i < n; i++) {
		cin >> a[i].l >> a[i].r;
	}
	cin >> m;
	int x, y, u, v;
	sz.resize(n);
	pr.resize(n);
	f.resize(n);
	for (int i = 0; i < n; i++) {
		sz[i] = 1;
		pr[i] = i;
		f[i] = a[i];
	}
	for (int i = 0; i < m; i++) {
		cin >> x >> y >> u >> v;
		x--;
		y--;
		u--;
		v--;
		if (x < y) {
			if (u < v) {
				for (int j = 0; j < y - x + 1; j++) {
					join(x + j, v + j);
				}
			}
			else {
				for (int j = 0; j < y - x + 1; j++) {
					join(x + j, v - j);
				}
			}
		}
		else {
			if (u < v) {
				for (int j = 0; j < x - y + 1; j++) {
					join(x - j, v + j);
				}
			}
			else {
				for (int j = 0; j < x - y + 1; j++) {
					join(x - j, v - j);
				}
			}
		}
	}
	long long count = 1;
	vector <bool> used(n, false);
	for (int i = 0; i < n; i++) {
		int t = find_parent(i);
		if (!used[t]) {
			if (f[t].r < f[t].l) {
				count = 0;
			}
			count = count * 1ll * (f[t].r - f[t].l + 1) % mod;
			used[t] = true;
		}
	}
	cout << count;
	return 0;
}