#include<iostream>
#include<vector>
#include<algorithm>
#include<queue>
using namespace std;
int parent[200000],sz[200000];
const int mod=1e9+7;
long long int ans;
int l,r;
vector<int>adj[200001],cadj[200001],d(200001);
vector<bool>vis(200001);
vector<pair<int,int>>interval(200001);
void setting(int x)
{
    parent[x]=x;
    sz[x]=1;
}
int find_parent(int x)
{
    if(parent[x]==x)return x;
    return parent[x]=find_parent(parent[x]);
}
void align(int a,int b)
{
    a=find_parent(a),b=find_parent(b);
    if(a==b)return;
    if(sz[a]<sz[b])swap(a,b);
    parent[b]=a;
    sz[a]+=sz[b];
}
vector<int>path(int s,int f,int n)
{
  vector<int>res;
  for(int i=0;i<n;i++)vis[i]=false;
  queue<int>q;
  d[s]=0,vis[s]=true,q.push(s);
  while(!q.empty())
  {
      int x=q.front();q.pop();
      for(auto y:adj[x])if(!vis[y])vis[y]=true,d[y]=d[x]+1,q.push(y);
  }
  int x=f;
  while(d[x])
  {
      res.push_back(x);
      for(auto y:adj[x])if(d[y]==d[x]-1){x=y;break;}
  }
  res.push_back(s);
  reverse(res.begin(),res.end());
  return res;
}
void dfs(int x)
{
    if(vis[x])return;
    vis[x]=true;
    l=max(l,interval[x].first),r=min(r,interval[x].second);
    for(auto y:cadj[x])dfs(y);
}
int main()
{
  int n,m,i,temp,a,b,c,d;
  cin>>n;
  vector<int>ansa,ansb;
  for(i=0;i<n-1;i++)cin>>temp,temp--,adj[i+1].push_back(temp),adj[temp].push_back(i+1);
  for(i=0;i<n;i++)cin>>interval[i].first>>interval[i].second;
  for(i=0;i<n;i++)setting(i);
  cin>>m;
  while(m--)
  {
      cin>>a>>b>>c>>d,a--,b--,c--,d--;
      ansa=path(a,b,n),ansb=path(c,d,n);
      for(i=0;i<ansa.size();i++)align(ansa[i],ansb[i]);
      ans=1;
      for(i=0;i<n;i++)vis[i]=false;
      vector<pair<int,int>>diff(n,{-1e9,1e9});
      for(i=0;i<n;i++)
      {
          diff[find_parent(i)].first=max(diff[find_parent(i)].first,interval[i].first);
          diff[find_parent(i)].second=min(diff[find_parent(i)].second,interval[i].second);
      }
      for(i=0;i<n;i++)if(diff[i].first>=0)ans*=max(0,diff[i].second-diff[i].first+1),ans%=mod;
      cout<<ans<<endl;
  }
}