#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<int>> g;
vector<int> tin, tout;
vector<int> p;
vector<bool> used;
vector<int> path;
vector<pair<int, int>> cost;

int tms = 0;

void df(int v) {
    used[v] = true;
    tin[v] = tms++;
    for (auto &u : g[v]) {
        if (!used[u]) {
            df(u);
        }
    }
    tout[v] = tms++;
}

bool check_p(int v, int u) {
    return tin[v] <= tin[u] && tout[v] >= tout[u];
}

void dfs(int v, int u) {
    path.push_back(v);
    if (v == u) {
        return;
    }
    if (check_p(v, u)) {
        for (auto &i : g[v]) {
            if (i != p[v] && check_p(i, u)) {
                dfs(i, u);
                return;
            }
        }
    }
    dfs(p[v], u);
}

ll mod = 1e9 + 7;

ll binpow(ll a, int n) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        ll b = binpow(a, n / 2);
        return b * b % mod;
    }
    ll b = binpow(a, n / 2);
    return a * (b * b % mod) % mod;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    p.resize(n);
    g.resize(n);
    tin.resize(n);
    tout.resize(n);
    used.resize(n);
    cost.resize(n);
    for (int i = 1; i < n; ++i) {
        int v;
        cin >> v;
        --v;
        g[v].push_back(i);
        g[i].push_back(v);
        p[i] = v;
    }
    ll ans = 1;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        ++r;
        cost[i] = {l, r};
        ans = (ans * (r - l)) % mod;
    }
    df(0);
    int m;
    cin >> m;
//    vector<vector<bool>> us(n, vector<bool> (n));
    vector<set<int>> ed(n);
    vector<int> vis(n);
    for (int i = 0; i < n; ++i) {
        vis[i] = i;
    }
    for (int i = 0; i < m; ++i) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        if (ans == 0) {
            cout << 0 << '\n';
            continue;
        }
        --a;
        --b;
        --c;
        --d;
        path.clear();
        dfs(a, b);
        vector<int> path2 = path;
        path.clear();
        dfs(c, d);
        for (int j = 0; j < path.size(); ++j) {
            int l1, l2, r1, r2;
            l1 = cost[path[j]].first;
            r1 = cost[path[j]].second;
            l2 = cost[path2[j]].first;
            r2 = cost[path2[j]].second;
            if (min(r1, r2) <= max(l1, l2)) {
                ans = 0;
            } else {
//                if (!vis[path[j]]) {
//                    ans = ans * binpow(r1 - l1, mod - 2) % mod;
//                }
//                if (!vis[path2[j]]) {
//                    ans = ans * binpow(r2 - l2, mod - 2) % mod;
//                }
//                if (vis[path[j]] && vis[path2[j]]) {
//                    ans = ans * binpow(r1 - l1, mod - 2) % mod;
//                }
                if (vis[path[j]] == vis[path2[j]]) {
                    ans = ans * binpow(r1 - l1, mod - 2) % mod;
                } else {
                    ans = ans * binpow(r1 - l1, mod - 2) % mod;
                    ans = ans * binpow(r2 - l2, mod - 2) % mod;
                }
                set<int> cop = ed[path[j]];
                for (auto &q : ed[path2[j]]) {
                    ed[path[j]].insert(q);
                }
                for (auto &q : cop) {
                    ed[path2[j]].insert(q);
                }
                ed[path2[j]].insert(path[j]);
                ed[path[j]].insert(path2[j]);
                for (auto &q : ed[path[j]]) {
                    cost[q] = {max(l1, l2), min(r1, r2)};
                    vis[q] = vis[path2[j]];
                }
                for (auto &q : ed[path2[j]]) {
                    cost[q] = {max(l1, l2), min(r1, r2)};
                    vis[q] = vis[path2[j]];
                }
//                cost[path[j]] = {max(l1, l2), min(r1, r2)};
//                cost[path2[j]] = {max(l1, l2), min(r1, r2)};
//                ans = ans * (-max(l1, l2) + min(r1, r2)) % mod;
                ans = ans * (-max(l1, l2) + min(r1, r2)) % mod;
//                if (!vis[path[j]] && !vis[path2[j]]) {
//                    vis[path2[j]] = true;
//                    vis[path[j]] = true;
//                }
            }
        }
        cout << ans << '\n';
    }
    return 0;
}