#include <bits/stdc++.h>
#include <bits/extc++.h>
using namespace     std;
using namespace     __gnu_pbds;
#define int         long long
#define popcnt      __builtin_popcount
#define clz         __builtin_clz
#define ctz         __builtin_ctz
using ordered_set = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;
vector<int> g[200000];
int p[200000], tin[200000], tout[200000], up[200000][25], l[200000], r[200000], dsu[200000], timer = 0;
void dfs(int v, int p) {
    tin[v] = timer++;
    up[v][0] = p == -1 ? v : p;
    for (int i = 1; i < 25; ++i) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    for (auto e : g[v]) {
        if (e != p) {
            dfs(e, v);
        }
    }
    tout[v] = timer++;
}
bool is_ancestor(int u, int v) {
    return tin[v] >= tin[u] && tout[v] <= tout[u];
}
int lca(int v, int u) {
    if (is_ancestor(v, u))
        return v;
    if (is_ancestor(u, v))
        return u;
    for (int i = 24; i >= 0; --i) {
        if (!is_ancestor(up[v][i], u))
            v = up[v][i];
    }
    return up[v][0];
}
vector<int> restore_path(int u, int v) {
    int s = lca(v, u);
    vector<int> path;
    while (u != s) {
        path.push_back(exchange(u, p[u]));
    }
    path.push_back(s);
    vector<int> h;
    while (v != s) {
        h.push_back(exchange(v, p[v]));
    }
    path.insert(path.end(), h.rbegin(), h.rend());
    return path;
}
int getcomp(int x) {
    return x == dsu[x] ? x : dsu[x] = getcomp(dsu[x]);
}
bool same(int x, int y) {
    return getcomp(x) == getcomp(y);
}
void unite(int x, int y) {
    x = getcomp(x);
    y = getcomp(y);
    if (x == y) return;
    dsu[x] = y;
}
struct modular {
    int val;
    void norm() {
        val = (val % 1000000007 + 1000000007) % 1000000007;
    }
    modular(int x) {
        val = x;
        norm();
    }
    static modular binexp(modular x, int y) {
        if (y == 0)
            return 1;
        if (y & 1)
            return binexp(x, y ^ 1) * x;
        auto res = binexp(x, y >> 1);
        return res * res;
    }
    modular inv() {
        return binexp(val, 1000000005);
    }
    friend modular operator+(modular x, modular y) {
        x.val += y.val;
        x.norm();
        return x;
    }
    friend modular operator-(modular x, modular y) {
        x.val -= y.val;
        x.norm();
        return x;
    }
    friend modular operator*(modular x, modular y) {
        x.val *= y.val;
        x.norm();
        return x;
    }
    friend modular operator/(modular x, modular y) {
        return x * y.inv();
    }
};
void solve() {
    iota(dsu, dsu + 200000, 0);
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        --p[i];
        g[p[i]].push_back(i);
        g[i].push_back(p[i]);
    }
    dfs(0, -1);
    modular ans = 1;
    for (int i = 0; i < n; ++i)
        cin >> l[i] >> r[i], ans = ans * (r[i] - l[i] + 1);
    int m;
    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a, --b, --c, --d;
        auto p = restore_path(a, b), q = restore_path(c, d);
        int cur = 0;
        while (cur < (int)p.size()) {
            p[cur] = getcomp(p[cur]);
            q[cur] = getcomp(q[cur]);
            if (!same(p[cur], q[cur]))
                ans = ans / max(1ll, (r[p[cur]] - l[p[cur]] + 1));
            ans = ans / max(1ll, (r[q[cur]] - l[q[cur]] + 1));
            unite(p[cur], q[cur]);
            l[p[cur]] = l[q[cur]] = max(l[p[cur]], l[q[cur]]);
            r[p[cur]] = r[q[cur]] = min(r[p[cur]], r[q[cur]]);
            ans = ans * max(0ll, (r[q[cur]] - l[q[cur]] + 1));
            cur++;
        }
        cout << ans.val << '\n';
    }
}
signed main() {
    cin.tie(0)->sync_with_stdio(0);
    int Tc = 1;
    // cin >> Tc;
    while (Tc--) {
        solve(), cout << '\n';
    }
}