#include <bits/stdc++.h>

#define int long long
#define F first
#define S second
#define ld long double
using namespace std;
int n;
vector<vector<int>> g;
vector<set<int>> eq;
vector<pair<int, int>> a;
vector<int> par;
vector<int> im;

void dfs(int v, int p) {
    par[v] = p;
    for (int i: g[v]) {
        if (i != p) {
            dfs(i, v);
        }
    }
}

int mod = 1e9 + 7;

signed main() {
    cin >> n;
    g.resize(n);
    a.resize(n);
    eq.resize(n);
    for (int i = 0; i < n - 1; ++i) {
        int x;
        cin >> x;
        x--;
        g[i + 1].push_back(x);
        g[x].push_back(i + 1);
    }
    im.resize(n);
    for (int i = 0; i < n; ++i) {
        eq[i].insert(i);
        im[i] = i;
        cin >> a[i].F >> a[i].S;
    }
    int m;
    cin >> m;
    while (m--) {
        par.clear();
        par.resize(n, -1);
        int ans = 1;
        int v1, u1, v2, u2;
        cin >> v1 >> u1 >> v2 >> u2;
        v1--;
        u1--;
        v2--;
        u2--;
        dfs(v1, -1);
        vector<int> path1, path2;
        while (u1 != -1) {
            path1.push_back(u1);
            u1 = par[u1];
        }
        par.clear();
        par.resize(n, -1);
        dfs(v2, -1);
        while (u2 != -1) {
            path2.push_back(u2);
            u2 = par[u2];
        }
        for (int i = 0; i < path1.size(); ++i) {
            int v = im[path1[i]], u = im[path2[i]];
            if(v==u)continue;
            if (eq[v].size() < eq[u].size())swap(v, u);
            for (int j: eq[u]) {
                eq[v].insert(j);
                im[j] = v;
            }
            eq[u].clear();
        }
        for (int i = 0; i < n; ++i) {
            if (eq[i].empty())continue;
            int mn = -1, mx = 1e18;
            for (int j: eq[i]) {
                mn = max(mn, a[j].F);
                mx = min(mx, a[j].S);
            }
            if (mn > mx) {
                ans = 0;
                break;
            }
            ans *= (mx - mn + 1);
            ans %= mod;
        }
        cout << ans << '\n';
    }
    return 0;
}
