#include "bits/stdc++.h"
#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,sse4,sse4.1,sse4.2,fma,bmi,bmi2,mmx,tune=native")
#include "bits/extc++.h"
#define all(x) begin(x), end(x)
#define rall(x) x.rbegin(), x.rend()
#define frl(i, x) for(auto& i : x)
#define rep(i, j, k) for(int i = j; i < k; i++)
#define rrep(i, j, k) for(int i = k - 1; i >= j; i--)
#define S second
#define F first

using namespace __gnu_pbds;
using namespace std;

using ll = long long;
using ld = long double;
using ull = unsigned long long;

const int maxn = 2e5+5;
int p[maxn];
vector<int> g[maxn];
int tin[maxn], tout[maxn];
int t = 0;

void dfs(int v){
    tin[v] = t++;
    frl(i, g[v]){
        dfs(i);
    }
    tout[v] = t++;
}
pair<int, int> lr[maxn];
ll mod = 1e9+7;
ll binpow(ll a, ll b){
    if(b == 0) return 1;
    if(b&1) return a * binpow(a, b^1) % mod;
    ll tt = binpow(a, b>>1);
    return tt*tt % mod;
}
ll obr(ll x){
    return binpow(x, mod-2);
}

bool is_anc(int a, int b){
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}
pair<int, int> intersect(pair<int, int> a, pair<int, int> b){
    pair<int, int> ans = {max(a.F, b.F), min(a.S, b.S)};
    if(ans.S < ans.F) ans = {0, -1};
    return ans;
}

int pp[maxn];
int szz[maxn];

int find(int x){ return x == pp[x] ? x : pp[x] = find(pp[x]); }
bool unite(int a, int b){
    if(a == b) return 0;
    if(szz[a] < szz[b]) swap(a, b);
    pp[b] = a;
    szz[a] += szz[b];
    lr[a] = intersect(lr[a], lr[b]);
    return 1;
}
void solve(){
    iota(all(pp), 0);
    fill(szz, szz+maxn, 1);

    int n;
    cin >> n;
    rep(i, 1, n){
        int x;cin>>x;x--;
        p[i] = x;
        g[x].push_back(i);
    }
    ll cur = 1;
    rep(i, 0, n){
        cin >> lr[i].F >> lr[i].S;
        cur *= (lr[i].S - lr[i].F + 1);
        cur %= mod;
    }
    dfs(0);
    int m;
    cin >> m;
    rep(_, 0, m){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--,b--,c--,d--;
        vector<int> p1, p2;
        while(!is_anc(a, b)){
            p1.push_back(a);
            a = p[a];
        }
        p1.push_back(a);
        int sz = p1.size();
        while(b != a){
            p1.push_back(b);
            b = p[b];
        }
        reverse(p1.begin() + sz, p1.end());

        while(!is_anc(c, d)){
            p2.push_back(c);
            c = p[c];
        }
        p2.push_back(c);
        sz = p2.size();
        while(c != d){
            p2.push_back(d);
            d = p[d];
        }
        reverse(p2.begin() + sz, p2.end());
        
        rep(i, 0, p1.size()){
            a = p1[i], b = p2[i];
            a = find(a), b = find(b);
            if(a == b) continue;
            auto lr1 = lr[a], lr2 = lr[b];
            ll old_vklad = 1ll * (lr1.S - lr1.F + 1) * (lr2.S - lr2.F + 1) % mod;
            cur *= obr(old_vklad);
            cur %= mod;
            unite(a, b);

            a = find(a);
            lr1 = lr[a];
            cur *= (lr1.S - lr1.F + 1);
            cur %= mod;
        }
        cout << cur << '\n';
    }
}

int main(){
    cin.tie(0)->ios::sync_with_stdio(0);
    cout << setprecision(15) << fixed;
    int TT=1;
    //cin>>TT;
    while(TT--) solve();
}