#include <bits/stdc++.h>

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

const int N = 2e5;
const ll INF = 1e9 + 7;
const ld EPS = 1e-6;

int tin[N], tout[N], pr[N], p[N], sz[N], w1[N], w2[N], tim = 0;
pair<int, int> gr[N];
vector<int> g[N];
ll ans = 1;

ll binpow(ll a, ll x) {
    if (x == 0) return 1ll;
    auto res = binpow(a, x / 2);
    res = res * res % INF;
    if (x & 1) res = res * a % INF;
    return res;
}

void prec(int v) {
    tin[v] = tim++;
    for (auto i : g[v]) prec(i);
    tout[v] = tim;
}

bool anc(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int get(int v) {
    if (v == p[v]) return v;
    return p[v] = get(p[v]);
}

void join(int v, int u) {
    v = get(v), u = get(u);
    if (v == u) return;
    if (sz[v] > sz[u]) swap(v, u);
    p[v] = u;
    sz[u] += sz[v];
    ans = ans * binpow(gr[u].second - gr[u].first + 1, INF - 2) % INF;
    ans = ans * binpow(gr[v].second - gr[v].first + 1, INF - 2) % INF;
    gr[u].first = max(gr[u].first, gr[v].first);
    gr[u].second = min(gr[u].second, gr[v].second);
    gr[u].second = max(gr[u].second, gr[u].first - 1);
    ans = ans * (gr[u].second - gr[u].first + 1) % INF;
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, q;
    cin >> n;
    for (int i = 1; i < n; i++) {
        cin >> pr[i];
        g[--pr[i]].push_back(i);
    }
    prec(0);
    for (int i = 0; i < n; i++) {
        sz[i] = 1;
        p[i] = i;
        cin >> gr[i].first >> gr[i].second;
        ans = ans * (gr[i].second - gr[i].first + 1) % INF;
    }
    cin >> q;
    for (int rq = 0; rq < q; rq++) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--; b--; c--; d--;
        int ind1 = 0, ind2 = 0;
        for (; !anc(a, b); a = pr[a]) w1[ind1++] = a;
        for (; !anc(c, d); c = pr[c]) w2[ind2++] = c;
        int s1 = ind1, s2 = ind2;
        for (; !anc(b, a); b = pr[b]) w1[ind1++] = b;
        for (; !anc(d, c); d = pr[d]) w2[ind2++] = d;
        w1[ind1] = a;
        for (int j = 0; s1 + j < ind1 - j; j++) swap(w1[s1 + j], w1[ind1 - j]);
        w2[ind2] = c;
        for (int j = 0; s2 + j < ind2 - j; j++) swap(w2[s2 + j], w2[ind2 - j]);
        for (int j = 0; j <= ind1; j++)
            join(w1[j], w2[j]);
        cout << ans << '\n';
    }
}
