#include<bits/stdc++.h>
#define MAXN 200007
using namespace std;

const long long inf=1e10,mod=1e9+7,modd=1e9+7;

int n,m,a,b,c,d,from,to,cnt,maxdeg;
int parent[MAXN],dep[MAXN],li[MAXN],tim,pos[MAXN];
vector<int> v[MAXN],ls,rs,w[MAXN],rod;
pair<int,int> curr;
long long ans,l[MAXN],r[MAXN],maxl[MAXN],minr[MAXN];
long long powr[MAXN];
int dsu[MAXN],pt;
vector<int> poss[MAXN];

int root(int x){
    if(dsu[x]==x)return dsu[x];
    dsu[x]=root(dsu[x]);
    return dsu[x];
}

void dfs(int x,int dd){
    dep[x]=dd;
    for(int i=0;i<v[x].size();i++){
        dfs(v[x][i],dd+1);
    }
}

vector<int> path(int x,int y){
    vector<int> lp={},rp={};
    while(dep[x]>dep[y]){
        lp.push_back(x);
        x=parent[x];
    }
    while(dep[y]>dep[x]){
        rp.push_back(y);
        y=parent[y];
    }
    while(x!=y){
        lp.push_back(x);
        rp.push_back(y);
        x=parent[x];
        y=parent[y];
    }
    lp.push_back(x);
    while(!rp.empty()){
        if(lp.back()!=rp.back()){
            lp.push_back(rp.back());
        }
        rp.pop_back();
    }
    return lp;
}

long long cost(int x){
    return max(0LL,minr[x]-maxl[x]+1);
}

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a;
    if(b==2)return (a*a)%mod;
    if(b%2==0)return power(power(a,b/2),2);
    return (power(power(a,b/2),2)*a)%mod;
}

long long combine(long long pref,long long suff,int len){
    return (pref*powr[len]+suff)%modd;
}

long long pref[4*MAXN],suff[4*MAXN];

void build(int v,int l,int r){
    if(l==r){
        pref[v]=suff[v]=rod[l];
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
        pref[v]=combine(pref[2*v],pref[2*v+1],(r-(tt+1)+1));
        suff[v]=combine(suff[2*v+1],suff[2*v],(tt-l+1));
    }
}

void update(int v,int l,int r,int pos,int val){
    if(l==r){
        pref[v]=suff[v]=val;
    }else{
        int tt=(l+r)/2;
        if(pos<=tt)update(2*v,l,tt,pos,val);
        else update(2*v+1,tt+1,r,pos,val);
        pref[v]=combine(pref[2*v],pref[2*v+1],(r-(tt+1)+1));
        suff[v]=combine(suff[2*v+1],suff[2*v],(tt-l+1));
    }
}

pair<long long,long long> gethesh(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {0,0};
    if(l==ll and r==rr){
        return {pref[v],suff[v]};
    }else{
        int tt=(l+r)/2;
        pair<long long,long long> lt=gethesh(2*v,l,tt,ll,min(tt,rr));
        pair<long long,long long> rt=gethesh(2*v+1,tt+1,r,max(tt+1,ll),rr);
        return { combine(lt.first,rt.first,max(rr-max(tt+1,ll)+1,0)) , combine(rt.second,lt.second,max(min(tt,rr)-ll+1,0)) };
    }
}

void mergev(int x,int y){
    x=root(x); y=root(y);
    if(x==y)cout<<1/0;

    ans*=power(cost(x),mod-2); ans%=mod;
    ans*=power(cost(y),mod-2); ans%=mod;

    if(poss[x].size()>poss[y].size())swap(x,y);

    minr[y]=min(minr[y],minr[x]);
    maxl[y]=max(maxl[y],maxl[x]);

    for(int i:poss[x]){
        update(1,0,n-1,i,y);
        poss[y].push_back(i);
    }

    dsu[x]=y; ans*=cost(y); ans%=mod;
}

void query(int a,int b,int c,int d){
    ls=path(a,b);
    rs=path(c,d);
    for(int i=0;i<ls.size();i++){
        a=root(ls[i]); b=root(rs[i]);
        if(a==b)continue;
        ans*=power(cost(a),mod-2); ans%=mod;
        ans*=power(cost(b),mod-2); ans%=mod;
        mergev(a,b);
        ans*=cost(b); ans%=mod;
    }
}

void query2(int a,int b,int c,int d){
    pt=0;
    if(c<=d){
        swap(a,c);
        swap(b,d);
    }
    if(a<=b and c<=d){
        if(gethesh(1,0,n-1,a,b).first==gethesh(1,0,n-1,c,d).first)return;
        while(true){
            int l=-1,r=(b-a+1),tt;
            while(l+1<r){
                tt=(l+r)/2;
                if(gethesh(1,0,n-1,a+pt,a+tt).first==gethesh(1,0,n-1,c+pt,c+tt).first){
                    l=tt;
                }else{
                    r=tt;
                }
            }
            if(l==b-a)break;
            from=gethesh(1,0,n-1,a+l+1,a+l+1).first;
            to=gethesh(1,0,n-1,c+l+1,c+l+1).first;
            mergev(from,to);
            pt+=l-pt+1;
        }
    }else if(a<=b and c>d){
        if(gethesh(1,0,n-1,a,b).first==gethesh(1,0,n-1,d,c).second)return;
        while(true){
            int l=-1,r=(b-a+1),tt;
            while(l+1<r){
                tt=(l+r)/2;
                if(gethesh(1,0,n-1,a+pt,a+tt).first==gethesh(1,0,n-1,c-tt,c-pt).second){
                    l=tt;
                }else{
                    r=tt;
                }
            }
            if(l==b-a)break;
            from=gethesh(1,0,n-1,a+l+1,a+l+1).first;
            to=gethesh(1,0,n-1,c-l-1,c-l-1).second;
            mergev(from,to);
            pt+=l-pt+1;
        }
    }else{
        if(gethesh(1,0,n-1,b,a).second==gethesh(1,0,n-1,d,c).second)return;
        while(true){
            int l=-1,r=(a-b+1),tt;
            while(l+1<r){
                tt=(l+r)/2;
                if(gethesh(1,0,n-1,a-tt,a-pt).second==gethesh(1,0,n-1,c-tt,c-pt).second){
                    l=tt;
                }else{
                    r=tt;
                }
            }
            if(l==a-b)break;
            from=gethesh(1,0,n-1,a-l-1,a-l-1).second;
            to=gethesh(1,0,n-1,c-l-1,c-l-1).second;
            mergev(from,to);
            pt+=l-pt+1;
        }
    }    
}

void dfs3(int x,int p){
    rod.push_back(x);
    pos[x]=int(rod.size())-1;
    for(int i=0;i<w[x].size();i++){
        if(w[x][i]!=p)dfs3(w[x][i],x);
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n;
    for(int i=2;i<=n;i++){
        cin>>parent[i];
        v[parent[i]].push_back(i);
        w[parent[i]].push_back(i);
        w[i].push_back(parent[i]);
    }

    for(int i=1;i<=n;i++){
        maxdeg=max(maxdeg,int(w[i].size()));
    }

    if(maxdeg==2){
        for(int i=1;i<=n;i++){
            if(w[i].size()==1){
                dfs3(i,0); break;
            }
        }

        powr[0]=1;
        for(int i=1;i<=n;i++){
            powr[i]=(long long) (powr[i-1]*(n+1))%mod;
        }
        build(1,0,n-1);

        ans=1;
        for(int i=1;i<=n;i++){
            cin>>l[i]>>r[i];
            dsu[i]=i; poss[i]={i-1};
            maxl[i]=l[i]; minr[i]=r[i];
            ans*=(r[i]-l[i]+1);
            ans%=mod;
        }

        cin>>m;
        for(int i=1;i<=m;i++){
            cin>>a>>b>>c>>d;
            query2(pos[a],pos[b],pos[c],pos[d]);
            cout<<ans<<"\n";
        }

    }else{
        dfs(1,1);

        ans=1;
        for(int i=1;i<=n;i++){
            cin>>l[i]>>r[i];
            dsu[i]=i;
            maxl[i]=l[i]; minr[i]=r[i];
            ans*=(r[i]-l[i]+1);
            ans%=mod;
        }

        cin>>m;
        for(int i=1;i<=m;i++){
            cin>>a>>b>>c>>d;
            query(a,b,c,d);
            cout<<ans<<"\n";
        }
    }

    return 0;
}