#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN = 2e5 + 10;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

int n, p[MAXN];
int li[MAXN], ri[MAXN];
int m;
struct year
{
    int a, b, c, d;
    year(){};
    year(int _a, int _b, int _c, int _d)
    {
        a = _a;
        b = _b;
        c = _c;
        d = _d;
    }
};
vector < year > g;
vector < int > v[MAXN];
void read()
{
    cin >> n;
    for (int i = 2; i <= n; ++ i)
    {
        cin >> p[i];
        v[p[i]].push_back(i);
        v[i].push_back(p[i]);
    }
    for (int i = 1; i <= n; ++ i)
    {
        cin >> li[i] >> ri[i];
    }
    cin >> m;
    int a, b, c, d;
    for (int i = 0; i < m; ++ i)
    {
        cin >> a >> b >> c >> d;
        g.push_back(year(a, b, c, d));
    }
}
int group[MAXN], r[MAXN];
pair < int, int > answer[MAXN];
void init_group()
{
    for (int i = 1; i <= n; ++ i)
    {
        group[i] = i;
        answer[i] = make_pair(li[i], ri[i]);
        r[i] = 1;
    }
}
int startt, finishh, used[MAXN];
vector < int > path, oldpath;

bool dfs(int beg)
{
    if(beg == finishh)
    {
        path.push_back(beg);
        return true;
    }
    used[beg] = 1;
    int nb, ok = 0;
    for (int i = 0; i < v[beg].size(); ++ i)
    {
        nb = v[beg][i];
        if(!used[nb])
        {
            if(dfs(nb) == 1)
                ok = 1;
        }
    }
    if(ok)path.push_back(beg);
    return ok;
}
int find_leader(int i)
{
    if(i == group[i])return i;
    return (group[i] = find_leader(group[i]));
}
bool connected(int i, int j)
{
    return (find_leader(i) == find_leader(j));
}
int irrelevant[MAXN];
void dsu(int i, int j)
{
    i = find_leader(i);
    j = find_leader(j);
    if(i == j)return;
    if(r[i] < r[j])swap(i, j);
    group[j] = i;
    irrelevant[j] = 1;
    answer[i].first = max(answer[i].first, answer[j].first);
    answer[i].second = min(answer[i].second, answer[j].second);
    r[i] += r[j];
    return;
}
void find_answer()
{
    memset(used, 0, sizeof(used));
    long long ans = 1, mod = 1e9 + 7;
    for (int i = 1; i <= n; ++ i)
    {
        if(!used[group[i]] && !irrelevant[group[i]])
        {
            int l = answer[group[i]].first;
            int r = answer[group[i]].second;
            if(l > r)
            {
                cout << 0 << endl;
                return;
            }
            used[group[i]] = 1;
            ans = ans * (r - l + 1);
            ans %= mod;
        }
    }
    cout << ans << endl;
}
void solve()
{
    init_group();
    for (int i = 0; i < m; ++ i)
    {
        path.clear();
        oldpath.clear();
        startt = g[i].a;
        finishh = g[i].b;
        memset(used, 0, sizeof(used));
        dfs(startt);
        oldpath = path;
        startt = g[i].c;
        finishh = g[i].d;
        path.clear();
        memset(used, 0, sizeof(used));
        dfs(startt);
        int ver1, ver2, group2;
        for (int j = 0; j < path.size(); ++ j)
        {
            ver1 = path[j];
            ver2 = oldpath[j];
            dsu(ver1, ver2);
        }
       // for (int j = 1; j <= n; ++ j)
         //   cout << group[j] << " ";
       // cout << endl;
        find_answer();
    }
}
int main()
{
	speed();

	read();
	solve();
    return 0;
}
