#include<bits/stdc++.h>
using namespace std;

long long const MAXN=3001;
long long n, par[MAXN], m, used[MAXN], mod = 1e9+7;
vector<long long> v[MAXN];

struct edge
{
    long long l, r;
};

edge ver[MAXN], d[MAXN];
/*
void DFS(long long i, long long par)
{
    lvl[i] = lvl[par]+1;
    long long sz = v[i].size();
    for(long long j=0;j<sz;j++)
    {
        long long nb = v[i][j];
        if(!lvl[nb])
        {
            DFS(nb, i);
        }
    }
}*/

void fill_array()
{
    for(long long i=1;i<=MAXN;i++)
    {
        par[i] = i;
        d[i] = ver[i];
    }
}

long long find_leader(long long x)
{
    if(par[x] == x) return x;
    else return par[x] = find_leader(par[x]);
}

void DSU(long long x, long long y)
{
    x = find_leader(x);
    y = find_leader(y);
    if(x == y) return;
    d[x].l = max(d[x].l, d[y].l);
    d[y].l = d[x].l;
    d[x].r = min(d[x].r, d[y].r);
    d[y].r = d[x].r;
    par[y] = x;
}

void read()
{
    long long lf, rf, a, b, c, e;
    long long ans = 1, x;
    cin>>n;
    for(long long i=2;i<=n;i++)
    {
        cin>>x;
        v[x].push_back(i);
        v[i].push_back(x);
    }
    //DFS(1, 0);
    for(long long i=1;i<=n;i++)
    {
        cin>>lf>>rf;
        ver[i] = {lf,rf};
    }
    fill_array();
    cin>>m;
    for(long long i=1;i<=m;i++)
    {
        ans = 1;
        cin>>a>>b>>c>>e;
        while(a != b)
        {
            if(a != c) DSU(a,c);
            if(b > a) a++;
            else a--;
            if(e > c) c++;
            else c--;
        }
        for(long long j=1;j<=n;j++)
        {
            x = find_leader(j);
            if(x == j)
            {
                if(d[x].r - d[x].l < 0)
                {
                    ans = 0;
                    break;
                }
                ans *= (d[x].r - d[x].l + 1);
                ans %= mod;
            }
        }
        cout<<ans<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    read();
    return 0;
}

/*
8
1 2 3 4 5 6 7
3 7
2 6
3 8
5 10
5 8
2 9
6 8
3 8
4
1 3 8 6
4 1 5 8
1 8 8 1
1 7 2 8
*/
