#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using ld = long double;
using ll = long long;
using vi = vector<int>;

const int maxN = 1e2, maxK = 1e7 + 1;
const ld eps = 1e-3;

int test = 1, n, k, a[maxN], sz, hlp;
ld ans, dp1[maxK], dp2[maxK];

void calc(int i, ld cur, ll temp) {
    if (temp >= k) {
        ans = max(ans, cur * k);
        return;
    }
    if (i == n)
        return;
    for (int j = 1; j <= a[i] && temp * (j - 1) < k && cur * ((ld)(a[i] / j) / a[i]) * k >= ans; j++)
        calc(i + 1, cur * ((ld)(a[i] / j) / a[i]), 1LL * temp * j);
}

void solve() {
    cin >> n >> k;
    if (n <= 2) {
        for (int i = 0; i < n; i++)
            cin >> a[i];
        ans = 0;
        calc(0, 1, 1);
        printf("%.20Lf\n", ans);
        return;
    }
    fill(dp1, dp1 + k + 1, 0);
    fill(dp2, dp2 + k + 1, 0);
    dp1[1] = dp2[1] = k;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        for (int h = 1; h <= k; h++) {
            if (h != k && abs(dp1[h] - dp1[h + 1]) < eps)
                continue;
            for (int j = 2; j <= a[i]; j++) {
                int q = a[i] / j;
                j = a[i] / q;
                ld temp = (ld)q / a[i];
                int id = min(1LL * h * j, (ll)k);
                dp2[id] = max(dp2[id], temp * dp1[h]);
                if (id == k)
                    break;
            }
        }
        for (int i = k - 1; i >= 1; i--)
            dp2[i] = max(dp2[i], dp2[i + 1]);
        for (int i = 1; i <= k; i++)
            dp1[i] = dp2[i];
    }
    ans = dp1[k];
    printf("%.20Lf\n", ans);
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
