#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;
typedef long double ld;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);

mt19937 rnd(time(0));


void solve() {
    auto start = clock();

    int n, k;
    cin >> n >> k;
    // n = 4;
    // k = 444;

    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    // a = {57, 179, 239, 2};

    ll gh = 1;
    for (int i = 0; i < n; ++i) {
        gh *= (ll)a[i];

        if (gh >= 1e7) break;
        if (gh >= k) break;
    }

    if (gh < k) {
        cout << 0;
        return;
    }

    if (n == 1) {
        cout << fixed << setprecision(10) << ld(a[0] / k * k) / ld(a[0]);
        return;
    }
    if (n == 2) {
        ld ans = 0;

        for (ll b0 = 1; b0 <= a[0]; ++b0) {
            ll b1 = (k + b0 - 1) / b0;

            if (b1 <= a[1]) {
                ans = max(ans, ld((a[0] / b0) * (a[1] / b1) * k) / ld(a[0] * a[1]));
            }
        }

        cout << fixed << setprecision(10) << ans << '\n';
        return;
    }

    ld qwer = (ld)k;

    for (int i = 0; i < n; ++i) qwer /= ld(a[i]);

    ld ans = 0;

    while (ld(clock() - start) / CLOCKS_PER_SEC < 1.5) {
        vector<int> b(n);

        for (int i = 0; i < n; ++i) {
            b[i] = rnd() % a[i] + 1;
        }

        ll gh = 1;
        for (int i = 0; i < n; ++i) {
            gh *= (ll)b[i];

            if (gh >= 1e7) break;
            if (gh >= k) break;
        }

        if (gh < k) {
            continue;
        }

        ld now_ans = 1;

        for (int i = 0; i < n; ++i) {
            now_ans *= ld(a[i] / b[i]);
        }

        now_ans *= qwer;

        if (ans < now_ans) {
            ans = now_ans;

            // a = b;
        }
    }

    cout << fixed << setprecision(10) << ans;
}

signed main() {
    int tests = 1;

    while (tests--) {
        solve();
    }
}

// cd "d:\open_olympiad\" ; if ($?) { g++ main.cpp -o main } ; if ($?) { .\main } 
/*

5
1 2 3 4
1 2
2 3
3 4
1 10
2 6
10
1 1 2 2
100
1 2
2 1
100
4 5 5 4
10
2 4 4 2
2
1 1 5 5
2

*/