#include <bits/stdc++.h>

using namespace std;
const int MAXK = 4000;
const int N = 110;
double dp1[N][MAXK];
double dp2[N][MAXK];
const double eps = 1e-9;

inline void solve() {
    int n, k;
    cin >> n >> k;
    int K;
    if (n == 2) K = 4000;
    else K = 2500;
    int K1 = 300;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    if (k == 1) {
        cout << 1;
        return;
    }
    dp1[0][1] = 1;
    for (int i = 0; i < n; ++i) {
        for (int prv = 1; prv < K; ++prv) {
            if (dp1[i][prv] < eps) continue;
            for (int val = 1; val * prv < K; ++val) {
                dp1[i + 1][prv * val] = max(dp1[i + 1][prv * val], dp1[i][prv] * (int) (a[i] / val) / (double) a[i]);
            }
        }
    }
    dp2[n][1] = 1;
    for (int i = n - 1; i >= 0; --i) {
        for (int prv = 1; prv < K; ++prv) {
            if (dp2[i + 1][prv] < eps) continue;
            for (int val = 1; val * prv < K; ++val) {
                dp2[i][prv * val] = max(dp2[i][prv * val], dp2[i + 1][prv] * (int) (a[i] / val) / (double) a[i]);
            }
        }
    }
    for (int i = 0; i <= n; ++i) {
        for (int j = K - 2; j >= 1; --j) {
            dp1[i][j] = max(dp1[i][j], dp1[i][j + 1]);
            dp2[i][j] = max(dp2[i][j], dp2[i][j + 1]);
        }
    }
    double ans = 0;
    for (int i = 0; i < n; ++i) {
        for (int x = 1; x < K1; ++x) {
            for (int y = 1; y < K; ++y) {
                int val = (k + x * y - 1) / (x * y);
                if (val > a[i]) break;
                ans = max(ans, dp1[i][x] * dp2[i + 1][y] * (int) (a[i] / val) / (double) a[i]);
            }
        }
        for (int x = 1; x < K; ++x) {
            for (int y = 1; y < K1; ++y) {
                int val = (k + x * y - 1) / (x * y);
                if (val > a[i]) break;
                ans = max(ans, dp1[i][x] * dp2[i + 1][y] * (int) (a[i] / val) / (double) a[i]);
            }
        }
        for (int cur = 1; cur < K1; ++cur) {
            for (int x = 1; x < K; ++x) {
                double me = (int) (a[i] / cur) / (double) a[i];
                int flex = cur * x;
                if (flex > k) {
                    ans = max(ans, me * dp1[i][x]);
                    break;
                }
                int need = (k + flex - 1) / flex;
                ans = max(ans, me * dp1[i][x] * dp2[i + 1][need]);
            }
        }
    }
    for (int i = k; i < K; ++i) ans = max(ans, dp1[n][i]);
    cout << fixed << setprecision(15) << ans * k;
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
    return 0;
}

/*

 */