#pragma GCC optimize("O3")
#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, k;
    cin >> n >> k;
    if (n == 1) {
        int a;
        cin >> a;
        cout << (a / k) * k / (long double)a << '\n';
        return;
    } else if (n == 2) {
        int a1, a2;
        cin >> a1 >> a2;
        long double ans = 0;
        for (int k1 = 1; k1 <= min(a1, k); ++k1) {
            int k2 = (k - 1) / k1 + 1;
            ans = max(ans, (a1 / k1) * 1LL * (a2 / k2) / (long double)a1 / (long double)a2 * k);
        }
        cout << ans << '\n';
        return;
    }
    vector<long double> dp(k + 1);
    dp[1] = k;
    for (int i = 0; i < n; ++i) {
        int a;
        cin >> a;
        for (int j = k; j >= 1; --j) {
            if (dp[j] == 0) {
                continue;
            }
            for (int nw_j = j * 2;; nw_j += j) {
                if (nw_j / j > a) {
                    break;
                }
                int vl = a / (nw_j / j);
                dp[min(k, nw_j)] = max(dp[min(k, nw_j)], dp[j] * vl / (long double)a);
                if (nw_j >= k) {
                    break;
                }
            }
        }
    }
    cout << dp[k] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.precision(25);
    cout << fixed;
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
