#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;


using namespace std;

ld dp[20000005];

void solve() {
    int n = 2; cin >> n;
    int k = 10000000; cin >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = 10000000; cin >> a[i];
    }
    dp[1] = k;
    for (int i = 0; i < n; ++i) {
        int anw = a[i];
        for (int j = k - 1; j >= 1; --j) {
            for (int b = 2; j * (b - 1) <= k; ++b) {
                if (b > anw) {
                    break;
                }
                dp[j * b] = max(dp[j * b], dp[j] * (ld)(anw / b) / (ld)(anw));
            }
        }
    }
    ld ans = 0;
    for (int i = k; i < 2 * k; ++i) {
        ans = max(ans, dp[i]);
    }
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}