#include <iostream>
#include <vector>
#include <set>
#include <string>
#include <numeric>
#include <algorithm>
#include <map>
#include <cmath>
#include <iomanip>

typedef long long ll;
typedef double ld;
#define all(x) x.begin(), x.end()

const ll MOD = 1000000007;
//const ll MOD = 998244353;


using namespace std;

ld ans = 0;
int n, k;
vector<vector<pair<int, ld>>> v;

void per(int i, int knw, ld ansnw) {
    if (knw >= k) {
        ans = max(ans, ansnw);
        return;
    }
    if (i == n) {
        return;
    }
    for (auto p : v[i]) {
        per(i + 1, min((ll)k, (ll)knw * p.first), ansnw * p.second);
    }
}

void solve() {
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        a[i] = 10000000; cin >> a[i];
    }
    sort(all(a)); reverse(all(a));
    v.resize(n);
    for (int i = 0; i < n; ++i) {
        int j = 1;
        while (j * j <= a[i]) {
            v[i].push_back({ j, (ld)(a[i] / j) / (ld)a[i] });
            int b = a[i] / j;
            v[i].push_back({ b, (ld)(a[i] / b) / (ld)a[i] });
            ++j;
        }
        sort(all(v));
        reverse(all(v));
    }
    per(0, 1, k);
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    cout << fixed << setprecision(20);
    int t = 1; //cin >> t;
    while (t--) {
        solve();
    }
}