#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
typedef long long ll;

int main() {
    ll n, k; cin >> n >> k;
    vector<ll> a(n); 
    for (int i = 0; i < n; i++) cin >> a[i];
    sort(all(a));
    vector<vector<ll> > dp(n, vector<ll> (k + 2));
    for (int i = 1; i <= min(k, a[0]); i++) {
        dp[0][i] = a[0] / i; 
    }
    vector<vector<ll> > d(k + 1);
    for (ll i = 1; i <= k; i++) {
        for (ll j = 1; j * j <= i; j++) {
            if (i % j == 0) {
                d[i].pb(j);
                if (j * j != i) d[i].pb(i / j);
            }
        }
    } 
    for (int i = 1; i < n; i++) {
        for (ll p = 1; p <= k; p++) {
            for (auto q : d[p]) {
                ll b = p / q;
                if (b <= a[i]) dp[i][p] = max(dp[i][p], dp[i - 1][q] * (a[i] / b));
            }
        }
        for (ll q = 1; q <= k + 1; q++) {
            ll b = (k + 1 + q - 1) / q;
            if (b == 0) b = 1;
            if (b <= a[i]) dp[i][k + 1] = max(dp[i][k + 1], dp[i - 1][q] * (a[i] / b));
        }
    }
    /*for (int i = 0; i < n; i++) {
        for (int j = 1; j <= k + 1; j++) {
            cout << dp[i][j] << " ";
        }
        cout << endl;
    }*/
    long double ans = max(dp[n - 1][k], dp[n - 1][k + 1]) * k;
    for (int i = 0; i < n; i++) ans /= a[i];
    cout << setprecision(20) << fixed << ans;
    return 0;
}