#include <bits/stdc++.h>
using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int n, k;
    cin >> n >> k;
    vector<set<int>> vals(n);
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        a[i] = x;
        for (int y = 1; y * y <= x; ++y) {
            vals[i].insert(x / y);
            vals[i].insert(x / (x / y));
        }
    }
    map<int, int> mn;
    mn[1] = 1;
    for (int i = 0; i < n; ++i) {
        map<int, int> nxt;
        for (auto x : vals[i]) {
            for (auto [l, y] : mn) {
                nxt[min(k, l * x)] = max(nxt[min(k, l * x)], y * (a[i] / x));
            }
        }
        mn = nxt;
    }
    long double ans = mn[k];
    for (int i = 0; i < n; ++i) ans /= a[i];
    cout << fixed << setprecision(100) << ans * k;
}


void solve() {
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
    }
    bool ok = 1;
    vector<int> used(n, 0);
    vector<int> top;
    vector<int> xr(n);
    auto dfs = [&](auto dfs, int u) -> void {
        used[u] = 1;
        for (auto [to, w] : g[u]) {
            if (!used[to]) {
                xr[to] = xr[u] ^ w;
                dfs(dfs, to);
            } else if (used[to] == 1) {
                if (xr[to] != xr[u]) ok = 0;
            }
        }
        used[u] = 2;
        top.push_back(u);
    };
    for (int i = 0; i < n; ++i) {
        if (!used[i]) dfs(dfs, i);
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (!ok) {
        cout << "-1\n";
        return;
    }
    cout << "0\n";
}