#include <iostream>
#include <vector>
#include <iomanip>
using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

	int n; cin >> n;
	ll k; cin >> k;
	vector<ll> a(n);
	ll P = 1;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		P *= a[i];
	}
	ll K = 3 * k;
	vector<vector<ll>> dp(n + 1, vector<ll>(K + 1, 0));
	for (ll i = 1; i <= a[0]; ++i) {
		dp[1][i] = a[0] / i;
	}
	for (int i = 2; i <= n; ++i) {
		for (ll j = 1; j <= a[i - 1]; ++j) {
			for (ll z = j; z <= K; z += j) {
				dp[i][z] = max(dp[i][z], dp[i - 1][z / j] * (a[i - 1] / j));
			}
		}
	}
	ll max_el = 0;
	for (ll z = k; z <= K; ++z) {
		max_el = max(max_el, dp[n][z]);
	}
	long double ans = (long double)max_el * (long double)k / (long double)P;
	cout << setprecision(30) << ans;

	return 0;
}