#include <iostream>
#include <iomanip>

#include <vector>
#include <string>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <stack>
#include <queue>

#include <algorithm>
#include <cstdlib>
#include <ctime>
#include <cmath>

using namespace std;

long long g(vector<int>& mass, vector<int>& a, int k)
{
	long long ans = 1;
	for (int i = 0; i < a.size(); ++i)
		ans *= a[i] / mass[i];

	return ans;
}

long long f(int m, int n, vector<int>& mass, vector<int>& a, int k, vector<int>& max_ans)
{
	if (m == n)
	{
		long long p = 1;
		for (int i : mass)
			p *= i;

		if (p >= k)
			return g(mass, a, k);
		else
			return 0;
	}

	long long ans = 0;
	for (int i = 1; i < a[m]; ++i)
	{
		mass[m] = i;
		int tmp = f(m + 1, n, mass, a, k, max_ans);
		if (tmp > ans)
		{
			ans = tmp;
			//max_ans = mass;
		}
	}

	return ans;
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int n, k;
	cin >> n >> k;
	vector<int> a(n);
	for (auto& i : a)
		cin >> i;

	long long p = 1;	
	for (int& i : a)
		p *= i;

	vector<int> mass(n);
	vector<int> max_ans(n);
	cout << fixed << setprecision(10) << f(0, n, mass, a, k, max_ans) * k / (long double)p << endl;

	/*for (int i : max_ans)
		cout << i << " ";*/
}