#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

mt19937 rng(time(0));

void solve() {
    int n, k;
    cin >> n >> k;
    int x, y;
    if (n == 1) {
        cin >> x;
        cout << fixed << setprecision(10) << ((db)(x / k)) / x * k << '\n';
        return;
    }
    cin >> x >> y;
    db ans = 0;
    for (int d1 = 1; d1 <= x; d1++) {
        int d2 = (k + d1 - 1) / d1;
        ans = max(ans, ((db)(x / d1)) * (y / d2) * k / x / y);
    }
    cout << fixed << setprecision(10) << ans << '\n';
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    solve();
}