#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
//#define int long long

using namespace std;

typedef long long ll;
typedef double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream &is, pair <T1, T2> &a) {is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream &os, pair <T1, T2> a) {os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream &is, vector <T> &a) {for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream &os, vector <T> a) {for (auto x : a) os << x << " "; os << endl; return os;}

#ifdef STRESS
const int N = 1000;
#else
const int N = 10000010;
#endif
ld dp[N];
vector <int> dels[N];

void solve(){
    int n, k;
    cin >> n >> k;
    if (k == 1){
        cout << 1 << endl;
        return;
    }
    if (n == 1){
        int a;
        cin >> a;
        if (a < k) cout << 0 << endl;
        else cout << setprecision(12) << fixed << ld(a / k) / a * k << endl;
        return;
    }
    if (n == 2){
        int a1, a2;
        cin >> a1 >> a2;
        ld ans = 0;
        for (int b1 = 1; b1 <= a1; b1++){
            int b2 = (k + b1 - 1) / b1;
            if (b2 <= a2) ans = max(ans, ld(a1 / b1) * ld(a2 / b2) / a1 / a2 * k);
        }
        cout << setprecision(12) << fixed << ans << endl;
        return;
    }/*
    for (int i = 2; i < k; i++){
        for (int j = 1; i * j < k; j++) {
            dels[i * j].push_back(i);
        }
    }*/
    dp[1] = 1;
    ld ans = 0;
    while (n--){
        int a;
        cin >> a;
        for (int i = k - 1; i >= 1; i--){
            int b = (k + i - 1) / i;
            if (b <= a) ans = max(ans, dp[i] * ld(a / b) / a);
            for (int x = 2; x <= min(i, a); x++){
                if (i % x == 0) dp[i] = max(dp[i], dp[i / x] * ld(a / x) / a);
            }
        }
        //for (int i = 1; i < k; i++) cout << dp[i] << " ";
        //cout << endl << ans << endl;
    }
    cout << setprecision(12) << fixed << ans * k << endl;
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int ttt = 1;
    //cin >> ttt;
    while (ttt--) solve();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}
