#include <bits/stdc++.h>
#pragma GCC optimize("Ofast");
#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 101, K = 1e7 + 5;

ld dp[2][K];
vector<pair<int, ld>> w[N]; // give b, give a / b
int a[N];
int n, k;
const ld inf = 1000000;

void split(int x, int id) {
    for (int i = 1; i <= x;) {
        int l = i, r = x, ans = i;
        int key = x / i;
        while (l <= r) {
            int c = (l + r) / 2;
            if (x / c == key) ans = c, l = c + 1;
            else r = c - 1;
        }
        w[id].pb({ans, log(x / ans)});
        i = ans + 1;
    }
}

ld suf[K];

void solve() {
    cin >> n >> k;
    for (int i = 1; i <= n; i++) cin >> a[i];
    for (int i = 1; i <= n; i++) {
        split(a[i], i);
    }
    for (int i = 0; i < 2; i++)
        for (int j = 0; j < K; j++)
            dp[i][j] = -inf;
    dp[0][1] = 0;
    for (int i = 1; i <= n; i++) {
        int c = i & 1;
        for (int j = 1; j <= k; j++) {
            suf[j] = dp[c ^ 1][j];
            dp[c][j] = -inf;
        }
        for (int j = k - 1; j >= 1; j--)
            relaxma(suf[j], suf[j + 1]);
        for (auto [b, d]: w[i]) {
            int mul = 1;
            int ri = k / b;
            for (; mul <= ri; mul++) {
                if (dp[c ^ 1][mul] != -inf) {
                    relaxma(dp[c][mul * b], dp[c ^ 1][mul] + d);
                }
            }

            if (mul <= k && suf[mul] != -inf) {
                relaxma(dp[c][k], suf[mul] + d);
            }
        }
    }
    ld res = dp[n & 1][k];
    ld cof = 0;
    for (int i = 1; i <= n; i++) cof -= log(a[i]);
    cof += log(k);
    res += cof;
    cout.precision(20);
    cout << fixed << exp(res);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}