#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <iomanip>

#define int long long

using namespace std;

long double recur(int n, int now, int k, long double meow, vector <int> &a, int last=1)
{
    if (n==0)
    {
        if (now>=k)
        {
            return meow;
        }
        else return 0;
    }
    else
    {
        long double maxans=0;
        for (int i=last; i<=a[n-1]; i++)
        {
            maxans=max(maxans,recur(n-1,now*i,k,meow * ((a[n-1]/i)/1.0/a[n-1]),a,last));
            if (now*i>=k) break;
        }
        return maxans;
    }
}

void solve()
{
    int n,k;
    cin>>n>>k;
    vector <int> a(n);
    for (int i=0; i<n; i++)
    {
        cin>>a[i];
    }
    sort(a.begin(),a.end());
    cout<<fixed<<setprecision(15)<<recur(n,1,k,k,a)<<"\n";
}

signed main() {
    int t=1;
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    //cin>>t;
    while (t--)
    {
        solve();
    }
}
