#include <bits/stdc++.h>

using namespace std;

// #include "debug.h"
// #define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"

#define sz(x) int((x).size())

typedef long long ll;
typedef long double ld;

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> a(n);
    for (int& x : a) cin >> x;

    vector dp(2, vector<ld>(m + 1));
    for (int i = 1; i <= min(m, a[0]); ++i) {
        dp[0][i] = a[0] / i;
    }

    for (int i = 1; i < n; ++i) {
        for (int j = 1; j <= min(m, a[i]); ++j) {
            for (int k = 0; k <= m && (k - 1) * j <= m; ++k) {
                umax(dp[i & 1][min(m, k * j)], dp[~i & 1][k] * (a[i] / j));
            }
        }
    }

    ld ans = dp[~n & 1][m];
    for (int i = 0; i < n; ++i) {
        ans /= a[i];
    }
    ans *= m;

    cout << ans << '\n';
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(20);

    int T = 1;
    // cin >> T;

    while (T--) {
        solve();
    }
}