#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}

vector<ll> a;
vector<vector<ll>> c;
ll get(ll k, ll i){
    if (i == -1){
        return k == 1;
    }
    if (c[i][k] != -1){
        return c[i][k];
    }
    ll maxim = 0;
    for (int b = 1; b <= a[i]; b++){
        ll temp_k = k;
        if (temp_k % b != 0){
            temp_k += b - temp_k % b;
        }
        maxim = max(maxim, get(temp_k / b, i - 1) * (a[i] / b));
    }
    c[i][k] = maxim;
    return maxim;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    c.resize(n, vector<ll> (k + 1, -1));
    a.resize(n);
    cin >> a;
    long double ans = k;
    for (auto el: a) {
        ans /= ld(el);
    }
    long double maxim = get(k, n - 1);
    cout  << fixed << setprecision(16)<< maxim * ans << "\n";
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}