import sys
input = sys.stdin.readline


def cmp(a, b):
    if a[-1] != b[-1]:
        return a[-1] < b[-1]
    l, r = -1, len(a)
    while r - l > 1:
        m = (r + l) // 2
        if a[m] > b[-1]:
            r = m
        else:
            l = m
    ans = len(a) - r + len(b)
    l, r = -1, len(b)
    while r - l > 1:
        m = (r + l) // 2
        if b[m] > a[-1]:
            r = m
        else:
            l = m
    ass = len(b) - r + len(a)
    return ans < ass


def merge(a):
    if len(a) == 1:
        return a
    m = len(a) // 2
    x = a[:m]
    y = a[m:]
    x = merge(x)
    y = merge(y)
    i, j = 0, 0
    while i < len(x) and j < len(y):
        if cmp(x[i], y[j]):
            a[i + j] = x[i]
            i += 1
        else:
            a[i + j] = y[j]
            j += 1
    while i < len(x):
        a[i + j] = x[i]
        i += 1
    while j < len(y):
        a[i + j] = y[j]
        j += 1
    return a


def solve2(a):
    a = merge(a)
    x = -1
    ans = 0
    for i in range(len(a)):
        for j in a[i]:
            if j > x:
                ans += 1
                x = j
    print(ans)


def solve():
    n, k = map(int, input().split())
    a = list(map(int, input().split()))
    if n == 1:
        print((a[0] // k) * (1 / a[0]) * k)
    else:
        ans = 0
        for i in range(1, a[0] + 1):
            for j in range((k - 1) // i + 1, a[1] + 1):
                ans = max(ans, (a[0] // i) * (a[1] // j) * (1 / (a[0] * a[1])) * k)
        print(ans)


solve()
