#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


#define int long long

void solve() {
	int n, k; cin >> n >> k;
	vector <int> v(n); for (auto& x : v) cin >> x;

	vector <double> dp(k + 1, 0); dp[1] = 1;
	for (int i = 0; i < n; ++i) {
		vector <double> dp1(k + 1, 0);
		for (int j = 1; j <= k; ++j) {
			for (int u = 1; u <= k && u * (j - 1) < k; ++u) {
				dp1[min(u * j, k)] = max(dp1[min(u * j, k)], dp[u] * (v[i] / j) / v[i]);
			}
		}
		dp = dp1;
	}

	cout << dp.back() * k;
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}