#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


//#define int long long

void solve() {
	int n, k; cin >> n >> k;
	int* v = new int[n];
	for (int i = 0; i < n; ++i) {
		cin >> v[i];
	}

	double* dp = new double[k + 1]; fill(dp, dp + k + 1, 0.0); dp[1] = 1.0;
	for (int i = 0; i < n; ++i) {
		for (int j = k; j >= 0; --j) {
			for (int u = (k + j - 1) / j; u >= 1; --u) {
				dp[min(u * j, k)] = max(dp[min(u * j, k)], dp[j] * (v[i] / u) / v[i]);
			}
		}
	}

	cout << dp[k] * k;
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}