#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int MAXN = 2e7 + 50;

ld dp[MAXN];

signed main() {
    int n, k;
    cin >> n >> k;
    for (int i = 0 ; i < MAXN; i++) {
        dp[i] = 0;
    }
    dp[1] = 1;
    vector <int> task;
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }
    int pos;
    for (int p = 0; p < n ; p++) {
        for (int i = k; i > 0; i--) {
            if (dp[i] != 0) { 
                pos = i;
                for (int mul = 2; mul <= task[p]; mul++) {
                    pos += i;
                    if (pos >= 2 * k) { // MAXN -> 2k
                        break;
                    }
                    dp[pos] = max(dp[pos], dp[i] * (task[p] / mul) / task[p]);
                }
            }
        }
        // for (int i = 0; i < 50 ;i++) {
        //     cout << dp[i] << " ";
        // }
        // cout << "\n";
    }
    ld ans = 0, tmp;
    for (int i = k; i < MAXN; i++) {
        tmp = dp[i];
        ans = max(ans, tmp);
    }
    ans *= k;
    cout << setprecision(15) << ans;
}