#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int MAXN = 1e7 + 50;
const int sqr = 1000;

double small[1000][1000];

double dp[MAXN];

int n, k;

void sol_2() {
    vector <int> task;
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }
    double ans = 0, tmp;
    if (n == 1) {
        if (k <= task[0]) {
            ans = (task[0] / k);
            ans /= task[0];
            ans *= k;
            cout << setprecision(23) << ans;
        } else {
            cout << 0;
        }
    } else {
        int pp = task[1];
        for (int i = 1 ; i <= task[0]; i++) {
            while (pp > 0 && (i * pp) >= k) {
                tmp = (task[0] / i);
                tmp /= task[0];
                tmp *= (task[1] / pp);
                tmp /= task[1];
                tmp *= k;
                ans = max(ans, tmp);
                pp--;
            }
        }
        cout << setprecision(23) << ans;
    }
}

signed main() {
    cin >> n >> k;
    if (n <= 2) {
        sol_2();
        return 0;
    }
    for (int i = 0 ; i < MAXN; i++) {
        dp[i] = 0;
    }
    dp[1] = 1;
    vector <int> task;
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }
    int pos;
    for (int p = 0; p < n ; p++) {
        for (int i = k; i > 0; i--) {
            if (dp[i] != 0) { 
                pos = i;
                int rec = -1;
                for (int mul = 2; mul <= task[p]; mul++) {
                    pos += i;
                    if (pos >= k) { // MAXN -> 2k
                        rec = mul;
                        break;
                    }
                    dp[pos] = max(dp[pos], dp[i] * (task[p] / mul) / task[p]);
                }
                if (rec != -1) {
                    dp[pos] = max(dp[pos], dp[i] * (task[p] / rec) / task[p]);
                }
            }
        }
        // for (int i = 0; i < 50 ;i++) {
        //     cout << dp[i] << " ";
        // }
        // cout << "\n";
    }
    double ans = 0, tmp;
    for (int i = k; i < MAXN; i++) {
        tmp = dp[i];
        ans = max(ans, tmp);
    }
    ans *= k;
    cout << setprecision(15) << ans;
}