#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define dl long double
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    sort(all(a));
    int M = 2 * k;
    vector<int> dp(M + 1);
    for (int i = 1; i <= min(M, a[0]); ++i) {
        dp[i] = a[0] / i;
    }
    for (int i = 1; i < n; ++i) {
        vector<int> new_dp(M + 1);
        for (int b = 1; b <= a[i]; ++b) {
            for (int was = 1; was * b <= M; ++was) {
               new_dp[was * b] = max(new_dp[was * b], dp[was] * (a[i] / b));
            }
        }
        dp = new_dp;
    }
    dl ans = 0;
    for (int i = k; i <= M; ++i) {
        ans = max(ans, (dl)dp[i]);
    }
    ans *= (dl)k;
    for (int i = 0; i < n; ++i) {
        ans /= (dl) a[i];
    }
    cout<<fixed<<setprecision(20)<<ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}