#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 5e5 + 300, mod = 1e9 + 7;
void solve(){
    ll n, k;
    cin >> n >> k;
    vector<ll> nums(n);
    for(int i = 0; i < n; i++)
        cin >> nums[i];
    sort(nums.begin(), nums.end());
    ll max_val = 1;
    for(ll num : nums){
        max_val *= num;
        if(max_val >= k)
            break;
    }
    if(max_val < k){
        cout << 0;
        return;
    }
    if(n == 1){
        ll s = nums[0] / k;
        cout << setprecision(10) << (long double)s / (long double)nums[0] * (long double)k;
        return;
    }
    if(n == 2){
        long double ans = 0;
        for(int j = 1; j <= nums[0]; j++){
            ll need = k / j + (k % j > 0);
            long double part_a = (nums[0] / j) / (long double)nums[0];
            long double part_b = (nums[1] / need) / (long double) nums[1];
            ans = max(ans, part_a * part_b * k);
        }
        cout << setprecision(10) << ans;
        return;
    }
    vector<vector<long double>> dp(n + 1, vector<long double>(limit));
    dp[0][1] = 1;
    for(int i = 1; i <= n; i++){
        for(int j = 1; j <= k; j++){
            for(int v = 1; v * j < dp[0].size() && v <= nums[i - 1]; v++) {
                ll side = nums[i - 1] / v;
                dp[i][v * j] = max(dp[i][v * j],
                                   dp[i - 1][j] * ((long double) side / (long double) nums[i - 1]));
            }
        }
    }
    long double ans = 0;
    for(int j = 1; j <= n; j++)
    for(int i = k; i < dp[n].size(); i++)
        ans = max(ans, (long double)(dp[j][i] * k));
    cout << setprecision(15) << ans;
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}