#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld long double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return (rng() % (r - l + 1)) + l;
}

const int N = 2e4 + 10;

long double dp[2][N];

const ld eps = 1e-12;

int sign (ld x) {
    if (x > eps) return 1;
    if (x < -eps) return -1;
    return 0;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    cin >> a;
    dp[0][1] = 1;
    for (int i = 0; i < n; i++) {
        int A = (i + 1) & 1;
        for (int j = 0; j <= k; j++) {
            dp[A][j] = 0;
        }
        for (int borrow = 1; borrow <= a[i]; borrow++) {
            int x = a[i] / borrow;
            for (int from = 1; from <= k; from++) {
                int nxt = min(k, from * borrow);
                long double z = (ld)(x) / (ld)(a[i]);
                dp[A][nxt] = max(dp[A][nxt], dp[A ^ 1][from] * z);
            }
        }
    }
    cout << dp[(n) & 1][k] * k << '\n';
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(20);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */