#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;

const ld EPS = 2e-14;

void solve()
{
	int n, k;
	cin >> n >> k;
	vll a(n);
	for (auto& elem : a) {
		cin >> elem;
	}
	sort(a.begin(), a.end());
	ll ans = 0;
	if (n == 1) {
		for (int i = k; i <= a[0]; i++) {
			ans = max(ans, a[0] / i);
		}
		cout << fixed << setprecision(10) << k * ans * (ld)1 / a[0];
		return;
	}
	if (n == 2) {
		for (int i = 1; i <= a[0]; i++) {
			int nd = (k + i - 1) / i;
			if (nd > a[1]) {
				continue;
			}
			ans = max(ans, (a[0] / i) * (a[1] / nd));
		}
		ld tmp = 1;
		for (auto& elem : a) {
			tmp *= 1.0 / (ld)elem;
		}
		tmp *= k;
		tmp *= ans;
		cout << fixed << setprecision(10) << tmp;
		return;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}
