#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

const int maxn = 1 << 18;
const int inf = 1e9;
const int mod = 1e9 + 7;

long double ans = 0;
long double optprod = 0;
long double minprod = inf;

vector<long double> solve(int l, int r, vector<int> &a, int c) {
    if (l + 1 == r) {
        vector<long double> res(c, 0);
        for (int i = 1; i <= a[l] && i < c; ++i) {
            res[i] = a[l] / i * 1.0 / a[l];
        }
        return res;
    }
    int m = (l + r) / 2;
    vector<long double> res1 = solve(l, m, a, c);
    vector<long double> res2 = solve(m, r, a, c);
    vector<long double> res(c, 0);
    for (int i = 1; i < c; ++i) {
        for (int j = i; j < c; j += i) {
            res[j] = max(res[j], res1[i] * res2[j / i]);
        }
    }
    return res;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    vector<long double> res = solve(0, n, a, maxn);
    ans = 0;
    for (int i = k; i < maxn; ++i) {
        ans = max(ans, res[i]);
    }
    cout << fixed << setprecision(20) << ans * k << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
