#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;

const int maxn = 400000;
const int inf = 1e9;
const int mod = 1e9 + 7;

double ans = 0;
long double optprod = 0;
long double minprod = inf;
double tr[256][maxn];
void solve(int v, int l, int r, vector<int> &a, int c) {
    if (l + 1 == r) {
        for (int i = 1; i <= a[l] && i < c; ++i) {
            tr[v][i] = a[l] / i * 1.0 / a[l];
        }
        return;
    }
    int m = (l + r) / 2;
    solve(v * 2, l, m, a, c);
    solve(v * 2 + 1, m, r, a, c);
    for (int i = 1; i < c; ++i) {
        for (int j = i; j < c; j += i) {
            tr[v][j] = max(tr[v][j], tr[v * 2][i] * tr[v * 2 + 1][j / i]);
        }
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int& i : a) {
        cin >> i;
    }
    solve(1, 0, n, a, k * 2);
    ans = 0;
    for (int i = k; i < k * 2; ++i) {
        ans = max(ans, tr[1][i]);
    }
    cout << fixed << setprecision(20) << ans * k << endl;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
