#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <random>
#include <string>
#include <fstream>

using namespace std;

#define ll long long

int n, k;

double eps = (1e-9) / 2;

double ans(ll a, ll b) {
	double l = 0, r = 1e15, m;

	while (r - l > eps) {
		m = (r + l) / 2;

		if (m * b < a) l = m;
		else r = m;
	}
	return r;
}

void out(long double x) {
	cout << (int)x << '.';
	x = x - (int)x;
	for (int i = 0; i < 10; i++) {
		x *= 10;
		cout << (int)x;
		x -= (int)x;
	}
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int a, b;
	cin >> n >> k;
	cin >> a >> b;
	double ans = 1;

	for (int i = 1; i <= k; i++) {
		
		int j = (k + i - 1) / i;
		int x = (a / i) * (b / j);
		ans = max(ans, (double)x / (a * b) * k);
	}
	out(ans);

	return 0;
}