#include <algorithm>
#include <cmath>
#include <iostream>
#include <vector>

using namespace std;

int main() {
    int n;
    int k;
    cin >> n >> k;
    vector<long double> a(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }

    vector<vector<long double>> dp(n + 1, vector<long double>(k + 1));

    dp[0][1] = 1;

    for (int i = 1; i <= n; i++) {
        dp[i][1] = 1;
        for (int cnt = 1; cnt <= k; cnt++) {
            for (int prevcnt = 1; prevcnt <= cnt; prevcnt++) {
                int ccnt = (cnt + prevcnt - 1) / prevcnt;
                dp[i][cnt] = fmaxl(dp[i][cnt], dp[i - 1][prevcnt] * floor(a[i - 1] / ccnt));
            }
        }
    }

    long double res = dp[n][k];

    long double ck = 1.L;
    for (int i = 0; i < n; i++) {
        ck *= a[i];
    }

    ck = 1 / ck;
    ck *= k;
    ck *= dp[n][k];

    cout.precision(10);
    cout << fixed << "\n";
    cout << ck << "\n";
}
