#include <bits/stdc++.h>

#define double long double

void solve() {
    int n, k;
    std::cin >> n >> k;
    std::vector<int> input(n);
    for (int& i : input) {
        std::cin >> i;
    }
    std::sort(input.rbegin(), input.rend());
    // int n2 = 32 - __builtin_clz(k - 1) + 1;
    // assert((1 << n2) >= k);
    // if (n > n2) {
    //     n = n2;
    //     input.resize(n);
    // }

    std::vector<double> dp(k + 1);
    dp[1] = 1;

    auto suf_max = [](auto& vec) {
        for (int i = (int)vec.size() - 1; i >= 1; i--) {
            vec[i - 1] = std::max(vec[i - 1], vec[i]);
        }
    };

    for (int t = 0; t < n; t++) {
        suf_max(dp);

        static std::vector<std::pair<int, int>> cum;
        cum.clear();
        int val = input[t];
        for (int i = val; i >= 1; i--) {
            // if (val / i != val / (i + 1)) {
            cum.push_back({i, val / i});
            // }
        }
        auto get = [&](int i, int j) {
            return dp[(i - 1) / cum[j].first + 1] * cum[j].second;
        };
        for (int i = k, j = 0; i >= 1; i--) {
            double sh = dp[i];
            for (int j = 0; j < cum.size(); j++) {
                int pos = std::min<int64_t>(k, i * 1LL * cum[j].first);
                dp[pos] = std::max(dp[pos], sh * cum[j].second);
            }
            // dp[i] = sh;
        }
    }

    suf_max(dp);

    double denom = std::accumulate(input.begin(), input.end(), 1, std::multiplies<double>());
    double ans = dp[k];
    ans /= denom;
    ans *= k;

    if (ans == 0) {
        std::cout << "0\n";
        return;
    }

    assert(ans > 0.4);
    std::cout << ans << "\n";
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    std::cout.precision(20);
    std::cout << std::fixed;

    int t = 1;
#ifdef LOCAL
    std::cin >> t;
#endif
    while (t--) {
        solve();
    }

    return 0;
}
