#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    ll p = 1;
    bool can = false;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
        p *= 1LL * a[i];
        if (p >= k) {
            can = true;
        }
    }
    if (!can) {
        cout << 0 << en;
        return;
    }
    ld ans = 0;
    if (n == 1) {
        ld v = 1 / (ld)(a[0]);
        for (int i = 1; i <= a[0]; ++i) {
            if (i < k) {
                continue;
            }
            ll now = a[0] / i;
            ans = max(ans, v * k * now);
        }
        cout << fixed << setprecision(12);
        cout << ans << en;
        return;
    }
//    ld v = 1 / (ld)(a[0]) / (ld)(a[1]);
    for (int i = 1; i <= a[0]; ++i) {
        for (int j = 1; j <= a[1]; ++j) {
            if (i * j < k) {
                continue;
            }
            ll now = 1;
            ld v = 1;
            if (i != 0) {
                now *= a[0] / i;
                v /= (ld)(a[0]);
            }
            if (j != 0) {
                now *= a[1] / j;
                v /= (ld)(a[1]);
            }
            ans = max(ans, v * k * now);
        }
    }
    cout << fixed << setprecision(12);
    cout << ans << en;
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 5;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
