#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int __int128_t
#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 2e9;
const ll MOD = 1e9 + 7;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

signed main(){
    Fast();
    ll n, k;
    cin >> n >> k;
    vector <ll> a(n + 1);
    vector <vector <int>> p(2 * k + 1);
    for (int i = 1; i <= 2 * k; i++){
        for (int j = 1; j * j <= i; j++){
            if (i % j) p[i].push_back(j), p[i].push_back(i / j);
        }
    }
    int sum = 1;
    bool flag = false;
    for (int i = 1; i <= n; i++){
        cin >> a[i];
        sum *= a[i];
        if (sum >= k) flag = true;
    }
    if (!flag){
        cout << 0;
        return 0;
    }
    vector <vector <ld>> dp(n + 1, vector <ld> (2 * k + 1)), pref(n + 1, vector <ld> (2 * k + 1));
    for (int i = 0; i <= n; i++) {
        dp[i][0] = -INF;
        pref[i][0] = -INF;
    }
    dp[0][1] = 1;
    pref[0][1] = 1;
    for (int i = 2; i <= 2 * k; i++){
        dp[0][i] = -INF;
        pref[0][i] = -INF;
    }
    for (int j = 1;  j <= 2 * k; j++){
        for (int i = 1; i <= n; i++){
            for (int y:p[j]){
                int g = a[i] / y;
                int e = j / y;
                dp[i][j] = max(dp[i][j], (ld)(g * pref[i - 1][e]) / (ld)a[i]);
                g = (a[i] / e);
                dp[i][j] = max(dp[i][j], (ld)(g * pref[i - 1][y]) / (ld)a[i]);
            }
            pref[i][j] = max(pref[i - 1][j], dp[i][j]);
        }
    }
    ld ma = 0;
    for (int i = k; i <= k * 2; i++) ma = max(ma, dp[n][i]);
    ld ans = ma * k;
    ans = max((ld)0, ans);
    cout << fixed << setprecision(11);
    cout << ans;
    return 0;
}
