#include <bits/stdc++.h>

#define ll long long
#define ld double
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

using namespace std;

int main(){
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	cin.tie(0);
	#ifdef ON_PC
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif // ON_PC
	int T = 1;
//	cin >> T;
	while (T--){
		int n, k;
		cin >> n >> k;
		vector<int> a(n);
		for (int i = 0; i < n; i++){
			cin >> a[i];
		}
		sort(rall(a));
		{
			int i = 0;
			__int128_t mult = 1;
			while (i < n && mult < k){
				mult *= a[i];
				i++;
			}
			if (mult < k){
				cout << 0 << "\n";
				continue;
			}
		}
		function<ld(vector<int>)> calc_ans = [&](vector<int> t){
			ld res = 1;
			for (int i = 0; i < n; i++){
				res *= (int)(a[i] / t[i]);
			}
			res *= k;
			for (int i = 0; i < n; i++){
				res /= a[i];
			}
			return res;
//			cout << fixed << setprecision(11) << res << "\n";
		};
		if (n == 1){
			cout << fixed << setprecision(11) << calc_ans({k}) << "\n";
			continue;
		}
		if (n == 2){
			vector<int> best = a;
			for (int x = 1; x <= a[0]; x++){
				int y = (k + x - 1) / x;
				if (y == 0){
					y++;
				}
				if (calc_ans({x, y}) > calc_ans(best)){
					best = {x, y};
				}
			}
			cout << fixed << setprecision(11) << calc_ans(best) << "\n";
			continue;
		}
//		cout << 4e4 * 100 * 14 << "\n";
		vector<vector<ld>> dp(n, vector<ld>(2 * k + 1, -1e9));
		for (int i = 1; i <= a[0]; i++){
			dp[0][i] = k * (int)(a[0] / i) * ((ld)1 / a[0]);
		}
		for (int i = 1; i < n; i++){
			for (int prev = 1; prev <= 2 * k; prev++){
				for (int j = 1; j <= a[i] && prev * 1ll * j <= 2 * k; j++){
					dp[i][prev * j] = max(dp[i][prev * j], dp[i - 1][prev] * (int)(a[i] / j) * ((ld)1 / a[i]));
				}
			}
		}
		ld res = 0;
		for (int i = k; i <= 2 * k; i++){
			res = max(res, dp[n - 1][i]);
		}
		cout << fixed << setprecision(11) << res << "\n";
	}
	return 0;
}
