#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
mt19937_64 gen(chrono::steady_clock::now().time_since_epoch().count());
const ll INF=1e18+2;
const ll N=1e7+2;

ve<ll> getv(ll x)
{
    ve<ll> v;
    ll pos=1;

    while(x/pos>=2)
    {
        ll l=pos,r=x;

        while(l<r)
        {
            ll mid=(l+r+1)/2;
            if(x/mid==x/pos) l=mid;
            else r=mid-1;
        }

        v.PB(l);
        pos=l+1;
    }

    v.PB(x);
    return v;
}

ll arr[N];
ld dp[N],dp1[N];

void solve()
{
    ll n,k;
    cin>>n>>k;

    for(ll i=0;i<n;i++)
        cin>>arr[i];

    shuffle(arr,arr+n,gen);
    ll tl=1.9*CLOCKS_PER_SEC;
    dp[1]=k;

    for(ll i=0;i<n&&clock()<tl;i++)
    {
        ve<ll> v=getv(arr[i]);
        ve<pll> p;

        for(ll j=0;j<k;j++)
        {
            if(dp[j]!=0)
                p.PB({dp[j],j});
        }

        sort(all(p),greater<pll>());

        for(ll pos=0;pos<min(20000000ll/ll(n*v.size()),ll(p.size()));pos++)
        {
            ll j=p[pos].S;
            if(dp[j]==0) continue;
            for(ll y:v) dp1[min(k,j*y)]=max(dp1[min(k,j*y)],dp[j]*(arr[i]/y)/arr[i]);
        }

        for(ll j=0;j<=k;j++)
            dp[j]=dp1[j];
    }

    cout<<fixed<<setprecision(12)<<dp[k];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
