#include <bits/stdc++.h>

using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;
typedef long double ld;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    assert(n <= 2);
    if (n == 1) {
        a.push_back(1);
        n++;
    }

    map<ll, ll> m1, m2;
    for (int i = 1; i <= a[0]; i++) {
        m1[a[0] / i] = i;
    }
    for (int i = 1; i <= a[1]; i++) {
        m2[a[1] / i] = i;
    }

    ll mx = -1;
    for (auto [e1, b1] : m1) {
        for (auto [e2, b2] : m2) {
            if (b1 * b2 >= k) {
                mx = max<ll>(mx, e1 * e2);
            }
        }
    }

    if (mx == -1) {
        cout << -1 << '\n';
        return 0;
    }

    ld ans = mx * k;
    for (int i = 0; i < n; i++) ans = ans / a[i];
    cout << fixed << setprecision(10) << ans << '\n';

    return 0;
}
