#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;
typedef long double ld;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << fixed << setprecision(9);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<cc_hash_table<int, int>> m(n);
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= a[i]; j++) {
            m[i][a[i] / j] = j;
        }
    }

    if (n <= 2) {
        if (n == 1) {
            a.push_back(1);
            n++;
        }

        map<ll, ll> m1, m2;
        for (int i = 1; i <= a[0]; i++) {
            m1[a[0] / i] = i;
        }
        for (int i = 1; i <= a[1]; i++) {
            m2[a[1] / i] = i;
        }

        ll mx = 0;
        for (auto [e1, b1] : m1) {
            for (auto [e2, b2]: m2) {
                if (b1 * b2 >= k) {
                    mx = max(mx, e1 * e2);
                }
            }
        }

        ld ans = mx * k;
        for (int i = 0; i < n; i++) ans = ans / a[i];
        cout << ans << '\n';
    } else {
        ld ans = 0;
        vector<vector<ld>> dp(n, vector<ld>(k));
        dp[0][1] = k;
        for (int i = 0; i < n; i++) {
            for (int j = 1; j < k; j++) {
                for (auto [sz, nxt] : m[i]) {
                    if (j * nxt >= k) {
                        ans = max(ans, dp[i][j] * sz / a[i]);
                    } else if (i + 1 < n) {
                        dp[i + 1][j * nxt] = max(dp[i + 1][j * nxt], dp[i][j] * sz / a[i]);
                    }
                }
            }
        }

        cout << ans << '\n';
    }

    return 0;
}
