#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;
typedef long double ld;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << fixed << setprecision(9);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<vector<pair<int, int>>> m(n);
    for (int i = 0; i < n; i++) {
        int cur = a[i];
        while (true) {
            if (cur == 0) break;
            m[i].push_back({a[i] / cur, cur});
            cur = a[i] / (a[i] / cur + 1);
        }
        reverse(all(m[i]));
    }

    ld ans = 0;
    vector<ld> dp1(k), dp2(k);
    dp1[1] = k;
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < k; j++) {
            for (auto [sz, nxt] : m[i]) {
                if (j * nxt >= k) {
                    ans = max(ans, dp1[j] * sz / a[i]);
                    break;
                } else if (i + 1 < n) {
                    dp2[j * nxt] = max(dp2[j * nxt], dp1[j] * sz / a[i]);
                }
            }
        }
        swap(dp1, dp2);
        dp2.assign(k, 0);
    }

    cout << ans << '\n';

    return 0;
}