#include <iostream>
#include <vector>
#include <cmath>
#include <string>
#include <map>
#include <set>
#include <deque>
#include <random>
#include <unordered_map>
#include <iomanip>

using namespace std;
typedef long long ll;
typedef long double ld;

int main() {
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int n, k;
	ld ans = 0;
	cin >> n >> k;
	vector<ld>dp(k);
	dp[1] = 1;
	for (int i = 0; i < n; i++) {
		int x; cin >> x;
		ld xld = x;
		for (int s = k - 1; s >= 1; s--) {
			if (dp[s] == 0)
				continue;
			for (int cnt = 1; cnt <= x; cnt++) {
				ll will = 1ll * s * cnt;
				ld score = dp[s] * (x / cnt) / xld;
				if (will >= k) {
					ans = max(ans, score);
					break;
				}
				else
					dp[will] = max(dp[will], score);
			}
		}
	}
	cout << setprecision(10) << fixed << ans * k;
	return 0;
}