#include <bits/stdc++.h>

#define int int64_t

const int INF = 2e18;
const int MOD = 998244353;
const int MAXN = 1e5;
const long double EPS = 1e-5;
const long double EPS1 = 1e-6;

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int gcd(int a, int b){
    while(a != 0 && b != 0){
        a %= b;
        swap(a, b);
    }
    return a + b;
}

int nok(int a, int b){
    return a / gcd(a, b) * b;
}

int bin_p(int a, int p){
    if(p == 0){
        return 1;
    }
    if(p % 2 == 0){
        int k = bin_p(a, p / 2);
        return k * k % MOD;
    }
    else{
        return bin_p(a, p - 1) * a % MOD;
    }
}
vector <int> temp;
vector <int> v;
int n, k;
long double ans = 0;
void rec(int i, int kolch, long double an){
    //cout << i << ' ' << kolch << ' ' << an << endl;
    if(i == v.size()){
        if(kolch < k){
            return;
        }
        if(an >= ans){
            cout << an << ' ';
            for(auto i:temp){
                cout << i << ' ';
            }
            cout << endl;
        }
        ans = max(ans, an);
        return;
    }
    int ch = v[i];
    int last = 1;
    int pr = ch / last;
    while(1){
        temp.push_back(last);
        rec(i + 1, min(k, kolch * last), an * pr / v[i]);
        temp.pop_back();
        if(kolch * last >= k){
            break;
        }
        if(pr == 1){
            break;
        }
        if(ch / (last + 1) == pr){
            if(pr == 1){
                last = ch;
            }
            else{
                last = ch / (pr - 1) + 1;
            }
        }
        else{
            last = ch / (ch / (last + 1));
        }
        pr = ch / last;
    }
}

void solve(){
    cin >> n >> k;
    int mx = 0;
    int pr = 1;
    for(int i = 0; i < n; i++){
        int a;
        cin >> a;
        if(pr < k){
            pr *= a;
        }
        mx = max(mx, a);
        v.push_back(a);
    }
    if(pr < k){
        cout << 0;
        return;
    }
    vector <pair<int, int>> vp[n];
    for(int i = 0; i < n; i++){
        int pr = v[i];
        int last = 1;
        int ch = v[i];
        while(1){
            vp[i].push_back({pr, last});
            if(pr == 1){
                break;
            }
            if(ch / (last + 1) == pr){
                if(pr == 1){
                    last = ch;
                }
                else{
                    last = ch / (pr - 1) + 1;
                }
            }
            else{
                last = ch / (ch / (last + 1));
            }
            pr = ch / last;
        }
    }
    map <int, long double> mp;
    long double o = 1;
    mp[1] = 1;
    set <int> st;
    st.insert(1);
    for(int i = 0; i < n; i++){
            vector <pair<int, long double>> aa;
        for(auto j:st){
            for(auto [b, a]:vp[i]){
                aa.push_back({min(k, b * j), o * mp[j] * a / v[i]});
            }
        }
        for(auto [i1, zn]:aa){
            mp[i1] = max(mp[i1], zn);
            st.insert(i1);
        }
        aa.clear();
    }
    cout << fixed << setprecision(10) << mp[k] * k;
}

signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
        cout << endl;
    }
    return 0;
}
