#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll INF = 1e16;

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> arr(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
    }

    vector<vector<ll>> maxx(n + 1, vector<ll>(k + 1, -INF));
    maxx[0][1] = 0;
    for (ll i = 1; i <= n; ++i) {
        for (ll nowk = 1; nowk <= k; ++nowk) {
            ll j = 1;
            while (j * j <= nowk) {
                if (nowk % j == 0) {
                    if (j <= arr[i]) {
                        maxx[i][nowk] = max(maxx[i][nowk], maxx[i - 1][nowk / j] + arr[i] / j);
                    }
                    if (nowk / j <= arr[i]) {
                        maxx[i][nowk] = max(maxx[i][nowk], maxx[i - 1][j] + arr[i] / (nowk / j));
                    }
                }

                ++j;
            }
        }
    }

    if (maxx[n][k] == 0) {
        cout << 0 << "\n";
    } else {
        ld ans = ld(k);
        for (ll i = 1; i <= n; ++i) {
            ans /= ld(arr[i]);
        }
        ans *= ld(maxx[n][k]);
        cout << fixed << setprecision(9) << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}
