#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> arr(n + 1);
    for (ll i = 1; i <= n; ++i) {
        cin >> arr[i];
    }

    if (n == 1) {
        if (arr[1] >= k) {
            double ans = double(k);
            ans /= double(arr[1]);
            ans *= double(arr[1] / k);
            cout << fixed << setprecision(32) << ans << "\n";
        } else {
            cout << 0 << "\n";
        }
        exit(0);
    }
    if (n == 2) {
        double best = 0;
        for (ll i = 1; i <= arr[1]; ++i) {
            ll second = (k + i - 1) / i;
            double ans = 0;
            if (arr[2] >= second) {
                ans = double(k);
                ans /= double(arr[1]);
                ans /= double(arr[2]);
                ans *= double(arr[1] / i);
                ans *= double(arr[2] / second);
            }

            best = max(ans, best);
        }

        cout << fixed << setprecision(32) << best << "\n";
        exit(0);
    }

    sort(arr.begin() + 1, arr.end());

    vector<vector<ll>> num(n + 1, vector<ll>(k + 1, 0));
    num[0][1] = 1;
    for (ll i = 1; i <= n; ++i) {
        for (ll prevk = 1; prevk <= k; ++prevk) {
            for (ll a = 1; a <= arr[i]; ++a) {
                num[i][min(k, prevk * a)] = max(num[i][min(k, prevk * a)], num[i - 1][prevk] * (arr[i] / a));
            }
        }
    }

    ll maxx1 = num[n][k];
    if (maxx1 == 0) {
        cout << 0 << "\n";
    } else {
        double ans = 1;
        ans *= maxx1;
        ans *= k;
        for (
                ll i = 1;
                i <=
                n;
                ++i) {
            ans /= double(arr[i]);
        }
        cout << fixed << setprecision(100) << ans << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}