#include <bits/stdc++.h>
#include <bits/extc++.h>

#include <random>
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;



#define int long long
const int N = 2e5 + 7;
const int M = 1e9 + 7;

vector<pair<int, int>> gr[N];
vector<pair<int, int>> rev_gr[N];
vector<vector<bool>> used;

void solve() {
    int n, k;
    cin >> n >> k;
    if (n <= 2) {
        vector<int> vec(n);
        for (int i = 0; i < n; ++i) {
            cin >> vec[i];
        }
        vector<pair<int, double>> vecs;
        vecs.push_back({1, k});
        shuffle(vecs.begin(), vecs.end(), std::mt19937(std::random_device()()));
        double ans = 0;
        for (int i = 0; i < n; ++i) {
            vector<pair<int, double>> here;
            for (int k1 = 1; k1 * k1 <= vec[i]; ++k1) {
                here.push_back({k1, (double)(vec[i] / k1) / vec[i]});
                int k2 = vec[i] / k1;
                here.push_back({k2, (double)(vec[i] / k2) / vec[i]});
            }
            int sz = vecs.size();
            for (int j = 0; j < sz; ++j) {
                for (auto c: here) {
                    if (vecs[j].first * c.first >= k) {
//                    cout << c.first << " " << c.second << endl;
                        ans = max(ans, c.second * vecs[j].second);
                        continue;
                    } else {
                        vecs.push_back({vecs[j].first * c.first, c.second * vecs[j].second});
                    }
                }
            }
        }
        cout << ans;
        return;
    }
    vector<int> vec(n);
    for (int i = 0; i < n; ++i) {
        cin >> vec[i];
    }
    vector<pair<int, double>> vecs;
    vector<double> dp(k + 1);
    dp[1] = k;
    double ans = 0;
    for (int i = 0; i < n; ++i) {
        vector<pair<int, double>> here;
        for (int k1 = 1; k1 * k1 <= vec[i] and k1 <= 10; ++k1) {
            here.push_back({k1, (double)(vec[i] / k1) / vec[i]});
            int k2 = vec[i] / k1;
            here.push_back({k2, (double)(vec[i] / k2) / vec[i]});
        }
        for (int k1 = max((int)sqrt(vec[i]) - 10, 0LL); k1 * k1 <= vec[i]; ++k1) {
            here.push_back({k1, (double)(vec[i] / k1) / vec[i]});
            int k2 = vec[i] / k1;
            here.push_back({k2, (double)(vec[i] / k2) / vec[i]});
        }
        sort(here.begin(), here.end());
        vector<pair<int, double>> here2;
        for (auto c : here) {
            while (!here2.empty() and here2.back().second <= c.second) {
                here2.pop_back();
            }
            here2.push_back(c);
        }
        for (int j = k - 1; j >= 0; --j) {
            for (auto c : here2) {
                if (j * c.first >= k) {
                    ans = max(ans, c.second * dp[j]);
                    break;
                } else {
                    dp[c.first * j] = max(dp[c.first * j], c.second * dp[j]);
                }
            }
        }
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed;
    cout.precision(12);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}