#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    cin >> a;
    cout << fixed << setprecision(10);
    if (n == 1) {
        cout << (a[0] / k) * (ld) 1 / (ld) a[0] * k;
        return 0;
    }
    ll ans = 0;
    for (int b1 = 1; b1 <= a[0]; ++b1) {
        // b1 * b2 >= k
        // b2 >= ceil(k / b1)
        int b2 = (k + b1 - 1) / b1;
//        assert(b1 * b2 >= k);
        if (b2 <= a[1]) {
            ans = max(ans, (a[0] / b1) * 1ll * (a[1] / b2));
        }
    }
    cout << ans * ((ld) 1 / (ld) a[0]) * ((ld) 1 / (ld) a[1]) * k;
}
