#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>

using namespace std;

#define ll long long
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), rend()
#define bit(i, n) ((n >> i) & 1)

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

vector<ll> pr, v, suf;
ll k;

ll dp[10000000][2];
bool was[10000000][2];

ll f(ll tk, int n) {
	if (tk >= k) re suf[n];
	if (n >= v.size())re 0;
	if (was[tk][n])re dp[tk][n];
	was[tk][n] = true;

	ll& ans = dp[tk][n];

	for (ll i = 1; i <= v[n]; i++) {
		ans = max(ans, f(tk * i, n + 1) * (v[n] / i));
		if (i * tk >= k)break;
	}

	re ans;
}


int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr); cout.tie(nullptr);

	memset(dp, 0, sizeof(dp));
	memset(was, 0, sizeof(was));

	ll n; cin >> n >> k;
	v.resize(n);
	cin >> v;
	suf.resize(n + 1);
	suf[n] = 1;
	for (int i = n - 1; i >= 0; i--)
		suf[i] = suf[i + 1] * v[i];

	sort(all(v));

	cout << fixed;
	cout.precision(15);

	long double ans = (long double)f(1, 0) * k / suf[0];
	assert(ans <= 1);
	cout << ans << "\n";
}