#include <iostream>
#include <vector>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    range(i, n) {
        cin >> a[i];
    }
    long double best = 0;
    if (n == 1) {
        cout << (a[0] / k) * k / (long double) a[0] << endline;
        return 0;
    }
    for(int b0 = 1; b0 <= a[0]; b0++) {
        int b1 = (k + b0 - 1) / b0;
        long double ans = k * (a[0] / b0) * (a[1] / b1) / (long double) (a[0] * a[1]);
        best = max(best, ans);
    }
    cout << best << endline;
}
