#include <iostream>
#include <vector>

using namespace std;

#define range(i, n) for (int i = 0; i < n; i++)
#define loop(n) range(_, n)

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl;
#define endline endl
#else
#define debug(x) ;
#define endline "\n"
#endif

int n, k;
vector<int> a;

long double get_ans(int i, int count, long double ans) {
    if (count >= k) {
        return ans;
    }
    if (i == n) {
        return (count >= k) * ans;
    }
    long double best = 0;
    for (int c = min((k + count - 1) / count, a[i]); c >= 1; c--) {
        best = max(best, get_ans(i + 1, count * c, ans * (a[i] / c) / (long double) a[i]));
        if (abs(best - 1) < 1e-9) {
            return 1;
        }
    }
    return best;
}


int main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    cin >> n >> k;
    cout.precision(15);
    a.resize(n);
    range(i, n) {
        cin >> a[i];
    }
    cout << get_ans(0, 1, k) << endline;
}
