#include <iostream>
#include <cmath>
#include <fstream>
#include <algorithm>
#include <vector>
#include <map>
#include <set>
#include <ext/pb_ds/assoc_container.hpp>
#include <numeric>
#include <iomanip>

using namespace __gnu_pbds;
using namespace std;

#define int long long
#define all(x) (x).begin(), (x).end()
#define sz(x) (int) ((x).size())

template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#ifdef LOCAL
#include "algo/debug.h"
#else
#define debug(...) 42
#endif

typedef long double ld;

const int K = 1e7 + 5;

ld dp[2][K];
int was[K];

void solve() {
  fill(dp[0], dp[0] + 2 * K, -32132121212);

  int n, k;
  cin >> n >> k;

  dp[0][1] = k;
  int par = 0;
  ld res = 0;
  for (int i = 0; i < n; i++) {
    int x;
    cin >> x;
    par ^= 1;
    for (int b = x; b >= 1; b--) {
      int cnt = x / b;
      if (was[cnt] == i + 1) {
        continue;
      }
      was[cnt] = i + 1;
      ld kok = cnt / (ld) x;
      for (int cur = k; cur >= 1; cur--) {
        if (cur * b >= k) {
          res = max(res, dp[par ^ 1][cur] * kok);
        } else {
          dp[par][cur * b] = max(dp[par][cur * b], dp[par ^ 1][cur] * kok);
        }
      }
    }
  }

  cout << fixed << setprecision(12) << res << '\n';
}

int32_t main() {
#ifdef LOCAL
  freopen("input.txt", "r", stdin);
#endif
  ios_base::sync_with_stdio(false);
  cin.tie(nullptr);
  solve();
  return 0;
}