#include <bits/stdc++.h>

#define ll long long
#define ld long double

#define pll pair<ll, ll>
#define pii pair<int, int>
#define vll vector<ll>
#define vpl vector<pll>
#define vbo vector<bool>
#define vii vector<int>
#define vpi vector<pii>

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

#define fillv(a) F0R(i, sz(a)){cin>>a[i];}
#define outv(a) F0R(i, sz(a)){cout<<a[i]<<' ';}

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

ll n, k;
vll a;

ld ans = -1;
vll choice;
ll cur = 1;

void gen(ll ind = 0, bool is_end = false){
    if (ind == sz(a)){
        if (cur < k){
            return;
        }
        ld mx = (ld)(k);
        F0R(i, sz(a)){
            mx *= (ld)(a[i] / choice[i]) / (ld)(a[i]);
        }
        ans = max(ans, mx);
        return;
    }
    if (is_end){
        choice[ind] = 1;
        gen(ind + 1, true);
        return;
    }
    FOR(i, 1, a[ind] + 1){
        if (i * cur >= k){
            ll old_cur = cur;
            cur *= i;
            choice[ind] = i;
            gen(ind + 1, true);
            cur = old_cur;
            break;
        }
        ll old_cur = cur;
        cur *= i;
        choice[ind] = i;
        gen(ind + 1);
        cur = old_cur;
    }
}

void solve() {

    cin >> n >> k;
    a.resize(n);
    choice.resize(n);
    fillv(a);
    if (n == 1){
        ll x = a[0] / k;
        ld ans = (ld)(x) / (ld)(a[0]) * (ld)k;
        cout << ans << '\n';
        return;
    }
    if (n <= 2){
        ld mx = 0;
        FOR(i, 1, a[0] + 1){
            ll x = k / i;
            if (k % i != 0){
                x++;
            }
            if (a[1] / x < 1){
                continue;
            }
            ll r = a[1] / x;
            ld ans = (ld)(r) / (ld)(a[1]) * (ld)(a[0] / i) / (ld)(a[0]) * (ld)(k);
            mx = max(mx, ans);
        }
        cout << mx;
        return;
    }
    gen(0);
    cout << ans;
}

int main() {
    fastio;
    int t = 1; //cin >> t;
    cout << fixed;
    cout << setprecision(20);
    F0R(i, t){
        solve();
    }
}