#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using ll = long long;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using vpi = vector<pi>;

const int maxN = 8e2;
const ll INF = 1e18;

int test = 1, n, m, p, g, w[maxN], a, b, s, x[maxN], itx, id[maxN];
ll ans;
pl d[maxN][maxN];
vpi gr[maxN];
priority_queue<pair<pl, pi>, vector<pair<pl, pi>>, greater<pair<pl, pi>>> q;

void solve() {
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        x[i] = w[i];
    }
    sort(x, x + n);
    itx = unique(x, x + n) - x;
    for (int i = 0; i < n; i++)
        id[i] = lower_bound(x, x + itx, w[i]) - x;
    for (int i = 0; i < n; i++)
        gr[i].clear();
    while (m--) {
        cin >> a >> b >> s;
        a--, b--;
        gr[a].emplace_back(b, s);
    }
    for (int i = 0; i < n; i++)
        fill(d[i], d[i] + itx, make_pair(INF, 0));
    d[0][id[0]] = make_pair(0, p);
    q.push(make_pair(make_pair(0, -p), make_pair(0, id[0])));
    while (!q.empty()) {
        pl t1 = q.top().first;
        t1.second = -t1.second;
        pi t2 = q.top().second;
        q.pop();
        if (d[t2.first][t2.second] != t1)
            continue;
        for (auto &[v1, w3]: gr[t2.first]) {
            ll w1 = max(0LL, (w3 - t1.second + x[t2.second] - 1) / x[t2.second]);
            ll w2 = t1.second + w1 * x[t2.second] - w3;
            int v2 = max(t2.second, id[v1]);
            if (d[v1][v2].first > d[t2.first][t2.second].first + w1 || (d[v1][v2].first == d[t2.first][t2.second].first + w1 && d[v1][v2].second < w2)) {
                d[v1][v2] = make_pair(d[t2.first][t2.second].first + w1, w2);
                q.push(make_pair(make_pair(d[v1][v2].first, -d[v1][v2].second), make_pair(v1, v2)));
            }
        }
    }
    ans = INF;
    for (int i = 0; i < itx; i++)
        ans = min(ans, d[n - 1][i].first);
    if (ans == INF)
        cout << -1;
    else
        cout << ans;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> test;
#endif
    while (test--)
        solve();
    return 0;
}
