#include<bits/stdc++.h>
using namespace std;
using ll = long long;
const ll inf = 1e18;
ll n, m, p, q;
vector<ll> w;
vector<vector<ll>> g;
vector<bool> used;
vector<ll> dist;
void dfs() {
    dist[0] = 0;
    for (int i = 0; i < n; ++i) {
        ll mx = inf, ind = -1;
        for (int j = 0; j < n; ++j) {
            if (!used[j] && (ind == -1 || mx > dist[j])) {
                mx = dist[j];
                ind = j;
            }
        }
        if (ind == -1) {
            return;
        }
        used[ind] = 1;
        for (int j = 0; j < n; ++j) {
            if (g[ind][j] != inf) {
                if (dist[j] > dist[ind] + g[ind][j]) {
                    dist[j] = dist[ind] + g[ind][j];
                }
            }
        }
    }
}
void solve() {
    cin >> n >> m >> p >> q;
    g.resize(n, vector<ll>(n, inf)); w.resize(n); used.resize(n); dist.resize(n, inf);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        ll a, b, s;
        cin >> a >> b >> s;
        --a; --b;
        g[a][b] = min(g[a][b], s);
    }
    if (q == 1) {
        dfs();
        if (dist[n - 1] == inf) {
            cout << -1;
            return;
        }
        cout << dist[n - 1] - p;
        return;
    }
    if (q == 2) {
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    ll t = 1;
    //cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}
