#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

ll INF = 2e18;
const ll mod = 1e9 + 7;

ll n, m, ppp, g;

vector<pll> a[1000];
vector<ll> verts;

ll w[1000];
pll dp[1000];

ll dist[1000][1000];

void dd(int v){
    set<pll> st;
    st.insert({0, v});
    for(int i = 0; i < n; i++) dist[v][i] = INF;
    dist[v][v] = 0;
    while((int)st.size()){
        pll u = *st.begin();
        st.erase(u);
        dist[v][u.ss] = u.ff;
        for(pll p : a[u.ss]){
            if(dist[v][p.ff] > u.ff + p.ss){
                st.erase({dist[v][p.ff], p.ff});
                dist[v][p.ff] = u.ff + p.ss;
                st.insert({dist[v][p.ff], p.ff});
            }
        }
    }
}

void solve(){
    cin >> n >> m >> ppp >> g;
    verts.reserve(n);
    for(int i = 0; i < n; i++) cin >> w[i];
    verts.push_back(0);
    for(int i = 1; i < n - 1; i++){
        if(w[i] > w[0]) verts.push_back(i);
    }
    sort(all(verts), [&](int u, int v){
            return w[u] < w[v];
         });
    for(int i = 0; i < m; i++){
        ll u, v, s;
        cin >> u >> v >> s;
        u--; v--;
        a[u].push_back({v, s});
    }
    for(int u : verts) dd(u);
    dp[0] = {0, ppp};
    ll ans = INF;
    if(dist[verts[0]][n - 1] != INF){
        ll sum = max(dist[verts[0]][n - 1] - dp[0].ss, 0ll);
        ll need = sum / w[verts[0]] + (ll)((bool)(sum % w[verts[0]]));
        ll mb = dp[0].ff + need;
        ans = min(ans, mb);
    }
    for(int i = 1; i < (int)verts.size(); i++){
        dp[i] = {INF, -INF};
        for(int j = 0; j < i; j++){
            if(dp[j].ff == INF || dist[verts[j]][verts[i]] == INF) continue;
            ll sum = max(dist[verts[j]][verts[i]] - dp[j].ss, 0ll);
            ll need = sum / w[verts[j]] + (ll)((bool)(sum % w[verts[j]]));
            pll mb = {dp[j].ff + need, dp[j].ss + need * w[verts[j]] - dist[verts[j]][verts[i]]};
            if(dp[i].ff > mb.ff || (dp[i].ff == mb.ff && dp[i].ss < mb.ss)) dp[i] = mb;
        }
        if(dist[verts[i]][n - 1] != INF && dp[i].ff != INF){
            ll sum = max(dist[verts[i]][n - 1] - dp[i].ss, 0ll);
            ll need = sum / w[verts[i]] + (ll)((bool)(sum % w[verts[i]]));
            ll mb = dp[i].ff + need;
            ans = min(ans, mb);
        }
    }
    cout << (ans == INF ? -1 : ans);
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    tt = 1;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "_____________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
    return 0;
}



