#include <iostream>
#include <vector>
#include <algorithm>
#include <string>
#include <set>
#include <map>
#include <unordered_set>
#include <unordered_map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <random>

using namespace std;

#define int long long

const int MAXN = 8e2, INF = 1e18;

int n, m, p, gg;

int add[MAXN];

vector<pair<int, int>> g[MAXN], rg[MAXN];

void solve1() {
    vector<int> d(n, INF);
    d[0] = 0;
    vector<int> used(n);
    for (int _ = 0; _ < n; ++_) {
        int v = -1;
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                if (v == -1 || d[i] < d[v]) {
                    v = i;
                }
            }
        }
        if (v == -1) break;
        used[v] = 1;
        for (auto e : g[v]) {
            int u = e.first;
            int s = e.second;
            d[u] = min(d[u], d[v] + s);
        }
    }
    if (d[n - 1] == INF) {
        cout << -1;
        return;
    }
    cout << min((int)0, d[n - 1] - p);
}

void solve() {
    cin >> m >> p >> gg;
    for (int i = 0; i < n; ++i) {
        cin >> add[i];
    }
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w;
        --a;
        --b;
        g[a].emplace_back(b, w);
        rg[b].emplace_back(a, w);
    }
    if (gg == 1) {
        solve1();
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    while (cin >> n) {
        solve();
        cout << "\n";
    }
}