#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define int long long

using namespace std;
using namespace __gnu_pbds;

void solve() {
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, s;
        cin >> u >> v >> s;
        u--, v--;
        g[u].emplace_back(v, s);
    }
    priority_queue<pair<int, int>> q;
    vector<int> dist(n, INT_MAX);
    dist[0] = 0;
    q.push({0, 0});
    while (!q.empty()) {
        int u, dst;
        tie(dst, u) = q.top();
        //dst *= -1;
        q.pop();
        if (dist[u] < dst)
            continue;
        for (auto& v : g[u]) {
            if (dist[v.first] > dst + v.second) {
                dist[v.first] = dst + v.second;
                q.push({dist[v.first], v.first});
            }
        }
    }
    if (dist.back() == INT_MAX) {
        cout << -1;
    } else {
        cout << dist.back() - p;
    }
}


signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr), cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}