#include <bits/stdc++.h>

using namespace std;
#define int long long
#define double long double

vector<vector<pair<int, int> >> gr;

vector<int> deik(int st) {
    int n = (int)gr.size();
    set<pair<int, int> > q;
    q.insert({0, st});
    vector<int> dist(n, -1);
    dist[st] = 0;
    while(!q.empty()){
        auto [dst, v] = *q.begin();
        q.erase(q.begin());
        for( auto u : gr[v]) {
            if(dist[u.first] == -1){
                dist[u.first] = dst + u.second;
                q.insert({dist[u.first], u.first});
            }
            else if(dist[u.first] > dst + u.second) {
                q.erase({dist[u.first], u.first});
                dist[u.first] = dst + u.second;
                q.insert({dist[u.first], u.first});
            }
        }
    }
    return dist;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for(int i =0 ;i<n;++i)
        cin >> w[i];
    gr.resize(n);
    for(int i = 0;i<m;++i){
        int x, y, a;
        cin >> x >> y >> a;
        --x;
        --y;
        gr[x].push_back({y, a});
//        gr[y].push_back({x, a});
    }
    if(g == 1) {
        vector<int> dist(deik(0));
        if (dist[n - 1] == -1)
            cout << -1;
        else
            cout << max(0LL, dist[n - 1] - p);
    }
    else {
        int MXX = 9999;
        vector<vector<int> > dp(n, vector<int>(MXX + 1, -1));
        vector<vector<bool> > used(n, vector<bool>(MXX + 1,false));
        dp[0][min(p, MXX)] = 0;
        deque< pair<int, int> > q;
        q.push_back({0, min(p, MXX)});
        while(!q.empty()) {
            auto now = *q.begin();
            q.erase(q.begin());
            int v = now.first;
            int money = now.second;
            if(used[v][money])
                continue;
            used[v][money] = 1;
            if(money != MXX - 1 && dp[v][min(MXX - 1, money + w[v])] == -1) {
                dp[v][min(MXX - 1, money + w[v])] = dp[v][money] + 1;
                q.push_back({v, min(MXX - 1, money + w[v])});
            }
            for(auto u : gr[v]){
                if(u.second <= money && (dp[u.first][money - u.second] > dp[v][money] || dp[u.first][money - u.second] == -1)) {
                    dp[u.first][money - u.second] = dp[v][money];
                    q.push_front({u.first, money - u.second});
                }
            }
        }int ans = -1;
        for(int i = 0;i<MXX + 1;++i){
            if(dp[n - 1][i] != -1 && (ans == -1 || ans > dp[n - 1][i]))
                ans = dp[n - 1][i];
        }
        cout << ans;
    }
}