#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

cosnt ll INF = 1e18 + 42;

struct Node {
    int cnt = 0, d = 0, maxw = 0;

    Node() = default;
    Node(int cnt, int d, int maxw) : cnt(cnt), d(d), maxw(maxw) {}
};

bool operator<(const Node& a, const Node& b) {
    if (a.cnt == b.cnt) {
        if (a.maxw == b.maxw)
            return a.d > b.d;
        return a.maxw > b.maxw;
    }
    return a.cnt < b.cnt;
}

int n, m, p, gr;
vector<int> a;
vector<vector<pair<int, ll>>> g;
vector<tuple<int, int, ll>> ed;

void solve() {
    cin >> n >> m >> p >> gr;
    a.assing(n, 0);
    for (auto& i : a)
        cin >> i;
    g.assing(n, {});
    ed.assing(m, {0, 0, 0});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
        ed[i] = {u, v, w};
    }
    /*
    for (auto [u, v, w] : ed)
        cout << u << " " << v << " " << w << endl;
    */
    vector<Node> dist(n, Node(INF, INF, -INF));
    for (int i = 0; i < n; ++i)
        dist[i].maxw = a[i];
    dist[0] = Node(0, p, a[0]);
    for (int i = 0; i < n; ++i) {
        auto dist1 = dist;

        for (const auto& [v, u, w] : ed) {
            if (dist[v].cnt == INF)
                continue;

            Node tmp = dist[v];
            if (tmp.d >= w)
                tmp.d -= w;
            else {
                int wait = (w - tmp.d + tmp.maxw - 1) / tmp.maxw;
                tmp.d += wait * tmp.maxw - w;
                tmp.cnt += wait;
            }
            tmp.maxw = max(tmp.maxw, dist[u].maxw);
            //cout << "! " << tmp.cnt << " " << tmp.d << " " << tmp.maxw << endl;
            if (tmp < dist1[u])
                dist1[u] = tmp;
        }

        dist = dist1;
    }
    /*
    for (auto [cnt, d, maxw] : dist)
        cout << cnt << " " << d << " " << maxw << endl;
    */
    cout << (dist[n - 1].cnt == INF ? -1 : dist[n - 1].cnt) << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
