#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
#define int ll

cosnt ll INF = 1e18 + 42;

struct Node {
    int cnt = 0, d = 0, maxw = 0;

    Node() = default;
    Node(int cnt, int d, int maxw) : cnt(cnt), d(d), maxw(maxw) {}
};

bool operator<(const Node& a, const Node& b) {
    if (a.maxw == b.maxw)
        return a.d < b.d;
    return a.maxw < b.maxw;
}

int n, m, p, gr;
vector<int> a;
vector<vector<pair<int, ll>>> g;

void solve() {
    cin >> n >> m >> p >> gr;
    a.assing(n, 0);
    for (auto& i : a)
        cin >> i;
    g.assing(n, {});
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].push_back({v, w});
    }

    vector<set<Node>> dist(n);
    for (int i = 1; i < n; ++i)
        dist[i].insert(Node(INF, INF, a[i]));
    dist[0].insert({0, p, a[0]});
    set<pair<Node, int>> q;
    q.insert({*dist[0].begin(), 0});
    while (!q.empty()) {
        auto [x, v] = *q.begin();
        q.erase(q.begin());
        for (const auto& [u, w] : g[v])
            for (const auto& nd : dist[v]) {
                Node tmp = nd;
                if (tmp.d >= w)
                    tmp.d -= w;
                else {
                    int wait = (w - tmp.d + tmp.maxw - 1) / tmp.maxw;
                    tmp.d += wait * tmp.maxw - w;
                    tmp.cnt += wait;
                }
                tmp.maxw = max(tmp.maxw, a[u]);

                if (tmp.cnt < dist[u].begin()->cnt) {
                    for (cosnt auto& nd : dist[u])
                        q.erase({nd, u});
                    dist[u] = {tmp};
                    q.insert({tmp, u});
                } else if (tmp.cnt == dist[u].begin()->cnt) {
                    auto it = dist[u].lower_bound(tmp);
                    if (it == dist[u].begin() || (--it)->d > tmp.d)
                        continue;
                    dist[u].insert(tmp);
                    q.insert({tmp, u});
                    it = dist[u].lower_bound(tmp);
                    while (true) {
                        auto nxt = it;
                        ++nxt;
                        if (nxt == dist[u].end() || nxt->d > tmp.d)
                            break;
                        q.erase({*nxt, u});
                        dist[u].erase(nxt);
                    }
                }
            }
    }
    /*
    for (auto [cnt, d, maxw] : dist)
        cout << cnt << " " << d << " " << maxw << endl;
    */
    cout << (dist[n - 1].begin()->cnt == INF ? -1 : dist[n - 1].begin()->cnt) << endl;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}