#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;
#define int ll

const int N = 805;
vc<std::pair<int, int>> g[N];

int32_t main() {
    std::cin.tie(nullptr)->sync_with_stdio(false);
    int n, m, p, G;
    std::cin >> n >> m >> p >> G;
    vc<int> w(n);
    for (auto &i: w) std::cin >> i;
    w.insert(w.begin(), 0);
    while (m--) {
        int a, b, w;
        std::cin >> a >> b >> w;
        g[a].push_back({b, w});
    }
    if (G == 1) {
        std::priority_queue<std::pair<int, int>, vc<std::pair<int, int>>, std::greater<>> q;
        vc<int> dist(n + 1, LLONG_MAX / 2);
        q.emplace(0, 1);
        dist[1] = 0;
        while (!q.empty()) {
            auto [d, v] = q.top();
            q.pop();
            if (dist[v] != d) continue;
            dist[v] = d;
            for (auto [u, w]: g[v]) if (dist[u] > dist[v] + w) dist[u] = dist[v] + w, q.emplace(dist[u], u);
        }
        if (dist[n] == LLONG_MAX / 2) std::cout << "-1\n";
        else std::cout << std::max(0ll, dist[n] - p) << '\n';
    } else if (G == 2) {
        int nw = p;
        int max = -1;
        int ans = 0;
        for (int v = 1; v < n; ++v) {
            max = std::max(max, w[v]);
            if (nw >= g[v][0].second) {
                nw -= g[v][0].second;
            } else {
                int add = (g[v][0].second - nw + max - 1) / max;
                ans += add;
                nw += add * max;
                nw -= g[v][0].second;
            }
        }
        std::cout << ans << '\n';
    } else {
        vc<bool> used(n + 1);
        ll ut = LLONG_MAX / 2;
        std::function<void(int, int, int, int)> dfs = [&](int v, int sum, int ans = 0, int max = -1) {
            if (ans >= ut) return;
            if (v == n) {
                ut = std::min(ut, ans);
                return;
            }
            max = std::max(max, w[v]);
            used[v] = 1;
            for (auto [u, w]: g[v]) {
                if (used[u]) continue;
                int e = sum;
                if (e >= w) dfs(u, e - w, ans, max);
                else {
                    int add = (w - e + max - 1) / max;
                    dfs(u, add * max + sum - w, ans + add, max);
                }
            }
            used[v] = 0;
        };
        dfs(1, p, 0, -1);
        if (ut == LLONG_MAX / 2) {
            std::cout << "-1\n";
        } else std::cout << ut << '\n';
    }
}

