#include <bits/stdc++.h>
///#include <ext/pb_ds/assoc_container.hpp>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define fi first
#define se second
#define all(v) (v).begin(), (v).end()

#define int long long

using namespace std;
///using namespace __gnu_pbds;
using ll = long long;
using ld = double;
using pii = pair <int, int>;

ll const inf = 1e16 + 7;

mt19937 rnd(4);
int const N = 802;
vector <pii> g[N], _g[N];
vector <bool> isr(N, 0);
int c[N];

int gei_ksta(int n, int p0){
    vector <int> d(n, inf);
    set <pii> st;
    d[0] = 0;
    st.insert({0, 0});
    while(!st.empty()){
        int v = (*st.begin()).se;
        st.erase(st.begin());
        for(auto [u, w] : g[v]){
            if(d[u] > d[v] + w){
                if(st.find({d[u], u}) != st.end()){
                    st.erase({d[u], u});
                }
                d[u] = d[v] + w;
                st.insert({d[u], u});
            }
        }
    }
    return (d[n - 1] == inf ? -1 : max(d[n - 1] - p0, 0ll));
}

int gr2(int n, int p0){
    int p = p0, cnt = 0, mx = -1;
    for(int i = 0; i < n - 1; ++i){
        mx = max(mx, c[i]);
        if(p < g[i][0].se){
            int d = g[i][0].se - p;
            cnt += (d + mx - 1ll)/mx;
            p += ((d + mx - 1ll)/mx) * mx;
        }
        p -= g[i][0].se;
    }
    return cnt;
}

int ANS = inf, F;

void dfs(int v, vector <int>& used, int p, int mx, int cnt){
    if(v == F){
        ANS = min(ANS, cnt);
        return;
    }
    if(!isr[v]){
        return;
    }
    used[v]++;
    mx = max(mx, c[v]);
    for(auto [u, w] : g[v]){
        if(used[u] == 2){ continue;}
        if(w > p){
            int d = (w - p);
            dfs(u, used, p + ((d + mx - 1ll)/mx) * mx - w, mx, cnt + (d + mx - 1ll)/mx);
        }
        else{
            dfs(u, used, p - w, mx, cnt);
        }
    }
    used[v]--;
    return;
}

void _dfs(int v, vector <bool>& used){
    used[v] = 1;
    for(auto [u, w] : _g[v]){
        if(used[u]){ continue;}
        _dfs(u, used);
    }
    return;
}

signed main(){
    ibase;
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    for(int i = 0; i < n; ++i){
        cin >> c[i];
    }

    vector < vector <int> > mt(n, vector <int>(n, inf));

    for(int i = 0; i < m; ++i){
        int v, u, w;
        cin >> v >> u >> w;
        --v; --u;
        mt[v][u] = min(mt[v][u], w);
//        if(mt[v][u] == inf){
//            g[v].push_back({u, w});
//            mt[v][u] = w;
//        }
//        else if(mt[v][u] )
//        _g[u].push_back({v, w});
    }

    for(int i = 0; i < n; ++i){
        for(int j = 0; j < n; ++j){
            if(mt[i][j] == inf){ continue;}
            g[i].push_back({j, mt[i][j]});
            _g[j].push_back({i, mt[i][j]});
        }
    }

    if(gr == 1){
        cout << gei_ksta(n, p);
        return 0;
    }
    else if(gr == 2){
        cout << gr2(n, p);
        return 0;
    }
    else if(gr <= 3){
        F = n - 1;
        vector <int> used(n, 0);
        _dfs(n - 1, isr);
        dfs(0, used, p, 0, 0);
        cout << (ANS == inf ? -1 : ANS);
    }
}
