#include <iostream>
#include <queue>
using namespace std;
const int MAXN=1e3;
vector <pair <int,long long> > v[MAXN];
long long dist[MAXN], w[MAXN];
bool inq[MAXN];
void dejkstra(int start) {
    priority_queue <pair <long long,int> > q;
    q.push({0,start});
    dist[start]=0;
    inq[start]=true;
    while (!q.empty()) {
        int x=q.top().second;
        ///cout << x << ' ' << dist[x] << ' ' << -q.front().first << endl;
        if (dist[x]!=-q.top().first) {
            q.pop();
            continue;
        }
        q.pop();
        for (auto i:v[x]) {
            if (dist[i.first]==-1 || dist[i.first]>dist[x]+i.second) {
                dist[i.first]=dist[x]+i.second;
                q.push({-dist[i.first],i.first});
            }
        }
    }
}
int main () {
    /*
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);*/
    int n, m, a, b, g;
    long long p, c;
    cin >> n >> m >> p >> g;
    for (int i=1;i<=n;i++) {
        cin >> w[i];
        dist[i]=-1;
    }
    for (int i=0;i<m;i++) {
        cin >> a >> b >> c;
        v[a].push_back({b,c});
        v[b].push_back({a,c});
    }
    if (g==1) {
        dejkstra(1);
        if (dist[n]==-1) cout << -1 << endl;
        else cout << max((long long)0,dist[n]-p) << endl;
    }
    return 0;
}
/*
4 4 2 1
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11
*/