#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
#define int long long
using namespace std;

vector<pair<int, int>> g[1000];
int w[1000];

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    for (int u = 1; u <= n; u++) {
        cin >> w[u];
    }
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a].emplace_back(b, s);
    }
    if (group == 1) {
        vector<int> dist(n + 1, INT64_MAX);
        dist[1] = 0;
        set<pair<int, int>> Q;
        Q.emplace(dist[1], 1);
        while (!Q.empty()) {
            int u = Q.begin()->second;
            Q.erase(Q.begin());
            for (auto &[v, w] : g[u]) {
                if (dist[v] > dist[u] + w) {
                    Q.erase(make_pair(dist[v], v));
                    dist[v] = dist[u] + w;
                    Q.insert(make_pair(dist[v], v));
                }
            }
        }
        if (dist[n] == INT64_MAX) {
            cout << -1 << "\n";
        } else {
            cout << max(0ll, dist[n] - p) << "\n";
        }
    }
    return 0;
}
