#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 1e16;

vector<vector<pair<int, ll> > > g;
vector<ll> w;
int n, m;
ll p;

void solve1() {
    vector<ll> d(n, INF);
    d[0] = 0;
    set<pair<ll, int> > s;
    s.insert(mp(0, 0));
    for (int i = 1; i < n; i++) s.insert(mp(INF, i));
    while (!s.empty()) {
        auto pp = s.begin();
        s.erase(pp);
        int v = (*pp).S;
        for (auto to : g[v]) {
            int u = to.F;
            ll len = to.S;
            if (d[v] + len < d[u]) {
                s.erase(mp(d[u], u));
                d[u] = d[v] + len;
                s.insert(mp(d[u], u));
            }
        } 
    }
    ll ans = d[n - 1];
    if (ans == INF) {
        cout << -1;
        return;
    }
    if (ans > p) ans -= p;
    else ans = 0;
    cout << ans;
}

int main() {
    int tt; cin >> n >> m >> p >> tt;
    w.resize(n);
    g.resize(n);
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < m; i++) {
        int u, v, s; cin >> u >> v >> s;
        u--, v--;
        g[u].pb(mp(v, s));
    }
    if (tt == 1) {
        solve1();
        return 0;
    }
    return 0;
}