#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define int int64_t
#define pb push_back
#define pii pair <int, int>
#define endl '\n'

using namespace std;
using namespace __gnu_pbds;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> oset;
const int N = 810, INF = 1e18;
vector <pii> g[N];
int dp[N][N * 3];
bool u[N];

void dfs (int v) {
    u[v] = 1;
    for(auto to : g[v]) {
        if(!u[to.fi]) {
            dfs(to.fi);
        }
    }
}

int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    int n, m, p, G;
    cin >> n >> m >> p >> G;
    int w[n];
    for(int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for(int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        x--; y--;
        g[x].pb({y, c});
    }
    dfs(0);
    if(!u[n - 1]) {
        cout << -1;
        return 0;
    }
    if(*max_element(w, w + n) == 1) {
        vector <int> r(n, INF);
        r[0] = 0;
        priority_queue <pii> q;
        q.push({-r[0], 0});
        while (!q.empty()) {
            int dst = -q.top().fi, v = q.top().se;
            q.pop();
            for(auto to : g[v]) {
                if(r[to.fi] > r[v] + to.se) {
                    r[to.fi] = r[v] + to.se;
                    q.push({-r[to.fi], to.fi});
                }
            }
        }
        cout << max(int64_t(0), r[n - 1] - p);
        return 0;
    }
    cout << -1;
    return 0;
}
