#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#pragma GCC optimize("Ofast")

#define fi first
#define se second
#define int int64_t
#define pb push_back
#define pii pair <int, int>
#define TIME 1.0*clock()/CLOCKS_PER_SEC
#define endl '\n'
//#define pw(x) (int64_t(1) << x)

using namespace std;
using namespace __gnu_pbds;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> oset;
const int N = 810, INF = 1e18, mod = 1e9 + 7;
vector <pii> g[N];
int dp[N][10001];
bool u[N];
int w[N];
int n, m, p;
int st[20];
int e[N][N];

void dfs (int v) {
    u[v] = 1;
    for(auto to : g[v]) {
        if(!u[to.fi]) {
            dfs(to.fi);
        }
    }
}

unordered_set <int> stt;
vector <pii> gr[N];
bool used[N];
int solvedp (vector <int> &all) {
    vector <int> dp(all.size()), cost(all.size());
    dp[0] = 0;
    cost[0] = p;
    int mx = 0;
    for(int i = 0; i + 1 < all.size(); ++i) {
        mx = max(mx, w[all[i]]);
        int need = e[all[i]][all[i + 1]];
        if(cost[i] >= need) {
            dp[i + 1] = dp[i];
            cost[i + 1] = cost[i] - need;
            continue;
        }
        int kol = (need - cost[i]) / mx + ((need - cost[i]) % mx > 0);
        dp[i + 1] = dp[i] + kol;
        cost[i + 1] = cost[i] - need + mx * kol;
    }
    return dp[all.size() - 1];
}

vector <int> now;
int64_t ans = INF, h = 0;
void go (int v) {
    if(TIME > 0.95) {
        if(ans == INF) ans = -1;
        cout << ans;
        exit(0);
    }
    if(stt.count(h)) {
        return;
    }
    stt.insert(h);
    if(v == n - 1) {
        ans = min(ans, solvedp(now));
        return;
    }
    for(auto to : g[v]) {
        if(used[to.fi]) {
            int add = st[now.size()] * (to.fi + 1);
            add %= mod;
            h += add;
            h %= mod;
            now.pb(to.fi);
            u[to.fi] = 1;
            go(to.fi);
            h -= add;
            h %= mod;
            now.pop_back();
            u[to.fi] = 0;
        }
    }
}

void solve () {
    now.pb(0);
    h = 1;
    go(0);
    cout << ans;
    exit(0);
}


int32_t main () {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    st[0] = 1;
    for(int i = 1; i < 20; ++i) {
        st[i] = (st[i - 1] * int64_t(17)) % mod;
    }
    int G;
    cin >> n >> m >> p >> G;
    for(int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    bool ok = (m == n - 1);
    for(int i = 0; i < m; ++i) {
        int x, y, c;
        cin >> x >> y >> c;
        x--;
        y--;
        if(!e[x][y]) {
            e[x][y] = c;
        } else {
            e[x][y] = min(e[x][y], c);
        }
        if(x != i || y != i + 1) {
            ok = 0;
        }
        gr[y].pb({x, c});
        g[x].pb({y, c});
    }
    dfs(0);
    if(!u[n - 1]) {
        cout << -1;
        return 0;
    }
    fill(u, u + n, 0);
    if(ok) {
        vector <int> dp(n), cost(n);
        dp[0] = 0;
        cost[0] = p;
        int mx = 0;
        for(int i = 0; i + 1 < n; ++i) {
            mx = max(mx, w[i]);
            int need = e[i][i + 1];
//            cerr << i << ' ' << need << ' ' << cost[i] << endl;
            if(cost[i] >= need) {
                dp[i + 1] = dp[i];
                cost[i + 1] = cost[i] - need;
                continue;
            }
            int kol = (need - cost[i]) / mx + ((need - cost[i]) % mx > 0);
//            cerr << i << ' ' << kol << ' ' << mx << endl;
            dp[i + 1] = dp[i] + kol;
            cost[i + 1] = cost[i] - need + mx * kol;
        }
        cout << dp[n - 1];
        return 0;
    }
    if(*max_element(w, w + n) == 1) {
        vector <int> r(n, INF);
        r[0] = 0;
        priority_queue <pii> q;
        q.push({-r[0], 0});
        while (!q.empty()) {
            int dst = -q.top().fi, v = q.top().se;
            q.pop();
            for(auto to : g[v]) {
                if(r[to.fi] > r[v] + to.se) {
                    r[to.fi] = r[v] + to.se;
                    q.push({-r[to.fi], to.fi});
                }
            }
        }
        cout << max(int64_t(0), r[n - 1] - p);
        return 0;
    }
    vector <int> d(n, INF);
    priority_queue <pii> q;
    d[n - 1] = 0;
    q.push({0, n - 1});
    while (!q.empty()) {
        int dst = -q.top().fi, v = q.top().se;
        q.pop();
        if(d[v] < dst) {
            continue;
        }
        for(auto to : gr[v]) {
            if(d[to.fi] > to.se + d[v]) {
                d[to.fi] = to.se + d[v];
                q.push({-d[to.fi], to.fi});
            }
        }
    }
    for(int i = 0; i < N; ++i) {
        for(int j = 0; j <= 10000; ++j) {
            dp[i][j] = INF;
        }
    }
//    cerr << d[0] << endl;
    set <array <int, 3>> Q;
    dp[0][p] = 0;
    Q.insert({0, p, 0});
    while (!Q.empty()) {
        array <int, 3> X = *Q.begin();
        Q.erase(X);
        int kol = X[0], sum = X[1], v = X[2];
//        cerr << v << endl;
        if(dp[v][sum] < kol) {
            continue;
        }
        for(auto to : g[v]) {
            for(int s = max(sum, to.se); s <= max(sum, to.se) + 77; ++s) {
//                cerr << s << endl;
                int add = (s - sum) / w[v] + ((s - sum) % w[v] > 0);
                if(dp[to.fi][s - to.se] > dp[v][sum] + add) {
                    dp[to.fi][s - to.se] = dp[v][sum] + add;
                    Q.insert({dp[to.fi][s - to.se], s - to.se, to.fi});
//                    cerr << "ADD" << endl;
                }
            }
        }
    }
    int ans = INF;
    for(int i = 0; i <= 10000; ++i) {
        ans = min(ans, dp[n - 1][i]);
    }
    cout << ans;
    return 0;
}
//3 2
//2 2 3
//1 2 3
//2 3 3
//2 1
