#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 801;
const long long inf = 1e14;
int n, m, p, g, w[maxn], used[maxn];
long long a[maxn][maxn];

void read(){
    cin >> n >> m >> p >> g;
    for(int i = 1;i <= n;i++){
        cin >> w[i];
    }
    for(int i = 1;i <= n;i++){
        for(int j = 1;j <= n;j++){
            a[i][j] = inf;
        }
    }
    for(int i = 1;i <= m;i++){
        int x, b, s;
        cin >> x >> b >> s;
        a[x][b] = s;
    }
}

void solve(){
    for(int k = 1;k <= n;k++){
        for(int i = 1;i <= n;i++){
            for(int j = 1;j <= n;j++){
                if(a[i][j] > a[i][k] + a[k][j]){
                    a[i][j] = a[i][k] + a[k][j];
                }
            }
        }
    }
    if(g == 1){
       if(a[1][n] == inf)
            cout << -1 << endl;
        else
            cout << max((long long)0, a[1][n] - p) << endl;
    }
    else{
        if(a[1][n] == inf){
            cout << -1 << endl;
            return;
        }
        vector<int> v;
        v.push_back(1);
        int maxx = w[1];
        for(int i = 2;i <= n;i++){
            if(w[i] > maxx){
                maxx = w[i];
                v.push_back(i);
            }
        }
        v.push_back(n);
        long long ost = p, cnt = 0;
        a[1][1] = 0;
        for(int i = 1;i < v.size();i++){
            long long money = a[1][v[i]] - a[1][v[i - 1]];
            if(money <= ost){
                ost -= money;
                continue;
            }
            money -= ost;
            ost = 0;
            cnt = cnt + money / w[v[i - 1]];
            if(money % w[v[i - 1]])
                cnt++;
            ost = money % w[v[i - 1]];
        }
        cout << cnt << endl;
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
