#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define int long long
//#define int __int128

const int N = 1000;
vector<pair<int, int>> g[N];

struct Node {
    int concert_cnt;
    int v;
    int maxpref;
    int bal;
};

int updiv(int a, int b){
    if(a <= 0) return 0;
    return (a - 1) / b + 1;
}
const int inf = 1e18;
int32_t main(){
    ll n, m, p, testik;
    cin >> n >> m >> p >> testik;
    vector<int> w(n + 1,0);
    for(int i=1;i<=n;++i){
        ll x;
        cin >> x;
        w[i] = x;
        g[i].push_back({i, 0});
    }
    for(int i=0;i<m;++i){
        ll f1, f2, f3;
        cin >> f1 >> f2 >> f3;
        g[f1].push_back({f2, f3});
    }
    queue<Node> q;
    vector<int> mxpref(n + 1, -inf);
    vector<int> mncnt(n + 1, inf);
    vector<int> mxbal(n + 1, -inf);
    q.push({0,1,w[1],p});
    while(!q.empty()){
        auto [cnt, v, pref, bal] = q.front();
        q.pop();
        if(!(pref > mxpref[v] || cnt < mncnt[v])) continue;
        mxpref[v] = max(mxpref[v], pref);
        mncnt[v] = min(mncnt[v], cnt);
        mxbal[v] = max(mxbal[v], bal);
        if(mxbal[v] > 1e13 || mxpref[v] > 1e13) assert(0);
        for(auto [to, cw]:g[v]){
            int needconc = updiv(cw-bal, pref);
            ll t1 = cnt + needconc;
            ll t2 = bal-cw+needconc*pref;
            if(t1 > 1e13 || t2 > 1e13) assert(0);
            q.push({t1, to, max(pref,w[to]), t2});
        }
    }
    if(mncnt[n] == inf){
        cout << -1;
//        if(testik == 5) assert(0);
        return 0;
    }
    cout << (ll)mncnt[n];
}