#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long
#define ld long double

ll INFl = 1e18;
int INFi = 1e9 + 1329;

void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    for (int i = 0; i < n; i++)
        cin >> w[i];
    
    vector<vector<int>> gr(n, vector<int>(n, INFi));
    for (int i = 0; i < n; i++)
        gr[i][i] = 0;

    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--; b--;
        gr[a][b] = min(gr[a][b], s);
    }
    vector<vector<ll>> dist(n, vector<ll>(n, INFl));
    for (int a = 0; a < n; a++) {
        for (int b = 0; b < n; b++)
            dist[a][b] = (gr[a][b] == INFi ? INFl : gr[a][b]);
    }

    for (int v = 0; v < n; v++) {
        for (int a = 0; a < n; a++) {
            for (int b = 0; b < n; b++) {
                dist[a][b] = min(dist[a][b], dist[a][v] + dist[v][b]);
            }
        }
    }
    if (dist[0][n - 1] == INFl) {
        cout << "-1\n";
        return;
    }

    vector<pair<ll, ll>> dp(n, { INFl, 0 });
    dp[0] = { 0, p };
    ll ans = INFl;
    for (int i = 0; i < n; i++) {
        vector<pair<ll, ll>> pdp = dp;
        dp.assign(n, { INFl, 0 });
        for (int v = 0; v < n; v++) {
            for (int p = 0; p < n; p++) {
                if (dist[p][v] == INFl) continue;
                ll cnt = max(0ll, (dist[p][v] - pdp[p].S + w[p] - 1) / w[p]);
                ll ost = pdp[p].S + cnt * w[p] - dist[p][v];
                dp[v] = min(dp[v], { pdp[p].F + cnt, ost });
            }
        }
        ans = min(ans, dp[n - 1].F);
    }
    cout << ans;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    solve();
}