#ifdef WIN64
    #define _GLIBCXX_DEBUG
#endif // WIN64
#include "bits/stdc++.h"

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mkp make_pair
#define mkt make_tuple
#define isz(x) (int) x.size()
#define xx first
#define yy second

#ifdef WIN64
    #define check(x) cerr << (#x) << " = " << x << "\n"
    template<class T> void print(T* ar, int sz) {
        for (int i = 0; i < sz; ++i) cerr << ar[i] << " ";
        cerr << "\n";
    }
#else
    #define check(x) 17
    template<class T> void print(T* ar, int sz) {}
#endif // WIN64

const int N = (int) 800 + 1;
const int INF = (int) 1e9 + 117;
const int MOD = (int) 1e9 + 7;
const long long INFll = (long long) 2e18 + 117;
const double EPS = 1e-8;

template<class T> ostream& operator<<(ostream& out, const vector<T>& v) {
    for (auto& i : v) out << i << " ";
    return out;
}

template<class T> istream& operator>>(istream& in, vector<T>& v) {
    for (auto& i : v) in >> i;
    return in;
}

template<class T> bool inmin(T& x, T y) {
    if (y < x) {
        x = y;
        return 1;
    }
    return 0;
}

template<class T> bool inmax(T& x, T y) {
    if (y > x) {
        x = y;
        return 1;
    }
    return 0;
}

#define int long long

using Pt = pair<int, int>;
using ll = long long;

int n, m, p, gt;

vector<pair<int, int>> g[N];
ll d[N];
set<pair<int, int>> st;
int w[N];

int solve1() {
    fill(d, d + n, INFll);
    st.clear();
    st.insert(mkp(-p, 0));
    d[0] = -p;
    while (isz(st)) {
        auto [curp, v] = *st.begin();
        st.erase(st.begin());
        for (auto [to, s] : g[v]) {
            if (curp + s < d[to]) {
                st.erase(mkp(d[to], to));
                d[to] = curp + s;
                st.insert(mkp(d[to], to));
            }
        }
    }
    if (d[n - 1] == INFll) cout << "-1\n";
    else cout << max(0ll, d[n - 1]) << "\n";
    return 0;
}

int solve() {
    return 0;
}

signed main() {
#ifdef WIN64
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // WIN64
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--) {
        assert(cin >> n >> m >> p >> gt);
        for (int i = 0; i < n; ++i) assert(cin >> w[i]);
        for (int i = 0; i < m; ++i) {
            int u, v, s;
            assert(cin >> u >> v >> s);
            --u, --v;
            g[u].push_back(mkp(v, s));
        }
        if (gt == 1) solve1();
    }
    return 0;
}
