#include <bits/stdc++.h>
#define int long long
#define double long double

using namespace std;

const int maxn = 1e3;

struct edge{
    int u, w;
};

vector <edge> g[maxn];

const int inf = 1e18;

int d[maxn][maxn];
int w[maxn];
int n;

int calc(int have, int v, int done) {
    if (d[v][n - 1] == inf) {
        return inf;
    }
    int res = inf;
    int perf = 0;
    if (d[v][n - 1] > have) {
        perf = (d[v][n - 1] - have + w[v] - 1) / w[v];
    }
    res = min(res, done + perf);
    for (int i = 0; i < n - 1; ++i) {
        if (w[i] <= w[v]) continue;
        if (d[v][i] == inf) continue;
        perf = 0;
        if (d[v][i] > have) {
            perf = (d[v][i] - have + w[v] - 1) / w[v];
        }
        res = min(res, calc(have + perf * w[v] - d[v][i], i, done + perf));
    }
    return res;
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    int m, p, test; cin >> n >> m >> p >> test;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int v, u, wt; cin >> v >> u >> wt;
        v--; u--;
        g[v].push_back({u, wt});
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            d[i][j] = inf;
        }
        d[i][i] = 0;
        set < pair <int, int> > q;
        q.insert({0, i});
        while (!q.empty()) {
            auto v = (*q.begin()).second;
            q.erase(q.begin());
            for (auto [u, wt] : g[v]) {
                if (d[i][v] + wt < d[i][u]) {
                    q.erase({d[i][u], u});
                    d[i][u] = d[i][v] + wt;
                    q.insert({d[i][u], u});
                }
            }
        }
    }
    if (d[0][n - 1] == inf) {
        cout << "-1\n";
        return 0;
    }
    if (test == 1) {
        cout << max((int) 0, d[0][n - 1] - p) << "\n";
        return 0;
    }
    if (test == 2) {
        int res = inf;
        int pr = 0, j = 0;
        for (int i = 0; i < n - 1; ++i) {
            if (i == 0) {
                int perf = 0;
                if (d[0][n - 1] > p) {
                    perf = (d[0][n - 1] - p + w[0] - 1) / w[0];
                }
                res = min(res, perf);
            } else {
                if (w[i] > w[pr]) {
                    int perf = 0;
                    if (d[pr][i] > p) {
                        perf = (d[pr][i] - p + w[pr] - 1) / w[pr];
                    }
                    j += perf;
                    pr = i;
                    perf = 0;
                    if (d[pr][n - 1] > p) {
                        perf = (d[pr][n - 1] - p + w[pr] - 1) / w[pr];
                    }
                    res = min(res, j + perf);
                }
            }
        }
        cout << res << "\n";
        return 0;
    }
    cout << calc(p, 0, 0) << "\n";
    return 0;
}