#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <string>
#include <iomanip>
#include <stdio.h>
#include <set>
#include <map>
#include <deque>
#include <stack>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <climits>
#include <random>
#include <bitset>

using namespace std;

//#pragma GCC optimize("Ofast")

#define int long long
//#define endl '\n'

mt19937_64 engine;

const long long mod = 1e9 + 7;
const long double pi = acosl(-1.0);
const long double eps = 1e-10;

long long gcd(long long x, long long y)
{
    if (y == 0) return x;
    return gcd(y, x % y);
}

long long lcm(long long x, long long y)
{
    return x / gcd(x, y) * y;
}

long long binpow(long long x, long long y)
{
    if (y == 0) return 1;
    if (y == 1) return x;
    int f = binpow(x, y / 2);
    if (y % 2 == 0) return (f * f) % mod;
    else return (((f * f) % mod) * x) % mod;
}

/*struct Node
{
    vector<pair<int, int>> to;
    int cnt = 0;
};

vector<Node> graph;
vector<Node> rgraph;

void task()
{
    int n, m;
    cin >> n >> m;
    graph.resize(n);
    rgraph.resize(n);

    bool flag = true;

    for (int i = 0; i < m; i++)
    {
        int v, u, w;
        cin >> v >> u >> w;
        v--;
        u--;

        graph[u].cnt++;
        graph[v].to.push_back({ u,w });
        rgraph[v].cnt++;
        rgraph[u].to.push_back({ v,w });
    }

    for (int i = 0; i < n; i++)
    {
        if (graph[i].to.size() != 1 || graph[i].to[0].first != (i + 1) % n) flag = false;
    }

    int a, b;
    cin >> a >> b;
    a--;
    b--;

    if (flag)
    {
        int v = a;
        int curans = 0;
        while (v != b)
        {
            curans ^= graph[v].to[0].second;
            v++;
            v %= n;
        }

        int cycle = 0;
        do
        {
            cycle ^= graph[v].to[0].second;
            v++;
            v %= n;
        } while (v != a);

        if ((cycle ^ curans) != 0 || cycle != 0)
        {
            cout << -1 << endl;
        }
        else
        {
            cout << 0 << endl;
        }

        graph.clear();
        rgraph.clear();
        return;
    }

    queue<int> q;
    for (int i = 0; i < n; i++)
    {
        if (graph[i].cnt == 0)
        {
            q.push(i);
        }
    }

    vector<int> dp(n, 0);
    vector<bool> achieve(n, false);
    dp[a] = 1;
    achieve[a] = 1;
    while (!q.empty())
    {
        int v = q.front();
        q.pop();

        for (int i = 0; i < graph[v].to.size(); i++)
        {
            int u = graph[v].to[i].first;
            int w = graph[v].to[i].second;

            dp[u] ^= dp[v];
            achieve[u] = achieve[u] || achieve[v];
            graph[u].cnt--;
            if (graph[u].cnt  == 0)
            {
                q.push(u);
            }
        }
    }

    if (achieve[b] == 0)
    {
        cout << 0 << endl;
        graph.clear();
        rgraph.clear();
        return;
    }

    for (int i = 0; i < n; i++)
    {
        if (rgraph[i].cnt == 0)
        {
            q.push(i);
        }
    }

    vector<int> rdp(n, 0);
    rdp[b] = 1;
    while (!q.empty())
    {
        int v = q.front();
        q.pop();

        for (int i = 0; i < rgraph[v].to.size(); i++)
        {
            int u = rgraph[v].to[i].first;
            int w = rgraph[v].to[i].second;

            rdp[u] ^= rdp[v];
            rgraph[u].cnt--;
            if (rgraph[u].cnt == 0)
            {
                q.push(u);
            }
        }
    }

    int ans = 0;

    for (int i = 0; i < n; i++)
    {
        for (int j = 0; j < graph[i].to.size(); j++)
        {
            int v = i;
            int u = graph[i].to[j].first;
            int w = graph[i].to[j].second;

            if (dp[v] % 2 == 1 && rdp[u] % 2 == 1)
            {
                ans ^= w;
            }
        }
    }

    cout << ans << endl;

    graph.clear();
    rgraph.clear();
}*/

/*void task()
{
    int n, k;
    cin >> n >> k;

    vector<int> v(n);
    for (int i = 0; i < n; i++)
    {
        cin >> v[i];
    }

    if (n == 1)
    {
        cout << (long double)((v[0] / k) * k) / (long double)v[0] << endl;
        return;
    }

    if (n == 2)
    {
        long double maxans = 0;
        for (int i = 1; i <= k; i++)
        {
            int b0 = i;
            int b1 = (k + i - 1) / i;
            int a0 = v[0];
            int a1 = v[1];
            maxans = max(maxans, (long double)(a0 / b0) * (long double)(a1 / b1) / (long double)(a0) / (long double)(a1)*k);
        }
        cout << maxans << endl;
        return;
    }

    //vector<vector<long double>> dp(n + 1, vector<long double>(k + 1, 0));
    vector<vector<long double>> dp(n + 1);
    dp[0].resize(k + 1, 0);
    dp[0][1] = 1;

    for (int i = 0; i < n; i++)
    {
        dp[i + 1].resize(k + 1, 0);
        for (int j = 1; j <= k; j++)
        {
            for (int f = 1; f <= (k + j - 1) / j; f++)
            {
                dp[i + 1][min(j * f, k)] = max(dp[i + 1][min(j * f, k)], dp[i][j] * (int)(v[i] / f) / (long double)v[i]);
                if (v[i] / f == 0) break;
            }
        }
        dp[i].clear();
    }

    cout << dp[n][k] * k << endl;
}*/

/*struct Node
{
    int tin, tout;
    vector<int> to;
    vector<int> up = vector<int>(22);
};

vector<Node> tree;
vector<int> parent;
vector<pair<int, int>> dm;

int ans = 1;

int get_parent(int x)
{
    if (x != parent[x])
    {
        parent[x] = get_parent(parent[x]);
        return parent[x];
    }
    return x;
}

bool in_one(int x, int y)
{
    return get_parent(x) == get_parent(y);
}

void merge(int x, int y)
{
    x = get_parent(x);
    y = get_parent(y);

    ans *= binpow(dm[x].second - dm[x].first + 1, mod - 2);
    ans %= mod;
    ans *= binpow(dm[y].second - dm[y].first + 1, mod - 2);
    ans %= mod;

    parent[y] = x;
    dm[x].first = max(dm[x].first, dm[y].first);
    dm[x].second = min(dm[x].second, dm[y].second);
    ans *= max((int)0, dm[x].second - dm[x].first + 1);
    ans %= mod;
}

int timer = 0;

void dfs(int v)
{
    tree[v].tin = ++timer;

    for (int u : tree[v].to)
    {
        dfs(u);
    }

    tree[v].tout = ++timer;
}

bool is_parent(int v, int u)
{
    return tree[v].tin <= tree[u].tin && tree[v].tout >= tree[u].tout;
}

int lca(int v, int u)
{
    if (is_parent(v, u)) return v;
    if (is_parent(u, v)) return u;

    for (int i = 21; i >= 0; --i)
    {
        if (!is_parent(tree[v].up[i], u))
        {
            v = tree[v].up[i];
        }
    }

    return tree[v].up[0];
}

void task()
{
    int n;
    cin >> n;

    tree.resize(n);
    tree[0].up[0] = 0;

    for (int i = 1; i < n; ++i)
    {
        int p;
        cin >> p;
        p--;
        tree[p].to.push_back(i);
        tree[i].up[0] = p;
    }

    dfs(0);

    parent.resize(n);
    for (int i = 0; i < n; ++i)
    {
        parent[i] = i;
    }
    dm.resize(n);
    for (int i = 0; i < n; ++i)
    {
        cin >> dm[i].first >> dm[i].second;
    }

    for (int i = 1; i < 22; ++i)
    {
        for (int j = 0; j < n; ++j)
        {
            tree[j].up[i] = tree[tree[j].up[i - 1]].up[i - 1];
        }
    }

    for (int i = 0; i < n; ++i)
    {
        ans *= dm[i].second - dm[i].first + 1;
        ans %= mod;
    }

    int m;
    cin >> m;
    for (int i = 0; i < m; ++i)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;

        int l1 = lca(a, b);
        int l2 = lca(c, d);

        vector<int> p1, p2, p3, p4;
        while (a != l1)
        {
            p1.emplace_back(a);
            a = tree[a].up[0];
        }
        while (b != l1)
        {
            p2.emplace_back(b);
            b = tree[b].up[0];
        }
        while (c != l2)
        {
            p3.emplace_back(c);
            c = tree[c].up[0];
        }
        while (d != l2)
        {
            p4.emplace_back(d);
            d = tree[d].up[0];
        }

        reverse(p2.begin(), p2.end());
        reverse(p4.begin(), p4.end());

        p1.emplace_back(l1);
        p3.emplace_back(l2);

        int m1, m2;

        for (int j = 0; j < p1.size() + p2.size(); ++j)
        {
            if (j < p1.size()) m1 = p1[j];
            else m1 = p2[j - p1.size()];

            if (j < p3.size()) m2 = p3[j];
            else m2 = p4[j - p3.size()];

            if (!in_one(m1, m2))
            {
                merge(m1, m2);
            }
        }

        cout << ans << endl;
    }
}*/

/*int n, k;

vector<int> ans;
unordered_map<int, int> q;

int ask(int x)
{
    if (q.find(x) != q.end()) return q[x];
    int f;
    cout << "? " << x << endl;
    cin >> f;
    if (f == -1) exit(0);
    q[x] = f;
    return f;
}

void rec(int l, int r)
{
    if (k == 0) return;
    int lc = ask(l - 1);
    int rc = ask(r - 1);

    if (rc - lc != (l + r - 1) * (r - l) / 2)
    {
        if (r - l == 1)
        {
            ans.push_back(l);
            k--;
        }
        else
        {
            int m = (r + l) / 2;
            rec(l, m);
            if (k == 0) return;
            rec(m, r);
            if (k == 0) return;
        }
    }
}

void rec2(int l, int r)
{
    if (k == 0) return;
    int lc = ask(l - 1);
    int rc = ask(r - 1);

    if (rc - lc != (l + r - 1) * (r - l) / 2)
    {
        int diff = (l + r - 1) * (r - l) / 2 - (rc - lc);
        if (k == 0) return;
        if (r - l == 1)
        {
            ans.push_back(l);
            k--;
        }
        else if (diff < r)
        {
            rec2(diff, diff + 1);
        }

        if (ans.size() == 0 || ans.back() != diff)
        {
            int m = (r + l) / 2;
            rec(l, m);
            if (k == 0) return;
            rec(m, r);
            if (k == 0) return;
        }
    }
}

void task()
{
    cin >> n >> k;
    
    //q.resize(n + 1, -1);
    q[0] = 0;

    if (k <= 3)
    {
        rec(1, n + 1);
    }
    else
    {
        rec2(1, n + 1);
    }

    cout << "! ";
    for (int i = 0; i < ans.size(); i++)
    {
        cout << ans[i] << ' ';
    }
    cout << endl;

    int x;
    cin >> x;

    if (x == -1) exit(0);

    ans.clear();
    q.clear();
}*/

vector<vector<int>> graph;
vector<int> w;
int minans = LLONG_MAX;
int n, m, p, g;
unordered_map<int, int> cnt;

void rec(int v, int p, int curm, int cc, int depth)
{
    if (v == n - 1)
    {
        minans = min(minans, cc);
        return;
    }

    for (int i = 0; i < n; i++)
    {
        if (graph[v][i] == LLONG_MAX || cnt[i] == 2) continue;
        int u = i;
        int c = graph[v][i];
        int add = max((int)0, (c - p + curm - 1) / curm);
        cnt[u]++;
        rec(u, p + add * curm - c, max(curm, w[u]), cc + add, depth + 1);
        cnt[u]--;
    }
}

void task()
{
    cin >> n >> m >> p >> g;

    if (n <= 10)
    {
        w.resize(n);
        for (int i = 0; i < n; i++)
        {
            cin >> w[i];
        }

        graph.resize(n, vector<int>(n, LLONG_MAX));
        for (int i = 0; i < m; i++)
        {
            int v, u, c;
            cin >> v >> u >> c;
            v--;
            u--;
            graph[v][u] = min(graph[v][u], c);
        }

        cnt[0] = 1;
        rec(0, p, w[0], 0, 0);

        if (minans != LLONG_MAX)
        {
            cout << minans << endl;
        }
        else
        {
            cout << -1 << endl;
        }
    }
    else if (g == 2)
    {
        vector<int> w(n);
        for (int i = 0; i < n; i++)
        {
            cin >> w[i];
        }
        int ans = 0;
        int curm = -1;
        for (int i = 0; i < n - 1; i++)
        {
            curm = max(w[i], curm);
            int v, u, c;
            cin >> v >> u >> c;
            if (p < c)
            {
                int add = (c - p + curm - 1) / curm;
                ans += add;
                p += add * curm;
            }
            p -= c;
        }

        cout << ans << endl;
    }
    else if (g == 1)
    {
        w.resize(n);
        for (int i = 0; i < n; i++)
        {
            cin >> w[i];
        }
        
        vector<vector<pair<int, int>>> graph(n);
        vector<int> mindist(n, 1e16);
        set<pair<int, int>> s;
        for (int i = 1; i < n; i++)
        {
            s.insert({ (int)1e16,i });
        }
        s.insert({ 0,0 });

        for (int i = 0; i < m; i++)
        {
            int v, u, c;
            cin >> v >> u >> c;
            v--;
            u--;
            graph[v].push_back({ u,c });
        }

        while (!s.empty())
        {
            pair<int, int> p = *s.begin();
            s.erase(s.begin());
            int v = p.second;
            int d = p.first;

            if (d == 1e16)
            {
                break;
            }

            for (int i = 0; i < graph[v].size(); i++)
            {
                int u = graph[v][i].first;
                int c = graph[v][i].second;
                if (mindist[u] > d + c)
                {
                    s.erase({ mindist[u],u });
                    mindist[u] = d + c;
                    s.insert({ mindist[u],u });
                }
            }
        }

        if (mindist[n - 1] != 1e16)
        {
            cout << max((int)0, mindist[n - 1] - p) << endl;
        }
        else
        {
            cout << -1 << endl;
        }
    }
}

signed main()
{
    //freopen("in.txt", "r", stdin);
    //freopen("out.txt", "w", stdout);

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cout << fixed << setprecision(15);
    engine.seed(58);

    int t = 1;
    bool multitest = false;
    if (multitest) cin >> t;
    while (t--) task();

    return 0;
}
