//#include <bits/stdc++.h>
#include <iostream>
#include <vector>
#include <string>
#include <map>
#include <set>
#include <fstream>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <cmath>
#include <math.h>
#include <algorithm>

#define int long long

using namespace std;

mt19937 rnd(12);

const int N = 2e5 + 11, inf = 1e18 + 111, mod = 1e9 + 7;

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(NULL), cout.tie(NULL);
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector<int> w(n);
    vector<int> conv(n);
    unordered_map<int, int> mp;
    int now = 0;
    vector<int> all(n);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        all[i] = w[i];
    }
    sort(all.begin(), all.end());
    vector<int> rev(n);
    for (int i = 0; i < n; i++) {
        if (i > 0 && all[i - 1] == all[i]) continue;
        mp[all[i]] = now;
        rev[now] = all[i];
        now++;
    }
    for (int i = 0; i < n; i++) {
        conv[i] = mp[w[i]];
    }
    set<vector<int>> st;
    vector<vector<pair<int, int>>> gr(n);
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        gr[a].push_back({ b, s });
    }
    st.insert({ 0, conv[0], -p, 0 });
    vector<vector<pair<int, int>>> dp(n, vector<pair<int, int>>(n, { inf, inf }));
    vector<vector<int>> used(n, vector<int>(n, 0));
    while (!st.empty()) {
        auto vec = *st.begin();
        st.erase(st.begin());
        int v = vec[3], mx = vec[1], ost = -vec[2];
        if (used[v][mx] == 1) continue;
        used[v][mx] = 1;
        for (pair<int, int>& p : gr[v]) {
            int to = p.first;
            int will = max(mx, conv[to]);
            if (used[to][will]) continue;
            int need = ost - p.second;
            int nw = ost - p.second;
            int konz = vec[0];
            if (need < 0) {
                need *= -1;
                int haveto = need / rev[mx];
                if (need % rev[mx] != 0) haveto++;
                konz += haveto;
                nw = -(need - rev[mx] * haveto);
            }
            if (dp[to][will].first > konz) {
                dp[to][will] = { konz, nw };
                st.insert({ konz, will, -nw, to });
            }
            else if (dp[to][will].first == konz && dp[to][will].second < nw) {
                dp[to][will] = { konz, nw };
                st.insert({ konz, will, -nw, to });
            }
        }
    }
    int res = inf;
    for (int i = 0; i < n; i++) {
        res = min(res, dp[n - 1][i].first);
    }
    if (res == inf) {
        cout << -1;
    }
    else {
        cout << res;
    }
}

