#include <bits/stdc++.h>
#define ff first
#define ss second
#ifndef LOCAL
#define endl '\n'
#endif
//#define int long long

using namespace std;

typedef long long ll;
typedef long double ld;

const int inf = 1000000009;
const ll inf18 = 1000000000000000018;

template <class T1, class T2> istream& operator>>(istream &is, pair <T1, T2> &a) {is >> a.ff >> a.ss; return is;}
template <class T1, class T2> ostream& operator<<(ostream &os, pair <T1, T2> a) {os << "(" << a.ff << ", " << a.ss << ")"; return os;}
template <class T> istream& operator>>(istream &is, vector <T> &a) {for (auto &x : a) is >> x; return is;}
template <class T> ostream& operator<<(ostream &os, vector <T> a) {for (auto x : a) os << x << " "; os << endl; return os;}

const int N = 810;
int n, m, p, w[N];
vector <pair <int, int>> g[N];

ll dist[N];
void solve1(){
    set <pair <ll, int>> s;
    for (int i = 0; i < n; i++) dist[i] = inf18;
    dist[0] = -p;
    s.insert({-p, 0});
    while (!s.empty()){
        auto [len, v] = *s.begin();
        s.erase(s.begin());
        for (auto [u, w] : g[v]) {
            if (dist[u] > len + w) {
                s.erase({dist[u], u});
                dist[u] = len + w;
                s.insert({dist[u], u});
            }
        }
    }
    cout << (dist[n - 1] == inf18 ? -1 : dist[n - 1]) << endl;
}

void solve2(){
    ll mon = p, ts = 0, mx = w[0];
    for (int i = 0; i < n - 1; i++){
        mx = max(mx, ll(w[i]));
        if (mon >= g[i][0].ss){
            mon -= g[i][0].ss;
            continue;
        }
        ll d = (g[i][0].ss - mon + mx - 1) / mx;
        ts += d;
        mon += mx * d - g[i][0].ss;
    }
    cout << ts << endl;
}

void solve3(){
    vector <int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    ll ans = inf18;
    do{
        ll mon = p, ts = 0, mx = w[0];
        for (int i = 0; i < n - 1; i++){
            mx = max(mx, ll(w[i]));
            int gi0 = inf;
            for (auto [u, w] : g[ord[i]]) if (u == ord[i + 1]) gi0 = min(gi0, w);
            if (gi0 == inf) goto nxt;
            if (mon >= gi0){
                mon -= gi0;
                continue;
            }
            ll d = (gi0 - mon + mx - 1) / mx;
            ts += d;
            mon += mx * d - gi0;
        }
        ans = min(ans, ts);
        nxt:;
    } while (next_permutation(++ord.begin(), --ord.end()));
    cout << ans << endl;
}

struct tripe{
    int v, mon, ts;
    friend bool operator<(const tripe &a, const tripe &b) {
        if (a.ts != b.ts) return a.ts < b.ts;
        if (a.v != b.v) return a.v < b.v;
        return a.mon < b.mon;
    }
};

const int M = 10010;
int dst[N][M];

void solve4(){
    set <tripe> s;
    for (int i = 0; i < n; i++) for (int j = 0; j < M; j++) dst[i][j] = inf;
    p = min(p, M - 1);
    dst[0][p] = 0;
    s.insert({0, p, 0});
    while (!s.empty()){
        auto [v, mon, len] = *s.begin();
        s.erase(s.begin());
        for (auto [u, w] : g[v]) {
            if (mon < w) continue;
            if (dst[u][mon - w] > len) {
                s.erase({u, mon - w, dst[u][mon - w]});
                dst[u][mon - w] = len;
                s.insert({u, mon - w, dst[u][mon - w]});
            }
        }
        int c = min(M - 1, mon + w[v]);
        if (dst[v][c] > len + 1){
            s.erase({v, c, dst[v][c]});
            dst[v][c] = len + 1;
            s.insert({v, c, dst[v][c]});
        }
    }
    int ans = inf;
    for (int i = 0; i < M; i++) ans = min(ans, dst[n - 1][i]);
    if (ans == inf) ans = -1;
    cout << ans << endl;
}

int32_t main(){
#ifdef LOCAL
    auto st = clock();
#else
    ios_base::sync_with_stdio(false); cin.tie(0);
#endif
    int t;
    cin >> n >> m >> p >> t;
    for (int i = 0; i < n; i++) cin >> w[i];
    for (int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        g[u].emplace_back(v, w);
    }
    if (t == 0) solve4();
    else if (t == 1) solve1();
    else if (t == 2) solve2();
    else if (t == 3) solve3();
    else solve4();
#ifdef LOCAL
    cout << endl << "TIME: " << (clock() - st) * 1.0 / CLOCKS_PER_SEC << " sec" << endl;
#endif
}
