#include <bits/stdc++.h>

#include <ranges>
#include <utility>

using namespace std;

typedef int64_t ll;
typedef long double ld;
constexpr int INF = 2e9;
constexpr ll INF_LL = 1e18;

bool STRS = false;

static constexpr ll mod = 1e9 + 7;

mt19937 rnd;

struct Solution {
    Solution() {
        rnd = mt19937(time(nullptr));
    }

    signed solve1(int n, int m, ll p) {
        vector<int> _____(n);
        for (auto &it: _____) cin >> it;
        vector<vector<pair<int, int>>> g(n);
        for (int i = 0; i < m; ++i) {
            int a, b;
            ll w;
            cin >> a >> b >> w;
            a--; b--;
            g[a].emplace_back(b, w);
        }
        vector<ll> dst(n, INF_LL);
        dst[0] = 0;
        set<pair<int, ll>> q = {{0, 0}};
        while (q.size()) {
            int cur = q.begin()->second;
            q.erase(q.begin());
            for (auto &it: g[cur]) {
                if (dst[it.first] > dst[cur] + it.second) {
                    q.erase({dst[it.first], it.first});
                    dst[it.first] = dst[cur] + it.second;
                    q.insert({dst[it.first], it.first});
                }
            }
        }
        if (dst.back() == INF_LL) {
            cout << -1 << "\n";
            return 0;
        }
        cout << max<ll>(0, dst.back() - p) << "\n";
        return 0;
    }

    ll tsolve2(int n, ll p, vector<ll> w, vector<ll> g) {
        ll res = 0;
        ll mx = 0;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(mx, w[i]);
//            if (mx == 0) {
//                exit(0);
//            }
//            if (i >= (int)g.size()) {
//                exit(0);
//            }
            if (g[i] > p) {
                ll nd = g[i] - p;
                ll fn = nd / mx + (nd % mx > 0 ? 1 : 0);
                p += fn * mx;
                res += fn;
            }
            p -= g[i];
        }
        return res;
    }

    signed solve2(int n, ll p) {
        vector<ll> w(n);
        for (auto& it : w) cin >> it;
        vector<ll> g(n - 1);
        for (auto& it : g) {
            int _;
            cin >> _ >> _ >> it;
        }
        cout << tsolve2(n, p, w, g) << "\n";
        return 0;
    }

    signed solve3(int n, int m, ll p) {
        vector<ll> w(n);
        for (auto& it : w) cin >> it;
        vector<vector<ll>> g(n, vector<ll>(n, INF_LL));
        for (int i = 0; i < m; ++i) {
            int a, b;
            ll w; cin >> a >> b >> w;
            g[a - 1][b - 1] = min(g[a - 1][b - 1], w);
            g[b - 1][a - 1] = min(g[b - 1][a - 1], w);
        }
        vector<int> cur(n);
        iota(cur.begin(), cur.end(), 0);
        ll ans = INF_LL;
        do {
            vector<ll> nw(n);
            for (int i = 0; i < n; ++i) {
                nw[i] = w[cur[i]];
            }
            vector<ll> prc;
            bool ok = true;
            int nwn = n;
            for (int i = 0; i < n; ++i) {
                int a = cur[i];
                if (a == n - 1) {
                    nwn = i + 1;
                    break;
                }
                int b = cur[i + 1];
                if (g[a][b] == INF_LL) {
                    ok = false;
                    break;
                }
                prc.push_back(g[a][b]);
            }
            if (ok) {
                ans = min(ans, tsolve2(nwn, p, w, prc));
            }
        } while (next_permutation(cur.begin() + 1, cur.end()));
        if (ans == INF_LL) {
            cout << "-1\n";
            return 0;
        }
        cout << ans << "\n";
        return 0;
    }

    signed operator()(int TEST = -1) {
        int n, m, g;
        ll p;
        cin >> n >> m >> p >> g;
        if (g == 1) {
            return solve1(n, m, p);
        } else if (g == 2) {
            return solve2(n, p);
        } else if (g == 0 || g == 3) {
            return solve3(n, m, p);
        }
#ifdef ILKRAS
#endif
        return 0;
    }
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
        if (st % 100 == 0) {
            cout << st << endl;
        }
    }
    int t = 1;
#ifdef ILKRAS
    cin >> t;
#endif
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}
//4
//
//4 4 2 0
//7 4 3 1
//1 2 21
//3 2 6
//1 3 8
//2 4 11
//
//4 4 10 0
//1 2 10 1
//1 2 20
//2 4 30
//1 3 25
//3 4 89
//
//4 4 7 0
//5 1 6 2
//1 2 5
//2 3 10
//3 4 50
//3 4 70
//
//4 1 2 0
//1 1 1 1
//1 3 2

//2
//
//4 1 2 1
//1 1 1 1
//1 4 10
//
//4 3 7 2
//5 1 6 2
//1 2 5
//2 3 10
//3 4 50