#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define ld long double
#define all(a) a.begin(), a.end()

const long long INF = 1e18;
const long long MAXN = 1e5;
const long double EPS = 1e-10;


void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector <int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];

    if (g == 2) {
        vector <int> s(n - 1);
        for (int i = 0; i < m; i++) {
            int x, y, si;
            cin >> x >> y >> si;
            s[i] = si;
        }
        for (int i = 1; i < n; i++) w[i] = max(w[i], w[i - 1]);
        int tmp = 0;
        for (int i = 0; i < n - 1; i++) tmp += s[i] / w[i] + (s[i] % w[i] != 0);
        vector <pair <int, int>> ost;
        for (int i = 0; i < n - 1; i++) ost.pb(mp(s[i] % w[i], i));
        sort(all(ost));
        vector <pair <int, int>> del;
        for (int i = 0; i < n - 1; i++) del.pb(mp(w[i], i));
        sort(all(del));

        /*
        for (auto at: ost) cout << at.first << " ";
        cout << endl;
        for (auto at: del) cout << at.first << " ";
        cout << endl;
        */

        int ind1 = 0, ind2 = 0;
        while ((ind1 < n - 1 or ind2 < n - 1) and p > 0) {
            if (ind1 < n - 1 and ind2 < n - 1) {
                if (p < ost[ind1].first and p < del[ind2].first) break;
                if (ost[ind1].first <= del[ind2].first and p >= ost[ind1].first) {
                    p -= ost[ind1].first;
                    if (ost[ind1].first > 0) tmp--;
                    ind1++;
                }
                else {
                    int cnt = s[del[ind2].second] / del[ind2].first;
                    int can = p / del[ind2].first;
                    cnt = min(can, cnt);

                    p -= cnt * del[ind2].first;
                    if (cnt == s[del[ind2].second] / del[ind2].first) ind2++;
                    tmp -= cnt;
                }
            }
            else if (ind1 < n - 1) {
                if (p < ost[ind1].first) break;
                p -= ost[ind1].first;
                if (ost[ind1].first > 0) tmp--;
                ind1++;
            }
            else if (ind2 < n - 1){
                if (p < del[ind2].first) break;
                int cnt = s[del[ind2].second] / del[ind2].first;
                int can = p / del[ind2].first;
                cnt = min(can, cnt);

                p -= cnt * del[ind2].first;
                if (cnt == s[del[ind2].second] / del[ind2].first) ind2++;
                tmp -= cnt;
            }
            //cout << ind1 << " " << ind2 << " " << tmp << endl;
        }

        cout << tmp << endl;
    }
    else if (g == 1) {
        vector <vector <pair <int, int>>> g;
        for (int i = 0; i < n; i++) {
            vector <pair <int, int>> tmp;
            g.pb(tmp);
        }
        for (int i = 0; i < m; i++) {
            int x, y, s;
            cin >> x >> y >> s;
            g[x - 1].pb(mp(y - 1, s));
        }

        vector <int> d(n, INF);
        queue <int> q;
        q.push(0);
        d[0] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto u: g[v]) {
                if (d[v] + u.second < d[u.first]) {
                    d[u.first] = d[v] + u.second;
                    q.push(u.first);
                }
            }
        }
        if (d[n - 1] < INF) cout << max(0LL, d[n - 1] - p) << endl;
        else cout << -1 << endl;
    }
}

/*
4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50
 */

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    solve();
}