#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define ld long double
#define all(a) a.begin(), a.end()

const long long INF = 1e18;
const long long MAXN = 1e5;
const long double EPS = 1e-10;


void solve() {
    int n, m, p, g;
    cin >> n >> m >> p >> g;
    vector <int> w(n);
    for (int i = 0; i < n; i++) cin >> w[i];

    if (g == 2) {
        vector <int> s(n - 1);
        for (int i = 0; i < m; i++) {
            int x, y, si;
            cin >> x >> y >> si;
            s[i] = si;
        }
        //for (int i = 1; i < n; i++) w[i] = max(w[i - 1], w[i]);
        int ans = 0;
        for (int i = 0; i < n - 1; i++) ans += s[i] / w[i] + (s[i] % w[i] != 0);
        vector <int> ost;
        vector <pair <int, int>> del;
        for (int i = 0; i < n - 1; i++) {
            ost.pb(s[i] % w[i]);
            del.pb(mp(w[i], s[i] / w[i]));
        }
        sort(all(ost));
        sort(all(del));
        int ind1 = 0, ind2 = 0;
        while ((ind1 < n - 1 and p >= ost[ind1]) or (ind2 < n - 1 and p >= del[ind2].first)) {
            if (ind1 < n - 1 and ind2 < n - 1) {
                if (ost[ind1] < del[ind2].first) {
                    p -= ost[ind1];
                    if (ost[ind1] > 0) ans--;
                    ind1++;
                }
                else {
                    p -= del[ind2].first;
                    ans--;
                    del[ind2].second--;
                    if (del[ind2].second == 0) ind2++;
                }
            }
            else if (ind1 < n - 1 and ind2 >= n - 1) {
                p -= ost[ind1];
                if (ost[ind1] > 0) ans--;
                ind1++;
            }
            else if (ind1 >= n - 1 and ind2 < n - 1) {
                p -= del[ind2].first;
                ans--;
                del[ind2].second--;
                if (del[ind2].second == 0) ind2++;
            }
        }
        cout << ans << endl;
    }
    else if (g == 1) {
        vector <vector <pair <int, int>>> g;
        for (int i = 0; i < n; i++) {
            vector <pair <int, int>> tmp;
            g.pb(tmp);
        }
        for (int i = 0; i < m; i++) {
            int x, y, s;
            cin >> x >> y >> s;
            g[x - 1].pb(mp(y - 1, s));
        }

        vector <int> d(n, INF);
        queue <int> q;
        q.push(0);
        d[0] = 0;
        while (!q.empty()) {
            int v = q.front();
            q.pop();
            for (auto u: g[v]) {
                if (d[v] + u.second < d[u.first]) {
                    d[u.first] = d[v] + u.second;
                    q.push(u.first);
                }
            }
        }
        if (d[n - 1] < INF) cout << max(0LL, d[n - 1] - p) << endl;
        else cout << -1 << endl;
    }
}

/*
4 3 7 2
5 1 6 2
1 2 5
2 3 10
3 4 50
 */

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);

    solve();
}