#include <bits/stdc++.h>

#define int long long

using namespace std;

vector<int> w;
vector<vector<pair<int, int>>> g;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n, m, p, test;
    cin >> n >> m >> p >> test;
    w.resize(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> w[i];
    g.resize(n + 1);
    for (int i = 0; i < m; i++) {
        int a, b, s;
        cin >> a >> b >> s;
        g[a].push_back({b, s});
    }
    if (test == 1) {
        vector<int> dist(n + 1, 1e17);
        dist[1] = 0;
        set<pair<int, int>> q = {{0, 1}};
        while (!q.empty()) {
            auto [d, u] = *q.begin();
            q.erase(q.begin());
            if (dist[u] != d)
                continue;
            for (auto [v, s] : g[u]) {
                if (dist[v] > d + s) {
                    dist[v] = d + s;
                    q.insert({d + s, v});
                }
            }
        }
        if (dist[n] == 1e17)
            cout << -1;
        else 
            cout << max(0ll, dist[n] - p);
    }
}