#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define endl "\n"
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif


const int N = 1000, INF = 1e15 + 10;
int w[N];
int g[N][N];
int n, m, p, group;
bool isArr = true;


void input() {
    cin >> n >> m >> p >> group;
    for (int i = 0; i < n; ++i)
        cin >> w[i];
    if (m != n - 1) isArr = false;
    for (auto& it : g)
        for (auto& jt : it) jt = -1;
    for (int i = 0; i < m; ++i) {
        int from, to, cost; cin >> from >> to >> cost;
        --from, --to;
        if (from != i + 1 || to != from + 1) isArr = false;
        if (g[from][to] == -1) g[from][to] = cost;
        else g[from][to] = min(g[from][to], cost);
    }
}

void superSlow() {
    vec<int> arr(n);
    iota(all(arr), 0);

    int ans = INF;
    do {

        vec<int> path = arr;
        int pCop = p;

        bool f = true;
        if (path.front() != 0) continue;
        while (path.back() != n - 1)
            path.pop_back();
        for (int i = 1; i < sz(path); ++i) {
            if (g[path[i - 1]][path[i]] == -1) f = false;
        }
        if (!f) continue;

        dbg("---------------------------");
        dbg(path);

        int nxt = 0, val = 0;
        for (int i = 0; i < sz(path); ++i) {
            if (i != nxt) continue;
            nxt = i + 1;
            int cur = path[i];
            while (nxt < sz(path) && w[path[nxt]] < w[cur]) ++nxt;
            int need = 0;
            dbg(sz(path) - 1);
            for (int j = i; j + 1 <= min(sz(path) - 1, nxt); ++j) {
                dbg(j + 1, sz(path) - 1, nxt);
                dbg(j, path[j], path[j + 1]);
                need += g[path[j]][path[j + 1]];
            }
            dbg(i, nxt, need);
            if (need <= pCop) pCop -= need;
            else {
                dbg(need, pCop);
                need -= pCop;
                int days = (need + w[cur] - 1) / w[cur];
                val += days;
                pCop = days * w[cur] - need;
                dbg(days, pCop, need);
            }
        }

        ans = min(ans, val);
        dbg(val);

    } while (next_permutation(all(arr)));

    cout << (ans == INF ? -1 : ans);
    exit(0);
}



int dist[N];
bool used[N];

void w1() {
    for (int from = 0; from < n; ++from) {
        for (int to = 0; to < n; ++to) {
            if (from == to || g[from][to] == -1) continue;
            int days = (g[from][to] + w[from] - 1) / w[from];
            g[from][to] = days;
        }
    }

    fill(dist, dist + n, INF);
    dist[0] = 0;

    for (int _ = 0; _ < n; ++_) {
        int miInd = -1;
        for (int i = 0; i < n; ++i) {
            if (!used[i] && (miInd == -1 || dist[i] < dist[miInd]))
                miInd = i;
        }
        used[miInd] = true;

        for (int to = 0; to < n; ++to) {
            if (g[miInd][to] == -1) continue;
            dist[to] = min(dist[to], dist[miInd] + g[miInd][to]);
        }

    }

    int ans = dist[n - 1];
    if (ans == INF) {
        cout << -1;
        exit(0);
    }
    dbg(ans);
    ans = max((int)0, ans - p);
    cout << ans;

    exit(0);

}


void arrai() {
    exit(0);
}


signed main() {
#ifdef LOCAL
    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
#endif
    FAST_IO

    input();
    bool f = true;
    for (int i = 0; i < n; ++i)
        if (w[i] != 1) f = false;
    if (f) w1();
    if (n <= 10) superSlow();
    //if (isArr) arrai();

}