//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m, p, g;
	cin >> n >> m >> p >> g;
	vector<ll> w(n);
	for (ll i = 0; i < n; i++) {
		cin >> w[i];
	}
	vector<vector<pair<ll, ll>>> go(n);
	for (ll i = 0; i < m; i++) {
		ll a, b, c;
		cin >> a >> b >> c;
		a--;
		b--;
		go[a].emplace_back(b, c);
	}
	if (g == 1) {
		vector<ll> d(n, INF64);
		d[0] = 0;
		priority_queue<pair<ll, ll>, vector<pair<ll, ll>>, greater<pair<ll, ll>>> q;
		q.push(make_pair(0, 0));
		while (!q.empty()) {
			auto[dx, x] = q.top();
			q.pop();
			if (d[x] != dx) {
				continue;
			}
			for (auto[b, c] : go[x]) {
				if (assign_min(d[b], d[x] + c)) {
					q.push(make_pair(d[b], b));
				}
			}
		}
		cout << (d.back() == INF64 ? -1 : max(0ll, d.back() - p)) << '\n';
		return;
	}
	if (g == 2) {
		ll mc = 0;
		ll ans = 0;
		for (ll i = 0; i < n - 1; i++) {
			assign_max(mc, w[i]);
			ll np = max(0ll, (go[i][0].second - p + mc - 1) / mc);
			ans += np;
			p += np * mc;
			p -= go[i][0].second;
		}
		cout << ans << '\n';
		return;
	}
	if (g == 3) {
		vector<vector<ll>> ms(n, vector<ll>(n, INF64));
		for (ll i = 0; i < n; i++) {
			for (auto[b, c] : go[i]) {
				assign_min(ms[i][b], c);
			}
		}
		vector<ll> way(n, 0);
		for (ll i = 0; i < n; i++) {
			way[i] = i;
		}
		ll ans = INF64;
		do {
			if (way[0] != 0) {
				break;
			}
			bool b = true;
			for (ll i = 1; i < n; i++) {
				if (way[i - 1] == n - 1) {
					break;
				}
				if (ms[way[i - 1]][way[i]] == INF64) {
					b = false;
					break;
				}
			}
			if (!b) {
				continue;
			}
			ll now = p;
			ll na = 0, mx = w[0];
			for (ll i = 1; i < n; i++) {
				if (way[i - 1] == n - 1) {
					break;
				}
				ll need = max(0ll, (ms[way[i - 1]][way[i]] - now + mx - 1) / mx);
				na += need;
				now += need * mx;
				now -= ms[way[i - 1]][way[i]];
				assign_max(mx, w[way[i]]);
			}
			assign_min(ans, na);
		} while (next_permutation(way.begin(), way.end()));
		cout << (ans >= INF32 * n ? -1 : ans) << '\n';
		return;
	}
	ll ms = 100;
	vector<vector<ll>> dp(n, vector<ll>(n * ms + 1, INF64));
	assign_min(p, n * ms);
	dp[0][p] = 0;
	priority_queue<tuple<ll, ll, ll>, vector<tuple<ll, ll, ll>>, greater<tuple<ll, ll, ll>>> pq;
	pq.push(make_tuple(0, 0, p));
	while (!pq.empty()) {
		auto[d, v, c] = pq.top();
		pq.pop();
		if (d != dp[v][c]) {
			continue;
		}
		if (assign_min(dp[v][min(n * ms, c + w[v])], d + 1)) {
			pq.push(make_tuple(d + 1, v, min(n * ms, c + w[v])));
		}
		for (auto[u, cc] : go[v]) {
			if (c >= cc && assign_min(dp[u][c - cc], d)) {
				pq.push(make_tuple(d, u, c - cc));
			}
		}
	}
	ll ans = INF64;
	for (auto i : dp.back()) {
		assign_min(ans, i);
	}
	cout << (ans == INF64 ? -1 : ans) << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		solve();
	} else {
		solve();
	}
}
