#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
using namespace std;
typedef long long ll;
vector<pair<ll, ll>> h;
vector<ll> pos;
void su(ll j) {
	while (j >= 0 && h[j] < h[(j - 1) / 2]) swap(h[j], h[(j - 1) / 2]), swap(pos[h[j].second], pos[h[(j - 1) / 2].second]), j = (j - 1) / 2;
}
void insert(ll i, ll x) {
	ll j = (ll)h.size();
	pos[i] = j;
	h.push_back({ x, i });
	su(j);
}
void erase(ll j) {
	h[j].first = 1e18;
	while (j * 2 + 1 < (ll)h.size()) {
		ll i = j * 2 + 1;
		if (j * 2 + 2 < (ll)h.size() && h[j * 2 + 2].first < h[i].first) i = j * 2 + 2;
		swap(h[i], h[j]);
		swap(pos[h[i].second], pos[h[j].second]);
		j = i;
	}
	swap(h[j], h.back());
	swap(pos[h[j].second], pos[h.back().second]);
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, m, p, G;
	cin >> n >> m >> p >> G;
	vector<ll> w(n);
	for (ll i = 0; i < n; ++i) cin >> w[i];
	vector<vector<vector<ll>>> g(n);
	for (ll i = 0; i < m; ++i) {
		ll a, b, s;
		cin >> a >> b >> s;
		g[--a].push_back({ --b, s });
	}
	if (G == 1) {
		pos.assign(n, -1);
		vector<ll> d(n, 1e18);
		d[0] = 0;
		for (auto to : g[0]) {
			insert(to[0], to[1]);
			d[to[0]] = to[1];
		}
		for (ll i = 0; i < n - 1 && (ll)h.size(); ++i) {
			ll v = h[0].second;
			erase(0);
			for (auto to : g[v]) {
				if (d[to[0]] == 1e18) {
					d[to[0]] = d[v] + to[1];
					insert(to[0], d[to[0]]);
				}
				else if (d[v] + to[1] < d[to[0]]) {
					d[to[0]] = d[v] + to[1];
					su(pos[to[0]]);
				}
			}
		}
		if (d[n - 1] == 1e18) cout << -1;
		else cout << d[n - 1] - p;
	}
	else if (G == 2) {
		ll mx = 0, s = 0, ans = 0;
		for (ll i = 0; i < n - 1; ++i) {
			if (w[i] > mx) {
				if (i) {
					ans += max((ll)0, (s - p) / mx + ((s - p) % mx > 0));
					p += max((ll)0, (s - p) / mx + ((s - p) % mx > 0)) * mx - s;
				}
				mx = w[i];
				s = 0;
			}
			s += g[i][0][1];
		}
		ans += max((ll)0, (s - p) / mx + ((s - p) % mx > 0));
		cout << ans;
	}
	return 0;
}