#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
using namespace std;
typedef long long ll;
vector<ll> w;
vector<vector<ll>> dp;
vector<vector<vector<ll>>> g;
ll ans(ll i, ll p) {
	if (p >= 0 && i == (ll)g.size() - 1) return 0;
	if (p < 0 || p > 20000) return 1e18;
	if (dp[i][p] != -1) return dp[i][p];
	dp[i][p] = ans(i, p + w[i]) + 1;
	for (auto to : g[i]) {
		dp[i][p] = min(dp[i][p], ans(to[0], p - to[1]));
	}
	return dp[i][p];
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, m, p, G;
	cin >> n >> m >> p >> G;
	w.resize(n);
	for (ll i = 0; i < n; ++i) cin >> w[i];
	g.resize(n);
	vector<vector<ll>> x(n, vector<ll>(n, 1e18));
	vector<vector<ll>> e;
	for (ll i = 0; i < m; ++i) {
		ll a, b, s;
		cin >> a >> b >> s;
		e.push_back({ --a, --b, s });
		x[a][b] = min(x[a][b], s);
	}
	for (ll i = 0; i < n; ++i) {
		for (ll j = 0; j < n; ++j) {
			if (x[i][j] != 1e18) g[i].push_back({ j, x[i][j]});
		}
	}
	if (G == 1) {
		x[0][0] = 0;
		for (ll i = 0; i < 10 * n; ++i) {
			for (ll j = 0; j < m; ++j) x[0][e[j][1]] = min(x[0][e[j][1]], x[0][e[j][0]] + e[j][2]);
		}
		if (x[0][n - 1] == 1e18) cout << -1;
		else cout << max((ll)0, x[0][n - 1] - p);
	}
	else if (G == 2) {
		ll mx = 0, s = 0, ans = 0;
		for (ll i = 0; i < n - 1; ++i) {
			if (w[i] > mx) {
				if (i) {
					ans += max((ll)0, (s - p) / mx + ((s - p) % mx > 0));
					p += max((ll)0, (s - p) / mx + ((s - p) % mx > 0)) * mx - s;
				}
				mx = w[i];
				s = 0;
			}
			s += g[i][0][1];
		}
		ans += max((ll)0, (s - p) / mx + ((s - p) % mx > 0));
		cout << ans;
	}
	else {
		dp.assign(n, vector<ll>(20001, -1));
		ll x = ans(0, p);
		if (x >= 1e18) x = -1;
		cout << x;
	}
	return 0;
}