#include <iostream>
#include <vector>
#include <map>

using namespace std;
using ll = long long;

ll n, m, cnt;

ll solveLine() {
    vector<ll> profit(n);
    for (auto &item: profit) {
        cin >> item;
    }

    vector<ll> cost(n);
    for (ll i = 1; i < n; ++i) {
        cin >> cost[i] >> cost[i] >> cost[i];
    }

    vector<ll> dp(n);
    ll maxProfit = profit[0];
    for (ll i = 1; i < n; ++i) {
        if (cnt >= cost[i]) {
            cnt -= cost[i];
            dp[i] = dp[i - 1];
            continue;
        }

        ll need = cost[i] - cnt;
        ll add = (need + maxProfit - 1) / maxProfit;
        cnt += maxProfit * add;
        cnt -= cost[i];
        dp[i] = add + dp[i - 1];
        maxProfit = max(maxProfit, profit[i]);
    }

    return dp[n - 1];
}

void resolve() {
    ll testGroup;
    cin >> n >> m >> cnt >> testGroup;
    ll res = 0;
    if (testGroup == 2) {
        res = solveLine();
    }

    cout << res << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    resolve();
    return 0;
}
