#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define f(n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define pb push_back

typedef long long ll;
typedef vector<int> vei;
typedef string str;

void solve() {
    int n, m, p, g;
    cin>>n>>m>>p>>g;
    vector<vector<int>> gr(n, vector<int>(n, (ll)1e17));
    vector<vector<int>> gr2(n);
    vei w(n);
    f(n) cin>>w[i];
    f(m) {
        int u, v, s;
        cin>>u>>v>>s;
        --u;--v;
        gr2[u].pb(v);
        gr[u][v] = min(gr[u][v], s);
    }
    for(int i = 0; i < n; ++i) {
        set<pair<int, int>> cur;
        gr[i][i] = 0;
        for(int j = 0; j < n; ++j) cur.insert({gr[i][j], j});
        while(cur.size()) {
            int v = (*cur.begin()).second;
            cur.erase(cur.begin());
            for(auto e : gr2[v]) {
                if(gr[i][e] > gr[i][v] + gr[v][e]) {
                    cur.erase({gr[i][e], e});
                    gr[i][e] = gr[i][v] + gr[v][e];
                    cur.insert({gr[i][e], e});
                }
            }
        }
    }
    vector<int> dp1(n, (ll)1e17), dp2(n);
    vector<pair<int, int>> tmp(n);
    f(n) tmp[i] = {w[i], i};
    sort(all(tmp));
    int ind = 0;
    f(n) if(tmp[i].second == 0) ind = i;
    dp1[ind] = 0;
    dp2[ind] = p;
    int ans = 1e17;
    for(int i = 0; i < n; ++i) {
        for(int j = 0; j < n; ++j) {
            int u = tmp[i].second;
            int v = tmp[j].second;
            if(gr[v][u] == (ll)1e17 || i == j) continue;
            if(dp1[i] > dp1[j] + max(0ll, (gr[v][u]-dp2[j]+w[v]-1)/w[v])) {
                dp1[i] = dp1[j] + max(0ll, (gr[v][u]-dp2[j]+w[v]-1)/w[v]);
                dp2[i] = dp2[j] + max(0ll, (gr[v][u]-dp2[j]+w[v]-1)/w[v]) * w[v] - gr[v][u];
            }
            if(dp1[i] == dp1[j] + max(0ll, (gr[v][u]-dp2[j]+w[v]-1)/w[v])) {
                dp2[i] = max(dp2[i], dp2[j] + max(0ll, (gr[v][u]-dp2[j]+w[v]-1)/w[v]) * w[v] - gr[v][u]);
            }
        }
        int v = tmp[i].second;
        int u = n-1;
        if(gr[v][u] != (ll)1e17) ans = min(ans, dp1[i] + max(0ll, (gr[v][u]-dp2[i]+w[v]-1)/w[v]));
    }
//    cout<<gr[1][3]<<' '<<dp1[3]<<' ';
    if(ans == (ll)1e17) {
        cout<<-1;
        return;
    }
    cout<<ans;
}

signed main() {
    cout<<fixed<<setprecision(15);
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
//    cin>>tc;
    for(int i = 0; i < tc; ++i) {
        // cout << "Test case: " << i+1 << endl;
        solve();
    }
    return 0;
}