#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }

inline void solve () {
    int n, m, p, GR; cin >> n >> m >> p >> GR;
    vector <int> w (n); for (auto &i : w) cin >> i;
    vector <vector <pii>> g (n);
    for (int i = 0; i < m; ++i) {
        int a, b, c; cin >> a >> b >> c; --a, --b;
        g[a].pb({b, c});
    }

    if (GR == 1) {
        const ll inf = 1e18 + 9;
        priority_queue <array <ll, 3>, vector <array <ll, 3>>, greater <array <ll, 3>>> pq;
        vector <ll> dist (n, inf);
        pq.push({0, -p, 0});
        while (sz(pq)) {
            auto [di, cash, v] = pq.top(); pq.pop();
            if (di > dist[v]) continue;
            cash = -cash;
            for (auto [u, cs] : g[v]) {
                int add = max(0ll, cs - cash);
                if (umin(dist[u], add + dist[v])) {
                    pq.push({dist[u], -(add + cash - cs), u});
                }
            }
        }
        if (dist[n - 1] == inf) dist[n - 1] = -1;
        cout << dist[n - 1] << endl;
    }
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
