#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
#define fast ios::sync_with_stdio(false);cin.tie(0);
#define int ll

vector<vector<pair<int ,int>>> g;

const int INF = 1e16;

int dijkstra(int s) {
    int n = g.size();
    vector<int> dp(n, INF );
    set<pair<int, int>> st;
    st.insert({0, s});
    dp[s] = 0;
    while (!st.empty()) {
        auto [dist, v] = *st.begin();
        st.erase(st.begin());
        for (auto [u, w] : g[v]) {
            if (dp[v] + w < dp[u]) {
                st.erase({dp[u], u});
                dp[u] = dp[v] + w;
                st.insert({dp[u], u});
            }
        }
    }
    return dp[n-1];
}

signed main() {
    fast;
    int n, m, p, task_num;
    cin >> n >> m >> p >> task_num;
    g.resize(n);
    vector<int> w(n);
    for (auto & i : w) cin >> i;
    for (int i = 0; i < m; i++) {
        int u, v, s;
        cin >> u >> v >> s;
        u--;v--;
        g[u].emplace_back(v, s);
    }
    if (task_num == 1) {
        int f = dijkstra(0);
        if (f == INF) {
            cout << "-1";
            return 0;
        }
        cout << max(0ll, f - p);
    } else if (task_num == 2) {
        vector<int> next(n);
        for (int i = 0; i + 1 < n; i++) {
            next[i] = g[i][0].second;
        }
        int ans = 0;
        int mx_prev = 0;
        int st = 0;
        for (int i = 0; i + 1< n; i++) {
            mx_prev = max(w[i], mx_prev);
            if (p - next[i] < 0) {
                ans += (abs(p - next[i]) + mx_prev - 1) / mx_prev;
                int f = (abs(p - next[i]) + mx_prev - 1) / mx_prev;
                p -= next[i];
                p += f * mx_prev;
            }
        }
        cout << ans;
    }
}
