#include<bits/stdc++.h>
using namespace std;
#define MAXN 805
#define INF 10000000000000000
int n,m;
long long p;
struct edge
{
    int to;
    long long s;
    edge(int tt, long long ss)
    {
        to=tt;
        s=ss;
    }
};
vector<edge> v[MAXN];
long long w[MAXN];
long long rzt[MAXN];
priority_queue<pair<long long, int>> qu;
void dijkstra()
{
    for (int q=2;q<=n;q++) rzt[q]=INF;
    rzt[1]=0;
    qu.push(make_pair(0,1));
    while (!qu.empty())
    {
        int tp=qu.top().second;
        long long rt=-1*qu.top().first;
        qu.pop();
        if (rt>rzt[tp]) continue;
        for (int q=0;q<v[tp].size();q++)
        {
            int to=v[tp][q].to;
            long long s=v[tp][q].s;
            if (rt+s<rzt[to])
            {
                rzt[to]=rt+s;
                qu.push(make_pair(-1*rzt[to],to));
            }
        }
    }
}
int g1()
{
    dijkstra();
    if (rzt[n]==INF) cout<<"-1\n";
    else
    {
        if (p>rzt[n]) cout<<"0\n";
        else cout<<rzt[n]-p<<"\n";
    }
    return 0;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int g;
    cin>>n>>m>>p>>g;
    for (int q=1;q<=n;q++) cin>>w[q];
    for (int q=0;q<m;q++)
    {
        int a,b;
        long long s;
        cin>>a>>b>>s;
        edge bb(b,s);
        v[a].push_back(bb);
    }
    if (g==1) return g1();
}
