#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

const int N = 1000;
int n, m, p, gr;
int dist[N], a[N];
vector <vector <pii> > g(N);

void solve1 () {
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        dist[i] = 1e18;
    }

    for (int i = 1; i <= m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        g[u].pb({v, w});
        g[v].pb({u, w});
    }

    set <pii> s;
    s.insert({0, 1});
    dist[1] = 0;
    while (!s.empty()) {
        pii cur = *s.begin();
        s.erase(s.begin());
        int v = cur.S;
        for (auto i : g[v]) {
            int to = i.F, w = i.S;
            if (dist[v] + w < dist[to]) {
                if (s.find({dist[to], to]}) !-= s.end())
                    s.erase({dist[to], to});
                dist[to] = dist[v] + w;
                s.insert({dist[to], to});
            }
        }
    }

    if (dist[n] == 1e18) {
        cout << -1;
        return;
    }
    p -= dist[n];
    if (p < 0) {
        cout << -p;
    }
    else {
        cout << 0;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n >> n >> m >> p >> gr;


    if (gr == 1) {
        solve1();
    }

}

