#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }

inline void solve() {
    int n, m, p, G;
    cin >> n >> m >> p >> G;

    ve<int> a(n);
    for (auto &i : a) cin >> i;

    ve<ve<pii>> gr(n);
    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        gr[--v].pb({--u, w});
    }

    ve<ve<pll>> d(n, ve<pll> (n, mpp(inf, inf)));

    d[0][0] = {0, -p};
    set<pair<pll,pii>> st;
    st.insert({{0, -p}, {0, 0}});

    while (!st.empty()) {
        auto [v, z] = st.begin()->se;
        auto [dist, have] = d[v][z];

        have *= -1;
        st.erase(st.begin());

        if (z != v && d[v][v] > d[v][z]) {
            st.erase({d[v][v], {v, v}});
            d[v][v] = d[v][z];
            st.insert({d[v][v], {v, v}});
        }

        for (const auto &[to, w] : gr[v]) {
            /// have + a[z] * k >= w
            ll k = max(0ll, (w - have + a[z] - 1) / a[z]);

            pll di = { dist + k, -(have + k * 1ll * a[z] - w) };
            if (d[to][z] > di) {
                st.erase({d[to][z], {to, z}});
                d[to][z] = di;
                st.insert({d[to][z], {to, z}});
            }
        }
    }

    ll ans = inf;
    for (int i = 0; i < n; ++i) {
        chmin(ans, d[n - 1][i].fi);
    }

    if (ans == inf) {
        return void(cout << -1);
    }

    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
