#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 1e5 + 1;
void solve() {
	int n, m, bal, group;
	cin >> n >> m >> bal >> group;
	vector<vector<pii>> g(n);
	vector<int> earn(n);
	for (int i = 0; i < n; ++i) cin >> earn[i];
	vector<int>W;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin>>u>>v>>w, u--, v--;
		g[u].push_back({v, w});
		W.push_back(w);
	}
	if(group == 1){
		int ans = 0;
		vector<int>d(n, inf);
		d[0] = 0;
		set<pii>q = {{0, 0}};
		while(!q.empty()){
			int v = q.begin()->second;
			q.erase(q.begin());
			for(auto[u, w]:g[v]){
				if(d[u] > d[v]+w){
					q.erase({d[u], u});
					d[u] = d[v] + w;
					q.insert({d[u], u});
				}
			}
		}
		if(d[n - 1] == inf){
			cout<<-1;
			return;
		}
		cout<<max(0ll, d[n - 1] - bal);
		return;
	}
	if(group == 2){
		int ans = 0, mx = earn[0], i = 1;
		reverse(all(W));
		while(!W.empty()){
			int x = W.back();
			W.pop_back();
			mx = max(mx, earn[i++]);
			if(bal >= x) {
				bal -= x;
				continue;
			}
			int raz = x - bal, cnt = (raz + mx - 1) / mx;
			ans += cnt, bal += cnt * mx - x;
		}
		cout<<ans;
		return;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int _ = 1;
	//cin>>_;
	while (_--) {
		solve();
		cout << '\n';
	}
	return 0;
}
