#pragma GCC optimize("03")
#pragma GCC optimize("unroll-loops")

#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 800 + 1;
int used[10];
vector<vector<pii>> g;
int n;
vector<int> earn;
int ANS = inf;

int best(int v, int bal, int mx, int ans) {
	if (ans >= ANS) return inf;
	if (v == n - 1) {
		ANS = ans;
		return ans;
	}
	int res = inf;
	for (auto[u, w]: g[v]) {
		if (used[u]) continue;
		used[u] = 1;
		int wasbal = bal, wasans = ans;
		if (bal < w) {
			int r = w - bal;
			int cnt = (r + mx - 1) / mx;
			ans += cnt;
			bal += cnt * mx;
		}
		bal -= w;
		if (ans < res)
			res = min(res, best(u, bal, max(mx, earn[u]), ans));
		bal = wasbal, ans = wasans;
		used[u] = 0;
	}
	return res;
}

int vis[maxn];

void dfs(int v = 0){
	vis[v] = 1;
	for (auto[u, w]: g[v]) {
		if (!vis[u]) dfs(u);
	}
}

void solve() {
	int m, bal, group;
	cin >> n >> m >> bal >> group;
	g.resize(n), earn.resize(n);
	for (int i = 0; i < n; ++i) cin >> earn[i];
	vector<int> W;
	for (int i = 0; i < m; ++i) {
		int u, v, w;
		cin >> u >> v >> w, u--, v--;
		g[u].push_back({v, w});
		W.push_back(w);
	}
	dfs();
	if (!vis[n - 1]) {
		cout << -1;
		return;
	}
	if (group == 1) {
		int ans = 0;
		vector<int> d(n, inf);
		d[0] = 0;
		set<pii > q = {{0, 0}};
		while (!q.empty()) {
			int v = q.begin()->second;
			q.erase(q.begin());
			for (auto[u, w]: g[v]) {
				if (d[u] > d[v] + w) {
					q.erase({d[u], u});
					d[u] = d[v] + w;
					q.insert({d[u], u});
				}
			}
		}
		if (d[n - 1] == inf) {
			cout << -1;
			return;
		}
		cout << max(0ll, d[n - 1] - bal);
		return;
	}
	if (group == 2) {
		int ans = 0, mx = earn[0], i = 1;
		reverse(all(W));
		while (!W.empty()) {
			int x = W.back();
			W.pop_back();
			if (bal < x) {
				int raz = x - bal, cnt = (raz + mx - 1) / mx;
				ans += cnt, bal += cnt * mx;
			}
			bal -= x, mx = max(mx, earn[i++]);
		}
		cout << ans;
		return;
	}
	if (group == 3 || group == 0) {
		used[0] = 1;
		int x = best(0, bal, earn[0], 0);
		if (ANS == inf)cout << -1;
		else cout << ANS;
		return;
	}
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int _ = 1;
	//cin>>_;
	while (_--) {
		solve();
		cout << '\n';
	}
	return 0;
}
