#include <bits/stdc++.h>
#pragma GCC optimize("O3,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution<ll> uid;
    return abs(uid(rng)) % n;
}

const ll INF = 1e17;
ll w[810];
ll dist[810][810];

void solve() {
    int n, m; ll p; int T;
    cin >> n >> m >> p >> T;
    bool flag1 = true, flag2 = (m == n - 1);
    for (int i = 0; i < n; i++) {
        cin >> w[i];
        if (w[i] != 1)
            flag1 = false;
    }
    for (int i = 0; i < n; i++)
        for (int j = 0; j < n; j++)
            if (i != j)
                dist[i][j] = INF;
    for (int i = 0; i < m; i++) {
        int a, b; ll x;
        cin >> a >> b >> x;
        a--, b--;
        if (a != i || b != i + 1)
            flag2 = false;
        dist[a][b] = min(dist[a][b], x);
    }
    for (int k = 0; k < n; k++)
        for (int i = 0; i < n; i++)
            for (int j = 0; j < n; j++)
                dist[i][j] = min(dist[i][j], dist[i][k] + dist[k][j]);
    if (dist[0][n - 1] == INF) {
        cout << -1 << endl;
        return;
    }
    if (flag1) {
        cout << max(0LL, p - dist[0][n - 1]) << endl;
        return;
    }
    if (flag2) {

        return;
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    // cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
