#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

const ll mod = 998244353;

const ll INF = 1e18;

vector<vector<pair<ll, ll>>> g;
vector<ll> used, ans;
ll n;

void dfs(ll u) {
    used[u] = 1;
    if (u == n - 1) {
        ans[u] = 0;
        return;
    }
    for (auto [v, c] : g[u]) {
        if (!used[v]) {
            dfs(v);
        }
        if (ans[v] != INF)
            ans[u] = min(ans[v] + c, ans[u]);
    }
}

void solve() {
    ll m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<ll> w(n);
    g.resize(n);
    used.resize(n);
    ans.resize(n, INF);
    for (ll i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (ll i = 0; i < m; i++) {
        ll a, b, s;
        cin >> a >> b >> s;
        a--;
        b--;
        g[a].emplace_back(b, s);
    }
    if (gr == 1) {
        dfs(0);
        if (ans[0] == INF) {
            cout << -1;
            return;
        }
        cout << max(0ll, ans[0] - p);
        return;
    }
}

int main() {
    srand(time(0));
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    for (; tpk; tpk--) {
        solve();
        cout << '\n';
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}