#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
const int maxn = 800;
const long long inf = 1e18;
long long d[maxn][maxn];
void solve() {
    int n, m, p, gr;
    cin >> n >> m >> p >> gr;
    vector<int> w(n);
    for (int &i: w) cin >> i;
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v, c;
        cin >> u >> v >> c;
        g[u].push_back({ v, c });
    }
    if (gr == 1) {
        vector<int> d(n, inf);
        set<pair<int, int>> s;
        s.insert({ 0, 0 });
        d[0] = 0;
        while (!s.empty()) {
            int v = s.begin()->second;
            s.erase(s.begin());
            for (auto [u, w] : g[v]) {
                if (d[u] > d[v] + w) {
                    s.erase({ d[u], u });
                    d[u] = d[v] + w;
                    s.insert({ d[u], u });
                }
            }
        }
        cout << max(0, d[n - 1] - p);
        return;
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
