#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

struct Edge {
    int from, to;
    ll s;

    Edge() = default;
    Edge(int from, int to, ll s) : from(from), to(to), s(s) {}
};

void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<vector<int>> g(n);
    vector<Edge> e(m);
    vector<int> w(n);
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
    }
    for (int i = 0; i < m; ++i) {
        int v, u, s;
        cin >> v >> u >> s;
        --v; --u;
        g[v].emplace_back(i);
        e[i] = {v, u, s};
    }
    bool gr_2 = true;
    for (int i = 0; i < m; ++i) {
        if (e[i].from != i || e[i].to != i + 1) {
            gr_2 = false;
        }
    }
    if (gr_2) {
        assert(0);
        int mx = w[0];
        ll ans = 0;
        ll now = p;
        for (int i = 0; i < n - 1; ++i) {
            mx = max(mx, w[i]);
            int id = g[i][0];
            ll s = e[id].s;
            if (s > now) {
                ll need = ((s - now) + mx - 1) / mx;
                ans += need;
                now += need * mx;
                now -= s;
            }
        }
        cout << ans << en;
        return;
    }
    if (n <= 10) {
        
    }
    vector<ll> d(n, INFLL);
    d[0] = 0;
    set<pii> q;
    q.emplace(0, 0);
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto i : g[v]) {
            int u = e[i].to;
            ll s = e[i].s;
            if (d[u] > d[v] + s) {
                q.erase({d[u], u});
                d[u] = d[v] + s;
                q.emplace(d[u], u);
            }
        }
    }
    if (d[n - 1] == INFLL) {
        cout << -1 << en;
        return;
    }
    cout << max(0LL, d[n - 1] - p);
}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
