#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';

using namespace std;
using ll = ::int64_t;
const int N = 100;
const ll INF = 1e18;
vector<pair<ll, ll>> g[N];
pair<ll, ll> dp[N][N];
unordered_map<ll, ll> mp;
ll w[N], pm[N];
void solve() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    set<ll> tmp;
    for (int i = 0; i < n; ++i) {
        cin >> w[i];
        tmp.insert(w[i]);
    }
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        a--, b--;
        g[a].emplace_back(b, s);
    }
    int c = 0;
    for (int x : tmp) {
        pm[c] = x;
        mp[x] = c++;
    }
    for (int v = 0; v < n; ++v) {
        for (int x = 0; x < c; ++x) dp[v][x] = {INF, INF};
    }
    for (int i = 0; i < n; ++i) w[i] = mp[w[i]];
    dp[0][w[0]] = {0, p};
    set<tuple<ll, ll, ll, ll>> s;
    s.emplace(0, p, 0, w[0]);
    while (!s.empty()) {
        auto it = s.begin();
        auto [x, cur, v, pref] = *it;
        s.erase(it);
        for (auto [to, cost] : g[v]) {
            ll d = cur >= cost ? 0 : (cost - cur - 1) / pm[pref] + 1;
            auto np = make_pair(x + d, cur + pm[pref] * d - cost);
            ll npref = max(pref, w[to]);
            if (dp[to][npref] > np) {
                auto [olda, oldb] = dp[to][npref];
                s.erase({olda, oldb, to, npref});
                dp[to][npref] = np;
                s.emplace(np.first, np.second, to, npref);
            }
        }
    }
    ll ans = INF;
    for (int i = 0; i < c; ++i) ans = min(ans, dp[n - 1][i].first);
    cout << (ans == INF ? -1 : ans) << '\n';
}

int main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(27);
#endif
    while (tt--) solve();
    return 0;
}