#include<bits/stdc++.h>

using namespace std;

struct edge
{
    long long ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
    bool operator<(const edge&ed) const
    {
        return dist>ed.dist;
    }
};

struct Point
{
    long long ch,br;
    Point(){};
    Point(long long chi, long long bri)
    {
        ch = chi;
        br = bri;
    }
};

const int maxn = 805;
int n,m,p,g;
int w[maxn];
int c[maxn];
Point dp[maxn];
unsigned long long d[maxn],inf = -1;
vector<edge>v[maxn];

void read()
{
    cin >> n >> m >> p >> g;
    for(int i=1;i<=n;i++) cin >> w[i];
    int x,y,z;
    for(int i=1;i<=m;i++)
    {
        cin >> x >> y >> z;
        if(x+1==y) c[y] = z;
        v[x].push_back({y,z});
    }
}

void dijkstra(int beg)
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    d[beg] = 0;
    q.push({beg,0});
    edge e,nb;
    int sz;
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.dist<=d[e.ver])
        {
            sz = v[e.ver].size();
            for(int i=0;i<sz;i++)
            {
                nb = v[e.ver][i];
                if(e.dist+nb.dist<d[nb.ver])
                {
                    nb.dist += e.dist;
                    d[nb.ver] = nb.dist;
                    q.push(nb);
                }
            }
        }
    }
}

void solve1()
{
    dijkstra(1);
    if(d[n]==inf) cout << -1 << endl;
    else
    {
        if(p>=d[n]) cout << 0 << endl;
        else
        {
            long long res = p;
            res -= d[n];
            cout << (-res) << endl;
        }
    }
}

void solve2()
{
    dp[1].ch = 0;
    dp[1].br = 0;
    for(int i=2;i<=n;i++)
    {
        if(p==0) break;
        if(p>=c[i])
        {
            p -= c[i];
            c[i] = 0;
        }
        else
        {
            c[i] -= p;
            p = 0;
        }
    }
    long long sumc = 0;
    long long pom;
    long long pom2;
    for(int i=2;i<=n;i++)
    {
        dp[i].ch = -1;
        for(int j=i-1;j>=1;j--)
        {
            sumc += c[j+1];
            pom = sumc - dp[j].br;
            pom2 = pom/w[j];
            if(pom%w[j]) pom2++;
            if(dp[i].ch==-1||dp[i].ch>dp[j].ch+pom2||(dp[i].ch==dp[j].ch+pom&&pom%w[j]<dp[i].br))
            {
                dp[i].ch = dp[j].ch+pom;
                dp[i].br = pom%w[j];
            }
        }
    }
    cout << dp[n].ch << endl;
}

void solve()
{
    if(g==1) solve1();
    if(g==2) solve2();
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	solve();
	return 0;
}

