#include<bits/stdc++.h>
using namespace std;

#define int long long

__int128_t inf = 1e33;
vector<int> used;
vector<vector<pair<int, int>>> g;

vector<__int128_t> dj(vector<__int128_t> dst) {
    int n = (int)dst.size();
    set<pair<__int128_t, int>> st;
    vector<__int128_t> res = dst;
    
    for (int i = 0; i < n; i++) {
        if (used[i] && dst[i] != inf) {
            st.insert({dst[i], i});
        }
    }

    while (!st.empty()) {
        auto pr = (*st.begin());
        int d = pr.first, v = pr.second;
        st.erase(st.begin());

        for (auto j :  g[v]) {
            if (used[j.first]) continue;
            if (res[j.first] > d + j.second) {
                st.erase({res[j.first], j.first});
                res[j.first] = d + j.second;
                st.insert({res[j.first], j.first});
            }
        }
    }

    return res;
}

pair<int, int> minn(pair<int, int> a, pair<int, int> b) {
    if (a.first != b.first) return (a.first < b.first ? a : b);
    return (a.second < b.second ? b : a);
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int n, m, p, group;
    cin >> n >> m >> p >> group;

    vector<int> cost;
    vector<pair<int, int>> order;
    used.assign(n, 0);
    g.assign(n, {});
    for (int i = 0; i < n; i++) {
        int w;
        cin >> w;
        cost.push_back(w);

        if (i != 0) {
            order.push_back({w, i});
        }
    }

    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--;
        b--;

        g[a].push_back({b, c});
    }

    sort(order.begin(), order.end());

    vector<int> from = {0};

    int inf2 = 1e18;
    vector<pair<int, int>> dist(n, {inf2, inf2});
    dist[0] = {0, p};

    int min_cnt = inf2;

    int ind = lower_bound(order.begin(), order.end(), pair<int, int>{cost[0] + 1, -1}) - order.begin();
    for (int i = 0; i < n; i++) {
        vector<__int128_t> cur_dist(n, inf);
        for (auto j : from) {
            used[j] = 1;
            if (dist[j].first != inf2) {
                cur_dist[j] = (__int128_t)dist[j].first * cost[j] - dist[j].second;
            }
        }

        auto res = dj(cur_dist);

        if (res[n - 1] < inf) {
            if (res[n - 1] <= 0) {
                min_cnt = 0;
                continue;
            }

            min_cnt = min(min_cnt, (int)((res[n - 1] - 1) / cost[from[0]] + 1));
        }

        for (int i = 0; i < n; i++) {
            if (res[i] == inf) continue;

            if (res[i] < 0) {
                dist[i] = minn(dist[i], {0, -res[i]});
                continue;
            }

            int k1 = ((res[i] - 1) / cost[from[0]] + 1);
            int k2 = k1 * cost[from[0]] - res[i];
            dist[i] = minn(dist[i], {k1, k2});
        }
        
        for (auto j : from) {
            used[j] = 0;
        }

        if (ind == n - 1) break;
        int wstart = order[ind].first;

        from.clear();
        while (ind != n - 1 && order[ind].first == wstart) {
            from.push_back(order[ind++].second);
        }
    }


    cout << (min_cnt == inf2 ? -1 : min_cnt) << endl;
}