#include <bits/stdc++.h>

#define all(x) (x).begin(), (x).end()
#define str to_string
#define pb push_back

using namespace std;
typedef long long ll;
typedef pair<ll, ll> pll;
typedef pair<int, int> pii;
typedef long double ld;

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

template <typename T>
inline ll len(const T& x) {
    return x.size();
}

const int inf = 1e9 + 9;
const ll llinf = 0x3f3f3f3f3f3f3f3f;
const ll MOD = 1e9 + 7;
const int maxN = 800 + 9;
ll w[maxN];
ll d[maxN][maxN];
pll dp[maxN];
bool cmp(const int& a, const int& b) {
    return w[a] < w[b];
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);

    ll n, m, p, kok; cin >> n >> m >> p >> kok;
    for(int i = 1; i <= n; ++i) cin >> w[i];
    memset(d, 0x3f, sizeof(d));
    for(int i = 1; i <= n; ++i) d[i][i] = 0;
    for(int i = 0; i < m; ++i) {
        ll u, v, ew; cin >> u >> v >> ew;
        d[u][v] = min(d[u][v], ew);
    }


    for(int k = 1; k <= n; ++k) {
        for(int i = 1; i <= n; ++i) {
            for(int j = 1; j <= n; ++j) {
                if(d[i][j] > d[i][k] + d[k][j]) {
                    d[i][j] = d[i][k] + d[k][j];
                }
            }
        }
    }

//    if(d[1][n] == llinf) cout << -1 << '\n';
//    else cout << max(0LL, d[1][n] - p) << '\n';



    vector<int> ord(n);
    iota(all(ord), 1);
    sort(all(ord), cmp);
    ll ans = llinf;
    for(auto &i: dp) i = {-1, -1};
    for(auto &v: ord) {
        if(d[1][v] == llinf) continue;
        {
            ll buy = max(0LL, d[1][v] - p + w[1] - 1) / w[1];
            dp[v] = {buy, p + w[1] * buy - d[1][v]};
        }
        for(auto &i: ord) {
            if(i == v) break;
            if(d[i][v] == llinf) continue;
            if(dp[i].first == -1) continue;
            ll buy = max(0LL, d[i][v] - dp[i].second + w[i] - 1) / w[i];
            ll nbuy = dp[i].first + buy;
            ll nsum = dp[i].second + w[i] * buy - d[i][v];
            if(nbuy < dp[v].first || (nbuy == dp[v].first && nsum > dp[v].second)) {
                dp[v] = {nbuy, nsum};
            }
        }
        if(d[v][n] != llinf) {
            ll buy = max(0LL, d[v][n] - dp[v].second + w[v] - 1) / w[v];
            ans = min(ans, dp[v].first + buy);
        }
    }

    if(ans == llinf) cout << -1 << '\n';
    else cout << ans << '\n';
}
/*

4 4 2 0
7 4 3 1
1 2 21
3 2 6
1 3 8
2 4 11

4 4 10 0
1 2 10 1
1 2 20
2 4 30
1 3 25
3 4 89


4 4 7 0
5 1 6 2
1 2 5
2 3 10
3 4 50
3 4 70



4 1 2 0
1 1 1 1
1 3 2


 */