#include <iostream>
#include <iomanip>
#include <set>
#include <vector>
#include <algorithm>
#include <cmath>
#include <tuple>
using namespace std;
typedef long long ll;
typedef long double ld;
struct st {
	ll kol, ost;
};
bool operator<(st a, st b) {
	return tie(a.kol, b.ost) < tie(b.kol, a.ost);
}
ll inf = 1e18;
ll len[800][800], kol[800];
st lenans[800][800];
int main() {
	cin.tie(NULL);
	ios_base::sync_with_stdio(false);
	ll n, m, p, tn; cin >> n >> m >> p >> tn;
	for (int i = 0; i < n; i++) for (int j = 0; j < n; j++) len[i][j] = inf, lenans[i][j] = { inf, -1 };
	for (int i = 0; i < n; i++) cin >> kol[i], len[i][i] = 0;
	for (int i = 0; i < m; i++) {
		ll a, b, c; cin >> a >> b >> c; a--, b--;
		len[a][b] = min(len[a][b], c);
		if (c <= p) lenans[a][b] = min(lenans[a][b], { 0, p - c });
		else {
			ll cnt = (c - p + kol[a] - 1) / kol[a];
			lenans[a][b] = min(lenans[a][b], { cnt, p + kol[a] * cnt - c });
		}
	}
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				len[i][j] = min(len[i][j], len[i][k] + len[k][j]);
			}
		}
	}
	lenans[0][0] = { 0, p };
	for (int k = 0; k < n; k++) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (lenans[i][k].kol == inf || len[k][j] == inf) continue;
				ll cnt = (max(0ll, (len[k][j] - lenans[i][k].ost)) + kol[k] - 1) / kol[k];
				if (lenans[i][j].kol > lenans[i][k].kol + cnt) lenans[i][j] = { lenans[i][k].kol + cnt, cnt * kol[k] + lenans[i][k].ost - len[k][j] };
				else if (lenans[i][j].kol == lenans[i][k].kol + cnt) lenans[i][j].ost = max(lenans[i][j].ost, cnt * kol[k] + lenans[i][k].ost - len[k][j]);
			}
		}
	}
	if (lenans[0][n - 1].kol == inf) cout << -1;
	else cout << lenans[0][n - 1].kol;
	return 0;
}