#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void group1(ll n, ll m, ll p) {
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0, u, v, s; i < m; ++i) {
        cin >> u >> v >> s;
        --u, --v;
        g[u].emplace_back(v, s);
    }
    vector<ll> d(n, 9e18);
    d[0] = 0;
    set<pair<ll, ll>> q;
    q.insert({0, 0});
    while (!q.empty()) {
        auto [dist, u] = *q.begin();
        q.erase(q.begin());
        for (auto [v, w] : g[u]) {
            if (dist + w < d[v]) {
                q.erase({d[v], v});
                d[v] = dist + w;
                q.insert({d[v], v});
            }
        }
    }
    if (d[n - 1] == 9e18) {
        cout << -1;
        return;
    }
    cout << max(0ll, d[n - 1] - p);
}

void group2(ll n, ll m, ll p) {
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }
    vector<vector<pair<ll, ll>>> g(n);
    vector<ll> pref_sum(n);
    pref_sum[0] = 0;
    for (ll i = 0, u, v, s; i < m; ++i) {
        cin >> u >> v >> s;
        --u, --v;
        g[u].emplace_back(v, s);
        pref_sum[i + 1] = pref_sum[i] + s;
    }
    vector<ll> path;
    path.push_back(0);
    for (ll i = 1; i < n - 1; ++i) {
        if (a[i] > a[path.back()]) {
            path.push_back(i);
        }
    }
    path.push_back(n - 1);
    ll cnt = 0;
    for (ll i = 0; i + 1 < path.size(); ++i) {
        ll cost = pref_sum[path[i + 1]] - pref_sum[path[i]];
        if (p >= cost) {
            p -= cost;
        } else {
            ll to_get = cost - p;
            ll add = (to_get + a[path[i]] - 1) / a[path[i]];
            cnt += add;
            p += add * a[path[i]];
            p -= cost;
        }
    }
    cout << cnt;
}

signed main() {
    ll n, m, p, group;
    cin >> n >> m >> p >> group;
    if (group == 1) {
        group1(n, m, p);
    }
    if (group == 2) {
        group2(n, m, p);
    }
    return 0;
}