#include <bits/stdc++.h>
#define int long long
using namespace std;
int n, m, p, g;
const int INF = 1e15 + 228;
void solve_1() // wi = 1
{
    int var;
    for (int i = 0; i < n; ++i)
        cin >> var;

    vector < vector < pair <int, int> > > a(n);

    for (int i = 0; i < m; ++i)
    {
        int ai, bi, si;
        cin >> ai >> bi >> si;
        a[ai - 1].emplace_back(bi - 1, si);
    }
    priority_queue< pair<int, int>> kk;
    vector <int> dist(n, INF);
    kk.emplace(0, 0);
    while(!kk.empty())
    {
        auto now = kk.top();
        kk.pop();
        int v = now.second;
        int d = -now.first;
        if(dist[v] < d)
            continue;
        dist[v] = d;
        for(auto x: a[v])
        {
            kk.emplace(-(d + x.second), x.first);
        }
    }
    if(dist[n - 1] == INF)
    {
        cout << -1;
    }
    else
    {
        cout << max((int)0, dist[n - 1] - p);
    }
}

void solve_2()
{
    vector <int> w(n);
    for(int i = 0; i < n; ++i) {
        cin >> w[i];
        if(i != 0)
            w[i] = max(w[i], w[i - 1]);
    }

    int ans = 0;
    for(int i = 0; i < n - 1; ++i)
    {
        int v1,v2,pr;
        cin >> v1 >> v2 >> pr;
        if(pr <= p)
        {
            p -= pr;
            continue;
        }
        else
        {
            pr -= p;
            p = 0;
        }
        int kol = (pr + w[i] - 1) / w[i];
        ans += kol;
        p += kol * w[i] - pr;
    }
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n >> m >> p >> g;
    if(g == 1)
    {
        solve_1();
    }
    if(g == 2)
    {
        solve_2();
    }
}
