#include <bits/stdc++.h>
#define int long long

using namespace std;
const int inf = LLONG_MAX / 6;

signed main() {
  ios::sync_with_stdio(false);
  cin.tie(nullptr);
#ifdef LOCAL
  freopen("input", "r", stdin);
#endif
  int n, m, p, tt;
  cin >> n >> m >> p >> tt;
  vector<int> W(n);
  for (int i = 0; i < n; i++) {
    cin >> W[i];
  }
  vector<vector<pair<int, int>>> g(n);
  for (int i = 0; i < m; i++) {
    int u, v, w;
    cin >> u >> v >> w;
    u--, v--;
    g[u].emplace_back(v, w);
  }
  if (tt == 1) {
    vector<int> dp(n, inf);
    dp[0] = 0;
    set<pair<int, int>> q;
    q.emplace(0, 0);
    while (!q.empty()) {
      auto [v, d] = *q.begin();
      q.erase(q.begin());
      for (auto &[to, w]: g[v]) {
        int relax = d + w;
        if (relax < dp[to]) {
          q.erase({to, dp[to]});
          dp[to] = relax;
          q.insert({to, dp[to]});
        }
      }
    }
    cout << (dp[n - 1] == inf ? -1 : max(0ll, dp[n - 1] - p));
    return 0;
  }
  if (tt == 2) {
    vector<int> a;
    for (int i = 0; i < n - 1; i++) {
      a.push_back(g[i][0].second);
    }
    int ans = 0;
    int mx = 0;
    for (int i = 0; i < n - 1; i++) {
      mx = max(mx, W[i]);
      p -= a[i];
      if (p < 0) {
        int t = (-p + mx - 1) / mx;
        ans += t;
        p += t * mx;
      }
    }
    cout << ans << '\n';
    return 0;
  }
}