#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef pair<ll,ll> pll;
mt19937_64 gen(1908172);
const ll INF=1e18+2;
const ll N=802;

ve<pll> gr[N];
ll val[N];
pll dist[N][N];

void solve()
{
    ll n,m,p,g;
    cin>>n>>m>>p>>g;

    for(ll i=0;i<n;i++)
        cin>>val[i];

    for(ll i=0;i<m;i++)
    {
        ll a,b,w;
        cin>>a>>b>>w;
        gr[a-1].PB({b-1,w});
    }

    for(ll i=0;i<n;i++)
    {
        for(ll j=0;j<n;j++)
            dist[i][j]={INF,0};
    }

    priority_queue<tuple<ll,ll,ll>> pq;
    dist[0][0]={0,p};
    pq.push({0,0,0});

    while(!pq.empty())
    {
        ll dst,x,t;
        tie(dst,x,t)=pq.top();
        pq.pop();

        auto go = [&](ll v, ll w)
        {
            ll nw=(val[v]>val[t]? v:t);
            ll add=max(0ll,(w-dist[x][t].S+val[t]-1)/val[t]);

            if(dist[v][nw].F>dist[x][t].F+add)
            {
                dist[v][nw].F=dist[x][t].F+add;
                dist[v][nw].S=dist[x][t].S-w+add*val[t];
                pq.push({-dist[v][nw].F,v,nw});
            }
        };

        for(pll i:gr[x])
            go(i.F,i.S);
    }

    ll ans=INF;

    for(ll i=0;i<n;i++)
        ans=min(ans,dist[n-1][i].F);

    cout<<(ans==INF? -1:ans);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
