#include <bits/stdc++.h>
using namespace std;
using ll = long long;

const ll inf = 1e18;

ll myceil(ll a,ll b){
    return (a%b == 0 ? a/b : a/b+1);
}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n,m,p,t;
    cin >> n >> m >> p >> t;
    if(t == 1){
        vector<int> a(n);
        for(int i=0;i<n;++i)
            cin >> a[i];
        vector<vector<pair<int,int> > > g(n);
        while(m--){
            int u,v,x;
            cin >> u >> v >> x;
            --u;
            --v;
            g[u].push_back(make_pair(v,x));
        }
        vector<ll> dist(n,-1);
        priority_queue<pair<ll,int> > q;
        q.push(make_pair(0,0));
        while(!q.empty()){
            auto [d,u] = q.top();
            q.pop();
            if(dist[u] != -1)
                continue;
            dist[u] = -d;
            for(const auto& p:g[u])
                q.push(make_pair(d-p.second,p.first));
        }
        if(dist[n-1] == -1){
            cout << -1 << "\n";
            return 0;
        }
        cout << max(0LL,dist[n-1]-p) << "\n";
        return 0;
    }
    if(t == 2){
        vector<ll> a(n);
        for(ll i=0;i<n;++i)
            cin >> a[i];
        vector<vector<pair<ll,ll> > > g(n);
        while(m--){
            ll u,v,x;
            cin >> u >> v >> x;
            --u;
            --v;
            g[u].push_back(make_pair(v,x));
        }
        ll q = 0;
        ll w = 0;
        for(ll u=0;u<n-1;++u){
            w = max(w,a[u]);
            ll s = myceil(max(0LL,g[u][0].second-p),w);
            q += s;
            p += s*w;
            p -= g[u][0].second;
        }
        cout << q << "\n";
        return 0;
    }
    if(t == 3){
        vector<ll> a(n);
        for(ll i=0;i<n;++i)
            cin >> a[i];
        vector<vector<pair<ll,ll> > > g(n);
        while(m--){
            ll u,v,x;
            cin >> u >> v >> x;
            --u;
            --v;
            g[u].push_back(make_pair(v,x));
        }
        ll q = inf;
        for(ll k=0;k<(1<<(n-2));++k){
            vector<ll> temp;
            for(ll c=0;c<n-2;++c)
                if(k&(1<<c))
                    temp.push_back(c+1);
            do{
                ll v = 0;
                auto b = temp;
                ll p0 = p;
                b.insert(b.begin(),0);
                b.push_back(n-1);
                ll w = 0;
                for(int i=0;i+1<b.size();++i){
                    ll cost = inf;
                    for(const auto& r:g[b[i]])
                        if(r.first == b[i+1])
                            cost = min(cost,r.second);
                    if(cost == inf){
                        v = inf;
                        break;
                    }
                    w = max(w,a[b[i]]);
                    ll s = myceil(max(0LL,cost-p0),w);
                    v += s;
                    p0 += s*w;
                    p0 -= cost;
                }
                q = min(q,v);
            }
            while(next_permutation(temp.begin(),temp.end()));
        }
        cout << (q == inf ? -1 : q) << "\n";
    }
    return 0;
}
