#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define F first
#define S second
#define endl '\n'
#define pb push_back
#define ll long long
#define vi vector <int>
#define pii pair <int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define RFOR(i, a, b) for (int i = a; i >= b; --i)
#define EACH(e, a) for (auto& e : a)
#define pbds tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>
#pragma GCC optimize("O3")
mt19937 rng(228);
#define int long long
const int MAX = 3007;
const ll INFLL = 1e18 + 7;

int n, m, p, tg, w[MAX];
vi g[MAX];
vector <array <int, 3>> edg;


void solve_path() {
    vi st, ct;
    st.pb(0);
    FOR(i, 1, n - 1) {
        if (w[st.back()] < w[i]) {
            int v = st.back(), z = 0;
            while (v != i) z += edg[g[v][0]][2], v = edg[g[v][0]][1];
            st.pb(i), ct.pb(z);
        }
    }
    int v = st.back(), z = 0;
    while (v != n - 1) z += edg[g[v][0]][2], v = edg[g[v][0]][1];
    ct.pb(z);
    int ans = 0;
    FOR(i, 0, sz(ct)) {
        if (p < ct[i]) {
            int d = (ct[i] - p + w[st[i]] - 1) / w[st[i]];
            ans += d, p += w[st[i]] * d;
        }
        p -= ct[i];
    }
    cout << ans;
}

int P, cv, x, bans = INFLL, eid[10];

void relax() {
    vi st, ct; // список позиций рёбер, начала которых выгодны нам, расстояние между этими началами
    st.pb(0);
    FOR(i, 1, P) {
        if (w[edg[eid[i]][0]] > w[edg[eid[st.back()]][0]]) {
            int z = 0;
            FOR(j, st.back(), i) z += edg[eid[j]][2];
            st.pb(i), ct.pb(z);
        }
    }
    int z = 0;
    FOR(j, st.back(), P) z += edg[eid[j]][2];
    ct.pb(z);
    int ans = 0, lt = p;
    FOR(i, 0, sz(ct)) {
        if (lt < ct[i]) {
            int d = (ct[i] - lt + w[edg[eid[st[i]]][0]] - 1) / w[edg[eid[st[i]]][0]];
            ans += d, lt += w[edg[eid[st[i]]][0]] * d;
        }
        lt -= ct[i];
    }
    bans = min(bans, ans);
}

void solve_brute() {
    if (cv == n - 1) {
        relax();
        return;
    }
    if (P == n - 1) return;
    EACH(id, g[cv]) {
        x = cv;
        eid[P++] = id, cv = edg[id][1];
        solve_brute();
        P--, cv = x;
    }
}

signed main() {
    //freopen("input.txt", "r", stdin);
    ios_base::sync_with_stdio(false); cin.tie(0);
    cin >> n >> m >> p >> tg;
    FOR(i, 0, n) cin >> w[i];
    FOR(i, 0, m) {
        int u, v, s; cin >> u >> v >> s, --u, --v;
        g[u].pb(i), edg.pb({u, v, s});
    }
    vi d(n, INFLL);
    set <pii> q;
    d[0] = 0, q.insert({0, 0});
    while (!q.empty()) {
        int v = q.begin()->S;
        q.erase(q.begin());
        EACH(id, g[v]) if (d[edg[id][1]] > d[v] + edg[id][2]) {
            q.erase({d[edg[id][1]], edg[id][1]});
            d[edg[id][1]] = d[v] + edg[id][2];
            q.insert({d[edg[id][1]], edg[id][1]});
        }
    }
    if (d[n - 1] == INFLL) return !(cout << -1);
    if (tg == 1) return !(cout << max(0LL, d[n - 1] - p));
    if (tg == 2) solve_path();
    else {
        solve_brute();
        cout << bans;
    }
}

/* NEVER GIVE UP */
