#include<bits/stdc++.h>

using namespace std;
struct edge
{
    long long v,d;
    edge() {}
    edge(long long _ver,long long _dist)
    {
        v=_ver;
        d=_dist;
    }
    bool operator<(const edge&e)const
    {
        return e.d<d;
    }
};
long long n,m,p,g;
vector<edge> v[1024];
bool subt1=1,subt2=1;
long long w[1024];
void read()
{
    cin>>n>>m>>p>>g;
    if(m!=n-1)subt2=0;
    for(long long i=1; i<=n; i++)
    {
        cin>>w[i];
        if(w[i]!=1)subt1=0;
    }
    for(long long i=1; i<=m; i++)
    {
        long long a,b,x;
        cin>>a>>b>>x;
        if(a!=b-1)subt2=0;
        v[a].push_back({b,x});
    }
}
long long d[1024],used[1024];
void dijkstra()
{
    for(long long i=1; i<=n; i++)
        d[i]=1e18;
    priority_queue<edge> q;
    q.push({1,0});
    d[1]=0;
    while(!q.empty())
    {
        edge t=q.top();
        //cout<<t.v<<" "<<t.d<<endl;
        q.pop();
        if(!used[t.v]&&d[t.v]>=t.d)
        {
            used[t.v]=1;
            for(long long i=0; i<v[t.v].size(); i++)
            {
                edge nb=v[t.v][i];
                if(nb.d+d[t.v]<d[nb.v])
                {
                    d[nb.v]=nb.d+d[t.v];
                    nb.d=d[nb.v];
                    q.push(nb);
                }
            }
        }
    }
}
long long ans=1e18;
void dfs(edge e,long long maxp,int rubli,long long jugle,int cnt)
{
    //cout<<e.v<<" "<<jugle<<" "<<rubli<<" "<<maxp<<endl;
    if(e.v==n)
    {
        ans=min(ans,jugle);
        return;
    }
    if(cnt>m)return;
    for(int i=0; i<v[e.v].size(); i++)
    {
        edge nb=v[e.v][i];
        int need=nb.d;
        if(rubli>=need)dfs(nb,max(maxp,w[nb.v]),rubli-nb.d,jugle,cnt+1);
        else
        {
            need-=rubli;
            int pred=need/maxp;
            if(need%maxp!=0)pred++;
            dfs(nb,max(maxp,w[nb.v]),maxp*pred+rubli-nb.d,jugle+pred,cnt+1);
        }
    }

}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    if(subt1)
    {
        dijkstra();
        if(d[n]==1e18)cout<<-1<<endl;
        else cout<<max(d[n]-p,(long long)(0))<<endl;
        return 0;
    }
    dfs({1,0},w[1],p,0,0);
    if(ans==1e18)cout<<-1<<endl;
    else cout<<ans<<endl;
    return 0;
}
/*
4 4 0 0
1 2 10 1
1 2 20
2 4 30
1 3 25
3 4 10


4 3 7 0
5 1 6 2
1 2 5
2 3 10
3 4 50
*/
