#pragma GCC target("avx2")
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int OO = 1e18;
const int N = 801;
int n, m, p, gr, w[N], D[N];
vec<pii> g[N];
bool used[N];

void dfs(int v, int ost = p, int ans = 0, int mx = w[1])
{
    D[v] = min(D[v], ans);
    used[v] = true;
    for (auto &to : g[v])
    {
        if (used[to.f]) continue;
        int cans = ans;
        int need = max(0ll, (to.s - ost + mx - 1) / mx);
        cans += need;
        int cost = ost + mx * need;
        cost -= to.s;
        dfs(to.f, cost, cans, max(mx, w[to.f]));
    }
    used[v] = false;
}

void solve()
{
    cin >> n >> m >> p >> gr;
    for (int i = 1; i <= n; i++) cin >> w[i];
    int sum = 0;
    for (int i = 0; i < m; i++)
    {
        int u, v, s;
        cin >> u >> v >> s;
        g[u].pb({v, s});
        sum += s;
    }
    if (gr == 2)
    {
        int ans = 0;
        int mx = -OO;
        int cur = p;
        for (int i = 1; i < n; i++)
        {
            mx = max(mx, w[i]);
            int need = max(0ll, (g[i].back().s - cur + mx - 1) / mx);
            ans += need;
            cur += mx * need;
            cur -= g[i].back().s;
        }
        cout << ans;
        return;
    }
    if (gr == 1)
    {
        vec<int> dist(n + 1, OO);
        dist[1] = 0;
        priority_queue<pii, vec<pii>, greater<pii>> pq;
        pq.push({0, 1});
        while (!pq.empty())
        {
            pii cur = pq.top(); pq.pop();
            int dst = cur.f, v = cur.s;
            if (dst > dist[v]) continue;
            for (auto &to : g[v])
            {
                if (dst + to.s < dist[to.f])
                {
                    dist[to.f] = dst + to.s;
                    pq.push({dist[to.f], to.f});
                }
            }
        }
        if (dist[n] == OO) cout << -1;
        else cout << max(0ll, dist[n] - p);
        return;
    }
    if (gr == 0)
    {
        fill(D, D + N, OO);
        dfs(1);
        if (D[n] == OO) cout << -1;
        else cout << D[n];
        return;
    }
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
