#include <bits/stdc++.h>
//#pragma GCC("avx2, avx, 03")
using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()
random_device rd;
mt19937 rnd(rd());
const ll N = 805;
const ll inf = 1e18;
ll n, m, p, g, dist[N][N], w[N];
pair<ll, ll> res[N][N];

void init() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            dist[i][j] = inf;
        }
        dist[i][i] = 0;
    }
}

void upd(ll &x, ll y) {
    x = min(x, y);
}

pair<ll, ll> calc(ll d, ll w, ll days_add, ll add) {
    ll need = max(0ll, d - add);
    ll days = (need + w - 1) / w;
    ll sum = add + days * w;
    ll ost = sum - d;
    return {days + days_add, ost};
}

void init2() {
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (dist[i][j] == inf) {
                res[i][j] = {inf, 0};
                continue;
            }
            res[i][j] = calc(dist[i][j], w[i], 0, ((i == 0) ? p : 0));
        }
    }
}

void upd(pair<ll, ll> &x, const pair<ll, ll> &y) {
    if (x.first == y.first) {
        x = {x.first, max(x.second, y.second)};
    } else if (x.first > y.first) {
        x = y;
    }
}

void krol()


void solve() {
    cin >> n >> m >> p >> g;
    init();
    for (int i = 0; i < n; i++) {
        cin >> w[i];
    }
    for (int i = 0; i < m; i++) {
        ll a, b, c;
        cin >> a >> b >> c, a--, b--;
        upd(dist[a][b], c);
    }

    for (int k = 0; k < n; k++) {
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                upd(dist[i][j], dist[i][k] + dist[k][j]);
            }
        }
    }

    if (dist[0][n - 1] == inf) {
        cout << "-1";
        return;
    }

    init2();
    for (int POS = 0; POS < 3; POS++) {
        for (int k = 0; k < n; k++) {
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    upd(res[i][j], calc(dist[k][j], w[k], res[i][k].first, res[i][k].second));
                }
            }
        }
    }

    cout << res[0][n - 1].first;
}

int main() {
    cin.tie(0), cout.tie(0);
    ios_base::sync_with_stdio(0);
    ll tt = 1;
    //cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}