#include <iostream>
#include "cstdio"
#include "iomanip"
#include "fstream"
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include "map"

using namespace std;
#define map unordered_map
#define ll long long
#define int ll

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}

struct eds{
    int u, s, num;
};

vector<int> w;
vector<vector<eds>> gr;
void main0(){
    int n, m, p, q; cin >> n >> m >> p >> q;
    if (q != 1) return;
    int mn = 1e9;
    vector<int> used(n+1);
    gr.resize(n+1);
    w.resize(n+1);
    for (int i = 1; i <= n; i++) cin >> w[i];
    for (int i = 0; i < m; i++){
        int v; eds e; cin >> v >> e.u >> e.s; e.num = i;
        gr[v].push_back(e);
    }
    set<pair<int, int>> bfs = {{0, 1}};
    while (bfs.size() && (*bfs.begin()).second != n){
        int s = (*bfs.begin()).first, v = (*bfs.begin()).second;
        bfs.erase(bfs.begin());
        //if (used[v]) continue;
        used[v] = 1;
        for (eds e : gr[v]){
            int u = e.u;
            bfs.insert({s + e.s, u});
        }
    }
    if (bfs.size()){
        cout << (*bfs.begin()).first - p;
    } else {
        cout << -1;
    }
}

signed main() {
    speed();
    //cout << fixed << setprecision(10);
    int t = 1;
    while (t--){
        main0();
        cout << '\n';
    }
}