#include <bits/stdc++.h>
using namespace std;

int main() {
    int n, m, p, group;
    cin >> n >> m >> p >> group;
    vector<int> w(n);
    for (int &v : w) {
        cin >> v;
    }
    vector<vector<pair<int, int>>> g(n);
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        g[u].emplace_back(v, c);
        g[v].emplace_back(u, c);
    }
    priority_queue<pair<long long, int>, vector<pair<long long, int>>, greater<>> q;
    q.emplace(0, 0);
    vector<long long> dist(n, LLONG_MAX);
    dist[0] = 0;
    while (!q.empty()) {
        auto [d, u] = q.top();
        q.pop();
        if (d > dist[u]) {
            continue;
        }
        for (auto [v, c] : g[u]) {
            if (dist[u] + c >= dist[v]) {
                continue;
            }
            dist[v] = dist[u] + c;
            q.emplace(c, v);
        }
    }
    cout << dist[n - 1] - p << "\n";
}