#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <vector>
#include <cassert>
#include <algorithm>
#include <set>
#include <map>
#include <queue>
#include <deque>

using namespace std;

#pragma GCC optimize(3)
#pragma GCC optimize("O3")
#pragma GCC target("avx")
#pragma GCC target("avx2")

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pi;

mt19937 rnd(time(NULL));

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define vec vector
#define pb push_back
#define int long long

const int INF = 2e18 + 333, N = 5e5 + 10;

vec<int> w(1e3);
vec<vec<int>> f(1e3, vec<int>(1e3, INF));
int ans2 = INF;
int n, m, p, g;

void pr(vec<int>& pp, vec<bool>& used) {
    if (pp.back() == n - 1) {
        int ans = 0, s = p;
        int maxv = 0;
        for (int i = 0; i < n - 1; ++i) {
            maxv = max(w[pp[i]], maxv);
            int c = f[pp[i]][pp[i + 1]];
            if (c > s) {
                c -= s;
                s = 0;
            }
            else {
                s -= c;
                c = 0;
            }
            int ln = (c + maxv - 1) / maxv;
            s += maxv * ln - c;
            ans += ln;
        }
        ans2 = min(ans, ans2);
        return;
    }
    for (int i = 0; i < n; ++i) {
        if (!used[i] && f[pp.back()][i] != INF) {
            pp.push_back(i);
            used[i] = 1;
            pr(pp, used);
            pp.pop_back();
            used[i] = 0;
        }
    }
}

void solve() {
    cin >> n >> m >> p >> g;
    for (int i = 0; i < n; ++i) cin >> w[i];
    for (int i = 0; i < m; ++i) {
        int a, b, s;
        cin >> a >> b >> s;
        a--; b--;
        f[a][b] = min(f[a][b], s);
    }
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            for (int q = 0; q < n; ++q)
                f[j][q] = min(f[j][q], f[j][i] + f[i][q]);
        }
    }
    if (f[0][n - 1] == INF) {
        cout << -1 << endl;
        return;
    }
    if (g == 1) {
        cout << max(0ll, f[0][n - 1]  - p) << endl;
        return;
    }
    if (g == 2) {
        int ans = 0, s = p;
        int maxv = 0;
        for (int i = 0; i < n - 1; ++i) {
            maxv = max(w[i], maxv);
            if (f[i][i + 1] > s) {
                f[i][i + 1] -= s;
                s = 0;
            }
            else {
                s -= f[i][i + 1];
                f[i][i + 1] = 0;
            }
            int ln = (f[i][i + 1] + maxv - 1) / maxv;
            s += maxv * ln - f[i][i + 1];
            ans += ln;
        }
        cout << ans;
        return;
    }
    if (g == 3 || g == 0) {
        vec<int> a(1);
        vec<bool> used(n);
        used[0] = 1;
        pr(a, used);
        cout << ans2;
        return;
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int t = 1;
    //cin >> t;
    for (; t > 0; --t) {
        solve();
    }
    return 0;
}