#include<bits/stdc++.h>
using namespace std;
const long long maxn = 5005;
struct edge
{
    long long ver;
    long long x;

    edge() {};
    edge( long long ver1, long long x1 )
    {
        ver = ver1;
        x = x1;
    }

    bool operator < ( const edge & e ) const
    {
        return ( x < e.x );
    }
};
long long n,m,p,g;
long long w[maxn];
vector<edge>v[maxn];
unsigned long long d[maxn];
long long lamp = 0;

void djikstra( long long s )
{
    memset(d,-1,sizeof(d));
    priority_queue<edge>q;
    q.push(edge(s,0));
    d[s] = 0;

    while( !q.empty() )
    {
        edge w = q.top();
        q.pop();

        if( w.x <= d[w.ver] )
        {
            long long sz = v[w.ver].size();
            for( long long i = 0; i < sz; i ++ )
            {
                edge nb = v[w.ver][i];
                if( w.x + nb.x < d[nb.ver] )
                {
                    if( nb.ver == n ) lamp = 1;
                    nb.x += w.x;
                    d[nb.ver] = nb.x;
                    q.push(nb);
                }
            }
        }
    }

    //cout << d[n] << endl;
}

void read()
{
    cin >> n >> m >> p >> g;
    for( long long i = 1; i <= n; i ++ )
        cin >> w[i];

    for( long long i = 1; i <= m; i ++ )
    {
        long long a,b,c;
        cin >> a >> b >> c;
        v[a].push_back( edge(b,c) );
        v[b].push_back( edge(a,c) );
    }
}
int main()
{
    read();
    if( g >= 0 )
    {
        djikstra(1);
        if( lamp == 0 )
        {
            cout << -1 << endl;
            exit(0);
        }
        long long ans = d[n] - p;
        if( ans <= 0 ) cout << 0 << endl;
        else cout << ans << endl;
    }
    return 0;
}
