#include<iostream>
#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
long long n,m,pp,g;
long long w[809];
long long a[3009][3009];
long long inf = 1e9+7;
struct edge
{
    int ver;
    int p;
    edge ()
    {
        ver = 0;
        p = inf;
    }
    edge (int v,int _p)
    {
        ver  = v;
        p = _p;
    }
    bool operator <(const edge &e)const
    {
        return (p>e.p);
    }
};
long long d[1000000];
vector<edge>v[1000000];
int used[1000000];
void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
void dijkstra(int s)
{
    memset(d,-1,sizeof(d));
    d[s] = 0;
    memset(used,0,sizeof(used));
    priority_queue<edge>q;
    edge e(s,0);
    q.push(e);
    while(!q.empty())
    {
        e = q.top();
        q.pop();
        if(e.p<=d[e.ver])
        {
            if(!used[e.ver])
            {
                used[e.ver] = 1;
                int sz = v[e.ver].size();
                for(int i=0; i<sz; i++)
                {
                    edge nb = v[e.ver][i];
                    if(e.p+nb.p<d[nb.ver])
                    {
                        nb.p+=e.p;
                        d[nb.ver] = nb.p;
                        q.push(nb);
                    }
                }
            }
        }
    }
}
void read()
{
    cin>>n>>m>>pp>>g;
    for(long long i=1; i<=n; i++)
    {
        cin>>w[i];
    }
    int x,y,z;
    for(long long i=1; i<=m; i++)
    {
        cin>>x>>y>>z;
        v[x].push_back({y,z});
    }
    dijkstra(1);
    if(d[n]==-1)cout<<-1<<endl;
    else
    {
        long long ans = d[n] - pp;
        if(ans<0)cout<<0<<endl;
        else cout<<ans<<endl;
    }

}
int main()
{
    speed();
    read();
    return 0;
}
