#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"
#include "cmath"
#include "iomanip"

using namespace std;

typedef long long ll;
typedef long double ld;


void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void solve() {
    ll n, m, p, G;
    cin >> n >> m >> p >> G;
    vector<ll> w(n);
    for (ll &i: w)
        cin >> i;
    vector<vector<pair<ll, ll>>> g(n);
    for (ll i = 0; i < m; i++) {
        ll a, b, w;
        cin >> a >> b >> w;
        a--;
        b--;
        g[a].push_back({b, w});
    }
    if (G == 1) {
        vector<ll> ans(n, 1e18);
        ans[0] = 0;
        set<pair<ll, ll>> s{{0, 0}};
        while (!s.empty()) {
            auto[d, x] = *s.begin();
            s.erase(s.begin());
            for (auto[j, w]: g[x]) {
                if (ans[j] >= ans[x] + w) {
                    s.erase({ans[j], j});
                    ans[j] = ans[x] + w;
                    s.insert({ans[j], j});
                }
            }
        }
        if (ans[n - 1] == 1e18)
            cout << -1;
        else
            cout << max(0LL, ans[n - 1] - p);
        return;
    }
    ll mx = w[0];
    ll ans = 0;
    for (ll i = 0; i < n; i++) {
        mx = max(mx, w[i]);
        if (g[i][0].second > p) {
            ans += (g[i][0].second - p + mx - 1) / mx;
        }
    }
    cout << ans;


}