#include <bits/stdc++.h>

#define ll long long
#define ld long double

#define pll pair<ll, ll>
#define pii pair<int, int>
#define vll vector<ll>
#define vpl vector<pll>
#define vbo vector<bool>
#define vii vector<int>
#define vpi vector<pii>

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

#define fillv(a) F0R(i, sz(a)){cin>>a[i];}
#define outv(a) F0R(i, sz(a)){cout<<a[i]<<' ';}

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

vector<vpl > graph;
vector<vector<vll>> dist;
vll w;

bool merge(ll v, ll u, ll s) {
    vector<vll > merged_v;
    ll i = 0, j = 0;
    while (i < sz(dist[v]) || j < sz(dist[u])) {
        vll res;
        if (i == sz(dist[v])) {
            res = dist[u][j];
            j++;
        } else if (j == sz(dist[u])) {
            res = dist[v][i];
            if (res[2] < s) {
                ll dt = 0;
                dt += (s - res[2]) / res[1];
                if ((s - res[2]) % res[1] != 0) {
                    dt++;
                }
                res[0] += dt;
                res[2] = dt * res[1] + res[2] - s;
            } else {
                res[2] -= s;
            }
            i++;
        } else {
            vll v1 = dist[v][i], v2 = dist[u][j];
            if (v1[2] < s) {
                ll dt = 0;
                dt += (s - v1[2]) / v1[1];
                if ((s - v1[2]) % v1[1] != 0) {
                    dt++;
                }
                v1[0] += dt;
                v1[2] = dt * v1[1] + v1[2] - s;
            } else {
                v1[2] -= s;
            }
            if (v1[0] < v2[0]) {
                res = v1;
                i++;
            } else {
                res = v2;
                j++;
            }
        }
        res[1] = max(res[1], w[u]);
        while (!merged_v.empty() && merged_v.back()[0] == res[0] && merged_v.back()[1] <= res[1] &&
               merged_v.back()[2] <= res[2]) {
            merged_v.pob();
        }
        merged_v.pub(res);
    }
    bool is_changed = false;
    if (sz(merged_v) == sz(dist[u])) {
        F0R(i, sz(dist[u])) {
            if (dist[u][i][0] != merged_v[i][0] || dist[u][i][1] != merged_v[i][1]) {
                is_changed = true;
                break;
            }
        }
    } else {
        is_changed = true;
    }
    swap(dist[u], merged_v);
    return is_changed;
}

void bfs() {
    set<pll> dq;
    dq.insert({0, 0});
    while (!dq.empty()) {
        pll p = *dq.begin();
        ll v = p.first;
        dq.erase(dq.begin());
        each(u,graph[v]){
            if (merge(v, u.first, u.second)){
                dq.insert({u.first, dist[u.first][0][0]});
            }
        }
    }
}

void solve() {
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    graph.resize(n);
    dist.resize(n);
    w.resize(n);
    F0R(i, n) {
        cin >> w[i];
    }
    dist[0].pub({0, w[0], p});
    F0R(i, m) {
        ll v, u, s;
        cin >> v >> u >> s;
        v--;
        u--;
        graph[v].pub({u, s});
    }
    bfs();
    if (sz(dist[n - 1]) == 0){
        cout << -1;
        return;
    }
    cout << dist[n - 1][0][0];
}

int main() {
    fastio;
    int t = 1; //cin >> t;
    F0R(i, t) {
        solve();
    }
}