#include <bits/stdc++.h>

#define ll long long
#define ld long double

#define pll pair<ll, ll>
#define pii pair<int, int>
#define vll vector<ll>
#define vpl vector<pll>
#define vbo vector<bool>
#define vii vector<int>
#define vpi vector<pii>

#define pub push_back
#define pob pop_back
#define puf push_front
#define pof pop_front

#define sz(a) a.size()
#define all(a) a.begin(),a.end()
#define sor(a) sort(all(a))

#define FOR(i, a, b) for (int i = a; i < b; ++i)
#define F0R(i, b) FOR(i, 0, b)
#define ROF(i, a, b) for (int i = b - 1; i >= a; --i)
#define R0F(i, b) ROF(i, 0, b)
#define each(i, a) for(auto &i : a)

#define fillv(a) F0R(i, sz(a)){cin>>a[i];}
#define outv(a) F0R(i, sz(a)){cout<<a[i]<<' ';}

#define fastio ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0)

using namespace std;

vector<vpl > graph;

vll w;


void solve() {
    ll n, m, p, g;
    cin >> n >> m >> p >> g;
    graph.resize(n);
    w.resize(n);
    F0R(i, n) {
        cin >> w[i];
    }

    F0R(i, m) {
        ll v, u, s;
        cin >> v >> u >> s;
        v--;
        u--;
        graph[v].pub({u, s});
    }
    vll dist(n, 1e16);
    dist[0] = 0;
    set<pll> st;
    st.insert({0, dist[0]});
    while(!st.empty()){
        pll k = *st.begin();
        st.erase(st.begin());
        ll v = k.first;
        ll d = k.second;
        each(i, graph[v]){
            ll u = i.first;
            ll s = i.second;
            if (dist[u] > d + s){
                st.erase({u, dist[u]});
                dist[u] = d + s;
                st.insert({u, dist[u]});
            }
        }
    }
    if (dist[n - 1] == 1e16){
        cout << -1;
        return;
    }
    cout << max((ll)0, dist[n - 1] - p);
}

int main() {
    fastio;
    int t = 1; //cin >> t;
    F0R(i, t) {
        solve();
    }
}