#include <bits/stdc++.h>

using namespace std;
using ll = long long;

vector<int> t;
int sz = 1;

void init(int n) {
    sz = 1 << __lg(n) + !!(n & (n - 1));
    t.resize(sz << 1);
}

void modify(int x, int v) {
    x += sz;
    t[x] = max(t[x], v);

    while (x /= 2) {
        t[x] = max(t[x << 1], t[x << 1 | 1]);
    }
}

int rangeMax(int l, int r) {
    int ans = 0;

    for (l += sz, r += sz; l < r; l >>= 1, r >>= 1) {
        if (l & 1) {
            ans = max(ans, t[l++]);
        }

        if (r & 1) {
            ans = max(ans, t[--r]);
        }
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<int> siz(n), mx(n);
    vector<vector<int>> a(n), stk(n);


    for (int i = 0; i < n; ++i) {
        cin >> siz[i];

        a[i].resize(siz[i]);

        for (int& x : a[i]) {
            cin >> x;
            mx[i] = max(mx[i], x);

            if (stk[i].empty() || stk[i].back() < x) {
                stk[i].push_back(x);
            }
        }
    }

    vector<int> ord(n);

    iota(ord.begin(), ord.end(), 0);

    sort(ord.begin(), ord.end(), [&](int i, int j) {
        return mx[i] < mx[j];
    });

    int A = mx[ord.back()];

    init(A + 1);

    for (int i : ord) {
        int best = 0, last = 0;
        int left = stk[i].size();

        for (int x : stk[i]) {
            best = max(best, rangeMax(last, x) + left);
            left -= 1;
        }

        modify(stk[i].back(), best);
    }

    cout << rangeMax(0, A + 1) << '\n';

    return 0;
}
