#ifdef AVEVAD
#define _GLIBCXX_DEBUG
#else
#pragma GCC optimize("Ofast")
#pragma GCC target("sse,sse2,avx,avx2")
#endif

#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
using ll = long long;
template<typename T>
using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const ll INF = 1e18;

int main() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    for (auto &b: a) {
        ll k;
        cin >> k;
        b.resize(k);
        for (ll &e: b) cin >> e;
        vector<ll> b1;
        for (ll e: b) if (b1.empty() || e > b1.back()) b1.push_back(e);
        b = b1;
    }
    sort(a.begin(), a.end(), [](const vector<ll> &a, const vector<ll> &b) -> bool {
        return a.back() < b.back();
    });
    vector<ll> d(n);
    ll pre = 0;
    for (ll i = 0; i < n; i++) {
        d[i] = ll(a[i].size());
        for (ll j = pre; j < i; j++) {
            ll val = d[j] + ll(a[i].end() - upper_bound(a[i].begin(), a[i].end(), a[j].back()));
            if (val > d[i]) pre = j, d[i] = val;//, cout << j << ' ';
        }
        //cout << '\n';
    }
    cout << d.back() << '\n';
}
