#include <bits/stdc++.h>

#define int long long
#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>

using namespace std;

struct SegTree{
    vec<int> t;
    SegTree (int n)
    {
        t.resize(4 * n);
    }

    void update(int v, int vl, int vr, int pos, int val)
    {
        if(vl == vr)
        {
            t[v] = val;
            return;
        }

        int vm = vl + vr >> 1;

        if(pos <= vm)
            update(v * 2 + 1, vl, vm, pos, val);
        else
            update(v * 2 + 2, vm + 1, vr, pos, val);
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int get(int v, int vl, int vr, int l, int r)
    {
        if(vl > r || vr < l)
            return 0;
        if(l <= vl && vr <= r)
            return t[v];
        int vm = vl + vr >> 1;

        return max(get(v * 2 + 1, vl, vm, l, r), get(v * 2 + 2, vm + 1, vr, l, r));
    }
};

void solve()
{
    int n;
    cin >> n;
    vec<vec<int>> a (n);
    vec<vec<int>> saved (n);
    vec<pii> maxa (n);
    int MAXA = 0;
    FOR(i, n)
    {
        int k;
        cin >> k;
        a[i].resize(k);
        for(auto &x : a[i])
            cin >> x;
        maxa[i].f = *max_element(all(a[i]));
        maxa[i].s = i;
        MAXA = max(MAXA, maxa[i].f);

        int last = 0;
        for(auto x : a[i])
            if(last < x)
            {
                saved[i].pb(x);
                last = x;
            }
    }

    sort(all(maxa), [&](pii x, pii y){
        if(x.f < y.f)
        {
            return 1;
        }
        return 0;
    });

    vec<int> dp (MAXA + 1, 0);
    SegTree T (MAXA + 1);

    FOR(i, n)
    {
        int ind = maxa[i].s;
        int curmx = *max_element(all(a[ind]));
        int opt = 0;
        int cntsuff = sz(saved[i]);

        for(auto x : saved[i])
        {
            int dpmx = T.get(0, 0, MAXA, 0, x - 1);
            opt = max(opt, dpmx + cntsuff);
            cntsuff--;
        }

        if(dp[curmx] < opt)
        {
            T.update(0, 0, MAXA, curmx, opt);
        }
        dp[curmx] = max(dp[curmx], opt);
    }

    cout << *max_element(all(dp));
}

/**

4
5
4 9 4 6 8
1
7
2
8 6
1
1


*/

signed main() {
    int q = 1;
    //cin >> q;

    while(q--)
    {
        solve();
    }
}

