#include <iostream>
#include<algorithm>
#include<bitset>
#include<cassert>
#include<cmath>
#include<complex>
#include<ctime>
#include<deque>
#include<iomanip>
#include<iterator>
#include<list>
#include<map>
#include<queue>
#include<random>
#include<set>
#include<string>
#include<tuple>
#include<unordered_map>
#include<unordered_set>
#include<vector>

#define int int_fast64_t
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

template<typename T>
bool assign_min(T &a, T b) {
    if (b < a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T>
bool assign_max(T &a, T b) {
    if (b > a) {
        a = b;
        return true;
    }
    return false;
}

template<typename T, typename F>
std::istream& operator>>(std::istream& in, std::pair<T, F> p) {
    return in >> p.first >> p.second;
}

template<typename T>
void input(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cin >> a[i];
}

template<typename T>
void output(std::vector<T> &a, int l = 0) {
    for (int i = l; i<(int)a.size(); ++i) std::cout << a[i] << " ";
    std::cout << '\n';
}

using namespace std;
const int inf = 1e18, MAXN = 2e5+10, mod = 998244353, mod1 = 1e9+7, mod2 = 1e9+1011;
const long double eps = 1e-9;

void solve() {
    int n; cin >> n;
    vector<vector<int>> a(n), ind(MAXN);
    for (int i = 0; i<n; ++i) {
        int k; cin >> k;
        int lst = 0;
        for (int j = 0; j<k; ++j) {
            int cur; cin >> cur;
            if (cur > lst) {
                a[i].emplace_back(cur);
                lst = cur;
            }
        }
        ind[a[i].back()].emplace_back(i);
    }
    vector<int> dp(MAXN);
    for (int i = 0; i<MAXN; ++i) {
        if (i) dp[i] = dp[i-1];
        for (auto j : ind[i]) {
            for (int k = 0; k<(int)a[j].size(); ++k) {
                int add = (int)a[j].size()-k;
                assign_max(dp[i], dp[a[j][k]-1]+add);
            }
        }
    }
    cout << dp.back() << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t = 1; //cin >> t;
    while (t--) solve();
    return 0;
}
