#include <iostream>
#include <vector>
#include <algorithm>
#include <stdio.h>
#include <set>
#include <map>
#include <cstring>


#define sc second
#define fr first
#define ll long long
#define ld long double

//#pragma GCC optimize("O3,unroll-loops")
//#pragma GCC optimize("acvx,bmi,bmi2")


using namespace std;

const int N = 200200;

int b[N];
int id[N];
vector<int> a[N];
int conv[N];
set<int> was;
int n, m;

void input(){
    scanf("%d", &n);
    vector<int> cur;
    int k;

    for (int i = 0; i < n; ++i){
        id[i] = i;

        scanf("%d", &k);
        for (int j = 0; j < k; ++j){
            scanf("%d", b + j);
        }
        int last = 0;
        for (int j = 0; j < k; ++j){
            if (b[j] > last){
                was.insert(b[j]);
                a[i].push_back(b[j]);
                last = b[j];
            }
        }
    }
    int I = 1;
    for (auto elem : was){
        conv[elem] = I++;
    }
    for (int i = 0; i < n; ++i){
        for (int j = 0; j < a[i].size(); ++i){
            a[i][j] = conv[a[i][j]];
        }
    }
}
int count(int i, int j){
    int ans = a[i].size();
    int last = a[i].back();
    for (auto song : a[j]){
        if (song > last){
            last = song;
            ++ans;
        }
    }
    return ans;
}

int work1(){
    sort(id, id + n, [](int i, int j){
        return count(i, j) > count(j, i);
    });
    int last = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i){
        for (auto song : a[id[i]]){
            if (song > last){
                ++ans;
                last = song;
            }
        }
    }
    return ans;

}

int work2(){
    sort(id, id + n, [](int i, int j){
        return a[i].back() < a[j].back();
    });
    int last = 0;
    int ans = 0;
    for (int i = 0; i < n; ++i){
        for (auto song : a[id[i]]){
            if (song > last){
                ++ans;
                last = song;
            }
        }
    }
    return ans;
}


int cost(int x, int i){
    int ans = 0;
    for (auto j : a[i]){
        if (j > x){
            ++ans;
        }
    }
    return ans;
}

int cost_(int x, int i){
    if (a[i][0] > x) return a[i].size();
    int l = 0, r = a[i].size();
    while (r - l > 1){
        int m = (r + l / 2);
        if (a[i][m] > x){
            m = r;
        }
        else{
            m = l;
        }
    }
    return a[i].size() - 1 - l;
}

int work3(){
    const int lim = 1000;
    int dp[lim];
    memset(dp, 0, sizeof(dp));
    dp[0] = 0;
    int ans = 0;
    for (int i = 0; i < lim; ++i){
        for (int j = 0; j < n; ++j){
            if (a[j].back() <= i){continue;}
            dp[a[j].back()] = max(dp[a[j].back()], dp[i] + cost(i, j));
        }
    }
    for (int i = 0; i < lim; ++i){
        ans = max(ans, dp[i]);
    }
    return ans;
}


int main(){
    input();
    cout << work3();

}


