#include <bits/stdc++.h>
using namespace std;
const int maxa = 2e5;

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = i;
        int k;
        cin >> k;
        int mx = -1;
        for (int j = 0; j < k; ++j) {
            int x;
            cin >> x;
            if (x > mx) {
                a[i].emplace_back(x);
                mx = x;
            }
        }
    }
    sort(p.begin(), p.end(), [&](const int& A, const int& B) {
         return a[A].back() < a[B].back();
    });
    vector<int> ans(maxa + 1);
    for (const int& i : p) {
        int cur = a[i].size();
        for (int j = 0; j < (int)a[i].size(); ++j) {
            cur = max(cur, ans[a[i][j] - 1] + (int)a[i].size() - j);
        }
        for (int j = a[i].back(); j <= maxa; ++j) {
            ans[j] = max(ans[j], cur);
        }
    }
    cout << ans[maxa] << '\n';
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
#else
    int T = 1;
    // cin >> T;
    while (T--) {
        solve();
    }
#endif // LOCAL

    return 0;
}
