#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#define ft first
#define sd second
#define pb push_back
using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
typedef pair<int,int> pii;

const int N=5e5+228;
const int inf=1e9+1;
const ll Inf=1e18+1;
const int mod=1e9+7;

int k[N],cnt[N],dp[N];
vector<int> v[N];
pii mx[N];

int func(int x, int u){
    int mx=dp[x];
    int it=upper_bound(v[u].begin(),v[u].end(),x)-v[u].begin();
    it=v[u].size()-it;
    return mx+it;
}

void solve(){
    int n;
    cin >> n;
    for(int i=1;i<=n;i++){
        cin >> k[i];
        for(int j=1;j<=k[i];j++){
            int x;
            cin >> x;
            int sz=v[i].size();
            if(sz==0) v[i].pb(x);
            else if(v[i][sz-1]<x) v[i].pb(x);
            mx[i].ft=max(mx[i].ft,x);
        }
        mx[i].sd=i;
    }
    sort(mx+1,mx+n+1);
    int ans=0;
    for(int i=1;i<=n;i++){
        for(int j=mx[i-1].ft+1;j<=mx[i].ft;j++) dp[j]=max(dp[j],dp[j-1]);
        int u=mx[i].ft,it=mx[i].sd;
        int mxi=0;
        if(n<=1000)
            for(int j=0;j<=200000;j++) mxi=max(mxi,func(j,it));
        else{
            int l=0,r=v[it].size()-1;
            while(r-l>3){
                int midl=l+(l+r)/3;
                int midr=r-(l+r)/3;
                if(func(v[it][midl]-1,it)<func(v[it][midr]-1,it)) l=midl;
                else r=midr;
            }
            for(int j=l;j<=r;j++) mxi=max(mxi,func(v[it][j]-1,it));
        }
        dp[u]=max(dp[u],mxi);
        dp[u]=max(dp[u],int(v[it].size()));
    }
    for(int i=1;i<=200000;i++) ans=max(ans,dp[i]);
    cout << ans << endl;
}
int main()
{
    #ifdef LOCAL
    freopen("input.txt","r",stdin);
    freopen("output.txt","w",stdout);
    #endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    solve();
    return 0;
}
