#include <bits/stdc++.h>

using namespace std;
const int MAXN = 2e5 + 10;

inline void solve() {
    int n;
    cin >> n;
    vector <vector <int>> all(MAXN);
    vector <int> cnt(n), mx(n);
    for (int i = 0; i < n; ++i) {
        int x, cur_mx = 0;
        cin >> x;
        while (x--) {
            int val;
            cin >> val;
            if (val > cur_mx) {
                ++cnt[i];
                all[val].push_back(i);
                cur_mx = val;
            }
        }
        mx[i] = cur_mx;
    }
    vector <int> dp(MAXN);
    for (int i = 1; i < MAXN; ++i) {
        dp[i] = max(dp[i], dp[i - 1]);
        for (int j : all[i]) {
            dp[mx[j]] = max(dp[mx[j]], dp[i - 1] + cnt[j]);
            --cnt[j];
        }
    }
    cout << dp.back();
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
    return 0;
}

/*
 4
 5
 4 9 4 6 8
 1
 7
 2
 8 6
 1
 1

 ---------
 4
 2
 3 4
 2
 1 8
 2
 2 8
 2
 7 9


 */