#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

struct seg_tree {
    vector<int> tree;

    seg_tree(int n) : tree(4 * n) {}

    void update(int v, int vl, int vr, int i, int x) {
        if (vl + 1 == vr)
            tree[v] = max(tree[v], x);
        else {
            int m = (vl + vr) / 2;
            if (i < m)
                update(2 * v + 1, vl, m, i, x);
            else
                update(2 * v + 2, m, vr, i, x);
            tree[v] = max(tree[2 * v + 1], tree[2 * v + 2]);
        }
    }

    int get(int v, int vl, int vr, int l, int r) {
        if (l <= vl && vr <= r)
            return tree[v];
        else {
            int m = (vl + vr) / 2;
            int res = 0;
            if (l < m)
                res = max(res, get(2 * v + 1, vl, m, l, r));
            if (m < r)
                res = max(res, get(2 * v + 2, m, vr, l, r));
            return res;
        }
    }
};

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].assing(k, 0);
        for (auto& j : a[i])
            cin >> j;
    }

    vector<vector<int>> b(n);
    for (int i = 0; i < n; ++i)
        for (auto j : a[i])
            if (b[i].empty() || b[i].back() < j)
                b[i].push_back(j);

    auto cmp = [&](const vector<int>& a, const vector<int>& b)->bool {
        return a.back() < b.back();
    };
    sort(all(b), cmp);

    for (auto i : b) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }

    seg_tree dp(n);
    for (int i = 0; i < n; ++i)
        dp.update(0, 0, n, i, b[i].size());
    for (int i = 1; i < n; ++i) {
        int last = 0;
        for (auto j : b[i]) {
            int it = lower_bound(all(b), vector<int>{j}, cmp) - b.begin();
            dp.update(0, 0, n, i, dp.get(0, 0, n, last, it) + (int)(b[i].end() - lower_bound(all(b[i]), j)));
            last = it;
        }
    }
    cout << dp.get(0, 0, n, 0, n) << endl;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}