#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<random>
#include<stack>
#include<deque>
#include<iomanip>

using namespace std;

//#pragma optimize("O3")
//#pragma optimize("avx2")
//#pragma optimize("unrool-loops")

#define int long long

random_device rd;
mt19937 gen(rd());

vector<int> arr[200005];
int dp[200005];
vector<int> nums[200005];

void solve() {
	int n;
	cin >> n;
	for (int i = 0; i < n; i++) {
		int k;
		cin >> k;
		int lx = -1;
		for (int j = 0; j < k; j++) {
			int x;
			cin >> x;
			if (x > lx) {
				arr[i].push_back(x);
				lx = x;
			}
		}
		nums[arr[i].back()].push_back(i);
	}
	dp[0] = 0;
	for (int i = 1; i <= 200000; i++) {
		dp[i] = dp[i - 1];
		if (nums[i].empty())
			continue;
		for (int j : nums[i]) {
			for (int h = 0; h < arr[j].size(); h++) {
				dp[i] = max(dp[i], dp[arr[j][h] - 1] + (int)arr[j].size() - h);
			}
		}
	}
	cout << dp[200000] << '\n';
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//freopen("Text.txt", "r", stdin);
	//freopen("", "w", stdout)

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}