#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 7;

inline void solve1(int n) {
    int max_res = 0;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int &j : a[i])
            cin >> j;
    }
    vector<int> perm(n);
    for (int i = 0; i < n; i++)
        perm[i] = i;
    do {
        int res = 0, max_tr = 0;
        for (int i : perm) {
            for (int j : a[i])
                if (j > max_tr) {
                    res++;
                    max_tr = j;
                }
        }
        max_res = max(max_res, res);
    } while (next_permutation(perm.begin(), perm.end()));
    cout << max_res << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    if (n <= 7)
        solve1(n);
}