#include <bits/stdc++.h>

#define int long long

using namespace std;

const int MOD = 1e9 + 7;

inline void solve1(int n) {
    int max_res = 0;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int &j : a[i])
            cin >> j;
    }
    vector<int> perm(n);
    for (int i = 0; i < n; i++)
        perm[i] = i;
    do {
        int res = 0, max_tr = 0;
        for (int i : perm) {
            for (int j : a[i])
                if (j > max_tr) {
                    res++;
                    max_tr = j;
                }
        }
        max_res = max(max_res, res);
    } while (next_permutation(perm.begin(), perm.end()));
    cout << max_res << "\n";
}

inline void solve2(int n, vector<vector<int>> &a) {
    vector<vector<int>> cnt(n);
    for (int i = 0; i < n; i++) {
        int max_res = 0;
        for (int j : a[i]) {
            if (j > max_res) {
                max_res = j;
                cnt[i].push_back(j);
            }
        }
    }
    bool flag1 = false, flag2 = false;
    for (int i = 0; i < n; i++) {
        if ((int)cnt[i].size() >= 2) {
            cout << 2 << "\n";
            return;
        }
        for (int j : cnt[i]) {
            if (j == 1)
                flag1 = true;
            else if (j == 2)
                flag2 = true;
        }
    }
    cout << flag1 + flag2 << "\n";
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n;
    cin >> n;
    if (n <= 7) {
        solve1(n);
        return 0;
    }
    vector<vector<int>> a(n);
    bool flag2 = true;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int &j : a[i]) {
            cin >> j;
            if (j > 2)
                flag2 = false;
        }
    }
    if (flag2) {
        solve2(n, a);
        return 0;
    }
}