#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

void solve(){
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++){
        int k; cin >> k;
        int mx = 0;
        for (int j = 0; j < k; j++){
            int x; cin >> x;
            if (x > mx) a[i].pb(x);
            mx = max(mx, x);
        }
    }
    sort(all(a), [](vi &a, vi &b){
        return a.back() < b.back();
    });
    vector<int> dp(n, 0);
    for (int i = 0; i < n; i++){
        dp[i] = 1;
        int ind = -1;
        int mx = 0;
        for (int j = 0; j < sz(a[i]); j++){
            while (a[i][j] > a[ind + 1].back()) {
                ind++;
                mx = max(mx, dp[i]);
            }
            dp[i] = max(dp[i], mx + sz(a[i]) - j);
        }
    }
    cout << dp[n - 1] << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while(n--) solve();
}
