#ifndef LOCAL
#   include <bits/stdc++.h>
#   include <ext/pb_ds/assoc_container.hpp>
#   define debug(...)
#endif
typedef long double ld;
using namespace std;

int get1(const vector<int> &A, int last) {
    int  i = -1;
    int n = (int)A.size();
    for (int j = 0; j < n; j++) {
        if (A[j] > last) {
            i = j;
            break;
        }
    }
    if (i == -1) {
        return 0;
    }
    int cnt = 0;
    int mx = (i == 0 ? 0 : *max_element(A.begin(), A.begin() + i));
    for (; i < n; i++) {
        if (A[i] > mx) {
            cnt++;
            mx = A[i];
        }
    }
    return cnt;
}

int get(const vector<int> &A) {
    int cnt = 0;
    int mx = 0;
    for (const int &i : A) {
        if (i > mx) {
            cnt++;
            mx = i;
        }
    }
    return cnt;
}

vector<int> operator+(const vector<int> &A, const vector<int> &B) {
    vector<int> C;
    C.reserve(A.size() + B.size());
    for (const auto &i : A) {
        C.push_back(i);
    }
    for (const auto &i : B) {
        C.push_back(i);
    }
    return C;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    static clock_t START = clock();
    int n;
    cin >> n;
    if (n <= 7) {
        vector<vector<int>> A(n);
        for (int i = 0; i < n; i++) {
            int k;
            cin >> k;
            A[i].resize(k);
            for (int j = 0; j < k; j++) {
                cin >> A[i][j];
            }
        }
        random_device rd;
        mt19937 rnd(rd());
        vector<int> B(n);
        iota(B.begin(), B.end(), 0);
        int ans = 0;
        do {
            shuffle(B.begin(), B.end(), rnd);
            vector<int> res;
            for (int i: B) {
                for (const auto &item: A[i]) {
                    res.push_back(item);
                }
            }
            ans = max(ans, get(res));
        } while (1. * (clock() - START) / CLOCKS_PER_SEC < 0.9);
        cout << ans << "\n";
        return 0;
    }
    vector<vector<int>> A(n);
    vector<int> mx(n);
    map<int, vector<int>> B;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        A[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> A[i][j];
        }
        mx[i] = *max_element(A[i].begin(), A[i].end());
        B[mx[i]].push_back(i);
    }

    int last = 0;
    int ans = 0;
    for (const auto &[x, C] : B) {
        int mxc = 0;
        for (int i : C) {
            mxc = max(mxc, get1(A[i], last));
        }
        ans += mxc;
        last = x;
    }
    cout << ans << "\n";
    return 0;
}
