#include <bits/stdc++.h>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

typedef int64_t ll;
typedef uint64_t ull;

const int INF = 1e9 + 117;

int n;

struct Playlist {
    int n, mx = -1;
    vector<int> a, kf;

    Playlist (vector<int>& _a) {
        for (auto& e : _a) a.push_back(e);
        n = a.size();
        kf.push_back(a[0]);
        mx = a[0];
        for (int i = 1; i < n; ++i) {
            if (a[i] > mx) {
                kf.push_back(a[i]);
                mx = a[i];
            }
        }
    }
};

bool cmp_pls(Playlist& fs, Playlist& sc) {
    return fs.mx < sc.mx;
}

int main() {
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fast();
    cin >> n;
    vector<int> tmp;
    vector<Playlist> pls;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        tmp.resize(k);
        for (auto& e : tmp) cin >> e;
        Playlist playlist_tmp(tmp);
        pls.push_back(playlist_tmp);
    }
    sort(pls.begin(), pls.end(), cmp_pls);
    vector<int> ans(n); // if I take playlist i
    ans[0] = pls[0].kf.size();
    for (int i = 1; i < n; ++i) {
        ans[i] = pls[i].kf.size();
        for (int j = 0; j < i; ++j) {
            int sz = pls[i].kf.end() - upper_bound(pls[i].kf.begin(), pls[i].kf.end(), pls[j].mx);
            ans[i] = max(ans[i], ans[j] + sz);
        }
    }
    int res = 0;
    for (auto& e : ans) res = max(res, e);
    cout << res;
    return 0;
}
