#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 2e3;

vector<int> a[MAXN];
vector<int> b[MAXN];
int k[MAXN];
vector<pll> prs;

struct SegTree {
    vector<int> t;

    SegTree() {
    }

    SegTree(int n) {
        t.rs(n * 4);
    }

    void upd(int v, int l, int r, int x, int val) {
        if (r - l == 1) {
            t[v] = max(t[v], val);
            return;
        }
        int mid = (l + r) >> 1;
        if (x < mid) {
            upd(v * 2 + 1, l, mid, x, val);
        } else {
            upd(v * 2 + 2, mid, r, x, val);
        }
        t[v] = max(t[v * 2 + 1], t[v * 2 + 2]);
    }

    int ask(int v, int l, int r, int ql, int qr) {
        if (ql >= r || l >= qr)return 0;
        if (ql <= l && r <= qr)return t[v];
        int mid = (l + r) >> 1;
        return max(ask(v * 2 + 1, l, mid, ql, qr), ask(v * 2 + 2, mid, r, ql, qr));
    }

};

SegTree dp[2];

void solve() {
    int n;
    cin >> n;
    vector<pii> mxs;
    dp[0] = SegTree(MAXN);

    for (int i = 0; i < n; i++) {
        cin >> k[i];
        a[i].rs(k[i]);
        cin >> a[i];
        int mx = -1;
        for (int j = 0; j < k[i]; j++) {
            if (mx < a[i][j]) {
                mx = a[i][j];
                b[i].pb(mx);
            }
        }
        k[i] = sz(b[i]);
        mxs.pb({b[i].back(), i});
    }
    sort(all(mxs));
    for (int i = 0; i < n; i++) {
        int ind = mxs[i].Y;
        int cur = i & 1;
        int nxt = cur ^ 1;
        dp[nxt] = dp[cur];
        for (int j = 0; j < k[ind]; j++) {
            int cdp = dp[cur].ask(0, 0, MAXN, 0, b[ind][j]);
            dp[nxt].upd(0, 0, MAXN, b[ind].back(), k[ind] - j + cdp);
        }
    }

    cout << dp[n & 1].ask(0, 0, n, 0, MAXN) << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
    int tests = 1;
    //cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
        cout << "______________\n";
#endif
    }
    return 0;
}