#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ull unsigned long long
#define ll long long
#define ld long double
#define x first
#define y second

const ll INF = 1e17 + 2, MOD = 1e9 + 7, MOD1 = 228228227;

random_device rd;
mt19937 rnd(rd());

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        v[i].resize(k);
        for (int &e : v[i]) {
            cin >> e;
        }
    }
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }
    int ans = 0;
    do {
        int cnt = 0, last = 0;
        for (int i : p) {
            for (int j : v[i]) {
                if (j > last) {
                    cnt++;
                    last = j;
                }
            }
        }
        ans = max(ans, cnt);
    } while(next_permutation(p.begin(), p.end()));
    cout << ans;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}
