#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ull unsigned long long
#define ll long long
#define ld long double
#define x first
#define y second

const ll INF = 1e17 + 2, MOD = 1e9 + 7, MOD1 = 228228227, N = 2e5 + 2;

random_device rd;
mt19937 rnd(rd());

void solve_fact(int n, vector<vector<int>> &v) {
    vector<int> p(n);
    for (int i = 0; i < n; i++) {
        p[i] = i;
    }
    int ans = 0;
    do {
        int cnt = 0, last = 0;
        for (int i : p) {
            for (int j : v[i]) {
                if (j > last) {
                    cnt++;
                    last = j;
                }
            }
        }
        ans = max(ans, cnt);
    } while(next_permutation(p.begin(), p.end()));
    cout << ans;
}

void solve_lowa(int n, int max_a, vector<vector<int>> &v) {
    cout << max_a;
}

bool comp(vector<int> a, vector<int> b) {
    if (a[1] == b[1]) {
        return a[0] < b[0];
    }
    return a[1] < b[1];
}

void solve_maxk(int n, vector<vector<int>> &v) {
    for (int i = 0; i < n; i++) {
        if (v[i].size() == 1) {
            v[i].push_back(v[i][0]);
        }
        if (v[i][0] > v[i][1]) {
            v[i][1] = v[i][0];
        }
    }
    sort(v.begin(), v.end(), comp);
    int ans = (v[0][1] > v[0][0]) + 1, last = v[0][1];
    for (int i = 1; i < n; i++) {
        if (v[i][0] > last) {
            ans++;
            last = v[i][0];
        }
        if (v[i][1] > last) {
            ans++;
            last = v[i][1];
        }
    }
    cout << ans;
}

vector<set<int>> g(12);
vector<int> dp;

void dfs(int v, int cnt = 1) {
    dp[v] = cnt;
    for (int e : g[v]) {
        if (dp[e] < cnt + 1) {
            dfs(e, cnt + 1);
        }
    }
}

void solve_a(int n, int max_a, vector<vector<int>> &v) {
    vector<bool> was(11);
    dp.resize(11);
    for (int i = 0; i < n; i++) {
        int m = v[i].size();
        vector<int> ch;
        vector<bool> used(11);
        int last = -1;
        for (int j = 0; j < m; j++) {
            was[v[i][j]] = true;
            if (!used[v[i][j]] && v[i][j] > last) {
                ch.push_back(v[i][j]);
                used[v[i][j]] = true;
                last = v[i][j];
            }
        }
        v[i] = ch;
    }
    for (auto &e : v) {
        for (int i = 0; i < e.size() - 1; i++) {
            g[e[i]].insert(e[i + 1]);
        }
    }
    for (auto &e : v) {
        for (int i = e.back() + 1; i <= 10; i++) {
            if (was[i]) {
                g[e.back()].insert(i);
            }
        }
    }
    int ans = 0;
    for (int i = 1; i <= 10; i++) {
        if (!dp[i]) {
            dfs(i);
        }
    }
    for (int i = 1; i <= 10; i++) {
        ans = max(ans, dp[i]);
    }
    cout << ans;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v(n);
    int max_a = 0, max_k = 0;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        max_k = max(max_k, k);
        v[i].resize(k);
        for (int &e : v[i]) {
            cin >> e;
            max_a = max(max_a, e);
        }
    }
    if ((max_a <= 1000 && n <= 1000) || max_a <= 10) {
        solve_a(n, max_a, v);
        return;
    }
    if (max_k <= 2) {
        solve_maxk(n, v);
        return;
    }
    if (n <= 7) {
        solve_fact(n, v);
        return;
    }
}

signed main() {
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}