#include "bits/stdc++.h"
#include<ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

typedef long long ll;
typedef long double ld;
typedef vector<ll> d1;
typedef vector<d1> d2;
typedef pair<ll, ll> pii;
typedef vector<pii> d1p;
typedef vector<d1p> d2p;
typedef tree<ll, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define stuff ios::sync_with_stdio(0); cin.tie(0);
#define fori(x, n) for(ll i = x; i < n; ++i)
#define forj(x, n) for(ll j = x; j < n; ++j)
#define fork(x, n) for(ll k = x; k < n; ++k)
#define  F first
#define  S second
#define B back()
#define endl "\n"
mt19937 rnd;
#define cur_time chrono::system_clock::now().time_since_epoch().count()
#define pb(a) push_back(a)

bool cmp(d1 &a, d1& b){
    return a.B < b.B;
}

ll get(d1 &dp, ll x){
    ll mx = 0;
    fori(0, x) mx = max(mx, dp[i]);
    return mx;
}

d1 t;

void upd(ll v, ll l, ll r, ll p, ll x){
    if(l == r){
        t[v] = max(t[v], x);
        return;
    }
    ll m = (r+l)/2;
    if(p <= m){
        upd(v*2, l, m, p, x);
    }
    else{
        upd(v*2+1, m+1, r, p, x);
    }
    t[v] = max(t[v*2], t[v*2+1]);
}

ll get(ll v, ll l, ll r, ll ql, ll qr){
    if(l > qr or r < ql) return -1e18;
    if(ql <= l and r <= qr) return t[v];
    ll m = (r+l)/2;
    return max(get(v*2, l, m, ql, qr), get(v*2+1, m+1, r, ql, qr));
}

ll ind(ll v, ll l, ll r, ll p){
    if(l == r) return t[v];
    ll m = (r+l)/2;
    if(p <= m) return ind(v*2, l, m, p);
    else return ind(v*2+1, m+1, r, p);
}

void st(ll v, ll l, ll r, ll p, ll x){
    if(l == r){
        t[v] = x;
        return;
    }
    ll m = (r+l)/2;
    if(p <= m){
        upd(v*2, l, m, p, x);
    }
    else{
        upd(v*2+1, m+1, r, p, x);
    }
    t[v] = max(t[v*2], t[v*2+1]);
}

int main() {
    stuff;
    ll n;
    cin >> n;
    d2 a(n);
    t = d1(4*200001, -1e18);
    fori(0, n) {
        ll k;
        cin >> k;
        a[i].resize(k);
        forj(0, k) cin >> a[i][j];
    }
    d2 b(n);
    fori(0, n){
        b[i].pb(a[i][0]);
        forj(1, a[i].size()){
            if(a[i][j] > b[i].B) b[i].pb(a[i][j]);
        }
    }
    sort(b.begin(), b.end(), cmp);
    st(1, 0, 200000, 0, 0);
    fori(0, n){
        forj(0, b[i].size()) {
            upd(1, 0, 200000, b[i].B, get(1, 0, 200000, 0, b[i][j]-1) + ll(b[i].size()) - j);
        }
    }
    ll mx = -1e18;
    fori(0, n){
        mx = max(mx, b[i].B);
    }
    cout << ind(1, 0, 200000, mx);
}
