#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n;
    struct album {
        in<int> len;
        vector<in<int>> a;

        album() : a(len) {
            int cur_max = 0;
            for (int i = 0; i < len; ++i) {
                cur_max = max(cur_max, (int) a[i]);
                a[i] = cur_max;
            }
            a.resize(unique(a.begin(), a.end()) - a.begin());
        }

        int get_f(int x) {
            return (int) (a.end() - upper_bound(a.begin(), a.end(), x));
        }
    };

    vector<album> albums;
    vector<int> dp;

    solve() : albums(n), dp(n) {
        sort(albums.begin(), albums.end(), [](const auto &x, const auto &y) { return x.a.back() < y.a.back(); });
        for (int i = 0; i < n; ++i) {
            dp[i] = albums[i].get_f(0);
            for (int j = 0; j < i; ++j) {
                dp[i] = max(dp[i], dp[j] + albums[i].get_f(albums[j].a.back()));
            }
        }
        cout << *max_element(dp.begin(), dp.end()) << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t = 1;
    while (t--) {
        solve();
    }
}
