#include<bits/stdc++.h>

#define pb push_back
#define ld long double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

const int N = 2e5 + 10;

struct Fenwick {
    vector<int> t;
    Fenwick(int n) {
        t.resize(n);
    }
    void upd(int i, int val) {
        for (; i < t.size(); i = (i | (i + 1))) {
            t[i] = max(t[i], val);
        }
    }
    int get(int r) {
        int ans = 0;
        for (; r >= 0; r = (r & (r + 1)) - 1) {
            ans = max(ans, t[r]);
        }
        return ans;
    }
};

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<int> mx(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; j++) {
            cin >> a[i][j];
            mx[i] = max(mx[i], a[i][j]);
        }
    }
    vector<int> ord(n);
    iota(ord.begin(), ord.end(), 0);
    Fenwick f(N);
    sort(all(ord), [&](int a, int b){return mx[a] < mx[b];});
    for (auto i : ord) {
        int m = a[i].size();
        vector<int> r(m, -1), dp(m);
        deque<int> q;
        for (int j = 0; j < m; j++) {
            for (int k = j + 1; k < m; k++) {
                if (a[i][j] < a[i][k]) {
                    r[j] = k;
                    break;
                }
            }
            continue;
            while (q.size() > 0 && a[i][q.back()] < a[i][j]) {
                r[q.back()] = j;
                q.pop_back();
            }
            q.pb(j);
        }
        for (int j = 0; j < m; j++) {
            dp[j] = max(dp[j], 1 + f.get(a[i][j] - 1));
            if (r[j] != -1) {
                dp[r[j]] = max(dp[r[j]], dp[j] + 1);
            }
        }
        for (int j = 0; j < m; j++) {
            if (a[i][j] == mx[i]) {
                f.upd(mx[i], dp[j]);
            }
        }
    }
    cout << f.get(N - 1) << endl;
    return 0;
}
