#include <bits/stdc++.h>
using namespace std;

#define int long long
#define pb push_back
#define mp make_pair
#define ld long double
#define all(a) a.begin(), a.end()

const long long INF = 1e18;
const long long MAXN = 3e4 + 1;
const long double EPS = 1e-10;

bool cmp(vector <int> a, vector <int> b) {
    return a[a.size() - 1] < b[b.size() - 1];
}

void solve() {
    int n;
    cin >> n;
    vector <vector <int>> a;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        vector <int> cur;
        int lst = -1;
        for (int j = 0; j < k; j++) {
            int x;
            cin >> x;
            if (x > lst) {
                lst = x;
                cur.pb(x);
            }
        }
        a.pb(cur);
    }
    sort(all(a), cmp);
    //cout << "OK" << endl;

    vector <vector <int>> dp;
    for (int i = 0; i < n + 1; i++) {
        vector <int> tmp(n, 0);
        dp.pb(tmp);
    }
    for (int j = 0; j < n; j++) dp[1][j] = a[j].size();
    for (int i = 2; i <= n; i++) {
        for (int j = i - 1; j < n; j++) {
            int ans = 0;
            for (int k = i - 2; k < j or (k < n and a[k][a[k].size()] == a[j][a[j].size()]); k++) {
                int tmp = dp[i - 1][k];
                int x = (upper_bound(all(a[j]), a[k][a[k].size() - 1]) - a[j].begin());
                if (a[j][x] <= a[k][a[k].size() - 1]) x = a[j].size();
                tmp += a[j].size() - x;
                if (a[j][a[j].size() - 1] < a[k][a[k].size() - 1]) tmp = 0;
                ans = max(ans, tmp);
            }
            dp[i][j] = ans;
        }
    }
    int mx = -1;
    for (int i = 0; i < n; i++) mx = max(mx, dp[n][i]);
    cout << mx << endl;
}

/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1
 */

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(nullptr);
    solve();
}