#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<int> tree(1e6);

int get(int i, int l, int r, int x, int y) {
    if (l >= y || r <= x)
        return 0;
    if (l >= x && r <= y)
        return tree[i];
    return max(get(2 * i + 1, l, (l + r) / 2, x, y), get(2 * i + 2, (l + r) / 2, r, x, y));
}

int upd(int i, int l, int r, int x, int k) {
    if (l > x || r <= x)
        return tree[i];
    if (r - l == 1)
        return tree[i] = max(tree[i], k);
    return tree[i] = max(upd(2 * i + 1, l, (l + r) / 2, x, k), upd(2 * i + 2, (l + r) / 2, r, x, k));
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        vector<int> now(1);
        cin >> now[0];
        for (int j = 1; j < k; j++) {
            int x;
            cin >> x;
            if (x > now.back())
                now.push_back(x);
        }
        swap(now[0], now[now.size() - 1]);
        a[i] = now;
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < n; i++)
        swap(a[i][0], a[i][a[i].size() - 1]);
    for (int i = 0; i < n; i++) {
        int now = 0;
        for (int j = 0; j < a[i].size(); j++)
            now = max(now, (int)a[i].size() - j + get(0, 0, 2e5 + 1, 0, a[i][j]));
        upd(0, 0, 2e5 + 1, a[i].back(), now);
    }
    cout << tree[0];
}