#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <iomanip>

using namespace std;
typedef long long ll;

int n;
vector <int> a[200010];
int ans;

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n;
	for (int i = 1; i <= n; ++i)
	{
		int k;
		cin >> k;
		while (k--)
		{
			int x;
			cin >> x;
			if (a[i].empty() || a[i].back() < x) a[i].push_back(x);
		}
	}

	vector <int> ord;
	for (int i = 1; i <= n; ++i) ord.push_back(i);

	do
	{
		int nans = 0;
		int lst = 0;
		for (auto i : ord)
		{
			for (auto j : a[i])
			{
				if (j > lst)
				{
					lst = j;
					++nans;
				}
			}
		}
		ans = max(ans, nans);
	} while (next_permutation(ord.begin(), ord.end()));

	cout << ans;

	return 0;
}