#include<iostream>
#include<vector>
#include<string>
#include<algorithm>
#include<set>
#include<stack>
#include<queue>

using namespace std;

typedef long long ll;

int main() {
	ll n;
	cin >> n;
	vector<vector<ll>> v(n, vector<ll> (0, 0));
	vector<pair<ll, ll>> mait(n);
	for (ll i = 0; i < n; ++i) {
		ll s;
		cin >> s;
		ll x;
		cin >> x;
		v[i].push_back(x);
		for (ll j = 1; j < s; ++j) {
			cin >> x;
			if (x > *v[i].rbegin()) v[i].push_back(x);
		}
		mait[i] = { *v[i].rbegin(), i };
	}
	sort(mait.begin(), mait.end());
	vector <ll> ans(n, 0);
	ans[0] = v[mait[0].second].size();
	for (ll i = 1; i < n; ++i) {
		ll kan = (ll)v[mait[i].second].size();
		for (ll j = 0; j < v[mait[i].second].size(); ++j) {
			ll l = 0, r = i + 3;
			while (l + 1 < r) {
				ll mid = (l + r) / 2;
				if (mait[mid].first < v[mait[i].second][j]) l = mid;
				else r = mid;
			}
			if (mait[l].first < v[mait[i].second][j] && kan < ans[l] + (ll)v[mait[i].second].size() - j) {
				kan = ans[l] + (ll)v[mait[i].second].size() - j;
			}
		}
		ans[i] = kan;
	}
	cout << ans[n - 1];
}