#include <bits/stdc++.h>

using namespace std;

// #include "debug.h"
// #define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"

#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

int get_kok(const vector<int>& a, const vector<int>& b) {
    int res = 0;
    int mx = INT_MIN;

    for (int x : a) {
        res += umax(mx, x);
    }

    for (int x : b) {
        res += umax(mx, x);
    }

    return res;
}

void solve() {
    int n;
    cin >> n;

    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        a[i].resize(k);
        for (int& x : a[i]) cin >> x;
    }

    vector<int> p(n);
    iota(p.begin(), p.end(), 0);

    sort(p.begin(), p.end(), [&](int x, int y) {
        int kok1 = get_kok(a[x], a[y]);
        int kok2 = get_kok(a[y], a[x]);
        if (kok1 != kok2) return kok1 > kok2;
        return *max_element(a[x].begin(), a[x].end()) < *max_element(a[y].begin(), a[y].end());
    });

    int res = 0;
    int mx = INT_MIN;
    for (int i : p) {
        for (int x : a[i]) {
            res += umax(mx, x);
        }
    }

    cout << res << '\n';
}

/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1
*/

/*
4
2
3 4
2
1 8
2
2 8
2
7 9
*/

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    while (T--) {
        solve();
    }
}