#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <deque>


#pragma GCC optimize("avx")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("179")

using namespace std;

#define int long long




signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n;
    cin >> n;
    vector <deque <int>> all;
    vector <vector <int>> mxp;
    vector <vector <int>> mxl;
    int mxk = -1;
    int mxa = -1;
    for (int i = 0; i < n; i++) {
        int cn;
        cin >> cn;
        int mx = -1;
        mxk = max(mxk, cn);
        all.push_back({});
        vector <vector<int>> pre;
        vector <int> now(cn);
        vector <int> prefm;
        int mxx = -1;
        for (int j = 0; j < cn; j++) {
            int nw;
            cin >> nw;
            mxa = max(mxa, nw);
            mx = max(mx, nw);
            mxx = max(mxx, nw);
            all[i].push_back(nw);
            prefm.push_back(mx);
        }
        for (int j = cn - 1; j > -1; j--) {
            int nw = all[i][j];
            while (pre.size() != 0 and nw <= pre.back()[0]) {
                pre.pop_back();
            }
            if (pre.size() == 0) {
                now[j] = 1;
            }
            else {
                now[j] = now[pre.back()[1]] + 1;
            }
        }
        mxl.push_back(now);
        mxp.push_back(prefm);
        all[i].push_front(mx);
        all[i].push_back(i);
    }
    sort(all.begin(), all.end());
    if (mxa <= 2 or mxk <= 2) {
        int pr = 0;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 1; j < all[i].size() - 1; j++) {
                if (all[i][j] > pr) {
                    ans++;
                    pr = all[i][j];
                }
            }
        }
        cout << ans << "\n";
    }
    else {
        int ans = -1;
        vector <int> dp(n + 1);
        vector <int> mxc(mxa + 1, -1);
        dp[0] = 0;
        mxc[0] = 0;
        for (int i = 1; i <= n; i++) {
            int id = all[i - 1].back();
            int mxn = all[i - 1][0];
            int maa = 0;
            for (int j = 0; j <= mxa; j++) {
                int zn = mxc[j];
                int na = zn;
                if (zn != -1) {
                    int l = -1;
                    int r = all[i - 1].size() - 2;
                    while (l + 1 != r) {
                        int m = (l + r) / 2;
                        if (mxp[id][m] <= j) {
                            l = m;
                        }
                        else {
                            r = m;
                        }
                    }
                    if (r != all[i - 1].size() - 2) {
                        na += mxl[id][r];
                    }
                }
                maa = max(na, maa);
            }
            dp[i] = maa;
            mxc[mxn] = max(mxc[mxn], maa);
            ans = max(ans, maa);
        }
        cout << ans << "\n";
    }
}
