#include<bits/stdc++.h>
#define pb push_back
#define all(A) A.begin(), A.end()
#define de(x) cout << #x << " = " << x << endl;
using namespace std;

const int MAXN = 2e5 + 5;

int N, max_x, dp[MAXN], subtask_4;
vector<vector<int>> A;

int larger(int x, vector<int> &A){
	int l = 0, r = A.size() - 1, ans = 0;
	while(l <= r){
		int m = (l + r) / 2;
		if(A[m] > x){
			ans = m;
			r = m - 1;
		}
		else{
			l = m + 1;
		}
	}
	return A.size() - ans;
}

bool cmp(vector<int> a, vector<int> b){
	return *max_element(all(a)) < *max_element(all(b));
}

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie();
	cin >> N;
	A.resize(N);
	for(auto &v : A){
		int k; cin >> k;
		subtask_4 = max(subtask_4, k);
		v.pb(0);
		for(int i = 0; i < k; i ++){
			int x; cin >> x;
			max_x = max(max_x, x);
			if(v.back() < x){
				v.pb(x);
			}
		}
	}
	if(subtask_4 <= 2){
		sort(all(A), cmp);
		int last = 0, ans = 0;
		for(auto v : A){
			for(auto x : v){
				if(last < x){
					++ ans;
					last = x;
				}
			}
		}
		cout << ans << endl;
		return 0;
	}
	else{
		vector<int> ptr(N);
		for(int curr = 0; curr <= max_x; curr ++){
			for(int i = 0; i < N; i ++){
				auto jump = A[i];
				int next = jump.back();
				if(next <= curr) continue;
				while(ptr[i] < jump.size() && jump[ptr[i]] <= curr){
					ptr[i] ++;
				}
				dp[next] = max(dp[next], dp[curr] + (int)jump.size() - ptr[i]);
			}
		}
		int ans = 0;
		for(int i = 0; i <= max_x; i ++){
			ans = max(ans, dp[i]);
		}
		cout << ans << endl;
		return 0;
	}
}
/**
4
5 4 9 4 6 8
1 7
2 8 6
1 1

4
2 3 4
2 1 8
2 2 8
2 7 9

*/