#include <iostream>
#include <algorithm>
#include <cmath>
#include <vector>
#include <cstring>
#include <cstdlib>
#include <map>
#include <unordered_map>
#include <set>
#include <iomanip>

using namespace std;

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define sqr(x) (x)*(x)
#define pw(x) (1LL << x)

const int A = 1000 + 5;
int n, dp[A][A];
vector<vector<int> > a;
int max_a;

main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    cin >> n;
    a.resize(n);
    for(int i = 0; i < n; i ++){
        int m;
        cin >> m;
        int ma = -1;
        for(int j = 0; j < m; j ++){
            int x;
            cin >> x;
            if (x > ma){
                ma = x;
                a[i].push_back(x);
            }
        }
        max_a = max(max_a, ma);
    }

    if (n <= 7){
        int ans = 0;
        vector<int> q(n);
        for(int i = 0; i < n; i ++)
            q[i] = i;
        do{
            int now = 0, ma = -1;
            for(int i = 0; i < n; i ++){
                for(int j = 0; j < sz(a[q[i]]); j ++){
                    if (a[q[i]][j] > ma){
                        ma = a[q[i]][j];
                        now ++;
                    }
                }
            }
            ans = max(ans, now);
        } while(next_permutation(all(q)));

        return cout << ans, 0;
    }

    if (max_a <= 2){
        bool has1, has2;
        has1 = has2 = false;
        for(int i = 0; i < n; i ++){
            if (a[i][0] == 1)
                has1 = true;
            if (sz(a[i]) > 1 || a[i][0] == 2)
                has2 = true;
        }

        return cout << 1 + (has1 && has2), 0;
    }

//    for(int i = 0; i < n; i ++)
//        dp[a[i][sz(a[i]) - 1]][a[i][sz(a[i]) - 1]] = 1;


//    for(int i = 1; i < A; i ++){
//        for(int j = 1; j + i < A; j ++)
//            dp[j][j + i] = dp[j][j + i - 1] + dp[j + 1][j + i];
//    }


//    for(int i = 1; i <= 10; i ++){
//        for(int j = 1; j <= 10; j ++)
//            cout << dp[i][j] << ' ';
//        cout << '\n';
//    }

}
