#include <bits/stdc++.h>

using namespace std;

#define int long long
#define all(a)  a.begin(), a.end()
#define rall(a)  a.rbegin(), a.rend()
#define sz(a) ((int)a.size())

random_device rd;

const long long mod = 1e9 + 7;
const long long inf = 9099999999999999999;
const long long nmax = 2e5 + 100;

struct ms{
    int x, y, k;
};

void solve() {
    int n;
    cin >> n;
    vector <vector <int>> arr(n);
    vector <int> mx;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        while (k--) {
            int x;
            cin >> x;
            if (arr[i].empty() || arr[i].back() < x)
                arr[i].emplace_back(x);
        }
        mx.push_back(arr[i].back());
    }
    sort(all(mx));

    vector <ms> p(n);
    for (int i = 0; i < n; i++) {
        int u = 0;
        for (int j = 0; j < sz(arr[i]); j++) {
            u = max(u, lower_bound(all(mx), arr[i][j]) - mx.begin() + sz(arr[i]) - j - 1);
        }
        p[i] = {arr[i].back(), i, u};
    }

    sort(all(p), [](ms a, ms b) {
        return a.x < b.x || (a.x == b.x && a.k < b.k);
    });

    int res = 0, mxx = -1;
    for (int i = 0; i < n; i++) {
        for (auto x : arr[p[i].y]) {
            if (x > mxx) {
                res++;
                mxx = x;
            }
        }
    }
    cout << res;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    int t = 1;
//    cin >> t;
    while (t--)
        solve();
    return 0;
}
