#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define f(n) for(int i = 0; i < n; ++i)
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define pb push_back
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>


typedef long long ll;
typedef vector<int> vei;
typedef string str;

const int MXN = 200001;

void solve() {
    int n;
    cin>>n;
    vector<vector<int>> a(n);
    f(n) {
        int s;
        cin>>s;
        a[i].resize(s);
        for(int j = 0; j < s; ++j) cin>>a[i][j];
    }
    vector<int> dp(MXN);
    vector<vector<int>> ends(MXN);
    f(n){
        int mx = 0;
        for(auto e : a[i]) mx = max(mx, e);
        ends[mx].pb(i);
    }
    for(int i = 1; i < MXN; ++i) {
        dp[i] = dp[i-1];
        for(auto e : ends[i]) {
            int pl = 0;
            int mx = 0;
            for(auto k : a[e]) {
                if(k>mx) pl++;
                mx = max(mx, k);
            }
            mx = 0;
            for(int j = 0; j < a[e].size(); ++j) {
                if(a[e][j] > mx) {
                    pl--;
                    mx = a[e][j];
                }
                dp[i] = max(dp[i], dp[mx-1] + pl + 1);
            }
        }
    }
    cout<<dp[MXN-1];
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    int tc = 1;
    // cin>>tc;
    for(int i = 0; i < tc; ++i) {
        // cout << "Test case: " << i+1 << endl;
        solve();
    }
    return 0;
}
