import sys
import queue
input = sys.stdin.readline


def cmp(a, b, x):
    l, r = -1, len(a)
    while r - l > 1:
        m = (r + l) // 2
        if a[m] > b[0] and a[m] > x:
            l = m
        else:
            r = m
    ans = r
    l, r = -1, len(b)
    while r - l > 1:
        m = (r + l) // 2
        if b[m] > x:
            l = m
        else:
            r = m
    ans += r
    l, r = -1, len(b)
    while r - l > 1:
        m = (r + l) // 2
        if b[m] > a[0] and b[m] > x:
            l = m
        else:
            r = m
    ass = r
    l, r = -1, len(a)
    while r - l > 1:
        m = (r + l) // 2
        if a[m] > x:
            l = m
        else:
            r = m
    ass += r
    if ans == ass:
        return a[0] < b[0]
    return ans < ass


def merge(a):
    ans = []
    y = 0
    while a:
        ind = 0
        x = a[0]
        for i in range(1, len(a)):
            if cmp(a[i], x, y):
                ind = i
                x = a[i]
        del a[ind]
        ans.append(x)
        y = max(y, x[0])
    return ans


def solve():
    a = [[] for i in range(200000)]
    used = [0 for i in range(200000)]
    m = []
    n = int(input())
    for i in range(n):
        ml = int(input())
        w = list(map(int, input().split()))
        b = []
        x = 0
        for j in w:
            if j > x:
                x = j
                b.append(j - 1)
                used[j - 1] = 1
        for j in range(len(b) - 1):
            a[b[j]].append((b[-1], len(b) - j - 1))
        m.append(b[-1])
    m.sort()
    for i in range(200000):
        if used[i]:
            for j in m:
                if j < i:
                    a[j].append((i, 1))
                else:
                    break
    dist = [0 for i in range(200000)]
    for i in range(200000):
        for j in a[i]:
            dist[j[0]] = max(dist[j[0]], dist[i] + j[1])
    print(max(dist) + 1)


solve()
