import sys
input = sys.stdin.readline


def cmp(a, b):
    if a[-1] != b[-1]:
        return a[-1] < b[-1]
    l, r = -1, len(a)
    while r - l > 1:
        m = (r + l) // 2
        if a[m] > b[-1]:
            r = m
        else:
            l = m
    ans = len(a) - r + len(b)
    l, r = -1, len(b)
    while r - l > 1:
        m = (r + l) // 2
        if b[m] > a[-1]:
            r = m
        else:
            l = m
    ass = len(b) - r + len(a)
    return ans < ass


def merge(a):
    if len(a) == 1:
        return a
    m = len(a) // 2
    x = a[:m]
    y = a[m:]
    x = merge(x)
    y = merge(y)
    i, j = 0, 0
    while i < len(x) and j < len(y):
        if cmp(x[i], y[j]):
            a[i + j] = x[i]
            i += 1
        else:
            a[i + j] = y[j]
            j += 1
    while i < len(x):
        a[i + j] = x[i]
        i += 1
    while j < len(y):
        a[i + j] = y[j]
        j += 1
    return a


def solve2(a):
    a = merge(a)
    x = -1
    ans = 0
    for i in range(len(a)):
        for j in a[i]:
            if j > x:
                ans += 1
                x = j
    print(ans)


def solve():
    f = 0
    ff = 0
    a = [[] for i in range(200000)]
    used = [0 for i in range(200000)]
    pos = []
    m = []
    n = int(input())
    for i in range(n):
        ml = int(input())
        if ml > 2:
            f = 1
        w = list(map(int, input().split()))
        b = []
        x = 0
        for j in w:
            if j > x:
                x = j
                b.append(j - 1)
                used[j - 1] = 1
                if j > 10: ff = 1
        for j in range(len(b) - 1):
            a[b[j]].append((b[-1], len(b) - j - 1))
        m.append(b[-1])
        pos.append(b)
    m.sort()
    if f and n > 1000 and ff:
        solve2(pos)
        return
    for i in range(200000):
        if used[i]:
            for j in m:
                if j < i:
                    a[j].append((i, 1))
                else:
                    break
    dist = [0 for i in range(200000)]
    for i in range(200000):
        for j in a[i]:
            dist[j[0]] = max(dist[j[0]], dist[i] + j[1])
    print(max(dist) + 1)


solve()
