#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;


#define int long long

void solve() {
	int n; cin >> n;
	vector <vector <int>> v(n);
	for (int i = 0; i < n; ++i) {
		int k; cin >> k;
		for (int j = 0; j < k; ++j) {
			int x; cin >> x;
			if (v[i].empty() || v[i].back() < x) {
				v[i].push_back(x);
			}
		}
	}
	sort(all(v), [&](const vector <int>& a, const vector <int>& b) {return a.back() < b.back(); });

	vector <int> dp(v.back().back() + 1, 0);
	for (auto& vec : v) {
		int j = vec.size();
		for (int i = vec.back() - 1; i >= 0; --i) {
			while (j > 0 && vec[j - 1] > i) {
				--j;
			}
			dp[vec.back()] = max(dp[vec.back()], dp[i] + ((int)vec.size() - j));
		}
	}

	cout << *max_element(all(dp));
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	//cin >> t;
	while (t--) {
		solve();
		cout << '\n';
	}

	return 0;
}