#include "iostream"
#include "vector"
#include "algorithm"
#include "map"
#include "random"
#include "set"
#include "unordered_map"
#include "unordered_set"
#include "bitset"

using namespace std;

#define ll long long
#define ld long double
//#define all(x) (x).begin(), (x).end()
//#define endl '\n'

const int INF = 1e9;

vector<int> mxs;

bool cmp(int i, int j) {
    return mxs[i] < mxs[j];
}

signed main() {
    //ios_base::sync_with_stdio(false);
    //cin.tie(nullptr); cout.tie(nullptr);
    int n; cin >> n;
    vector<vector<int>> a(n);
    mxs.resize(n, 0);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j) {
            cin >> a[i][j];
            mxs[i] = max(mxs[i], a[i][j]);
        }
    }
    //while (true) {}
    vector<int> order(n);
    for (int i = 0; i < n; ++i) {
        order[i] = i;
    }
    sort(order.begin(), order.end(), cmp);
    vector<int> l;
    for (auto i: order) {
        for (auto el: a[i]) {
            l.push_back(el);
        }
    }
    //vector<int> l = {1, 2, 3, 9, 10, 11, 4, 5, 6, 7};
    int m = l.size();
    vector<int> dp(m + 1, INF);
    dp[0] = -INF;
    for (int i = 0; i < m; ++i) {
        int j = lower_bound(dp.begin(), dp.end(), l[i]) - dp.begin() - 1;
        if (j >= 0 and j + 1 <= m) {
            dp[j + 1] = min(dp[j + 1], l[i]);
        }
    }
    for (int i = m; i >= 0; --i) {
        if (dp[i] != INF) {
            cout << i << '\n';
            break;
        }
    }
}