#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }

typedef pair <int, int> pii;

const int N = 1050;
vector <pii> g[N];
int dp[N];

struct do_ {
    int n; vector <int> t;
    do_ (int n = 0) : n(n), t(4 * n) {}
    inline void upd (int v, int tl, int tr, int pos, int x) {
        if (tl == tr) return void(umax(t[v], x));
        int tm = (tl + tr) >> 1;
        if (pos <= tm) upd(v << 1, tl, tm, pos, x);
        else upd(v << 1 | 1, tm + 1, tr, pos, x);
        t[v] = max(t[v << 1], t[v << 1 | 1]);
    }
    inline int get (int v, int tl, int tr, int l, int r) {
        if (tl > r || l > tr || l > r) return 0;
        if (l <= tl && tr <= r) return t[v];
        int tm = (tl + tr) >> 1;
        return max(get(v << 1, tl, tm, l, r), get(v << 1 | 1, tm + 1, tr, l, r));
    }

    inline void upd (int pos, int x) { upd(1, 0, n - 1, pos, x); }
    inline int get (int l, int r) { return get(1, 0, n - 1, l, r); }
};

inline void solve () {
    int n; cin >> n;
    vector <vector <int>> a (n);
    for (int i = 0; i < n; ++i) {
        int k; cin >> k;
        a[i].resize(k);
        for (int j = 0; j < k; ++j) cin >> a[i][j];
    }

    for (int i = 0; i < n; ++i) {
        int lst = -1;
        int len = 0;
        for (int j = 0; j < sz(a[i]); ++j) {
            if (a[i][j] <= lst) continue;
            lst = a[i][j];
            ++len;
        }
        int mx = lst;
        lst = -1;
        for (int j = 0; j < sz(a[i]); ++j) {
            if (a[i][j] <= lst) continue;
            g[mx].pb({a[i][j], len});
            lst = a[i][j];
            --len;
        }
    }

    for (int i = N - 1; ~i; --i) {
        sort(all(g[i]), [&] (pii a, pii b) { return a.fr < b.fr; });
        for (auto [q, w] : g[i]) {
            for (int ii = q + 1; ii < N; ++ii) {
                umax(dp[q], dp[ii] + w);
            }
        }
    }

    int ans = 0;
    for (int i = 0; i < n; ++i) {
        umax(ans, dp[a[i][0]]);
    }
    cout << ans;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
