#include <bits/stdc++.h>

using namespace std;

//#define int long long
#define ll long long
#define pii pair<int, int>
#define dl long double
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int N;
vector<int> used;
vector<int> t;

void build() {
    N = 1;
    while (N <= maxn)N *= 2;
    t.resize(2 * N);
}

void upd(int i, int x) {
    i += N;
    if (t[i] >= x) return;
    t[i] = x;
    used.push_back(i);
    while (i) {
        i /= 2;
        t[i] = max(t[i * 2], t[i * 2 + 1]);
        used.push_back(i);
    }
}

int get(int lq, int rq, int v = 1, int l = 0, int r = N) {
    if (rq <= l || r <= lq)return 0;
    if (lq <= l && r <= rq)return t[v];
    int m = (l + r) / 2;
    return max(get(lq, rq, v * 2, l, m), get(lq, rq, v * 2 + 1, m, r));
}

void solve() {
    int n;
    cin >> n;
    map<int, vector<vector<int>>> a;
    int mxk = 0, mxa = 0;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        mxk = max(mxk, k);
        vector<int> b(k);
        int mx = 0;
        for (int &x: b)cin >> x, mx = max(mx, x);
        a[mx].push_back(b);
        mxa = max(mxa, mx);
    }
    build();
    if(mxk < 3 || mxa < 3){

        int prev = 0, ans = 0;
        for (auto &[mx, mas]: a) {
            int best = 0;
            for (auto &v: mas) {
                for (int &el: v) {
                    if (el <= prev) continue;
                    int res = get(prev + 1, el) + 1;
                    upd(el, res);
                    best = max(best, res);
                }
                for (int i: used) t[i] = 0;
                used.clear();
            }
            ans += best;
            prev = mx;
        }
        cout<<ans;
        return;
    }
    vector<int>MAX = {0};
    int LEN = sz(a) + 1;
    vector<vector<int>>val(LEN, vector<int>(LEN));
    int ans = 0;
    for (auto &[mx, mas]: a) {
        int ind = 0;
        for (int& prev:MAX) {
            int best = 0;
            for (auto &v: mas) {
                for (int &el: v) {
                    if (el <= prev) continue;
                    int res = get(prev + 1, el) + 1;
                    upd(el, res);
                    best = max(best, res);
                }
                for (int i: used) t[i] = 0;
                used.clear();
            }
            val[sz(MAX)][ind++] = best;
        }
        MAX.push_back(mx);
    }
    vector<int>dp(LEN);
    dp[1] = val[1][0];
    for (int i = 2; i < LEN; ++i) {
        vector<int>new_dp(LEN);
        for (int last = 0; last < i; ++last) {
            new_dp[i] = max(new_dp[i], dp[last] + val[i][last]);
        }
        for (int j = 0; j < LEN; ++j) {
            dp[j] = max(dp[j], new_dp[j]);
        }
    }
    for(int res:dp)ans =max(ans, res);
    cout<<ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}
/*
4
5
4 9 4 6 8
1
7
2
8 6
1
1

 */