#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

vector<int> filter_ai(const vector<int>& ai) {
    vector<int> b;
    b.push_back(ai[0]);
    for (int aij : ai) {
        if (aij > b.back()) {
            b.push_back(aij);
        }
    }
    return b;
}

const int MAX_AI = 2e5 + 100;

void solve() {
    int n, ki;
    cin >> n;

    vector<vector<int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> ki;
        a[i].resize(ki);
        for (int j = 0; j < ki; ++j) {
            cin >> a[i][j];
        }
        a[i] = filter_ai(a[i]);
    }

    sort(a.begin(), a.end(), [](const auto& x, const auto& y) {
        return x.back() < y.back();
    });

    vector<int> dp(MAX_AI);
    for (int i = 0; i < n; ++i) {
        int k = (int) a[i].size();
        dp[a[i].back()] = max(dp[a[i].back()], k);
        for (int j = 0; j < k; ++j) {
            for (int z = 1; z < a[i][j]; ++z) {
                dp[a[i].back()] = max(dp[a[i].back()], dp[z] + k - j);
            }
        }
    }

    cout << *max_element(dp.begin(), dp.end()) << "\n";
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}