#include "bits/stdc++.h"
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;
using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
// gp_hash_table

#define int long long
#define sz(a) (int)(a.size())
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define pii pair<int, int>
#define ll long long
#define ld long double

#ifdef home
#define dbg(x) cout << #x << " = " << (x) << endl
#else
#define dbg(x) 42
#endif

//#pragma GCC optimize("O3")
//#pragma GCC target("avx2")

template <typename T>
istream& operator >> (istream &is, vector<T> &v) {
    for (auto &x : v) is >> x;
    return is;
}

template <typename T>
ostream& operator << (ostream &os, vector<T> v) {
    for (int i = 0; i < sz(v); i++) {
        os << v[i];
        if (i != sz(v) - 1) os << " ";
    }
    return os;
}

mt19937_64 rng (chrono::high_resolution_clock::now().time_since_epoch().count());

int getRandom (int l, int r) {
    return (rng() % (r - l + 1)) + l;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        a[i].resize(k);
        cin >> a[i];
        vector<int> current = {a[i][0]};
        for (int j = 1; j < sz(a[i]); j++) {
            if (current.back() < a[i][j]) current.push_back(a[i][j]);
        }
        a[i] = current;
    }
    sort (all(a), [&] (vector<int> &b, vector<int> &c) {
        return b.back() < c.back();
    });
    vector<int> values;
    for (int i = 0; i < n; i++) {
        values.push_back(a[i].back());
    }
    vector<int> dp(n, 0);
    vector<int> pref(n + 1, 0);
    for (int i = 0; i < n; i++) {
        dp[i] = sz(a[i]);
        for (int j = 0; j < sz(a[i]); j++) {
            int pos = lower_bound(all(values), a[i][j]) - values.begin();
            pos = min(pos, i);
            dp[i] = max(dp[i], pref[pos] + sz(a[i]) - j);
        }
        pref[i + 1] = max(pref[i], dp[i]);
    }
    cout << *max_element(all(dp)) << endl;
}

signed main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    cout << fixed << setprecision(15);
#ifdef home
    freopen("in.txt", "r", stdin);
#endif
    int t = 1;
//    cin >> t;
    while (t--)
        solve();
}

/*
1)Time.
2) Нафарми баллы
3) порешай задачки
4) пофанься
 */