#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define ll long long

using namespace std;
using namespace __gnu_pbds;

#define ordered_set tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update>

bool comp(const vector<ll> &a, const vector<ll> &b) {
    vector<ll> c1 = a;
    for (auto x : b) {
        c1.push_back(x);
    }
    ll p1 = 0;
    ll last = 0;
    for (auto x : c1) {
        if (x > last) {
            p1++;
        }
        last = max(last, x);
    }
    vector<ll> c2 = b;
    for (auto x : a) {
        c2.push_back(x);
    }
    ll p2 = 0;
    last = 0;
    for (auto x : c2) {
        if (x > last) {
            p2++;
        }
        last = max(last, x);
    }
    return p1 < p2;
}

void solve() {
    ll n;
    cin >> n;
    vector<vector<ll>> a(n);
    for (ll i = 0; i < n; i++) {
        ll k;
        cin >> k;
        a[i].resize(k);
        for (ll j = 0; j < k; j++) {
            cin >> a[i][j];
        }
    }
    sort(a.begin(), a.end(), comp);
    reverse(a.begin(), a.end());
    vector<ll> ans;
    for (auto x : a) {
        for (auto y : x) {
            ans.push_back(y);
        }
    }
    ll last = 0;
    ll p = 0;
    for (auto x : ans) {
        if (x > last) {
            p++;
        }
        last = max(x, last);
    }
    cout << p;
}

int main() {
#ifdef LOCAL
    ll clock_time = clock();
#endif
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    ll tpk = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    cin >> tpk;
#endif
    while (tpk--) {
        solve();
        cout << endl;
    }
#ifdef LOCAL
    cout << clock() - clock_time << endl;
#endif
}