#include <bits/stdc++.h>

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<std::vector<int>> input(n);
    for (auto& vec : input) {
        int k;
        std::cin >> k;
        vec.resize(k);

        for (int& i : vec) {
            std::cin >> i;
        }

        for (int i = 1; i < vec.size(); i++) {
            vec[i] = std::max(vec[i], vec[i - 1]);
        }
        vec.erase(std::unique(vec.begin(), vec.end()), vec.end());
    }

    std::sort(input.begin(), input.end(), [&](const auto& a, const auto& b) { return a.back() < b.back(); });

    std::vector<int> all;
    for (auto& vec : input) {
        all.insert(all.end(), vec.begin(), vec.end());
    }
    for (int i = 0; i < 5; i++) {
        all.insert(all.end(), all.begin(), all.end());
    }

    std::vector<int> cum;
    for (int val : all) {
        auto it = std::lower_bound(cum.begin(), cum.end(), val);
        if (it == cum.end()) {
            cum.push_back(val);
        } else {
            *it = val;
        }
    }

    std::cout << cum.size() << "\n";

    return 0;
}
