#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);
const int N = 2e5 + 3;
const int INF = 1e9;

vector<int> formx[N];

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<ordered_set> ors(n);
    set<int> mxses;
    int ind = 0;
    for (auto &v : a) {
        int k;
        cin >> k;
        v.resize(k);
        int mx = 0;
        for (auto &e : v) {
            cin >> e;
            ors[ind].insert(e);
            mx = max(mx, e);
        }
        formx[mx].emplace_back(ind++);
        mxses.insert(mx);
    }

    auto nvp = [&](int st, vector<int>& a) {
        int n = a.size();
        int ans = 0;
        for (auto x : a) {
            if (x > st) {
                ans++;
                st = x;
            }
        }
        return ans;
    };
    vector<int> b = {0};
    for (auto x : mxses)
        b.emplace_back(x);

    vector<int> dp(b.size(), -INF);
    dp[0] = 0;

    vector<int> cur;
    for (int i = 1; i < b.size(); i++) {
        for (auto id : formx[b[i]]) {
            for (int k = max(0ll, i - 800); k <= i - 1; k++) {
                dp[i] = max(dp[i], dp[k] + nvp(b[k], a[id]));
            }
        }
    }
    cout << *max_element(all(dp));
}

signed main() {
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}