#include <bits/stdc++.h>

using namespace std;

const int N = 2e5 + 7;

int n;
int k[N];
vector<int> a[N];
int f[N];

void upd(int i, int x) {
	for (++i; i < N; i += i & -i) {
		f[i] = max(f[i], x);
	}
}

int get(int i) {
	int ret = 0;
	for (; i > 0; i -= i & -i) {
		ret = max(ret, f[i]);
	}
	return ret;
}

int main() {
	ios::sync_with_stdio(false);
	cin.tie(0);
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> k[i];
		a[i].resize(k[i]);
		for (int j = 0; j < k[i]; ++j) {
			cin >> a[i][j];
		}
	}
	vector<int> mx(n);
	for (int i = 0; i < n; ++i) {
		for (int x : a[i]) {
			mx[i] = max(mx[i], x);
		}
	}
	vector<int> ord(n);
	for (int i = 0; i < n; ++i) {
		ord[i] = i;
	}
	sort(ord.begin(), ord.end(), [&](int i, int j) {
		return mx[i] < mx[j];
	});
	int ans = 0;
	for (int i : ord) {
		vector<int> kek;
		for (int x : a[i]) {
			if (kek.empty() || x > kek.back()) {
				kek.push_back(x);
			}
		}
		int cur = 0;
		int sz = kek.size();
		for (int j = 0; j < sz; ++j) {
			cur = max(cur, get(kek[j]) + sz - j);
		}
		ans = max(ans, cur);
		upd(kek.back(), cur);
	}
	cout << ans << endl;
	return 0;
}
