#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
//#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 3e5 + 42;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int get(vector<vector<int>> &a) {
    int ans = 0;
    int mx = 0;
    for(auto x : a) {
        for(auto i : x) {
            ans += mx < i;
            umax(mx, i);
        }
    }
    return ans;
}

int brute(vector<vector<int>> a) {
    int n = sz(a);
    pair<int, vector<vector<int>>> ans = {0, {}};
    sort(all(a));
    do {
        umax(ans, {get(a), a});
    }
    while(next_permutation(all(a)));
    for(auto x : ans.s) {
        for(auto i : x) {
            cout << i << " ";
        }
        cout << '\n';
    }
    return ans.f;
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    for(auto &i : a) {
        int k;
        cin >> k;
        i.resize(k);
        for(auto &j : i) {
            cin >> j;
        }
    }
    vector<pair<pair<int, int>, int>> v;
    for(int i = 0; i < n; i++) {
        vector<vector<int>> curr = {a[i]};
        pair<int, int> val = {*max_element(all(a[i])), get(curr)};
        v.pb({val, i});
    }
    sort(all(v));
    vector<vector<int>> order;
    for(auto [useless, idx] : v) order.pb(a[idx]);
    int ans = get(order);
    cout << ans << '\n';
//    cout << endl;
//    cout << brute(a) << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
