#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
//#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e9;
const int MAX = 2e3 + 5;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

int get(vector<int> &a, int mx) {
    int ans = 0;
    for(auto i : a) {
        ans += mx < i;
        umax(mx, i);
    }
    return ans;
}

int get(vector<vector<int>> &a) {
    int ans = 0;
    int mx = 0;
    for(auto x : a) {
        for(auto i : x) {
            ans += mx < i;
            umax(mx, i);
        }
    }
    return ans;
}

int stress = 1;

void out(vector<vector<int>> a) {
    cout << endl;
    for(auto x : a) {
        for(auto i : x) {
            cout << i << " ";
        }
        cout << '\n';
    }
    cout << endl;
}

int brute(vector<vector<int>> a) {
    int n = sz(a);
    int ans = 0;
    vector<vector<vector<int>>> cand;
    sort(all(a));
    do {
        int v = get(a);
        if(umax(ans, v)) {
            cand.clear();
            cand.pb(a);
        }
        else if(ans == v) cand.pb(a);
    }
    while(next_permutation(all(a)));
    int ok = 0;
    for(auto c : cand) {
        int mn = inf;
        for(auto i : c) umin(mn, *max_element(all(i)));
        int have = *max_element(all(c[0]));
        ok |= have == mn;
    }
//    if(!ok) out(cand[0]);
    if(!stress) out(cand[0]);
    return ans;
}

int my(vector<vector<int>> a) {
    int n = sz(a);
    auto comp1 = [&](vector<int> &f, vector<int> &s) {
        int mxf = *max_element(all(f));
        int mxs = *max_element(all(s));
        vector<vector<int>> curr = {f};
        int vf = get(curr);
        curr[0] = s;
        int vs = get(curr);
        return mp(mxf, 0) < mp(mxs, 0);
    };
    sort(all(a), comp1);
//    if(!stress) out(a);
    int v = *max_element(all(a.back())) + 1;
    vector<vector<int>> dp(n + 1, vector<int>(v));
    for(int i = 0; i < n; i++) {
        int mx = *max_element(all(a[i]));
        for(int j = 0; j < v; j++) {
            umax(dp[i + 1][mx], dp[i][j] + get(a[i], j));
            umax(dp[i + 1][j], dp[i][j]);
        }
    }
    int ans = *max_element(all(dp[n]));
    return ans;
}

/*
3
3  1 10 1
3  6 5 10
1  3
*/

void solve() {
    int n;
    n = 5;
    if(!stress) cin >> n;
    vector<vector<int>> a(n);
    for(auto &i : a) {
        int k;
        k = dis(gen) % 5 + 1;
        if(!stress) cin >> k;
        i.resize(k);
        for(auto &j : i) {
            j = dis(gen) % 10 + 1;
            if(!stress) cin >> j;
        }
    }
    int ans = my(a);
//    int exp = brute(a);
//    if(ans != exp) {
//        cout << n << '\n';
//        for(auto x : a) {
//            cout << sz(x) << "  ";
//            for(auto i : x) cout << i << " ";
//            cout << '\n';
//        }
//        cout << "Incorrect: " << ans << " " << exp << '\n';
//        cout << endl;
//    }
    cout << ans << '\n';
}

signed main() {
    stress = 0;
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    if(stress) cin >> ttt;
    while(ttt--) solve();
}
