#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
#define int long long

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<pair<int, int>> b(n);
    int k, x;
    for (int i = 0; i < n; i++) {
        cin >> k;
        a[i].resize(k);
        x = 0;
        for (auto &j: a[i]) cin >> j, x = max(x, j);
        b[i] = {x, i};
    }
    sort(b.begin(), b.end());
    int cnt = 0, cur = 0, cur2, cnt2, best;
    for (int i = 1; i < n; i++) {
        if (b[i].ff > b[i - 1].ff) {
            int j = i - 1;
            best = 0;
            while (j >= 0 && b[j].ff == b[i - 1].ff) {
                cur2 = cur;
                cnt2 = 0;
                for (auto &t: a[b[j].ss])
                    if (t > cur2) {
                        cur2 = t;
                        cnt2++;
                    }
                best = max(best, cnt2);
                j--;
            }
            cnt += best;
            cur = b[i - 1].ff;
        }
    }
    int j = n - 1;
    best = 0;
    while (j >= 0 && b[j].ff == b[n - 1].ff) {
        cur2 = cur;
        cnt2 = 0;
        for (auto &t: a[b[j].ss])
            if (t > cur2) {
                cur2 = t;
                cnt2++;
            }
        best = max(best, cnt2);
        j--;
    }
    cnt += best;
    cout << cnt;
}

signed main() {
#ifdef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}
