#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <unordered_map>
#include <set>
#include <algorithm>

using namespace std;

long long mod = 1e9 + 7;

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    long long n;
    cin >> n;

    bool fl = true;
    vector < vector < long long > > a(n);
    for (long long i = 0; i < n; i++) {
        long long m;
        cin >> m;
        if (m > 2)fl = false;
        for (long long j = 0; j < m; j++) {
            long long x;
            cin >> x;
            a[i].push_back(x);
        }
    }

    if (fl) {
        vector < pair < long long, long long > > pares;
        for (long long i = 0; i < n; i++) {
            pares.push_back({ max(a[i][0], a[i][1]), i });
        }
        sort(pares.begin(), pares.end());
        long long pr = -1, kol = 0;
        for (auto i : pares) {
            if (a[i.second][0] > pr) {
                kol += 1;
                pr = a[i.second][0];
            }
            if (a[i.second][1] > pr) {
                kol += 1;
                pr = a[i.second][1];
            }
        }
        cout << kol << '\n';
        return 0;
    }

    vector < long long > b;
    for (long long i = 0; i < n; i++) {
        b.push_back(i);
    }

    long long answer = 0;
    do {
        long long ma = 0, kol = 0;
        for (auto i : b) {
            for (auto j : a[i]) {
                if (j > ma) {
                    ma = j;
                    kol++;
                }
            }
        }
        if (kol > answer) {
            answer = kol;
        }
    } while (next_permutation(b.begin(), b.end()));

    cout << answer;
}