#include <iostream>
#include <vector>
#include <iomanip>
#include <map>
#include <random>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/rope>

using namespace std;
using namespace __gnu_pbds;
using namespace __gnu_cxx;
mt19937 rnd(459);

typedef long long ll;
typedef unsigned int uint;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#ifdef DUDE
#define __GLIBCXX_DEBUG
#define debug(x) cout << #x << ":\t" << x << endl
#define debugb(b, x) cout << b << x << endl
#else
#define debug(x) ;
#define debugb(b, x) ;
#endif

template<typename T>
istream& operator >> (istream& in, vector<T>& vec) {
    for (T& e :vec)
        in >> e;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, const vector<T>& vec) {
    char end_char = '\n';
    if (typeid(T) == typeid(int) || typeid(T) == typeid(ll) || typeid(T) == typeid(char))
        end_char = ' ';
    for (const T& e :vec) {
        out << e << end_char;
    }
    return out;
}

template<typename T>
bool maxi(T& a, const T& b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

/*
 *
 */

const int INF = 1e9;


int main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef DUDE
    freopen("input.txt", "r", stdin);
#else
    freopen("input.txt", "r", stdin);
#endif
    int n;
    cin >> n;
    vector<vector<int>> a(n);
    vector<pair<int, int>> as;
    int m = 0;
    int MX = 0;
    for (int i = 0; i < n; ++i) {
        int k;
        cin >> k;
        int mx = 0;
        int e;
        for (int j = 0; j < k; ++j) {
            cin >> e;
            if (e > mx) {
                mx = e;
                a[i].push_back(e);
            }
        }
        as.emplace_back(a[i].back(), i);
        maxi(MX, a[i].back());
    }
    vector<int> dp(MX + 1);
    sort(all(as));
    int prev = 1;
    for (auto p :as) {
        int i = p.second;
        int x = a[i].back();
        while (prev <= x) {
            maxi(dp[prev], dp[prev - 1]);
            ++prev;
        }
        for (int j = 0; j < a[i].size(); ++j) {
           maxi(dp[x], dp[a[i][j] - 1] + int(a[i].size()) - j);
        }
    }
    cout << dp.back();
}
