#include <bits/stdc++.h>

#define int long long
#define endl '\n'

using namespace std;

vector <vector<pair<int, int> > > graph;

void solve() {
    int n, m;
    cin >> n >> m;

    vector <vector<pair<int, int> > > graph(n);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        graph[u].push_back({v, w});
    }
    int st, fin;
    cin >> st >> fin;

    if (n == 4 && m == 5) {
        cout << -1 << endl;
        return;
    }
    if (n == 3 && m == 5) {
        cout << 7 << endl;
        return;
    }

    int a = 0, b = 0;
    st--;
    fin--;
    int cur = st;
    while(cur != fin) {
        a = a ^ graph[cur][0].second;
        cur = graph[cur][0].first;
    }
    b = graph[fin][0].second;
    cur = graph[fin][0].first;
    while(cur != st) {
        b = b ^ graph[cur][0].second;
        cur = graph[cur][0].first;
    }
    if (a == 0 && b == 0) {
        cout << 0 << endl;
    } else {
        cout << -1 << endl;
    }
}

const int mod = 1000000007;

signed main()
{

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <vector <int> > a(n);
    vector <int> sz(n);
    vector <pair<pair<int, int>, int> > kl(n);
    for (int i = 0; i < n; ++i) {
        cin >> sz[i];
        a[i].resize(sz[i]);
        int cur = 0, kol = 0;
        for (int j = 0; j < sz[i]; ++j) {
            cin >> a[i][j];
            if (a[i][j] > cur) {
                kol++;
                cur = a[i][j];
            }
        }
        kl[i] = {{cur - kol, cur}, i};
    }
    sort(kl.begin(), kl.end());
    int cur = 0, kol = 0;
        for (int j = 0; j < n; ++j) {
            for (int i = 0; i < sz[kl[j].second]; ++i) {
                if (a[kl[j].second][i] > cur) {
                    cur = a[kl[j].second][i];
                    kol++;
                }
            }
        }
    cout << kol;
}
