#include <bits/stdc++.h>

using namespace std;

#define int long long
#define endl '\n'

vector <vector <int> > graph;
vector <bool> used;

void dfs(int v, vector <int> & a) {
    used[v] = 1;
    a.push_back(v);
    for (int i = 0; i < graph[v].size(); ++i) {
        if (!used[graph[v][i]]) {
            dfs(graph[v][i], a);
        }
    }
}

const int mod = 1000000007;

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector <vector <int> > a(n);
    vector <int> sz(n);
    vector <int> maxi(n);
    for (int i = 0; i < n; ++i) {
        cin >> sz[i];
        a[i].resize(sz[i]);
        int mx = 0;
        for (int j = 0; j < sz[i]; ++j) {
            cin >> a[i][j];
            mx = max(a[i][j], mx);
        }
        maxi[i] = mx;
    }

    int kvo[n][n];
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < n; ++j) {
            int cur = maxi[i], kol = 0;
            for (int k = 0; k < sz[j]; ++k) {
                if (a[j][k] > cur) {
                    kol++;
                    cur =a[j][k];
                }
            }
            kvo[i][j] = kol;
        }
    }
    vector <pair<int, int> > p(n);
    for (int i = 0; i < n; ++i) {
        p[i] = {maxi[i], i};
    }
    sort(p.begin(), p.end());
    vector <int> ans(n);
    for (int i = 0; i < n; ++i) {
        int cur = 0, kol = 0;
        for (int j = 0; j < sz[p[i].second]; ++j) {
            if (a[p[i].second][j] > cur) {
                kol++;
                cur = a[p[i].second][j];
            }
        }
        ans[i] = kol;
    }
    for (int i = 0; i < n; ++i) {
        for (int j = i; j < n; ++j) {
            ans[j] = ans[i] + kvo[p[i].second][p[j].second];
        }
    }
    int qwe = 0;
    for (int i = 0; i < n; ++i) {
        qwe = max(qwe, ans[i]);
    }
    cout << qwe;
}
