#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    int n;
    cin >> n;

    vector<vector<int>> g(n);
    vector<int> ma(n, 0);
    for(int i = 0; i < n; i ++){
        int k;
        cin >> k;
        while(k --){
            int t;
            cin >> t;
            g[i].push_back(t);
        }
    }

    for(int i = 0; i < n; i ++){
        for(int j = 0; j < g[i].size(); j ++){
            if(g[i][j] > g[i][ma[i]])
                ma[i] = j;
        }
    }


    if(n <= 7){
        vector<int> p(n);
        for(int i = 0; i < n; i ++){
            p[i] = i;
        }
        int ans = 0;
        while(next_permutation(p.begin(), p.end())){
            int a = 0, lastm = 0;
            for(int i = 0; i < n; i ++){
                int q = p[i];
                for(int j = 0; j < g[q].size(); j ++){
                    if(lastm < g[q][j]){
                        a ++;
                        lastm = g[q][j];
                    }
                }
            }
            ans = max(ans, a);
        }
        cout << ans << "\n";
        return 0;

    }


    vector<pair<pair<int, int>, int>> sr(n);
    for(int i = 0; i < n; i ++){
        sr[i] = {{g[i][ma[i]], ma[i]}, i};
    }

    sort(sr.begin(), sr.end());

    int ans = 0, lastm = 0;
    for(int i = 0; i < n; i ++){
        int q = sr[i].second;
        for(int j = 0; j < g[q].size(); j ++){
            if(g[q][j] > lastm){
                lastm = g[q][j];
                ans ++;
            }
        }
    }

    cout<< ans << "\n";

  return 0;
}
