#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

void solve() {
	int n;
	cin >> n;
	vector <vector <int>> a(n);
	vector <pair <int, int>> tosort;
	int k;
	for (int i = 0; i < n; i++) {
		cin >> k;
		a[i].resize(k);
		for (int j = 0; j < k; j++)
			cin >> a[i][j];
		int ma = -1e9;
		for (auto e : a[i])
			ma = max(ma, e);
		tosort.push_back({ ma, i });
	}
	sort(tosort.begin(), tosort.end());
	vector <vector <int>> b(n);
	for (int i = 0; i < n; i++) {
		int id = tosort[i].second;
		b[i].push_back(a[id][0]);
		for (int j = 1; j < a[id].size(); j++)
			if (a[id][j] > b[i].back())
				b[i].push_back(a[id][j]);
	}
	vector <int> dp(n, 0);
	dp[0] = (int)b[0].size();
	for (int i = 1; i < n; i++) {
		int sz = (int)b[i].size();
		int cnt = sz;
		dp[i] = sz;
		for (int j = 0; j < i; j++) {
			while (cnt > 0 && b[i][sz - cnt - 1] <= b[j].back())
				cnt--;
			if (dp[i] > dp[j] + cnt)
				break;
			dp[i] = max(dp[i], dp[j] + cnt);
		}
	}
	int ans = 0;
	for (auto e : dp)
		ans = max(ans, e);
	cout << ans << "\n";
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);

	int tests = 1;
//	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}