#include <iostream>
#include "cstdio"
#include "iomanip"
#include "fstream"
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include "map"

using namespace std;
#define ll long long
#define int ll

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
const int MOD = 1e9 + 7;

struct truk{
    int cool = 0, next = -1, mx_p = 0;
    truk(int c = -1, int n = -1){
        cool = c; next = n;
    }
    bool operator<(truk t){
        return cool < t.cool;
    }
};

vector<truk> ts(1); int sz = 0;
bool comp(int a, int b){
    return ts[a].cool < ts[b].cool;
}

void main0(){
    int n; cin >> n;
    for (int i = 0; i < n; i++){
        //cout << "ok";
        int k; cin >> k;
        vector<int> stuck;
        while (k--){
            int a; cin >> a;
            if (!stuck.size() || stuck.back() < a) { stuck.push_back(a); }
        }
        sz += stuck.size();
        for (int j = 1; j < stuck.size(); j++){
            ts.push_back(truk(stuck[j - 1], ts.size() + 1));
        }ts.push_back(truk(stuck.back()));
    }
    vector<int> num_ts(sz + 1); for (int i = 0; i <= sz; i++) num_ts[i] = i;

    sort(num_ts.begin(), num_ts.end(), comp);

    vector<int> dp(sz + 1);
    dp[0] = 0;
    for (int i = 1; i <= sz; i++){
        dp[i] = ts[num_ts[i]].mx_p;
        for (int j = 0; j < i; j++){
            if (ts[num_ts[j]].next == -1 && (ts[num_ts[j]].cool < ts[num_ts[i]].cool))
                dp[i] = max(dp[i], dp[j] + 1);
        }
        if (ts[num_ts[i]].next != -1){
            ts[ts[num_ts[i]].next].mx_p = max(ts[ts[num_ts[i]].next].mx_p, dp[i] + 1);
        }
    }
    int out = 0;
    for (int i = 0; i <= sz; i++){
        //cout << ts[num_ts[i]].cool << '-' << dp[i] << '\n';
        out = max(out, dp[i]);
    } cout << out;
}

signed main() {
   speed();
    cout << fixed << setprecision(10);
    int t = 1;
    while (t--){
        main0();
        cout << '\n';
    }
}
