#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#define ll long long
using namespace std;
const string space=" ", slashn="\n";

void f(int num_alb, vector<vector<int>>& alb, int current_max_track, int& best_res, vector<bool>& used, int iter, int current_res) {
    //cout << num_alb << space;
    for (auto track : alb[num_alb]) {
        if (track > current_max_track) {
            ++current_res;
            current_max_track = track;
        }
    }

    if (iter == alb.size()) {
        best_res = max(best_res, current_res);
        //cout << slashn;
        return;
    }

    used[num_alb] = true;
    for (int i=0; i<alb.size(); ++i) {
        if (!used[i]) {
            f(i, alb, current_max_track, best_res, used, iter+1, current_res);
        }
    }
    used[num_alb] = false;
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n; cin >> n;
    vector<vector<int>> alb(n);

    // в процессе считывания внутри каждого альбома отсеиваем треки

    for (int i=0; i<n; ++i) {
        int k; cin >> k;
        int t;
        int current_best=0;
        for (int j=0; j<k; ++j) {
            cin >> t;
            if (t > current_best) {
                alb[i].push_back(t);
                current_best = t;
            }
        }
    }

    if (n<=7) {
        int best_res = 0;
        for (int i = 0; i < n; ++i) {
            vector<bool> used(n, false);
            f(i, alb, 0, best_res, used, 1, 0);
        }

        cout << best_res << slashn;
    } else {

        bool is_1 = false, is_2 = false;
        for (int i=0; i<n; ++i) {
            for (auto track : alb[i]) {
                if (track == 1) {
                    is_1 = true;
                }
                if (track == 2) {
                    is_2 = true;
                }
            }
        }

        if (is_1 && is_2) {
            cout << 2 << slashn;
        } else if (is_1 || is_2) {
            cout << 1 << slashn;
        } else {
            cout << 0 << slashn;
        }

    }

    return 0;
}