#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

int get(vector<int> a, vector<int> b) {
    int cur = 0, ans = 0;
    for (auto &el : a) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    for (auto &el : b) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    return ans;
}

int get1(vector<int> a, vector<int> b) {
    int cur = 0, ans = 0;
    for (auto &el : a) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    for (auto &el : b) {
        if (el > cur) {
            cur = el;
            ++ans;
        }
    }
    return cur;
}

int get2(vector<int> a, vector<int> b) {
    return min(a[0], a[1]);
}

void solve() {
    int n;
    cin >> n;
    vector<int> a[n];
    int mxall = 0;
    int mxsz = 0;
    for (int i = 0, k; i < n; ++i) {
        cin >> k;
        mxsz = max(mxsz, k);
        a[i].resize(k);
        for (auto &j : a[i]) {
            cin >> j;
            mxall = max(mxall, j);
        }
    }
    if (mxall <= 2) {
        int cnt1 = 0, cnt2 = 0;
        for (int i = 0; i < n; ++i) {
            int cn = count(all(a[i]), 1);
            for (auto &el : a[i]) {
                if (el == 1) {
                    --cn;
                } else {
                    if (cn) {
                        cout << 2;
                        return;
                    }
                }
            }
            if (count(all(a[i]), 1)) {
                ++cnt1;
            }
            if (count(all(a[i]), 2)) {
                ++cnt2;
            }
        }
        if (max(cnt1, cnt2) >= 2) {
            cout << 2;
        } else {
            cout << 1;
        }
        return;
    }
    const int MX = 1000;
    vector<int> dp(MX + 1, 0);
    for (int s = 0; s <= MX; ++s) {
        vector<pair<int, int>> cur;
        for (int i = 0; i < n; ++i) {
            int nw = s, cnt = 0;
            for (auto &el : a[i]) {
                if (el > nw) {
                    nw = el;
                    ++cnt;
                }
            }
            cur.emplace_back(cnt, nw);
            dp[nw] = max(dp[nw], dp[s] + cnt);
        }
    }
    int mx = *max_element(all(dp));
    cout << mx;
}