/**
 ____ ____ ____ ____ ____ ____
||l |||e |||i |||n |||a |||d ||
||__|||__|||__|||__|||__|||__||
|/__\|/__\|/__\|/__\|/__\|/__\|

**/

#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

const int maxn = 2e5 + 10;
int n, k[maxn], ridx[maxn];
vector < int > album[maxn];

void compress_album(int i)
{
    ///sort(album[i].begin(), album[i].end());
    vector < int > new_album;
    int last = 0;
    for (int j = 0; j < k[i]; j ++)
    {
        if (album[i][j] > last)
        {
            new_album.push_back(album[i][j]);
            last = album[i][j];
        }
    }
    album[i] = new_album;
}

bool cmp(int a, int b)
{
    return album[a].back() < album[b].back();
}

int dp[maxn];
vector < int > song[maxn];

int tree[4 * maxn];

void update(int root, int left, int right, int pos, int val)
{
    if (left == right)
    {
        tree[root] = max(tree[root], val);
        return;
    }

    int mid = (left + right) / 2;
    if (pos <= mid)
        update(root * 2, left, mid, pos, val);
    else
        update(root * 2 + 1, mid + 1, right, pos, val);

    tree[root] = max(tree[root * 2], tree[root * 2 + 1]);
}

int query(int root, int left, int right, int qleft, int qright)
{
    if (left > qright || right < qleft)
        return 0;

    if (left >= qleft && right <= qright)
        return tree[root];

    int mid = (left + right) / 2;
    return max(query(root * 2, left, mid, qleft, qright),
                query(root * 2 + 1, mid + 1, right, qleft, qright));
}

void solve()
{
    cin >> n;
    for (int i = 1; i <= n; i ++)
    {
        int x;
        cin >> k[i];
        album[i].resize(k[i]);
        for (int j = 0; j < k[i]; j ++)
        {
            cin >> album[i][j];
        }
    }

    for (int i = 1; i <= n; i ++)
        compress_album(i), ridx[i] = i;

    sort(ridx + 1, ridx + n + 1, cmp);


    int ans = 0;
    for (int i = 1; i <= n; i ++)
    {
        int idx = ridx[i];
        int pt = 0, val = 0;
        for (int cur = 0; cur < album[idx].size(); cur ++)
        {
            int max_val = query(1, 0, maxn - 1, 0, album[idx][cur] - 1);
            val = max(val, (int)(max_val + album[idx].size() - cur));

        }
        update(1, 0, maxn - 1, album[idx].back(), val);
        ans = max(ans, val);
    }

    cout << ans << endl;
}

int main()
{
    solve();
    return 0;
}
/**
3
3
4 8 5
3
2 6 9
2
1 10
 */
