#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

bool cmp(vector<int> a, vector<int> b)
{
    int cnt1 = a.size(), prv = a.back();
    for (auto num : b)
    {
        if (num > prv)
        {
            cnt1++;
            prv = num;
        }
    }

    int cnt2 = b.size();
    prv = b.back();
    for (auto num : a)
    {
        if (num > prv)
        {
            cnt2++;
            prv = num;
        }
    }

    if (cnt1 != cnt2) return (cnt1 > cnt2);
    return (a.back() < b.back());
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    vector< vector<int> > albums;
    for (int i = 1; i <= n; ++ i)
    {
        int k;
        cin >> k;

        int prv = 0;
        vector<int> v;
        for (int j = 1; j <= k; ++ j)
        {
            int num;
            cin >> num;
            if (num > prv)
            {
                v.push_back(num);
                prv = num;
            }
        }
        albums.push_back(v);
    }

    sort(albums.begin(), albums.end(), cmp);

    int cnt = 0, prv = 0;
    for (auto v : albums)
    {
        for (auto num : v)
        {
            if (num > prv)
            {
                cnt++;
                prv = num;
            }
        }
    }

    cout << cnt << endl;

    return 0;
}
