#include <algorithm>
#include <iostream>
#include <vector>
#define endl '\n'
using namespace std;

const int MAXN = 200000;

bool cmp(vector<int> a, vector<int> b)
{
    if (a.back() != b.back()) return (a.back() < b.back());
    return (a.size() < b.size());
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    cin >> n;

    vector< vector<int> > albums;
    for (int i = 1; i <= n; ++ i)
    {
        int k;
        cin >> k;

        int prv = 0;
        vector<int> v;
        for (int j = 1; j <= k; ++ j)
        {
            int num;
            cin >> num;
            if (num > prv)
            {
                v.push_back(num);
                prv = num;
            }
        }
        albums.push_back(v);
    }

    sort(albums.begin(), albums.end(), cmp);

    if (n <= 7)
    {
        int ans = 0;
        do
        {
            int cnt = 0, prv = 0;
            for (auto v : albums)
            {
                for (auto num : v)
                {
                    if (num > prv)
                    {
                        cnt++;
                        prv = num;
                    }
                }
            }
            ans = max(ans, cnt);
        } while (next_permutation(albums.begin(), albums.end(), cmp));
        cout << ans << endl;
        return 0;
    }

    vector<int> curr;
    curr.push_back(0);
    int cnt = 0, prv = 0, cnt1 = 0;
    for (auto v : albums)
    {
        if (v.back() != curr.back())
        {
            cnt += cnt1;
            cnt1 = 0;
            prv = curr.back();
            curr = v;
        }
        int cnt2 = 0;
        for (auto num : v)
        {
            if (num > prv) cnt2++;
        }
        cnt1 = max(cnt1, cnt2);
    }
    cnt += cnt1;

    cout << cnt << endl;

    return 0;
}
