#include <iostream>
#include <vector>
#include <algorithm>
#include <deque>
#include "set"
#include "map"
#include "string"

using namespace std;

typedef long long ll;

void solve();

signed main() {
#ifdef _GLIBXX_DEBUG
    freopen("input", "r", stdin);
#endif
    ll t = 1;
    //cin >> t;
    while (t--)
        solve();
}

void solve() {
    int n;
    cin >> n;
    vector<vector<int>> v;
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        v.push_back({});
        for (int j = 0; j < k; j++) {
            int a;
            cin >> a;
            v.back().push_back(a);
        }
    }
    vector<int> ndx(n);
    for (int i = 0; i < n; i++)
        ndx[i] = i;
    int ans = 0;
    while (1) {
        vector<int> h;
        for (int i = 0; i < n; i++) {
            for (int j: v[ndx[i]])
                h.push_back(j);
        }
        map<int, int> m;
        auto h1 = h;
        std::sort(h1.begin(), h1.end());
        int t = 0;
        for (int i: h1)
            m[i] = t++;
        for (int &i: h)
            i = m[i];
        vector<int> dp(1002);
        for (int i: h) {
            for (int j = 0; j < i; j++) {
                dp[i] = max(dp[i], dp[j] + 1);
            }
        }
        for (int i:dp)
            ans = max(ans, i);
        if (!std::next_permutation(ndx.begin(), ndx.end()))
            break;
    }
    cout << ans;


};