#include <bits/stdc++.h>


typedef long long ll;
typedef unsigned long long ull;
using namespace std;
const ll INF = 1e9 + 1;



int main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef DEBUGMB
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    multiset<int> bs;
    vector<vector<int>> apos(n);
    unordered_map<int, int> key;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
        bs.insert(b[i]);
        if (key.find(a[i]) == key.end()) {
            key[a[i]] = i;
            apos[i].push_back(i);
        } else {
            apos[key[a[i]]].push_back(i);
        }
    }
    vector<int> asort = a;
    std::sort(asort.rbegin(), asort.rend());
    int mxb = 0;
    int best = INF;
    for (int i = 0; i < n;) {
        int ela = asort[i];
        int nxtmxb = mxb;
        int kela = key[ela];
        for (auto &pos : apos[kela]) {
            int elb = b[pos];
            bs.erase(bs.find(elb));
            int x = INF;
            set<int>::iterator it = bs.lower_bound(ela);
            if (it != bs.end()) {
                x = abs(max(*it, mxb) - ela);
            }
            if (it != bs.begin()) {
                int y = abs(max(*(--it), mxb) - ela);
                x = min(x, y);
            }
            best = min(x, best);
//            cerr << mxb << " " << ela << " " << elb << " " << x << "\n";
            bs.insert(elb);
            nxtmxb = max(mxb, b[pos]);
            ++i;
        }
        mxb = max(mxb, nxtmxb);
    }
    cout << best << "\n";


    return 0;
}