#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
#define forn(i, n) for (int i = 0; i < n; ++i)
#define watch(x) cout << #x << " : " << x << '\n';
#define watch_arr(arr) \
cout << #arr << " : "; \
forn(i, arr.size()) \
    cout << arr[i] << ' '; \
cout << '\n';

const int INF = 2e9;
vector<pair<int, int>> pair_cost;
multiset<int> not_del_b, del_b;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    forn (i, n) {
        int a, b;
        cin >> a >> b;
        pair_cost.push_back({a, b});
        not_del_b.insert(b);
    }

    sort(pair_cost.begin(), pair_cost.end());

    int best = INF;
    forn (i, n) {
        auto del_it = not_del_b.find(pair_cost[i].second);
        not_del_b.erase(del_it);

        bool check = true;
        if (!not_del_b.empty()) {
            auto max_it = not_del_b.end();
            --max_it;
            best = min(best, abs(*max_it - pair_cost[i].first));
            if(*max_it > pair_cost[i].first)
                check = false;
        }

        if (!del_b.empty() && check) {
            auto it = lower_bound(del_b.begin(), del_b.end(), pair_cost[i].first);
            if(it != del_b.end())
                best = min(best, abs(*it - pair_cost[i].first));
            --it;
            if(it != del_b.begin())
                best = min(best, abs(pair_cost[i].first - *it));
        }
        del_b.insert(pair_cost[i].second);
    }

    cout << best;
}
