#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#define pii pair < int, int >
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;
using namespace __gnu_pbds;

template <typename T>
using ordered_set = tree < T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

const int MOD = (int)1e9 + 7;
const int N = (int)5e5 + 5;
const int p = 41;

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n;
    cin >> n;
    vector < pii > a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin() + 1, a.end());

    set < int > st;
    int ans = INT_MAX;
    vector < int > mx(n + 2, 0);
    for (int i = n; i >= 1; i--) {
        mx[i] = max(mx[i + 1], a[i].second);
    }
    for (int i = 1; i <= n; i++) {
        int m = mx[i + 1];
        ans = min(abs(m - a[i].first), ans);
        if (m < a[i].first && !st.empty()) {
            auto it = st.lower_bound(a[i].first);
            if (it != st.end()) {
                ans = min(ans, abs(*it - a[i].first));
            }
            if (it != st.begin()) {
                it--;
                ans = min(ans, abs(*it - a[i].first));
            }
        }
        st.insert(a[i].second);
    }

    cout << ans << '\n';
    return 0;
}
