#include <bits/stdc++.h>

using namespace std;
const int INF = 1e9;

inline int flex_solve(int n, const vector <int>& a, const vector <int>& b) {
    vector <pair <int, int>> all_a, all_b;
    for (int i = 0; i < n; ++i) all_a.emplace_back(a[i], i);
    for (int i = 0; i < n; ++i) all_b.emplace_back(b[i], i);
    sort(all_a.begin(), all_a.end());
    sort(all_b.begin(), all_b.end());
    int ans = INF;
    int mx1 = -INF, mx2 = -INF;
    int cur = 0;
    vector <int> suf_max(n + 1, -INF);
    for (int i = n - 1; i >= 0; --i) {
        suf_max[i] = max(suf_max[i + 1], b[all_a[i].second]);
    }
    int cha = 0;
    vector <vector <int>> all(n + 1);
    for (int i = 0; i < n; ++i) {
        while (cha < n && all_a[cha].first < b[i]) cha++;
        all[cha].push_back(i);
    }
    vector <int> active(n);
    for (int i = 0; i < n; ++i) {
        for (int j : all[i]) {
            if (active[j]) {
                if (mx1 < b[j]) {
                    mx2 = mx1;
                    mx1 = b[j];
                } else if (mx2 < b[j]) {
                    mx2 = b[j];
                }
            }
        }
        int w = all_a[i].first;
        while (cur < n && all_a[cur].first == w) {
            int ps = all_a[cur].second;
            active[ps] = 1;
            if (b[ps] <= w) {
                if (mx1 < b[ps]) {
                    mx2 = mx1;
                    mx1 = b[ps];
                } else if (mx2 < b[ps]) {
                    mx2 = b[ps];
                }
            }
            cur++;
        }
        int need_mx = suf_max[cur];
        if (need_mx > w) continue;
        if (mx1 == b[all_a[i].second]) need_mx = max(need_mx, mx2);
        else need_mx = max(need_mx, mx1);
        ans = min(ans, w - need_mx);
    }
    return ans;
}

inline void solve() {
    int n;
    cin >> n;
    vector <int> a(n), b(n);
    for (int i = 0; i < n; ++i) cin >> a[i] >> b[i];
    cout << min(flex_solve(n, a, b), flex_solve(n, b, a));
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        solve();
    }
    return 0;
}

/*
2
 1 2
 2 1

5
1 5
2 7
3 3
4 10
2 5

 */