#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <string>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    long long ans = 1e18;
    vector<pair<long long , long long>> a(n);
    set<long long> s;
    for (int i = 0; i < n; i++) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.begin() , a.end());
    s.insert(-1e9 - 5); s.insert(1e9 + 5);
    vector<long long> p(n);
    p[0] = 1e9+1;
    for (int i = 1; i < n; i++) {
        s.insert(a[i-1].second);
        auto c = s.lower_bound(a[i].first);
        p[i] = ((*c) - a[i].first);
        c--;
        p[i] = min(p[i] , (a[i].first - (*c)));
    }
    long long m = -1;
    for (int i = n - 2; i >= 0; i--) {
        m = max(m , a[i+1].second);
        p[i] = min(p[i] , abs(m - a[i].first));
    }
    m = 1e18;
    for (int i = 0; i < n; i++) {
        m = min(m , p[i]);
    }
    cout << m;
    return 0;
}
