#include <bits/stdc++.h>
//#include <ext/pd_ds/assoc_container.hpp>
//#include <ext/pd_ds/tree_policy.hpp>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size();
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef int64_t ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
ostream& operator << (ostream& out, pair<T, T1> &pr) {
    out << pr.first << " " << pr.second;
    return out;
}

template<typename T, typename T1>
istream& operator >> (istream& in, pair<T, T1> &pr) {
    in >> pr.first >> pr.second;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &arr) {
    for (auto &i : arr) {out << i << " ";}
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &arr) {
    for (auto &i : arr) {in >> i;}
    return in;
}

const int mod = 1e9 + 7;
const int maxn = 2e5;
//typedef tree<int, null_type, less<int>,
//        rb_tree_tag, tree_order_statistics_node> ordered_set;

int n;
vector<pii> s;
vector<int> suf;
vector<int> d;

bool check(int x) {
    //cout << x << ": ";
    for (int i = 0; i < n; i++) {
        int i1 = lower_bound(all(d), max(suf[i + 1], s[i].ff - x)) - d.begin();
        int i2 = upper_bound(all(d), s[i].ff) - d.begin() - 1;

        int i3 = lower_bound(all(d), max(suf[i + 1], s[i].ff)) - d.begin();
        int i4 = upper_bound(all(d), s[i].ff + x) - d.begin() - 1;

        if (!(i2 - i1 + 1 <= 0 || (i2 - i1 + 1 == 1 && d[i1] == s[i].ss))) {
            //cout << i1 << " " << i2 << " " << i << "\n";
            return 1;
        }

        if (!(i4 - i3 + 1 <= 0 || (i4 - i3 + 1 == 1 && d[i3] == s[i].ss))) {
            //9cout << i3 << " " << i4 << " " << i << "\n";
            return 1;
        }

    }
   //cout << "\n";
    return 0;
}

void solve() {
    cin >> n;

    s.rs(n); cin >> s;
    sort(all(s));

    suf.rs(n + 1);
    for (int i = n - 1; i > -1; i--) {
        suf[i] = max(s[i].ss, suf[i + 1]);
    }


    for (int i = 0; i < n; i++) {
        d.pb(s[i].ss);
    }
    sort(all(d));
    cout << d << "\n";

    int l = -1, r = 1e9;
    while (r - l > 1) {
        int md = (l + r) / 2;

        if (check(md)) r = md;
        else l = md;
    }

    cout << r << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double start_time = clock();
#endif
    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------\n";
#endif
    }
#ifdef LOCAL
    cout << "execution time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}
