#include <bits/stdc++.h>
//#include <ext/pd_ds/assoc_container.hpp>
//#include <ext/pd_ds/tree_policy.hpp>

using namespace std;

#define ff first
#define ss second
#define rs resize
#define pb push_back
#define sz(x) (int)x.size();
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define int long long

typedef int64_t ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

template<typename T, typename T1>
ostream& operator << (ostream& out, pair<T, T1> &pr) {
    out << pr.first << " " << pr.second;
    return out;
}

template<typename T, typename T1>
istream& operator >> (istream& in, pair<T, T1> &pr) {
    in >> pr.first >> pr.second;
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &arr) {
    for (auto &i : arr) {out << i << " ";}
    return out;
}

template<typename T>
istream& operator >> (istream& in, vector<T> &arr) {
    for (auto &i : arr) {in >> i;}
    return in;
}

const int mod = 1e9 + 7;
const int maxn = 2e5;
//typedef tree<int, null_type, less<int>,
//        rb_tree_tag, tree_order_statistics_node> ordered_set;

int n;
vector<pii> s;
vector<int> suf;
vector<int> d;

int check() {
    //cout << x << ": ";

    int ans = 1e9;
    for (int i = 0; i < n; i++) {
        int i1 = lower_bound(all(d), suf[i + 1]) - d.begin();
        int i2 = upper_bound(all(d), s[i].ff) - d.begin() - 1;

        int i4 = lower_bound(all(d), max(suf[i + 1], s[i].ff)) - d.begin();

        if (i1 <= i2 && (i2 - i1 != 0 || d[i2] != s[i].ss)) {
            if (d[i2] == s[i].ss) i2--;

            ans = min(ans, s[i].ff - d[i2]);
        }

        if (i4 < n && (i4 != n - 1 || d[i4] != s[i].ss)) {
            if (d[i4] == s[i].ss) i4++;
            ans = min(ans, d[i4] - s[i].ff);
        }

    }
   //cout << "\n";
    return ans;
}

void solve() {
    cin >> n;

    s.rs(n); cin >> s;
    sort(all(s));

    suf.rs(n + 1);
    for (int i = n - 1; i > -1; i--) {
        suf[i] = max(s[i].ss, suf[i + 1]);
    }


    for (int i = 0; i < n; i++) {
        d.pb(s[i].ss);
    }
    sort(all(d));
    //cout << d << "\n";

    cout << check() << "\n";
}

int32_t main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    double start_time = clock();
#endif
    int test = 1;
    //cin >> test;

    while (test--) {
        solve();
#ifdef LOCAL
        cout << "--------------\n";
#endif
    }
#ifdef LOCAL
    cout << "execution time: " << (clock() - start_time) / CLOCKS_PER_SEC;
#endif
}
