#include <bits/stdc++.h>
using namespace std;

#define int long long 
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back
#define all(x) x.begin(),x.end()
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const int inf=1e18;
const int mod=1e9+7;

const int sz=1<<30;

struct sgt {
	sgt *L, *R;
	int val;
	sgt() {
		L=R=NULL; val=0;
	}
	void add(int l, int r, int i) {
		val++;
		if (r-l==1) return;
		int m=(l+r)>>1;
		if (i<m) {
			if (!L) L=new sgt();
			L->add(l,m,i);
		} else {
			if (!R) R=new sgt();
			R->add(m,r,i);
		}
	}
	void add(int i) {
		add(0,sz,i);
	}
	int qleft(int l, int r, int i) {
		if (r-l==1) {
			return l;
		}
		if (l>=i) return -1;
		int m=(l+r)>>1;
		int f=-1, s=-1;
		if (L) if (L->val) f=L->qleft(l,m,i);
		if (R) if (R->val) s=R->qleft(m,r,i);
		if (f==-1) {
			if (s<i) return s;
		} else {
			if (s!=-1 && s<i) return s;
			if (f<i) return f;
		}
		return -1;
	}
	int qleft(int i) {
		return qleft(0,sz,i);
	}
	int qright(int l, int r, int i) {
		if (r-l==1) {
			return l;
		}
		if (r<=i+1) return -1;
		int m=(l+r)>>1;
		int f=-1, s=-1;
		if (L) if (L->val) f=L->qright(l,m,i);
		if (R) if (R->val) s=R->qright(m,r,i);
		if (f==-1) {
			if (s!=-1 && s>i) return s;
		} else {
			if (f>i) return f;
			if (s!=-1 && s>i) return s;
		}
		return -1;
	}
	int qright(int i) {
		return qright(0,sz,i);
	}
};

sgt st;

struct BIT {
	int n; vector<int> t;
	BIT(int _n) {
		n=_n;
		t.assign(n,0);
	}
	void add(int i, int x) {
		for( ; i<n; i=i|(i+1) ) {
			t[i]=max(t[i],x);
		}
	}
	int q(int r) {
		if (r<0) return -1;
		int ret=0;
		for(r; r>=0; r=(r&(r+1))-1) {
			ret=max(ret,t[r]);
		}
		return ret;
	}
};

void solve() {

	int n; cin>>n;
	vector<pi> a(n);
	forn(i,n) cin>>a[i].f>>a[i].s;
	int z=1;
	forn(i,n) z&=a[i].f==a[i].s;
	if (z) {
		sort(all(a));
		cout<<a[n-1].f-a[n-2].f<<'\n';
		return;
	}
	sort(all(a));
	BIT ft(n);
	for (int i=n-1; i>=0; --i) ft.add(n-1-i,a[i].s);
	int ans=inf;
	forn(i,n) {
		int f=a[i].f;
		int s=ft.q(n-i-2);
		if (s>=f) {
			ans=min(ans,s-f);
			st.add(a[i].s);
			continue;
		}
		if (s!=-1) ans=min(ans,abs(s-f));
		int L=st.qleft(f);
		int R=st.qright(f);
		if (L!=-1) ans=min(ans,f-L);
		if (R!=-1) ans=min(ans,R-f);
		st.add(a[i].s);
	}	
	cout<<ans;

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	//cin>>t;
	while (t--) solve();
	return 0;
}