#include "bits/stdc++.h"
#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

constexpr int MAX_MEM = 400228337;
char mem[MAX_MEM];
size_t mpos = 0;
inline void* operator new(size_t b) noexcept {
    mpos += b;
    return (void*)(mem + (mpos - b));
}
inline void operator delete(void*) noexcept {}
inline void operator delete(void*, size_t) noexcept {}

using namespace std;
using ll = long long;

template<typename T>
istream& operator>>(istream& in, vector<T> &v) {
    for (T &now : v) {
        in >> now;
    }
    return in;
}

#define comparator [&](const auto &lhs, const auto &rhs) {if (lhs.second == rhs.second) return lhs.first > rhs.first; return lhs.second > rhs.second;}

constexpr int MAXN = 500005;
pair<int, int> ab[MAXN];
int pm[MAXN];

int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int n;
    cin >> n;
    multiset<int> bs;
    for (int i = 0; i < n; ++i) {
        cin >> ab[i].first >> ab[i].second;
        bs.insert(ab[i].second);
    }
    std::sort(ab, ab + n, comparator);
    pm[0] = ab[0].first;
    for (int i = 1; i < n; ++i) {
        pm[i] = max(pm[i - 1], ab[i].first);
    }

    vector<int> rng(n);
    iota(rng.begin(), rng.end(), 0);
    std::sort(rng.begin(), rng.end(), [&](int lhs, int rhs) {
        return ab[lhs].first > ab[rhs].first;
    });
    int l = -1, r = 1000000228;
    while (r - l > 1) {
        int m = (r + l + 1) / 2;
        bool ok = false;
        int ptr = 0;
        for (int ap : rng) {
            while (ptr < n && ab[ptr].second > ab[ap].first + m) {
                ++ptr;
            }
            int pos = ptr - 1;
            bs.erase(bs.find(ab[ap].second));
            auto it = bs.lower_bound(ab[ap].first - m);
            if (ab[ap].first - m < ab[ap].second && ab[ap].second <= ab[ap].first + m) {
                ++it;
            }
            if ((pos == -1 || pm[pos] <= ab[ap].first) && (it != bs.end() && *it <= ab[ap].first + m)) {
                ok = true;
                break;
            }
            if (ok) break;
        }
        if (!ok) {
            l = m;
        } else {
            r = m;
        }
    }
    cout << r << '\n';
    return 0;
}