#include <iostream>
#include <vector>
#include <algorithm>
#include <set>

using namespace std;

#define mp make_pair
#define pb push_back
#define F first
#define S second
#define all(x) x.begin(), x.end()
typedef long long ll;

const ll INF = 2e9;

void solve4(vector<pair<ll, ll> > v) {
    ll n = v.size();
    sort(v.rbegin(), v.rend());
    cout << v[0].F - v[1].F;
}

bool comp(pair<ll, ll> a, pair<ll, ll> b) {
    return a.F > b.F || (a.F == b.F && a.S < b.S);
}

signed main() {
    ll n; cin >> n;
    vector<pair<ll, ll> > v(n);
    ll t4 = 1;
    for (ll i = 0; i < n; i++) {
        cin >> v[i].F >> v[i].S;
        if (v[i].F != v[i].S) t4 = 0;
    }
    if (t4) {
        solve4(v);
        return 0;
    }
    sort(v.begin(), v.end(), comp);

    vector<ll> mxb(n);
    ll mxbi = -1;
    for (int i = 0; i < n; i++) {
        mxb[i] = mxbi;
        if (i == 0 || (i > 0 && v[i].F != v[i - 1].F)) mxbi = max(mxbi, v[i].S);
    }

    ll ans = INF;
    for (int a = 0; a < n; a++) {
        ans = min(ans, abs(mxb[a] - v[a].F));
        for (int b = a; b < n; b++) {
            if (a == b) continue;
            if (mxb[a] <= v[b].S) {
                ans = min(ans, abs(v[a].F - v[b].S));
            } 
        }
    }
    cout << ans;
    return 0;
}