#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define pb push_back
#define elif else if
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)

using namespace std;
using str = string;
using ll = long long;
using vi = vector <int>;
using vl = vector <ll>;
using vvi = vector <vi>;
using vvl = vector <vl>;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

template <typename T>
istream& operator>>(istream& in, pair <T, T>& p) {
    in >> p.first >> p.second;
    return in;
}
template <typename T>
istream& operator>>(istream& in, vector <T>& a) {
    for (int i = 0; i < (int)a.size(); ++i) {
        in >> a[i];
    }
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, pair <T, T>& p) {
    out << p.first << p.second;
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector <T>& a) {
    for (auto c : a) {
        out << c space;
    }
    return out;
}

const int INF = INT_MAX;
const ll LINF = LLONG_MAX;
const ll hash_power = 29;
const ll mod = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector <pii> a(n);
    cin >> a;
    sort(all(a));

    multiset <int> left, right;
    for (auto p : a) {
        right.insert(p.second);
    }

    int ans = INF;
    for (int i = 0; i < n; ++i) {
        int w = a[i].first;
        right.erase(right.find(a[i].second));

        if (i + 1 < n && a[i] == a[i + 1]) {
            left.insert(a[i].second);
            continue;
        }

        int ma = 0;
        if (!right.empty()) ma = *right.rbegin();

        auto it = upper_bound(all(left), w);
        if (it != left.end()) {
            ans = min(ans, abs(max(ma, *it) - w));
        }
        if (it != left.begin()) {
            it--;
            ans = min(ans, abs(max(ma, *it) - w));
        }
        left.insert(a[i].second);
    }
    cout << ans;
}

void tests() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        cout << "Test number:" spc i newl;
        solve();
        cout newl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    /*
    freopen("inputB.txt", "r", stdin);
    tests();*/

    solve();
}
