#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define pb push_back
#define elif else if
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)

using namespace std;
using str = string;
using ll = long long;
using vi = vector <int>;
using vl = vector <ll>;
using vvi = vector <vi>;
using vvl = vector <vl>;
using pii = pair <int, int>;
using pll = pair <ll, ll>;

template <typename T>
istream& operator>>(istream& in, pair <T, T>& p) {
    in >> p.first >> p.second;
    return in;
}
template <typename T>
istream& operator>>(istream& in, vector <T>& a) {
    for (int i = 0; i < (int)a.size(); ++i) {
        in >> a[i];
    }
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, pair <T, T>& p) {
    out << p.first << p.second;
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector <T>& a) {
    for (auto c : a) {
        out << c space;
    }
    return out;
}

const int INF = INT_MAX;
const ll LINF = LLONG_MAX;
const ll hash_power = 29;
const ll mod = 1e9 + 7;

void solve() {
    int n;
    cin >> n;
    vector <pii> a(n);
    cin >> a;
    sort(all(a));

    vector <pii> temp(n);
    for (int i = 0; i < n; ++i) {
        temp[i] = {a[i].second, i};
    }
    temp.pb({-1, -1});
    temp.pb({1e9 + 1, -1});
    sort(all(temp));

    vi id(n);
    for (int i = 1; i <= n; ++i) {
        id[temp[i].second] = i;
    }

    vi lft(n + 2, -1), rgt(n + 2, -1);
    for (int i = 0; i < n + 2; ++i) {
        lft[i] = i - 1;
        rgt[i] = i + 1;
    }

    int l = 0;
    for (int i = 0; i < n + 2; ++i) {
        if (temp[i].first < a[n - 1].first) {
            if (l == -1 || temp[l].first <= temp[i].first) {
                l = i;
            }
        }
    }

    int ans = INF, ma = -1;
    for (int i = n - 1; i >= 0; --i) {
        int w = a[i].first;

        if (l == id[i]) {
            l = lft[l];
        }

        rgt[lft[id[i]]] = rgt[id[i]];
        lft[rgt[id[i]]] = lft[id[i]];

        while (temp[l].first >= w) l = lft[l];

        if (i + 1 < n && a[i] == a[i + 1]) {
            ma = max(ma, a[i].second);
            continue;
        }

        if (ma != -1) ans = min(ans, abs(ma - w));
        if (temp[l].first != -1) ans = min(ans, abs(max(ma, temp[l].first) - w));
        if (temp[rgt[l]].first != 1e9 + 1) ans = min(ans, abs(max(ma, temp[rgt[l]].first) - w));

        ma = max(ma, a[i].second);
    }
    cout << ans;
}

void tests() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        cout << "Test number:" spc i newl;
        solve();
        cout newl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    /*
    freopen("inputB.txt", "r", stdin);
    tests();*/

    solve();
}
