#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

const int INF = 1e9;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int n; cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i)
        cin >> a[i] >> b[i];
    if (n <= 20) {
        int ans = 1e9;
        for (int mask = 1; mask < (1 << n) - 1; ++mask) {
            int max_a = 0, max_b = 0;
            for (int i = 0; i < n; ++i) {
                if ((mask >> i) & 1) max_b = max(max_b, b[i]);
                else max_a = max(max_a, a[i]);
            }
            ans = min(ans, abs(max_a - max_b));
        }
        cout << ans;
    }
    else if (n <= 500) {
        int ans = 1e9;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < n; ++j) {
                bool flag = true;
                if (i == j) continue;
                vector<bool> not_used(n, false);
                for (int k = 0; k < n; ++k) {
                    if (a[k] > a[i])
                        not_used[k] = true;
                }
                for (int k = 0; k < n; ++k) {
                    if (b[k] > b[j] && not_used[k]) {
                        flag = false;
                        break;
                    }
                }
                if (flag) {
                    ans = min(ans, abs(a[i] - b[j]));
                }
            }
        }
        cout << ans;
    }
    else {
        int max1 = 0, max2 = 0;
        for (int i = 0; i < n; ++i) {
            if (a[i] > max1) {
                max2 = max1;
                max1 = a[i];
            }
            else if (a[i] > max2) {
                max2 = a[i];
            }
        }
        cout << max1 - max2;
    }

    return 0;
}