// #define _GLIBCXX_DEBUG_PEDANTIC
// думай о правильности перед написанием
// проверяй идеи
// проверяй правильность кода
// пробуй разные подходы
// не задерживайся слишком долго на одной задаче
#include <bits/stdc++.h>
using namespace std;
using ll = long long;

#define dbg(x) cerr << #x << ": " << x << endl;


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }

    int ans = 1e9 + 5;
    {
        sort(a.begin(), a.end());


        vector<int> pref_max(n + 1);
        for (int i = n - 1; i >= 0; --i) {
            pref_max[i] = max(pref_max[i + 1], a[i].second);
        }
        set<int> s;
        for (int i = 0; i < n; ++i) {
            auto it1 = s.lower_bound(a[i].first);
            if (pref_max[i + 1] <= a[i].first) {
                if (it1 != s.end()) {
                    ans = min(ans, abs(a[i].first - max(*it1, pref_max[i + 1])));
                }
                if (it1 != s.begin()) {
                    auto it2 = prev(it1);
                    ans = min(ans, abs(a[i].first - max(*it2, pref_max[i + 1])));
                }
            }
            s.insert(a[i].second);
            if (i != n - 1) {
                ans = min(ans, abs(a[i].first - pref_max[i + 1]));
            }
        }
    }

    cout << ans << '\n';

    return 0;
}