#include "bits/stdc++.h"
//#pragma GCC optimize("Ofast,unroll-loops")

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const int base = 177013;
const int mod = 1e9 + 7;

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int n;
    cin >> n;
    vector<int> a(n), b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
//        a[i] = gen() % 10;
//        b[i] = gen() % 10;
//        cout << a[i] << ' ' << b[i] << endl;
    }

//    int b_ans = INT32_MAX;
//    for (int i = 0; i < (1<<(n + 1)); ++i) {
//        int m1 = -1;
//        int m2 = -1;
//        for (int j = 0; j < n; ++j) {
//            if(i & (1<<j))
//                m1 = max(m1, a[j]);
//            else
//                m2 = max(m2, b[j]);
//        }
//        if(m1 != -1 and m2 != -1){
//            b_ans = min(b_ans, abs(m1 - m2));
//        }
//    }
//    cout << b_ans << endl;

    vector<int> ga(n), gb(n);
    iota(all(ga), 0);
    iota(all(gb), 0);
    sort(all(ga), [&](auto l, auto r){
        return a[l] > a[r];
    });
    sort(all(gb), [&](auto l, auto r){
        return b[l] > b[r];
    });
    int l = 0, r = 0;
    int best = INT32_MAX;
    vector<bool> can_sw(n, true);
    for (int i = 0; i < n; ++i) {
        int m1 = a[ga[l]];
        int m2 = b[gb[r]];
        if(r + 1 < n and ga[l] != gb[r + 1] and can_sw[gb[r]]){
            best = min(best, abs(a[ga[l]] - b[gb[r + 1]]));
        }

        if(l + 1 < n and ga[l + 1] != gb[r] and can_sw[ga[l]]){
            best = min(best, abs(a[ga[l + 1]] - b[gb[r]]));
        }

        if(ga[l] != gb[r])
            best = min(best, abs(a[ga[l]] - b[gb[r]]));
        if(!(can_sw[ga[l]] and can_sw[gb[r]])){
            if(can_sw[gb[r]]){
                can_sw[gb[r]] = false;
                ++r;
            }
            if(can_sw[ga[l]]){
                can_sw[ga[l]] = false;
                ++l;
            }
        }else {
            if (m1 > m2) {
                can_sw[ga[l]] = false;
                ++l;
            } else if (m2 > m1) {
                can_sw[gb[r]] = false;
                ++r;
            } else {
                if(ga[l] != gb[r]) {
                    cout << 0 << endl;
                    exit(0);
                }else{
                    int ans = INT_MAX;
                    for (int j = 1; r + j < n; ++j) {
                        if(can_sw[gb[r + j]]){
                            ans = min(ans, abs(a[ga[l]] - b[gb[r + j]]));
                            break;
                        }
                    }
                    for (int j = 1; l + j < n; ++j) {
                        if(can_sw[gb[l + j]]){
                            ans = min(ans, abs(a[ga[l + j]] - b[gb[r]]));
                            break;
                        }
                    }
                    cout << min(ans, best) << endl;
                    exit(0);
                }
            }
        }

        if(ga[l] != gb[r])
            best = min(best, abs(a[ga[l]] - b[gb[r]]));
    }
    cout << best << endl;
}