#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
#include <random>
#include <chrono>
#include <unordered_set>

using namespace std;
using pii = pair<int, int>;

int find(vector<pii>& a, int l, int r, int x) {
    int predl = -1, predr = -1;
    while (r - l > 1 ) {
        predl = l;
        predr = r;
        int m1 = (2 * l + r) / 3;
        int m2 = (l + 2 * r) / 3;
        int res1 = abs(x - a[m1].second);
        int res2 = abs(x - a[m2].second);
        if (res1 <= res2) {
            r = m2;
        } else {
            l = m1;
        }
        if (predl == l && predr == r) break;
    }
    if (abs(x - a[l].second) <= abs(x - a[r].second)) {
        return l;
    } else {
        return r;
    }
}

int main() {
    int n, x, y;
    cin >> n;
    vector<pii> a;
    for (int i = 0; i < n; ++i) {
        cin >> x >> y;
        a.emplace_back(x, y);
    }
    vector<int> possible;
    for (int i = 0; i < n; ++i) {
        possible.push_back(i);
    }
    sort(a.rbegin(), a.rend());
    unordered_set<int> cannot;
    int ans = 1e9;
    int cur = 0;
    for (int i = 0; i < n ;++i) {
        x = a[i].first;
        if (i > 0) {
            cur = max(cur, a[i - 1].second);
        }
        int ind = find(a, i + 1, a.size(), x);
        ans = min(ans, abs(x - max(cur, a[ind].second)));
    }
    cout << ans << endl;
    return 0;
}