#include <bits/stdc++.h>

#include <ranges>
#include <utility>

using namespace std;

typedef int64_t ll;
typedef long double ld;
constexpr int INF = 2e9;

bool STRS = false;

static constexpr ll mod = 1e9 + 7;

struct Solution {
    mt19937 rnd;

    Solution() {
        rnd = mt19937(time(nullptr));
    }
    signed operator()(int TEST = -1) {
        int n; cin >> n;
        vector<pair<int, int>> ar(n);
        for (auto& it : ar) cin >> it.first >> it.second;
        sort(ar.rbegin(), ar.rend());
        auto check = [&](int k) -> bool {
            int bmx = -1;
            multiset<int> bst;
            for (auto& it : ar) {
                bst.insert(it.second);
            }
            for (int i = 0; i < n - 1; ++i) {
                if (bmx != -1 && abs(ar[i].first - bmx) <= k) {
                    return true;
                }
                auto it = bst.lower_bound(max(ar[i].first - k, bmx));
                bmx = max(bmx, ar[i].second);
                bst.erase(bst.lower_bound(ar[i].second));
                if (it == bst.end()) {
                    continue;
                }
                if (*it > ar[i].first + k) {
                    continue;
                }
                return true;
            }
            return false;
        };
        int l = -1, r = 1e9;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (check(m)) {
                r = m;
            } else {
                l = m;
            }
        }
        cout << r << "\n";
#ifdef ILKRAS
        cout << endl;
#endif
        return 0;
    }
};

signed main() {
    cin.tie(nullptr)->sync_with_stdio(false);
    STRS = false;
    int st = 0;
    while (STRS) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    int t = 1;
#ifdef ILKRAS
//    cin >> t;
#endif
    while (t--) {
        int res = Solution()(st++);
        if (res != 0) {
            return res;
        }
    }
    return 0;
}

//2
//
//2 1
//1 2 1
//2 1
//
//2 1
//1 2 1
//1 2


//4
//
//2 2
//1 2 1
//2 1 1
//1 1
//
//3 3
//1 2 1
//2 3 1
//3 1 0
//1 3
//
//3 3
//1 2 1
//2 3 1
//3 1 0
//1 2
//
//3 3
//1 2 1
//2 3 1
//3 1 1
//1 3
