#pragma GCC optimize("O3, unroll-loops, -Ofast, fast-math")
#pragma GCC target("avx2")
#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define F first
#define S second

using namespace std;

const int N = 2e5 + 100, M = 1e9 + 7, IINF = 1e9 + 213, K = 1e3 + 10;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; i ++)
        cin >> a[i].F >> a[i].S;
    int ans = 2e9;
    sort(a.begin(), a.end(), [](auto x, auto y){
        return (x.F < y.F);
    });
    multiset<int> st;
    for (int i = 0; i < n; i ++)
        st.insert(a[i].S);
    multiset<int> usd;
    for (int i = 0; i < n; i ++){
        vector<int> vals;
        int j = i;
        while(j < n && a[i].F == a[j].F) {
            st.erase(st.find(a[j].S));
            vals.push_back(a[j].S);
            j ++;
        }
        if (!st.empty())
            ans = min(ans, abs(*st.rbegin() - a[i].F));
        int ff = 0;
        if (!st.empty())
            ff = *st.rbegin();
        if (vals.size() > 1) {
            for (auto ii: vals)
                ans = min(ans, abs(max(ii, ff) - a[i].F));
        }
        if (!usd.empty()){
            if (st.lower_bound(a[i].F) != st.end())
                ans = min(ans, abs(max(*st.lower_bound(a[i].F), ff) - a[i].F));
            int l = 0, r = a[i].F;
            while(r - l > 1){
                int m = (l + r) / 2;
                if (st.lower_bound(m) != st.end() && *st.lower_bound(m) < a[i].F)
                    l = m;
                else
                    r = m;
            }
            if (st.lower_bound(l) != st.end())
                ans = min(ans, abs(max(*st.lower_bound(l), ff) - a[i].F));
        }
        for (auto ii : vals)
            usd.insert(ii);
        i = j - 1;
    }
    for (int i = 0; i < n; i ++)
        swap(a[i].F, a[i].S);
    sort(a.begin(), a.end(), [](auto x, auto y){
        return (x.F < y.F);
    });
    st.clear();
    for (int i = 0; i < n; i ++)
        st.insert(a[i].S);
    usd.clear();
    for (int i = 0; i < n; i ++){
        vector<int> vals;
        int j = i;
        while(j < n && a[i].F == a[j].F) {
            st.erase(st.find(a[j].S));
            vals.push_back(a[j].S);
            j ++;
        }
        if (!st.empty())
            ans = min(ans, abs(*st.rbegin() - a[i].F));
        int ff = 0;
        if (!st.empty())
            ff = *st.rbegin();
        if (vals.size() > 1) {
            for (auto ii: vals)
                ans = min(ans, abs(max(ii, ff) - a[i].F));
        }
        if (!usd.empty()){
            if (st.lower_bound(a[i].F) != st.end())
                ans = min(ans, abs(max(*st.lower_bound(a[i].F), ff) - a[i].F));
            int l = 0, r = a[i].F;
            while(r - l > 1){
                int m = (l + r) / 2;
                if (st.lower_bound(m) != st.end() && *st.lower_bound(m) < a[i].F)
                    l = m;
                else
                    r = m;
            }
            if (st.lower_bound(l) != st.end())
                ans = min(ans, abs(max(*st.lower_bound(l), ff) - a[i].F));
        }
        for (auto ii : vals)
            usd.insert(ii);
        i = j - 1;
    }
    cout << ans << '\n';
    return 0;
}