#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>


using namespace __gnu_pbds;
using namespace std;
using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

unordered_map<int, int> se;
indexed_set root;

void del(int x){
    se[x]--;
    if (se[x]!=0) return;
    root.erase(x);
}

void ins(int x){
    se[x]++;
    if (se[x]!=1) return;
    root.insert(x);
}

pair<int,int> find(int x){
    int in=root.order_of_key(x);
    pair<int,int> ans={-1e9,-1e9};
    if (in!=0) ans.first=*root.find_by_order(in-1);
    if (in!=root.size()) ans.second=*root.find_by_order(in);
    return ans;
}

signed main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    vector<pair<int, int>> w;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        w.push_back({x, y});
    }
    sort(w.begin(), w.end());
    for (int i = 0; i < n; i++) {
        ins(w[i].second);
    }
    int ma2 = -1e9, ans = 1e9;
    int last = n - 1;
    for (int i = n - 1; i > -1; i--) {
        while (w[last].first > w[i].first) {
            del(w[last].second);
            last--;
        }
        int ma1 = w[i].first;
        del(w[i].second);
        auto [l,r] = find(ma1);
        ans = min(ans, abs(max(ma2, r) - ma1));
        ans = min(ans, abs(max(ma2, l) - ma1));
        ins(w[i].second);
        ans = min(ans, abs(ma1 - ma2));
        ma2 = max(ma2, w[i].second);
    }
    cout << ans;
}