#pragma GCC optimize("O3,unroll-loops")
#pragma GCC target("avx,avx2")

#include <bits/stdc++.h>

using namespace std;

#ifdef DESPAIR101
#include "debug.h"
#define dbg(x) cerr << #x << ":\n "; debug_out::print(x); cerr << "\n"
#else
#define dbg(x)
#endif

typedef long long ll;
typedef long double ld;

// #define int ll
#define sz(x) int((x).size())

template <class A>
bool umax(A& x, A y) {
    if (x >= y) return false;
    x = y;
    return true;
}

template <class A>
bool umin(A& x, A y) {
    if (x <= y) return false;
    x = y;
    return true;
}

mt19937 rnd(101);

int solve(int n, const vector<int>& a, const vector<int>& b) {
    map<int, vector<int>> mp;
    for (int i = 0; i < n; ++i) {
        mp[a[i]].push_back(i);
    }

    vector<pair<int, vector<int>>> occ(mp.begin(), mp.end());
    int m = sz(occ);

    vector<int> smax_b(m, INT_MIN);
    for (int i = m - 1; i >= 0; --i) {
        for (int j : occ[i].second) {
            umax(smax_b[i], b[j]);
        }
        if (i + 1 < m) umax(smax_b[i], smax_b[i + 1]);
    }

    int ans = INT_MAX;

    multiset<int> cur;
    for (int i = 0; i < m; ++i) {
        for (int j : occ[i].second) {
            cur.insert(b[j]);
        }
        for (int j : occ[i].second) {
            int a_max = a[j];
            cur.extract(b[j]);
            int b_max = INT_MIN;
            if (i + 1 < m) b_max = smax_b[i + 1];
            if (b_max <= a_max) {
                auto it = cur.upper_bound(a_max);
                if (it != cur.begin()) {
                    it = prev(it);
                    if (b_max == INT_MIN || *it > b_max) {
                        b_max = *it;
                    }
                }
                if (b_max != INT_MIN) {
                    umin(ans, a_max - b_max);
                }
            }
            cur.insert(b[j]);
        }
    }

    return ans;
}

int main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int T = 1;
    // cin >> T;

    while (T--) {
        int n;
        cin >> n;

        vector<int> a(n), b(n);
        for (int i = 0; i < n; ++i) {
            cin >> a[i] >> b[i];
        }

        cout << min(solve(n, a, b), solve(n, b, a)) << '\n';
    }
}