#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

void resolve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> src(n);
    for (auto &item: src) {
        cin >> item.first >> item.second;
    }

    if (n > 5000) {
        sort(src.begin(), src.end());
        cout << src[n - 1].first - src[n - 2].first << '\n';
    }

    ll res = 1e18;
    for (ll i = 0; i < n; ++i) {
        ll ai = src[i].first;
        set<ll> canB;
        ll maxB = -1e18;
        for (ll j = 0; j < n; ++j) {
            if (j == i) {
                continue;
            }

            if (src[j].first > src[i].first) {
                maxB = max(maxB, src[j].second);
            } else {
                canB.insert(src[j].second);
            }
        }

        res = min(res, abs(ai - maxB));
        for (const auto &item: canB) {
            if (item >= maxB) {
                res = min(res, abs(ai - item));
            }
        }
    }

    cout << res << '\n';
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    resolve();
    return 0;
}
