//#pragma GCC optimize("Ofast")
#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>
#include <set>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    vector<pair<int, int>> v(n, {0, 0});
    for (int i = 0; i < n; i++) {
        cin >> v[i].first >> v[i].second;
    }
    sort(v.rbegin(), v.rend());

    int lmax = (int) -1;
    set<int> right_m;
    set<int> right;
    for (int i = 1; i < n; i++) {
        right.insert(v[i].second);
        right_m.insert(-v[i].second);
    }
    int ans=  (int) 2e9;
    for (int i = 0; i < n; i++) {
        auto it = right.lower_bound(v[i].first);
        auto it2 = right_m.lower_bound(-v[i].first);

        int num1 = (int) -2e9 - 100;
        int num2 = (int) -2e9 - 100;
        if (it != right.end()) {
            num1 = *it;
        }
        if (it2 != right_m.end()) {
            num2 = -(*it2);
        }

        int now = lmax;
        if (abs(num1 - v[i].first) <= abs(num2 - v[i].first)) {
            now = max(now, num1);
        } else {
            now = max(now, num2);
        }
        ans = min(ans, abs(v[i].first - now));

        lmax = max(lmax, v[i].second);
        if (i + 1 < n) {
            right.erase(v[i + 1].second);
            right_m.erase(-v[i + 1].second);
        }
    }
    cout << ans << endl;
}
