#include <iostream>
#include <vector>
#include <random>
#include <set>
//#define int long long
typedef long long ll;
using namespace std;

//
// mt19937 rnd(time(0));

void solve() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    vector<pair<int, int>> v(2 * n);
    vector<bool> a_used(n), b_used(n);
    multiset<int> a_st, b_st;
    for (int i = 0; i < n; i++) {
        int x, y;
        cin >> x >> y;
        a_st.insert(x);
        b_st.insert(y);
        a[i] = x;
        b[i] = y;
        v[i] = {x, i};
        v[i + n] = {y, i + n};
    }

    sort(v.rbegin(), v.rend());
    int ans = 1e9;
    for (int i = 0; i < n; i++) {
        int ind = v[i].second;
        if (ind < n) {
            if (!b_used[ind]) {
                b_st.erase(b_st.find(b[ind]));
                ans = min(ans, abs(*a_st.rbegin() - *b_st.rbegin()));
//                cout << i << " : " << *a_st.rbegin() << " " << *b_st.rbegin() << endl;
                b_st.insert(b[ind]);
                a_st.erase(a_st.find(v[i].first));
                a_used[ind] = 1;
            }
        } else {
            ind -= n;
            if (!a_used[ind]) {
                a_st.erase(a_st.find(a[ind]));
                ans = min(ans, abs(*a_st.rbegin() - *b_st.rbegin()));
//                cout << i << " : " << *a_st.rbegin() << " " << *b_st.rbegin() << endl;
                a_st.insert(a[ind]);

                b_st.erase(b_st.find(v[i].first));
                b_used[ind] = 1;
            }
        }
    }

    cout << ans;

}

signed main () {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
//
//vect a.x * b.y - b.x * a.y
//scal a.x * b.x + a.y * b.y
