#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())

using namespace std;

typedef long long ll;
typedef pair <int, int> pii;

template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }

mt19937 rng(1251);

inline void solve () {
    int n; cin >> n;
    vector <pii> a (n);
    for (auto &[x, y] : a) cin >> x >> y;

    sort(all(a));

    vector <int> mx (n + 1);
    mx[n - 1] = a[n - 1].sc;
    for (int i = n - 2; ~i; --i) {
        mx[i] = max(mx[i + 1], a[i].sc);
    }

    set <int> s;
    int ans = 2e9;
    for (int i = 0; i < n; ++i) {
        int mx2 = mx[i + 1];
        pii bst = {2e9, -1};
        auto [x, y] = a[i];
        auto it = s.upper_bound(x);
        if (it != s.end()) umin(bst, {abs(*it - x), *it});
        if (it != s.begin()) {
            --it;
            umin(bst, {abs(*it - x), *it});
        }
        umax(mx2, bst.sc);
        umin(ans, abs(x - mx2));
        s.insert(y);
    }

    for (auto &[x, y] : a) swap(x, y);
    sort(all(a));
    s.clear(); fill(all(mx), 0);

    mx[n - 1] = a[n - 1].sc;
    for (int i = n - 2; ~i; --i) {
        mx[i] = max(mx[i + 1], a[i].sc);
    }

    for (int i = 0; i < n; ++i) {
        int mx2 = mx[i + 1];
        pii bst = {2e9, -1};
        auto [x, y] = a[i];
        auto it = s.upper_bound(x);
        if (it != s.end()) umin(bst, {abs(*it - x), *it});
        if (it != s.begin()) {
            --it;
            umin(bst, {abs(*it - x), *it});
        }
        umax(mx2, bst.sc);
        umin(ans, abs(x - mx2));
        s.insert(y);
    }

    cout << ans << endl;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; // cin >> t;
    while (t--) solve();
    return 0;
}
