#include <bits/stdc++.h>

using namespace std;
#define int long long
#define ll long long
#define dl long double
#define pii pair<int, int>
#define sz(v) (int) v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
int n, N;
vector<int> B, MN, MX;

void solve() {
	cin >> n;
	vector<pii > c(n);
	for (auto&[a, b]: c)cin >> a >> b;
	sort(all(c));
	for (int i = 0; i < n; ++i) {
		B.push_back(c[i].second);
	}
	MN.resize(n + 1), MX.resize(n + 1);
	MN[n] = -inf, MX[n] = inf;
	MN[n - 1] = B[n - 1], MX[n - 1] = B[n - 1];
	for (int i = n - 2; i >= 0; --i) {
		MN[i] = min(MN[i + 1], B[i]);
		MX[i] = max(MX[i + 1], B[i]);
	}
	int ans = inf;
	set<int> var;
	for (int i = 0; i < n;) {
		auto[a, b] = c[i];
		int i2 = i;
		while (i < n && c[i].first == a) i++;
		if (i - i2 > 1) {
			while (i2 < i) var.insert(c[i2++].second);
		}
		int mx = MX[i], mn = MN[i];
		if (mx < a) mx = inf;
		if (mn > a) mn = -inf;
		if (mx == inf) {
			auto it = var.lower_bound(a);
			if (it != var.end())mx = *it;
		}
		if (mn == -inf) {
			auto it = var.upper_bound(a);
			if (it != var.begin())mn = *--it;
		}
		int res = 0;
		if (mx != inf) res = mx - a;
		if (mn != -inf) res = max(res, a - mn);
		ans = min(ans, res);
		while (i2 < i) var.insert(c[i2++].second);
	}
	cout << ans;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	int _ = 1;
	//cin>>_;
	while (_--) {
		solve();
		cout << '\n';
	}
	return 0;
}
