#include <iostream>
#include <fstream>
#include <iomanip>
#include <algorithm>
#include <cmath>
#include <random>
#include <vector>
#include <string>
#include <map>
#include <unordered_map>
#include <set>
#include <unordered_set>
#include <bitset>

#pragma warning(disable: 4996)

typedef long long ll;
typedef long double ld;

using namespace std;

#define vec vector
#define pii pair<int, int>
#define pll pair<ll, ll>

ll const mod = 1e9 + 7;
ll const INF = 2e9;
ll const LINF = 4e18;
ll const mod1 = 1000575179;

void solve() {
    int n; cin >> n;
    vec<pll> qwe(n);
    for (int i = 0; i < n; i++) {
        cin >> qwe[i].first >> qwe[i].second;
    }

    set<vec<ll>> prs;
    for (int i = 0; i < n; i++) {
        prs.insert({qwe[i].first, qwe[i].second, i});
    }

    set<vec<ll>> now;
    ll ans = LINF;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
            if (i != j) {
                now.insert({abs(qwe[i].first - qwe[j].second), i, j});
            }
        }
    }
    for (auto elem : now) {
        int i = elem[1];
        int j = elem[2];
        auto tmp = prs.upper_bound({qwe[i].first, qwe[j].second, -1});
        bool ok = 1;
        if (tmp == prs.end()) {
            cout <<  elem[0] << "\n";
            exit(0);
        }
        if ((*tmp)[2] == i || (*tmp)[2] == j) {
            tmp++;
        }
        if (tmp == prs.end()) {
            cout << elem[0] << "\n";
            exit(0);
        }
        if ((*tmp)[2] == i || (*tmp)[2] == j) {
            tmp++;
        }
        if (tmp == prs.end()) {
            cout << elem[0] << "\n";
            exit(0);
        }
        
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

#ifdef _DEBUG
    freopen("input.txt", "r", stdin);
#endif // _DEBUG

    int tests = 1;
    // cin >> tests;

    while (tests--) {
        solve();
    }
}