#include <iostream>
#include "vector"
#include "set"
#include "random"
#include "map"
#include "string"
#include "math.h"
#include "algorithm"
#define all(a) a.begin(), a.end()
#define ll long long
#define len(a) (int)a.size()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fort(a, b) for(int a = 0; a < b; a++)
#define f first
#define s second
#define rd (int)ran()
using namespace std;

mt19937 ran;
int mod = 1e9+7;
int modsum(int a, int b){
    if(a + b < mod){
        return a + b;
    }
    return a + b - mod;
}
int modrazn(int a, int b){
    if(a - b < 0){
        return a - b + mod;
    }
    return a - b;
}
int modmult(int a, int b){
    return (int)1ll*a*b%mod;
}
int modpow(int a, int n){
    if(n == 0){
        return 1;
    }
    if(n % 2 == 0){
        return modpow(modmult(a,a), n/2);
    }
    return modmult(a, modpow(a, n - 1));
}
int moddel(int a, int b){
    return modmult(a, modpow(b, mod - 2));
}

struct dots {
    int x, y;
};
int scalar(dots a, dots b){
    return a.x*b.x + a.y*b.y;
}
int psevd(dots a, dots b){
    return a.x * b.y - a.y * b.x;
}

vector<pii> b, a;

ll bp(pii n){
    int l = 2, r = len(b) - 3;
    while(l < r){
        int m = (l + r)/2;
        if(b[m].f < n.first){
            l = m + 1;
        } else{
            r = m;
        }
    }
    if(b[l].s == n.s){
        return min(min(abs(n.f - b[l - 1].f),abs(n.f - b[l - 2].f)), min(abs(n.f - b[l + 1].f),abs(n.f - b[l + 2].f)));
    }
    else if(b[l + 1].second == n.s){
        return min(min(abs(n.f - b[l - 1].f),abs(n.f - b[l - 2].f)), min(abs(n.f - b[l].f),abs(n.f - b[l + 2].f)));
    }
    else if(b[l + 2].second == n.s){
        return min(min(abs(n.f - b[l - 1].f),abs(n.f - b[l - 2].f)), min(abs(n.f - b[l].f),abs(n.f - b[l + 1].f)));
    }
    else if(b[l - 2].second == n.s){
        return min(min(abs(n.f - b[l - 1].f),abs(n.f - b[l + 2].f)), min(abs(n.f - b[l].f),abs(n.f - b[l + 1].f)));
    }
    else if(b[l - 1].second == n.s){
        return min(min(abs(n.f - b[l - 2].f),abs(n.f - b[l + 2].f)), min(abs(n.f - b[l].f),abs(n.f - b[l + 1].f)));
    } else{
        return min(min(min(abs(n.f - b[l - 2].f),abs(n.f - b[l + 2].f)), min(abs(n.f - b[l].f),abs(n.f - b[l + 1].f))), abs(n.f - b[l - 1].f));
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    ll n;
    cin >> n;
    a.resize(n);
    b.resize(n + 4);
    fort(i, n){
        cin >> a[i].f >> b[i + 2].f;
        a[i].s = i;
        b[i + 2].s = i;
    }
    b[0].f = -10000000, b[n + 2].f = -10000000;
    b[1].f = -10000000, b[n + 3].f = -10000000;
    b[0].s = -10000000, b[n + 2].s = -10000000;
    b[1].s = -10000000, b[n + 3].s = -10000000;
    sort(b.begin() + 2, b.end() - 2);
    ll ans = INT32_MAX;
    fort(i, n){
        int temp = bp(a[i]);
        ans = min(ans, bp(a[i]));
    }
    cout << ans;
}
