#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>

using namespace std;

long long find(long long x, const vector<vector<long long>>& vect) {
	long long L = 0; long long R = vect.size(), c;
	while (R - L > 1) {
		c = (R + L) / 2;
		if (vect[c][0] <= x) {
			L = c;
		}
		else {
			R = c;
		}
	}
	return L;
}

void solve() {
	long long n, inp;
	vector<vector<long long>> a, b;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> inp;
		a.push_back({inp, i});
		cin >> inp;
		b.push_back({inp, i});
	}

	sort(a.begin(), a.end());

	long long mn = 1e18;
	for (int i = 0; i < n; ++i) {
		inp = find(b[i][0], a);
		mn = min(mn, abs(a[(inp + 1) % n][0] - b[i][0]));
		mn = min(mn, abs(a[(inp - 1 + n) % n][0] - b[i][0]));
		if (a[inp][1] != b[i][1]) {
			mn = min(mn, abs(a[inp][0] - b[i][0]));
		}
	}
	cout << mn << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();

	return 0;
}