#include <iostream>
#include <vector>
#include <set>
#include <iomanip>
#include <algorithm>

using namespace std;

long long find(long long x, const vector<vector<long long>>& vect) {
	long long L = 0; long long R = vect.size(), c;
	while (R - L > 1) {
		c = (R + L) / 2;
		if (vect[c][0] <= x) {
			L = c;
		}
		else {
			R = c;
		}
	}
	return L;
}

void solve() {
	long long n, inp, mn = 1e18;
	vector<vector<long long>> a, b, vect;
	cin >> n;
	for (int i = 0; i < n; ++i) {
		cin >> inp;
		a.push_back({inp, i});
		vect.push_back({inp});
		cin >> inp;
		b.push_back({inp, i});
		vect[i].push_back(inp);
	}

	sort(a.begin(), a.end());
	sort(b.begin(), b.end());
	char flag;

	for (int i = n - 1; i > -1; --i) {
		inp = find(a[i][0], b);
		for (int j = 0; j < n; ++j) {
			if (abs(a[i][0] - b[j][0]) >= mn) {
				if (b[j][0] < a[i][0]) {continue;}
				else {break;}
			}
			flag = 1;
			for (int k = i + 1; k < n; ++k) {
				if (a[i][0] < a[k][0] && b[j][0] < b[a[k][1]][0]) {
					flag = 0;
					break;
				}
			}
			for (int k = j + 1; k < n; ++k) {
				if (a[i][0] < a[b[k][1]][0] && b[j][0] < b[k][0]) {
					flag = 0;
					break;
				}
			}
			if (flag) {
				mn = min(mn, abs(a[i][0] - b[j][0]));
			}
		}
	}
	cout << mn << endl;
}

signed main() {
	ios::sync_with_stdio(false);
	cin.tie(0);cout.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	solve();

	return 0;
}