#include <bits/extc++.h>
using namespace std;
using namespace __gnu_pbds;
#define int long long
const int maxn = 1 << 19;
const int inf = 2e9;
const int mod = 1e9 + 7;

int bp(long long x, int n = mod - 2) {
    long long res = 1;
    while (n) {
        if (n & 1) {
            res *= x;
            res %= mod;
        }
        x *= x;
        x %= mod;
        n >>= 1;
    }
    return res;
}

int gcd(int a, int b) {
    if (!b) return a;
    return gcd(b, a % b);
}

int f[maxn];

int get(int i) {
    int ans = -inf;
    while (i >= 0) {
        ans = max(ans, f[i]);
         i = (i & (i + 1)) - 1;
    }
    return ans;
}

void upd(int i, int x) {
    while (i < maxn) {
        f[i] = max(f[i], x);
        i = i | (i + 1);
    }
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i].first >> a[i].second;
    }
    sort(a.rbegin(), a.rend());
    int ans = inf;
    for (int i = 0; i < n; ++i) {
        upd(i, a[i].second);
    }
    set<int> s;
    for (int i = 0; i < n; ++i) {
        s.insert(a[i].second);
    }
    for (int i = 0; i < n; ++i) {
        ans = min(ans, abs(a[i].first - get(i - 1)));
        s.erase(a[i].second);
        int q = -inf;
        auto pt = s.upper_bound(a[i].first);
        if (pt != s.begin()) {
            --pt;
            q = *pt;
        }
        ans = min(ans, abs(a[i].first - max(get(i - 1), q)));
        if (pt != s.end()) {
            ++pt;
            if (pt != s.end()) {
                q = *pt;
            }
        }
        ans = min(ans, abs(a[i].first - max(get(i - 1), q)));
    }
    cout << ans;
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    t = 1;
    while (t--) {
        solve();
    }
    return 0;
}
