#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
#include <random>
#include <set>

using namespace std;

#define ll long long

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);


	int n;
	cin >> n;

	vector<int> a(n), b(n);

	multiset <int> st, st1;
	vector<pair<int, int>> p;
	for (int i = 0; i < n; i++) {
		cin >> a[i] >> b[i];
		st.insert(b[i]);
		st1.insert(-b[i]);

		p.push_back({ a[i], b[i] });
	}

	sort(p.begin(), p.end());
	reverse(p.begin(), p.end());
	int ans = 1e9;
	for (int i = p.size() - 1; i >= 1; i--) {
		int mx = p[i].first;
		st.erase(p[i].second);
		st1.erase(-p[i].second);
		if (st.lower_bound(mx) != st.end()) ans = min(ans, abs(mx - (*st.lower_bound(mx))));
		if (st1.lower_bound(-mx) != st1.end())ans = min(ans, abs(mx + (*st1.lower_bound(-mx))));
	}
	cout << ans;

	
	
	return 0;
}