#include <bits/stdc++.h>

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n;
    std::cin >> n;
    std::vector<std::pair<int, int>> input(n);
    for (auto& [a, b] : input) {
        std::cin >> a >> b;
    }

    std::vector<int> ord_a(n);
    std::iota(ord_a.begin(), ord_a.end(), 0);
    std::sort(ord_a.begin(), ord_a.end(), [&](int a, int b) { return input[a].first < input[b].first; });

    std::multiset<int> sec, opt;
    for (int i = 0; i < n; i++) {
        sec.insert(input[i].second);
    }

    int ans = 1e9;

    for (int i : ord_a) {
        sec.extract(input[i].second);
        opt.insert(input[i].second);

        int res = 1e9;
        if (!sec.empty())
            res = abs(sec.rbegin().operator*() - input[i].second);

        if (sec.empty() || sec.rbegin().operator*() < input[i].second) {
            auto it = opt.lower_bound(input[i].second);
            if (it != opt.end()) {
                res = std::min(res, abs(input[i].second - *it));
            }
            if (it != opt.begin()) {
                res = std::min(res, abs(input[i].second - *std::prev(it)));
            }
        }
        ans = std::min(ans, res);
    }

    std::cout << ans << "\n";

    return 0;
}
