#include <bits/stdc++.h>

using namespace std;

const int INF = 1e9;
const int MOD = 1e9 + 7;

inline void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for (auto& i : a) {
        cin >> i.first >> i.second;
    }
    sort(a.begin(), a.end(), [](pair<int, int> f, pair<int, int> s) {
        if (f.second == s.second) {
            return f.first < s.first;
        }
        return f.second < s.second;
    });
    multiset<int> s;
    for (auto i : a)
        s.insert(i.first);
    int ans = INF, ma = -INF;
    for (int i = 0; i < n; ++i) {
        s.erase(s.find(a[i].first));
        if (i == 0) {
            ma = max(ma, a[i].first);
            continue;
        }
        auto it = s.lower_bound(a[i].second);
        ans = min(ans, abs(ma - a[i].second));
        if (it != s.end()) {
            ans = min(ans, abs(*it - a[i].second));
        }
        if (it != s.begin()) {
            it = prev(it);
            if (it != s.end()) {
                ans = min(ans, abs(*it - a[i].second));
            }
        }
        ma = max(ma, a[i].first);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#ifdef LOCAL
    auto f1 = freopen("input.txt", "r", stdin);
    auto f2 = freopen("output.txt", "w", stdout);
#endif
    int tests = 1;
#ifdef LOCAL
    cin >> tests;
#endif
    for (int i = 1; i <= tests; ++i)
        solve();
}
