#include <bits/stdc++.h>

using namespace std;

using ll = long long;

const ll N = 2e5, mod = 1e9 + 7, INF = 1e18;

pair<ll, ll> get(vector<ll>& a, ll x){
    pair<ll, ll> ans;
    ll l = -1, r = (ll)a.size();
    while(r - l > 1){
        ll mid = (l + r) / 2;
        if(a[mid] <= x){
            l = mid;
        } else {
            r = mid;
        }
    }
    if(l == -1){
        ans.first = -1;
    } else {
        ans.first = a[l];
    }
    if(r == (ll)a.size()){
        ans.second = -1;
    } else {
        ans.second = a[r];
    }
    return ans;
}

void add(vector<ll>& a, ll x){
    ll l = -1, r = (ll)a.size();
    while(r - l > 1){
        ll mid = (l + r) / 2;
        if(a[mid] <= x){
            l = mid;
        } else {
            r = mid;
        }
    }
    a.insert(a.begin() + l + 1, x);
}

void solve() {
    ll n;
    cin >> n;
    vector<pair<ll, ll>> v(n);
    for(ll i = 0; i < n; i++){
        cin >> v[i].first >> v[i].second;
    }
    sort(v.begin(), v.end());
    vector<ll> pref(n), cur;
    pref[n - 1] = v[n - 1].second;
    for(ll i = n - 2; i >= 0; i--){
        pref[i] = max(pref[i + 1], v[i].second);
    }
    ll ans = INF;
    for(ll i = 0; i < n; i++){
        ll mx = -1;
        if(i != n - 1){
            mx = pref[i + 1];
        }
        pair<ll, ll> p = get(cur, v[i].first);
        ll l = p.first, r = p.second;
        if(mx >= l && mx >= r){
            ans = min(ans, abs(mx - v[i].first));
        } else if(mx >= l && mx <= r){
            if(mx != -1){
                ans = min(ans, abs(mx - v[i].first));
            }
            if(r != -1){
                ans = min(ans, abs(r - v[i].first));
            }
        } else if(mx >= r && mx <= l){
            if(mx != -1){
                ans = min(ans, abs(mx - v[i].first));
            }
            if(l != -1){
                ans = min(ans, abs(l - v[i].first));
            }
        } else {
            if(l != -1){
                ans = min(ans, abs(l - v[i].first));
            }
            if(r != -1){
                ans = min(ans, abs(r - v[i].first));
            }
        }
        add(cur, v[i].second);
    }
    cout << ans;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    ll t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
}
