#include <bits/stdc++.h>

#define x first
#define y second
#define assert(x) if(!x) cout << "assert:" << #x << endl; exit(1);

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define int ll
#define double ld

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream& operator<<(ostream& os, vector<T> & v) {
    for (auto& e : v)
        os << e << " ";
    return os;
}

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> arr(n);
    for (auto & e : arr)
        cin >> e.x >> e.y;

    sort(all(arr));
    multiset<pair<int, int>> ms;
    multiset<pair<int, int>> ms2;
    for (auto & e : arr) {
        ms.insert({e.y, e.x});
        ms2.insert({-e.y, e.x});
    }

    int u = -INF;

    int ans = INF;

    for (int i = n - 1; i >= 0; --i) {
        ms.erase(ms.find({arr[i].y, arr[i].x}));
        ms2.erase(ms2.find({-arr[i].y, arr[i].x}));

        if (i != n - 1) {
            u = max(u, arr[i + 1].y);
        }

        auto e = ms.lower_bound({arr[i].x, -1});
        if (e != ms.end())
            ans = min(ans, e->x - arr[i].x);

        auto e2 = ms2.lower_bound({-arr[i].x, -1});
        if (e2 != ms2.end())
            ans = min(ans, arr[i].x + e2->x);

        ms.insert({arr[i].y, arr[i].x});
        ms2.insert({-arr[i].y, arr[i].x});
    }

    cout << ans << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    solve();

    return 0;
}
