#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("Ofast")
#pragma GCC optimize ("unroll-loops")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 2e5 + 5;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);

void solve() {
    int n;
    cin >> n;
    vector<pair<int, int>> a(n);
    for(auto &[x, y] : a) {
        cin >> x >> y;
    }
    sort(all(a));
    vector<int> suff(n + 1, -inf);
    for(int i = n - 1; ~i; i--) {
        suff[i] = a[i].s;
        umax(suff[i], suff[i + 1]);
    }
    set<int> s;
    int ans = inf;
    for(int i = 0; i < n; i++) {
        int m1 = a[i].f;
        int m2 = suff[i + 1];
        if(m2 < m1) {
            auto it = s.lower_bound(m1);
            if(it != s.end()) {
                if(m1 - m2 > (*it) - m1) m2 = (*it);
            }
            if(it != s.begin()) {
                --it;
                if(m1 - m2 > m1 - (*it)) m2 = (*it);
            }
        }
        umin(ans, abs(m1 - m2));
        s.insert(a[i].s);
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
