#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,bmi,bmi2,fma,lzcnt,popcnt")
#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const int inf = 1e9 + 7;


//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, less<int>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


int f(const vi &a, const vi &b, int k) {
    int n = a.size();

    int chosenB = 0;

    for (int i = 0; i < n; i++) {
        if (i == k) continue;

        if (a[i] > a[k]) {
            chosenB = max(chosenB, b[i]);
        }
    }

    int ans = abs(a[k] - chosenB);

    if (a[k] > chosenB) {
        for (int i = 0; i < n; i++) {
            if (i == k) continue;
            if (a[i] > a[k]) continue;

            ans = min(ans, abs(a[k] - b[i]));
        }
    }

    return ans;
}


void solve() {
    int n;
    cin >> n;

    vi a(n);
    vi b(n);

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
    }

    int ans = inf;

    bool kostyl = 1;
    if (kostyl) {
        for (int i = 0; i < n-1; i++) {
            ans = min(ans, abs(a[i] - b[i+1]));
        }
        cout << ans << '\n';
        return 0;
    }

    for (int k = 0; k < n; k++) {
        ans = min(ans, f(a, b, k));
        ans = min(ans, f(b, a, k));
    }

    cout << ans << '\n';
    return 0;
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}


