#pragma GCC optimize("Ofast,unroll-loops,fast-math,no-stack-protector")
#pragma GCC target("avx,avx2,sse,sse2,sse3,ssse3,sse4,sse4.1,bmi,bmi2,fma,lzcnt,popcnt")
#include<bits/stdc++.h>
using namespace std;

#define ff first
#define ss second
#define all(x) x.begin(),x.end()
#define rall(x) x.rbegin(),x.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
typedef vector<int> vi;
typedef vector<vi> vvi;
typedef pair<int, int> pii;
typedef vector<pii> vpii;
typedef vector<vpii> vvpii;
typedef pair<ll, ll> pll;
typedef vector<pll> vpll;
typedef vector<vpll> vvpll;
typedef vector<bool> vb;
const int inf = 1e9 + 7;


//#include<ext/pb_ds/assoc_container.hpp>
//#include<ext/pb_ds/tree_policy.hpp>
//using namespace __gnu_pbds;
//typedef tree<int, less<int>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;


int f(const vi &a, const vi &b) {
    int n = a.size();


    map<int, vi> c;
    for (int i = 0; i < n; i++) {
        c[a[i]].push_back(i);
    }

    multiset<int> unchosenB;
    for (int i = 0; i < n; i++) {
        unchosenB.insert(b[i]);
    }
    int chosenB = 0;


    int ans = inf;

    for (auto it = c.rbegin(); it != c.rend(); it++) {
        int val = it->ff;

        if (val > chosenB) {
            auto it_tmp = unchosenB.lower_bound(val);

            if (it_tmp != unchosenB.end()) {
                ans = min(ans, abs(val - *it_tmp));
            }
            if (it_tmp != unchosenB.begin()) {
                it_tmp--;
                ans = min(ans, abs(val - *it_tmp));
            }
        }

        ans = min(ans, abs(val - chosenB));

        for (int i : it->ss) {
            chosenB = max(chosenB, b[i]);
            unchosenB.erase(unchosenB.find(b[i]));
        }
    }

    return ans;
}


void solve() {
    int n;
    cin >> n;

    vi a(n);
    vi b(n);

    bool kostyl = true;

    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];

        kostyl &= (a[i] == b[i]);
    }

    int ans = inf;

    if (kostyl) {
        sort(all(a));
        cout << a[n-1] - a[n-2] << '\n';
        return;
    }

    ans = min(f(a, b), f(b, a));

    cout << ans << '\n';
}


int main() {
    ios_base::sync_with_stdio(0); cin.tie(); cout.tie();

    int t = 1;
    // cin >> t;

    while (t--) {
        solve();
    }
}


