#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

mt19937 gen(572);

long long stupid(vector<Pair> a) {
    ll n = (ll) a.size();
    ll ans = INF;
    for (ll mask = 0; mask < (1 << n); mask++) {
        ll mx1 = -INF, mx2 = -INF;
        for (ll i = 0; i < n; i++) {
            if ((mask >> i) & 1) mx1 = max(mx1, a[i].first);
            else mx2 = max(mx2, a[i].second);
        }
        ans = min(ans, abs(mx1 - mx2));
    }
    return ans;
}

long long smart(vector<Pair> a) {
    ll n = (ll) a.size();
    sort(a.begin(), a.end());
    multiset<ll> pref, suff;
    for (ll i = 0; i < n; i++) suff.insert(a[i].second);
    ll ans = INF;
    for (ll i = 0; i < n; i++) {
        suff.erase(suff.find(a[i].second));
        ll mx_suff;
        if (!suff.empty()) mx_suff = *suff.rbegin();
        else mx_suff = -INF;
        ll mx_pref;
        if (!pref.empty()) mx_pref = *pref.rbegin();
        else mx_pref = -INF;
        if (mx_suff > mx_pref) {
            ans = min(ans, abs(a[i].first - mx_suff));
        } else {
            ans = min(ans, abs(a[i].first - mx_suff));
            if (!pref.empty()) {
                auto it = pref.lower_bound(a[i].first);
                if (it != pref.end() && *it >= mx_suff) {
                    ans = min(ans, abs(a[i].first - *it));
                    if (it != pref.begin()) {
                        auto it1 = it;
                        it1--;
                        if (*it1 >= mx_suff) {
                            ans = min(ans, abs(a[i].first - *it1));
                        }
                    }
                } else {
                    it--;
                    if (*it >= mx_suff) {
                        ans = min(ans, abs(a[i].first - *it));
                    }
                }
            }
        }
        pref.insert(a[i].second);
    }
    return ans;
}

signed main() {
 //   ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n;
    cin >> n;
    vector<Pair> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i].first >> a[i].second;
    sort(a.begin(), a.end());
    multiset<ll> pref, suff;
    for (ll i = 0; i < n; i++) suff.insert(a[i].second);
    ll ans = INF;
    for (ll i = 0; i < n; i++) {
        suff.erase(suff.find(a[i].second));
        ll mx_suff;
        if (!suff.empty()) mx_suff = *suff.rbegin();
        else mx_suff = -INF;
        ll mx_pref;
        if (!pref.empty()) mx_pref = *pref.rbegin();
        else mx_pref = -INF;
        if (mx_suff > mx_pref) {
            ans = min(ans, abs(a[i].first - mx_suff));
        } else {
            ans = min(ans, abs(a[i].first - mx_suff));
            if (!pref.empty()) {
                auto it = pref.lower_bound(a[i].first);
                if (it != pref.end() && *it >= mx_suff) {
                    ans = min(ans, abs(a[i].first - *it));
                    if (it != pref.begin()) {
                        auto it1 = it;
                        it1--;
                        if (*it1 >= mx_suff) {
                            ans = min(ans, abs(a[i].first - *it1));
                        }
                    }
                } else {
                    it--;
                    if (*it >= mx_suff) {
                        ans = min(ans, abs(a[i].first - *it));
                    }
                }
            }
        }
        pref.insert(a[i].second);
    }
    return 0;
}