#pragma GCC optimize("Ofast,unroll-loops")
#pragma GCC target("avx,avx2,sse,sse2,sse3")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <numeric>
#include <cassert>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;
using ll = long long;
using ld = long double;


int get(int mx, int a){
    if (mx == -1){
        return 0;
    }
    return abs(mx - a);
}

int ans(vector<int> &a, vector<int> &b){
    int n = a.size();
    int mn = 1000001303;
    for (int mask = 0; mask < (1 << n); ++mask) {
        int mask1 = mask;
        int mx[2] = {-1000001303, -1000001303};
        for (int i = 0; i < n; ++i) {
            if (mask1 % 2){
                mx[1] = max(mx[1], b[i]);
            } else{
                mx[0] = max(mx[0], a[i]);
            }
            mask1 /= 2;
        }
        mn = min(mn, abs(mx[0] - mx[1]));
    }
    return mn;
}

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> c(n);
    vector<pair<int, int>> b(n);
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i].first;
        c[i] = b[i].first;
        b[i].second = i;
        v[i] = {a[i], i};
//        cin >> v[i].first >>i v[i].second;
    }
    int kkk = ans(a, c);
    sort(b.begin(), b.end());
    map<int, int> cnt;
    for (int i = 0; i < n; ++i) {
        cnt[c[i]]++;
    }
//    sort(v.rbegin(), v.rend());
    sort(v.begin(), v.end());
    int mn = 1e9;
    vector<int> mx(n);
    mx[n - 1] = c[v[n - 1].second];
    for (int i = n - 2; i >= 0; --i){
        mx[i] = max(c[v[i].second], mx[i + 1]);
    }
    for (int i = 0; i < n; ++i){
        int aa = v[i].first;
        int suff = 2e9;
        if (i < n - 1){
            suff = mx[i + 1];
        }
        mn = min(mn, abs(aa - suff));
        if (suff < aa || suff == 2e9){
            int it = lower_bound(b.begin(), b.end(), make_pair(aa, 0)) - b.begin();
            for (int j = max(it - 2, 0); j <= min(it + 1, n - 1); ++j){
                if (b[j].second != v[i].second){
                    mn = min(mn, abs(aa - b[j].first));
                }
            }
        }
    }
    cout << mn << endl;
    cout << kkk << endl;
    assert(mn == kkk);
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}