#include <iostream>
#include<iomanip>
#include <numeric>
#include<cmath>
#include<vector>
#include<map>
#include <queue>
#include<initializer_list>
typedef long long ll;
using namespace std;
typedef pair<ll, ll> ii;
typedef vector<ll> vi;

void solve2() {
	int n; cin >> n;
	vector<int> workmass;
	vector<pair<int, int>> mass;
	for (int i = 0; i < n; i++) {
		int a, b; cin >> a >> b;
		workmass.push_back(a);
		mass.push_back(make_pair(b, i));
	}
	sort(mass.begin(), mass.end());
	int ans = 1999999999, tempoans;
	for (int i = 0; i < n; i++) {
		tempoans = 1999999999;
		auto it = lower_bound(mass.begin(), mass.end(), make_pair(workmass[i], 0));
		int idex = distance(mass.begin(), it);
		if (mass[idex].second == i) {
			if (idex > 0)tempoans = abs(workmass[i] - mass[idex-1].first);
			if (idex < n - 1)tempoans = min(tempoans, abs(workmass[i] - mass[idex + 1].first));
		}
		else {
			tempoans = abs(workmass[i] - mass[idex].first);
			if(idex>0)tempoans = min(tempoans, abs(workmass[i] - mass[idex - 1].first));
		}
		ans = min(ans, tempoans);
	}
	cout << ans;
	
}

int main() {
	ios::sync_with_stdio(0); cin.tie(0); cout.tie(0); solve2();
}