	#include <bits/stdc++.h>
	#define newline cout << '\n'
	#define f first
	#define s second
	#define all(x) x.begin(), x.end()


	using namespace std;
	typedef long long ll;
	typedef long double ld;


	const int inf = 2e9;
	const int logn = 22;
	const int nmax = 1e5 + 5;
	const ll linf = 2e18;
	mt19937 rnd(time(0));


	void display(vector<int> a) {
		cout << linf << '\n';
		for (auto i : a) {
			cout << i << ' ';
		}
		newline;
	}

	bool cmp(pair<int, int> a, pair<int, int> b) {
		return (a.s < b.s || (a.s == b.s && a.f >= b.f));
	}


	void solve() {
		int n;
		cin >> n;
		ll ans = linf, maxa = -linf, maxb = -linf;
		vector<pair<ll, ll>> a(n);

		for (int i = 0; i < n; ++i) {
			cin >> a[i].f >> a[i].s;
			maxa = max(maxa, a[i].f);
			maxb = max(maxb, a[i].s);
		}

		ans = maxa;

		sort(all(a), cmp);

		vector<ll> max_suf(n + 1, 0);
		for (int i = n - 1; i > -1; --i) {
			max_suf[i] = max(max_suf[i + 1], a[i].f);
		}

		for (int i = 0; i < n; ++i) {
			ans = min(ans, abs(max_suf[i + 1] - a[i].s));
		}

		cout << ans << '\n';
	}


	int main() {
		ios_base::sync_with_stdio(0);
		cin.tie(0);

	#ifndef ONLINE_JUDGE
		freopen("input.txt", "r", stdin);
		freopen("output.txt", "w", stdout);
	#endif

		int t = 1;
		// cin >> t;

		while (t--) {
			solve();
		}

		

		return 0;
	}