#include <bits/stdc++.h>
#define newline cout << '\n'
#define f first
#define s second
#define all(x) x.begin(), x.end()


using namespace std;
typedef long long ll;
typedef long double ld;


const int inf = 2e9;
const int logn = 22;
const int nmax = 1e5 + 5;
const ll linf = 2e18;
mt19937 rnd(time(0));


bool cmp(pair<int, int> a, pair<int, int> b) {
	return (a.s < b.s || (a.s == b.s && a.f >= b.f));
}


void display(multiset<ll> &l) {
	for (auto it = l.begin(); it != l.end(); ++it) {
		cout << *it << ' ';
	}
	newline;
}

void solve() {
	int n;
	cin >> n;

	ll ans = linf;
	vector<pair<ll, ll>> a(n);

	multiset<ll> l;

	for (int i = 0; i < n; ++i) {
		cin >> a[i].f >> a[i].s;
	}

	sort(all(a), cmp);

	vector<ll> max_suf(n + 1, 0);
	for (int i = n - 1; i > -1; --i) {
		max_suf[i] = max(max_suf[i + 1], a[i].f);
	}



	for (int i = 0; i < n - 1; ++i) {
		auto lmin = l.lower_bound(a[i].s);
		auto lmax = l.upper_bound(a[i].s);
		ll tmp = linf;
		// display(l);
		if (lmin != l.end()) {
			tmp = min(tmp, abs(a[i].s - *lmin));
		}
		if (lmax != l.end()) {
			tmp = min(tmp, abs(a[i].s - *lmax));
		}
		if (tmp == linf) {
			tmp = abs(a[i].s - max_suf[i + 1]);
		}
		tmp = max(tmp, abs(a[i].s - max_suf[i + 1]));
		ans = min(ans, tmp);
		l.insert(a[i].f);
	}

	int i = n - 1;

	auto lmin = l.lower_bound(a[i].s);
	auto lmax = l.upper_bound(a[i].s);
	ll tmp = linf;
	if (lmin != l.end()) {
		tmp = min(tmp, abs(a[i].s - *lmin));
	}
	if (lmax != l.end()) {
		tmp = min(tmp, abs(a[i].s - *lmax));
	}
	if (tmp != linf) {
		ans = min(ans, tmp);
	}


	cout << ans << '\n';
}


int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);

#ifndef ONLINE_JUDGE
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif

	int t = 1;
	// cin >> t;

	while (t--) {
		solve();
	}

	

	return 0;
}