#pragma GCC target("avx2")
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int N = 2e5 + 10;
const int OO = 1e18;

bool check(int d, int n, vec<pii> &a)
{
    multiset<int> every;
    multiset<int> choice;
    for (int i = 0; i < n; i++) every.insert(a[i].s);
    bool ok = false;
    for (int i = 0; i < n; i++)
    {
        int j = i;
        while (j < n && a[j].f == a[i].f) j++;
        for (int k = i; k < j; k++)
        {
            every.erase(every.find(a[k].s));
            choice.insert(a[k].s);
        }
        bool cur = false;
        int cmx = -OO;
        for (int k = i; k < j; k++)
        {
            choice.erase(choice.find(a[k].s));
            auto it = choice.upper_bound(a[i].f + d);
            if (it != choice.begin())
            {
                --it;
                if (*it >= a[i].f - d && *it <= a[i].f + d)
                {
                    cmx = max(cmx, *it);
                }
            }
            choice.insert(a[k].s);
        }
        if (!every.empty())
        {
            int mn = *every.begin();
            int mx = *every.rbegin();
            if (max(cmx, mx) < a[i].f - d || mx > a[i].f + d) cur = false;
            else cur = true;
        }
        else
        {
            if (cmx >= a[i].f - d && cmx <= a[i].f + d) cur = true;
        }
        ok |= cur;
        if (ok) break;
        i = j - 1;
    }
    return ok;
}

void solve()
{
    int n;
    cin >> n;
    vec<pii> a(n);
    for (int i = 0; i < n; i++) cin >> a[i].f >> a[i].s;
    sort(all(a));
    int l = 0, r = 1e9;
    while (l < r)
    {
        int m = l + r >> 1;
        if (check(m, n, a)) r = m;
        else l = m + 1;
    }
    cout << l;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
