#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#include <deque>
#include <algorithm>

using namespace std;
typedef long long ll;

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n;
	cin >> n;
	vector<ll> a(n), b(n);
	bool fl = 1;
	ll mx1 = 0, mx2 = 0;
	for (int i = 0; i < n; ++i) {
		cin >> a[i] >> b[i];
		fl = fl && (a[i] == b[i]);
		if (a[i] > mx1) {
			mx2 = mx1;
			mx1 = a[i];
		}
		else if (a[i] > mx2) {
			mx2 = a[i];
		}
	}
	if (!fl) {
		vector<pair<ll, ll>> v(n);
		for (int i = 0; i < n; ++i) {
			v[i].first = a[i];
			v[i].second = b[i];
		}
		sort(v.begin(), v.end());
		vector<ll> msf(n + 1);
		for (int i = n - 1; i >= 0; --i) {
			msf[i] = max(msf[i + 1], v[i].second);
		}
		ll res = 1e9;
		set<ll> s2;
		for (int i = 0; i < n; ++i) {
			ll mx1 = msf[i+1];
			if (mx1 >= v[i].first) {
				res = min(res, abs(mx1 - v[i].first));
			}
			else {
				if (i != n - 1) {
					res = min(res, abs(v[i].first - mx1));
				}
				auto idx = s2.lower_bound(v[i].first);
				if (idx != s2.end()) {
					res = min(res, abs((*idx) - v[i].first));
				}
				if (idx == s2.begin()) {
					continue;
				}
				--idx;
				res = min(res, abs((*idx) - v[i].first));
			}
			s2.insert(v[i].second);
		}
		cout << res;
	}
	else {
		cout << mx1 - mx2;
	}
	return 0;
}