#include <iostream>
#include "cstdio"
#include "iomanip"
#include "fstream"
#include <vector>
#include <cmath>
#include <algorithm>
#include <unordered_map>
#include <set>
#include "map"

using namespace std;
#define ll long long
#define int ll

void speed() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(0);
}
const int MOD = 1e9 + 7;

struct Vec{
    int x, y;
    Vec(int a, int b){
        x = a; y = b;
    }
    Vec operator+(Vec p){
        return Vec(x + p.x, y + p.y);
    }
    Vec operator*(int k){
        return Vec(x * k, y * k);
    }
};
struct Line{
    int a, b, c;
    Line(int x, int y, int z) {
        a = z; b = y; c = z;
    }
};

int min_d(set<int> & s, int x){
    auto it = s.lower_bound(x);
    int out = 1e9;
    if (it != s.end()) out = min(out, *it - x);
    if (it != s.begin()) it--;
    if (it != s.end()) out = min(out, x - *it);
    return out;
}

void main0(){
    int n; cin >> n;
    vector<pair<int, int>> v(n);
    for (int i = 0; i < n; i++){
        cin >> v[i].first >> v[i].second;
    }
    sort(v.begin(), v.end());
    vector<int> mx(n);
    mx[n-1] = v[n-1].second;
    for (int i = n - 2; i >= 0; i--)
        mx[i] = max(v[i].second, mx[i+1]);
    int delt = 1e9;
    set<int> s;
    for (int i = 0; i < n; i++){
        if ((i == 0) || (i < n-1 && mx[i + 1] >= v[i].first)){
            delt = min(delt, abs(mx[i + 1] - v[i].first));
        } else {
            //for (int i : s) cout << i << ' '; cout << '\n';
            //cout << v[i].first << ' ';
            //cout << min_d(s, v[i].first) << '\n';
            if (i + 1 == n)delt = min_d(s, v[i].first);
            else delt = min(min_d(s, v[i].first), abs(v[i].first - mx[i + 1]));
        }

        s.insert(v[i].second);
    }
    cout << delt;
}

signed main() {
   // speed();
    cout << fixed << setprecision(10);
    int t = 1;
    while (t--){
        main0();
        cout << '\n';
    }
}
