#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <queue>
#include <unordered_set>
#include <unordered_map>
#include <algorithm>
#include <numeric>
#include <cmath>

using namespace std;

using ll = long long;
using ld = long double;

const int INT_INF = 2e9 + 10;
const ll LL_INF = 2e18 + 10;

template<typename T> istream& operator >> (istream& in, vector<T>& a) {
    for (auto& i : a) {
        in >> i;
    }
    return in;
}

struct Elem {
    int a, b;
    Elem() : a(0), b(0) {}
    Elem(int _a, int _b) : a(_a), b(_b) {}
};

int main() {
    int n;
    cin >> n;
    vector<int> a(n), b(n);
    vector<Elem> p(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i] >> b[i];
        p[i] = Elem(a[i], b[i]);
    }
    sort(p.begin(), p.end(), [](const Elem& _a, const Elem& _b) { return _a.b < _b.b; });
    sort(a.begin(), a.end());
    int ans = INT_INF;
    for (int a_it = 0; a_it < n; a_it++) {
        int max_a = a[a_it];
        int max_b = -INT_INF;
        for (auto el : p) {
            if (el.a > max_a) {
                max_b = max(max_b, el.b);
            }
        }
        if (max_b >= max_a) {
            ans = min(ans, max_b - max_a);
        } else {
            int min_b = INT_INF;
            for (auto el : p) {
                if (el.a == max_a) {
                    continue;
                }
                if (el.b <= max_a && el.b > max_b) {
                    max_b = el.b;
                } else if (el.b > max_a && el.b < min_b) {
                    min_b = el.b;
                }
            }
            ans = min(ans, min(max_a - max_b, min_b - max_a));
            int cnt = 0;
            for (auto el : p) {
                if (el.a == max_a) {
                    cnt++;
                    if (el.b <= max_a && el.b > max_b) {
                        max_b = el.b;
                    } else if (el.b > max_a && el.b < min_b) {
                        min_b = el.b;
                    }
                }
            }
            if (cnt != 1) {
                ans = min(ans, min(max_a - max_b, min_b - max_a));
            }
        }
    }
    cout << ans;
}
