#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cstring>
#include <algorithm>

using namespace std;

typedef pair<int, int> pii;
typedef long long ll;
typedef long double ld;

#define walk(v) v.begin(), v.end()
#define sz(v) (int)v.size()

void solve() {
	int n;
	cin >> n;
	vector<int> brr(n);
	vector<pii> arr(n);
	multiset<int> m;
	for (int i = 0; i < n; i++) {
		cin >> arr[i].first >> brr[i];
		arr[i].second = i;
		m.insert(brr[i]);
	}
	sort(walk(arr));
	reverse(walk(arr));
	int pref = -1, ans = 1e9;
	for (int i = 0; i < n; i++) {
		if (pref > arr[i].first) 
			ans = min(ans, pref - arr[i].first);
		else {
			m.erase(m.find(brr[arr[i].second]));
			auto it1 = m.lower_bound(arr[i].first); // мб линейный
			auto it2 = m.upper_bound(arr[i].first);
			int cans = 1e9;
			if (it1 != m.end()) 
				cans = min(cans, abs(arr[i].first - *it1));			
			if (it2 != m.end()) 
				cans = min(cans, abs(arr[i].first - *it2));
			m.insert(brr[arr[i].second]);
			ans = min(ans, cans);
		}
		pref = max(pref, brr[arr[i].second]);
		// в конце не забыть обновить pref и вернуть назад brr
	}
	cout << ans;
}

signed main() {
	cin.tie(0)->sync_with_stdio(false);
	//freopen("input.txt", "r", stdin);
	//freopen("output.txt", "w", stdout);	
	solve();
}