//#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

const int INF = 2e9;

int ans = INF;


map<int, int> vozm;
map<int, int> must;

void relax_ans2(int max_val, int val) {
    if (!must.empty()) {
        val = max(val, must.rbegin()->first);
    }
    ans = min(ans, abs(max_val - val));
}

void relax_ans(int max_val) {
    auto it = vozm.lower_bound(max_val);
    if (it != vozm.end()) {
        relax_ans2(max_val, it->first);
    }
    if (it != vozm.begin()) {
        --it;
        relax_ans2(max_val, it->first);
    }
    if ((vozm.empty()) && (!must.empty())) {
        relax_ans2(max_val, -1);
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    vector<int> a(n);
    vector<int> b(n);
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }

    map<int, vector<int>> index1;
    for (int i = 0; i < n; ++i) {
        index1[a[i]].push_back(i);
    }

    for (int i = 0; i < n; ++i) {
        ++must[b[i]];
    }
    for (const auto& [max_val, v] : index1) {
        if ((int)v.size() == 1) {
            auto it = must.find(b[v[0]]);
            --it->second;
            if (!it->second) {
                must.erase(it);
            }
            relax_ans(max_val);
            ++vozm[b[v[0]]];
        } else {
            for (int ind : v) {
                auto it = must.find(b[ind]);
                --it->second;
                if (!it->second) {
                    must.erase(it);
                }
                ++vozm[b[ind]];
            }
            relax_ans(max_val);
        }
    }
    cout << ans << '\n';
}