#include <iostream>
#include <vector>
#include <string>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <cassert>
#include <unordered_map>
#include <fstream>

using namespace std;

#define ll long long
#define eps 1e-10
#define inf 1e15
#define re return
#define fori(n) for(ll i = 0; i < n; i++)
#define forj(n) for(ll j = 0; j < n; j++)
#define rep(i, n) for(ll i = 0; i < n; i++)
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define bit(i, n) ((n >> i) & 1)

#ifdef LOCAL_BOBER
#define preproc ifstream fl("sample.io")
#define cin fl
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr);
#else
#define preproc ;
#define fast_io ios_base::sync_with_stdio(false);\
				cout.tie(nullptr); cin.tie(nullptr);
#endif

template <class T> istream& operator>>(istream& o, vector<T>& v) { for (auto& i : v) o >> i; re o; }
template <class T, class U> istream& operator>>(istream& o, pair<T, U>& p) { o >> p.first >> p.second; re o; }
template <class T, class U> pair<T, U> operator-(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first - p.first, a.second - p.second }; re t; }
template <class T, class U> pair<T, U> operator+(pair<T, U>& a, pair<T, U>& p) { pair<T, U> t = { a.first + p.first, a.second + p.second }; re t; }

ll ans = 1e10;

void rec(int i, vector<pair<ll, ll>>& v, ll mx1, ll mx2) {
	if (i == v.size()) {
		ans = min(ans, abs(mx1 - mx2));
		re;
	}

	rec(i + 1, v, max(mx1, v[i].first), mx2);
	rec(i + 1, v, mx1, max(mx2, v[i].second));
}

void solve1(int n, vector<pair<ll, ll>>& v) {
	rec(0, v, -1e9, -1e9);

	cout << ans;
}

void solve2(int n, vector<pair<ll, ll>>& v) {
	sort(rall(v));
	cout << v[0].first - v[1].first;
}

int main() {
	preproc; fast_io;

	int n; cin >> n;
	vector<pair<ll, ll>> v(n);
	cin >> v;

	if (n <= 20)solve1(n, v);
	else solve2(n, v);
}