#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using ll = long long;

const int SZ = 1e2, maxQ = 4e3;

int test = 1, n, k, l, r, p[SZ], it, sz;
ll a, cur;
pair<int, ll> dict[maxQ];

bool solve() {
    it = 0;
    cin >> n >> k;
    l = 0;
    r = n;
    cur = 0;
    sz = 0;
    while (it < k) {
        while (r - l > 1) {
            int m = (l + r) / 2;
            int id = lower_bound(dict, dict + sz, make_pair(m, -1LL)) - dict;
            if (id == sz || dict[id].first != m) {
                cout << "? " << m << endl;
                cin >> a;
                if (a == -1)
                    return false;
                dict[sz++] = make_pair(m, a);
                sort(dict, dict + sz);
            } else {
                a = dict[sz].second;
            }
            if (1LL * m * (m + 1) / 2 - cur != a)
                r = m;
            else
                l = m;
        }
        p[it++] = r;
        cur += r;
        r = n;
        l++;
        for (int i = 0; i < sz; i++) {
            if (dict[i].first < l)
                continue;
            if (1LL * dict[i].first * (dict[i].first + 1) / 2 - cur == dict[i].second) {
                l = dict[i].first;
            } else {
                r = dict[i].first;
                break;
            }
        }
    }
    cout << "!";
    for (int i = 0; i < k; i++)
        cout << " " << p[i];
    cout << endl;
    cin >> a;
    return a == 1;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> test;
    while (test--) {
        if (!solve())
            return 0;
    }
    return 0;
}
