#include <bits/stdc++.h>

#define int long long
#define f first
#define s second
#define FOR(i, n) for(int i = 0; i < (n); i++)
#define sz(x) (int)(x).size()
#define vec vector
#define pb push_back
#define all(x) x.begin(), x.end()
#define pii pair<int, int>
#define rz resize

using namespace std;

mt19937 rnd(time(0));

void solve()
{
    int n, k;
    cin >> n >> k;

    auto f = [&](int x)
    {
        return x * (x + 1) / 2;
    };

    vec<int> ans;
    map<int, int> qs;

    auto get = [&](int p) -> int
    {
        if(!p)
            return 0;
        if(qs.find(p) != qs.end())
        {
            return qs[p];
        }

        cout << "? " << p << endl;
        int ans;
        cin >> ans;
        if(ans == -1)
        {
            assert(0);
        }
        qs[p] = ans;
        return qs[p];
    };

    function<void(int, int)> go = [&](int l, int r)
    {
        if(l == r)
        {
            ans.pb(l);
            return;
        }

        if(sz(ans) == k)
            return;

        int mid = (l + r) >> 1;

        if(rnd() % 2)
        {
            int fmid = get(mid);
            int fl = get(l - 1);
            int flag = 1;
            if(fmid - fl != f(mid) - f(l - 1))
            {
                int diff = f(mid) - f(l - 1);
                int cnt = diff / l;
                if(cnt == 1)
                {
                    ans.pb(diff);
                }
                else
                    go(l, mid);
                flag = 0;
            }

            if(sz(ans) == k)
                return;
            if(flag)
            {
                go(l, mid);
                return;
            }

            int fr = get(r);
            if(fr - fmid != f(r) - f(mid))
            {
                int diff = f(r) - f(mid);
                int cnt = diff / (mid + 1);
                if(cnt == 1)
                {
                    ans.pb(diff);
                }
                else
                    go(mid + 1, r);
            }
        }
        else
        {
            int fr = get(r);
            int fmid = get(mid);
            int flag = 1;
            if(fr - fmid != f(r) - f(mid))
            {
                int diff = f(r) - f(mid);
                int cnt = diff / (mid + 1);
                if(cnt == 1)
                {
                    ans.pb(diff);
                }
                else
                    go(mid + 1, r);
                flag = 0;
            }

            if(sz(ans) == k)
                return;

            if(flag)
            {
                go(l, mid);
                return;
            }

            int fl = get(l - 1);
            if(fmid - fl != f(mid) - f(l - 1))
            {
                int diff = f(mid) - f(l - 1);
                int cnt = diff / l;
                if(cnt == 1)
                {
                    ans.pb(diff);
                }
                else
                    go(l, mid);
            }
        }
    };

    go(1, n);

    cout << "! ";
    for(auto &i : ans)
        cout << i << ' ';
    cout << endl;

    int ok;
    cin >> ok;
    if(ok == -1)
    {
        assert(0);
    }
}

signed main() {
    int q = 1;
    cin >> q;

    while(q--)
    {
        solve();
    }
}



