#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);



void solve() {
    ll n, k;
    cin >> n >> k;

    vector<ll> ans;
    ll summ_govna = 0;

    for (ll i = 0; i < k - 1; ++i) {
        ll left = 0, right = n;

        if (ans.size()) left = ans.back();

        while (right - left > 1) {
            ll mid = (left + right) / 2;

            cout << "? " << mid << endl;
            ll x;
            cin >> x;

            if (x + summ_govna == mid * (mid + 1) / 2) left = mid;
            else right = mid;
        }

        summ_govna += right;
        ans.push_back(right);
    }

    cout << "? " << n << endl;
    ll x;
    cin >> x;

    ans.push_back(n * (n + 1) / 2 - summ_govna - x);

    sort(all(ans));

    cout << "! ";

    for (auto i : ans) cout << i << ' ';
    cout << endl; 
}

signed main() {
    int tests = 1;
    cin >> tests;

    while (tests--) {
        solve();
    }
}

/*

5 4 3 2
1 2 1 10 6
1 2 5

2 3 3
3 4 4
4 5 20

*/