#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e18 + 100, MOD = 1e9 + (1000 - 7), MAXN = 3e5, p_ = 239, k = 100;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

ll q(ll i) {
    cout << "? " << i << endl;
    ll res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }
    return res;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    if (n <= 1) {
        ll lastres = 0;
        vector<bool> used(n + 1, true);
        for (ll i = 1; i <= n; i += 2) {
            ll res = q(i);
            if (res == lastres + i - 1) used[i] = false;
            else if (res == lastres + i) used[i - 1] = false;
            else if (res == lastres) used[i] = false, used[i - 1] = false;
            lastres = res;
        }
        if (n % 2 == 0) {
            cout << "? " << n << endl;
            ll res;
            cin >> res;
            if (res == lastres) used[n] = false;
        }
        cout << "! ";
        for (ll i = 1; i <= n; ++i) {
            if (!used[i]) cout << i << ' ';
        }
        cout << endl;
        ll res;
        cin >> res;
        if (res == -1) exit(0);
    } else {
        vector<ll> lozh;
        ll uzhe = 0;
        for (ll i = 0; i < k; ++i) {
            ll l = 0, r = n + 1;
            if (!lozh.empty()) l = lozh.back();
            while (r - l > 1) {
                ll m = (l + r) / 2;
                ll res = q(m);
                if (res == m * (m + 1) / 2 - uzhe) {
                    l = m;
                } else {
                    r = m;
                }
            }
            lozh.push_back(r);
            uzhe += r;
        }
        cout << "! ";
        for (ll i = 0; i < lozh.size(); ++i) cout << lozh[i] << ' ';
        cout << endl;
        ll res;
        cin >> res;
        if (res == -1) exit(0);
    }
}

signed main() {
//    ios_base::sync_with_stdio(0);
//    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}