#include <bits/stdc++.h>

typedef long long ll;

template<typename t> using vc = std::vector<t>;

int n, k;

vc<int> ans;

ll sum(int l, int r) {
    return (ll) (r + l) * (r - l + 1) / 2;
}

ll get(int p) {
    if (!p) return 0;
    std::cout << "? " << p << std::endl;
    ll x;
    std::cin >> x;
    return x;
}

void solve(int l, int r, ll L, ll R) {
    if (R - L == sum(l, r)) return;
    if (!k) return;
    if (l == r) {
        if (L == R) ans.push_back(r);
        --k;
        return;
    }
    int mid = (l + r) / 2;
    ll s = get(mid);
    ll diff = s + sum(mid + 1, r) - R;
    if (diff <= r) {
        if (diff) {
            ans.push_back(diff);
            --k;
        }
    } else solve(mid + 1, r, s, R);
    solve(l, mid, L, s);
}

int main() {
    int t;
    std::cin >> t;
    while (t--) {
        std::cin >> n >> k;
        ans.clear();
        solve(1, n, 0, get(n));
        std::sort(ans.begin(), ans.end());
        std::cout << "! ";
        for (auto &i: ans) std::cout << i << ' ';
        std::cout << std::endl;
        int x;
        std::cin >> x;
        assert(x);
    }
}