#include <bits/stdc++.h>

using namespace std;

map<int, long long> used;

long long ask_query(int pos) {
    if (used.count(pos)) {
        return used[pos];
    }
    cout << "? " << pos << endl;
    cin >> used[pos];
    return used[pos];
}

long long get_segm(int l, int r) {
    return ask_query(r) - ask_query(l - 1);
}

vector<int> ans;

int n, k;

long long solve(int l, int r) {
    long long sum = get_segm(l, r);
    long long sum_ans = (l + r) * 1LL * (r - l + 1) / 2;
    if (sum == 0) {
        long long ret = 0;
        for (int i = l; i <= r; ++i) {
            ans.push_back(i);
            ret += i;
        }
        return ret;
    }
    if (sum == sum_ans) {
        return 0;
    }
    if (l == r) {
        ans.push_back(l);
        return l;
    }
    if ((sum + l * 2 >= sum_ans || (l * 2 + 1 > r && sum_ans - sum <= r)) || (int)ans.size() + 1 == k) {
        ans.push_back(sum_ans - sum);
        return sum_ans - sum;
    }
    if ((int)ans.size() + 2 == k || (sum + r < sum_ans && sum + l + l + 1 + l + 2 > sum_ans)) {
        long long sum2 = sum_ans - sum;
        int centr = sum2 / 2;
        long long sum_nw = get_segm(l, centr);
        long long sum_ans_nw = (l + centr) * 1LL * (centr - l + 1) / 2;
        ans.push_back(sum_ans_nw - sum_nw);
        ans.push_back(sum2 - ans.back());
        return sum2;
    }
    // if (k == 1) {
    //     long long sum_nw = get_segm(l, r);
    //     long long sum_ans = (l + r) * 1LL * (r - l + 1) / 2;
    //     ans.push_back(sum_ans - sum_nw);
    //     return;
    // }
    int m = (l + r) / 2;
    long long add = 0;
    if (sum + m + 1 <= sum_ans) {
        add += solve(m + 1, r);
    } else {
        used[m] = used[r] - (m + 1 + r) * 1LL * (r - m) / 2;
    }
    if (sum + add < sum_ans) {
        add += solve(l, m);
    }
    return add;
    // solve(l, m);
    // solve(m + 1, r);
}

void solve() {
    used.clear();
    used[0] = 0;
    ans.clear();
    cin >> n >> k;
    solve(1, n);
    cout << "! ";
    for (int i = 0; i < k; ++i) {
        cout << ans[i] << ' ';
    }
    cout << endl;
    int ans_nw;
    cin >> ans_nw;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
