#include <bits/stdc++.h>
using namespace std;

#define int long long 
#define forn(i,n) for(int i=0;i<n;++i)

#define pi pair<int,int>
#define f first
#define s second

#define pb push_back
#define all(x) x.begin(),x.end()
#define vii(a,n) vector<int>a(n);forn(i,n)cin>>a[i];

const int inf=1e18;
const int mod=1e9+7;

map<int,int> mem;
int ask(int x) {
	if (mem[x]) return x;
	cout<<"? "<<x<<'\n';
	cout.flush();
	int r; cin>>r; mem[x]=r;
	return r;
}

void p1(int n, int k) {
	vector<int> s(n+1,0);
	vector<int> ans;
	int add=0;
	forn(i,n) s[i+1]=s[i]+i+1;
	for (int i=2; i<=n; i+=2) {
		int x=ask(i);
		if (x==s[i]-add) continue;

		if (x==s[i-2]-add) {
			ans.pb(i-1);
			ans.pb(i);
			add+=i-1+i;
			continue;
		}
		if (x==s[i-2]-add+i-1) {
			ans.pb(i);
			add+=i;
		} else {
			ans.pb(i-1);
			add+=i-1;
		}
	}
	if (n&1) {
		int x=ask(n);
		if (x!=s[n]-add) ans.pb(n);
	}
	cout<<"! "; for(auto&x:ans) cout<<x<<' '; cout<<'\n';
	cout.flush();
	int z; cin>>z;
	if (z==-1) exit(0);
}

const int sz=1<<30;
struct sgt {
	sgt *L, *R;
	int val;
	sgt() {
		L=R=NULL; val=0;
	}
	void add(int l, int r, int i, int x) {
		val+=x;
		if (r-l==1) return;
		int m=(l+r)>>1;
		if (i<m) {
			if (!L) L=new sgt();
			L->add(l,m,i,x);
		} else {
			if (!R) R=new sgt();
			R->add(m,r,i,x);
		}
	}
	void add(int i, int x) {
		add(0,sz,i,x);
	}
	int query(int l, int r, int lx, int rx) {
		if (rx<=l || r<=lx) return 0;
		if (lx<=l && r<=rx) return val;
		int m=(l+r)>>1;
		int f=0,s=0;
		if (L) f=L->query(l,m,lx,rx);
		if (R) s=R->query(m,r,lx,rx);
		return f+s;
	}
	int query(int l, int r) {
		return query(0,sz,l,r);
	}
};
sgt st;

void solve() {

	int n,k; cin>>n>>k;
	//if (n<=1000) {
	//	p1(n,k);
	//	return;
	//}
	vector<int> ans;
	while (ans.size()<k) {
		int l=1, r=n;
		while (l<r) {
			int mid=(l+r)>>1;
			int add=st.query(0,mid+1);
			int x=ask(mid);
			if (x+add == mid*(mid+1)/2) l=mid+1;
			else r=mid;
		}
		ans.pb(r);
		st.add(r,r);
	}
	cout<<"! "; for(auto&x:ans) cout<<x<<' '; cout<<'\n';
	cout.flush();
	int z; cin>>z;
	if (z==-1) exit(0);

}

int32_t main() {
	ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
	int t=1;
	cin>>t;
	while (t--) solve();
	return 0;
}