#include <bits/stdc++.h>

using namespace std;

#define rs resize
#define sz(x) (int)(x).size()
#define all(x) (x).begin(),(x).end()
#define X first
#define Y second
#define pb push_back

typedef long long ll;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;
typedef long double ld;

template<typename T>
istream &operator>>(istream &in, vector<T> &arr) {
    for (auto &item: arr)in >> item;
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &arr) {
    for (auto &item: arr)out << item << ' ';
    return out;
}

template<typename T1, typename T2>
istream &operator>>(istream &in, pair<T1, T2> &pr) {
    in >> pr.X >> pr.Y;
    return in;
}

template<typename T1, typename T2>
ostream &operator<<(ostream &out, pair<T1, T2> &pr) {
    cout << pr.X << ' ' << pr.Y;
    return out;
}

const int inf = 1e9;
const int MOD = 1e9 + 7;
const int MAXN = 3e5 + 5;

ll ask(int i) {
    ll ret = 0;
    cout << "? " << i << endl;
    cin >> ret;
    assert(ret != -1);
    return ret;
}

void answer(vector<int> &ans) {
    cout << "! ";
    for (int i = 0; i < sz(ans); i++) {
        cout << ans[i];
        if (i != sz(ans) - 1)cout << " ";
    }
    cout << endl;
    int ok;
    cin >> ok;
    assert(ok == 1);
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> ans;
    vector<int> out;
    for (int i = n; i >= 1 && sz(out) < k; i--) {
        if (!ans.empty()) {
            ll sum = ans.back();
            if (!out.empty() && out.back() != i + 1)sum -= i + 1;
            if (sum < i) {
                out.pb(i);
                ans.pb(ans.back());
                continue;
            }
        }
        ll cur = ask(i);
        if (!ans.empty() && ans.back() == cur) {
            out.pb(i + 1);
        }
        ans.pb(cur);
    }
    answer(out);
}

int main() {
#ifdef LOCAL
    //freopen("input.txt", "r", stdin);
#else
    //    ios_base::sync_with_stdio(false);
    //    cin.tie(nullptr);
#endif
    int tests = 1;
    cin >> tests;
    while (tests--) {
        solve();
#ifdef LOCAL
//cout << "______________\n";
#endif
    }
    return 0;
}

