#include <bits/stdc++.h>

using namespace std;
using ll = long long;
#define all(x) x.begin(), x.end()

void solve();

int32_t main() {
#ifdef LOCAL
//    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t ;
    while (t--) solve();
}

map<int, ll> qq;

ll ask(int p) {
    if (qq.count(p)) return qq[p];
    cout << "? " << p << endl;
    ll res;
    cin >> res;
    qq[p] = res;
    if (res == -1) exit(0);
    return res;
}

ll sum(int n) {
    return 1ll * n * (n + 1) / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    qq.clear();
    vector<int> ans;
    function<ll(int, int, ll)> go = [&](int l, int r, ll sl) -> ll {
        if (l == r) {
            ans.push_back(l);
            return l;
        }
        int m = (l + r) / 2;
        ll kk = sl;
        if (sl + ask(m) != sum(m)) {
            sl += go(l, m, sl);
        }
        if (sl + ask(r) != sum(r)) {
            sl += go(m + 1, r, sl);
        }
        return sl - kk;
    };
    go(1, n, 0);
    cout << "! ";
    for (auto i : ans) cout << i << " ";
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
}