#include <iostream>
#include <vector>
#include <algorithm>
#include <unordered_map>
using namespace std;
typedef long long ll;

int main() {
    int t; cin >> t;
    for (int _ = 0; _ < t; ++_) {
        ll n, k;
        cin >> n >> k;
        vector<ll> ans;
        vector<ll> pref(n + 1);
        pref[1] = 1;
        for (ll i = 2; i <= n; ++i)
            pref[i] = pref[i - 1] + i;
        ll cnt = 0;
        ll pred = 0; ll cur = 0;
        unordered_map<int, ll> used;
        while (cnt < k) {
            ll l = pred, r = n + 1;
            while (l + 1 < r) {
                ll mid = l + (r - l) / 2;
                ll res;
                if (used.find(mid) != used.end()) {
                    res = used[mid];
                }
                else {
                    cout << "? " << mid << "\n";
                    cin >> res;
                    if (res == -1) return 0;
                }
                used[mid] = res;
                cout.flush();
                if (res == pref[mid] - cur)
                    l = mid;
                else
                    r = mid;
            }
            cur += r;
            ans.push_back(r);
            pred = r;
            cnt++;
        }
        cout << "! ";
        for (ll el: ans) cout << el << " ";
        cout << "\n";
        cout.flush();
        ll a; cin >> a;
    }

    return 0;
}