// #pragma GCC optimize("O3")
// #pragma GCC target("avx,avx2,abm,popcnt,lzcnt")
#include <algorithm>
#include <array>
#include <bitset>
#include <chrono>
#include <climits>
#include <cmath>
#include <deque>
#include <iomanip>
#include <iostream>
#include <map>
#include <queue>
#include <random>
#include <ranges>
#include <set>
#include <stack>
#include <string>
#include <tuple>
#include <unordered_map>
#include <unordered_set>
#include <vector>
using namespace std;

// #include <ext/rope>
// #include <ext/pb_ds/tree_policy.hpp>
// #include <ext/pb_ds/assoc_container.hpp>
// using namespace __gnu_cxx;
// using namespace __gnu_pbds;
// typedef tree<int, null_type, less<>, rb_tree_tag,
// tree_order_statistics_node_update> ordered_set;

using ll = long long;
using ld = long double;
using uint = unsigned int;
using ull = unsigned long long;
using pi = pair<int, int>;
using pll = pair<ll, ll>;
using pld = pair<ld, ld>;

#define F first
#define S second
#define pb push_back
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

ll ask(int pos) {
    cout << "? " << pos << endl;
    ll out;
    cin >> out;
    return out;
}

bool answer(vector<int> &ans) {
    cout << "! ";
    for (auto x : ans)
        cout << x << " ";
    cout << endl;
    int ok;
    cin >> ok;
    return ok == 1;
}

void solve() {
    int n, k;
    cin >> n >> k;
    ll substract = 0;
    vector<int> ans;
    for (int i = 0; i < n; i++) {
        ll should = (i + 1) * (i + 2) / 2;
        ll be = ask(i + 1);
        if (should - substract > be) {
            substract += (should - substract - be);
            ans.pb(i + 1);
        }
    }
    answer(ans);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t = 1;
    cin >> t;
    while (t--)
        solve();
    return 0;
}