#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#ifdef LOCAL
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
#else
#define debug(x...) 7
#endif
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(2128137711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}
vector<int> P = {0, 2, 0, 0, 5, 6};
map<int, ll> mp;
set<int> st;
int Q = 0;
ll ask(int x) {
    if (x == 0) return 0;
    if (mp.count(x)) return mp[x];
    Q++;
#ifdef LOCAL
    ll ans = 0;
    for (int i = 0; i < x; i++) ans += P[i];
    return mp[x] = ans;
#else
    cout << "? " << x << endl;
    ll ans;
    cin >> ans;
    if (ans < 0) assert(false);
    return mp[x] = ans;
#endif
}
void solve_case() {
    int n, k;
#ifdef LOCAL
    n = P.size();
    k = 0;
    for (int j = 0; j < n; j++) if (P[j] == 0) k++;
#else
    cin >> n >> k;
#endif
    vector<int> ans;
    ll sum = 0;
    function<ll(int, int)> must = [&](int l, int r) {
        return 1ll * (l + r) * (r - l + 1) / 2;
    };
    function<void(int, int)> divide3 = [&](int l, int r) {
        int len = (r - l + 1) / 3;
        vector<pair<int, int>> inter;
        int was = 0;
        vector<pair<int, int>> ones;
        for (int i = 0; i < 3; i++) {
            int cl = l + i * len, cr;
            if (i + 1 == 3) {
                cr = r;
            } else {
                cr = cl + len - 1;
            }
            ll s = ask(cr) - ask(cl - 1);
            if (must(cl, cr) == s) {
                continue;
            } else if (must(cl, cr) - s <= cr) {
                // this one
                ones.push_back({cl, cr});
                //ans.push_back(must(cl, cr) - ask(cr) + ask(cl - 1));
            } else {
                // this two or three
                inter.emplace_back(cl, cr);
            }
        }
        if (inter.size() == 1 && ones.empty()) {
            divide3(inter[0].fi, inter[0].se);
        } else {
            if (ones.size() == 3) {
                for (auto [cl, cr] : ones) {
                    ans.push_back(must(cl, cr) - ask(cr) + ask(cl - 1));
                }
            } else if (ones.size() == 2) {
                int cl = ones.back().fi, cr = ones.back().se;
                ones.pop_back();
                ans.push_back(must(cl, cr) - ask(cr) + ask(cl - 1));
                inter = ones;
            } else if (ones.size() == 1) {
                int cl = ones.back().fi, cr = ones.back().se;
                ones.pop_back();
                ans.push_back(must(cl, cr) - ask(cr) + ask(cl - 1));
            }
            if (inter.size() == 1){
                int cl = inter[0].fi, cr = inter[0].se;
                int left = cl - 1, right = cr;
                while (right - left > 1) {
                    int mid = (left + right) / 2;
                    if (ask(mid) - ask(cl - 1) == must(cl, mid)) {
                        left = mid;
                    } else {
                        right = mid;
                    }
                }
                ll s = ask(cr) - ask(cl - 1);
                ans.push_back(right);
                ans.push_back(must(cl, cr) - s - right);
            }
        }
    };
    if (k == 3) {
        divide3(1, n);
    } else if (false) {
        function<void(int, int)> divide4 = [&](int l, int r) {
            int len = (r - l + 1) / 4;
            vector<pair<int, int>> inter;
            int was = 0;
            for (int i = 0; i < 4; i++) {
                int cl = l + i * len, cr;
                if (i + 1 == 4) {
                    cr = r;
                } else {
                    cr = cl + len - 1;
                }
                ll s = ask(cr) - ask(cl - 1);
                if (must(cl, cr) == s) {
                    continue;
                } else if (must(cl, cr) - s <= cr) {
                    // this one
                    was++;
                    ans.push_back(must(cl, cr) - s);
                } else {
                    // this two or three or four
                    inter.emplace_back(cl, cr);
                }
            }
            if (inter.size() == 1 && was == 0) {
                divide3(inter[0].fi, inter[0].se);
            } else if (inter.size() == 1){
                // this is two or three
                if (was == 1) {
                    // this three
                    divide3(inter[0].fi, inter[0].se);
                }
                int cl = inter[0].fi, cr = inter[0].se;
                int left = cl - 1, right = cr;
                while (right - left > 1) {
                    int mid = (left + right) / 2;
                    if (ask(mid) - ask(cl - 1) == must(cl, mid)) {
                        left = mid;
                    } else {
                        right = mid;
                    }
                }
                ll s = ask(cr) - ask(cl - 1);
                ans.push_back(right);
                ans.push_back(must(cl, cr) - s - right);
            } else if (inter.size() == 2) {
                // this is two & two
            }
        };
    }
    else if (k * 30 > n / 2) {
        for (int i = 1; i <= n; i += 2) {
            if (i == n) {
                if (sum == ask(i)) {
                    ans.push_back(i);
                }
            } else {
                ll v = ask(i + 1);
                if (i == v - sum) {
                    ans.push_back(i + 1);
                } else if (i + 1 == v - sum) {
                    ans.push_back(i);
                } else if (0 == v - sum) {
                    ans.push_back(i);
                    ans.push_back(i + 1);
                }
                sum = v;
            }
        }
    } else {
        for (int i = 1; i <= n;) {
            int left = i - 1, right = n + 1;
            while (right - left > 1) {
                int mid = (left + right) / 2;
                if (ask(mid) == sum + 1ll * (i + mid) * (mid - i + 1) / 2) {
                    left = mid;
                } else {
                    right = mid;
                }
            }
            if (right != n + 1) ans.push_back(right);
            sum += (i + left) * 1ll * (left - i + 1) / 2;
            i = right + 1;
        }
    }
    mp.clear();
    cout << "! ";
    assert(ans.size() == k);
    for (int i : ans) cout << i << " ";
    cout << endl;
    Q = 0;
    int ret;
#ifndef LOCAL
    cin >> ret;
#endif
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
#ifdef LOCAL
    freopen("inputik.txt", "r", stdin);
#endif
    /*
    for (int i = 0; i < 100000; i++) P.push_back(i + 1);
    while (st.size() != 3) {
        int x = rnd() % P.size();
        st.insert(x);
    }
    for (int i : st) P[i] = 0;
    */
    int T = 1;
    cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}