#include "bits/stdc++.h"
//#pragma GCC optimize("Ofast,unroll-loops")

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
//#define endl '\n'

using namespace std;

mt19937 gen(time(nullptr));
const int base = 177013;
const int mod = 1e9 + 7;

ll get_must_sum(int x){
    return (ll)x * (ll)(x + 1) / 2;
}

ll get_sum_segment(int l, int r){
    l += 1;
    r += 1;
    return get_must_sum(r) - get_must_sum(l - 1);
}

map<int, ll> was;

ll ask(int x){
    if(was[x]){
        return was[x] - 1;
    }
    if(x == 0)
        return 0;
    cout << "? " << x << endl;
    ll a;
    cin >> a;
    if(a == -1)
        exit(0);
    was[x] = a + 1;
    return a;
}

struct Otr{
    int l, r;
    ll weight;
};

bool empty(Otr &o){
    if(o.weight == get_sum_segment(o.l, o.r))
        return true;
    return false;
}

int has_one(Otr &o){
    ll c = get_sum_segment(o.l, o.r) - o.weight;
    if(c >= o.l + 1 and c <= o.r + 1)
        return c;
    return 0;
}

int main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);
    // Это красиво.
    int t;
    cin >> t;
    while(t--) {
        was.clear();
        int n, k;
        cin >> n >> k;
        vector<int> pozs;

        ll all_s = ask(n);
        vector<Otr> otr;
        otr.push_back({0, n - 1, all_s});
        while (!otr.empty()){
            Otr o = *--otr.end();
            otr.pop_back();
            if(empty(o))
                continue;
            int g = has_one(o);
            if(g != 0){
                pozs.emplace_back(g);
            }else{
                int vmid = (o.l + o.r) / 2;
                otr.push_back({o.l, vmid, ask(vmid + 1) - ask(o.l)});
                otr.push_back({vmid + 1, o.r, ask(vmid + 1) - ask(o.r + 1)});
            }
        }

        cout << "! ";
        for (auto u: pozs)
            cout << u << ' ';
        cout << endl;
        int ans;
        cin >> ans;
        if(ans == -1)
            exit(0);
    }
}