#include<bits/stdc++.h>

#define pb push_back
#define ld  double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int n, k;
map<int, ll> mp;
vector<int> ans, mas, need;

ll ask(int p) {
    if (mp.find(p) != mp.end()) {
        return mp[p];
    }
    ll a;
    #ifdef LOCAL
        ll sum = 0;
        for (int i = 0; i < p; i++) {
            sum += mas[i];
        }
        a = sum;
    #else
        cin >> a;
    #endif // LOCAL

    if (a == -1) {
        exit(0);
    }
    mp[p] = a;
    return a;
}

void answer(vector<int> a) {
    sort(all(a));
    #ifdef LOCAL
        assert(a == need);
    #else
        cout << "! ";
        for (auto to : a) {
            cout << to << ' ';
        }
        cout << endl;
        int a;
        cin >> a;
        if (a == -1) exit(0);
    #endif // LOCAL
}

ll good(int l, int r) {
    int n = r - l + 1;
    return 1ll * (l + r) * n / 2;
}

void solve(int l, int r) {
    ll sum = ask(r) - ask(l - 1);
    if (good(l, r) == sum) return;
    if (sum == 0) {
        for (int i = l; i <= r; i++) {
            ans.pb(i);
        }
        return;
    }
    int m = (l + r) / 2;
    solve(l, m);
    solve(m + 1, r);
}

signed main()
{
#ifdef LOCAL
   // freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (1) {
        int t;
        cin >> t;
        while (t--) {
            cin >> n >> k;
            need.resize(k);
            mas.resize(n);
            for (int i = 0; i < n; i++) mas[i] = i + 1;
            for (int i = 0; i < k; i++) {
                cin >> need[i];
                mas[need[i] - 1] = 0;
            }
            sort(all(need));
            mp[0] = 0;
            solve(1, n);
            mp.clear();
            ans.clear();
            cout << "OK" << endl;
        }
    } else {
        int t;
        cin >> t;
        while (t--) {
            cin >> n >> k;
            mp[0] = 0;
            solve(1, n);
            mp.clear();
            ans.clear();
        }
    }
    return 0;
}
