#include<bits/stdc++.h>

#define pb push_back
#define ld  double
#define all(a) a.begin(), a.end()
#define ll long long

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

int n, k;
map<int, ll> mp;
vector<int> ans, mas, need;

ll ask(int p) {
    if (mp.find(p) != mp.end()) {
        return mp[p];
    }
    ll a;
    #ifdef LOCAL
        ll sum = 0;
        for (int i = 0; i < p; i++) {
            sum += mas[i];
        }
        a = sum;
    #else
        cout << "? " << p << endl;
        cin >> a;
    #endif // LOCAL

    if (a == -1) {
        exit(0);
    }
    mp[p] = a;
    return a;
}

void answer(vector<int> res) {
    sort(all(res));
    #ifdef LOCAL
        assert(res == need);
    #else
        cout << "! ";
        for (auto to : res) {
            cout << to << ' ';
        }
        cout << endl;
        int a;
        cin >> a;
        if (a == -1) exit(0);
    #endif // LOCAL
}

ll good(int l, int r) {
    int n = r - l + 1;
    return 1ll * (l + r) * n / 2;
}

ll get(int l, int r) {
    return ask(r) - ask(l - 1);
}

bool any_element(int l, int r) {
    if (l > r) return 0;
    return good(l, r) != get(l, r);
}

ll rest(int l, int r) {
    return good(l, r) - get(l, r);
}

void solve() {
    deque<pair<int, int>> q{{1, n}};
    while (q.size() > 0) {
        if (q.size() + ans.size() == k) {
            for (int i = 0; i < q.size(); i++) {
                int l = q[i].first, r = q[i].second;
                ans.pb(rest(l, r));
            }
            return;
        }
        int l = q.front().first, r = q.front().second;
        q.pop_front();
        ll sum = get(l, r), need = rest(l, r);
        if (sum == 0) {
            for (int i = l; i <= r; i++) {
                ans.pb(i);
            }
            continue;
        }
        if (2 * l + 1 > need) {
            ans.pb(need);
            continue;
        }
        int m = (l + r) / 2;
        if (r - l + 1 > 50) {
            if (rnd() % 2) {
                m += rnd() % 5;
            } else {
                m -= rnd() % 5;
            }
        }
        if (need <= r) {
            m = need - 1;
        }
        if (any_element(l, m)) q.pb({l, m});
        if (any_element(m + 1, r)) q.pb({m + 1, r});
    }
}

signed main()
{
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    if (0) {
        int t;
        cin >> t;
        while (t--) {
            cin >> n >> k;
            need.resize(k);
            mas.resize(n);
            for (int i = 0; i < n; i++) mas[i] = i + 1;
            for (int i = 0; i < k; i++) {
                cin >> need[i];
                mas[need[i] - 1] = 0;
            }
            sort(all(need));
            mp[0] = 0;
            solve();
            answer(ans);
            mp.clear();
            ans.clear();
            cout << "OK" << endl;
        }
    } else {
        int t;
        cin >> t;
        while (t--) {
            cin >> n >> k;
            mp[0] = 0;
            solve();
            answer(ans);
            mp.clear();
            ans.clear();
        }
    }
    return 0;
}
