#include <iostream>
#include <vector>
#include <map>

using namespace std;

#define int long long

vector<int> got;
map<int, pair<int, int>> asked;

int query(int i) {
	if (got.size() && i <= got.back()) {
		return i * (i + 1) / 2;
	}
	if (asked[i].first) {
		int c = asked[i].second;
		for (int x: got) {
			if (x <= i) c += x;
		}
		return c;
	}
	cout << "? " << i << endl;
	int c;
	cin >> c;
	if (c == -1) return -1;
	asked[i] = {1, c};
	for (int x: got) {
		if (x <= i) c += x;
	}
	return c;
}

void call(int l, int r) {
	int m = (l + r) / 2;
	int ret = query(m);
	int need = m * (m + 1) / 2;
	if (need - ret <= m) {
		got.push_back(need - ret);
	}
	else {
		call(l, m);
	}
	if (query(r) != r * (r + 1) / 2) {
		if (r * (r + 1) / 2 - query(r) <= r) {
			got.push_back(r * (r + 1) / 2 - query(r));
		}
		else {
			call(m, r);
		}
	}
}

int solve() {
	int n, k;
	cin >> n >> k;
	got.clear();
	asked.clear();
	//int all = query(n);
	int last = 0;
	for (int i = 0; (1ll << i) < n; ++i) {
		int q = (1ll << i);
		int ret = query(q);
		if (ret == -1) return -1;
		int need = q * (q + 1) / 2;
		if (ret != need) {
			if (need - ret <= q) {
				got.push_back(need - ret);
			}
			else {
				call(last, q);
			}
		}
		last = q;
	}
	int q = n;
	int ret = query(q);
	if (ret == -1) return -1;
	int need = q * (q + 1) / 2;
	if (ret != need) {
		if (need - ret <= q) {
			got.push_back(need - ret);
		}
		else {
			call(last, q);
		}
	}
	
	// for (int i = 0; i < k - 1; ++i) {
	// 	int l = 0, r = n;
	// 	bool kek = 0;
	// 	while (l + 1 != r) {
	// 		int m = (l + r) / 2;
	// 		int ret = query(m);
	// 		if (ret == -1) return -1;
	// 		int need = m * (m + 1) / 2;
	// 		if (ret == need) {
	// 			l = m;
	// 		}
	// 		else {
	// 			if (got.size() && got.back() * 2 > need - ret) {
	// 				got.push_back(need - ret);
	// 				kek = 1;
	// 				break;
	// 			}
	// 			r = m;
	// 			//r = min(need - ret + 1, m);
	// 		}
	// 	}
	// 	if (!kek) got.push_back(r);
	// }
	// got.push_back(n * (n + 1) / 2 - query(n));
	cout << "! ";
	for (int x: got) cout << x << ' ';
	int a;
	cin >> a;
	if (a == -1) return -1;
	return 1;
}

signed main() {
	int t = 1;
	#ifndef LOCAL 
	cin >> t;
	#endif
	while (t--) {
		if (solve() == -1) return 0;
	}
}