#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<int, int> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((int)(x).size())

mt19937 rng(time(0));

int pref(int x) {
    return 1ll * x * (x + 1) / 2;
}

int sum(int l, int r) {
    return pref(r) - pref(l - 1);
}

int ask(int p) {
    if (p == 0) return 0;
    cout << p << endl;
    int a;
    cin >> a;
    return a;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    int pref_sum = 0;
    while(sz(ans) < k){
        int border = (ans.empty() ? 0 : ans.back());
        int tl = border-1, tr = n;
        int skip = sum(1, border) - pref_sum;
        while (tr - tl > 1) {
            int tm = (tl + tr) >> 1;
            int cnt = ask(tm) - skip;
            if (cnt == -1) exit(0);
            if (cnt < sum(border + 1, tm))
                tr = tm;
            else
                tl = tm;
        }
        ans.push_back(tr);
        pref_sum += tr;
    }
    cout << "! ";
    for (int i : ans)
        cout << i << ' ';
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int t;
    cin >> t;
    while(t--)
        solve();
}