#include <iostream>
#include <vector>
#include <algorithm>
#include <numeric>
#include <cstring>
#include <cmath>
#include <map>
#include <set>
#include <unordered_map>
#include <unordered_set>
#include <random>
#include <iomanip>
#include <queue>
#include <stack>
#include <tuple>
#include <bitset>
#include <cassert>

using namespace std;

typedef long long ll;
typedef pair<ll, ll> pii;
typedef double db;

#define X first
#define Y second
#define All(x) (x).begin(), (x).end()
#define rAll(x) (x).rbegin(), (x).rend()
#define sz(x) ((ll)(x).size())

mt19937 rng(time(0));

ll pref(ll x) {
    return 1ll * x * (x + 1) / 2;
}

ll sum(ll l, ll r) {
    return pref(r) - pref(l - 1);
}

ll ask(ll p) {
    if (p == 0) return 0;
    cout << "? " << p << endl;
    ll a;
    cin >> a;
    return a;
}

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> ans;
    if (k == 3) {
        ll full = sum(1,n)-ask(n), potent = -1;
        ll tl = 0, tr = n;
        while (tr - tl > 1) {
            ll tm = (tl + tr) >> 1ll;
            ll cur = ask(tm);
            if (cur == -1) exit(0);
            if ((potent == -1 && cur == sum(1, tm)) || (potent != -1 && sum(1, tm) - cur < potent)) {
                tl = tm;
            }
            else {
                if (potent == -1) {
                    potent = sum(1, tm) - cur;
                }
                tr = tm;
            }
        }
        ll p0 = sum(1, tl) - ask(tl);
        if (p0 == -1) exit(0);
        if (p0 == 0) {
            ll p1 = potent;
            ans.push_back(potent);
            ll sum2 = full - potent;
            ll x = sum2 / 2;
            ll p2 = sum(1, x) - ask(x) - p1;
            ans.push_back(p2);
            ans.push_back(full - p1 - p2);
        }
        else {
            ll p1 = p0;
            ans.push_back(p1);
            ll p2 = potent - p1;
            ans.push_back(p2);
            ll p3 = full - p1 - p2;
            ans.push_back(p3);
        }
    }
    else if (k > 30 && n <= 1000) {
        ll pref_sum = 0;
        for (ll l = 1; l <= n; l += 2) {
            ll r = min(n, l + 1);
            ll cur = ask(r);
            if (cur == -1) exit(0);
            cur -= pref_sum;
            if (r == l) {
                if (cur == 0)
                    ans.push_back(l);
            }
            else {
                if (cur == l)
                    ans.push_back(l + 1);
                else if (cur == r)
                    ans.push_back(l);
                else if (cur == 0) {
                    ans.push_back(l);
                    ans.push_back(r);
                }
            }
            pref_sum += cur;
        }
    }
    else {
        ll pref_sum = 0;
        while (sz(ans) < k) {
            ll border = (ans.empty() ? 0 : ans.back());
            ll tl = border - 1, tr = n;
            ll skip = sum(1, border) - pref_sum;
            while (tr - tl > 1) {
                ll tm = (tl + tr) >> 1;
                ll cnt = ask(tm) - skip;
                if (cnt == -1) exit(0);
                if (cnt < sum(border + 1, tm))
                    tr = tm;
                else
                    tl = tm;
            }
            ans.push_back(tr);
            pref_sum += tr;
        }
    }
    cout << "! ";
    for (ll i : ans)
        cout << i << ' ';
    cout << endl;
    ll a;
    cin >> a;
    if (a == -1) exit(0);
}

signed main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    ll t;
    cin >> t;
    while(t--)
        solve();
}