#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES\n"
#define int long long
#define str string

const int INF = 1e14 + 10;

int ask(int p) {
    cout << "? " << p << endl;
    int answ; cin >> answ;
    return answ;
}

int answer(vector<int> ans) {
    cout << "! ";
    for (auto &u : ans) cout << u << ' ';
    cout << endl;
    int res; cin >> res;
    return res;
}
vector<int> solve(int l, int r, int sum, int left) {
    if (l==r){
        return {l};
    }
    int mid = (l + r) / 2;
    int res = ask(mid) - left;
    vector<int> ret;
    if (res != (l + mid) * (mid - l + 1) / 2) {
        auto done = solve(l, mid, res, left);
        for (auto &u : done) ret.pb(u);
    }
    if (sum - res != (mid + 1 + r) * (r - mid) / 2) {
        auto done = solve(mid + 1, r, sum - res, res + left);
        for (auto &u : done) ret.pb(u);
    }
    return ret;
}

void solve() {
    int n, k; cin >> n >> k;

    if (n <= 1000) {
        int lastt = 0, now_ask = 2 - n % 2;
        vector<int> answ;
        while (now_ask - n <= 1) {
            int ress = ask(min(now_ask, n));
            if (ress - lastt == 0) {
                if(now_ask - 1 > 0) {
                    answ.pb(now_ask - 1);
                }
                answ.pb(now_ask);
            } else if (ress - lastt == now_ask) {
                if (now_ask - 1 > 0) {
                    answ.pb(now_ask - 1);
                }
            } else if (ress - lastt == now_ask - 1) {
                answ.pb(now_ask);
            }
            now_ask += 2;
            lastt = ress;
        }
        int ress = answer(answ);
        return;
    }
    int sm = ask(n);
    auto D = solve(1, n, sm, 0);
    int dd = answer(D);
}

signed main() {
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}