#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <unordered_map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
#pragma GCC optimize("O3")

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES"<<endl
#define str string

int ask(int p) {
    cout << "? " << p << endl;
    int answ; cin >> answ;
    return answ;
}

int answer(vector<int> ans) {
    cout << "! ";
    for (auto &u : ans) cout << u << ' ';
    cout << endl;
    int res; cin >> res;
    return res;
}

vector<int> solve(int l, int r, int sum, int left) {
    if (l==r){
        return {l};
    }
    int mid = (l + r) / 2;
    int res = ask(mid) - left;
    vector<int> ret;
    if (res != (l + mid) * (mid - l + 1) / 2) {
        auto done = solve(l, mid, res, left);
        for (auto &u : done) ret.pb(u);
    }
    if (sum - res != (mid + 1 + r) * (r - mid) / 2) {
        auto done = solve(mid + 1, r, sum - res, res + left);
        for (auto &u : done) ret.pb(u);
    }
    return ret;
}

vector<int> solve2(int l, int r, int sum) {
    int mid = (l + r) / 2;
    int res = ask(mid) - l * (l - 1) / 2;
    if ((l + mid) * (mid - l + 1) / 2 - res == sum) {
        return solve2(l, mid, sum);
    } else if ((l + mid) * (mid - l + 1) / 2 == res) {
        return solve2(mid + 1, r, sum);
    }
    int nedost = (l + mid) * (mid - l + 1) / 2 - res;
    if (sum - nedost > r) {
        //coe;
        int res2 = (((sum - nedost) / 2) * ((sum - nedost) / 2 + 1) / 2) - ask((sum - nedost) / 2) - nedost;
        return {nedost, res2, sum - nedost - res2};
    } else {
        int res1 = ((nedost/2) * (nedost/2+1)/2)-ask(nedost / 2);
        return {res1, nedost - res1, sum - nedost};
    }
}

vector<int> solve4(int l, int r, int sum, int left) {
    int mid = (l + r) / 2;
    int res = ask(mid) - l * (l - 1) / 2 + left;
    if ((l + mid) * (mid - l + 1) / 2 - res == sum) {
        return solve4(l, mid, sum, left);
    } else if ((l + mid) * (mid - l + 1) / 2 == res) {
        return solve4(mid + 1, r, sum, left);
    }
    int nedost = (l + mid) * (mid - l + 1) / 2 - res;
    if (sum - nedost > r) {
        int res2 = (((sum - nedost) / 2) * ((sum - nedost) / 2 + 1) / 2) - ask((sum - nedost) / 2) - nedost - left;
        return {nedost, res2, sum - nedost - res2};
    } else {
        int res1 = ((nedost/2) * (nedost/2+1)/2)-ask(nedost / 2) - left;
        return {res1, nedost - res1, sum - nedost};
    }
}

vector<int> solve3(int l, int r, int sum) {
    int mid = (l + r) / 2;
    int res = ask(mid) - l * (l - 1) / 2;
    if ((l + mid) * (mid - l + 1) / 2 - res == sum) {
        return solve3(l, mid, sum);
    } else if ((l + mid) * (mid - l + 1) / 2 == res) {
        return solve3(mid + 1, r, sum);
    }
    int nedost = (l + mid) * (mid - l + 1) / 2 - res;
    if (sum - nedost <= r) {
        auto res1 = solve2(l, mid, nedost);
        res1.pb(sum - nedost);
        return res1;
    } else {
        int cntleft = 0, param2=0;
        if(nedost==1){
            cntleft=1;
        }else{
            int res333 = (nedost/2)*(nedost/2+1)/2-ask(nedost/2);
            if(res333==0)cntleft=1;
            else {cntleft=2;param2=res333;}
        }
        if(cntleft==2){
            int res2 = (((sum - nedost) / 2) * ((sum - nedost) / 2 + 1) / 2) - ask((sum - nedost) / 2) - nedost;
            return {param2, nedost-param2, res2, sum-nedost-res2};
        } else {
            auto RESLAST = solve4(mid + 1, r, sum - nedost, nedost);
            return {nedost, RESLAST[0], RESLAST[1], RESLAST[2]};
        }
    }
}

void solve() {
    int n, k; cin >> n >> k;
    if (k == 3) {
        int sm = n * (n + 1) / 2 - ask(n);
        auto F = solve2(1, n, sm);
        int dd = answer(F);
        return;
    }
    if (k == 4) {
        int sm = n * (n + 1) / 2 - ask(n);
        auto F = solve3(1, n, sm);
        int dd = answer(F);
        return;
    }
    if (n <= 1000) {
        int lastt = 0, now_ask = 2 - n % 2;
        vector<int> answ;
        while (now_ask - n <= 1) {
            int ress = ask(min(now_ask, n));
            if (ress - lastt == 0) {
                if(now_ask - 1 > 0) {
                    answ.pb(now_ask - 1);
                }
                answ.pb(now_ask);
            } else if (ress - lastt == now_ask) {
                if (now_ask - 1 > 0) {
                    answ.pb(now_ask - 1);
                }
            } else if (ress - lastt == now_ask - 1) {
                answ.pb(now_ask);
            }
            now_ask += 2;
            lastt = ress;
        }
        int ress = answer(answ);
        return;
    }
    int sm = ask(n);
    auto D = solve(1, n, sm, 0);
    int dd = answer(D);
}

signed main() {
    int tt; cin >> tt;
    while (tt--) {
        solve();
    }

    return 0;
}