#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = long double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(1337);
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 2e5 + 5;


int ask(int r) {
    cout << "? " << r << endl;
    int res;
    cin >> res;
    return res;
}

vector<int> res;

int f(int l, int r) {
    int cur = r * (r - 1) / 2;
    cur -= l * (l - 1) / 2;
    return cur;
}

void build(int L, int R, int lsum, int rsum) {
    if (R - L == 1) {
        if (rsum - lsum == 0)
            res.pb(L);
        return;
    }
    int M = (L + R) / 2;
    int sum = ask(M - 1);
    int needl = f(L, M);
    int needr = f(M, R);
    int l_sum = sum - lsum;
    int r_sum = rsum - sum;
    if (needl != l_sum) {
        int rem = needl - l_sum;
        int ok = 0;
        if (rem == 2 * L + 1) {
            res.pb(L);
            res.pb(L + 1);
            ok = 1;
        }
        if (rem < 2 * L + 1 && !ok) {
            res.pb(rem);
            ok = 1;
        }
        if (!ok) {
            build(L, M, lsum, sum);
        }
    }
    if (needr != r_sum) {
        int rem = needr - r_sum;
        int ok = 0;
        if (rem == 2 * M + 1) {
            int now = ask(M) - sum;
            if (now == 0) {
                res.pb(M);
                res.pb(M + 1);
                ok = 1;
            }
        }
        if (rem < 2 * M + 1 && !ok) {
            res.pb(rem);
            ok = 1;
        }
        if (!ok) {
            build(M, R, sum, rsum);
        }
    }
}


void solve() {
    res.clear();
    int n, k;
    cin >> n >> k;
    int sum = ask(n);
    build(1, n + 1, 0, sum);
    cout << "! ";
    for (auto i: res) cout << i << ' ';
    cout << endl;
    int good;
    cin >> good;
    assert(good == 1);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
}