#include <bits/stdc++.h>
using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

#define int ll
#define vec vector
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define mp(a, b) make_pair(a, b)
#define sz(v) (int)(v.size())
#define eb emplace_back
#define lb(a, b) lower_bound(all(a), b)
#define ub(a, b) upper_bound(all(a), b)

int bubbleGum = 0;
#ifdef LOCAL
#include "Templates/DebugTemplate.cpp"
#define FAST_IO ;
#else
#define dbg(...) ++bubbleGum;
#define FAST_IO ios_base::sync_with_stdio(false), cin.tie(0);
#endif


const int INF = 2e15 + 10;

int ask(int x) {
    cout << "? " << x << endl;
    cout.flush();
    int cnt; cin >> cnt;
    if (cnt == -1) exit(0);
    return cnt;
}

void solve() {
    int n, k; cin >> n >> k;
    vec<int> ans, sums;
    while (sz(ans) < k) {
        int l = 0, r = n + 1;
        while (r > l + 1) {
            int mid = (l + r) >> 1;
            int sum = ask(mid);
            int before = ub(ans, mid) - ans.begin() - 1;
            if (before >= 0) before = sums[before];
            else before = 0;
            int need = (mid + 1) * mid / 2 - before;
            dbg(before, need, sum);
            if (need != sum) r = mid;
            else l = mid;
        }

        ans.eb(l + 1);
        sums.eb(l + 1 + (!sums.empty() ? sums.back() : (int)0));
    }

    cout << "! ";
    for (auto& it : ans) cout << it << " ";
    cout.flush();
    int x; cin >> x;
    if (x == -1) exit(0);

}


signed main() {
//#ifdef LOCAL
//    freopen("C:\\Users\\user\\CLionProjects\\OpenOlymp\\bigTest.in", "r", stdin);
//#endif
//    FAST_IO

    int t; cin >> t;
    while (t--) solve();

}
/*
5
10283982 98393
9849 3893893
98383 38993
3739 3894894
89389 389498
 */