#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define ld long double
#define pi pair<int, int>
#define int long long
mt19937 MT(179);

void small(int N) {
    int prev = 0;
    vector<int> ans;
    for(int i = 2; i <= N; i += 2) {
        cout << "? " << i << endl;
        int tmp = 0; cin >> tmp;
        if(prev == tmp) {
            ans.push_back(i - 1);
            ans.push_back(i);
            prev = tmp;
            continue;
        }
        if(prev + 2 * i - 1 == tmp) {
            prev = tmp;
            continue;
        }
        if(prev % 2 == tmp %2 ) {
            ans.push_back(i - 1);
        } else {
            ans.push_back(i);
        }
        prev = tmp;
    }
    if(N % 2 == 1) {
        cout << "? " << N << endl;
        int tmp = 0; cin >> tmp;
        if(tmp == prev) ans.push_back(N);
    }
    cout << "! ";
    for(int i = 0; i < ans.size(); ++i) cout << ans[i] << " ";
    cout << endl;
    int an = 1;
    cin >> an;
}
int gt(int N) {
    return N * (N + 1) / 2;
}
void dothr(int N) {
    int cur_l = 0; int cur_r = N;
    int add = 0;
    vector<int> ans;
    while(cur_r - cur_l > 1) {
        int mid = (cur_l + cur_r) / 2;
        int exp = gt(mid);
        for(auto x : ans) {
            if(x <= mid) exp -= x;
        }
        int got = 0;
        cout << "? " << mid << endl;
        cin >> got;
        if(got == exp) cur_l = mid;
        else cur_r = mid;
    }
    ans.push_back(cur_r);
    add += cur_r;
    int tot_sum = 0;
    cout << "? " << N << endl;
    cin >> tot_sum;
    tot_sum = gt(N) - tot_sum;
    int lft = tot_sum - add;
    int bfr = lft / 2;
    int tt = 0;
    cout << "? " << bfr << endl;
    cin >> tt;
    tt = gt(bfr) - tt;
    ans.push_back(tt - add);
    ans.push_back(tot_sum - tt);
    cout << "! ";
    for(auto x : ans) cout << x << " ";
    cout << endl;
    int k = 0; cin >> k;
}
void fr(int N) {
    int cur_l = 0; int cur_r = N;
    int add = 0;
    vector<int> ans;
    while(cur_r - cur_l > 1) {
        int mid = (cur_l + cur_r) / 2;
        int exp = gt(mid);
        for(auto x : ans) {
            if(x <= mid) exp -= x;
        }
        int got = 0;
        cout << "? " << mid << endl;
        cin >> got;
        if(got == exp) cur_l = mid;
        else cur_r = mid;
    }
    ans.push_back(cur_r);
    add += cur_r;
    int tot_sum = 0;
    cout << "? " << N << endl;
    cin >> tot_sum;
    tot_sum = gt(N) - tot_sum - add;
    int lft1 = tot_sum / 3;
    cout << "? " << lft1 << endl;
    int sfir = 0; cin >> sfir;
    sfir = gt(lft1) - sfir - add;
    assert(sfir >= 2);
    cout << "? " << sfir / 2 << endl;
    int sum2 = 0; cin >> sum2;
    sum2 = gt(sfir / 2) - sum2 - add;
    if(sum2 != 0) {
        cout << "! " << ans[0] << " " << sum2 << " " << sfir - sum2 << " " << tot_sum - sfir << endl;
        int k = 0; cin >> k;
        return;
    }
    int sum3 = tot_sum - sfir;
    cout << "? " << sum3 / 2 << endl;
    int sum4 = 0; cin >> sum4;
    sum4 = gt(sum3 / 2) - add - sfir - sum4;
    cout << "! " << add << " " << sfir << " " << sum4 << " " << tot_sum - sfir - sum4 << endl;
    int t = 0; cin >> t;
}
void solve() {
    int N = 0, K = 0; cin >> N >> K;
    if(N <= 1) {
        small(N);
        return;
    }
    if(K == 3) {
        dothr(N);
        return;
    }
    if(K == 4) {
        fr(N);
        return;
    }
    int add = 0;
    vector<int> ans;
    for(int j = 0; j < K; ++j) {
        int cur_l = 0; int cur_r = N;
        if(!ans.empty()) cur_l = ans[0];
        while(cur_r - cur_l > 1) {
            int mid = (cur_l + cur_r) / 2;
            int exp = gt(mid);
            for(auto x : ans) {
                if(x <= mid) exp -= x;
            }
            int got = 0;
            cout << "? " << mid << endl;
            cin >> got;
            if(got == exp) cur_l = mid;
            else cur_r = mid;
        }
        ans.push_back(cur_r);
        add += cur_r;
    }
    cout << "! ";
    for(auto x : ans) cout << x << " ";
    cout << endl;
    int t = 0; cin >> t;
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    cin >> T;
    while(T--) {
        solve();
    }
    return 0;
}
