//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

map<ll, ll> geted;

ll get(ll x) {
	if (geted.find(x) != geted.end()) {
		return geted[x];
	}
	cout << "? " << x << endl;
	cin >> geted[x];
	if (geted[x] == -1) {
		exit(0);
	}
	return geted[x];
}

void make(vector<ll> ans) {
	cout << "! ";
	for (auto i : ans) {
		cout << i << ' ';
	}
	cout << endl;
	ll x;
	cin >> x;
	if (x == -1) {
		exit(0);
	}
}

void solve() {
	geted.clear();
	ll n, k;
	cin >> n >> k;
	if (n <= 1000) {
		vector<ll> ans;
		ll ns = 0;
		for (ll i = 1; i <= n; i += 2) {
			if (i == n) {
				ll now = get(i);
				if (now - ns == 0) {
					ans.push_back(i);
				}
			} else {
				ll now = get(i + 1);
				if (now - ns == i) {
					ans.push_back(i + 1);
				}
				if (now - ns == i + 1) {
					ans.push_back(i);
				}
				if (now - ns == 0) {
					ans.push_back(i);
					ans.push_back(i + 1);
				}
				ns = now;
			}
		}
		make(ans);
		return;
	}
	vector<ll> ans;
	ll nr = n;
	while (k > 3) {
		ll x = nr * (nr + 1) / 2 - get(nr);
		ll l = 0, r = nr;
		while (r - l > 1) {
			ll mid = (l + r) / 2;
			ll nx = mid * (mid + 1) / 2 - get(mid);
			if (nx < x) {
				l = mid;
			} else {
				r = mid;
			}
		}
		ans.push_back(r);
		k--;
		nr = r - 1;
	}
	if (k == 1) {
		ans.push_back(nr * (nr + 1) / 2 - get(nr));
	}
	if (k == 2) {
		ll x = nr * (nr + 1) / 2 - get(nr);
		ll y = (x / 2) * (x / 2 + 1) / 2 - get(x / 2);
		ans.push_back(y);
		ans.push_back(x - y);
	}
	if (k == 3) {
		ll x = nr * (nr + 1) / 2 - get(nr);
		ll y = (x / 3) * (x / 3 + 1) / 2 - get(x / 3);
		ll g = (y > x / 3 ? y : (y == 1 ? 0 : (y - 1) * y / 2 - get(y - 1)));
		if (g == 0) {
			ans.push_back(y);
			x -= y;
			g = (x / 2) * (x / 2 + 1) / 2 - get(x / 2);
			g -= y;
			ans.push_back(g);
			ans.push_back(x - g);
		} else {
			ans.push_back(x - y);
			x = (y / 2) * (y / 2 + 1) / 2 - get(y / 2);
			ans.push_back(x);
			ans.push_back(y - x);
		}
	}
	make(ans);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		ll t;
		cin >> t;
		while (t--) {
			solve();
		}
	} else {
		ll t;
		cin >> t;
		while (t--) {
			solve();
		}
	}
}
