#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

template<typename T>
istream &operator>>(istream &in, vector<T> &a) {
    for (auto &el: a) {
        in >> el;
    }
    return in;
}

template<typename T>
ostream &operator<<(ostream &out, vector<T> &a) {
    for (auto &el: a) {
        out << el << " ";
    }
    return out;
}
map<ll, ll> ans;
vector<ll> bad_find;
ll quest(int i){
    if (ans.find(i) == ans.end()){
        cout << "? " << i << endl;
        ll x;
        cin >> x;
        ans[i] = x;
        return x;
    }
    return ans[i];
}
ll get_sum_pidor(int l, int r, ll need_sum_pidor){
    if (r - l == 1){
        bad_find.push_back(l);
        return l;
    }
    int mid = (r + l) / 2;
    ll x = quest(mid - 1);
    ll real = (mid) * (mid - 1) / 2;
    for (auto el : bad_find){
        if (el < mid){
            x += el;
        }
    }
    if (x != real){
        ll f = get_sum_pidor(l, mid, real - x);
        if (f == need_sum_pidor){
            return f;
        }
        x = quest(r - 1);
        real = (r) * (r - 1) / 2;
        for (auto el : bad_find){
            if (el < r){
                x += el;
            }
        }
        if (x != real){
            f += get_sum_pidor(mid, r, real - x);
        }
        return f;
    }
    else{
        return get_sum_pidor(mid, r, need_sum_pidor);
    }
}

void solve() {
    ans.clear();
    bad_find.clear();
    int n, k;
    cin >> n >> k;
    ll x = quest(n);
    get_sum_pidor(1, n + 1, n * (n + 1) /2 - x);
    cout << "! ";
    for (auto el : bad_find){
        cout << el << " ";
    }
    cout << endl;
    int c;
    cin >> c;
}


signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
