#pragma GCC optimize("Ofast")
#pragma GCC target("avx")
#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <string>

using namespace std;

//#define LOCAL

vector<int> v;
#define ll long long
#ifdef LOCAL
vector<int> not_real;
#endif

ll count(ll k) {
    return (k * (k + 1)) / 2;
}

ll ask(int k) {
    cout << '?' << ' ' << k << endl;
    ll res;
    cin >> res;
    for (int el : v) {
        if (el <= k) {
            res += el;
        }
    }
    return res;
}

void ans() {
    cout << '!' << ' ';
    for (int el : v) {
        cout << el << ' ';
    }
    cout << endl;
}

int main() {
    int t;
    cin >> t;
    for (int q = 0; q < t; q++) {
        int n, k;
        cin >> n >> k;
        v.resize(0);

        for (int i = 0; i < k; i++) {
            int l = 0, r = n;
            while (l + 1 < r) {
                int m = (l + r) / 2;
                if (ask(m) != count(m)) {
                    r = m;
                } else {
                    l = m;
                }
            }

            v.push_back(r);
        }
        ans();
    }

}
