#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

int ask(int n) {
	cout << "? " << n << endl;
	int ans; cin >> ans;
	if (ans == -1) exit(0);
	return ans;
}

void solve() {
	int n, k; cin >> n >> k;

	vector <int> ans;
	int d = 0;
	auto expec = [&](int r) {
		return r * (r + 1) / 2 - d;
	};

	if (n <= 1000) {
		int i = 1;
		for (; i + 1 <= n; i += 2) {
			int cur = ask(i + 1);
			int e = expec(i + 1);
			if (e == cur + i + i + 1) {
				ans.push_back(i);
				ans.push_back(i + 1);
				d += i;
				d += i + 1;
			}
			else if (e == cur + i + 1) {
				ans.push_back(i + 1);
				d += i + 1;
			}
			else if (e == cur + i) {
				ans.push_back(i);
				d += i;
			}
		}
		if (i == n) {
			int cur = ask(i);
			int e = expec(i);
			if (e == cur + i) {
				ans.push_back(i);
				d += i;
			}
		}
	}
	else if (k == 3) {
		int l = 0, r = n;
		while (l + 1 != r) {
			int m = (l + r) / 2;
			if (ask(m) == expec(m)) l = m;
			else r = m;
		}
		ans.push_back(r);
		d += r;
		
		int sm = expec(n) - ask(n);
		int mid = sm / 2;
		int a = expec(mid) - ask(mid);
		ans.push_back(a);
		d += a;
		ans.push_back(sm - a);
		d += sm - a;
	}
	else {
		int pr = 0;
		for (int i = 0; i < k; ++i) {
			int l = pr, r = n;
			while (l + 1 != r) {
				int m = (l + r) / 2;
				if (ask(m) == expec(m)) l = m;
				else r = m;
			}
			ans.push_back(r);
			d += r;
			pr = r;
		}
	}

	cout << "! ";
	for (auto x : ans) cout << x << ' ';
	cout << endl;
	int verd; cin >> verd;
	if (verd == -1) exit(0);
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		//cout << '\n';
	}

	return 0;
}
