#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2")

#include <iostream>
#include <vector> 
#include <algorithm>
#include <iomanip>
#include <numeric>
#include <functional>
#include <map>
#include <cassert>
#include <unordered_set>
#include <cstring>

using namespace std;

#define all(v) (v).begin(), (v).end()
#define rall(v) (v).rbegin(), (v).rend()


using int64 = long long;
using uint64 = unsigned long long;

#define int long long

map <int, int> mem;
int ask(int n) {
	if (mem.count(n)) return mem[n];
	cout << "? " << n << endl;
	int ans; cin >> ans;
	if (ans == -1) exit(0);
	return mem[n] = ans;
}

void calc(int l, int r, int sm, vector <int>& ans, int prsm) {
	if (sm == 0) return;
	if (r - l == 1) {
		ans.push_back(sm);
		return;
	}


	int m = (l + r) / 2;
	int a = ask(m - 1);
	a += prsm;
	int b = m * (m - 1) / 2 - a;

	calc(l, m, b, ans, prsm);
	calc(m, r, sm - b, ans, prsm + b);
}

void solve() {
	int n, k; cin >> n >> k;

	vector <int> ans;
	
	int a = ask(n);
	int b = n * (n + 1) / 2 - a;
	calc(1, n + 1, b, ans, 0);


	cout << "! ";
	assert(ans.size() == k);
	for (auto x : ans) cout << x << ' ';
	cout << endl;
	int verd; cin >> verd;
	if (verd == -1) exit(0);
}


int32_t main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cout << fixed << setprecision(15);

	int t = 1;
	cin >> t;
	while (t--) {
		solve();
		//cout << '\n';
		mem.clear();
	}

	return 0;
}