#include <bits/stdc++.h>

//#define _GLIBCXX_DEBUG

//#define GCC optimize("O3")
//#define GCC optimize("Ofast")
//#define GCC optimize("unroll-loops")
//#define GCC target("avx2")

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using namespace std;

int sum(int n) {
    return n * (n + 1) / 2;
}

void solve() {
    int n, k;
    cin >> n >> k;
    int cur = 1, last = 0;
    unordered_map<int, int> need;
    vector<int> ans;
    while (k--) {
        int l = cur - 1, r = n, prev = 0;
        while (r - l > 1) {
            int m = (l + r) / 2, now;
            if (need.find(m) == need.end()) {
                cout << "? " << m << endl;
                cin >> now;
                need[m] = now;
            } else {
                now = need[m];
            }
            if (now == -1) {
                exit(0);
            }
            if (now - last == sum(m) - sum(cur - 1)) {
                l = m;
                prev = now;
            } else {
                r = m;
            }
        }
        cur = l + 2;
        last = prev;
        ans.emplace_back(l + 1);
    }
    cout << '!';
    for (int &i: ans) cout << ' ' << i;
    cout << endl;
    int res;
    cin >> res;
    if (res == -1) {
        exit(0);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}