#include <iostream>
#include <vector>
#include <cmath>
#include <map>
#include <iomanip>
#include <cassert>
#include <algorithm>
#include <set>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;

#define all(a) (a).begin(), (a).end()
const int MAXQ = 1000;
int ask = 0;

vector<int> answ;

ll ASK(int a) {
    ++ask;
    cout << "? " << a << endl;
    ll get;
    cin >> get;
    return get;
}


void ANSW() {
    cout << "! ";
    for (auto elem : answ) {
        cout << elem << ' ';
    }
    cout << endl;
    int get;
    cin >> get;
    assert(ask < MAXQ);
}


void tree(int tl, int tr, ll pref_s, ll all_s) {
    if (tl + 1 == tr) {
        answ.push_back(tl);
        return;
    }
    int tm = (tl + tr) / 2;
    ll left_s = ASK(tm - 1);
    //cout << '|' << pref_s << '\n';
    if (left_s - pref_s != (tl + tm - 1) * (tm - tl) / 2) {
        tree(tl, tm, pref_s, left_s);
    }
    if (all_s - left_s != (tm + tr - 1) * (tr - tm) / 2) {
        tree(tm, tr, left_s, all_s);
    }
}


int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin >> t;

    for (int qe = 0; qe < t; ++qe) {
        int n, k;
        cin >> n >> k;
        tree(1, n + 1, 0, ASK(n));
        ANSW();
        answ.clear();
    }

    return 0;
}