#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

int ask(int val) {
    cout << "? " << val << endl;
    int res;
    cin >> res;
    if (res == -1) {
        exit(6);
    }
    return res;
}

vector <int> ans;
unordered_map <int, int> mem;

void sol(int l, int r) {
    int total;
    int n = r - l + 1;
    total = n * (r + l) / 2;
    if (mem.find(r) == mem.end()) {
        mem[r] = ask(r);
    }
    if (mem.find(l - 1) == mem.end()) {
        mem[l - 1] = ask(l - 1);
    }
    total -= mem[r];
    total += mem[l - 1];
    if (total == 0) {
        return;
    }
    if ((l * 2 + 1) > total) {
        ans.push_back(total);
        return;
    }
    int m = (l + r) >> 1;
    sol(l, m);
    sol(m + 1, r);
}

void solve() {
    int n, m;
    cin >> n >> m;
    ans = {};
    mem = {};
    mem[0] = 0;
    sol(1, n);
    if (ans.size() == m) {
        cout << "! ";
        for (int i: ans) {
            cout << i << " ";
        }
        cout << endl;
    } else {
        exit(6);
    }
    
    int res;
    cin >> res;
    if (res == -1) {
        exit(6);
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(0);
    cin.tie(0);
    // freopen("input.txt", "r", stdin);
    // freopen("output.txt", "w", stdout);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}