#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <string>
#include <math.h>
#include <iomanip>
using namespace std;
#define double long double
#define int long long
#define ll long long
#define s second
#define f first
#define pb push_back
#define mod 1000000007
#define INF 1000000007
#define mod9 1000000009
#define debug(x) cerr << (#x) << ": "<<x<<endl
int max(int a, int b) {
    if (a > b) return a;
    return b;
}
int min(int a, int b) {
    if (a < b) return a;
    return b;
}
int gcd(int a, int b) {
    while (a > 0 && b > 0) {
        int c = a;
        a = b % a;
        b = c;
    }
    return a + b;
}
ll bin_pow_make(ll a, ll n) {
    if (n == 0) return 1;
    if (n == 1) return a;
    if (n % 2 == 0) {
        ll t = bin_pow_make(a, n / 2);
        return (t * t) % mod;
    }
    ll x = bin_pow_make(a, n - 1);
    return (x * a) % mod;
}
int rev(int a) {
    return bin_pow_make(a, mod - 2);
}
int mul(int a, int b,int m) {
    return ((ll)a * b) % m;
}

int add(int a, int b,int m) {
    if (a + b >= m) return a + b - m;
    return a + b;
}
int ask(int pos) {
    cout << "? " << " " << pos << endl;
    int sum;
    cin >> sum;
    return sum;
}
void out_ans(vector<int> a) {
    cout << "! ";
    for (auto c : a) cout << c << " ";
    cout << endl;
}
int get_sum(int n) {
    return (n * (n + 1)) / 2;
}
void solve() {
    int n, k, add = 0;
    cin >> n >> k;
    map<int, int> we_find;
    vector<int> ans;
    for (int i = 0; i < k; i++) {
        int l = 0, r = n;
        /*
        for (auto c : we_find) {
            if (get_sum(c.first) != c.second) {
                r = c.first;
                break;
            }
        }
        */
        while (r - l > 1) {
            int m = (r + l) / 2, cur = 0;
            if (we_find.count(m)) {
                cur = we_find[m];
            }
            else {
                cur = ask(m);
            }
            int must = get_sum(m);
            we_find[m] = cur;
            if (cur + add == must) {
                l = m;
            }
            else {
                r = m;
            }
        }
        ans.pb(r);
        add += r;
    }
    out_ans(ans);
}
signed main()
{
    ios_base::sync_with_stdio();
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}