#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

const int N = 5e5 + 1;
const int mod = 1e9 + 7;
const int inf = 1e12;

map <int, int> mp;

int ask (int p) {
    if (p <= 0)
        return 0;
    if (mp.find(p) != mp.end())
        return mp[p];
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return mp[p] = x;
}

int g (int l, int r) {
    return (l + r) * (r - l + 1) / 2;
}
vc <int> ans;
int n, k;

void dfs (int l, int r) {
    if (l == r) {
        ans.pb(l);
        return;
    }
    int sum = ask(r) - ask(l - 1);
    int diff = g(l, r) - sum;
    if (diff < 2 * l + 1) {
        ans.pb(diff);
        return;
    }
    int m = (l + r) / 2;
    if (ask(m) - ask(l - 1) != g(l, m))
        dfs(l, m);
    if (ask(r) - ask(m) != g(m, r))
        dfs(m + 1, r);
}

void solve () {
    mp.clear();
    cin >> n >> k;
    dfs(1, n);
    cout << "! ";
    for (int i : ans)
        cout << i << ' ';
    cout << endl;
    ans.clear();
    int a;
    cin >> a;
    if (a != 1)
        exit(1);
}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}