#include <bits/stdc++.h>

using namespace std;

#define sz(a) (int)(a).size()

typedef long long ll;

ll ask(int p) {
    cout << "? " << p << endl;
    ll res;
    cin >> res;
    if (res == -1) assert(false);
    return res;
}

void answer(vector<int> &v) {
    cout << "?";
    for (auto el : v) {
        cout << ' ' << el;
    }
    cout << endl;
    int res;
    cin >> res;
    if (res == -1) assert(false);
}

ll diff(int p) {
    return ((ll)p * (p + 1) / 2) - ask(p);
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    int left = n;
    for (int i = 0; i < k; ++i) {
        ll d = diff(left);
        int l = 0, r = left;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (diff(m) == d) {
                r = m;
            } else {
                l = m;
            }
        }
        left = l;
        ans.push_back(r);
    }
    answer(ans);
}

int main() {
#ifdef LOCAL
//    freopen("../in.txt", "r", stdin);
//    freopen("../out.txt", "w", stdout);
#else
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
#endif

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}