#include <iostream>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <limits>
#include <string>
#include <vector>
#include <climits>

#define sz(a) int((int)a.size())

//#define int long long

using namespace std;

vector<int> ans;

bool print_ans() {
    cout << "! ";
    cout.flush();
    for (auto el : ans) {
        cout << el << ' ';
        cout.flush();
    }
    cout << endl;
    int a;
    cin >> a;
    return a == 1;
}

long long get_res(int r) {
    cout << "? " << r << endl;
    cout.flush();
    long long x;
    cin >> x;
//    if (x == -1) {
//        exit(0);
//    }
    return x;
}

bool good(int m) {
    unsigned long long supposed = m * (m + 1) / 2; // Переполнение???
    unsigned long long have = get_res(m);
    for (auto el : ans) {
        if (el <= m) {
            have += el;
        }
    }
    return supposed == have;
}

long long get_sum(int l, int r) {
    long long have = 0;
    if (l == 1) {
        have += get_res(r);
    }
    have += get_res(r) - get_res(l - 1);
    for (auto el : ans) {
        if (el <= r && el >= l) {
            have += el;
        }
    }
    return have;
}

void solve() {
    ans.clear();
    int n, k;
    cin >> n >> k;
    while (ans.size() < k) {
        int l = 0, r = n;
        while (r - l > 1) {
            long long sum_need = (l + r) * (r - l + 1) / 2 - get_sum(l, r);
            if (l + l + 1 > sum_need) {
                ans.push_back(sum_need);
                break;
            }
            int m = (l + r) / 2;
            if (good(m)) {
                l = m;
            } else {
                r = m;
            }
        }
        ans.push_back(r);
    }
    print_ans();
//        exit(0);
}

int32_t main() {
    //freopen("input.txt", "r", stdin);
//    ios_base::sync_with_stdio(false);
//    cin.tie(nullptr);
//    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t-->0) {
        solve();
    }
    return 0;
}