#include <iostream>
#include <map>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <set>
using namespace std;
#define int long long
int sould(vector<int> &have, int p) {
    int sum = p * (p + 1) / 2;
    for (auto x : have) {
        sum -= x;
    }
    return sum;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> have;
    int last = 0;
    map<int, int> was;
    for (int i = 0; i < k; i++) {
        int l = last;
        int r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            int a;
            if (was.find(m) == was.end()) {
                cout << "? " << m << endl;
                cin >> a;
            } else {
                a = was[m];
            }
            was[m] = a;
            int s = sould(have, m);

            if (a == s) {
                l = m;
            } else {
                if (a + last + 1 + last + 2 > s) {
                    r = s - a;
                    break;
                }
                r = m;
            }
        }
        have.push_back(r);
        last = r;
    }
    cout << "! ";
    for (auto x : have) {
        cout << x << ' ';
    }
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}
signed main() {
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        solve();
    }
}