#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define F first
#define S second
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()
#define sz(a) a.size()
#define dbg(a) cout << #a << " = " << a << endl
#define dbg1(a) cout << #a << " = [ "; for (auto e : a) cout << e << " "; cout << "]" << endl;
#define dbg2(a) cout << #a << " = [ "; for (auto [f, s] : a) cout << " { " << f << ' ' << s << " } " << ' '; cout << "]" << endl;

using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
using ll = long long;
using ld = long double;

mt19937 rnd(1337);

const int INF = 1e9 + 7;

map<int, int> pref;

int k;

int ask(int n) {
    cout << "? " << n << endl;
    int ans;
    cin >> ans;
    pref[n] = ans;
    return ans;
}

vector<int> ans;

int rec(int l, int r, int sm=-1) {
    int c;
    if (sm == -1)
        c = r * (r + 1) / 2 - l * (l - 1) / 2 - (ask(r) - pref[l - 1]);
    else
        c = sm;

    if (c == 0) {
        return c;
    }
    if (k == 1) {
        ans.emplace_back(c);
        k--;
    } else if (c == r * (r + 1) / 2 - l * (l - 1) / 2) {
        for (int i = l; i <= r; i++) {
            ans.emplace_back(i);
            k--;
        }
    } else if (c >= l && c <= r && 2 * l >= r) {
        ans.emplace_back(c);
        k--;
    } else {
        int m = (l + r) / 2;
        int c1 = rec(l, m);
        rec(m + 1, r, c - c1);
    }
    return c;
}

void solve() {
    pref.clear();
    ans.clear();
    int n;
    cin >> n >> k;
    rec(1, n);
    cout << "! ";
    for (auto a : ans) cout << a << ' ';
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1) {
        exit(0);
    }
}

signed main() {
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
}