#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';

using namespace std;
using ll = ::int64_t;

unordered_map<ll, ll> res;
ll ask(ll p) {
    if (res.count(p)) return res[p];
    cout << "? " << p << endl;
    ll r;
    cin >> r;
    if (r == -1) exit(3);
    return res[p] = r;
}

void solve() {
    res.clear();
    ll n, k;
    cin >> n >> k;
    ll full = n * (n + 1) / 2 - ask(n);
    vector<ll> ans;
    ll sum = 0;
    ll pos = 0;
    for (int i = 0; i + 1 < k; ++i) {
        ll lo = pos, hi = n;
        while (hi - lo > 1) {
            ll md = (hi - lo) / 2 + lo;
            ll r = ask(md);
            if (sum + r != md * (md + 1) / 2) {
                hi = md;
            } else {
                lo = md;
            }
        }
        ans.emplace_back(hi);
        sum += hi;
        pos = hi;
    }
    ans.emplace_back(full - sum);
    cout << "! ";
    assert(sz(ans) == k);
    for (ll x : ans) cout << x << ' ';
    cout << endl;
    ll a;
    cin >> a;
    if (a == -1) exit(0);
}

int main() {
    int tt = 1;
    cin >> tt;
    while (tt--) solve();
    return 0;
}