#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define VC(vc) vc.begin(), vc.end()

ll request(int p)
{
    ll ans;
    cout << "? " << p << endl;
    cin >> ans;
    return ans;
}

ll get_sum(ll ed)
{
    return (1ll + ed) * ed / 2ll;
}

const int INF = 1e9 + 7;

void solve()
{
    int n, k;
    cin >> n >> k;
    vector <int> anses;
    anses.reserve(k);
    map <int, ll> saves;
    ll delta = request(n) - get_sum(n);
    int mx_r = n + 1;
    ll pr = 0;
    int l = 0, r = n + 1;
    for (int i = 0; i < k; i++)
    {
        while (r - l > 1)
        {
            int m = (r - l) / 2 + l;

            ll ans = 0;
            if (saves.find(m) == saves.end()) ans = request(m);
            else ans = saves[m];
            if (ans == -1)
            {
                exit(0);
            }
            saves[m] = ans;
            if (ans == delta)
            {
                mx_r = min(mx_r, m);
            }
            //cout << ans << ' ' << get_sum(m) - pr << endl;
            if (ans != get_sum(m) - pr)
            {
                r = m;
            }
            else
            {
                l = m;
            }
        }
        anses.push_back(l + 1);
        pr += l + 1;
        l += 1;
        r = mx_r;
    }
    cout << "! ";
    for (auto i: anses)
    {
        cout << i << ' ';
    }
    cout << endl;
    int ans;
    cin >> ans;
    if (ans == -1)
    {
        exit(0);
    }
}

signed main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    cin >> t;
    while (t--)
    {
        solve();
    }
    return 0;
}
