from collections import defaultdict as dd


cache = dd(int)


def ask(p):
    if p in cache:
        return cache[p]

    print('?', p)
    a = int(input())

    if a == -1:
        return 1 / 0
    else:
        cache[p] = a
        return a


def answer(m):
    print('!', *m)
    if input() == '-1':
        exit(0)


def sm(a, b):
    n = b - a
    return a * n + n*(n-1)//2


def f(l, r, s, aboba):
    if r - l == 1:
        if s == 0:
            return [l]
        else:
            return []

    m = (l + r) // 2

    ls = ask(m-1) - aboba
    rs = s - ls

    ans = []

    if ls != sm(l, m):
        ans += f(l, m, ls, aboba)
    if rs != sm(m, r):
        ans += f(m, r, rs, aboba + ls)

    return ans


def main():
    n, k = map(int, input().split())
    s = ask(n)

    m = f(1, n+1, s, 0)
    answer(m)


if __name__ == '__main__':
    for _ in range(int(input())):
        cache = dd(int)
        main()
