#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
#define int long long
#define dl long double

map<int, int> mp;

int ask(int k) {
    if (mp.find(k) != mp.end()) return mp[k];
    cout << "? " << k << endl;
    int x;
    cin >> x;
    mp[k] = x;
    return x;
}

int find(int l, int r) {
    if (l == r) {
        ask(l);
        ask(l - 1);
        if (mp[l] == mp[l - 1]) return l;
        return 0;
    }
    int x = ask(l - 1);
    ask(r);
    if (mp[l - 1] == mp[r]) return 0;
    int mid;
    while (r - l > 1) {
        mid = (l + r) / 2;
        if (ask(mid) > x) r = mid;
        else l = mid;
    }
    return r;
}

vector<pair<int, int>> split(int l, int r, int mid) {
    vector<pair<int, int>> ans;
    if (l != mid) ans.pb({l, mid - 1});
    if (r != mid) ans.pb({mid + 1, r});
    return ans;
}

void solve() {
    int n, k;
    cin >> n >> k;
    mp[0] = 0;
    vector<pair<int, int>> a = {{1, n}};
    vector<int> res;
    while (!a.empty()) {
        auto [l, r] = a.back();
        a.pop_back();
        int x = find(l, r);
        if (x == 0) continue;
        res.pb(x);
        for (auto i: split(l, r, x)) a.pb(i);
    }
    cout << "! ";
    for (auto i: res) cout << i << ' ';
    cout << endl;
    cin >> n;
}

signed main() {
#ifndef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
//    freopen("input", "r", stdin);
//    freopen("out", "w", stdout);
#endif
    int tests = 1;
    cin >> tests;
    while (tests--) solve();
}