#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) v.rbegin(), v.rend()

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

const int mod = 1e9 + 7;

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    ll prv = 0;
    ll s = 0;
    for (int i = 0; i < k; i++) {
        ll l = prv;
        ll r = n;
        while (l + 1 < r) {
            ll m = (l + r) / 2;
            cout << '?' << ' ' << m << endl;
            ll a;
            cin >> a;
            if (a + s != m * (m + 1) / 2) {
                r = m;
            } else {
                l = m;
            }
        }

        prv = r;
        ans.push_back(prv);
        s += prv;
    }
    cout << '!' << ' ';
    for (int i = 0; i < k; i++) cout << ans[i] << ' '; cout << endl;

    int a;
    cin >> a;
    if (a == -1) {
        exit(0);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while (t--) solve();

    return 0;
}