#include <bits/stdc++.h>


using namespace std;


#define ll long long
#define flt double
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()


mt19937_64 rnd(24234);
const ll inf = 1e18;


bool strs = false;

int asks_cnt = 0;
ll n, k;
vector<ll> a;

void build_strs(){
    for(int i = 0; i < 1; i += 1){
        n = 1e9;
        k = 30;
        asks_cnt = 0;
        set<int> ast;
        a.clear();
        for(int i = 0; i < k; i += 1){
            ll x = rnd() % n + 1;
            while(ast.find(x) != ast.end()){
                x = rnd() % n + 1;
            }
            ast.insert(x);
            a.push_back(x);
        }
        sort(all(a));
    }
}



ll ask(ll p){
    if(strs){
        asks_cnt += 1;
        ll sm = 0;
        for(int i = 0; i < k; i += 1){
            if(a[i] <= p){
                sm += a[i];
            }
        }
        return sm;
    }
    cout << "? " << p << endl;
    ll sm = 0;
    cin >> sm;
    return (p * (p + 1)) / 2 - sm;
}


ll answer(vector<ll> &a){
    cout << "!";
    for(auto i: a){
        cout << " " << i;
    }
    cout << endl;
}


void solve(ll l, ll r, ll dx, ll msm, vector<ll> &rs){
    if(msm == 0){
        return;
    }
    if(l > ((r - 1) / 2) && msm < l + l + 1){
        rs.push_back(msm);
        return;
    }
    for(int cnt = 2; ; cnt += 1){
        ll p = msm / cnt;
        if(p >= r){
            continue;
        }
        ll sm = ask(p) - dx;
        if(sm != 0){
            solve(l, p, dx, sm, rs);
            solve(p + 1, r, dx + sm, msm - sm, rs);
            return;
        }
    }
}


vector<ll> solve(){
    vector<ll> rs;
    ll l = 1;
    ll prvs_sm = 0;
    while(l <= n){
        ll r = min(l + l, n);
        ll msm = ask(r) - prvs_sm;
        solve(l, r, prvs_sm, msm, rs);
        prvs_sm += msm;
        l = r + 1;
    }
    sort(all(rs));
    return rs;
}


int32_t main(){
    if(0){
        ios::sync_with_stdio(0);
        cin.tie(0);
        cout.tie(0);
    }
    int t;
    if(strs){
        t = 20;
    } else{
        cin >> t;
    }
    while(t--){
        if(strs){
            build_strs();
        } else{
            cin >> n >> k;
        }
        auto ans = solve();
        if(strs){
            if(ans != a){
                assert(0);
            }
        } else{
            answer(ans);
        }
        if(strs){
            cout << "Used: " << asks_cnt << "\n";
        }
    }
    return 0;
}

/*
1
10 3
38
3
3
7


*/