#include <bits/stdc++.h>

#define int long long
//g++ -std=c++17 -fsanitize=address -DLOCAL -D_GLIBCXX_DEBUG D.cpp -o D
using namespace std;

void outans(vector<int> &ans) {
    cout << "! ";
    for (auto i : ans) cout << i << ' ';
    cout << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
}

int guess(int p) {
    cout << "? " << p << endl;
    int a;
    cin >> a;
    if (a == -1) exit(0);
    return a;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> ans;
    int d = 0, prv = 0;
    for (int i = 0; i < k; ++i) {
        int l = prv, r = n;
        while (r - l > 1) {
            int m = (l + r) / 2;
            if (guess(m) != m * (m + 1) / 2 - d) r = m;
            else l = m;
        }
        ans.push_back(r);
        prv = r, d += r;
    }
    outans(ans);
}

int32_t main() {
    #ifdef LOCAL
    // freopen("in.txt", "r", stdin);
    // freopen("out.txt", "w", stdout);
    #else 
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    #endif
    int t;
    cin >> t;
    while (t--) solve();
    return 0;
}