#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <set>
#include <iomanip>
#include <map>
#include <string>
#include <vector>

using namespace std;

map <int, long long> asked;

long long ask(int p) {
	if (p == 0)
		return 0;
	if (asked.find(p) != asked.end())
		return asked[p];
	cout << "? " << p << endl;
	long long res;
	cin >> res;
	asked[p] = res;
	return res;
}

long long f(int l, int r) {
	int len = (r - l + 1);
	return 1ll * (l + r) * len / 2;
}

vector <int> ans;

void calc(int l, int r, long long w) {
	if (w == 0)
		return;
	if (w <= 2 * l) {
		ans.push_back(w);
		return;
	}
	int mid = (l + r) / 2;
	long long wl = f(l, mid) - (ask(mid) - ask(l - 1));
	calc(l, mid, wl);
	calc(mid + 1, r, w - wl);
}


void solve() {
	asked.clear();
	ans.clear();
	int n, k;
	cin >> n >> k;
	calc(1, n, f(1, n) - ask(n));
	cout << "! ";
	for (auto e : ans)
		cout << e << " ";
	cout << endl;
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int tests = 1;
	cin >> tests;
	for (int test = 1; test <= tests; test++) {
		solve();
	}
}