#include <bits/stdc++.h>

#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

int req(int p) {
    cout << "? " << p << endl;
    int x;
    cin >> x;
    return x;
}

int real(int l, int r) {
    return (l + r) * (r - l + 1) / 2;
}

vector<int> solve(int l, int r, int pf, int sum, int k) {
    if (real(l, r) == sum) return {};
    if (sum == 0) {
        vector<int> res(r - l + 1);
        iota(all(res), l);
        return res;
    }
    if (real(l, r) - sum < 2 * l + 1) return {real(l, r) - sum};
    if (sum < 2 * l + 1) {
        vector<int> res;
        res.reserve(r - l);
        for (int j = l; j <= r; j++) {
            if (j != sum) res.push_back(j);
        }
        return res;
    }
    if (k == -1) {
        int lef = 0, rig = 101;
        while (lef + 1 < rig) {
            int mid = (lef + rig) / 2;
            if (real(l, l + mid - 1) > real(l, r) - sum) rig = mid;
            else lef = mid;
        }
        if (real(r - lef + 2, r) < real(l, r) - sum) k = lef;
    }
    int mid;
    if (k == -1) mid = (l + r) / 2;
    else mid = (real(l, r) - sum) / k;
    int s1 = req(mid);
    auto res1 = solve(l, mid, pf, s1 - pf, -1);
    auto res2 = solve(mid + 1, r, s1, sum - s1 + pf, -1);
    vector<int> res;
    res.reserve(res1.size() + res2.size());
    for (auto j : res1) res.push_back(j);
    for (auto j : res2) res.push_back(j);
    return res;
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, k;
        cin >> n >> k;
        auto res = solve(1, n, 0, req(n), k);
        cout << '!';
        for (auto j : res) cout << ' ' << j;
        cout << endl;
        cin >> k;
    }
}
