#include <bits/stdc++.h>
using namespace std;

int n, k;
long long delta;
vector<int> pos;
map<int, long long> queries;

long long ask(int p) {
    if (queries.count(p)) {
        return queries[p];
    }
    cout << "? " << p << endl;
    long long r;
    cin >> r;
    if (r == -1) {
        exit(0);
    }
    queries[p] = r;
    return r;
}

void answer() {
    cout << "!";
    for (int v : pos) {
        cout << " " << v;
    }
    cout << endl;
    int r;
    cin >> r;
    if (r == -1) {
        exit(0);
    }
}

const int C = 30;

struct search_tree {
    int L, R;
    search_tree* children[C];
    long long value = -1;

    search_tree(int L, int R) : L(L), R(R) {}

    bool saturated() {
        if (k == 0) {
            return true;
        }
        if (R - L == 0) {
            return true;
        }
        if (value == -1) {
            value = ask(min(R, n));
        }
        return value + delta == 1ll * min(R, n) * (min(R, n) + 1) / 2;
    }

    void search() {
        int child = 0, left = L, add = (R - L) % C;
        while (!saturated()) {
            int delta = child < add;
            children[child] = new search_tree(left, left + (R - L) / C + delta);
            children[child]->search();
            left += (R - L) / C + delta;
            child++;
        }
    }
};

int32_t main() {
    int t;
    cin >> t;
    while (t--) {
        delta = 0;
        queries = map<int, long long>();
        cin >> n >> k;
        search_tree tree(0, n);
        tree.search();
        answer();
        pos = vector<int>();
    }
}