//#pragma GCC optimize("Ofast")

#include <bits/stdc++.h>
#include <bit>

using namespace std;

#define get_time() ((double)clock() / (double)CLOCKS_PER_SEC)

#define all(_a) _a.begin(), _a.end()
#define rall(_a) _a.rbegin(), _a.rend()

const int INF = 2e9;

const int MAX_N = 5e5;

int a[MAX_N];
int b[MAX_N];
int sorted[MAX_N * 2];

int len;

int ans = INF;

int vozm[MAX_N * 2];
int must[MAX_N * 2];

vector<int> index1[MAX_N * 2];

int len_vozm;
int len_must;

void vozm_insert(int i) {
    ++vozm[i];
    ++len_vozm;
}

void vozm_erase(int i) { // white -> ser
    --vozm[i];
    --len_vozm;
}

int max_must = -1;

void must_insert(int i) { // ser -> black
    ++must[i];
    max_must = max(max_must, i);
    ++len_must;
}

void relax_ans(int i, int val) {
    if (len_must != 0) {
        val = max(val, max_must);
    }
    ans = min(ans, abs(sorted[i] - sorted[val]));
}

void relax_ans(int i) {
//    cerr << i << '\n';
//    for (int i = 0; i < len; ++i) {
//        cerr << vozm[i] << ' ';
//    }
//    cerr << '\n';
//    for (int i = 0; i > len; ++i) {
//        cerr << must[i] << ' ';
//    }
//    exit(0);
    if (len_must != 0) {
        relax_ans(i, -1);
    }
    for (int j = 0; j < len; ++j) {
        if (vozm[j]) {
            relax_ans(i, j);
        }
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif

    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        cin >> a[i] >> b[i];
    }
    for (int i = 0; i < n; ++i) {
        sorted[len++] = a[i];
    }
    for (int i = 0; i < n; ++i) {
        sorted[len++] = b[i];
    }
    sort(sorted, sorted + len);
    len = unique(sorted, sorted + len) - sorted;


    for (int i = 0; i < n; ++i) {
        a[i] = lower_bound(sorted, sorted + len, a[i]) - sorted;
        b[i] = lower_bound(sorted, sorted + len, b[i]) - sorted;
    }

    for (int i = 0; i < n; ++i) {
        vozm_insert(b[i]);
    }
    for (int i = 0; i < n; ++i) {
        index1[a[i]].push_back(i);
    }
    for (int i = len - 1; i >= 0; --i) {
        vector<int>& v = index1[i];
        if (v.empty()) {

        } else if ((int)v.size() == 1) {
            vozm_erase(b[v[0]]);
            relax_ans(i);
            must_insert(b[v[0]]);
        } else {
            relax_ans(i);
            for (int ind : v) {
                vozm_erase(b[ind]);
                must_insert(b[ind]);
            }
        }
    }
    cout << ans << '\n';
}