#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <random>
#include <unordered_map>
#include <string>
#include <algorithm>
#include <cmath>
#include <cassert>
#define int long long
using namespace std;
int p = 31;
int md = 1e9 + 7;
int pp[6000010];

signed main()
{
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	vector <int> ht(t.size() + 1);
	pp[0] = 1;
	for (int i = 1; i < 6000010; ++i) {
		pp[i] = (pp[i - 1] * p) % md;
	}
	for (int i = 1; i <= t.size(); ++i) {
		ht[i] = (ht[i - 1] + (t[i - 1] - 'a' + 1) * pp[i - 1] % md) % md;
	}
	vector <set <int> > e(1e5 + 1);
	set <int> dl;
	for (int i = 0 ;i < n;++i){
		string s;
		int h = 0;
		cin >> s;
		for (int i = 0; i < s.size(); ++i) {
			h += (s[i] - 'a' + 1) * pp[i + 5000000] % md;
			h %= md;
		}
		e[s.size()].insert(h);
		dl.insert(s.size());
	}
	vector <vector <int> > u(1e5 + 1);


	for (auto x : dl) {
		if (x < t.size()) {
			for (int i = 0; i <= t.size() - x; ++i) {
				int ee = ((ht[i + x] - ht[i] + md) % md) * pp[5000000 - i];
				ee %= md;
				if (e[x].find(ee) != e[x].end()) {
					u[x].push_back(i);
				}
			}
		}
	}

	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		int ans = 0;
		l--;
		r--;
		for (auto x : dl) {
			if (x > (r - l + 1) ){
				break;
			}
			auto it1 = lower_bound(u[x].begin(), u[x].end(), l);
			auto it2 = upper_bound(u[x].begin(), u[x].end(), r - x + 1);
			ans += (it2 - it1);
		}
		cout << ans << " ";
	}

} 