#include <bits/stdc++.h>
#define ll long long
#define int ll
#define pb push_back
#define ull unsigned long long

using namespace std;
const int MOD = 1e9 + 7;
const int N = 1e5 + 10;
int P = 37;
int st[N];

int HASH(string &s) {
    int h = s[0] - 'a' + 1;
    for (int i = 1; i < (int)s.size(); ++i) {
        h = (h * P) + (s[i] - 'a' + 1);
        h %= MOD;
    }
    return h;
}
vector <int> make_hash(string &s) {
    int sz = s.size();
    vector <int> h(sz);
    h[0] = s[0] - 'a' + 1;
    for (int i = 1; i < sz; ++i) {
        h[i] = (h[i - 1] * P) + (s[i] - 'a' + 1);
        h[i] %= MOD;
    }
    return h;
}
int get_hash(vector <int> &h, int l, int r) {
    int ans = h[r];
    int len = r - l + 1;
    if (l) ans -= h[l - 1] * st[len] % MOD;
    ans = (ans + MOD * 10) % MOD;
    return ans;
}
int32_t main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    st[0] = 1;
    for (int i = 1; i < N; ++i) {
        st[i] = (st[i - 1] * P) % MOD;
    }
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int sz = t.size();
    vector <int> h;
    h = make_hash(t);
    map <int, int> mp;
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int now = HASH(s);
        mp[now]++;
    }
    while(m--) {
        int l, r;
        cin >> l >> r;
        l--; r--;
        int ans = 0;
        for (int i = l; i <= r; ++i) {
            for (int j = i; j <= r; ++j) {
                if (mp.count(get_hash(h, i, j))) ans++;
            }
        }
        cout << ans << " ";
    }
    return 0;
}
