#include <iostream>
#include <cmath>
#include <iomanip>
#include <queue>
#include <map>
#include <vector>
#include <set>
#include <algorithm>
#define ll long long
using namespace std;
void FAST() {
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
vector <ll> p(0);
ll mod = 1e9 + 7;
ll binpow(ll a, ll b) {
    if (b == 0)
        return 1;
    ll q = binpow(a, b / 2);
    ll tq = q * q % mod;
    if (b % 2 == 0)
        return tq;
    else
        return (tq * a) % mod;
}
void solve() {
    ll n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    vector <string> w(n);
    for (ll i = 0; i < n; ++i) {
        cin >> w[i];
    }
    vector <vector <ll> > ps(n);
    vector <ll> hs(s.size() + 1, 0);
    ll p = 43;
    vector <ll> fr(1e6 + 10, 1);
    vector <ll> def(1e6 + 10, 1);
    for (ll i = 1; i < 1e6 + 5; ++i) {
        fr[i] = fr[i - 1] * p;
        fr[i] %= mod;
        def[i] = binpow(fr[i], mod - 2);
    }
    for (ll i = 1; i <= s.size(); ++i) {
        ll now = fr[i] * (s[i - 1] - 'a');
        now %= mod;
        hs[i] = hs[i - 1] + now;
        hs[i] %= mod;
    }
    for (ll i = 0; i < n; ++i) {
        ll nw = 0;
        for (ll j = 0; j < w[i].size(); ++j) {
            ll now = fr[j] * (w[i][j] - 'a');
            now %= mod;
            nw += now;
            nw %= mod;
        }
        for (ll j = 0; j + w[i].size() <= s.size(); ++j) {
            ll now = hs[j + w[i].size()] - hs[j];
            now += mod;
            now %= mod;
            now *= def[j + 1];
            now %= mod;
            if (now == nw) {
                ps[i].push_back(j);
            }
        }
    }
    if (n > 100) {
        cout << "HAHA";
        return;
    }
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--; r--;
        ll ans = 0;
        for (ll i = 0; i < n; ++i) {
            ll t1 = lower_bound(ps[i].begin(), ps[i].end(), l) - ps[i].begin();
            if (ps[i].size() <= t1 || ps[i][t1] > r - (ll)w[i].size() + 1)
                t1 = 1e9;
            ll t2 = upper_bound(ps[i].begin(), ps[i].end(), r - (ll)w[i].size() + 1) - ps[i].begin() - 1;
            if (t2 == -1 || ps[i][t2] > r - w[i].size() + 1)
                t2 = -1e9;
            ans += max(0ll, t2 - t1 + 1);
        }
        cout << ans << "\n";
    }
}
int main()
{
    FAST();
    int tt = 1; cin >> tt;
    while (tt--) {
        solve();
    }
}