#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

ll INF = 2e18;
const ll mod = 1e9 + 7;

int q, m, n;
string ttt;

ll f[750005] = {0};

void upd(int pos){
    //cout << "here\n";
    for(; pos < n; pos |= (pos + 1)){
        f[pos] += 1;
        //cout << pos << ' ' << f[pos] << '\n';
    }
}

ll sum(int pos){
    ll res = 0;
    //cout << pos << ' ';
    for(; pos >= 0; pos = (pos & (pos + 1)) - 1) res += f[pos];
    //cout << res << '\n';
    return res;
}

ll sum(int l, int r){
    return sum(r) - sum(l - 1);
}

int t[100005][26] = {0};
int terms[100005] = {0};
int suff[1000005] = {0};
int nxt[1000005] = {0};
int ans[500005];

int cnt = 1;

void add(string& s){
    int v = 0;
    for(char c : s){
        if(!t[v][c - 'a']) t[v][c - 'a'] = cnt++;
        v = t[v][c - 'a'];
    }
    //cout << s << ' ' << v << '\n';
    terms[v] = (int)s.length();
}

int qq[1000005];
int st = 0, fn = 0;

vector<pii> qs[750005];

void suffs(){
    qq[fn++] = 0;
    while(st < fn){
        int v = qq[st++];
        for(int i = 0; i < 26; i++){
            if(!t[v][i]) continue;
            int u = t[v][i];
            int cur = suff[v];
            while(cur != -1 && !t[cur][i]) cur = suff[cur];
            suff[u] = (cur == -1 ? 0 : t[cur][i]);
            //cout << u << ' ' << suff[u] << '\n';
            nxt[u] = (terms[suff[u]] ? suff[u] : nxt[suff[u]]);
            qq[fn++] = u;
        }
    }
}

void solve(){
    cin >> m >> q;
    cin >> ttt;
    n = (int)ttt.length();
    string s;
    for(int i = 0; i < m; i++){
        cin >> s;
        if((int)s.length() <= n){
            reverse(all(s));
            add(s);
        }
    }
    suff[0] = -1;
    nxt[0] = -1;
    suffs();
    for(int i = 0; i < q; i++){
        int l, r;
        cin >> l >> r;
        l--; r--;
        qs[l].push_back({r, i});
    }
    int cur = 0;
    for(int i = n - 1; i >= 0; i--){
        int id = (int)(ttt[i] - 'a');
        while(cur != -1 && !t[cur][id]) cur = suff[cur];
        cur = (cur == -1 ? 0 : t[cur][id]);
        int v = cur;
        //cout << i << ' ' << cur << '\n';
        while(v != -1){
            //cout << i << ' ' << v << ' ' << terms[v] << '\n';
            if(terms[v]){
                upd(i + terms[v] - 1);
                //cout << "upd: " << i + terms[v] - 1 << '\n';
            }
            v = nxt[v];
        }
        for(pii& u : qs[i]){
            //cout << "qq " << i << ' ' << u.ff << ' ' << u.ss << ' ' << sum(i, u.ff) << '\n';
            ans[u.ss] = sum(i, u.ff);
        }
    }
    for(int i = 0; i < q; i++) cout << ans[i] << ' ';
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    tt = 1;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "_____________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << '\n';
    #endif // LOCAL
    return 0;
}

