#include <bits/stdc++.h>
#define all(a) a.begin(), a.end()
#define endl '\n'
#define len(a) (int)a.size()
#define allr(a) a.rbegin(), a.rend()
#define f first
#define s second

using namespace std;
typedef long long ll;
typedef long double ld;
const ll INF = 1e18;
const int MAXI = 1e9 + 1e7;

const int MAXT = 1e6 + 100;
int z[MAXT], pref[MAXT], fenwik[MAXT];

void add(int pos, int val) {
    for (; pos < MAXT; pos |= pos + 1)
        fenwik[pos] += val;
}

int get_pref(int pos) {
    int res = 0;
    for (; pos >= 0; pos = (pos & pos + 1) - 1)
        res += fenwik[pos];
    return res;
}

int get_seg(int l, int r) {
    return get_pref(r) - (!l ? 0 : get_pref(l - 1));
}


void z_function(const string &s) {
    int n = len(s);
    int r = n, l = n;
    z[n - 1] = 0;
    for (int i = n - 2; i >= 0; i--) {
        z[i] = 0;
        if (l <= i)
            z[i] = min(i - l + 1, z[n - (r - i) - 1]);
        while (i - z[i] >= 0 && s[n - z[i] - 1] == s[i - z[i]])
            z[i]++;
        if (i - z[i] + 1 < l) {
            r = i;
            l = i - z[i] + 1;
        }
    }
}

struct Node {
    int go[26] = {0};
    int end_here = 0;
};

Node trie[MAXT];
int timer = 0;

void add_string(const string &s) {
    int u = 0;
    for (char c : s) {
        if (!trie[u].go[c - 'a']) {
            timer++;
            trie[u].go[c - 'a'] = timer;
        }
        u = trie[u].go[c - 'a'];
    }
    trie[u].end_here++;
}

vector<pair<int, int> > finish[MAXT];

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
#ifdef MY_DEBUG
    freopen("../input.txt", "r", stdin);
    freopen("../output.txt", "w", stdout);
#endif
    const int block = 300;
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int l[m], r[m], ans[m];
    fill(ans, ans + m, 0);
    string s[n];
    for (int i = 0; i < n; i++)
        cin >> s[i];
    for (int i = 0; i < m; i++) {
        cin >> l[i] >> r[i];
        l[i]--, r[i]--;
        finish[r[i]].emplace_back(l[i], i);
    }

    for (int i = 0; i < n; i++) {
        int k = len(s[i]);
        if (k >= block) {
            t.append(s[i]);
            z_function(t);
            pref[0] = 0;
            for (int j = 0; j < len(t); j++)
                pref[j + 1] = pref[j] + (z[j] >= k);
            for (int j = 0; j < m; j++) {
                if (r[j] - l[j] + 1 >= k)
                    ans[j] += pref[r[j] + 1] - pref[l[j] + k - 1];
            }
            for (int j = 0; j < k; j++)
                t.pop_back();
        } else {
            reverse(all(s[i]));
            add_string(s[i]);
        }
    }

    for (int i = 0; i < len(t); i++) {
        int u = 0;
        for (int j = i; j >= 0 && trie[u].go[t[j] - 'a']; j--) {
            u = trie[u].go[t[j] - 'a'];
            if (trie[u].end_here)
                add(j, trie[u].end_here);
        }
        for (auto [start, idx] : finish[i])
            ans[idx] += get_seg(start, i);
    }

    for (int i = 0; i < m; i++)
        cout << ans[i] << endl;
}