#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define ll long long
#define all(x) (x).begin(), (x).end()

mt19937 rnd(179);
const ll mod = 1e9 + 11;
const int p = 31;

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int tlen = (int) t.size();
    vector<ll> pows(tlen + 1, 1);
    vector<ll> hash_t(tlen + 1);
    for (int i = 0; i < tlen; i++) {
        hash_t[i + 1] = (hash_t[i] * p + t[i]) % mod;
        pows[i + 1] = pows[i] * p % mod;
    }
    auto get_hash = [&](int l, int r) {
        ll res = hash_t[r + 1] - (hash_t[l] * pows[r - l + 1]) % mod;
        if (res >= mod) {
            res -= mod;
        }
        if (res < 0) {
            res += mod;
        }
        return res * 1ll;
    };
    vector<string> str(n);
    for (auto &s: str) {
        cin >> s;
    }
    vector<vector<int>> ind(n);
    for (int i = 0; i < n; i++) {
        int len = (int) str[i].size();
        ll h = 0;
        for (int j = 0; j < len; j++) {
            h = h * p + str[i][j];
            h %= mod;
        }
        for (int j = 0; j + len - 1 < (int) t.size(); j++) {
            ll ht = get_hash(j, j + len - 1);
            if (ht == h) {
                ind[i].push_back(j);
            }
        }
    }
    for (int qqq = 0; qqq < m; qqq++) {
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            int left = l;
            int right = r - (int) str[i].size() + 1;
            int cnt = (int) (upper_bound(all(ind[i]), right) - lower_bound(all(ind[i]), left));
            cnt = max(cnt, 0);
            ans += cnt;
        }
        cout << ans << ' ';
    }
    return 0;
}