#include <iostream>
#include <algorithm>
#include <cmath>
#include <set>
#include <vector>
#include <string>

using namespace std;

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n , m;
    cin >> n >> m;
    vector<string> a(n);
    string t;
    cin >> t;
    vector<pair<int , int>> p;
    for (int i = 0; i < n; i++) {
        cin >> a[i];
        string s = a[i] + '%' + t;
        int n1 = t.size() + a[i].size() + 1;
        vector<int> pi(n1);
        for (int k = 1; k < n1; k++) {
            int j = pi[k-1];
            while (j > 0 && s[j] != s[k]) {
                j = pi[j-1];
            }
            if (s[j] == s[k]) {
                j++;
            }
            pi[k] = j;
            if (j == a[i].size()) {
                p.push_back(make_pair(k - (2 * a[i].size()) + 1 , k - a[i].size()));
            }
        }
    }
    sort(p.begin() , p.end());
    while (m--) {
        int l , r;
        cin >> l >> r;
        long long ans = 0;
        for (int i = 0; i < p.size(); i++) {
            if (p[i].first > r) {
                break;
            } else if ((p[i].first >= l) && (p[i].second <= r)) {
                ans++;
            }
        }
        cout << ans << " ";
    }
    return 0;
}
