#pragma GCC optimize("O3", "inline", "unroll-loops", "no-stack-protector")
//#pragma GCC comment("/linker:64000000")
//#pragma GCC targer("fma")
#include <bits/stdc++.h>
//
//#include <ext/rope>
//#include <ext/pb_ds/tree_policy.hpp>
//#include <ext/pb_ds/assoc_container.hpp>
//
//using namespace __gnu_pbds;

#define endl "\n"
#define ll long long
//#define int long long
#define pii pair<int, int>
#define X first
#define Y second
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define double long double
#define mall(x) x.mutable_begin(), x.mutable_end()
#define uni(x) sort(all(x)); x.erase(unique(all(x)), x.end())
#define fast ios::sync_with_stdio(0); cin.tie(0); cout.tie(0)

using namespace std;
//using namespace __gnu_cxx;
//
//template<typename T>
//using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
//
//template<typename T>
//using ordered_multiset = tree<T, null_type, less_equal<T>, rb_tree_tag, tree_order_statistics_node_update>;


template<typename T, typename G>
bool rmax(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (a < b) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T, typename G>
bool rmin(T &a, G b1) {
    T b = static_cast<T>(b1);
    if (b < a) {
        a = b;
        return 1;
    }
    return 0;
}

template<typename T>
istream& operator >> (istream &in, vector<T> &a) {
    for (auto &it : a) {
        in >> it;
    }
    return in;
}

template<typename T>
ostream& operator << (ostream& out, vector<T> &a) {
    for (auto &it : a) {
        out << it << ' ';
    }
    return out;
}

struct Fenwick {
    vector<int> tree;
    int n;

    void upd(int i) {
        for (; i < n; i |= i + 1) {
            tree[i]++;
        }
    }

    int get(int i) {
        int res = 0;
        for (; i >= 0; i = (i & (i + 1)) - 1) {
            res += tree[i];
        }
        return res;
    }

    int get(int l, int r) {
        return get(r) - get(l - 1);
    }

    void init(int n) {
        this->n = n;
        tree.assign(n, 0);
    }
};

const int MAXN = 1e6 + 1;
struct node {
    array<int, 26> go;
    bool term;
};

node bor[MAXN];
int ind = 1;

const int K = 400;

void add(string &a) {
    int rt = 0;

    for (char &it : a) {
        it -= 'a';

        if (bor[rt].go[it] == -1) {
            bor[rt].go[it] = ind;
            bor[ind].term = 0;
            bor[ind].go.fill(-1);
            ind++;
        }
        rt = bor[rt].go[it];
    }

    bor[rt].term = 1;
}

struct query {
    int x, y;
    int id;
};

inline void solve() {
}


signed main() {
    fast;

    bor[0].term = 0;
    bor[0].go.fill(-1);

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    int q = n;

    n = t.size();
    vector<int> asks[n];
    vector<int> z(1e6 + n);

    while (q--) {
        string s;
        cin >> s;
        int f = s.size();

        if (s.size() >= K) {
            s = s + "#" + t;
            int n = s.size();
            int l = 0, r = 0;

            for (int i = 1; i < n; i++) {
                z[i] = max(0, min(r - i + 1, z[i - l]));
                while (i + z[i] < n && s[i + z[i]] == s[z[i]]) {
                    z[i]++;
                }

                if (i + z[i] - 1 > r) {
                    r = i + z[i] - 1;
                    l = i;
                }
            }
            for (int j = 0; j < t.size(); j++) {
                if (z[j + f + 1] == f) {
                    asks[j].push_back(j + f - 1);
                }
            }
        } else {
            int rt = 0;

            for (char &it : s) {
                it -= 'a';

                if (bor[rt].go[it] == -1) {
                    bor[rt].go[it] = ind;
                    bor[ind].term = 0;
                    bor[ind].go.fill(-1);
                    ind++;
                }
                rt = bor[rt].go[it];
            }

            bor[rt].term = 1;
//            cout << s << endl;
        }
    }

    for (int i = 0; i < n; i++) {
        int rt = 0;
        int r = i - 1;

        for (int j = 1; j <= K && i + j <= n; j++) {
            r++;

            rt = bor[rt].go[t[r] - 'a'];
            if (rt == -1) {
                break;
            }

            if (bor[rt].term) {
                asks[i].push_back(r);
            }
        }
    }
    vector<query> my_ask[n];

    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        --a; --b;

        if (a != 0) {
            my_ask[a - 1].push_back({a, b, -i - 1});
        }

        my_ask[b].push_back({a, b, i + 1});
    }

    Fenwick tree;
    tree.init(n);
    vector<int> ans(m, 0);

    for (int i = 0; i < n; i++) {
        for (int &it : asks[i]) {
//            cout << i << ' ' << it << endl;
            tree.upd(it);
        }

        for (query &it : my_ask[i]) {
            int val = tree.get(it.x, it.y);
//            cout << i << ' ' << it.x << ' ' << it.y << ' ' << val << endl;

            if (it.id < 0) {
                val *= -1;
                it.id *= -1;
            }

            ans[it.id - 1] += val;
        }
    }

    cout << ans << endl;
}