//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <algorithm>
#include <queue>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7, INF = 1e18 + 1;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve() {
    ll n, m, p = 239;
    cin >> n >> m;
    string st;
    cin >> st;
    ll sz = st.size();
    vector < ll > hs(sz + 1);
    hs[0] = 0;
    for (ll i = 0; i < sz; i++) hs[i + 1] = (hs[i] * p + st[i]) % mod;
    vector < ll > pw(sz + 1);
    pw[0] = 1;
    for (ll i = 1; i <= sz; i++) pw[i] = pw[i - 1] * p % mod;

    vector < string > a(n);
    vector < vector < ll >> id(n);
    for (ll i = 0; i < n; i++) {
        cin >> a[i];
        ll now = 0;
        forall(j, a[i]) now = (now * p + j) % mod;
        for (ll j = 0; j + a[i].size() <= sz; j++) {
            if ((hs[j + a[i].size()] - (hs[j] * pw[a[i].size()]) % mod + mod) % mod == now) {
                id[i].push_back(j);
            }
        }
    }
    while (m--) {
        ll s = 0;
        ll l, r;
        cin >> l >> r;
        l--; r--;
        for (ll i = 0; i < n; i++) {
            if (a[i].size() > r - l + 1) continue;
            s += upper_bound(all(id[i]), r - a[i].size() + 1) - lower_bound(all(id[i]), l);
        }
        cout << s <<'\n';
    }
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
//    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}