#pragma GCC optimize ("O3", "unroll-loops")
#pragma GCC target ("avx2", "bmi", "bmi2", "lzcnt", "popcnt")
#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
#define cosnt const
#define assing assign
#define all(x) x.begin(), x.end()
//#define int ll

const int MOD1 = 1e9 + 7, BASE1 = 101;
cosnt int MOD2 = 998244353, BASE2 = 31;
const int MAXN = 1e5;

pair<ll, ll> my_hash(const string& s) {
    pair<ll, ll> ans = {0, 0};
    for (int i = 0; i < s.size(); ++i) {
        ans.first = (ans.first * BASE1 + s[i] - 'a' + 1) % MOD1;
        ans.second = (ans.second * BASE2 + s[i] - 'a' + 1) % MOD2;
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> a(n);
    for (auto& i : a)
        cin >> i;

    vector<pair<ll, ll>> ha;
    ha.reserve(n);
    for (int i = 0; i < n; ++i)
        ha.push_back(my_hash(a[i]));
    sort(all(ha));

    vector<vector<pair<ll, ll>>> h(t.size(), vector<pair<ll, ll>>(t.size() + 1));
    for (int i = 0; i < t.size(); ++i) {
        h[i][i + 1].first = t[i] - 'a' + 1;
        h[i][i + 1].second = t[i] - 'a' + 1;
    }
    for (int l = t.size() - 1; l > -1; --l)
        for (int r = l + 2; r <= t.size(); ++r) {
            h[l][r].first = (h[l][r - 1].first * BASE1 + t[r - 1] - 'a' + 1) % MOD1;
            h[l][r].second = (h[l][r - 1].second * BASE2 + t[r - 1] - 'a' + 1) % MOD2;
        }

    vector<vector<int>> dp(t.size() + 1, vector<int>(t.size() + 1));
    for (int i = 0; i < t.size(); ++i)
        dp[i][i + 1] = (*lower_bound(all(ha), h[i][i + 1]) == h[i][i + 1]);
    for (int l = t.size() - 2; l > -1; --l)
        for (int r = l + 2; r <= t.size(); ++r)
            dp[l][r] = dp[l + 1][r] + dp[l][r - 1] - dp[l + 1][r - 1] + (*lower_bound(all(ha), h[l][r]) == h[l][r]);
    /*
    for (auto i : dp) {
        for (auto j : i)
            cout << j << " ";
        cout << endl;
    }*/

    while (m--) {
        int l, r;
        cin >> l >> r;
        --l;
        cout << dp[l][r] << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);

    int t = 1;
    //cin >> t;
    while (t--)
        solve();
}
