#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<random>
#include<stack>
#include<deque>
#include<queue>
#include<iomanip>
#include <cstring>

using namespace std;

//#pragma optimize("O3")
//#pragma optimize("avx2")
//#pragma optimize("unrool-loops")

//#define int long long

random_device rd;
mt19937 gen(rd());

struct node {
	int nx[26];
	int num;
	int prefs;
	int par;
	int let;
	int dep;
	int cprefs;
	node() {
		for (int i = 0; i < 26; i++) {
			nx[i] = -1;
		}
		num = -1;
		prefs = -1;
	}
};

string s;
string arr[500005];

int k = 0;
node bor[500005];

struct zapr {
	int l, r, ind;
};

zapr quest[500005];
vector<int> ask[750005];

void add(int v, int i, int j) {
	if (i == arr[j].size()) {
		bor[v].num = j;
		return;
	}
	if (bor[v].nx[arr[j][i] - 'a'] == -1) {
		bor[v].nx[arr[j][i] - 'a'] = k;
		bor[k].par = v;
		bor[k].dep = bor[v].dep + 1;
		bor[k].let = arr[j][i] - 'a';
		k++;
	}
	add(bor[v].nx[arr[j][i] - 'a'], i + 1, j);
}

void Aho() {
	queue<int>q;
	bor[0].prefs = 0;
	for (int i = 0; i < 26; i++) {
		if (bor[0].nx[i] == -1) {
			bor[0].nx[i] = 0;
		}
		else {
			q.push(bor[0].nx[i]);
		}
	}
	while (!q.empty()) {
		int v = q.front();
		q.pop();
		if (bor[v].par == 0) {
			bor[v].prefs = 0;
		}
		else {
			bor[v].prefs = bor[bor[bor[v].par].prefs].nx[bor[v].let];
		}
		if (bor[bor[v].prefs].num == -1) {
			bor[v].cprefs = bor[bor[v].prefs].cprefs;
		}
		else {
			bor[v].cprefs = bor[v].prefs;
		}
		for (int i = 0; i < 26; i++) {
			if (bor[v].nx[i] == -1) {
				bor[v].nx[i] = bor[bor[v].prefs].nx[i];
			}
			else {
				q.push(bor[v].nx[i]);
			}
		}
	}
}

bool cmp(zapr& lhs, zapr& rhs) {
	return lhs.l < rhs.l || (lhs.l == rhs.l && lhs.r < rhs.r);
}

int Y = 900;
int sum[1000];
int fsum[750005];
int ans[500005];

int get_sum(int l, int r) {
	int tsum = 0;
	l--;
	for (int i = 0; i < (l) / Y; i++) {
		tsum -= sum[i];
	}
	for (int i = (l / Y) * Y; i <= l; i++) {
		tsum -= fsum[i];
	}
	for (int i = 0; i < (r) / Y; i++) {
		tsum += sum[i];
	}
	for (int i = (r / Y) * Y; i <= r; i++) {
		tsum += fsum[i];
	}
	return tsum;
}

void solve() {
	bor[0].dep = 0;
	bor[0].par = 0;
	k++;
	int n, m;
	cin >> n >> m;
	cin >> s;
	for (int i = 0; i < n; i++) {
		cin >> arr[i];
		add(0, 0, i);
	}
	for (int i = 0; i < m; i++) {
		cin >> quest[i].l >> quest[i].r;
		quest[i].l--; quest[i].r--;
		quest[i].ind = i;
	}
	sort(quest, quest + m, cmp);
	for (int i = 0; i < m; i++) {
		ask[quest[i].r].push_back(i);
	}
	Aho();
	int v = 0;
	for (int i = 0; i < s.size(); i++) {
		v = bor[v].nx[s[i] - 'a'];
		if (bor[v].num != -1) {
			fsum[i - bor[v].dep + 1]++;
			sum[(i - bor[v].dep + 1) / Y]++;
		}
		int cv = v;
		while (bor[cv].cprefs != 0) {
			cv = bor[cv].cprefs;
			fsum[i - bor[cv].dep + 1]++;
			sum[(i - bor[cv].dep + 1) / Y]++;
		}
		for (auto u : ask[i]) {
			ans[quest[u].ind] = get_sum(quest[u].l, quest[u].r);
		}
	}
	for (int i = 0; i < m; i++) {
		cout << ans[i] << "\n";
	}
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//freopen("Text.txt", "r", stdin);
	//freopen("", "w", stdout)

	int t = 1;
	//cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}