#include <bits/stdc++.h>

using namespace std;

constexpr int mod = 1e9 + 9, base = 29;

constexpr int maxn = 1e5 + 5;

vector<int> vals[maxn];

int f[maxn];

void add(int pos) {
    for (int i = pos; i < maxn; i += i & -i) {
        f[i]++;
    }
}

int get(int pos) {
    int ans = 0;
    for (int i = pos; i > 0; i -= i & -i) {
        ans += f[i];
    }
    return ans;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> s(n);
    vector<int> vl(n);
    for (int i = 0; i < n; ++i) {
        cin >> s[i];
        for (auto ch : s[i]) {
            vl[i] = (vl[i] * 1LL * base + ch - 'a' + 1) % mod;
        }
    }
    vector<int> pw((int)t.size() + 1);
    pw[0] = 1;
    for (int i = 1; i <= (int)t.size(); ++i) {
        pw[i] = pw[i - 1] * 1LL * base % mod;
    }
    vector<int> pr((int)t.size() + 1);
    for (int i = 0; i < (int)t.size(); ++i) {
        pr[i + 1] = (pr[i] * 1LL * base + t[i] - 'a' + 1) % mod;
    }
    vector<int> l(m), r(m);
    vector<vector<int>> qs(t.size());
    for (int i = 0; i < m; ++i) {
        cin >> l[i] >> r[i];
        l[i]--;
        qs[l[i]].push_back(i);
    }
    vector<int> ans(m);
    for (int i = (int)t.size() - 1; i >= 0; --i) {
        for (int j = 0; j < n; ++j) {
            if (i + (int)s[j].size() <= (int)t.size()) {
                int hash_nw = pr[i + (int)s[j].size()] - pr[i] * 1LL * pw[(int)s[j].size()] % mod;
                if (hash_nw < 0) {
                    hash_nw += mod;
                }
                if (hash_nw == vl[j]) {
                    add(i + (int)s[j].size());
                }
            }
        }
        for (auto ind : qs[i]) {
            ans[ind] = get(r[ind]);
        }
    }
    for (int i = 0; i < m; ++i) {
        cout << ans[i] << ' ';
    }
    cout << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int t = 1;
    // cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
