#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

struct nd{
    vector<int> nxt = vector<int>(26, -1);
    vector<int> go = vector<int>(26, 0);
    int sf = 0;
    int fst = 0;
    int d = 0;
    int p = 0;
    int c = 0;
    bool term = false;
};

vector<nd> tr;

void add(string &s){
    int v = 0;
    for (char i : s){
        if (tr[v].nxt[i - 'a'] == -1){
            tr[v].nxt[i - 'a'] = sz(tr);
            tr.pb(nd());
            tr.back().p = v;
            tr.back().c = i - 'a';
            tr.back().d = tr[v].d + 1;
        }
        v = tr[v].nxt[i - 'a'];
    }
    tr[v].term = true;
}

vector<pii> otr;

void build(){
    queue<int> q;
    q.push(0);
    while (!q.empty()){
        int v = q.front();
        q.pop();
        if (v == 0 || tr[v].p == 0){
            tr[v].sf = 0;
        }
        else tr[v].sf = tr[tr[tr[v].p].sf].go[tr[v].c];
        for (int i = 0; i < 26; i++) {
            if (tr[v].nxt[i] != -1) tr[v].go[i] = tr[v].nxt[i];
            else tr[v].go[i] = tr[tr[v].sf].go[i];
        }
        if (tr[tr[v].sf].term) tr[v].fst = tr[v].sf;
        else tr[v].fst = tr[tr[v].sf].fst;
        for (int i = 0; i < 26; i++) if (tr[v].nxt[i] != -1) q.push(tr[v].nxt[i]);
    }
}

void get(int v, int i){
    while (v != 0){
        if (tr[v].term){
            otr.pb({i - tr[v].d + 1, i});
        }
        v = tr[v].fst;
    }
}

vector<ll> h;
const ll p = 31, md = 1e9 + 7;

ll bpow(ll a, ll b, ll m){
    if (b == 0) return 1;
    if (b % 2 == 0) {
        ll r = bpow(a, b / 2, m);
        return (r * r) % m;
    }
    return a * bpow(a, b - 1, m) % m;
}

ll get_h(int l, int r){
    if (l == 0) return h[r];
    ll ans = (h[r] - h[l - 1] * bpow(p, r - l + 1, md) % md) % md;
    if (ans < 0) ans += md;
    return ans;
}

void solve(){
    tr.pb(nd());
    int n, m;
    cin >> n >> m;
    string t; cin >> t;
    vector<string> s(n);
    set<int> ln;
    for (int i = 0; i < n; i++){
        cin >> s[i];
        ln.insert(sz(s[i]));
    }
    h.resize(sz(t));
    h[0] = t[0] - 'a' + 1;
    for (int i = 1; i < sz(t); i++) h[i] = (h[i - 1] * p + t[i] - 'a' + 1) % md;

    vector<int> d;
    map<int, int> len;
    for (int i : ln) {
        len[i] = sz(d);
        d.pb(i);
    }
    int k = 20;
    for (int i = 0; i < n; i++){
        if (sz(s[i]) >= k) add(s[i]);
    }
    build();
    unordered_set<ll> mp;
    for (int i = 0; i < n; i++){
        if (sz(s[i]) >= k) continue;
        ll hd = s[i][0] - 'a' + 1;
        for (int j = 1; j < sz(s[i]); j++) hd = (hd * p + s[i][j] - 'a' + 1) % md;
        mp.insert(hd);
    }
    vector<vector<ll>> pr(sz(ln), vector<ll>(sz(t) + 1));
    int v = 0;
    for (int i = 0; i < sz(t); i++){
        v = tr[v].go[t[i] - 'a'];
        get(v, i);
    }
    for (int l = 0; l < sz(d); l++){
        if (d[l] >= k) break;
        for (int i = 0; i + d[l] - 1 < sz(t); i++){
            ll cr = get_h(i, i + d[l] - 1);
            if (mp.find(cr) != mp.end()) pr[l][i + 1]++;
        }
    }
    for (pii i : otr){
        pr[len[i.ss - i.ff + 1]][i.ff + 1]++;
    }
    for (int l = 0; l < sz(d); l++){
        for (int j = 1; j <= sz(t); j++) pr[l][j] += pr[l][j - 1];
    }
    for (int tt = 0; tt< m; tt++){
        int l, r; cin >> l >> r; l--, r--;
        ll ans = 0;
        for (int i = 0; i < sz(d); i++){
            if (r - l + 1 < d[i]) break;
            ans += (pr[i][r - d[i] + 2] - pr[i][l]);
        }
        cout << ans << " ";
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    while(n--) solve();
}
