#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN
void dbg(ll a) {cout << a << "\n";}
void dbg(int a) {cout << a << "\n";}
void dbg(string a) {cout << a << "\n";}
void dbg(ll a, ll b) {cout << a << " " << b << "\n";}
void dbg(int a, int b) {cout << a << " " << b << "\n";}
void dbg(ll a, ll b, ll c) {cout << a << " " << b << " " << c << "\n";}
void dbg(int a, int b, int c) {cout << a << " " << b << " " << c << "\n";}
void dbg(vector<ll> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
void dbg(vector<int> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
#else
#define dbg(...)
#endif

const ll mod = 1e9 + 7;
const ll P = 157;
struct hasher {
    vector<ll> pows, hash;
    void build(string& s) {
        int n = s.size();
        hash.resize(n + 1);
        pows.resize(n + 1);
        pows[0] = 1;
        for (int i = 0; i < n; i++) {
            hash[i + 1] = (hash[i] * P + (s[i] - 'a' + 1)) % mod;
            pows[i + 1] = pows[i] * P % mod;
        }
    }
    ll get(int l, int r) {
        r++;
        return (hash[r] - hash[l] * pows[r - l] % mod + 2 * mod) % mod;
    }
};

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> a(n);
    int k = t.size();
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<int>> pref(n, vector<int>(k));
    hasher T;
    T.build(t);
    for (int i = 0; i < n; i++) {
        hasher cur;
        cur.build(a[i]);
        int sz = a[i].size();
        for (int j = 0; j + sz - 1 < k; j++) {
            ll hash = T.get(j, j + sz - 1);
            ll check = cur.get(0, sz - 1);
            if (check == hash) pref[i][j]++;
        }
        for (int j = 1; j < k; j++) {
            pref[i][j] = pref[i][j - 1] + pref[i][j];
        }
        dbg(pref[i]);
    }
    while (m--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int i = 0; i < n; i++) {
            int cr = r - (a[i].size() - 1);
            if (cr < l) continue;
            ans += pref[i][cr];
            if (l) ans -= pref[i][l - 1];
        }
        cout << ans << "\n";
    }
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
