#include <bits/stdc++.h>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

typedef int64_t ll;
typedef uint64_t ull;

#define int ll

const int INF = 1e9 + 117;

int n, m;
string t;
vector<string> a;

struct HashString {
    string s = "";
    int ln;
    const int M = 1e9 + 7, p = 37;
    vector<int> hash, pws;

    HashString (string _s) {
        for (auto& e : _s) s += e;
        ln = s.size();
        hash.resize(ln);
        hash[0] = s[0] - 97;
        for (int i = 1; i < ln; ++i) {
            hash[i] = (hash[i - 1] * p + s[i] - 97) % M;
        }

        pws.resize(ln + 1);
        pws[0] = 1;
        for (int i = 1; i <= ln; ++i) {
            pws[i] = (pws[i - 1] * p) % M;
        }
    }

    int get_hash(int l, int r) { // [l, r)
        if (l == 0) return hash[r - 1];
        return (hash[r - 1] - (hash[l - 1] * pws[r - l]) % M + M) % M;
    }

    int get_all_hash() {
        return hash.back();
    }
};

signed main() {
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fast();
    cin >> n >> m;
    cin >> t;
    a.resize(n);
    vector<HashString> hashes;
    for (auto& e : a) {
        cin >> e;
        HashString tmp_hash(e);
        hashes.push_back(tmp_hash);
    }
    HashString t_hash(t);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r;
        --l;
        int ans = 0;
        for (auto& hash : hashes) {
            for (int j = l; j <= r - hash.ln; ++j) {
                if (hash.get_all_hash() == t_hash.get_hash(j, j + hash.ln)) ans++;
            }
        }
        cout << ans << ' ';
    }
    return 0;
}