//#define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

const long long INF=1e15;
const long long MOD=1e9+7;
const long long B=179;
vector<long long> pows;
void calc(string&s, vector<long long>&h) {
    h.push_back(0);
    for (auto c:s) {
        h.push_back((h.back()*B%MOD+(long long)(c-'a'+1))%MOD);
    }
}

long long get(long long l, long long r, vector<long long>&h) {
    return (h[r] - h[l] * pows[r-l]%MOD + MOD)%MOD;
}

const long long MOD1=1e9+9;
const long long B1=239;
vector<long long> pows1;
void calc1(string&s, vector<long long>&h) {
    h.push_back(0);
    for (auto c:s) {
        h.push_back((h.back()*B1%MOD1+c-'a'+1)%MOD1);
    }
}

long long get1(long long l, long long r, vector<long long>&h) {
    return (h[r] - h[l] * pows1[r-l]%MOD1 + MOD1)%MOD1;
}


vector<long long> len;
bool cmp(long long a, long long b) {
    return len[a] < len[b];
}
signed main() {
    long long n,m;
    cin>> n >> m;
    pows.push_back(1);
    for (long long i = 0;i<1000000;i++) {
        pows.push_back(pows.back()*B%MOD);
    }
    pows1.push_back(1);
    for (long long i = 0;i<n;i++) {
        pows1.push_back(pows1.back()*B1%MOD1);
    }
    string t;
    cin >> t;
    vector<long long> h;
    vector<long long> h1;
    calc(t, h);
    calc1(t, h1);
    vector<long long> hs(n);
    vector<long long> hs1(n);
    len.resize(n);
    for (long long i =0;i<n;i++) {
        string s;
        cin >> s;
        hs[i] = 0;
        len[i] = s.size();
        for (auto c:s) {
            hs[i] *= B;
            hs[i] += (long long)(c-'a'+1);
            hs[i] %= MOD;
        }
        hs1[i] = 0;
        for (auto c:s) {
            hs1[i] *= B1;
            hs1[i] += (long long)(c-'a'+1);
            hs1[i] %= MOD1;
        }
    }
    if ( n <=100 && m <=500) {
        while(m--) {
            long long l, r;
            cin >> l >> r;
            l--;
            r--;
            long long ans=0;
            for (long long i = l;i<=r;i++) {

                for (long long j = 0;j<n;j++) {
                    if (len[j] + i - 1 <= r && get(i, i + len[j], h) == hs[j]) {
                        ans++;
                    }
                }
            }
            cout << ans << "\n";
        }
    }
    else if (n<=100){
        vector<vector<long long>> pref(n);
        for (long long i = 0;i<n;i++) {
            pref[i].push_back(0);
            for (long long j = 0;j<t.size();j++) {
                if (len[i] + j -1 <= t.size()-1 && get(j, j+len[i], h) == hs[i]) {
                    pref[i].push_back(pref[i].back()+1);
                }
                else {
                    pref[i].push_back(pref[i].back());
                }
            }
        }
        while(m--) {
            long long l, r;
            cin >> l >> r;
            l--;
            r--;
            long long ans = 0;
            for (long long j =0;j<n;j++) {
                long long r1 = r - len[j]+1;
                if (r1 < l) {
                    continue;
                }
                ans += pref[j][r1+1] - pref[j][l];
            }
            cout << ans << "\n";
        }
    }
    else {
        vector<long long> c(n);
        iota(c.begin(), c.end(), 0);
        sort(c.begin(), c.end(), cmp);
        vector<long long> new_hs(n), new_ln(n);
        vector<long long> new_hs1(n);
        for (long long i = 0;i<n;i++) {
            new_hs[i] = hs[c[i]];
            new_ln[i] = len[c[i]];
            new_hs1[i] = hs1[c[i]];
        }
        hs=new_hs;
        hs1=new_hs1;
        len=new_ln;
        vector<vector<long long>> pref(n);
        for (long long i = 0;i<n;i++) {
            pref[i].push_back(0);
            for (long long j = 0;j<t.size();j++) {
                if (len[i] + j -1 <= t.size()-1 && get(j, j+len[i], h) == hs[i] && get1(j, j+len[i], h1) == hs1[i]) {
                    pref[i].push_back(pref[i].back()+1);
                }
                else {
                    pref[i].push_back(pref[i].back());
                }
            }
        }
        vector<vector<long long>> prefl(t.size()+1, vector<long long>(t.size()+1, 0));
        vector<vector<long long>> prefr(t.size()+1, vector<long long>(t.size()+1, 0));

        long long cur = -1;
        for (long long ln = 1;ln<=t.size();ln++) {
            prefl[ln] = prefl[ln-1];
            prefr[ln] = prefr[ln-1];
            while(cur+1<n && len[cur+1] <= ln) {
                cur++;
                for (long long j = 0;j<t.size()+1;j++) {
                    prefl[ln][j] += pref[cur][j];
                    if (j >= len[cur]-1) {
                        prefr[ln][j] += pref[cur][j-len[cur]+1];
                    }
                }
            }

        }
        while(m--) {
            long long l, r;
            cin >> l >> r;
            l--;
            r--;
            cout << prefr[r-l+1][r+1] - prefl[r-l+1][l] << "\n";
        }
    }



}