#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb emplace_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less_equal<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);
int q = 239;
const int MOD1 = 1e9 + 7, MOD2 = 1e9 + 9;

unordered_set<int> st1, st2;
const int MAXN = 1e6 + 10;


pt gethash(string& s){
    ll h1 = 0, h2 = 0;
    /// optimize it
    for (char c: s)
        h1 = (h1 * q + c) % MOD1, h2 = (h2 * q + c) % MOD2;
    return {h1, h2};
}

string t;
ll pw1[MAXN], pw2[MAXN];
vector<int> starts[MAXN];
vector<pt> qs[MAXN];
int res[MAXN];
int tree[MAXN];

void calc(int ln){
    ll h1 = 0, h2 = 0;
    for (int i = 0; i < ln - 1; i++)
        h1 = (h1 * q + t[i]) % MOD1, h2 = (h2 * q + t[i]) % MOD2;
    for (int i = ln - 1; i < sz(t); i++){
        h1 = (h1 * q + t[i]) % MOD1;
        h2 = (h2 * q + t[i]) % MOD2;
        if (st1.find(h1) != st1.end() && st2.find(h2) != st2.end())
            starts[i].push_back(i - ln + 1);
        h1 = (h1 - pw1[ln - 1] * t[i - ln + 1] + (ll)MOD1 * MOD1) % MOD1;
        h2 = (h2 - pw2[ln - 1] * t[i - ln + 1] + (ll)MOD2 * MOD2) % MOD2;
    }
}

void add(int pos){
    pos++;
    for (; pos < MAXN; pos += pos & -pos)
        tree[pos]++;
}

int getsum(int r){
    r++;
    int result = 0;
    for (; r > 0; r -= r & -r)
        result += tree[r];
    return result;
}

int sum(int l, int r){
    return getsum(r) - getsum(l - 1);
}


void run(){
    int n, m;
    cin >> n >> m;
    cin >> t;
    pw1[0] = 1, pw2[0] = 1;
    for (int i = 1; i < MAXN; i++)
        pw1[i] = (pw1[i - 1] * q) % MOD1, pw2[i] = (pw2[i - 1] * q) % MOD2;
    vector<int> szs;
    for (int i = 0; i < n; i++){
        string s;
        cin >> s;
        auto [h1, h2] = gethash(s);
        st1.insert(h1), st2.insert(h2);
        szs.push_back(sz(s));
    }
    sort(all(szs));
    szs.resize(unique(all(szs)) - szs.begin());
    for (int ln: szs){
        calc(ln);
    }
    for (int i = 0; i < sz(t); i++)
        sort(all(starts[i]));
    for (int i = 0; i < m; i++){
        int l, r;
        cin >> l >> r;
        l--, r--;
        qs[r].pb(l, i);
    }
    for (int r = 0; r < sz(t); r++) {
        for (int l: starts[r])
            add(l);
        for (auto [l, id]: qs[r]) {
            res[id] = sum(l, r + 1);
        }
    }
    for (int i = 0; i < m; i++)
        cout << res[i] << " ";
    cout << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}
