#include <bits/stdc++.h>

#include <list>
#include <numeric>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long double ld;
typedef long long ll;
#define pb push_back
//typedef ordered_set<int> = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<int>> vr(5000000);
vector<vector<int>> tr(20000000);

void build(int v, int l, int r) {
    if (l == r-1) {
        tr[v] = vr[l];
        return;
    }
    int m = (l+r)/2;
    build (v*2+1, l,m);
    build(v*2+2 , m, r);
    tr[v].resize(tr[v*2+1].size() + tr[v*2+2].size());
    merge(tr[v*2+1].begin(),tr[v*2+1].end(), tr[v*2+2].begin(), tr[v*2+2].end(), tr[v].begin());
}
int get(int v, int l, int r, int lq, int rq){
    if (lq <= l && r <= rq) {
        return upper_bound(tr[v].begin(), tr[v].end(), r) - tr[v].begin();
    }
    if (lq >= r || rq <= l) {
        return 0;
    }
    int m = (l+r)/2;
    return get(v*2+1, l ,m, lq, rq) + get(v*2+2, m, r, lq, rq);
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> v(n);
    set<string> vs;
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        vs.insert(v[i]);
    }
    for (int l= 0; l < t.size(); l++) {
        string q = "";
        for (int r = l; r<t.size(); r++) {
            q += t[r];
            if(vs.find(q) != vs.end()) {
                vr[l].pb(r);
            }
        }
    }
    build(0, 0, t.size());
    int l, r;
    for (int i = 0; i < m; i++) {
        cin >> l >> r;
        l--;
        cout << get(0, 0, t.size(), l, r);
    }
}


signed main() {
#ifdef LOCAL
    auto f = freopen("C:\\clion\\input.txt", "r", stdin);
    auto f1 = freopen("C:\\clion\\output.txt", "w", stdout);
#endif
    int t;
    t=1;//cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}