#include <bits/stdc++.h>

#include <list>
#include <numeric>
#include <random>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long double ld;
typedef long long ll;
typedef unsigned long long ull;
#define pb push_back
//typedef ordered_set<int> = tree <int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>

vector<vector<int>> vr(500000);
vector<vector<int>> tr(2000000);

void build(int v, int l, int r) {
    if (l == r - 1) {
        tr[v] = vr[l];
        return;
    }
    int m = (l + r) / 2;
    build(v * 2 + 1, l, m);
    build(v * 2 + 2, m, r);
    tr[v].resize(tr[v * 2 + 1].size() + tr[v * 2 + 2].size());
    merge(tr[v * 2 + 1].begin(), tr[v * 2 + 1].end(), tr[v * 2 + 2].begin(), tr[v * 2 + 2].end(), tr[v].begin());
}
int get(int v, int l, int r, int lq, int rq) {
    if (lq <= l && r <= rq) {
        return upper_bound(tr[v].begin(), tr[v].end(), rq - 1) - tr[v].begin();
    }
    if (lq >= r || rq <= l) {
        return 0;
    }
    int m = (l + r) / 2;
    return get(v * 2 + 1, l, m, lq, rq) + get(v * 2 + 2, m, r, lq, rq);
}
const ull st = 29;
void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> v(n);
    gp_hash_table<ull, null_type> ma;
    int d = 300;
    vector<ull> hshi(n);
    for (int i = 0; i < n; i++) {
        cin >> v[i];
        ull h = 0;
        for (auto j : v[i]) {
            h = h * st + j - 'a' + 1;
        }
        hshi[i] = h;
        if (v[i].size() <= d) {
            ma[h];
        }
    }
    for (int l = 0; l < t.size(); l++) {
        ull h = 0;
        for (int r = l; r < t.size() && r - l < d; r++) {
            h = h * st + t[r] - 'a' + 1;
            if (ma.find(h) != ma.end()) {
                vr[l].pb(r);
            }
        }
    }
    vector<ull> hsh(t.size() + 1);
    vector<ull> p(t.size() + 1, 1);
    for (int i = 0; i < t.size(); i++) {
        hsh[i + 1] = hsh[i] * st + t[i] - 'a' + 1;
        p[i + 1] = p[i] * st;
    }
    for (int j = 0; j < n; j++) {
        if (v[j].size() > d) {
            for (int i = 0; i + v[j].size() <= t.size(); i++) {
                if (hsh[i + v[j].size()] - hsh[i] * p[v[j].size()] == hshi[j]) {
                    vr[i].pb(i + v[j].size() - 1);
                }
            }
        }
    }
    for (auto& i : vr) {
        sort(i.begin(), i.end());
    }
    build(0, 0, t.size());
    int l, r;
    for (int i = 0; i < m; i++) {
        cin >> l >> r;
        l--;
        cout << get(0, 0, t.size(), l, r) << ' ';
    }
}


signed main() {
#ifdef LOCAL
    auto f = freopen("C:\\clion\\input.txt", "r", stdin);
    auto f1 = freopen("C:\\clion\\output.txt", "w", stdout);
#endif
    int t;
    t = 1;//cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}