#include <bits/stdc++.h>
#define int long long
#define double long double

using namespace std;

const int alphabet = 26;

struct vertex{
    int e[alphabet];
    int p, s_l;
    vertex() {
        for (int i = 0; i < alphabet; ++i) {
            e[i] = -1;
        }
        p = -1; s_l = 0;
    }
};

vector <vertex> sf;
int len = 1, last = 0;

void add(int c) {
    int new_last;
    if (sf[last].e[c] != -1) {
        new_last = sf[last].e[c];
    } else {
        sf.emplace_back();
        new_last = len;
        sf[new_last].p = last;
        len++;
    }
    for (int i = last; i >= 0; i = sf[i].s_l) {
        if (sf[i].e[c] == -1) {
            sf[i].e[c] = new_last;
        } else {
            if (sf[sf[i].e[c]].p == i) {
                if (i == last) {
                    break;
                }
                sf[new_last].s_l = sf[i].e[c];
                break;
            }
            int bad = sf[i].e[c];
            sf.emplace_back();
            for (int j = 0; j < alphabet; ++j) {
                sf[len].e[j] = sf[bad].e[j];
            }
            sf[len].p = i;
            sf[len].s_l = sf[bad].s_l;
            sf[bad].s_l = len;
            sf[new_last] .s_l = len;
            while (i >= 0 && sf[i].e[c] == bad) {
                sf[i].e[c] = len;
                i = sf[i].s_l;
            }
            len++;
            break;
        }
    }
    last = new_last;
}

const int maxn = 5e6;

vector <int> g[maxn], st[maxn];
int pr[maxn];

void calc_p(int v, int pref) {
    pr[v] = pref;
    int dt = st[v].size();
    for (auto u : g[v]) {
        calc_p(u, pref + dt);
    }
}

signed main() {
    if (1) {
        ios_base::sync_with_stdio(false);
        cin.tie(0); cout.tie(0);
    }
    sf.emplace_back();
    int n, m; cin >> n >> m;
    string t; cin >> t;
    int k = t.size();
    for (int i = 0; i < k; ++i) {
        add(t[i] - 'a');
    }
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        last = 0;
        int ln = s.size();
        for (int j = 0; j < ln; ++j) {
            add(s[j] - 'a');
        }
        st[last].push_back(ln);
    }
    for (int i = 1; i < len; ++i) {
        g[sf[i].s_l].push_back(i);
    }
    calc_p(0, 0);
    for (int i = 0; i < m; ++i) {
        int l, r; cin >> l >> r;
        l--; r--;
        int res = 0;
        int ind = 0;
        for (int j = l; j <= r; ++j) {
            ind = sf[ind].e[t[j] - 'a'];
            res += pr[ind];
            res += (upper_bound(st[ind].begin(), st[ind].end(), j - l + 1) - st[ind].begin());
        }
        cout << res << "\n";
    }
    return 0;
}

