#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std; using namespace __gnu_pbds;
typedef long long ll; typedef long double ld;
typedef tree<int, less<>, null_type, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
int rnd(){
    return (rand() >> 16);
}
struct Dtree{
    struct Node{
        Node *left = nullptr, *right = nullptr;
        int val; int sz = 0; int y;
        Node() = default;
        Node(Node *l, Node *r, int v) : left(l), right(r), val(v), sz(1), y(rnd()) {};
    };
    Node* root = nullptr;
    int get(Node *t){
        if(t == nullptr) return 0;
        else return t->sz;
    }
    void upd(Node *t){
        t->sz = get(t->left) + get(t->right) + 1;
    }
    pair<Node*, Node*>split(Node* r, int k){
        if(r == nullptr) return {nullptr, nullptr};
        if(r->val >= k){
            auto first = split(r->left, k);
            r->left = first.second; upd(r); upd(first.first);
            return {first.first, r};
        }else{
            auto second = split(r->right, k);
            r->right = second.first; upd(r); upd(second.second);
            return {r, second.second};
        }
    }
    Node* merge(Node *a, Node *b){
        if(a == nullptr) return b;
        if(b == nullptr) return a;
        if(a->y > b->y){
            auto p = merge(a->right, b);
            a->right = p; upd(a);
        }else{
            auto p = merge(a, b->left);
            b->left = p; upd(b);
        }
    }
};
vector<int>pref; int step[(int)5e6 + 1]; int MOD = 1e9 + 7; int BASE = 26;
int hashing(int i, int j){
    return (pref[j] - pref[i] * step[j - i] % MOD + MOD) % MOD;
}
int main() {
    ios::sync_with_stdio(0); cin.tie(0);
    int n, m; cin >> n >> m;
    set<int>lens; step[0] = 1; string s; cin >> s; unordered_map<int, int>check; pref.resize(s.size() + 1);
    for(int i = 1; i <= s.size(); i++){
        pref[i] = (pref[i - 1] * BASE % MOD + s[i - 1] - '0' + 1) % MOD;
        step[i] = step[i - 1] * BASE % MOD;
    }
    for(int i = 0; i < n; i++){
        string t; cin >> t; int hash = 0;
        for(int j = 0; j < t.size(); j++){
            hash = (hash * BASE % MOD + t[j] - '0' + 1) % MOD;
        }
        check[hash]++; lens.insert(t.size());
    }
    vector<vector<int>>sums(lens.size(), vector<int>(s.size() + 1));
    int ind = 0;
    for(int len : lens){
        for(int j = 0; j <= (int)s.size() - len; j++){
            sums[ind][j + 1] += sums[ind][j];
            sums[ind][j + 1] += check[hashing(j, j + len)];
        }
        ind++;
    }
    for(int i = 0; i < m; i++){
        int l, r; cin >> l >> r; int ans = 0; int jnd = 0;
        for(int len : lens){
            if(r - l + 1 >= len){
                ans += sums[jnd][r - len + 1]; ans -= sums[jnd][l - 1];
            }else break;
            jnd++;
        }
        cout << ans << " ";
    }
}