#include <bits/stdc++.h>

#define all(x) x.begin(), x.end()
#define pb push_back
#define ff first
#define ss second
#define err(x) cerr << "[" << ""#x"" << "] " << (x) << '\n';
#define errv(x) {cerr << "[" << ""#x"" << "] "; for(const auto &_ : (x)) cerr << _ << ", "; cerr << "\n";}
#define errvn(x, n) {cerr << "[" << ""#x"" << "] "; for(int _ = 0;_ < n;_++) cerr << (x)[_] << ", "; cerr << "\n";}
using ll = long long;
using ld = long double;

using namespace std;

template<typename T1, typename T2>
inline bool relaxmi(T1 &a, const T2 &b) {
    return (a > b ? a = b, true : false);
}


template<typename T1, typename T2>
inline bool relaxma(T1 &a, const T2 &b) {
    return (a < b ? a = b, true : false);
}

mt19937 rnd(::std::chrono::high_resolution_clock::now().time_since_epoch().count());
const int MOD = 1e9 + 7;

/// actual code starts here

const int N = 3e5 + 5;

int add(int a, int b) {
    return (a + b >= MOD ? a + b - MOD : a + b);
}

int sub(int a, int b) {
    return (a - b < 0 ? a - b + MOD : a - b);
}

int mul(int a, int b) {
    return (1ll * a * b) % MOD;
}


uniform_int_distribution<int> azino(179, 239);

const int q0 = azino(rnd);

int h[N], q[N];

void calc() {
    q[0] = 1;
    for (int i = 1; i < N; i++) q[i] = mul(q[i - 1], q0);
}

int geth(int l, int r) {
    int res = h[r];
    if (l) res = sub(res, mul(h[l - 1], q[r - l + 1]));
    return res;
}

int f[N];

ll get(int r) {
    ll res = 0;
    for (; r >= 0; r = (r & (r + 1)) - 1)
        res += f[r];
    return res;
}

void upd(int p, int x) {
    for (; p < N; p |= (p + 1))
        f[p] += x;
}

void build_h(string &s) {
    int curh = 0;
    for (int i = 0; i < (int) s.size(); i++) {
        curh = add(mul(curh, q0), s[i]);
        h[i] = curh;
    }
}

string t;
vector<int> need_h[N];
vector<pair<int, int>> ask[N];

void solve() {
    int n, m;
    cin >> n >> m >> t;
    calc();
    build_h(t);
    vector<int> lens;
    for (int i = 0; i < n; i++) {
        string s;
        cin >> s;
        lens.pb(s.size());
        int curh = 0;
        for (auto j: s) {
            curh = add(mul(curh, q0), j);
        }
        need_h[s.size()].pb(curh);
    }
    sort(all(lens));
    lens.resize(unique(all(lens)) - lens.begin());
    for (auto j: lens) {
        sort(all(need_h[j]));
    }
    vector<ll> res(m);
    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        ask[r].pb({l, i});
    }
    int sum = 0;
    for (int i = 0; i < (int) t.size(); i++) {
        for (auto j: lens) {
            if (j > i + 1) break;
            int curh = geth(i - j + 1, i);
            if (binary_search(all(need_h[j]), curh)) {
                upd(i - j + 1, 1);
                sum++;
            }
        }
        for (auto [l, id]: ask[i])
            res[id] = sum - get(l - 1);
    }
    for (int i = 0; i < m; i++)
        cout << res[i] << ' ';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) solve();
}