#include <iostream>
#include <fstream>
#include <cmath>
#include <map>
#include <vector>
#include <set>
#include <queue>
#include <random>
#include <numeric>
#include <ctime>
#include <bits/stdc++.h>
#pragma GCC optimize(3)
using namespace std;
#define vi vector<int>
#define ll long long
#define ld long double
#define pi pair<int, int>
#define int long long
mt19937 MT(179);
const int INF = 1e18;
const int P = 31;
const int MOD = 1e9 + 7;
vector<int> p;
const int maxN = 1e6 + 5;
void precalc() {
    p.assign(maxN, 1);
    for(int i = 1; i < maxN; ++i) {
        p[i] = p[i - 1] * P;
        p[i] %= MOD;
    }
}
void make_hsh(string&s1, vi& hs) {
    int N = s1.size();
    hs.assign(N + 1, 0);
    for(int i = 1; i <= N; ++i) {
        hs[i] = hs[i - 1] * P + (s1[i - 1] - 'a' + 1);
        hs[i] %= MOD;
    }
}
int gtt(string &s1) {
    int chash = 0;
    for(int i = 0; i < s1.size(); ++i) {
        chash = chash * P + (s1[i] -'a' + 1);
        chash %= MOD;
    }
    return chash;
}
int gthsh(int l, int r, vi& hsh) {
    int tmp = hsh[r + 1] - hsh[l] * p[r - l + 1];
    tmp %= MOD;
    if(tmp < 0) tmp += MOD;
    return tmp;
}
vector<int> orighsh;
vector<int> sechsh;
vector<int> szzs;
vector<vector<int>> blgs;
void solve_small(int N, int M) {
    string t = ""; cin >> t;
    int S = t.size();
    make_hsh(t, orighsh);
    blgs.assign(S, vector<int> ());
    szzs.assign(N, 0);
    for(int j = 0; j < N; ++j) {
        string k = ""; cin >> k;
        sechsh.push_back(gtt(k));
        szzs[j] = k.size();
    }
    for(int pos = 0; pos < S; ++pos) {
        for(int ind = 0; ind < N; ++ind) {
            if(pos + szzs[ind] > S) continue;
            int t = gthsh(pos, pos + szzs[ind] - 1, orighsh);
            if(gthsh(pos, pos + szzs[ind] - 1, orighsh) == sechsh[ind]) {
                blgs[pos].push_back(pos + szzs[ind] - 1);
            }
        }
        sort(blgs[pos].begin(), blgs[pos].end());
    }
    for(int j = 0; j < M; ++j) {
        int l = 0, r = 0; cin >> l >> r;
        l--; r--;
        int ans = 0;
        for(int i = l; i <= r; ++i) {
            ans += upper_bound(blgs[i].begin(), blgs[i].end(), r) - blgs[i].begin();
        }
        cout << ans << endl;
    }
}

void solve() {
    int N = 0, M = 0; cin >> N >> M;
    if(N <= 5000) {
        solve_small(N, M);
        return;
    }
}

signed main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(12);
    int T = 1;
    precalc();
    while(T--) {
        solve();
    }
    return 0;
}

