#include <iostream>
#include <vector>
#include <iomanip>
#include <algorithm>
#include <string>
#include <chrono>
#include <fstream>
#include <random>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>

using namespace std;

#define ll long long
#define int ll
#define ld long double
#define pii pair<int, int>

mt19937 rnd(chrono::system_clock().now().time_since_epoch().count());

const int srt = 1000;

const int MOD = 1e9 + 7; //233

vector <vector <int>> small;


int pow26[5000050];

int get_hash(string s) {
    int hash = 0;
    for (int i = 0 ; i < s.size(); i++) {
        hash += (s[i] - 'a') * pow26[i];
        hash %= MOD;
    }
    return hash;
}

signed main() {
    pow26[0] = 1;
    for (int i = 1; i < 5000050; i++) {
        pow26[i] = pow26[i - 1] * 26;
        pow26[i] %= MOD;
    }
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
    int n, m;
    string s;
    vector <string> task;
    cin >> n >> m;
    cin >> s;
    task.resize(n);
    for (int i = 0 ; i < n; i++) {
        cin >> task[i];
    }
    vector <vector <int>> pos;
    pos.resize(srt + 1);
    vector <unordered_map<int, vector<int>>> hash_small;
    hash_small.resize(srt + 1);
    for (int i = 0; i < srt; i++) {
        int pp = 0;
        int hash = 0;
        for (int j = i; j < s.size(); j++) {
            hash += (s[j] - 'a') * pow26[pp];
            hash %= MOD;
            hash_small[pp][hash].push_back(i);
            pp++;
            if (pp == 1001) {
                break;
            }
        }
    }
    for (int i = 0; i < n; i++) {
        if (task[i].size() <= srt) {
            int h = get_hash(task[i]);
            for (int j: hash_small[task[i].size() - 1][h]) {
                pos[task[i].size()].push_back(j);
            }
        }
    }
    for (int i = 0 ; i <= srt; i++) {
        sort(pos[i].begin(), pos[i].end());
    }
    int l, r;
    for (int i = 0 ; i < m; i++) {
        cin >> l >> r;
        l--;
        int ans = 0;
        for (int p = 1; p <= 1000; p++) {
            if (l > r) {
                break;
            }
            ans -= lower_bound(pos[p].begin(), pos[p].end(), l) - pos[p].begin();
            ans += lower_bound(pos[p].begin(), pos[p].end(), r) - pos[p].begin();
            r--;
        }
        cout << ans << " ";
    }
}