#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("Ofast")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,fma")

#define ll long long
#define ld long double
#define pii pair<int,int>
#define pll pair<ll,ll>
#define ve vector
#define mpp make_pair
#define pb push_back
#define fi first
#define se second
#define sz(x)          ((int)((x).size()))
#define all(x)          (x).begin(),(x).end()
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
using namespace __gnu_pbds;
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }
template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }

constexpr ll md = 1e16 + 61;
constexpr ll p = 10039;

inline ll add(ll a, ll b) {
    if ((a += b) >= md) a -= md;
    return a;
}
inline ll sub(ll a, ll b) {
    if ((a -= b) < 0) a += md;
    return a;
}
inline ll mul(ll a, ll b) {
    ll q = (ld)a * (ld)b / (ld)md;
    ll r = (a * b - q * md) % md;
    if (r < 0) r += md;
    return r;
}

const int N = 1e6 + 100;

ll pw[N];
inline void calc() {
    pw[0] = 1;
    for (int i = 1; i < N; ++i) {
        pw[i] = mul(pw[i - 1], p);
    }
}

ll h[N];
inline ll get(int l, int r) {
    return sub(h[l], mul(pw[r - l + 1], h[r + 1]));
}

constexpr int buben = 1024;

int nn, mx_b;

int a[N];
int addd[N / buben + 10];

inline void addq(int pos, int x) {
    a[pos] += x;
    addd[pos / buben] += x;
}
inline ll get_sum(int l) {
    int lb = l / buben; ll ans = 0;
    for (int i = lb + 1; i <= mx_b; ++i) ans += addd[i];
    for (int i = l; i < (lb + 1) * buben; ++i) ans += a[i];
    return ans;
}

inline void solve() { calc();

    int n, m;
    cin >> n >> m;

    string s; cin >> s;
    int k = sz(s);

    nn = k;
    mx_b = (nn - 1) / buben;

    for (int i = k - 1; ~i; --i) {
        h[i] = add(s[i] - 'a' + 1, mul(p, h[i + 1]));
    }

    ve<string> a(n);
    for (auto &x : a) cin >> x;

    gp_hash_table<ll,bool> mp;
    for (const auto &s : a) {
        ll h = 0;
        for (int i = 0; i < sz(s); ++i) {
            h = add(h, mul(pw[i], s[i] - 'a' + 1));
        } mp[h] = 1;
    }

    ve<int> al;
    for (const auto &x : a) al.pb(sz(x));

    sort(all(al));
    al.erase(unique(all(al)), al.end());

    ve<ll> ans(m);
    ve<ve<pii>> que(k);
    for (int i = 0; i < m; ++i) {
        int l, r;
        cin >> l >> r, --l, --r;

        que[r].pb({l, i});
    }

    for (int r = 0; r < k; ++r) {
        for (const int &len : al) {
            int l = r - len + 1;
            if (l < 0) break;

            if (mp.find(get(l, r)) != mp.end()) {
                addq(l, +1);
            }
        }

        for (const auto &[l, id] : que[r]) {
            ans[id] = get_sum(l);
        }
    }

    for (auto &x : ans) cout << x << " ";
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
