#include <bits/stdc++.h>
using namespace std;
#pragma GCC optimize("O3,Ofast,fast-math")
#define nt int
const int mod = 1e9 + 7;
const int p = 31;
const int maxn = 1e5 + 5;
const int k = 600;
unordered_set<int> cc[k];
int pows[maxn];
int h[maxn];
int cnt_hash(string& s) {
    int res = 0;
    for (char c: s) {
        res = (1ll * res * p) % mod + c - 'a' + 1;
        if (res >= mod) res -= mod;
    }
    return res;
}
int cnt[maxn][k];
int get_h(nt l, int r) {
    int f = h[r] - (1ll * h[l - 1] * pows[r - l + 1]) % mod;
    if (f < 0) f += mod;
    return f;
}
int ft[maxn];
void add(int i) {
    i++;
    while (i < maxn) {
        ft[i]++;
        i += i & -i;
    }
}
int get(int i) {
    i++;
    int r = 0;
    while (i > 0) {
        r += ft[i];
        i -= i & -i;
    }
    return r;
}
struct event{
    int x;
    int type;
    int l, r;
    event(){}
    int num;
    event(int x, int  type, int  l, int  r) : x(x), type(type), l(l), r(r) {}
    bool operator < (const event& ev) const {
        if (x != ev.x) return x < ev.x;
        return type < ev.type;
    }
};
signed main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);
    pows[0] = 1;
    for (int i = 1; i < maxn; i++) {
        pows[i] = (1ll * pows[i - 1] * p) % mod;
    }
    int n, q;
    cin >> n >> q;
    string s; cin >> s;
    s = ' ' + s;
    for (int i = 1; i < s.size(); i++) {
        h[i] = (1ll * h[i - 1] * p) % mod + s[i] - 'a' + 1;
        if (h[i] >= mod) h[i] -= mod;
    }
    vector <string> patt;
    vector <int> lens;
    for (int i = 0; i < n; i++) {
        string t; cin >> t;
        lens.push_back(t.size());
        patt.push_back(t);
    }
    std::sort(lens.begin(), lens.end());
    lens = vector <int> (lens.begin(), std::unique(lens.begin(), lens.end()));
    for (string t: patt) {
        int hh = cnt_hash(t);
        cc[std::lower_bound(lens.begin(), lens.end(), t.size()) - lens.begin()].insert(hh);
    }
    vector <event> e;
    for (int l = 1; l < s.size(); l++) {
        for (int j = 0; j < lens.size() && lens[j] <= l; j++) {
            int lst_hash = get_h(l - lens[j] + 1, l);
            if (lens[j] <= l && cc[j].find(lst_hash) != cc[j].end()) {
                e.emplace_back(l, 0, l - lens[j], 0);
            }
        }
    }


    vector <int> ans(q + 1, 0);

    while (q--) {
        int l, r;
        cin >> l >> r;
        e.emplace_back(l, -1, l - 1, r - 1);
        e.back().num = q;
        e.emplace_back(r, 1, l - 1, r - 1);
        e.back().num = q;
    }
    std::sort(e.begin(), e.end());

    for (auto ev: e) {
        if (ev.type == 0) add(ev.l);
        else {
            ans[ev.num] += ev.type * (get(ev.r) - get(ev.l - 1));
        }
    }
    for (int i = ans.size() - 2; i >= 0; i--) cout << ans[i] << ' ';
    return 0;
}