#include <bits/stdc++.h>
typedef long long ll;
using namespace std;
const ll limit = 5e6 + 300, mod = 1e9 + 7;
ll base = 53;
vector<ll> powers(limit, 1);
void solve(){
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> strs(n);
    for(int i = 0; i < n; i++)
        cin >> strs[i];
    auto get_hash = [&](string s){
        vector<ll> hash(1, 0);
        ll p = 1;
        for(char c : s){
            hash.push_back((hash.back() + p * (c - 'a' + 1)) % mod);
             p = (p * base) % mod;
        }
        return hash;
    };
    vector<ll> hash = get_hash(t);
    vector<ll> hashes(n);
    for(int i = 0; i < n; i++)
        hashes[i] = get_hash(strs[i]).back();
    vector<vector<ll>> ind(n);
    for(int i = 0; i < n; i++){
        if(t.length() < strs[i].length())
            continue;
        for(int j = 0; j < t.length() - strs[i].length() + 1; j++) {
            ll hash_a = (hash[j + strs[i].length()] - hash[j] + mod) % mod;
            hash_a *= powers[limit - j - 1];
            hash_a %= mod;
            ll hash_b = (hashes[i] * powers[limit - 1]) % mod;
            if (hash_a == hash_b)
                ind[i].push_back(j);
        }
    }
    for(int i = 0; i < m; i++){
        ll l, r;
        cin >> l >> r, --l, --r;
        ll ans = 0;
        for(int j = 0; j < n; j++){
            r -= strs[j].length() - 1;
            ll l_ans = 0, r_ans = ind[j].size() - 1;
            if(!ind[j].empty()){
                if(ind[j][0] < l){
                    if(ind[j].back() < l)
                        l_ans = ind[j].size();
                    else{
                        ll lx = 0, rx = ind[j].size() - 1;
                        while(rx - lx > 1){
                            ll mid = (lx + rx) / 2;
                            if(ind[j][mid] >= l)
                                rx = mid;
                            else
                                lx = mid;
                        }
                        l_ans = rx;
                    }
                }
                if(ind[j].back() > r){
                    if(ind[j][0] > r)
                        r_ans = -1;
                    else if(ind[j].back() > r){
                        ll lx = 0, rx = ind[j].size() - 1;
                        while(rx - lx > 1){
                            ll mid = (lx + rx) / 2;
                            if(ind[j][mid] > r)
                                rx = mid;
                            else
                                lx = mid;
                        }
                        r_ans = lx;
                    }
                }
            }
            ans += max((ll)0, r_ans - l_ans + 1);
            //cout << j << " " << r_ans << " " << l_ans << " " << r << "\n\n";
            r += strs[j].length() - 1;
        }
        cout << ans << " ";
    }
}
int main(){
    for(int i = 1; i < limit; i++)
        powers[i] = (powers[i - 1] * base) % mod;
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    srand(time(0));
    ll t = 1;
    //cin >> t;
    while(t--)
        solve();
    return 0;
}