#include <bits/stdc++.h>
#define debug(x) cerr << (#x) << " : " << x << endl;
#define all(a) a.begin(), a.end()
#define int long long

typedef long long ll;
typedef double db;
using namespace std;
const int MOD = 1e9 + 7;
const int MAXL = 2e6;
const int MAXT = 5005;
const db eps = 1e-9;

struct Node {
    int go[26];
    int cntEnd;
};

int borSz = 1;
Node bor[MAXL];

void insertToBor(string s) {
    int v = 0;
    for (auto c : s) {
        if (bor[v].go[c - 'a'] != 0) {
            v = bor[v].go[c - 'a'];
        } else {
            bor[v].go[c - 'a'] = borSz;
            v = bor[v].go[c - 'a'];
            borSz++;
        }
    }
    bor[v].cntEnd++;
}

int f[MAXT][MAXT]; // all in 1 numer

int getPref(int x, int y) {
    int ans = 0;
    for (int i = x; i > 0; i -= i & -i) {
        for (int j = y; j > 0; j -= j & -j) {
            ans += f[i][j];
        }
    }
    return ans;
}

void add(int x, int y, int c) {
    for (int i = x; i < MAXT; i += i & -i) {
        for (int j = y; j < MAXT; j += j & -j) {
            f[i][j] += c;
        }
    }
}

int getSum(int x1, int y1, int x2, int y2) {
    return getPref(x2, y2) - getPref(x1 - 1, y2) - getPref(x2, y1 - 1) + getPref(x1 - 1, y1 - 1);
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int n, m; cin >> n >> m;
    string t; cin >> t;
//    vector<vector<int>> gr(t.size());
    for (int i = 0; i < n; ++i) {
        string s; cin >> s;
        insertToBor(s);
    }
    for (int i = 0; i < (int)t.size(); ++i) {
        int v = 0;
        for (int j = i; j < (int)t.size(); ++j) {
            if (bor[v].go[t[j] - 'a'] == 0) break;
            v = bor[v].go[t[j] - 'a'];
            if (bor[v].cntEnd) {
                add(i + 1, j + 1, 1);
            }
        }
    }
    for (int _ = 0; _ < m; ++_) {
        int l, r; cin >> l >> r;
        int ans = getSum(l, l, r, r);
        cout << ans << ' ';
    }
    return 0;
}