#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

ll Pp = 179;
ll MD = 228228227;

ll b_pow(ll a, ll k) {
    if (k == 0) return 1;
    if (k % 2 == 1) {
        return (a * b_pow(a, k - 1)) % MD;
    } else {
        ll t = b_pow(a, k / 2);
        return (t * t) % MD;
    }
}

ll dv(ll a, ll b) {
    return (a * b_pow(b, MD - 2)) % MD;
}

void solve() {
    int n, m;
    string S;
    cin >> n >> m;
    cin >> S;
    int T = S.size();
    vector<ll> h(T + 1);
    vector<ll> P(T + 1);
    P[0] = 1;
    for (int i = 0; i < T; i++) {
        P[i + 1] = (P[i] * Pp) % MD;
        h[i + 1] = (h[i] * Pp + S[i]) % MD;
    }
    vector<ll> sz(n);
    vector<vector<ll>> st(n);
    for (int i = 0; i < n; i++) {
        st[i].push_back(-1);
        string s;
        cin >> s;
        sz[i] = s.size();
        ll H = 0;
        for (int c: s) {
            H = (H * Pp + c) % MD;
        }
        for (int j = 0; j + sz[i] <= T; j++) {
            ll H1 = h[j + sz[i]];
            ll H2 = (h[j] * P[sz[i]]) % MD;
            ll H3 = (H1 - H2 + MD) % MD;
            if (H == H3) {
                st[i].push_back(j);
            }
        }
        st[i].push_back(T + 1);
    }
    vector<ll> ans(m);
    for (int I = 0; I < m; I++) {
        int l, r;
        cin >> l >> r;
        for (int i = 0; i < n; i++) {
            ll l1 = lower_bound(st[i].begin(), st[i].end(), l - 1) - st[i].begin();
            ll r1 = upper_bound(st[i].begin(), st[i].end(), r - sz[i]) - st[i].begin();
            ans[I] += max(0ll,r1 - l1);
        }
    }

    for (ll i: ans) {
        cout << i << ' ';
    }
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}