#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

#define int ll

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

const int P = 239;
const int MOD1 = 1e9 + 7;
const int MOD2 = 228228227;

int mul(int a, int b, int mod) {
    return 1LL * a * b % mod;
}

int add(int a, int b, int mod) {
    return (a + b) % mod;
}

int sub(int a, int b, int mod) {
    return ((a - b) % mod + mod) % mod;
}

int binpow(int a, int n, int mod) {
    if (n == 0) {
        return 1;
    }
    if (n % 2 == 0) {
        int b = binpow(a, n / 2, mod);
        return mul(b, b, mod);
    } else {
        return mul(a, binpow(a, n - 1, mod), mod);
    }
}

int divide(int a, int b, int mod) {
    if (b == 0) {
        return 0;
    }
    return mul(a, binpow(b, mod - 2, mod), mod);
}

const int N = 50'001;
int pw[N];

void solve() {
    int n, q;
    string t;
    cin >> n >> q >> t;
//    vector<int> h(sz(t) + 1);
//    for (int i = 1; i <= sz(t); ++i) {
//        h[i] = add(mul(h[i - 1], P, MOD1), t[i - 1] - 'a' + 1, MOD1);
//    }
//
//    auto get = [&h](int l, int r) {
//        return sub(h[r], mul(h[l - 1], pw[r - l + 1], MOD1), MOD1);
//    };

    set<pii> st;

    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        int now1 = 0;
        int now2 = 0;
        for (auto c : s) {
            now1 = add(mul(now1, P, MOD1), c - 'a' + 1, MOD1);
            now2 = add(mul(now2, P, MOD2), c - 'a' + 1, MOD2);
        }
        st.emplace(now1, now2);
    }

    vector<vector<ll>> precalc(sz(t) + 2, vector<ll> (sz(t) + 2, 0));
    for (int l = 1; l <= sz(t); ++l) {
        ll ans = 0;
        int now1 = 0;
        int now2 = 0;
        for (int r = l; r <= sz(t); ++r) {
            now1 = add(mul(now1, P, MOD1), t[r - 1] - 'a' + 1, MOD1);
            now2 = add(mul(now2, P, MOD2), t[r - 1] - 'a' + 1, MOD2);
            ans += (st.find({now1, now2}) != st.end());
            precalc[l][r] = ans;
        }
    }
    for (int len = 2; len <= sz(t); ++len) {
        for (int l = 1; l <= sz(t); ++l) {
            int r = l + len - 1;
            if (r > sz(t)) {
                break;
            }
            precalc[l][r] += precalc[l + 1][r];
//            precalc[l][r] += precalc[l][r - 1];
//            precalc[l][r] -= precalc[l + 1][r - 1];
        }
    }

    for (int w = 0; w < q; ++w) {
        int l, r;
        cin >> l >> r;
        cout << precalc[l][r] << ' ';
//        int ans = 0;
//        for (int i = l; i <= r; ++i) {
//            int now = 0;
//            for (int j = i; j <= r; ++j) {
//                now = add(mul(now, P), t[j - 1] - 'a' + 1);
//                ans += (st.find(now) != st.end());
//            }
//        }
//        cout << ans << ' ';
    }

}

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
//    pw[0] = 1;
//    for (int i = 1; i < N; ++i) {
//        pw[i] = mul(pw[i - 1], P);
//    }
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
