#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
//#define endl '\n'

typedef long long ll;
typedef long double ld;
typedef tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const ll INF = 1e18;
const ll MOD = 1e9 + 7;
const ll P = 97;

void Fast(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}

vector <pair <int, int>> p;

struct Hash{
    int MOD1 = 1e9 + 7, MOD2 = 1e9 + 9;
    vector <pair <int, int>> h;

    Hash(string s){
        h.resize(s.size() + 1);
        h[1] = {s[0] - 'a' + 1, s[0] - 'a' + 1};
        for (int i = 1; i < s.size(); i++){
            h[i + 1].first = (s[i] - 'a' + 1) + h[i].first * P;
            h[i + 1].second = (s[i] - 'a' + 1) + h[i].second * P;
            h[i + 1].first %= MOD1;
            h[i + 1].second %= MOD2;
        }
    }

    Hash(){}

    pair <int, int> get(int l, int r){
        pair <int, int> res;
        res.first = h[r].first + MOD1 - (h[l - 1].first * p[r - l + 1].first) % MOD1;
        res.second = h[r].second + MOD2 - (h[l - 1].second * p[r - l + 1].second) % MOD2;
        res.first %= MOD1;
        res.second %= MOD2;
        return res;
    }
};

signed main(){
    Fast();
    p.resize(100001);
    p[0] = {1, 1};
    for (int i = 1; i < p.size(); i++){
        p[i].first = p[i - 1].first * P;
        p[i].second = p[i - 1].second * P;
        p[i].first %= (int)(1e9 + 7);
        p[i].second %= (int)(1e9 + 9);
    }
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Hash h(t);
    set <pair <int, int>> s;
    for (int i = 0; i < n; i++){
        string st;
        cin >> st;
        Hash e(st);
        s.insert(e.h.back());
    }
    for (int _ = 0; _ < m; _++){
        int l, r;
        cin >> l >> r;
        int ans = 0;
        set <pair <int, int>> g;
        for (int i = l; i <= r; i++){
            for (int j = i; j <= r; j++){
                pair <int, int> k = h.get(i, j);
//                cout << i << " " << j << endl;
//                cout << k.first << " " << k.second << endl;
//                cout << s.count(k) << endl << endl;
                ans += s.count(k);
            }
        }
        cout << ans << " ";
    }
    return 0;
}