#include <bits/stdc++.h>

using namespace std;

typedef int ll;
typedef pair<int, int> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

struct Hash {
    vector<int> hash, pows;

    ll n;

    const int mod = 123456791;
    const int P = 31;

    Hash(string &s) {
        n = (ll) s.size();
        hash.resize(n + 1);
        pows.resize(n + 1);
        hash[0] = 0;
        pows[0] = 1;
        for (ll i = 0; i < n; i++) {
            hash[i + 1] = (hash[i] * P + s[i]) % mod;
            pows[i + 1] = (pows[i] * P) % mod;
        }
    }

    int get(ll l, ll r) {
        return ((hash[r + 1] % mod) - (((hash[l] % mod) * (pows[r - l + 1] % mod)) % mod) + mod) % mod;
    }
};

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    Hash h(t);
    vector<string> a(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    vector<pair<ll, ll>> val(n);
    for (ll i = 0; i < n; i++) val[i].first = Hash(a[i]).get(0, (ll) a[i].size() - 1), val[i].second = (ll) a[i].size();
    //  cout << "d: ";
    //  for (ll x : val) cout << x << " ";
    //  cout << endl;
    vector<ll> val1(n);
    for (ll i = 0; i < n; i++) val1[i] = Hash(a[i]).get(0, (ll) a[i].size() - 1);
    sort(val1.begin(), val1.end());
    ll all_size = 0;
    for (string &cur : a) all_size += (ll) cur.size();
    while (m--) {
        ll l, r;
        cin >> l >> r;
        l--, r--;
        ll len = r - l + 1;
        if (len * len < len * all_size) {
            ll ans = 0;
            for (ll cur_len = 1; cur_len <= len; cur_len++) {
                for (ll left = l; left + cur_len - 1 <= r; left++) {
                    ll right = left + cur_len - 1;
                    ll hash = h.get(left, right);
                    if (lower_bound(val1.begin(), val1.end(), hash) != val1.end()) {
                        if (*lower_bound(val1.begin(), val1.end(), hash) == hash) {
                            ans++;
                        }
                    }
                }
            }
            cout << ans << endl;
        } else {
            ll ans = 0;
            for (auto[cur, sz] : val) {
                for (ll left = l; left + sz - 1 <= r; left++) {
                    ll right = left + sz - 1;
                    if (h.get(left, right) == cur) {
                        ans++;
                    }
                }
            }
            cout << ans << endl;
        }
    }
    return 0;
}