#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef tree<pair<int, int>, null_type, less<pair<int, int>>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

#define ff first
#define ss second
#define pb push_back
#define int long long
#define dl long double

vector<int> pifunc(const string &s) {
    int n = (int) s.size();
    vector<int> pi(n);
    for (int i = 1; i < n; i++) {
        int j = pi[i - 1];
        while (j > 0 && s[i] != s[j]) j = pi[j - 1];
        if (s[i] == s[j]) j++;
        pi[i] = j;
    }
    return pi;
}

void solve() {
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int z = t.size();
    string s;
    vector<vector<int>> ans(n, vector<int>(z + 1));
    int x;
    vector<int> sz(n);
    for (int i = 0; i < n; i++) {
        cin >> s;
        x = s.size();
        sz[i] = x;
        s = s + '#' + t;
        auto a = pifunc(s);
        for (int j = x + 1; j <= x + z; j++)
            if (a[j] == x) ans[i][j - 2 * x + 1] = 1;
    }
    for (int i = 0; i < n; i++)
        for (int j = 1; j <= z; j++) ans[i][j] += ans[i][j - 1];
    int l, r;
    for (int i = 0; i < m; i++) {
        cin >> l >> r;
        int now = 0;
        for (int j = 0; j < n; j++)
            if (r - l + 1 >= sz[j]) now += ans[j][r - sz[j] + 1] - ans[j][l - 1];
        cout << now << ' ';
    }
}

signed main() {
#ifndef Bebra
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
#endif
#ifdef Bebra
    freopen("input", "r", stdin);
    freopen("out", "w", stdout);
#endif
    int tests = 1;
//    cin >> tests;
    while (tests--) solve();
}