#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
//#pragma GCC target("avx2")
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define sz(a) (int)a.size()
#define pb push_back
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

const int INFi = 1e9;
const ll INFl = 1e18;

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

mt19937 rnd(time(0));

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/Kek/read.txt", "r", stdin);
#endif
    cout << fixed << setprecision(15);
    int tc = 1;
    //cin >> tc;
    forn(i, tc) solve();
    return 0;
}
#define hsh pair<ll, ll>
const int Maxn = 5 * 1e6 + 10;
const int Mod[2] = {1234567891, 1000000009};
const int base[2] = {239, 311};

hsh step = {base[0], base[1]};

hsh pows[Maxn];
hsh mul(hsh a, hsh b) {
    hsh res;
    res.ff = (a.ff * 1ll * b.ff) % Mod[0];
    res.ss = (a.ss * 1ll * b.ss) % Mod[1];
    return res;
}
hsh add(hsh a, hsh b) {
    hsh res;
    res.ff = (a.ff + b.ff) % Mod[0];
    res.ss = (a.ss + b.ss) % Mod[1];
    return res;
}

hsh sub(hsh a, hsh b) {
    hsh res;
    res.ff = (a.ff - b.ff + Mod[0]) % Mod[0];
    res.ss = (a.ss - b.ss + Mod[1]) % Mod[1];
    return res;
}

struct ch {
    int n;
    vector<hsh> pref;
    ch(string &s) {
        n = sz(s);
        pref.resize(sz(s) + 1);
        pref[0] = {0, 0};
        for (int i = 0; i < sz(s); ++i) {
            pref[i + 1] = add(pref[i], mul(pows[i], {s[i] - 'a' + 1, s[i] - 'a' + 1}));
        }
    }

    hsh get(int l, int r) {
        hsh res = sub(pref[r], pref[l]);
        res = mul(res, pows[Maxn - l - 1]);
        return res;
    }
};

void solve() {
    pows[0] = {1, 1};
    for (int i = 1; i < Maxn; ++i) {
        pows[i] = mul(pows[i - 1], step);
    }
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    ch fl = ch(t);
    vector<ch> kek;
    forn(i, n) {
        string s;
        cin >> s;
        kek.pb(ch(s));
    }
    vector<vector<ll>> ans(sz(t), vector<ll>(sz(t), 0));
    forn(pos, sz(t)) {
        vector<ll> sm(sz(t));
        forn(j, n) {
            if (pos + kek[j].n <= sz(t)) {
                hsh l = fl.get(pos, pos + kek[j].n);
                hsh r = kek[j].get(0, kek[j].n);
                if (l == r) sm[pos + kek[j].n - 1]++;
            }
        }
        forn(j, sz(t)) {
            ans[pos][j] += sm[j];
            if (j + 1 < sz(t)) sm[j + 1] += sm[j];
        }
    }
    for (int i = sz(t) - 2; i >= 0; --i)
        forn(j, sz(t)) ans[i][j] += ans[i + 1][j];
    forn(q, m) {
        int l, r;
        cin >> l >> r;
        --l, --r;
        cout << ans[l][r] << ' ';
    }
}