#include <bits/stdc++.h>
using namespace std;
int C;
long long int MOD = 1000002161, P = 29;
struct Record {
    int l, r, ind;
    Record() : l(0), r(0), ind(-1) {}
    Record(int l, int r, int ind) : l(l), r(r), ind(ind) {}
};
bool cmp(Record r1, Record r2) {
    if (r1.l / C == r2.l / C) return r1.r < r2.r;
    return r1.l < r2.l;
}
vector <long long int> p, H, h;
long long int get_hash(int L, int R) {
    return ((H[R + 1] - ((H[L] * p[R - L + 1]) % MOD)) + MOD) % MOD;
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m, max_len = 1;
    cin >> n >> m;
    string t;
    cin >> t;
    max_len = int(t.size());
    vector <string> s(n);
    for (int i = 0; i < n; i++) {
        cin >> s[i];
        max_len = max(max_len, int(s[i].size()));
    }
    vector <Record> rec(m);
    for (int i = 0; i < m; i++) {
        cin >> rec[i].l >> rec[i].r;
        rec[i].l--;
        rec[i].r--;
    }
    //sort(rec.begin(), rec.end(), cmp);
    p.resize(max_len + 1);
    p[0] = 1;
    for (int i = 1; i <= max_len; i++) {
        p[i] = (p[i - 1] * P) % MOD;
    }
    H.resize(int(t.size()) + 1);
    H[0] = 0;
    for (int i = 0; i < t.size(); i++) {
        H[i + 1] = (H[i] * P + t[i] - 'a' + 1) % MOD;
    }
    h.resize(n, 0);
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < s[i].size(); j++) {
            h[i] = (h[i] * P + s[i][j] - 'a' + 1) % MOD;
        }
    }
    int x, y = int(t.size());
    vector <vector <int>> pref(n, vector <int> (y + 1, 0));
    for (int i = 0; i < n; i++) {
        x = int(s[i].size());
        pref[i][0] = 0;
        for (int L = 0; L < y; L++) {
            if (L + x <= y && get_hash(L, L + x - 1) == h[i]) {
                pref[i][L + 1] = pref[i][L] + 1;
            }
            else {
                pref[i][L + 1] = pref[i][L];
            }
        }
    }
    int ans;
    for (auto e: rec) {
        ans = 0;
        for (int i = 0; i < n; i++) {
            x = int(s[i].size());
            if (e.r - x + 2 >= e.l) ans += pref[i][e.r - x + 2] - pref[i][e.l];
        }
        cout << ans << " ";
    }
    return 0;
}