#include <bits/stdc++.h>

#define int int64_t

const int INF = 2e18;
const int MOD = 1e9 + 7;
const int MAXN = 1e5;
const long double EPS = 1e-5;
const long double EPS1 = 1e-6;

using namespace std;

mt19937 rnd(chrono::high_resolution_clock::now().time_since_epoch().count());

struct trie{
    int go[26];
    int temp = 0;
    trie(){
        for(int i = 0; i < 26; i++){
            go[i] = 0;
        }
    }
};

vector <trie> v;

void AddString(string& s){
    int pos = 0;
    for(int i = 0; i < s.size(); i++){
        if(v[pos].go[s[i] - 'a'] == 0){
            trie a;
            v[pos].go[s[i] - 'a'] = v.size();
            v.push_back(a);
        }
        pos = v[pos].go[s[i] - 'a'];
    }
    v[pos].temp++;
}

vector <pair<int, int>> vp;

void get(string &s, int l){
    int pos = 0;
    int cnt = 0;
    for(int i = 0; i < s.size(); i++){
        cnt = i;
        for(int j = 0; j < v[pos].temp; j++){
            vp.push_back({l, l + i - 1});
        }
        if(v[pos].go[s[i] - 'a'] != 0){
            pos = v[pos].go[s[i] - 'a'];
        }
        else{
            return;
        }
    }
    for(int j = 0; j < v[pos].temp; j++){
        vp.push_back({l, l + cnt});
    }
}


void solve(){
    trie aa;
    v.push_back(aa);
    int n, m;
    cin >> n >> m;
    string s;
    cin >> s;
    for(int i = 0; i < n; i++){
        string s1;
        cin >> s1;
        AddString(s1);
    }
    string s1 = "";
    for(int i = s.size() - 1; i >= 0; i--){
        s1 = s[i] + s1;
        get(s1, i);
    }
    sort(vp.begin(), vp.end());
    for(int i = 0; i < m; i++){
        int l, r;
        cin >> l >> r;
        l--;
        r--;
        int cnt = 0;
        int l1 = -1, r1 = vp.size();
        while(r1 - l1 > 1){
            int m = (l1 + r1) / 2;
            if(vp[m].first < l){
                l1 = m;
            }
            else{
                r1 = m;
            }
        }
        for(int i = r1; i < vp.size(); i++){
            auto [a, b] = vp[i];
            if(a > r){
                break;
            }
            if(a >= l && b <= r){
                cnt++;
            }
        }
        cout << cnt << ' ';
    }
}

signed main()
{
    cin.tie(0);
    ios_base::sync_with_stdio(false);
    int t = 1;
    //cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
