#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <set>
#include <unordered_map>
#include <iomanip>
#include <bitset>
#include <math.h>
#include <cmath>
#include <random>
using namespace std;
typedef long long ll;
typedef long double ld;
ll o = 113;
ll mod = 1e9 + 7;

ll geth(string& s) {
    ll res = 0;
    for (int i = 0; i < s.length(); ++i) {
        res = (res * o + (s[i] - 'a' + 1)) % mod;
    }
    return res;
}

int main() {
    ios::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    map<ll, ll> d;
    
    for (int i = 0; i < n; ++i) {
        string s;
        cin >> s;
        ++d[geth(s)];
    }
    
    if (t.length() <= 50000) {
        ll ln = t.length();
        vector<vector<ll>> a(ln, vector<ll>(ln, 0));
        vector<ll> answ;
        for (int i = 0; i < ln; ++i) {
            ll now = 0;
            for (int j = i; j < ln; ++j) {
                now = (now * o + (t[j] - 'a' + 1)) % mod;
                if (d[now]) ++a[i][j];
                if (j) a[i][j] += a[i][j - 1];
            }
        }
        for (int i = 0; i < m; ++i) {
            ll l, r;
            cin >> l >> r;
            --l;
            ll ans = 0;
            for (int j = l; j < r; ++j) {
                ans += a[j][r - 1] - (l ? a[j][l - 1] : 0);
            }
            answ.push_back(ans);
        }
        for (ll w : answ) cout << w << " ";
    }
}