#include<bits/stdc++.h>
using namespace std;
#pragma GCC optimize ("Ofast")
#pragma GCC target ("sse4")
#define ll long long
const ll mod1=1e9+7;
const ll base1=37;
const ll mod2=1e9+9;
const ll base2=53;
const int MAXN=1e5+6;
const int MAXM=1e5+6;
const int MAXQ=5e5+6;
int n,m;
string t;
ll powers1[MAXM];
ll powers2[MAXM];
ll rpowers1[MAXN];
ll rpowers2[MAXN];
ll fastpow(ll x,ll p,ll m)
{
    if(p==0)return 1;
    if(p==1)return x;
    ll t=fastpow(x,p/2,m);
    t*=t;t%=m;
    if(p%2==1)
    {
        t*=x;
        t%=m;
    }
    return t;
}
void precompute()
{
    powers1[0]=1;
    powers2[0]=1;
    rpowers1[0]=1;
    rpowers2[0]=1;
    for(ll i=1;i<MAXM;i++)
    {
        powers1[i]=powers1[i-1]*base1;
        powers2[i]=powers2[i-1]*base2;
        powers1[i]%=mod1;
        powers2[i]%=mod2;
        rpowers1[i]=fastpow(powers1[i],mod1-2,mod1);
        rpowers2[i]=fastpow(powers2[i],mod2-2,mod2);
    }
}
struct my_hash
{
    ll val1;
    ll val2;
    void append_letter(char c)
    {
        val1=val1*base1+c-'a'+1;
        val2=val2*base2+c-'a'+1;
        val1%=mod1;
        val2%=mod2;
    }
    void shift_left(ll p)
    {
        val1=val1*powers1[p];
        val2=val2*powers2[p];
        val1%=mod1;
        val2%=mod2;
    }
    void shift_right(ll p)
    {
        val1=val1*rpowers1[p];
        val2=val2*rpowers2[p];
        val1%=mod1;
        val2%=mod2;
    }
}pref[MAXM],hashes[MAXN];
my_hash calc_hash(string s)
{
    my_hash ret;
    ret.val1=0;
    ret.val2=0;
    for(int i=0;i<s.size();++i)
    {
        ret.append_letter(s[i]);
    }
    return ret;
}
my_hash get_hash(int l,int r)
{
    my_hash ret=pref[r];
    my_hash rem=pref[l-1];
    rem.shift_left(r-l+1);
    ret.val1-=rem.val1-mod1;
    ret.val2-=rem.val2-mod2;
    ret.val1%=mod1;
    ret.val2%=mod2;
    return ret;
}
string s[MAXN];
struct query
{
    int l,r,idx;
    bool operator<(query const& other)const
    {
        if(l!=other.l)return l<other.l;
        if(r!=other.r)return r<other.r;
        return idx<other.idx;
    }
};
vector<query>queries;
unordered_set<int>lens;
unordered_set<int>hashes1[MAXN];
void read()
{
    cin>>n>>m;
    cin>>t;
    for(int i=1;i<=n;++i)
    {
        cin>>s[i];
        lens.insert(s[i].size());
    }
    for(int i=1;i<=m;++i)
    {
        int l,r;
        cin>>l>>r;
        queries.push_back({l,r,i});
    }
}
struct BIT
{
    int tree[MAXM];
    void update(int idx,int val)
    {
        for(;idx<MAXM;idx+=idx&(-idx))
        {
            tree[idx]+=val;
        }
    }
    int query(int idx)
    {
        int ret=0;
        for(;idx>0;idx-=idx&(-idx))
        {
            ret+=tree[idx];
        }
        return ret;
    }
}fen;
vector<int>en[MAXM];
int ans[MAXQ];
void solve5()
{
    vector<pair<int,int> >segments;
    for(int i=1;i<=n;++i)
    {
        hashes[i]=calc_hash(s[i]);
        hashes1[s[i].size()].insert(hashes[i].val1*mod2+hashes[i].val2);
    }
    pref[0].val1=0;
    pref[0].val2=0;
    for(int i=1;i<=t.size();++i)
    {
        pref[i]=pref[i-1];
        pref[i].append_letter(t[i-1]);
    }
    for(int i=1;i<=t.size();++i)
    {
        for(auto len:lens)
        {
            int l=i,r=i+len-1;
            if(r>t.size())continue;
            my_hash eho=get_hash(l,r);
            ll alo=eho.val1*mod2+eho.val2;
            if(hashes1[len].find(alo)!=hashes1[len].end())
            {
                segments.push_back({l,r});
                fen.update(r,+1);
                en[l].push_back(r);
            }
        }
    }
    sort(queries.begin(),queries.end());
    int last=0;
    for(int i=0;i<queries.size();++i)
    {
        while(last+1<queries[i].l)
        {
            ++last;
            for(auto xd:en[last])
            {
                fen.update(xd,-1);
            }
        }
        ans[queries[i].idx]=fen.query(queries[i].r);
    }
    for(int i=1;i<=m;++i)
    {
        cout<<ans[i]<<" ";
    }
    cout<<endl;
}
void solve1234()
{
    vector<pair<int,int> >segments;
    for(int i=1;i<=n;++i)
    {
        hashes[i]=calc_hash(s[i]);
    }
    pref[0].val1=0;
    pref[0].val2=0;
    for(int i=1;i<=t.size();++i)
    {
        pref[i]=pref[i-1];
        pref[i].append_letter(t[i-1]);
    }
    for(int i=1;i<=t.size();++i)
    {
        for(int j=1;j<=n;++j)
        {
            int l=i,r=i+s[j].size()-1;
            if(r>t.size())continue;
            my_hash eho=get_hash(l,r);
            ll alo=eho.val1*mod2+eho.val2;
            if(alo==hashes[j].val1*mod2+hashes[j].val2)
            {
                segments.push_back({l,r});
                fen.update(r,+1);
                en[l].push_back(r);
            }
        }
    }
    sort(queries.begin(),queries.end());
    int last=0;
    for(int i=0;i<queries.size();++i)
    {
        while(last+1<queries[i].l)
        {
            ++last;
            for(auto xd:en[last])
            {
                fen.update(xd,-1);
            }
        }
        ans[queries[i].idx]=fen.query(queries[i].r);
    }
    for(int i=1;i<=m;++i)
    {
        cout<<ans[i]<<" ";
    }
    cout<<endl;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    precompute();
    read();
    if(t.size()<=50000)solve1234();
    else solve5();
return 0;
}
