#include <iostream>
#include <bits/stdc++.h>
#define int long long

using namespace std;

const int mod = 1e9 + 7, k = 41;

vector<int> hashes, st;

void calc(string &t){
    int hash = 0;
    for (auto c : t){
        int sym = (c - 'a' + 1);
        hash = (hash * k + sym) % mod;
        hashes.push_back(hash);
    }
}

int get(int l, int r){
    if (l == 0) return hashes[r];
    return ((hashes[r] - (hashes[l - 1] * st[r - l + 1]) % mod) % mod + mod) % mod;
}

signed main() {

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, m;
    cin >> n >> m;

    string t;
    cin >> t;

    int sz = (int) t.size();

    st.assign(sz + 1, 0);
    st[0] = 1;
    for (int i = 1; i <= sz; i ++){
        st[i] = (st[i - 1] * k) % mod;
    }

    calc(t);

    vector<vector<int>> find(n, vector<int>(sz, 0));
    vector<int> len(n);
    string s;

    for (int i = 0; i < n; i++) {
        int hash = 0;
        cin >> s;
        for (auto c: s) {
            int pos = (c - 'a' + 1);
            hash = (hash * k + pos) % mod;
        }
        len[i] = (int) s.size();
        for (int j = 0; j <= sz - len[i]; j++) {
            if (get(j, j + len[i] - 1) == hash) {
                find[i][j] = 1;
            }
        }
    }

    for (int i = 0; i < n; i++) {
        for (int j = 0; j < sz; j++) {
            find[i][j] += (j == 0 ? 0 : find[i][j - 1]);
        }
    }

    for (int i = 0; i < m; i++) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        int ans = 0;
        for (int j = 0; j < n; j++) {
            int rik = r - len[j] + 1;
            ans += find[j][rik] - (l == 0 ? 0 : find[j][l - 1]);
        }
        cout << ans << " ";
    }

}

/*
3 5
abacaba
aba
a
ac
1 7
1 3
2 7
2 5
4 5

 */