#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int mod2 = 1e9 + 9;
const int N = 5e6 + 10;
const int B = 31;
const int B2 = 37;
int p[N], p2[N];

pii HASH(string &s)
{
    int n = sz(s);
    int H = 0;
    for (int i = 0; i < n; i++) (H += (int)(s[i] - 'a' + 1) * p[i]) %= mod;
    int H2 = 0;
    for (int i = 0; i < n; i++) (H2 += (int)(s[i] - 'a' + 1) * p2[i]) %= mod;
    return {H, H2};
}

//int sum[4 * N];
//
//void change(int idx, int val, int v, int tl, int tr)
//{
//    if (tl == tr)
//    {
//        sum[v] = val;
//        return;
//    }
//    int m = tl + tr >> 1;
//    if (idx <= m) change(idx, val, 2 * v + 1, tl, m);
//    else change(idx, val, 2 * v + 2, m + 1, tr);
//    sum[v] = sum[2 * v + 1] + sum[2 * v + 2];
//}
//
//int get(int l, int r, int v, int tl, int tr)
//{
//    if (tl > r || tr < l) return 0;
//    if (tl >= l && tr <= r) return sum[v];
//    int m = tl + tr >> 1;
//    return get(l, r, )
//}

void solve()
{
    int n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    int len = sz(t);
    vec<string> s(n);
    set<pii> setik;
    for (int i = 0; i < n; i++)
    {
        cin >> s[i];
        pii H = HASH(s[i]);
        setik.insert(H);
    }
    vec<vec<int>> dp(len + 1, vec<int>(len + 1));
    for (int l = 0; l < len; l++)
    {
        int H = 0;
        int H2 = 0;
        for (int r = l; r < len; r++)
        {
            (H += (int)(t[r] - 'a' + 1) * p[r - l]) %= mod;
            (H2 += (int)(t[r] - 'a' + 1) * p2[r - l]) %= mod;
            if (setik.find({H, H2}) != setik.end()) dp[l][r] = 1;
        }
    }
    for (int L = 2; L <= len; L++)
    {
        for (int l = 0; l < len; l++)
        {
            int r = l + L - 1;
            if (r >= len) break;
            dp[l][r] += dp[l + 1][r] + (r - 1 >= 0 ? dp[l][r - 1] : 0) - (r - 1 >= 0 ? dp[l + 1][r - 1] : 0);
        }
    }
    while (m--)
    {
        int l, r;
        cin >> l >> r;
        l--; r--;
        cout << dp[l][r] << " ";
    }
}

void precalc()
{
    p[0] = 1;
    for (int i = 1; i < N; i++) p[i] = p[i - 1] * B % mod;
    p2[0] = 1;
    for (int i = 1; i < N; i++) p2[i] = p2[i - 1] * B2 % mod2;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    precalc();
    solve();
    return 0;
}
