#include <vector>
#include <set>
#include <map>
#include <string>
#include <iostream>
#include <deque>
#include <algorithm>

using namespace std;
typedef long long ll;

ll mod = 1e9 + 9;
ll osn = 28;

vector<ll> prhs;
vector<ll> ob;

ll hs(ll l, ll r) {
	return (prhs[r] - (prhs[l-1] * ob[r - l + 1]) % mod + mod) % mod;
}

int main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	int n, m;
	cin >> n >> m;
	string t;
	cin >> t;
	int l = t.length();
	prhs.resize(l + 1);
	ob.resize(l, 1);
	for (int i = 0; i < l; ++i) {
		prhs[i + 1] = (prhs[i] * osn + (t[i] - 'a' + 1)) % mod;
	}
	for (int i = 1; i < l; ++i) {
		ob[i] = ob[i - 1] * osn % mod;
	}
	vector<string> sts(n);
	vector<ll> hst(n);
	for (int i = 0; i < n; ++i) {
		cin >> sts[i];
		for (auto c : sts[i]) {
			hst[i] = (hst[i] * osn + (c - 'a' + 1)) % mod;
		}
	}

	for (int i = 0; i < m; ++i) {
		int l, r;
		cin >> l >> r;
		int res = 0;
		for (int i = l; i <= r; ++i) {
			for (int j = 0; j < n; ++j) {
				if (sts[j].length() + i - 1 <= r) {
					if (hs(i, i + (sts[j].length())-1) == hst[j]) {
						++res;
					}
				}
			}
		}
		cout << res << ' ';
	}
	return 0;
}