#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

string sc[100000];
string t;
int n, m, q;

int zfunc(int j1, string t1){

    string nw = sc[j1] + '#' + t1;
    vector<int> z(nw.size(), 0);
    int maxr = 0;
    for(int i = 1; i < nw.size(); i ++){
        if(z[maxr] + maxr - 1 < i){
            int j = 0;
            while(i + j < nw.size() && nw[j] == nw[i + j])
                j ++;

            z[i] = j;
            maxr = i;
        }
        else{
            z[i] = z[i - maxr];
            while(z[i] + i - 1 < nw.size() && nw[z[i]] == nw[z[i] + i])
                z[i] ++;

            if(z[i] > z[maxr])
                maxr = i;
        }
    }

    int kol = 0;
    for(int i = 0; i < nw.size(); i ++){
        if(z[i] == sc[j1].size())
                kol ++;
    }

    return kol;

}

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);

    cin >> n >> m;
    cin >> t;

    q = int(t.size());
    for(int i = 0; i < n; i ++){
        cin >> sc[i];

    }
    vector<int> ans(m);
    for(int i = 0; i < m; i ++){
        int l, r;
        cin >> l >> r;

        string t1 = t.substr(l - 1, r - l + 1);

        int kol = 0;
        for(int j = 0; j < n; j ++){
            kol += zfunc(j, t1);

        }
        ans[i] = kol;
    }
    for(int i = 0; i < m; i ++)
        cout<< ans[i] << " ";

  return 0;
}
