#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const ll MOD = 1e9 + 7;
const ll P = 31;

void solve() {
    ll n, m;
    cin >> n >> m;
    string t;
    cin >> t;
    vector<string> arr(n);

    map<ll, ll> mc;
    for (auto &x : arr) {
        cin >> x;
        ll h = 0;
        for (auto y : x) {
            h *= P;
            h += (y - 'a' + 1);
            h %= MOD;
        }

        ++mc[h];
    }


    n = t.size();
    vector<vector<ll>> ans(n, vector<ll>(n));
    for (ll i = 0; i < n; ++i) {
        ll now = 0;
        for (ll j = i; j < n; ++j) {
            now = (now * P + (t[j] - 'a' + 1)) % MOD;
            ans[i][j] += mc[now];
        }
    }

    for (ll i = n - 1; i >= 0; --i) {
        for (ll k = 1; k < n; ++k) {
            ans[i][k] += ans[i][k - 1];
        }
//        for (ll k = i; k < n; ++k) {
//            ans[i][k] += ans[i][k + 1];
//        }
    }

    while (m--) {
        ll l, r;
        cin >> l >> r;
        --l;
        --r;

        ll ans1 = 0;
        for (ll i = l; i <= r; ++i) {
            ans1 += ans[i][r];
        }
        cout << ans1 << " ";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    solve();

    return 0;
}