#include <bits/stdc++.h>

//#define int long long
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned int ui;
typedef unsigned long long ull;

const ll INF1 = 1e9 + 7, INF2 = 1791791791, p = 179;
const int N = 750001, M = 1e5 + 1, Q = 5e5, R = (1 << 24) - 1;
const ld EPS = 1e-6;

pair<ll, ll> pf[N], pw[N];
vector<ll> pod[M];
vector<int> flex[N];
vector<pair<int, int>> req[N];
vector<ll> myhash[R + 1];

bool find(ll x) {
    return find(all(myhash[x & R]), x) != myhash[x & R].end();
}

int ans[Q], fen[N], k;

void add(int i) {
    for (; i <= k; i |= (i + 1)) fen[i]++;
}

int get(int i) {
    int res = 0;
    for (; i > -1; i = (i & (i + 1)) - 1) res += fen[i];
    return res;
}

pair<ll, ll> operator + (pair<ll, ll> a, pair<ll, ll> b)  {
    pair<ll, ll> res = {a.first + b.first, a.second + b.second};
    if (res.first >= INF1) res.first -= INF1;
    if (res.second >= INF2) res.second -= INF2;
    return res;
}

pair<ll, ll> operator - (pair<ll, ll> a, pair<ll, ll> b)  {
    pair<ll, ll> res = {a.first - b.first, a.second - b.second};
    if (res.first < 0) res.first += INF1;
    if (res.second < 0) res.second += INF2;
    return res;
}

pair<ll, ll> operator * (pair<ll, ll> a, int x) {
    return {a.first * pw[x].first % INF1, a.second * pw[x].second % INF2};
}

inline ll rec(pair<ll, ll> a) {
    return a.first * INF2 + a.second;
}

ll get(int l, int r) {
    return rec(pf[r] - pf[l] * (r - l));
}

signed main() {
    ios::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int n, m;
    string t;
    cin >> n >> m >> t;
    pw[0] = {1, 1};
    pw[1] = {p, p};
    k = t.size();
    for (int i = 2; i <= k; i++) pw[i] = pw[i - 1] * 1;
    pf[0] = {0, 0};
    for (int i = 0; i < k; i++)
        pf[i + 1] = pf[i] * 1 + (pair<ll, ll>) {t[i], t[i]};
    for (int i = 0; i < n; i++) {
        cin >> t;
        pair<ll, ll> now{};
        for (auto j : t) now = now * 1 + (pair<ll, ll>) {j, j};
        pod[t.size()].push_back(rec(now));
    }
    for (int len = 1; len <= k; len++) {
        if (pod[len].empty()) continue;
        for (auto j : pod[len]) myhash[j & R].push_back(j);
        for (int i = 0; i <= k - len; i++) {
            if (find(get(i, i + len))) flex[i].push_back(i + len);
        }
        for (auto j : pod[len]) myhash[j & R].clear();
    }
    for (int i = 0; i < m; i++) {
        ans[i] = 0;
        int l, r;
        cin >> l >> r;
        req[l - 1].emplace_back(r, i);
        req[r].emplace_back(r, i);
    }
    for (int i = 0; i <= k; i++) fen[i] = 0;
    for (int i = 0; i <= k; i++) {
        for (auto j : req[i]) {
            if (j.first > i) ans[j.second] -= get(j.first);
            else ans[j.second] += get(j.first);
        }
        for (auto j : flex[i]) add(j);
    }
    for (int i = 0; i < m; i++) cout << ans[i] << ' ';
}