#include <bits/stdc++.h>
//#include <bits/extc++.h>

#include <random>

#pragma GCC optimize("Ofast")

//#define int long long
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;

const int N = 1e6 + 7 + 2e5;

int suff_arr[N];
int lcp[N];
int ekv[N];
const int K = 21;

int sparse[N][K];
int fenw[N];

int n, m;

void add(int i) {
    for (; i < n; i += i & -i) {
        fenw[i]++;
    }
}

int get(int i) {
    int ans = 0;
    for (; i > 0; i -= i & -i) {
        ans += fenw[i];
    }
    return ans;
}

int ll[N];
int rr[N];
int lg[N];

int get_mn(int l, int r) {
    if (r == n) return 0;
    if (l == -1) return 0;
    int ln = lg[r - l];
    return min(sparse[l][ln], sparse[r - (1 << ln)][ln]);
}

const int N2 = 3e5 + 7;

vector<pair<int, int>> quer2[N2];

void solve() {
    lg[1] = 0;
    for (int i = 2; i < N; ++i) {
        lg[i] = lg[i / 2] + 1;
    }
    cin >> n >> m;
    string t;
    cin >> t;
    string s = t;
    unordered_map<string, int> inds;
    for (int i = 0; i < n; ++i) {
        string r;
        cin >> r;
        if (r.size() > t.size()) continue;
        s.push_back('#');
        inds[r] = s.size();
        s += r;
    }
    s.push_back('#');

    n = s.size();


    vector<pair<pair<int, int>, int>> ddr;
    for (int i = 0; i < n; ++i) {
        ddr.push_back({{s[i], 0}, i});
    }
    sort(ddr.begin(), ddr.end());
    for (int i = 1; i < n; ++i) {
        if (ddr[i].first == ddr[i - 1].first) {
            ekv[ddr[i].second] = ekv[ddr[i - 1].second];
        } else {
            ekv[ddr[i].second] = ekv[ddr[i - 1].second] + 1;
        }
    }

    for (int len = 1; len <= n; len *= 2) {
        ddr.clear();
        bool fl55 = false;
        for (int i = 0; i < n; ++i) {
            ddr.push_back({{ekv[i], ekv[(i + len) % n]}, i});
        }
        sort(ddr.begin(), ddr.end());
        for (int i = 1; i < n; ++i) {
            if (ddr[i].first == ddr[i - 1].first) {
                ekv[ddr[i].second] = ekv[ddr[i - 1].second];
                fl55 = true;
            } else {
                ekv[ddr[i].second] = ekv[ddr[i - 1].second] + 1;
            }
        }
        if (!fl55) break;
    }
    for (int i = 0; i < n; ++i) {
        suff_arr[i] = ddr[i].second;
    }

    vector<int> obr(n);
    for (int i = 0; i < n; ++i) {
        obr[suff_arr[i]] = i;
    }

    int HAVE = 0;
    for (int i = 0; i < n - 1; ++i) {
        int ind = obr[i];
        HAVE = max(HAVE - 1, 0);
        if (ind + 1 >= n) continue;
        while (HAVE + suff_arr[ind] < n and HAVE + suff_arr[ind + 1] < n and
               s[HAVE + suff_arr[ind]] == s[HAVE + suff_arr[ind + 1]]) {
            HAVE++;
        }
        lcp[ind] = HAVE;
        sparse[ind][0] = HAVE;
    }
    for (int i = 1; i < K; ++i) {
        for (int j = 0; j + (1 << i) <= n; ++j) {
            sparse[j][i] = min(sparse[j][i - 1], sparse[j + (1 << (i - 1))][i - 1]);
        }
    }

    ll[0] = -1;
    for (int i = 1; i < n; ++i) {
        if (suff_arr[i - 1] < t.size()) {
            ll[i] = i - 1;
        } else {
            ll[i] = ll[i - 1];
        }
    }
    rr[n - 1] = n;
    for (int i = n - 2; i >= 0; --i) {
        if (suff_arr[i + 1] < t.size()) {
            rr[i] = i + 1;
        } else {
            rr[i] = rr[i + 1];
        }
    }
    vector<vector<int>> quers(n + 1);
    int cnt33 = 0;
    int cnt44 = 0;
    for (auto &c: inds) {
        int ind = obr[c.second];
        int ind2 = rr[ind];
        while (ind2 < n and get_mn(ind, ind2) >= c.first.size()) {
            if (suff_arr[ind2] < t.size()) {
                quers[suff_arr[ind2] + c.first.size()].push_back(suff_arr[ind2] + 1);
                cnt44++;
            }
            ind2 = rr[ind2];
            cnt33++;
        }
        int ind3 = ll[ind];
        while (ind3 >= 0 and get_mn(ind3, ind) >= c.first.size()) {
            if (suff_arr[ind3] < t.size()) {
                quers[suff_arr[ind3] + c.first.size()].push_back(suff_arr[ind3] + 1);
                cnt44++;
            }
            ind3 = ll[ind3];
            cnt33++;
        }
    }
//    if (cnt33 > 1e7) exit(1);
    for (int j = 0; j < m; ++j) {
        int l, r;
        cin >> l >> r;
        quer2[r].push_back({l, j});
    }
    vector<int> ans(m);
    int cnt = 0;
    for (int i = 1; i <= t.size(); ++i) {
        for (auto c: quers[i]) {
            cnt++;
            add(c);
        }
        for (auto c: quer2[i]) {
            ans[c.second] = cnt - get(c.first - 1);
        }
    }
    for (auto c: ans) {
        cout << c << " ";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout << fixed;
    cout.precision(12);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}