#include<bits/stdc++.h>
#define endl '\n'
using namespace std;
const int MAXN=1e6+100;
struct letter
{
    int a[30];
    int fail;
    int go;
    int t;
    int len;
};
letter Trie[MAXN];
int pref[MAXN];
int br=1;
vector<int> v[MAXN];
int block[10000];
void insertT(string s, int ind)
{
    int curr=0;
    for(int i=0; i<s.size(); i++)
    {
        if(Trie[curr].a[s[i]-'a'+1]==0)
        {
            Trie[curr].a[s[i]-'a'+1]=br++;
        }
        curr=Trie[curr].a[s[i]-'a'+1];
    }
    Trie[curr].t=ind;
    Trie[curr].len=s.size();
}
void build_links(int curr)
{
    queue<int> q;
    for(int i=1; i<=26; i++)
    {
        if(Trie[curr].a[i]!=0)
        {
            q.push(Trie[curr].a[i]);
            Trie[Trie[curr].a[i]].fail=0;
            Trie[Trie[curr].a[i]].go=0;
        }

    }
    while(!q.empty())
    {
        curr=q.front();
        //cout<<curr<<endl;
        q.pop();
        for(int i=1; i<=26; i++)
        {
            if(Trie[curr].a[i]!=0)
            {
                q.push(Trie[curr].a[i]);

                int curr2=Trie[curr].fail;
                while(curr2!=0&&Trie[curr2].a[i]==0)
                {
                    curr2=Trie[curr2].fail;
                }
                if(Trie[curr2].a[i]!=0&&curr!=curr2)Trie[Trie[curr].a[i]].fail=Trie[curr2].a[i];

                if(Trie[Trie[curr2].a[i]].t!=0)Trie[Trie[curr].a[i]].go=Trie[Trie[curr].a[i]].fail;
                else Trie[Trie[curr].a[i]].go=Trie[Trie[Trie[curr].a[i]].fail].go;

                //cout<<curr<<" "<<Trie[Trie[curr].a[i]].fail<<" "<<Trie[Trie[curr].a[i]].go<<endl;
            }
        }
    }
}
int Aho_Korasik(string t)
{
    int curr=0;
    int br=0;
    for(int i=0; i<t.size(); i++)
    {

        while(curr!=0&&Trie[curr].a[t[i]-'a'+1]==0)
        {
            curr=Trie[curr].fail;
        }
        if(Trie[curr].a[t[i]-'a'+1]==0)continue;


        curr=Trie[curr].a[t[i]-'a'+1];
        //cout<<i<<" "<<curr<<endl;
        if(Trie[curr].t!=0)
        {
            /*pref[i+1]--;*/
            v[i-Trie[curr].len+1].push_back(i);
            pref[i-Trie[curr].len+1]++;
            br++;
        }
        int curr2=Trie[curr].go;
        while(curr2!=0)
        {
            /* pref[i+1]--;*/
            v[i-Trie[curr2].len+1].push_back(i);
            pref[i-Trie[curr2].len+1]++;
            br++;
            curr2=Trie[curr2].go;
        }

    }
    return br;
}
int main()
{
    ios::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m;
    cin>>n>>m;
    string t;
    cin>>t;
    for(int i=1; i<=n; i++)
    {
        string s;
        cin>>s;
        insertT(s,i);
    }
    build_links(0);
    Aho_Korasik(t);
    /* for(int i=0; i<=t.size(); i++)
     {
         cout<<pref[i]<<" ";
     }
     for(int i=1;i<n;i++)
     {
         pref[i]+=pref[i-1];
     }*/
    int p=sqrt(t.size());
    /* for(int i=0;i<t.size();i++)
     {
         int k=i/p;
         for(int j=0;j<v[i].size();j++)
         {
             if(v[i][j]<((k+1)*p))block[k]++;
             else break;
         }
     }*/
    for(int i=1; i<t.size()/p+1; i++)
    {
        block[i]+=block[i-1];
    }
    for(int i=0; i<m; i++)
    {
        int l,r;
        cin>>l>>r;
        l--;
        r--;
        int otg=0;
        for(int i=l; i<=r; i++)
        {
            for(int j=0; j<v[i].size(); j++)
            {
                if(v[i][j]<=r)otg++;
                else break;
            }
        }
        /*int k=l/p;
        if(l%p!=0)k++;
        int t=r/p-1;
        if(r%p==0)t++;
        if(k==0)otg+=block[t];
        else otg+=block[t]-block[k-1];*/

        cout<<otg<<" ";
    }
    cout<<endl;
    return 0;
}
