#include <iostream>
#include <algorithm>
#include <cmath>
#include <string>
#include <vector>
#include <iomanip>
#include <map>
#include <cassert>

using namespace std;

typedef long long ll;
typedef long double ld;

vector<vector<pair<ll, ll>>> G;

void solve() {
	ll n, m, u, v, w;
	cin >> n >> m;
	G.assign(n, {});
	for (ll i = 0; i < m; i++) {
		cin >> u >> v >> w; u--; v--;
		G[u].push_back({ v, w });
	}
	ll a, b;
	cin >> a >> b; a--; b--;
	ll cur = a, Xor = 0;
	do {
		Xor ^= G[cur][0].second;
		cur = G[cur][0].first;
	} while (cur != b);
	cur = b;
	ll Xor2 = 0;
	while (cur != a) {
		Xor2 ^= G[cur][0].second;
		cur = G[cur][0].first;
	}
	if (Xor == Xor2 && Xor == 0) {
		cout << "0\n";
	}
	else {
		cout << "-1\n";
	}
}

int main() {
	int t;
	cin >> t;
	while (t--) {
		solve();
	}
}