#include <bits/stdc++.h>

#ifdef LOCAL
#define debug(x) cerr << #x << ": " << x << endl
#else
#define debug(x)
#endif

using namespace std;

using pi = pair<int, int>;
using vi = vector<int>;
using vpi = vector<pi>;

const int maxN = 2e5;

bool used[maxN], g1;
int test = 1, n, m, u, v, w, a, b, dp[maxN], cnt[maxN], temp;
vpi gr[maxN];

void dfs(int u) {
    used[u] = true;
    dp[u] = 0;
    cnt[u] = 0;
    if (u == b) {
        cnt[u] = 1;
        return;
    }
    for (auto &[v, w] : gr[u]) {
        if (!used[v])
            dfs(v);
        dp[u] ^= dp[v];
        cnt[u] ^= cnt[v];
        if (cnt[v] & 1)
            dp[u] ^= w;
    }
}

void solve() {
    cin >> n >> m;
    g1 = n == m;
    for (int i = 0; i < n; i++)
        gr[i].clear();
    while (m--) {
        cin >> u >> v >> w;
        u--, v--;
        gr[u].emplace_back(v, w);
        g1 &= v == (u + 1) % n;
    }
    cin >> a >> b;
    a--, b--;
    if (g1) {
        int cur = a;
        temp = 0;
        do {
            if (gr[cur].size() > 1 || gr[cur].empty()) {
                temp = 0;
                break;
            }
            temp ^= gr[cur][0].second;
            cur = gr[cur][0].first;
        } while (cur != a);
        if (temp != 0) {
            cout << "-1\n";
            return;
        }
        fill(used, used + n, false);
        dfs(a);
        cout << dp[a] << "\n";
    } else {
        if (a == b) {
            cout << "0\n";
            return;
        }
        fill(used, used + n, false);
        dfs(a);
        cout << dp[a] << "\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> test;
    while (test--)
        solve();
    return 0;
}
