#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;

#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")

typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

const ll mod = 1000000007;

void solve(){
    int n, m;
    cin >> n >> m;
    ll ans = 0;
    vector<ll> a(2 * n);
    for(int i = 0; i < n; i++){
        ll u, v, w;
        cin >> u >> v >> w;
        ans ^= w;
        a[i] = w;
    }
    int aa, bb;
    cin >> aa >> bb;
    aa--; bb--;
    if(aa == bb){
        cout << (ans ? -1 : 0) << '\n';
        return;
    }
    ll calc = 0;
    while(aa != bb){
        calc ^= a[aa];
        aa++;
        if(aa == n) aa = 0;
    }
    cout << (ans == 0 ? calc : -1) << '\n';
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    cin >> tt;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "________________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec\n";
    #endif // LOCAL
    return 0;
}


