#ifdef LOCAL
    #define _GLIBCXX_DEBUG
#endif // LOCAL

#include <bits/stdc++.h>

using namespace std;


typedef long long ll;
typedef long double ld;

#define ff first
#define ss second
#define pii pair<int, int>
#define pll pair<long long, long long>
#define all(v) v.begin(),v.end()

const ll mod = 1000000007;

vector<pll> a[200005];
vector<int> b[200005];
int cnt[200005] = {0};
bool was[200005] = {0};

void solve(){
    int n, m;
    cin >> n >> m;
    ll ans2 = 0;
    bool is = (n == m ? 1 : 0);
    vector<ll> aaa(2 * m);
    for(int i = 0; i < n; i++){
        a[i].clear();
        was[i] = 0;
        cnt[i] = 0;
    }
    for(int i = 0; i < m; i++){
        ll u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        a[u].push_back({v, w});
        b[v].push_back(u);
        if((i < n - 1 && (u != i || v != i + 1)) || (i == n - 1 && (u != i || v != 0))) is = 0;
        ans2 ^= w;
        aaa[i] = w;
    }
    if(is){
        int aa, bb;
        cin >> aa >> bb;
        aa--; bb--;
        if(aa == bb){
            cout << (ans2 ? -1 : 0) << '\n';
            return;
        }
        ll calc = 0;
        while(aa != bb){
            calc ^= aaa[aa];
            aa++;
            if(aa == n) aa = 0;
        }
        cout << (((ans2 ^ calc) == 0 && (ans2 ^ ans2 ^ calc) == 0) ? calc : -1) << '\n';
        return;
    }
    int s, t;
    cin >> s >> t;
    s--; t--;
    if(s >= t){
        cout << 0 << '\n';
        return;
    }
    cnt[s] = 1;
    ll ans = 0;
    was[t] = 1;
    for(int i = t; i >= s; i--){
        for(int u : b[i]) was[u] = 1;
    }
    for(int i = s; i < t; i++){
        //cout << i << ' ' << cnt[i] << '\n';
        for(pll u : a[i]){
            cnt[u.ff] = (cnt[u.ff] + cnt[i]) % 2;
            if(cnt[i] && was[u.ff]) ans ^= u.ss;
        }
    }
    cout << ans << '\n';
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
    #endif // LOCAL
    int tt;
    cin >> tt;
    while(tt--){
        solve();
        #ifdef LOCAL
            cout << "________________________________________\n";
        #endif // LOCAL
    }
    #ifdef LOCAL
        cout << "finished in " << clock() * 1.0 / CLOCKS_PER_SEC << " sec\n";
    #endif // LOCAL
    return 0;
}


