#include <bits/stdc++.h>


typedef long long ll;
typedef unsigned long long ull;
using namespace std;

struct Node {
    int val, cnt;
};


vector<vector<pair<int, int>>> g;
vector<bool> used;
vector<int> topsort;
vector<Node> dp;


int solve() {
    int n, m;
    cin >> n >> m;
    used.assign(n, false);
    g.clear();
    g.resize(n);
    dp.assign(n, {0, 0});
    bool testgroup1 = (m == n);
    int tg1_val = 0;
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w;
        x--, y--;
        g[x].emplace_back(y, w);
        tg1_val ^= w;
        if (x != i || y != i + 1) {
            if (i < m - 1) {
                testgroup1 = false;
            }
        }
        if (i == m - 1 && (x != n - 1 || y != 0)) {
            testgroup1 = false;
        }
    }
    int a, b;
    cin >> a >> b;
    a--, b--;
    if (testgroup1) {
        int val = 0;
        if (tg1_val == 0) {
            if (a == b) return 0;
            vector<vector<pair<int, int>>> g2(n, vector<pair<int, int>>());
            for (int i = 0; i < n - 1; ++i) {
                g2[i] = g[(i + a) % n];
            }
            dp[a] = {0, 1};
            for (int v = a; v < b; ++v) {
                for (auto [to, w] : g[v]) {
                    if (dp[v].cnt % 2 == 0) {
                        dp[to].cnt += dp[v].cnt;
                        dp[to].val ^= dp[v].val;
                    } else {
                        dp[to].cnt += dp[v].cnt;
                        dp[to].val ^= (dp[v].val ^ w);
                    }
                }
            }
            return dp[b].val;
        }
        return -1;
    }
    if (b < a) {
        return 0;
    }
    dp[a] = {0, 1};
    for (int v = a; v < b; ++v) {
        for (auto [to, w] : g[v]) {
            if (dp[v].cnt % 2 == 0) {
                dp[to].cnt += dp[v].cnt;
                dp[to].val ^= dp[v].val;
            } else {
                dp[to].cnt += dp[v].cnt;
                dp[to].val ^= (dp[v].val ^ w);
            }
        }
    }
//    for (auto [x, y] : dp) {
//        cout << x << " " << y << "\n";
//    }
    return dp[b].val;



    return 0;
}



int main() {
    ios::sync_with_stdio(true);
    cin.tie(0);
    cout.tie(0);
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    int t;
    cin >> t;
    while (t--) {
        cout << solve() << "\n";
    }



    return 0;
}