#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <math.h>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <cassert>
#include <assert.h>
#include <chrono>
#include <random>
#include <iomanip>
#include <numeric>
#include <queue>
#include <deque>

using namespace std;

typedef long long ll;
typedef long double ld;

int dfs(int v, int end, vector<vector<pair<int, int>>>& gr) {
	if (v == end) return 0;
	for (auto& it : gr[v]) {
		return it.second ^ dfs(it.first, end, gr);
	}
}

void solve() {
	int n, m; cin >> n >> m;
	ll ans = 0;
	vector<vector<pair<int, int>>> gr(n);
	int ways = 0;
	for (int x = 0; x < m; x++) {
		int st, fin, w; cin >> st >> fin >> w;
		ways ^= w;
		gr[st - 1].push_back({ fin - 1, w });
		//gr[fin - 1].push_back({ st - 1, w });
	}
	int a, b; cin >> a >> b; a--; b--;
	int one = dfs(a, b, gr);
	int two = dfs(b, a, gr);
	if ((one ^ ways) != 0 || (two ^ ways) != 0 || one != 0 || two != 0) cout << -1;
	else cout << 0;
	cout << endl;
}

signed main() {
	int t; cin >> t;
	for (int x = 0; x < t; x++) {
		solve();
	}
}