#define pii pair < int, int >
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;

const int N = (int)2e5 + 5;
const int MOD = (int)1e9 + 7;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

vector < pii > g[N];

int dfs(int a, int b, int now) {
    if (a == b) {
        return now;
    }
    for (auto to: g[a]) {
        return dfs(to.first, b, (now ^ to.second));
    }
}

vector < int > order;

pii dp[N];

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int q;
    cin >> q;
    while (q--) {
        int n, m;
        cin >> n >> m;
        int xr = 0;
        for (int i = 1; i <= n; i++) {
            g[i].clear(); dp[i] = { 0, 0 };
        }
        bool ok = (n == m);
        for (int i = 1; i <= m; i++) {
            int u, v, cost;
            cin >> u >> v >> cost;
            g[u].push_back({ v, cost });
            xr ^= cost;
            if (i < m) {
                if (u != i || v != i + 1) ok = false;
            }
            else {
                if (u != n || v != 1) ok = false;
            }
        }
        int a, b;
        cin >> a >> b;

        if (ok) {
            int val = dfs(a, b, 0);
            if (val == 0 && xr == 0) {
                cout << 0 << '\n';
                continue;
            }
            cout << -1 << '\n';
        }
        else {
            dp[a].first = 1;
            for (int v = 1; v <= n; v++) {
                for (auto to: g[v]) {
                    dp[to.first].first += dp[v].first;
                    dp[to.first].first %= 2;
                    int xr = dp[v].second;
                    if (dp[v].first & 1) {
                        xr ^= to.second;
                    }
                    dp[to.first].second ^= xr;
                }
            }
            cout << dp[b].second << '\n';
        }
    }
    return 0;
}
