#include<iostream>
#include<vector>
#include<set>
#include<map>
#include<algorithm>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int t;
    cin >> t;

    while (t--) {
        int n, m;
        cin >> n >> m;

        if (n == m) {
            vector<int> weights(n);
            while (m--) {
                int u, v, w;
                cin >> u >> v >> w;
                weights[u - 1] = w;
            }

            int a, b;
            cin >> a >> b;
            a--; b--;

            int ans = 0;
            while (a != b) {
                ans ^= weights[a];
                a = (a + 1) % n;
            }

            int res = 0;
            for (int i = 0; i < n; i++)
                res ^= weights[i];

            if (res != 0) cout << -1 << '\n';
            else cout << ans << '\n';

            continue;
        }
    }

    return 0;
}
