#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#pragma GCC optimize("-O3")

#define fi first
#define se second

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 5;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

mt19937 rng(time(0));

vector<pair<int, ll>> g[N];
bool used[N], del[N];
vector<int> e;
int timer, tin[N];
int a, b;
ll X[N];
gp_hash_table<int, ll> mp[N];
int cnt[N];

void dfs(int v, int p, ll x) {
    if(del[v])return;
    if(used[v]) {
        if(tin[v] <= tin[b] && tin[b] <= tin[p]){
            if(X[b] ^ X[v] != 0 || (x ^ X[b]) != 0){
                bool flag = 0;
                while(!flag) {
                    if(e.back() == v)flag = 1;
                    del[e.back()] = 1;
                    e.pop_back();
                }
                return;
            }
            return;
        }
        bool flag = 0;
        while(!flag) {
            if(e.back() == v)flag = 1;
            del[e.back()] = 1;
            e.pop_back();
        }
        return;
    }
    if(tin[v])return;
    X[v] = x;
    tin[v] = ++timer;
    e.pb(v);
    used[v] = 1;
    for(auto to : g[v]) {
        if(!del[to.fi]) {
            dfs(to.fi, v, x ^ to.se);
        }
    }
    if(!del[v]){
        e.pop_back();
    }
    used[v] = 0;
}

vector<pair<int, ll>> t[N];

void dfs2(int v){
    if(used[v])return;
    used[v] = 1;
    for(auto to : g[v]){
        if(del[to.fi])continue;
        t[v].pb(to);
        cnt[to.fi]++;
        dfs2(to.fi);
    }
}

ll dp[N];
bool flag = 0;

void dfs3(int v){
    if(del[v])return;
    if(v == b)flag = 1;
    //cout << v << " - " << dp[v] << "\n";
    for(auto to : t[v]){
        dp[to.fi] ^= dp[v] ^ to.se;
        cnt[to.fi]--;
        if(cnt[to.fi] == 0){
            dfs3(to.fi);
        }
    }
}

void solve() {
    int n, m;
    cin >> n >> m;

    bool h = 0;

    for(int i = 0; i < m; i++){
        ll u, v, w;
        cin >> u >> v >> w;
        h |= (w != 0);
        g[u].pb({v, w});
        mp[u][v] = w;
    }
    cin >> a >> b;

    dfs(a, 0, 0);
    for(int i = 1; i <= n; i++){
        used[i] = 0;
    }
    dfs2(a);
    flag = 0;
    dfs3(a);

    if(!flag)cout << "-1\n";
    else cout << dp[b] << "\n";

    for(int i = 1; i <= n; i++){
        del[i] = used[i] = tin[i] = cnt[i] = dp[i] = 0;
        g[i].clear();
    }
    timer = 0;
    e.clear();
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    ios_base::sync_with_stdio(0);

    int test;
    cin >> test;

    while(test--) {
        solve();
    }

    return 0;
}
