#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 5;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

mt19937 rng(time(0));

int a, b;
vector<pair<int, ll>> g[N];
int cnt[N];
ll dp[N];

void solve() {
    int n, m;
    cin >> n >> m;

    bool h = 0;

    for(int i = 0; i < m; i++){
        int u, v, w;
        cin >> u >> v >> w;
        cnt[v]++;
        h |= (v <= u);
        g[u].pb({v, w});
        //mp[u][v] = w;
    }

    cin >> a >> b;

    if(!h){
        queue<int> q;
        q.push(a);
        while(sz(q)){
            auto it = q.front();
            for(auto to : g[it]){
                dp[to.fi] += dp[it] + (to.se == 1);
                cnt[to.fi]--;
                if(cnt[to.fi] == 0)q.push(to.fi);
            }
            q.pop();
        }
        cout << dp[b] % 2 << "\n";
        for(int i = 1; i <= n; i++){
            dp[i] = cnt[i] = 0;
            g[i].clear();
        }
        return;
    }

    ll X1 = 0;
    int v = a;

    while(v != b){
        X1 ^= g[v][0].se;
        v = g[v][0].fi;
    }

    ll X2 = g[b][0].se;
    v = g[b][0].fi;

    while(v != a){
        X2 ^= g[v][0].se;
        v = g[v][0].fi;
    }

    if(X1 == 0 && (X1 ^ X2 ^ X1) == 0)cout << "0\n";
    else cout << "-1\n";

    for(int i = 1; i <= n; i++){
        g[i].clear();
        cnt[i] = 0;
        dp[i] = 0;
    }
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    int test;
    cin >> test;

    while(test--) {
        solve();
    }

    return 0;
}
