#include <bits/stdc++.h>

using namespace std;

void top_sort(int v, vector <int>& ord, vector <int>& used, vector <vector <pair <int, int>>>& gg, int lvl) {
    used[v] = lvl;
    for (auto i : gg[v]) {
        if (used[i.first] != lvl) top_sort(i.first, ord, used, gg, lvl);
    }
    ord.push_back(v);
}

vector <vector <pair <int, int>>> g, gg;
vector <vector <int>> rg;
vector <int> used, num, bad;

void dfs1(int v, int lvl) {
    num[v] = lvl;
    for (int i : rg[v]) {
        if (num[i] == -1) dfs1(i, lvl);
    }
}

inline void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    rg.assign(n, {});
    for (int i = 0; i < m; ++i) {
        int x, y, w;
        cin >> x >> y >> w; --x; --y;
        g[x].emplace_back(y, w);
        rg[y].emplace_back(x);
    }
    vector <int> ord;
    used.assign(n, 0);
    for (int i = 0; i < n; ++i) {
        if (!used[i]) top_sort(i, ord, used, g, 1);
    }
    reverse(ord.begin(), ord.end());
    num.assign(n, -1);
    int cur = 0;
    for (int i : ord) {
        if (num[i] == -1) {
            dfs1(i, cur++);
        }
    }
    bad.assign(cur, 0);
    gg.assign(cur, {});
    for (int i = 0; i < n; ++i) {
        for (auto j : g[i]) {
            if (num[i] == num[j.first]) {
                if (j.second > 0) bad[num[i]] = 1;
            } else {
                gg[num[i]].emplace_back(num[j.first], j.second);
            }
        }
    }
    int a, b;
    cin >> a >> b;
    a = num[a - 1];
    b = num[b - 1];
    ord = {};
    for (int i = 0; i < cur; ++i) {
        if (used[i] == 1) {
            top_sort(i, ord, used, gg, 2);
        }
    }
    vector <int> can_a(cur), can_b(cur), ca(cur), cb(cur), flex_a(cur), flex_b(cur), ok_a(cur, 1), ok_b(cur, 1), val_a(cur, -1), val_b(cur, -1);
    for (int i : ord) {
        if (i == b) {
            can_b[i] = cb[i] = 1;
            if (bad[i]) flex_b[i] = 1;
            ok_b[i] = 1;
            val_b[i] = 0;
        }
        for (auto j : gg[i]) {
            flex_b[i] |= flex_b[j.first];
            can_b[i] |= can_b[j.first];
            cb[i] ^= cb[j.first];
            if (bad[i]) flex_b[i] |= can_b[j.first];
            if (val_b[j.first] == -1) continue;
            if (!ok_b[j.first]) {
                ok_b[i] = 0;
            } else {
                if (val_b[i] != -1 && (val_b[j.first] ^ j.second) != val_b[i]) ok_b[i] = 0;
                val_b[i] = (val_b[j.first] ^ j.second);
            }
        }
    }
    reverse(ord.begin(), ord.end());
    for (int i : ord) {
        if (i == a) {
            can_a[i] = ca[i] = 1;
            if (bad[i]) flex_a[i] = 1;
            val_a[i] = 1;
        }
        for (auto j : gg[i]) {
            flex_a[j.first] |= flex_a[i];
            can_a[j.first] |= can_a[i];
            ca[j.first] ^= ca[i];
            if (bad[j.first] == 1) flex_a[j.first] |= can_a[i];
            if (val_a[i] == -1) continue;
            if (!ok_a[i]) {
                ok_a[j.first] = 0;
            } else {
                if (val_a[j.first] != -1 && val_a[j.first] != (val_a[i] ^ j.second)) ok_a[j.first] = 0;
                val_a[j.first] = (val_a[i] ^ j.second);
            }
        }
    }
    for (int i = 0; i < cur; ++i) {
        if (bad[i] && can_a[i] && can_b[i]) {
            cout << "-1\n";
            return;
        }
    }
    for (int i = 0; i < cur; ++i) {
        if (!can_a[i] || !can_b[i]) continue;
        if (!flex_a[i] && !flex_b[i]) continue;
        if (!ok_a[i] || !ok_b[i] || val_a[i] != val_b[i]) {
            cout << "-1\n";
            return;
        }
    }
    int ans = 0;
    for (int i = 0; i < cur; ++i) {
        if (!can_a[i]) continue;
        for (auto j : gg[i]) {
            if (!can_b[j.first]) continue;
            if (ca[i] && cb[j.first]) ans ^= j.second;
        }
    }
    cout << ans << "\n";
}

signed main() {
    if (0) {
        ios_base::sync_with_stdio(false);
        cin.tie(nullptr);
        cout.tie(nullptr);
    }
    if (1) {
        int t;
        cin >> t;
        while (t--) {
            solve();
        }
    }
    return 0;
}

/*
 5
 1 1
 1 1 0
 1 1

 3 5
 1 2 0
 1 2 1
 1 2 3
 2 3 5
 2 3 2
 1 3

 2 2
 1 2 1
 2 1 2
 1 2


 */