#pragma GCC optimize("O3")
#include <iostream>
#include <vector>
#include <algorithm>
#include <iomanip>
#include <set>

using namespace std;

struct el{
    long long b, e, w;
    el () {}
    el(long long b, long long e, long long w) {
        this->b = b;
        this->e = e;
        this->w = w;
    }
};

void sol() {
    long long n, m;
    cin >> n >> m;
    vector<el> v(m);
    vector<vector<set<long long>>> dist(2, vector<set<long long>>(n));
    for (int i = 0; i < m; i++) {
        long long b, e, w;
        cin >> b >> e >> w;
        b--;
        e--;
        v[i] = el(b, e, w);
    }
    long long a, f;
    cin >> a >> f;
    a--;
    f--;
    dist[0][a].insert(0);
    long long id = 0;
    long long res = 0;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            auto [b, e, w] = v[j];
            if (dist[id][b].size() != 0) {
                for (auto x : dist[id][b]) {
                    dist[(id + 1) % 2][e].insert(x ^ w);
                }
            }

        }
        for (auto x : dist[id][f]) {
            res = (res ^ x);
        }
        for (int j = 0; j < n; j++) {
            dist[id][j].clear();
        }

        id = (id + 1) % 2;
    }
    long long res1 = res;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < m; j++) {
            auto [b, e, w] = v[j];
            if (dist[id][b].size() != 0) {
                for (auto x : dist[id][b]) {
                    dist[(id + 1) % 2][e].insert(x ^ w);
                }
            }

        }
        for (auto x : dist[id][f]) {
            res = (res ^ x);
            if (res != res1) {
                cout <<"-1" << endl;
                return;
            }
        }
        for (int j = 0; j < n; j++) {
            dist[id][j].clear();
        }

        id = (id + 1) % 2;
    }
    if (res != res1) {
        cout << "-1" << endl;
        return;
    } else {
        cout << res << endl;
    }

}

int main()
{
    long long t;
    cin >> t;
    for (int i = 0; i < t; i++) {
        sol();
    }
    return 0;
}

