//#include <bits/stdc++.h>
#include <iostream>
#include <iomanip>
#include <random>
#include <chrono>
#include <set>
#include <map>
#include <vector>
#include <algorithm>

#define all(a) a.begin(), a.end()
#define forall(iiii, aaaa) for(auto& iiii: aaaa)
#define print(aaaa) forall(aaa, aaaa) cout << aaa << ' '; cout << '\n'

typedef long long ll;
typedef long double ld;

using namespace std;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

ll mod = 1e9+7;

ll bin_pow(ll n, ll p) {
    if (p == 0) return 1;
    if (p & 1) return n * bin_pow(n, p - 1) % mod;
    return bin_pow(n * n % mod, p / 2);
}

ll gcd(ll a, ll b) {
    while (b %= a) swap(a, b);
    return a;
}

void solve () {
    ll n, m;
    cin >> n >> m;
    vector < ll > a(n);
    vector < vector < ll >> edges(m, {0, 0, 0});
    forall(i, edges) {
        cin >> i[0] >> i[1] >> i[2];
        i[0]--;
        i[1]--;
    }
    bool check = true;
    for (ll i = 0; i < m; i++) {
        if (edges[i][0] != i || edges[i][1] != (i + 1) % n) check =false;
    }
    if (check && n == m) {
        for (ll i = 0; i < n; i++) {
            a[i] = edges[i][2];
        }
        ll x, y;
        cin >> x >> y;
        x--; y--;
        ll xx = 0;
        forall(i, a) xx ^= i;
        if (xx) {
            cout << -1 << '\n';
            return;
        }
        ll ans = 0;
        while (x != y) {
            ans ^= a[x];
            x = (x + 1) % n;
        }
        if (ans != 0) ans = -1;
        cout << ans << '\n';
        return;
    }
    ll x, y;
    cin >> x >> y;
    x--; y--;
    vector < vector < pair < ll, ll >>> g(n);
    forall(i, edges) {
        g[i[0]].emplace_back(i[1], i[2]);
    }
    vector < ll > ans(n, 0);
    vector < ll > cnt(n, 0);
    cnt[x] = 1;
    for (ll i = x; i <= y; i++) {
        forall(j, g[i]) {
            cnt[j.first] += cnt[i];
            ans[j.first] ^= ans[i];
            if (cnt[i] & 1) ans[j.first] ^= j.second;
        }
    }
    cout << ans[y] << '\n';
}

int main() {
    cin.tie(0);
    cout.tie(0);
    ios_base::sync_with_stdio(false);
//    cout << fixed << setprecision(12);
    ll T = 1;
    cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}