#include "bits/stdc++.h"
using namespace std;

// cd /mnt/commons/
// g++ -DHOME -Wall -Wextra -DGLIBCXX_DEBUG 1.cpp && ./a.out 

#define int long long
#define ll long long


#define all(a) a.begin(), a.end()
#define vc vector
#define ld long double
#define forn(i , n) for(int i = 0; i < (int)n; i++)
#define fri(st , en , step) for(int i = st; i < (int)en ; i+=step)
#define frj(st , en , step) for(int j = st; j < (int)en ; j+=step)
#define sz(a) ((int)a.size())
#define pb push_back
#define mp make_pair


template<typename T>
ostream& operator<<(ostream& a, vc<T> b){
	forn(i , sz(b) - 1) a << b[i] << " ";
	if(sz(b)) a << b.back(); 
	return a;
}






#ifdef HOME
	#define o(a) << "[" << #a << ": " << a << "] "
#else
	#define o(a) ;
#endif



class debug{
public:
	debug(){}
	~debug(){
		#ifdef HOME
			cerr << endl;
		#endif
	}
	template<typename T>
	debug& operator<<(T a){
		#ifdef HOME
			cerr << a;
		#endif
		return *this;
	}
};

mt19937 rnd(1211);

template<typename T>
inline bool cmin(T &a, T b){
	if(a > b){
		a = b;
		return 1;
	}
	return 0;
}

template<typename T>
inline bool cmax(T &a, T b){
	if(a < b){
		a = b;
		return 1;
	}
	return 0;
}

const int MOD = 1e9 + 7;
const ld e = 1e-9;
const int inf = 1e18;
const int maxn = 2e5 + 10;



void dfs(int a , vc<int> &vis , vc<int> &el , vc<vc<pair<int ,int>>> &g){
	if(vis[a]) return;
	vis[a] = 1;
	for(auto x : g[a]) dfs(x.first, vis , el , g);
	el.pb(a);
}

inline void run(){
	int n , m;
	cin >> n >> m;
	vc<vc<pair<int , int>>> g(n) , gob(n);
	
	
	forn(i , m){
		int a , b , w;
		cin >> a >> b >> w;
		a--;
		b--;
		g[a].pb({b, w});
		gob[b].pb({a, w});	
	
	}
	int a , b;
	cin >> a >> b;
	a--;
	b--;
	vc<int> vis(n) , el;
	dfs(a , vis , el , g);
	reverse(all(el));
	vc<int> ans(n);
	forn(i , sz(el)){
		for(auto x : g[el[i]]) ans[x.first] ^= (ans[el[i]] ^ x.second);	
	}
	cout << ans[b] << "\n";


}


signed main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int tt = 1;
	cin >> tt;
	while(tt--){
		run();
	}
	return 0;
}