#define _CRT_SECURE_NO_WARNINGS

#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<unordered_map>
#include<random>
#include<stack>
#include<deque>
#include<iomanip>
#include <cstring>

using namespace std;

//#pragma optimize("O3")
//#pragma optimize("avx2")
//#pragma optimize("unrool-loops")

#define int long long

random_device rd;
mt19937 gen(rd());

vector<pair<int, int>> gr[200005];
vector<pair<int, int>> ingr[200005];

int good1[200004];
int good2[200004];
int used[200004];
int dp[200005];

void gdfs1(int v) {
	if (used[v])
		return;
	used[v] = true;
	for (auto u : gr[v]) {
		gdfs1(u.first);
		good1[v] += good1[u.first];
	}
}

void gdfs2(int v) {
	if (used[v])
		return;
	used[v] = true;
	for (auto u : ingr[v]) {
		gdfs2(u.first);
		good2[v] += good2[u.first];
	}
}

int ans = 0;

void gdfs3(int v) {
	used[v] = true;
	for (auto u : gr[v]) {
		ans ^= (u.second * (good2[v] * good1[u.first] % 2));
		if (!used[u.first])
			gdfs3(u.first);
	}
}

void solve() {
	int n, m;
	cin >> n >> m;
	for (int i = 0; i < n; i++) {
		gr[i].clear();
		ingr[i].clear();
		good1[i] = 0;
		good2[i] = 0;
	}

	for (int i = 0; i < m; i++) {
		int u, v, w;
		cin >> u >> v >> w;
		u--; v--;
		gr[u].push_back({ v, w });
		ingr[v].push_back({ u, w });
	}
	int a, b;
	cin >> a >> b;
	a--; b--;
	good1[b] = 1;
	memset(used, 0, sizeof used);
	used[b] = true;
	gdfs1(a);


	good2[a] = 1;
	memset(used, 0, sizeof used);
	used[a] = true;
	gdfs2(b);

	memset(used, 0, sizeof used);
	used[b] = true;
	gdfs3(a);
	cout << ans << '\n';
	return;
}

signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	//freopen("Text.txt", "r", stdin);
	//freopen("", "w", stdout)

	int t = 1;
	cin >> t;
	for (int i = 0; i < t; i++) {
		solve();
	}
	return 0;
}