#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

const int N = 200200;

int t[2 * N], dp[N];

void upd(int i, int v) {
    for (t[i += N] = v; i > 1; i >>= 1)
        t[i >> 1] = max(t[i], t[i ^ 1]);
}

int get(int l, int r) {
    int res = 0;
    for (l += N, r += N; l < r; l >>= 1, r >>= 1) {
        if (l & 1) res = max(res, t[l++]);
        if (r & 1) res = max(res, t[--r]);
    }
    return res;
}

void solve() {
    int n;
    cin >> n;
    int res = 0;
    vector<tuple<int, int, int>> qq;
    vector<vector<int>> b(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;
        vector<int> a(k);
        for (int &x: a)
            cin >> x;
        int cur = 0;
        for (int j = k - 1; ~j; j--) {
            while (!b[i].empty() and b[i].back() <= a[j]) b[i].pop_back();
            b[i].push_back(a[j]);
        }
//        reverse(all(b[i]));
    }
    sort(all(b));
    for (auto &st : b) {
        reverse(all(st));
        int k = st.size();
        int mx = st.back();
        for (int i = 0; i < k; i++) {
            dp[mx] = max(dp[mx], get(0, st[i]) + k - i);
            upd(mx, dp[mx]);
        }
    }
    cout << get(0, N) << '\n';
}

int32_t main() {
    ios::sync_with_stdio(NULL);
    cin.tie(0), cout.tie(0);

    solve();
}
