#include <bits/stdc++.h>

#define int long long
#define all(a) a.begin(), a.end()
#define rall(a) a.begin(), a.end()
#define INF (int) 1e18 / 2

using namespace std;

mt19937 rnd(chrono::steady_clock().now().time_since_epoch().count());

void solve() {
    int n, m;
    cin >> n >> m;
    bool g1 = n == m;
    vector<int> a(2 * n);
    vector g(n, vector<pair<int, int>>());
    for (int i = 0; i < m; i++) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        g[v].push_back({u, w});
        g1 &= (v + 1) % n == u and i == v;
        a[u] = a[u + n] = w;
    }
    if (g1) {
        for (int i = 0; i < n; i++)
            a[i + n] = a[i];
        for (int i = 1; i < 2 * n; i++)
            a[i] ^= a[i - 1];
        int v, u;
        cin >> v >> u;
        v--, u--;
        if (u <= v) u += n;
        if ((a[u] ^ a[v]) or (a[n - 1])) cout << "-1\n";
        else cout << "0\n";
        return;
    }
    vector<int> topsort;
    vector<int> used(n);
    auto dfs = [&](auto dfs, int v) -> void {
        used[v] = 1;
        for (auto [u, w]: g[v])
            if (!used[u])
                dfs(dfs, u);
        topsort.push_back(v);
    };
    int s, t;
    cin >> s >> t;
    s--, t--;
    vector<int> dp(n), cnt(n);
    dfs(dfs, s);
    reverse(all(topsort));
    int res = 0;
    for (int bit = 0; bit < 30; bit++) {
        cnt.assign(n, 0);
        dp.assign(n, 0);
        cnt[s] = 1;
        for (int v: topsort) {
            for (auto [u, w]: g[v]) {
                cnt[u] ^= cnt[v];
                dp[u] ^= dp[v] ^ (w >> bit & cnt[v]);
            }
        }
        res |= (dp[t] << bit);
    }
    cout << res << '\n';
}

int32_t main() {
    ios::sync_with_stdio(NULL);
    cin.tie(0), cout.tie(0);

    int tt;
    cin >> tt;
    while (tt--)
        solve();
}
