#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
#define all(x) (x).begin(), (x).end()
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());

void fastio() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
}

#ifdef CLOWN
void dbg(ll a) {cout << a << "\n";}
void dbg(int a) {cout << a << "\n";}
void dbg(string  a) {cout << a << "\n";}
void dbg(ll a, ll b) {cout << a << " " << b << "\n";}
void dbg(int a, int b) {cout << a << " " << b << "\n";}
void dbg(ll a, ll b, ll c) {cout << a << " " << b << " " << c << "\n";}
void dbg(int a, int b, int c) {cout << a << " " << b << " " << c << "\n";}
void dbg(vector<ll> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
void dbg(vector<int> & a) {for (auto i : a) cout << i << " "; cout << "\n";}
#else
#define dbg(...)
#endif

const int LOG = 17;
int timer = 0, color = 1;
vector<vector<pair<int, int>>> g;
//vector<vector<int>> up;
vector<int> d, used, tin, tout;

void dfs(int u, int p) {
    used[u] = color;
//    tin[u] = timer++;
//    up[u][0] = p;
//    for (int i = 1; i < LOG; i++) up[u][i] = up[up[u][i - 1]][i - 1];
    for (auto [v, c] : g[u]) {
        if (used[v]) continue;
        dfs(v, u);
    }
//    tout[u] = timer++;
}
//
//int high(int u, int v) {
//    return tin[u] <= tin[v] && tout[u] >= tout[v];
//}
//
//int LCA(int u, int v) {
//    if (high(u, v)) return u;
//    if (high(v, u)) return v;
//    for (int i = LOG - 1; i >= 0; i--) {
//        if (up[u][i] == -1) continue;
//        if (!high(up[u][i], v)) {
//            u = up[u][i];
//        }
//    }
//    return up[u][0];
//}

int n, m;
void clear_and_resize() {
//    tin.clear();
    used.clear();
    d.clear();
//    tout.clear();
//    up.clear();
//    tin.resize(n);
    d.resize(n);
//    tout.resize(n);
    used.resize(n);
}

int A, B;
vector<vector<int>> dp;
void calc(int u, int bit) {
    map<int, map<int, int>> cnt;
    for (auto [v, c] : g[u]) {
        cnt[v][c >> bit & 1]++;
    }
    for (auto [v, ways] : cnt) {
        dp[v][1] += cnt[v][1];
        dp[v][1] %= 2;
        calc(v, bit);
    }
}

void solve() {
    cin >> n >> m;
    g.clear();
    g.resize(n);
    int flag_cycle = (n == m);
    int flag_tree = 1;
    for (int i = 0; i < m; i++) {
        int u, v, c;
        cin >> u >> v >> c;
        u--, v--;
        flag_tree &= (u < v);
        flag_cycle &= (u == (v - 1 + n) % n);
        g[u].push_back({v, c});
    }
    cin >> A >> B;
    A--, B--;
    if (flag_cycle) {
        d.assign(n, -1);
        queue<int> q;
        q.push(0);
        d[0] = 0;
        while (!q.empty()) {
            int u = q.front();
            q.pop();
            for (auto [v, c] : g[u]) {
                if (d[v] == -1) {
                    d[v] = d[u] ^ c;
                    q.push(v);
                } else {
                    if (d[u] ^ c) {
                        cout << "-1\n";
                        return;
                    }
                }
            }
        }
        if (d[A] ^ d[B]) {
            cout << "-1\n";
        } else {
            cout << "0\n";
        }
        return;
    }
    if (flag_tree) {
        dbg("tree");
        clear_and_resize();
        dfs(A, A);
        int flag = (used[A] == used[B]);
        clear_and_resize();
        int root = A;
        if (!flag) {
            root = B;
            dfs(B, B);
            if (used[A] != used[B]) {
                cout << "0\n";
                return;
            }
        }
        int ans = 0;
//        cout << "ROOT: " << root << "\n";
        for (int i = 0; i < 31; i++) {
            dp.assign(n, vector<int>(2, 0));
            calc(root, i);
//            for (int j = 0; j < n; j++) cout << dp[j][0] << " ";
//            cout << "\n";
//            for (int j = 0; j < n; j++) cout << dp[j][1] << " ";
//            cout << "\n";
            ans |= (1 << i) * max(0, dp[A ^ B ^ root][1]);
        }
        cout << ans << "\n";
        return;
    }
    dbg("else");
}

int32_t main() {
#ifdef CLOWN
    freopen("C://Users//olymp//CLionProjects//untitled//input.txt", "r", stdin);
    freopen("C://Users//olymp//CLionProjects//untitled//output.txt", "w", stdout);
#endif
    fastio();
    int t = 1;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
