#include <bits/stdc++.h>

using namespace std;

#define fast() ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);

typedef int64_t ll;
typedef uint64_t ull;

const int INF = 1e9 + 117;

int n, m, a, b;
vector<vector<pair<int, int>>> g;

void solve() {
    cin >> n >> m;
    g.assign(n, vector<pair<int, int>> ());
    map<int, int> cc;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        u--; v--;
        cc[w]++;
        g[u].push_back({v, w});
    }
    cin >> a >> b;
    a--; b--;
    if (cc.size() == 1) {
        cout << "0\n";
        return;
    }
    for (auto& [key, val] : cc) {
        if (val & 1) {
            cout << "-1\n";
            return;
        }
    }
    cout << "0\n";
}

int main() {
#ifdef FEDORODORO
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    fast();
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
    return 0;
}
