//#define _GLIBCXX_DEBUG

#include <bits/stdc++.h>
//#pragma GCC optimize("Ofast")
using namespace std;

vector<vector<pair<int, int>>> g;
vector<vector<int>> chet;
vector<vector<int>> nechet;
vector<int>used;
vector<int> dp;
vector<int> cnt;
int a,b;

bool notzero=false;
void dfs(int v) {
    used[v]=true;
    dp[v]=0;
    for (auto u:g[v]) {
        if (!used[u.first]) {
            dfs(u.first);
        }

        if (dp[u.first] != -1e9) {
            if (cnt[u.first]%2 != 0) {
                if (v==a && (u.second ^ dp[u.first]) != 0) {
                    notzero=true;
                }
                dp[v] ^= u.second ^ dp[u.first];
            }
            else {
                if (v==a && (u.second ^ dp[u.first]) != 0) {
                    notzero=true;
                }
                dp[v] ^= dp[u.first];
            }

            cnt[v] += cnt[u.first];
        }

    }
}

bool cycle=false;
bool ncycle=false;
vector<int> d;

void check_cycles(int v) {
    used[v]=1;
    for (auto u:g[v]) {
        if (!used[u.first]) {
            d[u.first] = d[v]^u.second;
            check_cycles(u.first);
        }
        else if (used[u.first] == 1) {
            cycle=true;
            if (d[u.first] != (d[v]^u.second)) {
                ncycle=true;
            }
        }

    }
    used[v]=2;
}

void check_path(int v) {
    used[v]=1;
    for (auto u:g[v]) {
        if (used[u.first]) {
            continue;
        }
        for (int b = 0;b<30;b++) {
            if ((u.second >> b)&1) {
                nechet[u.first][b] |= chet[v][b];
                chet[u.first][b]|= nechet[v][b];
            }
            else {
                nechet[u.first][b] |= nechet[v][b];
                chet[u.first][b] |= chet[v][b];
            }
        }
        check_path(u.first);
    }
}

signed main() {
    int t;
    cin >> t;
    bool flag=false;
    while(t--) {
        int n,m;
        g.clear();

        cin >> n >> m;
        g.resize(n);
        for (int i = 0;i<m;i++) {
            int u,v,w;
            cin >> u >> v >> w;
            u--;
            v--;
            if (u > v) {
                flag=true;
            }
            g[u].push_back({v, w});
        }

        used.assign(n, false);
        dp.assign(n, -1e9);
        cnt.assign(n, 0);
        d.assign(n, 0);
        cycle=false;
        ncycle=false;
        notzero=false;
        cin >> a >> b;
        b--;
        a--;
        check_cycles(a);
        if (ncycle) {
            cout << "-1\n";
            continue;
        }

        used.assign(n, 0);
        dp[b] = 0;
        cnt[b]=1;
        for (int i = 0;i<n;i++) {
            if (!used[i]) {
                dfs(i);
            }
        }
        chet.clear();
        nechet.clear();
        chet.resize(n);
        nechet.resize(n);
        for (int i = 0;i<n;i++) {
            chet[i].assign(30, false);
            nechet[i].assign(30, false);
        }
        for (int i = 0;i<30;i++) {
            chet[0][i] = true;
        }
        used.assign(n, false);
        check_path(a);
        notzero=false;
        for (int i = 0;i<30;i++) {
            if (nechet[b][i]) {
                notzero=true;
            }
        }
        if (cycle && notzero) {
            cout << "-1\n";
        }
        else if (cycle) {
            cout << "0\n";
        }
        else {
            cout << dp[a] << "\n";
        }



    }
}