#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
#define mp make_pair
#define F first
#define S second
typedef long long ll;

vector<vector<pair<int, int> > > g, rg;

int main() {
    int tt; cin >> tt;
    while (tt--) {
        int n, m; cin >> n >> m;
        g.assign(n, vector<pair<int, int> > (0));
        rg.assign(n, vector<pair<int, int> > (0));
        int cycle = (m == n);
        for (int i = 0; i < m; i++) {
            int u, v, w; cin >> u >> v >> w; u--, v--;
            if (cycle) {
                if (i < m - 1) {
                    if (u != i || v != i + 1) cycle = 0;
                } else {
                    if (u != i || v != 0) cycle = 0;
                }
            }
            g[u].pb(mp(v, w));
            rg[v].pb(mp(u, w));
        }
        cout << "-1\n";
    }
    return 0;
}