#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 2e5 + 10;
int n, m, a, b;
struct edge{
    int x, dist;
};

vector<edge> v[maxn];
void read(){
    cin >> n >> m;
    int t = 0;
    for(int i = 1;i <= m;i++){
        int x, y, w;
        cin >> x >> y >> w;
        v[x].push_back({y, w});
        t = max(t, w);
    }
    cin >> a >> b;
}

int used[maxn];

int cnt = 0;
void dfs(int ver){
    used[ver] = 1;
    for(edge x : v[ver]){
        if(!used[x.x]){
            cnt += x.dist;
            dfs(x.x);
        }
    }
}
void solve(){
    read();
    dfs(a);
    if(!used[b]){
        cout << -1 << endl;
        return;
    }
    else{
        cout << min(cnt, 1) << endl;
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while(t--){
        solve();
    }
    return 0;
}
