#include <bits/stdc++.h>

using namespace std;

#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define F first
#define S second
#define ll long long

vector<vector<pii>> gr, rgr, comp_gr;
vector<int> used, can_go, ver, ts, col;
int s, t, bit;

void dfs_ts(int v) {
    used[v] = 1;
    for (pii to : gr[v]) {
        if (!used[to.F])
            dfs_ts(to.F);
    }
    ts.push_back(v);
}

void dfs_go(int v) {
    used[v] = 1;
    can_go[v] = (v == t);
    for (pii to : gr[v]) {
        if (!used[to.F])
            dfs_go(to.F);
        can_go[v] |= can_go[to.F];
    }
}

void dfs_col(int v, int c) {
    col[v] = c;
    for (pii to : rgr[v]) {
        if (col[to.F] != -1)
            comp_gr[col[to.F]].push_back({ c, to.S });
        if (col[to.F] == -1 && can_go[to.F])
            dfs_col(to.F, c);
    }
}

bool dfs(int v) {
    used[v] = 1;
    for (pii to : gr[v]) {
        if (!can_go[to.F]) continue;
        int w = (to.S >> bit) & 1;
        if (!used[to.F]) {
            ver[to.F] = ver[v] ^ w;
            if (dfs(to.F))
                return true;
        }
        if (used[to.F] == 1 && (ver[to.F] ^ ver[v] ^ w))
            return true;
    }
    used[v] = 2;
    ts.push_back(v);
    return false;
}

void solve() {
    int n, m;
    cin >> n >> m;
    gr.assign(n, {});
    rgr.assign(n, {});
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;
        a--; b--;
        gr[a].push_back({ b, c });
        rgr[b].push_back({ a, c });
    }

    cin >> s >> t;
    s--; t--;

    used.assign(n, 0);
    can_go.assign(n, 0);
    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs_go(i);
    }
    used.assign(n, 0);

    ts = {};
    dfs_ts(s);
    reverse(all(ts));

    col.assign(n, -1);
    int cnt = 0;
    for (int v : ts) {
        if (!can_go[v] || col[v] != -1) continue;
        comp_gr.push_back({});
        dfs_col(v, cnt);
        cnt++;
    }

    vector<int> good(cnt, 0);



    for (bit = 0; bit < 30; bit++) {
        used.assign(n, 0);
        ver.assign(n, 0);
        // есть ли цикл с xor = 1
        if (dfs(s)) {
            cout << "-1\n";
            return;
        }
    }
    cout << "0\n";


}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#endif

    int t;
    cin >> t;
    while (t--)
        solve();
}