#include "bits/stdc++.h"

#define ll long long
#define ld long double
#define all(u) u.begin(), u.end()
#define endl '\n'

using namespace std;

mt19937 gen(time(0));
const int base = 177013;
const int mod = 1e9 + 7;

vector<vector<pair<int, int>>> gr_rev;
vector<vector<int>> out_v;
vector<int> weight;

int main(){
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr);
    cin.tie(nullptr);

    int t;
    cin >> t;
    while(t--){
        int n, m;
        cin >> n >> m;
        weight.assign(m, 0);
        gr_rev.assign(n, {});
        out_v.assign(n, {});
        for (int i = 0; i < m; ++i) {
            int a, b;
            cin  >> a >> b;
            cin >> weight[i];
            --a, --b;
            gr_rev[b].emplace_back(a, i);
            out_v[a].emplace_back(b);
        }
        int a, b;
        cin >> a >> b;
        --a, --b;
        vector<int> dp(m, 0);
        queue<int> vertexs;
        vertexs.emplace(b);
        while (!vertexs.empty()){
            int g = vertexs.front();
            vertexs.pop();
            if(dp[g] != 0)
                continue;
            if(g == b){
                for(auto [u, i] : gr_rev[g]){
                    vertexs.emplace(u);
                    dp[i] = 1;
                }
            }else{
                int sx = 0;
                for(auto u : out_v[g]){
                    sx += dp[u];
                }
                for(auto [u, i] : gr_rev[g]){
                    vertexs.emplace(u);
                    dp[i] = sx;
                }
            }
        }
        int ans = 0;
        for (int i = 0; i < m; ++i) {
            if(dp[i] % 2 != 0)
                ans ^= weight[i];
        }
        cout << ans << endl;
    }
}
