#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>

#define int long long

const int INF = 1e9 + 7;

using namespace std;
//using namespace __gnu_pbds;
//using indexed_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;

map<int, vector<pair<int, int>>> g;
map<pair<int, int>, int> mp;
map<pair<int, int>, int> cnt;
vector<int> dp_xor;
vector<bool> used;
vector<int> C;
vector<int> ts;

void tos(int start) {
    used[start] = true;
    for (auto [to, w] : g[start]) {
        if (!used[to]) tos(to);
    }
    ts.push_back(start);
}

void fnc(int start) {
    used[start] = true;
    for (auto [to, w] :g[start]) {
        used[to] = true;
        if (C[start] == 0) {
            if (cnt[make_pair(start, to)] == 1) {
                dp_xor[to] ^= dp_xor[start];
            }
            continue;
        }
        if (cnt[make_pair(start, to)]) {
            C[to] ^= 1;
            dp_xor[to] ^= dp_xor[start] ^ w;
        } else {
            dp_xor[to] ^= w;
        }
    }
}

vector<int> func(int w) {
    vector<int> res;
    while (w > 0) {
        res.push_back(w & 1);
        w /= 2;
    }
    while (res.size() < 30) res.push_back(0);
    return res;
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.clear();
    mp.clear();
    cnt.clear();
    C.assign(n, 0);
    set<pair<int, int>> use;
    ts.clear();
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        if (use.count(make_pair(u, v)) == 0) {
            use.insert(make_pair(u, v));
            mp[make_pair(u, v)] = w;
        } else {
            int &cur = mp[make_pair(u, v)];
            cur ^= w;
        }
        cnt[make_pair(u, v)] ^= 1;
    }
    for (auto i : mp) {
        g[i.first.first].emplace_back(make_pair(i.first.second, i.second));
    }
    int a, b;
    cin >> a >> b;
    a--;
    b--;
    dp_xor.assign(n, 0);
    used.assign(n, false);
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            tos(i);
        }
    }
    std::reverse(ts.begin(), ts.end());
    used.assign(n, false);
    used[a] = true;
    C[a] = 1;
    for (int i =  0; i < n; i++) {
        if (used[ts[i]]) {
            fnc(ts[i]);
        }
    }
    cout << dp_xor[b];
}

void sf() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

signed main() {
    sf();
    int t;
    cin >> t;
    while (t--) {
        solve();
        cout << endl;
    }
}