#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<int, int> pp;

struct Edge {
    int to, w;
};

vector<vector<Edge>> graph;

int a, b;
int xr = 0;
int ans = 0;
void dfs(int v){
    if (v == b){
        ans ^= xr;
        return;
    }
    for (auto ed:graph[v]){
        xr ^= ed.w;
        dfs(ed.to);
        xr ^= ed.w;
    }
}
void solve() {
    int n, m;
    cin >> n >> m;
    graph.assign(n, {});
    for (int i = 0; i < m; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        graph[u].push_back({v, w});
    }
    cin >> a >> b;
    a--;
    b--;
    xr = 0;
    ans = 0;
    dfs(a);
    cout << ans << '\n';

}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}