#include <bits/stdc++.h>
#define int long long
#define double long double
#define x first
#define y second
#define inf (INT64_MAX / 2)

using namespace std;

struct point {
    int u, v, x;
};

bool isCycle = false;

void dfs1(int s, vector<int>& used, vector<vector<int>>& g) {
    used[s] = 1;
    for (int i : g[s]) {
        if (!used[i]) {
            dfs1(i, used, g);
        } else if (used[i] == 1) {
            isCycle = true;
        }
    }
    used[s] = 2;
}


void solve() {
    int n, m, xrO = 0;
    cin >> n >> m;
    vector<vector<int>> g(n), h(n), k(n);
    vector<pair<int, int>> e(m);
    vector<point> goodE;
    vector<int> a(m), used(n, 0), used1(n, 0);
    for (int i = 0; i < m; i++) {
        int x, y;
        cin >> x >> y >> a[i]; x--; y--;
        h[y].push_back(x);
        k[x].push_back(y);
        e[i] = {x, y};
        xrO ^= a[i];
    }
    int s, f;
    cin >> s >> f; s--; f--;
    if (s == f) {
        cout << "0\n";
        return;
    }
    dfs1(f, used, h);
    dfs1(s, used1, k);
    if (!used1[f]) {
        cout << "0\n";
        return;
    }
    for (int i = 0; i < m; i++) {
        if (used1[e[i].x] && used[e[i].y] && e[i].y > e[i].x) {
            goodE.emplace_back(e[i].x, e[i].y, a[i]);
            g[e[i].x].push_back(e[i].y);
        }
    }
    vector<int> dp(n, 0), dp1(n, 0);
    dp[s] = 1;
    dp1[f] = 1;
    for (int i = 0; i < n; i++) {
        for (int j : g[i]) {
            dp[j] += dp[i];
            dp[j] %= 2;
        }
    }
    for (int i = n - 1; i >= 0; i--) {
        for (int j : g[i]) {
            dp1[i] += dp1[j];
            dp1[i] %= 2;
        }
    }
    int ans = 0;
    for (auto i : goodE) {
        if (dp[i.u] && dp1[i.v]) {
            ans ^= i.x;
        }
    }
    if (isCycle && (ans != 0 || xrO)) {
        cout << "-1\n";
        return;
    }
    cout << ans << '\n';
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr); cout.tie(nullptr);
    int _ = 1;
    cin >> _;
    while (_--) {
        solve();
        isCycle = false;
    }
}