#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

void solve_case() {
	int n, m; cin >> n >> m;
	vector<vector<pair<int, int>>> g(n);
	while (m--) {
		int u, v, w; cin >> u >> v >> w;
		u--; v--;
		g[u].emplace_back(v, w);
	}

	int a, b; cin >> a >> b;
	a--; b--;

	vector<char> can_go(n, 0);
	vector<int> cnt_parity(n, 0);
	vector<int> ans(n, 0);
	can_go[b] = cnt_parity[b] = 1;
	for (int i = b - 1; i >= a; i--) {
		for (auto& [v, w] : g[i]) {
			ans[i] ^= ans[v];
			if (cnt_parity[v])
				ans[i] ^= w;
			cnt_parity[i] ^= cnt_parity[v];

			can_go[i] |= (w > 0) && can_go[v];
		}
	}

	if (can_go[a] || true) {
		cout << ans[a] << "\n";
	}
	else {
		cout << "-1\n";
	}
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
