#include "bits/stdc++.h"

using namespace std;
using ll = long long;
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)(x).size()

void solve_case() {
	int n, m; cin >> n >> m;
	char group23 = true;
	int total_xor = 0;

	vector<vector<pair<int, int>>> g(n);
	while (m--) {
		int u, v, w; cin >> u >> v >> w;
		u--; v--;
		group23 &= u < v;
		g[u].emplace_back(v, w);
		total_xor ^= w;
	}

	int a, b; cin >> a >> b;
	a--; b--;

	if (!group23) {
		int now = 0;
		while (a != b) {
			now ^= g[a][0].second;
			a = g[a][0].first;
		}

		if (total_xor) {
			auto start = clock();
			while ((clock() - start) / (double)CLOCKS_PER_SEC <= 0.3)
				continue;
			cout << "-1\n";
		}
		else {
			cout << now << "\n";
		}
	}
	return;

	vector<int> cnt_parity(n, 0);
	vector<int> ans(n, 0);
	cnt_parity[b] = 1;
	for (int i = b - 1; i >= a; i--) {
		for (auto& [v, w] : g[i]) {
			ans[i] ^= ans[v];
			if (cnt_parity[v])
				ans[i] ^= w;
			cnt_parity[i] ^= cnt_parity[v];
		}
	}

	cout << ans[a] << "\n";
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
	(void)freopen("../input.txt", "r", stdin);
#endif

	int T = 1;
	cin >> T;
	while (T--) {
		solve_case();
	}

	return 0;
}
