//#pragma GCC optimize("Ofast")
//#pragma GCC terget("avx,avx2,sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx")
#include<bits/stdc++.h>

using namespace std;

typedef long long ll;

random_device rd;
mt19937 rnd32(rd());
mt19937_64 rnd64(rd());

const ll INF64 = 9'000'000'000'000'000'000, INF32 = 2'000'000'000, MOD = 1'000'000'007;
const double PI = acos(-1);
bool l = false;

template<typename T>
bool assign_min(T& a, T b) {
	if (a > b) {
		a = b;
		return true;
	}
	return false;
}

template<typename T>
bool assign_max(T& a, T b) {
	if (a < b) {
		a = b;
		return true;
	}
	return false;
}

void solve() {
	ll n, m;
	cin >> n >> m;
	ll sk = 0;
	vector<ll> aa(m), bb(m), c(m);
	bool f = m == n;
	for (ll i = 0; i < m; i++) {
		cin >> aa[i] >> bb[i] >> c[i];
		aa[i]--;
		bb[i]--;
		if (f) {
			if (aa[i] != i || bb[i] != (i + 1) % n) {
				f = false;
			}
		}
		sk ^= c[i];
	}
	ll a, b;
	cin >> a >> b;
	a--;
	b--;
	if (f) {
		if (sk != 0) {
			cout << -1 << '\n';
			return;
		}
		ll ans = 0;
		while (a != b) {
			ans ^= c[a];
			a++;
			if (a == n) {
				a = 0;
			}
		}
		cout << (ans != 0 ? -1 : ans) << '\n';
		return;
	}
	if (a >= b) {
		cout << 0 << '\n';
		return;
	}
	vector<ll> dp1(n, 0);
	dp1[a] = 1;
	vector<ll> dp2(n, 0);
	dp2[b] = 1;
	vector<vector<ll>> go(n), og(n);
	for (ll i = 0; i < m; i++) {
		go[aa[i]].push_back(bb[i]);
		og[bb[i]].push_back(aa[i]);
	}
	for (ll i = a; i < b; i++) {
		for (auto j : go[i]) {
			dp1[j] += dp1[i];
			dp1[j] %= 2;
		}
	}
	for (ll i = b; i > a; i--) {
		for (auto j : og[i]) {
			dp2[j] += dp2[i];
			dp2[j] %= 2;
		}
	}
	ll ans = 0;
	for (ll i = 0; i < m; i++) {
		if (aa[i] >= a && bb[i] <= b && dp1[aa[i]] && dp2[bb[i]]) {
			ans ^= c[i];
		}
	}
	cout << ans << '\n';
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#ifdef LOCAL
	l = true;
#endif
	if (!l) {
		ll t;
		cin >> t;
		for (ll _ = 0; _ < t; _++) {
			solve();
		}
	} else {
		ll t;
		cin >> t;
		for (ll _ = 0; _ < t; _++) {
			solve();
		}
	}
}
