#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <deque>


using namespace std;

#define int long long

const int mod = 1e9 + 7;




signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <vector <vector<int>>> gr(n);
        int ch = 1;
        if (n != m) {
            ch = 0;
        }
        for (int i = 0; i < m; i++) {
            int v, u, cs;
            cin >> v >> u >> cs;
            v--;
            u--;
            if ((v + 1) % n != u) {
                ch = 0;
            }
            gr[v].push_back({u, cs});
        }
        if (ch) {
            int s, f;
            cin >> s >> f;
            s--;
            f--;
            int an = 0;
            int v = s;
            while (v != f) {
                an = an ^ gr[v][0][1];
                v = gr[v][0][0];
            }
            int alc = an;
            while (v != s) {
                alc = alc ^ gr[v][0][1];
                v = gr[v][0][0];
            }
            if (alc == 0 and an == 0) {
                cout << 0 << "\n";
            }
            else {
                cout << -1 << "\n";
            }
        }
    }
}
