#include <iostream>
#include <iomanip>
#include <vector>
#include <map>
#include <algorithm>
#include <set>
#include <deque>


using namespace std;

#define int long long

const int mod = 1e9 + 7;




signed main() {
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        vector <vector <vector<int>>> gr(n);
        vector <vector <vector<int>>> rg(n);
        int ch = 1;
        int chh = 1;
        if (n != m) {
            ch = 0;
        }
        set <int> cnf;
        for (int i = 0; i < m; i++) {
            int v, u, cs;
            cin >> v >> u >> cs;
            v--;
            u--;
            cnf.insert(v);
            if ((v + 1) % n != u) {
                ch = 0;
            }
            if (v >= u) {
                chh = 0;
            }
            gr[v].push_back({u, cs});
            rg[u].push_back({v, cs});
        }
        if (ch and cnf.size() == n) {
            int s, f;
            cin >> s >> f;
            s--;
            f--;
            int an1 = 0;
            int v = s;
            while (v != f) {
                an1 = an1 ^ gr[v][0][1];
                v = gr[v][0][0];
            }
            v = s;
            int cnt = 0;
            int an2 = 0;
            while (cnt != 2) {
                if (v == f) {
                    cnt++;
                }
                if (cnt != 2) {
                    an2 = an2 ^ gr[v][0][1];
                    v = gr[v][0][0];
                }
            }
            if (an1 == 0 and an2 == 0) {
                cout << 0 << "\n";
            }
            else {
                cout << -1 << "\n";
            }
        }
        else if (chh) {
            int s, f;
            cin >> s >> f;
            vector <int> cn2(n);
            s--;
            f--;
            cn2[s] = 1;
            for (int i = 0; i < n; i++) {
                if (cn2[i] != 0) {
                    for (auto nw : gr[i]) {
                        int u = nw[0];
                        int zn = nw[1];
                        cn2[u] += cn2[i];
                        cn2[u] %= 2;
                    }
                }
            }
            vector <int> bit(30);
            vector <int> cn(n);
            cn[f] = 1;
            for (int i = n - 1; i > -1; i--) {
                if (cn[i] != 0) {
                    for (auto nw : rg[i]) {
                        int u = nw[0];
                        int zn = nw[1];
                        int cnh = cn2[u] * cn[i];
                        cn[u] += cn[i];
                        cn[u] %= 2;
                        if (cnh % 2 != 0) {
                            for (int bb = 0; bb < 30; bb++) {
                                if ((zn >> bb) % 2){
                                    bit[bb] ^= 1;
                                }
                            }
                        }
                    }
                }
            }
            int an = 0;
            for (int i = 0; i < 30; i++) {
                if (bit[i]) {
                    an += (1 << i);
                }
            }
            cout << an << "\n";
        }
        else {
            return -1;
        }
    }
}
