#include <iostream>
#include <vector>
#include <set>

using namespace std;
using ll = long long;

void resolve() {
    ll n, m;
    cin >> n >> m;
    vector<vector<pair<ll, ll>>> graph(n);
    ll xr = 0;
    for (ll i = 0; i < m; ++i) {
        ll v, u, w;
        cin >> v >> u >> w;
        --v;
        --u;
        graph[v].emplace_back(u, w);
        xr ^= w;
    }

    if (xr) {
        cout << xr << '\n';
    } else {
        cout << -1 << '\n';
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll testN;
    cin >> testN;
    while (testN--) {
        resolve();
    }

    return 0;
}
