#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

void resolve() {
    ll n, m;
    cin >> n >> m;
    ll xr = 0;
    vector<ll> nxt(n);
    for (ll i = 0; i < n; ++i) {
        cin >> nxt[i] >> nxt[i] >> nxt[i];
        xr ^= nxt[i];
    }

    ll start, finish;
    cin >> start >> finish;
    --start;
    --finish;
    ll sub = 0;
    while (start != finish) {
        sub ^= nxt[start];
        start = (start + 1) % n;
    }

    if (xr == 0 || sub == (sub ^ xr)) {
        cout << sub << '\n';
    } else {
        cout << "-1\n";
    }
}

int32_t main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll testN;
    cin >> testN;
    while (testN--) {
        resolve();
    }

    return 0;
}
