#include <bits/stdc++.h>
#define fr first
#define sc second
#define all(x) (x).begin(), (x).end()
#define sz(x) (int)((x).size())
#define pb push_back

using namespace std;

template <typename T> inline bool umax (T &a, const T &b) { if (a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin (T &a, const T &b) { if (a > b) { a = b; return 1; } return 0; }

typedef pair <int, int> pii;

const int N = 2e5 + 10;

inline void solve () {
    int n, m; cin >> n >> m;
    vector <vector <pii>> g (n);
    int al = 0, xr = 0;

    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        --u, --v;
        g[u].pb({v, w});
        al ^= w;
    }
    int a, b; cin >> a >> b; --a; --b;

    while (a != b) {
        xr ^= g[a][0].sc;
        a = g[a][0].fr;
    }

    if (!al && !xr) cout << 0 << endl;
    else cout << -1 << endl;
}

signed main () {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    #ifdef LOCAL
        freopen("input.txt", "r", stdin);
        freopen("output.txt", "w", stdout);
    #endif // LOCAL
    int t = 1; cin >> t;
    while (t--) solve();
    return 0;
}
