#include <bits/stdc++.h>

//#define _GLIBCXX_DEBUG

//#define GCC optimize("O3")
//#define GCC optimize("Ofast")
//#define GCC optimize("unroll-loops")
//#define GCC target("avx2")

#define int long long
#define ll long long
#define ld long double
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
#define sz(x) (int)x.size()

using namespace std;

int n, m, a, b;
vector<vector<pair<int, int>>> g;
vector<int> topSort;
vector<bool> used;

void dfs2(int v) {
    used[v] = false;
    for (auto &[u, w]: g[v]) {
        if (used[u]) {
            dfs2(u);
        }
    }
    topSort.emplace_back(v);
}

void solve() {
    cin >> n >> m;
    g.assign(n, vector<pair<int, int>> ());
    used.assign(n, true);
    bool flag1 = (n == m), flag2 = true;
    vector<int> pref(m, 0);
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        g[u].emplace_back(v, w);
        flag1 &= (u == i && v == (i + 1) % m);
        flag2 &= (u < v);
        pref[(i + 1) % m] = (pref[i] ^ w);
    }
    cin >> a >> b;
    --a, --b;
    if (flag1) {
        if (pref[0] == 0) {
            if ((a <= b && (pref[b] ^ pref[a]) == 0) ||
                (a > b && (pref[0] ^ pref[a] ^ pref[b]) == 0)) {
                cout << "0\n";
            } else {
                cout << "-1\n";
            }
        } else {
            cout << "-1\n";
        }
    } else if (flag2) {
        topSort = {};
        dfs2(0);
        reverse(all(topSort));
        vector<int> dp(n, INT64_MAX), cnt(n, 1);
        dp[a] = dp[b] = 0;
        for (int i = 0; i < n; ++i) {
            int v = topSort[i];
            if (dp[v] == INT64_MAX) continue;
            for (auto &[u, w]: g[v]) {
                cnt[u] += cnt[v];
                if (dp[u] == INT64_MAX) dp[u] = 0;
                dp[u] ^= dp[v] ^ (w * (cnt[v] % 2));
            }
        }
        cout << dp[b] << '\n';
    } else {
        assert(false);
    }
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int tt;
    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}