#include <bits/stdc++.h>
using namespace std;
typedef long long ll;

struct edge {
    int u, w;
};

vector<vector<edge>> g;

void solve() {
    int n, m, a, b;
    cin >> n >> m;

    g.clear();
    g.resize(n);

    bool group1 = (n == m);
    vector<int> wg(2 * n);

    for (int i = 0; i < m; ++i) {
        int v, u, w;
        cin >> v >> u >> w;
        v--, u--;
        g[v].push_back({u, w});

        if (i < n) {
            wg[i] = wg[n + i] = w;
        }

        if (i < n - 1) {
            group1 &= (v == i && u == i + 1);
        } else {
            group1 &= (v == n - 1 && u == 0);
        }
    }

    cin >> a >> b;
    a--, b--;

    if (group1) {
        if (b <= a) {
            b += n;
        }

        int ans = 0, all = 0;
        for (int i = 0; i < n; ++i) {
            all ^= wg[i];
        }
        for (int i = a; i < b; ++i) {
            ans ^= wg[i];
        }

        if (ans == 0 && (all ^ ans) == 0) {
            cout << "0\n";
        } else {
            cout << "-1\n";
        }
    }
}

int main() {
#ifndef NEKSTAS
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
#endif
    int t = 1;
    cin >> t;
    for (int i = 0; i < t; ++i) {
        solve();
    }
}