#include <bits/stdc++.h>
#pragma GCC optimize("Ofast,unroll-loops,fast-math")
#pragma GCC target("avx,avx2,bmi,bmi2,popcnt,lzcnt,tune=native")
#define F first
#define S second
#define endl '\n'
typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;
using namespace std;

mt19937_64 rng(time(nullptr));
ll rnd(ll n) {
    uniform_int_distribution <ll> uid;
    return uid(rng) % n;
}

int c[200010];
vector <pair <int, int>> g1[200010], g2[200010];

int used1[200010], used2[200010];
int r1[200010], r2[200010];
int a, b;

vector <int> z1;
void dfs1(int s) {
    used1[s] = 1;
    for (auto& el : g1[s]) {
        int e = el.F, i = el.S;
        r1[i] = 1;
        if (used1[e] == 0)
            dfs1(e);
    }
    used1[s] = 2;
    z1.push_back(s);
}

vector <int> z2;
void dfs2(int s) {
    used2[s] = 1;
    for (auto& el : g2[s]) {
        int e = el.F, i = el.S;
        r2[i] = 1;
        if (used2[e] == 0)
            dfs2(e);
    }
    used2[s] = 2;
    z2.push_back(s);
}

int kol1[200010], kol2[200010];

void solve() {
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; i++) {
        g1[i].clear();
        g2[i].clear();
        c[i] = 0;
        used1[i] = 0;
        used2[i] = 0;
        r1[i] = 0;
        r2[i] = 0;
        kol1[i] = 0;
        kol2[i] = 0;
    }
    z1.clear();
    z2.clear();
    vector <pair <int, int>> r;
    bool flag = true;
    int k = 0;
    for (int i = 0; i < m; i++) {
        int u, v, x;
        cin >> u >> v >> x;
        u--, v--;
        g1[u].emplace_back(v, i);
        g2[v].emplace_back(u, i);
        c[i] = x;
        r.push_back({u, v});
        if (u > v)
            flag = false;
        k ^= c[i];
    }
    cin >> a >> b;
    a--, b--;
    if (!flag) {
        if (a == b) {
            if (k == 0)
                cout << 0 << endl;
            else
                cout << -1 << endl;
            return;
        }
        int k1 = 0, now = a;
        while (now != b) {
            k1 ^= c[g1[now][0].S];
            now = g1[now][0].F;
        }
        int k2 = 0; now = b;
        while (now != a) {
            k2 ^= c[g1[now][0].S];
            now = g1[now][0].F;
        }
        if (k1 == 0 && k2 == 0)
            cout << 0 << endl;
        else
            cout << -1 << endl;
        return;
    }
    dfs1(a), dfs2(b);
    reverse(z1.begin(), z1.end());
    kol1[a] = 1;
    for (auto& s : z1)
        for (auto& e : g1[s])
            kol1[e.F] = (kol1[e.F] + kol1[s]) % 2;
    reverse(z2.begin(), z2.end());
    kol2[b] = 1;
    for (auto& s : z2)
        for (auto& e : g2[s])
            kol2[e.F] = (kol2[e.F] + kol2[s]) % 2;
    int ans = 0;
    for (int i = 0; i < m; i++)
        if (r1[i] && r2[i] && kol1[r[i].F] * kol2[r[i].S] % 2 == 1)
            ans ^= c[i];
    cout << ans << endl;
}

int main() {
    cin.tie(nullptr);
    cout.tie(nullptr);
    ios_base::sync_with_stdio(false);
    auto start_time = time(nullptr);
    int tt = 1;
    cin >> tt;
    while (tt--)
        solve();
    auto end_time = time(nullptr);
    cerr << "Ulyanovsk is the best" << endl;
    cerr << "Execution time: " << end_time - start_time << " ms" << endl;
}
