#include <bits/stdc++.h>
#define int long long

using namespace std;

const int C = 200010;


vector<vector<pair<int, int>>> g;
vector<int> used, dp, reach_b, cnt;
int finish;

void dfs(int u) {
    if (u == finish) {
        reach_b[u] = 1, cnt[u] = 1;
        return;
    }
    if (used[u]) return;
    used[u] = 1;
    for (auto[v, c] : g[u]) {
        dfs(v);
        if (reach_b[v]) cnt[u] = (cnt[u] + cnt[v]) % 2, dp[u] = dp[v] ^ dp[u] ^ (c * (cnt[v])), reach_b[u] = 1;
    }
}

void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    used.assign(n, 0);
    dp.assign(n, 0);
    reach_b.assign(n, 0);
    cnt.assign(n, 0);
    int W = 0, group1 = 1;
    vector<int> gr1(m);
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w, a--, b--;
        gr1[i] = w;
        if (i != a || (i + 1) % n != b) group1 = 0;
        W ^= w;
        g[a].emplace_back(b, w);
    }
    //   cout << group1 << endl;
    int a, b;
    cin >> a >> b, a--, b--;
    int W0 = 0;
    if (a > b) b += n;
    for (int i = a; i < b; ++i) W0 ^= gr1[i % n];
    //cout << (1 << 30) << endl;
    if (group1) {
        if ((W ^ W0) == 0 && W0 == 0) cout << W0 << endl;
        else cout << -1 << endl;
        return;
    }
    finish = b;
    dfs(a);
    if (reach_b[a] == 0) {
        cout << -1 << '\n';
        return;
    }
    cout << dp[a] << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}
