#include <bits/stdc++.h>
#define int long long

using namespace std;

vector<vector<pair<int, int>>> g, rg;
vector<int> used, reach_b, reach_a, cnta, cntb;
int start, finish;

void dfs_a(int u) {
    if (u == finish) {
        reach_b[u] = 1, cnta[u] = 1;
        return;
    }
    if (used[u]) return;
    used[u] = 1;
    for (auto[v, c] : g[u]) {
        dfs_a(v);
        if (reach_b[v]) {
            cnta[u] = (cnta[u] + cnta[v]) % 2;
            reach_b[u] = 1;
        }
    }
}


void dfs_b(int u) {
    if (u == start) {
        reach_a[u] = 1, cntb[u] = 1;
        return;
    }
    if (used[u]) return;
    used[u] = 1;
    for (auto[v, c] : rg[u]) {
        dfs_b(v);
        if (reach_a[v]) {
            cntb[u] = (cntb[u] + cntb[v]) % 2;
            reach_a[u] = 1;
        }
    }
}


void solve() {
    int n, m;
    cin >> n >> m;
    g.assign(n, {});
    rg.assign(n, {});
    used.assign(n, 0);
    reach_a.assign(n, 0);
    reach_b.assign(n, 0);
    cnta.assign(n, 0);
    cntb.assign(n, 0);
    int W = 0, group1 = 1;
    vector<int> gr1(m);
    for (int i = 0; i < m; ++i) {
        int a, b, w;
        cin >> a >> b >> w, a--, b--;
        gr1[i] = w;
        if (i != a || (i + 1) % n != b) group1 = 0;
        W ^= w;
        g[a].emplace_back(b, w);
        rg[b].emplace_back(a,w);
    }
    int a, b;
    cin >> a >> b, a--, b--;
    if (group1) {
        int W0 = 0;
        if (a > b) b += n;
        for (int i = a; i < b; ++i) W0 ^= gr1[i % n];
        if ((W ^ W0) == 0 && W0 == 0) cout << W0 << endl;
        else cout << -1 << endl;
        return;
    }
    if (a > b) {
        cout << -1 << endl;
        return;
    }
    b %= n;
    finish = b, start = a;
    dfs_a(a);
    used.assign(n, 0);
    dfs_b(b);
    if (reach_b[a] == 0) {
        cout << -1 << '\n';
        return;
    }
    int ans = 0;
    for (int i = 0; i < n; ++i) {
        for (auto [v, c] : g[i]) {
           // cout << i << " " << v << " " << c <<  " " << cnta[i] << endl;
            if (cnta[v] * cntb[i] == 1) ans ^= c;
        }
    }
    cout << ans << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int T = 1;
    cin >> T;
    while (T--) solve();
}
