#include <iostream>
#include <vector>
#include <queue>
#include <deque>
#include <stack>
#include <numeric>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

#define sz(a) (int)a.size()
#define vc vector
#define pii pair <int, int>
#define all(a) a.begin(), a.end()
#define fi first
#define se second
#define pb push_back
#define int long long

const int N = 5e5 + 1;
const int mod = 1e9 + 7;

void solve () {
    int n, m;
    cin >> n >> m;
    vc <vc <pii>> g(n);
    int xr = 0;
    int lst = 0;
    int f = 1;
    int f2 = 1;
    for (int i = 0; i < m; ++i) {
        int u, v, w;
        cin >> u >> v >> w; --u; --v;
        f &= u == i && v == (i + 1) % n;
        g[u].pb({ v , w });
        lst = w;
        f2 &= u < v;
    }
    int s, t;
    cin >> s >> t; --s; --t;
    if (f && m == n) {
        int xr = 0;
        while (s != t) {
            xr ^= g[s][0].se;
            s = g[s][0].fi;
        }
        if (xr != 0) {
            cout << "-1\n";
            return;
        }
        cout << xr << '\n';
        return;
    }
    if (f2) {
        vc<int> dp1(n), dp2(n), is(n);
        dp2[t] = 1;
        is[t] = 1;
        for (int i = t; i >= s; --i) {
            for (auto[v, w] : g[i]) {
                dp2[i] ^= dp2[v];
                dp1[i] ^= dp1[v];
                dp1[i] ^= w * dp2[v];
                is[i] |= is[v];
            }
        }
        cout << dp1[s] << '\n';
        return;
    }

}

signed main () {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int t = 1;
    cin >> t;
    while (t--)
        solve();
}