#include <bits/stdc++.h>

using namespace std;

#define pikachu push_back
#define mp make_pair
#define st first
#define nd second
#define pll pair<ll, ll>
#define pii pair<int, int>
#define sz(a) (int)(a.size())
#define all(a) a.begin(), a.end()
#define rall(a) a.rbegin(), a.rend()

typedef long long ll;
typedef long double ld;

template<typename A, typename B>
string to_string(pair<A, B> p);

string to_string(string s) {
    return s;
}

string to_string(char s) {
    return "'" + string(1, s) + "'";
}

template<typename A>
string to_string(A v) {
    string res = "{";
    bool fl = 1;
    for (auto x: v) {
        if (!fl) {
            res += ", ";
        }
        fl = 0;
        res += to_string(x);
    }
    res += "}";
    return res;
}

template<typename A, typename B>
string to_string(pair<A, B> p) {
    return "(" + to_string(p.first) + ", " + to_string(p.second) + ")";
}

void debug_out() {
    cerr << endl;
}

template<typename H, typename... T>
void debug_out(H h, T... t) {
    cerr << " " << to_string(h);
    debug_out(t...);
}

#ifdef LOCAL
#define debug(...) cerr << "[" << #__VA_ARGS__ << "]:", debug_out(__VA_ARGS__)
#else
#define debug(...)
#endif

template<typename A, typename B>
bool cmin(A &a, const B &b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}

template<typename A, typename B>
bool cmax(A &a, const B &b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}

struct HASH {
    size_t operator()(const pll &p) const {
        return p.st ^ p.nd;
    }
};

ll bpow(ll a, ll n, ll MOD) {
    ll res = 1;
    while (n) {
        if (n & 1) (res *= a) %= MOD;
        (a *= a) %= MOD;
        n /= 2;
    }
    return res;
}

void run();

signed main() {
    iostream::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    run();
}

void dfs(ll v, vector<vector<pll>> &g, vector<ll> &used, vector<ll> &tp) {
    used[v] = 1;
    for (auto [u, w]: g[v]) {
        if (!used[u]) dfs(u, g, used, tp);
    }
    tp.pikachu(v);
}

vector<vector<ll>> get(ll a, vector<vector<pll>> &g, vector<ll> &used) {
    vector<ll> tp;
    dfs(a, g, used, tp);
    reverse(all(tp));
    vector<ll> num(sz(g));
    for (ll i = 0; i < sz(tp); ++i) num[tp[i]] = i;
    vector<vector<ll>> ans(sz(g), vector<ll>(2));
    ans[a][0] = 1;
    for (auto v: tp) {
        for (auto [u, w]: g[v]) {
            if (num[u] <= num[v]) {
                continue;
            }
            w = !!w;
            for (ll i = 0; i < 2; ++i) {
                ans[u][i] |= ans[v][i ^ w];
            }
        }
    }
    return ans;
}

void task() {
    ll n, m;
    cin >> n >> m;
    vector<vector<pll>> g(n);
    bool fl1 = 1;
    if (n != m) fl1 = 0;
    ll sm = 0;
    for (ll i = 0; i < m; ++i) {
        ll u, v, w;
        cin >> u >> v >> w;
        --u, --v;
        sm ^= w;
        g[u].pikachu({v, w});
        if (i + 1 < m && (u != i || v != i + 1)) fl1 = 0;
        if (i + 1 == m && (u != n - 1 || v != 0)) fl1 = 0;
    }
    ll a, b;
    cin >> a >> b;
    --a, --b;
    if (fl1) {
        ll ans = 0;
        while (a != b) {
            ans ^= g[a][0].nd;
            a = g[a][0].st;
        }
        if (sm == 0 && ans == 0) cout << ans << '\n';
        else cout << "-1\n";
        return;
    }
    vector<ll> cnt(n), ans(n);
    vector<ll> used(n), tp;
    dfs(a, g, used, tp);
    reverse(all(tp));
    vector<ll> num(n);
    for (ll i = 0; i < sz(tp); ++i) num[tp[i]] = i;
    vector<vector<pll>> revg(n);
    for (ll i = 0; i < n; ++i) {
        for (auto [u, w]: g[i]) {
            revg[u].pikachu({i, w});
        }
    }
    cnt[a] = 1;
    bool cycle = 0;
    for (auto v: tp) {
        for (auto [u, w]: g[v]) {
            if (num[u] <= num[v]) {
                cycle = 1;
                continue;
            }
            cnt[u] += cnt[v];
            ans[u] ^= ans[v];
            if (cnt[v] & 1) ans[u] ^= w;
        }
    }
    if (!cycle) {
        cout << ans[b] << '\n';
        return;
    }
    vector<ll> useda(n), usedb(n);
    auto waya = get(a, g, useda);
    auto wayb = get(b, revg, usedb);
    for (ll v = 0; v < n; ++v) {
        for (auto [u, w]: g[v]) {
            if (num[u] <= num[v]) {
                vector<ll> way(2);
                for(ll i = 0; i < 2; ++i){
                    for(ll j = 0; j < 2; ++j){
                        way[i ^ j] |= (waya[v][i] && waya[u][j]);
                    }
                }
                if (!useda[u] || !useda[v]) continue;
                if (!usedb[u] || !usedb[v]) continue;
                debug(u, v);
                debug(way, waya[u], wayb[v]);
                if (way[1] && !w) {
                    cout << "-1\n";
                    return;
                }
                if (way[0] && w){
                    cout << "-1\n";
                    return;
                }
                if (way[0] && waya[u][1] && wayb[v][0]){
                    cout << "-1\n";
                    return;
                }
                if (way[0] && waya[u][0] && wayb[v][1]){
                    cout << "-1\n";
                    return;
                }
                if (way[1] && waya[u][1] && wayb[v][1]){
                    cout << "-1\n";
                    return;
                }
                if (way[1] && waya[u][0] && wayb[v][0]){
                    cout << "-1\n";
                    return;
                }
            }
        }
    }
    cout << ans[b] << '\n';
}

void run() {
    ll t;
    cin >> t;
    while (t--) {
        task();
    }
}

