#include <bits/stdc++.h>

void solve() {
    int n, m;
    std::cin >> n >> m;
    std::vector<std::vector<std::pair<int, int>>> gr(n);
    std::vector<std::array<int, 3>> edg(m);
    bool cum_1 = n == m;
    for (int i = 0; i < m; i++) {
        // int a, b, w;
        auto& [a, b, w] = edg[i];
        std::cin >> a >> b >> w;
        a--;
        b--;
        cum_1 = cum_1 && (a == i && b == (i + 1) % n);
        gr[a].push_back({b, w});
    }
    int s, t;
    std::cin >> s >> t;
    s--;
    t--;

    if (cum_1) {
        int all = 0;
        for (int i = 0; i < n; i++) {
            all ^= edg[i][2];
        }
        if (all) {
            std::cout << "-1\n";
            return;
        }
        int ww = 0;
        for (int i = s; i < t; i++) {
            ww ^= edg[i][2];
        }
        if (ww) {
            std::cout << "-1\n";
            return;
        }
        std::cout << 0 << "\n";
        return;
    }

    std::vector<int> dp(n);
    std::vector<int> cnt(n);
    cnt[t] = 1;

    for (int i = n - 1; i >= 0; i--) {
        for (auto [t, w] : gr[i]) {
            if (t <= i) {
                std::cout << "==\n";
                return;
            }
            assert(t > i);

            if (cnt[t]) {
                cnt[i] ^= 1;
                dp[i] ^= w;
            }
            dp[i] ^= dp[t];
        }
    }
    int ans = dp[s];
    std::cout << ans << "";
    std::cout << std::endl;
}

int32_t main() {
    std::ios_base::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int t;
    std::cin >> t;
    while (t--) {
        solve();
    }

    return 0;
}
