#include <bits/stdc++.h>

using namespace std;

#define sz(x) (int)((x).size())
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()

typedef long long ll;
typedef long double ld;
typedef __int128_t int128;
typedef pair<int, int> pii;
typedef pair<ll, ll> pll;

const char en = '\n';
const int INF = 1e9 + 7;
const ll INFLL = 1e18;

//mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());
mt19937 rnd(666);

struct Solution {
    Solution() = default;

    int n, m;
    vector<vector<int>> g;
    vector<int> edge;
    vector<int> w;

    void operator()() {
        cin >> n >> m;
        g.resize(n);
        edge.resize(m);
        w.resize(m);
        int res = 0;
        for (int i = 0; i < m; ++i) {
            int v, u;
            cin >> v >> u >> w[i];
            res ^= w[i];
            --v; --u;
            g[v].emplace_back(i);
            edge[i] = u;
        }
        int a, b;
        cin >> a >> b;
        --a; --b;
        int kek = 0;
        int v = a;
        while (v != b) {
            for (auto i : g[v]) {
                kek ^= w[i];
                v = edge[i];
            }
        }
        if ((kek ^ res) == 0 && kek == 0) {
            cout << kek << en;
        } else {
            cout << -1 << en;
        }
    }
};

int32_t main() {
    int tests = 1;
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
//    freopen("output.txt", "w", stdout);
    tests = 1;
#else
    ios_base::sync_with_stdio(0); cin.tie(0);
#endif
    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        Solution()();
    }
    return 0;
}
