#include <bits/stdc++.h>
#define sz(n) (int)(n).size()
#define dbg(x) cerr << #x << " : " << x << '\n';

using namespace std;
using ll = ::int64_t;
const int N = 200000;
vector<pair<int, int>> g[N];
vector<int> rg[N];
int x[N], cnt[N], st, trg, col[N], comp[N], sz[N];
bool good[N], exists[N], good2[N];
bool ans_ex = true;
int dfs_dag(int v) {
    good2[v] = true;
    if (x[v] != -1) return x[v];
    if (v == trg) {
        x[v] = 0, cnt[v] = 1;
        return 0;
    }
    x[v] = 0;
    for (auto [to, w] : g[v]) {
        if (good[to]) {
            dfs_dag(to);
            cnt[v] += cnt[to];
            x[v] ^= x[to];
            if (cnt[to] & 1) x[v] ^= w;
        } else if (comp[to] != -1) {
            exists[v] = true;
        }
    }
    cnt[v] %= 2;
    return x[v];
}
vector<int> vts;
void dfs(int v) {
    col[v] = 1;
    for (auto [to, w] : g[v]) {
        if (col[to] == 0) {
            dfs(to);
        }
    }
    vts.emplace_back(v);
}
void paint_comp(int v, int c) {
    comp[v] = c;
    sz[c]++;
    for (int to : rg[v]) if (comp[to] == -1) {
        paint_comp(to, c);
    }
}
void break1() {
    ans_ex = false;
}
void dfs2(int v) {
    col[v] = 1;
    for (auto [to, w] : g[v]) {
        if (col[to] == 2) {
            if ((x[v] ^ w) != x[to]) {
                if (!good[to] || exists[to]) {
                    break1();
                    return;
                }
            }
        } else if (col[to] == 1) {
            if ((x[v] ^ w) != x[to]) {
                break1();
                return;
            }
        } else if (!good2[to] || exists[to]) {
            x[to] = x[v] ^ w;
            dfs2(to);
        }
    }
    col[v] = 2;
}
void solve() {
    vts.clear();
    ans_ex = true;
    int n, m;
    cin >> n >> m;
    for (int i = 0; i < n; ++i) g[i].clear(), rg[i].clear();
    bool firstg = n == m;
    bool dag = true;
    int all_x = 0;
    for (int i = 0; i < m; ++i) {
        int a, b, c;
        cin >> a >> b >> c;
        a--, b--;
        all_x ^= c;
        firstg &= a == i;
        firstg &= b == (i < n - 1 ? i + 1 : 0);
        dag &= a < b;
        g[a].emplace_back(b, c);
        rg[b].emplace_back(a);
    }
    cin >> st >> trg;
    st--, trg--;
    fill(col, col + n, 0);
    fill(comp, comp + n, -1);
    fill(x, x + n, -1);
    fill(cnt, cnt + n, 0);
    fill(sz, sz + n, 0);
    fill(exists, exists + n, false);
    fill(good2, good2 + n, false);
    dfs(st);
    reverse(vts.begin(), vts.end());
    int c = 0;
    for (int v : vts) {
        if (comp[v] == -1) paint_comp(v, c++);
    }
    for (int i = 0; i < n; ++i) {
        bool ok = false;
        if (sz[comp[i]] == 1) {
            ok = true;
            for (int to : rg[i]) {
                if (to == i) ok = false;
            }
        }
        good[i] = ok;
    }
    int x1 = 0;
    if (good[st] && good[trg]) {
        x1 = dfs_dag(st);
    }
    fill(x, x + n, -1);
    fill(col, col + n, -1);
    x[st] = 0;
    dfs2(st);
    if (col[trg] != -1 && x[trg] != x1) {
        break1();
    }
    cout << (ans_ex ? x1 : -1) << '\n';
}

int main() {
    int tt = 1;
#ifdef LOCAL
    freopen("../stream.in", "r", stdin);
    freopen("../stream.out", "w", stdout);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
    cout << fixed << setprecision(27);
#endif
    cin >> tt;
    while (tt--) solve();
    return 0;
}