#pragma 'GCC-optimize'
#include <bits/stdc++.h>

// #define int long long
#define all(x) x.begin(),x.end()
#define vi vector <int>
#define fi(n) for (int i = 0; i < n; ++i)
#define f first
#define s second

using namespace std;

const int maxn = 2e5;
vector <map <int, int> > g(maxn);
vector <vector <pair <int, int> > > g1(maxn);
int n, m, a, b;
bool OK = false;
vector <vector <int> > dp(maxn, vector <int>(10, 0));

void bfs(int U) {
    queue <int> q;
    q.push(U);
    dp[U][0] = 1;
    vector <int> used(maxn, 0);
    while (!q.empty()) {
        int u = q.front(); q.pop();
        if (u == b) OK = true;
        for (auto x: g1[u]) {
            int v = x.f, w = x.s;
            // cout << u << "->" << v << '\n';
            dp[v][0 ^ w] += dp[u][0];
            dp[v][1 ^ w] += dp[u][1];
            if (!used[v]) {
                q.push(v);
                used[v] = 1;
            }
        }
    }
}

void solve1() {
    cin >> a >> b;
    a--; b--;
    bfs(a);
    // for (int i = 0; i < n; ++i) cout << dp[i][0] << " " << dp[i][1] << '\n';
    int ans = 0;
    if (dp[b][1] % 2 == 1) ans = 1;
    if (OK) cout << ans << '\n';
    else cout << "0\n";
}

void solve() {
    cin >> n >> m;
    int sm = 0, xr = 0;
    set <int> ok;
    for (int i = 0; i < m; ++i) {
        int u, v, w; cin >> u >> v >> w;
        u--; v--; sm += w;
        if ((u == i && v == i + 1) || (u == n - 1 && v == 0)) ok.insert(u);
        g[u][v] = w;
        g1[u].emplace_back(v, w);
    }
    if (!(n == m && ok.size() == n)) {
        solve1();
        return;
    }
    cin >> a >> b;
    a--; b--;
    int x = 0;
    if (a < b) {
        for (int i = a; i < b; ++i) {
            x = x ^ g[i][i + 1];
        }
        for (int i = b; i < a + n; ++i) {
            xr = xr ^ g[i % n][(i + 1) % n];
        }
    } else {
        for (int i = a; i < b + n; ++i) {
            x = x ^ g[i % n][(i + 1) % n];
        }
        for (int i = b; i < a; ++i) {
            xr = xr ^ g[i][i + 1];
        }
    }
    if (sm == 0 || (x == 0 && xr == 0)) cout << 0 << '\n';
    else cout << -1 << '\n';
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(nullptr); cout.tie(nullptr);
    int tests;
    cin >> tests;
    //tests = 1;
    while (tests--) {
        solve();
    }
    return 0;
}