#include<bits/stdc++.h>

using namespace std;

struct edge
{
    int ver,dist;
    edge(){};
    edge(int vi, int di)
    {
        ver = vi;
        dist = di;
    }
};

const int maxn = 2*1e5+5;
int t;
int n,m,a,b;
int c[maxn];
int used[maxn];
int dp[maxn],br[maxn];
vector<edge>v[maxn];
bool f,f1;
int sum;

void pre()
{
    ///NE ZABRAVQJ DA MEMSETVASH
    memset(dp,0,sizeof(dp));
    memset(br,0,sizeof(br));
    memset(used,0,sizeof(used));
    for(int i=1;i<=n;i++)
    {
        v[i].clear();
    }
}

void dfs(int beg)
{
    used[beg] = 1;
    if(beg==a)
    {
        br[a] = 1;
        return;
    }
    edge nb;
    int sz = v[beg].size();
    for(int i=0;i<sz;i++)
    {
        nb = v[beg][i];
        if(!used[nb.ver]) dfs(nb.ver);
        if(br[nb.ver]%2) dp[beg] = dp[beg] ^ (dp[nb.ver] ^ nb.dist);
        else dp[beg] = dp[beg] ^ dp[nb.ver];
        br[beg] += br[nb.ver];
    }
}

long long dfs2(int beg)
{
    long long res = 0;
    bool nz = false;
    used[beg] = 1;
    edge nb;
    int sz = v[beg].size();
    for(int i=0;i<sz;i++)
    {
        nb = v[beg][i];
        if(used[nb.ver]==1)
        {
            f = true;
            nz = true;
            res += nb.dist;
        }
        else if(!used[nb.ver])
        {
            long long pom = dfs2(nb.ver);
            if(pom>0)
            {
                nz = true;
                pom -= 1;
                res += pom;
            }
        }
    }
    if(nz) res++;
    used[beg] = 2;
    return res;
}

void is_cycle()
{
    f = false;
    long long ch;
    for(int i=1;i<=n;i++)
    {
        if(f) return;
        if(!used[i])
        {
            ch = dfs2(i);
            if(ch<2) f = false;
        }
    }
}

void solve1()
{
    int pom = 0;
    if(a<=b)
    {
        for(int i=a;i<b;i++)
        {
            pom ^= c[i];
        }
    }
    else
    {
        for(int i=a;i<=n;i++)
        {
            pom ^= c[i];
        }
        for(int i=1;i<b;i++)
        {
            pom ^= c[i];
        }
    }
    if(pom==0&&sum==0) cout << 0 << endl;
    else cout << -1 << endl;
    exit(0);
}

void solve()
{
    /*is_cycle();
    if(f)
    {
        cout << -1 << endl;
        return;
    }
    memset(used,0,sizeof(used));*/
    //br[a] = 1;
    if(f1) solve1();
    dfs(b);
    cout << dp[b] << endl;
}

void read()
{
    cin >> t;
    for(int i=1;i<=t;i++)
    {
        f1 = true;
        pre();
        cin >> n >> m;
        int x,y,d;
        sum = 0;
        if(n!=m) f1 = false;
        for(int j=1;j<=m;j++)
        {
            cin >> x >> y >> d;
            c[j] = d;
            v[y].push_back({x,d});
            sum ^= d;
            if(j<m&&y-x!=1) f1 = false;
            else if(j==m&&x-y!=n-1) f1 = false;
        }
        cin >> a >> b;
        solve();
    }
}

int main()
{
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	read();
	return 0;
}

