#include<bits/stdc++.h>
using namespace std;

vector<int> topsort;
vector<int> used;
vector<vector<pair<int, int>>> g;

void dfs(int i) {
    used[i] = 1;
    for (auto j : g[i]) {
        if (!used[j.first]) {
            dfs(j.first);
        }
    }

    topsort.push_back(i);
}

void solve() {
    int n, m;
    cin >> n >> m;

    used.assign(n, 0);
    g.assign(n, {});
    topsort.clear();

    bool fucking_shit = 1;
    int xor_all = 0;
    for (int i = 0; i < m; i++) {
        int a, b, c;
        cin >> a >> b >> c;

        a--;b--;
        fucking_shit &= (a < b);
        xor_all ^= c;

        g[a].push_back({b, c});
    }

    if (!fucking_shit) {
        int s, t;
        cin >> s >> t;
        s--; t--;

        if (xor_all) {
            cout << -1 << endl;
            return;
        }
        
        if (s == t) {
            cout << 0 << endl;
            return ;
        }

        int xor_cur = 0;
        while (s != t) {
            xor_cur ^= g[s][0].second;
            s += 1;
            s %= n;
        }

        cout << xor_cur << endl;

        return;
    }

    for (int i = 0; i < n; i++) {
        if (!used[i])
            dfs(i); 
    }

    int s, t;
    cin >> s >> t;
    s--;
    t--;

    vector<pair<int, int>> dp(n, {0, 0});
    for (auto i : topsort) {
        if (i == t) dp[i] = {0, 1};

        for (auto j : g[i]) {
            dp[i].second += dp[j.first].second % 2;
            dp[i].first ^= (j.second * (dp[j.first].second % 2)) ^ dp[j.first].first;
        }

        dp[i].second %= 2;
    }

    cout << dp[s].first << endl;
}

int32_t main() {
    ios::sync_with_stdio(0);
    cin.tie(0);

    int t;
    cin >> t;

    while (t--) {
        solve();
    }
}

/*
2
2 2
1 2 1
2 1 2
1 2
3 3
1 2 7
2 3 0
3 1 7
2 3
*/

/*
3
1 1
1 1 0
1 1

1
3 5
1 2 0
1 2 1
1 2 3
2 3 5
2 3 2
1 3

4 5
1 1 0
1 2 3
2 2 0
2 3 1
3 4 1
1 4
*/