#include <bits/stdc++.h>

#define x first
#define y second

#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbgegin(), (x).rend()

#define ll int64_t
#define ld long double

#ifdef LOCAL
#define dbg cout
#else
#define dbg if(0) cout
#endif

#define endl '\n'
#define double ld
#define int ll

using namespace std;

const ll INF = 1e18;
const int inf = 1e9;

mt19937 rnd;

template<typename T>
ostream &operator<<(ostream &os, vector<T> &v) {
    for (auto &e: v)
        os << e << " ";
    return os;
}

void solve() {
    int n, m;
    cin >> n >> m;

    vector<int> w(m + 1);
    for (int i = 1; i <= m; ++i) {
        int x, y;
        cin >> x >> y >> w[i];
    }
    int a, b;
    cin >> a >> b;

    int alls = 0;
    for (int x : w)
        alls ^= x;

    if (alls != 0) {
        cout << -1 << endl;
        return;
    }

    int me = 0;
    
    if (a < b) {
        for (int i = a; i < b; ++i) {
            me ^= w[i];
        }
    } else {
        me = alls;
        for (int i = b; i < a; ++i)
            me ^= w[i];
    }

    cout << me << endl;
}

signed main() {
#ifndef LOCAL
    cin.tie(NULL);
    cout.tie(NULL);
    ios_base::sync_with_stdio(false);
#endif

    int t;
    cin >> t;

    while (t--)
        solve();

    return 0;
}