#include <bits/stdc++.h>

using namespace std;

using ll = long long;

void solve(){
    int n, m;
    cin >> n >> m;
    vector<vector<pair<int, int>>> g(n);
    int xor_sum = 0;
    for (int i = 0, u, v, w; i < m; ++i) {
        cin >> u >> v >> w;
        xor_sum ^= w;
        --u, --v;
        g[u].emplace_back(v, w);
    }
    int a, b;
    cin >> a >> b;
    --a, --b;
    if (xor_sum != 0) {
        cout << -1 << '\n';
        return;
    }
    int path = 0;
    if (a < b) {
        while (a != b) {
            path ^= g[a][0].second;
            ++a;
        }
    } else {
        while (b != a) {
            path ^= g[b][0].second;
            ++b;
        }
    }
    if (path != 0) {
        cout << -1 << '\n';
        return;
    }
    cout << 0 << '\n';
}

int main() {
    int t;
    cin >> t;
    while (t--) {
        solve();
    }
}
