#include <bits/stdc++.h>
#define int long long
using namespace std;


vector <vector <pair <int, int>> > a;
int n, m;
vector < vector <pair <int, int > >> b;
int ans;
int f, l;
vector <bool> used;
vector <char> even;
bool cycle = false;
bool dfs(int v)
{
    //cout << "In " << v << '\n';
    used[v] = true;

    if(v == l)
    {
        even[v] = 'o';
        used[v] = false;
        return true;
    }
    bool now = false;
    for(auto p: a[v])
    {
        if(used[p.first])
        {
            //cout << "Hey\n";
            cycle = true;
            return false;
        }
        if(even[p.first] == '?')
            dfs(p.first);
        if(cycle)
            return false;
        if(even[p.first] == 'o')
            now = !now;
    }
    if(now)
    {
        even[v] = 'o';
        used[v] = false;
        return false;
    }
    else
    {
        even[v] = 'e';
    }

    used[v] = false;
    return false;
}


vector <char> even1;

bool dfs1(int v)
{
    //cout << "In " << v << '\n';

    if(v == f)
    {
        even1[v] = 'o';
        for(auto p : a[v])
        {
            if(even[p.first] == 'o')
                ans ^= p.second;
        }
        return true;
    }
    bool now = false;
    for(auto p: b[v])
    {
        if(even1[p.first] == '?')
            dfs1(p.first);
        if(even1[p.first] == 'o')
            now = !now;
    }
    if(now)
    {
        even1[v] = 'o';
        for(auto p: a[v])
        {
            if(even[p.first] == 'o')
                ans ^= p.second;
        }
        return false;
    }
    else
    {
        even1[v] = 'e';
    }
    return false;
}


void solve() {
    ans = 0, cycle = false;
    cin >> n >> m;
    bool is_1_subtest = true;
    if(n != m)
        is_1_subtest = false;
    a.clear(), b.clear(), used.clear(), even.clear(), even1.clear();
    a.resize(n), b.resize(n), used.resize(n, false), even.resize(n, '?'), even1.resize(n, '?');
    for(int i = 0; i < n; ++i)
    {
        a[i].clear();
        b[i].clear();
    }
    int last_chance = 0;
    for (int i = 0; i < m; ++i)
    {
        int ui, vi, wi;
        cin >> ui >> vi >> wi;
        --ui, --vi;
        last_chance ^= wi;
        a[ui].emplace_back(vi, wi);
        b[vi].emplace_back(ui, wi);
    }
    if(is_1_subtest)
    {
        for(int i = 0; i < n; ++i)
            if(a[i].size() != 1 || b[i].size() != 1)
            {
                is_1_subtest = false;
                break;
            }
    }
    if(is_1_subtest)
    {
        if(last_chance != 0)
        {
            cout << "-1\n";
            return;
        }
        int now = f;
        for(int i = 0; i < n; ++i)
        {
            last_chance ^= a[now][0].second;
            now = a[now][0].first;
            if(now == l)
                break;
        }
        if(last_chance != 0)
        {
            cout << "-1\n";
        }
        else
        {
            cout << "0\n";
        }

        return;
    }
    cin >> f >> l;
    --f, --l;
    dfs(f);
    if(!cycle)
        dfs1(l);
    if(cycle)
        cout << "-1\n";
    else
        cout << ans << '\n';

}

signed main() {
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    int t;
    cin >> t;
    while (t--)
    {
        solve();
    }
}
