#pragma GCC optimize("O3,unroll-loops")

#include <iostream>
#include <algorithm>
#include <vector>
#include <cmath>
#include <iomanip>
#include <set>
#include <map>
#include <unordered_map>
#include <unordered_set>
#include <numeric>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

vector<vector<pair<int, int>>> g1;
vector<vector<pair<int, int>>> g;
vector<vector<pair<int, int>>> t1;
vector<vector<pair<int, int>>> t;

void solve();

int main(){
#ifdef DEBUG
    freopen("input.txt", "r", stdin);
    auto BEGIN = (ld)clock() / CLOCKS_PER_SEC;
#else
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
#endif
    int t;
    cin >> t;
    while (t--){
        solve();
    }
#ifdef DEBUG
    cerr << (ld)clock() / CLOCKS_PER_SEC - BEGIN << endl;
#endif
}

void clear(){
    t1.resize(0);
    t.resize(0);
    g.resize(0);
    g1.resize(0);
}

void solve(){
    clear();
    int n, m;
    cin >> n >> m;
    t1.resize(n);
    t.resize(n);
    g1.resize(n);
    g.resize(n);
    bool f = true;
    bool f1 = true;
    int xrr = 0;
    for (int i = 0; i < m; ++i) {
        int a, b;
        cin >> a >> b;
        --a; --b;
        int c;
        cin >> c;
        xrr ^= c;
        f1 = f1 && (a < b);
        f = f && !(a != i || b != (i + 1) % n);
        g1[a].push_back({b, c});
        t1[b].push_back({a, c});
    }
    int S, T;
    cin >> S >> T;
    --S; --T;
    if (f){
        if (xrr != 0){
            cout << -1 << endl;
        } else{
            xrr = 0;
            for (int i = S; i != T; i = (i + 1) % n){
                xrr ^= g1[i][0].second;
                assert(g1[i][0].first == (i + 1) % n);
            }
            cout << xrr << endl;
        }
        return;
    }
    assert(0 == 1);
}
