#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef __int128 lll;
typedef long double ld;
ll inf = 1e15, mod = 1e9 + 7;
ld eps = 1e-9;
#define all(a) a.begin(), a.end()

ll binpow(ll n, ll k) {
    if (!k)
        return 1;
    if (k % 2)
        return (binpow(n, k - 1) * n) % mod;
    ll a = binpow(n, k / 2);
    return (a * a) % mod;
}

vector<vector<vector<ll>>> g, gab, gba;
vector<ll> us, cl, da, db, kla, klb;
vector<ll> p;

void fndcl(ll v) {
    us[v] = 1;
    p.push_back(v);
    for (auto i: g[v])
        if (us[i[0]] == 1) {
            for (ll j = p.size() - 1; p[j] != i[0]; j--)
                cl[p[j]] = 1;
            cl[i[0]] = 1;
        } else if (!us[i[0]])
            fndcl(i[0]);
    us[v] = 2;
    p.pop_back();
}

void clcda(ll v) {
    da[v] = 1;
    for (auto i: gab[v])
        if (!da[i[0]])
            clcda(i[0]);
}

void clcdb(ll v) {
    db[v] = 1;
    for (auto i: gba[v])
        if (!db[i[0]])
            clcdb(i[0]);
}

void clckla(ll v) {
    kla[v]++;
    for (ll i = 0; i < gab[v].size(); i++)
        if (!gab[v][i][1]) {
            gab[v][i][1] = 1;
            clckla(gab[v][i][0]);
        }
}

void clcklb(ll v) {
    klb[v]++;
    for (ll i = 0; i < gba[v].size(); i++)
        if (!gba[v][i][1]) {
            gba[v][i][1] = 1;
            clcklb(gba[v][i][0]);
        }
}

void solve() {
    ll n, m;
    cin >> n >> m;
    g.clear();
    gab.clear();
    gba.clear();
    us.clear();
    cl.clear();
    da.clear();
    db.clear();
    kla.clear();
    klb.clear();
    g.resize(n);
    gab.resize(n);
    gba.resize(n);
    us.resize(n);
    cl.resize(n);
    da.resize(n);
    db.resize(n);
    kla.resize(n);
    klb.resize(n);
    while (m--) {
        ll u, v, w;
        cin >> u >> v >> w;
        u--;
        v--;
        g[u].push_back({v, w});
        gab[u].push_back({v, 0});
        gba[v].push_back({u, 0});
    }
    ll a, b;
    cin >> a >> b;
    a--;
    b--;
    fndcl(a);
    clcda(a);
    clcdb(b);
    for (ll i = 0; i < n; i++)
        if (cl[i] && da[i] && db[i]) {
            cout << "-1\n";
            return;
        }
    clckla(a);
    clcklb(b);
    ll ans = 0;
    for (ll i = 0; i < n; i++)
        for (auto j: g[i])
            if ((kla[i] * klb[j[0]]) % 2)
                ans = (ans ^ j[1]);
    cout << ans << '\n';
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    ll test;
    cin >> test;
    while (test--) {
        solve();
    }
}