#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <unordered_set>
#include <unordered_map>
#include <stack>
#include <deque>
#include <queue>
#include <memory.h>
#include <iomanip>
#include <random>
#include <ctime>
#define int long long
#define pii pair<int,int>
#define pb push_back
#define fir first
#define sec second
#define endl '\n'
#define double long double
#define INF 1000000009
#define itn int
#define swpa swap
using namespace std;

const int N = 100005, MOD = 1e9 + 7, R = 1 << 20;

mt19937 rnd(228);
bool flag = 0;
void dfs(vector<vector<pii>>& gr, int v, vector<int>& used) {
	used[v] = 1;
	for (auto u : gr[v]) {
		if (used[u.fir] == 0) {
			dfs(gr, u.first, used);
		}
		else if (used[u.fir] == 1) {
			flag = 1;
		}
	}
	used[v] = 2;
} 

void dfs1(vector<vector<pii>>& gr, int v, vector<int>& used, vector<int> &kek) {
	used[v] = 1;
	for (auto &u : gr[v]) {
		if (!used[u.fir]) {
			dfs1(gr, u.first, used, kek);
		}
		kek[v] |= kek[u.fir];
	}
}
void solve() {
	int n, m;
	cin >> n >> m;
	flag = 0;
	vector<vector<pii>> gr(n);
	int kok = 0;
	bool suka = 1;
	for (int i = 0; i < m; i++) {
		int a, b, w;
		cin >> a >> b >> w;
		a--;
		b--;
		kok ^= w;
		if (a != i || b != (i + 1) % n)
			suka = 0;
		gr[a].pb({ b,w });
	}
	int a, b;
	cin >> a >> b;
	a--;
	b--;

	if (suka) {
		if (kok == 0 && a == b)
			cout << 0 << endl;
		else
			cout << -1 << endl;
		return;
	}
	vector<int> kek(n, 0);
	vector<int> used(n);
	kek[b] = 1;
	for (int i = 0; i < n; i++)
		dfs1(gr, a, used, kek);

	vector<vector<pii>> g(n);
	for (int i = 0; i < n; i++) {
		for (auto u : gr[i]) {
			if (kek[i] && kek[u.fir])
				g[i].pb(u);
		}
	}
	swap(gr, g);
	used.assign(n, 0);
	for (int i = 0; i < n; i++) {
		if (used[i] == 0) {
			dfs(gr, i, used);
		}
	}
	if (flag) {
		cout << -1 << endl;
		return;
	}
	vector<int> in(n), out(n);
	int ans = 0;
	for (int i = 0; i < n; i++) {
		for (auto u : gr[i]) {
			in[u.first]++;
		}
		out[i] = (int)(gr[i].size());
	}

	for (int i = 0; i < n; i++) {
		for (auto u : gr[i]) {
			ans ^= ((max(1LL, out[u.fir]) * max(1LL, in[i])) % 2) * u.second;
		}
	}
	cout << ans << endl;
	return;
}
signed main() {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	cout.precision(17);
	srand(time(0));

	int t;
	cin >> t;

	while (t--) {
		solve();
	}
	return 0;
}