#include <bits/stdc++.h>

using namespace std;

void solve() {
    int n, m;
    cin >> n >> m;

    map<pair<int, int>, int> mp;

    for (int i = 0; i < n; i++) {
        int u, v, w;
        cin >> u >> v >> w;
        u--, v--;
        mp[{u, v}] = w;
    }

    int a, b;
    cin >> a >> b;
    a--, b--;

    int sum1 = 0;
    int x1 = a;
    while (x1 != b) {
        sum1 ^= mp[{x1, (x1 + 1) % n}];
        x1++;
        x1 %= n;
    }

    int sum2 = 0;
    int x2 = b;
    while (x2 != a) {
        sum2 ^= mp[{x2, (x2 + 1) % n}];
        x2++;
        x2 %= n;
    }

    if (sum1 == 0 && sum2 == 0) {
        cout << "0\n";
    } else {
        cout << "-1\n";
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int tests;
    cin >> tests;
    while (tests--) {
        solve();
    }
}