#include <iostream>
#include <vector>
#include <map>
#include <algorithm>
#include <stack>
#include <queue>
#include <set>
#include <deque>
#include <chrono>
#include <random>
#include <iomanip>
#include <assert.h>
#include <numeric>
#include <bitset>
#include <string>
#include <cmath>
#include <unordered_map>
#include <unordered_set>

using namespace std;
//#pragma GCC optimize("O3")
//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("sse,sse2,sse3,ssse3,sse4,popcnt,abm,mmx,avx,avx2,tune=native")
using ll = long long;
using ld = long double;
#define int long long
ll inf = 1e9 + 7;
ll inf_ = 1e18 + 4;
const int mod = 1e9 + 7;
mt19937 rnd(chrono::steady_clock::now().time_since_epoch().count());


vector<vector<int>> g;
vector<pair<int, int>> s;
vector<vector<int>> dp;
vector<int> lg;
vector<bool> used;
vector<pair<int, int>> t;
int ti = 0;

void dfs(int v) {
    used[v] = 1;
    t[v].first = ti++;
    for (auto u: g[v]) {
        if (!used[u]) {
            dp[0][u] = v;
            dfs(u);
        }
    }
    t[v].second = ti++;
}

bool Parent(int u, int v) { return t[u].first <= t[v].first && t[v].second <= t[u].second; }

int n;

int lca(int u, int v) {
    if (Parent(u, v)) return u;
    if (Parent(v, u)) return v;
    for (int l = lg[n] + 1; l >= 0; l--) {
        if (!Parent(dp[l][u], v)) {
            u = dp[l][u];
        }
    }
    return dp[0][u];
}

vector<int> p, r;
vector<pair<int, int>> ob;

int find(int a) {
    if (p[a] == a) return a;
    int pr = find(p[a]);
    p[a] = pr;
    return pr;
}

multiset<pair<int, int>> st;

void update(int a, int b) {
    a = find(a);
    b = find(b);
    if (r[a] < r[b]) swap(a, b);
    if (r[a] == r[b]) r[a]++;
    p[b] = a;
    st.erase(st.find(ob[a]));
    st.erase(st.find(ob[b]));
    ob[a] = {max(ob[a].first, ob[b].first), min(ob[a].second, ob[b].second)};
    st.insert(ob[a]);
}

signed main() {
    //freopen("collider.in", "r", stdin);
    //freopen("collider.out", "w", stdout);
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t;
    cin >> t;
    while (t--) {
        int n, m;
        cin >> n >> m;
        bool f = 0;
        for (int i = 0; i < m; i++) {
            int u, v, x;
            cin >> u >> v >> x;
            u--;
            v--;
            if (x) f = 1;
        }
        cout << f << '\n';
    }
    return 0;
}