#include<bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN=2e5+5;

struct Edge
{
    int v,w;
    Edge() {}
    Edge(int _v,int _w)
    {
        v=_v;
        w=_w;
    }
};

int n=0,m;
vector<Edge> adj[MAXN];
vector<Edge> rev[MAXN];
int a,b;
vector<int> ts;

void init()
{
    for(int i=1;i<=n;i++) adj[i].clear();
}

bool used[MAXN];

void topSort(int v)
{
    used[v]=1;
    for(int i=0;i<adj[v].size();i++)
    {
        if(!used[adj[v][i].v]) topSort(adj[v][i].v);
    }
    ts.push_back(v);
}

int dp[MAXN];

void dp1()
{
    for(int i=ts.size()-2;i>=0;i--)
    {
        for(int j=0;j<rev[ts[i]].size();j++)
        {
            dp[ts[i]]^=dp[rev[ts[i]][j].v]^rev[ts[i]][j].w;
        }
    }
}

bool cmp(Edge x,Edge y)
{
    return x.v<y.v;
}

int main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int t;
cin>>t;
while(t--)
{
    init();
    bool fl1=1;
    cin>>n>>m;
    for(int i=0;i<m;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back(Edge(v,w));
        rev[v].push_back(Edge(u,w));
        if((v-u+n)%n!=1) fl1=0;
    }
    cin>>a>>b;
    /*if(n==m && fl1)
    {
        if(n==1)
        {
            if(adj[1][0].w==0) cout<<0<<endl;
            else cout<<-1<<endl;
            continue;
        }
        int x1=0;
        for(int i=a;i<b;i++)
        {
            x1=x1^adj[i][0].w;
        }
        for(int i=b;i<a;i++)
        {
            x1=x1^adj[i][0].w;
        }
        int x2=0;
        for(int i=1;i<=n;i++)
        {
            x2^=adj[i][0].w;
        }
        x2=x2^x1;
        if(x1==0 && x2==0) cout<<0<<endl;
        else cout<<-1<<endl;
        continue;
    }*/
    for(int i=1;i<=n;i++) sort(rev[i].begin(),rev[i].end(),cmp);
    topSort(a);
    dp1();
    cout<<dp[b]<<endl;
}

return 0;
}
