#pragma gcc optimize("O3,Ofast,no-stack-protector,inline")
#pragma gcc target("avx,avx2,popcnt,lzcnt,tune=native")
#include<bits/stdc++.h>
#include<vector>
#include<immintrin.h>
#include<ext/pb_ds/assoc_container.hpp>
#include<ext/pb_ds/tree_policy.hpp>
using namespace __gnu_pbds;
typedef tree<int, null_type, std::less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
using namespace std;
typedef long long ll;
typedef long double ld;
typedef __int128 li;
#define ft first
#define sc second
#define all(x) begin(x),end(x)
const ll mod = 1e9+7, inf = 2e9, N = 1e7+10;
vector<vector<int>> rebra;
vector<int> d, dsu, sz;
vector<pair<int, int>> seg;
ll ans = 1;
inline ll binpow(ll x, int p) {
    if (p == 0) return 1;
    if (p == 1) return x;
    if (p % 2 == 1) return (x * binpow(x, p-1))%mod;
    ll y = binpow(x, p/2);
    return (y*y)%mod;
}
inline int get(int i) {
    if (i == dsu[i]) return i;
    return dsu[i] = get(dsu[i]);
}
bool fl = 0;
inline void merge(int u, int v) {
    u = get(u); v = get(v);
    if (u != v) {
        if (sz[u] < sz[v]) swap(u, v);
        ans = (ans * binpow(seg[u].sc-seg[u].ft+1, mod-2))%mod;
        ans = (ans * binpow(seg[v].sc-seg[v].ft+1, mod-2))%mod;
        seg[u].ft = max(seg[u].ft, seg[v].ft);
        seg[u].sc = min(seg[u].sc, seg[v].sc);
        if (seg[u].ft > seg[u].sc) fl = 1;
        ans = (ans * (seg[u].sc-seg[u].ft+1))%mod;
        sz[u] += sz[v];
        dsu[v] = u;
    }
}
void dfs(int i, int prev) {
    for (auto j : rebra[i]) {
        d[j] = d[i]+1;
        if (j != prev) dfs(j, i);
    }
}
int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n, m, a, b, u, v;
    cin >> n;
    vector<int> p(n);
    vector<int> pr(n);
    rebra.resize(n);
    d.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> p[i];
        rebra[p[i]-1].push_back(i);
        pr[i] = p[i]-1;
    }
    seg.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> seg[i].ft >> seg[i].sc;
        ans = (ans * (seg[i].sc-seg[i].ft+1))%mod;
    }
    pr[0] = 0;
    d[0] = 0;
    dfs(0, -1);
    cin >> m;
    dsu.resize(n);
    iota(all(dsu), 0);
    sz.assign(n, 1);
    while (m--) {
        cin >> a >> b >> u >> v; a--; b--; u--; v--;
        vector<int> va, vb, vu, vv;
        while (d[a] > d[b]) {
            va.push_back(a);
            a = pr[a];
        }
        while (d[a] < d[b]) {
            vb.push_back(b);
            b = pr[b];
        }
        while (a != b) {
            va.push_back(a);
            a = pr[a];
            vb.push_back(b);
            b = pr[b];
        }
        va.push_back(a);

        while (d[u] > d[v]) {
            vu.push_back(u);
            u = pr[u];
        }
        while (d[u] < d[v]) {
            vv.push_back(v);
            v = pr[v];
        }
        while (u != v) {
            vu.push_back(u);
            u = pr[u];
            vv.push_back(v);
            v = pr[v];
        }
        vu.push_back(u);
        for (int i = vb.size()-1; i >= 0; i--) va.push_back(vb[i]);
        for (int i = vv.size()-1; i >= 0; i--) vu.push_back(vv[i]);
        for (int i = 0; i < va.size(); i++) merge(va[i], vu[i]);
        if (fl) cout << "0\n";
        else cout << ans << "\n";
    }
}
