#include <bits/stdc++.h>

using namespace std;


#define int long long
vector < vector <int> > g;
vector < pair <int, int> > vert;

int mod = 1e9 + 7;
vector <int> way;

bool dfs(int v, int p, int to) {
	bool ok = (v == to);
	for (auto u : g[v]) {
		if (u != p) {
			bool x = dfs(u, v, to);
			if (x) {
				way.push_back(u);
			}
			ok |= x;
		}
	}
	return ok;
}

vector <int> parent;
vector <int> ran;

int get(int v) {
	return (parent[v] == v ? v : get(parent[v]));
}

pair <int, int> connect(pair <int, int> s1, pair <int, int> s2) {
	return {max(s1.first, s2.first), min(s1.second, s2.second)};
}
 
void unite(int u, int v) {
	pair <int, int> s1 = vert[u];
	pair <int, int> s2 = vert[v];
	pair <int, int> s = connect(s1, s2);
	u = get(u); 
	v = get(v);
	if (u == v) return;
	if (ran[u] > ran[v]) {
		swap(u, v);
	}
	ran[v] += ran[u];
	parent[u] = v;
	vert[v] = connect(connect(vert[u], vert[v]), s);
}

int ans(int a, int b, int c, int d) {
	way.clear();
	dfs(a, -1, b);
	vector <int> way1 = way;
	way1.push_back(a);
	way.clear();
	dfs(c, -1, d);
	vector <int> way2 = way;
	way2.push_back(c);
	vector <int> used(g.size());
	for (int i = 0; i < way1.size(); i++) {
		unite(way1[i], way2[i]);
	}
	int res = 1;
	for (int i = 0; i < g.size(); i++) {
		if (get(i) == i) {
			res *= max(0ll, vert[i].second - vert[i].first + 1);
			res %= mod;
		}
	}
	return res;
}

signed main () {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
	int n;
	cin >> n;
	g.resize(n);
	parent.resize(n); for (int i = 0; i < n; i++) parent[i] = i;
	ran.resize(n, 1);
	for (int i = 0; i < n - 1; i++) {
		int x; cin >> x;
		x--;
		g[i + 1].push_back(x);
		g[x].push_back(i + 1);
	}
	vert.resize(n);
	for (int i = 0; i < n; i++) {
		cin >> vert[i].first >> vert[i].second;
	}
	int m;
	cin >> m;
	while (m--) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--, b--, c--, d--;
		cout << ans(a, b, c, d) << endl;
	}
	return 0;
} 