#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()

typedef long long ll;

const ll INF = (ll)(1e18);
const ll MOD = (ll)(1e9 + 7);




const ll MAXN = 2e5 + 20;
vector<ll> g[MAXN];
ll now_ans = 1;
pair<ll, ll> ogran[MAXN];
ll par[MAXN], sz[MAXN];
pair<ll, ll> for_dsu[MAXN];
ll h[MAXN], prv[MAXN];

void dfs(ll v, ll now_h, ll p) {
    h[v] = now_h;
    prv[v] = p;

    for (auto i : g[v]) {
        dfs(i, now_h + 1, v);
    }
}

ll get(ll v) {
    if (par[v] != v) par[v] = get(par[v]);
    return par[v];
}

ll get_count(ll r, ll t) {
    return max(0LL, t - r + 1);
}

ll bin_pow(ll a, ll step) {
    if (!step) return 1;

    ll g = bin_pow(a, step / 2);
    g *= g;
    g %= MOD;

    if (step % 2) {
        g *= a;
        g %= MOD;
    }

    return g;
}

ll get_obrat(ll x) {
    return bin_pow(x, MOD - 2);
}

void check_unite(ll a, ll b) {
    a = get(a);
    b = get(b);

    if (a == b) return;

    if (get_count(for_dsu[a].first, for_dsu[a].second) == 0 || get_count(for_dsu[b].first, for_dsu[b].second) == 0) {
        now_ans = 0;
        return;
    }

    // now_ans /= get_count 1, 2
    now_ans *= get_obrat(get_count(for_dsu[a].first, for_dsu[a].second));
    now_ans %= MOD;

    now_ans *= get_obrat(get_count(for_dsu[b].first, for_dsu[b].second));
    now_ans %= MOD;

    if (sz[a] < sz[b]) swap(a, b);

    sz[a] += sz[b];
    par[b] = a;

    for_dsu[a].first = max(for_dsu[a].first, for_dsu[b].first);
    for_dsu[a].second = min(for_dsu[a].second, for_dsu[b].second);
    
    now_ans *= get_count(for_dsu[a].first, for_dsu[a].second);
}

void solve() {
    ll n;
    cin >> n;

    for (ll i = 0; i < n; ++i) {
        par[i] = i;
        sz[i] = 1;
    }

    for (ll i = 0; i < n - 1; ++i) {
        ll x;
        cin >> x;

        g[x - 1].push_back(i + 1);
    }

    dfs(0, 0, -1);

    for (ll i = 0; i < n; ++i) {
        cin >> ogran[i].first >> ogran[i].second;
        now_ans *= get_count(ogran[i].first, ogran[i].second);
        now_ans %= MOD;

        for_dsu[i].first = ogran[i].first;
        for_dsu[i].second = ogran[i].second;
    }

    ll q;
    cin >> q;

    while (q--) {
        ll a, b, c, d;
        cin >> a >> b >> c >> d;

        --a, --b, --c, --d;

        vector<ll> fir_fir, fir_sec;

        while (a != b) {
            if (h[a] >= h[b]) {
                fir_fir.push_back(a);
                a = prv[a];
            }
            else {
                fir_sec.push_back(b);
                b = prv[b];
            }
        }
        fir_fir.push_back(a);
        for (ll i = (ll)fir_sec.size() - 1; i >= 0; --i) fir_fir.push_back(fir_sec[i]);


        vector<ll> sec_fir, sec_sec;

        while (c != d) {
            if (h[c] >= h[d]) {
                sec_fir.push_back(c);
                c = prv[c];
            }
            else {
                sec_sec.push_back(d);
                d = prv[d];
            }
        }
        sec_fir.push_back(c);
        for (ll i = (ll)sec_sec.size() - 1; i >= 0; --i) sec_fir.push_back(sec_sec[i]);


        for (ll i = 0; i < fir_fir.size(); ++i) check_unite(fir_fir[i], sec_fir[i]);

        // while (a != b) {
        //     check_unite(a, c);


        // }

        // check_unite(b, d);

        cout << now_ans << '\n';
    }
}

signed main() {
    int tests = 1;

    while (tests--) {
        solve();
    }
}

// cd "d:\open_olympiad\" ; if ($?) { g++ main.cpp -o main } ; if ($?) { .\main } 
