#include <bits/stdc++.h>

using namespace std;
//#define int long long
//#define double long double

const long long MOD = 1e9 + 7;

long long fast(long long a, int n) {
    if (n == 0)
        return 1;
    if (n == 1)
        return a;
    if (n % 2 == 1) {
        return (1LL * fast(a, n - 1) * a) % MOD;
    }
    long long b = fast(a, (n >> 1));
    return (1LL * b * b) % MOD;
}

vector<vector<int> > gr;
vector<pair<int, int> > otr;
vector<int> coll;
vector<vector<int> > elems;

vector<int> p, sz;
long long ans = 1;

long long take(const pair<int, int> &a) {
    return max(0, a.second - a.first + 1);
}

void mergee(pair<int, int> &a, pair<int, int> &b) {
    a.first = max(a.first, b.first);
    a.second = min(a.second, b.second);
}

int get(int x) {
    return coll[x];
    vector<int> now;
    while (p[x] != -1) {
        now.push_back(x);
        x = p[x];
    }
    for (auto u: now)
        p[u] = x;
    return x;
}

void uniq(int x, int y) {
    x = get(x);
    y = get(y);
    if (x == y)
        return;
    if (sz[x] < sz[y])
        swap(x, y);
    p[y] = x;
    sz[x] += sz[y];
    for (auto u: elems[y]) {
        coll[u] = x;
        elems[x].push_back(u);
    }
    elems[y].clear();
    ans *= 1LL * fast(take(otr[y]), MOD - 2);
    ans %= MOD;
    ans *= 1LL * fast(take(otr[x]), MOD - 2);
    ans %= MOD;
    mergee(otr[x], otr[y]);

    ans *= 1LL * take(otr[x]);
    ans %= MOD;
}


vector<vector<int> > binup;
int timer = 0;
vector<int> tin, tout;

void dfs(int v, int pr = 0) {
    binup[0][v] = pr;
    tin[v] = timer++;
    for (auto u: gr[v]) {
        if (u != pr)
            dfs(u, v);
    }
    tout[v] = timer++;
}

vector<int> used;

bool pred(int x, int y) {
    return tin[x] <= tin[y] && tout[y] <= tout[x];
}

int lca(int a, int b) {
    if (pred(a, b))
        return a;
    if (pred(b, a))
        return b;
    for (int i = 19; i >= 0; --i)
        if (!pred(binup[i][a], b))
            a = binup[i][a];
    return binup[0][a];
}

vector<int> get_put(int a, int b) {
    int lc = lca(a, b);
    vector<int> st, end;
    while (a != lc) {
        st.push_back(a);
        a = binup[0][a];
    }
    st.push_back(lc);
    while (b != lc) {
        end.push_back(b);
        b = binup[0][b];
    }
    for (int i = (int) end.size() - 1; i >= 0; --i)
        st.push_back(end[i]);
    return move(st);
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    gr.resize(n);
    used.resize(n, -1);
    coll.resize(n);
    elems.resize(n);
    for (int i = 0; i < n; ++i) {
        coll[i] = i;
        elems[i].push_back(i);
    }
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        gr[x].push_back(i);
        gr[i].push_back(x);
    }
    tin.resize(n);
    tout.resize(n);
    binup.resize(20, vector<int>(n));
    dfs(0, 0);
    for (int i = 1; i < 20; ++i) {
        for (int j = 0; j < n; ++j)
            binup[i][j] = binup[i - 1][binup[i - 1][j]];
    }
    otr.resize(n);
    for (int i = 0; i < n; ++i) {
        cin >> otr[i].first >> otr[i].second;
    }
    p.resize(n, -1);
    sz.resize(n, 0);
    int m;
    cin >> m;
    vector<vector<int> > peop(m, vector<int>(4));
    for (int i = 0; i < n; ++i)
        ans = (ans * 1LL * take(otr[i])) % MOD;
    for (int i = 0; i < m; ++i) {
        for (int j = 0; j < 4; ++j) {
            cin >> peop[i][j];
            peop[i][j]--;
        }
        vector<int> cur1(get_put(peop[i][0], peop[i][1])), cur2(get_put(peop[i][2], peop[i][3]));
        for (int j = 0; j < (int) cur1.size(); ++j) {
            if (coll[cur1[j]] == coll[cur2[j]])
                continue;
            uniq(cur1[j], cur2[j]);
        }
        cout << ans << "\n";
    }
}
