from collections import deque

n = int(input())
p = list(map(lambda x: int(x) - 1, input().split()))
prices = [list(map(int, input().split())) for _ in range(n)]
graph = [[] for _ in range(n)]
for i in range(n - 1):
    graph[i + 1].append(p[i])
    graph[p[i]].append(i + 1)
m = int(input())
prev = [-1] * n
price_range = [rng for rng in prices]
ans = 1
for l, r in prices:
    ans *= r - l + 1
for _ in range(m):
    a, b, c, d = map(lambda x: int(x) - 1, input().split())
    a_path = []
    b_path = []
    if a == b:
        a_path = [a]
    else:
        used = [False] * n
        used[a] = True
        queue = deque()
        queue.append(a)
        pr = [-1] * n
        while queue:
            v = queue.popleft()
            for u in graph[v]:
                if not used[u]:
                    used[u] = True
                    pr[u] = v
                    if u == b:
                        break
                    queue.append(u)
        while b != -1:
            a_path.append(b)
            b = pr[b]
    if c == d:
        b_path = [c]
    else:
        used = [False] * n
        used[c] = True
        queue = deque()
        queue.append(c)
        pr = [-1] * n
        while queue:
            v = queue.popleft()
            for u in graph[v]:
                if not used[u]:
                    used[u] = True
                    pr[u] = v
                    if u == d:
                        break
                    queue.append(u)
        while d != -1:
            b_path.append(d)
            d = pr[d]
    for i in range(len(a_path)):
        b = a_path[i]
        d = b_path[i]
        x = b
        while prev[x] != -1:
            x = prev[x]
        b_root = x
        x = d
        while prev[x] != -1:
            x = prev[x]
        d_root = x
        if b_root == d_root:
            continue
        prev[b_root] = d_root
        ans //= price_range[b_root][1] - price_range[b_root][0] + 1
        ans //= prices[d_root][1] - prices[d_root][0] + 1
        price_range[d_root][0] = max(price_range[b_root][0], prices[d_root][0])
        price_range[d_root][1] = min(price_range[b_root][1], prices[d_root][1])
        ans *= (price_range[d_root][1] - price_range[d_root][0] + 1)
    print(ans % (int(1e9 + 7)))
