#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

#define fi first
#define se second

#define pb push_back
#define all(x) (x).begin(), (x).end()
#define sz(x) int((x).size())

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
typedef long double ld;

const int N = 2e5 + 5;
const int MOD = 1e9 + 7;

template<typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;

#define fbo find_by_order
#define ook order_of_key

mt19937 rng(time(0));

int n, m, tin[N], timer, tout[N], l[N], r[N], p[N];
vector<int> g[N];
int up[N][21];
bool used[N];

void dfs(int v, int p){
    tin[v] = timer++;
    for(auto to : g[v]){
        dfs(to, v);
    }
    tout[v] = timer;
}

int bpow(int a, int b){
    int res = 1;
    while(b){
        if(b & 1)res = (1LL * res * a) % MOD;
        a = (1LL * a * a) % MOD;
        b >>= 1;
    }
    return res;
}

bool isupper(int u, int v){
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int L[N], R[N], pred[N];

int get_root(int v){
    if(pred[v] == v)return v;
    return pred[v] = get_root(pred[v]);
}

int ans = 1;

void unite(int u, int v){
    u = get_root(u);
    v = get_root(v);
    if(u == v)return;
    pred[v] = pred[u];
    ans = (1LL * ans * bpow(max(R[u] - L[u] + 1, 0), MOD - 2)) % MOD;
    ans = (1LL * ans * bpow(max(R[v] - L[v] + 1, 0), MOD - 2)) % MOD;
    int NL = max(L[u], L[v]);
    int NR = min(R[u], R[v]);
    L[u] = NL, R[u] = NR;
    ans = (1LL * ans * max(R[u] - L[u] + 1, 0)) % MOD;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL

    cin >> n;

    for(int i = 2; i <= n; i++){
        cin >> p[i];
        g[p[i]].pb(i);
    }

    for(int i = 1; i <= n; i++){
        cin >> l[i] >> r[i];
    }

    dfs(1, 1);

    cin >> m;

    for(int i = 1; i <= n; i++){
        pred[i] = i;
        L[i] = l[i], R[i] = r[i];
        ans = (1LL * ans * (max(R[i] - L[i] + 1, 0))) % MOD;
    }



    while(m--){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<int> A, B, A2, B2;

        int v = a;
        while(!isupper(v, b)){
            A.pb(v);
            v = p[v];
        }
        A.pb(v);
        v = b;
        while(!isupper(v, a)){
            A2.pb(v);
            v = p[v];
        }

        v = c;
        while(!isupper(v, d)){
            B.pb(v);
            v = p[v];
        }
        B.pb(v);
        v = d;
        while(!isupper(v, c)){
            B2.pb(v);
            v = p[v];
        }

        reverse(all(A2));
        for(auto it : A2)A.pb(it);

        reverse(all(B2));
        for(auto it : B2)B.pb(it);

        for(int i = 0; i < sz(A); i++){
            unite(A[i], B[i]);
        }

        cout << ans << "\n";
    }

    return 0;
}
