#include "bits/stdc++.h"
using namespace std;

// cd /mnt/commons/
// g++ -DHOME -Wall -Wextra -DGLIBCXX_DEBUG 1.cpp && ./a.out 

// #define int long long
#define ll long long


#define all(a) a.begin(), a.end()
#define vc vector
#define ld long double
#define forn(i , n) for(int i = 0; i < (int)n; i++)
#define fri(st , en , step) for(int i = st; i < (int)en ; i+=step)
#define frj(st , en , step) for(int j = st; j < (int)en ; j+=step)
#define sz(a) ((int)a.size())
#define pb push_back
#define mp make_pair


template<typename T>
ostream& operator<<(ostream& a, vc<T> b){
	forn(i , sz(b) - 1) a << b[i] << " ";
	if(sz(b)) a << b.back(); 
	return a;
}






#ifdef HOME
	#define o(a) << "[" << #a << ": " << a << "] "
#else
	#define o(a) ;
#endif



class debug{
public:
	debug(){}
	~debug(){
		#ifdef HOME
			cerr << endl;
		#endif
	}
	template<typename T>
	debug& operator<<(T a){
		#ifdef HOME
			cerr << a;
		#endif
		return *this;
	}
};

mt19937 rnd(1211);

template<typename T>
inline bool cmin(T &a, T b){
	if(a > b){
		a = b;
		return 1;
	}
	return 0;
}

template<typename T>
inline bool cmax(T &a, T b){
	if(a < b){
		a = b;
		return 1;
	}
	return 0;
}

const int MOD = 1e9 + 7;
const ld e = 1e-9;
// const int inf = 1e18;
const int maxn = 2e5 + 10;

vc<int> g[maxn];
int p[maxn] , A[2][maxn] , h[maxn] , B[2][maxn] , H[(int) 1e8 + 10];

void dfs(int a){
	for(int x : g[a]) {
		h[x] = h[a] + 1;
		dfs(x);
	}
}

int lca(int a , int b){
	while(a != b){
		if(h[b] > h[a]){
			b = p[b];
		}
		else a = p[a];	
	}
	return a;
}



int P[maxn] , use[maxn];

int find(int a){
	if(P[a] == a) return a;
	P[a] = find(P[a]);
	return P[a];
}
void merge(int a , int b){
	debug() o(a) o(b);
	int x = find(a), y = find(b);
	if(x == y) return;
	if(rnd() % 2){
		P[x] = y;
		use[x] = 0;
		cmin(A[1][y] , A[1][x]);
		cmax(A[0][y] , A[0][x]);
	}
	else{
		use[y] = 0;
		P[y] = x;
		cmin(A[1][x] , A[1][y]);
		cmax(A[0][x] , A[0][y]);
	}
}


int pw(int a , int b){
	if(b == 0) return 1;
	if(b % 2) return 1ll * a * pw(a , b - 1) % MOD;
	int x = pw(a , b / 2);
	return 1ll * x * x % MOD;
}

inline void run(){
	int n;
	cin >> n;
	forn(i  , n) {
		P[i] = i;
		use[i] = 1;
	}
	fri(1 , n , 1){
		cin >> p[i];
		p[i]--;
		g[p[i]].pb(i);
	}	
	dfs(0);
	forn(i , n){
		cin >> A[0][i] >> A[1][i];
		B[0][i] = A[0][i];
		B[1][i] = A[1][i];
			
	}
	int m;
	cin >> m;
	while(m--){
		
		int a , b , c , d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;

		
		
		int l1 = lca(a , b)  ,l2 = lca(c , d);
		int len = h[a] + h[b] - 2*h[l1] + 1;
		
		int iter = 0;
		while(a != l1 ){
			H[iter++] = a;
			a = p[a];
		}
		H[iter++] = l1;
		
		iter = len - 1;
		while(b != l1 ){
			H[iter--] = b;
			b = p[b];
		}
		debug() o(len) o(l1) o(a) o(b);
		// forn(i ,  len) cout << H[i] << " ";
		// cout << "\n"; 

		iter = 0;
		while(c != l2 ){
			merge(c , H[iter++]);
			c = p[c];
		}
		merge(l2 , H[iter++]);
		iter = len - 1;
		while(d != l2 ){
			merge(d , H[iter--]);
			d = p[d];
		}
		ll ans = 1;
		forn(i , n){
			if(!use[i]) continue;
			
			if(A[0][i] > A
				[1][i]) ans = 0;
			else ans = 1ll * ans * (A[1][i] - A[0][i] + 1) % MOD; 
		}
		cout << ans << "\n";
	}
	// ll ans = 1;

}


signed main(){
	cin.tie(0);
	ios_base::sync_with_stdio(0);
	int tt = 1;
	// cin >> tt;
	while(tt--){
		run();
	}
	return 0;
}