#include <bits/stdc++.h>
///#include <ext/pb_ds/assoc_container.hpp>

#define ibase ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
#define fi first
#define se second
#define all(v) (v).begin(), (v).end()

#define int long long

using namespace std;
///using namespace __gnu_pbds;
using ll = long long;
using ld = long double;
using pii = pair <int, int>;

ll const mod = 1e9 + 7;
int const N = 2e5 + 4;
vector <int> g[N];
int h[N], l[N], r[N], pr[N], sz[N], pd[N];

void h_dfs(int v, int _h = 0){
    h[v] = _h;
    for(auto u : g[v]){
        h_dfs(u, _h + 1);
    }
    return;
}

int get_p(int v){
    if(v == pd[v]){
        return v;
    }
    return (pd[v] = get_p(pd[v]));
}

void uni(int a, int b){
    a = get_p(a);
    b = get_p(b);
    if(a == b){ return;}
    if(sz[a] > sz[b]){
        swap(a, b);
    }
    pd[a] = b;
    sz[b] += sz[a];
    l[b] = max(l[b], l[a]);
    r[b] = min(r[b], r[a]);
    return;
}

vector <int> get(int a, int b){
    vector <int> v1;
    vector <int> v2;
    //cout << "WAY  " << a + 1 << ' ' << b + 1 << " : ";
    while(h[a] > h[b]){
        //cout << " ?? ";
        v1.push_back(a);
        a = pr[a];
    }
    while(h[b] > h[a]){
        //cout << " ! ";
        v2.push_back(b);
        b = pr[b];
    }
    while(a != b){
        v1.push_back(a);
        v2.push_back(b);
        a = pr[a];
        b = pr[b];
    }
    v1.push_back(a);
    reverse(all(v2));
    for(auto w : v2){
        v1.push_back(w);
    }
//    for(auto w : v1){
//        cout << w << ' ';
//    }
//    cout << '\n';
    return v1;
}

signed main(){
    ibase;
    int n;
    cin >> n;
    for(int i = 1; i < n; ++i){
        int p;
        cin >> p;
        --p;
        g[p].push_back(i);
        pr[i] = p;
    }
    for(int i = 0; i < n; ++i){
        cin >> l[i] >> r[i];
        pd[i] = i;
    }
    h_dfs(0);
    int m;
    cin >> m;
    bool f = 0;
    while(m --> 0){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a; --b; --c; --d;
        vector <int> v1 = get(a, b);
        vector <int> v2 = get(c, d);
        for(int i = 0; i < (int)v1.size(); ++i){
            uni(v1[i], v2[i]);
            //cout << "way " << v1[i] + 1 << ' ' << v2[i] + 1 << '\n';
        }
        ll ans = 1;
        if(f){
            cout << 0 << '\n';
            continue;
        }
        for(int i = 0; i < n; ++i){
            if(pd[i] != i){ continue;}
            if(l[i] > r[i]){
                f = 1;
                break;
            }
            //cout << "    " << l[i] << ' ' << r[i] << '\n';
            ans *= ((ll)r[i] - (ll)l[i] + 1ll);
            ans %= mod;
        }
        if(f){
            cout << 0 << '\n';
            continue;
        }
        cout << ans << '\n';
    }
}
