#pragma GCC target("avx2")
#include <bits/stdc++.h>
using namespace std;
#define int long long
#define all(x) x.begin(), x.end()
vector<pair<int, int>> pr;
const int mod = 1e9 + 7;
struct dsu {
    vector<int> p, sz;
    vector<pair<int, int>> pr;
    void init(int n) {
        p.resize(n, -1);
        sz.resize(n, 1);
        pr.resize(n);
    }
    int parent(int cur) {
        if (p[cur] == -1) return cur;
        p[cur] = parent(p[cur]);
        return p[cur];
    }
    void merge(int a, int b) {
        a = parent(a);
        b = parent(b);
        if (a == b) return;
        if (sz[a] < sz[b]) swap(a, b);
        p[b] = a;
        sz[a] += sz[b];
        pr[a].first = max(pr[a].first, pr[b].first);
        pr[a].second = min(pr[a].second, pr[b].second);
    }
    int amo(int cur) {
        if (pr[cur].second < pr[cur].first) return 0;
        return pr[cur].second - pr[cur].first + 1;
    } 
};
vector<int> path;
bool fnd = false;
vector<vector<int>> gr;
void pth(int cur, int dest, int p = -1) {
    if (!fnd) path.push_back(cur);
    if (cur == dest) {
        fnd = true;
        return;
    }
    for (auto i : gr[cur]) { 
        if (i != p) {
            pth(i, dest, cur);
            if (fnd) return;
        }
    }
    if (!fnd) path.pop_back();
}
signed main() {
    ios_base::sync_with_stdio(false);
    int n;
    cin >> n;
    gr.resize(n);
    for (int i = 1; i < n; i++) {
        int t;
        cin >> t;
        t--;
        gr[i].push_back(t);
        gr[t].push_back(i);
    }
    dsu ds;
    ds.init(n);
    for (auto& i : ds.pr) {
        cin >> i.first >> i.second;
    }
    int m;
    cin >> m;
    
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        fnd = false;
        path.clear();
        pth(a, b);
        vector<int> p1 = path;
        path.clear();
        fnd = false;
        pth(c, d);
        for (int i = 0; i < p1.size(); i++) {
            if (ds.parent(p1[i]) == ds.parent(path[i])) continue;
            ds.merge(p1[i], path[i]);
        }
        int ans = 1;
        for (int i = 0; i < n; i++) {
            if (ds.p[i] == -1) {
                ans = (ans * ds.amo(i)) % mod;
            }
        }
        cout << ans << '\n';
    }
} 
