#pragma GCC optimize("O3")
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
using namespace __gnu_pbds;
#define int long long
#define all(x) (x).begin(), (x).end()
#define fastio cin.tie(0), ios_base::sync_with_stdio(false)
constexpr int INF = (1ll << 61);
constexpr int mod = 1e9 + 7;
namespace s1 {

    vector<vector<signed>> g;

    int binpow(int a, int p) {
        int res = 1;
        while (p) {
            if (p % 2) {
                res *= a;
                res %= mod;
                p--;
            } else {
                a = (a * a) % mod;
                p /= 2;
            }
        }
        return res;
    }

    int obr(int x) {
        return binpow(x, mod - 2);
    }


    vector<signed> tin, tout;

    signed t = 0;

    void dfs1(int v) {
        tin[v] = t++;
        for (auto w: g[v]) dfs1(w);
        tout[v] = t++;
    }

    bool isp(signed u, signed v) { //is u pr of v
        return tin[u] <= tin[v] && tout[u] >= tout[v];
    }

    vector<signed> p;

    int res = 1;
    vector<pair<signed, signed>> vp;
    struct cell {
        signed l, r;
        signed sz;
    };

    struct dsu {
        vector<signed> p;
        vector<cell> v;

        dsu(int n) {
            p.resize(n);
            for (int i = 0; i < n; ++i) p[i] = i;
            v.resize(n);
            for (int i = 0; i < n; ++i) {
                v[i].sz = 1;
                v[i].l = vp[i].first;
                v[i].r = vp[i].second;
                res = (res * (v[i].r - v[i].l + 1)) % mod;
            }
        }

        signed fnd(signed v) {
            if (p[v] == v) return v;
            return p[v] = fnd(p[v]);
        }

        void merge(signed a, signed b) {
            a = fnd(a);
            b = fnd(b);
            if (a == b) return;
            if (v[a].sz < v[b].sz) swap(a, b);
            v[a].sz += v[b].sz;
            p[b] = a;
            if (v[b].r - v[b].l + 1 > 0) res = (res * obr(v[b].r - v[b].l + 1)) % mod;
            if (v[a].r - v[a].l + 1 > 0) res = (res * obr(v[a].r - v[a].l + 1)) % mod;
            v[a].l = max(v[a].l, v[b].l);
            v[a].r = min(v[a].r, v[b].r);
            res = (res * max(v[a].r - v[a].l + 1, 0)) % mod;
        }

    };

    void solve1(int n, vector<vector<signed>>& gv, vector<signed>& pv) {
        g = gv;
        p.resize(n);
        tin.resize(n);
        tout.resize(n);
        p = pv;
        vp.resize(n);
        for (auto& i : vp) cin >> i.first >> i.second;
        dfs1(0);
        dsu d(n);
        int m;
        cin >> m;
        for (int i = 0; i < m; ++i) {
            signed a, b, c, dd;
            cin >> a >> b >> c >> dd;
            a--, b--, c--, dd--;
            vector<signed> va, vb, vc, vd;
            while (!isp(a, b)) va.push_back(a), a = p[a];
            va.push_back(a);
            while (b != a) vb.push_back(b), b = p[b];

            vc.reserve(va.size() + vb.size());
            while (!isp(c, dd)) vc.push_back(c), c = p[c];
            vc.push_back(c);
            while (dd != c) vd.push_back(dd), dd = p[dd];
            reverse(all(vd));
            reverse(all(vb));
            for (auto i : vb) va.push_back(i);
            for (auto i : vd) vc.push_back(i);
            signed ind = 0;
            while (ind < va.size()) {
                d.merge(va[ind], vc[ind]);
                ind++;
            }
            cout << res << '\n';
        }
    }

}

namespace s2 {
    int parr[200000];
    int ph;
    struct Node {
        int h, sz;
    };
    Node merge(Node a, Node b) {
        return {(a.h + (b.h * parr[a.sz]) % mod) % mod, a.sz + b.sz};
    }

    struct st {
        vector<Node> t;
        vector<signed> a;

        void build(int v, int vl, int vr) {
            if (vl == vr) {
                t[v].h = a[vl];
                t[v].sz = 1;
                return;
            }
            int m = (vl + vr) / 2;
            build(v * 2, vl, m);
            build(v * 2 + 1, m + 1, vr);
            t[v] = merge(t[v * 2], t[v * 2 + 1]);
        }

        void con(vector<signed>& va) {
            a = va;
            t.resize(4 * a.size());
        }

        Node mg(int v, int vl, int vr, int l, int r) {
            if (vl >= l && vr <= r) return t[v];
            int m = (vl + vr) / 2;
            Node res = {0, 0};
            if (l <= m) res = mg(v * 2, vl, m, l, r);
            if (r > m) res = merge(res, mg(v * 2 + 1, m + 1, vr, l, r));
            return res;
        }

        int get(int l, int r) {
            return mg(1, 0, a.size() - 1, l, r).h;
        }

        void mu(int v, int vl, int vr, int ind, int to) {
            if (vl == vr) {
                t[v].h = to;
                return;
            }
            int m = (vl + vr) / 2;
            if (ind <= m) mu(v * 2, vl, m, ind, to);
            else mu(v * 2 + 1, m + 1, vr, ind, to);
            t[v] = merge(t[v * 2], t[v * 2 + 1]);
        }
        
        void update(int ind, int to) {
            mu(1, 0, a.size() - 1, ind, to);
        }
    };
    
    

    vector<signed> p;
    vector<vector<signed>> g;


    void solve2(int n, vector<vector<signed>>& gv, vector<signed>& pv) {
        g = gv;
        p = pv;
        random_device rd;
        mt19937 mt(rd());
        //ph = mt() % 
    }

}

signed main() {
    fastio;
    int n;
    cin >> n;
    vector<vector<signed>> g;vector<signed> p;
    g.resize(n);
    p.resize(n);
    bool r = true;
    for (int i = 1; i < n; ++i) cin >> p[i], p[i]--, g[p[i]].push_back(i);
    for (int i = 1; i < n; ++i) if (p[i] != i - 1) r = false;
    if (false) {
        s2::solve2(n, g, p);
    } else {
        s1::solve1(n, g, p);
    }
}
