#include<bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

//#define _GLICXX_DEBUG
#define endl '\n'
#define ss second
#define ff first
#define all(a) (a).begin(), (a).end()
#define int long long

const ll INF = 2e18 + 10, mod = 1e9 + 7;

vector<pair<int, int>> a;
vector<int> g[200000];
int tin[200000], tout[200000], pr[200000], used[200000];
int t = 0;

void dfs(int v, int p) {
    tin[v] = t++;
    for (auto u: g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = t++;
}

bool check(int x, int b) {
    return tin[x] <= tin[b] && tout[x] >= tout[b];
}

int binpow(int x, int y) {
    if (y == 0) return 1;
    if (y % 2 == 0) {
        int tt = binpow(x, y / 2);
        return tt * tt % mod;
    }
    return binpow(x, y - 1) * x % mod;
}

pair<int, int> cr(pair<int, int> x, pair<int, int> y) {
    return {max(x.ff, y.ff), min(x.ss, y.ss)};
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        p--;
        g[i].push_back(p);
        g[p].push_back(i);
        pr[i] = p;
    }

    int mn = 1;
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        a.push_back({l, r});
        mn *= (r - l + 1);
        mn %= mod;
    }

    vector<pair<int, int>> b = a;
    dfs(0, 0);

    int q;
    cin >> q;
    while (q--) {
        int x1, y1, x2, y2;
        cin >> x1 >> y1 >> x2 >> y2;
        x1--, y1--, x2--, y2--;
        vector<int> t1;
        while (!check(x1, y1)) {
            t1.push_back(x1);
            x1 = pr[x1];
        }
        t1.push_back(x1);
        vector<int> t11;
        while (x1 != y1) {
            t11.push_back(y1);
            y1 = pr[y1];
        }
        reverse(all(t11));
        for (auto i: t11) {
            t1.push_back(i);
        }

        vector<int> t2;
        while (!check(x2, y2)) {
            t2.push_back(x2);
            x2 = pr[x2];
        }
        t2.push_back(x2);
        vector<int> t22;
        while (x2 != y2) {
            t22.push_back(y2);
            y2 = pr[y2];
        }
        reverse(all(t22));
        for (auto i: t22) {
            t2.push_back(i);
        }


        int fl = 0;
        for (int i = 0; i < t1.size(); ++i) {
//            cout << t1[i] << " " << t2[i] << endl;
            b[t1[i]] = cr(b[t1[i]], b[t2[i]]);
            b[t2[i]] = b[t1[i]];
        }

        int ans1 = 1, ans2 = 1;
        for (int i = 0; i < t1.size(); ++i) {
            b[t1[i]] = cr(b[t1[i]], b[t2[i]]);
            b[t2[i]] = b[t1[i]];
//            cout << b[t1[i]].ff <<" " << b[t1[i]].ss << endl;
        }

        for (int i = 0; i < t1.size(); ++i) {
            if (b[t1[i]].ff > b[t1[i]].ss) {
                fl = 1;
                break;
            }
            if (!used[t2[i]]) ans2 *= (b[t1[i]].ss - b[t1[i]].ff + 1);
            ans2 %= mod;
            if (!used[t1[i]]) {
                ans1 *= (a[t1[i]].ss - a[t1[i]].ff + 1);
                ans1 %= mod;
            }
            used[t1[i]] = 1;
            if (!used[t2[i]]) {
                ans1 *= (a[t2[i]].ss - a[t2[i]].ff + 1);
                ans1 %= mod;
            }
            used[t2[i]] = 1;
        }

        if (fl) {
            cout << 0 << endl;
        } else {
            cout << mn * binpow(ans1, mod - 2) % mod * ans2 % mod << endl;
        }

        for (int i = 0; i < t1.size(); ++i) {
//            b[t1[i]] = a[t1[i]];
//            b[t2[i]] = a[t2[i]];
            used[t1[i]] = 0;
            used[t2[i]] = 0;
        }
    }
}
