#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 3001;
const long long mod = 1e9 + 7;
long long n, p[maxn], l[maxn], r[maxn], m, a[maxn], b[maxn], c[maxn], d[maxn];
vector<int> v[maxn], g[maxn];

void read(){
    cin >> n;
    for(int i = 2;i <= n;i++){
        cin >> p[i];
        v[p[i]].push_back(i);
        v[i].push_back(p[i]);
    }
    for(int i = 1;i <= n;i++){
        cin >> l[i] >> r[i];
    }
    cin >> m;
}

vector<int> path1, path2;
int used[maxn];

void dfs(int ver, int fin, vector<int> path, int idx){
    if(ver == fin){
        if(idx == 1)
            path1 = path;
        else
            path2 = path;
        return;
    }
    used[ver] = 1;
    for(int x : v[ver]){
        if(!used[x]){
            path.push_back(x);
            dfs(x, fin, path, idx);
            path.pop_back();
        }
    }
}

long long ans = 1;

long long maxl, minr;
void dfsc(int ver){
    used[ver] = 1;
    maxl = max(maxl, l[ver]);
    minr = min(minr, r[ver]);
    for(int x : g[ver]){
        if(!used[x])
            dfsc(x);
    }
}

void query(int a, int b, int c, int d){
    memset(used, 0, sizeof(used));
    dfs(a, b, {a}, 1);
    memset(used, 0, sizeof(used));
    dfs(c, d, {c}, 2);
    memset(used, 0, sizeof(used));
    long long ans = 1;
    vector<int> prior;
    for(int i = 0;i < path1.size();i++){
        int x1 = path1[i], x2 = path2[i];
        g[x1].push_back(x2);
        g[x2].push_back(x1);
    }
    for(int i = 1;i <= n;i++){
        if(!used[i]){
            maxl = l[i], minr = r[i];
            dfsc(i);
            if(maxl > minr) ans = 0;
            else ans = (ans * (minr - maxl + 1)) % mod;
        }
    }
    cout << ans << endl;
}

void solve(){
    for(int i = 1;i <= m;i++){
        cin >> a[i] >> b[i] >> c[i] >> d[i];
        query(a[i], b[i], c[i], d[i]);
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
