#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 3001;
const long long mod = 1e9 + 7;
int n, p[maxn], m, a[maxn], b[maxn], c[maxn], d[maxn], leader[maxn], maxl[maxn], minr[maxn];
long long l[maxn], r[maxn];
vector<int> v[maxn];
bool subtask = true;
void read(){
    cin >> n;
    for(int i = 2;i <= n;i++){
        cin >> p[i];
        v[p[i]].push_back(i);
        v[i].push_back(p[i]);
        if(p[i] != i - 1)
            subtask = false;
    }
    for(int i = 1;i <= n;i++){
        cin >> l[i] >> r[i];
        leader[i] = i;
        maxl[i] = l[i];
        minr[i] = r[i];
    }
    cin >> m;
}

vector<int> path1, path2;
int used[maxn];

void dfs(int ver, int fin, vector<int> path, int idx){
    if(ver == fin){
        if(idx == 1)
            path1 = path;
        else
            path2 = path;
        return;
    }
    used[ver] = idx;
    for(int x : v[ver]){
        if(used[x] != idx){
            path.push_back(x);
            dfs(x, fin, path, idx);
            path.pop_back();
        }
    }
}

long long ans = 1;

int find_leader(int x){
    if(leader[x] == x)
        return x;
    maxl[leader[x]] = max(maxl[leader[x]], maxl[x]);
    minr[leader[x]] = min(minr[leader[x]], minr[x]);
    return leader[x] = find_leader(leader[x]);
}

void query(int a, int b, int c, int d){
    memset(used, 0, sizeof(used));
    if(subtask){
        path1.clear();
        path2.clear();
        for(int i = min(a, b);i <= max(a, b);i++)
            path1.push_back(i);
        for(int i = min(c, d);i <= max(c, d);i++)
            path2.push_back(i);
        if(a > b) reverse(path1.begin(), path1.end());
        if(c > d) reverse(path2.begin(), path2.end());
    }
    else{
        dfs(a, b, {a}, 1);
        dfs(c, d, {c}, 2);
    }
    long long ans = 1;
    for(int i = 0;i < path1.size();i++){
        int x1 = path1[i], x2 = path2[i];
        x1 = find_leader(x1);
        x2 = find_leader(x2);
        if(leader[x1] != leader[x2]){
            leader[x1] = leader[x2];
            maxl[x2] = max(maxl[x2], maxl[x1]);
            minr[x2] = min(minr[x2], minr[x1]);
        }
    }
    for(int i = 1;i <= n;i++){
        int x = find_leader(i);
        if(used[x] != 3){
            if(maxl[x] > minr[x]) ans = 0;
            else ans = (ans * (minr[x] - maxl[x] + 1)) % mod;
            used[x] = 3;
        }
    }
    cout << ans << endl;
}

void solve(){
    for(int i = 1;i <= m;i++){
        cin >> a[i] >> b[i] >> c[i] >> d[i];
        query(a[i], b[i], c[i], d[i]);
    }
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    read();
    solve();
    return 0;
}
