#include <bits/stdc++.h>
using namespace std;
typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;
#define fi first
#define se second
template<typename T1, typename T2>
bool chmin(T1 &a, T2 b) {
    if (a > b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T1, typename T2>
bool chmax(T1 &a, T2 b) {
    if (a < b) {
        a = b;
        return true;
    }
    return false;
}
template<typename T>
ostream& operator << (ostream &out, vector<T> a);
template<typename T>
ostream& operator << (ostream &out, set<T> a);
template<typename T>
ostream& operator << (ostream &out, vector<T> a) {
    out << "{";
    for (int i = 0; i < a.size(); i++) {
        out << a[i];
        if (i + 1 == a.size()) {
            out << "}";
        } else {
            out << ", ";
        }
    }
    return out;
}
template<typename T>
ostream& operator << (ostream &out, set<T> a) {
    vector<T> b(a.begin(), a.end());
    out << b;
    return out;
}
#define debug(x...) cerr << "[" << #x << " : " << x << "]\n";
const int mod = (int)1e9 + 7;
const int inf = (int)1e9 + 1;
const ll infll = 1'000'000'000'000'000'000 + 1;
mt19937_64 rnd(21281337711);
int mul(int a, int b) {
    return (1ll * a * b) % mod;
}
int binpow(int a, int b) {
    int res = 1;
    while (b) {
        if (b & 1) res = mul(res, a);
        a = mul(a, a);
        b >>= 1;
    }
    return res;
}
int divide(int a, int b) {
    return mul(a, binpow(b, mod - 2));
}
int ans;
struct dsu  {
    vector<int> p, r, L, R;
    dsu(vector<int> ll, vector<int> rr) : L(ll), R(rr), p(ll.size()), r(ll.size()) {
        iota(p.begin(), p.end(), 0);
    }
    int find(int v) {
        return (p[v] == v) ? v : p[v] = find(p[v]);
    }
    bool join(int a, int b) {
        a = find(a), b = find(b);
        if (a == b) return false;
        if (r[a] < r[b]) swap(a, b);
        if (r[a] == r[b]) r[a]++;
        p[b] = a;
        if (ans == 0) return true;
        ans = divide(ans, R[a] - L[a] + 1);
        ans = divide(ans, R[b] - L[b] + 1);
        chmin(R[a], R[b]);
        chmax(L[a], L[b]);
        if (L[a] > R[a]) {
            ans = 0;
        } else {
            ans = mul(ans, R[a] - L[a] + 1);
        }
        return true;
    }
};


void solve_case() {
    int n;
    cin >> n;
    vector<vector<int>> g(n);
    vector<int> par(n);
    for (int i = 1; i < n; i++) {
        int x;
        cin >> x;
        x--;
        par[i] = x;
        g[x].push_back(i);
    }
    vector<int> tin(n), tout(n);
    int timer = 0;
    function<void(int)> dfs = [&](int v) {
        tin[v] = timer++;
        for (int u : g[v]) {
            dfs(u);
        }
        tout[v] = timer - 1;
    };
    dfs(0);
    function<bool(int, int)> ancestor = [&](int a, int b) {
        return tin[a] <= tin[b] && tin[b] <= tout[a];
    };
    function<vector<int>(int, int)> get_path = [&](int x, int y) {
        vector<int> ret;
        while (!ancestor(x, y)) {
            ret.push_back(x);
            x = par[x];
        }
        ret.push_back(x);
        vector<int> r;
        while (y != x) {
            r.push_back(y);
            y = par[y];
        }
        reverse(r.begin(), r.end());
        for (int v : r) ret.push_back(v);
        return ret;
    };
    vector<int> l(n), r(n);
    for (int i = 0; i < n; i++) cin >> l[i] >> r[i];
    dsu ds(l, r);
    ans = 1;
    for (int i = 0; i < n; i++) ans = mul(ans, r[i] - l[i] + 1);
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        vector<int> p1 = get_path(a, b), p2 = get_path(c, d);
        for (int i = 0; i < (int)p1.size(); i++) {
            ds.join(p1[i], p2[i]);
        }
        cout << ans << "\n";
    }
}
int32_t main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    //freopen("inputik.txt", "r", stdin);
    int T = 1;
    // cin >> T;
    while (T--) {
        solve_case();
    }
    return 0;
}