#define _CRT_SECURE_NO_WARNINGS
#include<iostream>
#include<algorithm>
#include<vector>
#include<set>
#include<map>
#include<vector>
#include<string>
#include<math.h>
#include<bitset>
#include<random>

using namespace std;

#define int long long
#define all(v) v.begin(), v.end()
#define endl '\n'
using ll = long long;
using ld = long double;

const int N = 1e5 + 9, X = 1 << 20, M = 1e9 + 7;
const long long INF = 1e18 + 9;


int l[N], r[N];
pair<int, int> seg[N];
int col[N];
vector<int> v[N];

pair<int, int> per(pair<int, int> a, pair<int, int> b) {
	return { max(a.first, b.first), min(a.second, b.second) };
}

signed main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
#else
	cin.tie(0);
	ios_base::sync_with_stdio(0);
#endif

	
	int n, m;
	cin >> n;
	for (int i = 0; i < n - 1; i++) {
		int x;
		cin >> x;
	}
	for (int i = 1; i <= n; i++) {
		int l, r;
		cin >> l >> r;
		seg[i] = { l, r };
		v[i].push_back(i);
		col[i] = i;
	}
	cin >> m;
	for (int i = 0; i < m; i++) {
		int l1, r1, l2, r2;
		cin >> l1 >> r1 >> l2 >> r2;
		for (int i = 0; i < r1 - l1 + 1; i++) {
			int a = l1 + i;
			int b = l2 + i;
			if (col[a] == col[b])
				continue;
			if (v[b].size() < v[a].size())
				swap(a, b);
			for (auto x : v[a]) {
				v[b].push_back(x);
				col[x] = col[b];
			}
			v[a].clear();
			seg[b] = per(seg[a], seg[b]);
			
		}
		int ans = 1;
		for (int i = 1; i <= n; i++) {
			if (!v[i].size() || seg[i].first > seg[i].second)
				continue;
			ans = ( ans * (seg[i].second - seg[i].first + 1) ) % M;
		}
		cout << ans << endl;
	}


}