#include <bits/stdc++.h>
#define ll long long

#define F first
#define S second

#define all(f) f.begin(),f.end()
#define rall(f) f.rbegin(),f.rend()

#define fori(i,j,n) for(ll i = j; i < n; ++i)

using namespace std;

vector<vector<int> > f;
vector<pair<ll,ll> > dt;

vector<int> comp;
vector<int> used;

bool DFS(int v, int last){
    used[v] = 1;
    if(v == last){
        comp.push_back(v);
        return 1;
    }
    bool z = 0;
    for(int u : f[v]){
        if(used[u])continue;
        bool z1 = DFS(u, last);
        if(z1)z = 1;
    }
    if(z)comp.push_back(v);
    return z;
}

pair<ll,ll> getInstersect(ll l1, ll r1, ll l2, ll r2){
    if(r1 >= l2){
        return {max(l1,l2), min(r1,r2)};
    }
    return {1,0};
}

int main() {
    /*
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
     */
    int n;
    cin >> n;
    f.resize(n);
    fori(i,0,n-1){
        int x;
        cin >> x;
        x--;
        f[i+1].push_back(x);
        f[x].push_back(i+1);
    }
    fori(i,0,n){
        ll l,r;
        cin >> l >> r;
        dt.push_back({l,r});
    }
    int m;
    cin >> m;
    fori(i,0,m){
        int a,b,c,d;
        cin >> a >> b >> c >> d;
        a--,b--,c--,d--;
        used.resize(n, 0);
        DFS(a, b);
        vector<int> c1 = comp;
        comp.clear();
        used.clear();
        used.resize(n, 0);
        DFS(c, d);
        vector<int> c2 = comp;
        comp.clear();
        ll ans = 1;
        //cout << c1.size() << " " << c2.size() << '\n';
        set<int> towns;
        set<pair<int,int> > ts;
        fori(j,0,c1.size()){
            pair<ll,ll> pr = getInstersect(dt[c1[j]].F, dt[c1[j]].S, dt[c2[j]].F, dt[c2[j]].S);
            dt[c1[j]] = pr;
            dt[c2[j]] = pr;
            if(ts.find({min(c1[j],c2[j]), max(c1[j],c2[j])}) != ts.end())continue;
            ans *= (pr.S - pr.F + 1);
            towns.insert(c1[j]);
            towns.insert(c2[j]);
            ts.insert({min(c1[j],c2[j]), max(c1[j],c2[j])});
        }
        fori(j,0,n){
            if(towns.find(j) != towns.end())continue;
            ans *= (dt[j].S - dt[j].F + 1);
        }
        //ans /= (2 * c1.size());
        cout << ans << '\n';
        used.clear();
    }
    return 0;
}
