#include <bits/stdc++.h>
#define fr(i, a, b) for (int i = a; i <= b; i++)
#define rf(i, a, b) for (int i = a; i >= b; i--)
#define fe(x, y) for(auto& x : y)

#define fi first
#define se second
#define pb push_back

#define all(x) x.begin(), x.end()
#define pw(x) (1LL << (x))
#define sz(x) (int)x.size()

using namespace std;

template <typename T>
using ve = vector < T >;

template <typename T>
bool umx(T& a, T b) { return a < b ? a = b, 1 : 0; }

template <typename T>
bool umn(T& a, T b) { return a > b ? a = b, 1 : 0; }

using ll = long long;
using pll = pair <ll, ll>;
using pii = pair <int, int>;


const ll OO = 1e18;
const int oo = 1e9 + 10000;
const int N = 2e5 + 100;
const int mod = 1e9 + 7;

inline int add(int a, int b) {
    return a + b >= mod ? a + b - mod : a + b;
}
inline void adds(int& a, int b) {
    a = add(a, b);
}
inline int sub(int a, int b) {
    return a - b < 0 ? a - b + mod : a - b;
}
inline void subs(int& a, int b) {
    a = sub(a, b);
}
inline int mul(int a, int b) {
    return 1LL * a * b % mod;
}
inline void muls(int& a, int b) {
    a = mul(a, b);
}
inline int bpow(int a, int n) {
    int res = 1;
    for (; n; muls(a, a), n >>= 1) if(n&1) muls(res, a);
    return res;
}
inline int inv(int a) {
    return bpow(a, mod - 2);
}

ve <int> G[N];
int L[N], R[N];
int p[N];
int n;

int tim;
int tin[N];
int tout[N];

void dfs(int u) {
    tin[u] = tim++;
    fe(to, G[u]) {
        dfs(to);
    }
    tout[u] = tim;
}

bool isupper(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}
int ans = 1;


int P[N];

int get(int v) {
    return P[v] == v ? v : P[v] = get(P[v]);
}


void uni(int u, int v) {
    u = get(u);
    v = get(v);
    if(u == v) return;
    muls(ans, inv(R[u] - L[u] + 1));
    muls(ans, inv(R[v] - L[v] + 1));
    P[u] = v;
    R[v] = min(R[v], R[u]);
    L[v] = max(L[v], L[u]);
    if (R[v] < L[v]) ans = 0;
    else muls(ans, R[v] - L[v] + 1);
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif // LOCAL
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> n;
    fr(i, 0, n - 1) P[i] = i;
    fr(i, 1, n - 1) {
        cin >> p[i]; p[i]--;
        G[p[i]].pb(i);
    }
    fr(i, 0, n - 1) {
        cin >> L[i] >> R[i];
    }
    dfs(0);

    fr(i, 0, n - 1) {
        muls(ans, R[i] - L[i] + 1);
    }
    int m; cin >> m;
    fr(i, 0, m - 1) {
        int u, v, a, b;
        cin >> u >> v >> a >> b; u--; v--; a--; b--;
        ve <int> hv1;
        {
            while (!isupper(u, v)) {
                hv1.pb(u);
                u = p[u];
            }
            ve <int> H;
            while(u != v) {
                H.pb(v);
                v = p[v];
            }
            H.pb(v);
            reverse(all(H));
            fe(x, H) {
                hv1.pb(x);
            }
        }
        ve <int> h2;
        {
            while (!isupper(a, b)) {
                h2.pb(a);
                a = p[a];
            }
            ve <int> H;
            while(a != b) {
                H.pb(b);
                b = p[b];
            }
            H.pb(b);
            reverse(all(H));
            fe(x, H) {
                h2.pb(x);
            }
        }
        assert(sz(hv1) == sz(h2));
//        return 0;
        fr(i, 0, sz(hv1) - 1) {
            int u = hv1[i];
            int v = h2[i];
            uni(u, v);

        }
        cout << ans << "\n";
    }


    return 0;
}
