/*
 * please ac
 * /free
 * wa2 protection
 * wa2 protection
 * wa2 protetcion
 */

#include <iostream>
#include <iomanip>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <vector>
#include <random>
#include <bitset>

using namespace std;

typedef long long ll;
typedef long double ld;

#define f(i, l, r) for (int i = (l); i < (r); i++)
#define sz(a) (int)(a).size()
#define all(a) (a).begin(), (a).end()
#define pii pair<int, int>
#define pb push_back
#define ff first
#define sc second
#define coe cout<<"YES\n"
#define int long long

const int mod = 1e9 + 7;
const int logmax = 18;
int timer = 0;

vector<vector<int>> g;
vector<vector<int>> up;
vector<int> tin, tout;

void dfs(int v, int p) {
    up[v][0] = p;
    for (int i = 1; i < logmax; i++) {
        up[v][i] = up[up[v][i - 1]][i - 1];
    }
    tin[v] = timer++;
    for (auto &u : g[v]) {
        if (u != p) {
            dfs(u, v);
        }
    }
    tout[v] = timer++;
}

bool parent(int v, int u) {
    return tin[v] <= tin[u] && tout[u] <= tout[v];
}

int lca(int u, int v) {
    if (parent(u, v)) return u;
    if (parent(v, u)) return v;

    for (int i = logmax - 1; i >= 0; i--) {
        if (!parent(up[v][i], u)) {
            v = up[v][i];
        }
    }
    return up[v][0];
}

int binpow(int a, int p) {
    if (p == 0) return 1;
    if (p % 2 == 0) {
        int b = binpow(a, p / 2);
        return (b * b) % mod;
    }
    return (a * binpow(a, p - 1)) % mod;
}

int obr(int a) {
    return binpow(a, mod - 2);
}

int divv(int a, int b) {
    return (a * obr(b)) % mod;
}

pii get(pii a, pii b) {
    if (a.sc < b.ff || b.sc < a.ff) return {-1, -1};
    if (a.ff <= b.ff && b.sc <= a.ff) return b;
    if (b.ff <= a.ff && a.sc <= b.sc) return a;
    return {max(a.ff, b.ff), min(a.sc, b.sc)};
}

struct DSU {
    int n;
    vector<int> par, sz;
    vector<pii> st;
    DSU (int n_, vector<pii> F) {
        st=F;
        n = n_;
        par.assign(n, 0);
        sz.assign(n, 1);
        f(i,0,n)par[i]=i;
    }

    int find_root(int v){
        if(par[v]==v)return v;
        int res=find_root(par[v]);
        par[v]=res;
        return res;
    }

    int merge(int a, int b) {
        a = find_root(a);b=find_root(b);
        if(a==b)return a;
        if(sz[a]<sz[b])swap(a,b);
        par[b]=a;
        st[a]=get(st[a], st[b]);
        sz[a]+=sz[b];
        return a;
    }
};

signed main() {
    ios_base::sync_with_stdio(false);
    cout.tie(nullptr); cin.tie(nullptr);
    cout << fixed << setprecision(10);

    int n; cin >> n;
    vector<int> p(n - 1);
    f (i, 0, n - 1) cin >> p[i];
    g.assign(n, {});
    f (i, 0, n - 1) {
        g[p[i] - 1].pb(i + 1);
        g[i+1].pb(p[i] - 1);
    }

    vector<pii> grans(n);
    int sans = 1;
    f (i, 0, n) {
        cin >> grans[i].ff >> grans[i].sc;
        sans *= (grans[i].sc - grans[i].ff + 1);
        sans %= mod;
    }

    up.assign(n, vector<int>(logmax, 0));
    tin.assign(n, 0);
    tout.assign(n, 0);
    dfs(0, 0);

    int q; cin >> q;
    vector<int> used(n, 0);
    DSU dd(n, grans);
    vector<int> p1(n+1), p2(n+1),p3(n+1),p4(n+1);
    int step = 0;
    while (q--) {
        int a, b, c, d; cin >> a >> b >> c >> d;a--;b--;c--;d--;
        if(sans==0){
            cout<<"0\n";
            continue;
        }
        int l1 = lca(a, b), l2=lca(c,d);
        {
            int ind1 = 0, ind2 = 0;
            int nw = a;
            while (nw != l1) {
                p1[ind1] = nw;
                ind1++;
                nw = p[nw - 1] - 1;
            }
            p1[ind1] = nw;
            ind1++;
            nw = b;
            while (nw != l1) {
                p2[ind2] = nw;
                ind2++;
                nw = p[nw - 1] - 1;
            }
            for(int i=ind2-1;i>=0;i--){
                p1[ind1]=p2[i];
                ind1++;
            }

        }
        {
            int ind1 = 0, ind2 = 0;
            int nw=c;
            while(nw!=l2){
                p3[ind1]=nw;
                ind1++;
                nw=p[nw-1]-1;
            }
            p3[ind1]=nw;
            ind1++;
            nw=d;
            while(nw!=l2){
                p4[ind2]=nw;
                ind2++;
                nw=p[nw-1]-1;
            }
            for(int i=ind2-1;i>=0;i--){
                p3[ind1]=p4[i];
                ind1++;
            }
        }

        for (int i = 0; i < p1.size(); i++) {
            if(sans==0)continue;
            int p1f = dd.find_root(p1[i]), p2f = dd.find_root(p3[i]);
            if (p1f != p2f) {
                pii was1 = dd.st[p1f], was2 = dd.st[p2f];
                auto res = dd.merge(p1f, p2f);
                sans = divv(sans, (was1.sc-was1.ff+1));
                //cout<<sans<<' '<<(was2.sc-was2.ff+1)<<'\n';
                sans=divv(sans,(was2.sc-was2.ff+1));

                if(dd.st[res].ff==-1){
                    sans=0;
                }else{
                    sans*=(dd.st[res].sc-dd.st[res].ff+1);
                    sans%=mod;
                }
            }
        }
        cout<<sans<<'\n';
    }

    return 0;
}