//#pragma GCC optimize("unroll-loops")
//#pragma GCC target("O3")
#include <bits/stdc++.h>
#define int long long
#define ld long double
#define F first
#define S second

using namespace std;

const int N = 2e5 + 100, M = 1e9 + 7, IINF = 1e9 + 213, LOG = 21;
const ll INF = 1e18 + 123;

int pls(int a, int b){
    a += b;
    while(a >= M)
        a -= M;
    while(a < 0)
        a += M;
    return a;
}

int mult(int a, int b){
    return 1ll * a * b % M;
}

int bpow(int a, int b){
    int res = 1;
    while(b){
        if (1 & b)
            res = mult(res, a);
        a = mult(a, a);
        b /= 2;
    }
    return res;
}

int del(int a, int b){
    return mult(a, bpow(b, M - 2));
}

vector<int> g[N];
int l[N], r[N];
int snm[N], snm_s[N], snml[N], snmr[N];
int ans = 1;

void init(int n){
    for (int i = 0; i < n; i ++){
        snm[i] = i, snm_s[i] = 1, snml[i] = l[i], snmr[i] = r[i];
        ans = mult(ans, r[i] - l[i] + 1);
    }
}

int root(int a){
    if (a == snm[a])
        return a;
    return root(snm[a]);
}

inline void unite(int a, int b){
    a = root(a), b = root(b);
    if (a == b)
        return;
    if (snm_s[a] < snm_s[b])
        swap(a, b);
    ans = del(ans, max(0, snmr[b] - snml[b] + 1));
    ans = del(ans, max(0, snmr[a] - snml[a] + 1));
    snmr[a] = min(snmr[a], snmr[b]);
    snml[a] = max(snml[a], snml[b]);
    snm[b] = a;
    ans = mult(ans, max(0, snmr[a] - snml[a] + 1));
    snm_s[a] += snm_s[b];
    return;
}

int up[N][LOG];
int tin[N], tout[N], tim = 1;

void dfs(int v, int p = 0){
    tin[v] = tim ++;
    up[v][0] = p;
    for (int i = 1; i < LOG; i ++)
        up[v][i] = up[up[v][i - 1]][i - 1];
    for (auto i : g[v]){
        if (i == p)
            continue;
        dfs(i, v);
    }
    tout[v] = tim;
}

bool anc(int a, int b){
    return (tin[a] <= tin[b]) && (tin[b] < tout[a]);
}

vector<int> lca(int a, int b){
    int v = a;
    for (int i = LOG - 1; i >= 0; i --)
        if (!anc(up[v][i], b))
            v = up[v][i];
    if (!anc(v, b))
        v = up[v][0];
    vector<int> p;
    while(a != v)
        p.push_back(a), a = up[a][0];
    p.push_back(v);
    vector<int> f;
    while(b != v)
        f.push_back(b), b = up[b][0];
    for (int i = f.size() - 1; i >= 0; i --)
        p.push_back(f[i]);
    return p;
}

int32_t main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n;
    cin >> n;
    for (int i = 1; i < n; i++){
        int x;
        cin >> x;
        x--;
        g[x].push_back(i);
        g[i].push_back(x);
    }
    for (int i = 0; i < n; i++)
        cin >> l[i] >> r[i];
    init(n);
    dfs(0);
    int m;
    cin >> m;
    for (int i = 1; i <= m; i ++){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        auto pa = lca(a, b);
        auto pb = lca(c, d);
        for (int j = 0; j < pa.size(); j ++)
            unite(pa[j], pb[j]);
        cout << ans << '\n';
    }
    return 0;
}