#pragma GCC optimize("O3")
#pragma GCC optimize("Ofast")
#pragma GCC optimize("no-stack-protector")
#pragma GCC optimize("tune=native")
#pragma GCC optimize("unroll-loops")
#pragma GCC optimize("fast-math")
#include<bits/stdc++.h>
#define int long long
#define sz(a) (int)a.size()

using namespace std;

const int MOD = 1e9 + 7, N = 200005;

vector<int> g[N];
int tin[N], tout[N], pr[N], P[N], dist[N];
int pt1[N], pt2[N];
pair<int, int> s[N];
int timer = 0;

void dfs(int v, int p, int h) {
    dist[v] = h;
    pr[v] = p;
    tin[v] = timer++;
    for (int i : g[v]) {
        if (i != p) {
            dfs(i, v, h + 1);
        }
    }
    tout[v] = timer++;
}

bool upper(int a, int b) {
    return tin[a] <= tin[b] && tout[b] <= tout[a];
}

int get(int v) {
    if (v == P[v]) return v;
    int x = get(P[v]);
    P[v] = x;
    return x;
}

int powa(int a, int n) {
    if (n == 0) return 1;
    if (n % 2 == 0) {
        int x = powa(a, n / 2);
        return (x * x) % MOD;
    }
    return (powa(a, n - 1) * a) % MOD;
}

int divv(int a, int b) {
    if (b <= 0 || a == 0) {
        return 0;
    }
    return (a * powa(b, MOD - 2)) % MOD;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for (int i = 0; i < n; ++i) {
        P[i] = i;
    }
    for (int i = 0; i < n - 1; ++i) {
        int p;
        cin >> p;
        --p;
        g[i + 1].push_back(p);
        g[p].push_back(i + 1);
    }
    for (int i = 0; i < n; ++i) {
        cin >> s[i].first >> s[i].second;
    }
    dfs(0, 0, 0);
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        ans *= (s[i].second - s[i].first + 1);
        ans %= MOD;
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        --a;
        --b;
        --c;
        --d;
        if (ans == 0) {
            cout << ans << '\n';
            continue;
        }
        int tr = 0;
        while (true) {
            pt1[tr] = a;
            if (upper(a, b)) break;
            a = pr[a];
            ++tr;
        }
        tr += dist[b] - dist[a];
        int sz = tr + 1;
        while (a != b) {
            pt1[tr] = b;
            b = pr[b];
            --tr;
        }
        tr = 0;
        while (true) {
            pt2[tr] = c;
            if (upper(c, d)) break;
            c = pr[c];
            ++tr;
        }
        tr += dist[d] - dist[c];
        while (c != d) {
            pt2[tr] = d;
            d = pr[d];
            --tr;
        }
        for (int i = 0; i < sz; ++i) {
            int A = get(pt1[i]);
            int B = get(pt2[i]);
            if (A != B) {
                ans = divv(ans, s[A].second - s[A].first + 1);
                ans = divv(ans, s[B].second - s[B].first + 1);
                s[A].first = max(s[A].first, s[B].first);
                s[A].second = min(s[A].second, s[B].second);
                ans *= max(0LL, s[A].second - s[A].first + 1);
                ans %= MOD;
                s[B] = s[A];
                if (rand() % 2)
                    P[A] = B;
                else
                    P[B] = A;
            }
        }
        cout << ans << '\n';
    }
}
