#include <iostream>
#include <vector>
#include <string>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>
#include <iomanip>
#include <cassert>
#include <queue>
#include <stack>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree <int, null_type, less <int>, rb_tree_tag, tree_order_statistics_node_update>;
#define ll long long
#define vc vector
#define pb push_back
#define mp(a,b) make_pair(a,b)
#define pip pair <int, int>
const int op = 1e9 + 7;
const ll inf = 1e18;
int N = 2e4 + 10;
vc <vc <int>> g, up;
vc <int> q, w, tin, tout, s;
int l = 0, timer = 0;
bool upper(int a, int b){
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}
int lca(int a, int b){
    if (upper(a,b)) return a;
    if (upper(b,a)) return b;
    for (int i = l; i >= 0; i--) if (!upper(up[a][i], b)) a = up[a][i];
    return up[a][0];
}
void dfs(int v, int p = 0){
    s[v] = s[p] + 1;
    tin[v] = timer++;
    up[v][0] = p;
    for (int i = 0; i+1 <= l; i++) up[v][i+1] = up[up[v][i]][i];
    for (int i = 0; i < g[v].size(); i++){
        int u = g[v][i];
        if (u != p) dfs(u, v);
    }
    tout[v] = timer++;
}
int dist(int a, int b){
    int c = lca(a,b);
    return s[a] - s[c] + s[b] - s[c];
}
int next(int a, int b){
    for (int i = 0; i < g[a].size(); i++){
        int c = g[a][i];
        if (dist(c,b) < dist(a,b)) return c;
    }
    return a;
}
void solve(){
    int n, a = 0, b, c, m, nn, v, d;
    cin >> n;
    q.resize(n);w.resize(n);tin.resize(n);tout.resize(n);
    g.resize(n);up.resize(n);s.resize(n);
    while ((1<<l) < n) l++;
    for (int i = 0; i < n; i++) g[i].resize(0), up[i].resize(l);
    for (int i = 1; i < n; i++) cin >> v, v--, g[v].pb(i), g[i].pb(v);
    for (int i = 0; i < n; i++) cin >> q[i] >> w[i];
    dfs(0);
    cin >> nn;
    while (nn--){
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        ll ans = 1;
        vc <bool> used(n, false);
        while (true){
            if (!used[a]) {
                ans *= max(0, 1 + min(w[a], w[c]) - max(q[a], q[c]));
                ans %= op;
            }
            used[a] = used[c] = true;
            if (a == b) break;
            a = next(a,b);
            c = next(c,d);
        }
        for (int i = 0; i < n; i++) if (!used[i]){
            ans *= w[i] - q[i] + 1;
            ans %= op;
        }
        cout << ans << "\n";
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}