#include <bits/stdc++.h>
#define ff first
#define ss second
#define all(x) x.begin(), x.end()
#define allr(x) x.rbegin(), x.rend()
#define endl '\n'
typedef long long ll;
using namespace std;

const ll MOD = 1e9 + 7;
const int N = 2e5;

ll lb[N];
ll rb[N];
int p[N];
vector<int> g[N];

int tin[N];
int tout[N];
int cnt = 0;

void dfs(int v) {
    tin[v] = cnt++;
    for (auto to : g[v]) {
        dfs(to);
    }
    tout[v] = cnt++;
}

vector<int> solve2(int a, int b) {
    vector<int> f;
    int w = a;
    while (!(tin[w] <= tin[b] && tout[w] >= tout[b])) {
        f.push_back(w);
        w = p[w];
    }
    f.push_back(w);

    vector<int> s;
    w = b;
    while (!(tin[w] <= tin[a] && tout[w] >= tout[a])) {
        s.push_back(w);
        w = p[w];
    }

    reverse(all(s));
    for (auto x : s) {
        f.push_back(x);
    }
    return f;
}

void solve() {
    int n, m;
    cin >> n;

    for (int i = 1; i < n; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
    }

    vector<int> k(n);
    vector<vector<int>> km(n);

    for (int i = 0; i < n; i++) {
        cin >> lb[i] >> rb[i];

        k[i] = i;
        km[i].push_back(i);
    }

    dfs(0);


    cin >> m;
    while (m--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;

        vector<int> f = solve2(a, b);
        vector<int> s = solve2(c, d);

        int v = f.size();
        for (int i = 0; i < v; i++) {
            int x = k[f[i]], y = k[s[i]];
            if (x == y) {
                continue;
            }
            if (km[x].size() < km[y].size()) {
                swap(x, y);
            }

            for (auto z : km[y]) {
                km[x].push_back(z);
                k[z] = x;
            }

            lb[x] = max(lb[x], lb[y]), rb[x] = min(rb[x], rb[y]);

            if (rb[x] < lb[x]) {
                cout << 0 << endl;
                while (m--) {
                    cout << 0 << endl;
                }
                return;
            }
            lb[y] = 0;
            rb[y] = 0;
        }
        ll ans = 1;
        for (int i = 0; i < n; i++) {
            ans = (ans * ((rb[i] - lb[i] + 1) % MOD)) % MOD;
        }
        cout << ans << endl;
    }
}

int main() {
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);


    int t = 1;
    //cin >> t;
    while (t--) {
        solve();
    }
}
