#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
using namespace std;
typedef long long ll;
vector<ll> p, l, r, P, R, h;
ll mod = 1e9 + 7;
vector<vector<ll>> ch;
ll find(ll v) {
	if (v == P[v]) return v;
	return P[v] = find(P[v]);
}
void un(ll x, ll y) {
	x = find(x), y = find(y);
	if (x == y) return;
	if (R[x] < R[y]) swap(x, y);
	P[y] = x;
	l[x] = max(l[x], l[y]);
	r[x] = min(r[x], r[y]);
	r[x] = max(r[x], l[x] - 1);
	if (R[x] == R[y]) ++R[x];
}
void dfs(ll v) {
	for (auto to : ch[v]) {
		h[to] = h[v] + 1;
		dfs(to);
	}
}
ll lca(ll u, ll v, vector<vector<ll>>& jmp) {
	if (h[u] < h[v]) swap(u, v);
	for (ll j = 19; j >= 0; --j) {
		if (jmp[j][u] != -1 && h[jmp[j][u]] >= h[v]) u = jmp[j][u];
	}
	for (ll j = 19; j >= 0; --j) {
		if (jmp[j][u] != jmp[j][v]) u = jmp[j][u], v = jmp[j][v];
	}
	while (u != v) u = p[u], v = p[v];
	return u;
}
ll gcdex(ll a, ll b, ll& x, ll& y) {
	if (b == 0) {
		x = 1;
		y = 0;
		return a;
	}
	ll x1, y1, g;
	g = gcdex(b, a % b, x1, y1);
	x = y1;
	y = x1 - y1 * (a / b);
	return g;
}
ll sub(ll a, ll b) {
	ll x, y, g;
	g = gcdex(b, mod, x, y);
	return ((((x) % mod + mod) % mod) * a) % mod;
}
int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	ll n, m;
	cin >> n;
	p.assign(n, -1);
	ch.resize(n);
	for (ll i = 1; i < n; ++i) cin >> p[i], ch[--p[i]].push_back(i);
	l.resize(n);
	r.resize(n);
	ll ans = 1;
	for (ll i = 0; i < n; ++i) cin >> l[i] >> r[i], ans = (ans * (r[i] - l[i] + 1)) % mod;
	P.resize(n);
	R.assign(n, 0);
	for (ll i = 0; i < n; ++i) P[i] = i;
	vector<vector<ll>> jmp(20, vector<ll>(n));
	for (ll j = 0; j < 20; ++j) {
		for (ll i = 0; i < n; ++i) {
			if (j == 0) jmp[j][i] = p[i];
			else if (jmp[j - 1][i] != -1) jmp[j][i] = jmp[j - 1][jmp[j - 1][i]];
		}
	}
	h.assign(n, 0);
	dfs(0);
	cin >> m;
	while (m--) {
		ll a, b, c, d;
		cin >> a >> b >> c >> d;
		if (ans) {
			ll u = lca(--a, --b, jmp), v = lca(--c, --d, jmp);
			vector<ll> p1, p2, p3, p4;
			while (a != u) p1.push_back(a), a = p[a];
			while (b != u) p2.push_back(b), b = p[b];
			while (c != v) p3.push_back(c), c = p[c];
			while (d != v) p4.push_back(d), d = p[d];
			p1.push_back(u);
			for (ll i = (ll)p2.size() - 1; i >= 0; --i) p1.push_back(p2[i]);
			p3.push_back(v);
			for (ll i = (ll)p4.size() - 1; i >= 0; --i) p3.push_back(p4[i]);
			for (ll i = 0; i < (ll)p1.size() && ans; ++i) {
				if (find(p1[i]) == find(p3[i])) continue;
				ans = sub(ans, r[find(p1[i])] - l[find(p1[i])] + 1);
				ans = sub(ans, r[find(p3[i])] - l[find(p3[i])] + 1);
				un(p1[i], p3[i]);
				ans = (ans * (r[find(p1[i])] - l[find(p1[i])] + 1)) % mod;
			}
		}
		cout << ans << "\n";
	}
	return 0;
}