#include "bits/stdc++.h"
//#include <ext/pb_ds/assoc_container.hpp>
using namespace std;
//using namespace __gnu_pbds;
//using ordered_set = tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update>;
//#define int long long
#define sz(a) (int) a.size()
#define all(a) a.begin(), a.end()
#define ld long double
#define ll long long
const long long INF = 30000000000000000;
ll mod = 1e9 + 7;
vector<vector<int>> g;
vector<int> lvl;
vector<bool> used;
vector<int> dsu;

void dfs(int v, int st = 0) {
    lvl[v] = st;
    used[v] = 1;
    for (int to: g[v]) {
        if (!used[to])dfs(to, st + 1);
    }
}

ll binpow(int a, int n) {
    if (n == 0)return 1;
    else if (n & 1) {
        ll d = binpow(a, n / 2) % mod;
        d = (((d * d) % mod) * a) % mod;
        return d;
    } else {
        ll d = binpow(a, n / 2) % mod;
        d = (d * d) % mod;
        return d;
    }
}

int get(int v) {
    if (v == dsu[v])return v;
    return dsu[v] = get(dsu[v]);
}

void solve() {
    int n;
    cin >> n;
    dsu.resize(n);
    g.resize(n);
    lvl.resize(n);
    used.resize(n);
    vector<int> p(n);
    for (int i = 1; i < n; ++i) {
        int x;
        cin >> x;
        --x;
        p[i] = x;
        g[x].push_back(i);
        dsu[i] = i;
    }
    dfs(0);
    ll cnt = 1;
    vector<pair<int, int>> lr(n);
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        lr[i] = {l, r};
        cnt = (cnt * (r - l + 1)) % mod;
    }
    int q;
    cin >> q;
    vector<int> la, ra, lb, rb;
    bool bad = 0;

    for (int i = 0; i < q; ++i) {
        int c, d, a, b;
        cin >> a >> b >> c >> d;
        if (bad) {
            cout << 0 << endl;
            continue;
        }
        --a, --b, --c, --d;
        while (lvl[a] > lvl[b]) {
            la.push_back(a);
            a = p[a];
        }
        while (lvl[b] > lvl[a]) {
            lb.push_back(b);
            b = p[b];
        }
        while (a != b) {
            la.push_back(a);
            a = p[a];
            lb.push_back(b);
            b = p[b];
        }
        la.push_back(a);
// second son
        while (lvl[c] > lvl[d]) {
            ra.push_back(c);
            c = p[c];
        }
        while (lvl[d] > lvl[c]) {
            rb.push_back(d);
            d = p[d];
        }
        while (c != d) {
            ra.push_back(c);
            c = p[c];
            rb.push_back(d);
            d = p[d];
        }
        ra.push_back(c);
        while (!lb.empty()) {
            la.push_back(lb.back());
            lb.pop_back();
        }
        while (!rb.empty()) {
            ra.push_back(rb.back());
            rb.pop_back();
        }
        while (!la.empty()) {
            int v = la.back();
            int u = ra.back();
            v = get(v);
            u = get(u);
            la.pop_back();
            ra.pop_back();
            if (v == u)continue;
            auto [l1, r1] = lr[v];
            auto [l2, r2] = lr[u];
            int l = max(l1, l2);
            int r = min(r1, r2);
            int len = r - l + 1;
            if (len <= 0) {
                cnt = 0;
                bad = 1;
                break;
            } else {
                ll del1 = binpow(r1 - l1 + 1, mod - 2ll) % mod;
                ll del2 = binpow(r2 - l2 + 1, mod - 2ll) % mod;
                cnt = (cnt * del1) % mod;
                cnt = (cnt * del2) % mod;   
                cnt = (cnt * len) % mod;
                dsu[v] = u;
            }
            lr[v] = {l, r};
            lr[u] = {l, r};
        }
        cout << cnt << endl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int test = 1;
//    cin >> test;
    while (test--)
        solve();
    return 0;
}