#include <bits/stdc++.h>

#define F first
#define S second
#define sz size()
#define pb push_back
#define all(x) x.begin(), x.end()
#define int long long

using namespace std;

typedef vector <int> vi;
typedef vector <vi> vvi;
typedef pair <int, int> pii;

const int mod = 1e9 + 7;
const int N = 200200, P = 200227;
int n, m;
vvi g(N);
int a[N], b[N], c[N], d[N], par[N], _sz[N], can[N], cur_p[N], p[N], st[N], st_inv[N], t[4 * N], t2[4 * N];
pii diap[N];
set <int> cont[N];
int ans = 1;

int bp (int x, int st) {
    if (st == 0) {
        return 1ll;
    }

    int t = bp(x, st / 2);
    t *= t;
    t %= mod;
    if (st & 1) {
        t *= x;
    }
    return t % mod;
}


int inv (int x) {
    return bp(x, mod - 2);
}

pii inters (pii a, pii b) {
    if (a.F > b.S || b.F > a.S) {
        return {0, -1};
    }

    if (a.S < b.S) {
        swap(a, b);
    }

    if (a.S == -1 || b.S == -1) {
        return {0, -1};
    }

    int nr = min(a.S, b.S);
    int nl = max(a.F, b.F);
    return {nl, nr};
}

int get_p(int v) {
    if (par[v] == v) {
        return v;
    }
    return (par[v] = get_p(par[v]));
}

void upd (int v, int l, int r, int pos, int val) {
    if (l > pos || r < pos) {
        return;
    }

    if (l == r) {
        t[v] = val * st[pos];
        t[v] %= mod;
        t2[v] = val * st[n - pos + 1];
        t2[v] %= mod;
        return;
    }

    int mid = (l + r) / 2;
    upd (2 * v, l, mid, pos, val);
    upd (2 * v + 1, mid + 1, r, pos, val);

    t[v] = t[2 * v] + t[2 * v + 1];
    t[v] %= mod;
    t2[v] = t2[2 * v] + t2[2 * v + 1];
    t2[v] %= mod;
}

void _union (int u, int v) {
    u = get_p(u);
    v = get_p(v);
    if (u == v) {
        return;
    }

    if (_sz[u] > _sz[v]) {
        swap(u, v);
    }

    ans *= inv(can[u]); ans %= mod;
    ans *= inv(can[v]); ans %= mod;

    diap[v] = inters(diap[v], diap[u]);
    can[v] = diap[v].S - diap[v].F + 1;
    ans *= can[v]; ans %= mod;

    par[u] = v;
    _sz[v] += _sz[u];

    for (auto i : cont[u]) {
        cont[v].insert(i);
        par[i] = v;
        upd (1, 1, n, i, par[i]);
    }
}

void dfs3000 (int v, int pr) {
    for (auto i : g[v]) {
        if (i == pr) {
            continue;
        }
        cur_p[i] = v;
        dfs3000 (i, v);
    }
}
void solve3000 () {
    for (int i = 1; i <= m; i++) {
        for (int j = 1; j <= n; j++) {
            cur_p[j] = j;
        }
        dfs3000 (a[i], a[i]);

        int v = b[i];
        vi vec1;
        vec1.pb(v);
        while (v != a[i]) {
            v = cur_p[v];
            vec1.pb(v);
        }
        reverse(all(vec1));

        for (int j = 1; j <= n; j++) {
            cur_p[j] = j;
        }
        dfs3000 (c[i], c[i]);

        v = d[i];
        vi vec2;
        vec2.pb(v);
        while (v != c[i]) {
            v = cur_p[v];
            vec2.pb(v);
        }
        reverse(all(vec2));

        for (int i = 0; i < vec1.sz; i++) {
            _union (vec1[i], vec2[i]);
        }

        cout << ans << "\n";
    }
}


int get_sum (int v, int l, int r, int tl, int tr, int flag) {
    if (l > tr || r < tl) {
        return 0;
    }

    if (l >= tl && r <= tr) {
        if (flag == 1) {
            return t[v];
        }
        else {
            return t2[v];
        }
    }
    int mid = (l + r) / 2;
    int sm1 = get_sum (2 * v, l, mid, tl, tr, 1);
    int sm2 = get_sum (2 * v + 1, mid + 1, r, tl, tr, 2);
    return (sm1 + sm2) % mod;
}


int get (int x, int len) {
    int sm = get_sum(1, 1, n, x, x + len - 1, 1);
    sm *= st_inv[x - 1];
    sm %= mod;
    return sm;
}

int get_inv (int x, int len) {
    int sm = get_sum(1, 1, n, x - len + 1, x, 2);
    sm *= st_inv[n - x];
    sm %= mod;
    return sm;
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    cin >> n;
    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].pb(i);
        g[i].pb(p[i]);

    }


    st[0] = 1;
    st_inv[0] = 1;
    for (int i = 1; i <= n; i++) {
        st[i] = st[i - 1] * P; st[i] %= mod;
        st_inv[i] = inv(st[i]);
    }

    for (int i = 1; i <= n; i++) {
        _sz[i] = 1, par[i] = i;
        cont[i].insert(i);
        upd (1, 1, n, i, par[i]);
    }


    for (int i = 1; i <= n; i++) {
        cin >> diap[i].F >> diap[i].S;
        can[i] = diap[i].S - diap[i].F + 1;
        ans *= can[i];
        ans %= mod;
    }

    cin >> m;
    for (int i = 1; i <= m; i++) {
        cin >> a[i] >> b[i] >> c[i] >> d[i];
    }

    if (n <= 3000 && m <= 3000) {
        solve3000();
        return 0;
    }

    for (int i = 1; i <= m; i++) {
        if (a[i] > b[i] && c[i] > d[i]) {
            swap(a[i], b[i]);
            swap(c[i], d[i]);
        }

        if (a[i] > b[i]) {
            swap(a[i], b[i]);
            swap(c[i], d[i]);
        }


        if (get(a[i], 1) != get(c[i], 1)) {
            _union(a[i], c[i]);
        }

        while (a[i] != b[i]) {
            int len = b[i] - a[i] + 1;
            int l = 1, r = len + 1;
            while (r - l > 1) {
                int mid = (l + r) / 2;
                int fir = get(a[i], mid);
                int sec;
                if (c[i] <= d[i]) {
                    sec = get(c[i], mid);
                }
                else {
                    sec = get_inv(c[i], mid);
                }

                if (fir == sec) {
                    l = mid;
                }
                else {
                    r = mid;
                }
            }

            if (l == len) {
                a[i] = b[i];
                break;
            }
            a[i] = a[i] + l;
            if (c[i] <= d[i]) {
                c[i] = c[i] + l;
            }
            else {
                c[i] = c[i] - l;
            }
            _union(a[i], c[i]);
        }

        cout << ans << "\n";
    }
}


/*
9
1 2 3 4 5 6 7 8
1 5
1 3
1 3
2 4
1 5
3 6
3 7
3 8
4 9
3
1 1 2 2
3 5 7 9
1 5 5 9
*/
