#include <bits/stdc++.h>
#define ll long long
#define ld long double
#define pii pair<int,int>
#define ve vector
#define mpp make_pair
#define pb push_back
#define all(x)      (x).begin(),(x).end()
#define sz(x)       ((int)(x).size())
#define fi first
#define se second
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;

template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

const int N = 2e5 + 100;

int l[N], r[N];

pii seg[N];
int p[N], rnk[N];
inline void build(int n) {
    for (int i = 0; i < n; ++i) {
        p[i] = i, rnk[i] = 1;

        seg[i] = {l[i], r[i]};
    }
}
inline int par(int v) {
    if (p[v] == v) return v;
    return (p[v] = par(p[v]));
}
inline bool uni(int a, int b) {
    a = par(a), b = par(b);
    if (a == b) return 0;
    if (rnk[a] > rnk[b]) swap(a, b);
    p[a] = b, rnk[b] += rnk[a];
    chmax(seg[b].fi, seg[a].fi);
    chmin(seg[b].se, seg[a].se);
    return 1;
}

int ac[N];
ve<int> gr[N];

int h[N];

inline void dfs(int v) {
    for (const auto &to : gr[v]) {
        h[to] = h[v] + 1;
        dfs(to);
    }
}

inline ve<int> path(int a, int b) {
    ve<int> u, d;
    while (a != b) {
        if (h[a] > h[b]) {
            u.pb(a);
            a = ac[a];
        }
        else {
            d.pb(b);
            b = ac[b];
        }
    }
    u.pb(b);
    reverse(all(d));
    for (const auto &x : d) u.pb(x);
    return u;
}

inline void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        int p;
        cin >> p;
        gr[--p].pb(i); ac[i] = p;
    } dfs(0);

    for (int i = 0; i < n; ++i) {
        cin >> l[i] >> r[i];
    }

    build(n);

    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        auto A = path(--a, --b);
        auto B = path(--c, --d);
        assert(sz(A) == sz(B));

//        for (const auto &x : A) cout << x + 1 << " ";
//        cout << '\n';
//        for (const auto &x : B) cout << x + 1 << " ";
//        cout << '\n' << '\n';

        for (int i = 0; i < sz(A); ++i) {
            uni(A[i], B[i]);
        }

        int ans = 1;
        for (int i = 0; i < n; ++i) {
            if (par(i) != i) continue;
            int L = seg[i].fi, R = seg[i].se;
            if (L > R) ans = 0;
            else {
                ans = ans * 1ll * (R - L + 1) % (int)(1e9 + 7);
            }
        }
        cout << ans << '\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
