#include <bits/stdc++.h>

using namespace std;

#define int long long
#define ll long long
#define pii pair<int, int>
#define dl long double
#define sz(v) (int)v.size()
#define all(v) v.begin(), v.end()

const ll inf = 1e18, mod = 1e9 + 7, maxn = 2e5 + 1;
vector<int> g[maxn];
int tin[maxn], tout[maxn], p[maxn], T = 1, n;
pii otr[maxn];

void dfs(int v = 0) {
    tin[v] = T++;
    for (int u: g[v])
        dfs(u);
    tout[v] = T;
}

int anc(int u, int v) {
    return tin[u] <= tin[v] && tout[u] >= tout[v];
}

int lca(int u, int v) {
    if (anc(u, v))return u;
    if (anc(v, u))return v;
    while (!anc(u, v)) u = p[u];
    return u;
}

pii ob(pii otr1, pii otr2) {
    auto [l1, r1] = otr1;
    auto [l2, r2] = otr2;
    if (l1 > l2)swap(l1, l2), swap(r1, r2);
    if(r1 < l2)
        return {-1, -1};

    int L = l2, R = min(r1, r2);
    return {L, R};
}

vector<int> path(int a, int b) {
    int k = lca(a, b);
    vector<int> p1, p2;
    while (a != k)p1.push_back(a), a = p[a];
    p1.push_back(k);
    while (b != k)p2.push_back(b), b = p[b];
    reverse(all(p2));
    for (int el: p2)p1.push_back(el);
    return p1;
}
vector<int>ch[maxn];
vector<int>used;
pii OTR;
void calc(int v){
    if(OTR.first == -1)return;
    used[v] = 1;
    for(int u:ch[v]){
        if(!used[u]){
            OTR = ob(OTR, otr[u]);
            calc(u);
        }
    }
}
void solve() {
    cin >> n;
    for (int i = 1; i < n; ++i) {
        cin >> p[i], p[i]--;
        g[p[i]].push_back(i);
    }
    dfs();
    for (int i = 0; i < n; ++i) {
        int l, r;
        cin >> l >> r;
        otr[i] = {l, r};
    }
    int q;
    cin >> q;
    while (q--) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--, b--, c--, d--;
        auto p1 = path(a, b);
        auto p2 = path(c, d);
        int len = sz(p1);
        for (int i = 0; i < len; ++i) {
            ch[p1[i]].push_back(p2[i]);
            ch[p2[i]].push_back(p1[i]);
        }
        int ans = 1;
        used.clear(), used.resize(n);
        for (int i = 0; i < n && ans; ++i) {
            if(!used[i]){
                OTR = otr[i];
                calc(i);
                if(OTR.first == -1){
                    ans = 0;
                    break;
                }
                auto[l, r] = OTR;
                ans = (ans * (r - l + 1)) % mod;
            }
        }
        cout<<ans<<'\n';
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int _ = 1;
    //cin>>_;
    while (_--) {
        solve();
        cout << '\n';
    }
}