#include <bits/stdc++.h>

#define ll long long
#define ld long double


using namespace std;

vector<ll> p(vector<vector<ll> >& g, ll u, ll f){
    queue<ll> q;
    q.push(u);
    vector<ll> frm(g.size(), -1);
    vector<bool> vis(g.size());
    while(!q.empty()){
        ll v = q.front();
        q.pop();
        vis[v] = 1;
        if(v == f)
            break;
        for(auto to : g[v])
            if(!vis[to]){
                q.push(to);
                vis[to] = 1;
                frm[to] = v;
            }
    }
    vector<ll> res;
    ll v = f;
    while(v != u){
        res.push_back(v);
        v = frm[v];
    }
    res.push_back(u);
    reverse(res.begin(), res.end());
    return res;

}

const ll mod = 1e9+7;

int main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    ll n;
    cin >> n;
    vector<vector<ll> > g(n);
    for(ll i = 1; i < n; i++){
        ll v;
        cin >> v;
        v--;
        g[i].push_back(v);
        g[v].push_back(i);
    }

    vector<pair<ll, ll> > v(n);
    ll pr = 1;
    for(auto& i : v){
        cin >> i.first >> i.second;
    }
    ll m;
    cin >> m;
    while(m--){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        vector<ll> p1 = p(g, a - 1, b - 1);
        vector<ll> p2 = p(g, c - 1, d - 1);
        ll res = 1;
        vector<bool> vis(n), vis2(n);
        set<ll> st;
        for(ll i = 0; i < p1.size(); i++){
            v[p1[i]].first = v[p2[i]].first = max(v[p1[i]].first, v[p2[i]].first);
            v[p1[i]].second = v[p2[i]].second = min(v[p1[i]].second, v[p2[i]].second);
            vis[p1[i]] = 1;
            vis[p2[i]] = 1;
        }
        for(ll i = 0; i < p1.size(); i++){
            if(!vis2[p1[i]] && !vis2[p2[i]]){
                res *=v[p1[i]].second - v[p1[i]].first + 1;
                res %= mod;
                vis2[p2[i]] = 1;
                vis2[p1[i]] = 1;
            }
        }
        for(ll i = 0; i < n; i++)
            if(!vis[i]){
                res *= v[i].second - v[i].first + 1;
                res %= mod;
        }
        cout << res << "\n";
    }
    return 0;
}
