#include <bits/stdc++.h>

using namespace std;
#define eb emplace_back

typedef long long ll;
typedef long double ld;
typedef pair<int, int> ii;
typedef pair<long long, long long> llll;
typedef vector<int> vi;
typedef vector<long long> vll;

const ll MOD = 1e9 + 7;

vi p, h, ABu, ABd, CDu, CDd;
vector<llll> lr;
vector<vi> eq;

vector<bool> used;

void getH(int v) {
    if (h[v] != -1)
        return;
    getH(p[v]);
    h[v] = h[p[v]] + 1;
}

ii get(int v) {
    used[v] = true;
    ii th = lr[v];
    for (int u : eq[v]) {
        if (!used[u]) {
            ii t = get(u);
            th.first = max(th.first, t.first);
            th.second = min(th.second, t.second);
        }
    }
    return th;
}

void solve() {
    int n;
    cin >> n;
    p.resize(n);
    p[0] = 0;
    lr.resize(n);
    h.assign(n, -1);
    for (int i = 1; i < n; ++i) {
        cin >> p[i];
        p[i]--;
    }
    h[0] = 0;
    for (int i = 1; i < n; ++i)
        getH(i);
//    for (int i = 0; i < n; ++i)
//        cerr << "p[" << i << "] = " << p[i] << '\n';
//    cerr << '\n';
//    for (int i = 0; i < n; ++i)
//        cerr << "h[" << i << "] = " << h[i] << '\n';
    for (int i = 0; i < n; ++i)
        cin >> lr[i].first >> lr[i].second;
    int m, a, b, c, d;
    cin >> m;
    eq.resize(n);
    for (int i = 0; i < m; ++i) {
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        while (a != b) {
            if (h[a] >= h[b]) {
                ABu.eb(a);
                a = p[a];
            } else {
                ABd.eb(b);
                b = p[b];
            }
        }
        ABu.eb(a);
        for (int j = ABd.size() - 1; j >= 0; --j)
            ABu.eb(ABd[j]);
        while (c != d) {
            if (h[c] >= h[d]) {
                CDu.eb(c);
                c = p[c];
            } else {
                CDd.eb(d);
                d = p[d];
            }
        }
        CDu.eb(c);
        for (int j = CDd.size() - 1; j >= 0; --j)
            CDu.eb(CDd[j]);
        assert(ABu.size() == CDu.size());
        for (int j = 0; j < ABu.size(); ++j) {
            eq[ABu[j]].eb(CDu[j]);
            eq[CDu[j]].eb(ABu[j]);
        }
        ll ans = 1;
        used.assign(n, false);
        for (int i = 0; i < n; ++i) {
            if (!used[i]) {
                ii t = get(i);
                ans = (ans * max(0, t.second - t.first + 1)) % MOD;
            }
        }
        cout << ans << '\n';
        ABu.clear();
        ABd.clear();
        CDu.clear();
        CDd.clear();
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tests = 1;
//    cin >> tests;
    for (int test = 1; test <= tests; ++test) {
        solve();
    }
    return 0;
}
