#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 2e5 + 5;
const int MOD = 1e9 + 7;

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        return a - MOD;
    }
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % MOD;
}

int bpow(int a, int b) {
    if (a < 0) a = 0;

    int res = 1;
    while (b) {
        if (b & 1) {
            res = mult(res, a);
        }
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

int n, m;
ve<int> g[N];
pii a[N];
int timer, tin[N], tout[N];

void dfs(int v = 1, int p = 0) {
    tin[v] = timer++;

    fe (to, g[v]) {
        if (to == p) continue;

        dfs(to, v);
    }

    tout[v] = timer;
}

bool isUpper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

#define link aboba

int link[N];
int sz[N];
int L[N], R[N];
int ans;
int p[N];

int root(int x) {
    if (link[x] == x) {
        return x;
    }
    return link[x] = root(link[x]);
}

bool bad;

bool uni(int a, int b) {
    a = root(a);
    b = root(b);
    if (a == b) {
        return 0;
    }
    if (sz[a] > sz[b]) swap(a, b);
    ans = mult(ans, bpow(R[a] - L[a] + 1, MOD - 2));
    ans = mult(ans, bpow(R[b] - L[b] + 1, MOD - 2));

    umx(L[b], L[a]);
    umn(R[b], R[a]);
    sz[b] += sz[a];
    link[a] = b;

    if (L[b] > R[b]) {
        bad = 1;
    } else {
        ans = mult(ans, R[b] - L[b] + 1);
    }

    return 1;
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif

    cin >> n;
    fr (i, 2, n) {
        cin >> p[i];
        g[p[i]].pb(i);
    }

    fr (i, 1, n) {
        cin >> a[i].fi >> a[i].se;
    }

    ans = 1;

    fr (i, 1, n) {
        link[i] = i;
        sz[i] = 1;
        L[i] = a[i].fi;
        R[i] = a[i].se;
        ans = mult(ans, R[i] - L[i] + 1);
    }

    dfs();

    cin >> m;

    fr (idx, 1, m) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        ve<int> path1;
        {
            while (!isUpper(a, b)) {
                path1.pb(a);
                a = p[a];
            }
            path1.pb(a);

//            cout << "a: " << a << " " << b << "\n";

            ve<int> t;
            while (b != a) {
                t.pb(b);
                b = p[b];
            }
            reverse(all(t));
            fe (x, t) path1.pb(x);
        }

        ve<int> path2;
        {
            while (!isUpper(c, d)) {
                path2.pb(c);
                c = p[c];
            }
            path2.pb(c);

            ve<int> t;
            while (c != d) {
                t.pb(d);
                d = p[d];
            }
            reverse(all(t));
            fe (x, t) path2.pb(x);
        }

//        cout << "path1: ";
//        fe (x, path1) cout << x << " ";
//        cout << "\n";
//        cout << "path2: ";
//        fe (x, path2) cout << x << " ";
//        cout << "\n\n";

        assert(sz(path1) == sz(path2));

        fr (i, 0, sz(path1) - 1) {
            if (root(path1[i]) != root(path2[i])) {
                uni(path1[i], path2[i]);

                if (bad) {
//                    cout << i << " " << m << "\n";
                    fr (j, idx, m) cout << "0\n";
                    return 0;
                }
            }
        }

        cout << ans << "\n";
    }

    return 0;
}
