#include <bits/stdc++.h>

#define fr(i, a, b) for (int i = (a); i <= (b); ++i)
#define rf(i, a, b) for (int i = (a); i >= (b); --i)
#define fe(x, y) for (auto& x : y)

#define fi first
#define se second
#define pb push_back
#define mp make_pair
#define mt make_tuple

#define all(x) (x).begin(), (x).end()
#define pw(x) (1LL << (x))
#define sz(x) (int)(x).size()

using namespace std;

mt19937 rng(228);

#include <ext/pb_ds/assoc_container.hpp>
using namespace __gnu_pbds;
template <typename T>
using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
#define fbo find_by_order
#define ook order_of_key

template <typename T>
bool umn(T& a, T b) {
    return a > b ? a = b, 1 : 0;
}
template <typename T>
bool umx(T& a, T b) {
    return a < b ? a = b, 1 : 0;
}

using ll = long long;
using ld = long double;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
template <typename T>
using ve = vector<T>;

const int N = 2e5 + 5;
const int MOD = 1e9 + 7;

const int P[2] = {200009, 200017};
const int MODS[2] = {int(1e9) + 7, int(1e9) + 9};
int pwr[2][N];

bool isPrime(int x) {
    for (int i = 2; i * i <= x; i++) {
        if (x % i == 0) {
            return 0;
        }
    }
    return 1;
}

int add(int a, int b) {
    a += b;
    if (a >= MOD) {
        return a - MOD;
    }
    return a;
}

int mult(int a, int b) {
    return 1LL * a * b % MOD;
}

int bpow(int a, int b) {
    assert(a >= 0 && a < MOD);

    int res = 1;
    while (b) {
        if (b & 1) {
            res = mult(res, a);
        }
        a = mult(a, a);
        b >>= 1;
    }
    return res;
}

int n, m;
ve<int> g[N];
pii a[N];
int timer, tin[N], tout[N];

void dfs(int v = 1, int p = 0) {
    tin[v] = timer++;

    fe (to, g[v]) {
        if (to == p) continue;

        dfs(to, v);
    }

    tout[v] = timer;
}

bool isUpper(int a, int b) {
    return tin[a] <= tin[b] && tout[a] >= tout[b];
}

#define link aboba

int link[N];
int sz[N];
int L[N], R[N];
int ans;
int p[N];

int root(int x) {
    if (link[x] == x) {
        return x;
    }
    return link[x] = root(link[x]);
}

bool bad;
bool subtask = 1;

ve<int> dsu[N];



struct Hash {
    int len;
    int h[2];

    bool operator==(const Hash& other) const {
        return len == other.len && h[0] == other.h[0] && h[1] == other.h[1];
    }
};

Hash t[4 * N];

Hash combine(Hash L, Hash R) {
    if (L.len == 0) return R;
    if (R.len == 0) return L;
    R.len += L.len;
    fr (i, 0, 1) {
        R.h[i] = 1LL * R.h[i] * pwr[i][L.len] % MODS[i];
        R.h[i] += L.h[i];
        if (R.h[i] >= MODS[i]) {
            R.h[i] -= MODS[i];
        }
    }
    return R;
}

void build(int v = 1, int tl = 1, int tr = n) {
    if (tl == tr) {
        t[v].len = 1;
        t[v].h[0] = tl;
        t[v].h[1] = tl;
        return;
    }
    int tm = (tl + tr) >> 1;
    build(v << 1, tl, tm);
    build(v << 1 | 1, tm + 1, tr);
    t[v] = combine(t[v << 1], t[v << 1 | 1]);
}

Hash get(int v, int tl, int tr, int l, int r) {
    if (l > r) {
        Hash h = {0, {0, 0}};
        return h;
    }
    if (tl == l && tr == r) {
        return t[v];
    }
    int tm = (tl + tr) >> 1;
    return combine(get(v << 1, tl, tm, l, min(r, tm)),
                   get(v << 1 | 1, tm + 1, tr, max(tm + 1, l), r));
}

Hash get(int l, int r) {
    return get(1, 1, n, l, r);
}

void upd(int v, int tl, int tr, int pos, int x) {
    if (tl == tr) {
        t[v].len = 1;
        t[v].h[0] = x;
        t[v].h[1] = x;
        return;
    }
    int tm = (tl + tr) >> 1;
    if (pos <= tm) {
        upd(v << 1, tl, tm, pos, x);
    } else {
        upd(v << 1 | 1, tm + 1, tr, pos, x);
    }
    t[v] = combine(t[v << 1], t[v << 1 | 1]);
}

void upd(int pos, int x) {
    upd(1, 1, n, pos, x);
}

int getLCP(int pos1, int pos2) {
    int ans = 0;
    rf (p, 19, 0) {
        if (pos1 + pw(p) - 1 > n || pos2 + pw(p) - 1 > n) {
            continue;
        }

        if (get(pos1, pos1 + pw(p) - 1) == get(pos2, pos2 + pw(p) - 1)) {
            pos1 += pw(p);
            pos2 += pw(p);
            ans += pw(p);
        }
    }
    return ans;
}

bool uni(int a, int b) {
    a = root(a);
    b = root(b);
    if (a == b) {
        return 0;
    }
    if (sz[a] > sz[b]) swap(a, b);
    ans = mult(ans, bpow(R[a] - L[a] + 1, MOD - 2));
    ans = mult(ans, bpow(R[b] - L[b] + 1, MOD - 2));

    umx(L[b], L[a]);
    umn(R[b], R[a]);
    sz[b] += sz[a];
    link[a] = b;

    fe (x, dsu[a]) {
        link[x] = b;

        if (subtask) {
            upd(x, b);
        }
        dsu[b].pb(x);
    }

    if (L[b] > R[b]) {
        bad = 1;
    } else {
        ans = mult(ans, R[b] - L[b] + 1);
    }

    return 1;
}


int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#else
    ios::sync_with_stdio(0);
    cin.tie(0);
#endif
    fr (i, 0, 1) {
        pwr[i][0] = 1;
        fr (j, 1, N - 1) {
            pwr[i][j] = 1LL * pwr[i][j - 1] * P[i] % MODS[i];
        }
    }

    cin >> n;
    fr (i, 2, n) {
        cin >> p[i];
        g[p[i]].pb(i);
        subtask &= p[i] == i - 1;
    }

    fr (i, 1, n) {
        cin >> a[i].fi >> a[i].se;
    }

    ans = 1;

    fr (i, 1, n) {
        link[i] = i;
        sz[i] = 1;
        L[i] = a[i].fi;
        R[i] = a[i].se;
        ans = mult(ans, R[i] - L[i] + 1);
        dsu[i] = {i};
    }

    subtask = 0;

    if (subtask) {
        build();

        cin >> m;
        fr (idx, 1, m) {
            int a, b, c, d;
            cin >> a >> b >> c >> d;
            if (a > b) swap(a, b);
            if (c > d) swap(c, d);

            while (1) {
                int p = getLCP(a, c);

                if (p >= b - a + 1) {
                    break;
                }
                uni(a + p, c + p);

                if (bad) {
                    fr (j, idx, m) cout << "0\n";
                    return 0;
                }
            }
            cout << ans << "\n";
        }

        return 0;
    }

    dfs();

    cin >> m;

    fr (idx, 1, m) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;

        ve<int> path1;
        {
            while (!isUpper(a, b)) {
                path1.pb(a);
                a = p[a];
            }
            path1.pb(a);

//            cout << "a: " << a << " " << b << "\n";

            ve<int> t;
            while (b != a) {
                t.pb(b);
                b = p[b];
            }
            reverse(all(t));
            fe (x, t) path1.pb(x);
        }

        ve<int> path2;
        {
            while (!isUpper(c, d)) {
                path2.pb(c);
                c = p[c];
            }
            path2.pb(c);

            ve<int> t;
            while (c != d) {
                t.pb(d);
                d = p[d];
            }
            reverse(all(t));
            fe (x, t) path2.pb(x);
        }

//        cout << "path1: ";
//        fe (x, path1) cout << x << " ";
//        cout << "\n";
//        cout << "path2: ";
//        fe (x, path2) cout << x << " ";
//        cout << "\n\n";

        assert(sz(path1) == sz(path2));

        fr (i, 0, sz(path1) - 1) {
            if (root(path1[i]) != root(path2[i])) {
                uni(path1[i], path2[i]);

                if (bad) {
//                    cout << i << " " << m << "\n";
                    fr (j, idx, m) cout << "0\n";
                    return 0;
                }
            }
        }

        cout << ans << "\n";
    }

    return 0;
}
