#include <bits/stdc++.h>

using namespace std;

#define ld long double
#define int long long
#define pb push_back

int l[300001], r[300001], pr[300001][20], tin[300001], tout[300001], timer = 0, dpr[300001], dsz[300001], dl[300001], dr[300001], cur = 1;
int mod = 1000000007;
vector < int > g[300001];

int st(int a, int b)
{
    if (b == 0) return 1;
    if (b == 1) return a;
    int x = st(a, b / 2);
    x = (x * x) % mod;
    if (b & 1) x = (x * a) % mod;
    return x;
}

int PR(int v)
{
    if (dpr[v] == v) return v;
        else return dpr[v] = PR(dpr[v]);
}

void unite(int a, int b)
{
    a = PR(a);
    b = PR(b);
    if (a == b) return;
    if (dsz[a] < dsz[b]) swap(a, b);
    dsz[a] += dsz[b];
    dpr[b] = a;
    cur = (cur * st(dr[a] - dl[a] + 1, mod - 2)) % mod;
    cur = (cur * st(dr[b] - dl[b] + 1, mod - 2)) % mod;
    dl[a] = max(dl[a], dl[b]);
    dr[a] = min(dr[a], dr[b]);
    if (dl[a] > dr[a]) cur = 0;
        else cur = (cur * (dr[a] - dl[a] + 1)) % mod;
}

void DFS(int v, int pred)
{
    tin[v] = timer++;
    pr[v][0] = pred;
    for (int i = 1; i < 20; i++)
        pr[v][i] = pr[pr[v][i - 1]][i - 1];
    for (auto to: g[v])
        if (to != pred) DFS(to, v);
    tout[v] = timer++;
}

bool upper(int a, int b)
{
    return (tin[a] <= tin[b] && tout[a] >= tout[b]);
}

int lca(int a, int b)
{
    if (upper(a, b)) return a;
    if (upper(b, a)) return b;
    for (int i = 19; i >= 0; i--)
        if (!upper(pr[a][i], b)) a = pr[a][i];
    return pr[a][0];
}

int32_t main()
{
    int n;
    cin >> n;
    for (int i = 1; i < n; i++)
    {
        int x;
        cin >> x;
        x--;
        g[x].pb(i);
        g[i].pb(x);
    }
    DFS(0, 0);
    for (int i = 0; i < n; i++)
    {
        cin >> l[i] >> r[i];
        cur = (cur * (r[i] - l[i] + 1)) % mod;
        dpr[i] = i;
        dsz[i] = 1;
        dl[i] = l[i];
        dr[i] = r[i];
    }
    int q;
    cin >> q;
    while (q--)
    {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        if (cur == 0)
        {
            cout << 0 << endl;
            continue;
        }
        int lc1 = lca(a, b), lc2 = lca(c, d);
        vector < int > v1, v2;
        while (a != lc1)
        {
            v1.pb(a);
            a = pr[a][0];
        }
        v1.pb(a);
        int pos = v1.size();
        while (b != lc1)
        {
            v1.pb(b);
            b = pr[b][0];
        }
        reverse(v1.begin() + pos, v1.end());
        while (c != lc2)
        {
            v2.pb(c);
            c = pr[c][0];
        }
        v2.pb(c);
        pos = v2.size();
        while (d != lc2)
        {
            v2.pb(d);
            d = pr[d][0];
        }
        reverse(v2.begin() + pos, v2.end());
        for (int i = 0; i < v1.size(); i++)
            unite(v1[i], v2[i]);
        cout << cur << endl;
    }
}
