#include<iostream>
#include<vector>
#include<cmath>
#include<algorithm>
#include<set>
#include<map>
#include<iomanip>

using namespace std;

#define ll long long

void dfs(int idx, vector<vector<int>> &v, vector<int> &used, vector<int>& pr) {
	used[idx] = 1;


	for (int i = 0; i < v[idx].size(); i++) {
		if (used[v[idx][i]] == 0) {
			pr[v[idx][i]] = idx;
			dfs(v[idx][i], v, used, pr);
		}
	}
}

int f(int x, vector<int>& par) {
	if (par[x] != x) {
		par[x] = f(par[x], par);
	}

	return par[x];
}

pair<ll, ll> fun(ll l1, ll r1, ll l2, ll r2) {
	return { max(l1, l2), min(r1, r2) };
}


int main() {
	int n;
	cin >> n;

	vector<vector<int>> v(n);
	for (int i = 1; i < n; i++) {
		int p;
		cin >> p;
		p--;

		v[p].push_back(i);
		v[i].push_back(p);
	}

	vector<ll> l(n);
	vector<ll> r(n);

	for (int i = 0; i < n; i++) {
		cin >> l[i] >> r[i];
	}

	int m;
	cin >> m;

	vector<int> par(n);

	vector<ll> si(n);

	for (int i = 0; i < n; i++) {
		par[i] = i;
		si[i] = 1;
	}

	ll e = 1e9 + 7;

	bool fl0 = false;
	for (int i = 0; i < m; i++) {
		int a, b, c, d;
		cin >> a >> b >> c >> d;
		a--;
		b--;
		c--;
		d--;
		if (fl0) {
			cout << 0 << endl;
			continue;
		}

		vector<int> pr1(n, -1);
		vector<int> used1(n, 0);
		dfs(a, v, used1, pr1);

		int idx1 = b;

		vector<int> a1;
		while (idx1 != -1) {
			a1.push_back(idx1);
			idx1 = pr1[idx1];
		}


		vector<int> pr2(n, -1);
		vector<int> used2(n, 0);
		dfs(c, v, used2, pr2);

		int idx2 = d;

		vector<int> a2;
		while (idx2 != -1) {
			a2.push_back(idx2);
			idx2 = pr2[idx2];
		}


		for (int j = 0; j < a1.size(); j++) {
			int x = a1[j], y = a2[j];

			x = f(x, par);
			y = f(y, par);

			if (x != y) {
				
				pair<ll, ll> p = fun(l[x], r[x], l[y], r[y]);

				if (si[x] > si[y]) {
					l[x] = p.first;
					r[x] = p.second;

					par[y] = x;
					si[x] += si[y];
				}
				else {
					l[y] = p.first;
					r[y] = p.second;

					par[x] = y;
					si[y] += si[x];
				}
			}
		}

		ll ans = 1;
		for (int j = 0; j < n; j++) {
			int pred = f(j, par);

			if (pred == j) {
				ans *= max(1ll * 0, r[pred] - l[pred] + 1);
				ans %= e;
			}
		}

		cout << ans << endl;

		if (ans == 0) {
			fl0 = true;
		}
	}

	// ограничение dfs!!!!!!!!!
}