#include <bits/stdc++.h>

typedef long long ll;
typedef long double ld;

#define F first
#define S second
#define PB push_back

using namespace std;
int t, n, a, m;
vector <vector<int>> g;
vector <pair<ll, ll>> mas;
vector <vector<int>> bin;
vector<int>d;
const ll mod = 1e9 + 7;

void dfs(int now, int pred) {
    bin[0][now] = pred;
    d[now] = d[pred] + 1;
    for (auto to : g[now]) {
        if (to != pred) {
            dfs(to, now);
        }
    }
}

void calc() {
    for (int j = 1; j < 20; j++) {
        for (int i = 0; i < n; i++) {
            bin[j][i] = bin[j - 1][bin[j - 1][i]];
        }
    }
}

int lca(int a1, int b1) {
    for (int j = 19; j > -1; j--) {
        if (d[bin[j][a1]] >= d[b1]) {
            a1 = bin[j][a1];
        }
    }
    for (int j = 19; j > -1; j--) {
        if (d[bin[j][b1]] >= d[a1]) {
            b1 = bin[j][b1];
        }
    }
    if (a1 == b1) {
        return a1;
    }
    for (int j = 19; j > -1; j--) {
        if (bin[j][a1] != bin[j][b1]) {
            a1 = bin[j][a1];
            b1 = bin[j][b1];
        }
    }
    return bin[0][a1];
}

ll binpow(ll a1, ll b1) {
    if (b1 == 0) {
        return 1;
    }
    if (b1 == 1) {
        return a1;
    }
    if (b1 % 2 == 0) {
        return binpow((a1 * a1) % mod, b1 / 2);
    }
    return (a1 * binpow((a1 * a1) % mod, b1 / 2)) % mod;
}

void solve() {
    ll ans = 1;
    cin >> n;
    g.resize(n);
    for (int i = 1; i < n; i++) {
        cin >> a;
        a--;
        g[a].PB(i);
        g[i].PB(a);
    }
    mas.resize(n);
    d.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> mas[i].F >> mas[i].S;
        ans *= mas[i].S - mas[i].F + 1;
        ans %= mod;
    }
    cin >> m;
    bin.resize(20, vector<int> (n));
    dfs(0, 0);
    calc();
    vector <vector<ll>> col(n);
    vector<ll> color(n);
    vector <ll> mx(n), mn(n);
    for (int i = 0; i < n; i++) {
        col[i].PB(i);
        color[i] = i;
        mx[i] = mas[i].S;
        mn[i] = mas[i].F;
    }
    vector <ll> sz(n, 1);
    while (m--) {
        int a1, b1, c1, d1;
        cin >> a1 >> b1 >> c1 >> d1;
        a1--; b1--; c1--; d1--;
        vector <int> mas1, mas2;
        if (lca(a1, b1) == a1) {
            while (b1 != a1) {
                mas1.PB(b1);
                b1 = bin[0][b1];
            }
            mas1.PB(a1);
            reverse(mas1.begin(), mas1.end());
        }
        else if (lca(a1, b1) == b1) {
            while (a1 != b1) {
                mas1.PB(a1);
                a1 = bin[0][a1];
            }
            mas1.PB(a1);
        }
        else {
            while (a1 != lca(b1, a1)) {
                mas1.PB(a1);
                a1 = bin[0][a1];
            }
            mas1.PB(a1);
            vector <int> mas3;
            while (b1 != lca(b1, a1)) {
                mas3.PB(b1);
                b1 = bin[0][b1];
            }
            while (!mas3.empty()) {
                mas1.PB(mas3.back());
                mas3.pop_back();
            }
        }
        mas2 = mas1;
        mas1.resize(0);
        a1 = c1;
        b1 = d1;
        if (lca(a1, b1) == a1) {
            while (b1 != a1) {
                mas1.PB(b1);
                b1 = bin[0][b1];
            }
            mas1.PB(a1);
            reverse(mas1.begin(), mas1.end());
        }
        else if (lca(a1, b1) == b1) {
            while (a1 != b1) {
                mas1.PB(a1);
                a1 = bin[0][a1];
            }
            mas1.PB(a1);
        }
        else {
            while (a1 != lca(b1, a1)) {
                mas1.PB(a1);
                a1 = bin[0][a1];
            }
            mas1.PB(a1);
            vector <int> mas3;
            while (b1 != lca(b1, a1)) {
                mas3.PB(b1);
                b1 = bin[0][b1];
            }
            while (!mas3.empty()) {
                mas1.PB(mas3.back());
                mas3.pop_back();
            }
        }
        for (int i = 0; i < mas1.size(); i++) {
            a = mas1[i];
            int b = mas2[i];
            if (color[a] != color[b]) {
                if (sz[color[a]] >= sz[color[b]]) {
                    sz[color[a]] += sz[color[b]];
                    sz[color[b]] = 0;
                    ll c = color[b];
                    mn[color[a]] = max(mn[color[a]], mn[c]);
                    mx[color[a]] = min(mx[color[a]], mx[c]);
                    for (auto el: col[c]) {
                        col[color[a]].PB(el);
                        color[el] = color[a];
                    }
                    col[c].resize(0);
                } else {
                    swap(a, b);
                    sz[color[a]] += sz[color[b]];
                    sz[color[b]] = 0;
                    ll c = color[b];
                    mn[color[a]] = max(mn[color[a]], mn[c]);
                    mx[color[a]] = min(mx[color[a]], mx[c]);
                    for (auto el: col[c]) {
                        col[color[a]].PB(el);
                        color[el] = color[a];
                    }
                    col[c].resize(0);
                }
            }
        }
        ans = 1;
        for (int i = 0; i < n; i++) {
            if (sz[i] != 0) {
                if (mx[i] >= mn[i]) {
                    ans *= mx[i] - mn[i] + 1;
                    ans %= mod;
                }
                else {
                    ans = 0;
                    break;
                }
            }
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int tt = 1;
    while (tt--) {
        solve();
    }
}
