#include <bits/stdc++.h>
#pragma GCC optimize("O3,inline,unroll-loops")
#pragma GCC target("avx,avx2")
using namespace std;

//#define int long long 
#define ll long long
#define ld long double
#define pt pair<int, int>
#define fi first
#define x first
#define se second
#define y second
#define all(x) x.begin(), x.end()

//mt19937_64 rnd(chrono::steady_clock::now().time_since_epoch().count());
#define sz(x) (int)(x.size())
mt19937 rnd(228);
///=================================================///
const int MX = 3e5 + 100;
const int INF = 2e9;
const int MOD = 1e9 + 7;
///=================================================///
int n;
int p[MX];
vector<int> g[MX];
int bin[20][MX];
int h[MX], L[MX], R[MX];

void dfs(int u) {
    bin[0][u] = p[u];
    h[u] = h[p[u]] + 1;
    for (int log = 1; log < 20; log++) {
        bin[log][u] = bin[log - 1][bin[log - 1][u]];
    }
    for (int v : g[u]) {
        dfs(v);
    }
}

int lca(int u, int v) {
    if (h[u] < h[v]) swap(u, v);
    for (int log = 19; log >= 0; log--) {
        if (h[bin[log][u]] >= h[v]) {
            u = bin[log][u];
        }
    }
    if (u == v) return u;
    for (int log = 19; log >= 0; log--) {
        if (bin[log][u] != bin[log][v]) {
            u = bin[log][u];
            v = bin[log][v];
        }
    }
    return p[u];
}

int bpow(ll x, int a) {
    ll r = 1;
    while (a) {
        if (a % 2 == 1) {
            r = (x * r) % MOD;
            a--;
        } else {
            x = (x * x) % MOD;
            a /= 2;
        }
    }
    return (int)r;
}
ll prod = 1;
int pr[MX], r[MX];

int get(int x) {
    if (pr[x] != x) pr[x] = get(pr[x]);
    return pr[x];
}


void mer(int x, int y) {
    x = get(x), y = get(y);
    if (x == y) return;
    if (r[x] > r[y]) swap(x, y);

    if (prod != 0) prod = (ll)prod * bpow(R[x] - L[x] + 1, MOD - 2) % MOD;
    if (prod != 0) prod = (ll)prod * bpow(R[y] - L[y] + 1, MOD - 2) % MOD;

    pr[x] = y;
    if (r[x] == r[y]) r[y]++;
    if (R[x] < L[y] || R[y] < L[x]) {
        L[y] = 0, R[y] = 0;
        prod = 0;
    } else {
        vector<int> v = {L[x], L[y], R[x], R[y]};
        sort(all(v));
        L[y] = v[1], R[y] = v[2];
        prod = (ll) prod * (R[y] - L[y] + 1) % MOD;
    }
}


void solve() {
    cin >> n;

    for (int i = 2; i <= n; i++) {
        cin >> p[i];
        g[p[i]].push_back(i);
    }
    for (int i = 1; i <= n; i++) {
        pr[i] = i;
        cin >> L[i] >> R[i];
        prod *= (R[i] - L[i] + 1);
        prod %= MOD;
    }
    dfs(1);


    int q; cin >> q;


    while (q--) {
        int a, b, c, d; cin >> a >> b >> c >> d;
        int lc1 = lca(a, b), lc2 = lca(c, d);

        vector<int> v1, v2, v3, v4;
        while (a != lc1) {
            v1.push_back(a); a = p[a];
        }
        while (b != lc1) {
            v2.push_back(b); b = p[b];
        }
        v1.push_back(lc1);
        for (int i = sz(v2) - 1; i >= 0; i--) v1.push_back(v2[i]);
        while (c != lc2) {
            v3.push_back(c); c = p[c];
        }
        while (d != lc2) {
            v4.push_back(d); d = p[d];
        }
        v3.push_back(lc2);
        for (int i = sz(v4) - 1; i >= 0; i--) v3.push_back(v4[i]);


        for (int i = 0; i < sz(v1); i++) {
            mer(v1[i], v3[i]);
        }
        cout << prod << "\n";
    }
}

signed main() {
#ifndef LOCAL
    ios::sync_with_stdio(0); cin.tie();
#endif
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int tests = 1;
    // cin >> tests;
    ld starts = clock();
    while (tests--) solve();
    ld endd = clock();
#ifdef LOCAL
    cout << "\nEND: " << (endd - starts) / (ld)(CLOCKS_PER_SEC) << " sec\n";
#endif
    return 0;
}
