#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
//using namespace __gnu_pbds;
//typedef tree<ll, null_type, less<ll>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
const ll mod = 1e9 + 7;
const ll inf =  1e9 + 7;

ll cans = 1;
vector<ll> pr;
vector<ll> rng;
ll fpow(ll a, ll p){
    if(p == 0) return 1;
    if(p % 2 == 0){
        ll x = fpow(a, p / 2);
        return (x * x) % mod;
    }
    else return (fpow(a, p - 1) * a) % mod;
}
void init(ll n){
    pr.resize(n);
    iota(pr.begin(), pr.end(), 0);
    rng.assign(n, 0);
}
ll get(ll v){
    if(pr[v] == v) return v;
    else return pr[v] = get(pr[v]);
}
void join(ll u, ll v){
    u = get(u);
    v = get(v);
    if(u == v) return;
    if(rng[v] > rng[u]) swap(u, v);
    pr[v] = u;
    rng[u] += (rng[u] == rng[v]);
    return;
}
vector<vector<ll>> up, g;
vector<ll> p, h;
void dfs(ll v, ll ch = 0){
    h[v] = ch;
    for(auto to: g[v]){
        dfs(to, ch + 1);
    }
    return;
}
ll lca(ll a, ll b){
    ll x = a, y = b;
    if(h[a] > h[b]){
        ll k = h[a] - h[b];
        for(ll i = 0; i < 20; i++){
            if((k >> i) & 1) x = up[x][i];
        }
    }
    if(h[b] > h[a]){
        ll k = h[b] - h[a];
        for(ll i = 0; i < 20; i++){
            if((k >> i) & 1) y = up[y][i];
        }
    }
    if(x == y) return x;
    for(ll i = 19; i >= 0; i--){
        if(up[x][i] != up[y][i]){
            x = up[x][i];
            y = up[y][i];
        }
    }
    return up[x][0];
}
void solve(){
    ll n;
    cin >> n;
    up.assign(n, vector<ll> (20, 0));
    p.assign(n, 0);
    g.resize(n);
    for(ll i = 1; i <n ; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
        up[i][0] = p[i];
    }
    h.assign(n, 0);
    dfs(0);
    for(ll j = 1; j < 20; j++) {
        for (ll i = 0; i < n; i++) {
            up[i][j] = up[up[i][j - 1]][j - 1];
        }
    }
    vector<pair<ll, ll>> cr(n);
    for(ll i = 0; i < n; i++) {
         cin >> cr[i].first >> cr[i].second;
    }
    ll m;
    cin >> m;
    init(n);
    while(m--){
        ll a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        vector<ll> v1, v2, v3;
        ll l1 = lca(a, b);
        ll l2 = lca(c, d);
        //-------
        while(a != l1){
            v1.push_back(a);
            a = p[a];
        }
        while(b != l1) {
            v2.push_back(b);
            b = p[b];
        }
        reverse(all(v2));
        v1.push_back(l1);
        for(auto i: v2) v1.push_back(i);
        //---------------
        v2.clear();
        while(c != l2){
            v2.push_back(c);
            c = p[c];
        }
        while(d != l2) {
            v3.push_back(d);
            d = p[d];
        }
        reverse(all(v3));
        v2.push_back(l2);
        for(auto i: v3) v2.push_back(i);
        //------------------
        for(ll i = 0; i < v1.size(); i++){
            join(v1[i], v2[i]);
        }
        ll ans = 1;
        vector<pair<ll, ll>> c2(n, {0, inf});
        for (ll i = 0; i < n; i++){
            ll u = get(i);
            c2[u].first = max(c2[u].first, cr[i].first);
            c2[u].second = min(c2[u].second, cr[i].second);
        }
        for(auto [x, y] : c2){
            if(x == 0) continue;
            ans *= max(0ll, y - x + 1);
            ans %= mod;
        }
        cout << ans << '\n';
    }
}
signed main() {
#ifdef Local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}
