#include <bits/stdc++.h>
//#include <ext/pb_ds/assoc_container.hpp>
//#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
//using namespace __gnu_pbds;
//typedef tree<int, nuint_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef long double ld;
#define aint(x) x.begin(), x.end()
#define raint(x) x.rbegin(), x.rend()
const int mod = 1e9 + 7;
const int inf =  1e9 + 7;

void fastio(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
}
ll cans = 1;
vector<int> pr;
vector<int> rng;
vector<pair<int, int>> cr; //диапазон для i
vector<int> cc; // сколько вариантов для i-й компоненты на данный момент
int fpow(int a, int p){
    if(p == 0) return 1;
    if(p % 2 == 0){
        int x = fpow(a, p / 2);
        return ((ll)x * x) % mod;
    }
    else return ((ll)fpow(a, p - 1) * a) % mod;
}
int dev(int x, int k){
    return ((ll)x * fpow(k, mod - 2)) % mod;
}
void init(int n){
    pr.resize(n);
    iota(pr.begin(), pr.end(), 0);
    rng.assign(n, 0);
}
int get(int v){
    if(pr[v] == v) return v;
    else return pr[v] = get(pr[v]);
}
int m;
void join(int u, int v){
    u = get(u);
    v = get(v);
    if(u == v) return;
    if(rng[v] > rng[u]) swap(u, v);
    cans = dev(cans, cc[u]);
    cans = dev(cans, cc[v]);

    pr[v] = u;
    cr[u].first = max(cr[v].first, cr[u].first);
    cr[u].second = min(cr[u].second, cr[v].second);
    cc[u] = max(0, cr[u].second - cr[u].first + 1);
    auto p = cr[u];
    cans *= max(0, cr[u].second - cr[u].first + 1);
    cans %= mod;
    rng[u] += (rng[u] == rng[v]);
    return;
}
vector<vector<int>> up, g;
vector<int> p, h;
void dfs(int v, int ch = 0){
    h[v] = ch;
    for(auto to: g[v]){
        dfs(to, ch + 1);
    }
    return;
}
int lca(int a, int b){
    int x = a, y = b;
    if(h[a] > h[b]){
        int k = h[a] - h[b];
        for(int i = 0; i < 20; i++){
            if((k >> i) & 1) x = up[x][i];
        }
    }
    if(h[b] > h[a]){
        int k = h[b] - h[a];
        for(int i = 0; i < 20; i++){
            if((k >> i) & 1) y = up[y][i];
        }
    }
    if(x == y) return x;
    for(int i = 19; i >= 0; i--){
        if(up[x][i] != up[y][i]){
            x = up[x][i];
            y = up[y][i];
        }
    }
    return up[x][0];
}
void solve(){
    int n;
    cin >> n;
    up.assign(n, vector<int> (20, 0));
    p.assign(n, 0);
    g.resize(n);
    cc.resize(n);
    for(int i = 1; i <n ; i++) {
        cin >> p[i];
        p[i]--;
        g[p[i]].push_back(i);
        up[i][0] = p[i];
    }
    h.assign(n, 0);
    dfs(0);
    for(int j = 1; j < 20; j++) {
        for (int i = 0; i < n; i++) {
            up[i][j] = up[up[i][j - 1]][j - 1];
        }
    }
    cr.resize(n);
    for(int i = 0; i < n; i++) {
         cin >> cr[i].first >> cr[i].second;
         cc[i] = max(0, cr[i].second - cr[i].first + 1);
         cans *= max(0, cr[i].second - cr[i].first + 1);
         cans %= mod;
    }
    //cout << cans << '\n';
    cin >> m;
    init(n);
    while(m--){
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;b--;c--;d--;
        vector<int> v1, v2, v3;
        int l1 = lca(a, b);
        int l2 = lca(c, d);
        //-------
        while(a != l1){
            v1.push_back(a);
            a = p[a];
        }
        while(b != l1) {
            v2.push_back(b);
            b = p[b];
        }
        reverse(aint(v2));
        v1.push_back(l1);
        for(auto i: v2) v1.push_back(i);
        //---------------
        v2.clear();
        while(c != l2){
            v2.push_back(c);
            c = p[c];
        }
        while(d != l2) {
            v3.push_back(d);
            d = p[d];
        }
        reverse(aint(v3));
        v2.push_back(l2);
        for(auto i: v3) v2.push_back(i);
        //------------------

        for(int i = 0; i < v1.size(); i++){
            join(v1[i], v2[i]);
        }
        cout << cans << '\n';
    }
}
signed main() {
#ifdef Local
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    solve();
}
