#include <bits/stdc++.h>
#include <bits/extc++.h>
//
//using namespace __gnu_pbds;
//using namespace __gnu_cxx;
using namespace std;

//typedef tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;



#define int long long
const int N = 2e5 + 7;
const int M = 1e9 + 7;

vector<int> gr[N];

int tin[N];
int tout[N];

int timer = 1;
int hs[N];

void dfs(int u, int h) {
    tin[u] = timer;
    hs[u] = h;
    timer++;
    for (auto c: gr[u]) {
        dfs(c, h + 1);
    }
    tout[u] = timer;
}

bool is_pr(int u, int v) {
    return tin[u] <= tin[v] and tout[v] <= tout[u];
}


int prd[N];
int pr[N];

int get_pr(int u) {
    if (u == prd[u]) {
        return u;
    }
    return prd[u] = get_pr(prd[u]);
}

pair<int, int> vec[N];

int bin_pow(int a, int p) {
    if (p == 0) return 1;
    if (p % 2) {
        return bin_pow(a, p - 1) * a % M;
    }
    int c = bin_pow(a, p / 2);
    return c * c % M;
}

void solve() {
    int n;
    cin >> n;
    for (int i = 1; i < n; ++i) {
        prd[i] = i;
        int a;
        cin >> a;
        a--;
        pr[i] = a;
        gr[a].push_back(i);
    }
    dfs(0);
    int ans = 1;
    for (int i = 0; i < n; ++i) {
        cin >> vec[i].first >> vec[i].second;
        ans *= vec[i].second - vec[i].first + 1;
        ans %= M;
    }
//    cout << ans << endl;
    int m;
    cin >> m;
    for (int j = 0; j < m; ++j) {
        int a, b, c, d;
        cin >> a >> b >> c >> d;
        a--;
        b--;
        c--;
        d--;
        vector<int> path11, path12;
        while (!is_pr(a, b)) {
            path11.push_back(a);
            a = pr[a];
        }
        int dt = hs[a] - hs[b];
        path11.push_back(a);
        while (dt > 0) {
            dt--;
            path12.push_back(b);
            b = pr[b];
        }
        reverse(path12.begin(), path12.end());
        for (auto c1: path12) {
            path11.push_back(c1);
        }


        vector<int> path21, path22;
        while (!is_pr(c, d)) {
            path21.push_back(c);
            c = pr[c];
        }
        dt = hs[c] - hs[d];
        path21.push_back(c);
        while (dt > 0) {
            dt--;
            path22.push_back(d);
            d = pr[d];
        }
        reverse(path22.begin(), path22.end());
        for (auto c1: path22) {
            path21.push_back(c1);
        }

        if (path11.size() != path21.size()) exit(1);
        for (int i = 0; i < path11.size(); ++i) {
            int u = get_pr(path11[i]), v = get_pr(path21[i]);
            if (u == v) continue;
            int maxl = max(vec[u].first, vec[v].first), minr = min(vec[u].second, vec[v].second);
            ans *= bin_pow(vec[u].second - vec[u].first + 1, M - 2);
            ans %= M;
            ans *= bin_pow(vec[v].second - vec[v].first + 1, M - 2);
            ans %= M;
            prd[v] = u;
            vec[u] = {maxl, minr};
            if (maxl > minr) {
                ans = 0;
            }
            ans *= minr - maxl + 1;
            ans %= M;
        }
        cout << ans << "\n";
    }
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int tt = 1;
//    cin >> tt;
    while (tt--) {
        solve();
    }
    return 0;
}
