#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

const long double EPS = 1e-9;

int MAXK = 5e4;

void solve()
{
    int n, k;
    cin >> n >> k;
    vector<ll> a(n);
    //MAXK = 10 * k;
    vector<vector<ll> > dp(n, vector<ll>(MAXK + 1, 0));
    vector<vector<int> > divs(MAXK + 1);
    for (int i = 1; i <= MAXK; i++)
    {
        for (int j = 1; j * j <= i; j++)
        {
            if (i % j == 0)
            {
                divs[i].push_back(j);
                if (i / j != j)
                {
                    divs[i].push_back(i / j);
                }
            }
        }
        sort(divs[i].begin(), divs[i].end());
    }
    ll m = 1;
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
        m *= a[i];
    }
    if (m < (ll)k)
    {
        cout << 0;
        return;
    }
    if (n <= 2)
    {
        if (n == 1)
        {
            int ans = 0;
            for (int i = k; i <= a[0]; i++)
            {
                ans = max(ans, a[0] / i);
            }
            cout.precision(10);
            cout << fixed << ans * 1.0 / m * k;
        }
        else
        {
            ll ans = 0;
            for (int i = 1; i <= a[0]; i++)
            {
                for (int j = k / i; j <= a[1]; j++)
                {
                    if (i * 1ll * j >= k){
                    ans = max(ans, (a[0] / i) * 1ll * (a[1] / j));
                    break;
                    }

                }
            }
            cout.precision(10);
            cout << fixed << ans * 1.0 / m * k;
        }
        return;
    }
    for (int i = 1; i <= MAXK; i++)
    {
        dp[0][i] = a[0] / i;
    }
    for (int i = 1; i < n; i++)
    {
        for (int j = 1; j <= MAXK; j++)
        {
            for (auto& x : divs[j])
            {
                if (x > a[i])
                    break;
                dp[i][j] = max(dp[i][j], dp[i - 1][j / x] * (a[i] / x));
            }
        }
    }
    if (*max_element(dp[n - 1].begin(), dp[n - 1].end()) == 0)
    {
        cout << 0;
        return;
    }
    long double res = 0;
    for (int i = k; i <= MAXK; i++)
    {
        if ((long double)dp[n -  1][i] - res > EPS)
        {
            res = dp[n - 1][i];
        }
    }
    res /= m;
    res *= k;
    cout.precision(10);
    cout << fixed << res;
}

signed main()
{
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
