#include <bits/stdc++.h>

using namespace std;
typedef long long ll;

#define int long long

const long double EPS = 1e-9;

int MAXK = 8e4 + 10;

void solve()
{
    int n;
    ll k;
    cin >> n >> k;
    vector<ll> a(n);
    //MAXK = 10 * k;
    vector<vector<long double> > dp(n, vector<long double>(MAXK + 1, 0));
    vector<vector<int> > divs(MAXK + 1);
    for (int i = 1; i <= MAXK; i++)
    {
        for (int j = 1; j * j <= i; j++)
        {
            if (i % j == 0)
            {
                divs[i].push_back(j);
                if (i / j != j)
                {
                    divs[i].push_back(i / j);
                }
            }
        }
        sort(divs[i].begin(), divs[i].end());
    }
    for (int i = 0; i < n; i++)
    {
        cin >> a[i];
    }

    if (n <= 2)
    {
        ll m = 1;
        for (int i = 0; i < n; i++)
        {
            m *= a[i];
        }
        if (m < (ll)k)
    {
        cout << 0;
        return;
    }
        if (n == 1)
        {
            ll ans = 0;
            for (int i = k; i <= a[0]; i++)
            {
                ans = max(ans, a[0] / i);
            }
            cout.precision(10);
            cout << fixed << ans * 1.0 / m * k;
        }
        else
        {
            ll ans = 0;
            for (int i = 1; i <= a[0]; i++)
            {
                for (int j = k / i; j <= a[1]; j++)
                {
                    if (i * 1ll * j >= k){
                    ans = max(ans, (a[0] / i) * 1ll * (a[1] / j));
                    break;
                    }

                }
            }
            cout.precision(10);
            cout << fixed << ans * 1.0 / m * k;
        }
        return;
    }
    for (int i = 1; i <= MAXK; i++)
    {
        dp[0][i] = (a[0] / i) * 1.0 / a[0] * k;
    }
    for (int i = 1; i < n; i++)
    {
        for (int j = 1; j <= MAXK; j++)
        {
            for (auto& x : divs[j])
            {
                if (x > a[i])
                    break;
                dp[i][j] = max(dp[i][j], dp[i - 1][j / x] * (a[i] / x) * 1.0 / a[i]);
            }
        }
    }
    long double res = 0;
    for (int i = k; i < dp[n - 1].size(); i++)
    {
        res = max(res, dp[n - 1][i]);
    }
    if (res == 0)
    {
        cout << 0;
        return;
    }
    cout.precision(10);
    cout << fixed << res;
}

signed main()
{
    int t = 1;
    //cin >> t;
    while (t--) solve();
    return 0;
}
