#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;
typedef unsigned long long ull;

struct point{
    int x;
    int y;
};

int cp (point p1, point p2){
    return p1.x*p2.y - p1.y*p2.x;
}

point operator - (point& p1, point& p2){
    return {p1.x - p2.x, p1.y - p2.y};
}

/*
int n;
vector <ll> a;

struct node {
    ll mn;
    ll mx;
    ll sum;
};

struct segtree {
    int size = 1;
    vector <node> tree;

    int init (int n) {
        while (size<n) size*=2;
        tree.assign(2*size - 1, {(ll)1e9, (ll)-1e9, 0});
        return size;
    }

    void build (int x, int lx, int rx){
        if (rx-lx==1){
            if (lx<n) tree[x] = {a[lx], a[lx], a[lx]};
            return;
        }
        int m = (lx+rx)/2;
        build (2*x+1, lx, m);
        build (2*x+2, m, rx);

        node n1 = tree[2*x+1];
        node n2 = tree[2*x+2];

        tree[x] = {min(n1.mn, n2.mn), max(n1.mx, n2.mx), n1.sum+n2.sum};
    }

    node get (int x, int lx, int rx, int l, int r){
        if (r<=lx or l>=rx) return {(ll)1e9, (ll)-1e9, 0};
        if (l<=lx and r>=rx) return tree[x];

        int m = (lx+rx)/2;

        node n1 = get(2*x+1, lx, m, l, r);
        node n2 = get(2*x+2, m, rx, l, r);

        return {min(n1.mn, n2.mn), max(n1.mx, n2.mx), n1.sum+n2.sum};
    }

};
*/
ll n, k;
vector <int> a(n);

map <pair<int, ll>, ld> d;

ld dp(int i, ll c) {
    if (i==n) {
        if (c>=k) return k;
        return 0;
    }
    if (d[{i, c}]!=0) return d[{i, c}];
    int r = a[i];
    ld mx = 0;
    for (int j = 1; j<=a[i]; j++){
        if (mx<=dp(i+1, min(k, c*j))*(a[i]/j)) {
            mx = dp(i+1, min(k, c*j))*(a[i]/j);
            r = j;
        }
        if (c*j>k) break;
    }
    d[{i, c}] = dp(i+1, min(k, c*r))*(a[i]/r)/a[i];
    return dp(i+1, min(k, c*r))*(a[i]/r)/a[i];
}

int main() {
    cin.tie(0); cout.tie(0); ios::sync_with_stdio(0);
    cin >> n >> k;
    a.resize(n);
    for (int i=0; i<n; i++) cin >> a[i];
    if (n==1) {
        cout << setprecision(20) << (ld) k * (a[0]/k) / a[0];
        return 0;
    }
    if (n==2) {
        ld ans = 0;
        for (int i=1; i<=a[0]; i++){
            //if (k/i>a[1]) continue;
            if (i * (k/i)>=k) {
                ans = max(ans, (ld) k/a[0]/a[1]* (a[0]/i) * (a[1]/(k/i)));
            }
            else {
                ans = max(ans, (ld) k /a[0]/a[1]* (a[0]/i) * (a[1]/(k/i + 1)));
            }
        }
        cout << setprecision(20) << ans << "\n";
        return 0;
    }
    ld ans = dp(0, 1);
    cout << setprecision(20) << ans << "\n";
}