#define pii pair < int, int >
#pragma GCC optimize("Ofast")
#include <bits/stdc++.h>
#define ld long double
#define ll long long
#define _ << ' ' <<
#define int ll

using namespace std;

const int N = (int)2e5 + 5;
const int MOD = (int)1e9 + 7;

mt19937_64 gen(chrono::system_clock::now().time_since_epoch().count());

ld dp[105][N];

int32_t main() {
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);

    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    int n, k;
    cin >> n >> k;
    vector < ld > a(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
    }

    if (n == 1) {
        ld ans = 0;
        int i = 1;
        for (int cur = 1; cur <= a[1]; cur++) {
            int l = cur, r = a[1], nxt = cur;
            while (l <= r) {
                int mid = (l + r) / 2;
                if ((int)(a[i] / cur) == (int)(a[i] / mid)) {
                    nxt = mid;
                    l = mid + 1;
                }
                else {
                    r = mid - 1;
                }
            }
            cur = nxt;
            for (int was = 1; was <= 1; was++) {
                if (was * cur >= k) ans = max(ans, 1.0 * k / a[i] * (int)(a[i] / cur));
            }
        }
        cout << fixed << setprecision(11) << ans << '\n';
        return 0;
    }
    if (n == 2) {
        vector < int > v[3];
        for (int i = 1; i <= n; i++) {
            for (int cur = 1; cur <= a[i]; cur++) {
                int l = cur, r = a[i], nxt = cur;
                while (l <= r) {
                    int mid = (l + r) / 2;
                    if ((int)(a[i] / cur) == (int)(a[i] / mid)) {
                        nxt = mid;
                        l = mid + 1;
                    }
                    else {
                        r = mid - 1;
                    }
                }
                cur = nxt;
                v[i].push_back(cur);
            }
        }
        ld ans = 0;
        for (auto x: v[1]) {
            for (auto y: v[2]) {
                if (x * y >= k)
                    ans = max(ans, 1.0 * k * (int)(a[1] / x) * (int)(a[2] / y) / a[1] / a[2]);
            }
        }
        cout << fixed << setprecision(11) << ans << '\n';
        return 0;
    }
    dp[0][1] = k;

    for (int i = 1; i <= n; i++) {
        for (int cur = 1; cur <= a[i]; cur++) {
            int l = cur, r = a[i], nxt = cur;
            while (l <= r) {
                int mid = (l + r) / 2;
                if ((int)(a[i] / cur) == (int)(a[i] / mid)) {
                    nxt = mid;
                    l = mid + 1;
                }
                else {
                    r = mid - 1;
                }
            }
            cur = nxt;
            for (int was = 1; was <= k; was++) {
                dp[i][min(k, was * cur)] = max(dp[i][min(k, was * cur)], dp[i - 1][was] / a[i] * (int)(a[i] / cur));
            }
        }
    }

    ld ans = dp[n][k];
    cout << fixed << setprecision(11) << ans << '\n';
    return 0;
}
