#include <bits/stdc++.h>
#include <bits/extc++.h>

using namespace std;
using namespace __gnu_pbds;
#define ordered_set tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>
#define int long long
#define all(x) (x).begin(), (x).end()

struct SegmentTree {
    struct Node {

    };
    vector<Node> tree;
    int size;

    void init(int n) {
        size = 1;
        while (size < n) {
            size *= 2;
        }
        tree.resize(2 * size - 1, {});
    }

    Node combine(Node a, Node b) {

    }

    void set(int i, int v, int x, int lx, int rx) {
        if (rx - lx == 1) {
            tree[x] = {};
            return;
        }
        int m = (lx + rx) / 2;
        if (i < m) {
            set(i, v, 2 * x + 1, lx, m);
        } else {
            set(i, v, 2 * x + 2, m, rx);
        }
    }

    void set(int i, int v) {
        set(i, v, 0, 0, size);
    }

    Node get(int l, int r, int x, int lx, int rx) {
        // l lx rx r
        if (lx >= l && rx <= r) {
            return tree[x];
        }
        // l r lx rx
        // lx rx l r
        if (lx >= r || l >= rx) {
            return {};
        }
        int m = (lx + rx) / 2;
        auto left = get(l, r, 2 * x + 1, lx, m);
        auto right = get(l, r, 2 * x + 2, m, rx);
        return combine(left, right);
    }

    Node get(int l, int r) {
        return get(l, r, 0, 0, size);
    }
};

struct Vector {
    int x, y;

    Vector() = default;

    Vector(int x, int y) : x(x), y(y) {}

    Vector operator-(Vector ot) {

    }
};

long long cross_product(Vector a, Vector b) {
    return a.x * b.y - a.y * b.x;
}

long long dot_product(Vector a, Vector b) {
    return a.x * b.x + a.y * b.y;
}

int32_t main() {
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
    cout << setprecision(20) << fixed;
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    int pr = 1;
    for (int& i : a) {
        cin >> i;
        if (pr < k) {
            pr *= i;
        }
    }
    if (pr < k) {
        cout << 0 << '\n';
        return 0;
    }
    if (n == 1) {
        long double res = k;
        res /= a[0];
        res *= (a[0] / k);
        cout << res;
        return 0;
    } else if (n == 2) {
        long double mx = 0;
        for (int b1 = 1; b1 <= a[0]; b1++) {
            int b2 = (k + b1 - 1) / b1;
            if (b2 >= 1 && b2 <= a[1]) {
                long double res = k;
                res /= a[0];
                res /= a[1];
                res *= (a[0] / b1);
                res *= (a[1] / b2);
                mx = max(mx, res);
            }
        }
        cout << mx;
        return 0;
    }
    vector<vector<pair<int, int>>> divs(n);
    for (int i = 0; i < n; i++) {
        for (int d = 1; d <= a[i]; d++) {
            divs[i].emplace_back(a[i] / d, d);
        }
        sort(all(divs[i]));
        divs[i].resize(unique(all(divs[i])) - divs[i].begin());
    }
    vector<long double> can(k + 1, 0);
    can[1] = 1;
    auto can2 = can;
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < k + 1; j++) {
            for (auto [x, y] : divs[i]) {
                int next = min(k, j * y);
                can2[next] = max(can2[next], can[j] * x);
            }
        }
        can = can2;
    }

    long double ans = can[k];
    ans *= k;
    for (int i : a) {
        ans /= i;
    }
    cout << setprecision(20) << ans;
    return 0;
}