#include<iostream>
#include<vector>
#include<algorithm>
using namespace std;

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    int n;
    cin >> n;

    vector<vector<int>> v(n);
    for (int i = 0; i < n; i++) {
        int k;
        cin >> k;

        v[i].resize(k);
        for (int j = 0; j < k; j++)
            cin >> v[i][j];
    }

    if (n <= 7) {
        vector<int> p(n);
        for (int i = 0; i < n; i++)
            p[i] = i;

        int mxlen = -1;
        do {
            int mx = 0, curlen = 0;
            for (auto e : p) {
                for (auto l : v[e]) {
                    if (l > mx) {
                        mx = l;
                        curlen++;
                    }
                }
            }
            mxlen = max(mxlen, curlen);
        } while (next_permutation(p.begin(), p.end()));

        cout << mxlen << '\n';
        return 0;
    }

    return 0;
}
