#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const ll INF = 1e9 + 100, MOD = 1e9 + (1000 - 7), MAXN = 2e5;
const ld EPS = 1e-8;

random_device rd;
mt19937 rnd(rd());

#define max3(a, b, c) max(max(a, b), c)
#define min3(a, b, c) min(min(a, b), c)
#define pow2(x) ((x) * (x));
#define mod(x, m) (((x) % (m) + (m)) % (m))
#define debug(x) cerr << (#x) << " : " << x << endl

void solve() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) cin >> a[i];
    vector<ld> dp(k + 1);
    for (ll j = 1; j <= a[0]; ++j) {
        ll mn = min(j, k);
        if (dp[mn] < (ll)(a[0] / j)) {
            dp[mn] = (ll)(a[0] / j);
        }
    }
    for (ll i = 0; i <= k; ++i) dp[i] /= a[0];
    for (ll i = 1; i < n; ++i) {
        vector<ld> ndp(k + 1);
        for (ll b = 1; b <= k; ++b) {
            for (ll del = 1; del <= b; ++del) {
                if (b % del == 0) {
                    if (ndp[b] < dp[del] * (ll)(a[i] / (b / del))) {
                        ndp[b] = dp[del] * (ll)(a[i] / (b / del));
                    }
                }
            }
        }
        for (ll b = 0; b <= k; ++b) ndp[b] /= a[i];
        dp = ndp;
    }
    ld ans = dp[k] * k;
    cout << fixed << setprecision(20) << ans;
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);

    //freopen("ALO.in", "r", stdin);
    //freopen("ALO.out", "w", stdout);

    ll test = 1;
//    cin >> test;
    while (test--) {
        solve();
    }
    return 0;
}