#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
#include <iomanip>
#include <unordered_map>
#include <unordered_set>
#include <map>
#include <set>
#include <deque>
#include <queue>
#include <random>
#include <chrono>

typedef long long ll;

using namespace std;

const ll INF = 2e9;

int main() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
    }

    vector<vector<ll>> dp(n + 1, vector<ll>(k + 1, 0));
    dp[0][1] = 1;
    for (ll i = 1; i <= n; ++i) {
        for (ll j = 1; j <= k; ++j) {
            for (ll bi = 1; bi <= a[i - 1]; ++bi) {
                dp[i][min(j * bi, k)] = max(dp[i - 1][j] * (a[i - 1] / bi), dp[i][min(j * bi, k)]);
            }
        }
    }

    long double ans = dp[n][k];
    ans *= k;
    for (ll i = 0; i < n; ++i) {
        ans /= a[i];
    }

    cout << fixed << setprecision(10);
    cout << ans << '\n';

    return 0;
}
