#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

void solve(){
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<ll>> c(n);
    for (int i = 0; i < n; i++){
        set<int> cr;
        for (int j = 1; j * j <= a[i]; j++){
            cr.insert(a[i] / j);
            cr.insert(j);
        }
        for (int j : cr) c[i].pb(j);
    }
    vector<unordered_map<ll, ll>> dp(n + 1);
    dp[0][1] = 1;
    for (int i = 0; i < n; i++){
        for (auto j : dp[i]){
            for (ll l : c[i]) {
                int kr = min(k, l * j.ff);
                if (dp[i + 1].find(kr) == dp[i + 1].end()) dp[i + 1][kr] = j.ss * (a[i] / l);
                dp[i + 1][kr] = max(dp[i + 1][kr], j.ss * (a[i] / l));
            }
        }
    }
    if (dp[n].find(k) == dp[n].end()){
        cout << 0 << endl;
        return;
    }
    ld ans = dp[n][k];
    for (int i : a) ans /= (ld)i;
    ans *= k;
    cout << fixed << setprecision(9) << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while(n--) solve();
}
