#include <bits/stdc++.h>

using namespace std;

using ll = long long;
using ld = long double;
using vi = vector<int>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;

#define debug(x) cerr << "[" << #x << "]: " << x << endl
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()
#define pb push_back
#define ff first
#define ss second

void solve(){
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    vector<vector<ll>> c(n);
    for (int i = 0; i < n; i++){
        set<ll> cr;
        for (ll j = 1; j * j <= a[i]; j++){
            cr.insert(a[i] / j);
            cr.insert(j);
        }
        for (ll j : cr) c[i].pb(j);
    }
    /*vector<unordered_map<ll, ld>> dp(n + 1);
    dp[0][k] = 1;
    for (int i = 0; i < n; i++){
        for (auto j : dp[i]){
            for (ll l : c[i]) {
                int kr = max(1ll, (j.ff - 1) / l + 1);
                if (dp[i + 1].find(kr) == dp[i + 1].end()) dp[i + 1][kr] = j.ss * (a[i] / l) / (ld)a[i];
                dp[i + 1][kr] = max(dp[i + 1][kr], j.ss * (a[i] / l) / (ld)a[i]);
            }
        }
    }*/
    set<ll> cr;
    for (ll j = 1; j * j <= k; j++){
        cr.insert(k / j);
        cr.insert(j);
    }
    vector<ll> ck;
    for (ll j : cr) ck.pb(j);
    vector<int> ord(k + 1, -1);
    for (int i = 0; i < sz(ck); i++) ord[ck[i]] = i;
    vector<vector<ld>> dp(n + 1, vector<ld> (sz(ck), 0));
    dp[0][ord[k]] = 1;
    for (int i = 0; i < n; i++){
        for (int j = 0; j < sz(ck); j++){
            if (dp[i][j] == 0) continue;
            for (ll l : c[i]){
                ll kr = (ck[j] - 1) / l + 1;
                dp[i + 1][ord[kr]] = max(dp[i + 1][ord[kr]], dp[i][j] * (a[i] / l) / (ld)a[i]);
            }
        }
    }
    ld ans = dp[n][ord[1]];
    if (ans == 0){
        cout << 0 << endl;
        return;
    }
    ans *= k;
    cout << fixed << setprecision(9) << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n = 1;
    //cin >> n;
    while(n--) solve();
}
