#include "bits/stdc++.h"
//#include <bits/extc++.h>

#ifndef NT1E
#pragma GCC target("tune=native")
#pragma GCC optimize("O3,unroll-loops")
#endif

using namespace std;
using ll = long long;

using float_type = float;

int main() {
#ifdef NT1E
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin.tie(nullptr)->sync_with_stdio(false);
    int n, k;
    cin >> n >> k;
    vector<vector<float_type>> dp(n + 1);
    for (auto &now : dp) {
        now.resize(k + 1);
    }
    vector<int> a(n);
    float_type prod = k;
    for (int i = 0; i < n; ++i) {
        cin >> a[i];
    }
    dp[0][1] = prod;
    for (int i = 0; i < n; ++i) {
        float_type c = 0;
        for (int to_dolek = 1; to_dolek <= a[i]; ++to_dolek) {
            float_type nc = ((a[i]) / to_dolek);
            if (nc == c) continue;
            for (int was_dolek = 1; was_dolek <= k; ++was_dolek) {
                int to_i = min(to_dolek * was_dolek, k);
                dp[i + 1][to_i] = max(dp[i + 1][to_i], (float_type)dp[i][was_dolek] / a[i] * nc);
                if (to_i == k) break;
            }
        }
        for (int t = k - 1; t >= 1; --t) {
            dp[i + 1][t] = max(dp[i + 1][t], dp[i + 1][t + 1]);
        }
    }
    cout << setprecision(10) << fixed << *max_element(dp[n].begin() + k, dp[n].end()) << '\n';
    return 0;
}
