#include <iostream>
#include <vector> 
#include <algorithm> 
#include <iomanip>

using namespace std;

#define all(x) x.begin(), x.end()
#define pb push_back
typedef long long ll;

int n;
vector<vector<int> > a;
vector<int> cur, used;

int gen(int pos) {
    if (pos == n) {
        int mx = 0, ans = 0;
        for (auto i : cur) {
            for (int j = 0; j < a[i].size(); j++) {
                if (a[i][j] > mx) ans++;
                mx = max(mx, a[i][j]);
            }
        }
        return ans;
    }
    int mx = 0;
    for (int i = 0; i < n; i++) {
        if (!used[i]) {
            used[i] = 1;
            cur.pb(i);
            mx = max(mx, gen(pos + 1));
            used[i] = 0;
            cur.pop_back();
        }
    }
    return mx;
}

void solve1() {
    used.resize(n);
    int ans = gen(0);
    cout << ans << "\n";
}

int main() {
    cin >> n;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        int k, x; cin >> k;
        for (int j = 0; j < k; j++) {
            cin >> x;
            a[i].pb(x);
        }
    }
    if (n <= 7) {
        solve1();
        return 0;
    }
    return 0;
}