#include <bits/stdc++.h>
#include <unordered_map>
#include <unordered_set>

#define umap unordered_map
#define uset unordered_set

#define spc << ' ' <<
#define space << ' '
#define newl << '\n'
#define endl << endl

#define pb push_back
#define elif else if
#define all(a) (a).begin(), (a).end()
#define rall(a) (a).rbegin(), (a).rend()
#define repeat(a) for (int i31 = 0; i31 < a; ++i31)

using namespace std;
using str = string;
using ll = long long;
using vi = vector <int>;
using vl = vector <ll>;
using vvi = vector <vi>;
using vvl = vector <vl>;
using pii = pair <int, int>;
using pll = pair <ll, ll>;
using ld = double;

template <typename T>
istream& operator>>(istream& in, pair <T, T>& p) {
    in >> p.first >> p.second;
    return in;
}
template <typename T>
istream& operator>>(istream& in, vector <T>& a) {
    for (int i = 0; i < (int)a.size(); ++i) {
        in >> a[i];
    }
    return in;
}
template <typename T>
ostream& operator<<(ostream& out, pair <T, T>& p) {
    out << p.first << p.second;
    return out;
}
template <typename T>
ostream& operator<<(ostream& out, vector <T>& a) {
    for (auto c : a) {
        out << c space;
    }
    return out;
}

const int INF = INT_MAX;
const ll LINF = LLONG_MAX;
const ll hash_power = 29;
const ll mod = 1e9 + 7;

void solve() {
    ll n, k;
    cin >> n >> k;
    vl a(n);
    cin >> a;

    cout << fixed << setprecision(20);

    if (n == 1) {
        if (a[0] < k) {
            cout << 0;
        }
        else {
            cout << (ld)k * (ld)(a[0] / k) / (ld)a[0];
        }
        return;
    }
    elif (n == 2) {
        ld ans = 0;
        for (ll d = 1; d <= a[0]; ++d) {
            ll t = k / d + (k % d != 0);
            if (t <= 0 || t > a[1]) continue;
            ans = max(ans, (ld)(a[0] / d) * (ld)(a[1] / t) * (ld)k / (ld)(a[0] * a[1]));
        }
        cout << ans;
        return;
    }

    vector <ld> dp(k + 1, 0);
    for (ll d = 1; d <= a[0]; ++d) {
        if (d + 1 <= a[0] && a[0] / d == a[0] / (d + 1)) continue;
        if (dp[min(d, k)] < (ld)(a[0] / d) / (ld)a[0]) {
            dp[min(d, k)] = (ld)(a[0] / d) / (ld)a[0];
        }
    }

    for (int i = 1; i < n; ++i) {
        vector <ld> newdp(k + 1, 0);
        for (ll d = 1; d <= a[i]; ++d) {
            if (d + 1 <= a[i] && a[i] / d == a[i] / (d + 1)) continue;
            for (ll s = 1; s <= k; ++s) {
                if (dp[s] == 0) continue;
                newdp[min(s * d, k)] = max(newdp[min(s * d, k)], dp[s] * (ld)(a[i] / d) / (ld)a[i]);
                if (s * d > k) break;
            }
        }
        swap(dp, newdp);
    }

    ld ans = dp[k] * k;
    cout << ans;
}

void tests() {
    int t;
    cin >> t;
    for (int i = 1; i <= t; ++i) {
        cout << "Test number:" spc i newl;
        solve();
        cout newl;
    }
}

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    /*
    freopen("inputA.txt", "r", stdin);
    tests();*/

    solve();
}
