#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>
#define x first
#define y second
#define pb emplace_back
#define all(x) x.begin(), x.end()
#define sz(x) (int)x.size()

using namespace std;
//using namespace __gnu_pbds;

//typedef tree<int, null_type, less<>, rb_tree_tag, tree_order_statistics_node_update> ordered_set;
typedef long long ll;
typedef pair<int, int> pt;
typedef pair<ll, ll> ptll;
typedef long double ld;
typedef pair<ld, ld> ptld;

void fastio(){
    cin.tie(nullptr);
    ios_base::sync_with_stdio(false);
}

/*
#pragma GCC optimize("Ofast")
#pragma GCC target("avx,avx2,sse,ssse3,sse3,sse4,sse4.1")
#pragma GCC optimize("inline")
#pragma GCC optimize("unroll-loops")
*/

mt19937 rnd(31);

const int SQRTK = 1e7;
const int MAXN = 105;

ld dp1[SQRTK], dp2[SQRTK];
vector<pt> vars[MAXN];
int a[MAXN];

vector<pt> precalc(int x){
    vector<pt> res;
    for (ll i = 1; i * i <= x + 1; i++){
        int b = x / i;
        int nw = x / b;
        if (res.empty() || res.back().x != b)
            res.pb(b, nw);
    }
    for (ll b = (int)(sqrt(x) + 1); b >= 1; b--){
        int l = x / (b + 1) + 1, r = x / b;
        if (l <= r){
            int nw = x / b;
            if (res.empty() || res.back().x > b)
                res.pb(b, nw);
        }
    }
    reverse(all(res));
    return res;
}

void run(){
    int n, k;
    cin >> n >> k;
    for (int i = 0; i < n; i++){
        int ai;
        cin >> ai;
        a[i] = ai;
        vars[i] = precalc(ai);
    }
    dp2[k] = k;
    vector<int> dels = {k};
    for (int i = 2; i <= k; i++){
        int nw = (k + i - 1) / i;
        if (dels.back() != nw)
            dels.push_back(nw);
    }
    reverse(all(dels));
    for (int i = 0; i < n; i++){
        swap(dp1, dp2);
        fill(dp2, dp2 + SQRTK, 0);
        for (int r: dels){
            if (dp1[r] == 0)
                continue;
            for (auto [b, d]: vars[i]){
                ld curr = dp1[r] * d / a[i];
                int r1 = (r + b - 1) / b;
                dp2[r1] = max(dp2[r1], curr);
            }
        }
    }
    cout << setprecision(20) << fixed;
    cout << dp2[1] << '\n';
}

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#else
    fastio();
#endif
    ld start = clock();
    run();
    ld stop = clock();
#ifdef LOCAL
    cerr << "\nProgram finished in " << (stop - start) / CLOCKS_PER_SEC << " sec\n";
#endif
    return 0;
}