#include <bits/stdc++.h>
#define endl '\n'

using namespace std;

const int maxn = 128;
int n, k, a[maxn];

void solve1(){
    if(k > a[1]){
        cout << 0 << endl;
        return;
    }
    int l = 1, r = a[1];
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[1] / mid >= k)
            l = mid + 1;
        else
            r = mid - 1;
    }
    double ans = (double)r / (double)a[1] * k;
    cout << fixed << setprecision(9) << ans << endl;
}

void solve2(){
    if(a[1] > a[2])
        swap(a[1], a[2]);
    if(a[1] * a[2] < k){
        cout << 0 << endl;
        return;
    }
    int l = 1, r = a[1];
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[1] / mid * a[2] / mid >= k)
            l = mid + 1;
        else
            r = mid - 1;
    }
    int br = a[1] / r;
    int w = k / br;
    if(k % br)
        w++;
    double ans = (double)r;
    l = 1, r = a[2];
    while(l <= r){
        int mid = (l + r) / 2;
        if(a[2] / mid >= w)
            l = mid + 1;
        else
            r = mid - 1;
    }
    ans *= (double)r;
    ans /= (double)(a[1] * a[2]);
    ans *= k;
    for(int i = 1;i <= a[1];i++){
        if(a[1] / i >= k){
            double curr = (double)(i * a[2]) / (double)(a[1] * a[2]) * k;
            ans = max(ans, curr);
        }
    }
    cout << fixed << setprecision(9) << ans << endl;
}
int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cin >> n >> k;
    for(int i = 1;i <= n;i++){
        cin >> a[i];
    }
    if(n == 1) solve1();
    else solve2();
    return 0;
}
