#define _GLIBCXX_DEBUG
#define __GLIBCXX_DEBUG
#include <iostream>
#include "bits/stdc++.h"
#include "ext/pb_ds/assoc_container.hpp"
#include "ext/pb_ds/tree_policy.hpp"
using ll = long long;
using ull = unsigned long long;
using namespace std;
using namespace __gnu_pbds;
template<typename T>
using ordered_set = __gnu_pbds::tree<T, __gnu_pbds::null_type, less<T>, __gnu_pbds::rb_tree_tag, __gnu_pbds::tree_order_statistics_node_update>;


const ll MAX_MEMORY = 240 * 1024 * 1024;
char MEMORY[MAX_MEMORY];
ll mem_pos = 0;
void* operator new(size_t n) {
    assert((mem_pos += n) <= MAX_MEMORY);
    return (void*)(MEMORY + mem_pos - n);
}
void* operator new[](size_t n) {
    assert((mem_pos += n) <= MAX_MEMORY);
    return (void*)(MEMORY + mem_pos - n);
}
void operator delete(void*) noexcept {}
void operator delete(void*, size_t) noexcept {}
void operator delete[](void*) noexcept {}
void operator delete[](void*, size_t) noexcept {}



int main() {
    ll n, k;
    cin >> n >> k;
    vector<ll> a(n);
    ll s = 1;
    for (ll i = 0; i < n; ++i) {
        cin >> a[i];
        s *= a[i];
    }
    if (s < k) {
        cout << 0 << endl;
        return 0;
    }
    vector<vector<ll>> a_chastn(n, vector<ll>());
    vector<ll> k_chastn;
    vector<ll> k_chastn_index(k + 1, -1);
    for (ll i = 0; i < n; ++i) {
        ll j;
        for (j = 1; j * j <= a[i]; ++j) {
            a_chastn[i].push_back(j);
            a_chastn[i].push_back(a[i] / j);
        }
        sort(a_chastn[i].begin(), a_chastn[i].end());
        a_chastn[i].resize(unique(a_chastn[i].begin(), a_chastn[i].end()) - a_chastn[i].begin());
    }
    {
        ll j;
        for (j = 1; j * j <= k; ++j) {
            k_chastn.push_back(j);
            k_chastn.push_back(j + 1);
            k_chastn.push_back((k + j - 1) / j);
        }
        sort(k_chastn.begin(), k_chastn.end());
        k_chastn.resize(unique(k_chastn.begin(), k_chastn.end()) - k_chastn.begin());
        for (j = 0; j < k_chastn.size(); ++j) {
            k_chastn_index[k_chastn[j]] = j;
        }
    }
    vector<vector<ll>> dp(n + 1, vector<ll>(k_chastn.size()));
    dp[0][0] = 1;
    for (ll j = 1; j < k_chastn.size(); ++j) {
        dp[0][j] = 0;
    }
    for (ll i = 0; i < n; ++i) {
        for (ll kki = 0; kki < k_chastn.size(); ++kki) {
            ll kk = k_chastn[kki];
            for (ll chastn : a_chastn[i]) {
                ll bmax = (a[i] / chastn);
                dp[i + 1][kki] = max(dp[i + 1][kki], dp[i][k_chastn_index[(kk + bmax - 1) / bmax]] * chastn);
            }
        }
    }
    cout << fixed << setprecision(18) << dp[n][k_chastn_index[k]] / (double)(s) * k << endl;
    return 0;
}
