#include <bits/stdc++.h>

template <typename T>
struct in {
    T x;

    in() {
        std::cin >> x;
    }

    in(const T &_x) : x(_x) {
    }

    operator T&() {
        return x;
    }

    operator const T&() const {
        return x;
    }
};

using namespace std;

struct solve {
    in<int> n, k;
    vector<in<int>> a;

    vector<vector<double>> dp;

    solve() : a(n), dp(n + 1, vector<double>(2 * k)) {
        dp[0][1] = k;
        for (int i = 0; i < n; ++i) {
            for (int ik = 1; ik < 2 * k; ++ik) {
                for (int bi = 1; bi <= a[i] && bi * ik < 2 * k; ++bi) {
                    dp[i + 1][bi * ik] = max(dp[i + 1][bi * ik], dp[i][ik] * (long double) (a[i] / bi) / a[i]);
                }
            }
        }
        cout.precision(20);
        cout << *max_element(dp.back().begin() + k, dp.back().end()) << "\n";
    }
};

int main() {
    ios::sync_with_stdio(false);
#ifndef LOCAL
    cout.tie(nullptr);
#endif

    in<int> t = 1;
    while (t--) {
        solve();
    }
}
