#include <bits/stdc++.h>

using namespace std;
typedef long long ll;
typedef long double ld;

const int MAXK = 502;

void solve() {
    int n, k;
    cin >> n >> k;

    vector <ll> a(n);
    for (ll &x: a) cin >> x;

    ll total = 1;
    for (int i = 0; i < n && total < k; i++)
        total *= a[i];

    if (total < k) {
        cout << "0\n";
        return;
    }

    vector <vector <ld>> dp(n + 1, vector <ld> (MAXK + 1, 0));
    dp[0][1] = 1;

    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= MAXK; j++) {
            for (int l = 1; l <= a[i]; l++) {
                int ki = min(MAXK, j * l);
                dp[i + 1][ki] = max(dp[i + 1][ki], dp[i][j] * (ll)(a[i] / l) / (ld)a[i]);
            }
        }
    }

    ld answer = 0;
    for (int i = k; i <= MAXK; i++) {
        answer = max(answer, dp[n][i]);
    }

    cout << setprecision(14) << fixed << answer * k << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
