#include <bits/stdc++.h>
#define int long long

using namespace std;
typedef long long ll;
typedef long double ld;

void solve() {
    int n, k;
    cin >> n >> k;

    vector <ll> a(n);
    for (ll &x: a) cin >> x;

    ll total = 1;
    for (int i = 0; i < n && total < k; i++)
        total *= a[i];

    if (total < k) {
        cout << "0\n";
        return;
    }

    if (n == 1) {
        ld answer = k;
        answer /= a[0];
        answer *= (ll)(a[0] / k);
        cout << setprecision(14) << fixed << answer << '\n';
        return;
    }

    if (n == 2) {
        ld answer = 0;

        for (int i = 1; i <= a[0]; i++) {
            ld newans = k;
            newans /= a[0];
            newans /= a[1];
            newans *= (ll)(a[0] / i);

            if (i < k) {
                if ((k + i - 1) / i > a[1])
                    continue;

                newans *= (ll)(a[1] / ((k + i - 1) / i));
            } else {
                newans *= a[1];
            }

            answer = max(answer, newans);
        }

        cout << setprecision(14) << fixed << answer << '\n';
        return;
    }

    vector <vector <ld>> dp(n + 1, vector <ld> (k + 1, 0));
    dp[0][1] = 1;

    auto find_next_l = [&] (int i, int x) {
        int l = x, r = a[i] + 1;
        while (r - l > 1) {
            int mid = (l + r) / 2;

            if (a[i] / mid != a[i] / x) {
                r = mid;
            } else {
                l = mid;
            }
        }

        return r;
    };

    for (int i = 0; i < n; i++) {
        int l = 1;
        int cnt = 0;

        while (true) {
            for (int j = 1; j <= k; j++) {
                int ki = min(k, l * j);
                dp[i + 1][ki] = max(dp[i + 1][ki], dp[i][j] * (ll)(a[i] / l) / (ld)a[i]);
            }

            if (l == a[i])
                break;

            cnt++;
            if (cnt > 10000)
                break;

            l = find_next_l(i, l + 1) - 1;
        }
    }

    cout << setprecision(14) << fixed << dp[n][k] * k << '\n';
}

signed main() {
    cin.tie(NULL);
    ios_base::sync_with_stdio(false);

    #ifdef local
    freopen("input.txt", "r", stdin);
    #endif // local

    solve();
}
