#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

typedef long long ll;
#define sz(x) (int)x.size()
#define all(x) x.begin(), x.end()
#define mem(x, y) memset(x, y, sizeof x)
#define int ll
#define double long double

const int maxn = 105;
int n, k, a[maxn], suf[maxn];
gp_hash_table <int, int> memo[maxn];
int ans(int i, int k) {
	if (i > n) return k <= 1;
	if (k <= 1) return suf[i];
	if (memo[i].find(k) == memo[i].end()) {
		int mx = 0;
		for (int x = 1; x <= a[i]; x++) {
			int y = int(a[i] / x) * ans(i + 1, (k + x - 1) / x);
			mx = max(mx, y);
		}
		memo[i][k] = mx;
	}
	return memo[i][k];
}

signed main() {
	cin.tie(0)->sync_with_stdio(0);
	
	cin >> n >> k;
	for (int i = 1; i <= n; i++) cin >> a[i];
	
	suf[n] = a[n];
	for (int i = n - 1; i >= 1; i--) {
		suf[i] = suf[i + 1] * a[i];
	}
	
	double x = ans(1, k) * k;
	for (int i = 1; i <= n; i++) x /= a[i];
	cout << fixed << setprecision(10) << x << endl;
	
	return 0;
}
