#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>

using namespace std;
struct st {
    int x, y;
};

bool comp1(st a, st b) {
    if (a.x == b.x) {
        return a.y < b.y;
    }
    return a.x < b.x;
};

bool comp2(st a, st b) {
    if (a.y == b.y) {
        return a.x < b.x;
    }
    return a.y < b.y;
};
vector<int> tree;
vector<int> arr;

void build(int v, int l, int r) {
    if (r - l == 1) {
        tree[v] = arr[l];
        return;
    }
    int m = l + (r - l) / 2;
    build(2 * v + 1, l, m);
    build(2 * v + 2, m, r);
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

void update(int v, int l, int r, int k, int x) {
    if (r - l == 1) {
        tree[v] = x;
        return;
    }
    int m = l + (r - l) / 2;
    if (k < m) {
        update(2 * v + 1, l, m, k, x);
    } else {
        update(2 * v + 2, m, r, k, x);
    }
    tree[v] = tree[2 * v + 1] + tree[2 * v + 2];
}

int get(int v, int l, int r, int ql, int qr) {
    if (ql <= l && r <= qr) {
        return tree[v];
    }
    if (l >= qr || r <= ql) {
        return 0;
    }
    int m = l + (r - l) / 2;
    return get(2 * v + 1, l, m, ql, qr) + get(2 * v + 2, m, r, ql, qr);
}

vector<long long> a;
double ans = 0;
int n;
long long k_ish = 0;
vector <long long> b_arr;
void find1(long long k, int i, int b_pred, long long temp1) {
    if (i == n) {
        bool flag = false;
        long long ch = 1;
        double temp_ans = 1;
        for (int j = 0; j < n; j++){
            ch *= b_arr[j];
            if (ch >= k_ish){
                flag = true;
                break;
            }
        }
        if (flag){
            for (int j = 0; j < n; j++){
                temp_ans *= (double((a[j] / b_arr[j])) / double(a[j]));
            }
        }
        if (temp_ans > ans && flag) {
            ans = temp_ans;
        }
        return;
    }
    for (int b = 1; b <= min(1ll * b_pred, k / temp1 + 1); b++) {
        b_arr[i] = b;
        find1(k, i + 1, a[i + 1], temp1 * b);
    }
}

int main() {
    cin >> n;
    cin >> k_ish;
    a.resize(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    b_arr.resize(n + 1, 1);
    sort(a.begin(), a.end());
    reverse(a.begin(), a.end());
    find1(k_ish, 0, min(a[0], k_ish), 1);
    cout << fixed << setprecision(10) << ans * k_ish;
    return 0;
}
