#include <iostream>
#include <vector>
#include <set>
#include <map>
#include <algorithm>
#include <deque>
#include <iomanip>
#include <cassert>

using namespace std;
typedef long long ll;
typedef long double ld;

int n;
int k;

const int N = 110;
const int K = 20010;

int a[N];
vector <pair <int, ld>> maybe[N];

signed main()
{
	ios::sync_with_stdio(false);
	cin.tie(0);

	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);

	cin >> n >> k;

	for (int i = 1; i <= n; ++i)
	{
		cin >> a[i];
	}

	vector <vector <ld>> dp(n + 1, vector <ld>(k));

	for (int i = 1; i <= n; ++i)
	{
		int f = 1;
		int v = a[i];

		while (v)
		{
			int x = a[i] / v + 1;
			int nv = a[i] / x;
			maybe[i].push_back({ x - 1, (ld)v / a[i] });
			f = x;
			v = nv;
		}
	}

	//ld ans = 0;

	//if (n == 2)
	//{
	//	for (auto i : maybe[1])
	//	{
	//		for (auto j : maybe[2])
	//		{
	//			if ((ll)i.first * j.first >= k) ans = max(ans, (ld)k * i.second * j.second);
	//		}
	//	}
	//}

	//cout << fixed << setprecision(20) << ans;

	dp[0][1] = k;
	for (int i = 1; i <= n; ++i)
	{
		for (auto j : maybe[i])
		{
			for (int pre = 1;; ++pre)
			{
				int nv = min((ll)pre * j.first, (ll)k);
				dp[i][nv] = max(dp[i][nv], (ld)dp[i - 1][pre] * j.second);
				if (nv == k) break;
			}
		}
	}

	cout << fixed << setprecision(20) << dp[n][k];

	return 0;
}