#include <iostream>
#include <vector>
#include <set>
#include <algorithm>
#include <map>
#include <stack>
#include <queue>
#include <iomanip>
#include <math.h>

using namespace std;

typedef long long ll;
typedef long double ld;

const int sz = 200100;
const ll mod = 1e9 + 7;

ll a[sz];
vector <ll> v[sz];
ld dp[100][50000];

int main() {
	int n;
	ld k;
	cin >> n >> k;
	for (int i = 0; i < n; ++i) {
		cin >> a[i];
		int x = 1, t = a[i];
		while (x < a[i]) {
			v[i].push_back(x);
			++x;
			t = a[i] / x;
			x = a[i] / t;
		}
		v[i].push_back(a[i]);
	}
	if (n == 1) {
		cout << fixed << setprecision(10) << k / a[0] * ll(a[0] / k);
		return 0;
	}
	if (n == 2) {
		ld ans = 0;
		for (int i : v[0]) {
			for (int j : v[1]) {
				if (i * j < k) continue;
				ans = max(ans, k / ld(a[0]) / ld(a[1]) * (a[0] / i) * (a[1] / j));
			}
		}
		cout << fixed << setprecision(10) << ans;
		return 0;
	}
	for (int i = 1; i <= k; ++i) {
		dp[0][i] = (a[0] / i) / ld(a[0]);
	}
	for (int i = 1; i < n; ++i) {
		for (int j = 1; j <= k; ++j) {
			for (int t = v[i].size() - 1; t >= 0; --t) {
				ll res = min(ll(k), v[i][t] * j);
				dp[i][res] = max(dp[i][res], dp[i - 1][j] / a[i] * (a[i] / v[i][t]));
			}
		}
		for (int j = k - 1; j >= 1; --j) {
			dp[i][j] = max(dp[i][j], dp[i][j + 1]);
		}
	}
	cout << fixed << setprecision(10) << dp[n - 1][ll(k)] * k;
}