#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
#pragma GCC optimize("-O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx,avx2,fma")
#define ll long long
#define ld long double
#define pii pair<int,int>
#define ve vector
#define mpp make_pair
#define pb push_back
#define all(x)      (x).begin(),(x).end()
#define sz(x)       ((int)(x).size())
const int iinf = 1e9;
const ll inf = 1e18;

using namespace std;
using namespace __gnu_pbds;

template<typename T> inline bool chmax(T& a, T b) { return (a < b ? a = b, 1 : 0); }
template<typename T> inline bool chmin(T& a, T b) { return (a > b ? a = b, 1 : 0); }

inline void solve() {
    int n, k;
    cin >> n >> k;

    ve<int> a(n);
    for (auto &i : a) cin >> i;

    ve<gp_hash_table<int,ld>> dp(n + 1);
    dp[0][k] = 1;

    for (int i = 0; i < n; ++i) {
        for (const auto &[d, val] : dp[i]) {

            int s = (int)sqrt(d);
            int vl = (d + s - 1) / s;

            for (int c = 1; c <= a[i]; ++c) {
                int x = (d + c - 1) / c;
                if (x == vl) break;

                chmax(dp[i + 1][x], val * (ld)(a[i] / c) / (ld)(a[i]));
            }
            for (int x = vl; x; --x) {
                int l = (d + x - 1) / x;
                int r = (x == 1 ? iinf : (d - 1) / (x - 1));
                if (l > a[i]) break;
                if (l > r) continue;

                chmax(dp[i + 1][x], val * (ld)(a[i] / l) / (ld)(a[i]));
            }

        }
    }

    dp[n][1] *= (ld)k;
    cout << fixed << setprecision(13) << dp[n][1];
}

signed main() {
    ios_base::sync_with_stdio(false); cin.tie(0); cout.tie(0);
    int q = 1; // cin >> q;
    while (q--) solve();
}
