#include <iostream>
#include "vector"
#include "set"
#include "random"
#include "map"
#include "string"
#include "math.h"
#include "algorithm"
#include "limits.h"
#define all(a) a.begin(), a.end()
#define ll long long
#define len(a) (int)a.size()
#define pii pair<int, int>
#define pll pair<ll, ll>
#define fort(a, b) for(int a = 0; a < b; a++)
#define f first
#define s second
using namespace std;

int mod = 1e9+7;
int modsum(int a, int b){
    if(a + b < mod){
        return a + b;
    }
    return a + b - mod;
}
int modrazn(int a, int b){
    if(a - b < 0){
        return a - b + mod;
    }
    return a - b;
}
int modmult(int a, int b){
    return (int)1ll*a*b%mod;
}

struct dots {
    int x, y;
};
int scalar(dots a, dots b){
    return a.x*b.x + a.y*b.y;
}
int psevd(dots a, dots b){
    return a.x * b.y - a.y * b.x;
}

vector<pii> prost(int n){
    vector<pii> temp;
    for(int i = 2; i * i <=n ; i++){
        if(n% i == 0){
            temp.push_back(make_pair(i, 0));
            while(n % i == 0){
                temp[len(temp) - 1].second++;
                n /= i;
            }
        }
    }
    if(n != 1){
        temp.push_back(make_pair(n, 1));
    }
    return temp;
}

int out(int i, vector<pii>& pows, int now, int k){
    if(now >= k){
        return now;
    }
    if(i == len(pows)){
        return INT32_MAX;
    }
    int pr = INT32_MAX;
    pr = min(pr, out(i + 1, pows, now, k));
    for(int j = 0; j < (pows[i].second); j++){
        now *= pows[i].first;
        pr = min(pr, out(i + 1, pows, now, k));
    }
    return pr;
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    fort(i, n){
        cin >> a[i];
    }
    map<int, int> razl;
    fort(i, n){
        vector<pii> tem = prost(a[i]);
        for(auto i: (tem)){
            razl[i.first] += i.second;
        }
    }
    auto temp = prost(k);
    int nowk = 1;
    for(int i = 0; i < len(temp); i++){
        if(razl.find(temp[i].first) != razl.end()){
            int mm = min(temp[i].second, razl[temp[i].first]);
            razl[temp[i].first] -= mm;
            if(razl[temp[i].first] == 0){
                razl.erase(temp[i].first);
            }
            temp[i].second -= mm;
        }
        if(temp[i].second != 0){
            nowk *= pow(temp[i].first, temp[i].second);
        }
    }
    map<int, int> foro;
    vector<pii> pows;
    for (auto i : razl){
        pows.push_back(make_pair(i.first, i.second));
    }
    int ans = out(0, pows, 1, k);
    cout << (double)k/ans;
}
