#include <bits/stdc++.h>
#define int long long

using namespace std;

const int INF = -1e9;

signed main() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; ++i) cin >> a[i];
    sort(a.begin(), a.end());
    if (n == 1) {
        cout << fixed << setprecision(20) << (long double)((int)a[0] / k) / a[0] * k << endl;
        return 0;
    }
    if (n == 2) {
        long double ans = 0;
        for (int d = 1; d * d <= k; ++d) {
            int x = d, y = (k + d - 1) / d;
            if (x <= a[0] && y <= a[1]) {
                int c = (a[0] / x) * (a[1] / y);
                ans = max(ans, (long double) (c) / a[0] / a[1] * k);
            }
            swap(x, y);
            if (x <= a[0] && y <= a[1]) {
                int c = (a[0] / x) * (a[1] / y);
                ans = max(ans, (long double) (c) / a[0] / a[1] * k);
            }
        }
        cout << fixed << setprecision(20) << ans << endl;
        return 0;
    }
    vector<vector<long double>> dp(2 * k + 1, vector<long double>(n + 1));
    vector<vector<int>> diff(n);
    for (int i = 0; i < n; ++i) {
        vector<int> to_try;
        for (int d = 1; d * d <= a[i]; ++d) {
            to_try.push_back(d);
            to_try.push_back(a[i] / d);
        }
        sort(to_try.rbegin(), to_try.rend());
//        cout << a[i] << endl;
//        for (int x : to_try) cout << x << " ";
//        cout << endl;
        diff[i].push_back(a[i]);
        for (int r : to_try) {
            if (a[i] / diff[i].back() != (a[i] / r)) diff[i].push_back(r);
        }
    }
    dp[1][0] = 1;
    for (int s = 0; s < dp.size(); ++s) {
        for (int i = 0; i < n; ++i) {
            for (int r : diff[i]) {
                if (s * r > 2 * k) continue;
                dp[s * r][i + 1] = max((long double)dp[s][i] * (a[i] / r) / a[i], dp[s * r][i + 1]);
            }
        }
    }
    long double ans = dp.back().back();
    for (int j = k; j < dp.size(); ++j) {
        for (int i = 1; i <= n; ++i) ans = max(ans, dp[j][i]);
    }
    cout << fixed << setprecision(20) << ans * k << endl;
}