#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <iomanip>
#include <queue>
#include <stack>
#include <deque>
#include <cstdio>
#include <random>
#include <cmath>
#include <ctime>

using namespace std;
using ll = long long;
using vii = vector<int>;
using ld = long double;
using vvi = vector<vii>;
using vll = vector<ll>;
using vvll = vector<vll>;
using vbb = vector<bool>;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using vpii = vector<pii>;
using vld = vector<ld>;

void solve()
{
	int n, k;
	cin >> n >> k;
	vll a(n);
	for (auto& elem : a) {
		cin >> elem;
	}
	sort(a.begin(), a.end());
	ll ans = 0;
	if (n == 1) {
		for (int i = k; i <= a[0]; i++) {
			ans = max(ans, a[0] / i);
		}
		cout << fixed << setprecision(10) << k * ans * (ld)1 / a[0];
		return;
	}
	if (n == 2) {
		for (int i = 1; i <= a[0]; i++) {
			int nd = (k + i - 1) / i;
			if (nd > a[1]) {
				continue;
			}
			ans = max(ans, (a[0] / i) * (a[1] / nd));
		}
		ld tmp = 1;
		for (auto& elem : a) {
			tmp *= 1.0 / (ld)elem;
		}
		tmp *= k;
		tmp *= ans;
		cout << fixed << setprecision(10) << tmp;
		return;
	}
	if (k <= 20000) {
		ld tmp = 1;
		for (auto& elem : a) {
			tmp *= (ld)1 / elem;
		}
		vvi lst(n, vii(2001));
		for (int i = 0; i < n; i++) {
			for (int b = 1; b <= a[i]; b++) {
				lst[i][a[i] / b] = max(lst[i][a[i] / b], b);
			}
		}
		vector<vpii> mv(n);
		for (int i = 0; i < n; i++) {
			for (int val = 1; val <= a[i]; val++) {
				if (lst[i][val]) {
					mv[i].push_back({ val, lst[i][val] });
				}
			}
		}
		vld dp(k + 1);
		for (auto& elem : mv[0]) {
			dp[elem.second] = elem.first;
			dp[elem.second] *= tmp;
		}
		for (int i = 1; i < n; i++) {
			vld ndp(k + 1);
			for (int pr = 1; pr <= k; pr++) {
				for (auto& elem : mv[i]) {
					ll newk = elem.second * pr;
					newk = min(newk, (ll)k);
					ndp[newk] = max(ndp[newk], dp[pr] * elem.first);
				}
			}
			dp = ndp;
		}
		cout << fixed << setprecision(10) << dp[k] * k;
		return;
	}
}

int main()
{
#ifdef _DEBUG
	freopen("in.txt", "r", stdin);
	freopen("out.txt", "w", stdout);
#else 
	ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
#endif
	solve();
}