#include <bits/stdc++.h>
using namespace std;
#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
#define double long double
const int N = 1e6, C = 1000, K = 28, INF = 0x3f3f3f3f;
const double EPS = 1e-5;


random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    vector<vector<int>> dp(n + 1, vector<int> (k + 10000));
    for (int j = 1; j <= a[1]; j++) {
        dp[1][j] = a[1] / j;
    }
    for (int i = 2; i <= n; i++) {
        for (int j = 1; j <= a[i]; j++) {
            for (int z = 1; z < k + 10000; z++) {
                if (j * z > k + 10000)
                    continue;
                dp[i][j * z] = max(dp[i][j * z], dp[i - 1][z] * (a[i] / j));
            }
        }
    }
    int sum = 0;
    for (int i = k; i < k + 1000; i++)
        sum = max(sum, dp[n][i]);
    int p = 1;
    for (int i = 1; i <= n; i++)
        p *= a[i];
    double ans = (double) (sum * k) / (double) p;
    cout << ans << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}