#include <bits/stdc++.h>
using namespace std;
//#define int long long
#define fi first
#define se second
#define lwb lower_bound
#define upb upper_bound
#define em emplace_back
#define all(x) x.begin(), x.end()
#define ll long long
#define double long double
const int N = 1e6, C = 1000, K = 28, INF = 0x3f3f3f3f;
const double EPS = 1e-5;


random_device r;
default_random_engine e1(r());
seed_seq seed2{r(), r(), r(), r(), r(), r(), r(), r()};
mt19937 rnd(seed2);


vector<vector<double>> dp;


void solve() {
    int n, k;
    cin >> n >> k;
    if (k > 5000) {
        cout << 0 << endl;
        return;
    }
    vector<int> a(n + 1);
    for (int i = 1; i <= n; i++)
        cin >> a[i];
    dp.resize(n + 1, vector<double> (k + 5000));
    for (int j = 1; j <= a[1]; j++) {
        dp[1][j] = (double) (a[1] / j) / (double) a[1];
    }
    for (int i = 2; i <= n; i++) {
        for (int j = 1; j <= a[i]; j++) {
            for (int z = 1; z * j < k + 5000; z++) {
                dp[i][j * z] = max(dp[i][j * z], dp[i - 1][z] * (double) (a[i] / j) / (double) a[i]);
            }
        }
    }
    double sum = 0;
    for (int i = k; i < k + 5000; i++)
        sum = max(sum, dp[n][i]);
    cout << sum * k << endl;
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout << fixed << setprecision(15);
    int T = 1;
    //cin >> T;
    while (T--) {
        solve();
    }
    return 0;
}