#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define ll long long
#define double long double

typedef tree<
        pair <int, int>,
        null_type,
        less < pair <int, int> >,
        rb_tree_tag,
        tree_order_statistics_node_update
> ordered_set;

int n, k;
vector <int> a;

set < vector <int> > mp;
double otv = 0;

void resh(vector <int> & b){
    if(mp.count(b)){
        return;
    }
    mp.insert(b);
    ll p = 1;
    for(int i = 0; i < n; ++i){
        p *= b[i];
    }

    if(p >= k){
        double ans = 1;
        for(int i = 0; i < n; ++i){
            int x = a[i] / b[i];
            ans *= x;
            ans /= a[i];
        }

        otv = max(otv, ans);

        return;
    }

    for(int i = 0; i < n; ++i){
        if(b[i] + 1 <= a[i]){
            b[i]++;
            resh(b);
            b[i]--;
        }
    }
}

void solve(){
    cin >> n >> k;

    a.resize(n);
    for(int i = 0; i < n; ++i){
        cin >> a[i];
    }

    if(n == 1){
        if(k > a[0]){
            cout << 0;
        }else{
            int x = a[0] / k;
            cout << x * k / (double)a[0];
        }

        return;
    }

    if(n == 2){
        for(int x = 1; x <= a[0]; ++x){
            int y = (k + x - 1) / x;

            if(y >= 1 && y <= a[1]){
                int f1 = a[0] / x;
                int f2 = a[1] / y;
                otv = max(otv, f1 * f2 * k / (double)a[0] / (double)a[1]);
            }
        }
        cout << otv;
        return;
    }

    vector < vector <double> > dp(n + 1, vector <double> (k + 1));
    dp[0][1] = k;
    for(int i = 1; i <= n; ++i){
        for(int j = 1; j <= k; ++j) {
            for (int b = 1; b <= a[i - 1]; ++b) {
                int x = a[i - 1] / b;
                double kol = x / (double) a[i - 1];
                int j1 = (j + b - 1) / b;
                dp[i][j] = max(dp[i][j], dp[i - 1][j1] * kol);
            }
        }
    }

    cout << dp[n][k];
}

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    cout.precision(20);

    int tests = 1;
    //cin >> tests;
    while(tests--) {
        solve();
    }
}