#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC target ("avx2")
#pragma GCC optimize ("unroll-loops")
#pragma GCC optimize ("Ofast")

#define f first
#define s second
#define all(x) (x).begin(), (x).end()
#define rall(x) (x).rbegin(), (x).rend()
#define sz(x) ((int) (x).size())
#define pb push_back
#define mp make_pair
#define int long long

using namespace std;
using namespace __gnu_pbds;

template <typename T> using oset = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename T> inline bool umax(T &a, const T &b) { if(a < b) { a = b; return 1; } return 0; }
template <typename T> inline bool umin(T &a, const T &b) { if(a > b) { a = b; return 1; } return 0; }

typedef long long ll;
typedef long double ld;

const ll mod = 1e9 + 7;
const ll base = 1e6 + 9;
const ll inf = 1e18;
const int MAX = 3e5 + 42;
const int LG = 20;

random_device rd;
mt19937 gen(rd());
uniform_int_distribution<ll> dis(1, inf);



void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for(auto &i : a) {
        cin >> i;
    }
    cout << fixed << setprecision(15);
    map<int, ld> dp, ndp;
    dp[1] = 1;
    for(int i = 0; i < n; i++) {
        for(int l = 1; l <= a[i]; l++) {
//            cout << a[i] << ' ' << l << " " << sz(dp) << endl;
            int val = a[i] / l;
            int b = a[i] / val;
            for(auto [p, v] : dp) {
                int np = min(p * b, k);
                ld nv = v * val / a[i] ;
                umax(ndp[np], nv);
                if(np == k) break;
            }
            l = b;
        }
        dp.clear();
        dp.swap(ndp);
    }
    dp[k] *= k;
    cout << fixed << setprecision(15) << dp[k] << '\n';
}

/*
10 10000000
12345 123472 1264238 123645 213476 123461 32141 213412 123443 2134214
*/

signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    int ttt = 1;
    //cin >> ttt;
    while(ttt--) solve();
}
