#include <bits/stdc++.h>

using namespace std;

typedef long long ll;
typedef pair<long long, long long> Pair;
const long long MOD = 1e9 + 7;
const long long INF = INT_MAX;

#define endl "\n"
#define debug cout << "# sus\n"

ll n, k;

vector<ll> was, a, suff;

long long gen(ll cur, ll sz) {
    if (sz == n) {
        ll val = 1;
        for (ll i = 0; i < n; i++) val *= (a[i] / was[i]);
        return val;
    }
    ll val = suff[sz + 1], ans = 0;
    for (ll x = max(1LL, (k + val * cur - 1) / (val * cur)); x <= a[sz]; x++) {
        was.push_back(x);
        ans = max(ans, gen(cur * x, sz + 1));
        was.pop_back();
    }
    return ans;
}

signed main() {
    ios_base::sync_with_stdio(false), cin.tie(nullptr);
    cin >> n >> k;
    a.resize(n);
    for (ll i = 0; i < n; i++) cin >> a[i];
    suff.resize(n + 1);
    suff[n] = 1;
    ll cur = 1;
    for (ll i = n - 1; i >= 0; i--) {
        cur *= a[i];
        suff[i] = cur;
    }
    ll val = gen(1, 0);
    cout << fixed << setprecision(12) << val * ((double) 1 / (double) suff[0]) * k << endl;
    return 0;
}
