#include <bits/stdc++.h>

#define PB push_back
#define F first
#define S second
#define ve vector
#define endl '\n'
#define all(x) x.begin(),x.end()

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<ll,ll> pll;
const ll INF=1e18+2;
const ll N=1e7+2;

ve<ll> getv(ll x)
{
    ve<ll> v;
    ll pos=1;

    while(x/pos>=2)
    {
        ll l=pos,r=x;

        while(l<r)
        {
            ll mid=(l+r+1)/2;
            if(x/mid==x/pos) l=mid;
            else r=mid-1;
        }

        v.PB(l);
        pos=l+1;
    }

    v.PB(x);
    return v;
}

ll arr[N];
ld dp[N];

void solve()
{
    ll n,k;
    cin>>n>>k;

    for(ll i=0;i<n;i++)
        cin>>arr[i];

    sort(arr,arr+n);
    dp[1]=k;

    for(ll i=0;i<n;i++)
    {
        ve<ll> v=getv(arr[i]);

        for(ll j=k-1;j>=0;j--)
        {
            if(dp[j]==0) continue;

            for(ll y:v)
                dp[min(k,j*y)]=max(dp[min(k,j*y)],dp[j]*(arr[i]/y)/arr[i]);
        }
    }

    cout<<fixed<<setprecision(12)<<dp[k];
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
    return 0;
}
