#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>

using namespace __gnu_pbds;
using namespace std;

#define all(v) v.begin(), v.end()
#define rall(v) r.begin(), r.end()

typedef long long ll;
typedef long double ld;

signed main() {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    cout << fixed << setprecision(9);

    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];

    vector<cc_hash_table<int, int>> m(n);
    for (int i = 0; i < n; i++) {
        for (int j = 1; j <= a[i]; j++) {
            m[i][a[i] / j] = j;
        }
    }

    ld ans = 0;
    vector<vector<ld>> dp(n, vector<ld>(k));
    dp[0][1] = k;
    for (int i = 0; i < n; i++) {
        for (int j = 1; j < k; j++) {
            for (auto [sz, nxt] : m[i]) {
                if (j * nxt >= k) {
                    ans = max(ans, dp[i][j] * sz / a[i]);
                } else if (i + 1 < n) {
                    dp[i + 1][j * nxt] = max(dp[i + 1][j * nxt], dp[i][j] * sz / a[i]);
                }
            }
        }
    }

    cout << ans << '\n';

    return 0;
}
