#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define sz(a) (int)a.size()
#define vc vector
#define pb push_back
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

const int INFi = 1e9;
const ll INFl = 1e18;

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

mt19937 rnd(time(0));

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/Kek/read.txt", "r", stdin);
#endif
    cout << fixed << setprecision(15);
    int tc = 1;
    //cin >> tc;
    forn(i, tc) solve();
    return 0;
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    forn(i, n) cin >> a[i];
    auto print = [&](ld ans) {
        ans *= k;
        forn(i, n) ans /= a[i];
        cout << ans << '\n';
    };
    if (n == 1) {
        if (a[0] < k) {
            cout << 0 << '\n';
        } else {
            ll v = a[0] / k;
            print(v);
        }
        return;
    }
    if (n == 2) {
        ll best = 0;
        for (int v = 1; v <= a[0]; ++v) {
            int need = (k + v - 1) / v;
            if (need > a[1]) continue;
            inmax(best, ((ll)a[0] / v) * ((ll)a[1] / need));
        }
        print(best);
        return;
    }
    vector<vector<int>> dv(2 * k + 1);
    for (int i = 1; i <= 2 * k; ++i) {
        for (int j = i; j <= 2 * k; j += i)
            dv[j].pb(i);
    }
    vector<ld> dp(2 * k + 1);
    dp[1] = 1;
    forn(i, n) {
        for (int x = 2 * k; x >= 1; --x) {
//            int pos = upper_bound(all(dv[x]), a[i]) - dv[x].begin();
//            int lhs = 0, rhs = pos - 1;
//            while (rhs - lhs > 2) {
//                int m1 = lhs + (rhs - lhs) / 3;
//                int m2 = rhs - (rhs -  lhs) / 3;
//                ld l = dp[x / dv[x][m1]] * (a[i] / dv[x][m1]);
//                ld r = dp[x / dv[x][m2]] * (a[i] / dv[x][m2]);
//                if (l < r) rhs = m2;
//                else lhs = m1;
//            }
//            for (; lhs <= rhs; ++lhs) {
//                inmax(dp[x], dp[x / dv[x][lhs]] * (a[i] / dv[x][lhs]));
//            }
            for (int del : dv[x]) {
                if (del > a[i]) break;
                inmax(dp[x], dp[x / del] * (a[i] / del));
            }
        }
//        for (auto el : dp) cout << el << ' ';
//        cout << endl;
    }
    ld ans = 0;
    for (int x = k; x <= 2 * k; ++x) inmax(ans, dp[x]);
    print(ans);
}