#include <bits/stdc++.h>
#pragma GCC optimize("Ofast")
#pragma GCC target("avx2")
using namespace std;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using ld = long double;
#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define sz(a) (int)a.size()
#define vc vector
#define pb push_back
#define ff first
#define ss second
#define all(a) (a).begin(), (a).end()

const int INFi = 1e9;
const ll INFl = 1e18;

template<class T>
bool inmin(T &x, T y) {
    if (y < x) {
        x = y;
        return true;
    }
    return false;
}

template<class T>
bool inmax(T &x, T y) {
    if (y > x) {
        x = y;
        return true;
    }
    return false;
}

mt19937 rnd(time(0));

void solve();

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
#ifdef LOCAL
    freopen("/home/olymp/CLionProjects/Kek/read.txt", "r", stdin);
#endif
    cout << fixed << setprecision(15);
    int tc = 1;
    //cin >> tc;
    forn(i, tc) solve();
    return 0;
}

#define ch unordered_map<int, ld>
vector<ch> dp;
vector<vector<int>> dv;
vector<int> a;

ld rec(int n, int k) {
    if (dp[n].find(k) != dp[n].end())
        return dp[n][k];
    if (n == 0) return 0;
    for (auto d : dv[k]) {
        if (d > a[n - 1]) break;
        inmax(dp[n][k], rec(n - 1, k / d) * (a[n - 1] / d));
    }
    return dp[n][k];
}
void solve() {
    int n, k;
    cin >> n >> k;
    a.resize(n);

    forn(i, n) cin >> a[i];
    shuffle(all(a), rnd);
    auto print = [&](ld ans) {
        ans *= k;
        forn(i, n) ans /= a[i];
        cout << ans << '\n';
    };
    if (n == 1) {
        if (a[0] < k) {
            cout << 0 << '\n';
        } else {
            ll v = a[0] / k;
            print(v);
        }
        return;
    }
    if (n == 2) {
        ll best = 0;
        for (int v = 1; v <= a[0]; ++v) {
            int need = (k + v - 1) / v;
            if (need > a[1]) continue;
            inmax(best, ((ll)a[0] / v) * ((ll)a[1] / need));
        }
        print(best);
        return;
    }
    dv.resize(2 * k);
    for (int i = 1; i < 2 * k; ++i) {
        for (int j = i; j < 2 * k; j += i)
            dv[j].pb(i);
    }
    dp.resize(n + 1);
    dp[0][1] = 1;
    ld ans = 0;
    for (int x = k; x < 2 * k; ++x) inmax(ans, rec(n, x));
    print(ans);
}
