#include <iostream>
#include <iomanip>
#include <vector>
#include <string>
#include <unordered_map>
#include <set>
#include <algorithm>

using namespace std;
typedef long long ll;

long long n, k;
vector < long long > a;
double proiz = 1;
double answer = -1e9;


bool cmp(long long x, long long y) {
    return x > y;
}

void get(long long ch, long long ind, vector < long long > divisors) {
    if (ind == n - 1) {
        if (ch > a[ind])return;
        divisors.push_back(ch);

        long long pr = 1;
        for (long long i = 0; i < n; i++) {
            pr *= a[i] / divisors[i];
        }

        if (pr > answer) {
            answer = pr;
        }
        return;
    }

    long long d = 1;
    while (d * d <= ch && d <= a[ind]) {
        if (ch % d == 0) {
            divisors.push_back(d);
            get(ch / d, ind + 1, divisors);
            divisors.pop_back();

            if (ch / d <= a[ind]) {
                divisors.push_back(ch / d);
                get(d, ind + 1, divisors);
                divisors.pop_back();
            }
        }
        d++;
    }
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> k;

    long long maxi = 0;
    a.resize(n);
    for (long long i = 0; i < n; i++) {
        cin >> a[i];
        proiz *= a[i];
        if (a[i] > maxi) {
            maxi = a[i];
        }
    }

    if (proiz < k) {
        cout << 0;
        return 0;
    }

    sort(a.begin(), a.end(), cmp);
    
    for (long long i = k; i <= k + 1e4; i++) {
        get(i, 0, {});
    }
    cout << fixed << setprecision(12);
    cout << answer / proiz * k;
}