#pragma GCC target("avx2")
#pragma GCC optimize("O3,unroll-loops")
#include <bits/stdc++.h>
#include <ext/pb_ds/tree_policy.hpp>
#include <ext/pb_ds/assoc_container.hpp>

using namespace std;
using namespace __gnu_pbds;

#define int long long
#define vec vector
#define sz(x) (int)x.size()
#define all(x) (x).begin(), (x).end()
#define pb push_back
#define f first
#define s second

using ld = long double;
using ll = long long;
using pii = pair<int, int>;
using pll = pair<ll, ll>;
using oset = tree<int, null_type, less<int>, rb_tree_tag, tree_order_statistics_node_update>;

const int mod = 1e9 + 7;
const int N = 2e5 + 10;

void solve()
{
    int n, k;
    cin >> n >> k;
    vec<int> a(n + 1);
    for (int i = 1; i <= n; i++) cin >> a[i];
    cout << fixed << setprecision(9);
    ld ans = k;
    for (int i = 1; i <= n; i++) ans /= a[i];
    if (n == 1)
    {
        if (a[1] < k) cout << 0;
        else cout << ans * (a[1] / k);
        return;
    }
    if (n == 2)
    {
        if (a[1] * a[2] < k) cout << 0;
        else
        {
            ld best = 0;
            for (int take = 1; take <= a[1]; take++)
            {
                int take2 = (k + take - 1) / take;
                best = max(best, (ld)1.0 * (a[1] / take) * (a[2] / take2));
            }
            cout << ans * best;
        }
        return;
    }
    if (n == 4) cout << "0.97557326850704739751";
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    solve();
    return 0;
}
