#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.precision(9);

    int n, k;
    cin >> n >> k;

    vector<long long> a(n);
    for(int i = 0; i < n; i ++)
        cin >> a[i];

    if(n == 1){
        if(a[0] < k){
            cout<< 0 << "\n";
            return 0;
        }
        if(a[0] % k == 0){
            cout<< 1;
        }
        else{
            double q = a[0] / k;
            double sa = a[0];
            cout << k * (q / sa);
        }
        return 0;
    }

    double ans = 0;
    if(a[0] * a[1] < k){
        cout << 0;
        return 0;
    }

    double a0 = a[0], a1 = a[1], k1 = k;

    for(int i = 1; i <= a[0]; i ++){
        if(k % i == 0){
            int b = k / i;
            if(b > a[1])
                continue;

            double i1 = i, b1 = b;
            double an = int(a0 / i1) * int(a1 / b1) * (1 / (a0 * a1)) * k1;
            //cout<< an << "\n";
            if(an - ans > 0.0000000001)
                ans = an;
            continue;
        }

        int b = k / i + 1;
        if(b > a[1])
            continue;

        double i1 = i, b1 = b;
        double an = int(a0 / i1) * int(a1 / b1) * (1 / (a0 * a1)) * k1;
        //cout<< an << "\n";
        if(an - ans > 0.000000001)
            ans = an;
    }
    cout << ans;

  return 0;
}
