#include <bits/stdc++.h>
using namespace std;

const int MAGIC = 10;
const int INF = 2000 + 10;
int n, k, k0, curv;
vector<int> a, b, divs;
long double ans = 0;

int my_pow(int x, int y) {
    int tot = 1;
    while (y--) {
        if (INF / tot < x) {
            tot = INF;
        } else {
            tot *= x;
        }
    }
    return tot;
}

void gen(int p) {
    if (p == (int)a.size()) {
        if (curv != 1) {
            return;
        }
        long double cur = 1;
        for (int i = 0; i < n; i++) {
            cur *= int(a[i] / b[i]);
        }
        for (int i = 0; i < n; i++) {
            cur /= a[i];
        }
        cur *= k0;
        ans = max(ans, cur);
    } else {
        int last = b.empty() ? 1 : b.back();
        int start = lower_bound(divs.begin(), divs.end(), last) - divs.begin();
        for (int i = start; i < (int)divs.size(); i++) {
            if (curv % divs[i]) {
                continue;
            }
            if (my_pow(divs[i], (int) a.size() - p) > curv) {
                break;
            }
            b.push_back(divs[i]);
            curv /= divs[i];
            gen(p + 1);
            b.pop_back();
            curv *= divs[i];
        }
    }
}

int main() {
    cout << fixed << setprecision(12);
    cin >> n >> k;
    k0 = k;
    a.resize(n);
    for (int &v : a) {
        cin >> v;
    }
    sort(a.begin(), a.end());
    for (int i = 0; i < MAGIC; i++) {
        divs = vector<int>();
        for (int j = 1; j * j <= k; j++) {
            if (j * j == k) {
                divs.push_back(j);
            } else {
                divs.push_back(j);
                divs.push_back(k / j);
            }
        }
        sort(divs.begin(), divs.end());
        curv = k;
        gen(0);
        k++;
    }
    cout << ans << "\n";
}