#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;
constexpr int INF = numeric_limits<int>::max() / 2;
constexpr ll INFLL = numeric_limits<ll>::max() / 2;

template<class T>
istream &operator>>(istream &is, vector<T> &a) {
    for (auto &i : a) {
        is >> i;
    }
    return is;
}

int main() {
    cin.tie(0)->sync_with_stdio(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
#endif
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    cin >> a;
    cout << fixed << setprecision(10);
    if (n == 1) {
        cout << (a[0] / k) * (ld) 1 / (ld) a[0] * k;
        return 0;
    }
    if (n == 2) {
        ll ans = 0;
        for (int b1 = 1; b1 <= a[0]; ++b1) {
            // b1 * b2 >= k
            // b2 >= ceil(k / b1)
            int b2 = (k + b1 - 1) / b1;
//        assert(b1 * b2 >= k);
            if (b2 <= a[1]) {
                ans = max(ans, (a[0] / b1) * 1ll * (a[1] / b2));
            }
        }
        cout << ans * ((ld) 1 / (ld) a[0]) * ((ld) 1 / (ld) a[1]) * k;
    } else {
        constexpr int C = 2000;
        vector<vector<ll>> dp(n, vector<ll>(C));
        for (int i = 1; i <= a[0]; ++i) {
            dp[0][i] = a[0] / i;
        }
        for (int i = 1; i < n; ++i) {
            for (int b = 1; b <= a[i]; ++b) {
                for (int j = 1; j * b < C; ++j) {
                    dp[i][j * b] = max(dp[i][j * b], dp[i - 1][j] * 1ll * (a[i] / b));
                }
            }
        }
        ll ans = *max_element(dp[n - 1].begin() + k + 1, dp[n - 1].end());
        ld prod = 1;
        for (auto i: a) {
            prod *= (ld) 1 / (ld) i;
        }
        cout << ans * prod * k << "\n";
    }
}
