#include<bits/stdc++.h>

using namespace std;

#define X first
#define Y second
#define all(a) (a).begin(), (a).end()

typedef long long ll;
typedef long double ld;

const int MAXN = 2e5 + 1337, MOD = 1e9 + 7;
const ll INF = LLONG_MAX;

void solve();

int32_t main() {
#ifdef LOCAL
    freopen("../input.txt", "r", stdin);
#else
    cin.tie(nullptr)->sync_with_stdio(false);
#endif
    int t = 1;
//    cin >> t;
    while (t--) {
        solve();
    }
}

void solve() {
    int n, k;
    cin >> n >> k;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    ld cnst = k;
    for (auto &el : a) {
        cnst *= ((ld)1 / el);
    }
    cout << fixed << setprecision(30);
    vector<vector<ld>> dp(n, vector<ld> (k + 1, 0));
    for (int i = 1; i <= a[0] && i <= k; ++i) {
        dp[0][min(i, k)] = (ld)(a[0] / i);
    }
    vector<ld> pref(k + 1, 0);
    for (int i = 1; i < n; ++i) {
        for (int j = k; j >= 1; --j) {
            pref[j] = dp[i - 1][j];
            if (j + 1 <= k) {
                pref[j] = max(pref[j], pref[j + 1]);
            }
        }
        for (int nw = 1; nw <= a[i]; ++nw) {
            ld cur = a[i] / nw;
            for (int was = 1; was <= k; ++was) {
                if (was * nw >= k) {
                    dp[i][k] = max(dp[i][k], pref[was] * cur);
                } else {
                    dp[i][nw * was] = max(dp[i][nw * was], dp[i - 1][was] * (ld) (a[i] / nw));
                }
            }
        }
    }
    cout << fixed << setprecision(30);
    cout << dp[n - 1][k] * cnst;
}